
--
-- Ensure correct encoding
--
SET NAMES utf8;


--
-- Table structure for table `lang_languages`
--


DROP TABLE IF EXISTS `lang_languages`;
CREATE TABLE `lang_languages` (
  `lang_id` int(11) NOT NULL auto_increment,
  `lang_code` char(2) NOT NULL default '',
  `lang_description` varchar(100) default NULL,
  UNIQUE KEY `lang_id` (`lang_id`)
) ENGINE=MyISAM AUTO_INCREMENT=20 ;


--
-- Dumping data for table `lang_languages`
--

INSERT INTO `lang_languages` VALUES (1, 'en', 'English (Standard)');
INSERT INTO `lang_languages` VALUES (2, 'se', 'Swedish');
INSERT INTO `lang_languages` VALUES (3, 'es', 'Spanish');
INSERT INTO `lang_languages` VALUES (4, 'de', 'German');
INSERT INTO `lang_languages` VALUES (5, 'du', 'Dutch');
INSERT INTO `lang_languages` VALUES (6, 'he', 'Hebrew');
INSERT INTO `lang_languages` VALUES (7, 'fr', 'French');
INSERT INTO `lang_languages` VALUES (8, 'no', 'Norwegian');
INSERT INTO `lang_languages` VALUES (9, 'zh', 'Chinese');
INSERT INTO `lang_languages` VALUES (10, 'ru', 'Russian');
INSERT INTO `lang_languages` VALUES (11, 'hy', 'Armenian');
INSERT INTO `lang_languages` VALUES (12, 'sk', 'Slovak');
INSERT INTO `lang_languages` VALUES (13, 'pt', 'Portuguese (Brazilian)');
INSERT INTO `lang_languages` VALUES (14, 'in', 'Bahasa Indonesia');
INSERT INTO `lang_languages` VALUES (15, 'gr', 'Greek');
INSERT INTO `lang_languages` VALUES (16, 'ei', 'English (Indian)');
INSERT INTO `lang_languages` VALUES (17, 'pe', 'Portuguese (European)');
INSERT INTO `lang_languages` VALUES (18, 'ar', 'Arabic');
INSERT INTO `lang_languages` VALUES (19, 'dd', 'dummy');

--


-- 
-- Table structure for table `lang_constants`
-- 


DROP TABLE IF EXISTS `lang_constants`;
CREATE TABLE `lang_constants` (
  `cons_id` int(11) NOT NULL auto_increment,
  `constant_name` varchar(255) BINARY default NULL,
  UNIQUE KEY `cons_id` (`cons_id`),
  KEY `constant_name` (`constant_name`)
) ENGINE=MyISAM AUTO_INCREMENT=3467 ;


-- 
-- Dumping data for table `lang_constants`
--

INSERT INTO `lang_constants` VALUES (1, 'A');
INSERT INTO `lang_constants` VALUES (2, 'A check number or claim number to identify the payment');
INSERT INTO `lang_constants` VALUES (3, 'A GCAC visit form should be added to this visit.');
INSERT INTO `lang_constants` VALUES (4, 'A lot number is required!');
INSERT INTO `lang_constants` VALUES (5, 'A related IPPF code is required!');
INSERT INTO `lang_constants` VALUES (6, 'A unique value to identify this field, not visible to the user');
INSERT INTO `lang_constants` VALUES (7, 'a.c.');
INSERT INTO `lang_constants` VALUES (8, 'a.m.');
INSERT INTO `lang_constants` VALUES (9, 'A/F Level Right:');
INSERT INTO `lang_constants` VALUES (10, 'AB');
INSERT INTO `lang_constants` VALUES (11, 'Abbreviation');
INSERT INTO `lang_constants` VALUES (12, 'Abcess:');
INSERT INTO `lang_constants` VALUES (13, 'Abdominal');
INSERT INTO `lang_constants` VALUES (14, 'Able to Bear Weight four (4) steps:');
INSERT INTO `lang_constants` VALUES (15, 'Abn');
INSERT INTO `lang_constants` VALUES (16, 'ABN1');
INSERT INTO `lang_constants` VALUES (17, 'Abnormal');
INSERT INTO `lang_constants` VALUES (18, 'Abnormal Blood Test');
INSERT INTO `lang_constants` VALUES (19, 'Abnormal Hair Growth');
INSERT INTO `lang_constants` VALUES (20, 'Abnormal Mammogram');
INSERT INTO `lang_constants` VALUES (21, 'Abortion');
INSERT INTO `lang_constants` VALUES (22, 'Abortion Issues');
INSERT INTO `lang_constants` VALUES (23, 'Abortion Method');
INSERT INTO `lang_constants` VALUES (24, 'Abortion-Related Categories');
INSERT INTO `lang_constants` VALUES (25, 'Abortions');
INSERT INTO `lang_constants` VALUES (26, 'Absences by Diagnosis');
INSERT INTO `lang_constants` VALUES (27, 'Accept Assignment');
INSERT INTO `lang_constants` VALUES (28, 'Accept Payment for ');
INSERT INTO `lang_constants` VALUES (29, 'Accepts Assignment');
INSERT INTO `lang_constants` VALUES (30, 'Access Control');
INSERT INTO `lang_constants` VALUES (31, 'Access Control List Administration');
INSERT INTO `lang_constants` VALUES (32, 'Accounting');
INSERT INTO `lang_constants` VALUES (33, 'Aches');
INSERT INTO `lang_constants` VALUES (34, 'Acknowledgment Requested (ISA14)');
INSERT INTO `lang_constants` VALUES (35, 'ACL');
INSERT INTO `lang_constants` VALUES (36, 'ACL Administration');
INSERT INTO `lang_constants` VALUES (37, 'ACL Administration Not Authorized');
INSERT INTO `lang_constants` VALUES (38, 'Acne');
INSERT INTO `lang_constants` VALUES (39, 'Act');
INSERT INTO `lang_constants` VALUES (40, 'Act Date');
INSERT INTO `lang_constants` VALUES (41, 'Active');
INSERT INTO `lang_constants` VALUES (42, 'Active Encounter');
INSERT INTO `lang_constants` VALUES (43, 'Active lists');
INSERT INTO `lang_constants` VALUES (44, 'Active Patient');
INSERT INTO `lang_constants` VALUES (45, 'Activity Type');
INSERT INTO `lang_constants` VALUES (46, 'Acute on Chronic');
INSERT INTO `lang_constants` VALUES (47, 'Add');
INSERT INTO `lang_constants` VALUES (48, 'add');
INSERT INTO `lang_constants` VALUES (49, 'Add a Company');
INSERT INTO `lang_constants` VALUES (50, 'Add a Pharmacy');
INSERT INTO `lang_constants` VALUES (51, 'add an event for ');
INSERT INTO `lang_constants` VALUES (52, 'Add as a new note');
INSERT INTO `lang_constants` VALUES (53, 'Add as New');
INSERT INTO `lang_constants` VALUES (54, 'Add Category');
INSERT INTO `lang_constants` VALUES (55, 'Add Constant');
INSERT INTO `lang_constants` VALUES (56, 'Add Copay');
INSERT INTO `lang_constants` VALUES (57, 'Add Drug');
INSERT INTO `lang_constants` VALUES (58, 'Add Encounter');
INSERT INTO `lang_constants` VALUES (59, 'Add Facility');
INSERT INTO `lang_constants` VALUES (60, 'Add Field');
INSERT INTO `lang_constants` VALUES (61, 'Add Group');
INSERT INTO `lang_constants` VALUES (62, 'Add ICD Code');
INSERT INTO `lang_constants` VALUES (63, 'Add Issue');
INSERT INTO `lang_constants` VALUES (64, 'Add Language');
INSERT INTO `lang_constants` VALUES (65, 'Add New');
INSERT INTO `lang_constants` VALUES (66, 'Add new category : ');
INSERT INTO `lang_constants` VALUES (67, 'Add New Group');
INSERT INTO `lang_constants` VALUES (68, 'Add New Note');
INSERT INTO `lang_constants` VALUES (69, 'Add new note');
INSERT INTO `lang_constants` VALUES (70, 'Add New Partner');
INSERT INTO `lang_constants` VALUES (71, 'Add Note');
INSERT INTO `lang_constants` VALUES (72, 'Add Patient Record');
INSERT INTO `lang_constants` VALUES (73, 'Add Prescription');
INSERT INTO `lang_constants` VALUES (74, 'Add to');
INSERT INTO `lang_constants` VALUES (75, 'Add to Medication List');
INSERT INTO `lang_constants` VALUES (76, 'Add Transaction');
INSERT INTO `lang_constants` VALUES (77, 'Add User');
INSERT INTO `lang_constants` VALUES (78, 'Add User To Group');
INSERT INTO `lang_constants` VALUES (79, 'added');
INSERT INTO `lang_constants` VALUES (80, 'Adding demographics is not authorized.');
INSERT INTO `lang_constants` VALUES (81, 'Addison Syndrom');
INSERT INTO `lang_constants` VALUES (82, 'Addison Syndrome');
INSERT INTO `lang_constants` VALUES (83, 'Additional Diagnosis:');
INSERT INTO `lang_constants` VALUES (84, 'Additional History');
INSERT INTO `lang_constants` VALUES (85, 'Additional history notes');
INSERT INTO `lang_constants` VALUES (86, 'Additional Info');
INSERT INTO `lang_constants` VALUES (87, 'Additional Labs');
INSERT INTO `lang_constants` VALUES (88, 'Additional Notes');
INSERT INTO `lang_constants` VALUES (89, 'Additional Notes:');
INSERT INTO `lang_constants` VALUES (90, 'Additional Notes: ');
INSERT INTO `lang_constants` VALUES (91, 'Additional X-RAY Notes:');
INSERT INTO `lang_constants` VALUES (92, 'addonly');
INSERT INTO `lang_constants` VALUES (93, 'Addr Bk');
INSERT INTO `lang_constants` VALUES (94, 'Addr Book');
INSERT INTO `lang_constants` VALUES (95, 'Address');
INSERT INTO `lang_constants` VALUES (96, 'Address Book');
INSERT INTO `lang_constants` VALUES (97, 'Address1');
INSERT INTO `lang_constants` VALUES (98, 'Address2');
INSERT INTO `lang_constants` VALUES (99, 'Adj');
INSERT INTO `lang_constants` VALUES (100, 'Adjust');
INSERT INTO `lang_constants` VALUES (101, 'Adjustment Reasons');
INSERT INTO `lang_constants` VALUES (102, 'Adjustment value for code ');
INSERT INTO `lang_constants` VALUES (103, 'Adjustments');
INSERT INTO `lang_constants` VALUES (104, 'Adm adjust');
INSERT INTO `lang_constants` VALUES (105, 'Admin');
INSERT INTO `lang_constants` VALUES (106, 'Admin Email Address');
INSERT INTO `lang_constants` VALUES (107, 'Administered');
INSERT INTO `lang_constants` VALUES (108, 'Administered By');
INSERT INTO `lang_constants` VALUES (109, 'Administration');
INSERT INTO `lang_constants` VALUES (110, 'Administrators');
INSERT INTO `lang_constants` VALUES (111, 'Administrators can do anything');
INSERT INTO `lang_constants` VALUES (112, 'Advanced');
INSERT INTO `lang_constants` VALUES (113, 'Advice');
INSERT INTO `lang_constants` VALUES (114, 'Affect normal');
INSERT INTO `lang_constants` VALUES (115, 'After hrs calls');
INSERT INTO `lang_constants` VALUES (116, 'After saving the PDF, click [View Log] to check for errors.');
INSERT INTO `lang_constants` VALUES (117, 'After saving your batch, click [View Log] to check for errors.');
INSERT INTO `lang_constants` VALUES (118, 'After the information is correctly entered, click the Save button.');
INSERT INTO `lang_constants` VALUES (119, 'Again');
INSERT INTO `lang_constants` VALUES (120, 'Age');
INSERT INTO `lang_constants` VALUES (121, 'Age By');
INSERT INTO `lang_constants` VALUES (122, 'Age Category');
INSERT INTO `lang_constants` VALUES (123, 'Age data is out of range.');
INSERT INTO `lang_constants` VALUES (124, 'Age format for \"age from\" is not valid');
INSERT INTO `lang_constants` VALUES (125, 'Age format for \"age up to\" is not valid');
INSERT INTO `lang_constants` VALUES (126, 'Age From');
INSERT INTO `lang_constants` VALUES (127, 'Aging Columns:');
INSERT INTO `lang_constants` VALUES (128, 'Alcohol');
INSERT INTO `lang_constants` VALUES (129, 'Alcohol consumption');
INSERT INTO `lang_constants` VALUES (130, 'All');
INSERT INTO `lang_constants` VALUES (131, 'All Categories');
INSERT INTO `lang_constants` VALUES (132, 'All Day');
INSERT INTO `lang_constants` VALUES (133, 'All day event');
INSERT INTO `lang_constants` VALUES (134, 'All Facilities');
INSERT INTO `lang_constants` VALUES (135, 'All or part of the first name');
INSERT INTO `lang_constants` VALUES (136, 'All or part of the last name');
INSERT INTO `lang_constants` VALUES (137, 'All Providers');
INSERT INTO `lang_constants` VALUES (138, 'All Reviewed and Negative:');
INSERT INTO `lang_constants` VALUES (139, 'All Topics');
INSERT INTO `lang_constants` VALUES (140, 'All Users');
INSERT INTO `lang_constants` VALUES (141, 'Allergic');
INSERT INTO `lang_constants` VALUES (142, 'Allergies');
INSERT INTO `lang_constants` VALUES (143, 'Allergies:');
INSERT INTO `lang_constants` VALUES (144, 'Allergy');
INSERT INTO `lang_constants` VALUES (145, 'Allow Email');
INSERT INTO `lang_constants` VALUES (146, 'Allow email messages?');
INSERT INTO `lang_constants` VALUES (147, 'Allow Email?');
INSERT INTO `lang_constants` VALUES (148, 'Allow Mail Message');
INSERT INTO `lang_constants` VALUES (149, 'Allow SMS');
INSERT INTO `lang_constants` VALUES (150, 'Allow SMS (text messages)?');
INSERT INTO `lang_constants` VALUES (151, 'Allow submitted events to be made active instantly?');
INSERT INTO `lang_constants` VALUES (152, 'Allow telephone messages?');
INSERT INTO `lang_constants` VALUES (153, 'Allow users to publish Global Events');
INSERT INTO `lang_constants` VALUES (154, 'Allow users to publish Personal Calendars');
INSERT INTO `lang_constants` VALUES (155, 'Allow Voice Message');
INSERT INTO `lang_constants` VALUES (156, 'Allowed');
INSERT INTO `lang_constants` VALUES (157, 'already exists.');
INSERT INTO `lang_constants` VALUES (158, 'Already used, choose another identifier');
INSERT INTO `lang_constants` VALUES (159, 'Already used, choose another title');
INSERT INTO `lang_constants` VALUES (160, 'Alt Address');
INSERT INTO `lang_constants` VALUES (161, 'alter');
INSERT INTO `lang_constants` VALUES (162, 'Alternatively, you may use the search page to upload an electronic remittance (X12 835) file that you have obtained from your payer or clearinghouse.  You can do this by clicking the Browse button and selecting the file to upload, and then clicking Search to perform the upload and display the corresponding invoices.  In this case the other parameters mentioned above do not apply and will be ignored.  Uploading saves the file but does not yet process its contents -- that is done separately as described below.');
INSERT INTO `lang_constants` VALUES (163, 'AM');
INSERT INTO `lang_constants` VALUES (164, 'Amend Existing Note');
INSERT INTO `lang_constants` VALUES (165, 'AMEX');
INSERT INTO `lang_constants` VALUES (166, 'Amount');
INSERT INTO `lang_constants` VALUES (167, 'Amount Charges');
INSERT INTO `lang_constants` VALUES (168, 'Amount for Past Balance');
INSERT INTO `lang_constants` VALUES (169, 'Amount for This Visit');
INSERT INTO `lang_constants` VALUES (170, 'Amount Paid');
INSERT INTO `lang_constants` VALUES (171, 'Amount:');
INSERT INTO `lang_constants` VALUES (172, 'An error occurred while dumping OpenEMR web directory tree');
INSERT INTO `lang_constants` VALUES (173, 'An error occurred while dumping phpGACL web directory tree');
INSERT INTO `lang_constants` VALUES (174, 'An error occurred while dumping SQL-Ledger web directory tree');
INSERT INTO `lang_constants` VALUES (175, 'An incomplete GCAC issue has been created and linked. Someone will need to complete it later.');
INSERT INTO `lang_constants` VALUES (176, 'And');
INSERT INTO `lang_constants` VALUES (177, 'AND');
INSERT INTO `lang_constants` VALUES (178, 'and');
INSERT INTO `lang_constants` VALUES (179, 'and ');
INSERT INTO `lang_constants` VALUES (180, 'and all subordinate data? This action will be logged');
INSERT INTO `lang_constants` VALUES (181, 'Anemia');
INSERT INTO `lang_constants` VALUES (182, 'Ankle');
INSERT INTO `lang_constants` VALUES (183, 'Ankle + heel');
INSERT INTO `lang_constants` VALUES (184, 'Ankle Evaluation Form');
INSERT INTO `lang_constants` VALUES (185, 'Ankle Problems');
INSERT INTO `lang_constants` VALUES (186, 'Ankylosing Sondlilitis');
INSERT INTO `lang_constants` VALUES (187, 'Ankylosing Spondlilitis');
INSERT INTO `lang_constants` VALUES (188, 'Anorexia');
INSERT INTO `lang_constants` VALUES (189, 'Another thing you can do in the posting window is request secondary billing. If you select this checkbox before saving, then the original claim will be re-opened and queued on the Billing page, and will be processed during the next billing run.');
INSERT INTO `lang_constants` VALUES (190, 'ante');
INSERT INTO `lang_constants` VALUES (191, 'Anus nl, no rectal tenderness/mass');
INSERT INTO `lang_constants` VALUES (192, 'Anxiety');
INSERT INTO `lang_constants` VALUES (193, 'Any');
INSERT INTO `lang_constants` VALUES (194, 'Any Category');
INSERT INTO `lang_constants` VALUES (195, 'Any part of the desired code or its description');
INSERT INTO `lang_constants` VALUES (196, 'Any part of the desired specialty');
INSERT INTO `lang_constants` VALUES (197, 'Any part of the patient name, or \"last,first\", or \"X-Y\"');
INSERT INTO `lang_constants` VALUES (198, 'Apnea');
INSERT INTO `lang_constants` VALUES (199, 'Appearance');
INSERT INTO `lang_constants` VALUES (200, 'Appearance:');
INSERT INTO `lang_constants` VALUES (201, 'Append to the existing note');
INSERT INTO `lang_constants` VALUES (202, 'Append to this note');
INSERT INTO `lang_constants` VALUES (203, 'Append to This Note');
INSERT INTO `lang_constants` VALUES (204, 'Appendectomy');
INSERT INTO `lang_constants` VALUES (205, 'Application Sender Code (GS02)');
INSERT INTO `lang_constants` VALUES (206, 'apply to affected area');
INSERT INTO `lang_constants` VALUES (207, 'apply to skin');
INSERT INTO `lang_constants` VALUES (208, 'Applying');
INSERT INTO `lang_constants` VALUES (209, 'Appointment Date');
INSERT INTO `lang_constants` VALUES (210, 'Appointment status');
INSERT INTO `lang_constants` VALUES (211, 'Appointment within');
INSERT INTO `lang_constants` VALUES (212, 'Appointments');
INSERT INTO `lang_constants` VALUES (213, 'Appointments (write optional)');
INSERT INTO `lang_constants` VALUES (214, 'Appointments and Encounters');
INSERT INTO `lang_constants` VALUES (215, 'Appointments Report');
INSERT INTO `lang_constants` VALUES (216, 'Appointments-Encounters Report');
INSERT INTO `lang_constants` VALUES (217, 'Approve');
INSERT INTO `lang_constants` VALUES (218, 'Approved');
INSERT INTO `lang_constants` VALUES (219, 'Approved Events Administration');
INSERT INTO `lang_constants` VALUES (220, 'Appt-Enc');
INSERT INTO `lang_constants` VALUES (221, 'Appts');
INSERT INTO `lang_constants` VALUES (222, 'April');
INSERT INTO `lang_constants` VALUES (223, 'Arabic');
INSERT INTO `lang_constants` VALUES (224, 'Are you prepared to complete a new GCAC issue for this visit?');
INSERT INTO `lang_constants` VALUES (225, 'Are you sure you want to approve these events?');
INSERT INTO `lang_constants` VALUES (226, 'Are you sure you want to completely remove this form?');
INSERT INTO `lang_constants` VALUES (227, 'Are you sure you want to delete this event?');
INSERT INTO `lang_constants` VALUES (228, 'Are you sure you want to delete this item from the database?');
INSERT INTO `lang_constants` VALUES (229, 'Are you sure you want to delete this note?');
INSERT INTO `lang_constants` VALUES (230, 'Are you sure you want to edit these events?');
INSERT INTO `lang_constants` VALUES (231, 'Are you sure you want to hide these events?');
INSERT INTO `lang_constants` VALUES (232, 'Are you sure you want to view these events?');
INSERT INTO `lang_constants` VALUES (233, 'Are you sure you wish to delete the entire group named');
INSERT INTO `lang_constants` VALUES (234, 'Are you sure you wish to delete the entire list');
INSERT INTO `lang_constants` VALUES (235, 'Are you sure you wish to delete the field in');
INSERT INTO `lang_constants` VALUES (236, 'Are you sure you wish to delete the selected fields?');
INSERT INTO `lang_constants` VALUES (237, 'Are you sure you\'d like to continue with these actions?');
INSERT INTO `lang_constants` VALUES (238, 'Area not specified');
INSERT INTO `lang_constants` VALUES (239, 'Armenian');
INSERT INTO `lang_constants` VALUES (240, 'Arrythmia');
INSERT INTO `lang_constants` VALUES (241, 'Arthritis');
INSERT INTO `lang_constants` VALUES (242, 'Arthritis / degen joint diseas');
INSERT INTO `lang_constants` VALUES (243, 'Arthritis / degen joint disease');
INSERT INTO `lang_constants` VALUES (244, 'as');
INSERT INTO `lang_constants` VALUES (245, 'As Of');
INSERT INTO `lang_constants` VALUES (246, 'Asian');
INSERT INTO `lang_constants` VALUES (247, 'Assessment');
INSERT INTO `lang_constants` VALUES (248, 'Assigned To');
INSERT INTO `lang_constants` VALUES (249, 'Assistant');
INSERT INTO `lang_constants` VALUES (250, 'Asthma');
INSERT INTO `lang_constants` VALUES (251, 'at');
INSERT INTO `lang_constants` VALUES (252, 'At the Navicular');
INSERT INTO `lang_constants` VALUES (253, 'At the Navicular:');
INSERT INTO `lang_constants` VALUES (254, 'Athletic/Injury');
INSERT INTO `lang_constants` VALUES (255, 'Attention');
INSERT INTO `lang_constants` VALUES (256, 'Attn');
INSERT INTO `lang_constants` VALUES (257, 'August');
INSERT INTO `lang_constants` VALUES (258, 'Auth');
INSERT INTO `lang_constants` VALUES (259, 'Auth/notes');
INSERT INTO `lang_constants` VALUES (260, 'Authorizations');
INSERT INTO `lang_constants` VALUES (261, 'Authorize');
INSERT INTO `lang_constants` VALUES (262, 'Authorize - any encounters');
INSERT INTO `lang_constants` VALUES (263, 'Authorize - my encounters');
INSERT INTO `lang_constants` VALUES (264, 'Authorized');
INSERT INTO `lang_constants` VALUES (265, 'Auto Send');
INSERT INTO `lang_constants` VALUES (266, 'Auto-generated');
INSERT INTO `lang_constants` VALUES (267, 'Automobile Medical');
INSERT INTO `lang_constants` VALUES (268, 'autosaved');
INSERT INTO `lang_constants` VALUES (269, 'Available Times');
INSERT INTO `lang_constants` VALUES (270, 'Avulsion / avulsion fracture');
INSERT INTO `lang_constants` VALUES (271, 'Avulsion lateral malleolus');
INSERT INTO `lang_constants` VALUES (272, 'Avulsion medial malleolus ');
INSERT INTO `lang_constants` VALUES (273, 'Awareness-Based');
INSERT INTO `lang_constants` VALUES (274, 'Axillary');
INSERT INTO `lang_constants` VALUES (275, 'b.i.d.');
INSERT INTO `lang_constants` VALUES (276, 'back');
INSERT INTO `lang_constants` VALUES (277, 'Back');
INSERT INTO `lang_constants` VALUES (278, 'Back eight visits');
INSERT INTO `lang_constants` VALUES (279, 'Back eleven visits');
INSERT INTO `lang_constants` VALUES (280, 'Back five visits');
INSERT INTO `lang_constants` VALUES (281, 'Back four visits');
INSERT INTO `lang_constants` VALUES (282, 'Back nine visits');
INSERT INTO `lang_constants` VALUES (283, 'Back one visit');
INSERT INTO `lang_constants` VALUES (284, 'Back Problems');
INSERT INTO `lang_constants` VALUES (285, 'Back seven visits');
INSERT INTO `lang_constants` VALUES (286, 'Back six visits');
INSERT INTO `lang_constants` VALUES (287, 'Back Surgery');
INSERT INTO `lang_constants` VALUES (288, 'Back ten visits');
INSERT INTO `lang_constants` VALUES (289, 'Back three visits');
INSERT INTO `lang_constants` VALUES (290, 'Back twelve visits');
INSERT INTO `lang_constants` VALUES (291, 'Back two visits');
INSERT INTO `lang_constants` VALUES (292, 'Backup');
INSERT INTO `lang_constants` VALUES (293, 'Backup file has been created. Will now send download.');
INSERT INTO `lang_constants` VALUES (294, 'Bad check');
INSERT INTO `lang_constants` VALUES (295, 'Bad debt');
INSERT INTO `lang_constants` VALUES (296, 'Bahasa Indonesia');
INSERT INTO `lang_constants` VALUES (297, 'Bal');
INSERT INTO `lang_constants` VALUES (298, 'Balance');
INSERT INTO `lang_constants` VALUES (299, 'balance');
INSERT INTO `lang_constants` VALUES (300, 'Balance Due');
INSERT INTO `lang_constants` VALUES (301, 'Base of fifth (5th) Metarsal');
INSERT INTO `lang_constants` VALUES (302, 'Base of fifth (5th) Metarsal:');
INSERT INTO `lang_constants` VALUES (303, 'Batch Communication Tool');
INSERT INTO `lang_constants` VALUES (304, 'Batch processing initiated; this may take a while.');
INSERT INTO `lang_constants` VALUES (305, 'BatchCom');
INSERT INTO `lang_constants` VALUES (306, 'because that id does not exist.');
INSERT INTO `lang_constants` VALUES (307, 'Begin');
INSERT INTO `lang_constants` VALUES (308, 'Begin Date');
INSERT INTO `lang_constants` VALUES (309, 'Beginning date of service yyyy-mm-dd');
INSERT INTO `lang_constants` VALUES (310, 'Belching');
INSERT INTO `lang_constants` VALUES (311, 'between');
INSERT INTO `lang_constants` VALUES (312, 'Bilateral:');
INSERT INTO `lang_constants` VALUES (313, 'Bill Date:');
INSERT INTO `lang_constants` VALUES (314, 'Bill/Collect');
INSERT INTO `lang_constants` VALUES (315, 'Billed');
INSERT INTO `lang_constants` VALUES (316, 'Billing');
INSERT INTO `lang_constants` VALUES (317, 'Billing (write optional)');
INSERT INTO `lang_constants` VALUES (318, 'Billing Attn');
INSERT INTO `lang_constants` VALUES (319, 'Billing Code for Requested Service');
INSERT INTO `lang_constants` VALUES (320, 'Billing codes');
INSERT INTO `lang_constants` VALUES (321, 'Billing Information');
INSERT INTO `lang_constants` VALUES (322, 'Billing Location');
INSERT INTO `lang_constants` VALUES (323, 'Billing Note');
INSERT INTO `lang_constants` VALUES (324, 'Billing Note for ');
INSERT INTO `lang_constants` VALUES (325, 'Billing Note:');
INSERT INTO `lang_constants` VALUES (326, 'Billing queue results:');
INSERT INTO `lang_constants` VALUES (327, 'Billing Report');
INSERT INTO `lang_constants` VALUES (328, 'billing to ');
INSERT INTO `lang_constants` VALUES (329, 'Biopsy');
INSERT INTO `lang_constants` VALUES (330, 'Birth Date');
INSERT INTO `lang_constants` VALUES (331, 'Black');
INSERT INTO `lang_constants` VALUES (332, 'Bladder Cancer');
INSERT INTO `lang_constants` VALUES (333, 'Bladder Infections');
INSERT INTO `lang_constants` VALUES (334, 'Blank Forms');
INSERT INTO `lang_constants` VALUES (335, 'Bleeding Problems');
INSERT INTO `lang_constants` VALUES (336, 'Blind Spots');
INSERT INTO `lang_constants` VALUES (337, 'Bloating');
INSERT INTO `lang_constants` VALUES (338, 'Blocked');
INSERT INTO `lang_constants` VALUES (339, 'Blood Pressure');
INSERT INTO `lang_constants` VALUES (340, 'Blood pressure');
INSERT INTO `lang_constants` VALUES (341, 'Bloody Nose');
INSERT INTO `lang_constants` VALUES (342, 'Blue Cross Blue Shield');
INSERT INTO `lang_constants` VALUES (343, 'Blue lines in this report are informational. Black lines show previously existing information.  Green lines show changes that were successfully applied.  Red lines indicate errors, or changes that were not applied; these must be processed manually.  Currently denied claims and payment reversals are not handled automatically and so will appear in red.');
INSERT INTO `lang_constants` VALUES (344, 'Blurred Vision');
INSERT INTO `lang_constants` VALUES (345, 'BMI');
INSERT INTO `lang_constants` VALUES (346, 'BMI Status');
INSERT INTO `lang_constants` VALUES (347, 'Body Region');
INSERT INTO `lang_constants` VALUES (348, 'Bone Tenderness:');
INSERT INTO `lang_constants` VALUES (349, 'Bone Tenderness: Medial Malleolus');
INSERT INTO `lang_constants` VALUES (350, 'Boolean');
INSERT INTO `lang_constants` VALUES (351, 'Bot');
INSERT INTO `lang_constants` VALUES (352, 'Both Ears');
INSERT INTO `lang_constants` VALUES (353, 'both ears');
INSERT INTO `lang_constants` VALUES (354, 'Bottom');
INSERT INTO `lang_constants` VALUES (355, 'BOX 10 A. Employment related ');
INSERT INTO `lang_constants` VALUES (356, 'BOX 10 B. Auto Accident ');
INSERT INTO `lang_constants` VALUES (357, 'BOX 10 C. Other Accident ');
INSERT INTO `lang_constants` VALUES (358, 'BOX 16. Date unable to work from (yyyy-mm-dd):');
INSERT INTO `lang_constants` VALUES (359, 'BOX 16. Date unable to work to (yyyy-mm-dd):');
INSERT INTO `lang_constants` VALUES (360, 'BOX 18. Hospitalization date from (yyyy-mm-dd): ');
INSERT INTO `lang_constants` VALUES (361, 'BOX 18. Hospitalization date to (yyyy-mm-dd): ');
INSERT INTO `lang_constants` VALUES (362, 'BOX 20. Is Outside Lab used?');
INSERT INTO `lang_constants` VALUES (363, 'BOX 22. Medicaid Resubmission Code (ICD-9) ');
INSERT INTO `lang_constants` VALUES (364, 'BOX 23. Prior Authorization No. ');
INSERT INTO `lang_constants` VALUES (365, 'BP');
INSERT INTO `lang_constants` VALUES (366, 'BP Diastolic');
INSERT INTO `lang_constants` VALUES (367, 'BP Systolic');
INSERT INTO `lang_constants` VALUES (368, 'Bpd');
INSERT INTO `lang_constants` VALUES (369, 'Bps');
INSERT INTO `lang_constants` VALUES (370, 'Brazilian Portuguese');
INSERT INTO `lang_constants` VALUES (371, 'Breast');
INSERT INTO `lang_constants` VALUES (372, 'Breast Biopsy');
INSERT INTO `lang_constants` VALUES (373, 'Breast Discharge');
INSERT INTO `lang_constants` VALUES (374, 'Breast Disease');
INSERT INTO `lang_constants` VALUES (375, 'Breast Exam');
INSERT INTO `lang_constants` VALUES (376, 'Breast Mass');
INSERT INTO `lang_constants` VALUES (377, 'Breath Sounds:');
INSERT INTO `lang_constants` VALUES (378, 'Broken Bones');
INSERT INTO `lang_constants` VALUES (379, 'Bronchitis Form');
INSERT INTO `lang_constants` VALUES (380, 'Browse');
INSERT INTO `lang_constants` VALUES (381, 'Browse for Record');
INSERT INTO `lang_constants` VALUES (382, 'Bruising/haematoma');
INSERT INTO `lang_constants` VALUES (383, 'Bulging Right:');
INSERT INTO `lang_constants` VALUES (384, 'Burning with Urination');
INSERT INTO `lang_constants` VALUES (385, 'Burning With Urination');
INSERT INTO `lang_constants` VALUES (386, 'Busy');
INSERT INTO `lang_constants` VALUES (387, 'Buttock + S.I.');
INSERT INTO `lang_constants` VALUES (388, 'by');
INSERT INTO `lang_constants` VALUES (389, 'by mouth');
INSERT INTO `lang_constants` VALUES (390, 'By/Source');
INSERT INTO `lang_constants` VALUES (391, 'By:');
INSERT INTO `lang_constants` VALUES (392, 'C');
INSERT INTO `lang_constants` VALUES (393, 'Cache Lifetime (in seconds)');
INSERT INTO `lang_constants` VALUES (394, 'Cache template output?');
INSERT INTO `lang_constants` VALUES (395, 'Caffeine consumption');
INSERT INTO `lang_constants` VALUES (396, 'Calendar');
INSERT INTO `lang_constants` VALUES (397, 'Calendar Settings');
INSERT INTO `lang_constants` VALUES (398, 'Calendar UI');
INSERT INTO `lang_constants` VALUES (399, 'Calendar View');
INSERT INTO `lang_constants` VALUES (400, 'Call to addForm() goes here.<br>');
INSERT INTO `lang_constants` VALUES (401, 'Calories');
INSERT INTO `lang_constants` VALUES (402, 'CAMOS');
INSERT INTO `lang_constants` VALUES (403, 'Cancel');
INSERT INTO `lang_constants` VALUES (404, 'Cancer');
INSERT INTO `lang_constants` VALUES (405, 'Cannot add this entry because it already exists!');
INSERT INTO `lang_constants` VALUES (406, 'Cannot add/update this entry because a duplicate already exists!');
INSERT INTO `lang_constants` VALUES (407, 'cannot be converted to JPEG. Perhaps ImageMagick is not installed?');
INSERT INTO `lang_constants` VALUES (408, 'cannot be displayed inline because its type is not supported by the browser.');
INSERT INTO `lang_constants` VALUES (409, 'cannot be displayed inline becuase its type is not supported by the browser');
INSERT INTO `lang_constants` VALUES (410, 'cannot be displayed inline becuase its type is not supported by the browser.');
INSERT INTO `lang_constants` VALUES (411, 'Cannot create');
INSERT INTO `lang_constants` VALUES (412, 'Cannot find ');
INSERT INTO `lang_constants` VALUES (413, 'Cannot find patient from SQL-Ledger customer id');
INSERT INTO `lang_constants` VALUES (414, 'Cannot find postscript document reference in ');
INSERT INTO `lang_constants` VALUES (415, 'Cannot find provider from SQL-Ledger employee = ');
INSERT INTO `lang_constants` VALUES (416, 'Cannot open ');
INSERT INTO `lang_constants` VALUES (417, 'Cannot read');
INSERT INTO `lang_constants` VALUES (418, 'Cannot update because you are not editing an existing entry!');
INSERT INTO `lang_constants` VALUES (419, 'capsule');
INSERT INTO `lang_constants` VALUES (420, 'Cardiac Catheterization');
INSERT INTO `lang_constants` VALUES (421, 'Cardiac Echo');
INSERT INTO `lang_constants` VALUES (422, 'Cardiovascular');
INSERT INTO `lang_constants` VALUES (423, 'Cartilage / chondral / disc damage');
INSERT INTO `lang_constants` VALUES (424, 'Cartilage injury');
INSERT INTO `lang_constants` VALUES (425, 'Cartoid pulsations nl, pedal pulses nl');
INSERT INTO `lang_constants` VALUES (426, 'cash');
INSERT INTO `lang_constants` VALUES (427, 'Cash');
INSERT INTO `lang_constants` VALUES (428, 'Cash Rec');
INSERT INTO `lang_constants` VALUES (429, 'Cash Receipts by Provider');
INSERT INTO `lang_constants` VALUES (430, 'Cataract Surgery');
INSERT INTO `lang_constants` VALUES (431, 'Cataracts');
INSERT INTO `lang_constants` VALUES (432, 'Categories');
INSERT INTO `lang_constants` VALUES (433, 'Category');
INSERT INTO `lang_constants` VALUES (434, 'category');
INSERT INTO `lang_constants` VALUES (435, 'Category ');
INSERT INTO `lang_constants` VALUES (436, 'Category Details');
INSERT INTO `lang_constants` VALUES (437, 'Category Limits');
INSERT INTO `lang_constants` VALUES (438, 'Category Name');
INSERT INTO `lang_constants` VALUES (439, 'Caucasian');
INSERT INTO `lang_constants` VALUES (440, 'Cell Phone');
INSERT INTO `lang_constants` VALUES (441, 'Cell Phone Number');
INSERT INTO `lang_constants` VALUES (442, 'Central Certification');
INSERT INTO `lang_constants` VALUES (443, 'cfirst($instype) . \' Ins');
INSERT INTO `lang_constants` VALUES (444, 'ChampUS');
INSERT INTO `lang_constants` VALUES (445, 'ChampUSVA');
INSERT INTO `lang_constants` VALUES (446, 'change');
INSERT INTO `lang_constants` VALUES (447, 'Change');
INSERT INTO `lang_constants` VALUES (448, 'Change Activity');
INSERT INTO `lang_constants` VALUES (449, 'Change in Vision');
INSERT INTO `lang_constants` VALUES (450, 'Change In Vision');
INSERT INTO `lang_constants` VALUES (451, 'Changed');
INSERT INTO `lang_constants` VALUES (452, 'Changed Bowel');
INSERT INTO `lang_constants` VALUES (453, 'Charge');
INSERT INTO `lang_constants` VALUES (454, 'Charges');
INSERT INTO `lang_constants` VALUES (455, 'Chart');
INSERT INTO `lang_constants` VALUES (456, 'Chart Activity');
INSERT INTO `lang_constants` VALUES (457, 'Chart Check-in/out Activity Report');
INSERT INTO `lang_constants` VALUES (458, 'Chart ID');
INSERT INTO `lang_constants` VALUES (459, 'Chart ID:');
INSERT INTO `lang_constants` VALUES (460, 'Chart Location Activity');
INSERT INTO `lang_constants` VALUES (461, 'Chart Note');
INSERT INTO `lang_constants` VALUES (462, 'Chart Storage Locations');
INSERT INTO `lang_constants` VALUES (463, 'Chart Tracker');
INSERT INTO `lang_constants` VALUES (464, 'Chart Trk');
INSERT INTO `lang_constants` VALUES (465, 'Charts Checked Out');
INSERT INTO `lang_constants` VALUES (466, 'Charts Out');
INSERT INTO `lang_constants` VALUES (467, 'check');
INSERT INTO `lang_constants` VALUES (468, 'Check');
INSERT INTO `lang_constants` VALUES (469, 'Check All');
INSERT INTO `lang_constants` VALUES (470, 'Check In To');
INSERT INTO `lang_constants` VALUES (471, 'Check Input Data');
INSERT INTO `lang_constants` VALUES (472, 'Check Number');
INSERT INTO `lang_constants` VALUES (473, 'Check/EOB Date:');
INSERT INTO `lang_constants` VALUES (474, 'Check/EOB No.:');
INSERT INTO `lang_constants` VALUES (475, 'Check/Ref Number');
INSERT INTO `lang_constants` VALUES (476, 'Check/Reference Number');
INSERT INTO `lang_constants` VALUES (477, 'Checkbox list');
INSERT INTO `lang_constants` VALUES (478, 'checkbox list');
INSERT INTO `lang_constants` VALUES (479, 'checkbox w/ text');
INSERT INTO `lang_constants` VALUES (480, 'Checkbox w/text');
INSERT INTO `lang_constants` VALUES (481, 'Checked box = yes ,  empty = no');
INSERT INTO `lang_constants` VALUES (482, 'Checkout');
INSERT INTO `lang_constants` VALUES (483, 'Chest');
INSERT INTO `lang_constants` VALUES (484, 'Chest CTAB');
INSERT INTO `lang_constants` VALUES (485, 'Chest Pain');
INSERT INTO `lang_constants` VALUES (486, 'Chest Pain:');
INSERT INTO `lang_constants` VALUES (487, 'Chest Pains');
INSERT INTO `lang_constants` VALUES (488, 'Chg');
INSERT INTO `lang_constants` VALUES (489, 'Chief Complaint');
INSERT INTO `lang_constants` VALUES (490, 'Child');
INSERT INTO `lang_constants` VALUES (491, 'Chills');
INSERT INTO `lang_constants` VALUES (492, 'Chinese');
INSERT INTO `lang_constants` VALUES (493, 'Choices');
INSERT INTO `lang_constants` VALUES (494, 'Cholecystectomy');
INSERT INTO `lang_constants` VALUES (495, 'Cholecystestomy');
INSERT INTO `lang_constants` VALUES (496, 'Choose');
INSERT INTO `lang_constants` VALUES (497, 'Choose a section and click an item within it; then in the other section you will see the related items highlighted, and you can click in that section to add and delete relationships.');
INSERT INTO `lang_constants` VALUES (498, 'Choose list');
INSERT INTO `lang_constants` VALUES (499, 'Choose print format for this encounter report.');
INSERT INTO `lang_constants` VALUES (500, 'Chronic Bronchitis');
INSERT INTO `lang_constants` VALUES (501, 'Chronic Joint Pain');
INSERT INTO `lang_constants` VALUES (502, 'Chronic synovitis / effusion / joint pain / gout');
INSERT INTO `lang_constants` VALUES (503, 'Chronic/Recurrent');
INSERT INTO `lang_constants` VALUES (504, 'Cirrhosis of the Liver');
INSERT INTO `lang_constants` VALUES (505, 'Cirrhosis Of The Liver');
INSERT INTO `lang_constants` VALUES (506, 'City');
INSERT INTO `lang_constants` VALUES (507, 'City Name');
INSERT INTO `lang_constants` VALUES (508, 'City, State');
INSERT INTO `lang_constants` VALUES (509, 'City, State Zip');
INSERT INTO `lang_constants` VALUES (510, 'City/State');
INSERT INTO `lang_constants` VALUES (511, 'Claim');
INSERT INTO `lang_constants` VALUES (512, 'Claim ');
INSERT INTO `lang_constants` VALUES (513, 'Claim test has completed running');
INSERT INTO `lang_constants` VALUES (514, 'Claim was generated to file ');
INSERT INTO `lang_constants` VALUES (515, 'Classification');
INSERT INTO `lang_constants` VALUES (516, 'Clear');
INSERT INTO `lang_constants` VALUES (517, 'Clear All');
INSERT INTO `lang_constants` VALUES (518, 'Clear Justification');
INSERT INTO `lang_constants` VALUES (519, 'Clear Smarty Cache');
INSERT INTO `lang_constants` VALUES (520, 'CLIA Number');
INSERT INTO `lang_constants` VALUES (521, 'Click');
INSERT INTO `lang_constants` VALUES (522, 'Click \'export\' to export your Category, Subcategory, Item, Content data to a text file. Any resemblance of this file to an XML file is purely coincidental. The opening and closing tags must be on the same line, they must be lowercase with no spaces. To import, browse for a file and click \'import\'. If the data is completely different, it will merge with your existing data. If there are similar item names, The old one will be kept and the new one saved with a number added to the end.');
INSERT INTO `lang_constants` VALUES (523, 'click for more');
INSERT INTO `lang_constants` VALUES (524, 'Click here to choose a date');
INSERT INTO `lang_constants` VALUES (525, 'click here to update priority, category and nickname settings');
INSERT INTO `lang_constants` VALUES (526, 'Click here to view all.');
INSERT INTO `lang_constants` VALUES (527, 'Click to download');
INSERT INTO `lang_constants` VALUES (528, 'Click to edit');
INSERT INTO `lang_constants` VALUES (529, 'Click to edit this event');
INSERT INTO `lang_constants` VALUES (530, 'Click to generate the report');
INSERT INTO `lang_constants` VALUES (531, 'Click to print');
INSERT INTO `lang_constants` VALUES (532, 'Click to receive (add) new lot');
INSERT INTO `lang_constants` VALUES (533, 'Click to select');
INSERT INTO `lang_constants` VALUES (534, 'Click to select or change diagnoses');
INSERT INTO `lang_constants` VALUES (535, 'Click to select patient');
INSERT INTO `lang_constants` VALUES (536, 'Click to select related code');
INSERT INTO `lang_constants` VALUES (537, 'Click to view');
INSERT INTO `lang_constants` VALUES (538, 'Click to view or edit');
INSERT INTO `lang_constants` VALUES (539, 'Click to view/edit');
INSERT INTO `lang_constants` VALUES (540, 'Click:');
INSERT INTO `lang_constants` VALUES (541, 'Client Copy');
INSERT INTO `lang_constants` VALUES (542, 'Client medical history summary');
INSERT INTO `lang_constants` VALUES (543, 'Client Profile - New Clients');
INSERT INTO `lang_constants` VALUES (544, 'Client Profile - Unique Clients');
INSERT INTO `lang_constants` VALUES (545, 'Clients');
INSERT INTO `lang_constants` VALUES (546, 'Clinic');
INSERT INTO `lang_constants` VALUES (547, 'Clinic Copy');
INSERT INTO `lang_constants` VALUES (548, 'Clinic Daily Record');
INSERT INTO `lang_constants` VALUES (549, 'Clinic ID');
INSERT INTO `lang_constants` VALUES (550, 'Clinicians');
INSERT INTO `lang_constants` VALUES (551, 'Clone');
INSERT INTO `lang_constants` VALUES (552, 'Clone Past Visit');
INSERT INTO `lang_constants` VALUES (553, 'Close');
INSERT INTO `lang_constants` VALUES (554, 'close window');
INSERT INTO `lang_constants` VALUES (555, 'Closed');
INSERT INTO `lang_constants` VALUES (556, 'cm');
INSERT INTO `lang_constants` VALUES (557, 'CMS 1500 Margins');
INSERT INTO `lang_constants` VALUES (558, 'CMS ID');
INSERT INTO `lang_constants` VALUES (559, 'CN2-12 intact');
INSERT INTO `lang_constants` VALUES (560, 'Code');
INSERT INTO `lang_constants` VALUES (561, 'code');
INSERT INTO `lang_constants` VALUES (562, 'Code Finder');
INSERT INTO `lang_constants` VALUES (563, 'Code must be two letter lowercase');
INSERT INTO `lang_constants` VALUES (564, 'code type');
INSERT INTO `lang_constants` VALUES (565, 'Codes');
INSERT INTO `lang_constants` VALUES (566, 'Coding');
INSERT INTO `lang_constants` VALUES (567, 'Coding - any encounters (write,wsome optional)');
INSERT INTO `lang_constants` VALUES (568, 'Coding - my encounters (write,wsome optional)');
INSERT INTO `lang_constants` VALUES (569, 'Coding not authorized');
INSERT INTO `lang_constants` VALUES (570, 'Coffee');
INSERT INTO `lang_constants` VALUES (571, 'Coll w/o');
INSERT INTO `lang_constants` VALUES (572, 'collapse all');
INSERT INTO `lang_constants` VALUES (573, 'Collections');
INSERT INTO `lang_constants` VALUES (574, 'Collections Report');
INSERT INTO `lang_constants` VALUES (575, 'Colon Cancer');
INSERT INTO `lang_constants` VALUES (576, 'Colon Cancer Surgery');
INSERT INTO `lang_constants` VALUES (577, 'Colonoscopy');
INSERT INTO `lang_constants` VALUES (578, 'colonoscopy');
INSERT INTO `lang_constants` VALUES (579, 'Color');
INSERT INTO `lang_constants` VALUES (580, 'Columns');
INSERT INTO `lang_constants` VALUES (581, 'Comments');
INSERT INTO `lang_constants` VALUES (582, 'Commercial Insurance Co.');
INSERT INTO `lang_constants` VALUES (583, 'Commit Changes');
INSERT INTO `lang_constants` VALUES (584, 'Communications');
INSERT INTO `lang_constants` VALUES (585, 'Completed');
INSERT INTO `lang_constants` VALUES (586, 'Complications by Service Provider');
INSERT INTO `lang_constants` VALUES (587, 'Complications of Abortion');
INSERT INTO `lang_constants` VALUES (588, 'Computer Aided Medical Ordering System');
INSERT INTO `lang_constants` VALUES (589, 'Conclusions');
INSERT INTO `lang_constants` VALUES (590, 'Congenital');
INSERT INTO `lang_constants` VALUES (591, 'Conjuntiva, pupils');
INSERT INTO `lang_constants` VALUES (592, 'Constant');
INSERT INTO `lang_constants` VALUES (593, 'constant name');
INSERT INTO `lang_constants` VALUES (594, 'constants');
INSERT INTO `lang_constants` VALUES (595, 'Constipation');
INSERT INTO `lang_constants` VALUES (596, 'Constitutional');
INSERT INTO `lang_constants` VALUES (597, 'Consultation Brief Description');
INSERT INTO `lang_constants` VALUES (598, 'Contact');
INSERT INTO `lang_constants` VALUES (599, 'Contact Email');
INSERT INTO `lang_constants` VALUES (600, 'Contact Email Address');
INSERT INTO `lang_constants` VALUES (601, 'contact info');
INSERT INTO `lang_constants` VALUES (602, 'Contact Lenses');
INSERT INTO `lang_constants` VALUES (603, 'Contact name');
INSERT INTO `lang_constants` VALUES (604, 'Contact Person');
INSERT INTO `lang_constants` VALUES (605, 'Contact Phone Number');
INSERT INTO `lang_constants` VALUES (606, 'Content');
INSERT INTO `lang_constants` VALUES (607, 'content');
INSERT INTO `lang_constants` VALUES (608, 'Continue');
INSERT INTO `lang_constants` VALUES (609, 'Contra Clients');
INSERT INTO `lang_constants` VALUES (610, 'Contraception');
INSERT INTO `lang_constants` VALUES (611, 'Contraception Issues');
INSERT INTO `lang_constants` VALUES (612, 'Contraceptive Complication (specify)');
INSERT INTO `lang_constants` VALUES (613, 'Contraceptive Method');
INSERT INTO `lang_constants` VALUES (614, 'Contraceptive services previously started');
INSERT INTO `lang_constants` VALUES (615, 'Contraceptives Start');
INSERT INTO `lang_constants` VALUES (616, 'Control No.');
INSERT INTO `lang_constants` VALUES (617, 'Copay');
INSERT INTO `lang_constants` VALUES (618, 'CoPay');
INSERT INTO `lang_constants` VALUES (619, 'Copay not positive');
INSERT INTO `lang_constants` VALUES (620, 'Copays');
INSERT INTO `lang_constants` VALUES (621, 'COPD');
INSERT INTO `lang_constants` VALUES (622, 'Copy Pages to Patient Chart');
INSERT INTO `lang_constants` VALUES (623, 'Copy Values');
INSERT INTO `lang_constants` VALUES (624, 'Copyright Notice');
INSERT INTO `lang_constants` VALUES (625, 'Coronary Artery Bypass');
INSERT INTO `lang_constants` VALUES (626, 'Cough');
INSERT INTO `lang_constants` VALUES (627, 'Cough:');
INSERT INTO `lang_constants` VALUES (628, 'Could not send email due to a server problem, ');
INSERT INTO `lang_constants` VALUES (629, 'Couldn\'t create backup dir:');
INSERT INTO `lang_constants` VALUES (630, 'Couldn\'t remove dir:');
INSERT INTO `lang_constants` VALUES (631, 'Couldn\'t remove old backup file:');
INSERT INTO `lang_constants` VALUES (632, 'Couldn\'t remove old export file: ');
INSERT INTO `lang_constants` VALUES (633, 'Couns by Method');
INSERT INTO `lang_constants` VALUES (634, 'Counseling');
INSERT INTO `lang_constants` VALUES (635, 'Counseling activities');
INSERT INTO `lang_constants` VALUES (636, 'COUNTER REFERRAL FORM');
INSERT INTO `lang_constants` VALUES (637, 'Counter-Referral');
INSERT INTO `lang_constants` VALUES (638, 'Country');
INSERT INTO `lang_constants` VALUES (639, 'Country List (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (640, 'county');
INSERT INTO `lang_constants` VALUES (641, 'Coupon');
INSERT INTO `lang_constants` VALUES (642, 'CPT');
INSERT INTO `lang_constants` VALUES (643, 'CPT Codes');
INSERT INTO `lang_constants` VALUES (644, 'Crackles:');
INSERT INTO `lang_constants` VALUES (645, 'cream');
INSERT INTO `lang_constants` VALUES (646, 'Create an Event');
INSERT INTO `lang_constants` VALUES (647, 'Create and download a full backup');
INSERT INTO `lang_constants` VALUES (648, 'Create Backup');
INSERT INTO `lang_constants` VALUES (649, 'Create New Patient');
INSERT INTO `lang_constants` VALUES (650, 'Create Patient Note');
INSERT INTO `lang_constants` VALUES (651, 'Created');
INSERT INTO `lang_constants` VALUES (652, 'Creating export file');
INSERT INTO `lang_constants` VALUES (653, 'credit');
INSERT INTO `lang_constants` VALUES (654, 'Credits');
INSERT INTO `lang_constants` VALUES (655, 'Crohn\'s Disease');
INSERT INTO `lang_constants` VALUES (656, 'Crohns Disease');
INSERT INTO `lang_constants` VALUES (657, 'CSV File');
INSERT INTO `lang_constants` VALUES (658, 'Current');
INSERT INTO `lang_constants` VALUES (659, 'Current Consultation');
INSERT INTO `lang_constants` VALUES (660, 'Current day highlight color');
INSERT INTO `lang_constants` VALUES (661, 'Current file name was changed to');
INSERT INTO `lang_constants` VALUES (662, 'Current Location');
INSERT INTO `lang_constants` VALUES (663, 'Current Patient');
INSERT INTO `lang_constants` VALUES (664, 'Currently Active');
INSERT INTO `lang_constants` VALUES (665, 'Cushing Syndrom');
INSERT INTO `lang_constants` VALUES (666, 'Cushing Syndrome');
INSERT INTO `lang_constants` VALUES (667, 'Custom');
INSERT INTO `lang_constants` VALUES (668, 'Cycle');
INSERT INTO `lang_constants` VALUES (669, 'CYP');
INSERT INTO `lang_constants` VALUES (670, 'CYP Factor');
INSERT INTO `lang_constants` VALUES (671, 'CYP Report');
INSERT INTO `lang_constants` VALUES (672, 'D');
INSERT INTO `lang_constants` VALUES (673, 'D&C');
INSERT INTO `lang_constants` VALUES (674, 'D&E');
INSERT INTO `lang_constants` VALUES (675, 'D.O.B.');
INSERT INTO `lang_constants` VALUES (676, 'daily');
INSERT INTO `lang_constants` VALUES (677, 'Data Alike is already in database, please change code and/or description');
INSERT INTO `lang_constants` VALUES (678, 'Data Alike is already in database, please change constant name');
INSERT INTO `lang_constants` VALUES (679, 'Data Cols');
INSERT INTO `lang_constants` VALUES (680, 'Data Type');
INSERT INTO `lang_constants` VALUES (681, 'Database');
INSERT INTO `lang_constants` VALUES (682, 'Database Reporting');
INSERT INTO `lang_constants` VALUES (683, 'DataCols must be a number between 1 and 999');
INSERT INTO `lang_constants` VALUES (684, 'Date');
INSERT INTO `lang_constants` VALUES (685, 'DATE');
INSERT INTO `lang_constants` VALUES (686, 'Date Administered');
INSERT INTO `lang_constants` VALUES (687, 'Date contraceptive services initially provided');
INSERT INTO `lang_constants` VALUES (688, 'Date Destroyed');
INSERT INTO `lang_constants` VALUES (689, 'Date Display Format');
INSERT INTO `lang_constants` VALUES (690, 'Date format for \"appointment end\" is not valid');
INSERT INTO `lang_constants` VALUES (691, 'Date format for \"appointment start\" is not valid');
INSERT INTO `lang_constants` VALUES (692, 'Date format for \"Next Appointment\" is not valid');
INSERT INTO `lang_constants` VALUES (693, 'Date format for \"not seen since\" is not valid');
INSERT INTO `lang_constants` VALUES (694, 'Date format for \"seen since\" is not valid');
INSERT INTO `lang_constants` VALUES (695, 'Date Immunization Information Statements Given');
INSERT INTO `lang_constants` VALUES (696, 'Date is missing for code ');
INSERT INTO `lang_constants` VALUES (697, 'Date of bank deposit yyyy-mm-dd');
INSERT INTO `lang_constants` VALUES (698, 'Date of Birth');
INSERT INTO `lang_constants` VALUES (699, 'Date of birth');
INSERT INTO `lang_constants` VALUES (700, 'Date of Injury');
INSERT INTO `lang_constants` VALUES (701, 'Date of payment yyyy-mm-dd');
INSERT INTO `lang_constants` VALUES (702, 'Date of referral');
INSERT INTO `lang_constants` VALUES (703, 'Date of reply');
INSERT INTO `lang_constants` VALUES (704, 'Date Of Service');
INSERT INTO `lang_constants` VALUES (705, 'Date of service mm/dd/yyyy');
INSERT INTO `lang_constants` VALUES (706, 'Date of Service:');
INSERT INTO `lang_constants` VALUES (707, 'Date Of Signature');
INSERT INTO `lang_constants` VALUES (708, 'Date of VIS Statement');
INSERT INTO `lang_constants` VALUES (709, 'Date/Appt');
INSERT INTO `lang_constants` VALUES (710, 'Date/Notes');
INSERT INTO `lang_constants` VALUES (711, 'Date/Notes of Last');
INSERT INTO `lang_constants` VALUES (712, 'Date:');
INSERT INTO `lang_constants` VALUES (713, 'day');
INSERT INTO `lang_constants` VALUES (714, 'Day');
INSERT INTO `lang_constants` VALUES (715, 'Day View');
INSERT INTO `lang_constants` VALUES (716, 'Day(s)');
INSERT INTO `lang_constants` VALUES (717, 'Day(s) M-F');
INSERT INTO `lang_constants` VALUES (718, 'days');
INSERT INTO `lang_constants` VALUES (719, 'Days');
INSERT INTO `lang_constants` VALUES (720, 'Days and Games Missed');
INSERT INTO `lang_constants` VALUES (721, 'Days From Last Encounter');
INSERT INTO `lang_constants` VALUES (722, 'Days per Column:');
INSERT INTO `lang_constants` VALUES (723, 'DB installed');
INSERT INTO `lang_constants` VALUES (724, 'DEA');
INSERT INTO `lang_constants` VALUES (725, 'Debug Information');
INSERT INTO `lang_constants` VALUES (726, 'December');
INSERT INTO `lang_constants` VALUES (727, 'Default');
INSERT INTO `lang_constants` VALUES (728, 'Default Calendar View');
INSERT INTO `lang_constants` VALUES (729, 'Default Facility');
INSERT INTO `lang_constants` VALUES (730, 'Default List (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (731, 'Default Method');
INSERT INTO `lang_constants` VALUES (732, 'Default Provider');
INSERT INTO `lang_constants` VALUES (733, 'Default Template');
INSERT INTO `lang_constants` VALUES (734, 'Default Value');
INSERT INTO `lang_constants` VALUES (735, 'Default X12 Partner');
INSERT INTO `lang_constants` VALUES (736, 'Default/Global');
INSERT INTO `lang_constants` VALUES (737, 'del');
INSERT INTO `lang_constants` VALUES (738, 'Delayed Recurrence (> 12 Mo)');
INSERT INTO `lang_constants` VALUES (739, 'Delete');
INSERT INTO `lang_constants` VALUES (740, 'delete');
INSERT INTO `lang_constants` VALUES (741, 'Delete Categories with ID(s) : ');
INSERT INTO `lang_constants` VALUES (742, 'Delete Group');
INSERT INTO `lang_constants` VALUES (743, 'Delete List');
INSERT INTO `lang_constants` VALUES (744, 'Delete Pages');
INSERT INTO `lang_constants` VALUES (745, 'Delete Patient, Encounter, Form, Issue, Document, Payment, Billing or Transaction');
INSERT INTO `lang_constants` VALUES (746, 'Delete Selected Items');
INSERT INTO `lang_constants` VALUES (747, 'Delete successful.');
INSERT INTO `lang_constants` VALUES (748, 'Delete this document');
INSERT INTO `lang_constants` VALUES (749, 'Delete this form');
INSERT INTO `lang_constants` VALUES (750, 'Delete this note');
INSERT INTO `lang_constants` VALUES (751, 'Dementia');
INSERT INTO `lang_constants` VALUES (752, 'Demographics');
INSERT INTO `lang_constants` VALUES (753, 'Demographics (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (754, 'Demographics not authorized');
INSERT INTO `lang_constants` VALUES (755, 'Demographics not authorized.');
INSERT INTO `lang_constants` VALUES (756, 'Dental');
INSERT INTO `lang_constants` VALUES (757, 'Dental Issues');
INSERT INTO `lang_constants` VALUES (758, 'Depending on the type of bill you are testing you will see HCFA like output on a blank page for HCFA bills, you will see many lines of somewhat garbled text  and information if you are testing an X12 claim. That garbled text is the X12 EDI 4010A format. Occasionally you will see odd characters that look like dominoes or  squiglies, these are control characters such as page feeds and are normal.');
INSERT INTO `lang_constants` VALUES (759, 'Deposit Date:');
INSERT INTO `lang_constants` VALUES (760, 'Depressed');
INSERT INTO `lang_constants` VALUES (761, 'Depression');
INSERT INTO `lang_constants` VALUES (762, 'Description');
INSERT INTO `lang_constants` VALUES (763, 'description');
INSERT INTO `lang_constants` VALUES (764, 'Description Translation');
INSERT INTO `lang_constants` VALUES (765, 'Destination');
INSERT INTO `lang_constants` VALUES (766, 'Destroy Lot');
INSERT INTO `lang_constants` VALUES (767, 'Destroy...');
INSERT INTO `lang_constants` VALUES (768, 'Destroyed');
INSERT INTO `lang_constants` VALUES (769, 'Destroyed Drugs');
INSERT INTO `lang_constants` VALUES (770, 'Destroyed Drugs Report');
INSERT INTO `lang_constants` VALUES (771, 'Details');
INSERT INTO `lang_constants` VALUES (772, 'Developmental abnormality');
INSERT INTO `lang_constants` VALUES (773, 'Diabetes');
INSERT INTO `lang_constants` VALUES (774, 'Diag');
INSERT INTO `lang_constants` VALUES (775, 'Diagnosis');
INSERT INTO `lang_constants` VALUES (776, 'Diagnosis must be coded into a linked encounter');
INSERT INTO `lang_constants` VALUES (777, 'Diagnosis:');
INSERT INTO `lang_constants` VALUES (778, 'Diagnosis: ');
INSERT INTO `lang_constants` VALUES (779, 'Diagnostic Tests:');
INSERT INTO `lang_constants` VALUES (780, 'Dials');
INSERT INTO `lang_constants` VALUES (781, 'Diaphragms/Caps');
INSERT INTO `lang_constants` VALUES (782, 'Diarrhea');
INSERT INTO `lang_constants` VALUES (783, 'Dictation');
INSERT INTO `lang_constants` VALUES (784, 'Dictation: ');
INSERT INTO `lang_constants` VALUES (785, 'Did you receive a copy of the HIPAA Notice?');
INSERT INTO `lang_constants` VALUES (786, 'Diffuse:');
INSERT INTO `lang_constants` VALUES (787, 'Digitally Signed');
INSERT INTO `lang_constants` VALUES (788, 'Direct Mail');
INSERT INTO `lang_constants` VALUES (789, 'Disability');
INSERT INTO `lang_constants` VALUES (790, 'disabled');
INSERT INTO `lang_constants` VALUES (791, 'Disabled');
INSERT INTO `lang_constants` VALUES (792, 'DISC');
INSERT INTO `lang_constants` VALUES (793, 'Discharge');
INSERT INTO `lang_constants` VALUES (794, 'Discharge From Urethra');
INSERT INTO `lang_constants` VALUES (795, 'Discharge Right');
INSERT INTO `lang_constants` VALUES (796, 'Discharge Right:');
INSERT INTO `lang_constants` VALUES (797, 'Discount');
INSERT INTO `lang_constants` VALUES (798, 'Discount Amount');
INSERT INTO `lang_constants` VALUES (799, 'Discount Level');
INSERT INTO `lang_constants` VALUES (800, 'Disease');
INSERT INTO `lang_constants` VALUES (801, 'Dislocation');
INSERT INTO `lang_constants` VALUES (802, 'Disp #');
INSERT INTO `lang_constants` VALUES (803, 'Dispatch');
INSERT INTO `lang_constants` VALUES (804, 'Dispatch Received Document');
INSERT INTO `lang_constants` VALUES (805, 'Dispensed');
INSERT INTO `lang_constants` VALUES (806, 'Display event dates in block?');
INSERT INTO `lang_constants` VALUES (807, 'Display how many events?');
INSERT INTO `lang_constants` VALUES (808, 'Display location in block?');
INSERT INTO `lang_constants` VALUES (809, 'Display the calendar?');
INSERT INTO `lang_constants` VALUES (810, 'Display today\'s events in the block?');
INSERT INTO `lang_constants` VALUES (811, 'Display topic in block?');
INSERT INTO `lang_constants` VALUES (812, 'Display upcoming events in block?');
INSERT INTO `lang_constants` VALUES (813, 'Distribution');
INSERT INTO `lang_constants` VALUES (814, 'Diverticulitis');
INSERT INTO `lang_constants` VALUES (815, 'Diverticulitis Surgery');
INSERT INTO `lang_constants` VALUES (816, 'Divirticulitis');
INSERT INTO `lang_constants` VALUES (817, 'Divirticulitis Surgery');
INSERT INTO `lang_constants` VALUES (818, 'Divorced');
INSERT INTO `lang_constants` VALUES (819, 'Dizziness:');
INSERT INTO `lang_constants` VALUES (820, 'do not save');
INSERT INTO `lang_constants` VALUES (821, 'do not substitute');
INSERT INTO `lang_constants` VALUES (822, 'do nothing');
INSERT INTO `lang_constants` VALUES (823, 'Do you really want to delete this group');
INSERT INTO `lang_constants` VALUES (824, 'Do you wish to continue adding this new patient?');
INSERT INTO `lang_constants` VALUES (825, 'Do you wish to continue with the new name?');
INSERT INTO `lang_constants` VALUES (826, 'Do you wish to PERMANENTLY delete this immunization record?');
INSERT INTO `lang_constants` VALUES (827, 'DOB');
INSERT INTO `lang_constants` VALUES (828, 'DOB is missing, please enter if possible');
INSERT INTO `lang_constants` VALUES (829, 'Docs');
INSERT INTO `lang_constants` VALUES (830, 'Doctor');
INSERT INTO `lang_constants` VALUES (831, 'Doctor:');
INSERT INTO `lang_constants` VALUES (832, 'Doctor\'s name and signature');
INSERT INTO `lang_constants` VALUES (833, 'Document');
INSERT INTO `lang_constants` VALUES (834, 'document');
INSERT INTO `lang_constants` VALUES (835, 'Document Categories');
INSERT INTO `lang_constants` VALUES (836, 'Document could not be moved to patient id');
INSERT INTO `lang_constants` VALUES (837, 'Document Date');
INSERT INTO `lang_constants` VALUES (838, 'Document date and issue updated successfully');
INSERT INTO `lang_constants` VALUES (839, 'Document moved to new category');
INSERT INTO `lang_constants` VALUES (840, 'Document moved to patient id');
INSERT INTO `lang_constants` VALUES (841, 'Document/Imaging Store');
INSERT INTO `lang_constants` VALUES (842, 'Documents');
INSERT INTO `lang_constants` VALUES (843, 'Documents (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (844, 'DOE');
INSERT INTO `lang_constants` VALUES (845, 'Domestic Partner');
INSERT INTO `lang_constants` VALUES (846, 'Don\'t Save');
INSERT INTO `lang_constants` VALUES (847, 'Don\'t Save');
INSERT INTO `lang_constants` VALUES (848, 'Don\'t Save Changes');
INSERT INTO `lang_constants` VALUES (849, 'Done');
INSERT INTO `lang_constants` VALUES (850, 'Done with:');
INSERT INTO `lang_constants` VALUES (851, 'Done.  Will now send download.');
INSERT INTO `lang_constants` VALUES (852, 'DOS');
INSERT INTO `lang_constants` VALUES (853, 'Dosage');
INSERT INTO `lang_constants` VALUES (854, 'double click to edit');
INSERT INTO `lang_constants` VALUES (855, 'Double Vision');
INSERT INTO `lang_constants` VALUES (856, 'Download billing file, post to accounting and mark as billed');
INSERT INTO `lang_constants` VALUES (857, 'Download configuration data');
INSERT INTO `lang_constants` VALUES (858, 'Dr Check');
INSERT INTO `lang_constants` VALUES (859, 'Dr Visit');
INSERT INTO `lang_constants` VALUES (860, 'Dr.');
INSERT INTO `lang_constants` VALUES (861, 'Dribbling');
INSERT INTO `lang_constants` VALUES (862, 'Drivers License or State ID');
INSERT INTO `lang_constants` VALUES (863, 'Drug');
INSERT INTO `lang_constants` VALUES (864, 'Drug Forms');
INSERT INTO `lang_constants` VALUES (865, 'Drug ID missing!');
INSERT INTO `lang_constants` VALUES (866, 'Drug Intervals');
INSERT INTO `lang_constants` VALUES (867, 'Drug Inventory');
INSERT INTO `lang_constants` VALUES (868, 'Drug Name');
INSERT INTO `lang_constants` VALUES (869, 'Drug Routes');
INSERT INTO `lang_constants` VALUES (870, 'Drug Units');
INSERT INTO `lang_constants` VALUES (871, 'Drugs');
INSERT INTO `lang_constants` VALUES (872, 'Dry Mouth');
INSERT INTO `lang_constants` VALUES (873, 'DT 1');
INSERT INTO `lang_constants` VALUES (874, 'DT 2');
INSERT INTO `lang_constants` VALUES (875, 'DT 3');
INSERT INTO `lang_constants` VALUES (876, 'DT 4');
INSERT INTO `lang_constants` VALUES (877, 'DT 5');
INSERT INTO `lang_constants` VALUES (878, 'DTaP 1');
INSERT INTO `lang_constants` VALUES (879, 'DTaP 2');
INSERT INTO `lang_constants` VALUES (880, 'DTaP 3');
INSERT INTO `lang_constants` VALUES (881, 'DTaP 4');
INSERT INTO `lang_constants` VALUES (882, 'DTaP 5');
INSERT INTO `lang_constants` VALUES (883, 'Due Date');
INSERT INTO `lang_constants` VALUES (884, 'Due date mm/dd/yyyy or yyyy-mm-dd');
INSERT INTO `lang_constants` VALUES (885, 'Due Date:');
INSERT INTO `lang_constants` VALUES (886, 'Due Ins');
INSERT INTO `lang_constants` VALUES (887, 'Due Pt');
INSERT INTO `lang_constants` VALUES (888, 'Dumping OpenEMR database');
INSERT INTO `lang_constants` VALUES (889, 'Dumping OpenEMR web directory tree');
INSERT INTO `lang_constants` VALUES (890, 'Dumping phpGACL database');
INSERT INTO `lang_constants` VALUES (891, 'Dumping phpGACL web directory tree');
INSERT INTO `lang_constants` VALUES (892, 'Dumping SQL-Ledger database');
INSERT INTO `lang_constants` VALUES (893, 'Dumping SQL-Ledger web directory tree');
INSERT INTO `lang_constants` VALUES (894, 'DUPLICATION WARNING');
INSERT INTO `lang_constants` VALUES (895, 'duration');
INSERT INTO `lang_constants` VALUES (896, 'Duration');
INSERT INTO `lang_constants` VALUES (897, 'Dutch');
INSERT INTO `lang_constants` VALUES (898, 'Dysphagia');
INSERT INTO `lang_constants` VALUES (899, 'Dyspnea:');
INSERT INTO `lang_constants` VALUES (900, 'Dysuria');
INSERT INTO `lang_constants` VALUES (901, 'Early Recurrence (<2 Mo)');
INSERT INTO `lang_constants` VALUES (902, 'Ears');
INSERT INTO `lang_constants` VALUES (903, 'ECG');
INSERT INTO `lang_constants` VALUES (904, 'Edema');
INSERT INTO `lang_constants` VALUES (905, 'Edit');
INSERT INTO `lang_constants` VALUES (906, 'Edit Allergies');
INSERT INTO `lang_constants` VALUES (907, 'Edit Categories');
INSERT INTO `lang_constants` VALUES (908, 'Edit definitions');
INSERT INTO `lang_constants` VALUES (909, 'Edit Diagnoses for');
INSERT INTO `lang_constants` VALUES (910, 'Edit Facilities');
INSERT INTO `lang_constants` VALUES (911, 'Edit Facility Information');
INSERT INTO `lang_constants` VALUES (912, 'Edit form');
INSERT INTO `lang_constants` VALUES (913, 'Edit layout');
INSERT INTO `lang_constants` VALUES (914, 'Edit list');
INSERT INTO `lang_constants` VALUES (915, 'Edit Structure');
INSERT INTO `lang_constants` VALUES (916, 'Education');
INSERT INTO `lang_constants` VALUES (917, 'Education Date');
INSERT INTO `lang_constants` VALUES (918, 'ee the  * GNU General Public License for more details.  *   * You should have received a copy of the GNU General Public License  * along with this program; if not, write to the Free ');
INSERT INTO `lang_constants` VALUES (919, 'Effective Date');
INSERT INTO `lang_constants` VALUES (920, 'Effectiveness');
INSERT INTO `lang_constants` VALUES (921, 'Ejaculations');
INSERT INTO `lang_constants` VALUES (922, 'Elbow');
INSERT INTO `lang_constants` VALUES (923, 'Elbow Problems');
INSERT INTO `lang_constants` VALUES (924, 'Electronic Remits');
INSERT INTO `lang_constants` VALUES (925, 'Email');
INSERT INTO `lang_constants` VALUES (926, 'Email from Batchcom');
INSERT INTO `lang_constants` VALUES (927, 'Email Notification');
INSERT INTO `lang_constants` VALUES (928, 'Email send before');
INSERT INTO `lang_constants` VALUES (929, 'Email Sender');
INSERT INTO `lang_constants` VALUES (930, 'Email Subject');
INSERT INTO `lang_constants` VALUES (931, 'Email Text, Usable Tag: ***NAME*** , i.e. Dear ***NAME***');
INSERT INTO `lang_constants` VALUES (932, 'Emergency Contact');
INSERT INTO `lang_constants` VALUES (933, 'Emergency Contact Person');
INSERT INTO `lang_constants` VALUES (934, 'Emergency Contact Phone Number');
INSERT INTO `lang_constants` VALUES (935, 'Emergency Contraception');
INSERT INTO `lang_constants` VALUES (936, 'Emergency Phone');
INSERT INTO `lang_constants` VALUES (937, 'Emphysema');
INSERT INTO `lang_constants` VALUES (938, 'Employee');
INSERT INTO `lang_constants` VALUES (939, 'Employer');
INSERT INTO `lang_constants` VALUES (940, 'Employer Address');
INSERT INTO `lang_constants` VALUES (941, 'Employer Data');
INSERT INTO `lang_constants` VALUES (942, 'Employer Name');
INSERT INTO `lang_constants` VALUES (943, 'Empty');
INSERT INTO `lang_constants` VALUES (944, 'Empty value in \"Email Hours\"');
INSERT INTO `lang_constants` VALUES (945, 'Empty value in \"Email Sender\"');
INSERT INTO `lang_constants` VALUES (946, 'Empty value in \"Email Subject\"');
INSERT INTO `lang_constants` VALUES (947, 'Empty value in \"Email Text\"');
INSERT INTO `lang_constants` VALUES (948, 'Empty value in \"Name of Provider\"');
INSERT INTO `lang_constants` VALUES (949, 'Empty value in \"Password\"');
INSERT INTO `lang_constants` VALUES (950, 'Empty value in \"SMS Hours\"');
INSERT INTO `lang_constants` VALUES (951, 'Empty value in \"SMS Text\"');
INSERT INTO `lang_constants` VALUES (952, 'Empty value in \"Username\"');
INSERT INTO `lang_constants` VALUES (953, 'enabled');
INSERT INTO `lang_constants` VALUES (954, 'Enc');
INSERT INTO `lang_constants` VALUES (955, 'encounter');
INSERT INTO `lang_constants` VALUES (956, 'Encounter');
INSERT INTO `lang_constants` VALUES (957, 'Encounter ');
INSERT INTO `lang_constants` VALUES (958, 'Encounter Forms');
INSERT INTO `lang_constants` VALUES (959, 'Encounter number');
INSERT INTO `lang_constants` VALUES (960, 'Encounter was coded');
INSERT INTO `lang_constants` VALUES (961, 'Encounter:');
INSERT INTO `lang_constants` VALUES (962, 'Encounters');
INSERT INTO `lang_constants` VALUES (963, 'Encounters & Forms');
INSERT INTO `lang_constants` VALUES (964, 'Encounters &amp; Forms');
INSERT INTO `lang_constants` VALUES (965, 'Encounters not authorized');
INSERT INTO `lang_constants` VALUES (966, 'Encounters Report');
INSERT INTO `lang_constants` VALUES (967, 'Encounters Section');
INSERT INTO `lang_constants` VALUES (968, 'End');
INSERT INTO `lang_constants` VALUES (969, 'End (yyyy-mm-dd): ');
INSERT INTO `lang_constants` VALUES (970, 'End date');
INSERT INTO `lang_constants` VALUES (971, 'End Date');
INSERT INTO `lang_constants` VALUES (972, 'End Date:');
INSERT INTO `lang_constants` VALUES (973, 'End Time');
INSERT INTO `lang_constants` VALUES (974, 'Ending date of service yyyy-mm-dd');
INSERT INTO `lang_constants` VALUES (975, 'Ending DOS mm/dd/yyyy if you wish to enter a range');
INSERT INTO `lang_constants` VALUES (976, 'Endo Abnormal Blood');
INSERT INTO `lang_constants` VALUES (977, 'Endocrine');
INSERT INTO `lang_constants` VALUES (978, 'Endoscopy');
INSERT INTO `lang_constants` VALUES (979, 'English');
INSERT INTO `lang_constants` VALUES (980, 'English ');
INSERT INTO `lang_constants` VALUES (981, 'English (Indian)');
INSERT INTO `lang_constants` VALUES (982, 'English (Standard)');
INSERT INTO `lang_constants` VALUES (983, 'Ensure OpenEMR has write privileges to directory');
INSERT INTO `lang_constants` VALUES (984, 'ENT Discharge');
INSERT INTO `lang_constants` VALUES (985, 'ENT Pain');
INSERT INTO `lang_constants` VALUES (986, 'Enter a diagnosis code to exclude all invoices not containing it');
INSERT INTO `lang_constants` VALUES (987, 'Enter body of letter here');
INSERT INTO `lang_constants` VALUES (988, 'Enter new State');
INSERT INTO `lang_constants` VALUES (989, 'Enter your search criteria above');
INSERT INTO `lang_constants` VALUES (990, 'Environmental');
INSERT INTO `lang_constants` VALUES (991, 'EOB Data Entry');
INSERT INTO `lang_constants` VALUES (992, 'EOB Posting - Electronic Remittances');
INSERT INTO `lang_constants` VALUES (993, 'EOB Posting - Instructions');
INSERT INTO `lang_constants` VALUES (994, 'EOB Posting - Invoice');
INSERT INTO `lang_constants` VALUES (995, 'EOB Posting - Patient Note');
INSERT INTO `lang_constants` VALUES (996, 'EOB Posting - Search');
INSERT INTO `lang_constants` VALUES (997, 'Epilepsy');
INSERT INTO `lang_constants` VALUES (998, 'Erase');
INSERT INTO `lang_constants` VALUES (999, 'Erections');
INSERT INTO `lang_constants` VALUES (1000, 'Error');
INSERT INTO `lang_constants` VALUES (1001, 'Error in \"Gender\" selection');
INSERT INTO `lang_constants` VALUES (1002, 'Error in \"HIPAA\" selection');
INSERT INTO `lang_constants` VALUES (1003, 'Error in \"Process\" selection');
INSERT INTO `lang_constants` VALUES (1004, 'Error in \"SMS Gateway\" selection');
INSERT INTO `lang_constants` VALUES (1005, 'Error in \"Sort By\" selection');
INSERT INTO `lang_constants` VALUES (1006, 'Error in gzip compression of file: ');
INSERT INTO `lang_constants` VALUES (1007, 'Error in YES or NO option');
INSERT INTO `lang_constants` VALUES (1008, 'Error opening uploaded file for reading');
INSERT INTO `lang_constants` VALUES (1009, 'error while registering form!');
INSERT INTO `lang_constants` VALUES (1010, 'Error while saving to the file');
INSERT INTO `lang_constants` VALUES (1011, 'Error while writing to file');
INSERT INTO `lang_constants` VALUES (1012, 'ERROR, unable to collect data from server');
INSERT INTO `lang_constants` VALUES (1013, 'Error. You need to install the Archive/Tar.php php module.');
INSERT INTO `lang_constants` VALUES (1014, 'ERROR: could not open table.sql, broken form?');
INSERT INTO `lang_constants` VALUES (1015, 'ERROR: Field');
INSERT INTO `lang_constants` VALUES (1016, 'Error: passwords don\'t match. Please check your typing.');
INSERT INTO `lang_constants` VALUES (1017, 'Error: Unable to create downloadable archive');
INSERT INTO `lang_constants` VALUES (1018, 'Errors');
INSERT INTO `lang_constants` VALUES (1019, 'Erythema:');
INSERT INTO `lang_constants` VALUES (1020, 'Established Patient');
INSERT INTO `lang_constants` VALUES (1021, 'Ethnicity or Race');
INSERT INTO `lang_constants` VALUES (1022, 'Ethnicity-Race List (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (1023, 'ETIN');
INSERT INTO `lang_constants` VALUES (1024, 'Event');
INSERT INTO `lang_constants` VALUES (1025, 'Event Begins');
INSERT INTO `lang_constants` VALUES (1026, 'Event Category');
INSERT INTO `lang_constants` VALUES (1027, 'Event Date');
INSERT INTO `lang_constants` VALUES (1028, 'Event Description');
INSERT INTO `lang_constants` VALUES (1029, 'Event Details');
INSERT INTO `lang_constants` VALUES (1030, 'Event does not repeat');
INSERT INTO `lang_constants` VALUES (1031, 'Event Duration');
INSERT INTO `lang_constants` VALUES (1032, 'Event duration in minutes');
INSERT INTO `lang_constants` VALUES (1033, 'Event Fee');
INSERT INTO `lang_constants` VALUES (1034, 'Event Location');
INSERT INTO `lang_constants` VALUES (1035, 'Event repeats every');
INSERT INTO `lang_constants` VALUES (1036, 'Event repeats on');
INSERT INTO `lang_constants` VALUES (1037, 'Event start time');
INSERT INTO `lang_constants` VALUES (1038, 'Event title');
INSERT INTO `lang_constants` VALUES (1039, 'Event Title');
INSERT INTO `lang_constants` VALUES (1040, 'Event Website');
INSERT INTO `lang_constants` VALUES (1041, 'Events');
INSERT INTO `lang_constants` VALUES (1042, 'Events for');
INSERT INTO `lang_constants` VALUES (1043, 'Events open in new window');
INSERT INTO `lang_constants` VALUES (1044, 'every');
INSERT INTO `lang_constants` VALUES (1045, 'Every');
INSERT INTO `lang_constants` VALUES (1046, 'every 3 hours');
INSERT INTO `lang_constants` VALUES (1047, 'every 4 hours');
INSERT INTO `lang_constants` VALUES (1048, 'every 5 hours');
INSERT INTO `lang_constants` VALUES (1049, 'every 6 hours');
INSERT INTO `lang_constants` VALUES (1050, 'every 8 hours');
INSERT INTO `lang_constants` VALUES (1051, 'Every Fourth');
INSERT INTO `lang_constants` VALUES (1052, 'Every Other');
INSERT INTO `lang_constants` VALUES (1053, 'Every Third');
INSERT INTO `lang_constants` VALUES (1054, 'Every, every other, every 3rd, etc.');
INSERT INTO `lang_constants` VALUES (1055, 'Exam and test results');
INSERT INTO `lang_constants` VALUES (1056, 'Exam results');
INSERT INTO `lang_constants` VALUES (1057, 'Examination Date');
INSERT INTO `lang_constants` VALUES (1058, 'Exams/Tests');
INSERT INTO `lang_constants` VALUES (1059, 'Excessive Tearing');
INSERT INTO `lang_constants` VALUES (1060, 'Exclusive Provider Organization (EPO)');
INSERT INTO `lang_constants` VALUES (1061, 'Exercise patterns');
INSERT INTO `lang_constants` VALUES (1062, 'Exercise Patterns');
INSERT INTO `lang_constants` VALUES (1063, 'Exit from Administration');
INSERT INTO `lang_constants` VALUES (1064, 'Exp');
INSERT INTO `lang_constants` VALUES (1065, 'Expanded View');
INSERT INTO `lang_constants` VALUES (1066, 'Expected form_encounter.pid to be ');
INSERT INTO `lang_constants` VALUES (1067, 'Expiration');
INSERT INTO `lang_constants` VALUES (1068, 'Expiration Date');
INSERT INTO `lang_constants` VALUES (1069, 'Expires');
INSERT INTO `lang_constants` VALUES (1070, 'Export');
INSERT INTO `lang_constants` VALUES (1071, 'Export as CSV');
INSERT INTO `lang_constants` VALUES (1072, 'Export Configuration');
INSERT INTO `lang_constants` VALUES (1073, 'Export Patient Demographics');
INSERT INTO `lang_constants` VALUES (1074, 'Export Selected as CSV');
INSERT INTO `lang_constants` VALUES (1075, 'Export Selected to Collections');
INSERT INTO `lang_constants` VALUES (1076, 'Export to CSV');
INSERT INTO `lang_constants` VALUES (1077, 'Export to external billing system');
INSERT INTO `lang_constants` VALUES (1078, 'Exposure to Foreign Countries');
INSERT INTO `lang_constants` VALUES (1079, 'Exposure To Foreign Countries');
INSERT INTO `lang_constants` VALUES (1080, 'External');
INSERT INTO `lang_constants` VALUES (1081, 'External ID');
INSERT INTO `lang_constants` VALUES (1082, 'External identifier');
INSERT INTO `lang_constants` VALUES (1083, 'External Only');
INSERT INTO `lang_constants` VALUES (1084, 'External Referral');
INSERT INTO `lang_constants` VALUES (1085, 'External Referral Followups');
INSERT INTO `lang_constants` VALUES (1086, 'External referral?');
INSERT INTO `lang_constants` VALUES (1087, 'External Referrals');
INSERT INTO `lang_constants` VALUES (1088, 'Exudate:');
INSERT INTO `lang_constants` VALUES (1089, 'Eye Irritation');
INSERT INTO `lang_constants` VALUES (1090, 'Eye Pain');
INSERT INTO `lang_constants` VALUES (1091, 'Eye Redness');
INSERT INTO `lang_constants` VALUES (1092, 'Eyes');
INSERT INTO `lang_constants` VALUES (1093, 'F');
INSERT INTO `lang_constants` VALUES (1094, 'F/H Blood Problems');
INSERT INTO `lang_constants` VALUES (1095, 'F/H Female Hirsutism/Striae');
INSERT INTO `lang_constants` VALUES (1096, 'Facilities');
INSERT INTO `lang_constants` VALUES (1097, 'Facility');
INSERT INTO `lang_constants` VALUES (1098, 'facility');
INSERT INTO `lang_constants` VALUES (1099, 'Facility Administration');
INSERT INTO `lang_constants` VALUES (1100, 'Facility Code');
INSERT INTO `lang_constants` VALUES (1101, 'Facility NPI');
INSERT INTO `lang_constants` VALUES (1102, 'Facility:');
INSERT INTO `lang_constants` VALUES (1103, 'Failed');
INSERT INTO `lang_constants` VALUES (1104, 'failed');
INSERT INTO `lang_constants` VALUES (1105, 'failure');
INSERT INTO `lang_constants` VALUES (1106, 'Family History');
INSERT INTO `lang_constants` VALUES (1107, 'Family History of Glaucoma');
INSERT INTO `lang_constants` VALUES (1108, 'Family History:');
INSERT INTO `lang_constants` VALUES (1109, 'Family Size');
INSERT INTO `lang_constants` VALUES (1110, 'Fancy');
INSERT INTO `lang_constants` VALUES (1111, 'Father');
INSERT INTO `lang_constants` VALUES (1112, 'Fatigue');
INSERT INTO `lang_constants` VALUES (1113, 'Fatigued');
INSERT INTO `lang_constants` VALUES (1114, 'Fax');
INSERT INTO `lang_constants` VALUES (1115, 'Fax number');
INSERT INTO `lang_constants` VALUES (1116, 'Fax/Scan');
INSERT INTO `lang_constants` VALUES (1117, 'Faxes In');
INSERT INTO `lang_constants` VALUES (1118, 'Faxes Out');
INSERT INTO `lang_constants` VALUES (1119, 'February');
INSERT INTO `lang_constants` VALUES (1120, 'FECA');
INSERT INTO `lang_constants` VALUES (1121, 'Federal Drug ID');
INSERT INTO `lang_constants` VALUES (1122, 'Federal EIN');
INSERT INTO `lang_constants` VALUES (1123, 'Federal Tax ID');
INSERT INTO `lang_constants` VALUES (1124, 'Fee');
INSERT INTO `lang_constants` VALUES (1125, 'fee');
INSERT INTO `lang_constants` VALUES (1126, 'Fee is not allowed');
INSERT INTO `lang_constants` VALUES (1127, 'Fee Sheet');
INSERT INTO `lang_constants` VALUES (1128, 'Fee Sheet Options');
INSERT INTO `lang_constants` VALUES (1129, 'Fees');
INSERT INTO `lang_constants` VALUES (1130, 'Female');
INSERT INTO `lang_constants` VALUES (1131, 'Female AP');
INSERT INTO `lang_constants` VALUES (1132, 'Female Condoms');
INSERT INTO `lang_constants` VALUES (1133, 'Female G');
INSERT INTO `lang_constants` VALUES (1134, 'Female LC');
INSERT INTO `lang_constants` VALUES (1135, 'Female P');
INSERT INTO `lang_constants` VALUES (1136, 'Female Symptoms');
INSERT INTO `lang_constants` VALUES (1137, 'Female VSC');
INSERT INTO `lang_constants` VALUES (1138, 'Fever');
INSERT INTO `lang_constants` VALUES (1139, 'Fever:');
INSERT INTO `lang_constants` VALUES (1140, 'FH Blood Problems');
INSERT INTO `lang_constants` VALUES (1141, 'Fibroids');
INSERT INTO `lang_constants` VALUES (1142, 'File');
INSERT INTO `lang_constants` VALUES (1143, 'File Room');
INSERT INTO `lang_constants` VALUES (1144, 'File to upload');
INSERT INTO `lang_constants` VALUES (1145, 'File with same name already exists at location:');
INSERT INTO `lang_constants` VALUES (1146, 'Filename');
INSERT INTO `lang_constants` VALUES (1147, 'Fill here only if sending email notification to patients');
INSERT INTO `lang_constants` VALUES (1148, 'Filter');
INSERT INTO `lang_constants` VALUES (1149, 'Filter for Constants');
INSERT INTO `lang_constants` VALUES (1150, 'Filters');
INSERT INTO `lang_constants` VALUES (1151, 'Final Diagnosis');
INSERT INTO `lang_constants` VALUES (1152, 'Final diagnosis by specialist');
INSERT INTO `lang_constants` VALUES (1153, 'Financial');
INSERT INTO `lang_constants` VALUES (1154, 'Financial Reporting - anything');
INSERT INTO `lang_constants` VALUES (1155, 'Financial Reporting - my encounters');
INSERT INTO `lang_constants` VALUES (1156, 'Financial Review Date');
INSERT INTO `lang_constants` VALUES (1157, 'Find');
INSERT INTO `lang_constants` VALUES (1158, 'Find Available');
INSERT INTO `lang_constants` VALUES (1159, 'Find Available Appointments');
INSERT INTO `lang_constants` VALUES (1160, 'Find Patient');
INSERT INTO `lang_constants` VALUES (1161, 'Findings');
INSERT INTO `lang_constants` VALUES (1162, 'Findings by specialist');
INSERT INTO `lang_constants` VALUES (1163, 'Fine');
INSERT INTO `lang_constants` VALUES (1164, 'First');
INSERT INTO `lang_constants` VALUES (1165, 'First day of the week');
INSERT INTO `lang_constants` VALUES (1166, 'First Name');
INSERT INTO `lang_constants` VALUES (1167, 'First name');
INSERT INTO `lang_constants` VALUES (1168, 'First Name:');
INSERT INTO `lang_constants` VALUES (1169, 'Fitness');
INSERT INTO `lang_constants` VALUES (1170, 'Fitness to Play');
INSERT INTO `lang_constants` VALUES (1171, 'Fix encounter dates - any encounters');
INSERT INTO `lang_constants` VALUES (1172, 'Fix this');
INSERT INTO `lang_constants` VALUES (1173, 'Flatulence');
INSERT INTO `lang_constants` VALUES (1174, 'Flow');
INSERT INTO `lang_constants` VALUES (1175, 'Flu Vaccination');
INSERT INTO `lang_constants` VALUES (1176, 'Fluid and electrolyte problem');
INSERT INTO `lang_constants` VALUES (1177, 'FMS');
INSERT INTO `lang_constants` VALUES (1178, 'Follow manually');
INSERT INTO `lang_constants` VALUES (1179, 'Food Intolerance');
INSERT INTO `lang_constants` VALUES (1180, 'Foot');
INSERT INTO `lang_constants` VALUES (1181, 'Foot Problems');
INSERT INTO `lang_constants` VALUES (1182, 'Foot:');
INSERT INTO `lang_constants` VALUES (1183, 'Football Injuries');
INSERT INTO `lang_constants` VALUES (1184, 'Football Injury Report');
INSERT INTO `lang_constants` VALUES (1185, 'Footwear Type');
INSERT INTO `lang_constants` VALUES (1186, 'for');
INSERT INTO `lang_constants` VALUES (1187, 'For Encounter Claims');
INSERT INTO `lang_constants` VALUES (1188, 'For Referred Organization/Practitioner');
INSERT INTO `lang_constants` VALUES (1189, 'for:');
INSERT INTO `lang_constants` VALUES (1190, 'Forearm');
INSERT INTO `lang_constants` VALUES (1191, 'Form');
INSERT INTO `lang_constants` VALUES (1192, 'form');
INSERT INTO `lang_constants` VALUES (1193, 'format');
INSERT INTO `lang_constants` VALUES (1194, 'Format');
INSERT INTO `lang_constants` VALUES (1195, 'Format incorrect for NDC');
INSERT INTO `lang_constants` VALUES (1196, 'Forms');
INSERT INTO `lang_constants` VALUES (1197, 'Forms Administration');
INSERT INTO `lang_constants` VALUES (1198, 'Forward Pages via Fax');
INSERT INTO `lang_constants` VALUES (1199, 'Fourth');
INSERT INTO `lang_constants` VALUES (1200, 'Fracture');
INSERT INTO `lang_constants` VALUES (1201, 'Fracture at the Navicula');
INSERT INTO `lang_constants` VALUES (1202, 'Fracture lateral malleolus');
INSERT INTO `lang_constants` VALUES (1203, 'Fracture medial malleolus');
INSERT INTO `lang_constants` VALUES (1204, 'Fracture, Base of fifth (5th) Metatarsal');
INSERT INTO `lang_constants` VALUES (1205, 'French');
INSERT INTO `lang_constants` VALUES (1206, 'Frequency');
INSERT INTO `lang_constants` VALUES (1207, 'Frequent Colds');
INSERT INTO `lang_constants` VALUES (1208, 'Frequent Illness');
INSERT INTO `lang_constants` VALUES (1209, 'Fri');
INSERT INTO `lang_constants` VALUES (1210, 'Friday');
INSERT INTO `lang_constants` VALUES (1211, 'From');
INSERT INTO `lang_constants` VALUES (1212, 'FROM');
INSERT INTO `lang_constants` VALUES (1213, 'From:');
INSERT INTO `lang_constants` VALUES (1214, 'From: ');
INSERT INTO `lang_constants` VALUES (1215, 'FROM_CITY');
INSERT INTO `lang_constants` VALUES (1216, 'FROM_FNAME');
INSERT INTO `lang_constants` VALUES (1217, 'FROM_LNAME');
INSERT INTO `lang_constants` VALUES (1218, 'FROM_MNAME');
INSERT INTO `lang_constants` VALUES (1219, 'FROM_PHONECELL');
INSERT INTO `lang_constants` VALUES (1220, 'FROM_POSTAL');
INSERT INTO `lang_constants` VALUES (1221, 'FROM_STATE');
INSERT INTO `lang_constants` VALUES (1222, 'FROM_STREET');
INSERT INTO `lang_constants` VALUES (1223, 'FROM_TITLE');
INSERT INTO `lang_constants` VALUES (1224, 'FROM_VALEDICTORY');
INSERT INTO `lang_constants` VALUES (1225, 'Front Office');
INSERT INTO `lang_constants` VALUES (1226, 'Front Office Receipts');
INSERT INTO `lang_constants` VALUES (1227, 'Front Office Receipts Report');
INSERT INTO `lang_constants` VALUES (1228, 'Front Rec');
INSERT INTO `lang_constants` VALUES (1229, 'Frontal Right:');
INSERT INTO `lang_constants` VALUES (1230, 'Full Name');
INSERT INTO `lang_constants` VALUES (1231, 'Full Play');
INSERT INTO `lang_constants` VALUES (1232, 'Full Training');
INSERT INTO `lang_constants` VALUES (1233, 'G');
INSERT INTO `lang_constants` VALUES (1234, 'Gall Bladder Condition');
INSERT INTO `lang_constants` VALUES (1235, 'Gall Stones');
INSERT INTO `lang_constants` VALUES (1236, 'Game Period');
INSERT INTO `lang_constants` VALUES (1237, 'Games');
INSERT INTO `lang_constants` VALUES (1238, 'games/events');
INSERT INTO `lang_constants` VALUES (1239, 'Games/Events Missed');
INSERT INTO `lang_constants` VALUES (1240, 'Gastritis');
INSERT INTO `lang_constants` VALUES (1241, 'Gastro Pain');
INSERT INTO `lang_constants` VALUES (1242, 'Gastrointestinal');
INSERT INTO `lang_constants` VALUES (1243, 'GCAC Statistics Report');
INSERT INTO `lang_constants` VALUES (1244, 'GCAC visit form is missing');
INSERT INTO `lang_constants` VALUES (1245, 'Gender');
INSERT INTO `lang_constants` VALUES (1246, 'Gender ');
INSERT INTO `lang_constants` VALUES (1247, 'General');
INSERT INTO `lang_constants` VALUES (1248, 'General Service Category');
INSERT INTO `lang_constants` VALUES (1249, 'Generate and download HCFA 1500 paper claims');
INSERT INTO `lang_constants` VALUES (1250, 'Generate and download X12 batch');
INSERT INTO `lang_constants` VALUES (1251, 'Generate and download X12 encounter claim batch');
INSERT INTO `lang_constants` VALUES (1252, 'Generate CMS 1500');
INSERT INTO `lang_constants` VALUES (1253, 'Generate HCFA');
INSERT INTO `lang_constants` VALUES (1254, 'Generate Letter');
INSERT INTO `lang_constants` VALUES (1255, 'Generate Letter regarding ');
INSERT INTO `lang_constants` VALUES (1256, 'Generate Report');
INSERT INTO `lang_constants` VALUES (1257, 'Generate X12');
INSERT INTO `lang_constants` VALUES (1258, 'Generate X12 Encounter');
INSERT INTO `lang_constants` VALUES (1259, 'Generated on');
INSERT INTO `lang_constants` VALUES (1260, 'Generates');
INSERT INTO `lang_constants` VALUES (1261, 'Genitourinary');
INSERT INTO `lang_constants` VALUES (1262, 'German');
INSERT INTO `lang_constants` VALUES (1263, 'Glaucoma');
INSERT INTO `lang_constants` VALUES (1264, 'Glaucoma Family History');
INSERT INTO `lang_constants` VALUES (1265, 'Global');
INSERT INTO `lang_constants` VALUES (1266, 'Global ID');
INSERT INTO `lang_constants` VALUES (1267, 'go');
INSERT INTO `lang_constants` VALUES (1268, 'Go');
INSERT INTO `lang_constants` VALUES (1269, 'Go to');
INSERT INTO `lang_constants` VALUES (1270, 'Go to week of');
INSERT INTO `lang_constants` VALUES (1271, 'Grade:');
INSERT INTO `lang_constants` VALUES (1272, 'grams');
INSERT INTO `lang_constants` VALUES (1273, 'Grand Total');
INSERT INTO `lang_constants` VALUES (1274, 'Grand Totals');
INSERT INTO `lang_constants` VALUES (1275, 'Greek');
INSERT INTO `lang_constants` VALUES (1276, 'Group');
INSERT INTO `lang_constants` VALUES (1277, 'Group Name');
INSERT INTO `lang_constants` VALUES (1278, 'Group names cannot be blank');
INSERT INTO `lang_constants` VALUES (1279, 'Group names cannot start with numbers or spaces.');
INSERT INTO `lang_constants` VALUES (1280, 'Group names cannot start with numbers.');
INSERT INTO `lang_constants` VALUES (1281, 'Group Number');
INSERT INTO `lang_constants` VALUES (1282, 'Group:');
INSERT INTO `lang_constants` VALUES (1283, 'Groupname');
INSERT INTO `lang_constants` VALUES (1284, 'Groups and Access Controls');
INSERT INTO `lang_constants` VALUES (1285, 'Growth Chart');
INSERT INTO `lang_constants` VALUES (1286, 'Growth-Chart');
INSERT INTO `lang_constants` VALUES (1287, 'gtts(drops)');
INSERT INTO `lang_constants` VALUES (1288, 'Gynecological Exam');
INSERT INTO `lang_constants` VALUES (1289, 'h');
INSERT INTO `lang_constants` VALUES (1290, 'h.s.');
INSERT INTO `lang_constants` VALUES (1291, 'H/O Hepatitis');
INSERT INTO `lang_constants` VALUES (1292, 'had been successfully deleted. Any sub-categories if present were moved below');
INSERT INTO `lang_constants` VALUES (1293, 'Haematoma / bruising');
INSERT INTO `lang_constants` VALUES (1294, 'HAI Status');
INSERT INTO `lang_constants` VALUES (1295, 'Hand + fingers');
INSERT INTO `lang_constants` VALUES (1296, 'Hand Problems');
INSERT INTO `lang_constants` VALUES (1297, 'Hardship w/o');
INSERT INTO `lang_constants` VALUES (1298, 'has been linked to visit');
INSERT INTO `lang_constants` VALUES (1299, 'Hazardous activities');
INSERT INTO `lang_constants` VALUES (1300, 'Hazardous Activities');
INSERT INTO `lang_constants` VALUES (1301, 'HCFA left margin in points');
INSERT INTO `lang_constants` VALUES (1302, 'HCFA Margins');
INSERT INTO `lang_constants` VALUES (1303, 'HCFA top margin in points');
INSERT INTO `lang_constants` VALUES (1304, 'he PostCalendar ');
INSERT INTO `lang_constants` VALUES (1305, 'Head');
INSERT INTO `lang_constants` VALUES (1306, 'Head Circ');
INSERT INTO `lang_constants` VALUES (1307, 'Head Circumference');
INSERT INTO `lang_constants` VALUES (1308, 'Headache');
INSERT INTO `lang_constants` VALUES (1309, 'Headaches');
INSERT INTO `lang_constants` VALUES (1310, 'Health centre/clinic');
INSERT INTO `lang_constants` VALUES (1311, 'Health Maintenance Organization');
INSERT INTO `lang_constants` VALUES (1312, 'Health Maintenance Organization (HMO) Medicare Risk');
INSERT INTO `lang_constants` VALUES (1313, 'Hearing Loss');
INSERT INTO `lang_constants` VALUES (1314, 'Heart Attack');
INSERT INTO `lang_constants` VALUES (1315, 'Heart Disease');
INSERT INTO `lang_constants` VALUES (1316, 'Heart Failure');
INSERT INTO `lang_constants` VALUES (1317, 'Heart Problem');
INSERT INTO `lang_constants` VALUES (1318, 'Heart Problems');
INSERT INTO `lang_constants` VALUES (1319, 'Heart Surgery');
INSERT INTO `lang_constants` VALUES (1320, 'Heart Transplant');
INSERT INTO `lang_constants` VALUES (1321, 'HEART:');
INSERT INTO `lang_constants` VALUES (1322, 'Heartburn');
INSERT INTO `lang_constants` VALUES (1323, 'Heat or Cold');
INSERT INTO `lang_constants` VALUES (1324, 'Heat Or Cold');
INSERT INTO `lang_constants` VALUES (1325, 'Hebrew');
INSERT INTO `lang_constants` VALUES (1326, 'HEENT');
INSERT INTO `lang_constants` VALUES (1327, 'Height');
INSERT INTO `lang_constants` VALUES (1328, 'Help');
INSERT INTO `lang_constants` VALUES (1329, 'help');
INSERT INTO `lang_constants` VALUES (1330, 'Hematemesis');
INSERT INTO `lang_constants` VALUES (1331, 'Hematochezia');
INSERT INTO `lang_constants` VALUES (1332, 'Hematologic');
INSERT INTO `lang_constants` VALUES (1333, 'Hematuria');
INSERT INTO `lang_constants` VALUES (1334, 'Hemoglobin');
INSERT INTO `lang_constants` VALUES (1335, 'Hemoptysis');
INSERT INTO `lang_constants` VALUES (1336, 'Hepatitis');
INSERT INTO `lang_constants` VALUES (1337, 'Hepatitis A 1');
INSERT INTO `lang_constants` VALUES (1338, 'Hepatitis A 2');
INSERT INTO `lang_constants` VALUES (1339, 'Hepatitis B 1');
INSERT INTO `lang_constants` VALUES (1340, 'Hepatitis B 2');
INSERT INTO `lang_constants` VALUES (1341, 'Hepatitis B 3');
INSERT INTO `lang_constants` VALUES (1342, 'here');
INSERT INTO `lang_constants` VALUES (1343, 'Hernia Repair');
INSERT INTO `lang_constants` VALUES (1344, 'Herniated Disc');
INSERT INTO `lang_constants` VALUES (1345, 'Herpes');
INSERT INTO `lang_constants` VALUES (1346, 'Hesitancy');
INSERT INTO `lang_constants` VALUES (1347, 'heyyo. you have been here for ');
INSERT INTO `lang_constants` VALUES (1348, 'Hib 1');
INSERT INTO `lang_constants` VALUES (1349, 'Hib 2');
INSERT INTO `lang_constants` VALUES (1350, 'Hib 3');
INSERT INTO `lang_constants` VALUES (1351, 'Hib 4');
INSERT INTO `lang_constants` VALUES (1352, 'Hidden');
INSERT INTO `lang_constants` VALUES (1353, 'Hidden Events Administration');
INSERT INTO `lang_constants` VALUES (1354, 'Hide');
INSERT INTO `lang_constants` VALUES (1355, 'Hide Details');
INSERT INTO `lang_constants` VALUES (1356, 'Hide/Show Columns');
INSERT INTO `lang_constants` VALUES (1357, 'High');
INSERT INTO `lang_constants` VALUES (1358, 'High Blood Pressure');
INSERT INTO `lang_constants` VALUES (1359, 'Hip + groin');
INSERT INTO `lang_constants` VALUES (1360, 'Hip and groin');
INSERT INTO `lang_constants` VALUES (1361, 'Hip Problems');
INSERT INTO `lang_constants` VALUES (1362, 'Hip Replacement');
INSERT INTO `lang_constants` VALUES (1363, 'HIPAA Notice Received');
INSERT INTO `lang_constants` VALUES (1364, 'Hirsutism/Striae');
INSERT INTO `lang_constants` VALUES (1365, 'Hispanic');
INSERT INTO `lang_constants` VALUES (1366, 'History');
INSERT INTO `lang_constants` VALUES (1367, 'History Data');
INSERT INTO `lang_constants` VALUES (1368, 'History Murmur');
INSERT INTO `lang_constants` VALUES (1369, 'History of Heart Murmur');
INSERT INTO `lang_constants` VALUES (1370, 'HIV');
INSERT INTO `lang_constants` VALUES (1371, 'HL7 Viewer');
INSERT INTO `lang_constants` VALUES (1372, 'Hold down [Ctrl] for multiple selections or to unselect');
INSERT INTO `lang_constants` VALUES (1373, 'Hold down Ctrl to select multiple items');
INSERT INTO `lang_constants` VALUES (1374, 'Hold down Ctrl to select multiple squads');
INSERT INTO `lang_constants` VALUES (1375, 'Home');
INSERT INTO `lang_constants` VALUES (1376, 'Home Phone');
INSERT INTO `lang_constants` VALUES (1377, 'Home Phone Number');
INSERT INTO `lang_constants` VALUES (1378, 'Homeless or similar?');
INSERT INTO `lang_constants` VALUES (1379, 'Homeless, etc');
INSERT INTO `lang_constants` VALUES (1380, 'Homeless, etc.');
INSERT INTO `lang_constants` VALUES (1381, 'Hours');
INSERT INTO `lang_constants` VALUES (1382, 'How did Injury Occur?');
INSERT INTO `lang_constants` VALUES (1383, 'How did Injury Occur?:');
INSERT INTO `lang_constants` VALUES (1384, 'How many months ahead to query for upcoming events?');
INSERT INTO `lang_constants` VALUES (1385, 'HPI:');
INSERT INTO `lang_constants` VALUES (1386, 'HT');
INSERT INTO `lang_constants` VALUES (1387, 'HTML');
INSERT INTO `lang_constants` VALUES (1388, 'Hyperactive');
INSERT INTO `lang_constants` VALUES (1389, 'Hypertension');
INSERT INTO `lang_constants` VALUES (1390, 'Hyperthyroidism');
INSERT INTO `lang_constants` VALUES (1391, 'Hypothyroidism');
INSERT INTO `lang_constants` VALUES (1392, 'Hysterectomy');
INSERT INTO `lang_constants` VALUES (1393, 'I');
INSERT INTO `lang_constants` VALUES (1394, 'I am busy during this time.');
INSERT INTO `lang_constants` VALUES (1395, 'I do not have permission to read ');
INSERT INTO `lang_constants` VALUES (1396, 'ICD');
INSERT INTO `lang_constants` VALUES (1397, 'ICD9');
INSERT INTO `lang_constants` VALUES (1398, 'ID');
INSERT INTO `lang_constants` VALUES (1399, 'ID cannot be blank');
INSERT INTO `lang_constants` VALUES (1400, 'IDays');
INSERT INTO `lang_constants` VALUES (1401, 'identified as');
INSERT INTO `lang_constants` VALUES (1402, 'Identifier(one word)');
INSERT INTO `lang_constants` VALUES (1403, 'If all data for all columns are complete for this form');
INSERT INTO `lang_constants` VALUES (1404, 'If name, any part of lastname or lastname,firstname');
INSERT INTO `lang_constants` VALUES (1405, 'if unemployed enter Student');
INSERT INTO `lang_constants` VALUES (1406, 'If you have chosen to upload electronic remittances, then the search window redisplays itself with the matching invoices from the X12 file.  You may click on any of these invoice numbers (as described below) if you wish to make any corrections before the remittance information is applied. To apply the changes, click the Process ERA File button at the bottom of the page.  This will produce a new window with a detailed report.');
INSERT INTO `lang_constants` VALUES (1407, 'If you have entered a Pay Date in the search page, this will override the posting date of payments and adjustments that are otherwise taken from the X12 file.  This may be useful for reporting purposes, if you want your receipts reporting to use your posting date rather than the insurance company\'s processing date.  Note that this will also affect dates of prior payments and adjustments that are put into secondary claims.');
INSERT INTO `lang_constants` VALUES (1408, 'If you want to change data types, or add rows or columns');
INSERT INTO `lang_constants` VALUES (1409, 'Illness');
INSERT INTO `lang_constants` VALUES (1410, 'IM');
INSERT INTO `lang_constants` VALUES (1411, 'Immunization');
INSERT INTO `lang_constants` VALUES (1412, 'Immunization Lot Number');
INSERT INTO `lang_constants` VALUES (1413, 'Immunization Manufacturer');
INSERT INTO `lang_constants` VALUES (1414, 'Immunizations');
INSERT INTO `lang_constants` VALUES (1415, 'Immunize');
INSERT INTO `lang_constants` VALUES (1416, 'Immunologic');
INSERT INTO `lang_constants` VALUES (1417, 'Implants');
INSERT INTO `lang_constants` VALUES (1418, 'Import');
INSERT INTO `lang_constants` VALUES (1419, 'Import Configuration');
INSERT INTO `lang_constants` VALUES (1420, 'Import Patient');
INSERT INTO `lang_constants` VALUES (1421, 'Import Patient Demographics');
INSERT INTO `lang_constants` VALUES (1422, 'Imported from Accounting');
INSERT INTO `lang_constants` VALUES (1423, 'Improved');
INSERT INTO `lang_constants` VALUES (1424, 'in');
INSERT INTO `lang_constants` VALUES (1425, 'IN');
INSERT INTO `lang_constants` VALUES (1426, 'in each eye');
INSERT INTO `lang_constants` VALUES (1427, 'in left eye');
INSERT INTO `lang_constants` VALUES (1428, 'in nostril');
INSERT INTO `lang_constants` VALUES (1429, 'In Office');
INSERT INTO `lang_constants` VALUES (1430, 'in right eye');
INSERT INTO `lang_constants` VALUES (1431, 'in-house');
INSERT INTO `lang_constants` VALUES (1432, 'Inactive');
INSERT INTO `lang_constants` VALUES (1433, 'Inactive Days');
INSERT INTO `lang_constants` VALUES (1434, 'Include inactive users');
INSERT INTO `lang_constants` VALUES (1435, 'Include Uncategorized');
INSERT INTO `lang_constants` VALUES (1436, 'Include Vitals');
INSERT INTO `lang_constants` VALUES (1437, 'Include vitals data?');
INSERT INTO `lang_constants` VALUES (1438, 'Income');
INSERT INTO `lang_constants` VALUES (1439, 'Incomplete Abortion Treatment');
INSERT INTO `lang_constants` VALUES (1440, 'Incontinence');
INSERT INTO `lang_constants` VALUES (1441, 'increased:');
INSERT INTO `lang_constants` VALUES (1442, 'Indemnity Insurance');
INSERT INTO `lang_constants` VALUES (1443, 'Indeterminate');
INSERT INTO `lang_constants` VALUES (1444, 'Indicates if this issue is currently active');
INSERT INTO `lang_constants` VALUES (1445, 'Indigent Patients Report');
INSERT INTO `lang_constants` VALUES (1446, 'Indigents');
INSERT INTO `lang_constants` VALUES (1447, 'Induced Abortion');
INSERT INTO `lang_constants` VALUES (1448, 'Infection / Abscess');
INSERT INTO `lang_constants` VALUES (1449, 'Infections');
INSERT INTO `lang_constants` VALUES (1450, 'Infert Couns');
INSERT INTO `lang_constants` VALUES (1451, 'Infertility');
INSERT INTO `lang_constants` VALUES (1452, 'Influenza 1');
INSERT INTO `lang_constants` VALUES (1453, 'Influenza 2');
INSERT INTO `lang_constants` VALUES (1454, 'Info');
INSERT INTO `lang_constants` VALUES (1455, 'Info test 1');
INSERT INTO `lang_constants` VALUES (1456, 'Info test 2');
INSERT INTO `lang_constants` VALUES (1457, 'Info test 3');
INSERT INTO `lang_constants` VALUES (1458, 'Info test 4');
INSERT INTO `lang_constants` VALUES (1459, 'Info test 5');
INSERT INTO `lang_constants` VALUES (1460, 'Info test 6');
INSERT INTO `lang_constants` VALUES (1461, 'inhalations');
INSERT INTO `lang_constants` VALUES (1462, 'inhilations');
INSERT INTO `lang_constants` VALUES (1463, 'Initial User');
INSERT INTO `lang_constants` VALUES (1464, 'Injectables');
INSERT INTO `lang_constants` VALUES (1465, 'Injured Out');
INSERT INTO `lang_constants` VALUES (1466, 'Injury');
INSERT INTO `lang_constants` VALUES (1467, 'Injury Mechanism');
INSERT INTO `lang_constants` VALUES (1468, 'Injury Overview Report');
INSERT INTO `lang_constants` VALUES (1469, 'Injury Surveillance');
INSERT INTO `lang_constants` VALUES (1470, 'Injury Type');
INSERT INTO `lang_constants` VALUES (1471, 'Input Fields');
INSERT INTO `lang_constants` VALUES (1472, 'Ins adjust');
INSERT INTO `lang_constants` VALUES (1473, 'Ins bundling');
INSERT INTO `lang_constants` VALUES (1474, 'Ins overpaid');
INSERT INTO `lang_constants` VALUES (1475, 'Ins refund');
INSERT INTO `lang_constants` VALUES (1476, 'Ins Summary');
INSERT INTO `lang_constants` VALUES (1477, 'Ins1');
INSERT INTO `lang_constants` VALUES (1478, 'Ins2');
INSERT INTO `lang_constants` VALUES (1479, 'Ins3');
INSERT INTO `lang_constants` VALUES (1480, 'Insert failed: ');
INSERT INTO `lang_constants` VALUES (1481, 'Insert old events into tables');
INSERT INTO `lang_constants` VALUES (1482, 'Insomnia');
INSERT INTO `lang_constants` VALUES (1483, 'Inspection');
INSERT INTO `lang_constants` VALUES (1484, 'Instability / subluxation');
INSERT INTO `lang_constants` VALUES (1485, 'install DB');
INSERT INTO `lang_constants` VALUES (1486, 'Instructed');
INSERT INTO `lang_constants` VALUES (1487, 'Instructions:');
INSERT INTO `lang_constants` VALUES (1488, 'Insulin Dependent Diabetes');
INSERT INTO `lang_constants` VALUES (1489, 'Insurance');
INSERT INTO `lang_constants` VALUES (1490, 'insurance');
INSERT INTO `lang_constants` VALUES (1491, 'Insurance Companies');
INSERT INTO `lang_constants` VALUES (1492, 'Insurance Company');
INSERT INTO `lang_constants` VALUES (1493, 'Insurance Company Search/Add');
INSERT INTO `lang_constants` VALUES (1494, 'Insurance Data');
INSERT INTO `lang_constants` VALUES (1495, 'Insurance Numbers');
INSERT INTO `lang_constants` VALUES (1496, 'Insurance Provider');
INSERT INTO `lang_constants` VALUES (1497, 'Intake Conclusion');
INSERT INTO `lang_constants` VALUES (1498, 'Intake Date');
INSERT INTO `lang_constants` VALUES (1499, 'Intellectual Decline');
INSERT INTO `lang_constants` VALUES (1500, 'Internal error - no pages were selected!');
INSERT INTO `lang_constants` VALUES (1501, 'Internal error - patient ID was not provided!');
INSERT INTO `lang_constants` VALUES (1502, 'Internal error accessing uploaded file!');
INSERT INTO `lang_constants` VALUES (1503, 'Internal error!');
INSERT INTO `lang_constants` VALUES (1504, 'Internal error, no drug ID specified!');
INSERT INTO `lang_constants` VALUES (1505, 'Internal error: claim ');
INSERT INTO `lang_constants` VALUES (1506, 'Internal error: encounter \'');
INSERT INTO `lang_constants` VALUES (1507, 'Internal error: pid or encounter is missing.');
INSERT INTO `lang_constants` VALUES (1508, 'Internal Identifier (pid)');
INSERT INTO `lang_constants` VALUES (1509, 'Internal Referrals');
INSERT INTO `lang_constants` VALUES (1510, 'International Duty');
INSERT INTO `lang_constants` VALUES (1511, 'Interpreter');
INSERT INTO `lang_constants` VALUES (1512, 'Interpreter needed?');
INSERT INTO `lang_constants` VALUES (1513, 'Interstitial Lung Disease');
INSERT INTO `lang_constants` VALUES (1514, 'Interval');
INSERT INTO `lang_constants` VALUES (1515, 'Intolerance');
INSERT INTO `lang_constants` VALUES (1516, 'intramuscularly');
INSERT INTO `lang_constants` VALUES (1517, 'intravenously');
INSERT INTO `lang_constants` VALUES (1518, 'Introduction');
INSERT INTO `lang_constants` VALUES (1519, 'Invalid or missing payer in source for code ');
INSERT INTO `lang_constants` VALUES (1520, 'Invalid Service Codes');
INSERT INTO `lang_constants` VALUES (1521, 'Invalid source designation \"');
INSERT INTO `lang_constants` VALUES (1522, 'InvAmt');
INSERT INTO `lang_constants` VALUES (1523, 'Inventory');
INSERT INTO `lang_constants` VALUES (1524, 'Inventory is not available for this order.');
INSERT INTO `lang_constants` VALUES (1525, 'Inventory List');
INSERT INTO `lang_constants` VALUES (1526, 'Invoice');
INSERT INTO `lang_constants` VALUES (1527, 'invoice');
INSERT INTO `lang_constants` VALUES (1528, 'Invoice Date');
INSERT INTO `lang_constants` VALUES (1529, 'Invoice has no date!');
INSERT INTO `lang_constants` VALUES (1530, 'Invoice:');
INSERT INTO `lang_constants` VALUES (1531, 'IPPF SRH Data for');
INSERT INTO `lang_constants` VALUES (1532, 'IPPF Statistics Report');
INSERT INTO `lang_constants` VALUES (1533, 'IPV 1');
INSERT INTO `lang_constants` VALUES (1534, 'IPV 2');
INSERT INTO `lang_constants` VALUES (1535, 'IPV 3');
INSERT INTO `lang_constants` VALUES (1536, 'IPV 4');
INSERT INTO `lang_constants` VALUES (1537, 'Irregular Heart Beat');
INSERT INTO `lang_constants` VALUES (1538, 'Irritability');
INSERT INTO `lang_constants` VALUES (1539, 'Irritation');
INSERT INTO `lang_constants` VALUES (1540, 'is a required field.');
INSERT INTO `lang_constants` VALUES (1541, 'is a root node and can not be deleted.');
INSERT INTO `lang_constants` VALUES (1542, 'is not valid (decimal fractions are OK).');
INSERT INTO `lang_constants` VALUES (1543, 'Is PHP using Safe Mode?');
INSERT INTO `lang_constants` VALUES (1544, 'is too long');
INSERT INTO `lang_constants` VALUES (1545, 'issue');
INSERT INTO `lang_constants` VALUES (1546, 'Issue');
INSERT INTO `lang_constants` VALUES (1547, 'Issues');
INSERT INTO `lang_constants` VALUES (1548, 'Issues (Injuries/Medical/Allergy):');
INSERT INTO `lang_constants` VALUES (1549, 'Issues and Encounters');
INSERT INTO `lang_constants` VALUES (1550, 'Issues and Encounters for');
INSERT INTO `lang_constants` VALUES (1551, 'Issues not authorized');
INSERT INTO `lang_constants` VALUES (1552, 'Issues Section');
INSERT INTO `lang_constants` VALUES (1553, 'Item');
INSERT INTO `lang_constants` VALUES (1554, 'item');
INSERT INTO `lang_constants` VALUES (1555, 'Items load failed');
INSERT INTO `lang_constants` VALUES (1556, 'IUD');
INSERT INTO `lang_constants` VALUES (1557, 'IV');
INSERT INTO `lang_constants` VALUES (1558, 'January');
INSERT INTO `lang_constants` VALUES (1559, 'Jaundice');
INSERT INTO `lang_constants` VALUES (1560, 'Job Description');
INSERT INTO `lang_constants` VALUES (1561, 'Job ID');
INSERT INTO `lang_constants` VALUES (1562, 'Joint dislocations');
INSERT INTO `lang_constants` VALUES (1563, 'Joint Pain');
INSERT INTO `lang_constants` VALUES (1564, 'Joint sprains');
INSERT INTO `lang_constants` VALUES (1565, 'July');
INSERT INTO `lang_constants` VALUES (1566, 'June');
INSERT INTO `lang_constants` VALUES (1567, 'Just below the check information is a blue area where you put in your search parameters.  You can search by patient name, chart number, encounter number or date of service, or any combination of these.  You may also select whether you want to see all invoices, open invoices, or only invoices that are due (by the patient).  Click the Search button to perform the search.');
INSERT INTO `lang_constants` VALUES (1568, 'Just Mine');
INSERT INTO `lang_constants` VALUES (1569, 'Justify');
INSERT INTO `lang_constants` VALUES (1570, 'Justify/Save');
INSERT INTO `lang_constants` VALUES (1571, 'k, here\'s the rest ');
INSERT INTO `lang_constants` VALUES (1572, 'Keywords');
INSERT INTO `lang_constants` VALUES (1573, 'kg');
INSERT INTO `lang_constants` VALUES (1574, 'kg/m^2');
INSERT INTO `lang_constants` VALUES (1575, 'Kidney Cancer');
INSERT INTO `lang_constants` VALUES (1576, 'Kidney Failure');
INSERT INTO `lang_constants` VALUES (1577, 'Kidney Infections');
INSERT INTO `lang_constants` VALUES (1578, 'Kidney Stones');
INSERT INTO `lang_constants` VALUES (1579, 'Kidney Transplant');
INSERT INTO `lang_constants` VALUES (1580, 'Knee');
INSERT INTO `lang_constants` VALUES (1581, 'Knee Problems');
INSERT INTO `lang_constants` VALUES (1582, 'Knee Replacement');
INSERT INTO `lang_constants` VALUES (1583, 'Lab');
INSERT INTO `lang_constants` VALUES (1584, 'Lab Report');
INSERT INTO `lang_constants` VALUES (1585, 'Label');
INSERT INTO `lang_constants` VALUES (1586, 'Label cannot be blank');
INSERT INTO `lang_constants` VALUES (1587, 'Label Cols');
INSERT INTO `lang_constants` VALUES (1588, 'LabelCols must be a number between 1 and 999');
INSERT INTO `lang_constants` VALUES (1589, 'Labels');
INSERT INTO `lang_constants` VALUES (1590, 'Labs');
INSERT INTO `lang_constants` VALUES (1591, 'Laceration / skin condition');
INSERT INTO `lang_constants` VALUES (1592, 'Laceration/abrasion');
INSERT INTO `lang_constants` VALUES (1593, 'Language');
INSERT INTO `lang_constants` VALUES (1594, 'Language Code');
INSERT INTO `lang_constants` VALUES (1595, 'Language definition added');
INSERT INTO `lang_constants` VALUES (1596, 'Language Interface Tool');
INSERT INTO `lang_constants` VALUES (1597, 'Language List (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (1598, 'Language Name');
INSERT INTO `lang_constants` VALUES (1599, 'Language:');
INSERT INTO `lang_constants` VALUES (1600, 'Last');
INSERT INTO `lang_constants` VALUES (1601, 'Last Activity Date');
INSERT INTO `lang_constants` VALUES (1602, 'Last Bill Date:');
INSERT INTO `lang_constants` VALUES (1603, 'Last Encounter');
INSERT INTO `lang_constants` VALUES (1604, 'Last Name');
INSERT INTO `lang_constants` VALUES (1605, 'Last name');
INSERT INTO `lang_constants` VALUES (1606, 'Last Name:');
INSERT INTO `lang_constants` VALUES (1607, 'Last Saved');
INSERT INTO `lang_constants` VALUES (1608, 'Last update by');
INSERT INTO `lang_constants` VALUES (1609, 'Last Visit');
INSERT INTO `lang_constants` VALUES (1610, 'Late Recurrence (2-12 Mo)');
INSERT INTO `lang_constants` VALUES (1611, 'Lateral Malleolus');
INSERT INTO `lang_constants` VALUES (1612, 'Lateral malleolus:');
INSERT INTO `lang_constants` VALUES (1613, 'laterally displaced PMI:');
INSERT INTO `lang_constants` VALUES (1614, 'Layout Based');
INSERT INTO `lang_constants` VALUES (1615, 'Layout Editor');
INSERT INTO `lang_constants` VALUES (1616, 'Layout groups');
INSERT INTO `lang_constants` VALUES (1617, 'Layout-Based Visit Forms');
INSERT INTO `lang_constants` VALUES (1618, 'Layouts');
INSERT INTO `lang_constants` VALUES (1619, 'lb');
INSERT INTO `lang_constants` VALUES (1620, 'lbs');
INSERT INTO `lang_constants` VALUES (1621, 'LDL');
INSERT INTO `lang_constants` VALUES (1622, 'leave blank if still active');
INSERT INTO `lang_constants` VALUES (1623, 'Leave blank to keep password unchanged.');
INSERT INTO `lang_constants` VALUES (1624, 'Leave Message With');
INSERT INTO `lang_constants` VALUES (1625, 'Leave The Form');
INSERT INTO `lang_constants` VALUES (1626, 'Left');
INSERT INTO `lang_constants` VALUES (1627, 'Left Ear');
INSERT INTO `lang_constants` VALUES (1628, 'left ear');
INSERT INTO `lang_constants` VALUES (1629, 'Left:');
INSERT INTO `lang_constants` VALUES (1630, 'Left: ');
INSERT INTO `lang_constants` VALUES (1631, 'Leg Pain/Cramping');
INSERT INTO `lang_constants` VALUES (1632, 'Legal');
INSERT INTO `lang_constants` VALUES (1633, 'Legend:');
INSERT INTO `lang_constants` VALUES (1634, 'Length');
INSERT INTO `lang_constants` VALUES (1635, 'Less-private information (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (1636, 'Letter');
INSERT INTO `lang_constants` VALUES (1637, 'Letter Generator');
INSERT INTO `lang_constants` VALUES (1638, 'Letterhead that doctor signs');
INSERT INTO `lang_constants` VALUES (1639, 'Letterhead that patient signs');
INSERT INTO `lang_constants` VALUES (1640, 'Level of urgency');
INSERT INTO `lang_constants` VALUES (1641, 'Liability');
INSERT INTO `lang_constants` VALUES (1642, 'Liability Medical');
INSERT INTO `lang_constants` VALUES (1643, 'License/ID');
INSERT INTO `lang_constants` VALUES (1644, 'Lifestyle');
INSERT INTO `lang_constants` VALUES (1645, 'Ligament tear or sprain');
INSERT INTO `lang_constants` VALUES (1646, 'Limit Of Events');
INSERT INTO `lang_constants` VALUES (1647, 'Linked');
INSERT INTO `lang_constants` VALUES (1648, 'linked to document');
INSERT INTO `lang_constants` VALUES (1649, 'List');
INSERT INTO `lang_constants` VALUES (1650, 'List box');
INSERT INTO `lang_constants` VALUES (1651, 'list box');
INSERT INTO `lang_constants` VALUES (1652, 'list box w/ add');
INSERT INTO `lang_constants` VALUES (1653, 'List box w/add');
INSERT INTO `lang_constants` VALUES (1654, 'List Editor');
INSERT INTO `lang_constants` VALUES (1655, 'List groups');
INSERT INTO `lang_constants` VALUES (1656, 'List Insurance Companies');
INSERT INTO `lang_constants` VALUES (1657, 'List items can not start with a number.');
INSERT INTO `lang_constants` VALUES (1658, 'List items contains illegal character(s).');
INSERT INTO `lang_constants` VALUES (1659, 'List lists');
INSERT INTO `lang_constants` VALUES (1660, 'List Name');
INSERT INTO `lang_constants` VALUES (1661, 'List names cannot start with numbers.');
INSERT INTO `lang_constants` VALUES (1662, 'List Prescriptions');
INSERT INTO `lang_constants` VALUES (1663, 'Lists');
INSERT INTO `lang_constants` VALUES (1664, 'LLL:');
INSERT INTO `lang_constants` VALUES (1665, 'LMP');
INSERT INTO `lang_constants` VALUES (1666, 'Load Definitions');
INSERT INTO `lang_constants` VALUES (1667, 'LOADING');
INSERT INTO `lang_constants` VALUES (1668, 'LOC');
INSERT INTO `lang_constants` VALUES (1669, 'Local');
INSERT INTO `lang_constants` VALUES (1670, 'Locality');
INSERT INTO `lang_constants` VALUES (1671, 'Location');
INSERT INTO `lang_constants` VALUES (1672, 'Location unspecified');
INSERT INTO `lang_constants` VALUES (1673, 'Location:');
INSERT INTO `lang_constants` VALUES (1674, 'Lock');
INSERT INTO `lang_constants` VALUES (1675, 'Logged in');
INSERT INTO `lang_constants` VALUES (1676, 'Logged in as');
INSERT INTO `lang_constants` VALUES (1677, 'Logged in as: ');
INSERT INTO `lang_constants` VALUES (1678, 'Logged out.');
INSERT INTO `lang_constants` VALUES (1679, 'Login');
INSERT INTO `lang_constants` VALUES (1680, 'login');
INSERT INTO `lang_constants` VALUES (1681, 'Logout');
INSERT INTO `lang_constants` VALUES (1682, 'logout');
INSERT INTO `lang_constants` VALUES (1683, 'Logs');
INSERT INTO `lang_constants` VALUES (1684, 'Logs Viewer');
INSERT INTO `lang_constants` VALUES (1685, 'Look Up');
INSERT INTO `lang_constants` VALUES (1686, 'Lot');
INSERT INTO `lang_constants` VALUES (1687, 'Lot ID missing!');
INSERT INTO `lang_constants` VALUES (1688, 'Lot Number');
INSERT INTO `lang_constants` VALUES (1689, 'Low');
INSERT INTO `lang_constants` VALUES (1690, 'Lower leg');
INSERT INTO `lang_constants` VALUES (1691, 'Lumbar spine');
INSERT INTO `lang_constants` VALUES (1692, 'LUNCH');
INSERT INTO `lang_constants` VALUES (1693, 'Lunch');
INSERT INTO `lang_constants` VALUES (1694, 'Lung Cancer');
INSERT INTO `lang_constants` VALUES (1695, 'Lung Cancer Surgery');
INSERT INTO `lang_constants` VALUES (1696, 'LUNGS:');
INSERT INTO `lang_constants` VALUES (1697, 'Lungs:');
INSERT INTO `lang_constants` VALUES (1698, 'Lupus');
INSERT INTO `lang_constants` VALUES (1699, 'M');
INSERT INTO `lang_constants` VALUES (1700, 'MA Category');
INSERT INTO `lang_constants` VALUES (1701, 'Main Address');
INSERT INTO `lang_constants` VALUES (1702, 'Make modifications to current categories.');
INSERT INTO `lang_constants` VALUES (1703, 'Make sure \"');
INSERT INTO `lang_constants` VALUES (1704, 'Malaise:');
INSERT INTO `lang_constants` VALUES (1705, 'Male');
INSERT INTO `lang_constants` VALUES (1706, 'Male Condoms');
INSERT INTO `lang_constants` VALUES (1707, 'Male VSC');
INSERT INTO `lang_constants` VALUES (1708, 'Mammogram');
INSERT INTO `lang_constants` VALUES (1709, 'Management');
INSERT INTO `lang_constants` VALUES (1710, 'Manual Posting');
INSERT INTO `lang_constants` VALUES (1711, 'Manufacturer');
INSERT INTO `lang_constants` VALUES (1712, 'March');
INSERT INTO `lang_constants` VALUES (1713, 'Marital Status');
INSERT INTO `lang_constants` VALUES (1714, 'Mark as billed but skip billing');
INSERT INTO `lang_constants` VALUES (1715, 'Mark as Cleared');
INSERT INTO `lang_constants` VALUES (1716, 'Mark as not billed');
INSERT INTO `lang_constants` VALUES (1717, 'Marked as cleared');
INSERT INTO `lang_constants` VALUES (1718, 'Married');
INSERT INTO `lang_constants` VALUES (1719, 'Maxillary Right:');
INSERT INTO `lang_constants` VALUES (1720, 'May');
INSERT INTO `lang_constants` VALUES (1721, 'MC');
INSERT INTO `lang_constants` VALUES (1722, 'mcg');
INSERT INTO `lang_constants` VALUES (1723, 'Medial malleolus:');
INSERT INTO `lang_constants` VALUES (1724, 'Medicaid');
INSERT INTO `lang_constants` VALUES (1725, 'Medical');
INSERT INTO `lang_constants` VALUES (1726, 'Medical Abortion');
INSERT INTO `lang_constants` VALUES (1727, 'Medical problem');
INSERT INTO `lang_constants` VALUES (1728, 'Medical Problems');
INSERT INTO `lang_constants` VALUES (1729, 'Medical Record');
INSERT INTO `lang_constants` VALUES (1730, 'Medical Record #');
INSERT INTO `lang_constants` VALUES (1731, 'Medical Records');
INSERT INTO `lang_constants` VALUES (1732, 'Medical/History (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (1733, 'Medicare Part B');
INSERT INTO `lang_constants` VALUES (1734, 'Medication');
INSERT INTO `lang_constants` VALUES (1735, 'Medications');
INSERT INTO `lang_constants` VALUES (1736, 'Medications:');
INSERT INTO `lang_constants` VALUES (1737, 'Medicine Units');
INSERT INTO `lang_constants` VALUES (1738, 'Medium');
INSERT INTO `lang_constants` VALUES (1739, 'Member Association Statistics Report');
INSERT INTO `lang_constants` VALUES (1740, 'Memory Problems');
INSERT INTO `lang_constants` VALUES (1741, 'Men');
INSERT INTO `lang_constants` VALUES (1742, 'Men and Women');
INSERT INTO `lang_constants` VALUES (1743, 'Men Only');
INSERT INTO `lang_constants` VALUES (1744, 'Menarche');
INSERT INTO `lang_constants` VALUES (1745, 'Menopause');
INSERT INTO `lang_constants` VALUES (1746, 'Menstrual Flow');
INSERT INTO `lang_constants` VALUES (1747, 'Menstrual Frequency');
INSERT INTO `lang_constants` VALUES (1748, 'Mental Illness');
INSERT INTO `lang_constants` VALUES (1749, 'Message');
INSERT INTO `lang_constants` VALUES (1750, 'MESSAGE:');
INSERT INTO `lang_constants` VALUES (1751, 'Method');
INSERT INTO `lang_constants` VALUES (1752, 'Method of Destruction');
INSERT INTO `lang_constants` VALUES (1753, 'mg');
INSERT INTO `lang_constants` VALUES (1754, 'mg/1cc');
INSERT INTO `lang_constants` VALUES (1755, 'mg/2cc');
INSERT INTO `lang_constants` VALUES (1756, 'mg/3cc');
INSERT INTO `lang_constants` VALUES (1757, 'mg/4cc');
INSERT INTO `lang_constants` VALUES (1758, 'mg/5cc');
INSERT INTO `lang_constants` VALUES (1759, 'Middle');
INSERT INTO `lang_constants` VALUES (1760, 'Middle Name');
INSERT INTO `lang_constants` VALUES (1761, 'Middle name');
INSERT INTO `lang_constants` VALUES (1762, 'Migrant or seasonal worker?');
INSERT INTO `lang_constants` VALUES (1763, 'Migrant/Seasonal');
INSERT INTO `lang_constants` VALUES (1764, 'MimeType');
INSERT INTO `lang_constants` VALUES (1765, 'min');
INSERT INTO `lang_constants` VALUES (1766, 'Minor joint strain +/- synovitis');
INSERT INTO `lang_constants` VALUES (1767, 'minutes');
INSERT INTO `lang_constants` VALUES (1768, 'Minutes');
INSERT INTO `lang_constants` VALUES (1769, 'Misc');
INSERT INTO `lang_constants` VALUES (1770, 'Misc Billing Options');
INSERT INTO `lang_constants` VALUES (1771, 'Misc Billing Options for HCFA-1500');
INSERT INTO `lang_constants` VALUES (1772, 'Misc Billing Options HCFA');
INSERT INTO `lang_constants` VALUES (1773, 'Miscellaneous');
INSERT INTO `lang_constants` VALUES (1774, 'Missed');
INSERT INTO `lang_constants` VALUES (1775, 'Missing Fee');
INSERT INTO `lang_constants` VALUES (1776, 'Missing PID.');
INSERT INTO `lang_constants` VALUES (1777, 'Missing slash after payer in source for code ');
INSERT INTO `lang_constants` VALUES (1778, 'Mixed');
INSERT INTO `lang_constants` VALUES (1779, 'ml');
INSERT INTO `lang_constants` VALUES (1780, 'mm/hg');
INSERT INTO `lang_constants` VALUES (1781, 'MMR 1');
INSERT INTO `lang_constants` VALUES (1782, 'MMR 2');
INSERT INTO `lang_constants` VALUES (1783, 'Mobile');
INSERT INTO `lang_constants` VALUES (1784, 'Mobile Phone');
INSERT INTO `lang_constants` VALUES (1785, 'Mod');
INSERT INTO `lang_constants` VALUES (1786, 'Modifier');
INSERT INTO `lang_constants` VALUES (1787, 'Mon');
INSERT INTO `lang_constants` VALUES (1788, 'Mon thru Fri');
INSERT INTO `lang_constants` VALUES (1789, 'Mon, Wed &amp; Fri');
INSERT INTO `lang_constants` VALUES (1790, 'Monday');
INSERT INTO `lang_constants` VALUES (1791, 'month');
INSERT INTO `lang_constants` VALUES (1792, 'Month');
INSERT INTO `lang_constants` VALUES (1793, 'Month View');
INSERT INTO `lang_constants` VALUES (1794, 'Month(s)');
INSERT INTO `lang_constants` VALUES (1795, 'Monthly Income');
INSERT INTO `lang_constants` VALUES (1796, 'More than 100 records found. Please narrow your search criteria.');
INSERT INTO `lang_constants` VALUES (1797, 'More than 50 results, please make your search more specific.');
INSERT INTO `lang_constants` VALUES (1798, 'Mother');
INSERT INTO `lang_constants` VALUES (1799, 'Mouth');
INSERT INTO `lang_constants` VALUES (1800, 'Move');
INSERT INTO `lang_constants` VALUES (1801, 'Move Document to Category:');
INSERT INTO `lang_constants` VALUES (1802, 'Move Down');
INSERT INTO `lang_constants` VALUES (1803, 'Move to Patient');
INSERT INTO `lang_constants` VALUES (1804, 'Move to...');
INSERT INTO `lang_constants` VALUES (1805, 'Move Up');
INSERT INTO `lang_constants` VALUES (1806, 'Mr.');
INSERT INTO `lang_constants` VALUES (1807, 'Mrs.');
INSERT INTO `lang_constants` VALUES (1808, 'Ms.');
INSERT INTO `lang_constants` VALUES (1809, 'Multi Language Tool');
INSERT INTO `lang_constants` VALUES (1810, 'Multiple areas');
INSERT INTO `lang_constants` VALUES (1811, 'Murmur:');
INSERT INTO `lang_constants` VALUES (1812, 'Musc Ache');
INSERT INTO `lang_constants` VALUES (1813, 'Musc Aches');
INSERT INTO `lang_constants` VALUES (1814, 'Musc Redness');
INSERT INTO `lang_constants` VALUES (1815, 'Musc Stiffness');
INSERT INTO `lang_constants` VALUES (1816, 'Musc Swelling');
INSERT INTO `lang_constants` VALUES (1817, 'Musc Warm');
INSERT INTO `lang_constants` VALUES (1818, 'Muscle');
INSERT INTO `lang_constants` VALUES (1819, 'Muscle injury');
INSERT INTO `lang_constants` VALUES (1820, 'Musculoskeletal');
INSERT INTO `lang_constants` VALUES (1821, 'Mutually Defined');
INSERT INTO `lang_constants` VALUES (1822, 'MVA');
INSERT INTO `lang_constants` VALUES (1823, 'N/A');
INSERT INTO `lang_constants` VALUES (1824, 'n/a');
INSERT INTO `lang_constants` VALUES (1825, 'Name');
INSERT INTO `lang_constants` VALUES (1826, 'Name 1');
INSERT INTO `lang_constants` VALUES (1827, 'Name 2');
INSERT INTO `lang_constants` VALUES (1828, 'Name and Title of Immunization Administrator');
INSERT INTO `lang_constants` VALUES (1829, 'Name of insurance company');
INSERT INTO `lang_constants` VALUES (1830, 'Name of Provider');
INSERT INTO `lang_constants` VALUES (1831, 'Name Translation');
INSERT INTO `lang_constants` VALUES (1832, 'Name/Value');
INSERT INTO `lang_constants` VALUES (1833, 'Name:');
INSERT INTO `lang_constants` VALUES (1834, 'NARES:');
INSERT INTO `lang_constants` VALUES (1835, 'NARES: Normal Right');
INSERT INTO `lang_constants` VALUES (1836, 'Nasal mucosa pink, septum midline');
INSERT INTO `lang_constants` VALUES (1837, 'Nationality');
INSERT INTO `lang_constants` VALUES (1838, 'Nausea');
INSERT INTO `lang_constants` VALUES (1839, 'Navigation');
INSERT INTO `lang_constants` VALUES (1840, 'NDC');
INSERT INTO `lang_constants` VALUES (1841, 'NDC Number');
INSERT INTO `lang_constants` VALUES (1842, 'Neck');
INSERT INTO `lang_constants` VALUES (1843, 'Neck Problems');
INSERT INTO `lang_constants` VALUES (1844, 'Neck supple');
INSERT INTO `lang_constants` VALUES (1845, 'Need to enter a description');
INSERT INTO `lang_constants` VALUES (1846, 'Need to enter a Return Value');
INSERT INTO `lang_constants` VALUES (1847, 'Need to enter identifier');
INSERT INTO `lang_constants` VALUES (1848, 'Need to enter title');
INSERT INTO `lang_constants` VALUES (1849, 'Needs Auth');
INSERT INTO `lang_constants` VALUES (1850, 'Needs Justify');
INSERT INTO `lang_constants` VALUES (1851, 'Needs secondary billing');
INSERT INTO `lang_constants` VALUES (1852, 'Nerve injury');
INSERT INTO `lang_constants` VALUES (1853, 'Neural condition / nerve damage');
INSERT INTO `lang_constants` VALUES (1854, 'Neuro Numbness');
INSERT INTO `lang_constants` VALUES (1855, 'Neuro Weakness');
INSERT INTO `lang_constants` VALUES (1856, 'Neurologic');
INSERT INTO `lang_constants` VALUES (1857, 'New');
INSERT INTO `lang_constants` VALUES (1858, 'New =>');
INSERT INTO `lang_constants` VALUES (1859, 'New Acceptors');
INSERT INTO `lang_constants` VALUES (1860, 'New Allergy');
INSERT INTO `lang_constants` VALUES (1861, 'New Appointment');
INSERT INTO `lang_constants` VALUES (1862, 'New Categories');
INSERT INTO `lang_constants` VALUES (1863, 'New Category');
INSERT INTO `lang_constants` VALUES (1864, 'New Clients');
INSERT INTO `lang_constants` VALUES (1865, 'New Consultation');
INSERT INTO `lang_constants` VALUES (1866, 'New Definition set added');
INSERT INTO `lang_constants` VALUES (1867, 'New Document');
INSERT INTO `lang_constants` VALUES (1868, 'New Encounter Form');
INSERT INTO `lang_constants` VALUES (1869, 'New encounters not authorized');
INSERT INTO `lang_constants` VALUES (1870, 'New Enctr');
INSERT INTO `lang_constants` VALUES (1871, 'New Facility Information');
INSERT INTO `lang_constants` VALUES (1872, 'New Group');
INSERT INTO `lang_constants` VALUES (1873, 'New Group Information');
INSERT INTO `lang_constants` VALUES (1874, 'New Limit of Events');
INSERT INTO `lang_constants` VALUES (1875, 'New List');
INSERT INTO `lang_constants` VALUES (1876, 'New Patient');
INSERT INTO `lang_constants` VALUES (1877, 'New Patient Encounter');
INSERT INTO `lang_constants` VALUES (1878, 'New Patient ID');
INSERT INTO `lang_constants` VALUES (1879, 'New Pt');
INSERT INTO `lang_constants` VALUES (1880, 'New Submissions');
INSERT INTO `lang_constants` VALUES (1881, 'New User');
INSERT INTO `lang_constants` VALUES (1882, 'New Visit');
INSERT INTO `lang_constants` VALUES (1883, 'New/Search');
INSERT INTO `lang_constants` VALUES (1884, 'Newspaper');
INSERT INTO `lang_constants` VALUES (1885, 'Next');
INSERT INTO `lang_constants` VALUES (1886, 'Next Day');
INSERT INTO `lang_constants` VALUES (1887, 'Next Month');
INSERT INTO `lang_constants` VALUES (1888, 'Next Week');
INSERT INTO `lang_constants` VALUES (1889, 'Nickname');
INSERT INTO `lang_constants` VALUES (1890, 'Night Sweats');
INSERT INTO `lang_constants` VALUES (1891, 'Nl ext genitalia, vag mucosa, cervix');
INSERT INTO `lang_constants` VALUES (1892, 'NO');
INSERT INTO `lang_constants` VALUES (1893, 'No');
INSERT INTO `lang_constants` VALUES (1894, 'No access');
INSERT INTO `lang_constants` VALUES (1895, 'No adenopathy (2 areas required)');
INSERT INTO `lang_constants` VALUES (1896, 'No adnexal tenderness/masses');
INSERT INTO `lang_constants` VALUES (1897, 'No billing system is currently active');
INSERT INTO `lang_constants` VALUES (1898, 'No Bills Found to Include in OFX Export<br>');
INSERT INTO `lang_constants` VALUES (1899, 'No code was specified!');
INSERT INTO `lang_constants` VALUES (1900, 'No Diagnosis');
INSERT INTO `lang_constants` VALUES (1901, 'No end date');
INSERT INTO `lang_constants` VALUES (1902, 'No entries found, use the form below to add an entry.');
INSERT INTO `lang_constants` VALUES (1903, 'No Events');
INSERT INTO `lang_constants` VALUES (1904, 'No group was selected');
INSERT INTO `lang_constants` VALUES (1905, 'No hernia');
INSERT INTO `lang_constants` VALUES (1906, 'No Insurance Companies Found');
INSERT INTO `lang_constants` VALUES (1907, 'No items were selected!');
INSERT INTO `lang_constants` VALUES (1908, 'No masses, tenderness');
INSERT INTO `lang_constants` VALUES (1909, 'No notes');
INSERT INTO `lang_constants` VALUES (1910, 'No ogrganomegoly');
INSERT INTO `lang_constants` VALUES (1911, 'No openings were found for this period.');
INSERT INTO `lang_constants` VALUES (1912, 'No Partners Found');
INSERT INTO `lang_constants` VALUES (1913, 'No peripheral edema');
INSERT INTO `lang_constants` VALUES (1914, 'No Pharmacies Found');
INSERT INTO `lang_constants` VALUES (1915, 'No Prescriptions Found');
INSERT INTO `lang_constants` VALUES (1916, 'No presenting illness/injury');
INSERT INTO `lang_constants` VALUES (1917, 'No Providers Found');
INSERT INTO `lang_constants` VALUES (1918, 'No rash or abnormal lesions');
INSERT INTO `lang_constants` VALUES (1919, 'No records found. Please expand your search criteria.');
INSERT INTO `lang_constants` VALUES (1920, 'No Results');
INSERT INTO `lang_constants` VALUES (1921, 'No Results Found For Search');
INSERT INTO `lang_constants` VALUES (1922, 'No results, please tray again.');
INSERT INTO `lang_constants` VALUES (1923, 'No results, please try again.');
INSERT INTO `lang_constants` VALUES (1924, 'No Show');
INSERT INTO `lang_constants` VALUES (1925, 'No Sinus Tenderness:');
INSERT INTO `lang_constants` VALUES (1926, 'No skin dimpling or breast nodules');
INSERT INTO `lang_constants` VALUES (1927, 'No testicular tenderness, masses');
INSERT INTO `lang_constants` VALUES (1928, 'No thrills or heaves');
INSERT INTO `lang_constants` VALUES (1929, 'No visit');
INSERT INTO `lang_constants` VALUES (1930, 'No, Cancel');
INSERT INTO `lang_constants` VALUES (1931, 'No:');
INSERT INTO `lang_constants` VALUES (1932, 'Nocturia');
INSERT INTO `lang_constants` VALUES (1933, 'Non specific injury');
INSERT INTO `lang_constants` VALUES (1934, 'Non-Insulin Dependent Diabetes');
INSERT INTO `lang_constants` VALUES (1935, 'Non-SRH Medical');
INSERT INTO `lang_constants` VALUES (1936, 'Non-SRH Non-Medical');
INSERT INTO `lang_constants` VALUES (1937, 'None');
INSERT INTO `lang_constants` VALUES (1938, 'none');
INSERT INTO `lang_constants` VALUES (1939, 'None of the above');
INSERT INTO `lang_constants` VALUES (1940, 'Noninsulin Dependent Diabetes');
INSERT INTO `lang_constants` VALUES (1941, 'Nor');
INSERT INTO `lang_constants` VALUES (1942, 'Normal');
INSERT INTO `lang_constants` VALUES (1943, 'Normal BL');
INSERT INTO `lang_constants` VALUES (1944, 'Normal Cardiac Exam:');
INSERT INTO `lang_constants` VALUES (1945, 'Normal Cardiac Exam: ');
INSERT INTO `lang_constants` VALUES (1946, 'Normal Lung Exam:');
INSERT INTO `lang_constants` VALUES (1947, 'Normal Lung Exam: ');
INSERT INTO `lang_constants` VALUES (1948, 'Normal Office Visit');
INSERT INTO `lang_constants` VALUES (1949, 'Normal Oropharynx:');
INSERT INTO `lang_constants` VALUES (1950, 'Normal Right');
INSERT INTO `lang_constants` VALUES (1951, 'Normal Right:');
INSERT INTO `lang_constants` VALUES (1952, 'Normal View');
INSERT INTO `lang_constants` VALUES (1953, 'normal:');
INSERT INTO `lang_constants` VALUES (1954, 'Norwegian');
INSERT INTO `lang_constants` VALUES (1955, 'Nose');
INSERT INTO `lang_constants` VALUES (1956, 'Nosebleed');
INSERT INTO `lang_constants` VALUES (1957, 'Not all fields are required for all codes or code types.');
INSERT INTO `lang_constants` VALUES (1958, 'Not Allowed');
INSERT INTO `lang_constants` VALUES (1959, 'Not allowed to delete the Administrators group');
INSERT INTO `lang_constants` VALUES (1960, 'Not allowed to inactivate all security objects');
INSERT INTO `lang_constants` VALUES (1961, 'Not allowed to inactivate anything from the Administrators ACL');
INSERT INTO `lang_constants` VALUES (1962, 'Not allowed to remove the admin user from the Administrators group');
INSERT INTO `lang_constants` VALUES (1963, 'Not authorised to access PostCalendar module');
INSERT INTO `lang_constants` VALUES (1964, 'Not authorized');
INSERT INTO `lang_constants` VALUES (1965, 'Not authorized for this squad.');
INSERT INTO `lang_constants` VALUES (1966, 'Not Available');
INSERT INTO `lang_constants` VALUES (1967, 'Not billed');
INSERT INTO `lang_constants` VALUES (1968, 'Not checked out');
INSERT INTO `lang_constants` VALUES (1969, 'Not Examined');
INSERT INTO `lang_constants` VALUES (1970, 'Not Examined:');
INSERT INTO `lang_constants` VALUES (1971, 'Not Examined: ');
INSERT INTO `lang_constants` VALUES (1972, 'not found');
INSERT INTO `lang_constants` VALUES (1973, 'not found!');
INSERT INTO `lang_constants` VALUES (1974, 'Not seen since');
INSERT INTO `lang_constants` VALUES (1975, 'Note');
INSERT INTO `lang_constants` VALUES (1976, 'Note Type');
INSERT INTO `lang_constants` VALUES (1977, 'Note: This code was not entered by an authorized user. Only authorized codes may be uploaded to the Open Medical Billing Network for processing. If you wish to upload these codes, please select an authorized user here.');
INSERT INTO `lang_constants` VALUES (1978, 'NOTE: Uploading files with duplicate names will cause the files to be automatically renamed. For example \'<i>file.jpg</i>\' will become \'<i>file.jpg.1</i>\'. Filenames are considered unique per patient, not per category. ');
INSERT INTO `lang_constants` VALUES (1979, 'Notes');
INSERT INTO `lang_constants` VALUES (1980, 'Notes - any encounters (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (1981, 'Notes - my encounters (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (1982, 'Notes not authorized');
INSERT INTO `lang_constants` VALUES (1983, 'Nothing was selected');
INSERT INTO `lang_constants` VALUES (1984, 'NOTICE:: PostCalendar Submission/Modification');
INSERT INTO `lang_constants` VALUES (1985, 'Notification');
INSERT INTO `lang_constants` VALUES (1986, 'Notify Admin About Event Submission/Modification?');
INSERT INTO `lang_constants` VALUES (1987, 'November');
INSERT INTO `lang_constants` VALUES (1988, 'Now posting for:');
INSERT INTO `lang_constants` VALUES (1989, 'Now printing $stmt_count statements and updating encounters.');
INSERT INTO `lang_constants` VALUES (1990, 'Now printing $stmt_count statements and updating invoices.');
INSERT INTO `lang_constants` VALUES (1991, 'Now printing $stmt_count statements; encounters will not be updated.');
INSERT INTO `lang_constants` VALUES (1992, 'Now printing $stmt_count statements; invoices will not be updated.');
INSERT INTO `lang_constants` VALUES (1993, 'NPI');
INSERT INTO `lang_constants` VALUES (1994, 'Number');
INSERT INTO `lang_constants` VALUES (1995, 'Number of columns in year view.');
INSERT INTO `lang_constants` VALUES (1996, 'Number of games or events missed, if any');
INSERT INTO `lang_constants` VALUES (1997, 'Numbness');
INSERT INTO `lang_constants` VALUES (1998, 'O.A.F.V.');
INSERT INTO `lang_constants` VALUES (1999, 'O2 Sat');
INSERT INTO `lang_constants` VALUES (2000, 'Obesity I');
INSERT INTO `lang_constants` VALUES (2001, 'Obesity II');
INSERT INTO `lang_constants` VALUES (2002, 'Obesity III');
INSERT INTO `lang_constants` VALUES (2003, 'Objective');
INSERT INTO `lang_constants` VALUES (2004, 'Occupation');
INSERT INTO `lang_constants` VALUES (2005, 'Occurrence');
INSERT INTO `lang_constants` VALUES (2006, 'October');
INSERT INTO `lang_constants` VALUES (2007, 'OD');
INSERT INTO `lang_constants` VALUES (2008, 'of quantity');
INSERT INTO `lang_constants` VALUES (2009, 'of tablets');
INSERT INTO `lang_constants` VALUES (2010, 'of the month every');
INSERT INTO `lang_constants` VALUES (2011, 'Ofc Notes');
INSERT INTO `lang_constants` VALUES (2012, 'Office Notes');
INSERT INTO `lang_constants` VALUES (2013, 'Office Visit');
INSERT INTO `lang_constants` VALUES (2014, 'Offspring');
INSERT INTO `lang_constants` VALUES (2015, 'ointment');
INSERT INTO `lang_constants` VALUES (2016, 'OK');
INSERT INTO `lang_constants` VALUES (2017, 'OK to link the GCAC issue dated');
INSERT INTO `lang_constants` VALUES (2018, 'Old Clients');
INSERT INTO `lang_constants` VALUES (2019, 'Old fracture non / malunion');
INSERT INTO `lang_constants` VALUES (2020, 'Omit internal users?');
INSERT INTO `lang_constants` VALUES (2021, 'omit to autoassign');
INSERT INTO `lang_constants` VALUES (2022, 'on');
INSERT INTO `lang_constants` VALUES (2023, 'On Hand');
INSERT INTO `lang_constants` VALUES (2024, 'On Order');
INSERT INTO `lang_constants` VALUES (2025, 'Once you change your password, you will have to re-login.');
INSERT INTO `lang_constants` VALUES (2026, 'Online Support');
INSERT INTO `lang_constants` VALUES (2027, 'Only Active');
INSERT INTO `lang_constants` VALUES (2028, 'only if billing location');
INSERT INTO `lang_constants` VALUES (2029, 'Only Inactive');
INSERT INTO `lang_constants` VALUES (2030, 'Only Mine');
INSERT INTO `lang_constants` VALUES (2031, 'Onset of Illness:');
INSERT INTO `lang_constants` VALUES (2032, 'Onset of Ilness: ');
INSERT INTO `lang_constants` VALUES (2033, 'Onset of Swelling:');
INSERT INTO `lang_constants` VALUES (2034, 'Onset/hosp. date:');
INSERT INTO `lang_constants` VALUES (2035, 'Open');
INSERT INTO `lang_constants` VALUES (2036, 'OpenEMR requires Javascript to perform user authentication.');
INSERT INTO `lang_constants` VALUES (2037, 'OpenEMR Users');
INSERT INTO `lang_constants` VALUES (2038, 'Option');
INSERT INTO `lang_constants` VALUES (2039, 'Optional');
INSERT INTO `lang_constants` VALUES (2040, 'Optional drug name, use % as a wildcard');
INSERT INTO `lang_constants` VALUES (2041, 'Optional information about this event');
INSERT INTO `lang_constants` VALUES (2042, 'Optional lot number, use % as a wildcard');
INSERT INTO `lang_constants` VALUES (2043, 'Optional numeric patient ID');
INSERT INTO `lang_constants` VALUES (2044, 'Optional procedure code');
INSERT INTO `lang_constants` VALUES (2045, 'Or');
INSERT INTO `lang_constants` VALUES (2046, 'OR');
INSERT INTO `lang_constants` VALUES (2047, 'or choose');
INSERT INTO `lang_constants` VALUES (2048, 'Or Out To');
INSERT INTO `lang_constants` VALUES (2049, 'Or upload ERA file:');
INSERT INTO `lang_constants` VALUES (2050, 'Oral');
INSERT INTO `lang_constants` VALUES (2051, 'Oral mucosa pink, throat clear');
INSERT INTO `lang_constants` VALUES (2052, 'Order');
INSERT INTO `lang_constants` VALUES (2053, 'Order must be a number between 1 and 999');
INSERT INTO `lang_constants` VALUES (2054, 'Organ injury');
INSERT INTO `lang_constants` VALUES (2055, 'Organization');
INSERT INTO `lang_constants` VALUES (2056, 'Organizations');
INSERT INTO `lang_constants` VALUES (2057, 'Orientated x 3');
INSERT INTO `lang_constants` VALUES (2058, 'Original');
INSERT INTO `lang_constants` VALUES (2059, 'OROPHARYNX: ');
INSERT INTO `lang_constants` VALUES (2060, 'Orthopnea');
INSERT INTO `lang_constants` VALUES (2061, 'OS');
INSERT INTO `lang_constants` VALUES (2062, 'Osetoarthritis');
INSERT INTO `lang_constants` VALUES (2063, 'Other');
INSERT INTO `lang_constants` VALUES (2064, 'other');
INSERT INTO `lang_constants` VALUES (2065, 'Other (specify)');
INSERT INTO `lang_constants` VALUES (2066, 'Other Federal Program');
INSERT INTO `lang_constants` VALUES (2067, 'Other HCFA');
INSERT INTO `lang_constants` VALUES (2068, 'Other injury not elsewhere specified');
INSERT INTO `lang_constants` VALUES (2069, 'other month');
INSERT INTO `lang_constants` VALUES (2070, 'Other Non-Federal Programs');
INSERT INTO `lang_constants` VALUES (2071, 'Other Notes');
INSERT INTO `lang_constants` VALUES (2072, 'Other Pertinent Symptoms');
INSERT INTO `lang_constants` VALUES (2073, 'Other Pertinent Symptoms:');
INSERT INTO `lang_constants` VALUES (2074, 'Other stress/Over use injury');
INSERT INTO `lang_constants` VALUES (2075, 'Other Surgical');
INSERT INTO `lang_constants` VALUES (2076, 'Other/Generic Abortion-Related');
INSERT INTO `lang_constants` VALUES (2077, 'otherwise you will destroy references to/from existing data.');
INSERT INTO `lang_constants` VALUES (2078, 'Ottawa Ankle Rules');
INSERT INTO `lang_constants` VALUES (2079, 'OU');
INSERT INTO `lang_constants` VALUES (2080, 'OUT');
INSERT INTO `lang_constants` VALUES (2081, 'Out Of Office');
INSERT INTO `lang_constants` VALUES (2082, 'Outcome');
INSERT INTO `lang_constants` VALUES (2083, 'Outlook');
INSERT INTO `lang_constants` VALUES (2084, 'Overuse');
INSERT INTO `lang_constants` VALUES (2085, 'Overweight');
INSERT INTO `lang_constants` VALUES (2086, 'Overwrite HIPAA choice');
INSERT INTO `lang_constants` VALUES (2087, 'Oxygen Saturation');
INSERT INTO `lang_constants` VALUES (2088, 'P');
INSERT INTO `lang_constants` VALUES (2089, 'p.c.');
INSERT INTO `lang_constants` VALUES (2090, 'p.m.');
INSERT INTO `lang_constants` VALUES (2091, 'p.r.n.');
INSERT INTO `lang_constants` VALUES (2092, 'Paedeatric');
INSERT INTO `lang_constants` VALUES (2093, 'Page');
INSERT INTO `lang_constants` VALUES (2094, 'Pages');
INSERT INTO `lang_constants` VALUES (2095, 'Paid');
INSERT INTO `lang_constants` VALUES (2096, 'Paid amount that you will allocate');
INSERT INTO `lang_constants` VALUES (2097, 'Paid Via');
INSERT INTO `lang_constants` VALUES (2098, 'Pain');
INSERT INTO `lang_constants` VALUES (2099, 'Palpitation');
INSERT INTO `lang_constants` VALUES (2100, 'Pap Smear');
INSERT INTO `lang_constants` VALUES (2101, 'Paralysis');
INSERT INTO `lang_constants` VALUES (2102, 'Parse HL7');
INSERT INTO `lang_constants` VALUES (2103, 'Partner');
INSERT INTO `lang_constants` VALUES (2104, 'Password');
INSERT INTO `lang_constants` VALUES (2105, 'Password Change');
INSERT INTO `lang_constants` VALUES (2106, 'Password change successful.');
INSERT INTO `lang_constants` VALUES (2107, 'Password for SMS Gateway');
INSERT INTO `lang_constants` VALUES (2108, 'Password:');
INSERT INTO `lang_constants` VALUES (2109, 'Past Encounters');
INSERT INTO `lang_constants` VALUES (2110, 'Past Encounters and Documents');
INSERT INTO `lang_constants` VALUES (2111, 'Paste HL7 Data');
INSERT INTO `lang_constants` VALUES (2112, 'Paste the data to import into the text area below:');
INSERT INTO `lang_constants` VALUES (2113, 'Patch');
INSERT INTO `lang_constants` VALUES (2114, 'Patient');
INSERT INTO `lang_constants` VALUES (2115, 'patient');
INSERT INTO `lang_constants` VALUES (2116, 'PATIENT');
INSERT INTO `lang_constants` VALUES (2117, 'Patient Allergies');
INSERT INTO `lang_constants` VALUES (2118, 'Patient allergies');
INSERT INTO `lang_constants` VALUES (2119, 'Patient Appointment');
INSERT INTO `lang_constants` VALUES (2120, 'Patient chart ID');
INSERT INTO `lang_constants` VALUES (2121, 'Patient Checkout');
INSERT INTO `lang_constants` VALUES (2122, 'Patient Checkout for ');
INSERT INTO `lang_constants` VALUES (2123, 'Patient Communication sent');
INSERT INTO `lang_constants` VALUES (2124, 'Patient Comunication Sent');
INSERT INTO `lang_constants` VALUES (2125, 'Patient Data');
INSERT INTO `lang_constants` VALUES (2126, 'Patient Document');
INSERT INTO `lang_constants` VALUES (2127, 'Patient Encounter');
INSERT INTO `lang_constants` VALUES (2128, 'Patient Encounter Form');
INSERT INTO `lang_constants` VALUES (2129, 'Patient Encounters');
INSERT INTO `lang_constants` VALUES (2130, 'Patient Finder');
INSERT INTO `lang_constants` VALUES (2131, 'Patient History');
INSERT INTO `lang_constants` VALUES (2132, 'Patient History / Lifestyle');
INSERT INTO `lang_constants` VALUES (2133, 'Patient ID');
INSERT INTO `lang_constants` VALUES (2134, 'Patient ID card');
INSERT INTO `lang_constants` VALUES (2135, 'Patient Immunization');
INSERT INTO `lang_constants` VALUES (2136, 'Patient Information');
INSERT INTO `lang_constants` VALUES (2137, 'Patient Insurance Distribution');
INSERT INTO `lang_constants` VALUES (2138, 'Patient Insurance Distribution Report');
INSERT INTO `lang_constants` VALUES (2139, 'Patient Issues');
INSERT INTO `lang_constants` VALUES (2140, 'Patient List');
INSERT INTO `lang_constants` VALUES (2141, 'Patient Medical Problems');
INSERT INTO `lang_constants` VALUES (2142, 'Patient Medications');
INSERT INTO `lang_constants` VALUES (2143, 'Patient Name & Address');
INSERT INTO `lang_constants` VALUES (2144, 'Patient Note Types');
INSERT INTO `lang_constants` VALUES (2145, 'Patient Notes');
INSERT INTO `lang_constants` VALUES (2146, 'Patient Notes (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (2147, 'Patient Number');
INSERT INTO `lang_constants` VALUES (2148, 'Patient Printed Report');
INSERT INTO `lang_constants` VALUES (2149, 'Patient Record Report');
INSERT INTO `lang_constants` VALUES (2150, 'Patient Report');
INSERT INTO `lang_constants` VALUES (2151, 'Patient Request');
INSERT INTO `lang_constants` VALUES (2152, 'Patient Summary');
INSERT INTO `lang_constants` VALUES (2153, 'Patient Transactions');
INSERT INTO `lang_constants` VALUES (2154, 'patient(s) in the database that match the demographic information you have entered.');
INSERT INTO `lang_constants` VALUES (2155, 'Patient/Client');
INSERT INTO `lang_constants` VALUES (2156, 'Patient:');
INSERT INTO `lang_constants` VALUES (2157, 'Patients');
INSERT INTO `lang_constants` VALUES (2158, 'Pay');
INSERT INTO `lang_constants` VALUES (2159, 'Pay attention to the \"Done with\" checkboxes.  After the insurances are marked complete then we will start asking the patient to pay the remaining balance; if you fail to mark all of the insurances complete then the remaining amount will not be collected!  Also if there is a balance that the patient should pay, then set the due date appropriately, as this will affect the language that appears on patient statements.');
INSERT INTO `lang_constants` VALUES (2160, 'Pay Date:');
INSERT INTO `lang_constants` VALUES (2161, 'Payer');
INSERT INTO `lang_constants` VALUES (2162, 'Payer Type');
INSERT INTO `lang_constants` VALUES (2163, 'Paying');
INSERT INTO `lang_constants` VALUES (2164, 'Payment');
INSERT INTO `lang_constants` VALUES (2165, 'payment');
INSERT INTO `lang_constants` VALUES (2166, 'Payment Date');
INSERT INTO `lang_constants` VALUES (2167, 'payment entered on');
INSERT INTO `lang_constants` VALUES (2168, 'Payment Method');
INSERT INTO `lang_constants` VALUES (2169, 'Payment value for code ');
INSERT INTO `lang_constants` VALUES (2170, 'Payments');
INSERT INTO `lang_constants` VALUES (2171, 'PDF');
INSERT INTO `lang_constants` VALUES (2172, 'Pelvis and buttock');
INSERT INTO `lang_constants` VALUES (2173, 'Pemphigus');
INSERT INTO `lang_constants` VALUES (2174, 'Pending');
INSERT INTO `lang_constants` VALUES (2175, 'Pending followup');
INSERT INTO `lang_constants` VALUES (2176, 'Pennington Firm OpenEMR  v');
INSERT INTO `lang_constants` VALUES (2177, 'Peptic Ulcer Disease');
INSERT INTO `lang_constants` VALUES (2178, 'per min');
INSERT INTO `lang_constants` VALUES (2179, 'Per Nostril');
INSERT INTO `lang_constants` VALUES (2180, 'per nostril');
INSERT INTO `lang_constants` VALUES (2181, 'Per Oris');
INSERT INTO `lang_constants` VALUES (2182, 'per oris');
INSERT INTO `lang_constants` VALUES (2183, 'Per Rectum');
INSERT INTO `lang_constants` VALUES (2184, 'per rectum');
INSERT INTO `lang_constants` VALUES (2185, 'Perforated Right:');
INSERT INTO `lang_constants` VALUES (2186, 'Perform Search');
INSERT INTO `lang_constants` VALUES (2187, 'Perform this action');
INSERT INTO `lang_constants` VALUES (2188, 'Peripheral');
INSERT INTO `lang_constants` VALUES (2189, 'Person');
INSERT INTO `lang_constants` VALUES (2190, 'Pharmacies');
INSERT INTO `lang_constants` VALUES (2191, 'Pharmacy');
INSERT INTO `lang_constants` VALUES (2192, 'Pharmacy Dispensary');
INSERT INTO `lang_constants` VALUES (2193, 'Pheumothorax');
INSERT INTO `lang_constants` VALUES (2194, 'Phone');
INSERT INTO `lang_constants` VALUES (2195, 'Phone call list');
INSERT INTO `lang_constants` VALUES (2196, 'Phone Number');
INSERT INTO `lang_constants` VALUES (2197, 'Photophobia');
INSERT INTO `lang_constants` VALUES (2198, 'PHP compressed');
INSERT INTO `lang_constants` VALUES (2199, 'PHP extracted');
INSERT INTO `lang_constants` VALUES (2200, 'php-GACL access controls are turned off');
INSERT INTO `lang_constants` VALUES (2201, 'PHP-gacl is not installed');
INSERT INTO `lang_constants` VALUES (2202, 'Physical Exam');
INSERT INTO `lang_constants` VALUES (2203, 'Physician Request');
INSERT INTO `lang_constants` VALUES (2204, 'Physician Signature');
INSERT INTO `lang_constants` VALUES (2205, 'Physicians');
INSERT INTO `lang_constants` VALUES (2206, 'pick');
INSERT INTO `lang_constants` VALUES (2207, 'PID');
INSERT INTO `lang_constants` VALUES (2208, 'PID (Pelvic Inflammatory Disease)');
INSERT INTO `lang_constants` VALUES (2209, 'Pill Size');
INSERT INTO `lang_constants` VALUES (2210, 'Pills');
INSERT INTO `lang_constants` VALUES (2211, 'Placeholder');
INSERT INTO `lang_constants` VALUES (2212, 'Placeholder (Maintains empty ACLs)');
INSERT INTO `lang_constants` VALUES (2213, 'Plain Text');
INSERT INTO `lang_constants` VALUES (2214, 'Plan');
INSERT INTO `lang_constants` VALUES (2215, 'Plan Name');
INSERT INTO `lang_constants` VALUES (2216, 'Plan:');
INSERT INTO `lang_constants` VALUES (2217, 'Player');
INSERT INTO `lang_constants` VALUES (2218, 'Playing Position');
INSERT INTO `lang_constants` VALUES (2219, 'Please choose a valid selection from the list.');
INSERT INTO `lang_constants` VALUES (2220, 'Please choose a valid selection.');
INSERT INTO `lang_constants` VALUES (2221, 'Please choose a value for');
INSERT INTO `lang_constants` VALUES (2222, 'Please close this window.');
INSERT INTO `lang_constants` VALUES (2223, 'Please compare the new name');
INSERT INTO `lang_constants` VALUES (2224, 'Please do not accept this prescription unless it was received via facimile.');
INSERT INTO `lang_constants` VALUES (2225, 'Please do NOT use your browsers stop or reload button while this page is running unless more than 10 minutes have elapsed, this will not cause the process to  stop on the server and will consume uneccesary resources.');
INSERT INTO `lang_constants` VALUES (2226, 'Please enter a monetary amount using only numbers and a decimal point.');
INSERT INTO `lang_constants` VALUES (2227, 'Please enter a title!');
INSERT INTO `lang_constants` VALUES (2228, 'Please note that this can take a very long time, up to several minutes, your web browser may not appear very active during this time but generating a bill is a  complicated process and your web browser is merely waiting for more information.');
INSERT INTO `lang_constants` VALUES (2229, 'Please Note: constants are case sensitive and any string is allowed.');
INSERT INTO `lang_constants` VALUES (2230, 'Please only use alphabetic characters');
INSERT INTO `lang_constants` VALUES (2231, 'Please only use alphabetic characters with no spaces');
INSERT INTO `lang_constants` VALUES (2232, 'Please pay this amount');
INSERT INTO `lang_constants` VALUES (2233, 'Please select an adjustment reason for code ');
INSERT INTO `lang_constants` VALUES (2234, 'Please select an event');
INSERT INTO `lang_constants` VALUES (2235, 'Please select the desired pages to copy or forward:');
INSERT INTO `lang_constants` VALUES (2236, 'PM');
INSERT INTO `lang_constants` VALUES (2237, 'Pmt Method');
INSERT INTO `lang_constants` VALUES (2238, 'PND');
INSERT INTO `lang_constants` VALUES (2239, 'Pneumococcal Conjugate 1');
INSERT INTO `lang_constants` VALUES (2240, 'Pneumococcal Conjugate 2');
INSERT INTO `lang_constants` VALUES (2241, 'Pneumococcal Conjugate 3');
INSERT INTO `lang_constants` VALUES (2242, 'Pneumococcal Conjugate 4');
INSERT INTO `lang_constants` VALUES (2243, 'Pneumonia Vaccination');
INSERT INTO `lang_constants` VALUES (2244, 'Point of Service (POS)');
INSERT INTO `lang_constants` VALUES (2245, 'Policy');
INSERT INTO `lang_constants` VALUES (2246, 'Policy Number');
INSERT INTO `lang_constants` VALUES (2247, 'Polydypsia');
INSERT INTO `lang_constants` VALUES (2248, 'Polyps');
INSERT INTO `lang_constants` VALUES (2249, 'Polyuria');
INSERT INTO `lang_constants` VALUES (2250, 'Poor Appetite');
INSERT INTO `lang_constants` VALUES (2251, 'Poor Circulation');
INSERT INTO `lang_constants` VALUES (2252, 'Poor Hearing');
INSERT INTO `lang_constants` VALUES (2253, 'Populate the year view with events?');
INSERT INTO `lang_constants` VALUES (2254, 'Popups');
INSERT INTO `lang_constants` VALUES (2255, 'Portuguese (Brazilian)');
INSERT INTO `lang_constants` VALUES (2256, 'Portuguese (European)');
INSERT INTO `lang_constants` VALUES (2257, 'POS Code');
INSERT INTO `lang_constants` VALUES (2258, 'Post Nasal Drip');
INSERT INTO `lang_constants` VALUES (2259, 'Post surgical');
INSERT INTO `lang_constants` VALUES (2260, 'Post to accounting and mark as billed');
INSERT INTO `lang_constants` VALUES (2261, 'Post-Abortion Care');
INSERT INTO `lang_constants` VALUES (2262, 'Post-Abortion Contraception');
INSERT INTO `lang_constants` VALUES (2263, 'Post-Abortion Counseling');
INSERT INTO `lang_constants` VALUES (2264, 'Post-Abortion Followup');
INSERT INTO `lang_constants` VALUES (2265, 'Postal');
INSERT INTO `lang_constants` VALUES (2266, 'Postal Code');
INSERT INTO `lang_constants` VALUES (2267, 'Postal code');
INSERT INTO `lang_constants` VALUES (2268, 'PostCalendar');
INSERT INTO `lang_constants` VALUES (2269, 'PostCalendar Administration');
INSERT INTO `lang_constants` VALUES (2270, 'PostCalendar Category Settings');
INSERT INTO `lang_constants` VALUES (2271, 'PostCalendar Global Settings');
INSERT INTO `lang_constants` VALUES (2272, 'Posted on');
INSERT INTO `lang_constants` VALUES (2273, 'Posting Date');
INSERT INTO `lang_constants` VALUES (2274, 'PPE + Prev Med/Surg Hx');
INSERT INTO `lang_constants` VALUES (2275, 'Practice');
INSERT INTO `lang_constants` VALUES (2276, 'Practice Settings');
INSERT INTO `lang_constants` VALUES (2277, 'Practitioner');
INSERT INTO `lang_constants` VALUES (2278, 'Pre-Abortion Consultation');
INSERT INTO `lang_constants` VALUES (2279, 'Pre-Abortion Counseling');
INSERT INTO `lang_constants` VALUES (2280, 'Pref Cat');
INSERT INTO `lang_constants` VALUES (2281, 'Preferred Event Category');
INSERT INTO `lang_constants` VALUES (2282, 'Preferred Language');
INSERT INTO `lang_constants` VALUES (2283, 'Preferred Pharmacy');
INSERT INTO `lang_constants` VALUES (2284, 'Preferred Provider Organization (PPO)');
INSERT INTO `lang_constants` VALUES (2285, 'Preg Test');
INSERT INTO `lang_constants` VALUES (2286, 'Prepay');
INSERT INTO `lang_constants` VALUES (2287, 'Prescription');
INSERT INTO `lang_constants` VALUES (2288, 'Prescription Label');
INSERT INTO `lang_constants` VALUES (2289, 'Prescriptions');
INSERT INTO `lang_constants` VALUES (2290, 'Prescriptions and Dispensations');
INSERT INTO `lang_constants` VALUES (2291, 'Prescriptions and other referrals');
INSERT INTO `lang_constants` VALUES (2292, 'Prescriptions and/or referrals by specialist');
INSERT INTO `lang_constants` VALUES (2293, 'Prescriptions Report');
INSERT INTO `lang_constants` VALUES (2294, 'Prescriptions/Referrals');
INSERT INTO `lang_constants` VALUES (2295, 'Presenting Complaint');
INSERT INTO `lang_constants` VALUES (2296, 'Press Continue to proceed');
INSERT INTO `lang_constants` VALUES (2297, 'Presumed Diagnosis');
INSERT INTO `lang_constants` VALUES (2298, 'Presumed diagnosis by specialist');
INSERT INTO `lang_constants` VALUES (2299, 'Prev');
INSERT INTO `lang_constants` VALUES (2300, 'Preview Event');
INSERT INTO `lang_constants` VALUES (2301, 'Previous');
INSERT INTO `lang_constants` VALUES (2302, 'Previous Consultations');
INSERT INTO `lang_constants` VALUES (2303, 'Previous Day');
INSERT INTO `lang_constants` VALUES (2304, 'Previous History/Screening');
INSERT INTO `lang_constants` VALUES (2305, 'Previous Month');
INSERT INTO `lang_constants` VALUES (2306, 'Previous Week');
INSERT INTO `lang_constants` VALUES (2307, 'Price');
INSERT INTO `lang_constants` VALUES (2308, 'Price Discounting');
INSERT INTO `lang_constants` VALUES (2309, 'Price Level');
INSERT INTO `lang_constants` VALUES (2310, 'Price Level:');
INSERT INTO `lang_constants` VALUES (2311, 'Prices');
INSERT INTO `lang_constants` VALUES (2312, 'Primary');
INSERT INTO `lang_constants` VALUES (2313, 'Primary Ins');
INSERT INTO `lang_constants` VALUES (2314, 'Primary Insurance');
INSERT INTO `lang_constants` VALUES (2315, 'Primary Insurance Data');
INSERT INTO `lang_constants` VALUES (2316, 'Primary Insurance Provider');
INSERT INTO `lang_constants` VALUES (2317, 'Primary Provider');
INSERT INTO `lang_constants` VALUES (2318, 'Print');
INSERT INTO `lang_constants` VALUES (2319, 'Print (HTML)');
INSERT INTO `lang_constants` VALUES (2320, 'Print (PDF)');
INSERT INTO `lang_constants` VALUES (2321, 'Print Any Encounter');
INSERT INTO `lang_constants` VALUES (2322, 'Print Blank Referral Form');
INSERT INTO `lang_constants` VALUES (2323, 'Print Format');
INSERT INTO `lang_constants` VALUES (2324, 'Print Four Panel');
INSERT INTO `lang_constants` VALUES (2325, 'Print Multiple');
INSERT INTO `lang_constants` VALUES (2326, 'Print Multiple To Fax');
INSERT INTO `lang_constants` VALUES (2327, 'Print name, sign and date.');
INSERT INTO `lang_constants` VALUES (2328, 'Print Notes');
INSERT INTO `lang_constants` VALUES (2329, 'Print Page 1');
INSERT INTO `lang_constants` VALUES (2330, 'Print Page 2');
INSERT INTO `lang_constants` VALUES (2331, 'Print Record');
INSERT INTO `lang_constants` VALUES (2332, 'Print Shot Record');
INSERT INTO `lang_constants` VALUES (2333, 'Print This Encounter');
INSERT INTO `lang_constants` VALUES (2334, 'Print this note');
INSERT INTO `lang_constants` VALUES (2335, 'Print This Note');
INSERT INTO `lang_constants` VALUES (2336, 'Print To Fax');
INSERT INTO `lang_constants` VALUES (2337, 'Print View');
INSERT INTO `lang_constants` VALUES (2338, 'printable');
INSERT INTO `lang_constants` VALUES (2339, 'Printable Version');
INSERT INTO `lang_constants` VALUES (2340, 'Printed');
INSERT INTO `lang_constants` VALUES (2341, 'Printing results:');
INSERT INTO `lang_constants` VALUES (2342, 'Printing skipped; see test output in ');
INSERT INTO `lang_constants` VALUES (2343, 'Prior Auth');
INSERT INTO `lang_constants` VALUES (2344, 'Prior Authorization Form');
INSERT INTO `lang_constants` VALUES (2345, 'Priority ');
INSERT INTO `lang_constants` VALUES (2346, 'Private');
INSERT INTO `lang_constants` VALUES (2347, 'Problem');
INSERT INTO `lang_constants` VALUES (2348, 'Problem List');
INSERT INTO `lang_constants` VALUES (2349, 'Problems/Issues');
INSERT INTO `lang_constants` VALUES (2350, 'Procedure');
INSERT INTO `lang_constants` VALUES (2351, 'Procedures');
INSERT INTO `lang_constants` VALUES (2352, 'Process');
INSERT INTO `lang_constants` VALUES (2353, 'Processing');
INSERT INTO `lang_constants` VALUES (2354, 'Products');
INSERT INTO `lang_constants` VALUES (2355, 'Prof.');
INSERT INTO `lang_constants` VALUES (2356, 'Progress Notes');
INSERT INTO `lang_constants` VALUES (2357, 'Prostate Cancer');
INSERT INTO `lang_constants` VALUES (2358, 'Prostate Exam');
INSERT INTO `lang_constants` VALUES (2359, 'Prostate Problems');
INSERT INTO `lang_constants` VALUES (2360, 'Prostate w/o enlrgmt, nodules, tender');
INSERT INTO `lang_constants` VALUES (2361, 'Provider');
INSERT INTO `lang_constants` VALUES (2362, 'Provider Number');
INSERT INTO `lang_constants` VALUES (2363, 'Provider:');
INSERT INTO `lang_constants` VALUES (2364, 'Providers');
INSERT INTO `lang_constants` VALUES (2365, 'Providers NPI');
INSERT INTO `lang_constants` VALUES (2366, 'Prv');
INSERT INTO `lang_constants` VALUES (2367, 'PSA');
INSERT INTO `lang_constants` VALUES (2368, 'Psoriasis');
INSERT INTO `lang_constants` VALUES (2369, 'Psych Diagnosis');
INSERT INTO `lang_constants` VALUES (2370, 'Psych Medication');
INSERT INTO `lang_constants` VALUES (2371, 'Psychiatric');
INSERT INTO `lang_constants` VALUES (2372, 'Psychiatric Brief Letter');
INSERT INTO `lang_constants` VALUES (2373, 'Psychiatric Diagnosis');
INSERT INTO `lang_constants` VALUES (2374, 'Psychiatric Examination');
INSERT INTO `lang_constants` VALUES (2375, 'Psychiatric History');
INSERT INTO `lang_constants` VALUES (2376, 'Psychiatric Intake');
INSERT INTO `lang_constants` VALUES (2377, 'Psychiatric Medication');
INSERT INTO `lang_constants` VALUES (2378, 'Pt %');
INSERT INTO `lang_constants` VALUES (2379, 'Pt Notes');
INSERT INTO `lang_constants` VALUES (2380, 'Pt Notes/Auth');
INSERT INTO `lang_constants` VALUES (2381, 'Pt overpaid');
INSERT INTO `lang_constants` VALUES (2382, 'Pt Paid');
INSERT INTO `lang_constants` VALUES (2383, 'Pt refund');
INSERT INTO `lang_constants` VALUES (2384, 'Pt released');
INSERT INTO `lang_constants` VALUES (2385, 'Pt Report');
INSERT INTO `lang_constants` VALUES (2386, 'PT Student, or leave blank');
INSERT INTO `lang_constants` VALUES (2387, 'PT_CITY');
INSERT INTO `lang_constants` VALUES (2388, 'PT_DOB');
INSERT INTO `lang_constants` VALUES (2389, 'PT_FNAME');
INSERT INTO `lang_constants` VALUES (2390, 'PT_LNAME');
INSERT INTO `lang_constants` VALUES (2391, 'PT_MNAME');
INSERT INTO `lang_constants` VALUES (2392, 'PT_POSTAL');
INSERT INTO `lang_constants` VALUES (2393, 'PT_STATE');
INSERT INTO `lang_constants` VALUES (2394, 'PT_STREET');
INSERT INTO `lang_constants` VALUES (2395, 'Public');
INSERT INTO `lang_constants` VALUES (2396, 'Pulmonary');
INSERT INTO `lang_constants` VALUES (2397, 'Pulse');
INSERT INTO `lang_constants` VALUES (2398, 'q.3h');
INSERT INTO `lang_constants` VALUES (2399, 'q.4h');
INSERT INTO `lang_constants` VALUES (2400, 'q.5h');
INSERT INTO `lang_constants` VALUES (2401, 'q.6h');
INSERT INTO `lang_constants` VALUES (2402, 'q.8h');
INSERT INTO `lang_constants` VALUES (2403, 'q.d.');
INSERT INTO `lang_constants` VALUES (2404, 'q.i.d.');
INSERT INTO `lang_constants` VALUES (2405, 'QOH');
INSERT INTO `lang_constants` VALUES (2406, 'Qty');
INSERT INTO `lang_constants` VALUES (2407, 'QTY');
INSERT INTO `lang_constants` VALUES (2408, 'Quality');
INSERT INTO `lang_constants` VALUES (2409, 'Quantity');
INSERT INTO `lang_constants` VALUES (2410, 'Quantity for NDC');
INSERT INTO `lang_constants` VALUES (2411, 'Quantity On Hand');
INSERT INTO `lang_constants` VALUES (2412, 'Queue for HCFA batch processing');
INSERT INTO `lang_constants` VALUES (2413, 'Queue for HCFA batch processing and printing');
INSERT INTO `lang_constants` VALUES (2414, 'Queue for UB-92 batch processing');
INSERT INTO `lang_constants` VALUES (2415, 'Queue for UB-92 batch processing and printing');
INSERT INTO `lang_constants` VALUES (2416, 'Queued');
INSERT INTO `lang_constants` VALUES (2417, 'Queued Events Administration');
INSERT INTO `lang_constants` VALUES (2418, 'Queued for');
INSERT INTO `lang_constants` VALUES (2419, 'Queued Submissions Administration');
INSERT INTO `lang_constants` VALUES (2420, 'R');
INSERT INTO `lang_constants` VALUES (2421, 'Race');
INSERT INTO `lang_constants` VALUES (2422, 'Race/Ethnicity');
INSERT INTO `lang_constants` VALUES (2423, 'Radio');
INSERT INTO `lang_constants` VALUES (2424, 'Radio buttons');
INSERT INTO `lang_constants` VALUES (2425, 'Rashes');
INSERT INTO `lang_constants` VALUES (2426, 'Rate');
INSERT INTO `lang_constants` VALUES (2427, 'Re-Open');
INSERT INTO `lang_constants` VALUES (2428, 'Re-opened');
INSERT INTO `lang_constants` VALUES (2429, 'Reactions');
INSERT INTO `lang_constants` VALUES (2430, 'Real Name');
INSERT INTO `lang_constants` VALUES (2431, 'Reason');
INSERT INTO `lang_constants` VALUES (2432, 'Reason for referral');
INSERT INTO `lang_constants` VALUES (2433, 'Reason for Visit');
INSERT INTO `lang_constants` VALUES (2434, 'Reason/Form');
INSERT INTO `lang_constants` VALUES (2435, 'Receipt');
INSERT INTO `lang_constants` VALUES (2436, 'Receipt for Payment');
INSERT INTO `lang_constants` VALUES (2437, 'Receipt Generated');
INSERT INTO `lang_constants` VALUES (2438, 'Receipts by Payment Method Report');
INSERT INTO `lang_constants` VALUES (2439, 'Receipts Summary');
INSERT INTO `lang_constants` VALUES (2440, 'Received');
INSERT INTO `lang_constants` VALUES (2441, 'Received By');
INSERT INTO `lang_constants` VALUES (2442, 'Received Faxes');
INSERT INTO `lang_constants` VALUES (2443, 'Receiver');
INSERT INTO `lang_constants` VALUES (2444, 'Receiver ID');
INSERT INTO `lang_constants` VALUES (2445, 'Receiver ID (ISA08)');
INSERT INTO `lang_constants` VALUES (2446, 'Receiver ID Qualifier (ISA07)');
INSERT INTO `lang_constants` VALUES (2447, 'Recommendations');
INSERT INTO `lang_constants` VALUES (2448, 'Recommendations and treatment');
INSERT INTO `lang_constants` VALUES (2449, 'Recommendations by specialist');
INSERT INTO `lang_constants` VALUES (2450, 'Record Payment');
INSERT INTO `lang_constants` VALUES (2451, 'records found.');
INSERT INTO `lang_constants` VALUES (2452, 'Rectal');
INSERT INTO `lang_constants` VALUES (2453, 'Rectal Exam');
INSERT INTO `lang_constants` VALUES (2454, 'rectally');
INSERT INTO `lang_constants` VALUES (2455, 'Redness');
INSERT INTO `lang_constants` VALUES (2456, 'reduced:');
INSERT INTO `lang_constants` VALUES (2457, 'Refer');
INSERT INTO `lang_constants` VALUES (2458, 'Refer By');
INSERT INTO `lang_constants` VALUES (2459, 'Refer Date');
INSERT INTO `lang_constants` VALUES (2460, 'Refer To');
INSERT INTO `lang_constants` VALUES (2461, 'Reference classification (risk level)');
INSERT INTO `lang_constants` VALUES (2462, 'Reference Reason');
INSERT INTO `lang_constants` VALUES (2463, 'Referer name and signature');
INSERT INTO `lang_constants` VALUES (2464, 'Referral');
INSERT INTO `lang_constants` VALUES (2465, 'Referral By');
INSERT INTO `lang_constants` VALUES (2466, 'Referral Card');
INSERT INTO `lang_constants` VALUES (2467, 'Referral Date');
INSERT INTO `lang_constants` VALUES (2468, 'Referral Form');
INSERT INTO `lang_constants` VALUES (2469, 'REFERRAL FORM');
INSERT INTO `lang_constants` VALUES (2470, 'Referral Source');
INSERT INTO `lang_constants` VALUES (2471, 'Referral To');
INSERT INTO `lang_constants` VALUES (2472, 'Referrals');
INSERT INTO `lang_constants` VALUES (2473, 'Referrals Report');
INSERT INTO `lang_constants` VALUES (2474, 'Referred by');
INSERT INTO `lang_constants` VALUES (2475, 'Referred By');
INSERT INTO `lang_constants` VALUES (2476, 'Referred to');
INSERT INTO `lang_constants` VALUES (2477, 'Referrer');
INSERT INTO `lang_constants` VALUES (2478, 'Referrer Diagnosis');
INSERT INTO `lang_constants` VALUES (2479, 'Referrer diagnosis');
INSERT INTO `lang_constants` VALUES (2480, 'Referring physician and practice');
INSERT INTO `lang_constants` VALUES (2481, 'Referring Provider');
INSERT INTO `lang_constants` VALUES (2482, 'Refills');
INSERT INTO `lang_constants` VALUES (2483, 'refills');
INSERT INTO `lang_constants` VALUES (2484, 'Reflexes normal');
INSERT INTO `lang_constants` VALUES (2485, 'Refresh');
INSERT INTO `lang_constants` VALUES (2486, 'reg_re');
INSERT INTO `lang_constants` VALUES (2487, 'register');
INSERT INTO `lang_constants` VALUES (2488, 'Registered');
INSERT INTO `lang_constants` VALUES (2489, 'registered');
INSERT INTO `lang_constants` VALUES (2490, 'Registration Date');
INSERT INTO `lang_constants` VALUES (2491, 'Registration Form');
INSERT INTO `lang_constants` VALUES (2492, 'Rehabilitation');
INSERT INTO `lang_constants` VALUES (2493, 'Relate To');
INSERT INTO `lang_constants` VALUES (2494, 'Related');
INSERT INTO `lang_constants` VALUES (2495, 'Relation(s) / Children');
INSERT INTO `lang_constants` VALUES (2496, 'Relationship');
INSERT INTO `lang_constants` VALUES (2497, 'Relatives');
INSERT INTO `lang_constants` VALUES (2498, 'Relay Health credentials are missing from this user account.');
INSERT INTO `lang_constants` VALUES (2499, 'Relay Health ID');
INSERT INTO `lang_constants` VALUES (2500, 'Religion');
INSERT INTO `lang_constants` VALUES (2501, 'Relogin');
INSERT INTO `lang_constants` VALUES (2502, 'Remove');
INSERT INTO `lang_constants` VALUES (2503, 'Remove Group');
INSERT INTO `lang_constants` VALUES (2504, 'Remove Group Form');
INSERT INTO `lang_constants` VALUES (2505, 'Renal Stones');
INSERT INTO `lang_constants` VALUES (2506, 'Rename Group');
INSERT INTO `lang_constants` VALUES (2507, 'Rendering');
INSERT INTO `lang_constants` VALUES (2508, 'Rendering Provider');
INSERT INTO `lang_constants` VALUES (2509, 'Rendering Provider Number');
INSERT INTO `lang_constants` VALUES (2510, 'Reorder At');
INSERT INTO `lang_constants` VALUES (2511, 'Repeating Info:');
INSERT INTO `lang_constants` VALUES (2512, 'Repeats');
INSERT INTO `lang_constants` VALUES (2513, 'Reply Date');
INSERT INTO `lang_constants` VALUES (2514, 'Reply From');
INSERT INTO `lang_constants` VALUES (2515, 'Report');
INSERT INTO `lang_constants` VALUES (2516, 'Report by');
INSERT INTO `lang_constants` VALUES (2517, 'Report Totals');
INSERT INTO `lang_constants` VALUES (2518, 'Reports');
INSERT INTO `lang_constants` VALUES (2519, 'Request ignored - claims processing is already running!');
INSERT INTO `lang_constants` VALUES (2520, 'Requested Service');
INSERT INTO `lang_constants` VALUES (2521, 'Required');
INSERT INTO `lang_constants` VALUES (2522, 'RESERVED');
INSERT INTO `lang_constants` VALUES (2523, 'Reserved');
INSERT INTO `lang_constants` VALUES (2524, 'Reserved for use to define Scheduled Vacation Time');
INSERT INTO `lang_constants` VALUES (2525, 'Reserved to define when a provider may not have available appointments after.');
INSERT INTO `lang_constants` VALUES (2526, 'Reserved to define when an event did not occur as specified.');
INSERT INTO `lang_constants` VALUES (2527, 'Reserved todefine when a provider may haveavailable appointments after.');
INSERT INTO `lang_constants` VALUES (2528, 'Resolved');
INSERT INTO `lang_constants` VALUES (2529, 'Respiration');
INSERT INTO `lang_constants` VALUES (2530, 'Respirator effort unlabored');
INSERT INTO `lang_constants` VALUES (2531, 'Respiratory');
INSERT INTO `lang_constants` VALUES (2532, 'Restricted Training');
INSERT INTO `lang_constants` VALUES (2533, 'Result');
INSERT INTO `lang_constants` VALUES (2534, 'Results Found For Search');
INSERT INTO `lang_constants` VALUES (2535, 'Retinal Exam');
INSERT INTO `lang_constants` VALUES (2536, 'Retracted Right:');
INSERT INTO `lang_constants` VALUES (2537, 'Return');
INSERT INTO `lang_constants` VALUES (2538, 'Return to calendar');
INSERT INTO `lang_constants` VALUES (2539, 'Return Value');
INSERT INTO `lang_constants` VALUES (2540, 'Return Visit');
INSERT INTO `lang_constants` VALUES (2541, 'Returned to Play');
INSERT INTO `lang_constants` VALUES (2542, 'Review of PMH:');
INSERT INTO `lang_constants` VALUES (2543, 'Review Of Systems');
INSERT INTO `lang_constants` VALUES (2544, 'Review of Systems Checks');
INSERT INTO `lang_constants` VALUES (2545, 'Revision');
INSERT INTO `lang_constants` VALUES (2546, 'Rheumotoid Arthritis');
INSERT INTO `lang_constants` VALUES (2547, 'Right');
INSERT INTO `lang_constants` VALUES (2548, 'Right Ear');
INSERT INTO `lang_constants` VALUES (2549, 'right ear');
INSERT INTO `lang_constants` VALUES (2550, 'Right:');
INSERT INTO `lang_constants` VALUES (2551, 'Ringing in Ears');
INSERT INTO `lang_constants` VALUES (2552, 'Ringing In Ears');
INSERT INTO `lang_constants` VALUES (2553, 'Risk Factors');
INSERT INTO `lang_constants` VALUES (2554, 'Risk Level');
INSERT INTO `lang_constants` VALUES (2555, 'RLL:');
INSERT INTO `lang_constants` VALUES (2556, 'ROM');
INSERT INTO `lang_constants` VALUES (2557, 'Roster');
INSERT INTO `lang_constants` VALUES (2558, 'Route');
INSERT INTO `lang_constants` VALUES (2559, 'Rows');
INSERT INTO `lang_constants` VALUES (2560, 'RRR without MOR');
INSERT INTO `lang_constants` VALUES (2561, 'Rub:');
INSERT INTO `lang_constants` VALUES (2562, 'Rubs:');
INSERT INTO `lang_constants` VALUES (2563, 'Running Command: ');
INSERT INTO `lang_constants` VALUES (2564, 'Rupture');
INSERT INTO `lang_constants` VALUES (2565, 'Russian');
INSERT INTO `lang_constants` VALUES (2566, 'Rx');
INSERT INTO `lang_constants` VALUES (2567, 'RX');
INSERT INTO `lang_constants` VALUES (2568, 'S');
INSERT INTO `lang_constants` VALUES (2569, 'S.S.');
INSERT INTO `lang_constants` VALUES (2570, 'S3:');
INSERT INTO `lang_constants` VALUES (2571, 'S4:');
INSERT INTO `lang_constants` VALUES (2572, 'SA  *  * To read the license please read the docs/license.txt or visit  * http://www.gnu.org/copyleft/gpl.html  *  */  //========================================================================= // ');
INSERT INTO `lang_constants` VALUES (2573, 'Sales');
INSERT INTO `lang_constants` VALUES (2574, 'Sales by Item');
INSERT INTO `lang_constants` VALUES (2575, 'Sales by Product Report');
INSERT INTO `lang_constants` VALUES (2576, 'Same Day');
INSERT INTO `lang_constants` VALUES (2577, 'Sample');
INSERT INTO `lang_constants` VALUES (2578, 'Sanction Type');
INSERT INTO `lang_constants` VALUES (2579, 'Sat');
INSERT INTO `lang_constants` VALUES (2580, 'Sat &amp; Sun');
INSERT INTO `lang_constants` VALUES (2581, 'Saturday');
INSERT INTO `lang_constants` VALUES (2582, 'Save');
INSERT INTO `lang_constants` VALUES (2583, 'Save and Dispense');
INSERT INTO `lang_constants` VALUES (2584, 'Save as New');
INSERT INTO `lang_constants` VALUES (2585, 'Save Changes');
INSERT INTO `lang_constants` VALUES (2586, 'Save Form');
INSERT INTO `lang_constants` VALUES (2587, 'Save Immunization');
INSERT INTO `lang_constants` VALUES (2588, 'Save New Field');
INSERT INTO `lang_constants` VALUES (2589, 'Save New Group');
INSERT INTO `lang_constants` VALUES (2590, 'Save New List');
INSERT INTO `lang_constants` VALUES (2591, 'Save new template');
INSERT INTO `lang_constants` VALUES (2592, 'Save Patient Demographics');
INSERT INTO `lang_constants` VALUES (2593, 'Save Successful for chart ID');
INSERT INTO `lang_constants` VALUES (2594, 'Save Transaction');
INSERT INTO `lang_constants` VALUES (2595, 'Scanned');
INSERT INTO `lang_constants` VALUES (2596, 'Scanned Encounter Note');
INSERT INTO `lang_constants` VALUES (2597, 'Scanner In');
INSERT INTO `lang_constants` VALUES (2598, 'Schedule');
INSERT INTO `lang_constants` VALUES (2599, 'Schedule Facilities:');
INSERT INTO `lang_constants` VALUES (2600, 'SCHOOL NOTE');
INSERT INTO `lang_constants` VALUES (2601, 'Scoliosis');
INSERT INTO `lang_constants` VALUES (2602, 'SE');
INSERT INTO `lang_constants` VALUES (2603, 'SE Address');
INSERT INTO `lang_constants` VALUES (2604, 'SE City');
INSERT INTO `lang_constants` VALUES (2605, 'SE Country');
INSERT INTO `lang_constants` VALUES (2606, 'SE Locality');
INSERT INTO `lang_constants` VALUES (2607, 'SE Postal Code');
INSERT INTO `lang_constants` VALUES (2608, 'SE State');
INSERT INTO `lang_constants` VALUES (2609, 'SE Zip Code');
INSERT INTO `lang_constants` VALUES (2610, 'Search');
INSERT INTO `lang_constants` VALUES (2611, 'search');
INSERT INTO `lang_constants` VALUES (2612, 'search again');
INSERT INTO `lang_constants` VALUES (2613, 'Search by:');
INSERT INTO `lang_constants` VALUES (2614, 'Search for:');
INSERT INTO `lang_constants` VALUES (2615, 'Search or Add Patient');
INSERT INTO `lang_constants` VALUES (2616, 'Search Results:');
INSERT INTO `lang_constants` VALUES (2617, 'Search Selected');
INSERT INTO `lang_constants` VALUES (2618, 'Search the Events');
INSERT INTO `lang_constants` VALUES (2619, 'Search/Add Insurer');
INSERT INTO `lang_constants` VALUES (2620, 'Searching for appointments');
INSERT INTO `lang_constants` VALUES (2621, 'Searching...');
INSERT INTO `lang_constants` VALUES (2622, 'Seatbelt use');
INSERT INTO `lang_constants` VALUES (2623, 'Seatbelt Use');
INSERT INTO `lang_constants` VALUES (2624, 'Second');
INSERT INTO `lang_constants` VALUES (2625, 'Secondary');
INSERT INTO `lang_constants` VALUES (2626, 'Secondary Insurance');
INSERT INTO `lang_constants` VALUES (2627, 'Secondary Insurance Data');
INSERT INTO `lang_constants` VALUES (2628, 'Secondary Insurance Provider');
INSERT INTO `lang_constants` VALUES (2629, 'See All');
INSERT INTO `lang_constants` VALUES (2630, 'See Authorizations');
INSERT INTO `lang_constants` VALUES (2631, 'See Growth-Chart');
INSERT INTO `lang_constants` VALUES (2632, 'See messages from the last set of generated claims');
INSERT INTO `lang_constants` VALUES (2633, 'Seen since');
INSERT INTO `lang_constants` VALUES (2634, 'Seizures');
INSERT INTO `lang_constants` VALUES (2635, 'Sel');
INSERT INTO `lang_constants` VALUES (2636, 'Select');
INSERT INTO `lang_constants` VALUES (2637, 'Select All');
INSERT INTO `lang_constants` VALUES (2638, 'Select CAMOS Entries for Printing');
INSERT INTO `lang_constants` VALUES (2639, 'Select field');
INSERT INTO `lang_constants` VALUES (2640, 'Select Fields');
INSERT INTO `lang_constants` VALUES (2641, 'Select for printing');
INSERT INTO `lang_constants` VALUES (2642, 'Select Issue');
INSERT INTO `lang_constants` VALUES (2643, 'Select the configuration items to export');
INSERT INTO `lang_constants` VALUES (2644, 'Select Yes to confirm group deletion');
INSERT INTO `lang_constants` VALUES (2645, 'Self');
INSERT INTO `lang_constants` VALUES (2646, 'Self Pay');
INSERT INTO `lang_constants` VALUES (2647, 'Send in progress');
INSERT INTO `lang_constants` VALUES (2648, 'Send this file');
INSERT INTO `lang_constants` VALUES (2649, 'Sender');
INSERT INTO `lang_constants` VALUES (2650, 'Sender ID');
INSERT INTO `lang_constants` VALUES (2651, 'Sender ID (ISA06)');
INSERT INTO `lang_constants` VALUES (2652, 'Sender ID Qualifier (ISA05)');
INSERT INTO `lang_constants` VALUES (2653, 'Sensitivities');
INSERT INTO `lang_constants` VALUES (2654, 'Sensitivity:');
INSERT INTO `lang_constants` VALUES (2655, 'Sensory exam normal');
INSERT INTO `lang_constants` VALUES (2656, 'Sent successfully');
INSERT INTO `lang_constants` VALUES (2657, 'sent to printer.');
INSERT INTO `lang_constants` VALUES (2658, 'Separated');
INSERT INTO `lang_constants` VALUES (2659, 'September');
INSERT INTO `lang_constants` VALUES (2660, 'Service Category');
INSERT INTO `lang_constants` VALUES (2661, 'Service Date');
INSERT INTO `lang_constants` VALUES (2662, 'Service Date:');
INSERT INTO `lang_constants` VALUES (2663, 'Service Location');
INSERT INTO `lang_constants` VALUES (2664, 'Service provided by specialist');
INSERT INTO `lang_constants` VALUES (2665, 'Services');
INSERT INTO `lang_constants` VALUES (2666, 'Services by Category');
INSERT INTO `lang_constants` VALUES (2667, 'Services provided');
INSERT INTO `lang_constants` VALUES (2668, 'Services Provided');
INSERT INTO `lang_constants` VALUES (2669, 'Settings');
INSERT INTO `lang_constants` VALUES (2670, 'Severe Migraine');
INSERT INTO `lang_constants` VALUES (2671, 'Severity of Pain');
INSERT INTO `lang_constants` VALUES (2672, 'Severity of Pain:');
INSERT INTO `lang_constants` VALUES (2673, 'Sex');
INSERT INTO `lang_constants` VALUES (2674, 'Sexually Transmitted Disease');
INSERT INTO `lang_constants` VALUES (2675, 'Sharing');
INSERT INTO `lang_constants` VALUES (2676, 'Shortness of Breath');
INSERT INTO `lang_constants` VALUES (2677, 'Shortness Of Breath');
INSERT INTO `lang_constants` VALUES (2678, 'Shortness Of Breath 2');
INSERT INTO `lang_constants` VALUES (2679, 'Shot Record');
INSERT INTO `lang_constants` VALUES (2680, 'Shot Record as of:');
INSERT INTO `lang_constants` VALUES (2681, 'should be like nnnnn-nnnn-nn');
INSERT INTO `lang_constants` VALUES (2682, 'Shoulder');
INSERT INTO `lang_constants` VALUES (2683, 'Shoulder + clavicle');
INSERT INTO `lang_constants` VALUES (2684, 'Shoulder Problems');
INSERT INTO `lang_constants` VALUES (2685, 'Show');
INSERT INTO `lang_constants` VALUES (2686, 'Show as Busy');
INSERT INTO `lang_constants` VALUES (2687, 'Show Authorized Only');
INSERT INTO `lang_constants` VALUES (2688, 'Show Details');
INSERT INTO `lang_constants` VALUES (2689, 'Show hovering event text on mouseover?');
INSERT INTO `lang_constants` VALUES (2690, 'Show how many events on admin pages?');
INSERT INTO `lang_constants` VALUES (2691, 'Show Patient Notes');
INSERT INTO `lang_constants` VALUES (2692, 'Show Report');
INSERT INTO `lang_constants` VALUES (2693, 'Show search/submit links in block?');
INSERT INTO `lang_constants` VALUES (2694, 'Show Unbilled Only');
INSERT INTO `lang_constants` VALUES (2695, 'Siblings');
INSERT INTO `lang_constants` VALUES (2696, 'Sickle Cell');
INSERT INTO `lang_constants` VALUES (2697, 'Sig');
INSERT INTO `lang_constants` VALUES (2698, 'Sigmoid/Colonoscopy');
INSERT INTO `lang_constants` VALUES (2699, 'Signature');
INSERT INTO `lang_constants` VALUES (2700, 'Signature:');
INSERT INTO `lang_constants` VALUES (2701, 'Signed Rx');
INSERT INTO `lang_constants` VALUES (2702, 'Significant Swelling:');
INSERT INTO `lang_constants` VALUES (2703, 'Since');
INSERT INTO `lang_constants` VALUES (2704, 'Sincerely,');
INSERT INTO `lang_constants` VALUES (2705, 'Single');
INSERT INTO `lang_constants` VALUES (2706, 'Sinus Problems');
INSERT INTO `lang_constants` VALUES (2707, 'Sinus Surgery');
INSERT INTO `lang_constants` VALUES (2708, 'SINUS TENDERNESS:');
INSERT INTO `lang_constants` VALUES (2709, 'Sinusitis');
INSERT INTO `lang_constants` VALUES (2710, 'Size');
INSERT INTO `lang_constants` VALUES (2711, 'Size must be a number between 1 and 999');
INSERT INTO `lang_constants` VALUES (2712, 'Size/List');
INSERT INTO `lang_constants` VALUES (2713, 'Skin');
INSERT INTO `lang_constants` VALUES (2714, 'Skin Cancer');
INSERT INTO `lang_constants` VALUES (2715, 'Skin Disease');
INSERT INTO `lang_constants` VALUES (2716, 'Skin Other');
INSERT INTO `lang_constants` VALUES (2717, 'Skipping SQL-Ledger dump - not implemented for Windows server');
INSERT INTO `lang_constants` VALUES (2718, 'Sleep patterns');
INSERT INTO `lang_constants` VALUES (2719, 'Sleep Patterns');
INSERT INTO `lang_constants` VALUES (2720, 'Sleeping');
INSERT INTO `lang_constants` VALUES (2721, 'Slovak');
INSERT INTO `lang_constants` VALUES (2722, 'Sm debt w/o');
INSERT INTO `lang_constants` VALUES (2723, 'Smarty Cache has been cleared');
INSERT INTO `lang_constants` VALUES (2724, 'SMS Gateway');
INSERT INTO `lang_constants` VALUES (2725, 'SMS Gateway API key');
INSERT INTO `lang_constants` VALUES (2726, 'SMS Notification');
INSERT INTO `lang_constants` VALUES (2727, 'SMS send before');
INSERT INTO `lang_constants` VALUES (2728, 'SMS Text, Usable Tag: ***NAME***, ***PROVIDER***, ***DATE***, ***STARTTIME***, ***ENDTIME***<br> i.e. Dear ***NAME***');
INSERT INTO `lang_constants` VALUES (2729, 'SMS/Email Alert Settings');
INSERT INTO `lang_constants` VALUES (2730, 'Snoring');
INSERT INTO `lang_constants` VALUES (2731, 'SOAP');
INSERT INTO `lang_constants` VALUES (2732, 'Social Difficulties');
INSERT INTO `lang_constants` VALUES (2733, 'Social History:');
INSERT INTO `lang_constants` VALUES (2734, 'Social Security Number');
INSERT INTO `lang_constants` VALUES (2735, 'solution');
INSERT INTO `lang_constants` VALUES (2736, 'Somatic Context');
INSERT INTO `lang_constants` VALUES (2737, 'Some authorizations were not displayed. Click here to view all');
INSERT INTO `lang_constants` VALUES (2738, 'Some codes were not displayed.');
INSERT INTO `lang_constants` VALUES (2739, 'Some encounters were not displayed. Click here to view all.');
INSERT INTO `lang_constants` VALUES (2740, 'Some notes were not displayed.');
INSERT INTO `lang_constants` VALUES (2741, 'some words');
INSERT INTO `lang_constants` VALUES (2742, 'Sore Throat');
INSERT INTO `lang_constants` VALUES (2743, 'Sort by');
INSERT INTO `lang_constants` VALUES (2744, 'Sort by Comments');
INSERT INTO `lang_constants` VALUES (2745, 'Sort by date');
INSERT INTO `lang_constants` VALUES (2746, 'Sort by date/time');
INSERT INTO `lang_constants` VALUES (2747, 'Sort by Event');
INSERT INTO `lang_constants` VALUES (2748, 'Sort by Group');
INSERT INTO `lang_constants` VALUES (2749, 'Sort by User');
INSERT INTO `lang_constants` VALUES (2750, 'Sort by vaccine');
INSERT INTO `lang_constants` VALUES (2751, 'Source');
INSERT INTO `lang_constants` VALUES (2752, 'Source is missing for code ');
INSERT INTO `lang_constants` VALUES (2753, 'Source:');
INSERT INTO `lang_constants` VALUES (2754, 'Spanish');
INSERT INTO `lang_constants` VALUES (2755, 'Specialist name and signature');
INSERT INTO `lang_constants` VALUES (2756, 'Specialty');
INSERT INTO `lang_constants` VALUES (2757, 'Specialty Systems');
INSERT INTO `lang_constants` VALUES (2758, 'Specialty:');
INSERT INTO `lang_constants` VALUES (2759, 'Specific');
INSERT INTO `lang_constants` VALUES (2760, 'Specific Service');
INSERT INTO `lang_constants` VALUES (2761, 'Speech Dictation');
INSERT INTO `lang_constants` VALUES (2762, 'Spermicides');
INSERT INTO `lang_constants` VALUES (2763, 'Splenectomy');
INSERT INTO `lang_constants` VALUES (2764, 'Spouse');
INSERT INTO `lang_constants` VALUES (2765, 'Sputum');
INSERT INTO `lang_constants` VALUES (2766, 'Sputum:');
INSERT INTO `lang_constants` VALUES (2767, 'SQ');
INSERT INTO `lang_constants` VALUES (2768, 'Squad');
INSERT INTO `lang_constants` VALUES (2769, 'Squad Membership');
INSERT INTO `lang_constants` VALUES (2770, 'Squads');
INSERT INTO `lang_constants` VALUES (2771, 'SRH');
INSERT INTO `lang_constants` VALUES (2772, 'SRH - Family Planning');
INSERT INTO `lang_constants` VALUES (2773, 'SRH Non Family Planning');
INSERT INTO `lang_constants` VALUES (2774, 'SRH Referrals');
INSERT INTO `lang_constants` VALUES (2775, 'SRH Visit Form');
INSERT INTO `lang_constants` VALUES (2776, 'SS');
INSERT INTO `lang_constants` VALUES (2777, 'SSN');
INSERT INTO `lang_constants` VALUES (2778, 'Stability');
INSERT INTO `lang_constants` VALUES (2779, 'Standard');
INSERT INTO `lang_constants` VALUES (2780, 'Start');
INSERT INTO `lang_constants` VALUES (2781, 'Start (yyyy-mm-dd): ');
INSERT INTO `lang_constants` VALUES (2782, 'Start Date');
INSERT INTO `lang_constants` VALUES (2783, 'Start Date at This Clinic');
INSERT INTO `lang_constants` VALUES (2784, 'Start Date:');
INSERT INTO `lang_constants` VALUES (2785, 'Start date:');
INSERT INTO `lang_constants` VALUES (2786, 'Start Time');
INSERT INTO `lang_constants` VALUES (2787, 'Starting Date');
INSERT INTO `lang_constants` VALUES (2788, 'stat');
INSERT INTO `lang_constants` VALUES (2789, 'State');
INSERT INTO `lang_constants` VALUES (2790, 'State List (write,addonly optional)');
INSERT INTO `lang_constants` VALUES (2791, 'State/Locality');
INSERT INTO `lang_constants` VALUES (2792, 'State/Parish');
INSERT INTO `lang_constants` VALUES (2793, 'Statistics');
INSERT INTO `lang_constants` VALUES (2794, 'Stats');
INSERT INTO `lang_constants` VALUES (2795, 'Status');
INSERT INTO `lang_constants` VALUES (2796, 'Status quo');
INSERT INTO `lang_constants` VALUES (2797, 'STD/AIDS Couns');
INSERT INTO `lang_constants` VALUES (2798, 'Stength and Conditioning');
INSERT INTO `lang_constants` VALUES (2799, 'Stiff Joints');
INSERT INTO `lang_constants` VALUES (2800, 'Stiffness');
INSERT INTO `lang_constants` VALUES (2801, 'Stomach Pains');
INSERT INTO `lang_constants` VALUES (2802, 'Strain of muscle');
INSERT INTO `lang_constants` VALUES (2803, 'Stream');
INSERT INTO `lang_constants` VALUES (2804, 'Street');
INSERT INTO `lang_constants` VALUES (2805, 'Street Address');
INSERT INTO `lang_constants` VALUES (2806, 'Street and Number');
INSERT INTO `lang_constants` VALUES (2807, 'Strength');
INSERT INTO `lang_constants` VALUES (2808, 'Strep Throat');
INSERT INTO `lang_constants` VALUES (2809, 'Stress fracture');
INSERT INTO `lang_constants` VALUES (2810, 'Stress Test');
INSERT INTO `lang_constants` VALUES (2811, 'Stroke');
INSERT INTO `lang_constants` VALUES (2812, 'Sub-category');
INSERT INTO `lang_constants` VALUES (2813, 'Sub-Total');
INSERT INTO `lang_constants` VALUES (2814, 'Subcategory');
INSERT INTO `lang_constants` VALUES (2815, 'subcategory');
INSERT INTO `lang_constants` VALUES (2816, 'subcutaneously');
INSERT INTO `lang_constants` VALUES (2817, 'Subjective');
INSERT INTO `lang_constants` VALUES (2818, 'Sublingual');
INSERT INTO `lang_constants` VALUES (2819, 'sublingual');
INSERT INTO `lang_constants` VALUES (2820, 'Submit');
INSERT INTO `lang_constants` VALUES (2821, 'Submit All Content');
INSERT INTO `lang_constants` VALUES (2822, 'Submit Event');
INSERT INTO `lang_constants` VALUES (2823, 'submit form');
INSERT INTO `lang_constants` VALUES (2824, 'Submit Selected Content');
INSERT INTO `lang_constants` VALUES (2825, 'submitted');
INSERT INTO `lang_constants` VALUES (2826, 'Submitted by');
INSERT INTO `lang_constants` VALUES (2827, 'Submitter EDI Access Number (PER06)');
INSERT INTO `lang_constants` VALUES (2828, 'Subscriber');
INSERT INTO `lang_constants` VALUES (2829, 'Subscriber Address');
INSERT INTO `lang_constants` VALUES (2830, 'Subscriber Employer');
INSERT INTO `lang_constants` VALUES (2831, 'Subscriber Employer (SE)');
INSERT INTO `lang_constants` VALUES (2832, 'Subscriber Employer Address');
INSERT INTO `lang_constants` VALUES (2833, 'Subscriber Employer City');
INSERT INTO `lang_constants` VALUES (2834, 'Subscriber Employer Country');
INSERT INTO `lang_constants` VALUES (2835, 'Subscriber Employer State');
INSERT INTO `lang_constants` VALUES (2836, 'Subscriber Employer Zip Code');
INSERT INTO `lang_constants` VALUES (2837, 'Subscriber Phone');
INSERT INTO `lang_constants` VALUES (2838, 'Subscriber Relationship');
INSERT INTO `lang_constants` VALUES (2839, 'Subscriber relationship is not self but name is the same! Is this really OK?');
INSERT INTO `lang_constants` VALUES (2840, 'Subscriber relationship is not self but SS number is the same!');
INSERT INTO `lang_constants` VALUES (2841, 'Subscriber relationship is self but name is different! Is this really OK?');
INSERT INTO `lang_constants` VALUES (2842, 'Subscriber relationship is self but SS number is different!');
INSERT INTO `lang_constants` VALUES (2843, 'Subscriber Sex');
INSERT INTO `lang_constants` VALUES (2844, 'Substitution');
INSERT INTO `lang_constants` VALUES (2845, 'substitution allowed');
INSERT INTO `lang_constants` VALUES (2846, 'success');
INSERT INTO `lang_constants` VALUES (2847, 'successfully added to category,');
INSERT INTO `lang_constants` VALUES (2848, 'successfully stored.');
INSERT INTO `lang_constants` VALUES (2849, 'successfully.');
INSERT INTO `lang_constants` VALUES (2850, 'Suicide');
INSERT INTO `lang_constants` VALUES (2851, 'Summary');
INSERT INTO `lang_constants` VALUES (2852, 'Sun');
INSERT INTO `lang_constants` VALUES (2853, 'Sunday');
INSERT INTO `lang_constants` VALUES (2854, 'Superbill');
INSERT INTO `lang_constants` VALUES (2855, 'Superbill Codes');
INSERT INTO `lang_constants` VALUES (2856, 'Superbill Codes Administration');
INSERT INTO `lang_constants` VALUES (2857, 'Superbill Report');
INSERT INTO `lang_constants` VALUES (2858, 'Superbills, sometimes referred to as Encounter Forms or Routing Slips, are an essential part of most medical practices.');
INSERT INTO `lang_constants` VALUES (2859, 'Superuser');
INSERT INTO `lang_constants` VALUES (2860, 'Supervising');
INSERT INTO `lang_constants` VALUES (2861, 'Surface Type');
INSERT INTO `lang_constants` VALUES (2862, 'Surgeries');
INSERT INTO `lang_constants` VALUES (2863, 'Surgery');
INSERT INTO `lang_constants` VALUES (2864, 'Suspended');
INSERT INTO `lang_constants` VALUES (2865, 'suspension');
INSERT INTO `lang_constants` VALUES (2866, 'Svc Date');
INSERT INTO `lang_constants` VALUES (2867, 'Svc Date:');
INSERT INTO `lang_constants` VALUES (2868, 'Sweating:');
INSERT INTO `lang_constants` VALUES (2869, 'Swedish');
INSERT INTO `lang_constants` VALUES (2870, 'Swelling');
INSERT INTO `lang_constants` VALUES (2871, 'Swelling Right');
INSERT INTO `lang_constants` VALUES (2872, 'Swollen Joints');
INSERT INTO `lang_constants` VALUES (2873, 'Swollen Lymph Nodes');
INSERT INTO `lang_constants` VALUES (2874, 'Symptoms');
INSERT INTO `lang_constants` VALUES (2875, 'Syncope');
INSERT INTO `lang_constants` VALUES (2876, 'Synovitis, impingement, bursitis');
INSERT INTO `lang_constants` VALUES (2877, 'System');
INSERT INTO `lang_constants` VALUES (2878, 'T');
INSERT INTO `lang_constants` VALUES (2879, 't.i.d.');
INSERT INTO `lang_constants` VALUES (2880, 'T.V.');
INSERT INTO `lang_constants` VALUES (2881, 'Table creation failed');
INSERT INTO `lang_constants` VALUES (2882, 'Table update failed');
INSERT INTO `lang_constants` VALUES (2883, 'tablet');
INSERT INTO `lang_constants` VALUES (2884, 'Take');
INSERT INTO `lang_constants` VALUES (2885, 'Takes long');
INSERT INTO `lang_constants` VALUES (2886, 'Tax Rate');
INSERT INTO `lang_constants` VALUES (2887, 'Taxes');
INSERT INTO `lang_constants` VALUES (2888, 'Taxonomy');
INSERT INTO `lang_constants` VALUES (2889, 'Td');
INSERT INTO `lang_constants` VALUES (2890, 'Team Injury Overview');
INSERT INTO `lang_constants` VALUES (2891, 'Team Roster');
INSERT INTO `lang_constants` VALUES (2892, 'Team Roster View');
INSERT INTO `lang_constants` VALUES (2893, 'Tel');
INSERT INTO `lang_constants` VALUES (2894, 'Temp');
INSERT INTO `lang_constants` VALUES (2895, 'Temp Location');
INSERT INTO `lang_constants` VALUES (2896, 'Temp Method');
INSERT INTO `lang_constants` VALUES (2897, 'Temperature');
INSERT INTO `lang_constants` VALUES (2898, 'Template');
INSERT INTO `lang_constants` VALUES (2899, 'Template Name');
INSERT INTO `lang_constants` VALUES (2900, 'Template names cannot start with numbers.');
INSERT INTO `lang_constants` VALUES (2901, 'Template:');
INSERT INTO `lang_constants` VALUES (2902, 'Templates');
INSERT INTO `lang_constants` VALUES (2903, 'Temporal Artery');
INSERT INTO `lang_constants` VALUES (2904, 'Tendon injury');
INSERT INTO `lang_constants` VALUES (2905, 'Tendonitis / osis / bursitis');
INSERT INTO `lang_constants` VALUES (2906, 'Tertiary');
INSERT INTO `lang_constants` VALUES (2907, 'Tertiary Insurance');
INSERT INTO `lang_constants` VALUES (2908, 'Tertiary Insurance Data');
INSERT INTO `lang_constants` VALUES (2909, 'Tertiary Insurance provider');
INSERT INTO `lang_constants` VALUES (2910, 'Test Scheduling');
INSERT INTO `lang_constants` VALUES (2911, 'Test System');
INSERT INTO `lang_constants` VALUES (2912, 'Text-date');
INSERT INTO `lang_constants` VALUES (2913, 'text-date');
INSERT INTO `lang_constants` VALUES (2914, 'Textarea');
INSERT INTO `lang_constants` VALUES (2915, 'textarea');
INSERT INTO `lang_constants` VALUES (2916, 'Textbox');
INSERT INTO `lang_constants` VALUES (2917, 'textbox');
INSERT INTO `lang_constants` VALUES (2918, 'Textbox list');
INSERT INTO `lang_constants` VALUES (2919, 'textbox list');
INSERT INTO `lang_constants` VALUES (2920, 'Thank You');
INSERT INTO `lang_constants` VALUES (2921, 'The claim file: ');
INSERT INTO `lang_constants` VALUES (2922, 'The destination form was closed; I cannot act on your selection.');
INSERT INTO `lang_constants` VALUES (2923, 'The event(s) have been approved.');
INSERT INTO `lang_constants` VALUES (2924, 'The event(s) have been hidden.');
INSERT INTO `lang_constants` VALUES (2925, 'The exported data appears in the text area below.  You can copy and paste this into an email or to any other desired destination.');
INSERT INTO `lang_constants` VALUES (2926, 'The following calendar event has been added:');
INSERT INTO `lang_constants` VALUES (2927, 'The following calendar event has been modifed:');
INSERT INTO `lang_constants` VALUES (2928, 'The following errors occurred');
INSERT INTO `lang_constants` VALUES (2929, 'The initial window is the invoice search page.  At the top you may enter a source (e.g. check number), pay date and check amount.  The reason for the source and pay date is so that you don\'t have to enter them over and over again for each claim.  The amount that you enter will be decreased for each invoice that is given part of the payment, and hopefully will end at zero when you are done.');
INSERT INTO `lang_constants` VALUES (2930, 'The label that appears to the user on the form');
INSERT INTO `lang_constants` VALUES (2931, 'The new category will be a sub-category of ');
INSERT INTO `lang_constants` VALUES (2932, 'The remaining information below applies only if you are posting manually, or if you are doing manual corrections.');
INSERT INTO `lang_constants` VALUES (2933, 'The requested document is not present at the expected location on the filesystem or there are not sufficient permissions to access it.');
INSERT INTO `lang_constants` VALUES (2934, 'The Source and Date columns are copied from the first page, so normally you will not need to touch those.  You can put a payment amount in the Pay column, an adjustment amount in the Adjust column, or both.  You can also click the \"W\" on the right to automatically compute an adjustment value that writes off the remainder of the charge for that line item.');
INSERT INTO `lang_constants` VALUES (2935, 'The translated label that will appear on the form in current language');
INSERT INTO `lang_constants` VALUES (2936, 'The translated Title that will appear in current language');
INSERT INTO `lang_constants` VALUES (2937, 'The translation of description in current language');
INSERT INTO `lang_constants` VALUES (2938, 'The X12 files as well as the resulting HTML output reports are archived in the \"era\" subdirectory of the main OpenEMR installation directory.  You will want to refer to these archives from time to time.  The URL is ');
INSERT INTO `lang_constants` VALUES (2939, 'Therapeutic Injections');
INSERT INTO `lang_constants` VALUES (2940, 'There are');
INSERT INTO `lang_constants` VALUES (2941, 'There are errors with your submission.  These are outlined below.');
INSERT INTO `lang_constants` VALUES (2942, 'There are no New Submissions');
INSERT INTO `lang_constants` VALUES (2943, 'There has been a mail error sending to');
INSERT INTO `lang_constants` VALUES (2944, 'There is already a category named');
INSERT INTO `lang_constants` VALUES (2945, 'There is already a subcategory named');
INSERT INTO `lang_constants` VALUES (2946, 'There is already an item named');
INSERT INTO `lang_constants` VALUES (2947, 'There is no COA entry for AR account ');
INSERT INTO `lang_constants` VALUES (2948, 'There is no COA entry for cash account ');
INSERT INTO `lang_constants` VALUES (2949, 'There is no COA entry for income account ');
INSERT INTO `lang_constants` VALUES (2950, 'There is no match for invoice id');
INSERT INTO `lang_constants` VALUES (2951, 'There is no match for invoice id = ');
INSERT INTO `lang_constants` VALUES (2952, 'There is no parts entry for services ID ');
INSERT INTO `lang_constants` VALUES (2953, 'There was an error while processing your request.');
INSERT INTO `lang_constants` VALUES (2954, 'Thickened Right:');
INSERT INTO `lang_constants` VALUES (2955, 'Thigh');
INSERT INTO `lang_constants` VALUES (2956, 'Thigh + hamstring');
INSERT INTO `lang_constants` VALUES (2957, 'Things that back office can read and enter but not modify');
INSERT INTO `lang_constants` VALUES (2958, 'Things that back office can read and modify');
INSERT INTO `lang_constants` VALUES (2959, 'Things that clinicians can read and enter but not modify');
INSERT INTO `lang_constants` VALUES (2960, 'Things that clinicians can read and modify');
INSERT INTO `lang_constants` VALUES (2961, 'Things that front office can read and enter but not modify');
INSERT INTO `lang_constants` VALUES (2962, 'Things that front office can read and modify');
INSERT INTO `lang_constants` VALUES (2963, 'Things that physicians can read and enter but not modify');
INSERT INTO `lang_constants` VALUES (2964, 'Things that physicians can read and modify');
INSERT INTO `lang_constants` VALUES (2965, 'Third');
INSERT INTO `lang_constants` VALUES (2966, 'This action cannot be undone.');
INSERT INTO `lang_constants` VALUES (2967, 'This action CANNOT be undone.');
INSERT INTO `lang_constants` VALUES (2968, 'This code type does not accept relations.');
INSERT INTO `lang_constants` VALUES (2969, 'This Encounter');
INSERT INTO `lang_constants` VALUES (2970, 'This feature is very experimental and not fully tested. Use at your own risk!');
INSERT INTO `lang_constants` VALUES (2971, 'This invoice number has been changed to ');
INSERT INTO `lang_constants` VALUES (2972, 'This module is in test mode. The database will not be changed.');
INSERT INTO `lang_constants` VALUES (2973, 'This module promotes efficient entry of EOB data.');
INSERT INTO `lang_constants` VALUES (2974, 'This page will inline include the login page, so that we do not have to click relogin every time.');
INSERT INTO `lang_constants` VALUES (2975, 'This patient has no activity.');
INSERT INTO `lang_constants` VALUES (2976, 'This patient ID is already in use!');
INSERT INTO `lang_constants` VALUES (2977, 'This user is not a member of any group');
INSERT INTO `lang_constants` VALUES (2978, 'This visit begins new contraceptive use');
INSERT INTO `lang_constants` VALUES (2979, 'This will create a backup in tar format and then send it to your web browser so you can save it');
INSERT INTO `lang_constants` VALUES (2980, 'Thoracic spine');
INSERT INTO `lang_constants` VALUES (2981, 'Throat');
INSERT INTO `lang_constants` VALUES (2982, 'Throat Cancer');
INSERT INTO `lang_constants` VALUES (2983, 'Throat Cancer Surgery');
INSERT INTO `lang_constants` VALUES (2984, 'Thrombosis/Stroke');
INSERT INTO `lang_constants` VALUES (2985, 'Thu');
INSERT INTO `lang_constants` VALUES (2986, 'Thurdsay');
INSERT INTO `lang_constants` VALUES (2987, 'Thursday');
INSERT INTO `lang_constants` VALUES (2988, 'Thyroid normal');
INSERT INTO `lang_constants` VALUES (2989, 'Thyroid Problems');
INSERT INTO `lang_constants` VALUES (2990, 'TIA');
INSERT INTO `lang_constants` VALUES (2991, 'Time');
INSERT INTO `lang_constants` VALUES (2992, 'Time Increment for Add (minutes 1-60)');
INSERT INTO `lang_constants` VALUES (2993, 'Timed event');
INSERT INTO `lang_constants` VALUES (2994, 'Times array (N/A)');
INSERT INTO `lang_constants` VALUES (2995, 'Timestamp and Text');
INSERT INTO `lang_constants` VALUES (2996, 'TIN');
INSERT INTO `lang_constants` VALUES (2997, 'Tinnitus');
INSERT INTO `lang_constants` VALUES (2998, 'Title');
INSERT INTO `lang_constants` VALUES (2999, 'Title V');
INSERT INTO `lang_constants` VALUES (3000, 'TitleCols must be a number between 1 and 999');
INSERT INTO `lang_constants` VALUES (3001, 'Titles');
INSERT INTO `lang_constants` VALUES (3002, 'TM\'S:');
INSERT INTO `lang_constants` VALUES (3003, 'TMs/EAMs/EE, ext nose');
INSERT INTO `lang_constants` VALUES (3004, 'To');
INSERT INTO `lang_constants` VALUES (3005, 'TO');
INSERT INTO `lang_constants` VALUES (3006, 'to');
INSERT INTO `lang_constants` VALUES (3007, 'To Affected Area');
INSERT INTO `lang_constants` VALUES (3008, 'to affected area');
INSERT INTO `lang_constants` VALUES (3009, 'To Billing View');
INSERT INTO `lang_constants` VALUES (3010, 'to category');
INSERT INTO `lang_constants` VALUES (3011, 'To Clinical View');
INSERT INTO `lang_constants` VALUES (3012, 'To copay');
INSERT INTO `lang_constants` VALUES (3013, 'To ded\'ble');
INSERT INTO `lang_constants` VALUES (3014, 'To Dems');
INSERT INTO `lang_constants` VALUES (3015, 'To Enctr');
INSERT INTO `lang_constants` VALUES (3016, 'To filter by sex');
INSERT INTO `lang_constants` VALUES (3017, 'To History');
INSERT INTO `lang_constants` VALUES (3018, 'To Issues');
INSERT INTO `lang_constants` VALUES (3019, 'To link this encounter/consult to an existing issue, click the desired issue above to highlight it and then click [Save]. Hold down [Ctrl] button to select multiple issues.');
INSERT INTO `lang_constants` VALUES (3020, 'to login again');
INSERT INTO `lang_constants` VALUES (3021, 'To Skin');
INSERT INTO `lang_constants` VALUES (3022, 'to skin');
INSERT INTO `lang_constants` VALUES (3023, 'to this visit?');
INSERT INTO `lang_constants` VALUES (3024, 'To:');
INSERT INTO `lang_constants` VALUES (3025, 'To: ');
INSERT INTO `lang_constants` VALUES (3026, 'TO_CITY');
INSERT INTO `lang_constants` VALUES (3027, 'TO_FAX');
INSERT INTO `lang_constants` VALUES (3028, 'TO_FNAME');
INSERT INTO `lang_constants` VALUES (3029, 'TO_LNAME');
INSERT INTO `lang_constants` VALUES (3030, 'TO_MNAME');
INSERT INTO `lang_constants` VALUES (3031, 'TO_ORGANIZATION');
INSERT INTO `lang_constants` VALUES (3032, 'TO_POSTAL');
INSERT INTO `lang_constants` VALUES (3033, 'TO_STATE');
INSERT INTO `lang_constants` VALUES (3034, 'TO_STREET');
INSERT INTO `lang_constants` VALUES (3035, 'TO_TITLE');
INSERT INTO `lang_constants` VALUES (3036, 'TO_VALEDICTORY');
INSERT INTO `lang_constants` VALUES (3037, 'Tobacco');
INSERT INTO `lang_constants` VALUES (3038, 'Tobacco use');
INSERT INTO `lang_constants` VALUES (3039, 'Today');
INSERT INTO `lang_constants` VALUES (3040, 'Today\'s Date');
INSERT INTO `lang_constants` VALUES (3041, 'Today\'s Events');
INSERT INTO `lang_constants` VALUES (3042, 'Tonsillectomy');
INSERT INTO `lang_constants` VALUES (3043, 'Top');
INSERT INTO `lang_constants` VALUES (3044, 'Topic');
INSERT INTO `lang_constants` VALUES (3045, 'total');
INSERT INTO `lang_constants` VALUES (3046, 'Total');
INSERT INTO `lang_constants` VALUES (3047, 'Total Amount Paid');
INSERT INTO `lang_constants` VALUES (3048, 'Total Charges');
INSERT INTO `lang_constants` VALUES (3049, 'Total Clients');
INSERT INTO `lang_constants` VALUES (3050, 'Total for');
INSERT INTO `lang_constants` VALUES (3051, 'Total for ');
INSERT INTO `lang_constants` VALUES (3052, 'Total for category');
INSERT INTO `lang_constants` VALUES (3053, 'Total Number of Patients');
INSERT INTO `lang_constants` VALUES (3054, 'Total SRH & Family Planning');
INSERT INTO `lang_constants` VALUES (3055, 'Totals');
INSERT INTO `lang_constants` VALUES (3056, 'Totals for');
INSERT INTO `lang_constants` VALUES (3057, 'Totals for ');
INSERT INTO `lang_constants` VALUES (3058, 'Training Type');
INSERT INTO `lang_constants` VALUES (3059, 'Transact');
INSERT INTO `lang_constants` VALUES (3060, 'transaction');
INSERT INTO `lang_constants` VALUES (3061, 'Transaction');
INSERT INTO `lang_constants` VALUES (3062, 'Transaction Type');
INSERT INTO `lang_constants` VALUES (3063, 'Transactions');
INSERT INTO `lang_constants` VALUES (3064, 'Transactions (write optional)');
INSERT INTO `lang_constants` VALUES (3065, 'Transactions/Referrals');
INSERT INTO `lang_constants` VALUES (3066, 'translate this');
INSERT INTO `lang_constants` VALUES (3067, 'Translation');
INSERT INTO `lang_constants` VALUES (3068, 'Translations');
INSERT INTO `lang_constants` VALUES (3069, 'Trauma');
INSERT INTO `lang_constants` VALUES (3070, 'Treatment Goals');
INSERT INTO `lang_constants` VALUES (3071, 'Treatment Plan');
INSERT INTO `lang_constants` VALUES (3072, 'Treatment:');
INSERT INTO `lang_constants` VALUES (3073, 'Treatment: ');
INSERT INTO `lang_constants` VALUES (3074, 'trftime($month_format, mktime(0, 0, 0, $i, 1, 2000)) );             $month_value');
INSERT INTO `lang_constants` VALUES (3075, 'Trigger point / compartment syndrome / DOMS / cramp');
INSERT INTO `lang_constants` VALUES (3076, 'Trimalleolar');
INSERT INTO `lang_constants` VALUES (3077, 'tring[,\'r\'[,');
INSERT INTO `lang_constants` VALUES (3078, 'Trunk and abdomen');
INSERT INTO `lang_constants` VALUES (3079, 'tsp');
INSERT INTO `lang_constants` VALUES (3080, 'TTS');
INSERT INTO `lang_constants` VALUES (3081, 'Tuberculosis');
INSERT INTO `lang_constants` VALUES (3082, 'Tue');
INSERT INTO `lang_constants` VALUES (3083, 'Tues &amp; Thur');
INSERT INTO `lang_constants` VALUES (3084, 'Tuesday');
INSERT INTO `lang_constants` VALUES (3085, 'Tumour');
INSERT INTO `lang_constants` VALUES (3086, 'twice daily');
INSERT INTO `lang_constants` VALUES (3087, 'Tympanic Membrane');
INSERT INTO `lang_constants` VALUES (3088, 'Type');
INSERT INTO `lang_constants` VALUES (3089, 'Type or scan the patient identifier here');
INSERT INTO `lang_constants` VALUES (3090, 'UCSMC codes provided by the University of Calgary Sports Medicine Centre');
INSERT INTO `lang_constants` VALUES (3091, 'Ulcerations');
INSERT INTO `lang_constants` VALUES (3092, 'Ulcerative Colitis');
INSERT INTO `lang_constants` VALUES (3093, 'Ulcers:');
INSERT INTO `lang_constants` VALUES (3094, 'Unassigned');
INSERT INTO `lang_constants` VALUES (3095, 'Unauthorized access.');
INSERT INTO `lang_constants` VALUES (3096, 'under tongue');
INSERT INTO `lang_constants` VALUES (3097, 'Underweight');
INSERT INTO `lang_constants` VALUES (3098, 'Undiagnosed');
INSERT INTO `lang_constants` VALUES (3099, 'Undo Checkout');
INSERT INTO `lang_constants` VALUES (3100, 'Unique Clients');
INSERT INTO `lang_constants` VALUES (3101, 'Unique New Clients');
INSERT INTO `lang_constants` VALUES (3102, 'Unique Seen Patients');
INSERT INTO `lang_constants` VALUES (3103, 'Unique Seen Patients Report');
INSERT INTO `lang_constants` VALUES (3104, 'Unique SP');
INSERT INTO `lang_constants` VALUES (3105, 'Unit');
INSERT INTO `lang_constants` VALUES (3106, 'Units');
INSERT INTO `lang_constants` VALUES (3107, 'units');
INSERT INTO `lang_constants` VALUES (3108, 'Units must be a number');
INSERT INTO `lang_constants` VALUES (3109, 'Unknown');
INSERT INTO `lang_constants` VALUES (3110, 'Unknown or N/A');
INSERT INTO `lang_constants` VALUES (3111, 'Unnamed insurance company');
INSERT INTO `lang_constants` VALUES (3112, 'Unregistered');
INSERT INTO `lang_constants` VALUES (3113, 'Unselect All');
INSERT INTO `lang_constants` VALUES (3114, 'Unselected');
INSERT INTO `lang_constants` VALUES (3115, 'Unspecified');
INSERT INTO `lang_constants` VALUES (3116, 'until');
INSERT INTO `lang_constants` VALUES (3117, 'Untimely filing');
INSERT INTO `lang_constants` VALUES (3118, 'Unused');
INSERT INTO `lang_constants` VALUES (3119, 'UOR');
INSERT INTO `lang_constants` VALUES (3120, 'Up to');
INSERT INTO `lang_constants` VALUES (3121, 'Upcoming Appointments');
INSERT INTO `lang_constants` VALUES (3122, 'Upcoming Events');
INSERT INTO `lang_constants` VALUES (3123, 'Update');
INSERT INTO `lang_constants` VALUES (3124, 'update');
INSERT INTO `lang_constants` VALUES (3125, 'Update files');
INSERT INTO `lang_constants` VALUES (3126, 'Update Info');
INSERT INTO `lang_constants` VALUES (3127, 'Update List');
INSERT INTO `lang_constants` VALUES (3128, 'Update Selected Items');
INSERT INTO `lang_constants` VALUES (3129, 'Update User Information');
INSERT INTO `lang_constants` VALUES (3130, 'Updating demographics is not authorized.');
INSERT INTO `lang_constants` VALUES (3131, 'UPIN');
INSERT INTO `lang_constants` VALUES (3132, 'Upload');
INSERT INTO `lang_constants` VALUES (3133, 'Upload configuration data');
INSERT INTO `lang_constants` VALUES (3134, 'Upload Document');
INSERT INTO `lang_constants` VALUES (3135, 'Upload failed!');
INSERT INTO `lang_constants` VALUES (3136, 'Upload import file:');
INSERT INTO `lang_constants` VALUES (3137, 'Upload Report');
INSERT INTO `lang_constants` VALUES (3138, 'Upload this file:');
INSERT INTO `lang_constants` VALUES (3139, 'Upon clicking an invoice number the \"manual posting window\" appears. Here you can change the due date and notes for the invoice, select the party for whom you are posting, and select the insurances for which all expected paymants have been received.  Most importantly, for each billing code for which an amount was charged, you can enter payment and adjustment information.');
INSERT INTO `lang_constants` VALUES (3140, 'Upon searching you are presented with a list of invoices.  You may click on one of the invoice numbers to open a second window, which is the data entry page for manual posting.  You may also click on a patient name if you want to enter a note that the front office staff will see when the patient checks in, and you may select invoices to appear on patient statements and print those statements.');
INSERT INTO `lang_constants` VALUES (3141, 'Upper arm');
INSERT INTO `lang_constants` VALUES (3142, 'Urgency');
INSERT INTO `lang_constants` VALUES (3143, 'Urine Dribbling');
INSERT INTO `lang_constants` VALUES (3144, 'Urine Frequency');
INSERT INTO `lang_constants` VALUES (3145, 'Urine Hesitancy');
INSERT INTO `lang_constants` VALUES (3146, 'Urine Stream');
INSERT INTO `lang_constants` VALUES (3147, 'Urine Urgency');
INSERT INTO `lang_constants` VALUES (3148, 'URL');
INSERT INTO `lang_constants` VALUES (3149, 'Usage Indicator (ISA15)');
INSERT INTO `lang_constants` VALUES (3150, 'Use 24 hour time format?');
INSERT INTO `lang_constants` VALUES (3151, 'Use Defaults');
INSERT INTO `lang_constants` VALUES (3152, 'Use international date style?');
INSERT INTO `lang_constants` VALUES (3153, 'Use this feature only with newly installed sites, ');
INSERT INTO `lang_constants` VALUES (3154, 'Use topics?');
INSERT INTO `lang_constants` VALUES (3155, 'User');
INSERT INTO `lang_constants` VALUES (3156, 'User Administration');
INSERT INTO `lang_constants` VALUES (3157, 'User and Facility Administration');
INSERT INTO `lang_constants` VALUES (3158, 'User and Group Administration');
INSERT INTO `lang_constants` VALUES (3159, 'User Defined');
INSERT INTO `lang_constants` VALUES (3160, 'User Defined Area 11');
INSERT INTO `lang_constants` VALUES (3161, 'User Defined Area 12');
INSERT INTO `lang_constants` VALUES (3162, 'User Defined Field');
INSERT INTO `lang_constants` VALUES (3163, 'User Defined List 1');
INSERT INTO `lang_constants` VALUES (3164, 'User Defined List 2');
INSERT INTO `lang_constants` VALUES (3165, 'User Defined List 3');
INSERT INTO `lang_constants` VALUES (3166, 'User Defined List 4');
INSERT INTO `lang_constants` VALUES (3167, 'User Defined List 5');
INSERT INTO `lang_constants` VALUES (3168, 'User Defined List 6');
INSERT INTO `lang_constants` VALUES (3169, 'User Defined List 7');
INSERT INTO `lang_constants` VALUES (3170, 'User Defined Text 1');
INSERT INTO `lang_constants` VALUES (3171, 'User Defined Text 2');
INSERT INTO `lang_constants` VALUES (3172, 'User Defined Text 3');
INSERT INTO `lang_constants` VALUES (3173, 'User Defined Text 4');
INSERT INTO `lang_constants` VALUES (3174, 'User Defined Text 5');
INSERT INTO `lang_constants` VALUES (3175, 'User Defined Text 6');
INSERT INTO `lang_constants` VALUES (3176, 'User Defined Text 7');
INSERT INTO `lang_constants` VALUES (3177, 'User Defined Text 8');
INSERT INTO `lang_constants` VALUES (3178, 'User Manual');
INSERT INTO `lang_constants` VALUES (3179, 'User Memberships');
INSERT INTO `lang_constants` VALUES (3180, 'Username');
INSERT INTO `lang_constants` VALUES (3181, 'Username for SMS Gateway');
INSERT INTO `lang_constants` VALUES (3182, 'Username:');
INSERT INTO `lang_constants` VALUES (3183, 'Users');
INSERT INTO `lang_constants` VALUES (3184, 'Users/Groups/Logs Administration');
INSERT INTO `lang_constants` VALUES (3185, 'uses php <a href=\"http://php.net/strftime\">strftime</a> format');
INSERT INTO `lang_constants` VALUES (3186, 'UTIs');
INSERT INTO `lang_constants` VALUES (3187, 'VACATION');
INSERT INTO `lang_constants` VALUES (3188, 'Vacation');
INSERT INTO `lang_constants` VALUES (3189, 'Vaccine');
INSERT INTO `lang_constants` VALUES (3190, 'Vaginal Ring');
INSERT INTO `lang_constants` VALUES (3191, 'Valedictory');
INSERT INTO `lang_constants` VALUES (3192, 'Value 1');
INSERT INTO `lang_constants` VALUES (3193, 'Value 2');
INSERT INTO `lang_constants` VALUES (3194, 'Var1');
INSERT INTO `lang_constants` VALUES (3195, 'Var2');
INSERT INTO `lang_constants` VALUES (3196, 'Varicella 1');
INSERT INTO `lang_constants` VALUES (3197, 'Varicella 2');
INSERT INTO `lang_constants` VALUES (3198, 'Varicose Veins');
INSERT INTO `lang_constants` VALUES (3199, 'Vascular condition');
INSERT INTO `lang_constants` VALUES (3200, 'Vascular injury');
INSERT INTO `lang_constants` VALUES (3201, 'Vascular Surgery');
INSERT INTO `lang_constants` VALUES (3202, 'Version');
INSERT INTO `lang_constants` VALUES (3203, 'Vertigo');
INSERT INTO `lang_constants` VALUES (3204, 'Veterans Administration Plan');
INSERT INTO `lang_constants` VALUES (3205, 'View');
INSERT INTO `lang_constants` VALUES (3206, 'view');
INSERT INTO `lang_constants` VALUES (3207, 'View Allergies');
INSERT INTO `lang_constants` VALUES (3208, 'View Comprehensive Patient Report');
INSERT INTO `lang_constants` VALUES (3209, 'View document');
INSERT INTO `lang_constants` VALUES (3210, 'View encounter');
INSERT INTO `lang_constants` VALUES (3211, 'View events in a popup window?');
INSERT INTO `lang_constants` VALUES (3212, 'View Page 1');
INSERT INTO `lang_constants` VALUES (3213, 'View Page 2');
INSERT INTO `lang_constants` VALUES (3214, 'View related encounters');
INSERT INTO `lang_constants` VALUES (3215, 'View/Edit Allergies');
INSERT INTO `lang_constants` VALUES (3216, 'View:');
INSERT INTO `lang_constants` VALUES (3217, 'VISA');
INSERT INTO `lang_constants` VALUES (3218, 'Visceral damage/trauma/surgery');
INSERT INTO `lang_constants` VALUES (3219, 'Visit Category:');
INSERT INTO `lang_constants` VALUES (3220, 'Visit Date');
INSERT INTO `lang_constants` VALUES (3221, 'Visit Forms');
INSERT INTO `lang_constants` VALUES (3222, 'Visits');
INSERT INTO `lang_constants` VALUES (3223, 'Visits From');
INSERT INTO `lang_constants` VALUES (3224, 'Vital Signs');
INSERT INTO `lang_constants` VALUES (3225, 'Vitals');
INSERT INTO `lang_constants` VALUES (3226, 'Vitals (Metric)');
INSERT INTO `lang_constants` VALUES (3227, 'Voice');
INSERT INTO `lang_constants` VALUES (3228, 'Vomiting');
INSERT INTO `lang_constants` VALUES (3229, 'W');
INSERT INTO `lang_constants` VALUES (3230, 'Waist Circ');
INSERT INTO `lang_constants` VALUES (3231, 'Waist Circumference');
INSERT INTO `lang_constants` VALUES (3232, 'Waiting');
INSERT INTO `lang_constants` VALUES (3233, 'Walk-In');
INSERT INTO `lang_constants` VALUES (3234, 'Walt Pennington');
INSERT INTO `lang_constants` VALUES (3235, 'Warm');
INSERT INTO `lang_constants` VALUES (3236, 'WARNING');
INSERT INTO `lang_constants` VALUES (3237, 'Warning: A visit was already created for this patient today!');
INSERT INTO `lang_constants` VALUES (3238, 'Warning: Patient ID is not unique!');
INSERT INTO `lang_constants` VALUES (3239, 'WARNING: This will overwrite configuration information with data from the uploaded file!');
INSERT INTO `lang_constants` VALUES (3240, 'we have seen your above patient for evaluation and treatment at our outpatient psychiatry clinic. Thank you for this referral.');
INSERT INTO `lang_constants` VALUES (3241, 'Weakness');
INSERT INTO `lang_constants` VALUES (3242, 'Website');
INSERT INTO `lang_constants` VALUES (3243, 'Wed');
INSERT INTO `lang_constants` VALUES (3244, 'Wednesday');
INSERT INTO `lang_constants` VALUES (3245, 'week');
INSERT INTO `lang_constants` VALUES (3246, 'Week');
INSERT INTO `lang_constants` VALUES (3247, 'Week View');
INSERT INTO `lang_constants` VALUES (3248, 'Week(s)');
INSERT INTO `lang_constants` VALUES (3249, 'Weight');
INSERT INTO `lang_constants` VALUES (3250, 'Weight Change');
INSERT INTO `lang_constants` VALUES (3251, 'Weight Loss');
INSERT INTO `lang_constants` VALUES (3252, 'What is to be counted?');
INSERT INTO `lang_constants` VALUES (3253, 'Wheezes:');
INSERT INTO `lang_constants` VALUES (3254, 'Wheezing');
INSERT INTO `lang_constants` VALUES (3255, 'Wheezing:');
INSERT INTO `lang_constants` VALUES (3256, 'Where may related scanned or paper documents be found?');
INSERT INTO `lang_constants` VALUES (3257, 'Whiplash');
INSERT INTO `lang_constants` VALUES (3258, 'Who');
INSERT INTO `lang_constants` VALUES (3259, 'Who replied?');
INSERT INTO `lang_constants` VALUES (3260, 'Widowed');
INSERT INTO `lang_constants` VALUES (3261, 'With selected:');
INSERT INTO `lang_constants` VALUES (3262, 'with the old name');
INSERT INTO `lang_constants` VALUES (3263, 'With whom may we leave a message?');
INSERT INTO `lang_constants` VALUES (3264, 'within hours');
INSERT INTO `lang_constants` VALUES (3265, 'within hours:');
INSERT INTO `lang_constants` VALUES (3266, 'within minutes');
INSERT INTO `lang_constants` VALUES (3267, 'within minutes:');
INSERT INTO `lang_constants` VALUES (3268, 'Without Update');
INSERT INTO `lang_constants` VALUES (3269, 'Witness');
INSERT INTO `lang_constants` VALUES (3270, 'WNL');
INSERT INTO `lang_constants` VALUES (3271, 'Women');
INSERT INTO `lang_constants` VALUES (3272, 'Women Only');
INSERT INTO `lang_constants` VALUES (3273, 'Work');
INSERT INTO `lang_constants` VALUES (3274, 'WORK NOTE');
INSERT INTO `lang_constants` VALUES (3275, 'Work Phone');
INSERT INTO `lang_constants` VALUES (3276, 'Work Phone Number');
INSERT INTO `lang_constants` VALUES (3277, 'Work related?');
INSERT INTO `lang_constants` VALUES (3278, 'Work/ Education/ Hobbies');
INSERT INTO `lang_constants` VALUES (3279, 'Work/School Note');
INSERT INTO `lang_constants` VALUES (3280, 'workday');
INSERT INTO `lang_constants` VALUES (3281, 'Workers Compensation Health Plan');
INSERT INTO `lang_constants` VALUES (3282, 'Worse');
INSERT INTO `lang_constants` VALUES (3283, 'Wrist');
INSERT INTO `lang_constants` VALUES (3284, 'Wrist and hand');
INSERT INTO `lang_constants` VALUES (3285, 'Wrist Problems');
INSERT INTO `lang_constants` VALUES (3286, 'write');
INSERT INTO `lang_constants` VALUES (3287, 'write off');
INSERT INTO `lang_constants` VALUES (3288, 'wsome');
INSERT INTO `lang_constants` VALUES (3289, 'WT');
INSERT INTO `lang_constants` VALUES (3290, 'x Cancelled');
INSERT INTO `lang_constants` VALUES (3291, 'X-ray');
INSERT INTO `lang_constants` VALUES (3292, 'X-RAY Interpretation:');
INSERT INTO `lang_constants` VALUES (3293, 'X-Ray Interpretation:');
INSERT INTO `lang_constants` VALUES (3294, 'X12 only: Replacement Claim ');
INSERT INTO `lang_constants` VALUES (3295, 'X12 Partner');
INSERT INTO `lang_constants` VALUES (3296, 'X12 Partners');
INSERT INTO `lang_constants` VALUES (3297, 'Y');
INSERT INTO `lang_constants` VALUES (3298, 'year');
INSERT INTO `lang_constants` VALUES (3299, 'Year');
INSERT INTO `lang_constants` VALUES (3300, 'Year View');
INSERT INTO `lang_constants` VALUES (3301, 'Year(s)');
INSERT INTO `lang_constants` VALUES (3302, 'YES');
INSERT INTO `lang_constants` VALUES (3303, 'Yes');
INSERT INTO `lang_constants` VALUES (3304, 'yes');
INSERT INTO `lang_constants` VALUES (3305, 'YES!');
INSERT INTO `lang_constants` VALUES (3306, 'Yes, Delete and Log');
INSERT INTO `lang_constants` VALUES (3307, 'Yes/No');
INSERT INTO `lang_constants` VALUES (3308, 'Yes:');
INSERT INTO `lang_constants` VALUES (3309, 'You are about to permanently replace the existing template. Are you sure you wish to continue?');
INSERT INTO `lang_constants` VALUES (3310, 'You are not allowed to delete this event');
INSERT INTO `lang_constants` VALUES (3311, 'You are not allowed to edit this event');
INSERT INTO `lang_constants` VALUES (3312, 'You are not authorized for this.');
INSERT INTO `lang_constants` VALUES (3313, 'You are not authorized to access this squad.');
INSERT INTO `lang_constants` VALUES (3314, 'You are not authorized to add/edit issues');
INSERT INTO `lang_constants` VALUES (3315, 'You are not authorized to see this encounter.');
INSERT INTO `lang_constants` VALUES (3316, 'You can not access this function directly.');
INSERT INTO `lang_constants` VALUES (3317, 'You cannot access this page directly.');
INSERT INTO `lang_constants` VALUES (3318, 'You cannot add a blank value for a category!');
INSERT INTO `lang_constants` VALUES (3319, 'You cannot add a blank value for a subcategory!');
INSERT INTO `lang_constants` VALUES (3320, 'You cannot add a blank value for an item!');
INSERT INTO `lang_constants` VALUES (3321, 'You did not choose any actions.');
INSERT INTO `lang_constants` VALUES (3322, 'You do not have access to view/edit this note');
INSERT INTO `lang_constants` VALUES (3323, 'You have attempted to alter content which is locked. Remove the lock if you want to do this. To unlock, remove the line, \'/*lock::*/\'');
INSERT INTO `lang_constants` VALUES (3324, 'You must first select or add a patient.');
INSERT INTO `lang_constants` VALUES (3325, 'You must first select or create an encounter.');
INSERT INTO `lang_constants` VALUES (3326, 'You must select some fields to continue.');
INSERT INTO `lang_constants` VALUES (3327, 'You should be running this test if this claim appeared to generate successfully but the actual claim file does not contain any data or only an unfinished portion of the amount of data it is supposed to contain. It is obvious with HCFA claims because they are human readable, with X12 claims it is a more difficult process to determine if the claim is properly complete.');
INSERT INTO `lang_constants` VALUES (3328, 'Your end date is invalid');
INSERT INTO `lang_constants` VALUES (3329, 'Your event has been deleted.');
INSERT INTO `lang_constants` VALUES (3330, 'Your event has been modified.');
INSERT INTO `lang_constants` VALUES (3331, 'Your event has been submitted.');
INSERT INTO `lang_constants` VALUES (3332, 'Your list name has been changed to meet naming requirements.');
INSERT INTO `lang_constants` VALUES (3333, 'Your PostCalendar configuration has been reset to use defaults.');
INSERT INTO `lang_constants` VALUES (3334, 'Your PostCalendar configuration has been updated.');
INSERT INTO `lang_constants` VALUES (3335, 'Your repeating frequency must be an integer.');
INSERT INTO `lang_constants` VALUES (3336, 'Your repeating frequency must be at least 1.');
INSERT INTO `lang_constants` VALUES (3337, 'Your start date is greater than your end date');
INSERT INTO `lang_constants` VALUES (3338, 'Your start date is invalid');
INSERT INTO `lang_constants` VALUES (3339, 'Your submission failed.');
INSERT INTO `lang_constants` VALUES (3340, 'yyyy-mm-dd');
INSERT INTO `lang_constants` VALUES (3341, 'yyyy-mm-dd date associated with this document');
INSERT INTO `lang_constants` VALUES (3342, 'yyyy-mm-dd date destroyed');
INSERT INTO `lang_constants` VALUES (3343, 'yyyy-mm-dd Date of Birth');
INSERT INTO `lang_constants` VALUES (3344, 'yyyy-mm-dd date of birth');
INSERT INTO `lang_constants` VALUES (3345, 'yyyy-mm-dd date of expiration');
INSERT INTO `lang_constants` VALUES (3346, 'yyyy-mm-dd Date of onset or hospitalization');
INSERT INTO `lang_constants` VALUES (3347, 'yyyy-mm-dd date of onset, surgery or start of medication');
INSERT INTO `lang_constants` VALUES (3348, 'yyyy-mm-dd date of recovery or end of medication');
INSERT INTO `lang_constants` VALUES (3349, 'yyyy-mm-dd Date of return to play');
INSERT INTO `lang_constants` VALUES (3350, 'yyyy-mm-dd Date of service');
INSERT INTO `lang_constants` VALUES (3351, 'yyyy-mm-dd date of this letter');
INSERT INTO `lang_constants` VALUES (3352, 'yyyy-mm-dd date returned to play');
INSERT INTO `lang_constants` VALUES (3353, 'yyyy-mm-dd document date');
INSERT INTO `lang_constants` VALUES (3354, 'yyyy-mm-dd event date or starting date');
INSERT INTO `lang_constants` VALUES (3355, 'yyyy-mm-dd last date of this event');
INSERT INTO `lang_constants` VALUES (3356, 'Zero');
INSERT INTO `lang_constants` VALUES (3357, 'Zip');
INSERT INTO `lang_constants` VALUES (3358, 'Zip Code');
INSERT INTO `lang_constants` VALUES (3359, 'Zip/Country:');
INSERT INTO `lang_constants` VALUES (3360, ' but was ');
INSERT INTO `lang_constants` VALUES (3361, ' could not be accessed.');
INSERT INTO `lang_constants` VALUES (3362, ' Do you really want to delete');
INSERT INTO `lang_constants` VALUES (3363, ' Drug');
INSERT INTO `lang_constants` VALUES (3364, ' emails not sent');
INSERT INTO `lang_constants` VALUES (3365, ' from');
INSERT INTO `lang_constants` VALUES (3366, ' has been created. ');
INSERT INTO `lang_constants` VALUES (3367, ' has been re-opened.');
INSERT INTO `lang_constants` VALUES (3368, ' History');
INSERT INTO `lang_constants` VALUES (3369, ' is not a number');
INSERT INTO `lang_constants` VALUES (3370, ' is ready for re-billing.');
INSERT INTO `lang_constants` VALUES (3371, ' LLL:');
INSERT INTO `lang_constants` VALUES (3372, ' Lot');
INSERT INTO `lang_constants` VALUES (3373, ' Medicaid Original Reference No. ');
INSERT INTO `lang_constants` VALUES (3374, ' min');
INSERT INTO `lang_constants` VALUES (3375, ' not found!');
INSERT INTO `lang_constants` VALUES (3376, ' Pecularities in many browsers may mean that the output below enters your screen in sudden jerks and that there are long pauses of several seconds where it  appears as though things may have crashed. That is not the case, you will eventually see output coming out line by line. There may be sequential numbers appearing  below, this is to indicate that even though nothing else may be displaying there is activity going on. These numbers will be interspersed with the content of the  billing and that is normal.');
INSERT INTO `lang_constants` VALUES (3377, ' prescription has reached its limit of');
INSERT INTO `lang_constants` VALUES (3378, ' until ');
INSERT INTO `lang_constants` VALUES (3379, ' update failed, not in database?');
INSERT INTO `lang_constants` VALUES (3380, ' was marked as billed only.');
INSERT INTO `lang_constants` VALUES (3381, ' was queued successfully.');
INSERT INTO `lang_constants` VALUES (3382, '! Left w/o visit');
INSERT INTO `lang_constants` VALUES (3383, '\" for code ');
INSERT INTO `lang_constants` VALUES (3384, '\" is CHECKED in PostCalendar Settings!');
INSERT INTO `lang_constants` VALUES (3385, '# Ins/fin issue');
INSERT INTO `lang_constants` VALUES (3386, '# of tablets:');
INSERT INTO `lang_constants` VALUES (3387, '$');
INSERT INTO `lang_constants` VALUES (3388, '$ Coding done');
INSERT INTO `lang_constants` VALUES (3389, '$1');
INSERT INTO `lang_constants` VALUES (3390, '$label (yyyy-mm-dd): ');
INSERT INTO `lang_constants` VALUES (3391, '%');
INSERT INTO `lang_constants` VALUES (3392, '% Cancelled <  24h ');
INSERT INTO `lang_constants` VALUES (3393, '\' should exist but does not.');
INSERT INTO `lang_constants` VALUES (3394, '(% matches any string, _ matches any character)');
INSERT INTO `lang_constants` VALUES (3395, '(Back)');
INSERT INTO `lang_constants` VALUES (3396, '(Click to edit)');
INSERT INTO `lang_constants` VALUES (3397, '(More)');
INSERT INTO `lang_constants` VALUES (3398, '(New Patient)');
INSERT INTO `lang_constants` VALUES (3399, '(Notes and Authorizations)');
INSERT INTO `lang_constants` VALUES (3400, '(Patient Notes)');
INSERT INTO `lang_constants` VALUES (3401, '(Select one of these, or type your own title)');
INSERT INTO `lang_constants` VALUES (3402, '* Reminder done');
INSERT INTO `lang_constants` VALUES (3403, '** Please move surgeries to Issues!');
INSERT INTO `lang_constants` VALUES (3404, '*Required');
INSERT INTO `lang_constants` VALUES (3405, '+ Chart pulled');
INSERT INTO `lang_constants` VALUES (3406, '.');
INSERT INTO `lang_constants` VALUES (3407, '0-10');
INSERT INTO `lang_constants` VALUES (3408, '1.Rest 2. Ice for two days 3. Compression, leave the dressing in place unless the foot develops numbness or pale color 4. Elevate the foot and leg');
INSERT INTO `lang_constants` VALUES (3409, '11-14');
INSERT INTO `lang_constants` VALUES (3410, '15-19');
INSERT INTO `lang_constants` VALUES (3411, '20-24');
INSERT INTO `lang_constants` VALUES (3412, '2111-13');
INSERT INTO `lang_constants` VALUES (3413, '25-29');
INSERT INTO `lang_constants` VALUES (3414, '2nd');
INSERT INTO `lang_constants` VALUES (3415, '3 months');
INSERT INTO `lang_constants` VALUES (3416, '3 times daily');
INSERT INTO `lang_constants` VALUES (3417, '30-34');
INSERT INTO `lang_constants` VALUES (3418, '35-39');
INSERT INTO `lang_constants` VALUES (3419, '3rd');
INSERT INTO `lang_constants` VALUES (3420, '4 months');
INSERT INTO `lang_constants` VALUES (3421, '4 times daily');
INSERT INTO `lang_constants` VALUES (3422, '40-44');
INSERT INTO `lang_constants` VALUES (3423, '45+');
INSERT INTO `lang_constants` VALUES (3424, '465.9, URI');
INSERT INTO `lang_constants` VALUES (3425, '466.0, Bronchitis, Acute NOS');
INSERT INTO `lang_constants` VALUES (3426, '486.0, Pneumonia, Acute');
INSERT INTO `lang_constants` VALUES (3427, '491.21, COPD Exacerbation');
INSERT INTO `lang_constants` VALUES (3428, '491.8, Bronchitis, Chronic');
INSERT INTO `lang_constants` VALUES (3429, '493.92, Asthma, Acute Exac.');
INSERT INTO `lang_constants` VALUES (3430, '496.0, COPD');
INSERT INTO `lang_constants` VALUES (3431, '4th');
INSERT INTO `lang_constants` VALUES (3432, '519.7, Bronchospasm');
INSERT INTO `lang_constants` VALUES (3433, '5th');
INSERT INTO `lang_constants` VALUES (3434, '6 months');
INSERT INTO `lang_constants` VALUES (3435, '6th');
INSERT INTO `lang_constants` VALUES (3436, '824.0 Fracture, medial malleolus, closed');
INSERT INTO `lang_constants` VALUES (3437, '824.2 Fracture, lateral malleolus, closed');
INSERT INTO `lang_constants` VALUES (3438, '824.6 Fracture, Trimalleolar, closed');
INSERT INTO `lang_constants` VALUES (3439, '825.32 Fracture, of Navicular (ankle)');
INSERT INTO `lang_constants` VALUES (3440, '825.35 Fracture, Base of fifth (5th) Metatarsal');
INSERT INTO `lang_constants` VALUES (3441, '845.00 ankle sprain NOS');
INSERT INTO `lang_constants` VALUES (3442, '845.01 Sprain Medial (Deltoid) Lig.');
INSERT INTO `lang_constants` VALUES (3443, '845.02 Sprain, Calcaneal fibular');
INSERT INTO `lang_constants` VALUES (3444, '99212 Established - Uncomplicated');
INSERT INTO `lang_constants` VALUES (3445, '99213 Established - Low Complexity');
INSERT INTO `lang_constants` VALUES (3446, '< In exam room');
INSERT INTO `lang_constants` VALUES (3447, '> Checked out');
INSERT INTO `lang_constants` VALUES (3448, '? No show');
INSERT INTO `lang_constants` VALUES (3449, '@ Arrived');
INSERT INTO `lang_constants` VALUES (3450, '[Change View]');
INSERT INTO `lang_constants` VALUES (3451, '[Date of Last Encounter]');
INSERT INTO `lang_constants` VALUES (3452, '[Days Since Last Encounter]');
INSERT INTO `lang_constants` VALUES (3453, '[EOBs]');
INSERT INTO `lang_constants` VALUES (3454, '[Export OFX]');
INSERT INTO `lang_constants` VALUES (3455, '[not recommended]');
INSERT INTO `lang_constants` VALUES (3456, '[Number Of Encounters]');
INSERT INTO `lang_constants` VALUES (3457, '[Reports]');
INSERT INTO `lang_constants` VALUES (3458, '[Select All]');
INSERT INTO `lang_constants` VALUES (3459, '[SQL-Ledger]');
INSERT INTO `lang_constants` VALUES (3460, '[Start Batch Processing]');
INSERT INTO `lang_constants` VALUES (3461, '[View Log]');
INSERT INTO `lang_constants` VALUES (3462, '[View Printable Report]');
INSERT INTO `lang_constants` VALUES (3463, '_PC_DUR_HOURS');
INSERT INTO `lang_constants` VALUES (3464, '_PC_DUR_MINUTES');
INSERT INTO `lang_constants` VALUES (3465, '_PC_LOCALE');
INSERT INTO `lang_constants` VALUES (3466, '~ Arrived late');

--


-- 
-- Table structure for table `lang_definitions`
-- 


DROP TABLE IF EXISTS `lang_definitions`;
CREATE TABLE `lang_definitions` (
  `def_id` int(11) NOT NULL auto_increment,
  `cons_id` int(11) NOT NULL default '0',
  `lang_id` int(11) NOT NULL default '0',
  `definition` mediumtext,
  UNIQUE KEY `def_id` (`def_id`),
  KEY `cons_id` (`cons_id`) 
) ENGINE=MyISAM AUTO_INCREMENT=28670 ;


-- 
-- Dumping data for table `lang_definitions`
--

INSERT INTO `lang_definitions` VALUES (1, 1, 2, 'A');
INSERT INTO `lang_definitions` VALUES (2, 2, 2, 'Ett betalningsnr för att identifiera betalningen');
INSERT INTO `lang_definitions` VALUES (3, 4, 2, 'Ett serienr krävs!');
INSERT INTO `lang_definitions` VALUES (4, 5, 2, 'En relaterad IPPF kod krävs!');
INSERT INTO `lang_definitions` VALUES (5, 6, 2, 'Ett unikt värde för att identifiera detta område, inte synlig för användaren');
INSERT INTO `lang_definitions` VALUES (6, 7, 2, 'Innan du äter');
INSERT INTO `lang_definitions` VALUES (7, 8, 2, 'morgonen');
INSERT INTO `lang_definitions` VALUES (8, 10, 2, 'AB');
INSERT INTO `lang_definitions` VALUES (9, 11, 2, 'Förkortning');
INSERT INTO `lang_definitions` VALUES (10, 12, 2, 'Abcess:');
INSERT INTO `lang_definitions` VALUES (11, 13, 2, 'Abdominal');
INSERT INTO `lang_definitions` VALUES (12, 14, 2, 'kan bära Vikt fyra (4) steg: ');
INSERT INTO `lang_definitions` VALUES (13, 15, 2, 'Abn');
INSERT INTO `lang_definitions` VALUES (14, 16, 2, 'ABN1');
INSERT INTO `lang_definitions` VALUES (15, 17, 2, 'Onormal');
INSERT INTO `lang_definitions` VALUES (16, 18, 2, 'Onormalt blod test');
INSERT INTO `lang_definitions` VALUES (17, 19, 2, 'Onormal hår växt');
INSERT INTO `lang_definitions` VALUES (18, 20, 2, 'Onormalt mammogram');
INSERT INTO `lang_definitions` VALUES (19, 21, 2, 'Abort');
INSERT INTO `lang_definitions` VALUES (20, 22, 2, 'Abortproblematik');
INSERT INTO `lang_definitions` VALUES (21, 23, 2, 'Abortmetod ');
INSERT INTO `lang_definitions` VALUES (22, 24, 2, 'Abortrelaterade kategorier');
INSERT INTO `lang_definitions` VALUES (23, 25, 2, 'Aborter');
INSERT INTO `lang_definitions` VALUES (24, 26, 2, 'Frånvaro av Diagnos ');
INSERT INTO `lang_definitions` VALUES (25, 27, 2, 'Acceptera uppdrag ');
INSERT INTO `lang_definitions` VALUES (26, 28, 2, 'acceptera betalning för ');
INSERT INTO `lang_definitions` VALUES (27, 29, 2, 'Accepterar uppdrag ');
INSERT INTO `lang_definitions` VALUES (28, 30, 2, 'Åtkomstkontroll ');
INSERT INTO `lang_definitions` VALUES (29, 31, 2, 'Lista för accesskontroll');
INSERT INTO `lang_definitions` VALUES (30, 32, 2, 'Redovisning');
INSERT INTO `lang_definitions` VALUES (31, 33, 2, 'Värk');
INSERT INTO `lang_definitions` VALUES (32, 35, 2, 'ACL ');
INSERT INTO `lang_definitions` VALUES (33, 36, 2, 'ACL Administration');
INSERT INTO `lang_definitions` VALUES (34, 37, 2, 'ACL Ej behörig för administration ');
INSERT INTO `lang_definitions` VALUES (35, 38, 2, 'Acne');
INSERT INTO `lang_definitions` VALUES (36, 39, 2, 'Akt');
INSERT INTO `lang_definitions` VALUES (37, 40, 2, 'aktivitetsdatum ');
INSERT INTO `lang_definitions` VALUES (38, 41, 2, 'Aktiva ');
INSERT INTO `lang_definitions` VALUES (39, 42, 2, 'Aktivt ärende ');
INSERT INTO `lang_definitions` VALUES (40, 43, 2, 'Aktiva listor');
INSERT INTO `lang_definitions` VALUES (41, 44, 2, 'Aktiv patient ');
INSERT INTO `lang_definitions` VALUES (42, 45, 2, 'Aktivitetstyp');
INSERT INTO `lang_definitions` VALUES (43, 46, 2, 'Akut av Kronisk ');
INSERT INTO `lang_definitions` VALUES (44, 47, 2, 'Lägg till ');
INSERT INTO `lang_definitions` VALUES (45, 49, 2, 'Lägg till ett företag ');
INSERT INTO `lang_definitions` VALUES (46, 50, 2, 'Lägg till ett apotek ');
INSERT INTO `lang_definitions` VALUES (47, 51, 2, 'Lägg till ett evenemang för ');
INSERT INTO `lang_definitions` VALUES (48, 52, 2, 'lägg till anteckning');
INSERT INTO `lang_definitions` VALUES (49, 53, 2, 'Lägg till som ny ');
INSERT INTO `lang_definitions` VALUES (50, 54, 2, 'Lägg till Kategori ');
INSERT INTO `lang_definitions` VALUES (51, 55, 2, 'Lägg till Konstant ');
INSERT INTO `lang_definitions` VALUES (52, 56, 2, 'Lägg till Medbetalning ');
INSERT INTO `lang_definitions` VALUES (53, 57, 2, 'Lägg till Läkemedel');
INSERT INTO `lang_definitions` VALUES (54, 58, 2, 'Lägg till Besök');
INSERT INTO `lang_definitions` VALUES (55, 59, 2, 'Lägg till klinik');
INSERT INTO `lang_definitions` VALUES (56, 60, 2, 'Lägg till fält');
INSERT INTO `lang_definitions` VALUES (57, 61, 2, 'Lägg till Grupp ');
INSERT INTO `lang_definitions` VALUES (58, 62, 2, 'Lägg till ICD-kod');
INSERT INTO `lang_definitions` VALUES (59, 63, 2, 'Lägg till i aktuellt');
INSERT INTO `lang_definitions` VALUES (60, 64, 2, 'Lägg till Språk ');
INSERT INTO `lang_definitions` VALUES (61, 65, 2, 'Lägg till Ny ');
INSERT INTO `lang_definitions` VALUES (62, 66, 2, 'Lägg till ny kategori: ');
INSERT INTO `lang_definitions` VALUES (63, 67, 2, 'Lägg till ny grupp ');
INSERT INTO `lang_definitions` VALUES (64, 68, 2, 'Lägg till ny kommentar ');
INSERT INTO `lang_definitions` VALUES (65, 69, 2, 'Lägg till ny kommentar ');
INSERT INTO `lang_definitions` VALUES (66, 70, 2, 'Lägg till ny partner ');
INSERT INTO `lang_definitions` VALUES (67, 71, 2, 'Lägg till anteckning ');
INSERT INTO `lang_definitions` VALUES (68, 72, 2, 'Lägg till patientjournal ');
INSERT INTO `lang_definitions` VALUES (69, 73, 2, 'Lägg till Recept');
INSERT INTO `lang_definitions` VALUES (70, 75, 2, 'Lägg till i Medicinlista ');
INSERT INTO `lang_definitions` VALUES (71, 76, 2, 'Lägg till transaktion');
INSERT INTO `lang_definitions` VALUES (72, 77, 2, 'Lägg till användare ');
INSERT INTO `lang_definitions` VALUES (73, 78, 2, 'Lägg till användare i gruppen ');
INSERT INTO `lang_definitions` VALUES (74, 79, 2, 'Läggas ');
INSERT INTO `lang_definitions` VALUES (75, 80, 2, 'Ej tillåtet att lägga till i demografi.');
INSERT INTO `lang_definitions` VALUES (76, 81, 2, 'Addison Syndrom');
INSERT INTO `lang_definitions` VALUES (77, 82, 2, 'Addison Syndrom');
INSERT INTO `lang_definitions` VALUES (78, 83, 2, 'Ytterligare Diagnos:');
INSERT INTO `lang_definitions` VALUES (79, 84, 2, 'Ytterligare Historia');
INSERT INTO `lang_definitions` VALUES (80, 85, 2, 'Ytterligare anteckningar');
INSERT INTO `lang_definitions` VALUES (81, 86, 2, 'Ytterligare Info');
INSERT INTO `lang_definitions` VALUES (82, 87, 2, 'Ytterligare Lab');
INSERT INTO `lang_definitions` VALUES (83, 88, 2, 'Ytterligare noteringar');
INSERT INTO `lang_definitions` VALUES (84, 89, 2, 'Ytterligare noteringar:');
INSERT INTO `lang_definitions` VALUES (85, 90, 2, 'Ytterligare noteringar:');
INSERT INTO `lang_definitions` VALUES (86, 91, 2, 'Ytterligare röntgen Anmärkning:');
INSERT INTO `lang_definitions` VALUES (87, 92, 2, 'Lägg endast till');
INSERT INTO `lang_definitions` VALUES (88, 93, 2, 'Adressbok');
INSERT INTO `lang_definitions` VALUES (89, 94, 2, 'Adressbok');
INSERT INTO `lang_definitions` VALUES (90, 95, 2, 'Adress');
INSERT INTO `lang_definitions` VALUES (91, 96, 2, 'Adressbok');
INSERT INTO `lang_definitions` VALUES (92, 97, 2, 'Adress1');
INSERT INTO `lang_definitions` VALUES (93, 98, 2, 'Adress2');
INSERT INTO `lang_definitions` VALUES (94, 99, 2, 'Adj');
INSERT INTO `lang_definitions` VALUES (95, 100, 2, 'Justera');
INSERT INTO `lang_definitions` VALUES (96, 101, 2, 'Orsak till justering');
INSERT INTO `lang_definitions` VALUES (97, 102, 2, 'Justering värde för kod');
INSERT INTO `lang_definitions` VALUES (98, 103, 2, 'Justeringar');
INSERT INTO `lang_definitions` VALUES (99, 104, 2, 'Adm justera');
INSERT INTO `lang_definitions` VALUES (100, 105, 2, 'Admin');
INSERT INTO `lang_definitions` VALUES (101, 106, 2, 'Admin E-postadress');
INSERT INTO `lang_definitions` VALUES (102, 107, 2, 'Administreras');
INSERT INTO `lang_definitions` VALUES (103, 108, 2, 'Administrerad av');
INSERT INTO `lang_definitions` VALUES (104, 109, 2, 'Sys.Administration');
INSERT INTO `lang_definitions` VALUES (105, 110, 2, 'Administratörer');
INSERT INTO `lang_definitions` VALUES (106, 111, 2, 'Administratörer kan göra allt');
INSERT INTO `lang_definitions` VALUES (107, 112, 2, 'Avancerad');
INSERT INTO `lang_definitions` VALUES (108, 113, 2, 'Råd');
INSERT INTO `lang_definitions` VALUES (109, 114, 2, 'Påverka normal');
INSERT INTO `lang_definitions` VALUES (110, 115, 2, 'Joursamtal');
INSERT INTO `lang_definitions` VALUES (111, 116, 2, 'Efter att sparat PDF, klicka på [View Log] för att leta efter fel.');
INSERT INTO `lang_definitions` VALUES (112, 117, 2, 'Efter sparat partiet, klicka på [View Log] för att leta efter fel. ');
INSERT INTO `lang_definitions` VALUES (113, 118, 2, 'Efter informationen är korrekt, klicka på knappen Spara.');
INSERT INTO `lang_definitions` VALUES (114, 119, 2, 'Igen');
INSERT INTO `lang_definitions` VALUES (115, 120, 2, 'Ålder');
INSERT INTO `lang_definitions` VALUES (116, 121, 2, 'Ålder Genom');
INSERT INTO `lang_definitions` VALUES (117, 122, 2, 'Ålderskategori');
INSERT INTO `lang_definitions` VALUES (118, 123, 2, 'Åder - data utanför intervall');
INSERT INTO `lang_definitions` VALUES (119, 124, 2, 'Ålderformat för \"ålder\" är inte giltig');
INSERT INTO `lang_definitions` VALUES (120, 125, 2, 'Ålder format för \"ålder upp till\" är inte giltig');
INSERT INTO `lang_definitions` VALUES (121, 126, 2, 'Ålder från');
INSERT INTO `lang_definitions` VALUES (122, 127, 2, 'Aging Kolumner:');
INSERT INTO `lang_definitions` VALUES (123, 128, 2, 'Alkohol');
INSERT INTO `lang_definitions` VALUES (124, 129, 2, 'Alkoholkonsumtion');
INSERT INTO `lang_definitions` VALUES (125, 130, 2, 'Alla');
INSERT INTO `lang_definitions` VALUES (126, 131, 2, 'Alla Kategorier');
INSERT INTO `lang_definitions` VALUES (127, 132, 2, 'All Day');
INSERT INTO `lang_definitions` VALUES (128, 133, 2, 'Heldagshändelse');
INSERT INTO `lang_definitions` VALUES (129, 134, 2, 'Alla kliniker');
INSERT INTO `lang_definitions` VALUES (130, 135, 2, 'Hela eller del av förnamn');
INSERT INTO `lang_definitions` VALUES (131, 136, 2, 'Hela eller del av efternamnet');
INSERT INTO `lang_definitions` VALUES (132, 137, 2, 'Alla leverantörer');
INSERT INTO `lang_definitions` VALUES (133, 138, 2, 'Alla granskade och Negativa:');
INSERT INTO `lang_definitions` VALUES (134, 139, 2, 'Alla ämnen');
INSERT INTO `lang_definitions` VALUES (135, 140, 2, 'Alla användare');
INSERT INTO `lang_definitions` VALUES (136, 141, 2, 'Allergiska');
INSERT INTO `lang_definitions` VALUES (137, 142, 2, 'Allergier');
INSERT INTO `lang_definitions` VALUES (138, 143, 2, 'Allergier: ');
INSERT INTO `lang_definitions` VALUES (139, 144, 2, 'Allergi');
INSERT INTO `lang_definitions` VALUES (140, 145, 2, 'E-mailkontakt tillåten?');
INSERT INTO `lang_definitions` VALUES (141, 146, 2, 'E-mailkontakt tillåten?');
INSERT INTO `lang_definitions` VALUES (142, 147, 2, 'Tillåt e-mail?');
INSERT INTO `lang_definitions` VALUES (143, 148, 2, 'Kontakt via brev tillåten?');
INSERT INTO `lang_definitions` VALUES (144, 149, 2, 'SMS-kontakt tillåten?');
INSERT INTO `lang_definitions` VALUES (145, 150, 2, 'SMS-kontakt tillåten?');
INSERT INTO `lang_definitions` VALUES (146, 151, 2, 'Tillåt skickade händelser att bli aktiva omedelbart? ');
INSERT INTO `lang_definitions` VALUES (147, 152, 2, 'Tillåt telefon meddelanden? ');
INSERT INTO `lang_definitions` VALUES (148, 153, 2, 'Tillåt användare att publicera Globala Händelser');
INSERT INTO `lang_definitions` VALUES (149, 154, 2, 'Tillåt användare att publicera personliga kalendrar ');
INSERT INTO `lang_definitions` VALUES (150, 155, 2, 'Medgivande till telefonsvarare');
INSERT INTO `lang_definitions` VALUES (151, 156, 2, 'Tillåten ');
INSERT INTO `lang_definitions` VALUES (152, 157, 2, 'Finns redan');
INSERT INTO `lang_definitions` VALUES (153, 158, 2, 'Används redan, välj en annan identitetsbeteckning ');
INSERT INTO `lang_definitions` VALUES (154, 159, 2, 'Används redan, välj en annan titel ');
INSERT INTO `lang_definitions` VALUES (155, 160, 2, 'Alt Adress ');
INSERT INTO `lang_definitions` VALUES (156, 162, 2, 'Alternativt kan du använda sökfunktionen sida att lägga upp en elektronisk remittance (X12 835) fil som du fått från din betalare eller clearingorganisationer. Du kan göra detta genom att klicka på knappen Bläddra och välj den fil som ska laddas upp och sedan klicka på Sök för att utföra de ladda upp och visa motsvarande fakturor. I detta fall är det andra parametrar som nämns ovan gäller inte och kommer att ignoreras. Överföring sparar filen menprocessar ännu inte innehållet - detta är gjort separat enligt nedan. ');
INSERT INTO `lang_definitions` VALUES (157, 163, 2, 'FM');
INSERT INTO `lang_definitions` VALUES (158, 164, 2, 'Ändra Befintlig notering');
INSERT INTO `lang_definitions` VALUES (159, 165, 2, 'AMEX ');
INSERT INTO `lang_definitions` VALUES (160, 166, 2, 'Belopp ');
INSERT INTO `lang_definitions` VALUES (161, 168, 2, 'Belopp för tidigare Saldo ');
INSERT INTO `lang_definitions` VALUES (162, 169, 2, 'Belopp för besöket ');
INSERT INTO `lang_definitions` VALUES (163, 170, 2, 'Belopp som betalts ');
INSERT INTO `lang_definitions` VALUES (164, 171, 2, 'Belopp: ');
INSERT INTO `lang_definitions` VALUES (165, 175, 2, 'En ofullständig GCAC fråga har inrättats och knutits. Någon kommer att behöva fylla i det senare.');
INSERT INTO `lang_definitions` VALUES (166, 176, 2, 'Och ');
INSERT INTO `lang_definitions` VALUES (167, 177, 2, 'OCH');
INSERT INTO `lang_definitions` VALUES (168, 178, 2, 'och');
INSERT INTO `lang_definitions` VALUES (169, 179, 2, 'och ');
INSERT INTO `lang_definitions` VALUES (170, 180, 2, 'och alla underordnade data? Denna åtgärd kommer att loggas ');
INSERT INTO `lang_definitions` VALUES (171, 181, 2, 'Anemi');
INSERT INTO `lang_definitions` VALUES (172, 182, 2, 'Ankle ');
INSERT INTO `lang_definitions` VALUES (173, 183, 2, 'Ankel + häl ');
INSERT INTO `lang_definitions` VALUES (174, 184, 2, 'Ankel Utvärderingsformulär ');
INSERT INTO `lang_definitions` VALUES (175, 185, 2, 'AnkelProblem ');
INSERT INTO `lang_definitions` VALUES (176, 186, 2, 'Ankyloserande Sondlilitis ');
INSERT INTO `lang_definitions` VALUES (177, 187, 2, 'Ankyloserande Spondlilitis ');
INSERT INTO `lang_definitions` VALUES (178, 188, 2, 'Anorexia ');
INSERT INTO `lang_definitions` VALUES (179, 189, 2, 'En annan sak du kan göra i utstationering fönstret är att begära en sekundära fakturering. Om du markerar rutan innan du sparar, så kommer den ursprungliga fordran att öppnas igen och köas på faktureringssidan och sedan behandlas under nästa faktureringskörning. ');
INSERT INTO `lang_definitions` VALUES (180, 191, 2, 'Anus, ingen rektal ömhet');
INSERT INTO `lang_definitions` VALUES (181, 192, 2, 'Ångest');
INSERT INTO `lang_definitions` VALUES (182, 193, 2, 'Valfri ');
INSERT INTO `lang_definitions` VALUES (183, 194, 2, 'någon Kategori');
INSERT INTO `lang_definitions` VALUES (184, 195, 2, 'Varje del av en kod eller dess beskrivning ');
INSERT INTO `lang_definitions` VALUES (185, 196, 2, 'Varje del av önskad specialitet');
INSERT INTO `lang_definitions` VALUES (186, 197, 2, 'Varje del av patientens namn, eller \"sista, första \" eller \"X-Y \" ');
INSERT INTO `lang_definitions` VALUES (187, 198, 2, 'Apnea');
INSERT INTO `lang_definitions` VALUES (188, 199, 2, 'Utseende ');
INSERT INTO `lang_definitions` VALUES (189, 200, 2, 'Utseende: ');
INSERT INTO `lang_definitions` VALUES (190, 201, 2, 'Lägg till den nuvarande noteringen');
INSERT INTO `lang_definitions` VALUES (191, 202, 2, 'Lägg till denna anmärkning');
INSERT INTO `lang_definitions` VALUES (192, 203, 2, 'Bifoga till denna notering');
INSERT INTO `lang_definitions` VALUES (193, 204, 2, 'Appendektomi');
INSERT INTO `lang_definitions` VALUES (194, 206, 2, 'tillämpas på berörda området ');
INSERT INTO `lang_definitions` VALUES (195, 207, 2, 'appliceras på huden ');
INSERT INTO `lang_definitions` VALUES (196, 209, 2, 'besöksdatum ');
INSERT INTO `lang_definitions` VALUES (197, 210, 2, 'besökssstatus ');
INSERT INTO `lang_definitions` VALUES (198, 211, 2, 'möte innom');
INSERT INTO `lang_definitions` VALUES (199, 212, 2, 'Möten');
INSERT INTO `lang_definitions` VALUES (200, 213, 2, 'Möten ( valfritt att skriva )');
INSERT INTO `lang_definitions` VALUES (201, 214, 2, 'Möten och besök');
INSERT INTO `lang_definitions` VALUES (202, 215, 2, 'Besöksrapport ');
INSERT INTO `lang_definitions` VALUES (203, 216, 2, 'Besöks och klientmöten Rapport ');
INSERT INTO `lang_definitions` VALUES (204, 217, 2, 'Godkänn ');
INSERT INTO `lang_definitions` VALUES (205, 218, 2, 'Godkänd');
INSERT INTO `lang_definitions` VALUES (206, 219, 2, 'Godkända administrativa händelser');
INSERT INTO `lang_definitions` VALUES (207, 220, 2, 'Möten-Besök');
INSERT INTO `lang_definitions` VALUES (208, 221, 2, 'Möten');
INSERT INTO `lang_definitions` VALUES (209, 222, 2, 'April');
INSERT INTO `lang_definitions` VALUES (210, 224, 2, 'Är du beredd att genomföra en ny GCAC fråga för detta besök? ');
INSERT INTO `lang_definitions` VALUES (211, 225, 2, 'Är du säker på att du vill godkänna dessa händelser?');
INSERT INTO `lang_definitions` VALUES (212, 226, 2, 'Är du säker på att du vill ta bort denna form? ');
INSERT INTO `lang_definitions` VALUES (213, 227, 2, 'Är du säker på att du vill ta bort denna händelse?');
INSERT INTO `lang_definitions` VALUES (214, 229, 2, 'Är du säker på att du vill ta bort detta meddelande? ');
INSERT INTO `lang_definitions` VALUES (215, 230, 2, 'Är du säker på att du vill ändra dessa händelser?');
INSERT INTO `lang_definitions` VALUES (216, 231, 2, 'Är du säker på att du vill dölja dessa händelser?');
INSERT INTO `lang_definitions` VALUES (217, 232, 2, 'Är du säker på att du vill visa dessa händelser?');
INSERT INTO `lang_definitions` VALUES (218, 233, 2, 'Är du säker på att du vill ta bort hela den valda gruppen ');
INSERT INTO `lang_definitions` VALUES (219, 234, 2, 'Är du säker på att du vill ta bort hela listan');
INSERT INTO `lang_definitions` VALUES (220, 235, 2, 'Är du säker på att du vill ta bort fältet i');
INSERT INTO `lang_definitions` VALUES (221, 236, 2, 'Är du säker på att du vill ta bort markerade fält?');
INSERT INTO `lang_definitions` VALUES (222, 237, 2, 'Är du säker på att du vill fortsätta med dessa åtgärder?');
INSERT INTO `lang_definitions` VALUES (223, 238, 2, 'Område är ej specifiserat');
INSERT INTO `lang_definitions` VALUES (224, 239, 2, 'Armensk');
INSERT INTO `lang_definitions` VALUES (225, 240, 2, 'Arrytmi');
INSERT INTO `lang_definitions` VALUES (226, 241, 2, 'Artrit');
INSERT INTO `lang_definitions` VALUES (227, 242, 2, 'Artrit / Degen ledsjukdom');
INSERT INTO `lang_definitions` VALUES (228, 243, 2, 'Artrit / Degen ledsjukdom');
INSERT INTO `lang_definitions` VALUES (229, 244, 2, 'som');
INSERT INTO `lang_definitions` VALUES (230, 245, 2, 'Per');
INSERT INTO `lang_definitions` VALUES (231, 246, 2, 'Asiatisk');
INSERT INTO `lang_definitions` VALUES (232, 247, 2, 'Bedömning');
INSERT INTO `lang_definitions` VALUES (233, 248, 2, 'Tilldelas');
INSERT INTO `lang_definitions` VALUES (234, 249, 2, 'Assistent');
INSERT INTO `lang_definitions` VALUES (235, 250, 2, 'Astma');
INSERT INTO `lang_definitions` VALUES (236, 251, 2, 'på');
INSERT INTO `lang_definitions` VALUES (237, 252, 2, 'Vid Båtbenet');
INSERT INTO `lang_definitions` VALUES (238, 253, 2, 'Vid Båtbenet:');
INSERT INTO `lang_definitions` VALUES (239, 254, 2, 'Atletisk / Skada');
INSERT INTO `lang_definitions` VALUES (240, 255, 2, 'Uppmärksamhet');
INSERT INTO `lang_definitions` VALUES (241, 256, 2, 'OBS');
INSERT INTO `lang_definitions` VALUES (242, 257, 2, 'Augusti');
INSERT INTO `lang_definitions` VALUES (243, 258, 2, 'Auth');
INSERT INTO `lang_definitions` VALUES (244, 259, 2, 'Författare/Noteringar');
INSERT INTO `lang_definitions` VALUES (245, 260, 2, 'Tillstånd');
INSERT INTO `lang_definitions` VALUES (246, 261, 2, 'Bemyndiga');
INSERT INTO `lang_definitions` VALUES (247, 262, 2, 'Auktorisera - möte (alla)');
INSERT INTO `lang_definitions` VALUES (248, 263, 2, 'Auktorisera - Mina möten');
INSERT INTO `lang_definitions` VALUES (249, 264, 2, 'Auktoriserad');
INSERT INTO `lang_definitions` VALUES (250, 265, 2, 'Skicka automatiskt');
INSERT INTO `lang_definitions` VALUES (251, 266, 2, 'Autogenererad');
INSERT INTO `lang_definitions` VALUES (252, 267, 2, 'Automobilemedicin');
INSERT INTO `lang_definitions` VALUES (253, 268, 2, 'Sparad automatisk');
INSERT INTO `lang_definitions` VALUES (254, 269, 2, 'Tillgängliga tider');
INSERT INTO `lang_definitions` VALUES (255, 270, 2, 'Avulsion / avulsion fraktur');
INSERT INTO `lang_definitions` VALUES (256, 271, 2, 'Avulsion laterala malleolus');
INSERT INTO `lang_definitions` VALUES (257, 272, 2, 'Avulsion mediala malleolus');
INSERT INTO `lang_definitions` VALUES (258, 273, 2, 'Medvetandebaserad');
INSERT INTO `lang_definitions` VALUES (259, 274, 2, 'Axillär');
INSERT INTO `lang_definitions` VALUES (260, 275, 2, '2 ggr/dag');
INSERT INTO `lang_definitions` VALUES (261, 276, 2, 'tillbaka');
INSERT INTO `lang_definitions` VALUES (262, 277, 2, 'Tillbaka');
INSERT INTO `lang_definitions` VALUES (263, 284, 2, 'Ryggproblem');
INSERT INTO `lang_definitions` VALUES (264, 287, 2, 'Ryggkirurgi');
INSERT INTO `lang_definitions` VALUES (265, 292, 2, 'Backup');
INSERT INTO `lang_definitions` VALUES (266, 293, 2, 'Backup-filen har skapats. Kommer nu skicka till nedladdning.');
INSERT INTO `lang_definitions` VALUES (267, 294, 2, 'Dålig kontroll');
INSERT INTO `lang_definitions` VALUES (268, 295, 2, 'Kundförluster');
INSERT INTO `lang_definitions` VALUES (269, 296, 2, 'Bahasa Indonesia');
INSERT INTO `lang_definitions` VALUES (270, 297, 2, 'Bal');
INSERT INTO `lang_definitions` VALUES (271, 298, 2, 'Saldo');
INSERT INTO `lang_definitions` VALUES (272, 299, 2, 'saldo');
INSERT INTO `lang_definitions` VALUES (273, 300, 2, 'Restskuld');
INSERT INTO `lang_definitions` VALUES (274, 301, 2, 'Basen av femte (5e) Metarsal');
INSERT INTO `lang_definitions` VALUES (275, 302, 2, 'Basen av femte (5e) Metarsal');
INSERT INTO `lang_definitions` VALUES (276, 303, 2, 'Batchkummunikationsverktyg');
INSERT INTO `lang_definitions` VALUES (277, 304, 2, 'Batchprocess påbörjad, detta kan ta ett tag.');
INSERT INTO `lang_definitions` VALUES (278, 305, 2, 'BatchCom');
INSERT INTO `lang_definitions` VALUES (279, 306, 2, 'För att ID inte existerar');
INSERT INTO `lang_definitions` VALUES (280, 307, 2, 'Starta');
INSERT INTO `lang_definitions` VALUES (281, 308, 2, 'Startdatum');
INSERT INTO `lang_definitions` VALUES (282, 309, 2, 'Tjänstens startdatum åååå-mm-dd');
INSERT INTO `lang_definitions` VALUES (283, 310, 2, 'Rapningar');
INSERT INTO `lang_definitions` VALUES (284, 311, 2, 'Mellan');
INSERT INTO `lang_definitions` VALUES (285, 312, 2, 'Bilaterala:');
INSERT INTO `lang_definitions` VALUES (286, 313, 2, 'Fakturadatumatum:');
INSERT INTO `lang_definitions` VALUES (287, 314, 2, 'Faktura');
INSERT INTO `lang_definitions` VALUES (288, 315, 2, 'Fakturerade');
INSERT INTO `lang_definitions` VALUES (289, 316, 2, 'Faktureringspreferenser');
INSERT INTO `lang_definitions` VALUES (290, 317, 2, 'Fakturering (skriv alternativ)');
INSERT INTO `lang_definitions` VALUES (291, 318, 2, 'Faktureringspreferenser Attn');
INSERT INTO `lang_definitions` VALUES (292, 319, 2, 'Betalningskod för begärd service');
INSERT INTO `lang_definitions` VALUES (293, 320, 2, 'Betalningskoder');
INSERT INTO `lang_definitions` VALUES (294, 321, 2, 'Faktureringsinformation');
INSERT INTO `lang_definitions` VALUES (295, 322, 2, 'Faktureringsadress');
INSERT INTO `lang_definitions` VALUES (296, 323, 2, 'Faktureringspreferenser Anmärkning');
INSERT INTO `lang_definitions` VALUES (297, 324, 2, 'Faktureringspreferenser anmärkning för');
INSERT INTO `lang_definitions` VALUES (298, 325, 2, 'Faktureringspreferenser Obs!');
INSERT INTO `lang_definitions` VALUES (299, 326, 2, 'Faktureringspreferenser kö resultat:');
INSERT INTO `lang_definitions` VALUES (300, 327, 2, 'Faktureringsrapport');
INSERT INTO `lang_definitions` VALUES (301, 328, 2, 'fakturera till');
INSERT INTO `lang_definitions` VALUES (302, 329, 2, 'Biopsi');
INSERT INTO `lang_definitions` VALUES (303, 330, 2, 'Födelsedatum');
INSERT INTO `lang_definitions` VALUES (304, 331, 2, 'Svart');
INSERT INTO `lang_definitions` VALUES (305, 332, 2, 'Cancer i urinblåsan');
INSERT INTO `lang_definitions` VALUES (306, 333, 2, 'Infektioner i urinblåsan');
INSERT INTO `lang_definitions` VALUES (307, 334, 2, 'Blankt formulär');
INSERT INTO `lang_definitions` VALUES (308, 335, 2, 'Problem med blödning');
INSERT INTO `lang_definitions` VALUES (309, 336, 2, 'Blinda punkter');
INSERT INTO `lang_definitions` VALUES (310, 337, 2, 'Svullnad');
INSERT INTO `lang_definitions` VALUES (311, 338, 2, 'Blockerade');
INSERT INTO `lang_definitions` VALUES (312, 339, 2, 'Blodtryck');
INSERT INTO `lang_definitions` VALUES (313, 340, 2, 'Blodtryck');
INSERT INTO `lang_definitions` VALUES (314, 341, 2, 'Näsblod');
INSERT INTO `lang_definitions` VALUES (315, 342, 2, 'Blått kors blå sköld');
INSERT INTO `lang_definitions` VALUES (316, 343, 2, 'Blå linjerna i denna rapport är informativa. Svarta linjer visar tidigare information. Gröna linjerna visar förändringar som tillämpats framgångsrikt. Röda linjer visar fel eller förändringar som inte har genomförts, och dessa måste behandlas manuellt. För närvarande nekas fordringar och betalning reverseringar inte hanteras automatiskt och det kommer att visas i rött.');
INSERT INTO `lang_definitions` VALUES (317, 344, 2, 'Dimsyn');
INSERT INTO `lang_definitions` VALUES (318, 345, 2, 'BMI');
INSERT INTO `lang_definitions` VALUES (319, 346, 2, 'BMI status');
INSERT INTO `lang_definitions` VALUES (320, 347, 2, 'kroppsregion');
INSERT INTO `lang_definitions` VALUES (321, 348, 2, 'Benömhet: ');
INSERT INTO `lang_definitions` VALUES (322, 349, 2, 'Benömhet: Malleoulus Medialis');
INSERT INTO `lang_definitions` VALUES (323, 350, 2, 'Boolean');
INSERT INTO `lang_definitions` VALUES (324, 352, 2, 'Båda öronen');
INSERT INTO `lang_definitions` VALUES (325, 353, 2, 'båda öronen');
INSERT INTO `lang_definitions` VALUES (326, 354, 2, 'Botten');
INSERT INTO `lang_definitions` VALUES (327, 355, 2, 'RUTA 10 A. sysselsättningsrelaterad');
INSERT INTO `lang_definitions` VALUES (328, 356, 2, 'RUTA 10 B. Bilolycka');
INSERT INTO `lang_definitions` VALUES (329, 357, 2, 'RUTA 10 C. Övriga olyckor');
INSERT INTO `lang_definitions` VALUES (330, 358, 2, 'FÄLT 16. Datum, oförmögen till arbete från (åååå-mm-dd):');
INSERT INTO `lang_definitions` VALUES (331, 359, 2, 'FÄLT 16. Datum, oförmögen att arbeta tills (åååå-mm-dd):');
INSERT INTO `lang_definitions` VALUES (332, 360, 2, 'FÄLT 18. Sjukhusvistelse datum, från (åååå-mm-dd):');
INSERT INTO `lang_definitions` VALUES (333, 361, 2, 'FÄLT 18. Sjukhusvistelse till, datum (åååå-mm-dd):');
INSERT INTO `lang_definitions` VALUES (334, 362, 2, 'FÄLT 20. Ligger utanför Lab användas?');
INSERT INTO `lang_definitions` VALUES (335, 366, 2, 'BT Diastoliskt');
INSERT INTO `lang_definitions` VALUES (336, 367, 2, 'BT Systoliskt');
INSERT INTO `lang_definitions` VALUES (337, 368, 2, 'BPD');
INSERT INTO `lang_definitions` VALUES (338, 369, 2, 'Puls');
INSERT INTO `lang_definitions` VALUES (339, 370, 2, 'Brasiliansk portugisiska');
INSERT INTO `lang_definitions` VALUES (340, 371, 2, 'Bröst');
INSERT INTO `lang_definitions` VALUES (341, 372, 2, 'Bröst Biopsi');
INSERT INTO `lang_definitions` VALUES (342, 373, 2, 'Bröstlossning');
INSERT INTO `lang_definitions` VALUES (343, 374, 2, 'Bröstsjukdom');
INSERT INTO `lang_definitions` VALUES (344, 375, 2, 'Bröstundersökning');
INSERT INTO `lang_definitions` VALUES (345, 376, 2, 'Bröstvävnad');
INSERT INTO `lang_definitions` VALUES (346, 377, 2, 'Andningsljud:');
INSERT INTO `lang_definitions` VALUES (347, 378, 2, 'Brutna ben');
INSERT INTO `lang_definitions` VALUES (348, 379, 2, 'Bronkit Formulär');
INSERT INTO `lang_definitions` VALUES (349, 380, 2, 'Bläddra');
INSERT INTO `lang_definitions` VALUES (350, 381, 2, 'Bläddra efter journal');
INSERT INTO `lang_definitions` VALUES (351, 382, 2, 'Blåmärken / hematom');
INSERT INTO `lang_definitions` VALUES (352, 383, 2, 'Utbuktningen Höger:');
INSERT INTO `lang_definitions` VALUES (353, 384, 2, 'Sveda vid vattenkastning');
INSERT INTO `lang_definitions` VALUES (354, 385, 2, 'Sveda vid urinering');
INSERT INTO `lang_definitions` VALUES (355, 386, 2, 'Upptagen');
INSERT INTO `lang_definitions` VALUES (356, 387, 2, 'Skinkan + S.I.');
INSERT INTO `lang_definitions` VALUES (357, 388, 2, 'via');
INSERT INTO `lang_definitions` VALUES (358, 389, 2, 'via munnen');
INSERT INTO `lang_definitions` VALUES (359, 390, 2, 'Genom / Källa');
INSERT INTO `lang_definitions` VALUES (360, 391, 2, 'Av:');
INSERT INTO `lang_definitions` VALUES (361, 392, 2, 'C');
INSERT INTO `lang_definitions` VALUES (362, 393, 2, 'Cache, livstid (i sekunder)');
INSERT INTO `lang_definitions` VALUES (363, 394, 2, 'Cache template output?');
INSERT INTO `lang_definitions` VALUES (364, 395, 2, 'Koffein konsumsion');
INSERT INTO `lang_definitions` VALUES (365, 396, 2, 'Kalender');
INSERT INTO `lang_definitions` VALUES (366, 397, 2, 'Kalenderinställningar');
INSERT INTO `lang_definitions` VALUES (367, 398, 2, 'Kalender UI');
INSERT INTO `lang_definitions` VALUES (368, 399, 2, 'Kalendervy');
INSERT INTO `lang_definitions` VALUES (369, 400, 2, 'Call to addForm() goes here.<br>');
INSERT INTO `lang_definitions` VALUES (370, 402, 2, 'CAMOS');
INSERT INTO `lang_definitions` VALUES (371, 403, 2, 'Avbryt');
INSERT INTO `lang_definitions` VALUES (372, 404, 2, 'Cancer');
INSERT INTO `lang_definitions` VALUES (373, 405, 2, 'Det går ej att lägga till detta för att det redan existerar!');
INSERT INTO `lang_definitions` VALUES (374, 406, 2, 'Kan inte lägga till / uppdatera den här posten eftersom duplikat redan finns!');
INSERT INTO `lang_definitions` VALUES (375, 407, 2, 'kan inte konverteras till JPEG. Kanske ImageMagick inte är installerad?');
INSERT INTO `lang_definitions` VALUES (376, 408, 2, 'kan inte visas inline eftersom den typen stöds inte av webbläsaren. ');
INSERT INTO `lang_definitions` VALUES (377, 409, 2, 'kan inte visas inline eftersom den typen stöds inte av webbläsaren. ');
INSERT INTO `lang_definitions` VALUES (378, 410, 2, 'kan inte visas inline eftersom den typen stöds inte av webbläsaren. ');
INSERT INTO `lang_definitions` VALUES (379, 411, 2, 'Det går inte att skapa');
INSERT INTO `lang_definitions` VALUES (380, 412, 2, 'Kan ej hitta');
INSERT INTO `lang_definitions` VALUES (381, 413, 2, 'Kan inte hitta patienten från SQL-Reskontra kundnummer');
INSERT INTO `lang_definitions` VALUES (382, 414, 2, 'Kan ej hitta postscript dokumenthänvisning i');
INSERT INTO `lang_definitions` VALUES (383, 415, 2, 'Kan inte hitta patienten från SQL-Reskontra arbetsgivare');
INSERT INTO `lang_definitions` VALUES (384, 416, 2, 'Går inte att öppna');
INSERT INTO `lang_definitions` VALUES (385, 417, 2, 'Kan ej läsa');
INSERT INTO `lang_definitions` VALUES (386, 418, 2, 'Kan inte uppdatera eftersom du inte redigera en befintlig post!');
INSERT INTO `lang_definitions` VALUES (387, 419, 2, 'kapsel');
INSERT INTO `lang_definitions` VALUES (388, 420, 2, 'Cardiac Katetrisering');
INSERT INTO `lang_definitions` VALUES (389, 421, 2, 'Cardiac Echo');
INSERT INTO `lang_definitions` VALUES (390, 422, 2, 'Kardiovaskulära');
INSERT INTO `lang_definitions` VALUES (391, 423, 2, 'Cartilage / chondral / skiva skador');
INSERT INTO `lang_definitions` VALUES (392, 424, 2, 'Cartilago skada');
INSERT INTO `lang_definitions` VALUES (393, 426, 2, 'kontanter');
INSERT INTO `lang_definitions` VALUES (394, 427, 2, 'Kontanter');
INSERT INTO `lang_definitions` VALUES (395, 429, 2, 'Inbetalningar av Provider');
INSERT INTO `lang_definitions` VALUES (396, 430, 2, 'Kataraktkirurgi');
INSERT INTO `lang_definitions` VALUES (397, 431, 2, 'Katarakt');
INSERT INTO `lang_definitions` VALUES (398, 432, 2, 'Kategorier');
INSERT INTO `lang_definitions` VALUES (399, 433, 2, 'Kategori');
INSERT INTO `lang_definitions` VALUES (400, 434, 2, 'kategori');
INSERT INTO `lang_definitions` VALUES (401, 435, 2, 'Kategori');
INSERT INTO `lang_definitions` VALUES (402, 436, 2, 'Kategori Detaljer');
INSERT INTO `lang_definitions` VALUES (403, 437, 2, 'Kategori Gränser');
INSERT INTO `lang_definitions` VALUES (404, 438, 2, 'Kategorinamn');
INSERT INTO `lang_definitions` VALUES (405, 439, 2, 'Kaukasisk');
INSERT INTO `lang_definitions` VALUES (406, 440, 2, 'Mobiltelefon');
INSERT INTO `lang_definitions` VALUES (407, 441, 2, 'Mobiltelefonnummer');
INSERT INTO `lang_definitions` VALUES (408, 442, 2, 'Central Certifiering');
INSERT INTO `lang_definitions` VALUES (409, 443, 2, 'cfirst($instype) . \' Ins');
INSERT INTO `lang_definitions` VALUES (410, 444, 2, 'ChampUS');
INSERT INTO `lang_definitions` VALUES (411, 445, 2, 'ChampUSVA');
INSERT INTO `lang_definitions` VALUES (412, 446, 2, 'ändra');
INSERT INTO `lang_definitions` VALUES (413, 448, 2, 'Ändra Aktivitet');
INSERT INTO `lang_definitions` VALUES (414, 449, 2, 'Förändrat synsätt');
INSERT INTO `lang_definitions` VALUES (415, 451, 2, 'Förändrad');
INSERT INTO `lang_definitions` VALUES (416, 452, 2, 'Förändrad tarm');
INSERT INTO `lang_definitions` VALUES (417, 453, 2, 'Avgift');
INSERT INTO `lang_definitions` VALUES (418, 454, 2, 'Avgifter');
INSERT INTO `lang_definitions` VALUES (419, 455, 2, 'Diagram');
INSERT INTO `lang_definitions` VALUES (420, 456, 2, 'Diagram aktivitet');
INSERT INTO `lang_definitions` VALUES (421, 457, 2, 'Diagram Check-in/out Aktivitetsrapport');
INSERT INTO `lang_definitions` VALUES (422, 458, 2, 'Diagram ID');
INSERT INTO `lang_definitions` VALUES (423, 459, 2, 'Diagram-id:');
INSERT INTO `lang_definitions` VALUES (424, 460, 2, 'Diagram Läge Aktivitet');
INSERT INTO `lang_definitions` VALUES (425, 461, 2, 'Diagramanteckning');
INSERT INTO `lang_definitions` VALUES (426, 462, 2, 'Diagramlagringsplats');
INSERT INTO `lang_definitions` VALUES (427, 463, 2, 'Diagramtracker');
INSERT INTO `lang_definitions` VALUES (428, 464, 2, 'Diagramtrk.');
INSERT INTO `lang_definitions` VALUES (429, 465, 2, 'Diagram utcheckat');
INSERT INTO `lang_definitions` VALUES (430, 467, 2, 'Kontroll');
INSERT INTO `lang_definitions` VALUES (431, 468, 2, 'Kontroll');
INSERT INTO `lang_definitions` VALUES (432, 469, 2, 'Kontrollera alla');
INSERT INTO `lang_definitions` VALUES (433, 470, 2, 'checka in till');
INSERT INTO `lang_definitions` VALUES (434, 471, 2, 'Kontrollera indata');
INSERT INTO `lang_definitions` VALUES (435, 472, 2, 'Kontrollnummer');
INSERT INTO `lang_definitions` VALUES (436, 473, 2, 'Kontrollera / EOB Datum:');
INSERT INTO `lang_definitions` VALUES (437, 474, 2, 'Kontrollera / EOB Antal:');
INSERT INTO `lang_definitions` VALUES (438, 475, 2, 'Kontrollera / Ref Antal');
INSERT INTO `lang_definitions` VALUES (439, 476, 2, 'Kontrollera / Referensnummer');
INSERT INTO `lang_definitions` VALUES (440, 478, 2, 'Checkboxlista');
INSERT INTO `lang_definitions` VALUES (441, 479, 2, 'checkbox w/ text');
INSERT INTO `lang_definitions` VALUES (442, 481, 2, 'Markerade fält = ja, tom = nej');
INSERT INTO `lang_definitions` VALUES (443, 482, 2, 'Kassa');
INSERT INTO `lang_definitions` VALUES (444, 483, 2, 'Bröst');
INSERT INTO `lang_definitions` VALUES (445, 484, 2, 'Chest CTAB');
INSERT INTO `lang_definitions` VALUES (446, 485, 2, 'Bröstsmärtor');
INSERT INTO `lang_definitions` VALUES (447, 486, 2, 'Bröstsmärta:');
INSERT INTO `lang_definitions` VALUES (448, 487, 2, 'Bröstsmärtor');
INSERT INTO `lang_definitions` VALUES (449, 488, 2, 'Chg');
INSERT INTO `lang_definitions` VALUES (450, 490, 2, 'Barn');
INSERT INTO `lang_definitions` VALUES (451, 491, 2, 'Frossbrytningar');
INSERT INTO `lang_definitions` VALUES (452, 492, 2, 'Kinesiska');
INSERT INTO `lang_definitions` VALUES (453, 493, 2, 'Valmöjligheter');
INSERT INTO `lang_definitions` VALUES (454, 494, 2, 'Cholecystectomia');
INSERT INTO `lang_definitions` VALUES (455, 495, 2, 'Cholecystotomia');
INSERT INTO `lang_definitions` VALUES (456, 496, 2, 'Välj');
INSERT INTO `lang_definitions` VALUES (457, 497, 2, 'Välj ett avsnitt och klicka på ett objekt i den; Då, i den andra sektionen visas relaterade objekt. Klicka på avsnitten om du vill lägga till och ta bort relationer.');
INSERT INTO `lang_definitions` VALUES (458, 498, 2, 'Välj lista');
INSERT INTO `lang_definitions` VALUES (459, 500, 2, 'Kronisk bronkit');
INSERT INTO `lang_definitions` VALUES (460, 501, 2, 'Kronisk ledvärk');
INSERT INTO `lang_definitions` VALUES (461, 502, 2, 'Kronisk synovit / effusion / ledvärk / gikt');
INSERT INTO `lang_definitions` VALUES (462, 503, 2, 'Kronisk / Återkommande');
INSERT INTO `lang_definitions` VALUES (463, 504, 2, 'Leverciros');
INSERT INTO `lang_definitions` VALUES (464, 505, 2, 'Levercirros');
INSERT INTO `lang_definitions` VALUES (465, 506, 2, 'Stad');
INSERT INTO `lang_definitions` VALUES (466, 507, 2, 'Stadsnamn');
INSERT INTO `lang_definitions` VALUES (467, 508, 2, 'Stad, stat');
INSERT INTO `lang_definitions` VALUES (468, 509, 2, 'Stad, stat Zip');
INSERT INTO `lang_definitions` VALUES (469, 510, 2, 'Stad / stat');
INSERT INTO `lang_definitions` VALUES (470, 512, 2, 'Påstå');
INSERT INTO `lang_definitions` VALUES (471, 515, 2, 'Klassificering');
INSERT INTO `lang_definitions` VALUES (472, 516, 2, 'Rensa');
INSERT INTO `lang_definitions` VALUES (473, 517, 2, 'Rensa allt');
INSERT INTO `lang_definitions` VALUES (474, 518, 2, 'Rensa Motivering');
INSERT INTO `lang_definitions` VALUES (475, 519, 2, 'Rensa Smarty Cache');
INSERT INTO `lang_definitions` VALUES (476, 520, 2, 'CLIA Antal');
INSERT INTO `lang_definitions` VALUES (477, 521, 2, 'Klicka');
INSERT INTO `lang_definitions` VALUES (478, 523, 2, 'Klicka för mer');
INSERT INTO `lang_definitions` VALUES (479, 524, 2, 'Klicka här för att välja ett datum');
INSERT INTO `lang_definitions` VALUES (480, 525, 2, 'Klicka här för att uppdatera prioritet, kategori och smeknamn inställningar');
INSERT INTO `lang_definitions` VALUES (481, 526, 2, 'Klicka här, för att se alla.');
INSERT INTO `lang_definitions` VALUES (482, 527, 2, 'Klicka för att ladda ner');
INSERT INTO `lang_definitions` VALUES (483, 528, 2, 'Klicka för att ändra');
INSERT INTO `lang_definitions` VALUES (484, 529, 2, 'Klicka för att ändra denna händelse');
INSERT INTO `lang_definitions` VALUES (485, 530, 2, 'Klicka för att generera rapporten');
INSERT INTO `lang_definitions` VALUES (486, 531, 2, 'Klicka för att printa');
INSERT INTO `lang_definitions` VALUES (487, 532, 2, 'Klicka för att lägga till/få ny lot');
INSERT INTO `lang_definitions` VALUES (488, 533, 2, 'Klicka för att välja');
INSERT INTO `lang_definitions` VALUES (489, 534, 2, 'Klicka för att välja eller ändra diagnoser');
INSERT INTO `lang_definitions` VALUES (490, 535, 2, 'Klicka för att välja patient');
INSERT INTO `lang_definitions` VALUES (491, 536, 2, 'Klicka för att välja tillhörande kod');
INSERT INTO `lang_definitions` VALUES (492, 537, 2, 'Klicka för att titta');
INSERT INTO `lang_definitions` VALUES (493, 538, 2, 'Klicka för att visa eller redigera');
INSERT INTO `lang_definitions` VALUES (494, 539, 2, 'Klicka för visa/redigera');
INSERT INTO `lang_definitions` VALUES (495, 540, 2, 'Klicka på:');
INSERT INTO `lang_definitions` VALUES (496, 542, 2, 'Sammanfattning av klientens sjukdomshistoria');
INSERT INTO `lang_definitions` VALUES (497, 543, 2, 'Klientprofil - Ny Klient');
INSERT INTO `lang_definitions` VALUES (498, 544, 2, 'Klientprofil - Unika klienter');
INSERT INTO `lang_definitions` VALUES (499, 545, 2, 'Kunder');
INSERT INTO `lang_definitions` VALUES (500, 546, 2, 'Klinik');
INSERT INTO `lang_definitions` VALUES (501, 548, 2, 'Kliniken Daily Record');
INSERT INTO `lang_definitions` VALUES (502, 549, 2, 'Klinik ID');
INSERT INTO `lang_definitions` VALUES (503, 550, 2, 'Klinikmedverkande');
INSERT INTO `lang_definitions` VALUES (504, 553, 2, 'Stäng');
INSERT INTO `lang_definitions` VALUES (505, 554, 2, 'Stäng fönstret');
INSERT INTO `lang_definitions` VALUES (506, 555, 2, 'Stängt');
INSERT INTO `lang_definitions` VALUES (507, 556, 2, 'cm');
INSERT INTO `lang_definitions` VALUES (508, 558, 2, 'CMS-id');
INSERT INTO `lang_definitions` VALUES (509, 559, 2, 'CN2-12 intakta');
INSERT INTO `lang_definitions` VALUES (510, 560, 2, 'Kod');
INSERT INTO `lang_definitions` VALUES (511, 561, 2, 'kod');
INSERT INTO `lang_definitions` VALUES (512, 562, 2, 'Kodsökare');
INSERT INTO `lang_definitions` VALUES (513, 563, 2, 'Kod måste vara två bokstäver (gemener)');
INSERT INTO `lang_definitions` VALUES (514, 564, 2, 'Kodtyp');
INSERT INTO `lang_definitions` VALUES (515, 565, 2, 'Koder');
INSERT INTO `lang_definitions` VALUES (516, 566, 2, 'Kodning');
INSERT INTO `lang_definitions` VALUES (517, 567, 2, 'Coding - any encounters (write,wsome optional)');
INSERT INTO `lang_definitions` VALUES (518, 568, 2, 'Coding - my encounters (write,wsome optional)');
INSERT INTO `lang_definitions` VALUES (519, 569, 2, 'Kodning ej godkänd');
INSERT INTO `lang_definitions` VALUES (520, 570, 2, 'Kaffe');
INSERT INTO `lang_definitions` VALUES (521, 571, 2, 'Förf.saml w / o');
INSERT INTO `lang_definitions` VALUES (522, 572, 2, 'Komprimera alla');
INSERT INTO `lang_definitions` VALUES (523, 573, 2, 'Samlingar');
INSERT INTO `lang_definitions` VALUES (524, 574, 2, 'Samlingsrapport');
INSERT INTO `lang_definitions` VALUES (525, 575, 2, 'Koloncancer');
INSERT INTO `lang_definitions` VALUES (526, 576, 2, 'Koloncancer Kirurgi');
INSERT INTO `lang_definitions` VALUES (527, 577, 2, 'Kolonoskopi');
INSERT INTO `lang_definitions` VALUES (528, 578, 2, 'kolonoskopi');
INSERT INTO `lang_definitions` VALUES (529, 579, 2, 'Färg');
INSERT INTO `lang_definitions` VALUES (530, 580, 2, 'Kolumner');
INSERT INTO `lang_definitions` VALUES (531, 581, 2, 'Kommentarer');
INSERT INTO `lang_definitions` VALUES (532, 582, 2, 'Commercial Insurance Co');
INSERT INTO `lang_definitions` VALUES (533, 583, 2, 'Godkänn Ändringar');
INSERT INTO `lang_definitions` VALUES (534, 584, 2, 'Förbindelser');
INSERT INTO `lang_definitions` VALUES (535, 585, 2, 'Avslutat');
INSERT INTO `lang_definitions` VALUES (536, 586, 2, 'Komplikationer orsakade av vårdgivare');
INSERT INTO `lang_definitions` VALUES (537, 587, 2, 'Komplikationer av Abort');
INSERT INTO `lang_definitions` VALUES (538, 588, 2, 'Datorstödd Medical Ordering System');
INSERT INTO `lang_definitions` VALUES (539, 589, 2, 'Slutsatser');
INSERT INTO `lang_definitions` VALUES (540, 590, 2, 'Kongenital');
INSERT INTO `lang_definitions` VALUES (541, 591, 2, 'Conjuntiva, elever');
INSERT INTO `lang_definitions` VALUES (542, 592, 2, 'Konstant');
INSERT INTO `lang_definitions` VALUES (543, 593, 2, 'konstantnamn');
INSERT INTO `lang_definitions` VALUES (544, 594, 2, 'Konstanter');
INSERT INTO `lang_definitions` VALUES (545, 595, 2, 'Förstoppning');
INSERT INTO `lang_definitions` VALUES (546, 596, 2, 'Konstitutionella');
INSERT INTO `lang_definitions` VALUES (547, 597, 2, 'Konsultation, kortfattad beskrivning');
INSERT INTO `lang_definitions` VALUES (548, 598, 2, 'Kontakt');
INSERT INTO `lang_definitions` VALUES (549, 599, 2, 'E-postadress');
INSERT INTO `lang_definitions` VALUES (550, 600, 2, 'Kontak E-mail');
INSERT INTO `lang_definitions` VALUES (551, 601, 2, 'Kontaktinformation');
INSERT INTO `lang_definitions` VALUES (552, 602, 2, 'Kontaktlinser');
INSERT INTO `lang_definitions` VALUES (553, 603, 2, 'Kontaktnamn');
INSERT INTO `lang_definitions` VALUES (554, 604, 2, 'Kontaktperson');
INSERT INTO `lang_definitions` VALUES (555, 605, 2, 'Kontakttelefonnummer');
INSERT INTO `lang_definitions` VALUES (556, 606, 2, 'Innehåll');
INSERT INTO `lang_definitions` VALUES (557, 607, 2, 'innehåll');
INSERT INTO `lang_definitions` VALUES (558, 608, 2, 'Fortsätt');
INSERT INTO `lang_definitions` VALUES (559, 609, 2, 'kontraindikationer');
INSERT INTO `lang_definitions` VALUES (560, 610, 2, 'Preventivmedel');
INSERT INTO `lang_definitions` VALUES (561, 611, 2, 'Preventivmedelsproblematik');
INSERT INTO `lang_definitions` VALUES (562, 612, 2, 'Preventivmedelsproblematik (specificera)');
INSERT INTO `lang_definitions` VALUES (563, 613, 2, 'Preventivmedel Metod');
INSERT INTO `lang_definitions` VALUES (564, 614, 2, 'Preventivmedel, tjänster som tidigare startats');
INSERT INTO `lang_definitions` VALUES (565, 615, 2, 'Preventivmedel start');
INSERT INTO `lang_definitions` VALUES (566, 616, 2, 'Kontrollnum.');
INSERT INTO `lang_definitions` VALUES (567, 617, 2, 'Medbetalare');
INSERT INTO `lang_definitions` VALUES (568, 618, 2, 'Medbetalare');
INSERT INTO `lang_definitions` VALUES (569, 620, 2, 'Medbetalare');
INSERT INTO `lang_definitions` VALUES (570, 621, 2, 'COPD');
INSERT INTO `lang_definitions` VALUES (571, 622, 2, 'Kopiera Sidor till Patientdiagram');
INSERT INTO `lang_definitions` VALUES (572, 623, 2, 'Kopiera Värderingar');
INSERT INTO `lang_definitions` VALUES (573, 624, 2, 'Upphovsrättsskydd');
INSERT INTO `lang_definitions` VALUES (574, 625, 2, 'Coronary Artery Bypass');
INSERT INTO `lang_definitions` VALUES (575, 626, 2, 'Hosta');
INSERT INTO `lang_definitions` VALUES (576, 627, 2, 'Hosta:');
INSERT INTO `lang_definitions` VALUES (577, 628, 2, 'Kunde inte skicka e-post på grund av en server problem');
INSERT INTO `lang_definitions` VALUES (578, 633, 2, 'Couns av metod');
INSERT INTO `lang_definitions` VALUES (579, 634, 2, 'Rådgivning');
INSERT INTO `lang_definitions` VALUES (580, 635, 2, 'Rådgivning, Aktivitet');
INSERT INTO `lang_definitions` VALUES (581, 636, 2, 'svarsremiss, formulär');
INSERT INTO `lang_definitions` VALUES (582, 637, 2, 'Remisssvar');
INSERT INTO `lang_definitions` VALUES (583, 638, 2, 'Land');
INSERT INTO `lang_definitions` VALUES (584, 639, 2, 'Land, Lista');
INSERT INTO `lang_definitions` VALUES (585, 640, 2, 'county');
INSERT INTO `lang_definitions` VALUES (586, 641, 2, 'kupong');
INSERT INTO `lang_definitions` VALUES (587, 642, 2, 'CPT');
INSERT INTO `lang_definitions` VALUES (588, 643, 2, 'CPT Koder');
INSERT INTO `lang_definitions` VALUES (589, 644, 2, 'Sprickor:');
INSERT INTO `lang_definitions` VALUES (590, 645, 2, 'kräm');
INSERT INTO `lang_definitions` VALUES (591, 646, 2, 'Skapa en händelse');
INSERT INTO `lang_definitions` VALUES (592, 649, 2, 'Skapa ny patient');
INSERT INTO `lang_definitions` VALUES (593, 650, 2, 'Skapa Patientanteckning');
INSERT INTO `lang_definitions` VALUES (594, 651, 2, 'Skapad');
INSERT INTO `lang_definitions` VALUES (595, 653, 2, 'kredit');
INSERT INTO `lang_definitions` VALUES (596, 654, 2, 'Kredit');
INSERT INTO `lang_definitions` VALUES (597, 655, 2, 'Crohn\'s sjukdom');
INSERT INTO `lang_definitions` VALUES (598, 656, 2, 'Chrons sjukdom');
INSERT INTO `lang_definitions` VALUES (599, 657, 2, 'Csv-fil');
INSERT INTO `lang_definitions` VALUES (600, 658, 2, 'Pågående');
INSERT INTO `lang_definitions` VALUES (601, 659, 2, 'Pågående konsultation');
INSERT INTO `lang_definitions` VALUES (602, 660, 2, 'Aktuell dag i färg');
INSERT INTO `lang_definitions` VALUES (603, 661, 2, 'Nuvarande filnamn är ändrat till');
INSERT INTO `lang_definitions` VALUES (604, 662, 2, 'Nuvarande lokalisation');
INSERT INTO `lang_definitions` VALUES (605, 663, 2, 'Pågående patient');
INSERT INTO `lang_definitions` VALUES (606, 664, 2, 'För närvarande Aktiv');
INSERT INTO `lang_definitions` VALUES (607, 665, 2, 'Cushing Syndrom');
INSERT INTO `lang_definitions` VALUES (608, 666, 2, 'Cushings syndrom');
INSERT INTO `lang_definitions` VALUES (609, 667, 2, 'Custom');
INSERT INTO `lang_definitions` VALUES (610, 669, 2, 'CYP');
INSERT INTO `lang_definitions` VALUES (611, 670, 2, 'CYP Factor');
INSERT INTO `lang_definitions` VALUES (612, 671, 2, 'CYP Rapport');
INSERT INTO `lang_definitions` VALUES (613, 672, 2, 'D');
INSERT INTO `lang_definitions` VALUES (614, 673, 2, 'D & C');
INSERT INTO `lang_definitions` VALUES (615, 674, 2, 'D & E');
INSERT INTO `lang_definitions` VALUES (616, 675, 2, 'D.O.B.');
INSERT INTO `lang_definitions` VALUES (617, 676, 2, 'dagligen');
INSERT INTO `lang_definitions` VALUES (618, 677, 2, 'Liknande data finns redan i databasen, ändra koden och / eller beskrivning');
INSERT INTO `lang_definitions` VALUES (619, 678, 2, 'Liknande data finns redan i databasen, ändra koden och / eller beskrivning');
INSERT INTO `lang_definitions` VALUES (620, 679, 2, 'Data Cols');
INSERT INTO `lang_definitions` VALUES (621, 680, 2, 'Datattyp');
INSERT INTO `lang_definitions` VALUES (622, 681, 2, 'Databas');
INSERT INTO `lang_definitions` VALUES (623, 682, 2, 'Databasrapportering');
INSERT INTO `lang_definitions` VALUES (624, 683, 2, 'Datacols måste ha ett nummer mellan 1 och 999');
INSERT INTO `lang_definitions` VALUES (625, 684, 2, 'Datum');
INSERT INTO `lang_definitions` VALUES (626, 685, 2, 'DATUM');
INSERT INTO `lang_definitions` VALUES (627, 686, 2, 'Administreringsdatum');
INSERT INTO `lang_definitions` VALUES (628, 687, 2, 'Datum då preventivmeddel insattes för första gången');
INSERT INTO `lang_definitions` VALUES (629, 688, 2, 'Förstörd datum');
INSERT INTO `lang_definitions` VALUES (630, 689, 2, 'Date Display Format');
INSERT INTO `lang_definitions` VALUES (631, 690, 2, 'Datumformat för \"mötet slutar\" är inte giltigt');
INSERT INTO `lang_definitions` VALUES (632, 691, 2, 'Datumformat för \"mötet startat \"är inte giltig');
INSERT INTO `lang_definitions` VALUES (633, 692, 2, 'Datumformat för \"Nästa Möte\" är inte giltig');
INSERT INTO `lang_definitions` VALUES (634, 693, 2, 'Datumformat för \"sista besök\" är inte giltig');
INSERT INTO `lang_definitions` VALUES (635, 694, 2, 'Datumformat för \"sista besök\" är inte giltig');
INSERT INTO `lang_definitions` VALUES (636, 695, 2, 'Datum för vaccinationsinformation ');
INSERT INTO `lang_definitions` VALUES (637, 696, 2, 'Datum saknas för kod');
INSERT INTO `lang_definitions` VALUES (638, 697, 2, 'Datum för bankinsättning åååå-mm-dd');
INSERT INTO `lang_definitions` VALUES (639, 698, 2, 'Födelsedatum');
INSERT INTO `lang_definitions` VALUES (640, 699, 2, 'Födelsedatum');
INSERT INTO `lang_definitions` VALUES (641, 700, 2, 'Datum för skada');
INSERT INTO `lang_definitions` VALUES (642, 701, 2, 'Datum för betalning åååå-mm-dd');
INSERT INTO `lang_definitions` VALUES (643, 702, 2, 'Remissdatum');
INSERT INTO `lang_definitions` VALUES (644, 703, 2, 'Svarsdatum');
INSERT INTO `lang_definitions` VALUES (645, 704, 2, 'Datum för tjänst');
INSERT INTO `lang_definitions` VALUES (646, 705, 2, 'Datum för tjänst MM / DD / ÅÅÅÅ');
INSERT INTO `lang_definitions` VALUES (647, 706, 2, 'Datum för tjänst:');
INSERT INTO `lang_definitions` VALUES (648, 708, 2, 'Ej tilldelad');
INSERT INTO `lang_definitions` VALUES (649, 710, 2, 'Datum/anteckningar');
INSERT INTO `lang_definitions` VALUES (650, 711, 2, 'Datum / Anteckningar, senast');
INSERT INTO `lang_definitions` VALUES (651, 712, 2, 'Datum:');
INSERT INTO `lang_definitions` VALUES (652, 713, 2, 'dag');
INSERT INTO `lang_definitions` VALUES (653, 714, 2, 'Dag');
INSERT INTO `lang_definitions` VALUES (654, 715, 2, 'Överblick dag');
INSERT INTO `lang_definitions` VALUES (655, 716, 2, 'Dag (ar)');
INSERT INTO `lang_definitions` VALUES (656, 717, 2, 'Dag (ar) M-F');
INSERT INTO `lang_definitions` VALUES (657, 718, 2, 'dagar');
INSERT INTO `lang_definitions` VALUES (658, 719, 2, 'Dagar');
INSERT INTO `lang_definitions` VALUES (659, 720, 2, 'Dagar och spel Missade');
INSERT INTO `lang_definitions` VALUES (660, 721, 2, 'Dagar från förra mötet');
INSERT INTO `lang_definitions` VALUES (661, 722, 2, 'Dagar per Kolumn:');
INSERT INTO `lang_definitions` VALUES (662, 723, 2, 'DB installerad');
INSERT INTO `lang_definitions` VALUES (663, 724, 2, 'DEA');
INSERT INTO `lang_definitions` VALUES (664, 725, 2, 'Debuginformation');
INSERT INTO `lang_definitions` VALUES (665, 726, 2, 'December');
INSERT INTO `lang_definitions` VALUES (666, 727, 2, 'Standard');
INSERT INTO `lang_definitions` VALUES (667, 728, 2, 'Standard Kalender vy');
INSERT INTO `lang_definitions` VALUES (668, 729, 2, 'Standard Klinik');
INSERT INTO `lang_definitions` VALUES (669, 730, 2, 'Standardlista');
INSERT INTO `lang_definitions` VALUES (670, 731, 2, 'Standardmetod');
INSERT INTO `lang_definitions` VALUES (671, 732, 2, 'Standardleverantör');
INSERT INTO `lang_definitions` VALUES (672, 733, 2, 'Standardmall');
INSERT INTO `lang_definitions` VALUES (673, 734, 2, 'Standardvärde');
INSERT INTO `lang_definitions` VALUES (674, 735, 2, 'Standard X12 Partner');
INSERT INTO `lang_definitions` VALUES (675, 736, 2, 'Default / Global');
INSERT INTO `lang_definitions` VALUES (676, 738, 2, 'Fördröjd Återkommande (> 12 mån)');
INSERT INTO `lang_definitions` VALUES (677, 739, 2, 'Ta bort');
INSERT INTO `lang_definitions` VALUES (678, 740, 2, 'ta bort');
INSERT INTO `lang_definitions` VALUES (679, 741, 2, 'Radera Kategorier med ID (s):');
INSERT INTO `lang_definitions` VALUES (680, 742, 2, 'Ta bort grupp');
INSERT INTO `lang_definitions` VALUES (681, 743, 2, 'Ta bort lista');
INSERT INTO `lang_definitions` VALUES (682, 744, 2, 'Radera Sidor');
INSERT INTO `lang_definitions` VALUES (683, 745, 2, 'Ta bort patient, Möte, Formulär, Ämne, Dokument, Betalning, Fakturering eller transaktionstryck');
INSERT INTO `lang_definitions` VALUES (684, 747, 2, 'Borttagning OK');
INSERT INTO `lang_definitions` VALUES (685, 748, 2, 'Radera detta dokument');
INSERT INTO `lang_definitions` VALUES (686, 749, 2, 'Radera detta formulär');
INSERT INTO `lang_definitions` VALUES (687, 750, 2, 'Radera denna anteckning');
INSERT INTO `lang_definitions` VALUES (688, 751, 2, 'Demens');
INSERT INTO `lang_definitions` VALUES (689, 752, 2, 'Demografi');
INSERT INTO `lang_definitions` VALUES (690, 753, 2, 'Demografi');
INSERT INTO `lang_definitions` VALUES (691, 754, 2, 'Demografi ej auktoriserad');
INSERT INTO `lang_definitions` VALUES (692, 755, 2, 'Demografi ej auktoriserad');
INSERT INTO `lang_definitions` VALUES (693, 756, 2, 'Dental');
INSERT INTO `lang_definitions` VALUES (694, 757, 2, 'Dentala frågeställningar');
INSERT INTO `lang_definitions` VALUES (695, 759, 2, 'Insättning Datum:');
INSERT INTO `lang_definitions` VALUES (696, 760, 2, 'Deprimerad');
INSERT INTO `lang_definitions` VALUES (697, 761, 2, 'Depression');
INSERT INTO `lang_definitions` VALUES (698, 762, 2, 'Beskrivning');
INSERT INTO `lang_definitions` VALUES (699, 763, 2, 'beskrivning');
INSERT INTO `lang_definitions` VALUES (700, 764, 2, 'Beskrivning översättning');
INSERT INTO `lang_definitions` VALUES (701, 765, 2, 'Mål');
INSERT INTO `lang_definitions` VALUES (702, 766, 2, 'Förstör Parti');
INSERT INTO `lang_definitions` VALUES (703, 767, 2, 'Förstör ...');
INSERT INTO `lang_definitions` VALUES (704, 768, 2, 'Förstörd');
INSERT INTO `lang_definitions` VALUES (705, 769, 2, 'Förstörda läkemedel');
INSERT INTO `lang_definitions` VALUES (706, 770, 2, 'Förstöras narkotika Rapport');
INSERT INTO `lang_definitions` VALUES (707, 771, 2, 'Detaljer');
INSERT INTO `lang_definitions` VALUES (708, 772, 2, 'Utvecklingstoxicitet abnormalitet');
INSERT INTO `lang_definitions` VALUES (709, 773, 2, 'Diabetes');
INSERT INTO `lang_definitions` VALUES (710, 774, 2, 'Diag');
INSERT INTO `lang_definitions` VALUES (711, 775, 2, 'Diagnos');
INSERT INTO `lang_definitions` VALUES (712, 776, 2, 'Diagnos måste kodas in i ett länkat patientmöte');
INSERT INTO `lang_definitions` VALUES (713, 777, 2, 'Diagnos:');
INSERT INTO `lang_definitions` VALUES (714, 778, 2, 'Diagnos:');
INSERT INTO `lang_definitions` VALUES (715, 779, 2, 'Diagnostiska tester:');
INSERT INTO `lang_definitions` VALUES (716, 780, 2, 'Dials');
INSERT INTO `lang_definitions` VALUES (717, 782, 2, 'Diarée');
INSERT INTO `lang_definitions` VALUES (718, 783, 2, 'Diktat');
INSERT INTO `lang_definitions` VALUES (719, 784, 2, 'Diktat:');
INSERT INTO `lang_definitions` VALUES (720, 785, 2, 'Fick du en kopia av denna HIPAA notering?');
INSERT INTO `lang_definitions` VALUES (721, 786, 2, 'Diffusa:');
INSERT INTO `lang_definitions` VALUES (722, 788, 2, 'Direkt mail');
INSERT INTO `lang_definitions` VALUES (723, 789, 2, 'Funktionshinder');
INSERT INTO `lang_definitions` VALUES (724, 790, 2, 'funktionshindrade');
INSERT INTO `lang_definitions` VALUES (725, 791, 2, 'Funktionshindrade');
INSERT INTO `lang_definitions` VALUES (726, 792, 2, 'DISC');
INSERT INTO `lang_definitions` VALUES (727, 793, 2, 'Ansvarsfrihet');
INSERT INTO `lang_definitions` VALUES (728, 794, 2, 'Flytningar från urinröret');
INSERT INTO `lang_definitions` VALUES (729, 797, 2, 'Rabatt');
INSERT INTO `lang_definitions` VALUES (730, 798, 2, 'Rabatt Belopp');
INSERT INTO `lang_definitions` VALUES (731, 799, 2, 'Rabatt nivå');
INSERT INTO `lang_definitions` VALUES (732, 800, 2, 'Sjukdom');
INSERT INTO `lang_definitions` VALUES (733, 801, 2, 'Förskjutning');
INSERT INTO `lang_definitions` VALUES (734, 802, 2, 'Antal:');
INSERT INTO `lang_definitions` VALUES (735, 803, 2, 'Skicka i väg');
INSERT INTO `lang_definitions` VALUES (736, 804, 2, 'Skicka mottagna dokument');
INSERT INTO `lang_definitions` VALUES (737, 805, 2, 'Dispenseras');
INSERT INTO `lang_definitions` VALUES (738, 806, 2, 'Visa händelsedatum i blocket?');
INSERT INTO `lang_definitions` VALUES (739, 807, 2, 'Visa hur många händelser?');
INSERT INTO `lang_definitions` VALUES (740, 808, 2, 'Visa plats i blocket?');
INSERT INTO `lang_definitions` VALUES (741, 809, 2, 'Visa kalender?');
INSERT INTO `lang_definitions` VALUES (742, 810, 2, 'Display dagens händelser i blocket?');
INSERT INTO `lang_definitions` VALUES (743, 811, 2, 'Visa ämne i blocket?');
INSERT INTO `lang_definitions` VALUES (744, 812, 2, 'Visa kommande händelser i blocket?');
INSERT INTO `lang_definitions` VALUES (745, 813, 2, 'Distrubition');
INSERT INTO `lang_definitions` VALUES (746, 814, 2, 'Divertikulit');
INSERT INTO `lang_definitions` VALUES (747, 815, 2, 'Diverticulitis Kirurgi');
INSERT INTO `lang_definitions` VALUES (748, 816, 2, 'Divertikulit');
INSERT INTO `lang_definitions` VALUES (749, 817, 2, 'Divertikulit Kirurgi');
INSERT INTO `lang_definitions` VALUES (750, 818, 2, 'Skild');
INSERT INTO `lang_definitions` VALUES (751, 819, 2, 'Yrsel:');
INSERT INTO `lang_definitions` VALUES (752, 820, 2, 'spara inte');
INSERT INTO `lang_definitions` VALUES (753, 821, 2, 'ersätt inte');
INSERT INTO `lang_definitions` VALUES (754, 823, 2, 'Vill du verkligen ta bort den här gruppen');
INSERT INTO `lang_definitions` VALUES (755, 824, 2, 'Vill du fortsätta att lägga till den nya patienten?');
INSERT INTO `lang_definitions` VALUES (756, 825, 2, 'Vill du fortsätta med det nya namnet?');
INSERT INTO `lang_definitions` VALUES (757, 827, 2, 'Födelsedatum');
INSERT INTO `lang_definitions` VALUES (758, 828, 2, 'Födelsedatum saknas, ange om möjligt');
INSERT INTO `lang_definitions` VALUES (759, 829, 2, 'Dokument');
INSERT INTO `lang_definitions` VALUES (760, 831, 2, 'Läkare:');
INSERT INTO `lang_definitions` VALUES (761, 832, 2, 'Läkares namn och underskrift');
INSERT INTO `lang_definitions` VALUES (762, 833, 2, 'Dokument');
INSERT INTO `lang_definitions` VALUES (763, 834, 2, 'dokument');
INSERT INTO `lang_definitions` VALUES (764, 835, 2, 'Dokument Kategorier');
INSERT INTO `lang_definitions` VALUES (765, 836, 2, 'Dokument kan inte flyttas till patienten id ');
INSERT INTO `lang_definitions` VALUES (766, 837, 2, 'Dokument Datum');
INSERT INTO `lang_definitions` VALUES (767, 838, 2, 'Dokumentets datum och utförande uppdaterats ');
INSERT INTO `lang_definitions` VALUES (768, 839, 2, 'Dokument är flyttat till ny kategori');
INSERT INTO `lang_definitions` VALUES (769, 840, 2, 'Dokument är flyttat till patienten id');
INSERT INTO `lang_definitions` VALUES (770, 841, 2, 'Dokument/avbildning lagrad');
INSERT INTO `lang_definitions` VALUES (771, 842, 2, 'Dokument');
INSERT INTO `lang_definitions` VALUES (772, 843, 2, 'Dokument (skriva, tilllägg frivilligt)');
INSERT INTO `lang_definitions` VALUES (773, 844, 2, 'DOE');
INSERT INTO `lang_definitions` VALUES (774, 845, 2, 'Inrikes Partner ');
INSERT INTO `lang_definitions` VALUES (775, 846, 2, 'Spara inte');
INSERT INTO `lang_definitions` VALUES (776, 847, 2, 'Spara inte');
INSERT INTO `lang_definitions` VALUES (777, 848, 2, 'Spara inte');
INSERT INTO `lang_definitions` VALUES (778, 850, 2, 'Klar med:');
INSERT INTO `lang_definitions` VALUES (779, 852, 2, 'DOS');
INSERT INTO `lang_definitions` VALUES (780, 853, 2, 'Dosering');
INSERT INTO `lang_definitions` VALUES (781, 854, 2, 'dubbelklicka för att redigera');
INSERT INTO `lang_definitions` VALUES (782, 855, 2, 'Dubbelseende');
INSERT INTO `lang_definitions` VALUES (783, 858, 2, 'Läkarkontroll');
INSERT INTO `lang_definitions` VALUES (784, 859, 2, 'Läkarbesök');
INSERT INTO `lang_definitions` VALUES (785, 860, 2, 'Dr.');
INSERT INTO `lang_definitions` VALUES (786, 861, 2, 'Dribblande');
INSERT INTO `lang_definitions` VALUES (787, 862, 2, 'Körkortsnr');
INSERT INTO `lang_definitions` VALUES (788, 863, 2, 'Läkemedel');
INSERT INTO `lang_definitions` VALUES (789, 864, 2, 'Läkemedelsformulär');
INSERT INTO `lang_definitions` VALUES (790, 865, 2, 'Läkemeddels ID saknas!');
INSERT INTO `lang_definitions` VALUES (791, 866, 2, 'Läkemedel intervall');
INSERT INTO `lang_definitions` VALUES (792, 867, 2, 'Inventarielista, läkemedel');
INSERT INTO `lang_definitions` VALUES (793, 868, 2, 'Läkemedelsnamn');
INSERT INTO `lang_definitions` VALUES (794, 869, 2, 'Läkemedelslinje/väg');
INSERT INTO `lang_definitions` VALUES (795, 870, 2, 'Läkemedel, enheter');
INSERT INTO `lang_definitions` VALUES (796, 871, 2, 'Läkemedel');
INSERT INTO `lang_definitions` VALUES (797, 872, 2, 'Muntorrhet');
INSERT INTO `lang_definitions` VALUES (798, 873, 2, 'DT 1');
INSERT INTO `lang_definitions` VALUES (799, 874, 2, 'DT 2');
INSERT INTO `lang_definitions` VALUES (800, 875, 2, 'DT 3');
INSERT INTO `lang_definitions` VALUES (801, 876, 2, 'DT 4');
INSERT INTO `lang_definitions` VALUES (802, 877, 2, 'DT 5');
INSERT INTO `lang_definitions` VALUES (803, 878, 2, 'DTaP 1');
INSERT INTO `lang_definitions` VALUES (804, 879, 2, 'DTaP 2');
INSERT INTO `lang_definitions` VALUES (805, 880, 2, 'DTaP 3');
INSERT INTO `lang_definitions` VALUES (806, 881, 2, 'DTaP 4');
INSERT INTO `lang_definitions` VALUES (807, 882, 2, 'DTaP 5');
INSERT INTO `lang_definitions` VALUES (808, 883, 2, 'Förfallodatum');
INSERT INTO `lang_definitions` VALUES (809, 884, 2, 'Återl.datum mm / dd / yyyy eller åååå-mm-dd');
INSERT INTO `lang_definitions` VALUES (810, 885, 2, 'Förfallodatum:');
INSERT INTO `lang_definitions` VALUES (811, 888, 2, 'Dumping OpenEMR database');
INSERT INTO `lang_definitions` VALUES (812, 889, 2, 'Dumping OpenEMR web directory tree');
INSERT INTO `lang_definitions` VALUES (813, 890, 2, 'Dumping phpGACL database');
INSERT INTO `lang_definitions` VALUES (814, 891, 2, 'Dumping phpGACL web directory tree');
INSERT INTO `lang_definitions` VALUES (815, 892, 2, 'Dumping SQL-Ledger database');
INSERT INTO `lang_definitions` VALUES (816, 893, 2, 'Dumping SQL-Ledger web directory tree');
INSERT INTO `lang_definitions` VALUES (817, 894, 2, 'DUPLIKATION, VARNING');
INSERT INTO `lang_definitions` VALUES (818, 895, 2, 'varaktighet');
INSERT INTO `lang_definitions` VALUES (819, 896, 2, 'Varaktighet');
INSERT INTO `lang_definitions` VALUES (820, 897, 2, 'Holländsk');
INSERT INTO `lang_definitions` VALUES (821, 898, 2, 'Dysphagi');
INSERT INTO `lang_definitions` VALUES (822, 899, 2, 'Dyspné:');
INSERT INTO `lang_definitions` VALUES (823, 900, 2, 'Dysuria');
INSERT INTO `lang_definitions` VALUES (824, 901, 2, 'Tidig Återkommande (<2 Mo)');
INSERT INTO `lang_definitions` VALUES (825, 902, 2, 'Öron');
INSERT INTO `lang_definitions` VALUES (826, 903, 2, 'EKG');
INSERT INTO `lang_definitions` VALUES (827, 904, 2, 'Ödem');
INSERT INTO `lang_definitions` VALUES (828, 905, 2, 'Redigera');
INSERT INTO `lang_definitions` VALUES (829, 906, 2, 'Redigera allergier');
INSERT INTO `lang_definitions` VALUES (830, 907, 2, 'Edit Kategorier');
INSERT INTO `lang_definitions` VALUES (831, 908, 2, 'Redigera definitioner');
INSERT INTO `lang_definitions` VALUES (832, 909, 2, 'Redigera diagnoser för');
INSERT INTO `lang_definitions` VALUES (833, 910, 2, 'Redigera Kliniker');
INSERT INTO `lang_definitions` VALUES (834, 911, 2, 'Redigera Klinikinformation');
INSERT INTO `lang_definitions` VALUES (835, 912, 2, 'Redigera form');
INSERT INTO `lang_definitions` VALUES (836, 913, 2, 'Redigera layout');
INSERT INTO `lang_definitions` VALUES (837, 914, 2, 'Redigera lista');
INSERT INTO `lang_definitions` VALUES (838, 915, 2, 'Redigera Struktur');
INSERT INTO `lang_definitions` VALUES (839, 916, 2, 'Utbildning');
INSERT INTO `lang_definitions` VALUES (840, 917, 2, 'Information');
INSERT INTO `lang_definitions` VALUES (841, 919, 2, 'Ikraftträdandedatum');
INSERT INTO `lang_definitions` VALUES (842, 920, 2, 'Effektivitet');
INSERT INTO `lang_definitions` VALUES (843, 921, 2, 'Ejaculation');
INSERT INTO `lang_definitions` VALUES (844, 922, 2, 'Armbåge');
INSERT INTO `lang_definitions` VALUES (845, 923, 2, 'Problem med armbågen');
INSERT INTO `lang_definitions` VALUES (846, 924, 2, 'Elektronisk remiss');
INSERT INTO `lang_definitions` VALUES (847, 925, 2, 'Email');
INSERT INTO `lang_definitions` VALUES (848, 926, 2, 'E-post från Batchcom');
INSERT INTO `lang_definitions` VALUES (849, 927, 2, 'E-postmeddelande');
INSERT INTO `lang_definitions` VALUES (850, 928, 2, 'E-post skicka innan');
INSERT INTO `lang_definitions` VALUES (851, 929, 2, 'Email, skicka');
INSERT INTO `lang_definitions` VALUES (852, 930, 2, 'Epost Ämnesord');
INSERT INTO `lang_definitions` VALUES (853, 931, 2, 'Email Text, användbara Tag: *** NAMN ***, dvs Bäste *** NAMN ***');
INSERT INTO `lang_definitions` VALUES (854, 932, 2, 'ICE Kontakt');
INSERT INTO `lang_definitions` VALUES (855, 933, 2, 'ICE kontaktperson');
INSERT INTO `lang_definitions` VALUES (856, 934, 2, 'ICE kontakt telefonnummer');
INSERT INTO `lang_definitions` VALUES (857, 935, 2, 'Akut Preventivmedel');
INSERT INTO `lang_definitions` VALUES (858, 936, 2, 'ICE Telefon ');
INSERT INTO `lang_definitions` VALUES (859, 937, 2, 'Emfysem');
INSERT INTO `lang_definitions` VALUES (860, 938, 2, 'Anställd');
INSERT INTO `lang_definitions` VALUES (861, 939, 2, 'Arbetsgivare');
INSERT INTO `lang_definitions` VALUES (862, 940, 2, 'Arbetsgivarens adress');
INSERT INTO `lang_definitions` VALUES (863, 941, 2, 'Arbetsgivare Data');
INSERT INTO `lang_definitions` VALUES (864, 942, 2, 'Arbetsgivarens namn');
INSERT INTO `lang_definitions` VALUES (865, 943, 2, 'Ta bort');
INSERT INTO `lang_definitions` VALUES (866, 944, 2, 'Ta bort värdet i \"E-tider\"');
INSERT INTO `lang_definitions` VALUES (867, 945, 2, 'Ta bort värde \"Email, skicka\"');
INSERT INTO `lang_definitions` VALUES (868, 946, 2, 'Ta bort värde i \"Email, ämne\"');
INSERT INTO `lang_definitions` VALUES (869, 947, 2, 'Ta bort i \"text\"');
INSERT INTO `lang_definitions` VALUES (870, 948, 2, 'Ta bort i \"Försörjarens namn\"');
INSERT INTO `lang_definitions` VALUES (871, 949, 2, 'Ta bort i \"Lösenord\"');
INSERT INTO `lang_definitions` VALUES (872, 950, 2, 'Ta bort \"SMS tider\"');
INSERT INTO `lang_definitions` VALUES (873, 951, 2, 'Ta bort \"SMS text\"');
INSERT INTO `lang_definitions` VALUES (874, 952, 2, 'Ta bort värdet i \"Användarnamn\"');
INSERT INTO `lang_definitions` VALUES (875, 953, 2, 'aktiverat');
INSERT INTO `lang_definitions` VALUES (876, 954, 2, 'Möte');
INSERT INTO `lang_definitions` VALUES (877, 955, 2, 'patientmöte');
INSERT INTO `lang_definitions` VALUES (878, 956, 2, 'Patientmöte');
INSERT INTO `lang_definitions` VALUES (879, 957, 2, 'Patientmöter');
INSERT INTO `lang_definitions` VALUES (880, 958, 2, 'Patientmöte formulär');
INSERT INTO `lang_definitions` VALUES (881, 959, 2, 'Patientmöte antal/nummer');
INSERT INTO `lang_definitions` VALUES (882, 960, 2, 'Patientmöte har kodats');
INSERT INTO `lang_definitions` VALUES (883, 961, 2, 'Patientmöte:');
INSERT INTO `lang_definitions` VALUES (884, 962, 2, 'Patientmöten');
INSERT INTO `lang_definitions` VALUES (885, 963, 2, 'Patientmöte & Formulär');
INSERT INTO `lang_definitions` VALUES (886, 964, 2, 'Patientmöte & Formulär');
INSERT INTO `lang_definitions` VALUES (887, 965, 2, 'Encounters inte godkända');
INSERT INTO `lang_definitions` VALUES (888, 966, 2, 'Patientmöte, rapport');
INSERT INTO `lang_definitions` VALUES (889, 967, 2, 'Patientmöte, avsnitt');
INSERT INTO `lang_definitions` VALUES (890, 968, 2, 'Slut');
INSERT INTO `lang_definitions` VALUES (891, 969, 2, 'Slutar (åååå-mm-dd):');
INSERT INTO `lang_definitions` VALUES (892, 970, 2, 'Slutdatum');
INSERT INTO `lang_definitions` VALUES (893, 971, 2, 'Slutdatum');
INSERT INTO `lang_definitions` VALUES (894, 972, 2, 'Slutdatum:');
INSERT INTO `lang_definitions` VALUES (895, 973, 2, 'Sluttid');
INSERT INTO `lang_definitions` VALUES (896, 974, 2, 'Tjänsten slutar åååå-mm-dd');
INSERT INTO `lang_definitions` VALUES (897, 977, 2, 'Endokrina');
INSERT INTO `lang_definitions` VALUES (898, 978, 2, 'Endoskopi');
INSERT INTO `lang_definitions` VALUES (899, 979, 2, 'Engelsk');
INSERT INTO `lang_definitions` VALUES (900, 980, 2, 'Engelsk');
INSERT INTO `lang_definitions` VALUES (901, 981, 2, 'Engelsk (indien)');
INSERT INTO `lang_definitions` VALUES (902, 982, 2, 'Engelsk (standard)');
INSERT INTO `lang_definitions` VALUES (903, 984, 2, 'ENT Ansvarsfrihet');
INSERT INTO `lang_definitions` VALUES (904, 985, 2, 'ENT Smärta');
INSERT INTO `lang_definitions` VALUES (905, 986, 2, 'Skriv en diagnos kod för att utesluta alla fakturor som inte innehåller det');
INSERT INTO `lang_definitions` VALUES (906, 989, 2, 'Ange dina sökkriterier ovan');
INSERT INTO `lang_definitions` VALUES (907, 990, 2, 'Miljöpåverkan');
INSERT INTO `lang_definitions` VALUES (908, 991, 2, 'EOB Data tillträde');
INSERT INTO `lang_definitions` VALUES (909, 993, 2, 'EOB Boknings - Instruktioner');
INSERT INTO `lang_definitions` VALUES (910, 994, 2, 'EOB Boknings - Faktura');
INSERT INTO `lang_definitions` VALUES (911, 995, 2, 'EOB Boknings - Patient Anmärkning ');
INSERT INTO `lang_definitions` VALUES (912, 996, 2, 'EOB Boknings - Sök');
INSERT INTO `lang_definitions` VALUES (913, 997, 2, 'Epilepsi');
INSERT INTO `lang_definitions` VALUES (914, 998, 2, 'Radera');
INSERT INTO `lang_definitions` VALUES (915, 999, 2, 'Erektion');
INSERT INTO `lang_definitions` VALUES (916, 1000, 2, 'Fel');
INSERT INTO `lang_definitions` VALUES (917, 1001, 2, 'Fel i \"kön\" val');
INSERT INTO `lang_definitions` VALUES (918, 1002, 2, 'Fel i \"HIPAA\" val');
INSERT INTO `lang_definitions` VALUES (919, 1003, 2, 'Fel i \"Process\" val');
INSERT INTO `lang_definitions` VALUES (920, 1004, 2, 'Fel i \"SMS Gateway\" val');
INSERT INTO `lang_definitions` VALUES (921, 1005, 2, 'Fel i \"Sortera efter\" val');
INSERT INTO `lang_definitions` VALUES (922, 1007, 2, 'Fel i JA eller NEJ alternativ');
INSERT INTO `lang_definitions` VALUES (923, 1009, 2, 'fel under registrering! ');
INSERT INTO `lang_definitions` VALUES (924, 1010, 2, 'Fel vid sparande av fil');
INSERT INTO `lang_definitions` VALUES (925, 1011, 2, 'Fel vid skrivning till fil ');
INSERT INTO `lang_definitions` VALUES (926, 1012, 2, 'FEL, kunde inte samla in data från servern');
INSERT INTO `lang_definitions` VALUES (927, 1014, 2, 'FEL: kunde inte öppna table.sql bruten form?');
INSERT INTO `lang_definitions` VALUES (928, 1016, 2, 'Fel: lösenord matchar inte. Kontrollera din stavning.');
INSERT INTO `lang_definitions` VALUES (929, 1018, 2, 'Fel');
INSERT INTO `lang_definitions` VALUES (930, 1019, 2, 'Erythema:');
INSERT INTO `lang_definitions` VALUES (931, 1020, 2, 'Redan känd patient');
INSERT INTO `lang_definitions` VALUES (932, 1021, 2, 'Etnicitet');
INSERT INTO `lang_definitions` VALUES (933, 1023, 2, 'ETIN');
INSERT INTO `lang_definitions` VALUES (934, 1024, 2, 'Händelse');
INSERT INTO `lang_definitions` VALUES (935, 1025, 2, 'Händelse Begins');
INSERT INTO `lang_definitions` VALUES (936, 1026, 2, 'Händelse Kategori');
INSERT INTO `lang_definitions` VALUES (937, 1027, 2, 'Händelse Datum');
INSERT INTO `lang_definitions` VALUES (938, 1028, 2, 'Händelse, Beskrivning');
INSERT INTO `lang_definitions` VALUES (939, 1029, 2, 'Händelse, detaljer');
INSERT INTO `lang_definitions` VALUES (940, 1030, 2, 'Händelsen upprepas ej');
INSERT INTO `lang_definitions` VALUES (941, 1031, 2, 'Händelse, Varaktighet');
INSERT INTO `lang_definitions` VALUES (942, 1032, 2, 'Händelsens tid i minuter');
INSERT INTO `lang_definitions` VALUES (943, 1033, 2, 'Händelse, Avgift');
INSERT INTO `lang_definitions` VALUES (944, 1034, 2, 'Event Location');
INSERT INTO `lang_definitions` VALUES (945, 1035, 2, 'Händelsen upprepas varje');
INSERT INTO `lang_definitions` VALUES (946, 1036, 2, 'Händelsen upprepas den');
INSERT INTO `lang_definitions` VALUES (947, 1037, 2, 'Händelse börjar timme');
INSERT INTO `lang_definitions` VALUES (948, 1038, 2, 'Händelserubrik');
INSERT INTO `lang_definitions` VALUES (949, 1039, 2, 'Händelserubrik');
INSERT INTO `lang_definitions` VALUES (950, 1040, 2, 'Händelse Website');
INSERT INTO `lang_definitions` VALUES (951, 1041, 2, 'Händelse');
INSERT INTO `lang_definitions` VALUES (952, 1042, 2, 'Händelser för');
INSERT INTO `lang_definitions` VALUES (953, 1043, 2, 'Händelsen öppnas i nytt fönster');
INSERT INTO `lang_definitions` VALUES (954, 1044, 2, 'Varje');
INSERT INTO `lang_definitions` VALUES (955, 1045, 2, 'Varje');
INSERT INTO `lang_definitions` VALUES (956, 1046, 2, 'var 3:e timme');
INSERT INTO `lang_definitions` VALUES (957, 1047, 2, 'var 4:e timme');
INSERT INTO `lang_definitions` VALUES (958, 1048, 2, 'var 5:e timme');
INSERT INTO `lang_definitions` VALUES (959, 1049, 2, 'var 6 timme');
INSERT INTO `lang_definitions` VALUES (960, 1050, 2, 'var 8 timme');
INSERT INTO `lang_definitions` VALUES (961, 1051, 2, 'Var fjärde');
INSERT INTO `lang_definitions` VALUES (962, 1052, 2, 'Varannan');
INSERT INTO `lang_definitions` VALUES (963, 1053, 2, 'Var tredje');
INSERT INTO `lang_definitions` VALUES (964, 1054, 2, 'Varje, var andra, var 3:e, etc');
INSERT INTO `lang_definitions` VALUES (965, 1055, 2, 'Tenta och testresultat');
INSERT INTO `lang_definitions` VALUES (966, 1056, 2, 'Testresultat');
INSERT INTO `lang_definitions` VALUES (967, 1057, 2, 'Examination Datum');
INSERT INTO `lang_definitions` VALUES (968, 1058, 2, 'Exams / Tester');
INSERT INTO `lang_definitions` VALUES (969, 1059, 2, 'Överdrivet rivande');
INSERT INTO `lang_definitions` VALUES (970, 1061, 2, 'Motions mönster ');
INSERT INTO `lang_definitions` VALUES (971, 1062, 2, 'Övningsmönster');
INSERT INTO `lang_definitions` VALUES (972, 1063, 2, 'lämna från Administration');
INSERT INTO `lang_definitions` VALUES (973, 1065, 2, 'Utökad vy');
INSERT INTO `lang_definitions` VALUES (974, 1066, 2, 'Förväntad form_mötes.pid att');
INSERT INTO `lang_definitions` VALUES (975, 1067, 2, 'Utgångsdatum');
INSERT INTO `lang_definitions` VALUES (976, 1068, 2, 'Utgångsdatum');
INSERT INTO `lang_definitions` VALUES (977, 1069, 2, 'Förfaller');
INSERT INTO `lang_definitions` VALUES (978, 1070, 2, 'Exportera');
INSERT INTO `lang_definitions` VALUES (979, 1071, 2, 'Exportera som CSV');
INSERT INTO `lang_definitions` VALUES (980, 1076, 2, 'Exportera till CSV');
INSERT INTO `lang_definitions` VALUES (981, 1077, 2, 'Exportera till externa faktureringssystem');
INSERT INTO `lang_definitions` VALUES (982, 1078, 2, 'Exponering för andra länder');
INSERT INTO `lang_definitions` VALUES (983, 1084, 2, 'Extern remiss');
INSERT INTO `lang_definitions` VALUES (984, 1086, 2, 'Extern remiss?');
INSERT INTO `lang_definitions` VALUES (985, 1087, 2, 'Externa remisser');
INSERT INTO `lang_definitions` VALUES (986, 1093, 2, 'F');
INSERT INTO `lang_definitions` VALUES (987, 1096, 2, 'Kliniker');
INSERT INTO `lang_definitions` VALUES (988, 1097, 2, 'Klinik');
INSERT INTO `lang_definitions` VALUES (989, 1098, 2, 'klinik');
INSERT INTO `lang_definitions` VALUES (990, 1099, 2, 'Klinikadm');
INSERT INTO `lang_definitions` VALUES (991, 1100, 2, 'Klinikkod');
INSERT INTO `lang_definitions` VALUES (992, 1101, 2, 'Klinik NPI');
INSERT INTO `lang_definitions` VALUES (993, 1102, 2, 'Klinik:');
INSERT INTO `lang_definitions` VALUES (994, 1103, 2, 'Misslyckades');
INSERT INTO `lang_definitions` VALUES (995, 1106, 2, 'Familjehistoria');
INSERT INTO `lang_definitions` VALUES (996, 1108, 2, 'Familjehistoria:');
INSERT INTO `lang_definitions` VALUES (997, 1109, 2, 'Familj Storlek');
INSERT INTO `lang_definitions` VALUES (998, 1111, 2, 'Fader');
INSERT INTO `lang_definitions` VALUES (999, 1113, 2, 'Fatigue');
INSERT INTO `lang_definitions` VALUES (1000, 1114, 2, 'Fax');
INSERT INTO `lang_definitions` VALUES (1001, 1117, 2, 'Fax in');
INSERT INTO `lang_definitions` VALUES (1002, 1118, 2, 'Fax ut');
INSERT INTO `lang_definitions` VALUES (1003, 1119, 2, 'Februari');
INSERT INTO `lang_definitions` VALUES (1004, 1121, 2, 'Läkemedel ID');
INSERT INTO `lang_definitions` VALUES (1005, 1123, 2, 'Skatt ID');
INSERT INTO `lang_definitions` VALUES (1006, 1124, 2, 'Avgift');
INSERT INTO `lang_definitions` VALUES (1007, 1125, 2, 'avgift');
INSERT INTO `lang_definitions` VALUES (1008, 1127, 2, 'Avgift blankett');
INSERT INTO `lang_definitions` VALUES (1009, 1129, 2, 'Avgifter');
INSERT INTO `lang_definitions` VALUES (1010, 1130, 2, 'Kvinna');
INSERT INTO `lang_definitions` VALUES (1011, 1132, 2, 'Kvinnliga Kondomer');
INSERT INTO `lang_definitions` VALUES (1012, 1137, 2, 'Kvinna VSC');
INSERT INTO `lang_definitions` VALUES (1013, 1138, 2, 'Feber');
INSERT INTO `lang_definitions` VALUES (1014, 1139, 2, 'Feber:');
INSERT INTO `lang_definitions` VALUES (1015, 1146, 2, 'Filnamn');
INSERT INTO `lang_definitions` VALUES (1016, 1147, 2, 'Fyll här endast om du skickar e-postmeddelande till patienter');
INSERT INTO `lang_definitions` VALUES (1017, 1150, 2, 'Filter');
INSERT INTO `lang_definitions` VALUES (1018, 1151, 2, 'Slutgiltig diagnos');
INSERT INTO `lang_definitions` VALUES (1019, 1152, 2, 'Slutgiltig diagnos av specialist');
INSERT INTO `lang_definitions` VALUES (1020, 1153, 2, 'Finansiella');
INSERT INTO `lang_definitions` VALUES (1021, 1156, 2, 'Financial Review Datum');
INSERT INTO `lang_definitions` VALUES (1022, 1157, 2, 'Hitta');
INSERT INTO `lang_definitions` VALUES (1023, 1158, 2, 'Hitta Ledig');
INSERT INTO `lang_definitions` VALUES (1024, 1159, 2, 'Sök Ledig mötestider');
INSERT INTO `lang_definitions` VALUES (1025, 1160, 2, 'Hitta Patientient');
INSERT INTO `lang_definitions` VALUES (1026, 1161, 2, 'Undersökningsresultat');
INSERT INTO `lang_definitions` VALUES (1027, 1162, 2, 'Undersökningsresultat av specialist');
INSERT INTO `lang_definitions` VALUES (1028, 1163, 2, 'Fin');
INSERT INTO `lang_definitions` VALUES (1029, 1164, 2, 'Första');
INSERT INTO `lang_definitions` VALUES (1030, 1165, 2, 'Första dagen i veckan');
INSERT INTO `lang_definitions` VALUES (1031, 1166, 2, 'Förnamn');
INSERT INTO `lang_definitions` VALUES (1032, 1168, 2, 'Förnamn:');
INSERT INTO `lang_definitions` VALUES (1033, 1169, 2, 'Fitness');
INSERT INTO `lang_definitions` VALUES (1034, 1170, 2, 'Fitness att spela');
INSERT INTO `lang_definitions` VALUES (1035, 1175, 2, 'Influensavaccination');
INSERT INTO `lang_definitions` VALUES (1036, 1176, 2, 'Vätske-och elektrolyt problem');
INSERT INTO `lang_definitions` VALUES (1037, 1178, 2, 'Följa manuellt');
INSERT INTO `lang_definitions` VALUES (1038, 1180, 2, 'Fot');
INSERT INTO `lang_definitions` VALUES (1039, 1181, 2, 'Fotproblem');
INSERT INTO `lang_definitions` VALUES (1040, 1182, 2, 'Fot:');
INSERT INTO `lang_definitions` VALUES (1041, 1184, 2, 'Fotboll Skaderapport');
INSERT INTO `lang_definitions` VALUES (1042, 1185, 2, 'Skotyp');
INSERT INTO `lang_definitions` VALUES (1043, 1186, 2, 'för');
INSERT INTO `lang_definitions` VALUES (1044, 1189, 2, 'för:');
INSERT INTO `lang_definitions` VALUES (1045, 1190, 2, 'Underarm');
INSERT INTO `lang_definitions` VALUES (1046, 1191, 2, 'Formulär');
INSERT INTO `lang_definitions` VALUES (1047, 1194, 2, 'Format');
INSERT INTO `lang_definitions` VALUES (1048, 1195, 2, 'Format felaktigt för NDC');
INSERT INTO `lang_definitions` VALUES (1049, 1196, 2, 'Formulär');
INSERT INTO `lang_definitions` VALUES (1050, 1197, 2, 'Formulär administration');
INSERT INTO `lang_definitions` VALUES (1051, 1198, 2, 'Vidarebefordra Sidor via Fax');
INSERT INTO `lang_definitions` VALUES (1052, 1199, 2, 'Fjärde');
INSERT INTO `lang_definitions` VALUES (1053, 1200, 2, 'Fraktur');
INSERT INTO `lang_definitions` VALUES (1054, 1201, 2, 'Fracture på Navicula');
INSERT INTO `lang_definitions` VALUES (1055, 1202, 2, 'Fracture laterala malleolus');
INSERT INTO `lang_definitions` VALUES (1056, 1203, 2, 'Fracture mediala malleolus');
INSERT INTO `lang_definitions` VALUES (1057, 1209, 2, 'Fre');
INSERT INTO `lang_definitions` VALUES (1058, 1210, 2, 'Fredag');
INSERT INTO `lang_definitions` VALUES (1059, 1211, 2, 'Från');
INSERT INTO `lang_definitions` VALUES (1060, 1213, 2, 'Från:');
INSERT INTO `lang_definitions` VALUES (1061, 1214, 2, 'Från:');
INSERT INTO `lang_definitions` VALUES (1062, 1225, 2, 'Reception');
INSERT INTO `lang_definitions` VALUES (1063, 1226, 2, 'Reception, kvitton');
INSERT INTO `lang_definitions` VALUES (1064, 1227, 2, 'Reception, kvitton, rapport');
INSERT INTO `lang_definitions` VALUES (1065, 1229, 2, 'Frontal Höger:');
INSERT INTO `lang_definitions` VALUES (1066, 1232, 2, 'All utbildning');
INSERT INTO `lang_definitions` VALUES (1067, 1235, 2, 'Gallsten');
INSERT INTO `lang_definitions` VALUES (1068, 1236, 2, 'Game Period');
INSERT INTO `lang_definitions` VALUES (1069, 1237, 2, 'Spel');
INSERT INTO `lang_definitions` VALUES (1070, 1238, 2, 'spel / evenemang');
INSERT INTO `lang_definitions` VALUES (1071, 1240, 2, 'Gastrit');
INSERT INTO `lang_definitions` VALUES (1072, 1242, 2, 'Gastrointestinala');
INSERT INTO `lang_definitions` VALUES (1073, 1243, 2, 'GCAC Statistik Rapport');
INSERT INTO `lang_definitions` VALUES (1074, 1246, 2, 'Kön');
INSERT INTO `lang_definitions` VALUES (1075, 1247, 2, 'Allmänt');
INSERT INTO `lang_definitions` VALUES (1076, 1248, 2, 'Allmänna Tjänstekategori');
INSERT INTO `lang_definitions` VALUES (1077, 1249, 2, 'Skapa och hämta HCFA 1500 papper fordringar');
INSERT INTO `lang_definitions` VALUES (1078, 1250, 2, 'Skapa och hämta X12 parti');
INSERT INTO `lang_definitions` VALUES (1079, 1255, 2, 'Generera Skrivelse angående');
INSERT INTO `lang_definitions` VALUES (1080, 1256, 2, 'Generera rapport');
INSERT INTO `lang_definitions` VALUES (1081, 1259, 2, 'Skapad på');
INSERT INTO `lang_definitions` VALUES (1082, 1260, 2, 'Genererar');
INSERT INTO `lang_definitions` VALUES (1083, 1263, 2, 'Glaukom');
INSERT INTO `lang_definitions` VALUES (1084, 1265, 2, 'Global');
INSERT INTO `lang_definitions` VALUES (1085, 1267, 2, 'gå');
INSERT INTO `lang_definitions` VALUES (1086, 1268, 2, 'Gå');
INSERT INTO `lang_definitions` VALUES (1087, 1271, 2, 'Grad:');
INSERT INTO `lang_definitions` VALUES (1088, 1273, 2, 'Totalsumma');
INSERT INTO `lang_definitions` VALUES (1089, 1274, 2, 'Totalsummor');
INSERT INTO `lang_definitions` VALUES (1090, 1276, 2, 'Grupp');
INSERT INTO `lang_definitions` VALUES (1091, 1281, 2, 'Gruppnummer');
INSERT INTO `lang_definitions` VALUES (1092, 1282, 2, 'Grupp:');
INSERT INTO `lang_definitions` VALUES (1093, 1283, 2, 'Gruppnamn');
INSERT INTO `lang_definitions` VALUES (1094, 1284, 2, 'Grupper och åtkomstkontroller');
INSERT INTO `lang_definitions` VALUES (1095, 1287, 2, 'Droppar');
INSERT INTO `lang_definitions` VALUES (1096, 1293, 2, 'Hematom / blåmärken');
INSERT INTO `lang_definitions` VALUES (1097, 1295, 2, 'Hand + fingrar');
INSERT INTO `lang_definitions` VALUES (1098, 1296, 2, 'Handproblem');
INSERT INTO `lang_definitions` VALUES (1099, 1297, 2, 'Umbäranden w / o');
INSERT INTO `lang_definitions` VALUES (1100, 1300, 2, 'Farliga aktiviteter');
INSERT INTO `lang_definitions` VALUES (1101, 1304, 2, 'han PostCalendar');
INSERT INTO `lang_definitions` VALUES (1102, 1305, 2, 'Huvud');
INSERT INTO `lang_definitions` VALUES (1103, 1309, 2, 'Huvudvärk');
INSERT INTO `lang_definitions` VALUES (1104, 1314, 2, 'Heart Attack');
INSERT INTO `lang_definitions` VALUES (1105, 1316, 2, 'Hjärtsvikt');
INSERT INTO `lang_definitions` VALUES (1106, 1318, 2, 'Hjärtproblem');
INSERT INTO `lang_definitions` VALUES (1107, 1319, 2, 'Hjärtkirurgi');
INSERT INTO `lang_definitions` VALUES (1108, 1320, 2, 'Heart Transplant');
INSERT INTO `lang_definitions` VALUES (1109, 1321, 2, 'Heart:');
INSERT INTO `lang_definitions` VALUES (1110, 1327, 2, 'Längd');
INSERT INTO `lang_definitions` VALUES (1111, 1328, 2, 'Hjälp');
INSERT INTO `lang_definitions` VALUES (1112, 1329, 2, 'hjälp');
INSERT INTO `lang_definitions` VALUES (1113, 1334, 2, 'Hemoglobin');
INSERT INTO `lang_definitions` VALUES (1114, 1336, 2, 'Hepatit');
INSERT INTO `lang_definitions` VALUES (1115, 1343, 2, 'Bråck Reparation');
INSERT INTO `lang_definitions` VALUES (1116, 1344, 2, 'Diskbråck');
INSERT INTO `lang_definitions` VALUES (1117, 1345, 2, 'Herpes');
INSERT INTO `lang_definitions` VALUES (1118, 1347, 2, 'heyyo. du har varit här i');
INSERT INTO `lang_definitions` VALUES (1119, 1352, 2, 'Dolda');
INSERT INTO `lang_definitions` VALUES (1120, 1353, 2, 'Dolda Händelser Administration');
INSERT INTO `lang_definitions` VALUES (1121, 1354, 2, 'Gömma');
INSERT INTO `lang_definitions` VALUES (1122, 1355, 2, 'Dölj detaljer');
INSERT INTO `lang_definitions` VALUES (1123, 1357, 2, 'Hög');
INSERT INTO `lang_definitions` VALUES (1124, 1358, 2, 'Högt blodtryck');
INSERT INTO `lang_definitions` VALUES (1125, 1359, 2, 'Höft + ljumske');
INSERT INTO `lang_definitions` VALUES (1126, 1360, 2, 'Höft och ljumske');
INSERT INTO `lang_definitions` VALUES (1127, 1361, 2, 'Hip Problem');
INSERT INTO `lang_definitions` VALUES (1128, 1362, 2, 'Höftledsplastik');
INSERT INTO `lang_definitions` VALUES (1129, 1363, 2, 'Ej Tilldelad');
INSERT INTO `lang_definitions` VALUES (1130, 1365, 2, 'Spansktalande');
INSERT INTO `lang_definitions` VALUES (1131, 1366, 2, 'Historia');
INSERT INTO `lang_definitions` VALUES (1132, 1367, 2, 'Historikdata');
INSERT INTO `lang_definitions` VALUES (1133, 1372, 2, 'Håll ner [Ctrl] för flera val eller avmarkera');
INSERT INTO `lang_definitions` VALUES (1134, 1373, 2, 'Håll ned Ctrl för att välja flera objekt');
INSERT INTO `lang_definitions` VALUES (1135, 1374, 2, 'Håll ned Ctrl för att välja flera patruller');
INSERT INTO `lang_definitions` VALUES (1136, 1375, 2, 'Hem');
INSERT INTO `lang_definitions` VALUES (1137, 1376, 2, 'Hemtelefon');
INSERT INTO `lang_definitions` VALUES (1138, 1378, 2, 'Hemlös eller liknande?');
INSERT INTO `lang_definitions` VALUES (1139, 1379, 2, 'Hemlös');
INSERT INTO `lang_definitions` VALUES (1140, 1380, 2, 'Hemlös');
INSERT INTO `lang_definitions` VALUES (1141, 1381, 2, 'Timmar');
INSERT INTO `lang_definitions` VALUES (1142, 1382, 2, 'Hur uppstod skadan?');
INSERT INTO `lang_definitions` VALUES (1143, 1383, 2, 'Hur uppstod skadan?:');
INSERT INTO `lang_definitions` VALUES (1144, 1384, 2, 'Hur många månader att fråga efter kommande evenemang?');
INSERT INTO `lang_definitions` VALUES (1145, 1388, 2, 'Hyperaktiv');
INSERT INTO `lang_definitions` VALUES (1146, 1390, 2, 'Hyperthyroidism');
INSERT INTO `lang_definitions` VALUES (1147, 1391, 2, 'Hypotyreoidism');
INSERT INTO `lang_definitions` VALUES (1148, 1392, 2, 'Hysterektomi');
INSERT INTO `lang_definitions` VALUES (1149, 1394, 2, 'Jag är upptagen under denna tid.');
INSERT INTO `lang_definitions` VALUES (1150, 1395, 2, 'Jag har inte behörighet att läsa');
INSERT INTO `lang_definitions` VALUES (1151, 1402, 2, 'Identifierare (ett ord)');
INSERT INTO `lang_definitions` VALUES (1152, 1403, 2, 'Om alla uppgifter för alla kolumner är komplett för denna form');
INSERT INTO `lang_definitions` VALUES (1153, 1404, 2, 'Om namn, någon del av efternamn eller efternamn, förnamn');
INSERT INTO `lang_definitions` VALUES (1154, 1405, 2, 'om arbetslösa lägg till student');
INSERT INTO `lang_definitions` VALUES (1155, 1408, 2, 'Om du vill ändra datatyper, lägg till rader eller kolumner');
INSERT INTO `lang_definitions` VALUES (1156, 1409, 2, 'Sjukdom');
INSERT INTO `lang_definitions` VALUES (1157, 1411, 2, 'Vaccinering');
INSERT INTO `lang_definitions` VALUES (1158, 1412, 2, 'Vaccin, Lotnummer');
INSERT INTO `lang_definitions` VALUES (1159, 1413, 2, 'Vaccin, tillverkare');
INSERT INTO `lang_definitions` VALUES (1160, 1414, 2, 'Vaccineringar');
INSERT INTO `lang_definitions` VALUES (1161, 1415, 2, 'Vaccinera');
INSERT INTO `lang_definitions` VALUES (1162, 1417, 2, 'Implantat');
INSERT INTO `lang_definitions` VALUES (1163, 1418, 2, 'Importera ');
INSERT INTO `lang_definitions` VALUES (1164, 1420, 2, 'Importera patient');
INSERT INTO `lang_definitions` VALUES (1165, 1421, 2, 'Importera Patientdemografi');
INSERT INTO `lang_definitions` VALUES (1166, 1422, 2, 'Importerad från Accounting');
INSERT INTO `lang_definitions` VALUES (1167, 1423, 2, 'förbättrad');
INSERT INTO `lang_definitions` VALUES (1168, 1424, 2, 'i');
INSERT INTO `lang_definitions` VALUES (1169, 1426, 2, 'i båda ögonen');
INSERT INTO `lang_definitions` VALUES (1170, 1427, 2, 'i vänster öga');
INSERT INTO `lang_definitions` VALUES (1171, 1428, 2, 'i näsborre');
INSERT INTO `lang_definitions` VALUES (1172, 1429, 2, 'Arbetar');
INSERT INTO `lang_definitions` VALUES (1173, 1430, 2, 'i höger öga');
INSERT INTO `lang_definitions` VALUES (1174, 1433, 2, 'Inaktiv Dagar');
INSERT INTO `lang_definitions` VALUES (1175, 1436, 2, 'Inkludera mätväden');
INSERT INTO `lang_definitions` VALUES (1176, 1438, 2, 'Inkomst');
INSERT INTO `lang_definitions` VALUES (1177, 1441, 2, 'ökat:');
INSERT INTO `lang_definitions` VALUES (1178, 1442, 2, 'Ansvarsförsäkring');
INSERT INTO `lang_definitions` VALUES (1179, 1443, 2, 'Obestämd');
INSERT INTO `lang_definitions` VALUES (1180, 1444, 2, 'Indikerar om detta problem/frågeställning är aktiv');
INSERT INTO `lang_definitions` VALUES (1181, 1445, 2, 'Hjälpbehövande Patienter Rapport');
INSERT INTO `lang_definitions` VALUES (1182, 1448, 2, 'Infektion / Abscess');
INSERT INTO `lang_definitions` VALUES (1183, 1449, 2, 'Infektioner');
INSERT INTO `lang_definitions` VALUES (1184, 1450, 2, 'Infert Couns');
INSERT INTO `lang_definitions` VALUES (1185, 1454, 2, 'Info');
INSERT INTO `lang_definitions` VALUES (1186, 1455, 2, 'Info test 1');
INSERT INTO `lang_definitions` VALUES (1187, 1456, 2, 'Info test 2');
INSERT INTO `lang_definitions` VALUES (1188, 1457, 2, 'Info test 3');
INSERT INTO `lang_definitions` VALUES (1189, 1458, 2, 'Info test 4');
INSERT INTO `lang_definitions` VALUES (1190, 1459, 2, 'Info test 5');
INSERT INTO `lang_definitions` VALUES (1191, 1460, 2, 'Info test 6');
INSERT INTO `lang_definitions` VALUES (1192, 1461, 2, 'inhalation');
INSERT INTO `lang_definitions` VALUES (1193, 1462, 2, 'inhalationer');
INSERT INTO `lang_definitions` VALUES (1194, 1463, 2, 'Ursprunglig användare');
INSERT INTO `lang_definitions` VALUES (1195, 1464, 2, 'Injeserbara');
INSERT INTO `lang_definitions` VALUES (1196, 1465, 2, 'Skadade ut');
INSERT INTO `lang_definitions` VALUES (1197, 1467, 2, 'Skademekanism');
INSERT INTO `lang_definitions` VALUES (1198, 1468, 2, 'Skada, översiktsrapport');
INSERT INTO `lang_definitions` VALUES (1199, 1470, 2, 'Skada Typ');
INSERT INTO `lang_definitions` VALUES (1200, 1471, 2, 'Inmatningsfält');
INSERT INTO `lang_definitions` VALUES (1201, 1472, 2, 'Ins justera');
INSERT INTO `lang_definitions` VALUES (1202, 1473, 2, 'Ins paketering');
INSERT INTO `lang_definitions` VALUES (1203, 1474, 2, 'Ins överskjutande');
INSERT INTO `lang_definitions` VALUES (1204, 1475, 2, 'Ins återbetalning');
INSERT INTO `lang_definitions` VALUES (1205, 1476, 2, 'Ins Sammering');
INSERT INTO `lang_definitions` VALUES (1206, 1477, 2, 'Ins1');
INSERT INTO `lang_definitions` VALUES (1207, 1478, 2, 'Ins2');
INSERT INTO `lang_definitions` VALUES (1208, 1479, 2, 'Ins3');
INSERT INTO `lang_definitions` VALUES (1209, 1480, 2, 'isättning misslyckades:');
INSERT INTO `lang_definitions` VALUES (1210, 1481, 2, 'Sätt gamla händelser i tabeller');
INSERT INTO `lang_definitions` VALUES (1211, 1482, 2, 'Insomnia');
INSERT INTO `lang_definitions` VALUES (1212, 1483, 2, 'Inspektion');
INSERT INTO `lang_definitions` VALUES (1213, 1484, 2, 'Instabilitet / subluxation');
INSERT INTO `lang_definitions` VALUES (1214, 1485, 2, 'installera DB');
INSERT INTO `lang_definitions` VALUES (1215, 1486, 2, 'Instruerad');
INSERT INTO `lang_definitions` VALUES (1216, 1487, 2, 'Instruktioner:');
INSERT INTO `lang_definitions` VALUES (1217, 1488, 2, 'Insulinberoende diabetiker');
INSERT INTO `lang_definitions` VALUES (1218, 1489, 2, 'Försäkring');
INSERT INTO `lang_definitions` VALUES (1219, 1490, 2, 'försäkring');
INSERT INTO `lang_definitions` VALUES (1220, 1491, 2, 'Försäkringsbolag');
INSERT INTO `lang_definitions` VALUES (1221, 1492, 2, 'Försäkringsbolag');
INSERT INTO `lang_definitions` VALUES (1222, 1493, 2, 'Försäkringsbolag Sök / Köp');
INSERT INTO `lang_definitions` VALUES (1223, 1494, 2, 'Försäkring Data');
INSERT INTO `lang_definitions` VALUES (1224, 1495, 2, 'Försäkring Number');
INSERT INTO `lang_definitions` VALUES (1225, 1496, 2, 'Försäkringsbolag');
INSERT INTO `lang_definitions` VALUES (1226, 1500, 2, 'Internt fel - inga sidor valdes!');
INSERT INTO `lang_definitions` VALUES (1227, 1501, 2, 'Internt fel - patient-ID fanns inte!');
INSERT INTO `lang_definitions` VALUES (1228, 1503, 2, 'Internt fel!');
INSERT INTO `lang_definitions` VALUES (1229, 1505, 2, 'Internt fel: påstående');
INSERT INTO `lang_definitions` VALUES (1230, 1506, 2, 'Internt fel: möter\"');
INSERT INTO `lang_definitions` VALUES (1231, 1509, 2, 'Inre Övergångar');
INSERT INTO `lang_definitions` VALUES (1232, 1511, 2, 'Tolk');
INSERT INTO `lang_definitions` VALUES (1233, 1513, 2, 'Interstitiell lungsjukdom');
INSERT INTO `lang_definitions` VALUES (1234, 1514, 2, 'Interval');
INSERT INTO `lang_definitions` VALUES (1235, 1515, 2, 'Intolerans ');
INSERT INTO `lang_definitions` VALUES (1236, 1516, 2, 'intramuskulärt');
INSERT INTO `lang_definitions` VALUES (1237, 1517, 2, 'intravenöst');
INSERT INTO `lang_definitions` VALUES (1238, 1518, 2, 'Introduktion');
INSERT INTO `lang_definitions` VALUES (1239, 1519, 2, 'Ogiltig eller saknas betalaren i källan för kod');
INSERT INTO `lang_definitions` VALUES (1240, 1520, 2, 'Ogiltig Service Kod');
INSERT INTO `lang_definitions` VALUES (1241, 1521, 2, 'Ogiltig källdestination\"');
INSERT INTO `lang_definitions` VALUES (1242, 1523, 2, 'Inventering ');
INSERT INTO `lang_definitions` VALUES (1243, 1524, 2, 'Inventering är inte tillgänglig för denna beställning.');
INSERT INTO `lang_definitions` VALUES (1244, 1525, 2, 'Inventeringslista');
INSERT INTO `lang_definitions` VALUES (1245, 1526, 2, 'Faktura');
INSERT INTO `lang_definitions` VALUES (1246, 1527, 2, 'faktura');
INSERT INTO `lang_definitions` VALUES (1247, 1528, 2, 'Fakturadatum');
INSERT INTO `lang_definitions` VALUES (1248, 1529, 2, 'Fakturanhar inget datum!');
INSERT INTO `lang_definitions` VALUES (1249, 1530, 2, 'Faktura:');
INSERT INTO `lang_definitions` VALUES (1250, 1537, 2, 'Oregelbunden hjärtrytm');
INSERT INTO `lang_definitions` VALUES (1251, 1538, 2, 'Retlighet');
INSERT INTO `lang_definitions` VALUES (1252, 1539, 2, 'Irritation ');
INSERT INTO `lang_definitions` VALUES (1253, 1540, 2, 'är ett obligatoriskt fält.');
INSERT INTO `lang_definitions` VALUES (1254, 1542, 2, 'inte är giltig (decimalbråk är OK).');
INSERT INTO `lang_definitions` VALUES (1255, 1543, 2, 'Är PHP använder felsäkert läge?');
INSERT INTO `lang_definitions` VALUES (1256, 1545, 2, 'frågeställning');
INSERT INTO `lang_definitions` VALUES (1257, 1546, 2, 'Frågeställning');
INSERT INTO `lang_definitions` VALUES (1258, 1547, 2, 'Aktuellt');
INSERT INTO `lang_definitions` VALUES (1259, 1548, 2, 'Aktuellt (Problem / Medicin / Allergi):');
INSERT INTO `lang_definitions` VALUES (1260, 1549, 2, 'Information och Patientmöten');
INSERT INTO `lang_definitions` VALUES (1261, 1550, 2, 'Information och möten för');
INSERT INTO `lang_definitions` VALUES (1262, 1551, 2, 'Problematik, ej behörig');
INSERT INTO `lang_definitions` VALUES (1263, 1552, 2, 'Frågeställningssektion');
INSERT INTO `lang_definitions` VALUES (1264, 1553, 2, 'Artikel');
INSERT INTO `lang_definitions` VALUES (1265, 1554, 2, 'artikel');
INSERT INTO `lang_definitions` VALUES (1266, 1555, 2, 'Poster laddades inte');
INSERT INTO `lang_definitions` VALUES (1267, 1558, 2, 'Januari');
INSERT INTO `lang_definitions` VALUES (1268, 1560, 2, 'Jobb-beskrivning');
INSERT INTO `lang_definitions` VALUES (1269, 1561, 2, 'Jobb id');
INSERT INTO `lang_definitions` VALUES (1270, 1562, 2, 'Led dislokation');
INSERT INTO `lang_definitions` VALUES (1271, 1563, 2, 'Led smärta');
INSERT INTO `lang_definitions` VALUES (1272, 1564, 2, 'Led vrickning');
INSERT INTO `lang_definitions` VALUES (1273, 1565, 2, 'Juli');
INSERT INTO `lang_definitions` VALUES (1274, 1566, 2, 'Juni');
INSERT INTO `lang_definitions` VALUES (1275, 1568, 2, 'Bara min');
INSERT INTO `lang_definitions` VALUES (1276, 1569, 2, 'Motivera');
INSERT INTO `lang_definitions` VALUES (1277, 1570, 2, 'Motivera / Spara');
INSERT INTO `lang_definitions` VALUES (1278, 1571, 2, 'k, här är resten');
INSERT INTO `lang_definitions` VALUES (1279, 1572, 2, 'Nyckelord');
INSERT INTO `lang_definitions` VALUES (1280, 1575, 2, 'Njurcancer');
INSERT INTO `lang_definitions` VALUES (1281, 1576, 2, 'Njursvikt');
INSERT INTO `lang_definitions` VALUES (1282, 1577, 2, 'Njure Infektioner');
INSERT INTO `lang_definitions` VALUES (1283, 1578, 2, 'Njursten');
INSERT INTO `lang_definitions` VALUES (1284, 1579, 2, 'Njurtransplantation');
INSERT INTO `lang_definitions` VALUES (1285, 1580, 2, 'Knä');
INSERT INTO `lang_definitions` VALUES (1286, 1581, 2, 'Knä Problem');
INSERT INTO `lang_definitions` VALUES (1287, 1582, 2, 'Knä Ersättning /protes');
INSERT INTO `lang_definitions` VALUES (1288, 1583, 2, 'Lab');
INSERT INTO `lang_definitions` VALUES (1289, 1584, 2, 'Lab Rapport');
INSERT INTO `lang_definitions` VALUES (1290, 1585, 2, 'Etikett');
INSERT INTO `lang_definitions` VALUES (1291, 1587, 2, 'Label Cols');
INSERT INTO `lang_definitions` VALUES (1292, 1589, 2, 'Etiketter');
INSERT INTO `lang_definitions` VALUES (1293, 1590, 2, 'Labs');
INSERT INTO `lang_definitions` VALUES (1294, 1591, 2, 'Laceration / hudkodition');
INSERT INTO `lang_definitions` VALUES (1295, 1592, 2, 'Laceration / nötning');
INSERT INTO `lang_definitions` VALUES (1296, 1593, 2, 'Språk');
INSERT INTO `lang_definitions` VALUES (1297, 1594, 2, 'Språk-kod');
INSERT INTO `lang_definitions` VALUES (1298, 1595, 2, 'Språk definition tillagd');
INSERT INTO `lang_definitions` VALUES (1299, 1598, 2, 'Språknamn');
INSERT INTO `lang_definitions` VALUES (1300, 1599, 2, 'Språk:');
INSERT INTO `lang_definitions` VALUES (1301, 1600, 2, 'Sist');
INSERT INTO `lang_definitions` VALUES (1302, 1601, 2, 'Datum för senaste aktivitet');
INSERT INTO `lang_definitions` VALUES (1303, 1602, 2, 'Sista betalnings dag på faktura:');
INSERT INTO `lang_definitions` VALUES (1304, 1603, 2, 'Senaste patientmötet');
INSERT INTO `lang_definitions` VALUES (1305, 1604, 2, 'Efternamn');
INSERT INTO `lang_definitions` VALUES (1306, 1605, 2, 'Efternamn');
INSERT INTO `lang_definitions` VALUES (1307, 1606, 2, 'Efternamn:');
INSERT INTO `lang_definitions` VALUES (1308, 1607, 2, 'Senast sparad');
INSERT INTO `lang_definitions` VALUES (1309, 1608, 2, 'Senast uppdaterad av');
INSERT INTO `lang_definitions` VALUES (1310, 1609, 2, 'Senaste besöket');
INSERT INTO `lang_definitions` VALUES (1311, 1610, 2, 'Sen Återkommande (2-12 mån)');
INSERT INTO `lang_definitions` VALUES (1312, 1613, 2, 'sidled fördrivna PMI:');
INSERT INTO `lang_definitions` VALUES (1313, 1615, 2, 'Layout Editor');
INSERT INTO `lang_definitions` VALUES (1314, 1618, 2, 'Layouter');
INSERT INTO `lang_definitions` VALUES (1315, 1621, 2, 'LDL');
INSERT INTO `lang_definitions` VALUES (1316, 1622, 2, 'lämna tom om fortfarande aktiv');
INSERT INTO `lang_definitions` VALUES (1317, 1623, 2, 'Lämna tomt för att hålla lösenord oförändrad.');
INSERT INTO `lang_definitions` VALUES (1318, 1624, 2, 'Kontakt via');
INSERT INTO `lang_definitions` VALUES (1319, 1625, 2, 'Lämna Form');
INSERT INTO `lang_definitions` VALUES (1320, 1626, 2, 'Vänster');
INSERT INTO `lang_definitions` VALUES (1321, 1627, 2, 'vänster öra');
INSERT INTO `lang_definitions` VALUES (1322, 1628, 2, 'vänster öra');
INSERT INTO `lang_definitions` VALUES (1323, 1629, 2, 'Vänster:');
INSERT INTO `lang_definitions` VALUES (1324, 1630, 2, 'Vänster:');
INSERT INTO `lang_definitions` VALUES (1325, 1631, 2, 'Ben smärta / Kramper');
INSERT INTO `lang_definitions` VALUES (1326, 1632, 2, 'Rättsärenden');
INSERT INTO `lang_definitions` VALUES (1327, 1633, 2, 'Förklaring:');
INSERT INTO `lang_definitions` VALUES (1328, 1634, 2, 'Längd');
INSERT INTO `lang_definitions` VALUES (1329, 1636, 2, 'Brev');
INSERT INTO `lang_definitions` VALUES (1330, 1637, 2, 'Brevgenerator');
INSERT INTO `lang_definitions` VALUES (1331, 1641, 2, 'Ansvar');
INSERT INTO `lang_definitions` VALUES (1332, 1642, 2, 'Ansvar för medicinskt');
INSERT INTO `lang_definitions` VALUES (1333, 1643, 2, 'passnr');
INSERT INTO `lang_definitions` VALUES (1334, 1644, 2, 'Livsstil');
INSERT INTO `lang_definitions` VALUES (1335, 1645, 2, 'Ligament skada eller vrickning');
INSERT INTO `lang_definitions` VALUES (1336, 1646, 2, 'Begränsning av händelser');
INSERT INTO `lang_definitions` VALUES (1337, 1649, 2, 'Förteckning');
INSERT INTO `lang_definitions` VALUES (1338, 1654, 2, 'List Editor');
INSERT INTO `lang_definitions` VALUES (1339, 1656, 2, 'Lista Insurance Companies');
INSERT INTO `lang_definitions` VALUES (1340, 1659, 2, 'Lista listor');
INSERT INTO `lang_definitions` VALUES (1341, 1660, 2, 'Lista Namn');
INSERT INTO `lang_definitions` VALUES (1342, 1662, 2, 'Lista recept');
INSERT INTO `lang_definitions` VALUES (1343, 1663, 2, 'Listor');
INSERT INTO `lang_definitions` VALUES (1344, 1666, 2, 'Ladda definitioner');
INSERT INTO `lang_definitions` VALUES (1345, 1667, 2, 'Laddar');
INSERT INTO `lang_definitions` VALUES (1346, 1669, 2, 'Lokalt');
INSERT INTO `lang_definitions` VALUES (1347, 1670, 2, 'Lokalitet');
INSERT INTO `lang_definitions` VALUES (1348, 1671, 2, 'Lokalisation');
INSERT INTO `lang_definitions` VALUES (1349, 1672, 2, 'Lokalisation ospecificerad');
INSERT INTO `lang_definitions` VALUES (1350, 1673, 2, 'Lokalisation');
INSERT INTO `lang_definitions` VALUES (1351, 1675, 2, 'Inloggad');
INSERT INTO `lang_definitions` VALUES (1352, 1676, 2, 'Inloggad som');
INSERT INTO `lang_definitions` VALUES (1353, 1677, 2, 'Inloggad som:');
INSERT INTO `lang_definitions` VALUES (1354, 1678, 2, 'Utloggad.');
INSERT INTO `lang_definitions` VALUES (1355, 1679, 2, 'Logga in');
INSERT INTO `lang_definitions` VALUES (1356, 1680, 2, 'logga in');
INSERT INTO `lang_definitions` VALUES (1357, 1681, 2, 'Logout');
INSERT INTO `lang_definitions` VALUES (1358, 1682, 2, 'logout');
INSERT INTO `lang_definitions` VALUES (1359, 1683, 2, 'Loggar');
INSERT INTO `lang_definitions` VALUES (1360, 1685, 2, 'Slå upp');
INSERT INTO `lang_definitions` VALUES (1361, 1686, 2, 'Batch');
INSERT INTO `lang_definitions` VALUES (1362, 1688, 2, 'Batchnummer');
INSERT INTO `lang_definitions` VALUES (1363, 1689, 2, 'låg');
INSERT INTO `lang_definitions` VALUES (1364, 1690, 2, 'Benet');
INSERT INTO `lang_definitions` VALUES (1365, 1691, 2, 'Lumbal delen av ryggraden');
INSERT INTO `lang_definitions` VALUES (1366, 1692, 2, 'LUNCH');
INSERT INTO `lang_definitions` VALUES (1367, 1693, 2, 'Lunch');
INSERT INTO `lang_definitions` VALUES (1368, 1694, 2, 'Lung Cancer');
INSERT INTO `lang_definitions` VALUES (1369, 1695, 2, 'Lung Cancer kirurgi');
INSERT INTO `lang_definitions` VALUES (1370, 1696, 2, 'Lungor:');
INSERT INTO `lang_definitions` VALUES (1371, 1697, 2, 'Lungor:');
INSERT INTO `lang_definitions` VALUES (1372, 1699, 2, 'M');
INSERT INTO `lang_definitions` VALUES (1373, 1700, 2, 'MA Kategori');
INSERT INTO `lang_definitions` VALUES (1374, 1701, 2, 'Huvudadress');
INSERT INTO `lang_definitions` VALUES (1375, 1702, 2, 'Gör ändringar i nuvarande kategorier.');
INSERT INTO `lang_definitions` VALUES (1376, 1703, 2, 'Försäkra \"');
INSERT INTO `lang_definitions` VALUES (1377, 1704, 2, 'Sjukdomskänsla:');
INSERT INTO `lang_definitions` VALUES (1378, 1705, 2, 'Man');
INSERT INTO `lang_definitions` VALUES (1379, 1706, 2, 'Manlig Kondomer');
INSERT INTO `lang_definitions` VALUES (1380, 1708, 2, 'Mammogram');
INSERT INTO `lang_definitions` VALUES (1381, 1709, 2, 'Administration');
INSERT INTO `lang_definitions` VALUES (1382, 1710, 2, 'Manuell post');
INSERT INTO `lang_definitions` VALUES (1383, 1711, 2, 'Tillverkare');
INSERT INTO `lang_definitions` VALUES (1384, 1712, 2, 'Mars');
INSERT INTO `lang_definitions` VALUES (1385, 1713, 2, 'Civilstånd');
INSERT INTO `lang_definitions` VALUES (1386, 1714, 2, 'Markera som faktureras men hoppa fakturering');
INSERT INTO `lang_definitions` VALUES (1387, 1715, 2, 'Markera som avklarad');
INSERT INTO `lang_definitions` VALUES (1388, 1716, 2, 'Markera som ej fakturerad');
INSERT INTO `lang_definitions` VALUES (1389, 1717, 2, 'Markerad som avslutad');
INSERT INTO `lang_definitions` VALUES (1390, 1718, 2, 'Gift');
INSERT INTO `lang_definitions` VALUES (1391, 1719, 2, 'Maxillary Höger:');
INSERT INTO `lang_definitions` VALUES (1392, 1720, 2, 'Maj');
INSERT INTO `lang_definitions` VALUES (1393, 1721, 2, 'MC');
INSERT INTO `lang_definitions` VALUES (1394, 1722, 2, 'mcg');
INSERT INTO `lang_definitions` VALUES (1395, 1725, 2, 'Medicinsk');
INSERT INTO `lang_definitions` VALUES (1396, 1727, 2, 'Medicinska problem');
INSERT INTO `lang_definitions` VALUES (1397, 1728, 2, 'Medicinska problem');
INSERT INTO `lang_definitions` VALUES (1398, 1729, 2, 'Journal');
INSERT INTO `lang_definitions` VALUES (1399, 1730, 2, 'Journal #');
INSERT INTO `lang_definitions` VALUES (1400, 1731, 2, 'Journaler');
INSERT INTO `lang_definitions` VALUES (1401, 1732, 2, 'Journal / Historia ( frivilligt att skriva )');
INSERT INTO `lang_definitions` VALUES (1402, 1734, 2, 'Medicin');
INSERT INTO `lang_definitions` VALUES (1403, 1735, 2, 'Läkemedel');
INSERT INTO `lang_definitions` VALUES (1404, 1736, 2, 'Läkemedel:');
INSERT INTO `lang_definitions` VALUES (1405, 1737, 2, 'Medicinska enheter');
INSERT INTO `lang_definitions` VALUES (1406, 1738, 2, 'Medium');
INSERT INTO `lang_definitions` VALUES (1407, 1739, 2, 'Ledamot Association Statistik Rapport');
INSERT INTO `lang_definitions` VALUES (1408, 1740, 2, 'Minnes Problem');
INSERT INTO `lang_definitions` VALUES (1409, 1741, 2, 'Män');
INSERT INTO `lang_definitions` VALUES (1410, 1742, 2, 'Män och kvinnor');
INSERT INTO `lang_definitions` VALUES (1411, 1743, 2, 'Män Endast');
INSERT INTO `lang_definitions` VALUES (1412, 1745, 2, 'Klimakteriet');
INSERT INTO `lang_definitions` VALUES (1413, 1748, 2, 'Psykisk sjukdom');
INSERT INTO `lang_definitions` VALUES (1414, 1749, 2, 'Meddelande');
INSERT INTO `lang_definitions` VALUES (1415, 1750, 2, 'MEDELANDE:');
INSERT INTO `lang_definitions` VALUES (1416, 1751, 2, 'Metod');
INSERT INTO `lang_definitions` VALUES (1417, 1752, 2, 'Metod för förstöring');
INSERT INTO `lang_definitions` VALUES (1418, 1753, 2, 'mg');
INSERT INTO `lang_definitions` VALUES (1419, 1754, 2, 'mg/ml');
INSERT INTO `lang_definitions` VALUES (1420, 1755, 2, 'g');
INSERT INTO `lang_definitions` VALUES (1421, 1756, 2, 'g/ml');
INSERT INTO `lang_definitions` VALUES (1422, 1759, 2, 'Mellan');
INSERT INTO `lang_definitions` VALUES (1423, 1760, 2, 'Mellannamn');
INSERT INTO `lang_definitions` VALUES (1424, 1761, 2, 'Mellannamn');
INSERT INTO `lang_definitions` VALUES (1425, 1762, 2, 'Migrerande eller säsongsarbetare?');
INSERT INTO `lang_definitions` VALUES (1426, 1763, 2, 'Migrerande / Säsong');
INSERT INTO `lang_definitions` VALUES (1427, 1767, 2, 'minuter');
INSERT INTO `lang_definitions` VALUES (1428, 1768, 2, 'Protokoll');
INSERT INTO `lang_definitions` VALUES (1429, 1773, 2, 'Diverse');
INSERT INTO `lang_definitions` VALUES (1430, 1774, 2, 'Missade');
INSERT INTO `lang_definitions` VALUES (1431, 1778, 2, 'Blandat');
INSERT INTO `lang_definitions` VALUES (1432, 1779, 2, 'ml');
INSERT INTO `lang_definitions` VALUES (1433, 1783, 2, 'Mobil');
INSERT INTO `lang_definitions` VALUES (1434, 1784, 2, 'Mobiltelefon');
INSERT INTO `lang_definitions` VALUES (1435, 1787, 2, 'Mån');
INSERT INTO `lang_definitions` VALUES (1436, 1788, 2, 'Mån tills fredag');
INSERT INTO `lang_definitions` VALUES (1437, 1789, 2, 'Måndag, onsdag och fredag');
INSERT INTO `lang_definitions` VALUES (1438, 1790, 2, 'Måndag');
INSERT INTO `lang_definitions` VALUES (1439, 1791, 2, 'månad');
INSERT INTO `lang_definitions` VALUES (1440, 1792, 2, 'Månad');
INSERT INTO `lang_definitions` VALUES (1441, 1793, 2, 'Månadsvy');
INSERT INTO `lang_definitions` VALUES (1442, 1794, 2, 'Månad (er)');
INSERT INTO `lang_definitions` VALUES (1443, 1795, 2, 'Månadsinkomst');
INSERT INTO `lang_definitions` VALUES (1444, 1797, 2, 'Mer än 50 resultat, gör din sökning mer specifik.');
INSERT INTO `lang_definitions` VALUES (1445, 1798, 2, 'Moder');
INSERT INTO `lang_definitions` VALUES (1446, 1800, 2, 'Flytta');
INSERT INTO `lang_definitions` VALUES (1447, 1803, 2, 'Flytta till patient');
INSERT INTO `lang_definitions` VALUES (1448, 1804, 2, 'Flytta till...');
INSERT INTO `lang_definitions` VALUES (1449, 1805, 2, 'flytta up');
INSERT INTO `lang_definitions` VALUES (1450, 1806, 2, 'Herr.');
INSERT INTO `lang_definitions` VALUES (1451, 1807, 2, 'Fru.');
INSERT INTO `lang_definitions` VALUES (1452, 1808, 2, 'Fröken');
INSERT INTO `lang_definitions` VALUES (1453, 1809, 2, 'Multi Language Tool');
INSERT INTO `lang_definitions` VALUES (1454, 1810, 2, 'Flera områden');
INSERT INTO `lang_definitions` VALUES (1455, 1811, 2, 'Sorla:');
INSERT INTO `lang_definitions` VALUES (1456, 1812, 2, 'Muskel värk');
INSERT INTO `lang_definitions` VALUES (1457, 1818, 2, 'Muskel');
INSERT INTO `lang_definitions` VALUES (1458, 1819, 2, 'Muskel skada');
INSERT INTO `lang_definitions` VALUES (1459, 1820, 2, 'Muskuloskeletala');
INSERT INTO `lang_definitions` VALUES (1460, 1821, 2, 'Ömsesidigt Definierad');
INSERT INTO `lang_definitions` VALUES (1461, 1825, 2, 'Namn');
INSERT INTO `lang_definitions` VALUES (1462, 1826, 2, 'Namn 1');
INSERT INTO `lang_definitions` VALUES (1463, 1827, 2, 'Namn 2');
INSERT INTO `lang_definitions` VALUES (1464, 1828, 2, 'Namn på administratör');
INSERT INTO `lang_definitions` VALUES (1465, 1829, 2, 'Namn på försäkringsbolag');
INSERT INTO `lang_definitions` VALUES (1466, 1830, 2, 'Namn på Provider');
INSERT INTO `lang_definitions` VALUES (1467, 1833, 2, 'Namn:');
INSERT INTO `lang_definitions` VALUES (1468, 1834, 2, 'Narės:');
INSERT INTO `lang_definitions` VALUES (1469, 1835, 2, 'Narės: Normal Rätt');
INSERT INTO `lang_definitions` VALUES (1470, 1836, 2, 'Nasal mucosa rosa, septumets mittlinje');
INSERT INTO `lang_definitions` VALUES (1471, 1837, 2, 'Nationalitet');
INSERT INTO `lang_definitions` VALUES (1472, 1839, 2, 'Navigering');
INSERT INTO `lang_definitions` VALUES (1473, 1842, 2, 'Nacke');
INSERT INTO `lang_definitions` VALUES (1474, 1843, 2, 'Nackproblem');
INSERT INTO `lang_definitions` VALUES (1475, 1845, 2, 'Måste ange en beskrivning');
INSERT INTO `lang_definitions` VALUES (1476, 1846, 2, 'Ange ett returvärde');
INSERT INTO `lang_definitions` VALUES (1477, 1847, 2, 'Ange identifieraren');
INSERT INTO `lang_definitions` VALUES (1478, 1848, 2, 'Ange titel');
INSERT INTO `lang_definitions` VALUES (1479, 1851, 2, 'Ange sekundära fakturering');
INSERT INTO `lang_definitions` VALUES (1480, 1852, 2, 'Nervskada');
INSERT INTO `lang_definitions` VALUES (1481, 1853, 2, 'Neurala tillstånd / nervskada');
INSERT INTO `lang_definitions` VALUES (1482, 1857, 2, 'Ny');
INSERT INTO `lang_definitions` VALUES (1483, 1858, 2, 'Ny =>');
INSERT INTO `lang_definitions` VALUES (1484, 1859, 2, 'Nya mottagare');
INSERT INTO `lang_definitions` VALUES (1485, 1861, 2, 'Nytt möte');
INSERT INTO `lang_definitions` VALUES (1486, 1862, 2, 'Nya kategorier');
INSERT INTO `lang_definitions` VALUES (1487, 1864, 2, 'Nya kunder');
INSERT INTO `lang_definitions` VALUES (1488, 1865, 2, 'Ny konsultation');
INSERT INTO `lang_definitions` VALUES (1489, 1866, 2, 'Nytt definitionset tillagt');
INSERT INTO `lang_definitions` VALUES (1490, 1868, 2, 'Nya Patientbesöksformulär');
INSERT INTO `lang_definitions` VALUES (1491, 1869, 2, 'Nya möten som inte godkänts');
INSERT INTO `lang_definitions` VALUES (1492, 1871, 2, 'Nya Klinikinformation');
INSERT INTO `lang_definitions` VALUES (1493, 1872, 2, 'Ny grupp');
INSERT INTO `lang_definitions` VALUES (1494, 1874, 2, 'Ny begränsning av händelser');
INSERT INTO `lang_definitions` VALUES (1495, 1876, 2, 'Ny Patient');
INSERT INTO `lang_definitions` VALUES (1496, 1877, 2, 'Nytt Patientbesök');
INSERT INTO `lang_definitions` VALUES (1497, 1878, 2, 'Nytt patient-ID');
INSERT INTO `lang_definitions` VALUES (1498, 1880, 2, 'Nya förslag');
INSERT INTO `lang_definitions` VALUES (1499, 1881, 2, 'Ny användare');
INSERT INTO `lang_definitions` VALUES (1500, 1882, 2, 'Nytt besök');
INSERT INTO `lang_definitions` VALUES (1501, 1883, 2, 'Ny/Sök');
INSERT INTO `lang_definitions` VALUES (1502, 1884, 2, 'Dagstidning');
INSERT INTO `lang_definitions` VALUES (1503, 1885, 2, 'Nästa');
INSERT INTO `lang_definitions` VALUES (1504, 1886, 2, 'Nästa dag');
INSERT INTO `lang_definitions` VALUES (1505, 1887, 2, 'Nästa Månad');
INSERT INTO `lang_definitions` VALUES (1506, 1888, 2, 'Nästa vecka');
INSERT INTO `lang_definitions` VALUES (1507, 1889, 2, 'Alias');
INSERT INTO `lang_definitions` VALUES (1508, 1890, 2, 'Nattliga svettningar');
INSERT INTO `lang_definitions` VALUES (1509, 1892, 2, 'NEJ');
INSERT INTO `lang_definitions` VALUES (1510, 1893, 2, 'Nej');
INSERT INTO `lang_definitions` VALUES (1511, 1894, 2, 'Ingen tillgång');
INSERT INTO `lang_definitions` VALUES (1512, 1897, 2, 'Inget faktureringssystem är aktivt');
INSERT INTO `lang_definitions` VALUES (1513, 1899, 2, 'Ingen kod specificerades!');
INSERT INTO `lang_definitions` VALUES (1514, 1900, 2, 'Ingen diagnos');
INSERT INTO `lang_definitions` VALUES (1515, 1901, 2, 'Inget slutdatum');
INSERT INTO `lang_definitions` VALUES (1516, 1902, 2, 'Inga poster funna, använda formuläret nedan för att lägga till en post.');
INSERT INTO `lang_definitions` VALUES (1517, 1903, 2, 'Inga händelser');
INSERT INTO `lang_definitions` VALUES (1518, 1904, 2, 'Ingen grupp valdes');
INSERT INTO `lang_definitions` VALUES (1519, 1905, 2, 'Inga bråck');
INSERT INTO `lang_definitions` VALUES (1520, 1906, 2, 'Nr Insurance Companies Found');
INSERT INTO `lang_definitions` VALUES (1521, 1911, 2, 'Inga tider hittades för denna period.');
INSERT INTO `lang_definitions` VALUES (1522, 1912, 2, 'Inga Partners hittades');
INSERT INTO `lang_definitions` VALUES (1523, 1913, 2, 'Inga perifera ödem');
INSERT INTO `lang_definitions` VALUES (1524, 1914, 2, 'Inga apotek hittades');
INSERT INTO `lang_definitions` VALUES (1525, 1915, 2, 'Inga recept hittades');
INSERT INTO `lang_definitions` VALUES (1526, 1916, 2, 'Ingen sjukdom / skada visas');
INSERT INTO `lang_definitions` VALUES (1527, 1921, 2, 'Inga resultat hittades i sökningen');
INSERT INTO `lang_definitions` VALUES (1528, 1922, 2, 'Inga resultat, försök igen.');
INSERT INTO `lang_definitions` VALUES (1529, 1924, 2, 'Ej kommit på avtalad tid');
INSERT INTO `lang_definitions` VALUES (1530, 1926, 2, 'Ingen hud dimpling eller bröst knölar');
INSERT INTO `lang_definitions` VALUES (1531, 1931, 2, 'Nr:');
INSERT INTO `lang_definitions` VALUES (1532, 1933, 2, 'Icke specifika skada');
INSERT INTO `lang_definitions` VALUES (1533, 1934, 2, 'Icke-insulinberoende diabetes');
INSERT INTO `lang_definitions` VALUES (1534, 1935, 2, 'Icke-SRH Medical');
INSERT INTO `lang_definitions` VALUES (1535, 1936, 2, 'Icke-SRH icke-medicinska');
INSERT INTO `lang_definitions` VALUES (1536, 1937, 2, 'Ingen');
INSERT INTO `lang_definitions` VALUES (1537, 1938, 2, 'ingen');
INSERT INTO `lang_definitions` VALUES (1538, 1939, 2, 'Inget av ovanstående');
INSERT INTO `lang_definitions` VALUES (1539, 1941, 2, 'Inte heller');
INSERT INTO `lang_definitions` VALUES (1540, 1942, 2, 'Normal');
INSERT INTO `lang_definitions` VALUES (1541, 1953, 2, 'Normal:');
INSERT INTO `lang_definitions` VALUES (1542, 1957, 2, 'Alla fält är obligatoriska för alla nummer eller kod typer.');
INSERT INTO `lang_definitions` VALUES (1543, 1958, 2, 'Ej tillåtet');
INSERT INTO `lang_definitions` VALUES (1544, 1959, 2, 'Ej tillåtet att ta bort gruppen Administratörer');
INSERT INTO `lang_definitions` VALUES (1545, 1960, 2, 'Ej tillåtet att inaktivera alla trygghet objekt');
INSERT INTO `lang_definitions` VALUES (1546, 1961, 2, 'Ej tillåtet att inaktivera allt från Administratörer ACL');
INSERT INTO `lang_definitions` VALUES (1547, 1962, 2, 'Ej tillåtet att ta bort admin-användare från gruppen Administratörer');
INSERT INTO `lang_definitions` VALUES (1548, 1963, 2, 'Ej behörighet att nå PostCalendar modulen');
INSERT INTO `lang_definitions` VALUES (1549, 1969, 2, 'Inte undersökt');
INSERT INTO `lang_definitions` VALUES (1550, 1970, 2, 'Inte undersökt:');
INSERT INTO `lang_definitions` VALUES (1551, 1971, 2, 'Inte undersökt:');
INSERT INTO `lang_definitions` VALUES (1552, 1974, 2, 'Inte sett sedan');
INSERT INTO `lang_definitions` VALUES (1553, 1975, 2, 'kommentera');
INSERT INTO `lang_definitions` VALUES (1554, 1976, 2, 'Kommentartyp');
INSERT INTO `lang_definitions` VALUES (1555, 1977, 2, 'Anmärkning: Denna kod har inte förts in av en auktoriserad användare. Endast godkända koder kan laddas upp till Open Medical Billing nätverket för bearbetning. Om du vill ladda upp dessa nummer kan du välja en auktoriserad användare här.');
INSERT INTO `lang_definitions` VALUES (1556, 1978, 2, 'OBS: Överföra filer med duplikat namn gör att filerna automatiskt ska döpas. Till exempel \"<i> file.jpg </ i>\" blir \"<i> file.jpg.1 </ i>\". Filnamnen anses unika per patient, inte per kategori.');
INSERT INTO `lang_definitions` VALUES (1557, 1979, 2, 'Kommentarer');
INSERT INTO `lang_definitions` VALUES (1558, 1983, 2, 'Ingenting valdes');
INSERT INTO `lang_definitions` VALUES (1559, 1984, 2, 'MEDDELANDE: PostCalendar Inlämning / Modifiering');
INSERT INTO `lang_definitions` VALUES (1560, 1985, 2, 'Besked');
INSERT INTO `lang_definitions` VALUES (1561, 1986, 2, 'Meddela Admin Om Händelse Inlämning / Modifieringsförslag?');
INSERT INTO `lang_definitions` VALUES (1562, 1987, 2, 'November');
INSERT INTO `lang_definitions` VALUES (1563, 1993, 2, 'NPI');
INSERT INTO `lang_definitions` VALUES (1564, 1994, 2, 'Nummer');
INSERT INTO `lang_definitions` VALUES (1565, 1995, 2, 'Antal kolumner i år-vy.');
INSERT INTO `lang_definitions` VALUES (1566, 2004, 2, 'Yrke');
INSERT INTO `lang_definitions` VALUES (1567, 2005, 2, 'Förekomst');
INSERT INTO `lang_definitions` VALUES (1568, 2006, 2, 'Oktober');
INSERT INTO `lang_definitions` VALUES (1569, 2009, 2, 'tabletter');
INSERT INTO `lang_definitions` VALUES (1570, 2010, 2, 'i månaden per');
INSERT INTO `lang_definitions` VALUES (1571, 2012, 2, 'Mottagningskommentarer');
INSERT INTO `lang_definitions` VALUES (1572, 2013, 2, 'Mottagningsbesök');
INSERT INTO `lang_definitions` VALUES (1573, 2014, 2, 'Avkomma');
INSERT INTO `lang_definitions` VALUES (1574, 2015, 2, 'salva');
INSERT INTO `lang_definitions` VALUES (1575, 2016, 2, 'OK');
INSERT INTO `lang_definitions` VALUES (1576, 2018, 2, 'Gamla klienter');
INSERT INTO `lang_definitions` VALUES (1577, 2021, 2, 'underlåtit att autoassign');
INSERT INTO `lang_definitions` VALUES (1578, 2022, 2, 'på');
INSERT INTO `lang_definitions` VALUES (1579, 2023, 2, 'På Hand');
INSERT INTO `lang_definitions` VALUES (1580, 2024, 2, 'På beställning');
INSERT INTO `lang_definitions` VALUES (1581, 2025, 2, 'När du byter lösenord måste du logga in på nytt.');
INSERT INTO `lang_definitions` VALUES (1582, 2027, 2, 'Endast aktiva');
INSERT INTO `lang_definitions` VALUES (1583, 2028, 2, 'endast om faktureringsadress');
INSERT INTO `lang_definitions` VALUES (1584, 2029, 2, 'Endast Inaktiva');
INSERT INTO `lang_definitions` VALUES (1585, 2030, 2, 'Endast Min');
INSERT INTO `lang_definitions` VALUES (1586, 2031, 2, 'Uppkomsten av sjukdom:');
INSERT INTO `lang_definitions` VALUES (1587, 2032, 2, 'Uppkomsten av sjukdom:');
INSERT INTO `lang_definitions` VALUES (1588, 2033, 2, 'Uppkomsten av Svullnad:');
INSERT INTO `lang_definitions` VALUES (1589, 2034, 2, 'Debut / Inskrivning. Datum:');
INSERT INTO `lang_definitions` VALUES (1590, 2035, 2, 'Öppen');
INSERT INTO `lang_definitions` VALUES (1591, 2036, 2, 'OpenEMR kräver Javascript för att utföra användarverifiering.');
INSERT INTO `lang_definitions` VALUES (1592, 2038, 2, 'Alternativ');
INSERT INTO `lang_definitions` VALUES (1593, 2039, 2, 'Valfritt');
INSERT INTO `lang_definitions` VALUES (1594, 2041, 2, 'Frivillig information om denna händelse');
INSERT INTO `lang_definitions` VALUES (1595, 2044, 2, 'Valfri procedurkodkod');
INSERT INTO `lang_definitions` VALUES (1596, 2045, 2, 'Eller');
INSERT INTO `lang_definitions` VALUES (1597, 2046, 2, 'ELLER');
INSERT INTO `lang_definitions` VALUES (1598, 2047, 2, 'Eller välj');
INSERT INTO `lang_definitions` VALUES (1599, 2049, 2, 'Eller ladda upp ERA fil:');
INSERT INTO `lang_definitions` VALUES (1600, 2052, 2, 'Ordning');
INSERT INTO `lang_definitions` VALUES (1601, 2054, 2, 'Organskada');
INSERT INTO `lang_definitions` VALUES (1602, 2055, 2, 'Organisation');
INSERT INTO `lang_definitions` VALUES (1603, 2057, 2, 'Orienterad x 3');
INSERT INTO `lang_definitions` VALUES (1604, 2061, 2, 'P.O. (via munnen)');
INSERT INTO `lang_definitions` VALUES (1605, 2063, 2, 'Övrigt');
INSERT INTO `lang_definitions` VALUES (1606, 2064, 2, 'annan');
INSERT INTO `lang_definitions` VALUES (1607, 2068, 2, 'Andra skador inte specificerade på någon annan plats');
INSERT INTO `lang_definitions` VALUES (1608, 2069, 2, 'annan månad');
INSERT INTO `lang_definitions` VALUES (1609, 2070, 2, 'Andra icke-federala program');
INSERT INTO `lang_definitions` VALUES (1610, 2072, 2, 'Andra relevanta Symtom');
INSERT INTO `lang_definitions` VALUES (1611, 2073, 2, 'Andra relevanta Symtom:');
INSERT INTO `lang_definitions` VALUES (1612, 2075, 2, 'Andra kirurgiska');
INSERT INTO `lang_definitions` VALUES (1613, 2079, 2, 'OU');
INSERT INTO `lang_definitions` VALUES (1614, 2082, 2, 'Utfall');
INSERT INTO `lang_definitions` VALUES (1615, 2083, 2, 'Outlook');
INSERT INTO `lang_definitions` VALUES (1616, 2084, 2, 'Överutnyttjande');
INSERT INTO `lang_definitions` VALUES (1617, 2089, 2, 'vid behov');
INSERT INTO `lang_definitions` VALUES (1618, 2092, 2, 'Pedriatisk');
INSERT INTO `lang_definitions` VALUES (1619, 2094, 2, 'Sidor');
INSERT INTO `lang_definitions` VALUES (1620, 2095, 2, 'Betald');
INSERT INTO `lang_definitions` VALUES (1621, 2096, 2, 'Betalt belopp som du kommer att fördela');
INSERT INTO `lang_definitions` VALUES (1622, 2097, 2, 'Betalas via');
INSERT INTO `lang_definitions` VALUES (1623, 2103, 2, 'Partner');
INSERT INTO `lang_definitions` VALUES (1624, 2104, 2, 'Lösenord');
INSERT INTO `lang_definitions` VALUES (1625, 2105, 2, 'Ändra lösenord');
INSERT INTO `lang_definitions` VALUES (1626, 2107, 2, 'Lösenord för SMS Gateway');
INSERT INTO `lang_definitions` VALUES (1627, 2108, 2, 'Lösenord:');
INSERT INTO `lang_definitions` VALUES (1628, 2109, 2, 'Tidigare möten');
INSERT INTO `lang_definitions` VALUES (1629, 2110, 2, 'Tidigare möten och dokument');
INSERT INTO `lang_definitions` VALUES (1630, 2111, 2, 'Klistra in HL7 Data');
INSERT INTO `lang_definitions` VALUES (1631, 2114, 2, 'Patient');
INSERT INTO `lang_definitions` VALUES (1632, 2117, 2, 'Patient Allergier');
INSERT INTO `lang_definitions` VALUES (1633, 2119, 2, 'Patient träff/bokning');
INSERT INTO `lang_definitions` VALUES (1634, 2120, 2, 'Patient diagram ID');
INSERT INTO `lang_definitions` VALUES (1635, 2125, 2, 'Patientdata');
INSERT INTO `lang_definitions` VALUES (1636, 2126, 2, 'Patientdokument');
INSERT INTO `lang_definitions` VALUES (1637, 2127, 2, 'Patientmöten');
INSERT INTO `lang_definitions` VALUES (1638, 2128, 2, 'Patientmötesformulär');
INSERT INTO `lang_definitions` VALUES (1639, 2129, 2, 'Patientmöten');
INSERT INTO `lang_definitions` VALUES (1640, 2130, 2, 'Patientsök');
INSERT INTO `lang_definitions` VALUES (1641, 2131, 2, 'Patienthistoria');
INSERT INTO `lang_definitions` VALUES (1642, 2132, 2, 'Patientens historia / Livsstil');
INSERT INTO `lang_definitions` VALUES (1643, 2133, 2, 'Patient-ID');
INSERT INTO `lang_definitions` VALUES (1644, 2135, 2, 'Patient -vaccination');
INSERT INTO `lang_definitions` VALUES (1645, 2137, 2, 'Ej tilldelad!');
INSERT INTO `lang_definitions` VALUES (1646, 2139, 2, 'Patient -problem');
INSERT INTO `lang_definitions` VALUES (1647, 2140, 2, 'Patientlista');
INSERT INTO `lang_definitions` VALUES (1648, 2141, 2, 'Patientens medicinska problem');
INSERT INTO `lang_definitions` VALUES (1649, 2142, 2, 'Patient -Mediciner');
INSERT INTO `lang_definitions` VALUES (1650, 2143, 2, 'Patient: Namn och Adress');
INSERT INTO `lang_definitions` VALUES (1651, 2144, 2, 'Patientanteckning, typ');
INSERT INTO `lang_definitions` VALUES (1652, 2145, 2, 'Patient -kommentarer');
INSERT INTO `lang_definitions` VALUES (1653, 2147, 2, 'Patientnummer');
INSERT INTO `lang_definitions` VALUES (1654, 2149, 2, 'Patient -Journalrapport');
INSERT INTO `lang_definitions` VALUES (1655, 2150, 2, 'Patientrapport');
INSERT INTO `lang_definitions` VALUES (1656, 2151, 2, 'Patientförfrågan');
INSERT INTO `lang_definitions` VALUES (1657, 2152, 2, 'Patient -Sammanfattning');
INSERT INTO `lang_definitions` VALUES (1658, 2153, 2, 'Patient -Remisser m.m.');
INSERT INTO `lang_definitions` VALUES (1659, 2155, 2, 'Patient / Klient');
INSERT INTO `lang_definitions` VALUES (1660, 2156, 2, 'Patient:');
INSERT INTO `lang_definitions` VALUES (1661, 2157, 2, 'Patienter');
INSERT INTO `lang_definitions` VALUES (1662, 2158, 2, 'Betala');
INSERT INTO `lang_definitions` VALUES (1663, 2160, 2, 'Betalningsdatum:');
INSERT INTO `lang_definitions` VALUES (1664, 2161, 2, 'Betalare');
INSERT INTO `lang_definitions` VALUES (1665, 2162, 2, 'Betalare Typ');
INSERT INTO `lang_definitions` VALUES (1666, 2163, 2, 'Utbetalande');
INSERT INTO `lang_definitions` VALUES (1667, 2164, 2, 'Betalning');
INSERT INTO `lang_definitions` VALUES (1668, 2166, 2, 'Betalningsdatum');
INSERT INTO `lang_definitions` VALUES (1669, 2168, 2, 'Betalningsmetod');
INSERT INTO `lang_definitions` VALUES (1670, 2169, 2, 'Betalning värde för kod');
INSERT INTO `lang_definitions` VALUES (1671, 2170, 2, 'Betalningar');
INSERT INTO `lang_definitions` VALUES (1672, 2174, 2, 'Oavslutad');
INSERT INTO `lang_definitions` VALUES (1673, 2175, 2, 'Oklart');
INSERT INTO `lang_definitions` VALUES (1674, 2179, 2, 'via näsborre');
INSERT INTO `lang_definitions` VALUES (1675, 2180, 2, 'via näsborre');
INSERT INTO `lang_definitions` VALUES (1676, 2183, 2, 'Rektalt');
INSERT INTO `lang_definitions` VALUES (1677, 2184, 2, 'rektalt');
INSERT INTO `lang_definitions` VALUES (1678, 2186, 2, 'Utför sökning');
INSERT INTO `lang_definitions` VALUES (1679, 2187, 2, 'Utför åtgärden');
INSERT INTO `lang_definitions` VALUES (1680, 2190, 2, 'Apotek');
INSERT INTO `lang_definitions` VALUES (1681, 2191, 2, 'Patient Insurance Distribution');
INSERT INTO `lang_definitions` VALUES (1682, 2193, 2, 'Pheumothorax');
INSERT INTO `lang_definitions` VALUES (1683, 2194, 2, 'Telefon');
INSERT INTO `lang_definitions` VALUES (1684, 2195, 2, 'Telefon samtalslistan');
INSERT INTO `lang_definitions` VALUES (1685, 2196, 2, 'Telefonnummer');
INSERT INTO `lang_definitions` VALUES (1686, 2202, 2, 'Hälsokontroll');
INSERT INTO `lang_definitions` VALUES (1687, 2203, 2, 'Läkares Begäran ');
INSERT INTO `lang_definitions` VALUES (1688, 2204, 2, 'Läkares Underskrift ');
INSERT INTO `lang_definitions` VALUES (1689, 2205, 2, 'Läkare');
INSERT INTO `lang_definitions` VALUES (1690, 2206, 2, 'välj');
INSERT INTO `lang_definitions` VALUES (1691, 2209, 2, 'Tablett Storlek ');
INSERT INTO `lang_definitions` VALUES (1692, 2210, 2, 'Tabletter');
INSERT INTO `lang_definitions` VALUES (1693, 2213, 2, 'Vanlig text');
INSERT INTO `lang_definitions` VALUES (1694, 2217, 2, 'Spelare');
INSERT INTO `lang_definitions` VALUES (1695, 2218, 2, 'Position ');
INSERT INTO `lang_definitions` VALUES (1696, 2221, 2, 'Välj ett värde för');
INSERT INTO `lang_definitions` VALUES (1697, 2222, 2, 'Stäng detta fönster');
INSERT INTO `lang_definitions` VALUES (1698, 2223, 2, 'Jämför det nya namnet');
INSERT INTO `lang_definitions` VALUES (1699, 2230, 2, 'Vänligen använ endast alfabetiska tecken ');
INSERT INTO `lang_definitions` VALUES (1700, 2231, 2, 'Vänligen använd endast alfabetiska tecken utan mellanslag ');
INSERT INTO `lang_definitions` VALUES (1701, 2232, 2, 'Vänligen betala detta belopp ');
INSERT INTO `lang_definitions` VALUES (1702, 2234, 2, 'Välj en händelse ');
INSERT INTO `lang_definitions` VALUES (1703, 2236, 2, 'EM');
INSERT INTO `lang_definitions` VALUES (1704, 2243, 2, 'Lunginflammations Vaccination ');
INSERT INTO `lang_definitions` VALUES (1705, 2245, 2, 'Förhållningssätt');
INSERT INTO `lang_definitions` VALUES (1706, 2248, 2, 'Polyper ');
INSERT INTO `lang_definitions` VALUES (1707, 2250, 2, 'Dålig apptit');
INSERT INTO `lang_definitions` VALUES (1708, 2251, 2, 'Dålig cirkulation ');
INSERT INTO `lang_definitions` VALUES (1709, 2252, 2, 'Dålig hörsel');
INSERT INTO `lang_definitions` VALUES (1710, 2254, 2, 'Popup-fönster ');
INSERT INTO `lang_definitions` VALUES (1711, 2265, 2, 'Postnr');
INSERT INTO `lang_definitions` VALUES (1712, 2266, 2, 'Postnummer');
INSERT INTO `lang_definitions` VALUES (1713, 2273, 2, 'Överförings Datum ');
INSERT INTO `lang_definitions` VALUES (1714, 2275, 2, 'Practice ');
INSERT INTO `lang_definitions` VALUES (1715, 2285, 2, 'Graviditets test');
INSERT INTO `lang_definitions` VALUES (1716, 2286, 2, 'Förskottsbetalning ');
INSERT INTO `lang_definitions` VALUES (1717, 2288, 2, 'Receptbelagda märken');
INSERT INTO `lang_definitions` VALUES (1718, 2289, 2, 'Recept ');
INSERT INTO `lang_definitions` VALUES (1719, 2290, 2, 'Föreskrifter och dispenser ');
INSERT INTO `lang_definitions` VALUES (1720, 2291, 2, 'Recept och andra råd');
INSERT INTO `lang_definitions` VALUES (1721, 2292, 2, 'Recept och andra råd av specialist');
INSERT INTO `lang_definitions` VALUES (1722, 2293, 2, 'recept rapport');
INSERT INTO `lang_definitions` VALUES (1723, 2294, 2, 'Recept/råd');
INSERT INTO `lang_definitions` VALUES (1724, 2295, 2, 'Presentera Klagomål');
INSERT INTO `lang_definitions` VALUES (1725, 2296, 2, 'Tryck på fortsätt för att fortsätta');
INSERT INTO `lang_definitions` VALUES (1726, 2297, 2, 'Förmodad diagnos');
INSERT INTO `lang_definitions` VALUES (1727, 2298, 2, 'Förmodad diagnos från specialist');
INSERT INTO `lang_definitions` VALUES (1728, 2299, 2, 'Föregående');
INSERT INTO `lang_definitions` VALUES (1729, 2301, 2, 'Föregående ');
INSERT INTO `lang_definitions` VALUES (1730, 2302, 2, 'Föregående konsultation');
INSERT INTO `lang_definitions` VALUES (1731, 2303, 2, 'Föregående dag ');
INSERT INTO `lang_definitions` VALUES (1732, 2305, 2, 'Föregående månad ');
INSERT INTO `lang_definitions` VALUES (1733, 2306, 2, 'Föregående vecka ');
INSERT INTO `lang_definitions` VALUES (1734, 2307, 2, 'Pris');
INSERT INTO `lang_definitions` VALUES (1735, 2309, 2, 'Prisnivå');
INSERT INTO `lang_definitions` VALUES (1736, 2310, 2, 'Prisnivå: ');
INSERT INTO `lang_definitions` VALUES (1737, 2312, 2, 'Primär');
INSERT INTO `lang_definitions` VALUES (1738, 2314, 2, 'Primära Försäkring ');
INSERT INTO `lang_definitions` VALUES (1739, 2315, 2, 'Primära Försäkrings Data ');
INSERT INTO `lang_definitions` VALUES (1740, 2316, 2, 'Primär försäkringsbolag ');
INSERT INTO `lang_definitions` VALUES (1741, 2318, 2, 'Skriv ut ');
INSERT INTO `lang_definitions` VALUES (1742, 2322, 2, 'Printa blankt remissformulär');
INSERT INTO `lang_definitions` VALUES (1743, 2325, 2, 'Skriv ut flera ');
INSERT INTO `lang_definitions` VALUES (1744, 2334, 2, 'Skriv ut denna anmärkning ');
INSERT INTO `lang_definitions` VALUES (1745, 2335, 2, 'Skriv ut Denna Anmärkning ');
INSERT INTO `lang_definitions` VALUES (1746, 2338, 2, 'Utskrivbar');
INSERT INTO `lang_definitions` VALUES (1747, 2339, 2, 'Utskriftsversion ');
INSERT INTO `lang_definitions` VALUES (1748, 2341, 2, 'Skriva ut resultat: ');
INSERT INTO `lang_definitions` VALUES (1749, 2345, 2, 'Prioritet ');
INSERT INTO `lang_definitions` VALUES (1750, 2346, 2, 'Privat ');
INSERT INTO `lang_definitions` VALUES (1751, 2349, 2, 'Problem/anledningar');
INSERT INTO `lang_definitions` VALUES (1752, 2350, 2, 'Förfarande ');
INSERT INTO `lang_definitions` VALUES (1753, 2351, 2, 'Förfarande ');
INSERT INTO `lang_definitions` VALUES (1754, 2352, 2, 'Process ');
INSERT INTO `lang_definitions` VALUES (1755, 2353, 2, 'Bearbetning ');
INSERT INTO `lang_definitions` VALUES (1756, 2354, 2, 'Produkter ');
INSERT INTO `lang_definitions` VALUES (1757, 2355, 2, 'Prof.');
INSERT INTO `lang_definitions` VALUES (1758, 2357, 2, 'Prostata Cancer ');
INSERT INTO `lang_definitions` VALUES (1759, 2358, 2, 'Prostata undersökning');
INSERT INTO `lang_definitions` VALUES (1760, 2359, 2, 'Prostata problem ');
INSERT INTO `lang_definitions` VALUES (1761, 2361, 2, 'Leverantör');
INSERT INTO `lang_definitions` VALUES (1762, 2362, 2, 'Leverantör, nummmer');
INSERT INTO `lang_definitions` VALUES (1763, 2363, 2, 'Leverantör: ');
INSERT INTO `lang_definitions` VALUES (1764, 2364, 2, 'Leverantörer');
INSERT INTO `lang_definitions` VALUES (1765, 2397, 2, 'Puls');
INSERT INTO `lang_definitions` VALUES (1766, 2398, 2, 'Var 3:e timme');
INSERT INTO `lang_definitions` VALUES (1767, 2399, 2, 'Var 4:e timme');
INSERT INTO `lang_definitions` VALUES (1768, 2400, 2, 'Var 5:e timme');
INSERT INTO `lang_definitions` VALUES (1769, 2401, 2, 'Var 6:e timme');
INSERT INTO `lang_definitions` VALUES (1770, 2402, 2, 'Var 8:e timme');
INSERT INTO `lang_definitions` VALUES (1771, 2403, 2, '1 ggr/dag');
INSERT INTO `lang_definitions` VALUES (1772, 2404, 2, '4ggr/dag');
INSERT INTO `lang_definitions` VALUES (1773, 2406, 2, 'Antal ');
INSERT INTO `lang_definitions` VALUES (1774, 2408, 2, 'Kvalitet ');
INSERT INTO `lang_definitions` VALUES (1775, 2409, 2, 'Kvantitet ');
INSERT INTO `lang_definitions` VALUES (1776, 2410, 2, 'Kvantitet för NDC ');
INSERT INTO `lang_definitions` VALUES (1777, 2416, 2, 'köad');
INSERT INTO `lang_definitions` VALUES (1778, 2417, 2, 'Kö Evenemang Administration ');
INSERT INTO `lang_definitions` VALUES (1779, 2418, 2, 'köad för ');
INSERT INTO `lang_definitions` VALUES (1780, 2419, 2, 'Kö föreläggande Administration');
INSERT INTO `lang_definitions` VALUES (1781, 2421, 2, 'Ras ');
INSERT INTO `lang_definitions` VALUES (1782, 2422, 2, 'Etnisitet');
INSERT INTO `lang_definitions` VALUES (1783, 2423, 2, 'Radio');
INSERT INTO `lang_definitions` VALUES (1784, 2425, 2, 'Utslag ');
INSERT INTO `lang_definitions` VALUES (1785, 2426, 2, 'Betygsätta ');
INSERT INTO `lang_definitions` VALUES (1786, 2428, 2, 'Åter öppnas ');
INSERT INTO `lang_definitions` VALUES (1787, 2429, 2, 'Reaktioner ');
INSERT INTO `lang_definitions` VALUES (1788, 2430, 2, 'Riktigt namn');
INSERT INTO `lang_definitions` VALUES (1789, 2431, 2, 'Anledning ');
INSERT INTO `lang_definitions` VALUES (1790, 2432, 2, 'Anledning till remiss');
INSERT INTO `lang_definitions` VALUES (1791, 2433, 2, 'Anledning till besök');
INSERT INTO `lang_definitions` VALUES (1792, 2434, 2, 'Orsak / Form ');
INSERT INTO `lang_definitions` VALUES (1793, 2435, 2, 'Kvitto ');
INSERT INTO `lang_definitions` VALUES (1794, 2436, 2, 'Kvitto för betalning ');
INSERT INTO `lang_definitions` VALUES (1795, 2439, 2, 'Kvitton Sammanfattning ');
INSERT INTO `lang_definitions` VALUES (1796, 2440, 2, 'Mottagna ');
INSERT INTO `lang_definitions` VALUES (1797, 2441, 2, 'Mottagna av');
INSERT INTO `lang_definitions` VALUES (1798, 2442, 2, 'Mottagna fax ');
INSERT INTO `lang_definitions` VALUES (1799, 2443, 2, 'Mottagare ');
INSERT INTO `lang_definitions` VALUES (1800, 2444, 2, 'Mottagare ID ');
INSERT INTO `lang_definitions` VALUES (1801, 2447, 2, 'Rekomendationer');
INSERT INTO `lang_definitions` VALUES (1802, 2448, 2, 'Rekomendationer och behandling');
INSERT INTO `lang_definitions` VALUES (1803, 2449, 2, 'Rekomendationer av specialist');
INSERT INTO `lang_definitions` VALUES (1804, 2456, 2, 'reduceras:');
INSERT INTO `lang_definitions` VALUES (1805, 2457, 2, 'Remitera');
INSERT INTO `lang_definitions` VALUES (1806, 2458, 2, 'Remiterad av');
INSERT INTO `lang_definitions` VALUES (1807, 2459, 2, 'Remissdatum ');
INSERT INTO `lang_definitions` VALUES (1808, 2460, 2, 'Remiteras till');
INSERT INTO `lang_definitions` VALUES (1809, 2461, 2, 'Prioritetsnivå (Risknivå)');
INSERT INTO `lang_definitions` VALUES (1810, 2462, 2, 'Orsak till remiss');
INSERT INTO `lang_definitions` VALUES (1811, 2463, 2, 'Remittent, namn och signatur');
INSERT INTO `lang_definitions` VALUES (1812, 2464, 2, 'Remiss');
INSERT INTO `lang_definitions` VALUES (1813, 2465, 2, 'Remitterad av');
INSERT INTO `lang_definitions` VALUES (1814, 2466, 2, 'Remisskort');
INSERT INTO `lang_definitions` VALUES (1815, 2467, 2, 'Remissdadum');
INSERT INTO `lang_definitions` VALUES (1816, 2468, 2, 'Remissformulär');
INSERT INTO `lang_definitions` VALUES (1817, 2469, 2, 'REMISSFORMULÄR');
INSERT INTO `lang_definitions` VALUES (1818, 2470, 2, 'Remisskälla');
INSERT INTO `lang_definitions` VALUES (1819, 2471, 2, 'Remitteras till');
INSERT INTO `lang_definitions` VALUES (1820, 2472, 2, 'remittering');
INSERT INTO `lang_definitions` VALUES (1821, 2473, 2, 'remiss');
INSERT INTO `lang_definitions` VALUES (1822, 2474, 2, 'Remiterats från ');
INSERT INTO `lang_definitions` VALUES (1823, 2475, 2, 'Remiterats från ');
INSERT INTO `lang_definitions` VALUES (1824, 2476, 2, 'Remitterats till');
INSERT INTO `lang_definitions` VALUES (1825, 2477, 2, 'Remiterats av');
INSERT INTO `lang_definitions` VALUES (1826, 2482, 2, 'Påfyllnad ');
INSERT INTO `lang_definitions` VALUES (1827, 2483, 2, 'påfyllnad ');
INSERT INTO `lang_definitions` VALUES (1828, 2484, 2, 'Reflexer normala ');
INSERT INTO `lang_definitions` VALUES (1829, 2485, 2, 'Uppdatera ');
INSERT INTO `lang_definitions` VALUES (1830, 2488, 2, 'Registrerad ');
INSERT INTO `lang_definitions` VALUES (1831, 2489, 2, 'registrerade ');
INSERT INTO `lang_definitions` VALUES (1832, 2490, 2, 'Registreringsdag ');
INSERT INTO `lang_definitions` VALUES (1833, 2492, 2, 'Rehabilitering ');
INSERT INTO `lang_definitions` VALUES (1834, 2494, 2, 'Relaterat ');
INSERT INTO `lang_definitions` VALUES (1835, 2496, 2, 'Förhållande ');
INSERT INTO `lang_definitions` VALUES (1836, 2497, 2, 'Anhöriga ');
INSERT INTO `lang_definitions` VALUES (1837, 2500, 2, 'Religion ');
INSERT INTO `lang_definitions` VALUES (1838, 2501, 2, 'Relogin ');
INSERT INTO `lang_definitions` VALUES (1839, 2503, 2, 'Ta bort grupp ');
INSERT INTO `lang_definitions` VALUES (1840, 2512, 2, 'Upprepar ');
INSERT INTO `lang_definitions` VALUES (1841, 2513, 2, 'Svars Datum');
INSERT INTO `lang_definitions` VALUES (1842, 2515, 2, 'Rapport ');
INSERT INTO `lang_definitions` VALUES (1843, 2518, 2, 'Rapporter ');
INSERT INTO `lang_definitions` VALUES (1844, 2521, 2, 'Nödvändig ');
INSERT INTO `lang_definitions` VALUES (1845, 2522, 2, 'RESERVERAD');
INSERT INTO `lang_definitions` VALUES (1846, 2523, 2, 'reserverad');
INSERT INTO `lang_definitions` VALUES (1847, 2528, 2, 'Löst');
INSERT INTO `lang_definitions` VALUES (1848, 2532, 2, 'Begränsat Utbildning ');
INSERT INTO `lang_definitions` VALUES (1849, 2533, 2, 'Resultat ');
INSERT INTO `lang_definitions` VALUES (1850, 2536, 2, 'Infällda Höger: ');
INSERT INTO `lang_definitions` VALUES (1851, 2537, 2, 'Avkastning ');
INSERT INTO `lang_definitions` VALUES (1852, 2539, 2, 'Returvärde ');
INSERT INTO `lang_definitions` VALUES (1853, 2540, 2, 'Återresa');
INSERT INTO `lang_definitions` VALUES (1854, 2544, 2, 'Översyn av System Kontroller ');
INSERT INTO `lang_definitions` VALUES (1855, 2545, 2, 'Revision ');
INSERT INTO `lang_definitions` VALUES (1856, 2547, 2, 'Höger ');
INSERT INTO `lang_definitions` VALUES (1857, 2548, 2, 'Höger öra');
INSERT INTO `lang_definitions` VALUES (1858, 2549, 2, 'höger öra ');
INSERT INTO `lang_definitions` VALUES (1859, 2550, 2, 'Höger: ');
INSERT INTO `lang_definitions` VALUES (1860, 2551, 2, 'Ringningar i öron');
INSERT INTO `lang_definitions` VALUES (1861, 2552, 2, 'Tinitus');
INSERT INTO `lang_definitions` VALUES (1862, 2558, 2, 'Rutt ');
INSERT INTO `lang_definitions` VALUES (1863, 2559, 2, 'Rader ');
INSERT INTO `lang_definitions` VALUES (1864, 2561, 2, 'Massera: ');
INSERT INTO `lang_definitions` VALUES (1865, 2562, 2, 'Gnuggar: ');
INSERT INTO `lang_definitions` VALUES (1866, 2563, 2, 'Kör kommando: ');
INSERT INTO `lang_definitions` VALUES (1867, 2566, 2, 'Recept');
INSERT INTO `lang_definitions` VALUES (1868, 2567, 2, 'Recept');
INSERT INTO `lang_definitions` VALUES (1869, 2568, 2, 'K');
INSERT INTO `lang_definitions` VALUES (1870, 2569, 2, 'Personnr');
INSERT INTO `lang_definitions` VALUES (1871, 2576, 2, 'Samma dag');
INSERT INTO `lang_definitions` VALUES (1872, 2578, 2, 'Sanktions Typ ');
INSERT INTO `lang_definitions` VALUES (1873, 2579, 2, 'Lördag ');
INSERT INTO `lang_definitions` VALUES (1874, 2580, 2, 'Lördag & söndag ');
INSERT INTO `lang_definitions` VALUES (1875, 2581, 2, 'Lördag ');
INSERT INTO `lang_definitions` VALUES (1876, 2582, 2, 'Spara ');
INSERT INTO `lang_definitions` VALUES (1877, 2583, 2, 'Spara och fördela');
INSERT INTO `lang_definitions` VALUES (1878, 2584, 2, 'Spara som ny ');
INSERT INTO `lang_definitions` VALUES (1879, 2585, 2, 'Spara ändringar ');
INSERT INTO `lang_definitions` VALUES (1880, 2587, 2, 'Spara vaccination');
INSERT INTO `lang_definitions` VALUES (1881, 2594, 2, 'Spara transaktionen');
INSERT INTO `lang_definitions` VALUES (1882, 2595, 2, 'Inskannade ');
INSERT INTO `lang_definitions` VALUES (1883, 2598, 2, 'Schema ');
INSERT INTO `lang_definitions` VALUES (1884, 2601, 2, 'Skolios ');
INSERT INTO `lang_definitions` VALUES (1885, 2602, 2, 'SE ');
INSERT INTO `lang_definitions` VALUES (1886, 2603, 2, 'SE Adress ');
INSERT INTO `lang_definitions` VALUES (1887, 2604, 2, 'SE Stad');
INSERT INTO `lang_definitions` VALUES (1888, 2605, 2, 'SE Land ');
INSERT INTO `lang_definitions` VALUES (1889, 2610, 2, 'Söka ');
INSERT INTO `lang_definitions` VALUES (1890, 2611, 2, 'söka ');
INSERT INTO `lang_definitions` VALUES (1891, 2612, 2, 'Sök igen ');
INSERT INTO `lang_definitions` VALUES (1892, 2613, 2, 'Sök efter: ');
INSERT INTO `lang_definitions` VALUES (1893, 2614, 2, 'Sök efter: ');
INSERT INTO `lang_definitions` VALUES (1894, 2615, 2, 'Sök efter eller lägg till patient');
INSERT INTO `lang_definitions` VALUES (1895, 2616, 2, 'Sökresultat:');
INSERT INTO `lang_definitions` VALUES (1896, 2618, 2, 'Sök i Evenemang ');
INSERT INTO `lang_definitions` VALUES (1897, 2619, 2, 'Sök / Lägg till försäkringsgivaren ');
INSERT INTO `lang_definitions` VALUES (1898, 2623, 2, 'Bilbältesanvändning ');
INSERT INTO `lang_definitions` VALUES (1899, 2624, 2, 'Andra ');
INSERT INTO `lang_definitions` VALUES (1900, 2625, 2, 'Sekundär ');
INSERT INTO `lang_definitions` VALUES (1901, 2626, 2, 'Sekundär Försäkring ');
INSERT INTO `lang_definitions` VALUES (1902, 2627, 2, 'Sekundär Försäkrings Data ');
INSERT INTO `lang_definitions` VALUES (1903, 2629, 2, 'Se Alla');
INSERT INTO `lang_definitions` VALUES (1904, 2630, 2, 'Se Auktoriseringar');
INSERT INTO `lang_definitions` VALUES (1905, 2633, 2, 'Sett sedan');
INSERT INTO `lang_definitions` VALUES (1906, 2636, 2, 'Välj ');
INSERT INTO `lang_definitions` VALUES (1907, 2637, 2, 'Välj Alla ');
INSERT INTO `lang_definitions` VALUES (1908, 2646, 2, 'Egen lön ');
INSERT INTO `lang_definitions` VALUES (1909, 2647, 2, 'Överföring pågår ');
INSERT INTO `lang_definitions` VALUES (1910, 2649, 2, 'Avsändare ');
INSERT INTO `lang_definitions` VALUES (1911, 2650, 2, 'Avsändar ID');
INSERT INTO `lang_definitions` VALUES (1912, 2654, 2, 'Känslighet: ');
INSERT INTO `lang_definitions` VALUES (1913, 2656, 2, 'Skickats ');
INSERT INTO `lang_definitions` VALUES (1914, 2657, 2, 'skickas till skrivaren. ');
INSERT INTO `lang_definitions` VALUES (1915, 2658, 2, 'Separerade');
INSERT INTO `lang_definitions` VALUES (1916, 2659, 2, 'September ');
INSERT INTO `lang_definitions` VALUES (1917, 2662, 2, 'Service Datum: ');
INSERT INTO `lang_definitions` VALUES (1918, 2663, 2, 'Service Location ');
INSERT INTO `lang_definitions` VALUES (1919, 2665, 2, 'Tjänster ');
INSERT INTO `lang_definitions` VALUES (1920, 2666, 2, 'Tjänster efter kategori ');
INSERT INTO `lang_definitions` VALUES (1921, 2667, 2, 'Tjänster som tillhandahålls');
INSERT INTO `lang_definitions` VALUES (1922, 2668, 2, 'Tjänster som Tillhandahålls');
INSERT INTO `lang_definitions` VALUES (1923, 2669, 2, 'Inställningar ');
INSERT INTO `lang_definitions` VALUES (1924, 2670, 2, 'Svår huvudvärk');
INSERT INTO `lang_definitions` VALUES (1925, 2671, 2, 'Svårighetsgrad av smärta');
INSERT INTO `lang_definitions` VALUES (1926, 2672, 2, 'Svårighetsgrad av smärta:');
INSERT INTO `lang_definitions` VALUES (1927, 2673, 2, 'Kön');
INSERT INTO `lang_definitions` VALUES (1928, 2674, 2, 'Sexuellt överförbara sjukdomar ');
INSERT INTO `lang_definitions` VALUES (1929, 2675, 2, 'Dela ');
INSERT INTO `lang_definitions` VALUES (1930, 2676, 2, 'Andnöd ');
INSERT INTO `lang_definitions` VALUES (1931, 2681, 2, 'bör vara som nnnnn-nnnn-nn ');
INSERT INTO `lang_definitions` VALUES (1932, 2682, 2, 'Axel');
INSERT INTO `lang_definitions` VALUES (1933, 2683, 2, 'Axel + nyckelben');
INSERT INTO `lang_definitions` VALUES (1934, 2684, 2, 'Axelproblem');
INSERT INTO `lang_definitions` VALUES (1935, 2685, 2, 'visa');
INSERT INTO `lang_definitions` VALUES (1936, 2686, 2, 'Visa som upptagen ');
INSERT INTO `lang_definitions` VALUES (1937, 2687, 2, 'Visa endast behöriga');
INSERT INTO `lang_definitions` VALUES (1938, 2688, 2, 'Visa detaljer ');
INSERT INTO `lang_definitions` VALUES (1939, 2692, 2, 'Visa rapport ');
INSERT INTO `lang_definitions` VALUES (1940, 2694, 2, 'Visa endast icke fakturerad ');
INSERT INTO `lang_definitions` VALUES (1941, 2695, 2, 'Syskon ');
INSERT INTO `lang_definitions` VALUES (1942, 2699, 2, 'Underskrift ');
INSERT INTO `lang_definitions` VALUES (1943, 2700, 2, 'Underskrift: ');
INSERT INTO `lang_definitions` VALUES (1944, 2702, 2, 'Betydande Svullnad: ');
INSERT INTO `lang_definitions` VALUES (1945, 2705, 2, 'Singel');
INSERT INTO `lang_definitions` VALUES (1946, 2710, 2, 'Storlek ');
INSERT INTO `lang_definitions` VALUES (1947, 2712, 2, 'Storlek / Lista ');
INSERT INTO `lang_definitions` VALUES (1948, 2713, 2, 'Hud ');
INSERT INTO `lang_definitions` VALUES (1949, 2719, 2, 'sömn mönster');
INSERT INTO `lang_definitions` VALUES (1950, 2720, 2, 'sover');
INSERT INTO `lang_definitions` VALUES (1951, 2733, 2, 'Social History:');
INSERT INTO `lang_definitions` VALUES (1952, 2735, 2, 'lösning ');
INSERT INTO `lang_definitions` VALUES (1953, 2739, 2, 'Vissa möten visas inte. Klicka här för att visa alla. ');
INSERT INTO `lang_definitions` VALUES (1954, 2740, 2, 'Vissa anteckningar visades inte');
INSERT INTO `lang_definitions` VALUES (1955, 2741, 2, 'några ord ');
INSERT INTO `lang_definitions` VALUES (1956, 2743, 2, 'Sortera efter ');
INSERT INTO `lang_definitions` VALUES (1957, 2751, 2, 'Källa ');
INSERT INTO `lang_definitions` VALUES (1958, 2752, 2, 'Källa saknas för kod ');
INSERT INTO `lang_definitions` VALUES (1959, 2753, 2, 'Källa: ');
INSERT INTO `lang_definitions` VALUES (1960, 2755, 2, 'Specialist namn och signatur');
INSERT INTO `lang_definitions` VALUES (1961, 2756, 2, 'Specialtet');
INSERT INTO `lang_definitions` VALUES (1962, 2758, 2, 'Specialitet: ');
INSERT INTO `lang_definitions` VALUES (1963, 2759, 2, 'Särskilda ');
INSERT INTO `lang_definitions` VALUES (1964, 2760, 2, 'Särskilda tjänster ');
INSERT INTO `lang_definitions` VALUES (1965, 2761, 2, 'Tal diktamen ');
INSERT INTO `lang_definitions` VALUES (1966, 2762, 2, 'Spermiedödande ');
INSERT INTO `lang_definitions` VALUES (1967, 2764, 2, 'Maka ');
INSERT INTO `lang_definitions` VALUES (1968, 2766, 2, 'Sputum: ');
INSERT INTO `lang_definitions` VALUES (1969, 2776, 2, 'Personnummmer');
INSERT INTO `lang_definitions` VALUES (1970, 2777, 2, 'Persnr');
INSERT INTO `lang_definitions` VALUES (1971, 2778, 2, 'Stabilitet');
INSERT INTO `lang_definitions` VALUES (1972, 2779, 2, 'Standard');
INSERT INTO `lang_definitions` VALUES (1973, 2780, 2, 'Start ');
INSERT INTO `lang_definitions` VALUES (1974, 2781, 2, 'Start (åååå-mm-dd): ');
INSERT INTO `lang_definitions` VALUES (1975, 2782, 2, 'Startdatum ');
INSERT INTO `lang_definitions` VALUES (1976, 2783, 2, 'Start datum vid denna klinik');
INSERT INTO `lang_definitions` VALUES (1977, 2784, 2, 'Startdatum: ');
INSERT INTO `lang_definitions` VALUES (1978, 2785, 2, 'Startdatum: ');
INSERT INTO `lang_definitions` VALUES (1979, 2786, 2, 'Start tid');
INSERT INTO `lang_definitions` VALUES (1980, 2787, 2, 'Startdatum ');
INSERT INTO `lang_definitions` VALUES (1981, 2789, 2, 'Stat ');
INSERT INTO `lang_definitions` VALUES (1982, 2791, 2, 'församling');
INSERT INTO `lang_definitions` VALUES (1983, 2793, 2, 'Statistik ');
INSERT INTO `lang_definitions` VALUES (1984, 2794, 2, 'Övrigt');
INSERT INTO `lang_definitions` VALUES (1985, 2795, 2, 'Status');
INSERT INTO `lang_definitions` VALUES (1986, 2796, 2, 'Oförändrat');
INSERT INTO `lang_definitions` VALUES (1987, 2799, 2, 'Stela leder ');
INSERT INTO `lang_definitions` VALUES (1988, 2801, 2, 'Ont i magen ');
INSERT INTO `lang_definitions` VALUES (1989, 2802, 2, 'Överbelastade muskler ');
INSERT INTO `lang_definitions` VALUES (1990, 2804, 2, 'Gata');
INSERT INTO `lang_definitions` VALUES (1991, 2806, 2, 'Gatu nummer');
INSERT INTO `lang_definitions` VALUES (1992, 2807, 2, 'styrka');
INSERT INTO `lang_definitions` VALUES (1993, 2809, 2, 'Stress fraktur ');
INSERT INTO `lang_definitions` VALUES (1994, 2810, 2, 'Stresstest ');
INSERT INTO `lang_definitions` VALUES (1995, 2811, 2, 'Stroke ');
INSERT INTO `lang_definitions` VALUES (1996, 2813, 2, 'Delsumma ');
INSERT INTO `lang_definitions` VALUES (1997, 2814, 2, 'Underkategori ');
INSERT INTO `lang_definitions` VALUES (1998, 2815, 2, 'underkategori ');
INSERT INTO `lang_definitions` VALUES (1999, 2816, 2, 'subkutant ');
INSERT INTO `lang_definitions` VALUES (2000, 2817, 2, 'Subjektiv');
INSERT INTO `lang_definitions` VALUES (2001, 2818, 2, 'Sublingual ');
INSERT INTO `lang_definitions` VALUES (2002, 2819, 2, 'sublingual');
INSERT INTO `lang_definitions` VALUES (2003, 2820, 2, 'Lämna in');
INSERT INTO `lang_definitions` VALUES (2004, 2822, 2, 'Lämna in händelsen');
INSERT INTO `lang_definitions` VALUES (2005, 2823, 2, 'lämna in blanketten ');
INSERT INTO `lang_definitions` VALUES (2006, 2826, 2, 'Inlämnat av');
INSERT INTO `lang_definitions` VALUES (2007, 2828, 2, 'Prenuremant');
INSERT INTO `lang_definitions` VALUES (2008, 2829, 2, 'Prenuremants Adress ');
INSERT INTO `lang_definitions` VALUES (2009, 2844, 2, 'Ersättare');
INSERT INTO `lang_definitions` VALUES (2010, 2845, 2, 'Ersättare tillåts');
INSERT INTO `lang_definitions` VALUES (2011, 2850, 2, 'Självmord ');
INSERT INTO `lang_definitions` VALUES (2012, 2851, 2, 'Sammanfattning ');
INSERT INTO `lang_definitions` VALUES (2013, 2852, 2, 'Sön');
INSERT INTO `lang_definitions` VALUES (2014, 2853, 2, 'Söndag ');
INSERT INTO `lang_definitions` VALUES (2015, 2863, 2, 'Kirurgi');
INSERT INTO `lang_definitions` VALUES (2016, 2864, 2, 'avstänga');
INSERT INTO `lang_definitions` VALUES (2017, 2865, 2, 'Uppslammad vätska');
INSERT INTO `lang_definitions` VALUES (2018, 2869, 2, 'Svenska');
INSERT INTO `lang_definitions` VALUES (2019, 2879, 2, '3 ggr/dag');
INSERT INTO `lang_definitions` VALUES (2020, 2881, 2, 'Tabell skapas inte ');
INSERT INTO `lang_definitions` VALUES (2021, 2882, 2, 'Tabell uppdateringen misslyckades ');
INSERT INTO `lang_definitions` VALUES (2022, 2883, 2, 'tablett ');
INSERT INTO `lang_definitions` VALUES (2023, 2884, 2, 'Ta ');
INSERT INTO `lang_definitions` VALUES (2024, 2885, 2, 'Tar lång tid');
INSERT INTO `lang_definitions` VALUES (2025, 2887, 2, 'Skatter ');
INSERT INTO `lang_definitions` VALUES (2026, 2898, 2, 'Mall');
INSERT INTO `lang_definitions` VALUES (2027, 2901, 2, 'Mall:');
INSERT INTO `lang_definitions` VALUES (2028, 2910, 2, 'Testa schema');
INSERT INTO `lang_definitions` VALUES (2029, 2911, 2, 'Testa system ');
INSERT INTO `lang_definitions` VALUES (2030, 2920, 2, 'Tack ');
INSERT INTO `lang_definitions` VALUES (2031, 2921, 2, 'Påstående ärendet: ');
INSERT INTO `lang_definitions` VALUES (2032, 2923, 2, 'Händelsen har godkänts. ');
INSERT INTO `lang_definitions` VALUES (2033, 2924, 2, 'Händelsen har gömts undan');
INSERT INTO `lang_definitions` VALUES (2034, 2926, 2, 'Följande kalenderhändelse har lagts till: ');
INSERT INTO `lang_definitions` VALUES (2035, 2927, 2, 'Följande kalenderhändelse har modifierats: ');
INSERT INTO `lang_definitions` VALUES (2036, 2939, 2, 'Terapeutiska Injektioner ');
INSERT INTO `lang_definitions` VALUES (2037, 2941, 2, 'Det är fel med din ansökan. Dessa beskrivs nedan. ');
INSERT INTO `lang_definitions` VALUES (2038, 2942, 2, 'Det finns inga nya synpunkter ');
INSERT INTO `lang_definitions` VALUES (2039, 2953, 2, 'Det uppstod ett fel när din begäran behandlades. ');
INSERT INTO `lang_definitions` VALUES (2040, 2954, 2, 'Förtjockad Höger: ');
INSERT INTO `lang_definitions` VALUES (2041, 2955, 2, 'Lår ');
INSERT INTO `lang_definitions` VALUES (2042, 2956, 2, 'Lår + knäsena ');
INSERT INTO `lang_definitions` VALUES (2043, 2965, 2, 'Tredje');
INSERT INTO `lang_definitions` VALUES (2044, 2969, 2, 'Pågående besök');
INSERT INTO `lang_definitions` VALUES (2045, 2971, 2, 'Detta fakturanumret har ändrats till ');
INSERT INTO `lang_definitions` VALUES (2046, 2975, 2, 'Denna patient har ingen aktivitet ');
INSERT INTO `lang_definitions` VALUES (2047, 2976, 2, 'Denna patients ID används redan! ');
INSERT INTO `lang_definitions` VALUES (2048, 2985, 2, 'Tor');
INSERT INTO `lang_definitions` VALUES (2049, 2986, 2, 'torsdag');
INSERT INTO `lang_definitions` VALUES (2050, 2987, 2, 'Torsdag ');
INSERT INTO `lang_definitions` VALUES (2051, 2988, 2, 'Sköldkörtel normal');
INSERT INTO `lang_definitions` VALUES (2052, 2991, 2, 'Tid ');
INSERT INTO `lang_definitions` VALUES (2053, 2993, 2, 'beräkna tid på händelse ');
INSERT INTO `lang_definitions` VALUES (2054, 2995, 2, 'Tidsstämpel och Text ');
INSERT INTO `lang_definitions` VALUES (2055, 2998, 2, 'Titel ');
INSERT INTO `lang_definitions` VALUES (2056, 3004, 2, 'Till ');
INSERT INTO `lang_definitions` VALUES (2057, 3005, 2, 'TILL');
INSERT INTO `lang_definitions` VALUES (2058, 3006, 2, 'till ');
INSERT INTO `lang_definitions` VALUES (2059, 3007, 2, 'På det påverkade området ');
INSERT INTO `lang_definitions` VALUES (2060, 3008, 2, 'på det påverkade området ');
INSERT INTO `lang_definitions` VALUES (2061, 3010, 2, 'till kategori ');
INSERT INTO `lang_definitions` VALUES (2062, 3012, 2, 'Till medbetalare');
INSERT INTO `lang_definitions` VALUES (2063, 3015, 2, 'Till Besök');
INSERT INTO `lang_definitions` VALUES (2064, 3016, 2, 'Om du vill filtrera efter kön ');
INSERT INTO `lang_definitions` VALUES (2065, 3017, 2, 'Till Historik ');
INSERT INTO `lang_definitions` VALUES (2066, 3018, 2, 'Till frågor ');
INSERT INTO `lang_definitions` VALUES (2067, 3019, 2, 'För att länka detta besök till objekt i ovanstående lista, markera önskade objekt och klicka sedan på [spara]. Håll ner [Ctrl] för att markera fler objekt. ');
INSERT INTO `lang_definitions` VALUES (2068, 3020, 2, 'för att logga in igen');
INSERT INTO `lang_definitions` VALUES (2069, 3021, 2, 'Huden ');
INSERT INTO `lang_definitions` VALUES (2070, 3022, 2, 'huden');
INSERT INTO `lang_definitions` VALUES (2071, 3023, 2, 'Till detta besök?');
INSERT INTO `lang_definitions` VALUES (2072, 3024, 2, 'Till: ');
INSERT INTO `lang_definitions` VALUES (2073, 3025, 2, 'Till: ');
INSERT INTO `lang_definitions` VALUES (2074, 3037, 2, 'Tobak ');
INSERT INTO `lang_definitions` VALUES (2075, 3038, 2, 'Tobaks användande');
INSERT INTO `lang_definitions` VALUES (2076, 3039, 2, 'Idag ');
INSERT INTO `lang_definitions` VALUES (2077, 3040, 2, 'Dagens datum');
INSERT INTO `lang_definitions` VALUES (2078, 3041, 2, 'Dagens händelser');
INSERT INTO `lang_definitions` VALUES (2079, 3042, 2, 'Tonsillektomi');
INSERT INTO `lang_definitions` VALUES (2080, 3043, 2, 'Topp');
INSERT INTO `lang_definitions` VALUES (2081, 3044, 2, 'Ämne ');
INSERT INTO `lang_definitions` VALUES (2082, 3045, 2, 'totalt ');
INSERT INTO `lang_definitions` VALUES (2083, 3046, 2, 'Totalt ');
INSERT INTO `lang_definitions` VALUES (2084, 3047, 2, 'Sammanlagt belopp som betalats ');
INSERT INTO `lang_definitions` VALUES (2085, 3048, 2, 'Totala kostnader ');
INSERT INTO `lang_definitions` VALUES (2086, 3049, 2, 'Totalt antal Kunder ');
INSERT INTO `lang_definitions` VALUES (2087, 3050, 2, 'Totalt för ');
INSERT INTO `lang_definitions` VALUES (2088, 3051, 2, 'Totalt för ');
INSERT INTO `lang_definitions` VALUES (2089, 3052, 2, 'Totalt för kategori ');
INSERT INTO `lang_definitions` VALUES (2090, 3053, 2, 'Totalt antal patienter ');
INSERT INTO `lang_definitions` VALUES (2091, 3055, 2, 'Totalt');
INSERT INTO `lang_definitions` VALUES (2092, 3056, 2, 'Totalbeloppen för');
INSERT INTO `lang_definitions` VALUES (2093, 3057, 2, 'Totalbeloppen för');
INSERT INTO `lang_definitions` VALUES (2094, 3058, 2, 'Utbildnings sort');
INSERT INTO `lang_definitions` VALUES (2095, 3059, 2, 'Remiss m.m.');
INSERT INTO `lang_definitions` VALUES (2096, 3060, 2, 'Transaktion');
INSERT INTO `lang_definitions` VALUES (2097, 3061, 2, 'Transaktion ');
INSERT INTO `lang_definitions` VALUES (2098, 3062, 2, 'Transaktionstyp ');
INSERT INTO `lang_definitions` VALUES (2099, 3063, 2, 'Transaktioner ');
INSERT INTO `lang_definitions` VALUES (2100, 3064, 2, 'Transaktioner (skriva valfritt)');
INSERT INTO `lang_definitions` VALUES (2101, 3065, 2, 'Transaktioner / Övergångar');
INSERT INTO `lang_definitions` VALUES (2102, 3066, 2, 'översätt detta');
INSERT INTO `lang_definitions` VALUES (2103, 3067, 2, 'översätta ');
INSERT INTO `lang_definitions` VALUES (2104, 3069, 2, 'Trauma ');
INSERT INTO `lang_definitions` VALUES (2105, 3070, 2, 'Behandlings mål');
INSERT INTO `lang_definitions` VALUES (2106, 3071, 2, 'Behandlings plan');
INSERT INTO `lang_definitions` VALUES (2107, 3072, 2, 'Behandling: ');
INSERT INTO `lang_definitions` VALUES (2108, 3073, 2, 'Behandling: ');
INSERT INTO `lang_definitions` VALUES (2109, 3079, 2, 'tesked');
INSERT INTO `lang_definitions` VALUES (2110, 3082, 2, 'Tis');
INSERT INTO `lang_definitions` VALUES (2111, 3084, 2, 'Tisdag');
INSERT INTO `lang_definitions` VALUES (2112, 3085, 2, 'Tumör');
INSERT INTO `lang_definitions` VALUES (2113, 3086, 2, 'två gånger dagligen');
INSERT INTO `lang_definitions` VALUES (2114, 3088, 2, 'Typ');
INSERT INTO `lang_definitions` VALUES (2115, 3089, 2, 'Skriv in eller skanna patientidentifikation här');
INSERT INTO `lang_definitions` VALUES (2116, 3091, 2, 'Ulcerations ');
INSERT INTO `lang_definitions` VALUES (2117, 3092, 2, 'Ulcerös kolit ');
INSERT INTO `lang_definitions` VALUES (2118, 3093, 2, 'Sår: ');
INSERT INTO `lang_definitions` VALUES (2119, 3094, 2, 'Ej tilldelad ');
INSERT INTO `lang_definitions` VALUES (2120, 3095, 2, 'Obehörig åtkomst. ');
INSERT INTO `lang_definitions` VALUES (2121, 3096, 2, 'under tungan ');
INSERT INTO `lang_definitions` VALUES (2122, 3097, 2, 'Undervikt');
INSERT INTO `lang_definitions` VALUES (2123, 3098, 2, 'odiagnosticerad');
INSERT INTO `lang_definitions` VALUES (2124, 3099, 2, 'Ångra Kassa ');
INSERT INTO `lang_definitions` VALUES (2125, 3100, 2, 'Unika Kunder ');
INSERT INTO `lang_definitions` VALUES (2126, 3101, 2, 'Unika nya kunder ');
INSERT INTO `lang_definitions` VALUES (2127, 3105, 2, 'Enhet ');
INSERT INTO `lang_definitions` VALUES (2128, 3106, 2, 'Enheter ');
INSERT INTO `lang_definitions` VALUES (2129, 3107, 2, 'enheter ');
INSERT INTO `lang_definitions` VALUES (2130, 3109, 2, 'Okänt ');
INSERT INTO `lang_definitions` VALUES (2131, 3110, 2, 'Okänd eller N / A ');
INSERT INTO `lang_definitions` VALUES (2132, 3111, 2, 'Namnlöst försäkringsbolag ');
INSERT INTO `lang_definitions` VALUES (2133, 3112, 2, 'Oregistrerad ');
INSERT INTO `lang_definitions` VALUES (2134, 3113, 2, 'Avmarkera alla');
INSERT INTO `lang_definitions` VALUES (2135, 3114, 2, 'Omarkerat ');
INSERT INTO `lang_definitions` VALUES (2136, 3115, 2, 'Ospecificerad');
INSERT INTO `lang_definitions` VALUES (2137, 3116, 2, 'tills ');
INSERT INTO `lang_definitions` VALUES (2138, 3118, 2, 'Outnyttjad ');
INSERT INTO `lang_definitions` VALUES (2139, 3120, 2, 'Upp till ');
INSERT INTO `lang_definitions` VALUES (2140, 3121, 2, 'Kommande möten');
INSERT INTO `lang_definitions` VALUES (2141, 3122, 2, 'Kommande evenemang ');
INSERT INTO `lang_definitions` VALUES (2142, 3123, 2, 'Uppdatera ');
INSERT INTO `lang_definitions` VALUES (2143, 3124, 2, 'uppdatera ');
INSERT INTO `lang_definitions` VALUES (2144, 3125, 2, 'Uppdateringsfilerna ');
INSERT INTO `lang_definitions` VALUES (2145, 3126, 2, 'Uppdatera Info ');
INSERT INTO `lang_definitions` VALUES (2146, 3132, 2, 'Uppladdning');
INSERT INTO `lang_definitions` VALUES (2147, 3134, 2, 'Ladda upp dokument');
INSERT INTO `lang_definitions` VALUES (2148, 3136, 2, 'Ladda upp fil att importera: ');
INSERT INTO `lang_definitions` VALUES (2149, 3137, 2, 'Ladda upp rapport ');
INSERT INTO `lang_definitions` VALUES (2150, 3138, 2, 'Ladda upp den här filen: ');
INSERT INTO `lang_definitions` VALUES (2151, 3141, 2, 'Överarmen ');
INSERT INTO `lang_definitions` VALUES (2152, 3142, 2, 'Brådskande');
INSERT INTO `lang_definitions` VALUES (2153, 3144, 2, 'Urin Frekvens');
INSERT INTO `lang_definitions` VALUES (2154, 3145, 2, 'Urin Tveksamhet');
INSERT INTO `lang_definitions` VALUES (2155, 3148, 2, 'URL');
INSERT INTO `lang_definitions` VALUES (2156, 3150, 2, 'Använd 24-timmars format? ');
INSERT INTO `lang_definitions` VALUES (2157, 3151, 2, 'Använd Standardinställningar ');
INSERT INTO `lang_definitions` VALUES (2158, 3152, 2, 'Använd internationellt utseende på datum?');
INSERT INTO `lang_definitions` VALUES (2159, 3154, 2, 'Använd ämnen? ');
INSERT INTO `lang_definitions` VALUES (2160, 3155, 2, 'Användare ');
INSERT INTO `lang_definitions` VALUES (2161, 3156, 2, 'Användaradministration ');
INSERT INTO `lang_definitions` VALUES (2162, 3157, 2, 'Användar-och Facility Administration ');
INSERT INTO `lang_definitions` VALUES (2163, 3158, 2, 'Användare och grupp Administration');
INSERT INTO `lang_definitions` VALUES (2164, 3159, 2, 'Användardefinierad');
INSERT INTO `lang_definitions` VALUES (2165, 3160, 2, 'Användar definierad Area 11');
INSERT INTO `lang_definitions` VALUES (2166, 3161, 2, 'Användar definierad Area 12');
INSERT INTO `lang_definitions` VALUES (2167, 3179, 2, 'Användare Medlemskap ');
INSERT INTO `lang_definitions` VALUES (2168, 3180, 2, 'Användarnamn ');
INSERT INTO `lang_definitions` VALUES (2169, 3181, 2, 'Användarnamn för SMS Gateway ');
INSERT INTO `lang_definitions` VALUES (2170, 3182, 2, 'Användarnamn: ');
INSERT INTO `lang_definitions` VALUES (2171, 3183, 2, 'Användare');
INSERT INTO `lang_definitions` VALUES (2172, 3184, 2, 'Användare / grupper / Logs Administration');
INSERT INTO `lang_definitions` VALUES (2173, 3187, 2, 'SEMESTER');
INSERT INTO `lang_definitions` VALUES (2174, 3188, 2, 'Semester');
INSERT INTO `lang_definitions` VALUES (2175, 3189, 2, 'Vaccin ');
INSERT INTO `lang_definitions` VALUES (2176, 3199, 2, 'Blodkärls kondition ');
INSERT INTO `lang_definitions` VALUES (2177, 3200, 2, 'Blodkärsl skada ');
INSERT INTO `lang_definitions` VALUES (2178, 3201, 2, 'Kärlkirurgi ');
INSERT INTO `lang_definitions` VALUES (2179, 3202, 2, 'Version ');
INSERT INTO `lang_definitions` VALUES (2180, 3203, 2, 'Svindel');
INSERT INTO `lang_definitions` VALUES (2181, 3205, 2, 'Visa');
INSERT INTO `lang_definitions` VALUES (2182, 3206, 2, 'visa');
INSERT INTO `lang_definitions` VALUES (2183, 3207, 2, 'Visa allergier');
INSERT INTO `lang_definitions` VALUES (2184, 3208, 2, 'Visa Omfattande Patient Rapport ');
INSERT INTO `lang_definitions` VALUES (2185, 3209, 2, 'Visa dokument');
INSERT INTO `lang_definitions` VALUES (2186, 3210, 2, 'Visa möte');
INSERT INTO `lang_definitions` VALUES (2187, 3211, 2, 'Visa händelser i ett popup-fönster? ');
INSERT INTO `lang_definitions` VALUES (2188, 3212, 2, 'Visa Sida 1');
INSERT INTO `lang_definitions` VALUES (2189, 3213, 2, 'Visa sida 2');
INSERT INTO `lang_definitions` VALUES (2190, 3214, 2, 'Se relaterade möten');
INSERT INTO `lang_definitions` VALUES (2191, 3216, 2, 'Visa: ');
INSERT INTO `lang_definitions` VALUES (2192, 3217, 2, 'VISA ');
INSERT INTO `lang_definitions` VALUES (2193, 3218, 2, 'Visceral skada / trauma / kirurgi ');
INSERT INTO `lang_definitions` VALUES (2194, 3219, 2, 'Besökskategori: ');
INSERT INTO `lang_definitions` VALUES (2195, 3220, 2, 'Besöks Datum ');
INSERT INTO `lang_definitions` VALUES (2196, 3222, 2, 'Besök');
INSERT INTO `lang_definitions` VALUES (2197, 3223, 2, 'Besök från ');
INSERT INTO `lang_definitions` VALUES (2198, 3225, 2, 'Livsviktiga ');
INSERT INTO `lang_definitions` VALUES (2199, 3226, 2, 'Livsviktiga (metriska)');
INSERT INTO `lang_definitions` VALUES (2200, 3228, 2, 'Kräkningar');
INSERT INTO `lang_definitions` VALUES (2201, 3229, 2, 'W');
INSERT INTO `lang_definitions` VALUES (2202, 3232, 2, 'Väntar ');
INSERT INTO `lang_definitions` VALUES (2203, 3235, 2, 'Varm');
INSERT INTO `lang_definitions` VALUES (2204, 3236, 2, 'VARNING');
INSERT INTO `lang_definitions` VALUES (2205, 3237, 2, 'Varning: Ett besök var redan skapat för denna patient idag!');
INSERT INTO `lang_definitions` VALUES (2206, 3238, 2, 'Varning: patient-ID är inte unikt!');
INSERT INTO `lang_definitions` VALUES (2207, 3241, 2, 'Svaghet');
INSERT INTO `lang_definitions` VALUES (2208, 3242, 2, 'Hemsida');
INSERT INTO `lang_definitions` VALUES (2209, 3243, 2, 'Ons');
INSERT INTO `lang_definitions` VALUES (2210, 3244, 2, 'Onsdag ');
INSERT INTO `lang_definitions` VALUES (2211, 3245, 2, 'vecka ');
INSERT INTO `lang_definitions` VALUES (2212, 3246, 2, 'Vecka ');
INSERT INTO `lang_definitions` VALUES (2213, 3247, 2, 'Veckovy ');
INSERT INTO `lang_definitions` VALUES (2214, 3248, 2, 'Veckan (s) ');
INSERT INTO `lang_definitions` VALUES (2215, 3249, 2, 'Vikt');
INSERT INTO `lang_definitions` VALUES (2216, 3250, 2, 'Vikt förändring');
INSERT INTO `lang_definitions` VALUES (2217, 3251, 2, 'Viktminskning ');
INSERT INTO `lang_definitions` VALUES (2218, 3252, 2, 'Vad är det som räknas? ');
INSERT INTO `lang_definitions` VALUES (2219, 3255, 2, 'Wheezing:');
INSERT INTO `lang_definitions` VALUES (2220, 3257, 2, 'Whiplash ');
INSERT INTO `lang_definitions` VALUES (2221, 3258, 2, 'Vem');
INSERT INTO `lang_definitions` VALUES (2222, 3259, 2, 'Vem har svarat?');
INSERT INTO `lang_definitions` VALUES (2223, 3260, 2, 'Änka');
INSERT INTO `lang_definitions` VALUES (2224, 3261, 2, 'Med vald:');
INSERT INTO `lang_definitions` VALUES (2225, 3262, 2, 'med det gamla namnet');
INSERT INTO `lang_definitions` VALUES (2226, 3263, 2, 'Med vem kan vi lämna ett meddelande? ');
INSERT INTO `lang_definitions` VALUES (2227, 3264, 2, 'inom några timmar ');
INSERT INTO `lang_definitions` VALUES (2228, 3265, 2, 'inom några timmar: ');
INSERT INTO `lang_definitions` VALUES (2229, 3266, 2, 'inom några minuter ');
INSERT INTO `lang_definitions` VALUES (2230, 3267, 2, 'inom några minuter: ');
INSERT INTO `lang_definitions` VALUES (2231, 3268, 2, 'Utan Updatering');
INSERT INTO `lang_definitions` VALUES (2232, 3269, 2, 'vittne');
INSERT INTO `lang_definitions` VALUES (2233, 3271, 2, 'Kvinnor ');
INSERT INTO `lang_definitions` VALUES (2234, 3272, 2, 'Enbart kvinnor ');
INSERT INTO `lang_definitions` VALUES (2235, 3273, 2, 'Arbete ');
INSERT INTO `lang_definitions` VALUES (2236, 3275, 2, 'Telefon, arbete ');
INSERT INTO `lang_definitions` VALUES (2237, 3276, 2, 'Telefon, Arbete, Nummer');
INSERT INTO `lang_definitions` VALUES (2238, 3277, 2, 'Arbetsrelaterat? ');
INSERT INTO `lang_definitions` VALUES (2239, 3278, 2, 'Arbete/ Utbildning/ Hobby');
INSERT INTO `lang_definitions` VALUES (2240, 3279, 2, 'Arbete / Skola Anmärkning ');
INSERT INTO `lang_definitions` VALUES (2241, 3280, 2, 'arbetsdag');
INSERT INTO `lang_definitions` VALUES (2242, 3282, 2, 'förvärrad');
INSERT INTO `lang_definitions` VALUES (2243, 3283, 2, 'Handled');
INSERT INTO `lang_definitions` VALUES (2244, 3284, 2, 'Handled och hand ');
INSERT INTO `lang_definitions` VALUES (2245, 3285, 2, 'Handleds Problem ');
INSERT INTO `lang_definitions` VALUES (2246, 3286, 2, 'skriv');
INSERT INTO `lang_definitions` VALUES (2247, 3287, 2, 'avskriva ');
INSERT INTO `lang_definitions` VALUES (2248, 3290, 2, 'x inställt');
INSERT INTO `lang_definitions` VALUES (2249, 3291, 2, 'Röntgen');
INSERT INTO `lang_definitions` VALUES (2250, 3292, 2, 'Röntgen Tolkning: ');
INSERT INTO `lang_definitions` VALUES (2251, 3293, 2, 'Röntgen Tolkning: ');
INSERT INTO `lang_definitions` VALUES (2252, 3294, 2, 'Endast X12: Ersättningskrav');
INSERT INTO `lang_definitions` VALUES (2253, 3295, 2, 'X12 Partner');
INSERT INTO `lang_definitions` VALUES (2254, 3296, 2, 'X12 Partners');
INSERT INTO `lang_definitions` VALUES (2255, 3297, 2, 'Y');
INSERT INTO `lang_definitions` VALUES (2256, 3298, 2, 'år ');
INSERT INTO `lang_definitions` VALUES (2257, 3299, 2, 'År ');
INSERT INTO `lang_definitions` VALUES (2258, 3300, 2, 'År Visa ');
INSERT INTO `lang_definitions` VALUES (2259, 3301, 2, 'År');
INSERT INTO `lang_definitions` VALUES (2260, 3302, 2, 'JA ');
INSERT INTO `lang_definitions` VALUES (2261, 3303, 2, 'Ja ');
INSERT INTO `lang_definitions` VALUES (2262, 3304, 2, 'ja ');
INSERT INTO `lang_definitions` VALUES (2263, 3305, 2, 'JA! ');
INSERT INTO `lang_definitions` VALUES (2264, 3306, 2, 'Ja, radera och logga');
INSERT INTO `lang_definitions` VALUES (2265, 3307, 2, 'Ja/Nej');
INSERT INTO `lang_definitions` VALUES (2266, 3308, 2, 'Ja:');
INSERT INTO `lang_definitions` VALUES (2267, 3309, 2, 'Du håller på att permanent ersätta den befintliga mallen. Är du säker på att du vill fortsätta?');
INSERT INTO `lang_definitions` VALUES (2268, 3310, 2, 'Det är inte tillåtet att ta bort denna händelse ');
INSERT INTO `lang_definitions` VALUES (2269, 3311, 2, 'Du har inte tillåtelse att redigera den här händelsen ');
INSERT INTO `lang_definitions` VALUES (2270, 3312, 2, 'Du har inte behörighet för detta. ');
INSERT INTO `lang_definitions` VALUES (2271, 3313, 2, 'Du har inte behörighet att komma åt den här gruppen. ');
INSERT INTO `lang_definitions` VALUES (2272, 3314, 2, 'Du har inte behörighet att lägga till / redigera frågor ');
INSERT INTO `lang_definitions` VALUES (2273, 3315, 2, 'Du har inte behörighet att se det här mötet.');
INSERT INTO `lang_definitions` VALUES (2274, 3316, 2, 'Du kan inte komma åt denna funktion direkt. ');
INSERT INTO `lang_definitions` VALUES (2275, 3317, 2, 'Du kan inte komma åt den här sidan direkt. ');
INSERT INTO `lang_definitions` VALUES (2276, 3321, 2, 'Du har inte valt några åtgärder. ');
INSERT INTO `lang_definitions` VALUES (2277, 3322, 2, 'Du har inte behörighet att se / redigera denna anmärkning ');
INSERT INTO `lang_definitions` VALUES (2278, 3324, 2, 'Du måste först välja eller lägga till en patient. ');
INSERT INTO `lang_definitions` VALUES (2279, 3325, 2, 'Du måste först välja eller skapa ett möte. ');
INSERT INTO `lang_definitions` VALUES (2280, 3326, 2, 'Du måste välja några områden för att fortsätta. ');
INSERT INTO `lang_definitions` VALUES (2281, 3328, 2, 'Ditt slutdatum är ogiltig ');
INSERT INTO `lang_definitions` VALUES (2282, 3329, 2, 'Din händelse har strukits. ');
INSERT INTO `lang_definitions` VALUES (2283, 3330, 2, 'Din händelse har ändrats. ');
INSERT INTO `lang_definitions` VALUES (2284, 3331, 2, 'Din händelse har lämnats in. ');
INSERT INTO `lang_definitions` VALUES (2285, 3332, 2, 'Din namnlista har ändrats för att uppfylla namngivnings krav. ');
INSERT INTO `lang_definitions` VALUES (2286, 3333, 2, 'Din Post Kalender konfiguration har återställts att använda standardvärden. ');
INSERT INTO `lang_definitions` VALUES (2287, 3334, 2, 'Din Post Kalender konfiguration har uppdaterats. ');
INSERT INTO `lang_definitions` VALUES (2288, 3335, 2, 'Den upprepade frekvens måste vara ett heltal. ');
INSERT INTO `lang_definitions` VALUES (2289, 3336, 2, 'Den upprepade frekvensen måste vara minst 1. ');
INSERT INTO `lang_definitions` VALUES (2290, 3337, 2, 'Ditt startdatum är större än ditt slutdatum ');
INSERT INTO `lang_definitions` VALUES (2291, 3338, 2, 'Ditt startdatum är ogiltig ');
INSERT INTO `lang_definitions` VALUES (2292, 3339, 2, 'Ditt förslag misslyckats.');
INSERT INTO `lang_definitions` VALUES (2293, 3340, 2, 'åååå-mm-dd ');
INSERT INTO `lang_definitions` VALUES (2294, 3341, 2, 'åååå-mm-dd dag är förknippade med detta dokument ');
INSERT INTO `lang_definitions` VALUES (2295, 3343, 2, 'åååå-mm-dd Födelsedatum ');
INSERT INTO `lang_definitions` VALUES (2296, 3344, 2, 'åååå-mm-dd födelsedatum ');
INSERT INTO `lang_definitions` VALUES (2297, 3345, 2, 'ååå-mm-dd datum för utlöpande');
INSERT INTO `lang_definitions` VALUES (2298, 3346, 2, 'åååå-mm-dd Datum för uppkomsten eller sjukhusvistelse ');
INSERT INTO `lang_definitions` VALUES (2299, 3347, 2, 'åååå-mm-dd datum debut, kirurgi eller början av medicinering ');
INSERT INTO `lang_definitions` VALUES (2300, 3348, 2, 'åååå-mm-dd dagen för tillfrisknande eller slutet av medicinering ');
INSERT INTO `lang_definitions` VALUES (2301, 3350, 2, 'åååå-mm-dd Delgivningsdatum ');
INSERT INTO `lang_definitions` VALUES (2302, 3351, 2, 'åååå-mm-dd dagen för denna skrivelse ');
INSERT INTO `lang_definitions` VALUES (2303, 3353, 2, 'åååå-mm-dd dokumentets datum ');
INSERT INTO `lang_definitions` VALUES (2304, 3354, 2, 'åååå-mm-dd händelse datum eller startdatum ');
INSERT INTO `lang_definitions` VALUES (2305, 3355, 2, 'åååå-mm-dd sista datum för detta evenemang');
INSERT INTO `lang_definitions` VALUES (2306, 3356, 2, 'noll');
INSERT INTO `lang_definitions` VALUES (2307, 3357, 2, 'postadress');
INSERT INTO `lang_definitions` VALUES (2308, 3358, 2, 'postnummer');
INSERT INTO `lang_definitions` VALUES (2309, 3359, 2, 'land');
INSERT INTO `lang_definitions` VALUES (2310, 3360, 2, 'men var');
INSERT INTO `lang_definitions` VALUES (2311, 3361, 2, 'gick inte att komma åt');
INSERT INTO `lang_definitions` VALUES (2312, 3362, 2, 'Vill du verkligen radera');
INSERT INTO `lang_definitions` VALUES (2313, 3363, 2, 'läkemedel');
INSERT INTO `lang_definitions` VALUES (2314, 3364, 2, 'e-postmeddelande ej skickat');
INSERT INTO `lang_definitions` VALUES (2315, 3365, 2, 'från');
INSERT INTO `lang_definitions` VALUES (2316, 3366, 2, 'har skapats');
INSERT INTO `lang_definitions` VALUES (2317, 3367, 2, 'har återupptagits');
INSERT INTO `lang_definitions` VALUES (2318, 3368, 2, 'Historia');
INSERT INTO `lang_definitions` VALUES (2319, 3369, 2, 'är inget nummer');
INSERT INTO `lang_definitions` VALUES (2320, 3370, 2, 'är redo för ny fakturering');
INSERT INTO `lang_definitions` VALUES (2321, 3371, 2, 'LLL:');
INSERT INTO `lang_definitions` VALUES (2322, 3372, 2, 'Batchnr');
INSERT INTO `lang_definitions` VALUES (2323, 3373, 2, 'Medicaid orginal referensnr.');
INSERT INTO `lang_definitions` VALUES (2324, 3375, 2, 'finns ej!');
INSERT INTO `lang_definitions` VALUES (2325, 3378, 2, 'Tills');
INSERT INTO `lang_definitions` VALUES (2326, 3379, 2, 'Uppdateringen misslyckades, inte i databasen? ');
INSERT INTO `lang_definitions` VALUES (2327, 3380, 2, 'präglades som faktureras endast. ');
INSERT INTO `lang_definitions` VALUES (2328, 3381, 2, 'var kö framgångsrikt. ');
INSERT INTO `lang_definitions` VALUES (2329, 3382, 2, '! Lämnat utan besök');
INSERT INTO `lang_definitions` VALUES (2330, 3383, 2, '\"För kod ');
INSERT INTO `lang_definitions` VALUES (2331, 3384, 2, 'Kontrolleras PostCalendar Inställningar! \"');
INSERT INTO `lang_definitions` VALUES (2332, 3387, 2, 'kr');
INSERT INTO `lang_definitions` VALUES (2333, 3388, 2, 'Kodningen av kronor är färdig');
INSERT INTO `lang_definitions` VALUES (2334, 3389, 2, '1 kr');
INSERT INTO `lang_definitions` VALUES (2335, 3390, 2, '$ etikett (åååå-mm-dd): ');
INSERT INTO `lang_definitions` VALUES (2336, 3391, 2, '%');
INSERT INTO `lang_definitions` VALUES (2337, 3392, 2, '% Annullerat <24h ');
INSERT INTO `lang_definitions` VALUES (2338, 3393, 2, 'bör finnas, men finns inte. ');
INSERT INTO `lang_definitions` VALUES (2339, 3394, 2, '(% Matchar alla strängar, _ matchar alla tecken) ');
INSERT INTO `lang_definitions` VALUES (2340, 3395, 2, '(Tillbaka) ');
INSERT INTO `lang_definitions` VALUES (2341, 3396, 2, '(Klicka för att redigera)');
INSERT INTO `lang_definitions` VALUES (2342, 3397, 2, '(Mer) ');
INSERT INTO `lang_definitions` VALUES (2343, 3398, 2, '(Ny Patient) ');
INSERT INTO `lang_definitions` VALUES (2344, 3399, 2, '(Anteckningar och Auktoriseringar) ');
INSERT INTO `lang_definitions` VALUES (2345, 3400, 2, '(Patient anteckningar) ');
INSERT INTO `lang_definitions` VALUES (2346, 3401, 2, '(Välj ett av dessa, eller skriv din egen rubrik) ');
INSERT INTO `lang_definitions` VALUES (2347, 3402, 2, '* Påminnelse skickad');
INSERT INTO `lang_definitions` VALUES (2348, 3404, 2, '* Obligatorisk');
INSERT INTO `lang_definitions` VALUES (2349, 3406, 2, '.');
INSERT INTO `lang_definitions` VALUES (2350, 3407, 2, '0-10');
INSERT INTO `lang_definitions` VALUES (2351, 3408, 2, '1.Vila 2. Lägg på is i två dagar 3. Komprimering lämna förbandet på plats om inte foten utvecklar domningar eller blek färg 4. Ha foten och ben i Upphöjt läge.');
INSERT INTO `lang_definitions` VALUES (2352, 3409, 2, '11/14/09');
INSERT INTO `lang_definitions` VALUES (2353, 3410, 2, '15-19');
INSERT INTO `lang_definitions` VALUES (2354, 3411, 2, '20-24');
INSERT INTO `lang_definitions` VALUES (2355, 3412, 2, '2111-13');
INSERT INTO `lang_definitions` VALUES (2356, 3413, 2, '25-29');
INSERT INTO `lang_definitions` VALUES (2357, 3414, 2, '2:a');
INSERT INTO `lang_definitions` VALUES (2358, 3415, 2, '3 månader ');
INSERT INTO `lang_definitions` VALUES (2359, 3416, 2, '3 gånger dagligen ');
INSERT INTO `lang_definitions` VALUES (2360, 3417, 2, '30-34 ');
INSERT INTO `lang_definitions` VALUES (2361, 3418, 2, '35-39 ');
INSERT INTO `lang_definitions` VALUES (2362, 3419, 2, '3:e');
INSERT INTO `lang_definitions` VALUES (2363, 3420, 2, '4 månader ');
INSERT INTO `lang_definitions` VALUES (2364, 3421, 2, '4 gånger dagligen ');
INSERT INTO `lang_definitions` VALUES (2365, 3422, 2, '40-44 ');
INSERT INTO `lang_definitions` VALUES (2366, 3423, 2, '45');
INSERT INTO `lang_definitions` VALUES (2367, 3431, 2, '4:e');
INSERT INTO `lang_definitions` VALUES (2368, 3433, 2, '5:e');
INSERT INTO `lang_definitions` VALUES (2369, 3434, 2, '6 månader');
INSERT INTO `lang_definitions` VALUES (2370, 3435, 2, '6:e');
INSERT INTO `lang_definitions` VALUES (2371, 3444, 2, '99212 Etablerade - okomplicerad');
INSERT INTO `lang_definitions` VALUES (2372, 3445, 2, '99213 Etablerade - Låg komplexitet');
INSERT INTO `lang_definitions` VALUES (2373, 3446, 2, '< I undersökningsrummet');
INSERT INTO `lang_definitions` VALUES (2374, 3447, 2, '> Avslutat');
INSERT INTO `lang_definitions` VALUES (2375, 3448, 2, '?Har ej dykt upp på avtalad tid');
INSERT INTO `lang_definitions` VALUES (2376, 3449, 2, 'Anlänt');
INSERT INTO `lang_definitions` VALUES (2377, 3450, 2, '[Ändra vy]');
INSERT INTO `lang_definitions` VALUES (2378, 3451, 2, '[Datum för senaste mötet] ');
INSERT INTO `lang_definitions` VALUES (2379, 3452, 2, '[Dagar sedan senaste mötet] ');
INSERT INTO `lang_definitions` VALUES (2380, 3455, 2, '[rekommenderas inte] ');
INSERT INTO `lang_definitions` VALUES (2381, 3456, 2, '[Antalet möten] ');
INSERT INTO `lang_definitions` VALUES (2382, 3457, 2, '[Rapporter] ');
INSERT INTO `lang_definitions` VALUES (2383, 3458, 2, '[Markera alla] ');
INSERT INTO `lang_definitions` VALUES (2384, 3459, 2, '[SQL-Ledger]');
INSERT INTO `lang_definitions` VALUES (2385, 3460, 2, '[Starta batchprocess]');
INSERT INTO `lang_definitions` VALUES (2386, 3461, 2, '[Titta på logg]');
INSERT INTO `lang_definitions` VALUES (2387, 3462, 2, '[Se printbar rapport]');
INSERT INTO `lang_definitions` VALUES (2388, 3466, 2, '~ Kommit sent');
INSERT INTO `lang_definitions` VALUES (2389, 1, 3, 'A');
INSERT INTO `lang_definitions` VALUES (2390, 2, 3, 'Número de cheque o reclamación para identificar el pago');
INSERT INTO `lang_definitions` VALUES (2391, 4, 3, 'Número de lote es requerido');
INSERT INTO `lang_definitions` VALUES (2392, 5, 3, 'Código IPPF relacionado es requerido');
INSERT INTO `lang_definitions` VALUES (2393, 6, 3, 'Un valor único para identificar este campo, no visible al usuario ');
INSERT INTO `lang_definitions` VALUES (2394, 7, 3, 'antes de las comidas');
INSERT INTO `lang_definitions` VALUES (2395, 8, 3, 'a.m.');
INSERT INTO `lang_definitions` VALUES (2396, 9, 3, 'A/F Nivel de Derecho');
INSERT INTO `lang_definitions` VALUES (2397, 10, 3, 'AB');
INSERT INTO `lang_definitions` VALUES (2398, 11, 3, 'Abreviatura');
INSERT INTO `lang_definitions` VALUES (2399, 12, 3, 'Absceso');
INSERT INTO `lang_definitions` VALUES (2400, 13, 3, 'Abdominal');
INSERT INTO `lang_definitions` VALUES (2401, 14, 3, 'Capaz de cargar peso cuatro pasos');
INSERT INTO `lang_definitions` VALUES (2402, 15, 3, 'Abn');
INSERT INTO `lang_definitions` VALUES (2403, 16, 3, 'ABN1');
INSERT INTO `lang_definitions` VALUES (2404, 17, 3, 'Anormal');
INSERT INTO `lang_definitions` VALUES (2405, 18, 3, 'Análisis de sangre anormal ');
INSERT INTO `lang_definitions` VALUES (2406, 19, 3, 'Crecimiento anormal del pelo ');
INSERT INTO `lang_definitions` VALUES (2407, 20, 3, 'Mamograma anormal ');
INSERT INTO `lang_definitions` VALUES (2408, 21, 3, 'Aborto');
INSERT INTO `lang_definitions` VALUES (2409, 22, 3, 'Problemas de Aborto');
INSERT INTO `lang_definitions` VALUES (2410, 23, 3, 'Método de Aborto');
INSERT INTO `lang_definitions` VALUES (2411, 24, 3, 'Categorías Aborto-Relacionadas ');
INSERT INTO `lang_definitions` VALUES (2412, 25, 3, 'Abortos');
INSERT INTO `lang_definitions` VALUES (2413, 26, 3, 'Carencias por Diagnósticos');
INSERT INTO `lang_definitions` VALUES (2414, 27, 3, 'Aceptar Encargo');
INSERT INTO `lang_definitions` VALUES (2415, 28, 3, 'Aceptar Pago por');
INSERT INTO `lang_definitions` VALUES (2416, 29, 3, 'Acepta el encargo');
INSERT INTO `lang_definitions` VALUES (2417, 30, 3, 'Control de acceso');
INSERT INTO `lang_definitions` VALUES (2418, 31, 3, 'Lista de Administración de Control de Acceso');
INSERT INTO `lang_definitions` VALUES (2419, 32, 3, 'Contabilidad');
INSERT INTO `lang_definitions` VALUES (2420, 33, 3, 'Dolores');
INSERT INTO `lang_definitions` VALUES (2421, 35, 3, 'ACL');
INSERT INTO `lang_definitions` VALUES (2422, 36, 3, 'Administración del ACL');
INSERT INTO `lang_definitions` VALUES (2423, 37, 3, 'Administración de ACL no autorizada');
INSERT INTO `lang_definitions` VALUES (2424, 38, 3, 'Acné ');
INSERT INTO `lang_definitions` VALUES (2425, 39, 3, 'Acto');
INSERT INTO `lang_definitions` VALUES (2426, 40, 3, 'Fecha Activo');
INSERT INTO `lang_definitions` VALUES (2427, 41, 3, 'Activo');
INSERT INTO `lang_definitions` VALUES (2428, 42, 3, 'Encuentro Activo');
INSERT INTO `lang_definitions` VALUES (2429, 44, 3, 'Paciente Activo');
INSERT INTO `lang_definitions` VALUES (2430, 45, 3, 'Tipo de Actividad');
INSERT INTO `lang_definitions` VALUES (2431, 46, 3, 'Agudo en Crónico');
INSERT INTO `lang_definitions` VALUES (2432, 47, 3, 'Añadir');
INSERT INTO `lang_definitions` VALUES (2433, 49, 3, 'Añadir una compañía');
INSERT INTO `lang_definitions` VALUES (2434, 50, 3, 'Añadir una farmacia');
INSERT INTO `lang_definitions` VALUES (2435, 51, 3, 'Añadir un evento para');
INSERT INTO `lang_definitions` VALUES (2436, 52, 3, 'Añadir como nueva nota');
INSERT INTO `lang_definitions` VALUES (2437, 53, 3, 'Añadir como nuevo');
INSERT INTO `lang_definitions` VALUES (2438, 54, 3, 'Añadir categoria');
INSERT INTO `lang_definitions` VALUES (2439, 55, 3, 'Añadir constante');
INSERT INTO `lang_definitions` VALUES (2440, 56, 3, 'Añadir Co-pago');
INSERT INTO `lang_definitions` VALUES (2441, 57, 3, 'Añadir droga');
INSERT INTO `lang_definitions` VALUES (2442, 58, 3, 'Añadir encuentro');
INSERT INTO `lang_definitions` VALUES (2443, 59, 3, 'Añadir instalación');
INSERT INTO `lang_definitions` VALUES (2444, 60, 3, 'Añadir el Campo');
INSERT INTO `lang_definitions` VALUES (2445, 61, 3, 'Añadir grupo');
INSERT INTO `lang_definitions` VALUES (2446, 62, 3, 'Añadir código ICD');
INSERT INTO `lang_definitions` VALUES (2447, 63, 3, 'Añadir Incidente');
INSERT INTO `lang_definitions` VALUES (2448, 64, 3, 'Añadir idioma');
INSERT INTO `lang_definitions` VALUES (2449, 65, 3, 'Añadir nuevo');
INSERT INTO `lang_definitions` VALUES (2450, 66, 3, 'Añadir nuevo categoría :');
INSERT INTO `lang_definitions` VALUES (2451, 67, 3, 'Añadir nuevo grupo');
INSERT INTO `lang_definitions` VALUES (2452, 68, 3, 'Añadir nueva nota');
INSERT INTO `lang_definitions` VALUES (2453, 69, 3, 'Añadir nueva nota');
INSERT INTO `lang_definitions` VALUES (2454, 70, 3, 'Añadir nuevo socio');
INSERT INTO `lang_definitions` VALUES (2455, 71, 3, 'Añadir nota');
INSERT INTO `lang_definitions` VALUES (2456, 72, 3, 'Añadir record del paciente');
INSERT INTO `lang_definitions` VALUES (2457, 73, 3, 'Añadir receta');
INSERT INTO `lang_definitions` VALUES (2458, 75, 3, 'Añadir a lista de medicación');
INSERT INTO `lang_definitions` VALUES (2459, 76, 3, 'Añadir Transacción');
INSERT INTO `lang_definitions` VALUES (2460, 77, 3, 'Añadir usuario');
INSERT INTO `lang_definitions` VALUES (2461, 78, 3, 'Añadir usuario al grupo');
INSERT INTO `lang_definitions` VALUES (2462, 80, 3, 'No se autoriza añadir datos demograficos.');
INSERT INTO `lang_definitions` VALUES (2463, 81, 3, 'Síndrome de Addison');
INSERT INTO `lang_definitions` VALUES (2464, 82, 3, 'Síndrome de Addison');
INSERT INTO `lang_definitions` VALUES (2465, 83, 3, 'Diagnóstico adicional:');
INSERT INTO `lang_definitions` VALUES (2466, 84, 3, 'Historial adicional');
INSERT INTO `lang_definitions` VALUES (2467, 85, 3, 'Notas adicionales de la historia ');
INSERT INTO `lang_definitions` VALUES (2468, 86, 3, 'Información adicional');
INSERT INTO `lang_definitions` VALUES (2469, 87, 3, 'Laboratorios adicionales');
INSERT INTO `lang_definitions` VALUES (2470, 88, 3, 'Notas adicionales');
INSERT INTO `lang_definitions` VALUES (2471, 89, 3, 'Notas adicionales:');
INSERT INTO `lang_definitions` VALUES (2472, 90, 3, 'Notas adicionales:');
INSERT INTO `lang_definitions` VALUES (2473, 91, 3, 'Notas de Rayos X adicionales:');
INSERT INTO `lang_definitions` VALUES (2474, 92, 3, 'solo añadir');
INSERT INTO `lang_definitions` VALUES (2475, 93, 3, 'Lbta Direcciónes');
INSERT INTO `lang_definitions` VALUES (2476, 94, 3, 'Lbta Direcciónes');
INSERT INTO `lang_definitions` VALUES (2477, 95, 3, 'Dirección');
INSERT INTO `lang_definitions` VALUES (2478, 96, 3, 'Libreta de direcciones');
INSERT INTO `lang_definitions` VALUES (2479, 97, 3, 'Dirección1');
INSERT INTO `lang_definitions` VALUES (2480, 98, 3, 'Dirección2');
INSERT INTO `lang_definitions` VALUES (2481, 99, 3, 'Ajuste ');
INSERT INTO `lang_definitions` VALUES (2482, 100, 3, 'Ajustar');
INSERT INTO `lang_definitions` VALUES (2483, 101, 3, 'Razones del ajuste');
INSERT INTO `lang_definitions` VALUES (2484, 102, 3, 'Valor de ajuste para código');
INSERT INTO `lang_definitions` VALUES (2485, 103, 3, 'Ajustes');
INSERT INTO `lang_definitions` VALUES (2486, 104, 3, 'Ajuste administrativo');
INSERT INTO `lang_definitions` VALUES (2487, 105, 3, 'Administrativo');
INSERT INTO `lang_definitions` VALUES (2488, 106, 3, 'Dirección correo electrónico administración');
INSERT INTO `lang_definitions` VALUES (2489, 107, 3, 'Administrado ');
INSERT INTO `lang_definitions` VALUES (2490, 108, 3, 'Administrado por');
INSERT INTO `lang_definitions` VALUES (2491, 109, 3, 'Administración');
INSERT INTO `lang_definitions` VALUES (2492, 110, 3, 'Administradores');
INSERT INTO `lang_definitions` VALUES (2493, 111, 3, 'Los administradores pueden hacer cualquier cosa');
INSERT INTO `lang_definitions` VALUES (2494, 112, 3, 'Avanzado');
INSERT INTO `lang_definitions` VALUES (2495, 113, 3, 'Consejo');
INSERT INTO `lang_definitions` VALUES (2496, 114, 3, 'Afectar normal');
INSERT INTO `lang_definitions` VALUES (2497, 115, 3, 'llamadas fuera horario laboral');
INSERT INTO `lang_definitions` VALUES (2498, 116, 3, 'Después de guardar el PDF, clic [registro de la visión] para comprobar si hay errores. ');
INSERT INTO `lang_definitions` VALUES (2499, 117, 3, 'Después de guadar su hornada, clic [registro de la visión] para comproba si hay errores. ');
INSERT INTO `lang_definitions` VALUES (2500, 118, 3, 'Una vez medita la información correcta, pinchar botón guardar.');
INSERT INTO `lang_definitions` VALUES (2501, 119, 3, 'Otra vez');
INSERT INTO `lang_definitions` VALUES (2502, 120, 3, 'Edad');
INSERT INTO `lang_definitions` VALUES (2503, 121, 3, 'Edad por');
INSERT INTO `lang_definitions` VALUES (2504, 122, 3, 'Categoría edad');
INSERT INTO `lang_definitions` VALUES (2505, 123, 3, 'Datos de edad están fuera de alcance. ');
INSERT INTO `lang_definitions` VALUES (2506, 124, 3, 'Formato de edad para \'desde x edad\' no es válido');
INSERT INTO `lang_definitions` VALUES (2507, 125, 3, 'Formato de edad para \'hasta x edad\' no es válido');
INSERT INTO `lang_definitions` VALUES (2508, 126, 3, 'Edad desde');
INSERT INTO `lang_definitions` VALUES (2509, 127, 3, 'Columnas del envejecimiento: ');
INSERT INTO `lang_definitions` VALUES (2510, 128, 3, 'Alcohol');
INSERT INTO `lang_definitions` VALUES (2511, 129, 3, 'Consumición del alcohol ');
INSERT INTO `lang_definitions` VALUES (2512, 130, 3, 'Todos');
INSERT INTO `lang_definitions` VALUES (2513, 131, 3, 'Todas las categorías');
INSERT INTO `lang_definitions` VALUES (2514, 132, 3, 'Todo el día');
INSERT INTO `lang_definitions` VALUES (2515, 133, 3, 'Evento de día completo');
INSERT INTO `lang_definitions` VALUES (2516, 134, 3, 'Todas las instalaciones');
INSERT INTO `lang_definitions` VALUES (2517, 135, 3, 'Todo o parte del nombre');
INSERT INTO `lang_definitions` VALUES (2518, 136, 3, 'Todo o parte del apellido');
INSERT INTO `lang_definitions` VALUES (2519, 137, 3, 'Todos los provedores');
INSERT INTO `lang_definitions` VALUES (2520, 138, 3, 'Todos respasados y negativos:');
INSERT INTO `lang_definitions` VALUES (2521, 139, 3, 'Todos los temas');
INSERT INTO `lang_definitions` VALUES (2522, 140, 3, 'Todos los usuarios');
INSERT INTO `lang_definitions` VALUES (2523, 141, 3, 'Alérgico ');
INSERT INTO `lang_definitions` VALUES (2524, 142, 3, 'Alergias');
INSERT INTO `lang_definitions` VALUES (2525, 143, 3, 'Alergias:');
INSERT INTO `lang_definitions` VALUES (2526, 144, 3, 'Alergia');
INSERT INTO `lang_definitions` VALUES (2527, 145, 3, 'Permita el Email');
INSERT INTO `lang_definitions` VALUES (2528, 146, 3, '¿Permita los correos electrónicos?');
INSERT INTO `lang_definitions` VALUES (2529, 147, 3, '¿Permita Email?');
INSERT INTO `lang_definitions` VALUES (2530, 148, 3, 'Permita el mensaje de correo');
INSERT INTO `lang_definitions` VALUES (2531, 149, 3, 'Permitir SMS');
INSERT INTO `lang_definitions` VALUES (2532, 150, 3, '¿Permitir SMS (mensaje de texto)?');
INSERT INTO `lang_definitions` VALUES (2533, 151, 3, 'Permitir la activación instantánea de los eventos entrados?');
INSERT INTO `lang_definitions` VALUES (2534, 152, 3, '¿Permitir mensaje telefonico?');
INSERT INTO `lang_definitions` VALUES (2535, 153, 3, 'Permitir a los usuarios publicar eventos globales');
INSERT INTO `lang_definitions` VALUES (2536, 154, 3, 'Permitir a los usuarios publicar calendarios personales');
INSERT INTO `lang_definitions` VALUES (2537, 155, 3, 'Permita Mensaje de Voz');
INSERT INTO `lang_definitions` VALUES (2538, 156, 3, 'Permitido');
INSERT INTO `lang_definitions` VALUES (2539, 158, 3, 'Indentificador usado ya, elige otro');
INSERT INTO `lang_definitions` VALUES (2540, 159, 3, 'Título usado ya, elige otro');
INSERT INTO `lang_definitions` VALUES (2541, 160, 3, 'Dirección alternativa');
INSERT INTO `lang_definitions` VALUES (2542, 162, 3, 'De forma alternativa, puede usar la página de búsqueda para cargar un archivo electrónico (X12835) que haya recibido de su pagador. Puede hacerlo oprimiendo el botón \"Explorar\" y seleccionar el archivo a cargar, y luego oprimir \"Explorar\" para ejecutar la carga y desplegar las facturas correspondientes. En este caso, los parámetros mencionados arriba no aplican y pueden ser ignorados. La carga guarda el archivo pero no procesa su contenido - esto se realiza de forma separada tal y como se describe abajo.');
INSERT INTO `lang_definitions` VALUES (2543, 163, 3, 'AM');
INSERT INTO `lang_definitions` VALUES (2544, 164, 3, 'Enmendar nota existente');
INSERT INTO `lang_definitions` VALUES (2545, 165, 3, 'AMEX');
INSERT INTO `lang_definitions` VALUES (2546, 166, 3, 'Balance');
INSERT INTO `lang_definitions` VALUES (2547, 168, 3, 'Cantidad para balance anterior');
INSERT INTO `lang_definitions` VALUES (2548, 169, 3, 'Balance por esta visita');
INSERT INTO `lang_definitions` VALUES (2549, 170, 3, 'Balance pagado');
INSERT INTO `lang_definitions` VALUES (2550, 171, 3, 'Balance:');
INSERT INTO `lang_definitions` VALUES (2551, 175, 3, 'Se ha creado y se ha ligado una edición incompleta de GCAC. Alguien necesitará terminarla más adelante.');
INSERT INTO `lang_definitions` VALUES (2552, 176, 3, 'Y');
INSERT INTO `lang_definitions` VALUES (2553, 179, 3, 'y');
INSERT INTO `lang_definitions` VALUES (2554, 180, 3, '¿y toda la información subordinada? Esta acción será registrada');
INSERT INTO `lang_definitions` VALUES (2555, 181, 3, 'Anemia ');
INSERT INTO `lang_definitions` VALUES (2556, 182, 3, 'Tobillo');
INSERT INTO `lang_definitions` VALUES (2557, 183, 3, 'Tobillo + talón');
INSERT INTO `lang_definitions` VALUES (2558, 184, 3, 'Formulario de evalución del tobillo');
INSERT INTO `lang_definitions` VALUES (2559, 185, 3, 'Problemas de tobillo');
INSERT INTO `lang_definitions` VALUES (2560, 186, 3, 'Espondilitis anquilosante');
INSERT INTO `lang_definitions` VALUES (2561, 187, 3, 'Espondilitis anquilosante');
INSERT INTO `lang_definitions` VALUES (2562, 188, 3, 'Anorexia');
INSERT INTO `lang_definitions` VALUES (2563, 189, 3, 'Otra cosa que puede hacer en la ventana de publicación es solicitar facturación secundaria. Si selecciona la casilla de verificación antes de guardar, la reclamación original será reabierta y asignada en la página de Facturación, y será procesada en la siguiente corrida de facturación.');
INSERT INTO `lang_definitions` VALUES (2564, 190, 3, 'ante');
INSERT INTO `lang_definitions` VALUES (2565, 191, 3, 'Nl ano, recto sin ternura / masa');
INSERT INTO `lang_definitions` VALUES (2566, 192, 3, 'Ansiedad ');
INSERT INTO `lang_definitions` VALUES (2567, 193, 3, 'Cualquier');
INSERT INTO `lang_definitions` VALUES (2568, 195, 3, 'Cualquier parte del código deseado o su descripción');
INSERT INTO `lang_definitions` VALUES (2569, 196, 3, 'Cualquier parte de la especialidad deseada');
INSERT INTO `lang_definitions` VALUES (2570, 197, 3, 'Cualquier parte del nombre del paciente, o \"Apellido, Nombre\", o \"X-Y\"');
INSERT INTO `lang_definitions` VALUES (2571, 198, 3, 'Apnea');
INSERT INTO `lang_definitions` VALUES (2572, 199, 3, 'Aspecto');
INSERT INTO `lang_definitions` VALUES (2573, 200, 3, 'Aspecto:');
INSERT INTO `lang_definitions` VALUES (2574, 201, 3, 'Añada a la nota existente');
INSERT INTO `lang_definitions` VALUES (2575, 202, 3, 'Añada a esta nota ');
INSERT INTO `lang_definitions` VALUES (2576, 203, 3, 'Añadir a esta nota');
INSERT INTO `lang_definitions` VALUES (2577, 204, 3, 'Apendectomía');
INSERT INTO `lang_definitions` VALUES (2578, 206, 3, 'aplicar a la zona afectada');
INSERT INTO `lang_definitions` VALUES (2579, 207, 3, 'aplicar a la piel');
INSERT INTO `lang_definitions` VALUES (2580, 209, 3, 'Fecha de Cita');
INSERT INTO `lang_definitions` VALUES (2581, 210, 3, 'Situación de Cita');
INSERT INTO `lang_definitions` VALUES (2582, 211, 3, 'Cita dentro');
INSERT INTO `lang_definitions` VALUES (2583, 212, 3, 'Citas');
INSERT INTO `lang_definitions` VALUES (2584, 213, 3, 'Citas (escriba opcional)');
INSERT INTO `lang_definitions` VALUES (2585, 214, 3, 'Citas y encuentros');
INSERT INTO `lang_definitions` VALUES (2586, 215, 3, 'Informe Citas');
INSERT INTO `lang_definitions` VALUES (2587, 216, 3, 'Informes Citas-Encuentros');
INSERT INTO `lang_definitions` VALUES (2588, 217, 3, 'Aprobar');
INSERT INTO `lang_definitions` VALUES (2589, 218, 3, 'Aprobado');
INSERT INTO `lang_definitions` VALUES (2590, 219, 3, 'Eventos Administrativos Aprobados');
INSERT INTO `lang_definitions` VALUES (2591, 220, 3, 'Citas Encuentro');
INSERT INTO `lang_definitions` VALUES (2592, 221, 3, 'Citas');
INSERT INTO `lang_definitions` VALUES (2593, 222, 3, 'Abril');
INSERT INTO `lang_definitions` VALUES (2594, 224, 3, '¿Le preparan para terminar una nueva edición de GCAC para esta visita?');
INSERT INTO `lang_definitions` VALUES (2595, 225, 3, '¿Estás seguro quer quieres aprobar estos eventos?');
INSERT INTO `lang_definitions` VALUES (2596, 226, 3, '¿Estás seguro de que deseas eliminar por completo este formulario? ');
INSERT INTO `lang_definitions` VALUES (2597, 227, 3, '¿Estás seguro que quieres eliminar estos eventos?');
INSERT INTO `lang_definitions` VALUES (2598, 229, 3, '¿Está usted seguro usted quiere suprimir esta nota?');
INSERT INTO `lang_definitions` VALUES (2599, 230, 3, '¿Estás seguro que quieres editar estos eventos?');
INSERT INTO `lang_definitions` VALUES (2600, 231, 3, '¿Estás seguro que quieres ocultar estos eventos?');
INSERT INTO `lang_definitions` VALUES (2601, 232, 3, '¿Estás seguro que quieres visualizar estos eventos?');
INSERT INTO `lang_definitions` VALUES (2602, 233, 3, 'Está usted seguro usted que desea suprimir al grupo entero nombrado');
INSERT INTO `lang_definitions` VALUES (2603, 234, 3, 'Está usted seguro que desea suprimir la lista entera');
INSERT INTO `lang_definitions` VALUES (2604, 235, 3, 'Está usted seguro que quiere suprimir el campo interno');
INSERT INTO `lang_definitions` VALUES (2605, 237, 3, '¿Estás seguro que quieres continuar con estas acciones?');
INSERT INTO `lang_definitions` VALUES (2606, 238, 3, 'Zona no especificada');
INSERT INTO `lang_definitions` VALUES (2607, 239, 3, 'Armenio ');
INSERT INTO `lang_definitions` VALUES (2608, 240, 3, 'Arritmia ');
INSERT INTO `lang_definitions` VALUES (2609, 241, 3, 'Artritis');
INSERT INTO `lang_definitions` VALUES (2610, 242, 3, 'Artritis / Enfermedad degenerativa de articulaciones');
INSERT INTO `lang_definitions` VALUES (2611, 243, 3, 'Artritis / Enfermedad degenerativa de articulaciones');
INSERT INTO `lang_definitions` VALUES (2612, 244, 3, 'como');
INSERT INTO `lang_definitions` VALUES (2613, 245, 3, 'Desde');
INSERT INTO `lang_definitions` VALUES (2614, 246, 3, 'Asiático');
INSERT INTO `lang_definitions` VALUES (2615, 247, 3, 'Gravamen');
INSERT INTO `lang_definitions` VALUES (2616, 248, 3, 'Asignado a');
INSERT INTO `lang_definitions` VALUES (2617, 249, 3, 'Ayudante');
INSERT INTO `lang_definitions` VALUES (2618, 250, 3, 'Asma');
INSERT INTO `lang_definitions` VALUES (2619, 252, 3, 'En el Escafoides');
INSERT INTO `lang_definitions` VALUES (2620, 253, 3, 'En el Escafoides:');
INSERT INTO `lang_definitions` VALUES (2621, 254, 3, 'Atlético / Lesión');
INSERT INTO `lang_definitions` VALUES (2622, 255, 3, 'Atención');
INSERT INTO `lang_definitions` VALUES (2623, 256, 3, 'Atención');
INSERT INTO `lang_definitions` VALUES (2624, 257, 3, 'Agosto');
INSERT INTO `lang_definitions` VALUES (2625, 258, 3, 'Autorización');
INSERT INTO `lang_definitions` VALUES (2626, 259, 3, 'Autori/Notas');
INSERT INTO `lang_definitions` VALUES (2627, 260, 3, 'Autorizaciones');
INSERT INTO `lang_definitions` VALUES (2628, 261, 3, 'Autorizar');
INSERT INTO `lang_definitions` VALUES (2629, 262, 3, 'Autorice - cualesquiera los encuentros');
INSERT INTO `lang_definitions` VALUES (2630, 263, 3, 'Autorice - mi encuentro');
INSERT INTO `lang_definitions` VALUES (2631, 264, 3, 'Autorizado');
INSERT INTO `lang_definitions` VALUES (2632, 265, 3, 'Mandar automáticamente');
INSERT INTO `lang_definitions` VALUES (2633, 266, 3, 'Auto-generado');
INSERT INTO `lang_definitions` VALUES (2634, 267, 3, 'Automovil Medico');
INSERT INTO `lang_definitions` VALUES (2635, 268, 3, 'salvado automáticamente');
INSERT INTO `lang_definitions` VALUES (2636, 269, 3, 'Horas disponbiles');
INSERT INTO `lang_definitions` VALUES (2637, 270, 3, 'Avulsión / fractura por avulsión');
INSERT INTO `lang_definitions` VALUES (2638, 271, 3, 'Avulsión maleolo peroneal');
INSERT INTO `lang_definitions` VALUES (2639, 272, 3, 'Avulsión maleolo tibial');
INSERT INTO `lang_definitions` VALUES (2640, 273, 3, 'Conocimiento-Basado');
INSERT INTO `lang_definitions` VALUES (2641, 274, 3, 'Axilar ');
INSERT INTO `lang_definitions` VALUES (2642, 275, 3, 'b.i.d.');
INSERT INTO `lang_definitions` VALUES (2643, 276, 3, 'espalda');
INSERT INTO `lang_definitions` VALUES (2644, 277, 3, 'Espalda');
INSERT INTO `lang_definitions` VALUES (2645, 284, 3, 'Problemas de espalda');
INSERT INTO `lang_definitions` VALUES (2646, 287, 3, 'Cirujia de la espalda');
INSERT INTO `lang_definitions` VALUES (2647, 292, 3, 'Resguardo');
INSERT INTO `lang_definitions` VALUES (2648, 293, 3, 'Se ha creado el archivo de reserva. Ahora enviará transferencia directa.');
INSERT INTO `lang_definitions` VALUES (2649, 294, 3, 'Talón sin fondos');
INSERT INTO `lang_definitions` VALUES (2650, 295, 3, 'Cheque devuelto');
INSERT INTO `lang_definitions` VALUES (2651, 296, 3, 'Bahasa Indonesia');
INSERT INTO `lang_definitions` VALUES (2652, 297, 3, 'Bal');
INSERT INTO `lang_definitions` VALUES (2653, 298, 3, 'Balance');
INSERT INTO `lang_definitions` VALUES (2654, 299, 3, 'balance');
INSERT INTO `lang_definitions` VALUES (2655, 300, 3, 'Balance a pagar');
INSERT INTO `lang_definitions` VALUES (2656, 301, 3, 'Base del quinto (5to) Metatarsiano');
INSERT INTO `lang_definitions` VALUES (2657, 302, 3, 'Base del quinto (5to) Metatarsiano:');
INSERT INTO `lang_definitions` VALUES (2658, 303, 3, 'Herramienta de Comunicación del Batch');
INSERT INTO `lang_definitions` VALUES (2659, 304, 3, 'Proceso de Batch iniciado; puede tomar unos minutos');
INSERT INTO `lang_definitions` VALUES (2660, 305, 3, 'Comunicación');
INSERT INTO `lang_definitions` VALUES (2661, 306, 3, 'porque no existe esa identificación. ');
INSERT INTO `lang_definitions` VALUES (2662, 307, 3, 'Empezar');
INSERT INTO `lang_definitions` VALUES (2663, 308, 3, 'Fecha de comienzo');
INSERT INTO `lang_definitions` VALUES (2664, 309, 3, 'Fecha comienzo servicio aaaa-mm.dd');
INSERT INTO `lang_definitions` VALUES (2665, 310, 3, 'Eructo ');
INSERT INTO `lang_definitions` VALUES (2666, 312, 3, 'Bilateral:');
INSERT INTO `lang_definitions` VALUES (2667, 313, 3, 'Fecha factura:');
INSERT INTO `lang_definitions` VALUES (2668, 314, 3, 'Recoge/Factura');
INSERT INTO `lang_definitions` VALUES (2669, 315, 3, 'Facturado');
INSERT INTO `lang_definitions` VALUES (2670, 316, 3, 'Facturación');
INSERT INTO `lang_definitions` VALUES (2671, 317, 3, 'Facturación (escritura opcional)');
INSERT INTO `lang_definitions` VALUES (2672, 318, 3, 'Atención factura');
INSERT INTO `lang_definitions` VALUES (2673, 319, 3, 'Código de factura para el Servicio Solicitado');
INSERT INTO `lang_definitions` VALUES (2674, 320, 3, 'Código de factura');
INSERT INTO `lang_definitions` VALUES (2675, 321, 3, 'Información factura');
INSERT INTO `lang_definitions` VALUES (2676, 322, 3, 'Dirección para factura');
INSERT INTO `lang_definitions` VALUES (2677, 323, 3, 'Nota de factura');
INSERT INTO `lang_definitions` VALUES (2678, 324, 3, 'Nota de factura para ');
INSERT INTO `lang_definitions` VALUES (2679, 325, 3, 'Nota de factura:');
INSERT INTO `lang_definitions` VALUES (2680, 326, 3, 'Resultados de la coleta de la facturación:');
INSERT INTO `lang_definitions` VALUES (2681, 327, 3, 'Informe de Facturación');
INSERT INTO `lang_definitions` VALUES (2682, 328, 3, 'factura para');
INSERT INTO `lang_definitions` VALUES (2683, 329, 3, 'Biopsia ');
INSERT INTO `lang_definitions` VALUES (2684, 330, 3, 'Fecha de nacimiento');
INSERT INTO `lang_definitions` VALUES (2685, 331, 3, 'Negro');
INSERT INTO `lang_definitions` VALUES (2686, 332, 3, 'Cáncer de vejiga');
INSERT INTO `lang_definitions` VALUES (2687, 333, 3, 'Infecciones de vejiga');
INSERT INTO `lang_definitions` VALUES (2688, 334, 3, 'Formas en blanco');
INSERT INTO `lang_definitions` VALUES (2689, 335, 3, 'Problemas de sangrado ');
INSERT INTO `lang_definitions` VALUES (2690, 336, 3, 'Puntos Ciegos ');
INSERT INTO `lang_definitions` VALUES (2691, 337, 3, 'Hinchazón ');
INSERT INTO `lang_definitions` VALUES (2692, 338, 3, 'Atascado');
INSERT INTO `lang_definitions` VALUES (2693, 339, 3, 'Presión Arterial ');
INSERT INTO `lang_definitions` VALUES (2694, 340, 3, 'Presión arterial ');
INSERT INTO `lang_definitions` VALUES (2695, 341, 3, 'Sangra de la nariz');
INSERT INTO `lang_definitions` VALUES (2696, 342, 3, 'Protector azul cruzado azul');
INSERT INTO `lang_definitions` VALUES (2697, 343, 3, 'Las líneas azules en este reporte son informativas. Líneasa negras muestran información existente. Líneas verdes muestran cambios aplicados exitosamente. Líneas rojas indican errores o cambios que no fueron aplicados, y deben ser procesados manualmente. Reclamaciones denegadas y pagos revertidos no se manejan automáticamente y aparecerán en rojo.');
INSERT INTO `lang_definitions` VALUES (2698, 344, 3, 'Visión borrosa');
INSERT INTO `lang_definitions` VALUES (2699, 345, 3, 'BMI');
INSERT INTO `lang_definitions` VALUES (2700, 346, 3, 'BMI Estado');
INSERT INTO `lang_definitions` VALUES (2701, 347, 3, 'Región corporal');
INSERT INTO `lang_definitions` VALUES (2702, 348, 3, 'Fragilidad osea:');
INSERT INTO `lang_definitions` VALUES (2703, 349, 3, 'Fragilidad osea: Maleolo Tibial');
INSERT INTO `lang_definitions` VALUES (2704, 350, 3, 'Boleano');
INSERT INTO `lang_definitions` VALUES (2705, 351, 3, 'Infer');
INSERT INTO `lang_definitions` VALUES (2706, 352, 3, 'Ambos Oídos ');
INSERT INTO `lang_definitions` VALUES (2707, 353, 3, 'ambas orejas/ ambos oídos');
INSERT INTO `lang_definitions` VALUES (2708, 354, 3, 'Parte inferior');
INSERT INTO `lang_definitions` VALUES (2709, 355, 3, 'CAJA 10 A. relacionados con el Empleo');
INSERT INTO `lang_definitions` VALUES (2710, 356, 3, 'CAJA 10 B. Accidentes de Autos');
INSERT INTO `lang_definitions` VALUES (2711, 357, 3, 'CAJA 10 C. Otros Accidentes');
INSERT INTO `lang_definitions` VALUES (2712, 358, 3, 'CAJA 16. Fecha incapaz de trabajar apartir de (aaaa-mm-dd):');
INSERT INTO `lang_definitions` VALUES (2713, 359, 3, 'CAJA 16. Fecha incapaz de trabajar (aaaa-mm-dd):');
INSERT INTO `lang_definitions` VALUES (2714, 360, 3, 'CAJA 18. Fecha a partir de la hospitalización (aaaa-mm-dd):');
INSERT INTO `lang_definitions` VALUES (2715, 361, 3, 'CAJA 18. Fecha de la hospitalización a (aaaa-mm-dd):');
INSERT INTO `lang_definitions` VALUES (2716, 362, 3, 'CAJA 20. Fuera del laboratorio se utilizan?');
INSERT INTO `lang_definitions` VALUES (2717, 363, 3, 'CAJA 22. Código de la resumisión de Medicaid (ICD-9) ');
INSERT INTO `lang_definitions` VALUES (2718, 364, 3, 'CAJA 23. Autorización previa No.');
INSERT INTO `lang_definitions` VALUES (2719, 366, 3, 'BP Diastólico ');
INSERT INTO `lang_definitions` VALUES (2720, 367, 3, 'BP Sistólica ');
INSERT INTO `lang_definitions` VALUES (2721, 368, 3, 'Bpd');
INSERT INTO `lang_definitions` VALUES (2722, 369, 3, 'Bps');
INSERT INTO `lang_definitions` VALUES (2723, 370, 3, 'Portugués brasileño');
INSERT INTO `lang_definitions` VALUES (2724, 371, 3, 'Pecho ');
INSERT INTO `lang_definitions` VALUES (2725, 372, 3, 'Biopsia del Pecho ');
INSERT INTO `lang_definitions` VALUES (2726, 373, 3, 'Descarga del Pecho ');
INSERT INTO `lang_definitions` VALUES (2727, 374, 3, 'Enfermedad de Pecho');
INSERT INTO `lang_definitions` VALUES (2728, 375, 3, 'Revisión mama');
INSERT INTO `lang_definitions` VALUES (2729, 376, 3, 'Masa del Pecho');
INSERT INTO `lang_definitions` VALUES (2730, 377, 3, 'Sonidos respiratorios: ');
INSERT INTO `lang_definitions` VALUES (2731, 378, 3, 'Huesos fracturados');
INSERT INTO `lang_definitions` VALUES (2732, 379, 3, 'Fortmulario broncitis');
INSERT INTO `lang_definitions` VALUES (2733, 380, 3, 'Explorar');
INSERT INTO `lang_definitions` VALUES (2734, 381, 3, 'Explorar para Registro');
INSERT INTO `lang_definitions` VALUES (2735, 382, 3, 'Contusiones/Hematomas');
INSERT INTO `lang_definitions` VALUES (2736, 383, 3, 'Bombear a la derecha:');
INSERT INTO `lang_definitions` VALUES (2737, 384, 3, 'Quema al orinar');
INSERT INTO `lang_definitions` VALUES (2738, 385, 3, 'Quema al orinar');
INSERT INTO `lang_definitions` VALUES (2739, 386, 3, 'Ocupado');
INSERT INTO `lang_definitions` VALUES (2740, 387, 3, 'Nalga + S.I.');
INSERT INTO `lang_definitions` VALUES (2741, 388, 3, 'por');
INSERT INTO `lang_definitions` VALUES (2742, 389, 3, 'por boca');
INSERT INTO `lang_definitions` VALUES (2743, 390, 3, 'Por / Fuente');
INSERT INTO `lang_definitions` VALUES (2744, 391, 3, 'Por:');
INSERT INTO `lang_definitions` VALUES (2745, 392, 3, 'C');
INSERT INTO `lang_definitions` VALUES (2746, 393, 3, 'Tiempo de Vida del Cache (en segundos)');
INSERT INTO `lang_definitions` VALUES (2747, 394, 3, '¿Salida de la plantilla del escondrijo?');
INSERT INTO `lang_definitions` VALUES (2748, 395, 3, 'Consumo de cafeína');
INSERT INTO `lang_definitions` VALUES (2749, 396, 3, 'Calendario');
INSERT INTO `lang_definitions` VALUES (2750, 397, 3, 'Ajustes del calendario');
INSERT INTO `lang_definitions` VALUES (2751, 398, 3, 'Calendario UI');
INSERT INTO `lang_definitions` VALUES (2752, 399, 3, 'Ver calendario');
INSERT INTO `lang_definitions` VALUES (2753, 400, 3, 'Llamado a añadir Forma () va aqui <br>');
INSERT INTO `lang_definitions` VALUES (2754, 402, 3, 'CAMOS');
INSERT INTO `lang_definitions` VALUES (2755, 403, 3, 'Cancelar');
INSERT INTO `lang_definitions` VALUES (2756, 404, 3, 'Cáncer');
INSERT INTO `lang_definitions` VALUES (2757, 405, 3, 'No se puede agregar esta entrada, por que ya existe!');
INSERT INTO `lang_definitions` VALUES (2758, 406, 3, '¡No puede agregar/actualización esta entrada porque existe un duplicado ya!');
INSERT INTO `lang_definitions` VALUES (2759, 407, 3, 'no puede convertirse a JPEG. ¿probablemente ImageMagick no está instalado?');
INSERT INTO `lang_definitions` VALUES (2760, 408, 3, 'no puede ser exhibido en línea porque su tipo no es apoyado por el hojeador.');
INSERT INTO `lang_definitions` VALUES (2761, 409, 3, 'no puede ser exhibido en línea porque su tipo no es apoyado por el hojeador');
INSERT INTO `lang_definitions` VALUES (2762, 410, 3, 'no puede ser exhibido en línea porque su tipo no es apoyado por el hojeador.');
INSERT INTO `lang_definitions` VALUES (2763, 411, 3, 'No se puede crear');
INSERT INTO `lang_definitions` VALUES (2764, 412, 3, 'No se encuentra');
INSERT INTO `lang_definitions` VALUES (2765, 413, 3, 'No puede encontrar al paciente de la identificación del cliente del SQL-Libro mayor');
INSERT INTO `lang_definitions` VALUES (2766, 414, 3, 'No se puede encontrar el documento de referencia de postdata en');
INSERT INTO `lang_definitions` VALUES (2767, 415, 3, 'No puede encontrar el abastecedor del empleado del SQL-Libro mayor =');
INSERT INTO `lang_definitions` VALUES (2768, 416, 3, 'No se puede abrir');
INSERT INTO `lang_definitions` VALUES (2769, 417, 3, 'No se puede leer ');
INSERT INTO `lang_definitions` VALUES (2770, 418, 3, 'No se puede actualizar porque no estás editando una entrada que ya exista.');
INSERT INTO `lang_definitions` VALUES (2771, 419, 3, 'pastilla');
INSERT INTO `lang_definitions` VALUES (2772, 420, 3, 'Cateterismo Cardiaco');
INSERT INTO `lang_definitions` VALUES (2773, 421, 3, 'Eco cardiaco');
INSERT INTO `lang_definitions` VALUES (2774, 422, 3, 'Cardiovascular');
INSERT INTO `lang_definitions` VALUES (2775, 423, 3, 'Daño de cartílago, condral o del disco articular.');
INSERT INTO `lang_definitions` VALUES (2776, 424, 3, 'Lesión de cartílago');
INSERT INTO `lang_definitions` VALUES (2777, 425, 3, 'Nl Cartoid pulsaciones, pedal de pulsos nl');
INSERT INTO `lang_definitions` VALUES (2778, 426, 3, 'efectivo');
INSERT INTO `lang_definitions` VALUES (2779, 427, 3, 'Efectivo');
INSERT INTO `lang_definitions` VALUES (2780, 428, 3, 'Recibos Efectivo');
INSERT INTO `lang_definitions` VALUES (2781, 429, 3, 'Recibos de efectivo de Proveedor');
INSERT INTO `lang_definitions` VALUES (2782, 430, 3, 'Cirugía de cataratas');
INSERT INTO `lang_definitions` VALUES (2783, 431, 3, 'Cataratas');
INSERT INTO `lang_definitions` VALUES (2784, 432, 3, 'Categorías');
INSERT INTO `lang_definitions` VALUES (2785, 433, 3, 'Categoría');
INSERT INTO `lang_definitions` VALUES (2786, 434, 3, 'categoría');
INSERT INTO `lang_definitions` VALUES (2787, 435, 3, 'Categoría');
INSERT INTO `lang_definitions` VALUES (2788, 436, 3, 'Detalles de categoría');
INSERT INTO `lang_definitions` VALUES (2789, 437, 3, 'Límites de categoría');
INSERT INTO `lang_definitions` VALUES (2790, 438, 3, 'Nombre de categoría');
INSERT INTO `lang_definitions` VALUES (2791, 439, 3, 'Caucásico ');
INSERT INTO `lang_definitions` VALUES (2792, 440, 3, 'Teléfono celular ');
INSERT INTO `lang_definitions` VALUES (2793, 441, 3, 'Numero de movil');
INSERT INTO `lang_definitions` VALUES (2794, 442, 3, 'Certificación central');
INSERT INTO `lang_definitions` VALUES (2795, 443, 3, 'cfirst($instype) . \' Ins');
INSERT INTO `lang_definitions` VALUES (2796, 444, 3, 'ChampUS');
INSERT INTO `lang_definitions` VALUES (2797, 445, 3, 'ChampUSVA');
INSERT INTO `lang_definitions` VALUES (2798, 446, 3, 'cambiar');
INSERT INTO `lang_definitions` VALUES (2799, 448, 3, 'Cambia actividad');
INSERT INTO `lang_definitions` VALUES (2800, 449, 3, 'Cambio en la visión ');
INSERT INTO `lang_definitions` VALUES (2801, 451, 3, 'Cambiado');
INSERT INTO `lang_definitions` VALUES (2802, 452, 3, 'Intestino Cambiado');
INSERT INTO `lang_definitions` VALUES (2803, 453, 3, 'Cobrar');
INSERT INTO `lang_definitions` VALUES (2804, 454, 3, 'Gastos');
INSERT INTO `lang_definitions` VALUES (2805, 455, 3, 'Historial');
INSERT INTO `lang_definitions` VALUES (2806, 456, 3, 'Gráfico de actividad');
INSERT INTO `lang_definitions` VALUES (2807, 457, 3, 'Informe historial de actividad de entradas y salidas');
INSERT INTO `lang_definitions` VALUES (2808, 458, 3, 'Identificación de la carta');
INSERT INTO `lang_definitions` VALUES (2809, 459, 3, 'Identicación de historial');
INSERT INTO `lang_definitions` VALUES (2810, 460, 3, 'Actividad de localización de historial');
INSERT INTO `lang_definitions` VALUES (2811, 461, 3, 'Identificación de la nota');
INSERT INTO `lang_definitions` VALUES (2812, 462, 3, 'Localizaciones de almacenaje de la carta');
INSERT INTO `lang_definitions` VALUES (2813, 463, 3, 'Rastreador de Historial');
INSERT INTO `lang_definitions` VALUES (2814, 464, 3, 'Gráfico de la Pista');
INSERT INTO `lang_definitions` VALUES (2815, 465, 3, 'Historiales comprobador');
INSERT INTO `lang_definitions` VALUES (2816, 466, 3, 'Cartas de salida');
INSERT INTO `lang_definitions` VALUES (2817, 467, 3, 'comprobar');
INSERT INTO `lang_definitions` VALUES (2818, 468, 3, 'Comprobar');
INSERT INTO `lang_definitions` VALUES (2819, 469, 3, 'Comprobar todo');
INSERT INTO `lang_definitions` VALUES (2820, 470, 3, 'Llegue a');
INSERT INTO `lang_definitions` VALUES (2821, 471, 3, 'Comprobar data insertado');
INSERT INTO `lang_definitions` VALUES (2822, 472, 3, 'Número de cheque');
INSERT INTO `lang_definitions` VALUES (2823, 473, 3, 'Comprobar Fecha /EOB:');
INSERT INTO `lang_definitions` VALUES (2824, 474, 3, 'Comprobar No EOB.:');
INSERT INTO `lang_definitions` VALUES (2825, 475, 3, 'Comprobar/número de referencia');
INSERT INTO `lang_definitions` VALUES (2826, 476, 3, 'Comprobar/Número de referencia');
INSERT INTO `lang_definitions` VALUES (2827, 478, 3, 'lista de verificación');
INSERT INTO `lang_definitions` VALUES (2828, 479, 3, 'Casilla con Texto');
INSERT INTO `lang_definitions` VALUES (2829, 481, 3, 'Casilla con tic = sí, vacio = no');
INSERT INTO `lang_definitions` VALUES (2830, 482, 3, 'Comprobación');
INSERT INTO `lang_definitions` VALUES (2831, 483, 3, 'Pecho');
INSERT INTO `lang_definitions` VALUES (2832, 484, 3, 'Pecho CTAB');
INSERT INTO `lang_definitions` VALUES (2833, 485, 3, 'Dolor de Pecho');
INSERT INTO `lang_definitions` VALUES (2834, 486, 3, 'Dolor en Pecho:');
INSERT INTO `lang_definitions` VALUES (2835, 487, 3, 'Dolores en el pecho');
INSERT INTO `lang_definitions` VALUES (2836, 488, 3, 'Var');
INSERT INTO `lang_definitions` VALUES (2837, 490, 3, 'Niño');
INSERT INTO `lang_definitions` VALUES (2838, 491, 3, 'Escalofríos');
INSERT INTO `lang_definitions` VALUES (2839, 492, 3, 'Chino');
INSERT INTO `lang_definitions` VALUES (2840, 493, 3, 'Opciones');
INSERT INTO `lang_definitions` VALUES (2841, 494, 3, 'Colecistectomía');
INSERT INTO `lang_definitions` VALUES (2842, 495, 3, 'Colecistectomía');
INSERT INTO `lang_definitions` VALUES (2843, 496, 3, 'Elegir ');
INSERT INTO `lang_definitions` VALUES (2844, 497, 3, 'Elige una sección y pincha un elemento dentro de ella; luego, en la otra sección, verás remarcados los elementos relacionados y puedes pinchar en esa sección para añadir y borrar relaciones.');
INSERT INTO `lang_definitions` VALUES (2845, 500, 3, 'Bronquitis crónica');
INSERT INTO `lang_definitions` VALUES (2846, 501, 3, 'Dolor crónico Mixto');
INSERT INTO `lang_definitions` VALUES (2847, 502, 3, 'Sinovitis crónica/derrame/dolor articular/gota');
INSERT INTO `lang_definitions` VALUES (2848, 503, 3, 'Crónico/recurrente');
INSERT INTO `lang_definitions` VALUES (2849, 504, 3, 'Cirrosis del hígado');
INSERT INTO `lang_definitions` VALUES (2850, 505, 3, 'Cirrosis del Hígado ');
INSERT INTO `lang_definitions` VALUES (2851, 506, 3, 'Ciudad');
INSERT INTO `lang_definitions` VALUES (2852, 507, 3, 'Nombre de Ciudad');
INSERT INTO `lang_definitions` VALUES (2853, 508, 3, 'Ciudad, Estado');
INSERT INTO `lang_definitions` VALUES (2854, 509, 3, 'Ciudad, Estado código postal');
INSERT INTO `lang_definitions` VALUES (2855, 510, 3, 'Ciudad/Estado');
INSERT INTO `lang_definitions` VALUES (2856, 512, 3, 'Reclamar');
INSERT INTO `lang_definitions` VALUES (2857, 513, 3, 'La prueva demandada ha terminado');
INSERT INTO `lang_definitions` VALUES (2858, 514, 3, 'Reclamación se ha generado para el archivo');
INSERT INTO `lang_definitions` VALUES (2859, 515, 3, 'Clasificación');
INSERT INTO `lang_definitions` VALUES (2860, 516, 3, 'Borrar');
INSERT INTO `lang_definitions` VALUES (2861, 517, 3, 'Borrar todos');
INSERT INTO `lang_definitions` VALUES (2862, 518, 3, 'Borrar justificación');
INSERT INTO `lang_definitions` VALUES (2863, 519, 3, 'Borrar Cache Smarty');
INSERT INTO `lang_definitions` VALUES (2864, 520, 3, 'Num CLIA');
INSERT INTO `lang_definitions` VALUES (2865, 521, 3, 'Pinchar');
INSERT INTO `lang_definitions` VALUES (2866, 523, 3, 'Pinchar para más');
INSERT INTO `lang_definitions` VALUES (2867, 524, 3, 'Pinchar aquí para elegir fecha');
INSERT INTO `lang_definitions` VALUES (2868, 525, 3, 'pinchar aquí para actualizar prioridad, categoría y apodos');
INSERT INTO `lang_definitions` VALUES (2869, 526, 3, 'pinchar aquí para ver todos.');
INSERT INTO `lang_definitions` VALUES (2870, 527, 3, 'Pinchar para bajar');
INSERT INTO `lang_definitions` VALUES (2871, 528, 3, 'Pinchar para corregir');
INSERT INTO `lang_definitions` VALUES (2872, 530, 3, 'Pinchar para generar un informe');
INSERT INTO `lang_definitions` VALUES (2873, 531, 3, 'Pinchar para imprimir');
INSERT INTO `lang_definitions` VALUES (2874, 532, 3, 'Clic aquí para recibir (añadir) nuevo lote ');
INSERT INTO `lang_definitions` VALUES (2875, 533, 3, 'Pinchar para seleccionar');
INSERT INTO `lang_definitions` VALUES (2876, 534, 3, 'Pinchar para selccionar o cambiar diagnóstico');
INSERT INTO `lang_definitions` VALUES (2877, 535, 3, 'Pinchar para seleccionar paciente');
INSERT INTO `lang_definitions` VALUES (2878, 536, 3, 'Pinchar para seleccionar código relacionado');
INSERT INTO `lang_definitions` VALUES (2879, 538, 3, 'Pinchar para ver o para corregir');
INSERT INTO `lang_definitions` VALUES (2880, 539, 3, 'Clic para ver/editar');
INSERT INTO `lang_definitions` VALUES (2881, 540, 3, 'Pinchar:');
INSERT INTO `lang_definitions` VALUES (2882, 542, 3, 'Resumen de historia clínica del cliente ');
INSERT INTO `lang_definitions` VALUES (2883, 543, 3, 'Perfil de cliente - Nuevos Clientes');
INSERT INTO `lang_definitions` VALUES (2884, 544, 3, 'Perfil de cliente - Único Clientes');
INSERT INTO `lang_definitions` VALUES (2885, 545, 3, 'Clientes');
INSERT INTO `lang_definitions` VALUES (2886, 546, 3, 'Clínica');
INSERT INTO `lang_definitions` VALUES (2887, 548, 3, 'Informe diario de la clínica');
INSERT INTO `lang_definitions` VALUES (2888, 549, 3, 'Identificación de la clínica ');
INSERT INTO `lang_definitions` VALUES (2889, 550, 3, 'Clínicos');
INSERT INTO `lang_definitions` VALUES (2890, 553, 3, 'Cerrar');
INSERT INTO `lang_definitions` VALUES (2891, 554, 3, 'cerrar ventana');
INSERT INTO `lang_definitions` VALUES (2892, 555, 3, 'Cerrado');
INSERT INTO `lang_definitions` VALUES (2893, 556, 3, 'cm');
INSERT INTO `lang_definitions` VALUES (2894, 558, 3, 'CMS ID');
INSERT INTO `lang_definitions` VALUES (2895, 559, 3, 'CN2-12 Intacto');
INSERT INTO `lang_definitions` VALUES (2896, 560, 3, 'Código');
INSERT INTO `lang_definitions` VALUES (2897, 561, 3, 'código');
INSERT INTO `lang_definitions` VALUES (2898, 562, 3, 'Buscador de código');
INSERT INTO `lang_definitions` VALUES (2899, 563, 3, 'Código debe ser 2 letras en minúscula');
INSERT INTO `lang_definitions` VALUES (2900, 564, 3, 'tipo de código');
INSERT INTO `lang_definitions` VALUES (2901, 565, 3, 'Códigos');
INSERT INTO `lang_definitions` VALUES (2902, 566, 3, 'Codificando');
INSERT INTO `lang_definitions` VALUES (2903, 567, 3, 'Codificación - cualquier encuentros (escribir, con algunas opcional) ');
INSERT INTO `lang_definitions` VALUES (2904, 568, 3, 'Codificación - mis encuentros (escribir, con algunas opcional) ');
INSERT INTO `lang_definitions` VALUES (2905, 569, 3, 'Codificación no autorizadas');
INSERT INTO `lang_definitions` VALUES (2906, 570, 3, 'Café');
INSERT INTO `lang_definitions` VALUES (2907, 571, 3, 'Coll w/o');
INSERT INTO `lang_definitions` VALUES (2908, 572, 3, 'cerrar todos');
INSERT INTO `lang_definitions` VALUES (2909, 573, 3, 'Colecciones');
INSERT INTO `lang_definitions` VALUES (2910, 574, 3, 'Informe de recogidas');
INSERT INTO `lang_definitions` VALUES (2911, 575, 3, 'Cáncer de colon');
INSERT INTO `lang_definitions` VALUES (2912, 576, 3, 'Cirugía del cáncer de colon');
INSERT INTO `lang_definitions` VALUES (2913, 577, 3, 'Colonoscopia');
INSERT INTO `lang_definitions` VALUES (2914, 578, 3, 'colonoscopia');
INSERT INTO `lang_definitions` VALUES (2915, 579, 3, 'Color');
INSERT INTO `lang_definitions` VALUES (2916, 580, 3, 'Columnas');
INSERT INTO `lang_definitions` VALUES (2917, 581, 3, 'Comentarios');
INSERT INTO `lang_definitions` VALUES (2918, 582, 3, 'Compañía Aseguradora');
INSERT INTO `lang_definitions` VALUES (2919, 583, 3, 'Cometer cambios');
INSERT INTO `lang_definitions` VALUES (2920, 584, 3, 'Comunicaciones');
INSERT INTO `lang_definitions` VALUES (2921, 585, 3, 'Completado');
INSERT INTO `lang_definitions` VALUES (2922, 586, 3, 'Conplicaciones por el servicio proveedor');
INSERT INTO `lang_definitions` VALUES (2923, 587, 3, 'Complicaciones de aborto');
INSERT INTO `lang_definitions` VALUES (2924, 588, 3, 'Sistema de órdenes médicas asistido informáticamente');
INSERT INTO `lang_definitions` VALUES (2925, 589, 3, 'Conclusiones ');
INSERT INTO `lang_definitions` VALUES (2926, 590, 3, 'Congénito');
INSERT INTO `lang_definitions` VALUES (2927, 591, 3, 'Conjuntiva, pupilas');
INSERT INTO `lang_definitions` VALUES (2928, 593, 3, 'Nombre constante');
INSERT INTO `lang_definitions` VALUES (2929, 594, 3, 'Constantes');
INSERT INTO `lang_definitions` VALUES (2930, 595, 3, 'Estreñimiento ');
INSERT INTO `lang_definitions` VALUES (2931, 596, 3, 'Constitucional ');
INSERT INTO `lang_definitions` VALUES (2932, 597, 3, 'Breve descripción de consulta');
INSERT INTO `lang_definitions` VALUES (2933, 598, 3, 'Contacto');
INSERT INTO `lang_definitions` VALUES (2934, 599, 3, 'Dirección correo electrónico del contacto');
INSERT INTO `lang_definitions` VALUES (2935, 600, 3, 'Dirección de correo electrónico de contacto ');
INSERT INTO `lang_definitions` VALUES (2936, 602, 3, 'Lentes de contacto');
INSERT INTO `lang_definitions` VALUES (2937, 603, 3, 'Nombre del contacto');
INSERT INTO `lang_definitions` VALUES (2938, 604, 3, 'Persona de contacto');
INSERT INTO `lang_definitions` VALUES (2939, 605, 3, 'Número de teléfono del contacto');
INSERT INTO `lang_definitions` VALUES (2940, 606, 3, 'Contenido');
INSERT INTO `lang_definitions` VALUES (2941, 607, 3, 'contenido');
INSERT INTO `lang_definitions` VALUES (2942, 608, 3, 'Continuar');
INSERT INTO `lang_definitions` VALUES (2943, 609, 3, 'Contra Clientes');
INSERT INTO `lang_definitions` VALUES (2944, 610, 3, 'Contracepción');
INSERT INTO `lang_definitions` VALUES (2945, 611, 3, 'Temas anticonceptivos');
INSERT INTO `lang_definitions` VALUES (2946, 612, 3, 'Complicación anticonceptivos (especificar)');
INSERT INTO `lang_definitions` VALUES (2947, 613, 3, 'Método anticonceptivo');
INSERT INTO `lang_definitions` VALUES (2948, 614, 3, 'Servicios anticonceptivos ya empezados');
INSERT INTO `lang_definitions` VALUES (2949, 615, 3, 'Comienzo de anticonceptivos ');
INSERT INTO `lang_definitions` VALUES (2950, 616, 3, 'N º de control ');
INSERT INTO `lang_definitions` VALUES (2951, 617, 3, 'Copago');
INSERT INTO `lang_definitions` VALUES (2952, 618, 3, 'CoPago');
INSERT INTO `lang_definitions` VALUES (2953, 620, 3, 'Copagos');
INSERT INTO `lang_definitions` VALUES (2954, 621, 3, 'COPD');
INSERT INTO `lang_definitions` VALUES (2955, 622, 3, 'Copiar páginas al historial del paciente');
INSERT INTO `lang_definitions` VALUES (2956, 623, 3, 'Copiar valores');
INSERT INTO `lang_definitions` VALUES (2957, 624, 3, 'Anuncio de copyright');
INSERT INTO `lang_definitions` VALUES (2958, 625, 3, 'Bypass coronario arterial');
INSERT INTO `lang_definitions` VALUES (2959, 626, 3, 'Tos');
INSERT INTO `lang_definitions` VALUES (2960, 627, 3, 'Tos:');
INSERT INTO `lang_definitions` VALUES (2961, 628, 3, 'Correo no salió por problema con servidor,');
INSERT INTO `lang_definitions` VALUES (2962, 633, 3, 'Couns por el Método');
INSERT INTO `lang_definitions` VALUES (2963, 634, 3, 'Aconsejando');
INSERT INTO `lang_definitions` VALUES (2964, 635, 3, 'Actividades de asesoramiento');
INSERT INTO `lang_definitions` VALUES (2965, 636, 3, 'CONTADOR DE REMISIÓN');
INSERT INTO `lang_definitions` VALUES (2966, 637, 3, 'Contador-Remisión ');
INSERT INTO `lang_definitions` VALUES (2967, 638, 3, 'País');
INSERT INTO `lang_definitions` VALUES (2968, 639, 3, 'Lista del país (escriba, addonly opcional) ');
INSERT INTO `lang_definitions` VALUES (2969, 640, 3, 'condado');
INSERT INTO `lang_definitions` VALUES (2970, 641, 3, 'Cupón');
INSERT INTO `lang_definitions` VALUES (2971, 642, 3, 'CPT');
INSERT INTO `lang_definitions` VALUES (2972, 643, 3, 'Codigo CPT');
INSERT INTO `lang_definitions` VALUES (2973, 644, 3, 'Crujidos, crepitaciones');
INSERT INTO `lang_definitions` VALUES (2974, 645, 3, 'nata');
INSERT INTO `lang_definitions` VALUES (2975, 646, 3, 'Crear un evento');
INSERT INTO `lang_definitions` VALUES (2976, 649, 3, 'Crear paciente nuevo');
INSERT INTO `lang_definitions` VALUES (2977, 650, 3, 'Crear nota de paciente');
INSERT INTO `lang_definitions` VALUES (2978, 651, 3, 'Creado');
INSERT INTO `lang_definitions` VALUES (2979, 653, 3, 'crédito');
INSERT INTO `lang_definitions` VALUES (2980, 654, 3, 'Créditos');
INSERT INTO `lang_definitions` VALUES (2981, 655, 3, 'Enfermedad de Crohn');
INSERT INTO `lang_definitions` VALUES (2982, 656, 3, 'Enfermedad de Crohns ');
INSERT INTO `lang_definitions` VALUES (2983, 657, 3, 'Archivo de CSV ');
INSERT INTO `lang_definitions` VALUES (2984, 658, 3, 'Actual');
INSERT INTO `lang_definitions` VALUES (2985, 659, 3, 'Consulta actual ');
INSERT INTO `lang_definitions` VALUES (2986, 660, 3, 'Color resaltado del presente día');
INSERT INTO `lang_definitions` VALUES (2987, 661, 3, 'El nombre de fichero actual fue cambiado a ');
INSERT INTO `lang_definitions` VALUES (2988, 662, 3, 'Localización actual ');
INSERT INTO `lang_definitions` VALUES (2989, 663, 3, 'Actual Paciente');
INSERT INTO `lang_definitions` VALUES (2990, 664, 3, 'Actualmente activo');
INSERT INTO `lang_definitions` VALUES (2991, 665, 3, 'Síndrome de Cushing');
INSERT INTO `lang_definitions` VALUES (2992, 666, 3, 'Síndrome de Cushing');
INSERT INTO `lang_definitions` VALUES (2993, 667, 3, 'Costumbre');
INSERT INTO `lang_definitions` VALUES (2994, 669, 3, 'CYP');
INSERT INTO `lang_definitions` VALUES (2995, 670, 3, 'Factor de CYP');
INSERT INTO `lang_definitions` VALUES (2996, 671, 3, 'Informe de CYP');
INSERT INTO `lang_definitions` VALUES (2997, 672, 3, 'D');
INSERT INTO `lang_definitions` VALUES (2998, 673, 3, 'D&C');
INSERT INTO `lang_definitions` VALUES (2999, 674, 3, 'D&E');
INSERT INTO `lang_definitions` VALUES (3000, 675, 3, 'F.D.N.');
INSERT INTO `lang_definitions` VALUES (3001, 676, 3, 'diariamente');
INSERT INTO `lang_definitions` VALUES (3002, 677, 3, 'Información parecida está ya en la base de datos, por favor cambie el código o la descripción');
INSERT INTO `lang_definitions` VALUES (3003, 679, 3, 'Datos Cols');
INSERT INTO `lang_definitions` VALUES (3004, 680, 3, 'Tipo de datos');
INSERT INTO `lang_definitions` VALUES (3005, 681, 3, 'base de datos');
INSERT INTO `lang_definitions` VALUES (3006, 682, 3, 'Información de la base de datos ');
INSERT INTO `lang_definitions` VALUES (3007, 683, 3, 'DataCols debe ser un número entre 1 y 999 ');
INSERT INTO `lang_definitions` VALUES (3008, 684, 3, 'Fecha');
INSERT INTO `lang_definitions` VALUES (3009, 685, 3, 'FECHA');
INSERT INTO `lang_definitions` VALUES (3010, 686, 3, 'Fecha adminstrada');
INSERT INTO `lang_definitions` VALUES (3011, 687, 3, 'Servicios anticonceptivos de la fecha prevista inicialmente ');
INSERT INTO `lang_definitions` VALUES (3012, 688, 3, 'Fecha destruída');
INSERT INTO `lang_definitions` VALUES (3013, 689, 3, 'Formato de muestra de fecha');
INSERT INTO `lang_definitions` VALUES (3014, 690, 3, 'Formato fecha para última cita no es válido');
INSERT INTO `lang_definitions` VALUES (3015, 691, 3, 'Formato fecha para primera cita no es válido');
INSERT INTO `lang_definitions` VALUES (3016, 692, 3, 'Formato fecha para \'Próxima Cita\' no es válida');
INSERT INTO `lang_definitions` VALUES (3017, 693, 3, 'Formato fecha para \'no visto desde\' no es válido');
INSERT INTO `lang_definitions` VALUES (3018, 694, 3, 'Formato fecha para \'visto desde\' no es válido');
INSERT INTO `lang_definitions` VALUES (3019, 695, 3, 'Comunicados de información de la inmunidad de fecha entregados');
INSERT INTO `lang_definitions` VALUES (3020, 696, 3, 'Falta fecha para código');
INSERT INTO `lang_definitions` VALUES (3021, 697, 3, 'Fecha ingreso en banco aaaa-mm-dd');
INSERT INTO `lang_definitions` VALUES (3022, 698, 3, 'Fecha de nacimiento');
INSERT INTO `lang_definitions` VALUES (3023, 699, 3, 'Fecha de nacimiento');
INSERT INTO `lang_definitions` VALUES (3024, 700, 3, 'Fecha de la lesión');
INSERT INTO `lang_definitions` VALUES (3025, 701, 3, 'Fecha de pago aaaa-mm-dd');
INSERT INTO `lang_definitions` VALUES (3026, 702, 3, 'Fecha de remisión');
INSERT INTO `lang_definitions` VALUES (3027, 703, 3, 'Fecha de la respuesta');
INSERT INTO `lang_definitions` VALUES (3028, 704, 3, 'Fecha De Servicio');
INSERT INTO `lang_definitions` VALUES (3029, 705, 3, 'Fecha de servicio mm/dd/aaaa');
INSERT INTO `lang_definitions` VALUES (3030, 706, 3, 'Fecha de Servicio:');
INSERT INTO `lang_definitions` VALUES (3031, 708, 3, 'Fecha de la Declaración de VIS');
INSERT INTO `lang_definitions` VALUES (3032, 710, 3, 'Fecha/Notas');
INSERT INTO `lang_definitions` VALUES (3033, 711, 3, 'Fecha/Notas de Último');
INSERT INTO `lang_definitions` VALUES (3034, 712, 3, 'Fecha:');
INSERT INTO `lang_definitions` VALUES (3035, 713, 3, 'dia');
INSERT INTO `lang_definitions` VALUES (3036, 714, 3, 'Día');
INSERT INTO `lang_definitions` VALUES (3037, 715, 3, 'Vista de día');
INSERT INTO `lang_definitions` VALUES (3038, 716, 3, 'Día(s)');
INSERT INTO `lang_definitions` VALUES (3039, 717, 3, 'Día(s) L-V');
INSERT INTO `lang_definitions` VALUES (3040, 718, 3, 'días');
INSERT INTO `lang_definitions` VALUES (3041, 719, 3, 'Días');
INSERT INTO `lang_definitions` VALUES (3042, 720, 3, 'Dïas y juegos perdidos');
INSERT INTO `lang_definitions` VALUES (3043, 721, 3, 'Días De Último Encuentro ');
INSERT INTO `lang_definitions` VALUES (3044, 722, 3, 'Días por columna');
INSERT INTO `lang_definitions` VALUES (3045, 723, 3, 'DB instalado');
INSERT INTO `lang_definitions` VALUES (3046, 724, 3, 'DEA');
INSERT INTO `lang_definitions` VALUES (3047, 725, 3, 'Elimine errores de la información');
INSERT INTO `lang_definitions` VALUES (3048, 726, 3, 'Diciembre');
INSERT INTO `lang_definitions` VALUES (3049, 727, 3, 'Defecto');
INSERT INTO `lang_definitions` VALUES (3050, 728, 3, 'Defecto de ver calendario');
INSERT INTO `lang_definitions` VALUES (3051, 729, 3, 'Defecto de Facilidad');
INSERT INTO `lang_definitions` VALUES (3052, 730, 3, 'Lista del defecto (escriba, sólo añadir opcional) ');
INSERT INTO `lang_definitions` VALUES (3053, 731, 3, 'Defecto por Método');
INSERT INTO `lang_definitions` VALUES (3054, 732, 3, 'Defecto por Proveedor ');
INSERT INTO `lang_definitions` VALUES (3055, 733, 3, 'Defecto de Plantilla');
INSERT INTO `lang_definitions` VALUES (3056, 734, 3, 'Defecto de valor');
INSERT INTO `lang_definitions` VALUES (3057, 735, 3, 'X12 por defecto para pareja');
INSERT INTO `lang_definitions` VALUES (3058, 736, 3, 'Defecto/Global');
INSERT INTO `lang_definitions` VALUES (3059, 738, 3, 'Repetición retrasada (> 12 Mo)');
INSERT INTO `lang_definitions` VALUES (3060, 739, 3, 'Eliminar');
INSERT INTO `lang_definitions` VALUES (3061, 740, 3, 'eliminar');
INSERT INTO `lang_definitions` VALUES (3062, 741, 3, 'Eliminar Categrorías con identificador(es) :');
INSERT INTO `lang_definitions` VALUES (3063, 742, 3, 'Eliminar Grupo');
INSERT INTO `lang_definitions` VALUES (3064, 743, 3, 'Eliminar Lista');
INSERT INTO `lang_definitions` VALUES (3065, 744, 3, 'Eliminar Páginas');
INSERT INTO `lang_definitions` VALUES (3066, 745, 3, 'Paciente, encuentro, forma, edición, documento, pago, facturación o transacción de la cancelación');
INSERT INTO `lang_definitions` VALUES (3067, 747, 3, 'Eliminar éxito. ');
INSERT INTO `lang_definitions` VALUES (3068, 748, 3, 'Eliminar este documento');
INSERT INTO `lang_definitions` VALUES (3069, 749, 3, 'Eliminar este formulario');
INSERT INTO `lang_definitions` VALUES (3070, 750, 3, 'Eliminar esta nota');
INSERT INTO `lang_definitions` VALUES (3071, 751, 3, 'Demencia ');
INSERT INTO `lang_definitions` VALUES (3072, 752, 3, 'Datos demográficos');
INSERT INTO `lang_definitions` VALUES (3073, 753, 3, 'Demografía (escribir, sólo añadir opcional) ');
INSERT INTO `lang_definitions` VALUES (3074, 754, 3, 'Datos demográficos no autorizados');
INSERT INTO `lang_definitions` VALUES (3075, 755, 3, 'Datos demográficos no autorizados');
INSERT INTO `lang_definitions` VALUES (3076, 756, 3, 'Dental');
INSERT INTO `lang_definitions` VALUES (3077, 757, 3, 'Ediciones Dentales ');
INSERT INTO `lang_definitions` VALUES (3078, 758, 3, 'Dependiendo del tipo de cuenta usted es prueba que usted verá HCFA como salida en una página en blanco para las cuentas de HCFA, usted verán muchas líneas de texto algo mutilado y la información si usted está probando una demanda X12. Ese texto mutilado es el formato del X12 IED 4010A. Usted verá de vez en cuando los caracteres impares que parecen dominós o squiglies, éstos es caracteres de control tales como alimentaciones de página y es normal.');
INSERT INTO `lang_definitions` VALUES (3079, 759, 3, 'Fecha del depósito');
INSERT INTO `lang_definitions` VALUES (3080, 760, 3, 'Depresivo');
INSERT INTO `lang_definitions` VALUES (3081, 761, 3, 'Depresión');
INSERT INTO `lang_definitions` VALUES (3082, 762, 3, 'Descripción');
INSERT INTO `lang_definitions` VALUES (3083, 763, 3, 'descripción');
INSERT INTO `lang_definitions` VALUES (3084, 764, 3, 'Traducción de la descripción ');
INSERT INTO `lang_definitions` VALUES (3085, 765, 3, 'Destino');
INSERT INTO `lang_definitions` VALUES (3086, 766, 3, 'Destruir todo el lote');
INSERT INTO `lang_definitions` VALUES (3087, 767, 3, 'Destruido ...');
INSERT INTO `lang_definitions` VALUES (3088, 768, 3, 'Destruido');
INSERT INTO `lang_definitions` VALUES (3089, 769, 3, 'Drogas destruidas');
INSERT INTO `lang_definitions` VALUES (3090, 770, 3, 'Informe drogas destruido');
INSERT INTO `lang_definitions` VALUES (3091, 771, 3, 'Detalles');
INSERT INTO `lang_definitions` VALUES (3092, 772, 3, 'Anormalidad del desarrollo');
INSERT INTO `lang_definitions` VALUES (3093, 773, 3, 'Diabetes');
INSERT INTO `lang_definitions` VALUES (3094, 774, 3, 'Diagnóstico');
INSERT INTO `lang_definitions` VALUES (3095, 775, 3, 'Diagnóstico');
INSERT INTO `lang_definitions` VALUES (3096, 776, 3, 'El diagnóstico debe ser codificada en un encuentro vinculado');
INSERT INTO `lang_definitions` VALUES (3097, 777, 3, 'Diagnóstico:');
INSERT INTO `lang_definitions` VALUES (3098, 778, 3, 'Diagnóstico:');
INSERT INTO `lang_definitions` VALUES (3099, 779, 3, 'Pruebas diagnósticas:');
INSERT INTO `lang_definitions` VALUES (3100, 780, 3, 'Diales');
INSERT INTO `lang_definitions` VALUES (3101, 781, 3, 'Diafragmas/Gorros');
INSERT INTO `lang_definitions` VALUES (3102, 782, 3, 'Diarrea ');
INSERT INTO `lang_definitions` VALUES (3103, 783, 3, 'Dictado');
INSERT INTO `lang_definitions` VALUES (3104, 784, 3, 'Dictado:');
INSERT INTO `lang_definitions` VALUES (3105, 785, 3, '¿Usted recibió una copia del aviso de HIPAA? ');
INSERT INTO `lang_definitions` VALUES (3106, 786, 3, 'Difuso:');
INSERT INTO `lang_definitions` VALUES (3107, 788, 3, 'Correo Directo');
INSERT INTO `lang_definitions` VALUES (3108, 789, 3, 'inhabilitación');
INSERT INTO `lang_definitions` VALUES (3109, 790, 3, 'inhabilitado');
INSERT INTO `lang_definitions` VALUES (3110, 791, 3, 'inhabilitado');
INSERT INTO `lang_definitions` VALUES (3111, 792, 3, 'DISCO');
INSERT INTO `lang_definitions` VALUES (3112, 793, 3, 'Descarga ');
INSERT INTO `lang_definitions` VALUES (3113, 794, 3, 'Pérdidas/secreciones de la uretra');
INSERT INTO `lang_definitions` VALUES (3114, 795, 3, 'Aprobación de la gestión Derecha');
INSERT INTO `lang_definitions` VALUES (3115, 796, 3, 'Aprobación de la gestión Derecha');
INSERT INTO `lang_definitions` VALUES (3116, 797, 3, 'Descuento');
INSERT INTO `lang_definitions` VALUES (3117, 798, 3, 'Suma de descuentos');
INSERT INTO `lang_definitions` VALUES (3118, 799, 3, 'Nivel del Descuento ');
INSERT INTO `lang_definitions` VALUES (3119, 800, 3, 'Enfermedad ');
INSERT INTO `lang_definitions` VALUES (3120, 801, 3, 'Dislocación');
INSERT INTO `lang_definitions` VALUES (3121, 802, 3, '# Disp ');
INSERT INTO `lang_definitions` VALUES (3122, 803, 3, 'Informe');
INSERT INTO `lang_definitions` VALUES (3123, 804, 3, 'Remitir documento recibido');
INSERT INTO `lang_definitions` VALUES (3124, 805, 3, 'Prescrito');
INSERT INTO `lang_definitions` VALUES (3125, 806, 3, '¿Mostrar fechas de eventos en bloque?');
INSERT INTO `lang_definitions` VALUES (3126, 807, 3, '¿Mostrar cuántos eventos?');
INSERT INTO `lang_definitions` VALUES (3127, 808, 3, '¿Mostrar lugar/sitio en bloque?');
INSERT INTO `lang_definitions` VALUES (3128, 809, 3, '¿Mostrar el calendario?');
INSERT INTO `lang_definitions` VALUES (3129, 810, 3, '¿Mostrar los eventos de hoy en la tabla?');
INSERT INTO `lang_definitions` VALUES (3130, 811, 3, '¿Mostrar tema en tabla?');
INSERT INTO `lang_definitions` VALUES (3131, 812, 3, '¿Mostrar los eventos próximos en tabla?');
INSERT INTO `lang_definitions` VALUES (3132, 813, 3, 'Distribución');
INSERT INTO `lang_definitions` VALUES (3133, 814, 3, 'Diverticulitis');
INSERT INTO `lang_definitions` VALUES (3134, 815, 3, 'Operación de Diverticulitis');
INSERT INTO `lang_definitions` VALUES (3135, 816, 3, 'Diverticulitis');
INSERT INTO `lang_definitions` VALUES (3136, 817, 3, 'Operación de Diverticulitis');
INSERT INTO `lang_definitions` VALUES (3137, 818, 3, 'Divorciado');
INSERT INTO `lang_definitions` VALUES (3138, 819, 3, 'Mareo:');
INSERT INTO `lang_definitions` VALUES (3139, 820, 3, 'no guardar');
INSERT INTO `lang_definitions` VALUES (3140, 821, 3, 'no sustituir');
INSERT INTO `lang_definitions` VALUES (3141, 823, 3, 'Estás seguro que quieres eliminar este grupo');
INSERT INTO `lang_definitions` VALUES (3142, 825, 3, '¿Usted desea continuar con el nuevo nombre? ');
INSERT INTO `lang_definitions` VALUES (3143, 826, 3, '¿Usted desea suprimir PERMANENTEMENTE este expediente de la inmunización? ');
INSERT INTO `lang_definitions` VALUES (3144, 827, 3, 'Fecha de nacimiento');
INSERT INTO `lang_definitions` VALUES (3145, 828, 3, 'Falta fecha de nacimiento, por favor insertarla al ser posible');
INSERT INTO `lang_definitions` VALUES (3146, 829, 3, 'Documentos');
INSERT INTO `lang_definitions` VALUES (3147, 831, 3, 'Médico:');
INSERT INTO `lang_definitions` VALUES (3148, 832, 3, 'Nombre del médico y la firma ');
INSERT INTO `lang_definitions` VALUES (3149, 833, 3, 'Documento');
INSERT INTO `lang_definitions` VALUES (3150, 834, 3, 'documento');
INSERT INTO `lang_definitions` VALUES (3151, 835, 3, 'Categorías documento');
INSERT INTO `lang_definitions` VALUES (3152, 836, 3, 'El documento no ha podido ser trasladado a la identificación del paciente');
INSERT INTO `lang_definitions` VALUES (3153, 837, 3, 'Fecha de documento');
INSERT INTO `lang_definitions` VALUES (3154, 838, 3, 'Fecha y edición del documento actualizadas con éxito ');
INSERT INTO `lang_definitions` VALUES (3155, 839, 3, 'Documento se trasladó a nueva categoría ');
INSERT INTO `lang_definitions` VALUES (3156, 840, 3, 'Documento de identificación del paciente se trasladó a ');
INSERT INTO `lang_definitions` VALUES (3157, 841, 3, 'Documento / Imágenes de tiendas');
INSERT INTO `lang_definitions` VALUES (3158, 842, 3, 'Documentos');
INSERT INTO `lang_definitions` VALUES (3159, 843, 3, 'Documentos (escribir, addonly opcional) ');
INSERT INTO `lang_definitions` VALUES (3160, 844, 3, 'DOE');
INSERT INTO `lang_definitions` VALUES (3161, 845, 3, 'Socio doméstico ');
INSERT INTO `lang_definitions` VALUES (3162, 846, 3, 'No Guardar ');
INSERT INTO `lang_definitions` VALUES (3163, 847, 3, 'No Guardar');
INSERT INTO `lang_definitions` VALUES (3164, 848, 3, 'No Guardar Cambios');
INSERT INTO `lang_definitions` VALUES (3165, 850, 3, 'Hecho con:');
INSERT INTO `lang_definitions` VALUES (3166, 852, 3, 'DOS');
INSERT INTO `lang_definitions` VALUES (3167, 853, 3, 'Dosis');
INSERT INTO `lang_definitions` VALUES (3168, 855, 3, 'Visión doble');
INSERT INTO `lang_definitions` VALUES (3169, 856, 3, 'Descargar expediente de factura, mandar a contabilidad y marcar como facturado.');
INSERT INTO `lang_definitions` VALUES (3170, 858, 3, 'Revisar médico');
INSERT INTO `lang_definitions` VALUES (3171, 859, 3, 'Visitar médico');
INSERT INTO `lang_definitions` VALUES (3172, 860, 3, 'Médico ');
INSERT INTO `lang_definitions` VALUES (3173, 861, 3, 'Goteo ');
INSERT INTO `lang_definitions` VALUES (3174, 862, 3, 'Licencia de Manejar o Identificación del Estado ');
INSERT INTO `lang_definitions` VALUES (3175, 863, 3, 'Medicamento');
INSERT INTO `lang_definitions` VALUES (3176, 864, 3, 'Formularios de Medicamento');
INSERT INTO `lang_definitions` VALUES (3177, 865, 3, 'Identificación de la droga estan desaparecidos!');
INSERT INTO `lang_definitions` VALUES (3178, 866, 3, 'Intervalos de Medicamento');
INSERT INTO `lang_definitions` VALUES (3179, 867, 3, 'Inventorio de Medicamento');
INSERT INTO `lang_definitions` VALUES (3180, 868, 3, 'Nombre del Medicamento');
INSERT INTO `lang_definitions` VALUES (3181, 869, 3, 'Rutas de Medicamento');
INSERT INTO `lang_definitions` VALUES (3182, 870, 3, 'Unidades de Medicamento');
INSERT INTO `lang_definitions` VALUES (3183, 871, 3, 'Medicamentos');
INSERT INTO `lang_definitions` VALUES (3184, 872, 3, 'Boca seca');
INSERT INTO `lang_definitions` VALUES (3185, 873, 3, 'DT 1');
INSERT INTO `lang_definitions` VALUES (3186, 874, 3, 'DT 2');
INSERT INTO `lang_definitions` VALUES (3187, 875, 3, 'DT 3');
INSERT INTO `lang_definitions` VALUES (3188, 876, 3, 'DT 4');
INSERT INTO `lang_definitions` VALUES (3189, 877, 3, 'DT 5');
INSERT INTO `lang_definitions` VALUES (3190, 878, 3, 'DTaP 1');
INSERT INTO `lang_definitions` VALUES (3191, 879, 3, 'DTaP 2');
INSERT INTO `lang_definitions` VALUES (3192, 880, 3, 'DTaP 3');
INSERT INTO `lang_definitions` VALUES (3193, 881, 3, 'DTaP 4');
INSERT INTO `lang_definitions` VALUES (3194, 882, 3, 'DTaP 5');
INSERT INTO `lang_definitions` VALUES (3195, 883, 3, 'Fecha del parto');
INSERT INTO `lang_definitions` VALUES (3196, 884, 3, 'Fecha del parto mm/dd/aaaa o aaaa-mm-dd');
INSERT INTO `lang_definitions` VALUES (3197, 885, 3, 'Fecha del parto:');
INSERT INTO `lang_definitions` VALUES (3198, 886, 3, 'Deuda Seguro');
INSERT INTO `lang_definitions` VALUES (3199, 887, 3, 'Deuda Paciente');
INSERT INTO `lang_definitions` VALUES (3200, 888, 3, 'Vaciar OpenEMR base de datos');
INSERT INTO `lang_definitions` VALUES (3201, 889, 3, 'Vaciar OpenEMR web de árbol de directorios ');
INSERT INTO `lang_definitions` VALUES (3202, 890, 3, 'Vaciar phpGACL base de datos');
INSERT INTO `lang_definitions` VALUES (3203, 891, 3, 'Vaciar phpGACL web de árbol de directorios ');
INSERT INTO `lang_definitions` VALUES (3204, 892, 3, 'Vaciar SQL-Ledger base de datos');
INSERT INTO `lang_definitions` VALUES (3205, 893, 3, 'Vaciar phpGACL web de árbol de directorios ');
INSERT INTO `lang_definitions` VALUES (3206, 895, 3, 'duración');
INSERT INTO `lang_definitions` VALUES (3207, 896, 3, 'Duración');
INSERT INTO `lang_definitions` VALUES (3208, 897, 3, 'Holandés');
INSERT INTO `lang_definitions` VALUES (3209, 898, 3, 'Disfagia ');
INSERT INTO `lang_definitions` VALUES (3210, 899, 3, 'Disnea');
INSERT INTO `lang_definitions` VALUES (3211, 900, 3, 'Disuria ');
INSERT INTO `lang_definitions` VALUES (3212, 901, 3, 'Repetición Temprana (<2 Mo)');
INSERT INTO `lang_definitions` VALUES (3213, 902, 3, 'Orejas ');
INSERT INTO `lang_definitions` VALUES (3214, 903, 3, 'Electrocardiograma');
INSERT INTO `lang_definitions` VALUES (3215, 904, 3, 'Edema');
INSERT INTO `lang_definitions` VALUES (3216, 905, 3, 'Editar');
INSERT INTO `lang_definitions` VALUES (3217, 906, 3, 'Editar alergias');
INSERT INTO `lang_definitions` VALUES (3218, 907, 3, 'Editar categorías');
INSERT INTO `lang_definitions` VALUES (3219, 908, 3, 'Editar definiciones');
INSERT INTO `lang_definitions` VALUES (3220, 909, 3, 'Editar diagnóstico para');
INSERT INTO `lang_definitions` VALUES (3221, 910, 3, 'Editar instalaciones');
INSERT INTO `lang_definitions` VALUES (3222, 911, 3, 'Editar información de instalaciones');
INSERT INTO `lang_definitions` VALUES (3223, 912, 3, 'Editar forma ');
INSERT INTO `lang_definitions` VALUES (3224, 913, 3, 'Editar el diseño ');
INSERT INTO `lang_definitions` VALUES (3225, 914, 3, 'Editar la lista');
INSERT INTO `lang_definitions` VALUES (3226, 915, 3, 'Editar estructura');
INSERT INTO `lang_definitions` VALUES (3227, 916, 3, 'Educación');
INSERT INTO `lang_definitions` VALUES (3228, 917, 3, 'Fecha educación');
INSERT INTO `lang_definitions` VALUES (3229, 918, 3, 'Debería haber recibido una copia del GNU con este programa, si no, escriba al Free');
INSERT INTO `lang_definitions` VALUES (3230, 919, 3, 'Fecha efectiva');
INSERT INTO `lang_definitions` VALUES (3231, 920, 3, 'Efectividad');
INSERT INTO `lang_definitions` VALUES (3232, 921, 3, 'Eyaculaciones ');
INSERT INTO `lang_definitions` VALUES (3233, 922, 3, 'Codo');
INSERT INTO `lang_definitions` VALUES (3234, 923, 3, 'Problemas del codo');
INSERT INTO `lang_definitions` VALUES (3235, 924, 3, 'Mandatos Electronicos');
INSERT INTO `lang_definitions` VALUES (3236, 925, 3, 'Correo electrónico');
INSERT INTO `lang_definitions` VALUES (3237, 926, 3, 'Correo electrónico de Batchcom ');
INSERT INTO `lang_definitions` VALUES (3238, 927, 3, 'Notificación correo electrónico');
INSERT INTO `lang_definitions` VALUES (3239, 928, 3, 'Correo electrónico envía antes');
INSERT INTO `lang_definitions` VALUES (3240, 929, 3, 'Remitente de correo');
INSERT INTO `lang_definitions` VALUES (3241, 930, 3, 'Asunto del correo');
INSERT INTO `lang_definitions` VALUES (3242, 931, 3, 'Texto del email, etiqueta usable: *** NOMBRE ***, i.e. Estimado ***NOMBRE***');
INSERT INTO `lang_definitions` VALUES (3243, 932, 3, 'Contacto en caso de emergencia');
INSERT INTO `lang_definitions` VALUES (3244, 933, 3, 'Persona de Contacto de Emergencia');
INSERT INTO `lang_definitions` VALUES (3245, 934, 3, 'Teléfono de Contacto de Emergencia ');
INSERT INTO `lang_definitions` VALUES (3246, 935, 3, 'Emergencia anticonceptiva');
INSERT INTO `lang_definitions` VALUES (3247, 936, 3, 'Telefono de emergencia');
INSERT INTO `lang_definitions` VALUES (3248, 937, 3, 'Enfisema');
INSERT INTO `lang_definitions` VALUES (3249, 938, 3, 'Empleadeo');
INSERT INTO `lang_definitions` VALUES (3250, 939, 3, 'Empresa');
INSERT INTO `lang_definitions` VALUES (3251, 940, 3, 'Dirección del empresario');
INSERT INTO `lang_definitions` VALUES (3252, 941, 3, 'Datos de la empresa');
INSERT INTO `lang_definitions` VALUES (3253, 942, 3, 'Nombre de Empresa');
INSERT INTO `lang_definitions` VALUES (3254, 943, 3, 'Vacio');
INSERT INTO `lang_definitions` VALUES (3255, 944, 3, 'Vaciar el valor en \"Correo electrónico Horas\"');
INSERT INTO `lang_definitions` VALUES (3256, 945, 3, 'Vaciar el valor en \"Correo electrónico Remitente\"');
INSERT INTO `lang_definitions` VALUES (3257, 946, 3, 'Vaciar el valor en \"Correo electrónico Asunto\"');
INSERT INTO `lang_definitions` VALUES (3258, 947, 3, 'Vaciar el valor en \"Correo electrónico de texto\"');
INSERT INTO `lang_definitions` VALUES (3259, 948, 3, 'Vaciar el valor en \"Nombre del Proveedor\"');
INSERT INTO `lang_definitions` VALUES (3260, 949, 3, 'Vaciar el valor en \"Contraseña\"');
INSERT INTO `lang_definitions` VALUES (3261, 950, 3, 'Vaciar el valor en \"Horas de SMS\"');
INSERT INTO `lang_definitions` VALUES (3262, 951, 3, 'Vaciar en el valor \"Texto SMS\"');
INSERT INTO `lang_definitions` VALUES (3263, 952, 3, 'Vaciar en el valor \"Usuario\"');
INSERT INTO `lang_definitions` VALUES (3264, 953, 3, 'Habilitado');
INSERT INTO `lang_definitions` VALUES (3265, 954, 3, 'Encuentro');
INSERT INTO `lang_definitions` VALUES (3266, 955, 3, 'encuentro');
INSERT INTO `lang_definitions` VALUES (3267, 956, 3, 'Encuentro');
INSERT INTO `lang_definitions` VALUES (3268, 957, 3, 'Encuentro');
INSERT INTO `lang_definitions` VALUES (3269, 958, 3, 'Encuentro formas');
INSERT INTO `lang_definitions` VALUES (3270, 959, 3, 'Encuentro número');
INSERT INTO `lang_definitions` VALUES (3271, 960, 3, 'Encuentro fue codificado');
INSERT INTO `lang_definitions` VALUES (3272, 961, 3, 'Encuentro:');
INSERT INTO `lang_definitions` VALUES (3273, 962, 3, 'Encuentro');
INSERT INTO `lang_definitions` VALUES (3274, 963, 3, 'Encuentro y Formas');
INSERT INTO `lang_definitions` VALUES (3275, 964, 3, 'Encuentra el & amperio; Formas ');
INSERT INTO `lang_definitions` VALUES (3276, 965, 3, 'Encuentros no autorizados');
INSERT INTO `lang_definitions` VALUES (3277, 966, 3, 'Informe de los encuentros ');
INSERT INTO `lang_definitions` VALUES (3278, 967, 3, 'Sección Encuentros');
INSERT INTO `lang_definitions` VALUES (3279, 968, 3, 'Final');
INSERT INTO `lang_definitions` VALUES (3280, 969, 3, 'Final (aaaa-mm-dd): ');
INSERT INTO `lang_definitions` VALUES (3281, 970, 3, 'Fecha final');
INSERT INTO `lang_definitions` VALUES (3282, 971, 3, 'Fecha final');
INSERT INTO `lang_definitions` VALUES (3283, 972, 3, 'Fecha Final:');
INSERT INTO `lang_definitions` VALUES (3284, 973, 3, 'Hora finalización');
INSERT INTO `lang_definitions` VALUES (3285, 974, 3, 'Fecha final de servicio aaaa-mm-dd');
INSERT INTO `lang_definitions` VALUES (3286, 975, 3, 'Termina DOS dd / mm / aaaa si desea entrar en una serie');
INSERT INTO `lang_definitions` VALUES (3287, 976, 3, 'Sangre anormal Endo ');
INSERT INTO `lang_definitions` VALUES (3288, 977, 3, 'Endocrino');
INSERT INTO `lang_definitions` VALUES (3289, 978, 3, 'Endoscopía');
INSERT INTO `lang_definitions` VALUES (3290, 979, 3, 'Inglés');
INSERT INTO `lang_definitions` VALUES (3291, 980, 3, 'Inglés');
INSERT INTO `lang_definitions` VALUES (3292, 981, 3, 'Ingleses (Indios) ');
INSERT INTO `lang_definitions` VALUES (3293, 982, 3, 'Inglés (Estándar) ');
INSERT INTO `lang_definitions` VALUES (3294, 983, 3, 'Garantizar OpenEMR tiene privilegios al directorio ');
INSERT INTO `lang_definitions` VALUES (3295, 984, 3, 'ENT Descarga ');
INSERT INTO `lang_definitions` VALUES (3296, 985, 3, 'ENT Dolor');
INSERT INTO `lang_definitions` VALUES (3297, 986, 3, 'Introduzca un código de la diagnosis para excluir todas las facturas que no lo contienen');
INSERT INTO `lang_definitions` VALUES (3298, 987, 3, 'Incorpore el cuerpo en la carta aquí ');
INSERT INTO `lang_definitions` VALUES (3299, 988, 3, 'Escriba el nuevo Estado ');
INSERT INTO `lang_definitions` VALUES (3300, 989, 3, 'Incorpore sus criterios de búsqueda arriba ');
INSERT INTO `lang_definitions` VALUES (3301, 990, 3, 'Ambiental');
INSERT INTO `lang_definitions` VALUES (3302, 991, 3, 'Entrada de datos de EOB ');
INSERT INTO `lang_definitions` VALUES (3303, 992, 3, 'EOB envío - Remesas electrónicas');
INSERT INTO `lang_definitions` VALUES (3304, 993, 3, 'EOB envío - Instrucciones');
INSERT INTO `lang_definitions` VALUES (3305, 994, 3, 'EOB envío - Factura');
INSERT INTO `lang_definitions` VALUES (3306, 995, 3, 'EOB envío - Nota del Paciente');
INSERT INTO `lang_definitions` VALUES (3307, 996, 3, 'EOB envío - Buscar');
INSERT INTO `lang_definitions` VALUES (3308, 997, 3, 'Epilepsia');
INSERT INTO `lang_definitions` VALUES (3309, 998, 3, 'Borrar');
INSERT INTO `lang_definitions` VALUES (3310, 999, 3, 'Erecciones ');
INSERT INTO `lang_definitions` VALUES (3311, 1000, 3, 'Error');
INSERT INTO `lang_definitions` VALUES (3312, 1001, 3, 'Error en selección de género');
INSERT INTO `lang_definitions` VALUES (3313, 1002, 3, 'Error en \"HIPAA\" selección');
INSERT INTO `lang_definitions` VALUES (3314, 1003, 3, 'Error en el \"Proceso de selección');
INSERT INTO `lang_definitions` VALUES (3315, 1004, 3, 'El error en la selección de \"Puerta de SMS\"');
INSERT INTO `lang_definitions` VALUES (3316, 1005, 3, 'Error en \"Ordenar por\" selección');
INSERT INTO `lang_definitions` VALUES (3317, 1007, 3, 'Error en la opción SI o NO');
INSERT INTO `lang_definitions` VALUES (3318, 1009, 3, 'error al registrar la forma! ');
INSERT INTO `lang_definitions` VALUES (3319, 1010, 3, 'Error al guardar en el archivo ');
INSERT INTO `lang_definitions` VALUES (3320, 1011, 3, 'Error al escribir en el archivo ');
INSERT INTO `lang_definitions` VALUES (3321, 1012, 3, 'ERROR, incapaz de recoger los datos de servidor ');
INSERT INTO `lang_definitions` VALUES (3322, 1014, 3, 'ERROR: no pudo abrir tabla sql, formulario roto? ');
INSERT INTO `lang_definitions` VALUES (3323, 1016, 3, 'Error: las contraseñas no coinciden. Por favor, compruebe al escribir. ');
INSERT INTO `lang_definitions` VALUES (3324, 1018, 3, 'Errores');
INSERT INTO `lang_definitions` VALUES (3325, 1019, 3, 'Eritema');
INSERT INTO `lang_definitions` VALUES (3326, 1020, 3, 'Paciente Establecido ');
INSERT INTO `lang_definitions` VALUES (3327, 1021, 3, 'La etnia o la raza');
INSERT INTO `lang_definitions` VALUES (3328, 1022, 3, 'Lista de Origen étnico--Raza (escriba, sólo añadir opcional) ');
INSERT INTO `lang_definitions` VALUES (3329, 1023, 3, 'ETIN');
INSERT INTO `lang_definitions` VALUES (3330, 1024, 3, 'Evento');
INSERT INTO `lang_definitions` VALUES (3331, 1025, 3, 'Fecha comienzo de evento');
INSERT INTO `lang_definitions` VALUES (3332, 1026, 3, 'Categoría de evento');
INSERT INTO `lang_definitions` VALUES (3333, 1027, 3, 'Fecha evento');
INSERT INTO `lang_definitions` VALUES (3334, 1028, 3, 'Descripción evento');
INSERT INTO `lang_definitions` VALUES (3335, 1029, 3, 'Detalles evento');
INSERT INTO `lang_definitions` VALUES (3336, 1030, 3, 'Evento no se repite');
INSERT INTO `lang_definitions` VALUES (3337, 1031, 3, 'Duración de Evento');
INSERT INTO `lang_definitions` VALUES (3338, 1032, 3, 'Duración de evento en minutos');
INSERT INTO `lang_definitions` VALUES (3339, 1033, 3, 'Honorarios del evento');
INSERT INTO `lang_definitions` VALUES (3340, 1034, 3, 'Lugar de evento');
INSERT INTO `lang_definitions` VALUES (3341, 1035, 3, 'Evento repite cada');
INSERT INTO `lang_definitions` VALUES (3342, 1036, 3, 'Evento repite en');
INSERT INTO `lang_definitions` VALUES (3343, 1037, 3, 'Hora comienzo evento');
INSERT INTO `lang_definitions` VALUES (3344, 1038, 3, 'Título de evento');
INSERT INTO `lang_definitions` VALUES (3345, 1039, 3, 'Título de Evento');
INSERT INTO `lang_definitions` VALUES (3346, 1040, 3, 'Página web de evento');
INSERT INTO `lang_definitions` VALUES (3347, 1041, 3, 'Eventos');
INSERT INTO `lang_definitions` VALUES (3348, 1042, 3, 'Eventos para');
INSERT INTO `lang_definitions` VALUES (3349, 1043, 3, 'Eventos abre en nueva ventana');
INSERT INTO `lang_definitions` VALUES (3350, 1044, 3, 'cada');
INSERT INTO `lang_definitions` VALUES (3351, 1045, 3, 'Cada');
INSERT INTO `lang_definitions` VALUES (3352, 1046, 3, 'cada 3 horas');
INSERT INTO `lang_definitions` VALUES (3353, 1047, 3, 'cada 4 horas');
INSERT INTO `lang_definitions` VALUES (3354, 1048, 3, 'cada 5 horas');
INSERT INTO `lang_definitions` VALUES (3355, 1049, 3, 'cada 6 horas');
INSERT INTO `lang_definitions` VALUES (3356, 1050, 3, 'cada 8 horas');
INSERT INTO `lang_definitions` VALUES (3357, 1051, 3, 'cada cuarto');
INSERT INTO `lang_definitions` VALUES (3358, 1052, 3, 'uno sí, otro no');
INSERT INTO `lang_definitions` VALUES (3359, 1053, 3, 'cada tercero');
INSERT INTO `lang_definitions` VALUES (3360, 1054, 3, 'Cada, cada otro, cada 3ro, etc. ');
INSERT INTO `lang_definitions` VALUES (3361, 1055, 3, 'Examen y los resultados de las pruebas');
INSERT INTO `lang_definitions` VALUES (3362, 1056, 3, 'Resultados del examen');
INSERT INTO `lang_definitions` VALUES (3363, 1057, 3, 'Fecha de examen ');
INSERT INTO `lang_definitions` VALUES (3364, 1058, 3, 'Exámenes / Pruebas');
INSERT INTO `lang_definitions` VALUES (3365, 1059, 3, 'Lagrimeo Excesivo ');
INSERT INTO `lang_definitions` VALUES (3366, 1060, 3, 'Organización de provedor exclusivo (OPE)');
INSERT INTO `lang_definitions` VALUES (3367, 1061, 3, 'Patrones de ejercicio ');
INSERT INTO `lang_definitions` VALUES (3368, 1062, 3, 'Patrones del ejercicio / rutinas deportivas');
INSERT INTO `lang_definitions` VALUES (3369, 1063, 3, 'Salir de Administración');
INSERT INTO `lang_definitions` VALUES (3370, 1064, 3, 'Exp');
INSERT INTO `lang_definitions` VALUES (3371, 1065, 3, 'Vista ampliada');
INSERT INTO `lang_definitions` VALUES (3372, 1066, 3, 'La forma esperada_encuentro. pid para ser');
INSERT INTO `lang_definitions` VALUES (3373, 1067, 3, 'Caducidad');
INSERT INTO `lang_definitions` VALUES (3374, 1068, 3, 'Fecha de caducidad');
INSERT INTO `lang_definitions` VALUES (3375, 1069, 3, 'Caducidad');
INSERT INTO `lang_definitions` VALUES (3376, 1070, 3, 'Exportar');
INSERT INTO `lang_definitions` VALUES (3377, 1071, 3, 'Exportar con CSV');
INSERT INTO `lang_definitions` VALUES (3378, 1073, 3, 'La exportación de pacientes Demografía ');
INSERT INTO `lang_definitions` VALUES (3379, 1074, 3, 'Selección de exportación como CSV ');
INSERT INTO `lang_definitions` VALUES (3380, 1075, 3, 'Selección de las colecciones a la exportación ');
INSERT INTO `lang_definitions` VALUES (3381, 1076, 3, 'Exportar a CSV');
INSERT INTO `lang_definitions` VALUES (3382, 1077, 3, 'Exportación al sistema de facturación externo');
INSERT INTO `lang_definitions` VALUES (3383, 1078, 3, 'Exposición a los países extranjeros');
INSERT INTO `lang_definitions` VALUES (3384, 1079, 3, 'Exposición a Países Extranjeros ');
INSERT INTO `lang_definitions` VALUES (3385, 1081, 3, 'Identificación externa');
INSERT INTO `lang_definitions` VALUES (3386, 1082, 3, 'Externos de identificación ');
INSERT INTO `lang_definitions` VALUES (3387, 1084, 3, 'Remisión externa');
INSERT INTO `lang_definitions` VALUES (3388, 1086, 3, 'Referencia externa?');
INSERT INTO `lang_definitions` VALUES (3389, 1087, 3, 'Remisiones externas');
INSERT INTO `lang_definitions` VALUES (3390, 1088, 3, 'Exudado:');
INSERT INTO `lang_definitions` VALUES (3391, 1089, 3, 'Irritación de Ojo ');
INSERT INTO `lang_definitions` VALUES (3392, 1090, 3, 'Dolor de Ojo ');
INSERT INTO `lang_definitions` VALUES (3393, 1091, 3, 'Enrojecimiento de Ojo');
INSERT INTO `lang_definitions` VALUES (3394, 1092, 3, 'Ojos');
INSERT INTO `lang_definitions` VALUES (3395, 1093, 3, 'F');
INSERT INTO `lang_definitions` VALUES (3396, 1094, 3, 'F/H Problemas de Sangre ');
INSERT INTO `lang_definitions` VALUES (3397, 1095, 3, 'F/H Hirsutismo Femenino/Estrías ');
INSERT INTO `lang_definitions` VALUES (3398, 1096, 3, 'Facilidades');
INSERT INTO `lang_definitions` VALUES (3399, 1097, 3, 'Facilidad');
INSERT INTO `lang_definitions` VALUES (3400, 1098, 3, 'Instalaciones');
INSERT INTO `lang_definitions` VALUES (3401, 1099, 3, 'Facilidad de Administración ');
INSERT INTO `lang_definitions` VALUES (3402, 1100, 3, 'Código de la facilidad ');
INSERT INTO `lang_definitions` VALUES (3403, 1101, 3, 'Facilidad NPI');
INSERT INTO `lang_definitions` VALUES (3404, 1102, 3, 'Instalaciones:');
INSERT INTO `lang_definitions` VALUES (3405, 1103, 3, 'Fallado');
INSERT INTO `lang_definitions` VALUES (3406, 1105, 3, 'error');
INSERT INTO `lang_definitions` VALUES (3407, 1106, 3, 'Historial familiar');
INSERT INTO `lang_definitions` VALUES (3408, 1107, 3, 'Historia Familiar de Glaucoma ');
INSERT INTO `lang_definitions` VALUES (3409, 1108, 3, 'Historial familiar:');
INSERT INTO `lang_definitions` VALUES (3410, 1109, 3, 'Tamaño familia');
INSERT INTO `lang_definitions` VALUES (3411, 1110, 3, 'Suposición');
INSERT INTO `lang_definitions` VALUES (3412, 1111, 3, 'Padre');
INSERT INTO `lang_definitions` VALUES (3413, 1112, 3, 'Fatiga ');
INSERT INTO `lang_definitions` VALUES (3414, 1113, 3, 'Fatigado');
INSERT INTO `lang_definitions` VALUES (3415, 1114, 3, 'Fax');
INSERT INTO `lang_definitions` VALUES (3416, 1115, 3, 'Número de fax ');
INSERT INTO `lang_definitions` VALUES (3417, 1116, 3, 'Fax/Escanear');
INSERT INTO `lang_definitions` VALUES (3418, 1117, 3, 'Faxes entrada');
INSERT INTO `lang_definitions` VALUES (3419, 1118, 3, 'Faxes salida');
INSERT INTO `lang_definitions` VALUES (3420, 1119, 3, 'Febrero');
INSERT INTO `lang_definitions` VALUES (3421, 1120, 3, 'FECA');
INSERT INTO `lang_definitions` VALUES (3422, 1121, 3, 'Identificación de medicamento federal');
INSERT INTO `lang_definitions` VALUES (3423, 1122, 3, 'Federal EIN');
INSERT INTO `lang_definitions` VALUES (3424, 1123, 3, 'Identificación de impuesto federal');
INSERT INTO `lang_definitions` VALUES (3425, 1124, 3, 'Tarifa');
INSERT INTO `lang_definitions` VALUES (3426, 1125, 3, 'tarifa');
INSERT INTO `lang_definitions` VALUES (3427, 1127, 3, 'Hoja de tarifa');
INSERT INTO `lang_definitions` VALUES (3428, 1129, 3, 'Tarifas');
INSERT INTO `lang_definitions` VALUES (3429, 1130, 3, 'Mujer');
INSERT INTO `lang_definitions` VALUES (3430, 1131, 3, 'Mujeres AP ');
INSERT INTO `lang_definitions` VALUES (3431, 1132, 3, 'Condones femininos');
INSERT INTO `lang_definitions` VALUES (3432, 1133, 3, 'G Femenino ');
INSERT INTO `lang_definitions` VALUES (3433, 1134, 3, 'LC Femenino ');
INSERT INTO `lang_definitions` VALUES (3434, 1135, 3, 'P Femenino ');
INSERT INTO `lang_definitions` VALUES (3435, 1136, 3, 'Síntomas Femeninos ');
INSERT INTO `lang_definitions` VALUES (3436, 1137, 3, 'Mujeres VSC');
INSERT INTO `lang_definitions` VALUES (3437, 1138, 3, 'Fiebre');
INSERT INTO `lang_definitions` VALUES (3438, 1139, 3, 'Fiebre');
INSERT INTO `lang_definitions` VALUES (3439, 1140, 3, 'Problemas de Sangre FH ');
INSERT INTO `lang_definitions` VALUES (3440, 1141, 3, 'Fibromas');
INSERT INTO `lang_definitions` VALUES (3441, 1142, 3, 'ARCHIVO');
INSERT INTO `lang_definitions` VALUES (3442, 1143, 3, 'Cuarto de archivo');
INSERT INTO `lang_definitions` VALUES (3443, 1145, 3, 'Archivo con el mismo nombre ya existe en la ubicación: ');
INSERT INTO `lang_definitions` VALUES (3444, 1146, 3, 'Nombre de fichero');
INSERT INTO `lang_definitions` VALUES (3445, 1147, 3, 'Rellenar sólo si manda notificación a paciente por correo electrónico');
INSERT INTO `lang_definitions` VALUES (3446, 1148, 3, 'Filtro ');
INSERT INTO `lang_definitions` VALUES (3447, 1149, 3, 'Filtro para los constantes ');
INSERT INTO `lang_definitions` VALUES (3448, 1150, 3, 'Filtros');
INSERT INTO `lang_definitions` VALUES (3449, 1151, 3, 'Diagnóstico final');
INSERT INTO `lang_definitions` VALUES (3450, 1152, 3, 'Diagnóstico final por especialista');
INSERT INTO `lang_definitions` VALUES (3451, 1153, 3, 'Financiero');
INSERT INTO `lang_definitions` VALUES (3452, 1154, 3, 'Información financiera - cualquier cosa ');
INSERT INTO `lang_definitions` VALUES (3453, 1155, 3, 'Información financiera - mis encuentros ');
INSERT INTO `lang_definitions` VALUES (3454, 1156, 3, 'Fecha de revisión financiero');
INSERT INTO `lang_definitions` VALUES (3455, 1157, 3, 'Encontrar');
INSERT INTO `lang_definitions` VALUES (3456, 1158, 3, 'Busca disponible');
INSERT INTO `lang_definitions` VALUES (3457, 1159, 3, 'Busca citas disponibles');
INSERT INTO `lang_definitions` VALUES (3458, 1160, 3, 'Busca paciente');
INSERT INTO `lang_definitions` VALUES (3459, 1161, 3, 'Conclusiones');
INSERT INTO `lang_definitions` VALUES (3460, 1162, 3, 'Conclusiones por especialista');
INSERT INTO `lang_definitions` VALUES (3461, 1163, 3, 'Multa');
INSERT INTO `lang_definitions` VALUES (3462, 1164, 3, 'Primero');
INSERT INTO `lang_definitions` VALUES (3463, 1165, 3, 'Primer día de la semana');
INSERT INTO `lang_definitions` VALUES (3464, 1166, 3, 'Nombre ');
INSERT INTO `lang_definitions` VALUES (3465, 1167, 3, 'Nombre ');
INSERT INTO `lang_definitions` VALUES (3466, 1168, 3, 'Nombre ');
INSERT INTO `lang_definitions` VALUES (3467, 1169, 3, 'Aptitud');
INSERT INTO `lang_definitions` VALUES (3468, 1170, 3, 'Aptitud a jugar');
INSERT INTO `lang_definitions` VALUES (3469, 1171, 3, 'Encuentro fijar fechas - cualquier encuentros ');
INSERT INTO `lang_definitions` VALUES (3470, 1172, 3, 'Solucionar este ');
INSERT INTO `lang_definitions` VALUES (3471, 1173, 3, 'Flatulencia ');
INSERT INTO `lang_definitions` VALUES (3472, 1174, 3, 'Flujo ');
INSERT INTO `lang_definitions` VALUES (3473, 1175, 3, 'Vacunación de la gripe');
INSERT INTO `lang_definitions` VALUES (3474, 1176, 3, 'Problema de fluído y electrolito');
INSERT INTO `lang_definitions` VALUES (3475, 1177, 3, 'FMS');
INSERT INTO `lang_definitions` VALUES (3476, 1178, 3, 'Seguir manualmente');
INSERT INTO `lang_definitions` VALUES (3477, 1179, 3, 'Intolerancia del Alimento ');
INSERT INTO `lang_definitions` VALUES (3478, 1180, 3, 'Pie');
INSERT INTO `lang_definitions` VALUES (3479, 1181, 3, 'Problemas en los píes');
INSERT INTO `lang_definitions` VALUES (3480, 1182, 3, 'Píe:');
INSERT INTO `lang_definitions` VALUES (3481, 1183, 3, 'Lesiones de fútbol ');
INSERT INTO `lang_definitions` VALUES (3482, 1184, 3, 'Informe de lesión futbolística');
INSERT INTO `lang_definitions` VALUES (3483, 1185, 3, 'Tipo de calzado');
INSERT INTO `lang_definitions` VALUES (3484, 1186, 3, 'para');
INSERT INTO `lang_definitions` VALUES (3485, 1189, 3, 'para:');
INSERT INTO `lang_definitions` VALUES (3486, 1190, 3, 'Antebrazo');
INSERT INTO `lang_definitions` VALUES (3487, 1191, 3, 'Formulario');
INSERT INTO `lang_definitions` VALUES (3488, 1192, 3, 'formulario');
INSERT INTO `lang_definitions` VALUES (3489, 1193, 3, 'formato');
INSERT INTO `lang_definitions` VALUES (3490, 1194, 3, 'Formato');
INSERT INTO `lang_definitions` VALUES (3491, 1195, 3, 'Formato incorrecto para el NDC ');
INSERT INTO `lang_definitions` VALUES (3492, 1196, 3, 'Formularios');
INSERT INTO `lang_definitions` VALUES (3493, 1197, 3, 'Formas de administración');
INSERT INTO `lang_definitions` VALUES (3494, 1198, 3, 'Páginas delanteras vía fax ');
INSERT INTO `lang_definitions` VALUES (3495, 1199, 3, 'Cuarto');
INSERT INTO `lang_definitions` VALUES (3496, 1200, 3, 'Fractura');
INSERT INTO `lang_definitions` VALUES (3497, 1201, 3, 'Fractura de escafoides');
INSERT INTO `lang_definitions` VALUES (3498, 1202, 3, 'Fractura del maléolo lat.');
INSERT INTO `lang_definitions` VALUES (3499, 1203, 3, 'Fractura del maléolo med.');
INSERT INTO `lang_definitions` VALUES (3500, 1204, 3, 'Fractura de base quinta (5 ª) metatarsianas ');
INSERT INTO `lang_definitions` VALUES (3501, 1205, 3, 'Francés');
INSERT INTO `lang_definitions` VALUES (3502, 1206, 3, 'Frecuencia ');
INSERT INTO `lang_definitions` VALUES (3503, 1207, 3, 'Resfriados Frecuentes ');
INSERT INTO `lang_definitions` VALUES (3504, 1208, 3, 'Enfermedades Frecuentes ');
INSERT INTO `lang_definitions` VALUES (3505, 1209, 3, 'Viernes');
INSERT INTO `lang_definitions` VALUES (3506, 1210, 3, 'Viernes');
INSERT INTO `lang_definitions` VALUES (3507, 1211, 3, 'Desde');
INSERT INTO `lang_definitions` VALUES (3508, 1212, 3, 'DESDE');
INSERT INTO `lang_definitions` VALUES (3509, 1213, 3, 'Desde:');
INSERT INTO `lang_definitions` VALUES (3510, 1214, 3, 'Desde:');
INSERT INTO `lang_definitions` VALUES (3511, 1215, 3, 'DESDE_CIUDAD');
INSERT INTO `lang_definitions` VALUES (3512, 1216, 3, 'DESDE_NOMBRE');
INSERT INTO `lang_definitions` VALUES (3513, 1217, 3, 'DESDE_APELLIDO');
INSERT INTO `lang_definitions` VALUES (3514, 1218, 3, 'DESDE_SEGUNDONOMBRE');
INSERT INTO `lang_definitions` VALUES (3515, 1219, 3, 'DESDE_TELÉFONOCELULAR ');
INSERT INTO `lang_definitions` VALUES (3516, 1220, 3, 'DESDE_POSTAL');
INSERT INTO `lang_definitions` VALUES (3517, 1221, 3, 'DESDE_ESTADO');
INSERT INTO `lang_definitions` VALUES (3518, 1222, 3, 'DESDE_CALLE');
INSERT INTO `lang_definitions` VALUES (3519, 1223, 3, 'DESDE_TÍTULO ');
INSERT INTO `lang_definitions` VALUES (3520, 1224, 3, 'DESDE_DESPEDIDA');
INSERT INTO `lang_definitions` VALUES (3521, 1225, 3, 'Oficina central ');
INSERT INTO `lang_definitions` VALUES (3522, 1226, 3, 'Recibos de la Oficina Central ');
INSERT INTO `lang_definitions` VALUES (3523, 1227, 3, 'Reportes de Recibos de la Oficina Central');
INSERT INTO `lang_definitions` VALUES (3524, 1228, 3, 'Frente Rec.');
INSERT INTO `lang_definitions` VALUES (3525, 1229, 3, 'La derecha frontal: ');
INSERT INTO `lang_definitions` VALUES (3526, 1230, 3, 'Nombre Completo ');
INSERT INTO `lang_definitions` VALUES (3527, 1231, 3, 'Juego completo ');
INSERT INTO `lang_definitions` VALUES (3528, 1232, 3, 'Entrenamiento completo ');
INSERT INTO `lang_definitions` VALUES (3529, 1233, 3, 'G');
INSERT INTO `lang_definitions` VALUES (3530, 1234, 3, 'Condición de la vesícula biliar');
INSERT INTO `lang_definitions` VALUES (3531, 1235, 3, 'Piedras de la rozadura ');
INSERT INTO `lang_definitions` VALUES (3532, 1236, 3, 'Periodo de Juego');
INSERT INTO `lang_definitions` VALUES (3533, 1237, 3, 'Juegos');
INSERT INTO `lang_definitions` VALUES (3534, 1238, 3, 'juegos/eventos');
INSERT INTO `lang_definitions` VALUES (3535, 1239, 3, 'Juegos / Eventos perdidas');
INSERT INTO `lang_definitions` VALUES (3536, 1240, 3, 'Gastritis');
INSERT INTO `lang_definitions` VALUES (3537, 1241, 3, 'Dolor Gastrointestinal ');
INSERT INTO `lang_definitions` VALUES (3538, 1242, 3, 'Gastrointestinal ');
INSERT INTO `lang_definitions` VALUES (3539, 1243, 3, 'Informe de las estadísticas de GCAC ');
INSERT INTO `lang_definitions` VALUES (3540, 1245, 3, 'Género');
INSERT INTO `lang_definitions` VALUES (3541, 1246, 3, 'Género');
INSERT INTO `lang_definitions` VALUES (3542, 1247, 3, 'General');
INSERT INTO `lang_definitions` VALUES (3543, 1248, 3, 'Categoría de servicio general');
INSERT INTO `lang_definitions` VALUES (3544, 1249, 3, 'Generar y descargar HCFA 1500 reclamaciones en papel');
INSERT INTO `lang_definitions` VALUES (3545, 1250, 3, 'Generar y descargar lote X12 ');
INSERT INTO `lang_definitions` VALUES (3546, 1253, 3, 'Genere HCFA ');
INSERT INTO `lang_definitions` VALUES (3547, 1254, 3, 'Genere la Carta');
INSERT INTO `lang_definitions` VALUES (3548, 1255, 3, 'Generar carta relacionada');
INSERT INTO `lang_definitions` VALUES (3549, 1256, 3, 'Generar informe');
INSERT INTO `lang_definitions` VALUES (3550, 1257, 3, 'Generar X12');
INSERT INTO `lang_definitions` VALUES (3551, 1259, 3, 'Generado en');
INSERT INTO `lang_definitions` VALUES (3552, 1260, 3, 'genera');
INSERT INTO `lang_definitions` VALUES (3553, 1261, 3, 'Genitourinario');
INSERT INTO `lang_definitions` VALUES (3554, 1262, 3, 'Alemán');
INSERT INTO `lang_definitions` VALUES (3555, 1263, 3, 'Glaucoma');
INSERT INTO `lang_definitions` VALUES (3556, 1264, 3, 'Historia Familiar de Glaucoma ');
INSERT INTO `lang_definitions` VALUES (3557, 1265, 3, 'Global');
INSERT INTO `lang_definitions` VALUES (3558, 1267, 3, 'ir');
INSERT INTO `lang_definitions` VALUES (3559, 1268, 3, 'Ir');
INSERT INTO `lang_definitions` VALUES (3560, 1271, 3, 'Grado:');
INSERT INTO `lang_definitions` VALUES (3561, 1272, 3, 'Gramos');
INSERT INTO `lang_definitions` VALUES (3562, 1273, 3, 'Suma total');
INSERT INTO `lang_definitions` VALUES (3563, 1274, 3, 'Sumas totales');
INSERT INTO `lang_definitions` VALUES (3564, 1275, 3, 'Griego ');
INSERT INTO `lang_definitions` VALUES (3565, 1276, 3, 'Grupo');
INSERT INTO `lang_definitions` VALUES (3566, 1277, 3, 'Nombre de Grupo ');
INSERT INTO `lang_definitions` VALUES (3567, 1280, 3, 'Los nombres de grupo no pueden comenzar con números. ');
INSERT INTO `lang_definitions` VALUES (3568, 1281, 3, 'Número de grupo');
INSERT INTO `lang_definitions` VALUES (3569, 1282, 3, 'Grupo:');
INSERT INTO `lang_definitions` VALUES (3570, 1283, 3, 'Nombre del grupo');
INSERT INTO `lang_definitions` VALUES (3571, 1284, 3, 'Controles de grupos y accesos');
INSERT INTO `lang_definitions` VALUES (3572, 1285, 3, 'Gráfico de Crecimiento ');
INSERT INTO `lang_definitions` VALUES (3573, 1286, 3, 'Gráfico de Crecimiento ');
INSERT INTO `lang_definitions` VALUES (3574, 1287, 3, 'gtts (gotas) ');
INSERT INTO `lang_definitions` VALUES (3575, 1288, 3, 'Examen ginecológico');
INSERT INTO `lang_definitions` VALUES (3576, 1289, 3, 'h');
INSERT INTO `lang_definitions` VALUES (3577, 1290, 3, 'h.s.');
INSERT INTO `lang_definitions` VALUES (3578, 1291, 3, 'H/O Hepatitis ');
INSERT INTO `lang_definitions` VALUES (3579, 1292, 3, 'se ha suprimido con éxito. Cualquier sub-categorías si fueron trasladados abajo');
INSERT INTO `lang_definitions` VALUES (3580, 1293, 3, 'Hematoma/moratón');
INSERT INTO `lang_definitions` VALUES (3581, 1294, 3, 'HAI Estado ');
INSERT INTO `lang_definitions` VALUES (3582, 1295, 3, 'manos + dedos');
INSERT INTO `lang_definitions` VALUES (3583, 1296, 3, 'Problemas de manos');
INSERT INTO `lang_definitions` VALUES (3584, 1297, 3, 'Dificultad sin ');
INSERT INTO `lang_definitions` VALUES (3585, 1298, 3, 'se ha ligado para visitar ');
INSERT INTO `lang_definitions` VALUES (3586, 1299, 3, 'Actividades peligrosas ');
INSERT INTO `lang_definitions` VALUES (3587, 1300, 3, 'Actividades peligrosas');
INSERT INTO `lang_definitions` VALUES (3588, 1301, 3, 'Margen izquierdo de HCFA en puntos ');
INSERT INTO `lang_definitions` VALUES (3589, 1302, 3, 'Márgenes de HCFA ');
INSERT INTO `lang_definitions` VALUES (3590, 1303, 3, 'Margen superior de HCFA en puntos ');
INSERT INTO `lang_definitions` VALUES (3591, 1304, 3, 'él Poste Calendario');
INSERT INTO `lang_definitions` VALUES (3592, 1305, 3, 'Cabeza');
INSERT INTO `lang_definitions` VALUES (3593, 1306, 3, 'Jefe Circ ');
INSERT INTO `lang_definitions` VALUES (3594, 1307, 3, 'Circunferencia principal ');
INSERT INTO `lang_definitions` VALUES (3595, 1308, 3, 'Dolor de cabeza ');
INSERT INTO `lang_definitions` VALUES (3596, 1309, 3, 'Dolores de cabeza');
INSERT INTO `lang_definitions` VALUES (3597, 1310, 3, 'Centro de salud/clínica ');
INSERT INTO `lang_definitions` VALUES (3598, 1311, 3, 'Organización para el mantenimiento de la salud');
INSERT INTO `lang_definitions` VALUES (3599, 1312, 3, 'Riesgo de Seguro de enfermedad de la organización de mantenimiento de salud (HMO) ');
INSERT INTO `lang_definitions` VALUES (3600, 1313, 3, 'Pérdida de Oído ');
INSERT INTO `lang_definitions` VALUES (3601, 1314, 3, 'Ataque al Corazón');
INSERT INTO `lang_definitions` VALUES (3602, 1315, 3, 'Enfermedad del corazón');
INSERT INTO `lang_definitions` VALUES (3603, 1316, 3, 'Fallo cardiaco');
INSERT INTO `lang_definitions` VALUES (3604, 1317, 3, 'Problema del Corazón ');
INSERT INTO `lang_definitions` VALUES (3605, 1318, 3, 'Problemas de corazón');
INSERT INTO `lang_definitions` VALUES (3606, 1319, 3, 'Cirugía del Corazón');
INSERT INTO `lang_definitions` VALUES (3607, 1320, 3, 'Transplante de corazón');
INSERT INTO `lang_definitions` VALUES (3608, 1321, 3, 'CORAZÓN:');
INSERT INTO `lang_definitions` VALUES (3609, 1322, 3, 'Ardor de estómago ');
INSERT INTO `lang_definitions` VALUES (3610, 1323, 3, 'Calor o Frío ');
INSERT INTO `lang_definitions` VALUES (3611, 1325, 3, 'Hebreo');
INSERT INTO `lang_definitions` VALUES (3612, 1326, 3, 'HEENT');
INSERT INTO `lang_definitions` VALUES (3613, 1327, 3, 'Altura ');
INSERT INTO `lang_definitions` VALUES (3614, 1328, 3, 'Ayuda');
INSERT INTO `lang_definitions` VALUES (3615, 1329, 3, 'ayuda');
INSERT INTO `lang_definitions` VALUES (3616, 1330, 3, 'Hematemesis ');
INSERT INTO `lang_definitions` VALUES (3617, 1331, 3, 'Hematoquecia ');
INSERT INTO `lang_definitions` VALUES (3618, 1332, 3, 'Hematológico ');
INSERT INTO `lang_definitions` VALUES (3619, 1333, 3, 'Hematuria ');
INSERT INTO `lang_definitions` VALUES (3620, 1334, 3, 'Hemoglobina');
INSERT INTO `lang_definitions` VALUES (3621, 1335, 3, 'Hemoptisis ');
INSERT INTO `lang_definitions` VALUES (3622, 1336, 3, 'Hepatitis');
INSERT INTO `lang_definitions` VALUES (3623, 1337, 3, 'Hepatitis A 1 ');
INSERT INTO `lang_definitions` VALUES (3624, 1338, 3, 'Hepatitis A 2');
INSERT INTO `lang_definitions` VALUES (3625, 1339, 3, 'Hepatitis B 1');
INSERT INTO `lang_definitions` VALUES (3626, 1340, 3, 'Hepatitis B 2');
INSERT INTO `lang_definitions` VALUES (3627, 1341, 3, 'Hepatitis B 3');
INSERT INTO `lang_definitions` VALUES (3628, 1342, 3, 'aqui');
INSERT INTO `lang_definitions` VALUES (3629, 1343, 3, 'La reparación de la hernia');
INSERT INTO `lang_definitions` VALUES (3630, 1344, 3, 'disco herniado');
INSERT INTO `lang_definitions` VALUES (3631, 1345, 3, 'Herpes');
INSERT INTO `lang_definitions` VALUES (3632, 1346, 3, 'Vacilación ');
INSERT INTO `lang_definitions` VALUES (3633, 1347, 3, 'Ey, tú. has estado aquí para');
INSERT INTO `lang_definitions` VALUES (3634, 1348, 3, 'Hib 1');
INSERT INTO `lang_definitions` VALUES (3635, 1349, 3, 'Hib 2');
INSERT INTO `lang_definitions` VALUES (3636, 1350, 3, 'Hib 3');
INSERT INTO `lang_definitions` VALUES (3637, 1351, 3, 'Hib 4');
INSERT INTO `lang_definitions` VALUES (3638, 1352, 3, 'Oculto');
INSERT INTO `lang_definitions` VALUES (3639, 1353, 3, 'Administración de eventos ocultos');
INSERT INTO `lang_definitions` VALUES (3640, 1354, 3, 'Ocultar');
INSERT INTO `lang_definitions` VALUES (3641, 1355, 3, 'Ocultar detalles');
INSERT INTO `lang_definitions` VALUES (3642, 1357, 3, 'Alto');
INSERT INTO `lang_definitions` VALUES (3643, 1358, 3, 'Presión Sanguínea Alta');
INSERT INTO `lang_definitions` VALUES (3644, 1359, 3, 'Cadera + ingle');
INSERT INTO `lang_definitions` VALUES (3645, 1360, 3, 'Cadera y ingle');
INSERT INTO `lang_definitions` VALUES (3646, 1361, 3, 'Problemas de cadera');
INSERT INTO `lang_definitions` VALUES (3647, 1362, 3, 'Reemplazo de Cadera');
INSERT INTO `lang_definitions` VALUES (3648, 1363, 3, 'Aviso Recibido de HIPPA');
INSERT INTO `lang_definitions` VALUES (3649, 1364, 3, 'Hirsutismo/Estrías ');
INSERT INTO `lang_definitions` VALUES (3650, 1365, 3, 'Hispano');
INSERT INTO `lang_definitions` VALUES (3651, 1366, 3, 'Historial');
INSERT INTO `lang_definitions` VALUES (3652, 1367, 3, 'Historia de Datos');
INSERT INTO `lang_definitions` VALUES (3653, 1368, 3, 'Historia de Murmullos');
INSERT INTO `lang_definitions` VALUES (3654, 1369, 3, 'Historia de los Murmullos de Corazón ');
INSERT INTO `lang_definitions` VALUES (3655, 1370, 3, 'HIV');
INSERT INTO `lang_definitions` VALUES (3656, 1371, 3, 'Espectador HL7 ');
INSERT INTO `lang_definitions` VALUES (3657, 1372, 3, 'Mantener apretado Control para selecciones múltiples o deseleccionar');
INSERT INTO `lang_definitions` VALUES (3658, 1373, 3, 'Mantener apretado Control para seleccionar múltiples elementos');
INSERT INTO `lang_definitions` VALUES (3659, 1374, 3, 'Mantenga presionada la tecla CTRL para seleccionar varios escuadrones');
INSERT INTO `lang_definitions` VALUES (3660, 1375, 3, 'Casa');
INSERT INTO `lang_definitions` VALUES (3661, 1376, 3, 'Teléfono de casa');
INSERT INTO `lang_definitions` VALUES (3662, 1377, 3, 'Teléfono de Casa ');
INSERT INTO `lang_definitions` VALUES (3663, 1378, 3, 'Sin hogar o similares?');
INSERT INTO `lang_definitions` VALUES (3664, 1379, 3, 'Sin hogar, etc.');
INSERT INTO `lang_definitions` VALUES (3665, 1380, 3, 'Sin hogar, etc');
INSERT INTO `lang_definitions` VALUES (3666, 1381, 3, 'Horas');
INSERT INTO `lang_definitions` VALUES (3667, 1382, 3, '¿Cómo ocurrió la lesión?');
INSERT INTO `lang_definitions` VALUES (3668, 1383, 3, '¿Cómo ocurrió la lesión?: ');
INSERT INTO `lang_definitions` VALUES (3669, 1384, 3, '¿Cuántos meses de antelación a la consulta para los próximos eventos?');
INSERT INTO `lang_definitions` VALUES (3670, 1385, 3, 'HPI:');
INSERT INTO `lang_definitions` VALUES (3671, 1387, 3, 'HTML');
INSERT INTO `lang_definitions` VALUES (3672, 1388, 3, 'Hiperactivo');
INSERT INTO `lang_definitions` VALUES (3673, 1389, 3, 'Hipertensión ');
INSERT INTO `lang_definitions` VALUES (3674, 1390, 3, 'Hipertiroidismo');
INSERT INTO `lang_definitions` VALUES (3675, 1391, 3, 'Hipotiroidismo');
INSERT INTO `lang_definitions` VALUES (3676, 1392, 3, 'Histerectomía');
INSERT INTO `lang_definitions` VALUES (3677, 1393, 3, 'I');
INSERT INTO `lang_definitions` VALUES (3678, 1394, 3, 'Estoy ocupado durante este periodo.');
INSERT INTO `lang_definitions` VALUES (3679, 1395, 3, 'No tengo permiso para leer');
INSERT INTO `lang_definitions` VALUES (3680, 1396, 3, 'ICD');
INSERT INTO `lang_definitions` VALUES (3681, 1398, 3, 'Identificación ');
INSERT INTO `lang_definitions` VALUES (3682, 1400, 3, 'IDays');
INSERT INTO `lang_definitions` VALUES (3683, 1401, 3, 'identificado como ');
INSERT INTO `lang_definitions` VALUES (3684, 1402, 3, 'Identificador (una palabra)');
INSERT INTO `lang_definitions` VALUES (3685, 1403, 3, 'Si todos los datos para todas las columnas están completos para este formulario');
INSERT INTO `lang_definitions` VALUES (3686, 1404, 3, 'Si el nombre, apellido de cualquier parte o apellido, Nombre');
INSERT INTO `lang_definitions` VALUES (3687, 1405, 3, 'Si no tiene trabajo, poner Estudiante');
INSERT INTO `lang_definitions` VALUES (3688, 1406, 3, 'Si ha optado por subir las remesas electrónicas y, a continuación, vuelve la ventana de búsqueda con la adecuación de las facturas X12 archivo. Puede hacer clic en cualquiera de estos números de factura (como se describe a continuación) si desea hacer las correcciones antes de que el envío de información se aplica. Para aplicar los cambios, haga clic en el botón de archivos de procesos de ERA en la parte inferior de la página. Esto producirá una nueva ventana con un informe detallado.');
INSERT INTO `lang_definitions` VALUES (3689, 1407, 3, 'Si usted ha incorporado una fecha de pago a la página de la búsqueda, ésta eliminarán la fecha de la fijación de pagos y los ajustes que se toman de otra manera del archivo X12. Esto puede ser útil para los propósitos de la información, si usted quiere sus recibos que divulgan para utilizar su fecha de la fijación algo que el seguro company\' s que procesa la fecha. Observe que esto también afectarán a las fechas de pagos anteriores y los ajustes que se ponen en demandas secundarias. ');
INSERT INTO `lang_definitions` VALUES (3690, 1408, 3, 'Si quiere cambiar tipos de datos, o añadir filas o columnas');
INSERT INTO `lang_definitions` VALUES (3691, 1409, 3, 'Enfermedad');
INSERT INTO `lang_definitions` VALUES (3692, 1410, 3, 'IM');
INSERT INTO `lang_definitions` VALUES (3693, 1411, 3, 'Inmunización');
INSERT INTO `lang_definitions` VALUES (3694, 1412, 3, 'Inmunización Número de lote');
INSERT INTO `lang_definitions` VALUES (3695, 1413, 3, 'Fabricante de inmunización');
INSERT INTO `lang_definitions` VALUES (3696, 1414, 3, 'Inmunizaciones ');
INSERT INTO `lang_definitions` VALUES (3697, 1415, 3, 'inmunizar');
INSERT INTO `lang_definitions` VALUES (3698, 1416, 3, 'Inmunológicas ');
INSERT INTO `lang_definitions` VALUES (3699, 1417, 3, 'Implantes');
INSERT INTO `lang_definitions` VALUES (3700, 1418, 3, 'Importar');
INSERT INTO `lang_definitions` VALUES (3701, 1420, 3, 'Paciente de importación ');
INSERT INTO `lang_definitions` VALUES (3702, 1421, 3, 'Paciente de importación Demografía ');
INSERT INTO `lang_definitions` VALUES (3703, 1422, 3, 'Importados de Contabilidad');
INSERT INTO `lang_definitions` VALUES (3704, 1423, 3, 'Mejorado ');
INSERT INTO `lang_definitions` VALUES (3705, 1424, 3, 'dentro');
INSERT INTO `lang_definitions` VALUES (3706, 1425, 3, 'DENTRO');
INSERT INTO `lang_definitions` VALUES (3707, 1426, 3, 'dentro de cada ojo');
INSERT INTO `lang_definitions` VALUES (3708, 1427, 3, 'en ojo izquierdo');
INSERT INTO `lang_definitions` VALUES (3709, 1428, 3, 'en los agujeros de la nariz');
INSERT INTO `lang_definitions` VALUES (3710, 1429, 3, 'En Oficina ');
INSERT INTO `lang_definitions` VALUES (3711, 1430, 3, 'en ojo derecho');
INSERT INTO `lang_definitions` VALUES (3712, 1431, 3, 'Dentro de la empresa');
INSERT INTO `lang_definitions` VALUES (3713, 1432, 3, 'Inactivo ');
INSERT INTO `lang_definitions` VALUES (3714, 1433, 3, 'Días no activo');
INSERT INTO `lang_definitions` VALUES (3715, 1434, 3, 'Incluir los usuarios inactivos ');
INSERT INTO `lang_definitions` VALUES (3716, 1435, 3, 'Incluir a un no clasificado');
INSERT INTO `lang_definitions` VALUES (3717, 1436, 3, 'Incluir vitales');
INSERT INTO `lang_definitions` VALUES (3718, 1437, 3, 'Incluir los datos vitales?');
INSERT INTO `lang_definitions` VALUES (3719, 1438, 3, 'Ingresos');
INSERT INTO `lang_definitions` VALUES (3720, 1439, 3, 'Tratamiento Aborto incompleto');
INSERT INTO `lang_definitions` VALUES (3721, 1440, 3, 'Incontinencia ');
INSERT INTO `lang_definitions` VALUES (3722, 1441, 3, 'aumentado:');
INSERT INTO `lang_definitions` VALUES (3723, 1442, 3, 'Seguro de Indemnización');
INSERT INTO `lang_definitions` VALUES (3724, 1443, 3, 'indeterminado');
INSERT INTO `lang_definitions` VALUES (3725, 1444, 3, 'Indica si este asunto está activo');
INSERT INTO `lang_definitions` VALUES (3726, 1445, 3, 'Informe de Pacientes Indigentes');
INSERT INTO `lang_definitions` VALUES (3727, 1446, 3, 'Indigentes');
INSERT INTO `lang_definitions` VALUES (3728, 1447, 3, 'Aborto Inducido');
INSERT INTO `lang_definitions` VALUES (3729, 1448, 3, 'Infección/abceso');
INSERT INTO `lang_definitions` VALUES (3730, 1449, 3, 'Infecciones');
INSERT INTO `lang_definitions` VALUES (3731, 1450, 3, 'Infert Couns');
INSERT INTO `lang_definitions` VALUES (3732, 1451, 3, 'Infertilidad');
INSERT INTO `lang_definitions` VALUES (3733, 1452, 3, 'Gripe 1 ');
INSERT INTO `lang_definitions` VALUES (3734, 1453, 3, 'Gripe 2');
INSERT INTO `lang_definitions` VALUES (3735, 1454, 3, 'Información');
INSERT INTO `lang_definitions` VALUES (3736, 1455, 3, 'Información de ensayo 1');
INSERT INTO `lang_definitions` VALUES (3737, 1456, 3, 'Información de ensayo 2');
INSERT INTO `lang_definitions` VALUES (3738, 1457, 3, 'Información de ensayo 3');
INSERT INTO `lang_definitions` VALUES (3739, 1458, 3, 'Información de ensayo 4');
INSERT INTO `lang_definitions` VALUES (3740, 1459, 3, 'Información de ensayo 5');
INSERT INTO `lang_definitions` VALUES (3741, 1460, 3, 'Información de ensayo 6');
INSERT INTO `lang_definitions` VALUES (3742, 1461, 3, 'Inhalaciones');
INSERT INTO `lang_definitions` VALUES (3743, 1462, 3, 'Inhalaciones');
INSERT INTO `lang_definitions` VALUES (3744, 1463, 3, 'Usuario Inicial');
INSERT INTO `lang_definitions` VALUES (3745, 1464, 3, 'Inyectables');
INSERT INTO `lang_definitions` VALUES (3746, 1465, 3, 'Herido a Fuera');
INSERT INTO `lang_definitions` VALUES (3747, 1466, 3, 'Herido');
INSERT INTO `lang_definitions` VALUES (3748, 1467, 3, 'Mecanismo de lesión');
INSERT INTO `lang_definitions` VALUES (3749, 1468, 3, 'Informe General de lesión');
INSERT INTO `lang_definitions` VALUES (3750, 1469, 3, 'Vigilancia de Lesiones');
INSERT INTO `lang_definitions` VALUES (3751, 1470, 3, 'Tipo de lesión');
INSERT INTO `lang_definitions` VALUES (3752, 1471, 3, 'Campos de entrada');
INSERT INTO `lang_definitions` VALUES (3753, 1472, 3, 'Ajuste Seg');
INSERT INTO `lang_definitions` VALUES (3754, 1473, 3, 'Ins bundling');
INSERT INTO `lang_definitions` VALUES (3755, 1474, 3, 'Sobre pago Seg');
INSERT INTO `lang_definitions` VALUES (3756, 1475, 3, 'Reembolso Seg');
INSERT INTO `lang_definitions` VALUES (3757, 1476, 3, 'Resumen Seg');
INSERT INTO `lang_definitions` VALUES (3758, 1477, 3, 'Seg1');
INSERT INTO `lang_definitions` VALUES (3759, 1478, 3, 'Seg2');
INSERT INTO `lang_definitions` VALUES (3760, 1479, 3, 'Seg3');
INSERT INTO `lang_definitions` VALUES (3761, 1480, 3, 'Insertar fallido:');
INSERT INTO `lang_definitions` VALUES (3762, 1481, 3, 'Introduzca los eventos antiguos en tablas');
INSERT INTO `lang_definitions` VALUES (3763, 1482, 3, 'Insomnio');
INSERT INTO `lang_definitions` VALUES (3764, 1483, 3, 'Inspección');
INSERT INTO `lang_definitions` VALUES (3765, 1484, 3, 'Inestabilidad / subluxación');
INSERT INTO `lang_definitions` VALUES (3766, 1485, 3, 'Instalar DB');
INSERT INTO `lang_definitions` VALUES (3767, 1486, 3, 'instrucciones');
INSERT INTO `lang_definitions` VALUES (3768, 1487, 3, 'instrucciones:');
INSERT INTO `lang_definitions` VALUES (3769, 1488, 3, 'Diabetes de Dependiente de Insulina');
INSERT INTO `lang_definitions` VALUES (3770, 1489, 3, 'Seguro');
INSERT INTO `lang_definitions` VALUES (3771, 1490, 3, 'Seguro');
INSERT INTO `lang_definitions` VALUES (3772, 1491, 3, 'Compañias de Seguro');
INSERT INTO `lang_definitions` VALUES (3773, 1492, 3, 'Compañia de Seguro');
INSERT INTO `lang_definitions` VALUES (3774, 1493, 3, 'Compañia de Seguro Buscar/Añadir');
INSERT INTO `lang_definitions` VALUES (3775, 1494, 3, 'Data Seguro');
INSERT INTO `lang_definitions` VALUES (3776, 1495, 3, 'Num Seguro');
INSERT INTO `lang_definitions` VALUES (3777, 1496, 3, 'Proveedor de Seguro');
INSERT INTO `lang_definitions` VALUES (3778, 1497, 3, 'Conclusión Ingesta ');
INSERT INTO `lang_definitions` VALUES (3779, 1498, 3, 'Fecha de Ingesta');
INSERT INTO `lang_definitions` VALUES (3780, 1499, 3, 'Declinación intelectual ');
INSERT INTO `lang_definitions` VALUES (3781, 1500, 3, 'Error interno - no se seleccionó ningunas páginas! ');
INSERT INTO `lang_definitions` VALUES (3782, 1501, 3, 'Error interno - la identificación del paciente no fue proporcionada! ');
INSERT INTO `lang_definitions` VALUES (3783, 1503, 3, '¡Error interno! ');
INSERT INTO `lang_definitions` VALUES (3784, 1504, 3, 'Error interno, no identificación de drogas especificada ');
INSERT INTO `lang_definitions` VALUES (3785, 1505, 3, 'Error interno: reclamación');
INSERT INTO `lang_definitions` VALUES (3786, 1506, 3, 'Error Interno: Encuentro');
INSERT INTO `lang_definitions` VALUES (3787, 1507, 3, 'Error interno: pid o se encuentran desaparecidos. ');
INSERT INTO `lang_definitions` VALUES (3788, 1509, 3, 'Referidos Internos');
INSERT INTO `lang_definitions` VALUES (3789, 1510, 3, 'Deber Internacional');
INSERT INTO `lang_definitions` VALUES (3790, 1511, 3, 'Intérprete');
INSERT INTO `lang_definitions` VALUES (3791, 1512, 3, 'Require Intérprete?');
INSERT INTO `lang_definitions` VALUES (3792, 1513, 3, 'Enfermedad Pulmonar Intersticial ');
INSERT INTO `lang_definitions` VALUES (3793, 1514, 3, 'Intervalo');
INSERT INTO `lang_definitions` VALUES (3794, 1515, 3, 'Intolerancia ');
INSERT INTO `lang_definitions` VALUES (3795, 1516, 3, 'Intramuscularmente');
INSERT INTO `lang_definitions` VALUES (3796, 1517, 3, 'Intravenoso ');
INSERT INTO `lang_definitions` VALUES (3797, 1518, 3, 'Introducción ');
INSERT INTO `lang_definitions` VALUES (3798, 1519, 3, 'Inválido o pagador ausente en fuente para código');
INSERT INTO `lang_definitions` VALUES (3799, 1520, 3, 'Códigos de Servicio Inválidos');
INSERT INTO `lang_definitions` VALUES (3800, 1521, 3, 'Designación de la fuente inválida \"');
INSERT INTO `lang_definitions` VALUES (3801, 1522, 3, 'InvAmt');
INSERT INTO `lang_definitions` VALUES (3802, 1523, 3, 'Inventario');
INSERT INTO `lang_definitions` VALUES (3803, 1524, 3, 'El inventario no está disponible para esta orden. ');
INSERT INTO `lang_definitions` VALUES (3804, 1525, 3, 'Lista de Inventario');
INSERT INTO `lang_definitions` VALUES (3805, 1526, 3, 'Factura');
INSERT INTO `lang_definitions` VALUES (3806, 1527, 3, 'factura');
INSERT INTO `lang_definitions` VALUES (3807, 1528, 3, 'Fecha de Factura');
INSERT INTO `lang_definitions` VALUES (3808, 1529, 3, 'Factura no tiene fecha');
INSERT INTO `lang_definitions` VALUES (3809, 1530, 3, 'Factura: ');
INSERT INTO `lang_definitions` VALUES (3810, 1531, 3, 'Datos para SRH IPPF ');
INSERT INTO `lang_definitions` VALUES (3811, 1532, 3, 'Informe de las estadísticas de IPPF ');
INSERT INTO `lang_definitions` VALUES (3812, 1533, 3, 'IPV 1 ');
INSERT INTO `lang_definitions` VALUES (3813, 1534, 3, 'IPV 2');
INSERT INTO `lang_definitions` VALUES (3814, 1535, 3, 'IPV 3');
INSERT INTO `lang_definitions` VALUES (3815, 1536, 3, 'IPV 4');
INSERT INTO `lang_definitions` VALUES (3816, 1537, 3, 'Latido de Corazón Irregular');
INSERT INTO `lang_definitions` VALUES (3817, 1538, 3, 'Irritabilidad ');
INSERT INTO `lang_definitions` VALUES (3818, 1539, 3, 'Irritación ');
INSERT INTO `lang_definitions` VALUES (3819, 1540, 3, 'es un campo requerido.');
INSERT INTO `lang_definitions` VALUES (3820, 1541, 3, 'es un nodo de raíz y no puede ser suprimido. ');
INSERT INTO `lang_definitions` VALUES (3821, 1542, 3, 'no es válido (las fracciones decimales están bien).');
INSERT INTO `lang_definitions` VALUES (3822, 1543, 3, '¿El PHP utiliza el modo a prueba de fallos?');
INSERT INTO `lang_definitions` VALUES (3823, 1545, 3, 'asunto');
INSERT INTO `lang_definitions` VALUES (3824, 1546, 3, 'Asunto');
INSERT INTO `lang_definitions` VALUES (3825, 1547, 3, 'Asuntos');
INSERT INTO `lang_definitions` VALUES (3826, 1548, 3, 'Asuntos (Daños, Médicos, Alergias):');
INSERT INTO `lang_definitions` VALUES (3827, 1549, 3, 'Asuntos y Visitas');
INSERT INTO `lang_definitions` VALUES (3828, 1550, 3, 'Asuntos y Visitas por');
INSERT INTO `lang_definitions` VALUES (3829, 1551, 3, 'Asuntos no autorizados');
INSERT INTO `lang_definitions` VALUES (3830, 1552, 3, 'Sección de Cuestiones');
INSERT INTO `lang_definitions` VALUES (3831, 1553, 3, 'Artículo');
INSERT INTO `lang_definitions` VALUES (3832, 1554, 3, 'Artículo');
INSERT INTO `lang_definitions` VALUES (3833, 1555, 3, 'La carga de artículos falló');
INSERT INTO `lang_definitions` VALUES (3834, 1556, 3, 'IUD');
INSERT INTO `lang_definitions` VALUES (3835, 1557, 3, 'IV');
INSERT INTO `lang_definitions` VALUES (3836, 1558, 3, 'Enero');
INSERT INTO `lang_definitions` VALUES (3837, 1559, 3, 'Ictericia ');
INSERT INTO `lang_definitions` VALUES (3838, 1560, 3, 'Descripción del trabajo');
INSERT INTO `lang_definitions` VALUES (3839, 1561, 3, 'Identificación del trabajo ');
INSERT INTO `lang_definitions` VALUES (3840, 1562, 3, 'Dislocaciones de articulaciones');
INSERT INTO `lang_definitions` VALUES (3841, 1563, 3, 'Dolor en las Articulaciones ');
INSERT INTO `lang_definitions` VALUES (3842, 1564, 3, 'Esguinces de articulaciones');
INSERT INTO `lang_definitions` VALUES (3843, 1565, 3, 'Julio');
INSERT INTO `lang_definitions` VALUES (3844, 1566, 3, 'Junio');
INSERT INTO `lang_definitions` VALUES (3845, 1567, 3, 'Justo debajo, la información de comprobación es un área azul donde pones los parámetros de búsqueda. Puedes buscar por nombre del paciente, número de informe, número de cita o fecha de servicio, o cualquier combinación de éstas. Tu también puedes seleccionar si quieres ver todas las facturas, facturas abiertas o sólo las que debe el paciente. Pincha el botón de búsqueda para realizarla.');
INSERT INTO `lang_definitions` VALUES (3846, 1568, 3, 'Solo mío');
INSERT INTO `lang_definitions` VALUES (3847, 1569, 3, 'Justificar');
INSERT INTO `lang_definitions` VALUES (3848, 1570, 3, 'Justificar / Guardar');
INSERT INTO `lang_definitions` VALUES (3849, 1571, 3, 'k, aquí está el resto ');
INSERT INTO `lang_definitions` VALUES (3850, 1572, 3, 'Palabras Claves');
INSERT INTO `lang_definitions` VALUES (3851, 1573, 3, 'kg');
INSERT INTO `lang_definitions` VALUES (3852, 1574, 3, 'kg/m^2');
INSERT INTO `lang_definitions` VALUES (3853, 1575, 3, 'Cáncer de Riñon');
INSERT INTO `lang_definitions` VALUES (3854, 1576, 3, 'Fallo Renal');
INSERT INTO `lang_definitions` VALUES (3855, 1577, 3, 'Infecciones de Riñón');
INSERT INTO `lang_definitions` VALUES (3856, 1578, 3, 'Piedra en el Riñón');
INSERT INTO `lang_definitions` VALUES (3857, 1579, 3, 'Transplante de Riñon');
INSERT INTO `lang_definitions` VALUES (3858, 1580, 3, 'Rodilla');
INSERT INTO `lang_definitions` VALUES (3859, 1581, 3, 'Problemas de la rodilla');
INSERT INTO `lang_definitions` VALUES (3860, 1582, 3, 'Reemplazo de Rodilla');
INSERT INTO `lang_definitions` VALUES (3861, 1583, 3, 'Laboratorio');
INSERT INTO `lang_definitions` VALUES (3862, 1584, 3, 'Informe del Laboratorio ');
INSERT INTO `lang_definitions` VALUES (3863, 1585, 3, 'Etiqueta');
INSERT INTO `lang_definitions` VALUES (3864, 1586, 3, 'Etiqueta no puede estar en blanco ');
INSERT INTO `lang_definitions` VALUES (3865, 1587, 3, 'Col etiqueta');
INSERT INTO `lang_definitions` VALUES (3866, 1589, 3, 'Etiquetas');
INSERT INTO `lang_definitions` VALUES (3867, 1590, 3, 'Laboratorio');
INSERT INTO `lang_definitions` VALUES (3868, 1591, 3, 'Laceración/Cond. Piel');
INSERT INTO `lang_definitions` VALUES (3869, 1592, 3, 'Laceración/abrasión');
INSERT INTO `lang_definitions` VALUES (3870, 1593, 3, 'Idioma');
INSERT INTO `lang_definitions` VALUES (3871, 1594, 3, 'Codio Idioma');
INSERT INTO `lang_definitions` VALUES (3872, 1595, 3, 'La definición de lengua añadió');
INSERT INTO `lang_definitions` VALUES (3873, 1596, 3, 'Herramienta de interfaz de idioma ');
INSERT INTO `lang_definitions` VALUES (3874, 1597, 3, 'Lista lengua (escribir, addonly opcional) ');
INSERT INTO `lang_definitions` VALUES (3875, 1598, 3, 'Nombre Idioma');
INSERT INTO `lang_definitions` VALUES (3876, 1599, 3, 'Idioma:');
INSERT INTO `lang_definitions` VALUES (3877, 1600, 3, 'Último ');
INSERT INTO `lang_definitions` VALUES (3878, 1601, 3, 'Última Actividad Fecha');
INSERT INTO `lang_definitions` VALUES (3879, 1602, 3, 'Última Fecha de Cuenta');
INSERT INTO `lang_definitions` VALUES (3880, 1603, 3, 'Último Encuentro');
INSERT INTO `lang_definitions` VALUES (3881, 1604, 3, 'Apellido:');
INSERT INTO `lang_definitions` VALUES (3882, 1605, 3, 'Apellido:');
INSERT INTO `lang_definitions` VALUES (3883, 1606, 3, 'Apellido:');
INSERT INTO `lang_definitions` VALUES (3884, 1607, 3, 'Última guardados ');
INSERT INTO `lang_definitions` VALUES (3885, 1608, 3, 'Última actualización por ');
INSERT INTO `lang_definitions` VALUES (3886, 1609, 3, 'Última Visita');
INSERT INTO `lang_definitions` VALUES (3887, 1610, 3, 'Tarde araecurrencia (2-12 Mes)');
INSERT INTO `lang_definitions` VALUES (3888, 1611, 3, 'Maléolo lateral');
INSERT INTO `lang_definitions` VALUES (3889, 1612, 3, 'Maléolo lateral:');
INSERT INTO `lang_definitions` VALUES (3890, 1613, 3, 'desplazados lateralmente PMI: ');
INSERT INTO `lang_definitions` VALUES (3891, 1614, 3, 'Diseño de la base ');
INSERT INTO `lang_definitions` VALUES (3892, 1615, 3, 'Redactor de Disposición');
INSERT INTO `lang_definitions` VALUES (3893, 1617, 3, 'Diseño basado en la visita las formas ');
INSERT INTO `lang_definitions` VALUES (3894, 1618, 3, 'Disposición');
INSERT INTO `lang_definitions` VALUES (3895, 1619, 3, 'libra ');
INSERT INTO `lang_definitions` VALUES (3896, 1620, 3, 'libra');
INSERT INTO `lang_definitions` VALUES (3897, 1621, 3, 'LDL');
INSERT INTO `lang_definitions` VALUES (3898, 1622, 3, 'dejar en blanco si sigue activo');
INSERT INTO `lang_definitions` VALUES (3899, 1623, 3, 'Deje en blanco para no cambiar la contraseña');
INSERT INTO `lang_definitions` VALUES (3900, 1624, 3, 'Dejar mensaje Con');
INSERT INTO `lang_definitions` VALUES (3901, 1625, 3, 'Salir del Formulario');
INSERT INTO `lang_definitions` VALUES (3902, 1626, 3, 'Izquierda');
INSERT INTO `lang_definitions` VALUES (3903, 1627, 3, 'Oído izquierdo ');
INSERT INTO `lang_definitions` VALUES (3904, 1628, 3, 'oreja izquierda');
INSERT INTO `lang_definitions` VALUES (3905, 1629, 3, 'Interstitial Lung Disease');
INSERT INTO `lang_definitions` VALUES (3906, 1630, 3, 'Izquierda: ');
INSERT INTO `lang_definitions` VALUES (3907, 1631, 3, 'Dolor de Pierna/Calambres ');
INSERT INTO `lang_definitions` VALUES (3908, 1632, 3, 'Legal');
INSERT INTO `lang_definitions` VALUES (3909, 1633, 3, 'Leyenda:');
INSERT INTO `lang_definitions` VALUES (3910, 1634, 3, 'Longitud');
INSERT INTO `lang_definitions` VALUES (3911, 1635, 3, 'Menos la información privada (escribir, addonly opcional) ');
INSERT INTO `lang_definitions` VALUES (3912, 1636, 3, 'Carta');
INSERT INTO `lang_definitions` VALUES (3913, 1637, 3, 'Carta');
INSERT INTO `lang_definitions` VALUES (3914, 1640, 3, 'Nivel de urgencia');
INSERT INTO `lang_definitions` VALUES (3915, 1641, 3, 'Responsabilidad ');
INSERT INTO `lang_definitions` VALUES (3916, 1642, 3, 'Responsabilidad Médica');
INSERT INTO `lang_definitions` VALUES (3917, 1643, 3, 'Licencia / Identificación');
INSERT INTO `lang_definitions` VALUES (3918, 1644, 3, 'Estilo de Vida');
INSERT INTO `lang_definitions` VALUES (3919, 1645, 3, 'Rasgón o esguince del ligamento ');
INSERT INTO `lang_definitions` VALUES (3920, 1646, 3, 'Límite de Eventos');
INSERT INTO `lang_definitions` VALUES (3921, 1649, 3, 'Lista');
INSERT INTO `lang_definitions` VALUES (3922, 1651, 3, 'caja de lista');
INSERT INTO `lang_definitions` VALUES (3923, 1652, 3, 'agrega cuadro de lista ');
INSERT INTO `lang_definitions` VALUES (3924, 1654, 3, 'Editor de Lista');
INSERT INTO `lang_definitions` VALUES (3925, 1656, 3, 'Lista Compañias Seguro');
INSERT INTO `lang_definitions` VALUES (3926, 1659, 3, 'Lista Listas');
INSERT INTO `lang_definitions` VALUES (3927, 1660, 3, 'Lista de Nombres');
INSERT INTO `lang_definitions` VALUES (3928, 1661, 3, 'Lista de los nombres no pueden empezar con números. ');
INSERT INTO `lang_definitions` VALUES (3929, 1662, 3, 'Lista de Recetas');
INSERT INTO `lang_definitions` VALUES (3930, 1663, 3, 'Listas');
INSERT INTO `lang_definitions` VALUES (3931, 1664, 3, 'LLL:');
INSERT INTO `lang_definitions` VALUES (3932, 1665, 3, 'LMP');
INSERT INTO `lang_definitions` VALUES (3933, 1667, 3, 'Cargando');
INSERT INTO `lang_definitions` VALUES (3934, 1668, 3, 'LOC');
INSERT INTO `lang_definitions` VALUES (3935, 1669, 3, 'Local');
INSERT INTO `lang_definitions` VALUES (3936, 1670, 3, 'Localidad ');
INSERT INTO `lang_definitions` VALUES (3937, 1671, 3, 'Localización ');
INSERT INTO `lang_definitions` VALUES (3938, 1672, 3, 'Lugar no especificado');
INSERT INTO `lang_definitions` VALUES (3939, 1673, 3, 'Localización:');
INSERT INTO `lang_definitions` VALUES (3940, 1675, 3, 'Iniciar sesión');
INSERT INTO `lang_definitions` VALUES (3941, 1676, 3, 'Abierto una sesión como');
INSERT INTO `lang_definitions` VALUES (3942, 1677, 3, 'Abierto una sesión como:');
INSERT INTO `lang_definitions` VALUES (3943, 1678, 3, 'Salir de sesión.');
INSERT INTO `lang_definitions` VALUES (3944, 1679, 3, 'Conexión');
INSERT INTO `lang_definitions` VALUES (3945, 1680, 3, 'conexión');
INSERT INTO `lang_definitions` VALUES (3946, 1681, 3, 'Cerrar sesión');
INSERT INTO `lang_definitions` VALUES (3947, 1682, 3, 'cerrar sesión');
INSERT INTO `lang_definitions` VALUES (3948, 1683, 3, 'Registros');
INSERT INTO `lang_definitions` VALUES (3949, 1684, 3, 'Espectador de los registros ');
INSERT INTO `lang_definitions` VALUES (3950, 1685, 3, 'Buscar');
INSERT INTO `lang_definitions` VALUES (3951, 1686, 3, 'Lote');
INSERT INTO `lang_definitions` VALUES (3952, 1687, 3, 'Identificación del lote que faltan! ');
INSERT INTO `lang_definitions` VALUES (3953, 1688, 3, 'Número de Lote ');
INSERT INTO `lang_definitions` VALUES (3954, 1689, 3, 'Bajo');
INSERT INTO `lang_definitions` VALUES (3955, 1690, 3, 'Pierna inferior');
INSERT INTO `lang_definitions` VALUES (3956, 1691, 3, 'Columna lumbar');
INSERT INTO `lang_definitions` VALUES (3957, 1692, 3, 'ALMUERZO ');
INSERT INTO `lang_definitions` VALUES (3958, 1693, 3, 'almuerzo');
INSERT INTO `lang_definitions` VALUES (3959, 1694, 3, 'cáncer de pulmón');
INSERT INTO `lang_definitions` VALUES (3960, 1695, 3, 'Cirugía del cáncer de pulmón ');
INSERT INTO `lang_definitions` VALUES (3961, 1696, 3, 'PULMONES:');
INSERT INTO `lang_definitions` VALUES (3962, 1697, 3, 'pulmones:');
INSERT INTO `lang_definitions` VALUES (3963, 1698, 3, 'Lupus');
INSERT INTO `lang_definitions` VALUES (3964, 1699, 3, 'M');
INSERT INTO `lang_definitions` VALUES (3965, 1700, 3, 'Categoría de MA ');
INSERT INTO `lang_definitions` VALUES (3966, 1701, 3, 'Dirección principal');
INSERT INTO `lang_definitions` VALUES (3967, 1702, 3, 'Hacer modificaciones a las actuales categorías.');
INSERT INTO `lang_definitions` VALUES (3968, 1703, 3, 'Cerciorarse \"');
INSERT INTO `lang_definitions` VALUES (3969, 1704, 3, 'Malestar: ');
INSERT INTO `lang_definitions` VALUES (3970, 1705, 3, 'Masculino');
INSERT INTO `lang_definitions` VALUES (3971, 1706, 3, 'Condones Masculinos ');
INSERT INTO `lang_definitions` VALUES (3972, 1707, 3, 'Varón VSC ');
INSERT INTO `lang_definitions` VALUES (3973, 1708, 3, 'Mamograma');
INSERT INTO `lang_definitions` VALUES (3974, 1709, 3, 'Gerencia');
INSERT INTO `lang_definitions` VALUES (3975, 1710, 3, 'Manual de envío');
INSERT INTO `lang_definitions` VALUES (3976, 1711, 3, 'Fabricante');
INSERT INTO `lang_definitions` VALUES (3977, 1712, 3, 'Marzo');
INSERT INTO `lang_definitions` VALUES (3978, 1713, 3, 'Estado Civil');
INSERT INTO `lang_definitions` VALUES (3979, 1714, 3, 'Marcar como facturado pero saltar de facturación');
INSERT INTO `lang_definitions` VALUES (3980, 1715, 3, 'Marcar como Resueltos ');
INSERT INTO `lang_definitions` VALUES (3981, 1716, 3, 'Marcar como no facturados');
INSERT INTO `lang_definitions` VALUES (3982, 1717, 3, 'Marcado como despejado');
INSERT INTO `lang_definitions` VALUES (3983, 1718, 3, 'Casado');
INSERT INTO `lang_definitions` VALUES (3984, 1719, 3, 'La derecha maxilar: ');
INSERT INTO `lang_definitions` VALUES (3985, 1720, 3, 'Mayo');
INSERT INTO `lang_definitions` VALUES (3986, 1721, 3, 'MC');
INSERT INTO `lang_definitions` VALUES (3987, 1722, 3, 'magnetocardiograma ');
INSERT INTO `lang_definitions` VALUES (3988, 1723, 3, 'Maléolo medial: ');
INSERT INTO `lang_definitions` VALUES (3989, 1724, 3, 'Seguro de enfermedad');
INSERT INTO `lang_definitions` VALUES (3990, 1725, 3, 'Médico');
INSERT INTO `lang_definitions` VALUES (3991, 1726, 3, 'Aborto Médico');
INSERT INTO `lang_definitions` VALUES (3992, 1727, 3, 'Problema médico');
INSERT INTO `lang_definitions` VALUES (3993, 1728, 3, 'Problemas médico');
INSERT INTO `lang_definitions` VALUES (3994, 1729, 3, 'Registro Médico');
INSERT INTO `lang_definitions` VALUES (3995, 1730, 3, 'Informe médico # ');
INSERT INTO `lang_definitions` VALUES (3996, 1731, 3, 'Registros Médico');
INSERT INTO `lang_definitions` VALUES (3997, 1732, 3, 'Médico / Historia (escribir, addonly opcional) ');
INSERT INTO `lang_definitions` VALUES (3998, 1733, 3, 'Parte B de Seguro de enfermedad');
INSERT INTO `lang_definitions` VALUES (3999, 1734, 3, 'Medicación ');
INSERT INTO `lang_definitions` VALUES (4000, 1735, 3, 'Medicamentos');
INSERT INTO `lang_definitions` VALUES (4001, 1736, 3, 'Medicamentos:');
INSERT INTO `lang_definitions` VALUES (4002, 1737, 3, 'Unidades de Medicina');
INSERT INTO `lang_definitions` VALUES (4003, 1738, 3, 'Mediano');
INSERT INTO `lang_definitions` VALUES (4004, 1739, 3, 'Miembro de la Asociación de Estadística Informe');
INSERT INTO `lang_definitions` VALUES (4005, 1740, 3, 'Problemas de Memoria ');
INSERT INTO `lang_definitions` VALUES (4006, 1741, 3, 'Hombres');
INSERT INTO `lang_definitions` VALUES (4007, 1742, 3, 'Hombres y Mujeres');
INSERT INTO `lang_definitions` VALUES (4008, 1743, 3, 'Hombres Solamente');
INSERT INTO `lang_definitions` VALUES (4009, 1744, 3, 'Menarquía ');
INSERT INTO `lang_definitions` VALUES (4010, 1745, 3, 'Menopausia ');
INSERT INTO `lang_definitions` VALUES (4011, 1746, 3, 'Flujo Menstrual ');
INSERT INTO `lang_definitions` VALUES (4012, 1747, 3, 'Menstrual Frequency');
INSERT INTO `lang_definitions` VALUES (4013, 1748, 3, 'Enfermedad Mental');
INSERT INTO `lang_definitions` VALUES (4014, 1749, 3, 'Mensaje');
INSERT INTO `lang_definitions` VALUES (4015, 1750, 3, 'MENSAJE:');
INSERT INTO `lang_definitions` VALUES (4016, 1751, 3, 'Método');
INSERT INTO `lang_definitions` VALUES (4017, 1752, 3, 'Método de destrucción');
INSERT INTO `lang_definitions` VALUES (4018, 1753, 3, 'mg');
INSERT INTO `lang_definitions` VALUES (4019, 1754, 3, 'mg/1cc');
INSERT INTO `lang_definitions` VALUES (4020, 1755, 3, 'mg/2cc');
INSERT INTO `lang_definitions` VALUES (4021, 1756, 3, 'mg/3cc');
INSERT INTO `lang_definitions` VALUES (4022, 1757, 3, 'mg/4cc');
INSERT INTO `lang_definitions` VALUES (4023, 1758, 3, 'mg/5cc');
INSERT INTO `lang_definitions` VALUES (4024, 1759, 3, 'Segundo');
INSERT INTO `lang_definitions` VALUES (4025, 1760, 3, 'Segundo Nombre');
INSERT INTO `lang_definitions` VALUES (4026, 1761, 3, 'Segundo nombre');
INSERT INTO `lang_definitions` VALUES (4027, 1762, 3, 'Migrante o trabajador de temporada?');
INSERT INTO `lang_definitions` VALUES (4028, 1763, 3, 'Migrantes / temporada');
INSERT INTO `lang_definitions` VALUES (4029, 1764, 3, 'Mime Tipo');
INSERT INTO `lang_definitions` VALUES (4030, 1766, 3, 'Menor tensión conjunta /-Sinovitis');
INSERT INTO `lang_definitions` VALUES (4031, 1767, 3, 'minutos');
INSERT INTO `lang_definitions` VALUES (4032, 1768, 3, 'Minutos');
INSERT INTO `lang_definitions` VALUES (4033, 1769, 3, 'Misceláneas');
INSERT INTO `lang_definitions` VALUES (4034, 1772, 3, 'Opciones misceláneas HCFA de la facturación ');
INSERT INTO `lang_definitions` VALUES (4035, 1773, 3, 'Misceláneo');
INSERT INTO `lang_definitions` VALUES (4036, 1774, 3, 'Faltado');
INSERT INTO `lang_definitions` VALUES (4037, 1776, 3, 'Falta el PID. ');
INSERT INTO `lang_definitions` VALUES (4038, 1777, 3, 'Raya vertical que falta después del pagador en la fuente para el código ');
INSERT INTO `lang_definitions` VALUES (4039, 1778, 3, 'Mixto');
INSERT INTO `lang_definitions` VALUES (4040, 1779, 3, 'ml');
INSERT INTO `lang_definitions` VALUES (4041, 1780, 3, 'mm/hg');
INSERT INTO `lang_definitions` VALUES (4042, 1781, 3, 'MMR 1');
INSERT INTO `lang_definitions` VALUES (4043, 1782, 3, 'MMR 2');
INSERT INTO `lang_definitions` VALUES (4044, 1783, 3, 'Móvil');
INSERT INTO `lang_definitions` VALUES (4045, 1784, 3, 'Teléfono Móvil');
INSERT INTO `lang_definitions` VALUES (4046, 1785, 3, 'Mod');
INSERT INTO `lang_definitions` VALUES (4047, 1786, 3, 'Modificador');
INSERT INTO `lang_definitions` VALUES (4048, 1787, 3, 'Lun');
INSERT INTO `lang_definitions` VALUES (4049, 1788, 3, 'Lun a Vier');
INSERT INTO `lang_definitions` VALUES (4050, 1789, 3, 'Lunes, miércoles &amperio; viernes ');
INSERT INTO `lang_definitions` VALUES (4051, 1790, 3, 'Lunes');
INSERT INTO `lang_definitions` VALUES (4052, 1791, 3, 'mes');
INSERT INTO `lang_definitions` VALUES (4053, 1792, 3, 'Mes');
INSERT INTO `lang_definitions` VALUES (4054, 1793, 3, 'Ver Mes');
INSERT INTO `lang_definitions` VALUES (4055, 1794, 3, 'Mes(es)');
INSERT INTO `lang_definitions` VALUES (4056, 1795, 3, 'Ingreso Mensual');
INSERT INTO `lang_definitions` VALUES (4057, 1796, 3, 'Más de 100 registros encontrados. Por favor, reducir su criterio de búsqueda. ');
INSERT INTO `lang_definitions` VALUES (4058, 1797, 3, 'Más de 50 resultados, por favor, hacer su búsqueda más específica.');
INSERT INTO `lang_definitions` VALUES (4059, 1798, 3, 'Madre');
INSERT INTO `lang_definitions` VALUES (4060, 1799, 3, 'Boca ');
INSERT INTO `lang_definitions` VALUES (4061, 1800, 3, 'Movimiento');
INSERT INTO `lang_definitions` VALUES (4062, 1801, 3, 'Mueva el documento a la categoría: ');
INSERT INTO `lang_definitions` VALUES (4063, 1802, 3, 'Mueve Abajo');
INSERT INTO `lang_definitions` VALUES (4064, 1803, 3, 'Trasladar al paciente');
INSERT INTO `lang_definitions` VALUES (4065, 1805, 3, 'Mueve Arriba');
INSERT INTO `lang_definitions` VALUES (4066, 1806, 3, 'Sr. ');
INSERT INTO `lang_definitions` VALUES (4067, 1807, 3, 'Señora. ');
INSERT INTO `lang_definitions` VALUES (4068, 1808, 3, 'Señorita');
INSERT INTO `lang_definitions` VALUES (4069, 1809, 3, 'Herramienta multi idioma');
INSERT INTO `lang_definitions` VALUES (4070, 1810, 3, 'Múltiples áreas');
INSERT INTO `lang_definitions` VALUES (4071, 1811, 3, 'Murmullos: ');
INSERT INTO `lang_definitions` VALUES (4072, 1812, 3, 'Dolor de Musc ');
INSERT INTO `lang_definitions` VALUES (4073, 1814, 3, 'Rojez de Musc ');
INSERT INTO `lang_definitions` VALUES (4074, 1815, 3, 'Tiesura de Musc ');
INSERT INTO `lang_definitions` VALUES (4075, 1817, 3, 'Musc Caliente ');
INSERT INTO `lang_definitions` VALUES (4076, 1818, 3, 'Músculo ');
INSERT INTO `lang_definitions` VALUES (4077, 1819, 3, 'Lesiones musculares');
INSERT INTO `lang_definitions` VALUES (4078, 1820, 3, 'Musculoesquelético ');
INSERT INTO `lang_definitions` VALUES (4079, 1821, 3, 'Definido mutuamente ');
INSERT INTO `lang_definitions` VALUES (4080, 1822, 3, 'MVA');
INSERT INTO `lang_definitions` VALUES (4081, 1823, 3, 'No Interesa');
INSERT INTO `lang_definitions` VALUES (4082, 1824, 3, 'no interesa');
INSERT INTO `lang_definitions` VALUES (4083, 1825, 3, 'Nombre');
INSERT INTO `lang_definitions` VALUES (4084, 1826, 3, 'Nombre 1');
INSERT INTO `lang_definitions` VALUES (4085, 1827, 3, 'Nombre 2');
INSERT INTO `lang_definitions` VALUES (4086, 1828, 3, 'Nombre y título del administrador de la inmunización ');
INSERT INTO `lang_definitions` VALUES (4087, 1829, 3, 'Nombre de la compañía de seguros ');
INSERT INTO `lang_definitions` VALUES (4088, 1830, 3, 'Nombre del Proveedor');
INSERT INTO `lang_definitions` VALUES (4089, 1831, 3, 'Nombre de Traducción ');
INSERT INTO `lang_definitions` VALUES (4090, 1832, 3, 'Nombre/Valor');
INSERT INTO `lang_definitions` VALUES (4091, 1833, 3, 'Nombre:');
INSERT INTO `lang_definitions` VALUES (4092, 1834, 3, 'NARES:');
INSERT INTO `lang_definitions` VALUES (4093, 1835, 3, 'NARES: Normal Derecho ');
INSERT INTO `lang_definitions` VALUES (4094, 1836, 3, 'Mucosa nasal de color rosa, septo de línea media ');
INSERT INTO `lang_definitions` VALUES (4095, 1837, 3, 'Nacionalidad');
INSERT INTO `lang_definitions` VALUES (4096, 1838, 3, 'Náuseas ');
INSERT INTO `lang_definitions` VALUES (4097, 1839, 3, 'Navegación');
INSERT INTO `lang_definitions` VALUES (4098, 1840, 3, 'NDC');
INSERT INTO `lang_definitions` VALUES (4099, 1841, 3, 'Número del NDC');
INSERT INTO `lang_definitions` VALUES (4100, 1842, 3, 'Cuello');
INSERT INTO `lang_definitions` VALUES (4101, 1843, 3, 'Problemas de Cuello');
INSERT INTO `lang_definitions` VALUES (4102, 1844, 3, 'Cuello flexible ');
INSERT INTO `lang_definitions` VALUES (4103, 1845, 3, 'Necesidad de introducir una descripción');
INSERT INTO `lang_definitions` VALUES (4104, 1846, 3, 'Necesidad de introducir un Valor de Retorno');
INSERT INTO `lang_definitions` VALUES (4105, 1847, 3, 'Necesidad de entrar en el identificador ');
INSERT INTO `lang_definitions` VALUES (4106, 1848, 3, 'Necesidad de incorporar título ');
INSERT INTO `lang_definitions` VALUES (4107, 1851, 3, 'Necesita la facturación secundaria ');
INSERT INTO `lang_definitions` VALUES (4108, 1852, 3, 'Lesión del nervio');
INSERT INTO `lang_definitions` VALUES (4109, 1853, 3, 'Condición neural / daño en los nervios');
INSERT INTO `lang_definitions` VALUES (4110, 1854, 3, 'Entumecimiento Neuro ');
INSERT INTO `lang_definitions` VALUES (4111, 1855, 3, 'Debilidad Neura ');
INSERT INTO `lang_definitions` VALUES (4112, 1856, 3, 'Neurológico ');
INSERT INTO `lang_definitions` VALUES (4113, 1857, 3, 'Nuevo');
INSERT INTO `lang_definitions` VALUES (4114, 1858, 3, 'Nuevo=>');
INSERT INTO `lang_definitions` VALUES (4115, 1859, 3, 'Nuevos aceptadores ');
INSERT INTO `lang_definitions` VALUES (4116, 1860, 3, 'Nueva alergia ');
INSERT INTO `lang_definitions` VALUES (4117, 1861, 3, 'Cita Nueva');
INSERT INTO `lang_definitions` VALUES (4118, 1862, 3, 'Categoria Nueva');
INSERT INTO `lang_definitions` VALUES (4119, 1863, 3, 'Nueva Categoría ');
INSERT INTO `lang_definitions` VALUES (4120, 1864, 3, 'Cliente Nuevo');
INSERT INTO `lang_definitions` VALUES (4121, 1865, 3, 'Nueva consulta ');
INSERT INTO `lang_definitions` VALUES (4122, 1866, 3, 'Nueva definición añadido');
INSERT INTO `lang_definitions` VALUES (4123, 1867, 3, 'Nuevo documento ');
INSERT INTO `lang_definitions` VALUES (4124, 1868, 3, 'Nueva forma del encuentro');
INSERT INTO `lang_definitions` VALUES (4125, 1869, 3, 'Nuevos encuentros no autorizados ');
INSERT INTO `lang_definitions` VALUES (4126, 1870, 3, 'Nuevos Enctr');
INSERT INTO `lang_definitions` VALUES (4127, 1871, 3, 'Nueva información de la facilidad ');
INSERT INTO `lang_definitions` VALUES (4128, 1872, 3, 'Grupo Nuevo');
INSERT INTO `lang_definitions` VALUES (4129, 1873, 3, 'Nuevo Grupo de Información ');
INSERT INTO `lang_definitions` VALUES (4130, 1874, 3, 'Nuevo límite de Eventos');
INSERT INTO `lang_definitions` VALUES (4131, 1875, 3, 'Nueva Lista ');
INSERT INTO `lang_definitions` VALUES (4132, 1876, 3, 'Paciente Nuevo');
INSERT INTO `lang_definitions` VALUES (4133, 1877, 3, 'Nuevo Encuentro de Paciente');
INSERT INTO `lang_definitions` VALUES (4134, 1878, 3, 'Identificación del Paciente Nuevo ');
INSERT INTO `lang_definitions` VALUES (4135, 1879, 3, 'Nuevos Pt');
INSERT INTO `lang_definitions` VALUES (4136, 1880, 3, 'Nuevas sumisiones ');
INSERT INTO `lang_definitions` VALUES (4137, 1881, 3, 'Usuario Nuevo');
INSERT INTO `lang_definitions` VALUES (4138, 1882, 3, 'Nueva visita');
INSERT INTO `lang_definitions` VALUES (4139, 1883, 3, 'Nuevo/búsqueda ');
INSERT INTO `lang_definitions` VALUES (4140, 1884, 3, 'Periódico');
INSERT INTO `lang_definitions` VALUES (4141, 1885, 3, 'Próximo');
INSERT INTO `lang_definitions` VALUES (4142, 1886, 3, 'Próximo Dia');
INSERT INTO `lang_definitions` VALUES (4143, 1887, 3, 'Próximo mes');
INSERT INTO `lang_definitions` VALUES (4144, 1888, 3, 'Próxima semana');
INSERT INTO `lang_definitions` VALUES (4145, 1889, 3, 'Apodo');
INSERT INTO `lang_definitions` VALUES (4146, 1890, 3, 'Sudores nocturnos');
INSERT INTO `lang_definitions` VALUES (4147, 1891, 3, 'Órganos genitales de la extensión de NL, mucosa de vag, cuello uterino');
INSERT INTO `lang_definitions` VALUES (4148, 1892, 3, 'NO');
INSERT INTO `lang_definitions` VALUES (4149, 1893, 3, 'No');
INSERT INTO `lang_definitions` VALUES (4150, 1894, 3, 'No tienen acceso');
INSERT INTO `lang_definitions` VALUES (4151, 1895, 3, 'No adenopatías (2 áreas requeridas)');
INSERT INTO `lang_definitions` VALUES (4152, 1896, 3, 'Sin adnexal delicado/masa');
INSERT INTO `lang_definitions` VALUES (4153, 1897, 3, 'Sistema de facturación no se encuentra activa');
INSERT INTO `lang_definitions` VALUES (4154, 1898, 3, 'Ningunas cuentas encontraron para incluir en la exportación de OFX ');
INSERT INTO `lang_definitions` VALUES (4155, 1899, 3, 'No se ha especificado el código!');
INSERT INTO `lang_definitions` VALUES (4156, 1900, 3, 'Ninguna diagnosis ');
INSERT INTO `lang_definitions` VALUES (4157, 1901, 3, 'Sin fecha de finalización');
INSERT INTO `lang_definitions` VALUES (4158, 1902, 3, 'No se encuentran entradas, utilice el formulario que aparece a continuación para agregar una entrada.');
INSERT INTO `lang_definitions` VALUES (4159, 1903, 3, 'Ningunos Eventos');
INSERT INTO `lang_definitions` VALUES (4160, 1904, 3, 'Ningún grupo fue seleccionado');
INSERT INTO `lang_definitions` VALUES (4161, 1905, 3, 'Ninguna hernia ');
INSERT INTO `lang_definitions` VALUES (4162, 1906, 3, 'Ningunas compañías de seguros encontraron ');
INSERT INTO `lang_definitions` VALUES (4163, 1908, 3, 'Ninguna masas, ternura');
INSERT INTO `lang_definitions` VALUES (4164, 1909, 3, 'Ningunas notas ');
INSERT INTO `lang_definitions` VALUES (4165, 1910, 3, 'No ogrganomegoly');
INSERT INTO `lang_definitions` VALUES (4166, 1911, 3, 'No se encontraron aberturas para este período. ');
INSERT INTO `lang_definitions` VALUES (4167, 1912, 3, 'Socios no encontrado');
INSERT INTO `lang_definitions` VALUES (4168, 1913, 3, 'Ningún edema periférico');
INSERT INTO `lang_definitions` VALUES (4169, 1914, 3, 'Ningunas farmacias encontrada');
INSERT INTO `lang_definitions` VALUES (4170, 1915, 3, 'Ningunas prescripciones encontradas');
INSERT INTO `lang_definitions` VALUES (4171, 1916, 3, 'Ninguna actuales enfermedad/lesión ');
INSERT INTO `lang_definitions` VALUES (4172, 1917, 3, 'Ningun proveedor encontrado');
INSERT INTO `lang_definitions` VALUES (4173, 1918, 3, 'Ninguna erupción o lesiones anormales ');
INSERT INTO `lang_definitions` VALUES (4174, 1919, 3, 'Ningunos expedientes encontraron. Amplíe por favor sus criterios de búsqueda. ');
INSERT INTO `lang_definitions` VALUES (4175, 1921, 3, 'Ningunos resultados encontraron para la búsqueda ');
INSERT INTO `lang_definitions` VALUES (4176, 1922, 3, 'Ningun resultado, por favor trate de nuevo');
INSERT INTO `lang_definitions` VALUES (4177, 1924, 3, 'Ausente');
INSERT INTO `lang_definitions` VALUES (4178, 1925, 3, 'Ninguna Ternura del Seno: ');
INSERT INTO `lang_definitions` VALUES (4179, 1926, 3, 'Ningunos nódulos the formar hoyuelos o del pecho de la piel');
INSERT INTO `lang_definitions` VALUES (4180, 1927, 3, 'No hay sensibilidad testicular, masas');
INSERT INTO `lang_definitions` VALUES (4181, 1928, 3, 'Ningunas emociones o tirones ');
INSERT INTO `lang_definitions` VALUES (4182, 1930, 3, 'No, Cancelar');
INSERT INTO `lang_definitions` VALUES (4183, 1931, 3, 'No:');
INSERT INTO `lang_definitions` VALUES (4184, 1932, 3, 'Nicturia ');
INSERT INTO `lang_definitions` VALUES (4185, 1933, 3, 'Lesión no específica ');
INSERT INTO `lang_definitions` VALUES (4186, 1934, 3, 'Non-insulin dependent diabetes');
INSERT INTO `lang_definitions` VALUES (4187, 1935, 3, 'NinguÌn sensibilidad testicular, masas del heno');
INSERT INTO `lang_definitions` VALUES (4188, 1936, 3, 'No-SRH No-Médico');
INSERT INTO `lang_definitions` VALUES (4189, 1937, 3, 'Ninguno');
INSERT INTO `lang_definitions` VALUES (4190, 1938, 3, 'ninguno');
INSERT INTO `lang_definitions` VALUES (4191, 1939, 3, 'Ninguna de las anteriores ');
INSERT INTO `lang_definitions` VALUES (4192, 1940, 3, 'Diabetes del dependiente de Noninsulin ');
INSERT INTO `lang_definitions` VALUES (4193, 1941, 3, 'Tampoco ');
INSERT INTO `lang_definitions` VALUES (4194, 1942, 3, 'Normal');
INSERT INTO `lang_definitions` VALUES (4195, 1943, 3, 'Normal BL');
INSERT INTO `lang_definitions` VALUES (4196, 1944, 3, 'Examen Cardiaco Normal: ');
INSERT INTO `lang_definitions` VALUES (4197, 1945, 3, 'Examen Cardiaco Normal: ');
INSERT INTO `lang_definitions` VALUES (4198, 1946, 3, 'Examen Normal del Pulmón: ');
INSERT INTO `lang_definitions` VALUES (4199, 1947, 3, 'Examen Normal del Pulmón:');
INSERT INTO `lang_definitions` VALUES (4200, 1948, 3, 'Visitar la Oficina normal');
INSERT INTO `lang_definitions` VALUES (4201, 1949, 3, 'Orofaringe normal:');
INSERT INTO `lang_definitions` VALUES (4202, 1950, 3, 'Derecho Normal ');
INSERT INTO `lang_definitions` VALUES (4203, 1951, 3, 'Derecho Normal: ');
INSERT INTO `lang_definitions` VALUES (4204, 1952, 3, 'Ver Normal');
INSERT INTO `lang_definitions` VALUES (4205, 1953, 3, 'normal:');
INSERT INTO `lang_definitions` VALUES (4206, 1954, 3, 'Noruego');
INSERT INTO `lang_definitions` VALUES (4207, 1955, 3, 'Nariz ');
INSERT INTO `lang_definitions` VALUES (4208, 1956, 3, 'Sangrado por la nariz ');
INSERT INTO `lang_definitions` VALUES (4209, 1957, 3, 'No todos los campos son obligatorios para todos los códigos o tipos de códigos.');
INSERT INTO `lang_definitions` VALUES (4210, 1958, 3, 'No permitido ');
INSERT INTO `lang_definitions` VALUES (4211, 1959, 3, 'No pueden eliminar el grupo Administradores');
INSERT INTO `lang_definitions` VALUES (4212, 1960, 3, 'No pueden inactivar todos los objetos de seguridad');
INSERT INTO `lang_definitions` VALUES (4213, 1961, 3, 'No permitido hacer inactivo cualquier cosa de los administradores ACL ');
INSERT INTO `lang_definitions` VALUES (4214, 1962, 3, 'No pueden eliminar el usuario administrador del grupo Administradores');
INSERT INTO `lang_definitions` VALUES (4215, 1963, 3, 'No autorizado para tener acceso al módulo de PosteCalendario ');
INSERT INTO `lang_definitions` VALUES (4216, 1964, 3, 'No autorizado');
INSERT INTO `lang_definitions` VALUES (4217, 1965, 3, 'No autorizados para este equipo.');
INSERT INTO `lang_definitions` VALUES (4218, 1969, 3, 'No examinado');
INSERT INTO `lang_definitions` VALUES (4219, 1970, 3, 'No Examinado:');
INSERT INTO `lang_definitions` VALUES (4220, 1971, 3, 'No Examinado:');
INSERT INTO `lang_definitions` VALUES (4221, 1972, 3, 'No se ha encontrado');
INSERT INTO `lang_definitions` VALUES (4222, 1973, 3, 'No encontrado! ');
INSERT INTO `lang_definitions` VALUES (4223, 1974, 3, 'No visto desde');
INSERT INTO `lang_definitions` VALUES (4224, 1975, 3, 'Nota');
INSERT INTO `lang_definitions` VALUES (4225, 1976, 3, 'Tipo de Nota');
INSERT INTO `lang_definitions` VALUES (4226, 1977, 3, 'Nota: este código no fue por un usuario autorizado. Sólo están autorizados los códigos pueden ser subidos a la Red Abierta de facturación médica para su procesamiento. Si desea cargar estos códigos, por favor, seleccione un usuario autorizado aquí.');
INSERT INTO `lang_definitions` VALUES (4227, 1978, 3, 'NOTA: Los archivos que cargan con nombres duplicados harán los archivos ser retitulados automáticamente. Por ejemplo \' archivo.jpg\' se convertirá \' archivo.jpg.1\'. Los nombres de fichero se consideran únicos por paciente, no por categoría.');
INSERT INTO `lang_definitions` VALUES (4228, 1979, 3, 'Notas');
INSERT INTO `lang_definitions` VALUES (4229, 1980, 3, 'Notas - cualquier encuentros (escribir, sólo añadir opcional) ');
INSERT INTO `lang_definitions` VALUES (4230, 1981, 3, 'Notas - mis encuentros (escribir, sólo añadir opcional) ');
INSERT INTO `lang_definitions` VALUES (4231, 1982, 3, 'Notas no autorizados');
INSERT INTO `lang_definitions` VALUES (4232, 1983, 3, 'Nada fue seleccionado');
INSERT INTO `lang_definitions` VALUES (4233, 1984, 3, 'AVISO:: Sumisión/modificación de PosteCalendario');
INSERT INTO `lang_definitions` VALUES (4234, 1985, 3, 'Notificación');
INSERT INTO `lang_definitions` VALUES (4235, 1986, 3, 'Notificar Administrador Acerca del Evento de presentación / Modificación? ');
INSERT INTO `lang_definitions` VALUES (4236, 1987, 3, 'Noviembre');
INSERT INTO `lang_definitions` VALUES (4237, 1988, 3, 'Ahora, la publicación de:');
INSERT INTO `lang_definitions` VALUES (4238, 1989, 3, 'Ahora impresión $ stmt_contra declaraciones y actualización de los encuentros. ');
INSERT INTO `lang_definitions` VALUES (4239, 1990, 3, 'Ahora declaraciones de la impresión $stmt_contra y facturas de la puesta al día. ');
INSERT INTO `lang_definitions` VALUES (4240, 1991, 3, 'Ahora declaraciones de la impresión $stmt_contra; los encuentros no serán actualizados. ');
INSERT INTO `lang_definitions` VALUES (4241, 1992, 3, 'Ahora declaraciones de la impresión $stmt_contra; las facturas no serán actualizadas. ');
INSERT INTO `lang_definitions` VALUES (4242, 1993, 3, 'NPI');
INSERT INTO `lang_definitions` VALUES (4243, 1994, 3, 'Número');
INSERT INTO `lang_definitions` VALUES (4244, 1995, 3, 'Número de columnas de opinión en el año.');
INSERT INTO `lang_definitions` VALUES (4245, 1996, 3, 'Número de perdidas en juegos o eventos, en su caso ');
INSERT INTO `lang_definitions` VALUES (4246, 1997, 3, 'Entumecimiento ');
INSERT INTO `lang_definitions` VALUES (4247, 1998, 3, 'O.A.F.V.');
INSERT INTO `lang_definitions` VALUES (4248, 2000, 3, 'Obesidad I ');
INSERT INTO `lang_definitions` VALUES (4249, 2001, 3, 'Obesidad II ');
INSERT INTO `lang_definitions` VALUES (4250, 2002, 3, 'Obesidad III ');
INSERT INTO `lang_definitions` VALUES (4251, 2003, 3, 'Objetivo');
INSERT INTO `lang_definitions` VALUES (4252, 2004, 3, 'Ocupación');
INSERT INTO `lang_definitions` VALUES (4253, 2005, 3, 'Acontecimiento');
INSERT INTO `lang_definitions` VALUES (4254, 2006, 3, 'Octubre');
INSERT INTO `lang_definitions` VALUES (4255, 2007, 3, 'OD');
INSERT INTO `lang_definitions` VALUES (4256, 2008, 3, 'de la cantidad ');
INSERT INTO `lang_definitions` VALUES (4257, 2009, 3, 'de tabletas');
INSERT INTO `lang_definitions` VALUES (4258, 2010, 3, 'de cada mes ');
INSERT INTO `lang_definitions` VALUES (4259, 2011, 3, 'Notas de la oficina');
INSERT INTO `lang_definitions` VALUES (4260, 2012, 3, 'Oficina de Notas');
INSERT INTO `lang_definitions` VALUES (4261, 2013, 3, 'Visita a Oficina');
INSERT INTO `lang_definitions` VALUES (4262, 2014, 3, 'Descendencia ');
INSERT INTO `lang_definitions` VALUES (4263, 2015, 3, 'Ungüento');
INSERT INTO `lang_definitions` VALUES (4264, 2016, 3, 'Esta Bien');
INSERT INTO `lang_definitions` VALUES (4265, 2017, 3, 'OK para vincular la cuestión de fecha GCAC ');
INSERT INTO `lang_definitions` VALUES (4266, 2018, 3, 'Clientes antiguos');
INSERT INTO `lang_definitions` VALUES (4267, 2019, 3, 'La fractura vieja no/malunion');
INSERT INTO `lang_definitions` VALUES (4268, 2021, 3, 'Omitir para firma automatico');
INSERT INTO `lang_definitions` VALUES (4269, 2022, 3, 'en');
INSERT INTO `lang_definitions` VALUES (4270, 2023, 3, 'En mano');
INSERT INTO `lang_definitions` VALUES (4271, 2024, 3, 'En Orden');
INSERT INTO `lang_definitions` VALUES (4272, 2025, 3, 'Una vez que cambie su contraseña, tendrá que volver a iniciar sesión.');
INSERT INTO `lang_definitions` VALUES (4273, 2027, 3, 'Sólo activa');
INSERT INTO `lang_definitions` VALUES (4274, 2028, 3, 'sólo si la ubicación de facturación');
INSERT INTO `lang_definitions` VALUES (4275, 2029, 3, 'Sólo inactivo');
INSERT INTO `lang_definitions` VALUES (4276, 2030, 3, 'Sólo mio');
INSERT INTO `lang_definitions` VALUES (4277, 2031, 3, 'Inicio Enfermedad: ');
INSERT INTO `lang_definitions` VALUES (4278, 2032, 3, 'Inicio Enfermedad: ');
INSERT INTO `lang_definitions` VALUES (4279, 2033, 3, 'Inicio de Hinchazón:');
INSERT INTO `lang_definitions` VALUES (4280, 2034, 3, 'Fecha de Inicio/hospital.:');
INSERT INTO `lang_definitions` VALUES (4281, 2035, 3, 'Abrir');
INSERT INTO `lang_definitions` VALUES (4282, 2036, 3, 'OpenEMR requiere Javascript para realizar la autenticación de usuario. ');
INSERT INTO `lang_definitions` VALUES (4283, 2037, 3, 'OpenEMR Usuarios ');
INSERT INTO `lang_definitions` VALUES (4284, 2038, 3, 'Opcion');
INSERT INTO `lang_definitions` VALUES (4285, 2039, 3, 'Opcional');
INSERT INTO `lang_definitions` VALUES (4286, 2040, 3, 'Nombre opcional de drogas, el uso % como comodin ');
INSERT INTO `lang_definitions` VALUES (4287, 2041, 3, 'Información opcional sobre este evento');
INSERT INTO `lang_definitions` VALUES (4288, 2042, 3, 'Opcional número de lote, usar % como un comodin');
INSERT INTO `lang_definitions` VALUES (4289, 2043, 3, 'Numérico de identificación del paciente opcional');
INSERT INTO `lang_definitions` VALUES (4290, 2044, 3, 'Código opcional del procedimiento ');
INSERT INTO `lang_definitions` VALUES (4291, 2045, 3, 'ó');
INSERT INTO `lang_definitions` VALUES (4292, 2047, 3, 'o elija ');
INSERT INTO `lang_definitions` VALUES (4293, 2048, 3, 'O hacia fuera a ');
INSERT INTO `lang_definitions` VALUES (4294, 2049, 3, 'O cargar archivo ERA:');
INSERT INTO `lang_definitions` VALUES (4295, 2050, 3, 'Oral ');
INSERT INTO `lang_definitions` VALUES (4296, 2051, 3, 'Mucosa oral rosada, garganta clara');
INSERT INTO `lang_definitions` VALUES (4297, 2052, 3, 'Orden');
INSERT INTO `lang_definitions` VALUES (4298, 2053, 3, 'Orden debe ser un número entre 1 y 999 ');
INSERT INTO `lang_definitions` VALUES (4299, 2054, 3, 'Lesión de órganos');
INSERT INTO `lang_definitions` VALUES (4300, 2055, 3, 'Organización');
INSERT INTO `lang_definitions` VALUES (4301, 2056, 3, 'Organizacións');
INSERT INTO `lang_definitions` VALUES (4302, 2057, 3, 'Orientada x 3');
INSERT INTO `lang_definitions` VALUES (4303, 2059, 3, 'OROFARINGE: ');
INSERT INTO `lang_definitions` VALUES (4304, 2060, 3, 'Orthopnea');
INSERT INTO `lang_definitions` VALUES (4305, 2061, 3, 'OS');
INSERT INTO `lang_definitions` VALUES (4306, 2062, 3, 'Osteoartritis');
INSERT INTO `lang_definitions` VALUES (4307, 2063, 3, 'Otro');
INSERT INTO `lang_definitions` VALUES (4308, 2064, 3, 'otro');
INSERT INTO `lang_definitions` VALUES (4309, 2065, 3, 'Otro (especifique) ');
INSERT INTO `lang_definitions` VALUES (4310, 2066, 3, 'Otro Progama Federal');
INSERT INTO `lang_definitions` VALUES (4311, 2067, 3, 'Otro HCFA');
INSERT INTO `lang_definitions` VALUES (4312, 2068, 3, 'Otra lesión en otra parte especificada');
INSERT INTO `lang_definitions` VALUES (4313, 2069, 3, 'Otro mes');
INSERT INTO `lang_definitions` VALUES (4314, 2070, 3, 'Otros programas No-Federales ');
INSERT INTO `lang_definitions` VALUES (4315, 2071, 3, 'Otras Notas ');
INSERT INTO `lang_definitions` VALUES (4316, 2072, 3, 'Otros síntomas pertinentes');
INSERT INTO `lang_definitions` VALUES (4317, 2073, 3, 'Otros síntomas pertinentes:');
INSERT INTO `lang_definitions` VALUES (4318, 2074, 3, 'Otra tensión/lesión por sobreuso');
INSERT INTO `lang_definitions` VALUES (4319, 2075, 3, 'Otro Quirúrgico');
INSERT INTO `lang_definitions` VALUES (4320, 2076, 3, 'Otro/Aborto-Relacionado genérico ');
INSERT INTO `lang_definitions` VALUES (4321, 2078, 3, 'Reglas de tobillo de Ottawa');
INSERT INTO `lang_definitions` VALUES (4322, 2079, 3, 'OU');
INSERT INTO `lang_definitions` VALUES (4323, 2080, 3, 'Fuera');
INSERT INTO `lang_definitions` VALUES (4324, 2081, 3, 'Fuera de la oficina');
INSERT INTO `lang_definitions` VALUES (4325, 2082, 3, 'Resultado');
INSERT INTO `lang_definitions` VALUES (4326, 2083, 3, 'Outlook');
INSERT INTO `lang_definitions` VALUES (4327, 2084, 3, 'Sobreuso');
INSERT INTO `lang_definitions` VALUES (4328, 2085, 3, 'Sobrepeso ');
INSERT INTO `lang_definitions` VALUES (4329, 2086, 3, 'Sobrescribir la elección HIPAA');
INSERT INTO `lang_definitions` VALUES (4330, 2087, 3, 'Saturación del Oxígeno ');
INSERT INTO `lang_definitions` VALUES (4331, 2088, 3, 'P');
INSERT INTO `lang_definitions` VALUES (4332, 2089, 3, 'p.c.');
INSERT INTO `lang_definitions` VALUES (4333, 2090, 3, 'p.m.');
INSERT INTO `lang_definitions` VALUES (4334, 2091, 3, 'p.r.n.');
INSERT INTO `lang_definitions` VALUES (4335, 2092, 3, 'Paedeatric');
INSERT INTO `lang_definitions` VALUES (4336, 2093, 3, 'Página');
INSERT INTO `lang_definitions` VALUES (4337, 2094, 3, 'Páginas');
INSERT INTO `lang_definitions` VALUES (4338, 2095, 3, 'Pago');
INSERT INTO `lang_definitions` VALUES (4339, 2096, 3, 'Cantidad pagada que usted asignará ');
INSERT INTO `lang_definitions` VALUES (4340, 2097, 3, 'Pagado Via');
INSERT INTO `lang_definitions` VALUES (4341, 2098, 3, 'Dolor');
INSERT INTO `lang_definitions` VALUES (4342, 2099, 3, 'Palpitaciones ');
INSERT INTO `lang_definitions` VALUES (4343, 2100, 3, 'Prueba de Papanicolaou ');
INSERT INTO `lang_definitions` VALUES (4344, 2101, 3, 'Parálisis ');
INSERT INTO `lang_definitions` VALUES (4345, 2102, 3, 'Analizar HL7');
INSERT INTO `lang_definitions` VALUES (4346, 2103, 3, 'Socio');
INSERT INTO `lang_definitions` VALUES (4347, 2104, 3, 'Contraseña ');
INSERT INTO `lang_definitions` VALUES (4348, 2105, 3, 'Cambio de la contraseña ');
INSERT INTO `lang_definitions` VALUES (4349, 2106, 3, 'Cambio de contraseña con éxito.');
INSERT INTO `lang_definitions` VALUES (4350, 2107, 3, 'Contraseña para la entrada de SMS ');
INSERT INTO `lang_definitions` VALUES (4351, 2108, 3, 'Contraseña ');
INSERT INTO `lang_definitions` VALUES (4352, 2109, 3, 'Últimos encuentros ');
INSERT INTO `lang_definitions` VALUES (4353, 2110, 3, 'Encuentros Pasados y Documentos');
INSERT INTO `lang_definitions` VALUES (4354, 2111, 3, 'Pegar datos HL7 ');
INSERT INTO `lang_definitions` VALUES (4355, 2112, 3, 'Pegar los datos de importación en el área de texto a continuación:');
INSERT INTO `lang_definitions` VALUES (4356, 2113, 3, 'Parche');
INSERT INTO `lang_definitions` VALUES (4357, 2114, 3, 'Paciente');
INSERT INTO `lang_definitions` VALUES (4358, 2115, 3, 'paciente');
INSERT INTO `lang_definitions` VALUES (4359, 2116, 3, 'PACIENTE');
INSERT INTO `lang_definitions` VALUES (4360, 2117, 3, 'Alergias del Pacientes ');
INSERT INTO `lang_definitions` VALUES (4361, 2118, 3, 'Alergias del Pacientes');
INSERT INTO `lang_definitions` VALUES (4362, 2119, 3, 'Cita del Paciente');
INSERT INTO `lang_definitions` VALUES (4363, 2120, 3, 'Identificación de la tabla del paciente ');
INSERT INTO `lang_definitions` VALUES (4364, 2121, 3, 'Comprobación de paciente');
INSERT INTO `lang_definitions` VALUES (4365, 2122, 3, 'Comprobación de paciente para');
INSERT INTO `lang_definitions` VALUES (4366, 2123, 3, 'Comunicación Enviada la Paciente');
INSERT INTO `lang_definitions` VALUES (4367, 2124, 3, 'Comunicación Enviada la Paciente');
INSERT INTO `lang_definitions` VALUES (4368, 2125, 3, 'Datos del Paciente');
INSERT INTO `lang_definitions` VALUES (4369, 2126, 3, 'Documentos del Paciente');
INSERT INTO `lang_definitions` VALUES (4370, 2127, 3, 'Encuentros del Paciente');
INSERT INTO `lang_definitions` VALUES (4371, 2128, 3, 'Formulario de Encuentros del Paciente');
INSERT INTO `lang_definitions` VALUES (4372, 2129, 3, 'Encuentros de Pacientes');
INSERT INTO `lang_definitions` VALUES (4373, 2130, 3, 'Buscador de paciente');
INSERT INTO `lang_definitions` VALUES (4374, 2131, 3, 'Historoa del Paciente');
INSERT INTO `lang_definitions` VALUES (4375, 2132, 3, 'Historia del Paciente / Estilo de Vida');
INSERT INTO `lang_definitions` VALUES (4376, 2133, 3, 'Identificación del Paciente');
INSERT INTO `lang_definitions` VALUES (4377, 2134, 3, 'Tarjeta de identificación del paciente ');
INSERT INTO `lang_definitions` VALUES (4378, 2135, 3, 'Inmunización del paciente');
INSERT INTO `lang_definitions` VALUES (4379, 2136, 3, 'Información de Pacientes');
INSERT INTO `lang_definitions` VALUES (4380, 2137, 3, 'Distribución de pacientes de Seguros ');
INSERT INTO `lang_definitions` VALUES (4381, 2138, 3, 'Informe de distribución de seguros de pacientes ');
INSERT INTO `lang_definitions` VALUES (4382, 2139, 3, 'Cuestiones del Paciente');
INSERT INTO `lang_definitions` VALUES (4383, 2140, 3, 'Lista de Pacientes');
INSERT INTO `lang_definitions` VALUES (4384, 2141, 3, 'Problemas Médicos del Paciente');
INSERT INTO `lang_definitions` VALUES (4385, 2142, 3, 'Medicamentos del Paciente');
INSERT INTO `lang_definitions` VALUES (4386, 2143, 3, 'Nombre y dirección del paciente ');
INSERT INTO `lang_definitions` VALUES (4387, 2144, 3, 'Nota de tipos de pacientes');
INSERT INTO `lang_definitions` VALUES (4388, 2145, 3, 'Notas de Paciente');
INSERT INTO `lang_definitions` VALUES (4389, 2146, 3, 'Notas paciente (escribir, sólo añadir opcional) ');
INSERT INTO `lang_definitions` VALUES (4390, 2147, 3, 'Numero del Paciente');
INSERT INTO `lang_definitions` VALUES (4391, 2148, 3, 'Informe Impreso del Paciente');
INSERT INTO `lang_definitions` VALUES (4392, 2149, 3, 'Informe de registro del paciente ');
INSERT INTO `lang_definitions` VALUES (4393, 2150, 3, 'Inforne del Paciente');
INSERT INTO `lang_definitions` VALUES (4394, 2151, 3, 'Solicitud del Paciente');
INSERT INTO `lang_definitions` VALUES (4395, 2152, 3, 'Resumen del Paciente ');
INSERT INTO `lang_definitions` VALUES (4396, 2153, 3, 'Transacciones del Pacientes ');
INSERT INTO `lang_definitions` VALUES (4397, 2155, 3, 'Paciente/Cliente');
INSERT INTO `lang_definitions` VALUES (4398, 2156, 3, 'Paciente:');
INSERT INTO `lang_definitions` VALUES (4399, 2157, 3, 'Pacientes');
INSERT INTO `lang_definitions` VALUES (4400, 2158, 3, 'Pago');
INSERT INTO `lang_definitions` VALUES (4401, 2159, 3, 'Preste atención a la \"Hecho con\" casillas de verificación. Después de los seguros están marcados completa luego empezaremos a pedir a la paciente a pagar el saldo restante, si usted no marca la totalidad de los seguros luego completar la cantidad restante no serán recogidos! También si hay un equilibrio que el paciente debe pagar, a continuación, establezca la fecha apropiada, ya que esto afecta a la lengua que aparece en las declaraciones del paciente. ');
INSERT INTO `lang_definitions` VALUES (4402, 2160, 3, 'Fecha de Pago:');
INSERT INTO `lang_definitions` VALUES (4403, 2161, 3, 'Pagador');
INSERT INTO `lang_definitions` VALUES (4404, 2162, 3, 'Tipo del Pagador ');
INSERT INTO `lang_definitions` VALUES (4405, 2163, 3, 'Pagar');
INSERT INTO `lang_definitions` VALUES (4406, 2164, 3, 'Pago');
INSERT INTO `lang_definitions` VALUES (4407, 2165, 3, 'pago');
INSERT INTO `lang_definitions` VALUES (4408, 2166, 3, 'Fecha de Pago');
INSERT INTO `lang_definitions` VALUES (4409, 2168, 3, 'Método de Pago');
INSERT INTO `lang_definitions` VALUES (4410, 2169, 3, 'Valor de pago para el código ');
INSERT INTO `lang_definitions` VALUES (4411, 2170, 3, 'Pagos');
INSERT INTO `lang_definitions` VALUES (4412, 2171, 3, 'PDF');
INSERT INTO `lang_definitions` VALUES (4413, 2172, 3, 'Pelvis y nalga');
INSERT INTO `lang_definitions` VALUES (4414, 2173, 3, 'Pénfigo ');
INSERT INTO `lang_definitions` VALUES (4415, 2174, 3, 'Pendiente ');
INSERT INTO `lang_definitions` VALUES (4416, 2175, 3, 'Seguimento Pendiente');
INSERT INTO `lang_definitions` VALUES (4417, 2176, 3, 'Pennington firme OpenEMR v');
INSERT INTO `lang_definitions` VALUES (4418, 2177, 3, 'La úlcera péptica ');
INSERT INTO `lang_definitions` VALUES (4419, 2178, 3, 'por minuto ');
INSERT INTO `lang_definitions` VALUES (4420, 2179, 3, 'Por las fosas nasales ');
INSERT INTO `lang_definitions` VALUES (4421, 2180, 3, 'por las fosas nasales ');
INSERT INTO `lang_definitions` VALUES (4422, 2181, 3, 'Por Oris');
INSERT INTO `lang_definitions` VALUES (4423, 2182, 3, 'por oris');
INSERT INTO `lang_definitions` VALUES (4424, 2183, 3, 'Por Recto');
INSERT INTO `lang_definitions` VALUES (4425, 2184, 3, 'por recto');
INSERT INTO `lang_definitions` VALUES (4426, 2185, 3, 'Derecho Perforado:');
INSERT INTO `lang_definitions` VALUES (4427, 2186, 3, 'Realizar la búsqueda');
INSERT INTO `lang_definitions` VALUES (4428, 2187, 3, 'Realizar esta acción');
INSERT INTO `lang_definitions` VALUES (4429, 2188, 3, 'Periférico ');
INSERT INTO `lang_definitions` VALUES (4430, 2189, 3, 'Persona ');
INSERT INTO `lang_definitions` VALUES (4431, 2190, 3, 'Farmacias');
INSERT INTO `lang_definitions` VALUES (4432, 2191, 3, 'Farmacia');
INSERT INTO `lang_definitions` VALUES (4433, 2192, 3, 'Dispensario de la Farmacia ');
INSERT INTO `lang_definitions` VALUES (4434, 2193, 3, 'Neumotorax');
INSERT INTO `lang_definitions` VALUES (4435, 2194, 3, 'Teléfono');
INSERT INTO `lang_definitions` VALUES (4436, 2195, 3, 'Lista de llamadas de teléfono');
INSERT INTO `lang_definitions` VALUES (4437, 2196, 3, 'Número de teléfono ');
INSERT INTO `lang_definitions` VALUES (4438, 2197, 3, 'Fotofobia ');
INSERT INTO `lang_definitions` VALUES (4439, 2198, 3, 'PHP comprimida');
INSERT INTO `lang_definitions` VALUES (4440, 2199, 3, 'Extraído de PHP');
INSERT INTO `lang_definitions` VALUES (4441, 2200, 3, 'controles de acceso de PHP-GACL están desactivados.');
INSERT INTO `lang_definitions` VALUES (4442, 2201, 3, 'controles de acceso de PHP-GACL are desactivados.');
INSERT INTO `lang_definitions` VALUES (4443, 2202, 3, 'Examen Físico');
INSERT INTO `lang_definitions` VALUES (4444, 2203, 3, 'Solicitud de Médico');
INSERT INTO `lang_definitions` VALUES (4445, 2204, 3, 'Firma del Médico');
INSERT INTO `lang_definitions` VALUES (4446, 2205, 3, 'Médicos');
INSERT INTO `lang_definitions` VALUES (4447, 2206, 3, 'escoger');
INSERT INTO `lang_definitions` VALUES (4448, 2207, 3, 'PID');
INSERT INTO `lang_definitions` VALUES (4449, 2208, 3, 'PID (enfermedad pélvica inflamatoria)');
INSERT INTO `lang_definitions` VALUES (4450, 2209, 3, 'Tamaño de la Píldora');
INSERT INTO `lang_definitions` VALUES (4451, 2210, 3, 'Píldoras');
INSERT INTO `lang_definitions` VALUES (4452, 2211, 3, 'Marcador de posición ');
INSERT INTO `lang_definitions` VALUES (4453, 2212, 3, 'Marcador de posición (Mantiene vacia ACL) ');
INSERT INTO `lang_definitions` VALUES (4454, 2213, 3, 'Texto sin Formato');
INSERT INTO `lang_definitions` VALUES (4455, 2214, 3, 'Plan');
INSERT INTO `lang_definitions` VALUES (4456, 2215, 3, 'Nombre del Plan');
INSERT INTO `lang_definitions` VALUES (4457, 2216, 3, 'Plan:');
INSERT INTO `lang_definitions` VALUES (4458, 2217, 3, 'Jugador');
INSERT INTO `lang_definitions` VALUES (4459, 2218, 3, 'Posición de juego');
INSERT INTO `lang_definitions` VALUES (4460, 2219, 3, 'Por favor, elija una selección válida de la lista.');
INSERT INTO `lang_definitions` VALUES (4461, 2221, 3, 'Por favor, elija un valor para');
INSERT INTO `lang_definitions` VALUES (4462, 2222, 3, 'Por favor, cierre esta ventana. ');
INSERT INTO `lang_definitions` VALUES (4463, 2223, 3, 'Por favor, comparar el nuevo nombre');
INSERT INTO `lang_definitions` VALUES (4464, 2224, 3, 'No acepte por favor esta prescripción a menos que fuera recibida vía facimile. ');
INSERT INTO `lang_definitions` VALUES (4465, 2225, 3, 'Por favor, no utilice su navegador botón de parada o recarga, mientras que esta página está funcionando a menos que más de 10 minutos han transcurrido, esto no causa para detener el proceso en el servidor y se consumen innecesario recursos.');
INSERT INTO `lang_definitions` VALUES (4466, 2226, 3, 'Por favor, introduzca un importe monetario, utilizando sólo los números y un punto decimal.');
INSERT INTO `lang_definitions` VALUES (4467, 2227, 3, 'Por favor, escriba un título!');
INSERT INTO `lang_definitions` VALUES (4468, 2228, 3, 'Por Favor tenga en cuenta que esto puede tomar mucho tiempo, hasta varios minutos, el navegador web puede no aparecer muy activa durante este tiempo, pero la generación de un proyecto de ley es un proceso complicado y su navegador web no es más que la espera de más información.');
INSERT INTO `lang_definitions` VALUES (4469, 2229, 3, 'Por favor Nota: constantes son sensibles a mayúsculas y minúsculas y se permite cualquier cadena. ');
INSERT INTO `lang_definitions` VALUES (4470, 2230, 3, 'Por favor, utilice únicamente caracteres alfabéticos ');
INSERT INTO `lang_definitions` VALUES (4471, 2231, 3, 'Por favor, utilice únicamente caracteres alfabéticos sin espacios');
INSERT INTO `lang_definitions` VALUES (4472, 2232, 3, 'Por favor, pagar esta cantidad ');
INSERT INTO `lang_definitions` VALUES (4473, 2233, 3, 'Por favor, seleccione un ajuste de código de razón ');
INSERT INTO `lang_definitions` VALUES (4474, 2234, 3, 'Por favor, seleccione un evento');
INSERT INTO `lang_definitions` VALUES (4475, 2235, 3, 'Por favor, seleccione el que desee copiar o páginas hacia adelante: ');
INSERT INTO `lang_definitions` VALUES (4476, 2236, 3, 'PM');
INSERT INTO `lang_definitions` VALUES (4477, 2237, 3, 'Método de pago');
INSERT INTO `lang_definitions` VALUES (4478, 2238, 3, 'PND');
INSERT INTO `lang_definitions` VALUES (4479, 2239, 3, 'Conjugación Neumocócica 1 ');
INSERT INTO `lang_definitions` VALUES (4480, 2240, 3, 'Conjugación Neumocócica 2');
INSERT INTO `lang_definitions` VALUES (4481, 2241, 3, 'Conjugación Neumocócica 3');
INSERT INTO `lang_definitions` VALUES (4482, 2242, 3, 'Conjugación Neumocócica 4');
INSERT INTO `lang_definitions` VALUES (4483, 2243, 3, 'Vacunación de Neumonía');
INSERT INTO `lang_definitions` VALUES (4484, 2244, 3, 'Punto del servicio (posición) ');
INSERT INTO `lang_definitions` VALUES (4485, 2245, 3, 'Póliza ');
INSERT INTO `lang_definitions` VALUES (4486, 2246, 3, 'Número de Póliza ');
INSERT INTO `lang_definitions` VALUES (4487, 2247, 3, 'Polydypsia ');
INSERT INTO `lang_definitions` VALUES (4488, 2248, 3, 'Pólipos');
INSERT INTO `lang_definitions` VALUES (4489, 2249, 3, 'Poliuria ');
INSERT INTO `lang_definitions` VALUES (4490, 2250, 3, 'Falta de Apetito ');
INSERT INTO `lang_definitions` VALUES (4491, 2251, 3, 'Pobre Circulación ');
INSERT INTO `lang_definitions` VALUES (4492, 2252, 3, 'Pobre Audiencia');
INSERT INTO `lang_definitions` VALUES (4493, 2253, 3, '¿Rellenar la vista del año con eventos?');
INSERT INTO `lang_definitions` VALUES (4494, 2254, 3, 'Los menús emergentes');
INSERT INTO `lang_definitions` VALUES (4495, 2257, 3, 'Código de POS');
INSERT INTO `lang_definitions` VALUES (4496, 2258, 3, 'Goteo nasal posterior ');
INSERT INTO `lang_definitions` VALUES (4497, 2259, 3, 'Poste quirúrgico ');
INSERT INTO `lang_definitions` VALUES (4498, 2260, 3, 'Poste en la contabilidad y la marca como factura ');
INSERT INTO `lang_definitions` VALUES (4499, 2261, 3, 'Cuidado del Poste-Aborto ');
INSERT INTO `lang_definitions` VALUES (4500, 2262, 3, 'Contracepción del Poste-Aborto ');
INSERT INTO `lang_definitions` VALUES (4501, 2263, 3, 'Asesoramiento del Poste-Aborto ');
INSERT INTO `lang_definitions` VALUES (4502, 2264, 3, 'Seguimiento Poste-Aborto ');
INSERT INTO `lang_definitions` VALUES (4503, 2265, 3, 'Postal');
INSERT INTO `lang_definitions` VALUES (4504, 2266, 3, 'Código Postal');
INSERT INTO `lang_definitions` VALUES (4505, 2267, 3, 'Código Postal');
INSERT INTO `lang_definitions` VALUES (4506, 2268, 3, 'PosteCalendario');
INSERT INTO `lang_definitions` VALUES (4507, 2269, 3, 'PosteCalendario de Administración ');
INSERT INTO `lang_definitions` VALUES (4508, 2270, 3, 'PosteCalendario de Configuración de la Categoría ');
INSERT INTO `lang_definitions` VALUES (4509, 2271, 3, 'PosteCalendario de Configuración Global ');
INSERT INTO `lang_definitions` VALUES (4510, 2272, 3, 'Publicado en');
INSERT INTO `lang_definitions` VALUES (4511, 2273, 3, 'Fecha de Envío');
INSERT INTO `lang_definitions` VALUES (4512, 2275, 3, 'Práctica');
INSERT INTO `lang_definitions` VALUES (4513, 2276, 3, 'Configuración de la práctica');
INSERT INTO `lang_definitions` VALUES (4514, 2277, 3, 'Médico ');
INSERT INTO `lang_definitions` VALUES (4515, 2278, 3, 'Consulta del Pre-Aborto ');
INSERT INTO `lang_definitions` VALUES (4516, 2279, 3, 'Asesoramiento del Pre-Aborto ');
INSERT INTO `lang_definitions` VALUES (4517, 2280, 3, 'Gato de Pref');
INSERT INTO `lang_definitions` VALUES (4518, 2281, 3, 'Categoría preferida del evento');
INSERT INTO `lang_definitions` VALUES (4519, 2282, 3, 'Lengua preferida ');
INSERT INTO `lang_definitions` VALUES (4520, 2283, 3, 'Preferencia Farmacia');
INSERT INTO `lang_definitions` VALUES (4521, 2284, 3, 'Organización de Proveedor Preferido (PPO)');
INSERT INTO `lang_definitions` VALUES (4522, 2285, 3, 'Prueba de embarazo');
INSERT INTO `lang_definitions` VALUES (4523, 2286, 3, 'Pague por Adelantado');
INSERT INTO `lang_definitions` VALUES (4524, 2287, 3, 'Prescripción ');
INSERT INTO `lang_definitions` VALUES (4525, 2288, 3, 'Etiqueta de la prescripción');
INSERT INTO `lang_definitions` VALUES (4526, 2289, 3, 'Prescripciónes');
INSERT INTO `lang_definitions` VALUES (4527, 2290, 3, 'Prescripciones y dispensaciones ');
INSERT INTO `lang_definitions` VALUES (4528, 2291, 3, 'Recetas y otras referencias ');
INSERT INTO `lang_definitions` VALUES (4529, 2292, 3, 'Prescripciones y/o remisiones del especialista ');
INSERT INTO `lang_definitions` VALUES (4530, 2293, 3, 'Informe de las prescripciones ');
INSERT INTO `lang_definitions` VALUES (4531, 2294, 3, 'Prescripciones/remisiones');
INSERT INTO `lang_definitions` VALUES (4532, 2295, 3, 'Presentación de queja');
INSERT INTO `lang_definitions` VALUES (4533, 2296, 3, 'Pulse Continuar para proseguir');
INSERT INTO `lang_definitions` VALUES (4534, 2297, 3, 'Diagnosis presumida');
INSERT INTO `lang_definitions` VALUES (4535, 2298, 3, 'Diagnosis presumida del especialista ');
INSERT INTO `lang_definitions` VALUES (4536, 2299, 3, 'Previa');
INSERT INTO `lang_definitions` VALUES (4537, 2300, 3, 'Vista previa del evento');
INSERT INTO `lang_definitions` VALUES (4538, 2301, 3, 'Anterior');
INSERT INTO `lang_definitions` VALUES (4539, 2302, 3, 'Consultas Anteriores');
INSERT INTO `lang_definitions` VALUES (4540, 2303, 3, 'Dia Anterior');
INSERT INTO `lang_definitions` VALUES (4541, 2304, 3, 'Historia Anterior/Proyección');
INSERT INTO `lang_definitions` VALUES (4542, 2305, 3, 'Mes Anterior');
INSERT INTO `lang_definitions` VALUES (4543, 2306, 3, 'Semana Anterior');
INSERT INTO `lang_definitions` VALUES (4544, 2307, 3, 'Precio');
INSERT INTO `lang_definitions` VALUES (4545, 2308, 3, 'Precio de descuento');
INSERT INTO `lang_definitions` VALUES (4546, 2309, 3, 'Nivel de Precio');
INSERT INTO `lang_definitions` VALUES (4547, 2310, 3, 'Nivel de Precio:');
INSERT INTO `lang_definitions` VALUES (4548, 2312, 3, 'Primaria');
INSERT INTO `lang_definitions` VALUES (4549, 2313, 3, 'Seguro Primario');
INSERT INTO `lang_definitions` VALUES (4550, 2314, 3, 'Seguro Primario ');
INSERT INTO `lang_definitions` VALUES (4551, 2315, 3, 'Datos Primarios del Seguro ');
INSERT INTO `lang_definitions` VALUES (4552, 2316, 3, 'Proveedor Primario del Seguro ');
INSERT INTO `lang_definitions` VALUES (4553, 2317, 3, 'Proveedor de primaria ');
INSERT INTO `lang_definitions` VALUES (4554, 2318, 3, 'Imprime');
INSERT INTO `lang_definitions` VALUES (4555, 2322, 3, 'Imprimir el formulario de remisión en blanco');
INSERT INTO `lang_definitions` VALUES (4556, 2323, 3, 'Imprimir el Formato');
INSERT INTO `lang_definitions` VALUES (4557, 2324, 3, 'Imprimir cuatro paneles');
INSERT INTO `lang_definitions` VALUES (4558, 2325, 3, 'Imprimir Múltiples');
INSERT INTO `lang_definitions` VALUES (4559, 2326, 3, 'Para imprimir múltiples Fax ');
INSERT INTO `lang_definitions` VALUES (4560, 2329, 3, 'Imprimir Página 1 ');
INSERT INTO `lang_definitions` VALUES (4561, 2330, 3, 'Imprimir Página 2 ');
INSERT INTO `lang_definitions` VALUES (4562, 2331, 3, 'Grabar Imprimir ');
INSERT INTO `lang_definitions` VALUES (4563, 2332, 3, 'Registro de tiro impresión');
INSERT INTO `lang_definitions` VALUES (4564, 2334, 3, 'Imprimir esta nota');
INSERT INTO `lang_definitions` VALUES (4565, 2335, 3, 'Imprimir Esta Nota');
INSERT INTO `lang_definitions` VALUES (4566, 2336, 3, 'Para imprimir Fax ');
INSERT INTO `lang_definitions` VALUES (4567, 2337, 3, 'Ver Imprenta');
INSERT INTO `lang_definitions` VALUES (4568, 2338, 3, 'Imprimible ');
INSERT INTO `lang_definitions` VALUES (4569, 2339, 3, 'Versión Imprimible ');
INSERT INTO `lang_definitions` VALUES (4570, 2341, 3, 'Resultados de la impresión: ');
INSERT INTO `lang_definitions` VALUES (4571, 2342, 3, 'Impresión saltado; ver la prueba de salida en');
INSERT INTO `lang_definitions` VALUES (4572, 2343, 3, 'Antes de autentificación');
INSERT INTO `lang_definitions` VALUES (4573, 2344, 3, 'Formulario de Autorización Previa');
INSERT INTO `lang_definitions` VALUES (4574, 2345, 3, 'Prioridad');
INSERT INTO `lang_definitions` VALUES (4575, 2346, 3, 'Privado');
INSERT INTO `lang_definitions` VALUES (4576, 2347, 3, 'Problema');
INSERT INTO `lang_definitions` VALUES (4577, 2348, 3, 'Lista de Problema ');
INSERT INTO `lang_definitions` VALUES (4578, 2349, 3, 'Problemas y Cuestiones');
INSERT INTO `lang_definitions` VALUES (4579, 2350, 3, 'Procedimiento');
INSERT INTO `lang_definitions` VALUES (4580, 2351, 3, 'Procedimientos');
INSERT INTO `lang_definitions` VALUES (4581, 2352, 3, 'Proceso');
INSERT INTO `lang_definitions` VALUES (4582, 2353, 3, 'Procesamiento');
INSERT INTO `lang_definitions` VALUES (4583, 2354, 3, 'Productos');
INSERT INTO `lang_definitions` VALUES (4584, 2355, 3, 'Prof.');
INSERT INTO `lang_definitions` VALUES (4585, 2357, 3, 'Cáncer de Próstata');
INSERT INTO `lang_definitions` VALUES (4586, 2358, 3, 'Examen de Próstata');
INSERT INTO `lang_definitions` VALUES (4587, 2359, 3, 'Problemas de Próstata');
INSERT INTO `lang_definitions` VALUES (4588, 2360, 3, 'El concurso de nódulos, próstata sin enlrgmt,');
INSERT INTO `lang_definitions` VALUES (4589, 2361, 3, 'Proveedor');
INSERT INTO `lang_definitions` VALUES (4590, 2362, 3, 'Número de Proveedor');
INSERT INTO `lang_definitions` VALUES (4591, 2363, 3, 'Proveedor:');
INSERT INTO `lang_definitions` VALUES (4592, 2364, 3, 'Proveedores');
INSERT INTO `lang_definitions` VALUES (4593, 2365, 3, 'Proveedores NPI');
INSERT INTO `lang_definitions` VALUES (4594, 2366, 3, 'Prv');
INSERT INTO `lang_definitions` VALUES (4595, 2367, 3, 'PSA');
INSERT INTO `lang_definitions` VALUES (4596, 2368, 3, 'Psoriasis');
INSERT INTO `lang_definitions` VALUES (4597, 2369, 3, 'Psych Diagnóstico ');
INSERT INTO `lang_definitions` VALUES (4598, 2370, 3, 'Psych Medicamentos ');
INSERT INTO `lang_definitions` VALUES (4599, 2371, 3, 'Psiquiátricos ');
INSERT INTO `lang_definitions` VALUES (4600, 2372, 3, 'Breve carta Psiquiátrica ');
INSERT INTO `lang_definitions` VALUES (4601, 2373, 3, 'Diagnosis psiquiátrica ');
INSERT INTO `lang_definitions` VALUES (4602, 2374, 3, 'Examinación psiquiátrica ');
INSERT INTO `lang_definitions` VALUES (4603, 2375, 3, 'Historia Psiquiátrica ');
INSERT INTO `lang_definitions` VALUES (4604, 2376, 3, 'Producto Psiquiátrico ');
INSERT INTO `lang_definitions` VALUES (4605, 2377, 3, 'Medicación Psiquiátrica ');
INSERT INTO `lang_definitions` VALUES (4606, 2378, 3, 'Pt %');
INSERT INTO `lang_definitions` VALUES (4607, 2379, 3, 'Pt Notas');
INSERT INTO `lang_definitions` VALUES (4608, 2380, 3, 'Pt Notas/Autorización');
INSERT INTO `lang_definitions` VALUES (4609, 2381, 3, 'Pt en exceso');
INSERT INTO `lang_definitions` VALUES (4610, 2382, 3, 'Pt Pagado');
INSERT INTO `lang_definitions` VALUES (4611, 2383, 3, 'Pt Reembolso');
INSERT INTO `lang_definitions` VALUES (4612, 2384, 3, 'Pt liberados');
INSERT INTO `lang_definitions` VALUES (4613, 2385, 3, 'Pt Informe');
INSERT INTO `lang_definitions` VALUES (4614, 2386, 3, 'PT Estudiante, o dejar en blanco');
INSERT INTO `lang_definitions` VALUES (4615, 2388, 3, 'PT_FDN');
INSERT INTO `lang_definitions` VALUES (4616, 2389, 3, 'PT_NOMBRE');
INSERT INTO `lang_definitions` VALUES (4617, 2390, 3, 'PT_APELLIDO');
INSERT INTO `lang_definitions` VALUES (4618, 2391, 3, 'PT_NOMBRE');
INSERT INTO `lang_definitions` VALUES (4619, 2395, 3, 'Público');
INSERT INTO `lang_definitions` VALUES (4620, 2396, 3, 'Pulmonar');
INSERT INTO `lang_definitions` VALUES (4621, 2397, 3, 'Pulso ');
INSERT INTO `lang_definitions` VALUES (4622, 2398, 3, 'q.3h');
INSERT INTO `lang_definitions` VALUES (4623, 2399, 3, 'q.4h');
INSERT INTO `lang_definitions` VALUES (4624, 2400, 3, 'q.5h');
INSERT INTO `lang_definitions` VALUES (4625, 2401, 3, 'q.6h');
INSERT INTO `lang_definitions` VALUES (4626, 2402, 3, 'q.8h');
INSERT INTO `lang_definitions` VALUES (4627, 2403, 3, 'q.d.');
INSERT INTO `lang_definitions` VALUES (4628, 2404, 3, 'q.i.d.');
INSERT INTO `lang_definitions` VALUES (4629, 2405, 3, 'QOH');
INSERT INTO `lang_definitions` VALUES (4630, 2406, 3, 'Cantidad');
INSERT INTO `lang_definitions` VALUES (4631, 2407, 3, 'Cantidad');
INSERT INTO `lang_definitions` VALUES (4632, 2408, 3, 'Calidad');
INSERT INTO `lang_definitions` VALUES (4633, 2409, 3, 'Cantidad');
INSERT INTO `lang_definitions` VALUES (4634, 2410, 3, 'Cantidad para NDC');
INSERT INTO `lang_definitions` VALUES (4635, 2411, 3, 'Cantidad En Mano');
INSERT INTO `lang_definitions` VALUES (4636, 2412, 3, 'HCFA cola de procesamiento por lotes ');
INSERT INTO `lang_definitions` VALUES (4637, 2413, 3, 'HCFA cola de procesamiento por lotes y la impresión');
INSERT INTO `lang_definitions` VALUES (4638, 2414, 3, 'Cola de la UB-92 del procesamiento por lotes');
INSERT INTO `lang_definitions` VALUES (4639, 2415, 3, 'Cola de la UB-92 del procesamiento por lotes y la impresión');
INSERT INTO `lang_definitions` VALUES (4640, 2416, 3, 'Cola');
INSERT INTO `lang_definitions` VALUES (4641, 2417, 3, 'Administración de Eventos en cola');
INSERT INTO `lang_definitions` VALUES (4642, 2418, 3, 'Cola para');
INSERT INTO `lang_definitions` VALUES (4643, 2419, 3, 'Cola de Peticiones Administración ');
INSERT INTO `lang_definitions` VALUES (4644, 2420, 3, 'R');
INSERT INTO `lang_definitions` VALUES (4645, 2421, 3, 'Raza');
INSERT INTO `lang_definitions` VALUES (4646, 2422, 3, 'Raza/étnica');
INSERT INTO `lang_definitions` VALUES (4647, 2423, 3, 'Radio');
INSERT INTO `lang_definitions` VALUES (4648, 2425, 3, 'Erupciones ');
INSERT INTO `lang_definitions` VALUES (4649, 2426, 3, 'tarifa');
INSERT INTO `lang_definitions` VALUES (4650, 2427, 3, 'Abra de nuevo ');
INSERT INTO `lang_definitions` VALUES (4651, 2428, 3, 'Volvió a abrir');
INSERT INTO `lang_definitions` VALUES (4652, 2429, 3, 'reacciones');
INSERT INTO `lang_definitions` VALUES (4653, 2430, 3, 'Nombre Real');
INSERT INTO `lang_definitions` VALUES (4654, 2431, 3, 'Razón');
INSERT INTO `lang_definitions` VALUES (4655, 2432, 3, 'Motivo de la remisión');
INSERT INTO `lang_definitions` VALUES (4656, 2433, 3, 'Motivo de la Visita ');
INSERT INTO `lang_definitions` VALUES (4657, 2434, 3, 'Motivo / Forma');
INSERT INTO `lang_definitions` VALUES (4658, 2435, 3, 'Recibo');
INSERT INTO `lang_definitions` VALUES (4659, 2436, 3, 'Recibo de Pago');
INSERT INTO `lang_definitions` VALUES (4660, 2437, 3, 'Recibo de Creación');
INSERT INTO `lang_definitions` VALUES (4661, 2438, 3, 'Recibos de pago por Informe');
INSERT INTO `lang_definitions` VALUES (4662, 2439, 3, 'Resumen del Recibo');
INSERT INTO `lang_definitions` VALUES (4663, 2440, 3, 'Recibido ');
INSERT INTO `lang_definitions` VALUES (4664, 2441, 3, 'Recibido Por ');
INSERT INTO `lang_definitions` VALUES (4665, 2442, 3, 'Recibido faxes ');
INSERT INTO `lang_definitions` VALUES (4666, 2443, 3, 'Receptor ');
INSERT INTO `lang_definitions` VALUES (4667, 2444, 3, 'Identificación del receptor ');
INSERT INTO `lang_definitions` VALUES (4668, 2447, 3, 'Recomendaciones ');
INSERT INTO `lang_definitions` VALUES (4669, 2448, 3, 'Recomendaciones y el tratamiento ');
INSERT INTO `lang_definitions` VALUES (4670, 2449, 3, 'Recomendaciones del especialista ');
INSERT INTO `lang_definitions` VALUES (4671, 2450, 3, 'Pago de Registro ');
INSERT INTO `lang_definitions` VALUES (4672, 2451, 3, 'expedientes encontrados. ');
INSERT INTO `lang_definitions` VALUES (4673, 2452, 3, 'Rectal');
INSERT INTO `lang_definitions` VALUES (4674, 2453, 3, 'Examen Rectal ');
INSERT INTO `lang_definitions` VALUES (4675, 2454, 3, 'Rectal');
INSERT INTO `lang_definitions` VALUES (4676, 2455, 3, 'Enrojecimiento ');
INSERT INTO `lang_definitions` VALUES (4677, 2456, 3, 'Reducido: ');
INSERT INTO `lang_definitions` VALUES (4678, 2457, 3, 'Referir');
INSERT INTO `lang_definitions` VALUES (4679, 2458, 3, 'Referir Por');
INSERT INTO `lang_definitions` VALUES (4680, 2459, 3, 'Referir Fecha');
INSERT INTO `lang_definitions` VALUES (4681, 2460, 3, 'Referir Para');
INSERT INTO `lang_definitions` VALUES (4682, 2461, 3, 'Clasificación de referencia (nivel de riesgo) ');
INSERT INTO `lang_definitions` VALUES (4683, 2462, 3, 'Motivo de referencia ');
INSERT INTO `lang_definitions` VALUES (4684, 2463, 3, 'Referer nombre y la firma ');
INSERT INTO `lang_definitions` VALUES (4685, 2464, 3, 'Referido');
INSERT INTO `lang_definitions` VALUES (4686, 2465, 3, 'Referido Por');
INSERT INTO `lang_definitions` VALUES (4687, 2466, 3, 'Tarjeta de Referido');
INSERT INTO `lang_definitions` VALUES (4688, 2467, 3, 'Fecha de Referido');
INSERT INTO `lang_definitions` VALUES (4689, 2468, 3, 'Formulario de remisión ');
INSERT INTO `lang_definitions` VALUES (4690, 2469, 3, 'FORMULARIO DE REMISIÓN ');
INSERT INTO `lang_definitions` VALUES (4691, 2470, 3, 'Fuente de referido ');
INSERT INTO `lang_definitions` VALUES (4692, 2471, 3, 'Referido a ');
INSERT INTO `lang_definitions` VALUES (4693, 2472, 3, 'Referidos');
INSERT INTO `lang_definitions` VALUES (4694, 2473, 3, 'Informes de Referidos');
INSERT INTO `lang_definitions` VALUES (4695, 2474, 3, 'Referido por');
INSERT INTO `lang_definitions` VALUES (4696, 2475, 3, 'Referido Por');
INSERT INTO `lang_definitions` VALUES (4697, 2476, 3, 'Referido a');
INSERT INTO `lang_definitions` VALUES (4698, 2477, 3, 'Referencia ');
INSERT INTO `lang_definitions` VALUES (4699, 2478, 3, 'Diagnóstico de Referencia ');
INSERT INTO `lang_definitions` VALUES (4700, 2479, 3, 'Diagnóstico de referencia ');
INSERT INTO `lang_definitions` VALUES (4701, 2480, 3, 'Referir al médico y la práctica ');
INSERT INTO `lang_definitions` VALUES (4702, 2481, 3, 'Refiriéndose Proveedor');
INSERT INTO `lang_definitions` VALUES (4703, 2482, 3, 'Repuesto');
INSERT INTO `lang_definitions` VALUES (4704, 2483, 3, 'repuestos');
INSERT INTO `lang_definitions` VALUES (4705, 2484, 3, 'Reflejos normales');
INSERT INTO `lang_definitions` VALUES (4706, 2485, 3, 'Refrescar');
INSERT INTO `lang_definitions` VALUES (4707, 2486, 3, 'reg_re');
INSERT INTO `lang_definitions` VALUES (4708, 2487, 3, 'Registrar');
INSERT INTO `lang_definitions` VALUES (4709, 2488, 3, 'Registrado');
INSERT INTO `lang_definitions` VALUES (4710, 2489, 3, 'registrado');
INSERT INTO `lang_definitions` VALUES (4711, 2490, 3, 'Fecha de Registro ');
INSERT INTO `lang_definitions` VALUES (4712, 2491, 3, 'Formulario de Inscripción ');
INSERT INTO `lang_definitions` VALUES (4713, 2492, 3, 'Rehabilitación ');
INSERT INTO `lang_definitions` VALUES (4714, 2493, 3, 'Relaciónese Con ');
INSERT INTO `lang_definitions` VALUES (4715, 2494, 3, 'Relacionado');
INSERT INTO `lang_definitions` VALUES (4716, 2495, 3, 'Relación (s) / Niños ');
INSERT INTO `lang_definitions` VALUES (4717, 2496, 3, 'Relación ');
INSERT INTO `lang_definitions` VALUES (4718, 2497, 3, 'Familiares ');
INSERT INTO `lang_definitions` VALUES (4719, 2498, 3, 'Las credenciales de la salud del relais faltan de esta cuenta de usuario. ');
INSERT INTO `lang_definitions` VALUES (4720, 2499, 3, 'Relay Health ID');
INSERT INTO `lang_definitions` VALUES (4721, 2500, 3, 'Religión');
INSERT INTO `lang_definitions` VALUES (4722, 2501, 3, 'Re-Validar');
INSERT INTO `lang_definitions` VALUES (4723, 2502, 3, 'Quitar');
INSERT INTO `lang_definitions` VALUES (4724, 2503, 3, 'Eliminar Grupo');
INSERT INTO `lang_definitions` VALUES (4725, 2504, 3, 'Eliminar el formulario del grupo');
INSERT INTO `lang_definitions` VALUES (4726, 2505, 3, 'Litiasis Renal ');
INSERT INTO `lang_definitions` VALUES (4727, 2506, 3, 'Retitule al Grupo ');
INSERT INTO `lang_definitions` VALUES (4728, 2507, 3, 'Representación ');
INSERT INTO `lang_definitions` VALUES (4729, 2508, 3, 'Representación del Proveedor');
INSERT INTO `lang_definitions` VALUES (4730, 2509, 3, 'Numero Representación del Proveedor');
INSERT INTO `lang_definitions` VALUES (4731, 2510, 3, 'Al reordenar ');
INSERT INTO `lang_definitions` VALUES (4732, 2511, 3, 'Repetir Información:');
INSERT INTO `lang_definitions` VALUES (4733, 2512, 3, 'Repite');
INSERT INTO `lang_definitions` VALUES (4734, 2513, 3, 'Fecha de Respuesta');
INSERT INTO `lang_definitions` VALUES (4735, 2514, 3, 'De respuesta');
INSERT INTO `lang_definitions` VALUES (4736, 2515, 3, 'Informe');
INSERT INTO `lang_definitions` VALUES (4737, 2516, 3, 'Informe cerca ');
INSERT INTO `lang_definitions` VALUES (4738, 2517, 3, 'Informe Totales');
INSERT INTO `lang_definitions` VALUES (4739, 2518, 3, 'Informes');
INSERT INTO `lang_definitions` VALUES (4740, 2519, 3, 'Solicitud ignorada - los reclamos de procesamiento ya se está ejecutando');
INSERT INTO `lang_definitions` VALUES (4741, 2520, 3, 'Servicio Solicitado ');
INSERT INTO `lang_definitions` VALUES (4742, 2521, 3, 'Requerido ');
INSERT INTO `lang_definitions` VALUES (4743, 2522, 3, 'RESERVADO');
INSERT INTO `lang_definitions` VALUES (4744, 2523, 3, 'Reservados ');
INSERT INTO `lang_definitions` VALUES (4745, 2524, 3, 'Reservados para su uso para definir el Tiempo Programado de Vacaciones');
INSERT INTO `lang_definitions` VALUES (4746, 2525, 3, 'Reservados para definir cuando un proveedor no podrá tener citas disponibles después. ');
INSERT INTO `lang_definitions` VALUES (4747, 2526, 3, 'Reservados para definir cuando un evento no ocurrió, tal como se especifica. ');
INSERT INTO `lang_definitions` VALUES (4748, 2527, 3, 'Reservados para definir cuando un proveedor puede tener citas disponibles después.');
INSERT INTO `lang_definitions` VALUES (4749, 2528, 3, 'Resuelto');
INSERT INTO `lang_definitions` VALUES (4750, 2529, 3, 'Respiración ');
INSERT INTO `lang_definitions` VALUES (4751, 2530, 3, 'Esfuerzo al Respirar');
INSERT INTO `lang_definitions` VALUES (4752, 2531, 3, 'Respiratorias ');
INSERT INTO `lang_definitions` VALUES (4753, 2532, 3, 'Entrenamiento Restringido');
INSERT INTO `lang_definitions` VALUES (4754, 2533, 3, 'Resultado');
INSERT INTO `lang_definitions` VALUES (4755, 2534, 3, 'Los resultados encontraron para la búsqueda');
INSERT INTO `lang_definitions` VALUES (4756, 2535, 3, 'Examen de Retina');
INSERT INTO `lang_definitions` VALUES (4757, 2536, 3, 'Se retractó de la derecha:');
INSERT INTO `lang_definitions` VALUES (4758, 2537, 3, 'Volver');
INSERT INTO `lang_definitions` VALUES (4759, 2539, 3, 'Valor Devuelto ');
INSERT INTO `lang_definitions` VALUES (4760, 2540, 3, 'Visita de Vuelta ');
INSERT INTO `lang_definitions` VALUES (4761, 2541, 3, 'Volvió a jugar');
INSERT INTO `lang_definitions` VALUES (4762, 2542, 3, 'Examen de PMH: ');
INSERT INTO `lang_definitions` VALUES (4763, 2543, 3, 'Revisión de los sistemas');
INSERT INTO `lang_definitions` VALUES (4764, 2544, 3, 'Revisión de los cheques de sistemas ');
INSERT INTO `lang_definitions` VALUES (4765, 2545, 3, 'Revisión ');
INSERT INTO `lang_definitions` VALUES (4766, 2546, 3, 'Artritis de Rheumotoid ');
INSERT INTO `lang_definitions` VALUES (4767, 2547, 3, 'Derecho');
INSERT INTO `lang_definitions` VALUES (4768, 2548, 3, 'Oido Derecho');
INSERT INTO `lang_definitions` VALUES (4769, 2549, 3, 'oido derecho');
INSERT INTO `lang_definitions` VALUES (4770, 2550, 3, 'Derecho:');
INSERT INTO `lang_definitions` VALUES (4771, 2551, 3, 'Zumbido en Oídos ');
INSERT INTO `lang_definitions` VALUES (4772, 2552, 3, 'Sonido en Oídos ');
INSERT INTO `lang_definitions` VALUES (4773, 2553, 3, 'Factores de Riesgo ');
INSERT INTO `lang_definitions` VALUES (4774, 2554, 3, 'Nivel de Riesgo');
INSERT INTO `lang_definitions` VALUES (4775, 2555, 3, 'RLL:');
INSERT INTO `lang_definitions` VALUES (4776, 2556, 3, 'ROM');
INSERT INTO `lang_definitions` VALUES (4777, 2557, 3, 'Lista');
INSERT INTO `lang_definitions` VALUES (4778, 2558, 3, 'Ruta');
INSERT INTO `lang_definitions` VALUES (4779, 2559, 3, 'Filas');
INSERT INTO `lang_definitions` VALUES (4780, 2560, 3, 'RRR sin MOR ');
INSERT INTO `lang_definitions` VALUES (4781, 2561, 3, 'Frotar');
INSERT INTO `lang_definitions` VALUES (4782, 2562, 3, 'Frotaciones: ');
INSERT INTO `lang_definitions` VALUES (4783, 2563, 3, 'Comando Corriente:');
INSERT INTO `lang_definitions` VALUES (4784, 2564, 3, 'ruptura');
INSERT INTO `lang_definitions` VALUES (4785, 2565, 3, 'Ruso');
INSERT INTO `lang_definitions` VALUES (4786, 2566, 3, 'Rx');
INSERT INTO `lang_definitions` VALUES (4787, 2567, 3, 'RX');
INSERT INTO `lang_definitions` VALUES (4788, 2568, 3, 'S');
INSERT INTO `lang_definitions` VALUES (4789, 2569, 3, 'S.S.');
INSERT INTO `lang_definitions` VALUES (4790, 2570, 3, 'S3:');
INSERT INTO `lang_definitions` VALUES (4791, 2571, 3, 'S4:');
INSERT INTO `lang_definitions` VALUES (4792, 2572, 3, 'SA ** para leer la licencia por favor lea la documentoss/licencia.texto o visite * http://www.gnu.org/copyleft/gpl.html * * / / / ========================================================================= / /');
INSERT INTO `lang_definitions` VALUES (4793, 2573, 3, 'Ventas');
INSERT INTO `lang_definitions` VALUES (4794, 2574, 3, 'Ventas por Partida ');
INSERT INTO `lang_definitions` VALUES (4795, 2575, 3, 'Informe de ventas por producto ');
INSERT INTO `lang_definitions` VALUES (4796, 2576, 3, 'Mismo Día ');
INSERT INTO `lang_definitions` VALUES (4797, 2577, 3, 'Muestra');
INSERT INTO `lang_definitions` VALUES (4798, 2578, 3, 'Tipo de sanción ');
INSERT INTO `lang_definitions` VALUES (4799, 2579, 3, 'Sabado');
INSERT INTO `lang_definitions` VALUES (4800, 2580, 3, 'Sabado y Domingo');
INSERT INTO `lang_definitions` VALUES (4801, 2581, 3, 'Sabado');
INSERT INTO `lang_definitions` VALUES (4802, 2582, 3, 'Guardar');
INSERT INTO `lang_definitions` VALUES (4803, 2583, 3, 'Guardar y Distribuir ');
INSERT INTO `lang_definitions` VALUES (4804, 2584, 3, 'Guradar como Nuevo');
INSERT INTO `lang_definitions` VALUES (4805, 2585, 3, 'Guardar Cambios');
INSERT INTO `lang_definitions` VALUES (4806, 2586, 3, 'Guardar Formulario ');
INSERT INTO `lang_definitions` VALUES (4807, 2587, 3, 'Guardar Inmunización');
INSERT INTO `lang_definitions` VALUES (4808, 2588, 3, 'Guardar Nuevo Campo');
INSERT INTO `lang_definitions` VALUES (4809, 2589, 3, 'Guardar Nuevo Grupo');
INSERT INTO `lang_definitions` VALUES (4810, 2590, 3, 'Guardar Nueva Lista');
INSERT INTO `lang_definitions` VALUES (4811, 2591, 3, 'Guardar la nueva plantilla ');
INSERT INTO `lang_definitions` VALUES (4812, 2592, 3, 'Guardar Demograficas de Paciente');
INSERT INTO `lang_definitions` VALUES (4813, 2593, 3, 'Guardar Exitoso para el gráfico identificación');
INSERT INTO `lang_definitions` VALUES (4814, 2594, 3, 'Guardar ITransacción');
INSERT INTO `lang_definitions` VALUES (4815, 2595, 3, 'Escaneados ');
INSERT INTO `lang_definitions` VALUES (4816, 2596, 3, 'Encuentro de Nota Escaneada ');
INSERT INTO `lang_definitions` VALUES (4817, 2597, 3, 'Escáner En');
INSERT INTO `lang_definitions` VALUES (4818, 2598, 3, 'Horario');
INSERT INTO `lang_definitions` VALUES (4819, 2599, 3, 'Calendario de Facilidades');
INSERT INTO `lang_definitions` VALUES (4820, 2600, 3, 'Nota Escolar');
INSERT INTO `lang_definitions` VALUES (4821, 2601, 3, 'Escoliosis ');
INSERT INTO `lang_definitions` VALUES (4822, 2602, 3, 'SE');
INSERT INTO `lang_definitions` VALUES (4823, 2603, 3, 'SE Dirección ');
INSERT INTO `lang_definitions` VALUES (4824, 2604, 3, 'SE Ciudad');
INSERT INTO `lang_definitions` VALUES (4825, 2605, 3, 'SE Pais');
INSERT INTO `lang_definitions` VALUES (4826, 2606, 3, 'SE Localidad ');
INSERT INTO `lang_definitions` VALUES (4827, 2607, 3, 'SE Código Postal');
INSERT INTO `lang_definitions` VALUES (4828, 2608, 3, 'SE Estado ');
INSERT INTO `lang_definitions` VALUES (4829, 2609, 3, 'SE Código Postal ');
INSERT INTO `lang_definitions` VALUES (4830, 2610, 3, 'Búsqueda');
INSERT INTO `lang_definitions` VALUES (4831, 2611, 3, 'búsqueda');
INSERT INTO `lang_definitions` VALUES (4832, 2612, 3, 'Búsqar Nuevamente');
INSERT INTO `lang_definitions` VALUES (4833, 2613, 3, 'Búscar por:');
INSERT INTO `lang_definitions` VALUES (4834, 2614, 3, 'Búscar para:');
INSERT INTO `lang_definitions` VALUES (4835, 2615, 3, 'Busque o Agregue al Paciente ');
INSERT INTO `lang_definitions` VALUES (4836, 2616, 3, 'Resultados de la Búsqueda: ');
INSERT INTO `lang_definitions` VALUES (4837, 2618, 3, 'Búsqueda de eventos');
INSERT INTO `lang_definitions` VALUES (4838, 2619, 3, 'Buscar / Añadir Asegurador ');
INSERT INTO `lang_definitions` VALUES (4839, 2622, 3, 'Uso de cinturón de seguridad ');
INSERT INTO `lang_definitions` VALUES (4840, 2623, 3, 'Uso de cinturón de seguridad ');
INSERT INTO `lang_definitions` VALUES (4841, 2624, 3, 'Segundo');
INSERT INTO `lang_definitions` VALUES (4842, 2625, 3, 'Secundaria');
INSERT INTO `lang_definitions` VALUES (4843, 2626, 3, 'Seguro Secundario ');
INSERT INTO `lang_definitions` VALUES (4844, 2627, 3, 'Datos de Seguro Secundario ');
INSERT INTO `lang_definitions` VALUES (4845, 2628, 3, 'Proveedor de Seguro Secundario ');
INSERT INTO `lang_definitions` VALUES (4846, 2629, 3, 'Ver Todo');
INSERT INTO `lang_definitions` VALUES (4847, 2630, 3, 'Ver Autorizaciones');
INSERT INTO `lang_definitions` VALUES (4848, 2631, 3, 'Véase el Gráfico de Crecimiento');
INSERT INTO `lang_definitions` VALUES (4849, 2632, 3, 'Ver los mensajes de la última serie de reclamaciones generan ');
INSERT INTO `lang_definitions` VALUES (4850, 2633, 3, 'Visto desde');
INSERT INTO `lang_definitions` VALUES (4851, 2634, 3, 'Convulsiones ');
INSERT INTO `lang_definitions` VALUES (4852, 2635, 3, 'Seleción');
INSERT INTO `lang_definitions` VALUES (4853, 2636, 3, 'Seleción');
INSERT INTO `lang_definitions` VALUES (4854, 2637, 3, 'Seleccionar Todo ');
INSERT INTO `lang_definitions` VALUES (4855, 2640, 3, 'Seleccione Sector ');
INSERT INTO `lang_definitions` VALUES (4856, 2641, 3, 'Seleccionar para Imprimir ');
INSERT INTO `lang_definitions` VALUES (4857, 2642, 3, 'Seleccione Edición ');
INSERT INTO `lang_definitions` VALUES (4858, 2644, 3, 'Seleccione Sí para confirmar la eliminación del grupo ');
INSERT INTO `lang_definitions` VALUES (4859, 2645, 3, 'Uno Mismo');
INSERT INTO `lang_definitions` VALUES (4860, 2646, 3, 'Paga del uno mismo');
INSERT INTO `lang_definitions` VALUES (4861, 2647, 3, 'Envíe en curso ');
INSERT INTO `lang_definitions` VALUES (4862, 2649, 3, 'Remitente');
INSERT INTO `lang_definitions` VALUES (4863, 2650, 3, 'Identificación del Remitente ');
INSERT INTO `lang_definitions` VALUES (4864, 2653, 3, 'Sensibilidades ');
INSERT INTO `lang_definitions` VALUES (4865, 2654, 3, 'Sensibilidad: ');
INSERT INTO `lang_definitions` VALUES (4866, 2655, 3, 'Examen sensorial normal');
INSERT INTO `lang_definitions` VALUES (4867, 2656, 3, 'Enviado con éxito ');
INSERT INTO `lang_definitions` VALUES (4868, 2657, 3, 'Enviado a Impresora');
INSERT INTO `lang_definitions` VALUES (4869, 2658, 3, 'Separado ');
INSERT INTO `lang_definitions` VALUES (4870, 2659, 3, 'Septiembre');
INSERT INTO `lang_definitions` VALUES (4871, 2660, 3, 'Categoría de Servicio ');
INSERT INTO `lang_definitions` VALUES (4872, 2661, 3, 'Fecha de Servicio');
INSERT INTO `lang_definitions` VALUES (4873, 2662, 3, 'Fecha de Servicio:');
INSERT INTO `lang_definitions` VALUES (4874, 2663, 3, 'Servicio de Localización ');
INSERT INTO `lang_definitions` VALUES (4875, 2664, 3, 'Servicio prestado por el especialista ');
INSERT INTO `lang_definitions` VALUES (4876, 2665, 3, 'Servicios');
INSERT INTO `lang_definitions` VALUES (4877, 2666, 3, 'Servicios por Categoría ');
INSERT INTO `lang_definitions` VALUES (4878, 2667, 3, 'Servicios prestados ');
INSERT INTO `lang_definitions` VALUES (4879, 2668, 3, 'Servicios proporcionados ');
INSERT INTO `lang_definitions` VALUES (4880, 2669, 3, 'Ajustes');
INSERT INTO `lang_definitions` VALUES (4881, 2670, 3, 'Migraña Grave ');
INSERT INTO `lang_definitions` VALUES (4882, 2671, 3, 'Severidad del dolor');
INSERT INTO `lang_definitions` VALUES (4883, 2672, 3, 'Severidad del dolor');
INSERT INTO `lang_definitions` VALUES (4884, 2673, 3, 'Sexo');
INSERT INTO `lang_definitions` VALUES (4885, 2674, 3, 'Enfermedades de Transmisión Sexual ');
INSERT INTO `lang_definitions` VALUES (4886, 2675, 3, 'Conpartir');
INSERT INTO `lang_definitions` VALUES (4887, 2676, 3, 'Falta de aire al respirar ');
INSERT INTO `lang_definitions` VALUES (4888, 2677, 3, 'Falta de Aliento ');
INSERT INTO `lang_definitions` VALUES (4889, 2678, 3, 'Falta de Aliento 2');
INSERT INTO `lang_definitions` VALUES (4890, 2679, 3, 'Registro de Tiro');
INSERT INTO `lang_definitions` VALUES (4891, 2680, 3, 'Fecha de Expediente de Tiro: ');
INSERT INTO `lang_definitions` VALUES (4892, 2681, 3, 'debe ser como nnnnn-nnnn-nn ');
INSERT INTO `lang_definitions` VALUES (4893, 2682, 3, 'Hombro');
INSERT INTO `lang_definitions` VALUES (4894, 2683, 3, 'Hombro + Clavicula');
INSERT INTO `lang_definitions` VALUES (4895, 2684, 3, 'Prob. de Hombro');
INSERT INTO `lang_definitions` VALUES (4896, 2685, 3, 'Presente');
INSERT INTO `lang_definitions` VALUES (4897, 2686, 3, 'Occupado');
INSERT INTO `lang_definitions` VALUES (4898, 2687, 3, 'Mostrar Sólo Autorizado ');
INSERT INTO `lang_definitions` VALUES (4899, 2688, 3, 'Mostrar Detalles');
INSERT INTO `lang_definitions` VALUES (4900, 2689, 3, '¿Demuestre el texto de cernido del acontecimiento en mouseover? ');
INSERT INTO `lang_definitions` VALUES (4901, 2690, 3, 'Mostrar el número de eventos en las páginas de administrador? ');
INSERT INTO `lang_definitions` VALUES (4902, 2692, 3, 'Mostrar Informe');
INSERT INTO `lang_definitions` VALUES (4903, 2693, 3, 'Mostrar búsqueda y presentar los enlaces en el bloque? ');
INSERT INTO `lang_definitions` VALUES (4904, 2694, 3, 'Mostrar sólo no facturados ');
INSERT INTO `lang_definitions` VALUES (4905, 2695, 3, 'Hermanos');
INSERT INTO `lang_definitions` VALUES (4906, 2696, 3, 'Célula de hoz');
INSERT INTO `lang_definitions` VALUES (4907, 2697, 3, 'Sig');
INSERT INTO `lang_definitions` VALUES (4908, 2698, 3, 'Sigmoide / Colonoscopia ');
INSERT INTO `lang_definitions` VALUES (4909, 2699, 3, 'Firma');
INSERT INTO `lang_definitions` VALUES (4910, 2700, 3, 'Firma:');
INSERT INTO `lang_definitions` VALUES (4911, 2702, 3, 'Hinchazón Significativa: ');
INSERT INTO `lang_definitions` VALUES (4912, 2703, 3, 'Desde');
INSERT INTO `lang_definitions` VALUES (4913, 2705, 3, 'Individual');
INSERT INTO `lang_definitions` VALUES (4914, 2706, 3, 'Problemas del Seno ');
INSERT INTO `lang_definitions` VALUES (4915, 2707, 3, 'Cirugía de Seno');
INSERT INTO `lang_definitions` VALUES (4916, 2708, 3, 'TERNURA DE SENO: ');
INSERT INTO `lang_definitions` VALUES (4917, 2709, 3, 'Sinusitis');
INSERT INTO `lang_definitions` VALUES (4918, 2710, 3, 'Tamaño');
INSERT INTO `lang_definitions` VALUES (4919, 2711, 3, 'El tamaño debe ser un número entre 1 y 999 ');
INSERT INTO `lang_definitions` VALUES (4920, 2712, 3, 'Tamaño/Lista');
INSERT INTO `lang_definitions` VALUES (4921, 2713, 3, 'Piel');
INSERT INTO `lang_definitions` VALUES (4922, 2714, 3, 'Cáncer de Piel');
INSERT INTO `lang_definitions` VALUES (4923, 2715, 3, 'Enfermedad de Piel ');
INSERT INTO `lang_definitions` VALUES (4924, 2716, 3, 'Otra Piel');
INSERT INTO `lang_definitions` VALUES (4925, 2718, 3, 'Patrones de Sueño ');
INSERT INTO `lang_definitions` VALUES (4926, 2719, 3, 'Patrones de Sueño ');
INSERT INTO `lang_definitions` VALUES (4927, 2720, 3, 'Durmiendo');
INSERT INTO `lang_definitions` VALUES (4928, 2721, 3, 'Eslovaco ');
INSERT INTO `lang_definitions` VALUES (4929, 2722, 3, 'La deuda de SM sin');
INSERT INTO `lang_definitions` VALUES (4930, 2723, 3, 'Smarty caché ha sido borrada');
INSERT INTO `lang_definitions` VALUES (4931, 2724, 3, 'Entrada de SMS ');
INSERT INTO `lang_definitions` VALUES (4932, 2725, 3, 'API clave de Entrada de SMS');
INSERT INTO `lang_definitions` VALUES (4933, 2726, 3, 'Notificación de SMS ');
INSERT INTO `lang_definitions` VALUES (4934, 2727, 3, 'SMS envían antes ');
INSERT INTO `lang_definitions` VALUES (4935, 2728, 3, 'SMS de texto, Etiqueta Utilizable: ***NOMBRE *** *** PROVEEDOR, *** *** FECHA *** *** HORA DE COMIENZO*** , *** HORA DE SALIDA *** *** <br> i.e. Estimado ***NOMBRE *** ');
INSERT INTO `lang_definitions` VALUES (4936, 2729, 3, 'SMS/CORREO ELECTRONICO Ajustes Alerta');
INSERT INTO `lang_definitions` VALUES (4937, 2730, 3, 'Ronquidos ');
INSERT INTO `lang_definitions` VALUES (4938, 2731, 3, 'JABÓN ');
INSERT INTO `lang_definitions` VALUES (4939, 2732, 3, 'Dificultades Sociales ');
INSERT INTO `lang_definitions` VALUES (4940, 2733, 3, 'Historia Social:');
INSERT INTO `lang_definitions` VALUES (4941, 2734, 3, 'Número de Seguridad Social ');
INSERT INTO `lang_definitions` VALUES (4942, 2735, 3, 'solución');
INSERT INTO `lang_definitions` VALUES (4943, 2736, 3, 'Contexto Somático ');
INSERT INTO `lang_definitions` VALUES (4944, 2737, 3, 'Algunas autorizaciones no fueron exhibidas. Clic aquí para ver todos ');
INSERT INTO `lang_definitions` VALUES (4945, 2738, 3, 'Algunos códigos no fueron exhibidos. ');
INSERT INTO `lang_definitions` VALUES (4946, 2739, 3, 'Algunos encuentros no fueron exhibidos. Clic aquí para ver todo. ');
INSERT INTO `lang_definitions` VALUES (4947, 2740, 3, 'Algunas notas no fueron mostradas. ');
INSERT INTO `lang_definitions` VALUES (4948, 2741, 3, 'algunas palabras ');
INSERT INTO `lang_definitions` VALUES (4949, 2742, 3, 'Dolor de Garganta ');
INSERT INTO `lang_definitions` VALUES (4950, 2743, 3, 'Organizado por');
INSERT INTO `lang_definitions` VALUES (4951, 2744, 3, 'Ordenar por Comentarios ');
INSERT INTO `lang_definitions` VALUES (4952, 2745, 3, 'Ordenar por fecha ');
INSERT INTO `lang_definitions` VALUES (4953, 2746, 3, 'Ordenar por fecha / hora ');
INSERT INTO `lang_definitions` VALUES (4954, 2747, 3, 'Ordenar por Evento ');
INSERT INTO `lang_definitions` VALUES (4955, 2748, 3, 'Ordenar por Grupo ');
INSERT INTO `lang_definitions` VALUES (4956, 2749, 3, 'Ordenar por Usuario ');
INSERT INTO `lang_definitions` VALUES (4957, 2750, 3, 'Ordenar por vacuna ');
INSERT INTO `lang_definitions` VALUES (4958, 2751, 3, 'Fuente');
INSERT INTO `lang_definitions` VALUES (4959, 2752, 3, 'Fuente falta de código ');
INSERT INTO `lang_definitions` VALUES (4960, 2753, 3, 'Fuente:');
INSERT INTO `lang_definitions` VALUES (4961, 2754, 3, 'Español ');
INSERT INTO `lang_definitions` VALUES (4962, 2755, 3, 'Nombre y firma del especialista ');
INSERT INTO `lang_definitions` VALUES (4963, 2756, 3, 'Especialidad');
INSERT INTO `lang_definitions` VALUES (4964, 2757, 3, 'Sistemas de la especialidad ');
INSERT INTO `lang_definitions` VALUES (4965, 2758, 3, 'Especialidad:');
INSERT INTO `lang_definitions` VALUES (4966, 2759, 3, 'Específico ');
INSERT INTO `lang_definitions` VALUES (4967, 2760, 3, 'Servicio Específico ');
INSERT INTO `lang_definitions` VALUES (4968, 2761, 3, 'Dictado');
INSERT INTO `lang_definitions` VALUES (4969, 2762, 3, 'Espermicidas');
INSERT INTO `lang_definitions` VALUES (4970, 2763, 3, 'Esplenectomía');
INSERT INTO `lang_definitions` VALUES (4971, 2764, 3, 'Esposa');
INSERT INTO `lang_definitions` VALUES (4972, 2765, 3, 'Esputo ');
INSERT INTO `lang_definitions` VALUES (4973, 2766, 3, 'Esputo:');
INSERT INTO `lang_definitions` VALUES (4974, 2767, 3, 'SQ');
INSERT INTO `lang_definitions` VALUES (4975, 2768, 3, 'Equipo');
INSERT INTO `lang_definitions` VALUES (4976, 2769, 3, 'Miembro de Equipo');
INSERT INTO `lang_definitions` VALUES (4977, 2770, 3, 'Equipos');
INSERT INTO `lang_definitions` VALUES (4978, 2771, 3, 'SRH');
INSERT INTO `lang_definitions` VALUES (4979, 2772, 3, 'SRH - Planificación de la Familia');
INSERT INTO `lang_definitions` VALUES (4980, 2773, 3, 'SRH no de Planificación de la Familia');
INSERT INTO `lang_definitions` VALUES (4981, 2774, 3, 'SRH Referencias');
INSERT INTO `lang_definitions` VALUES (4982, 2775, 3, 'Forma de la visita del SRH ');
INSERT INTO `lang_definitions` VALUES (4983, 2776, 3, 'SS');
INSERT INTO `lang_definitions` VALUES (4984, 2777, 3, 'SSN');
INSERT INTO `lang_definitions` VALUES (4985, 2778, 3, 'comienzo');
INSERT INTO `lang_definitions` VALUES (4986, 2779, 3, 'Estándar');
INSERT INTO `lang_definitions` VALUES (4987, 2780, 3, 'Comienzo');
INSERT INTO `lang_definitions` VALUES (4988, 2781, 3, 'Comienzo (aaaa-mm-dd): ');
INSERT INTO `lang_definitions` VALUES (4989, 2782, 3, 'Fecha de Comienzo:');
INSERT INTO `lang_definitions` VALUES (4990, 2783, 3, 'Fecha de inicio en esta clínica ');
INSERT INTO `lang_definitions` VALUES (4991, 2784, 3, 'Fecha de Comienzo:');
INSERT INTO `lang_definitions` VALUES (4992, 2785, 3, 'Fecha de comienzo:');
INSERT INTO `lang_definitions` VALUES (4993, 2786, 3, 'Hora de Comienzo');
INSERT INTO `lang_definitions` VALUES (4994, 2787, 3, 'Fecha el Comenzar ');
INSERT INTO `lang_definitions` VALUES (4995, 2788, 3, 'Estado');
INSERT INTO `lang_definitions` VALUES (4996, 2789, 3, 'Estado');
INSERT INTO `lang_definitions` VALUES (4997, 2790, 3, 'Lista del estado (escriba, sólo añadir opcional) ');
INSERT INTO `lang_definitions` VALUES (4998, 2791, 3, 'Estado/lugar ');
INSERT INTO `lang_definitions` VALUES (4999, 2792, 3, 'Estado/Parroquia ');
INSERT INTO `lang_definitions` VALUES (5000, 2793, 3, 'Estadísticas');
INSERT INTO `lang_definitions` VALUES (5001, 2794, 3, 'Estados');
INSERT INTO `lang_definitions` VALUES (5002, 2795, 3, 'Estado');
INSERT INTO `lang_definitions` VALUES (5003, 2796, 3, 'Estado quo');
INSERT INTO `lang_definitions` VALUES (5004, 2797, 3, 'Couns de ETS/SIDA');
INSERT INTO `lang_definitions` VALUES (5005, 2798, 3, 'Stength y Acondicionado');
INSERT INTO `lang_definitions` VALUES (5006, 2799, 3, 'Coyunturas Tiesas');
INSERT INTO `lang_definitions` VALUES (5007, 2800, 3, 'Tiesura ');
INSERT INTO `lang_definitions` VALUES (5008, 2801, 3, 'Dolores de Estómago ');
INSERT INTO `lang_definitions` VALUES (5009, 2802, 3, 'Tensión del músculo ');
INSERT INTO `lang_definitions` VALUES (5010, 2803, 3, 'Corriente ');
INSERT INTO `lang_definitions` VALUES (5011, 2804, 3, 'Calle');
INSERT INTO `lang_definitions` VALUES (5012, 2806, 3, 'Calle y Número ');
INSERT INTO `lang_definitions` VALUES (5013, 2807, 3, 'Fuerza ');
INSERT INTO `lang_definitions` VALUES (5014, 2808, 3, 'Estrep Garganta');
INSERT INTO `lang_definitions` VALUES (5015, 2809, 3, 'Fractura de Estrés ');
INSERT INTO `lang_definitions` VALUES (5016, 2810, 3, 'Prueba de Estrés ');
INSERT INTO `lang_definitions` VALUES (5017, 2811, 3, 'Derrame Cerebral');
INSERT INTO `lang_definitions` VALUES (5018, 2812, 3, 'Sub-categoría ');
INSERT INTO `lang_definitions` VALUES (5019, 2813, 3, 'Sub-Total');
INSERT INTO `lang_definitions` VALUES (5020, 2814, 3, 'Subcategoria');
INSERT INTO `lang_definitions` VALUES (5021, 2815, 3, 'subcategoria');
INSERT INTO `lang_definitions` VALUES (5022, 2816, 3, 'Subcutáneo ');
INSERT INTO `lang_definitions` VALUES (5023, 2817, 3, 'Subjetivo ');
INSERT INTO `lang_definitions` VALUES (5024, 2818, 3, 'Sublingual ');
INSERT INTO `lang_definitions` VALUES (5025, 2819, 3, 'sublingual ');
INSERT INTO `lang_definitions` VALUES (5026, 2820, 3, 'Someter');
INSERT INTO `lang_definitions` VALUES (5027, 2822, 3, 'Someter Evento');
INSERT INTO `lang_definitions` VALUES (5028, 2823, 3, 'Someter Formulario');
INSERT INTO `lang_definitions` VALUES (5029, 2826, 3, 'Sometido por');
INSERT INTO `lang_definitions` VALUES (5030, 2828, 3, 'Suscriptor ');
INSERT INTO `lang_definitions` VALUES (5031, 2829, 3, 'Dirección del Suscriptor');
INSERT INTO `lang_definitions` VALUES (5032, 2830, 3, 'Patrón del suscriptor ');
INSERT INTO `lang_definitions` VALUES (5033, 2831, 3, 'Patrón del suscriptor (SE) ');
INSERT INTO `lang_definitions` VALUES (5034, 2832, 3, 'Dirección del patrón del suscriptor ');
INSERT INTO `lang_definitions` VALUES (5035, 2833, 3, 'Ciudad del patrón del suscriptor ');
INSERT INTO `lang_definitions` VALUES (5036, 2834, 3, 'Subscriber Employer Country');
INSERT INTO `lang_definitions` VALUES (5037, 2835, 3, 'Estado del patrón del suscriptor ');
INSERT INTO `lang_definitions` VALUES (5038, 2836, 3, 'Código postal del patrón del suscriptor ');
INSERT INTO `lang_definitions` VALUES (5039, 2837, 3, 'Teléfono de Suscriptor');
INSERT INTO `lang_definitions` VALUES (5040, 2838, 3, 'Relación con el Suscriptor ');
INSERT INTO `lang_definitions` VALUES (5041, 2839, 3, '¡La relación del suscriptor no es uno mismo pero el nombre es igual! ¿Es esto realmente ACEPTABLE? ');
INSERT INTO `lang_definitions` VALUES (5042, 2840, 3, '¡La relación del suscriptor no es uno mismo pero el número de SS es igual! ');
INSERT INTO `lang_definitions` VALUES (5043, 2841, 3, '¡La relación del suscriptor es uno mismo pero el nombre es diferente! ¿Es esto realmente ACEPTABLE? ');
INSERT INTO `lang_definitions` VALUES (5044, 2842, 3, '¡La relación del suscriptor es uno mismo pero el número de SS es diferente! ');
INSERT INTO `lang_definitions` VALUES (5045, 2843, 3, 'Sexo de Suscriptor');
INSERT INTO `lang_definitions` VALUES (5046, 2844, 3, 'Sustituto');
INSERT INTO `lang_definitions` VALUES (5047, 2845, 3, 'sustituto permitido');
INSERT INTO `lang_definitions` VALUES (5048, 2846, 3, 'éxito ');
INSERT INTO `lang_definitions` VALUES (5049, 2847, 3, 'agregado con éxito a la categoría, ');
INSERT INTO `lang_definitions` VALUES (5050, 2848, 3, 'almacenado con éxito.');
INSERT INTO `lang_definitions` VALUES (5051, 2849, 3, 'con éxito. ');
INSERT INTO `lang_definitions` VALUES (5052, 2850, 3, 'suicidio');
INSERT INTO `lang_definitions` VALUES (5053, 2851, 3, 'Resumen');
INSERT INTO `lang_definitions` VALUES (5054, 2852, 3, 'Domingo');
INSERT INTO `lang_definitions` VALUES (5055, 2853, 3, 'Domingo');
INSERT INTO `lang_definitions` VALUES (5056, 2854, 3, 'Superbill');
INSERT INTO `lang_definitions` VALUES (5057, 2855, 3, 'Códigos de superbill');
INSERT INTO `lang_definitions` VALUES (5058, 2856, 3, 'Códigos Superbill Administración ');
INSERT INTO `lang_definitions` VALUES (5059, 2857, 3, 'Reportes de superbill');
INSERT INTO `lang_definitions` VALUES (5060, 2858, 3, 'Superbills, designado a veces Encuentro Formas de Enrutamiento o Resbalones, son una parte esencial de la mayoría de las prácticas médicas. ');
INSERT INTO `lang_definitions` VALUES (5061, 2859, 3, 'Superusuario ');
INSERT INTO `lang_definitions` VALUES (5062, 2861, 3, 'Tipo de Superficie ');
INSERT INTO `lang_definitions` VALUES (5063, 2862, 3, 'Cirugías ');
INSERT INTO `lang_definitions` VALUES (5064, 2863, 3, 'Cirugía ');
INSERT INTO `lang_definitions` VALUES (5065, 2864, 3, 'Suspendido');
INSERT INTO `lang_definitions` VALUES (5066, 2865, 3, 'suspención');
INSERT INTO `lang_definitions` VALUES (5067, 2866, 3, 'Svc Fecha');
INSERT INTO `lang_definitions` VALUES (5068, 2867, 3, 'Svc Fecha:');
INSERT INTO `lang_definitions` VALUES (5069, 2868, 3, 'Sudoración: ');
INSERT INTO `lang_definitions` VALUES (5070, 2869, 3, 'Sueco');
INSERT INTO `lang_definitions` VALUES (5071, 2870, 3, 'Hinchazón ');
INSERT INTO `lang_definitions` VALUES (5072, 2871, 3, 'Hinchazón a la Derecha ');
INSERT INTO `lang_definitions` VALUES (5073, 2872, 3, 'Articulaciones Inflamadas ');
INSERT INTO `lang_definitions` VALUES (5074, 2873, 3, 'Inflamación de los ganglios linfáticos ');
INSERT INTO `lang_definitions` VALUES (5075, 2874, 3, 'Síntomas ');
INSERT INTO `lang_definitions` VALUES (5076, 2875, 3, 'Síncope ');
INSERT INTO `lang_definitions` VALUES (5077, 2876, 3, 'Tendinitis / IIS / bursitis ');
INSERT INTO `lang_definitions` VALUES (5078, 2877, 3, 'Sistema');
INSERT INTO `lang_definitions` VALUES (5079, 2878, 3, 'T');
INSERT INTO `lang_definitions` VALUES (5080, 2879, 3, 't.i.d.');
INSERT INTO `lang_definitions` VALUES (5081, 2880, 3, 'T.V.');
INSERT INTO `lang_definitions` VALUES (5082, 2881, 3, 'La creación de la tabla falló ');
INSERT INTO `lang_definitions` VALUES (5083, 2882, 3, 'La actualización de la tabla falló ');
INSERT INTO `lang_definitions` VALUES (5084, 2883, 3, 'tableta');
INSERT INTO `lang_definitions` VALUES (5085, 2884, 3, 'Tomar');
INSERT INTO `lang_definitions` VALUES (5086, 2885, 3, 'Toma tiempo ');
INSERT INTO `lang_definitions` VALUES (5087, 2886, 3, 'Tarifa de Impuestos');
INSERT INTO `lang_definitions` VALUES (5088, 2887, 3, 'Impuestos');
INSERT INTO `lang_definitions` VALUES (5089, 2888, 3, 'Taxonomía ');
INSERT INTO `lang_definitions` VALUES (5090, 2889, 3, 'TD');
INSERT INTO `lang_definitions` VALUES (5091, 2890, 3, 'Descripción de lesión del equipo ');
INSERT INTO `lang_definitions` VALUES (5092, 2891, 3, 'Lista del Equipo ');
INSERT INTO `lang_definitions` VALUES (5093, 2892, 3, 'Ver Lista de Equipo ');
INSERT INTO `lang_definitions` VALUES (5094, 2893, 3, 'Tel');
INSERT INTO `lang_definitions` VALUES (5095, 2895, 3, 'Ubicación Temporal ');
INSERT INTO `lang_definitions` VALUES (5096, 2896, 3, 'Método Temporal ');
INSERT INTO `lang_definitions` VALUES (5097, 2897, 3, 'Temperatura ');
INSERT INTO `lang_definitions` VALUES (5098, 2898, 3, 'Plantilla');
INSERT INTO `lang_definitions` VALUES (5099, 2899, 3, 'Nombre de Plantilla ');
INSERT INTO `lang_definitions` VALUES (5100, 2900, 3, 'Los nombres de la plantilla no pueden comenzar con números. ');
INSERT INTO `lang_definitions` VALUES (5101, 2901, 3, 'Plantilla: ');
INSERT INTO `lang_definitions` VALUES (5102, 2902, 3, 'Pantillas');
INSERT INTO `lang_definitions` VALUES (5103, 2903, 3, 'Arteria Temporal ');
INSERT INTO `lang_definitions` VALUES (5104, 2904, 3, 'Daño al tendón');
INSERT INTO `lang_definitions` VALUES (5105, 2905, 3, 'Tendonitis / osis / bursitis');
INSERT INTO `lang_definitions` VALUES (5106, 2906, 3, 'Terciario');
INSERT INTO `lang_definitions` VALUES (5107, 2907, 3, 'Seguro Terciario');
INSERT INTO `lang_definitions` VALUES (5108, 2908, 3, 'Datos terciarios del seguro ');
INSERT INTO `lang_definitions` VALUES (5109, 2909, 3, 'Proveedor terciario del seguro ');
INSERT INTO `lang_definitions` VALUES (5110, 2910, 3, 'Programación de Prueba');
INSERT INTO `lang_definitions` VALUES (5111, 2911, 3, 'Sistema de Prueba ');
INSERT INTO `lang_definitions` VALUES (5112, 2913, 3, 'texto actualizado ');
INSERT INTO `lang_definitions` VALUES (5113, 2915, 3, 'erea de texto');
INSERT INTO `lang_definitions` VALUES (5114, 2917, 3, 'caja de texto');
INSERT INTO `lang_definitions` VALUES (5115, 2919, 3, 'lista de texto ');
INSERT INTO `lang_definitions` VALUES (5116, 2920, 3, 'Gracias');
INSERT INTO `lang_definitions` VALUES (5117, 2921, 3, 'El archivo de reclamación: ');
INSERT INTO `lang_definitions` VALUES (5118, 2922, 3, 'La forma de la destinación era cerrada; No puedo actuar en su selección. ');
INSERT INTO `lang_definitions` VALUES (5119, 2923, 3, 'El evento(s) han sido aprobadas. ');
INSERT INTO `lang_definitions` VALUES (5120, 2924, 3, 'Se han ocultado el evento(s).');
INSERT INTO `lang_definitions` VALUES (5121, 2925, 3, 'Los datos exportados aparece en el área de texto a continuación. Puedes copiarla y pegarla en un mensaje de correo electrónico o cualquier otro destino.');
INSERT INTO `lang_definitions` VALUES (5122, 2926, 3, 'Los siguientes eventos del calendario, se ha añadido: ');
INSERT INTO `lang_definitions` VALUES (5123, 2927, 3, 'Los siguientes eventos del calendario ha sido modificada: ');
INSERT INTO `lang_definitions` VALUES (5124, 2928, 3, 'Los errores siguientes ocurrieron ');
INSERT INTO `lang_definitions` VALUES (5125, 2929, 3, 'La ventana inicial es la factura de la página de búsqueda. En la parte superior usted puede entrar en una fuente (por ejemplo, número de cheque), y comprobar la fecha de pago de cantidad. La razón de la fuente y la fecha de pago es para que usted no tiene que entrar una y otra vez para cada reclamación. La cantidad que usted introduzca será disminuido por cada factura que se da parte del pago, y es de esperar que terminará a las cero cuando haya terminado.');
INSERT INTO `lang_definitions` VALUES (5126, 2930, 3, 'La etiqueta que aparece al usuario en la forma ');
INSERT INTO `lang_definitions` VALUES (5127, 2931, 3, 'La nueva categoría será una subcategoría de ');
INSERT INTO `lang_definitions` VALUES (5128, 2932, 3, 'La información restante abajo se aplica solamente si usted está fijando manualmente, o si usted está haciendo correcciones manuales. ');
INSERT INTO `lang_definitions` VALUES (5129, 2933, 3, 'El documento solicitado no está presente en el lugar previsto en el sistema de ficheros o no hay suficientes permisos para acceder a ella. ');
INSERT INTO `lang_definitions` VALUES (5130, 2934, 3, 'Las columnas de la fuente y de fecha se copian de la primera página, por lo que normalmente no será necesario que los toque. Usted puede poner una cantidad del pago en la columna de pagos, una cantidad de ajuste en la columna de ajuste, o ambas. Puedes también hacer clic en \" W\" a la derecha de computar automáticamente un ajuste valorar que escriba del resto de la carga para esa línea artículo.');
INSERT INTO `lang_definitions` VALUES (5131, 2935, 3, 'La etiqueta traducida que aparecerá en la forma en lengua actual');
INSERT INTO `lang_definitions` VALUES (5132, 2936, 3, 'El título traducido que aparecerá en lengua actual');
INSERT INTO `lang_definitions` VALUES (5133, 2937, 3, 'La traducción de descripción en lengua actual');
INSERT INTO `lang_definitions` VALUES (5134, 2938, 3, 'El X12 archivos, así como la salida HTML informes resultantes se archivan en la \"era\" subdirectorio del directorio de instalación principal OpenEMR. Usted querrá hacer referencia a estos archivos de vez en cuando. La URL es ');
INSERT INTO `lang_definitions` VALUES (5135, 2939, 3, 'Inyecciones Terapéuticas');
INSERT INTO `lang_definitions` VALUES (5136, 2941, 3, 'Hay errores con su sumisión. Éstos se contornean abajo. ');
INSERT INTO `lang_definitions` VALUES (5137, 2942, 3, 'No hay nuevas sumisiones');
INSERT INTO `lang_definitions` VALUES (5138, 2943, 3, 'Se ha producido un error al enviar correo a ');
INSERT INTO `lang_definitions` VALUES (5139, 2947, 3, 'No hay entrada de COA para la cuenta de AR ');
INSERT INTO `lang_definitions` VALUES (5140, 2948, 3, 'No hay entrada de COA para la cuenta de efectivo');
INSERT INTO `lang_definitions` VALUES (5141, 2949, 3, 'No hay entrada de COA para la cuenta de ingresos ');
INSERT INTO `lang_definitions` VALUES (5142, 2950, 3, 'No hay identificacion igual de la factura ');
INSERT INTO `lang_definitions` VALUES (5143, 2951, 3, 'No hay identificacion igual de la factura =');
INSERT INTO `lang_definitions` VALUES (5144, 2952, 3, 'No hay partes de entrada para los servicios de identificación ');
INSERT INTO `lang_definitions` VALUES (5145, 2953, 3, 'Se ha producido un error mientras se procesaba su solicitud. ');
INSERT INTO `lang_definitions` VALUES (5146, 2954, 3, 'Espesado a la derecha: ');
INSERT INTO `lang_definitions` VALUES (5147, 2955, 3, 'Muslo');
INSERT INTO `lang_definitions` VALUES (5148, 2956, 3, 'Muslo + tendón de la corva');
INSERT INTO `lang_definitions` VALUES (5149, 2957, 3, 'Cosas que la oficina trasera puede leer y entrar pero no modificar ');
INSERT INTO `lang_definitions` VALUES (5150, 2958, 3, 'Things that back office can read and modify');
INSERT INTO `lang_definitions` VALUES (5151, 2959, 3, 'Cosas que los clínicos pueden leer y entrar pero no modificar ');
INSERT INTO `lang_definitions` VALUES (5152, 2960, 3, 'Cosas que los clinicos pueden leer y modificar');
INSERT INTO `lang_definitions` VALUES (5153, 2961, 3, 'Cosas que la oficina central puede leer y entrar pero no modificar ');
INSERT INTO `lang_definitions` VALUES (5154, 2962, 3, 'Cosas que la oficina central puede leer y modificar ');
INSERT INTO `lang_definitions` VALUES (5155, 2963, 3, 'Cosas que los médicos pueden entrar y leer pero no modificar ');
INSERT INTO `lang_definitions` VALUES (5156, 2964, 3, 'Cosas que los médicos pueden leer y modificar ');
INSERT INTO `lang_definitions` VALUES (5157, 2965, 3, 'Tercera');
INSERT INTO `lang_definitions` VALUES (5158, 2966, 3, 'Esta acción no se puede deshacer. ');
INSERT INTO `lang_definitions` VALUES (5159, 2967, 3, 'Esta acción NO SE PUEDE deshacer. ');
INSERT INTO `lang_definitions` VALUES (5160, 2968, 3, 'Este tipo de código no acepta las relaciones. ');
INSERT INTO `lang_definitions` VALUES (5161, 2969, 3, 'Esta Visita');
INSERT INTO `lang_definitions` VALUES (5162, 2971, 3, 'Este número de factura se ha cambiado a ');
INSERT INTO `lang_definitions` VALUES (5163, 2972, 3, 'Este módulo está en modo de prueba. La base de datos no será cambiada. ');
INSERT INTO `lang_definitions` VALUES (5164, 2973, 3, 'Este módulo promueve la entrada eficiente de los datos de EOB. ');
INSERT INTO `lang_definitions` VALUES (5165, 2974, 3, 'Esta página en línea incluirá la página de la conexión, de modo que no tengamos que hacer clic en relogin cada vez.');
INSERT INTO `lang_definitions` VALUES (5166, 2975, 3, 'Este paciente no tiene ninguna actividad. ');
INSERT INTO `lang_definitions` VALUES (5167, 2976, 3, 'Esta identificación del paciente ya esta funcionando! ');
INSERT INTO `lang_definitions` VALUES (5168, 2977, 3, 'Este usuario no es miembro de ningún grupo ');
INSERT INTO `lang_definitions` VALUES (5169, 2978, 3, 'Esta visita comienza nuevo uso anticonceptivo ');
INSERT INTO `lang_definitions` VALUES (5170, 2979, 3, 'Esto creará una copia de seguridad en formato tar y luego enviar a su navegador web para que pueda guardar ');
INSERT INTO `lang_definitions` VALUES (5171, 2980, 3, 'Espina dorsal torácica');
INSERT INTO `lang_definitions` VALUES (5172, 2981, 3, 'Garganta ');
INSERT INTO `lang_definitions` VALUES (5173, 2982, 3, 'Cáncer de Garganta ');
INSERT INTO `lang_definitions` VALUES (5174, 2983, 3, 'Cirugía del Cáncer de Garganta ');
INSERT INTO `lang_definitions` VALUES (5175, 2984, 3, 'Trombosis/Derrame Cerebral');
INSERT INTO `lang_definitions` VALUES (5176, 2985, 3, 'Jueves');
INSERT INTO `lang_definitions` VALUES (5177, 2986, 3, 'Jueves');
INSERT INTO `lang_definitions` VALUES (5178, 2987, 3, 'Jueves');
INSERT INTO `lang_definitions` VALUES (5179, 2988, 3, 'Normal de la tiroides ');
INSERT INTO `lang_definitions` VALUES (5180, 2989, 3, 'Problemas de la Tiroides ');
INSERT INTO `lang_definitions` VALUES (5181, 2990, 3, 'TIA');
INSERT INTO `lang_definitions` VALUES (5182, 2991, 3, 'Tiempo');
INSERT INTO `lang_definitions` VALUES (5183, 2992, 3, 'Incremento de tiempo para agrega (minutos 1-60) ');
INSERT INTO `lang_definitions` VALUES (5184, 2993, 3, 'El tiempo de evento ');
INSERT INTO `lang_definitions` VALUES (5185, 2994, 3, 'Los tiempos forman en serie (NO INTERESA)');
INSERT INTO `lang_definitions` VALUES (5186, 2995, 3, 'Reloj fechador y texto ');
INSERT INTO `lang_definitions` VALUES (5187, 2996, 3, 'TIN');
INSERT INTO `lang_definitions` VALUES (5188, 2997, 3, 'Tinnitus');
INSERT INTO `lang_definitions` VALUES (5189, 2998, 3, 'Titulo');
INSERT INTO `lang_definitions` VALUES (5190, 2999, 3, 'Titulo V');
INSERT INTO `lang_definitions` VALUES (5191, 3000, 3, 'Cols título debe ser un número entre 1 y 999 ');
INSERT INTO `lang_definitions` VALUES (5192, 3001, 3, 'Títulos ');
INSERT INTO `lang_definitions` VALUES (5193, 3002, 3, 'TM\'S:');
INSERT INTO `lang_definitions` VALUES (5194, 3003, 3, 'TMs/EAMs/EE, ext nariz');
INSERT INTO `lang_definitions` VALUES (5195, 3004, 3, 'Para');
INSERT INTO `lang_definitions` VALUES (5196, 3005, 3, 'PARA');
INSERT INTO `lang_definitions` VALUES (5197, 3006, 3, 'para');
INSERT INTO `lang_definitions` VALUES (5198, 3007, 3, 'Área afectada ');
INSERT INTO `lang_definitions` VALUES (5199, 3008, 3, 'área afectada ');
INSERT INTO `lang_definitions` VALUES (5200, 3009, 3, 'Ver a facturación ');
INSERT INTO `lang_definitions` VALUES (5201, 3010, 3, 'a la categoría ');
INSERT INTO `lang_definitions` VALUES (5202, 3011, 3, 'Ver a Clínica ');
INSERT INTO `lang_definitions` VALUES (5203, 3012, 3, 'De copago ');
INSERT INTO `lang_definitions` VALUES (5204, 3013, 3, 'Para ded\'ble ');
INSERT INTO `lang_definitions` VALUES (5205, 3014, 3, 'Para DEMs ');
INSERT INTO `lang_definitions` VALUES (5206, 3015, 3, 'Para Enctr');
INSERT INTO `lang_definitions` VALUES (5207, 3016, 3, 'Para filtrar por sexo');
INSERT INTO `lang_definitions` VALUES (5208, 3017, 3, 'La Historia ');
INSERT INTO `lang_definitions` VALUES (5209, 3018, 3, 'Para cuestiones ');
INSERT INTO `lang_definitions` VALUES (5210, 3019, 3, 'Para enlazar este encuentro / consultar a un problema, haga clic en el tema de arriba para destacar y, a continuación, haga clic en [Guardar]. Mantenga pulsada la tecla [Ctrl] para seleccionar múltiples cuestiones. ');
INSERT INTO `lang_definitions` VALUES (5211, 3020, 3, 'volver a iniciar sesión ');
INSERT INTO `lang_definitions` VALUES (5212, 3021, 3, 'Para la piel ');
INSERT INTO `lang_definitions` VALUES (5213, 3022, 3, 'para la piel');
INSERT INTO `lang_definitions` VALUES (5214, 3023, 3, '¿a esta visita? ');
INSERT INTO `lang_definitions` VALUES (5215, 3024, 3, 'Para:');
INSERT INTO `lang_definitions` VALUES (5216, 3025, 3, 'Para:');
INSERT INTO `lang_definitions` VALUES (5217, 3026, 3, 'PARA_CIUDAD');
INSERT INTO `lang_definitions` VALUES (5218, 3027, 3, 'PARA_FAX');
INSERT INTO `lang_definitions` VALUES (5219, 3028, 3, 'PARA_NOMBRE');
INSERT INTO `lang_definitions` VALUES (5220, 3029, 3, 'PARA_APELLIDO');
INSERT INTO `lang_definitions` VALUES (5221, 3030, 3, 'PARA_SEGUNDONOMBRE');
INSERT INTO `lang_definitions` VALUES (5222, 3031, 3, 'PARA_ORGANIZACIÓN ');
INSERT INTO `lang_definitions` VALUES (5223, 3032, 3, 'PARA_POSTAL');
INSERT INTO `lang_definitions` VALUES (5224, 3033, 3, 'PARA_ESTADO');
INSERT INTO `lang_definitions` VALUES (5225, 3034, 3, 'PARA_CALLE');
INSERT INTO `lang_definitions` VALUES (5226, 3035, 3, 'PARA_TÍTULO ');
INSERT INTO `lang_definitions` VALUES (5227, 3036, 3, 'PARA_DESPEDIDA ');
INSERT INTO `lang_definitions` VALUES (5228, 3037, 3, 'Tabaco');
INSERT INTO `lang_definitions` VALUES (5229, 3038, 3, 'El uso del tabaco ');
INSERT INTO `lang_definitions` VALUES (5230, 3039, 3, 'Hoy');
INSERT INTO `lang_definitions` VALUES (5231, 3040, 3, 'Fecha de Hoy ');
INSERT INTO `lang_definitions` VALUES (5232, 3041, 3, 'Eventos de Hoy ');
INSERT INTO `lang_definitions` VALUES (5233, 3042, 3, 'Tonsilectomía ');
INSERT INTO `lang_definitions` VALUES (5234, 3043, 3, 'Superior');
INSERT INTO `lang_definitions` VALUES (5235, 3044, 3, 'Tema ');
INSERT INTO `lang_definitions` VALUES (5236, 3045, 3, 'total');
INSERT INTO `lang_definitions` VALUES (5237, 3046, 3, 'Total');
INSERT INTO `lang_definitions` VALUES (5238, 3047, 3, 'Cantidad total pagada ');
INSERT INTO `lang_definitions` VALUES (5239, 3048, 3, 'Total de cargos ');
INSERT INTO `lang_definitions` VALUES (5240, 3049, 3, 'Total de Clientes ');
INSERT INTO `lang_definitions` VALUES (5241, 3050, 3, 'Total para');
INSERT INTO `lang_definitions` VALUES (5242, 3051, 3, 'Total para');
INSERT INTO `lang_definitions` VALUES (5243, 3052, 3, 'Total para la categoría ');
INSERT INTO `lang_definitions` VALUES (5244, 3053, 3, 'Total número de pacientes ');
INSERT INTO `lang_definitions` VALUES (5245, 3054, 3, 'Total SRH & Planificación Familiar ');
INSERT INTO `lang_definitions` VALUES (5246, 3055, 3, 'Total');
INSERT INTO `lang_definitions` VALUES (5247, 3056, 3, 'Total para');
INSERT INTO `lang_definitions` VALUES (5248, 3057, 3, 'Total para');
INSERT INTO `lang_definitions` VALUES (5249, 3058, 3, 'Tipo de Entrenamiento ');
INSERT INTO `lang_definitions` VALUES (5250, 3059, 3, 'Tramite ');
INSERT INTO `lang_definitions` VALUES (5251, 3060, 3, 'transacción ');
INSERT INTO `lang_definitions` VALUES (5252, 3061, 3, 'Transacción ');
INSERT INTO `lang_definitions` VALUES (5253, 3062, 3, 'Tipo de Transacción ');
INSERT INTO `lang_definitions` VALUES (5254, 3063, 3, 'Transacción ');
INSERT INTO `lang_definitions` VALUES (5255, 3064, 3, 'Transacciones (escriba opcional) ');
INSERT INTO `lang_definitions` VALUES (5256, 3065, 3, 'Transacciones / Visitas ');
INSERT INTO `lang_definitions` VALUES (5257, 3066, 3, 'traducir este ');
INSERT INTO `lang_definitions` VALUES (5258, 3067, 3, 'Traducción ');
INSERT INTO `lang_definitions` VALUES (5259, 3069, 3, 'Trauma');
INSERT INTO `lang_definitions` VALUES (5260, 3070, 3, 'Objetivos de Tratamiento ');
INSERT INTO `lang_definitions` VALUES (5261, 3071, 3, 'Plan de Tratamiento ');
INSERT INTO `lang_definitions` VALUES (5262, 3072, 3, 'Tratamiento: ');
INSERT INTO `lang_definitions` VALUES (5263, 3073, 3, 'Tratamiento: ');
INSERT INTO `lang_definitions` VALUES (5264, 3074, 3, 'trftime ($ mes_formato, mkhora(0, 0, 0, $i, 1, 2000))); $ mes_valor');
INSERT INTO `lang_definitions` VALUES (5265, 3075, 3, 'Punto de activación / síndrome compartimental / DOM / calambres ');
INSERT INTO `lang_definitions` VALUES (5266, 3076, 3, 'Trimalleolar');
INSERT INTO `lang_definitions` VALUES (5267, 3077, 3, 'tring[,\'r\'[,');
INSERT INTO `lang_definitions` VALUES (5268, 3078, 3, 'Tronco y abdomen ');
INSERT INTO `lang_definitions` VALUES (5269, 3079, 3, 'tsp');
INSERT INTO `lang_definitions` VALUES (5270, 3080, 3, 'TTS');
INSERT INTO `lang_definitions` VALUES (5271, 3081, 3, 'Tuberculosis ');
INSERT INTO `lang_definitions` VALUES (5272, 3082, 3, 'Martes');
INSERT INTO `lang_definitions` VALUES (5273, 3083, 3, 'Martes y Jueves ');
INSERT INTO `lang_definitions` VALUES (5274, 3084, 3, 'Martes');
INSERT INTO `lang_definitions` VALUES (5275, 3085, 3, 'Tumor');
INSERT INTO `lang_definitions` VALUES (5276, 3086, 3, 'Dos veses al dia');
INSERT INTO `lang_definitions` VALUES (5277, 3087, 3, 'Membrana Timpánica ');
INSERT INTO `lang_definitions` VALUES (5278, 3088, 3, 'Tipo');
INSERT INTO `lang_definitions` VALUES (5279, 3089, 3, 'Tipo de exploración o el identificador del paciente aquí');
INSERT INTO `lang_definitions` VALUES (5280, 3090, 3, 'Los códigos de UCSMC proporcionaron por la universidad del centro de la medicina de deportes de Calgary ');
INSERT INTO `lang_definitions` VALUES (5281, 3091, 3, 'Ulceraciones ');
INSERT INTO `lang_definitions` VALUES (5282, 3092, 3, 'Colitis ulcerosa ');
INSERT INTO `lang_definitions` VALUES (5283, 3093, 3, 'Úlceras: ');
INSERT INTO `lang_definitions` VALUES (5284, 3094, 3, 'Unassigned');
INSERT INTO `lang_definitions` VALUES (5285, 3095, 3, 'Acceso no autorizado. ');
INSERT INTO `lang_definitions` VALUES (5286, 3096, 3, 'debajo de la lengüeta ');
INSERT INTO `lang_definitions` VALUES (5287, 3097, 3, 'De peso insuficiente ');
INSERT INTO `lang_definitions` VALUES (5288, 3098, 3, 'Sin diagnosticar ');
INSERT INTO `lang_definitions` VALUES (5289, 3099, 3, 'Deshacer desprotección');
INSERT INTO `lang_definitions` VALUES (5290, 3100, 3, 'Clientes Únicos');
INSERT INTO `lang_definitions` VALUES (5291, 3101, 3, 'Nuevos Clientes Unicos ');
INSERT INTO `lang_definitions` VALUES (5292, 3102, 3, 'Unicos Pacientes Vistos');
INSERT INTO `lang_definitions` VALUES (5293, 3103, 3, 'Informe de unicos pacientes vistos');
INSERT INTO `lang_definitions` VALUES (5294, 3104, 3, 'SP único');
INSERT INTO `lang_definitions` VALUES (5295, 3105, 3, 'Unidad');
INSERT INTO `lang_definitions` VALUES (5296, 3106, 3, 'Unidades');
INSERT INTO `lang_definitions` VALUES (5297, 3107, 3, 'unidades');
INSERT INTO `lang_definitions` VALUES (5298, 3109, 3, 'Desconocido ');
INSERT INTO `lang_definitions` VALUES (5299, 3110, 3, 'Desconocidos o N/A');
INSERT INTO `lang_definitions` VALUES (5300, 3111, 3, 'Compañía de seguros sin nombre ');
INSERT INTO `lang_definitions` VALUES (5301, 3112, 3, 'No registrado ');
INSERT INTO `lang_definitions` VALUES (5302, 3113, 3, 'Deseleccionar todos ');
INSERT INTO `lang_definitions` VALUES (5303, 3114, 3, 'Deseleccionados ');
INSERT INTO `lang_definitions` VALUES (5304, 3115, 3, 'Sin especificar ');
INSERT INTO `lang_definitions` VALUES (5305, 3116, 3, 'Hasta');
INSERT INTO `lang_definitions` VALUES (5306, 3117, 3, 'Presentación extemporánea ');
INSERT INTO `lang_definitions` VALUES (5307, 3118, 3, 'No utilizados ');
INSERT INTO `lang_definitions` VALUES (5308, 3119, 3, 'UOR');
INSERT INTO `lang_definitions` VALUES (5309, 3120, 3, 'Hasta');
INSERT INTO `lang_definitions` VALUES (5310, 3121, 3, 'Próximas Citas ');
INSERT INTO `lang_definitions` VALUES (5311, 3122, 3, 'Próximos Eventos ');
INSERT INTO `lang_definitions` VALUES (5312, 3123, 3, 'Actualizar ');
INSERT INTO `lang_definitions` VALUES (5313, 3124, 3, 'actualizar ');
INSERT INTO `lang_definitions` VALUES (5314, 3125, 3, 'Actualizar archivos');
INSERT INTO `lang_definitions` VALUES (5315, 3126, 3, 'Actualizar Informacion');
INSERT INTO `lang_definitions` VALUES (5316, 3130, 3, 'Updating demographics is not authorized.');
INSERT INTO `lang_definitions` VALUES (5317, 3131, 3, 'UPIN');
INSERT INTO `lang_definitions` VALUES (5318, 3132, 3, 'Subir');
INSERT INTO `lang_definitions` VALUES (5319, 3134, 3, 'Subir Documento ');
INSERT INTO `lang_definitions` VALUES (5320, 3136, 3, 'Subrir archivo de importación: ');
INSERT INTO `lang_definitions` VALUES (5321, 3137, 3, 'Upload Report');
INSERT INTO `lang_definitions` VALUES (5322, 3138, 3, 'Subir este archivo: ');
INSERT INTO `lang_definitions` VALUES (5323, 3139, 3, 'Al hacer clic en un número de factura el \"manual de desplazamiento ventana\" aparece. Aquí puede cambiar la fecha de vencimiento y toma nota de la factura, para seleccionar la parte a quien se le envío por correo, y seleccione los seguros para que todos esperemos los pagos se han recibidos. Lo que es más importante, para cada código de facturación para los que fue acusado una cantidad, puede introducir la información de pago y el ajuste.');
INSERT INTO `lang_definitions` VALUES (5324, 3140, 3, 'Tras la búsqueda se le presenta con una lista de las facturas. Puede hacer clic en uno de los números de la factura para abrir una segunda ventana, que es la página de entrada de datos manual de desplazamiento. También puede hacer clic sobre el nombre de un paciente si desea escribir una nota que la oficina de personal se verá cuando el paciente en los controles, y usted puede seleccionar que aparezca en las facturas del paciente declaraciones e imprimir esas declaraciones. ');
INSERT INTO `lang_definitions` VALUES (5325, 3141, 3, 'Parte superior del brazo');
INSERT INTO `lang_definitions` VALUES (5326, 3142, 3, 'Urgencia ');
INSERT INTO `lang_definitions` VALUES (5327, 3143, 3, 'Goteo de Orina ');
INSERT INTO `lang_definitions` VALUES (5328, 3144, 3, 'Frecuencia de la Orina ');
INSERT INTO `lang_definitions` VALUES (5329, 3145, 3, 'Vacilación de la Orina ');
INSERT INTO `lang_definitions` VALUES (5330, 3146, 3, 'Flujo de Orina ');
INSERT INTO `lang_definitions` VALUES (5331, 3147, 3, 'Urgencia de la Orina ');
INSERT INTO `lang_definitions` VALUES (5332, 3148, 3, 'URL');
INSERT INTO `lang_definitions` VALUES (5333, 3150, 3, 'Utilice el formato de 24 horas? ');
INSERT INTO `lang_definitions` VALUES (5334, 3151, 3, 'Utilice los defectos ');
INSERT INTO `lang_definitions` VALUES (5335, 3152, 3, '¿Utilice el estilo internacional de la fecha? ');
INSERT INTO `lang_definitions` VALUES (5336, 3154, 3, 'Usar temas? ');
INSERT INTO `lang_definitions` VALUES (5337, 3155, 3, 'Usar');
INSERT INTO `lang_definitions` VALUES (5338, 3156, 3, 'Usar Administración ');
INSERT INTO `lang_definitions` VALUES (5339, 3157, 3, 'Facilidad de administración de usuarios');
INSERT INTO `lang_definitions` VALUES (5340, 3158, 3, 'Administración de usuarios y grupos ');
INSERT INTO `lang_definitions` VALUES (5341, 3159, 3, 'Usarios Definidos');
INSERT INTO `lang_definitions` VALUES (5342, 3160, 3, 'Definido por el usuario Zona 11');
INSERT INTO `lang_definitions` VALUES (5343, 3161, 3, 'Definido por el usuario Zona 12');
INSERT INTO `lang_definitions` VALUES (5344, 3162, 3, 'Campo definido por el usario ');
INSERT INTO `lang_definitions` VALUES (5345, 3163, 3, 'Definido por el usuario Lista 1');
INSERT INTO `lang_definitions` VALUES (5346, 3164, 3, 'Definido por el usuario Lista 2');
INSERT INTO `lang_definitions` VALUES (5347, 3165, 3, 'Definido por el usuario Lista 3');
INSERT INTO `lang_definitions` VALUES (5348, 3166, 3, 'Definido por el usuario Lista 4');
INSERT INTO `lang_definitions` VALUES (5349, 3167, 3, 'Definido por el usuario Lista 5');
INSERT INTO `lang_definitions` VALUES (5350, 3168, 3, 'Definido por el usuario Lista 6');
INSERT INTO `lang_definitions` VALUES (5351, 3169, 3, 'Definido por el usuario Lista 7');
INSERT INTO `lang_definitions` VALUES (5352, 3170, 3, 'Definido por el usuario Texto 1 ');
INSERT INTO `lang_definitions` VALUES (5353, 3171, 3, 'Definido por el usuario Texto 2');
INSERT INTO `lang_definitions` VALUES (5354, 3172, 3, 'Definido por el usuario Texto 3');
INSERT INTO `lang_definitions` VALUES (5355, 3173, 3, 'Definido por el usuario Texto 4');
INSERT INTO `lang_definitions` VALUES (5356, 3174, 3, 'Definido por el usuario Texto 5');
INSERT INTO `lang_definitions` VALUES (5357, 3175, 3, 'Definido por el usuario Texto 6');
INSERT INTO `lang_definitions` VALUES (5358, 3176, 3, 'Definido por el usuario Texto 7');
INSERT INTO `lang_definitions` VALUES (5359, 3177, 3, 'Definido por el usuario Texto 8');
INSERT INTO `lang_definitions` VALUES (5360, 3179, 3, 'Asociaciones de usuarios ');
INSERT INTO `lang_definitions` VALUES (5361, 3180, 3, 'Nombre de usuario ');
INSERT INTO `lang_definitions` VALUES (5362, 3181, 3, 'Nombre de usuario para la entrada de SMS ');
INSERT INTO `lang_definitions` VALUES (5363, 3182, 3, 'Nombre de usuario: ');
INSERT INTO `lang_definitions` VALUES (5364, 3183, 3, 'Usuarios');
INSERT INTO `lang_definitions` VALUES (5365, 3184, 3, 'Usuarios / Grupos / Administración de Registros ');
INSERT INTO `lang_definitions` VALUES (5366, 3185, 3, 'usar php <a href=\"http://php.net/strftime\">strfhora</a> formato');
INSERT INTO `lang_definitions` VALUES (5367, 3186, 3, 'UTIs');
INSERT INTO `lang_definitions` VALUES (5368, 3187, 3, 'VACACIONES');
INSERT INTO `lang_definitions` VALUES (5369, 3188, 3, 'Vacaciones ');
INSERT INTO `lang_definitions` VALUES (5370, 3189, 3, 'Vacuna');
INSERT INTO `lang_definitions` VALUES (5371, 3190, 3, 'Anillo Vaginal ');
INSERT INTO `lang_definitions` VALUES (5372, 3191, 3, 'Despedida');
INSERT INTO `lang_definitions` VALUES (5373, 3192, 3, 'Valor 1');
INSERT INTO `lang_definitions` VALUES (5374, 3193, 3, 'Valor 2 ');
INSERT INTO `lang_definitions` VALUES (5375, 3194, 3, 'Var1');
INSERT INTO `lang_definitions` VALUES (5376, 3195, 3, 'Var2');
INSERT INTO `lang_definitions` VALUES (5377, 3196, 3, 'Varicela 1 ');
INSERT INTO `lang_definitions` VALUES (5378, 3197, 3, 'Varicela 2 ');
INSERT INTO `lang_definitions` VALUES (5379, 3198, 3, 'Venas varicosas ');
INSERT INTO `lang_definitions` VALUES (5380, 3199, 3, 'Condición vascular');
INSERT INTO `lang_definitions` VALUES (5381, 3200, 3, 'Lesión vascular');
INSERT INTO `lang_definitions` VALUES (5382, 3201, 3, 'Cirugía Vascular');
INSERT INTO `lang_definitions` VALUES (5383, 3202, 3, 'Versión ');
INSERT INTO `lang_definitions` VALUES (5384, 3203, 3, 'Vértigo ');
INSERT INTO `lang_definitions` VALUES (5385, 3204, 3, 'Plan de Administración de veteranos ');
INSERT INTO `lang_definitions` VALUES (5386, 3205, 3, 'Ver');
INSERT INTO `lang_definitions` VALUES (5387, 3206, 3, 'ver');
INSERT INTO `lang_definitions` VALUES (5388, 3207, 3, 'Ver Alergias');
INSERT INTO `lang_definitions` VALUES (5389, 3208, 3, 'Ver Informe comprensiva del paciente');
INSERT INTO `lang_definitions` VALUES (5390, 3209, 3, 'Ver documento ');
INSERT INTO `lang_definitions` VALUES (5391, 3210, 3, 'Ver encuentro ');
INSERT INTO `lang_definitions` VALUES (5392, 3211, 3, 'Ver los eventos en una ventana móvil? ');
INSERT INTO `lang_definitions` VALUES (5393, 3212, 3, 'Ver Página 1 ');
INSERT INTO `lang_definitions` VALUES (5394, 3213, 3, 'Ver Página 2');
INSERT INTO `lang_definitions` VALUES (5395, 3214, 3, 'Ver los encuentros relacionados ');
INSERT INTO `lang_definitions` VALUES (5396, 3216, 3, 'Ver:');
INSERT INTO `lang_definitions` VALUES (5397, 3217, 3, 'VISA');
INSERT INTO `lang_definitions` VALUES (5398, 3218, 3, 'Daño viscerales/trauma/cirugía ');
INSERT INTO `lang_definitions` VALUES (5399, 3219, 3, 'Visita Categoría: ');
INSERT INTO `lang_definitions` VALUES (5400, 3220, 3, 'Fecha de Visita ');
INSERT INTO `lang_definitions` VALUES (5401, 3222, 3, 'Visitas');
INSERT INTO `lang_definitions` VALUES (5402, 3223, 3, 'Visitas De');
INSERT INTO `lang_definitions` VALUES (5403, 3225, 3, 'Vitales ');
INSERT INTO `lang_definitions` VALUES (5404, 3226, 3, 'Vitales (Métrico) ');
INSERT INTO `lang_definitions` VALUES (5405, 3228, 3, 'Vómitos ');
INSERT INTO `lang_definitions` VALUES (5406, 3229, 3, 'W');
INSERT INTO `lang_definitions` VALUES (5407, 3230, 3, 'Circ cintura ');
INSERT INTO `lang_definitions` VALUES (5408, 3231, 3, 'Circunferencia de la Cintura ');
INSERT INTO `lang_definitions` VALUES (5409, 3232, 3, 'Espera');
INSERT INTO `lang_definitions` VALUES (5410, 3233, 3, 'Entrar ');
INSERT INTO `lang_definitions` VALUES (5411, 3234, 3, 'Walt Pennington');
INSERT INTO `lang_definitions` VALUES (5412, 3235, 3, 'Cálido ');
INSERT INTO `lang_definitions` VALUES (5413, 3236, 3, 'ADVERTENCIA ');
INSERT INTO `lang_definitions` VALUES (5414, 3237, 3, 'Advertencia: La visita se ha creado para este paciente de hoy! ');
INSERT INTO `lang_definitions` VALUES (5415, 3238, 3, 'Advertencia: Identificación del paciente no es único! ');
INSERT INTO `lang_definitions` VALUES (5416, 3240, 3, 'hemos visto por encima de su paciente para la evaluación y tratamiento en nuestra clínica de consulta externa de psiquiatría. Gracias por esta referencia. ');
INSERT INTO `lang_definitions` VALUES (5417, 3241, 3, 'Debilidad ');
INSERT INTO `lang_definitions` VALUES (5418, 3242, 3, 'Sitio Web ');
INSERT INTO `lang_definitions` VALUES (5419, 3243, 3, 'Miércoles');
INSERT INTO `lang_definitions` VALUES (5420, 3244, 3, 'Miércoles');
INSERT INTO `lang_definitions` VALUES (5421, 3245, 3, 'semana');
INSERT INTO `lang_definitions` VALUES (5422, 3246, 3, 'Semana');
INSERT INTO `lang_definitions` VALUES (5423, 3247, 3, 'Ver Semana');
INSERT INTO `lang_definitions` VALUES (5424, 3248, 3, 'Semana(s)');
INSERT INTO `lang_definitions` VALUES (5425, 3249, 3, 'Peso ');
INSERT INTO `lang_definitions` VALUES (5426, 3250, 3, 'Cambio de peso ');
INSERT INTO `lang_definitions` VALUES (5427, 3251, 3, 'Perdida de Peso');
INSERT INTO `lang_definitions` VALUES (5428, 3252, 3, '¿Cuál debe ser contado? ');
INSERT INTO `lang_definitions` VALUES (5429, 3253, 3, 'Los Resuellos: ');
INSERT INTO `lang_definitions` VALUES (5430, 3254, 3, 'Sibilancia ');
INSERT INTO `lang_definitions` VALUES (5431, 3255, 3, 'Resollando: ');
INSERT INTO `lang_definitions` VALUES (5432, 3256, 3, '¿Donde puede los documentos explorados o de papel relacionados que se encontrarán? ');
INSERT INTO `lang_definitions` VALUES (5433, 3257, 3, 'Trallazo ');
INSERT INTO `lang_definitions` VALUES (5434, 3258, 3, 'Quién ');
INSERT INTO `lang_definitions` VALUES (5435, 3259, 3, '¿Quién respondió?');
INSERT INTO `lang_definitions` VALUES (5436, 3260, 3, 'Viudo ');
INSERT INTO `lang_definitions` VALUES (5437, 3262, 3, 'con el viejo nombre ');
INSERT INTO `lang_definitions` VALUES (5438, 3263, 3, '¿Con quién podemos dejar un mensaje? ');
INSERT INTO `lang_definitions` VALUES (5439, 3264, 3, 'dentro de horas ');
INSERT INTO `lang_definitions` VALUES (5440, 3265, 3, 'dentro de horas: ');
INSERT INTO `lang_definitions` VALUES (5441, 3266, 3, 'dentro de minutos');
INSERT INTO `lang_definitions` VALUES (5442, 3267, 3, 'dentro de minutos:');
INSERT INTO `lang_definitions` VALUES (5443, 3268, 3, 'Sin Actualización ');
INSERT INTO `lang_definitions` VALUES (5444, 3269, 3, 'Testigo ');
INSERT INTO `lang_definitions` VALUES (5445, 3270, 3, 'WNL');
INSERT INTO `lang_definitions` VALUES (5446, 3271, 3, 'Mujer');
INSERT INTO `lang_definitions` VALUES (5447, 3272, 3, 'Sólo las Mujeres ');
INSERT INTO `lang_definitions` VALUES (5448, 3273, 3, 'Trabajo');
INSERT INTO `lang_definitions` VALUES (5449, 3274, 3, 'NOTA DE TRABAJO');
INSERT INTO `lang_definitions` VALUES (5450, 3275, 3, 'Teléfono de Trabajo ');
INSERT INTO `lang_definitions` VALUES (5451, 3276, 3, 'Número de Teléfono de Trabajo ');
INSERT INTO `lang_definitions` VALUES (5452, 3277, 3, 'Relacionados con el trabajo? ');
INSERT INTO `lang_definitions` VALUES (5453, 3278, 3, 'Trabajo / Educación / aficiones ');
INSERT INTO `lang_definitions` VALUES (5454, 3279, 3, 'Nota de Trabajo/Escuela');
INSERT INTO `lang_definitions` VALUES (5455, 3280, 3, 'día de trabajo ');
INSERT INTO `lang_definitions` VALUES (5456, 3281, 3, 'Indemnización de los trabajadores del Plan de Salud ');
INSERT INTO `lang_definitions` VALUES (5457, 3282, 3, 'Peor');
INSERT INTO `lang_definitions` VALUES (5458, 3283, 3, 'Muñeca ');
INSERT INTO `lang_definitions` VALUES (5459, 3284, 3, 'Muñeca y mano');
INSERT INTO `lang_definitions` VALUES (5460, 3285, 3, 'Problemas de Mano');
INSERT INTO `lang_definitions` VALUES (5461, 3286, 3, 'escribir ');
INSERT INTO `lang_definitions` VALUES (5462, 3287, 3, 'Cancelar');
INSERT INTO `lang_definitions` VALUES (5463, 3288, 3, 'con algunos ');
INSERT INTO `lang_definitions` VALUES (5464, 3290, 3, 'x Cancelado ');
INSERT INTO `lang_definitions` VALUES (5465, 3291, 3, 'Rayos X');
INSERT INTO `lang_definitions` VALUES (5466, 3292, 3, 'Interpretación de RAYOS X: ');
INSERT INTO `lang_definitions` VALUES (5467, 3293, 3, 'Interpretación de Rayos X: ');
INSERT INTO `lang_definitions` VALUES (5468, 3294, 3, 'X12 solamente: Demanda del reemplazo ');
INSERT INTO `lang_definitions` VALUES (5469, 3295, 3, 'X12 Socio');
INSERT INTO `lang_definitions` VALUES (5470, 3296, 3, 'X12 Socios ');
INSERT INTO `lang_definitions` VALUES (5471, 3297, 3, 'A');
INSERT INTO `lang_definitions` VALUES (5472, 3298, 3, 'Año');
INSERT INTO `lang_definitions` VALUES (5473, 3299, 3, 'Año');
INSERT INTO `lang_definitions` VALUES (5474, 3300, 3, 'Ver año');
INSERT INTO `lang_definitions` VALUES (5475, 3301, 3, 'Año(s)');
INSERT INTO `lang_definitions` VALUES (5476, 3302, 3, 'SI');
INSERT INTO `lang_definitions` VALUES (5477, 3303, 3, 'Si');
INSERT INTO `lang_definitions` VALUES (5478, 3304, 3, 'si');
INSERT INTO `lang_definitions` VALUES (5479, 3305, 3, 'SI!');
INSERT INTO `lang_definitions` VALUES (5480, 3306, 3, 'Sí, Borrar y Registros ');
INSERT INTO `lang_definitions` VALUES (5481, 3307, 3, 'Si/No');
INSERT INTO `lang_definitions` VALUES (5482, 3308, 3, 'Si:');
INSERT INTO `lang_definitions` VALUES (5483, 3309, 3, 'Estás a punto de reemplazar permanentemente la plantilla existente. ¿Estás seguro de que desea continuar? ');
INSERT INTO `lang_definitions` VALUES (5484, 3310, 3, 'No está permitido eliminar este evento ');
INSERT INTO `lang_definitions` VALUES (5485, 3311, 3, 'No está permitido a editar este evento ');
INSERT INTO `lang_definitions` VALUES (5486, 3312, 3, 'Usted no está autorizado para esto. ');
INSERT INTO `lang_definitions` VALUES (5487, 3313, 3, 'Usted no está autorizado para acceder a esta escuadra. ');
INSERT INTO `lang_definitions` VALUES (5488, 3314, 3, 'No está autorizado a añadir o editar temas ');
INSERT INTO `lang_definitions` VALUES (5489, 3315, 3, 'Usted no está autorizado para ver este encuentro. ');
INSERT INTO `lang_definitions` VALUES (5490, 3316, 3, 'No se puede acceder a esta función directamente. ');
INSERT INTO `lang_definitions` VALUES (5491, 3317, 3, 'No se puede acceder a esta página directamente. ');
INSERT INTO `lang_definitions` VALUES (5492, 3321, 3, 'Usted no escogió ninguna acción. ');
INSERT INTO `lang_definitions` VALUES (5493, 3322, 3, 'Usted no tiene acceso para ver o editar esta nota ');
INSERT INTO `lang_definitions` VALUES (5494, 3324, 3, 'Primero debe seleccionar o agregar un paciente. ');
INSERT INTO `lang_definitions` VALUES (5495, 3325, 3, 'Primero debe seleccionar o crear un encuentro. ');
INSERT INTO `lang_definitions` VALUES (5496, 3326, 3, 'Debe seleccionar algunos campos para continuar. ');
INSERT INTO `lang_definitions` VALUES (5497, 3327, 3, 'Usted debe estar ejecutando esta prueba si esta afirmación parece generar con éxito, pero la reclamación no contiene el archivo de los datos o sólo una parte inconclusa de la cantidad de datos que se supone que contienen. Es evidente con HCFA reclamaciones porque son legibles, con X12 afirma que es más difícil un proceso para determinar si la demanda está bien completa.');
INSERT INTO `lang_definitions` VALUES (5498, 3328, 3, 'Su fecha de finalización no es válida ');
INSERT INTO `lang_definitions` VALUES (5499, 3329, 3, 'Su evento a sido suprimido');
INSERT INTO `lang_definitions` VALUES (5500, 3330, 3, 'Su evento a sido modificados');
INSERT INTO `lang_definitions` VALUES (5501, 3331, 3, 'Su evento a sido presentado');
INSERT INTO `lang_definitions` VALUES (5502, 3332, 3, 'Su nombre de la lista se ha cambiado para resolver el nombramiento de requisitos. ');
INSERT INTO `lang_definitions` VALUES (5503, 3333, 3, 'Su configuración de PosteCalendario se ha reajustado a los defectos del uso. ');
INSERT INTO `lang_definitions` VALUES (5504, 3334, 3, 'Se ha puesto al día su configuración de PosteCalendario.');
INSERT INTO `lang_definitions` VALUES (5505, 3335, 3, 'Su frecuencia de repetición debe ser un número entero. ');
INSERT INTO `lang_definitions` VALUES (5506, 3336, 3, 'Su frecuencia de repetición debe ser por lo menos 1. ');
INSERT INTO `lang_definitions` VALUES (5507, 3337, 3, 'Su fecha de inicio es mayor que su fecha de finalización ');
INSERT INTO `lang_definitions` VALUES (5508, 3338, 3, 'Su fecha de inicio no es válido ');
INSERT INTO `lang_definitions` VALUES (5509, 3339, 3, 'Su sumisión falló. ');
INSERT INTO `lang_definitions` VALUES (5510, 3340, 3, 'aaaa-mm-dd ');
INSERT INTO `lang_definitions` VALUES (5511, 3341, 3, 'aaaa-mm-dd fecha asociada con este documento ');
INSERT INTO `lang_definitions` VALUES (5512, 3342, 3, 'aaaa-mm-dd fecha destruido ');
INSERT INTO `lang_definitions` VALUES (5513, 3343, 3, 'aaaa-mm-dd Fecha de Nacimiento ');
INSERT INTO `lang_definitions` VALUES (5514, 3344, 3, 'aaaa-mm-dd fecha de nacimiento ');
INSERT INTO `lang_definitions` VALUES (5515, 3345, 3, 'aaaa-mm-dd fecha de expiración ');
INSERT INTO `lang_definitions` VALUES (5516, 3346, 3, 'aaaa-mm-dd Fecha de inicio o de hospitalización ');
INSERT INTO `lang_definitions` VALUES (5517, 3347, 3, 'aaaa-mm-dd fecha de inicio, cirugía o comienzo de la medicación');
INSERT INTO `lang_definitions` VALUES (5518, 3348, 3, 'aaaa-mm-dd fecha de recuperación o al final de la medicación ');
INSERT INTO `lang_definitions` VALUES (5519, 3349, 3, 'aaaa-mm-dd Fecha de volver a jugar ');
INSERT INTO `lang_definitions` VALUES (5520, 3350, 3, 'aaaa-mm-dd Fecha de servicios');
INSERT INTO `lang_definitions` VALUES (5521, 3351, 3, 'aaaa-mm-dd fecha de esta carta');
INSERT INTO `lang_definitions` VALUES (5522, 3352, 3, 'aaaa-mm-dd fecha que volvió a jugar');
INSERT INTO `lang_definitions` VALUES (5523, 3353, 3, 'aaaa-mm-dd fecha del documento');
INSERT INTO `lang_definitions` VALUES (5524, 3354, 3, 'aaaa-mm-dd fecha de evento o fecha de inicio');
INSERT INTO `lang_definitions` VALUES (5525, 3355, 3, 'aaaa-mm-dd última fecha de este evento');
INSERT INTO `lang_definitions` VALUES (5526, 3356, 3, 'Cero ');
INSERT INTO `lang_definitions` VALUES (5527, 3357, 3, 'Postal');
INSERT INTO `lang_definitions` VALUES (5528, 3358, 3, 'Código postal ');
INSERT INTO `lang_definitions` VALUES (5529, 3359, 3, 'Postal/Pais');
INSERT INTO `lang_definitions` VALUES (5530, 3360, 3, 'pero ha sido');
INSERT INTO `lang_definitions` VALUES (5531, 3361, 3, 'no se ha podido acceder.');
INSERT INTO `lang_definitions` VALUES (5532, 3362, 3, 'Seguro que quiere borrar');
INSERT INTO `lang_definitions` VALUES (5533, 3363, 3, 'Medicamento');
INSERT INTO `lang_definitions` VALUES (5534, 3364, 3, 'correos no mandados');
INSERT INTO `lang_definitions` VALUES (5535, 3365, 3, 'de');
INSERT INTO `lang_definitions` VALUES (5536, 3366, 3, 'ha sido creado');
INSERT INTO `lang_definitions` VALUES (5537, 3367, 3, 'ha sido abierto de nuevo.');
INSERT INTO `lang_definitions` VALUES (5538, 3368, 3, 'Historial');
INSERT INTO `lang_definitions` VALUES (5539, 3369, 3, 'no es un número');
INSERT INTO `lang_definitions` VALUES (5540, 3370, 3, 'listo para refacturar');
INSERT INTO `lang_definitions` VALUES (5541, 3371, 3, 'LLL:');
INSERT INTO `lang_definitions` VALUES (5542, 3372, 3, 'Lote');
INSERT INTO `lang_definitions` VALUES (5543, 3373, 3, 'Nº de Referencia original de Medicaid');
INSERT INTO `lang_definitions` VALUES (5544, 3374, 3, 'min');
INSERT INTO `lang_definitions` VALUES (5545, 3375, 3, 'no encontrado!');
INSERT INTO `lang_definitions` VALUES (5546, 3376, 3, 'Peculiaridades en varios programas de exploración pueden asumir que la información abajo aparece bruscamente, y ocurren pausas extensas que aparentan que el sistema se ha dañado. Este no es el caso, y eventualmente verá información desplegada línea por línea. Podrían aparecer números secuenciales para indicar que aunque no aparezca nada más, el sistema tiene actividad. Estos números serán entremezclados con el contenido de la facturación, y es normal.');
INSERT INTO `lang_definitions` VALUES (5547, 3377, 3, 'la receta ha alcanzado el límite de');
INSERT INTO `lang_definitions` VALUES (5548, 3378, 3, 'hasta');
INSERT INTO `lang_definitions` VALUES (5549, 3379, 3, '¿falló la actualización, no está en la base de datos?');
INSERT INTO `lang_definitions` VALUES (5550, 3380, 3, 'marcado como solo facturado.');
INSERT INTO `lang_definitions` VALUES (5551, 3381, 3, 'puesto en cola.');
INSERT INTO `lang_definitions` VALUES (5552, 3382, 3, '! se retiró sin consulta');
INSERT INTO `lang_definitions` VALUES (5553, 3383, 3, '\" para código ');
INSERT INTO `lang_definitions` VALUES (5554, 3384, 3, '\" está marcado en el seting the PostCalendar');
INSERT INTO `lang_definitions` VALUES (5555, 3385, 3, '# asunto de seguro o financiero');
INSERT INTO `lang_definitions` VALUES (5556, 3386, 3, '# número de tabletas:');
INSERT INTO `lang_definitions` VALUES (5557, 3387, 3, '$');
INSERT INTO `lang_definitions` VALUES (5558, 3388, 3, '$ Codificado');
INSERT INTO `lang_definitions` VALUES (5559, 3389, 3, '$1.00');
INSERT INTO `lang_definitions` VALUES (5560, 3390, 3, '$etiqueta (yyyy-mm-dd)');
INSERT INTO `lang_definitions` VALUES (5561, 3392, 3, '% Cancelado < 24 hrs');
INSERT INTO `lang_definitions` VALUES (5562, 3393, 3, 'debería, pero no existe');
INSERT INTO `lang_definitions` VALUES (5563, 3394, 3, '(% Coincide con cualquier cadena, _ Coincide con cualquier carácter) ');
INSERT INTO `lang_definitions` VALUES (5564, 3395, 3, '(Volver) ');
INSERT INTO `lang_definitions` VALUES (5565, 3396, 3, '(Haga clic para editar) ');
INSERT INTO `lang_definitions` VALUES (5566, 3397, 3, '(Mas)');
INSERT INTO `lang_definitions` VALUES (5567, 3398, 3, '(Paciente Nuevo)');
INSERT INTO `lang_definitions` VALUES (5568, 3399, 3, '(Notas y Autorizaciones)');
INSERT INTO `lang_definitions` VALUES (5569, 3400, 3, 'Notas del Paciente');
INSERT INTO `lang_definitions` VALUES (5570, 3401, 3, '(Seleccione una de estas, o escriba su propio título) ');
INSERT INTO `lang_definitions` VALUES (5571, 3402, 3, '* Recordatorio hecho');
INSERT INTO `lang_definitions` VALUES (5572, 3403, 3, '** Por Favor mover cirugías a asuntos');
INSERT INTO `lang_definitions` VALUES (5573, 3404, 3, '* Requerido');
INSERT INTO `lang_definitions` VALUES (5574, 3405, 3, 'Historia Clínica retirada');
INSERT INTO `lang_definitions` VALUES (5575, 3406, 3, '.');
INSERT INTO `lang_definitions` VALUES (5576, 3407, 3, '0-10');
INSERT INTO `lang_definitions` VALUES (5577, 3408, 3, '1. Descanso 2. Hielo por dos días 3. Compresión, dejar el vendaje en su lugar a menos que el pie presente hormigueo o color pálido 4. Elevar la pierna y el pie');
INSERT INTO `lang_definitions` VALUES (5578, 3409, 3, '11/14/09');
INSERT INTO `lang_definitions` VALUES (5579, 3410, 3, '15-19');
INSERT INTO `lang_definitions` VALUES (5580, 3411, 3, '20-24');
INSERT INTO `lang_definitions` VALUES (5581, 3412, 3, '2111-13');
INSERT INTO `lang_definitions` VALUES (5582, 3413, 3, '25-29');
INSERT INTO `lang_definitions` VALUES (5583, 3414, 3, '2da');
INSERT INTO `lang_definitions` VALUES (5584, 3415, 3, '3 meses');
INSERT INTO `lang_definitions` VALUES (5585, 3416, 3, '3 veces al día');
INSERT INTO `lang_definitions` VALUES (5586, 3417, 3, '30-34');
INSERT INTO `lang_definitions` VALUES (5587, 3418, 3, '35-39');
INSERT INTO `lang_definitions` VALUES (5588, 3419, 3, '3era');
INSERT INTO `lang_definitions` VALUES (5589, 3420, 3, '4 meses');
INSERT INTO `lang_definitions` VALUES (5590, 3421, 3, '4 veces al día');
INSERT INTO `lang_definitions` VALUES (5591, 3422, 3, '40-44');
INSERT INTO `lang_definitions` VALUES (5592, 3423, 3, '45');
INSERT INTO `lang_definitions` VALUES (5593, 3424, 3, '465,9, URI');
INSERT INTO `lang_definitions` VALUES (5594, 3425, 3, '466.0, Bronquitis, Aguda');
INSERT INTO `lang_definitions` VALUES (5595, 3426, 3, '486.0, Neumonía, Aguda');
INSERT INTO `lang_definitions` VALUES (5596, 3427, 3, '491.21 Gravedad de Enfermedad Pulmonar Obstructiva Crónica');
INSERT INTO `lang_definitions` VALUES (5597, 3428, 3, '491.8, Bronquitis, Crónica');
INSERT INTO `lang_definitions` VALUES (5598, 3429, 3, '493.92, Asma, Aguda');
INSERT INTO `lang_definitions` VALUES (5599, 3430, 3, '496.0 Enfermedad Pulmonar Obstructiva Crónica');
INSERT INTO `lang_definitions` VALUES (5600, 3431, 3, '4ta');
INSERT INTO `lang_definitions` VALUES (5601, 3432, 3, '519.7, Broncoespasmo');
INSERT INTO `lang_definitions` VALUES (5602, 3433, 3, '5ta');
INSERT INTO `lang_definitions` VALUES (5603, 3434, 3, '6 meses');
INSERT INTO `lang_definitions` VALUES (5604, 3435, 3, '6ta');
INSERT INTO `lang_definitions` VALUES (5605, 3436, 3, '824.0 Fractura, maléolo intermedio, cerrado ');
INSERT INTO `lang_definitions` VALUES (5606, 3437, 3, '824.2 Fractura, maléolo lateral, cerrado ');
INSERT INTO `lang_definitions` VALUES (5607, 3438, 3, '824,6 Fractura, Trimalleolar, cerrado');
INSERT INTO `lang_definitions` VALUES (5608, 3439, 3, '825.32 Fractura de navicular (tobillo)');
INSERT INTO `lang_definitions` VALUES (5609, 3440, 3, '825,35 Fractura, Base de la quinta (5 ª) metatarsianas');
INSERT INTO `lang_definitions` VALUES (5610, 3441, 3, '845,00 torcedura del tobillo NOS');
INSERT INTO `lang_definitions` VALUES (5611, 3442, 3, '845,01 Letra de medio de la Torcedura (Deltoides) Lig. ');
INSERT INTO `lang_definitions` VALUES (5612, 3443, 3, '845,02 Torcedura, fibular Calcánea');
INSERT INTO `lang_definitions` VALUES (5613, 3444, 3, 'Establecido 99212 - sin complicaciones ');
INSERT INTO `lang_definitions` VALUES (5614, 3445, 3, 'Establecido 99213 - Baja Complejidad ');
INSERT INTO `lang_definitions` VALUES (5615, 3446, 3, '< en consultorio');
INSERT INTO `lang_definitions` VALUES (5616, 3447, 3, '> De Alta / Salida');
INSERT INTO `lang_definitions` VALUES (5617, 3448, 3, '? ausente');
INSERT INTO `lang_definitions` VALUES (5618, 3449, 3, '@ llegado');
INSERT INTO `lang_definitions` VALUES (5619, 3450, 3, '[cambiar vista]');
INSERT INTO `lang_definitions` VALUES (5620, 3451, 3, '[Fecha de último encuentro]');
INSERT INTO `lang_definitions` VALUES (5621, 3452, 3, '[Días desde último encuentro]');
INSERT INTO `lang_definitions` VALUES (5622, 3453, 3, '[EDB]');
INSERT INTO `lang_definitions` VALUES (5623, 3454, 3, '[Exportar OFX]');
INSERT INTO `lang_definitions` VALUES (5624, 3455, 3, '[no recomendado]');
INSERT INTO `lang_definitions` VALUES (5625, 3456, 3, '[Número de encuentros]');
INSERT INTO `lang_definitions` VALUES (5626, 3457, 3, '[Informes]');
INSERT INTO `lang_definitions` VALUES (5627, 3458, 3, '[Seleccionar todos]');
INSERT INTO `lang_definitions` VALUES (5628, 3459, 3, '[SQL-Ledger]');
INSERT INTO `lang_definitions` VALUES (5629, 3460, 3, '[Procesar masivamente]');
INSERT INTO `lang_definitions` VALUES (5630, 3461, 3, '[Visualizar registro]');
INSERT INTO `lang_definitions` VALUES (5631, 3462, 3, '[Ver reporte de variables]');
INSERT INTO `lang_definitions` VALUES (5632, 3463, 3, '_PC_DUR_HORAS');
INSERT INTO `lang_definitions` VALUES (5633, 3464, 3, '_PC_DUR_MINUTOS');
INSERT INTO `lang_definitions` VALUES (5634, 3465, 3, '_PC_LOCALE');
INSERT INTO `lang_definitions` VALUES (5635, 3466, 3, '~ Llegó tarde ');
INSERT INTO `lang_definitions` VALUES (5636, 1, 4, 'A');
INSERT INTO `lang_definitions` VALUES (5637, 2, 4, 'scheck number und ausweiss');
INSERT INTO `lang_definitions` VALUES (5638, 4, 4, 'Eine Losnummer ist notwendig!');
INSERT INTO `lang_definitions` VALUES (5639, 5, 4, 'eine ippf nummer muss angegeben werden');
INSERT INTO `lang_definitions` VALUES (5640, 7, 4, 'präprandial');
INSERT INTO `lang_definitions` VALUES (5641, 8, 4, 'morgens');
INSERT INTO `lang_definitions` VALUES (5642, 9, 4, 'Luft-Fluessigkeit-Ebene Recht');
INSERT INTO `lang_definitions` VALUES (5643, 11, 4, 'Abkürzung');
INSERT INTO `lang_definitions` VALUES (5644, 12, 4, 'Geschwuer');
INSERT INTO `lang_definitions` VALUES (5645, 13, 4, 'Abdominal');
INSERT INTO `lang_definitions` VALUES (5646, 14, 4, 'gewicht an geben in 4 raten');
INSERT INTO `lang_definitions` VALUES (5647, 17, 4, 'auffällig');
INSERT INTO `lang_definitions` VALUES (5648, 18, 4, 'auffälliger Bluttest');
INSERT INTO `lang_definitions` VALUES (5649, 19, 4, 'auffälliges Haarwachstum');
INSERT INTO `lang_definitions` VALUES (5650, 20, 4, 'auffälliges Mammogramm');
INSERT INTO `lang_definitions` VALUES (5651, 21, 4, 'Abort');
INSERT INTO `lang_definitions` VALUES (5652, 22, 4, 'Verhaltener Abort');
INSERT INTO `lang_definitions` VALUES (5653, 23, 4, 'Abtreibungsmethode');
INSERT INTO `lang_definitions` VALUES (5654, 24, 4, 'Abtreibung-Kategorien');
INSERT INTO `lang_definitions` VALUES (5655, 25, 4, 'Abtreibungen');
INSERT INTO `lang_definitions` VALUES (5656, 26, 4, 'Fehlen der Diagnose');
INSERT INTO `lang_definitions` VALUES (5657, 27, 4, 'acept befund');
INSERT INTO `lang_definitions` VALUES (5658, 28, 4, 'acept bezahlung');
INSERT INTO `lang_definitions` VALUES (5659, 29, 4, 'aceptden auftrack');
INSERT INTO `lang_definitions` VALUES (5660, 30, 4, 'acept controlle');
INSERT INTO `lang_definitions` VALUES (5661, 31, 4, 'Verwaltung der Zugriffskontrolllisten');
INSERT INTO `lang_definitions` VALUES (5662, 32, 4, 'Abrechnung');
INSERT INTO `lang_definitions` VALUES (5663, 33, 4, 'Beschwerden');
INSERT INTO `lang_definitions` VALUES (5664, 35, 4, 'Zugangskontrollliste');
INSERT INTO `lang_definitions` VALUES (5665, 36, 4, 'Verwaltung der Zugangskontrollliste');
INSERT INTO `lang_definitions` VALUES (5666, 37, 4, 'Zugriff auf Zugangskontrollliste verweigert');
INSERT INTO `lang_definitions` VALUES (5667, 38, 4, 'Akne');
INSERT INTO `lang_definitions` VALUES (5668, 39, 4, 'Behandlung');
INSERT INTO `lang_definitions` VALUES (5669, 40, 4, 'Behandlungsdatum');
INSERT INTO `lang_definitions` VALUES (5670, 41, 4, 'Aktiv');
INSERT INTO `lang_definitions` VALUES (5671, 42, 4, 'Ausgewählter Fall');
INSERT INTO `lang_definitions` VALUES (5672, 43, 4, 'Ausgewählte Liste');
INSERT INTO `lang_definitions` VALUES (5673, 44, 4, 'Ausgewählter Patient');
INSERT INTO `lang_definitions` VALUES (5674, 45, 4, 'Aktivitätstyp');
INSERT INTO `lang_definitions` VALUES (5675, 46, 4, 'akut exazerbierte chronische');
INSERT INTO `lang_definitions` VALUES (5676, 47, 4, 'Hinzufügen');
INSERT INTO `lang_definitions` VALUES (5677, 49, 4, 'Hinzufügen einer Firma');
INSERT INTO `lang_definitions` VALUES (5678, 50, 4, 'Hinzufügen einer Apotheke');
INSERT INTO `lang_definitions` VALUES (5679, 51, 4, 'hinzufügen eines Ereignisses für');
INSERT INTO `lang_definitions` VALUES (5680, 52, 4, 'Hinzufügen als neue Bemerkung');
INSERT INTO `lang_definitions` VALUES (5681, 53, 4, 'Hinzufügen als neues Element');
INSERT INTO `lang_definitions` VALUES (5682, 54, 4, 'Hinzufügen einer Kategorie');
INSERT INTO `lang_definitions` VALUES (5683, 55, 4, 'Hinzufügen einer Konstante');
INSERT INTO `lang_definitions` VALUES (5684, 56, 4, 'Hinzufügen einer Eigenleistung');
INSERT INTO `lang_definitions` VALUES (5685, 57, 4, 'Hinzufügen eines Medikamentes');
INSERT INTO `lang_definitions` VALUES (5686, 58, 4, 'Hinzufügen eines Falles');
INSERT INTO `lang_definitions` VALUES (5687, 59, 4, 'Hinzufügen einer Einrichtung');
INSERT INTO `lang_definitions` VALUES (5688, 60, 4, 'Hinzufügen eines Feldes');
INSERT INTO `lang_definitions` VALUES (5689, 61, 4, 'Hinzufügen einer Gruppe');
INSERT INTO `lang_definitions` VALUES (5690, 62, 4, 'Hinzufügen eines ICD-Codes');
INSERT INTO `lang_definitions` VALUES (5691, 63, 4, 'Hinzufügen eines Problems');
INSERT INTO `lang_definitions` VALUES (5692, 64, 4, 'Hinzufügen einer Sprache');
INSERT INTO `lang_definitions` VALUES (5693, 65, 4, 'Hinzufügen eines neuen Elementes');
INSERT INTO `lang_definitions` VALUES (5694, 66, 4, 'Hinzufügen einer neuen Kategorie');
INSERT INTO `lang_definitions` VALUES (5695, 67, 4, 'Hinzufügen einer neuen Gruppe');
INSERT INTO `lang_definitions` VALUES (5696, 68, 4, 'Hinzufügen einer neuen Bemerkung');
INSERT INTO `lang_definitions` VALUES (5697, 69, 4, 'Hinzufügen einer neuen Bemerkung');
INSERT INTO `lang_definitions` VALUES (5698, 70, 4, 'Hinzufügen eines neuen Partners');
INSERT INTO `lang_definitions` VALUES (5699, 71, 4, 'Hinzufügen einer Bemerkung');
INSERT INTO `lang_definitions` VALUES (5700, 72, 4, 'Hinzufügen eines Patienten-Datensatzes');
INSERT INTO `lang_definitions` VALUES (5701, 73, 4, 'Hinzufügen einer Verschreibung');
INSERT INTO `lang_definitions` VALUES (5702, 75, 4, 'Hinzufügen zur Liste der Medikamente');
INSERT INTO `lang_definitions` VALUES (5703, 76, 4, 'Hinzufügen einer Transaktion');
INSERT INTO `lang_definitions` VALUES (5704, 77, 4, 'Hinzufügen eines Benutzers');
INSERT INTO `lang_definitions` VALUES (5705, 78, 4, 'Hinzufügen des Benutzers zur Gruppe');
INSERT INTO `lang_definitions` VALUES (5706, 79, 4, 'hinzugefügt');
INSERT INTO `lang_definitions` VALUES (5707, 80, 4, 'Hinzufügen demographischer Daten nicht gestattet.');
INSERT INTO `lang_definitions` VALUES (5708, 81, 4, 'Addison Syndrom');
INSERT INTO `lang_definitions` VALUES (5709, 82, 4, 'Addison Syndrom');
INSERT INTO `lang_definitions` VALUES (5710, 83, 4, 'Weitere Diagnosen:');
INSERT INTO `lang_definitions` VALUES (5711, 84, 4, 'Weitere Vorgeschichte');
INSERT INTO `lang_definitions` VALUES (5712, 85, 4, 'Weitere Bemerkungen zur Vorgeschichte');
INSERT INTO `lang_definitions` VALUES (5713, 86, 4, 'Weitere Informationen');
INSERT INTO `lang_definitions` VALUES (5714, 87, 4, 'Weitere Laborbefunde');
INSERT INTO `lang_definitions` VALUES (5715, 88, 4, 'Weitere Bemerkungen');
INSERT INTO `lang_definitions` VALUES (5716, 89, 4, 'Weitere Bemerkungen:');
INSERT INTO `lang_definitions` VALUES (5717, 90, 4, 'Weitere Bemerkungen:');
INSERT INTO `lang_definitions` VALUES (5718, 91, 4, 'Weitere Bemerkungen zu Röntgenuntersuchungen:');
INSERT INTO `lang_definitions` VALUES (5719, 92, 4, 'nur hinzufügen');
INSERT INTO `lang_definitions` VALUES (5720, 93, 4, 'Adressbuch');
INSERT INTO `lang_definitions` VALUES (5721, 94, 4, 'Adressbuch');
INSERT INTO `lang_definitions` VALUES (5722, 95, 4, 'Adresse');
INSERT INTO `lang_definitions` VALUES (5723, 96, 4, 'Adressbuch');
INSERT INTO `lang_definitions` VALUES (5724, 97, 4, 'Adresse1');
INSERT INTO `lang_definitions` VALUES (5725, 98, 4, 'Adresse2');
INSERT INTO `lang_definitions` VALUES (5726, 99, 4, 'Adj');
INSERT INTO `lang_definitions` VALUES (5727, 100, 4, 'Einstellen');
INSERT INTO `lang_definitions` VALUES (5728, 101, 4, 'Gründe für die Einstellung');
INSERT INTO `lang_definitions` VALUES (5729, 102, 4, 'Angleichungswert für Code');
INSERT INTO `lang_definitions` VALUES (5730, 103, 4, 'Angleichungen');
INSERT INTO `lang_definitions` VALUES (5731, 104, 4, 'Adm anpassen');
INSERT INTO `lang_definitions` VALUES (5732, 105, 4, 'Admin');
INSERT INTO `lang_definitions` VALUES (5733, 106, 4, 'Email-Adresse des Admins');
INSERT INTO `lang_definitions` VALUES (5734, 107, 4, 'Administeriert');
INSERT INTO `lang_definitions` VALUES (5735, 108, 4, 'Administriert durch');
INSERT INTO `lang_definitions` VALUES (5736, 109, 4, 'Administration');
INSERT INTO `lang_definitions` VALUES (5737, 110, 4, 'Administratoren');
INSERT INTO `lang_definitions` VALUES (5738, 111, 4, 'Administratoren haben vollen Zugriff');
INSERT INTO `lang_definitions` VALUES (5739, 112, 4, 'Fortgeschritten');
INSERT INTO `lang_definitions` VALUES (5740, 113, 4, 'Ratschlag');
INSERT INTO `lang_definitions` VALUES (5741, 114, 4, 'Affekt unauffällig');
INSERT INTO `lang_definitions` VALUES (5742, 116, 4, 'Nach Speicherung als PDF [View log] clicken zur Fehlersuche.');
INSERT INTO `lang_definitions` VALUES (5743, 117, 4, 'Nach Speicherung der Stapeldatei [View log] clicken zur Fehlersuche.');
INSERT INTO `lang_definitions` VALUES (5744, 118, 4, 'Nachdem die Daten korrekt eingegeben sind, bitte Speichern klicken.');
INSERT INTO `lang_definitions` VALUES (5745, 119, 4, 'Wieder');
INSERT INTO `lang_definitions` VALUES (5746, 120, 4, 'Alter');
INSERT INTO `lang_definitions` VALUES (5747, 121, 4, 'Alter nach');
INSERT INTO `lang_definitions` VALUES (5748, 122, 4, 'Altersstufe');
INSERT INTO `lang_definitions` VALUES (5749, 123, 4, 'Altersangabe ungültig.');
INSERT INTO `lang_definitions` VALUES (5750, 128, 4, 'Alkohol');
INSERT INTO `lang_definitions` VALUES (5751, 129, 4, 'Alkoholkonsum');
INSERT INTO `lang_definitions` VALUES (5752, 130, 4, 'Alle');
INSERT INTO `lang_definitions` VALUES (5753, 131, 4, 'Alle Kategorien');
INSERT INTO `lang_definitions` VALUES (5754, 132, 4, 'Ganz Tags');
INSERT INTO `lang_definitions` VALUES (5755, 133, 4, 'Ganz Tags event');
INSERT INTO `lang_definitions` VALUES (5756, 134, 4, 'Alle einrichtungen');
INSERT INTO `lang_definitions` VALUES (5757, 135, 4, 'Vollständiger Vorname');
INSERT INTO `lang_definitions` VALUES (5758, 136, 4, 'Vollständiger Familienname');
INSERT INTO `lang_definitions` VALUES (5759, 137, 4, 'Alle Einweiser');
INSERT INTO `lang_definitions` VALUES (5760, 139, 4, 'Alle Themen');
INSERT INTO `lang_definitions` VALUES (5761, 140, 4, 'Alle Benutzer');
INSERT INTO `lang_definitions` VALUES (5762, 141, 4, 'Allergisch');
INSERT INTO `lang_definitions` VALUES (5763, 142, 4, 'Allergien');
INSERT INTO `lang_definitions` VALUES (5764, 143, 4, 'Allergien:');
INSERT INTO `lang_definitions` VALUES (5765, 144, 4, 'Allergie');
INSERT INTO `lang_definitions` VALUES (5766, 145, 4, 'Email erlauben');
INSERT INTO `lang_definitions` VALUES (5767, 146, 4, 'Email-Nachrichten erlauben?');
INSERT INTO `lang_definitions` VALUES (5768, 147, 4, 'Email erlauben?');
INSERT INTO `lang_definitions` VALUES (5769, 148, 4, 'Email-Nachricht erlauben?');
INSERT INTO `lang_definitions` VALUES (5770, 149, 4, 'SMS erlauben?');
INSERT INTO `lang_definitions` VALUES (5771, 150, 4, 'SMS (Text-Nachricht) erlauben?');
INSERT INTO `lang_definitions` VALUES (5772, 151, 4, 'Sofortige Aktivierung von gesendeten Ereignissen erlauben?');
INSERT INTO `lang_definitions` VALUES (5773, 152, 4, 'Telefonnachrichten erlauben?');
INSERT INTO `lang_definitions` VALUES (5774, 153, 4, 'Benutzern die Veröffentlichung von globalen Terminen erlauben?');
INSERT INTO `lang_definitions` VALUES (5775, 154, 4, 'Benutzern die Veröffentlichung von persönlichen Terminlisten erlauben?');
INSERT INTO `lang_definitions` VALUES (5776, 155, 4, 'Sprachnachrichten erlauben?');
INSERT INTO `lang_definitions` VALUES (5777, 156, 4, 'Erlaubt');
INSERT INTO `lang_definitions` VALUES (5778, 157, 4, 'existiert bereits.');
INSERT INTO `lang_definitions` VALUES (5779, 158, 4, 'Wird bereits verwendet, bitte anderen Identifier wählen');
INSERT INTO `lang_definitions` VALUES (5780, 159, 4, 'Wird bereits verwendet, bitte anderen Titel wählen');
INSERT INTO `lang_definitions` VALUES (5781, 160, 4, 'Alternative Adresse');
INSERT INTO `lang_definitions` VALUES (5782, 166, 4, 'Menge');
INSERT INTO `lang_definitions` VALUES (5783, 167, 4, 'Berechnete Menge');
INSERT INTO `lang_definitions` VALUES (5784, 170, 4, 'Bezahlte Summe');
INSERT INTO `lang_definitions` VALUES (5785, 171, 4, 'Menge:');
INSERT INTO `lang_definitions` VALUES (5786, 176, 4, 'Und');
INSERT INTO `lang_definitions` VALUES (5787, 177, 4, 'UND');
INSERT INTO `lang_definitions` VALUES (5788, 178, 4, 'und');
INSERT INTO `lang_definitions` VALUES (5789, 179, 4, 'und');
INSERT INTO `lang_definitions` VALUES (5790, 181, 4, 'Anämie');
INSERT INTO `lang_definitions` VALUES (5791, 182, 4, 'Sprunggelenk');
INSERT INTO `lang_definitions` VALUES (5792, 183, 4, 'Sprunggelenk + Ferse');
INSERT INTO `lang_definitions` VALUES (5793, 186, 4, 'Ankylosierende Spondylitis');
INSERT INTO `lang_definitions` VALUES (5794, 187, 4, 'Ankylosierende Spondylitis');
INSERT INTO `lang_definitions` VALUES (5795, 188, 4, 'Anorexia');
INSERT INTO `lang_definitions` VALUES (5796, 189, 4, 'Eine weitere mögliche Aktion im Sendefenster ist die Anfrage einer sekundären Berechnung. Wenn Sie dies in der Auswahlbox vor dem Speichern wählen, wird die originale Anforderung erneut geöffnet und auf der Abrechnungsseite eingestellt und wird bei der nächsten Bearbeitung dieser abgesendet.');
INSERT INTO `lang_definitions` VALUES (5797, 190, 4, 'vor');
INSERT INTO `lang_definitions` VALUES (5798, 192, 4, 'Angst');
INSERT INTO `lang_definitions` VALUES (5799, 193, 4, 'Etwas');
INSERT INTO `lang_definitions` VALUES (5800, 194, 4, 'Belibige kategorie');
INSERT INTO `lang_definitions` VALUES (5801, 195, 4, 'irgentein teil eines ausgewählten Codes oder beschreibung');
INSERT INTO `lang_definitions` VALUES (5802, 199, 4, 'Erscheinungsbild');
INSERT INTO `lang_definitions` VALUES (5803, 200, 4, 'Erscheinungsbild:');
INSERT INTO `lang_definitions` VALUES (5804, 204, 4, 'Appendektomie');
INSERT INTO `lang_definitions` VALUES (5805, 315, 4, 'Berechnet');
INSERT INTO `lang_definitions` VALUES (5806, 316, 4, 'Rechnung');
INSERT INTO `lang_definitions` VALUES (5807, 328, 4, 'Rechnung an');
INSERT INTO `lang_definitions` VALUES (5808, 330, 4, 'Geburtsdatum');
INSERT INTO `lang_definitions` VALUES (5809, 331, 4, 'Schwarz');
INSERT INTO `lang_definitions` VALUES (5810, 332, 4, 'Blasencarcinom');
INSERT INTO `lang_definitions` VALUES (5811, 338, 4, 'Geblockt');
INSERT INTO `lang_definitions` VALUES (5812, 339, 4, 'Blood druck');
INSERT INTO `lang_definitions` VALUES (5813, 341, 4, 'Blutige Nase');
INSERT INTO `lang_definitions` VALUES (5814, 342, 4, 'Blaues kreuz blaues Schield');
INSERT INTO `lang_definitions` VALUES (5815, 370, 4, 'Brüste');
INSERT INTO `lang_definitions` VALUES (5816, 384, 4, 'Brennen beim Wasserlassen');
INSERT INTO `lang_definitions` VALUES (5817, 385, 4, 'Brennen beim Wasserlassen');
INSERT INTO `lang_definitions` VALUES (5818, 386, 4, 'Besetzt');
INSERT INTO `lang_definitions` VALUES (5819, 388, 4, 'bei');
INSERT INTO `lang_definitions` VALUES (5820, 389, 4, 'oral');
INSERT INTO `lang_definitions` VALUES (5821, 396, 4, 'Kalender');
INSERT INTO `lang_definitions` VALUES (5822, 397, 4, 'Kalendereinstellungen');
INSERT INTO `lang_definitions` VALUES (5823, 399, 4, 'Kalenderanzeige');
INSERT INTO `lang_definitions` VALUES (5824, 403, 4, 'Abbrechen');
INSERT INTO `lang_definitions` VALUES (5825, 404, 4, 'Krebs');
INSERT INTO `lang_definitions` VALUES (5826, 405, 4, 'Kann diesen Eintrag nicht hinzufügen, da er bereits existiert!');
INSERT INTO `lang_definitions` VALUES (5827, 412, 4, 'kann nicht finden');
INSERT INTO `lang_definitions` VALUES (5828, 416, 4, 'kann nicht öffnen');
INSERT INTO `lang_definitions` VALUES (5829, 426, 4, 'bar');
INSERT INTO `lang_definitions` VALUES (5830, 427, 4, 'Bar');
INSERT INTO `lang_definitions` VALUES (5831, 431, 4, 'Katarakte');
INSERT INTO `lang_definitions` VALUES (5832, 432, 4, 'Kategorien');
INSERT INTO `lang_definitions` VALUES (5833, 433, 4, 'Kategorien');
INSERT INTO `lang_definitions` VALUES (5834, 434, 4, 'Kategorie');
INSERT INTO `lang_definitions` VALUES (5835, 435, 4, 'Kategorie');
INSERT INTO `lang_definitions` VALUES (5836, 440, 4, 'Mobiltelefon');
INSERT INTO `lang_definitions` VALUES (5837, 441, 4, 'Mobiltelefonnummer');
INSERT INTO `lang_definitions` VALUES (5838, 442, 4, 'Zentrale Zertifizierung');
INSERT INTO `lang_definitions` VALUES (5839, 446, 4, 'ändern');
INSERT INTO `lang_definitions` VALUES (5840, 451, 4, 'Geändert');
INSERT INTO `lang_definitions` VALUES (5841, 467, 4, 'prüfen');
INSERT INTO `lang_definitions` VALUES (5842, 468, 4, 'Prüfung');
INSERT INTO `lang_definitions` VALUES (5843, 485, 4, 'Thoraxbeschwerden');
INSERT INTO `lang_definitions` VALUES (5844, 486, 4, 'Thoraxbeschwerden:');
INSERT INTO `lang_definitions` VALUES (5845, 487, 4, 'Thoraxschmerz');
INSERT INTO `lang_definitions` VALUES (5846, 490, 4, 'Kind');
INSERT INTO `lang_definitions` VALUES (5847, 493, 4, 'Auswahlmöglichkeiten');
INSERT INTO `lang_definitions` VALUES (5848, 494, 4, 'Cholecystektomie');
INSERT INTO `lang_definitions` VALUES (5849, 495, 4, 'Cholecystektomie');
INSERT INTO `lang_definitions` VALUES (5850, 496, 4, 'Auswählen');
INSERT INTO `lang_definitions` VALUES (5851, 498, 4, 'Auswahlliste');
INSERT INTO `lang_definitions` VALUES (5852, 500, 4, 'Chronische Bronchitis');
INSERT INTO `lang_definitions` VALUES (5853, 501, 4, 'Chronische Gelenkbeschwerden');
INSERT INTO `lang_definitions` VALUES (5854, 502, 4, 'Chronische Synovitis / Gelenkschmerzen');
INSERT INTO `lang_definitions` VALUES (5855, 504, 4, 'Leberzirrhose');
INSERT INTO `lang_definitions` VALUES (5856, 505, 4, 'Leberzirrhose');
INSERT INTO `lang_definitions` VALUES (5857, 506, 4, 'Stadt');
INSERT INTO `lang_definitions` VALUES (5858, 507, 4, 'Stadt');
INSERT INTO `lang_definitions` VALUES (5859, 508, 4, 'Stadt, Land');
INSERT INTO `lang_definitions` VALUES (5860, 509, 4, 'Stadt, Land, Postleitzahl');
INSERT INTO `lang_definitions` VALUES (5861, 510, 4, 'Stadt/Land');
INSERT INTO `lang_definitions` VALUES (5862, 516, 4, 'Löschen');
INSERT INTO `lang_definitions` VALUES (5863, 517, 4, 'Alles löschen');
INSERT INTO `lang_definitions` VALUES (5864, 521, 4, 'Klick');
INSERT INTO `lang_definitions` VALUES (5865, 523, 4, 'Klick für weiter');
INSERT INTO `lang_definitions` VALUES (5866, 524, 4, 'Klicken Sie hier um das Datum zu wählen');
INSERT INTO `lang_definitions` VALUES (5867, 528, 4, 'Clicken zum editieren');
INSERT INTO `lang_definitions` VALUES (5868, 529, 4, 'Klicken um Ereignis zu editieren');
INSERT INTO `lang_definitions` VALUES (5869, 530, 4, 'Klicken um Bericht zu generieren');
INSERT INTO `lang_definitions` VALUES (5870, 531, 4, 'Klicken um zu Drucken');
INSERT INTO `lang_definitions` VALUES (5871, 540, 4, 'Click:');
INSERT INTO `lang_definitions` VALUES (5872, 542, 4, 'Zusammenfassung der Anamnese');
INSERT INTO `lang_definitions` VALUES (5873, 545, 4, 'Patienten');
INSERT INTO `lang_definitions` VALUES (5874, 546, 4, 'Klinik');
INSERT INTO `lang_definitions` VALUES (5875, 548, 4, 'Täglicher Klinik-Bericht');
INSERT INTO `lang_definitions` VALUES (5876, 549, 4, 'Klinik ID');
INSERT INTO `lang_definitions` VALUES (5877, 550, 4, 'Kliniker');
INSERT INTO `lang_definitions` VALUES (5878, 553, 4, 'Schließen');
INSERT INTO `lang_definitions` VALUES (5879, 554, 4, 'Fenster schließen');
INSERT INTO `lang_definitions` VALUES (5880, 555, 4, 'geschlossen');
INSERT INTO `lang_definitions` VALUES (5881, 556, 4, 'cm');
INSERT INTO `lang_definitions` VALUES (5882, 570, 4, 'Kaffee');
INSERT INTO `lang_definitions` VALUES (5883, 573, 4, 'versammlung');
INSERT INTO `lang_definitions` VALUES (5884, 575, 4, 'Kolon-Carcinom');
INSERT INTO `lang_definitions` VALUES (5885, 576, 4, 'Kolon-Caricinom-Chirurgie');
INSERT INTO `lang_definitions` VALUES (5886, 577, 4, 'Koloskopie');
INSERT INTO `lang_definitions` VALUES (5887, 578, 4, 'Koloskopie');
INSERT INTO `lang_definitions` VALUES (5888, 579, 4, 'Farbe');
INSERT INTO `lang_definitions` VALUES (5889, 580, 4, 'Spalten');
INSERT INTO `lang_definitions` VALUES (5890, 581, 4, 'Kommentare');
INSERT INTO `lang_definitions` VALUES (5891, 583, 4, 'Änderungen eintragen');
INSERT INTO `lang_definitions` VALUES (5892, 584, 4, 'Kommunikationen');
INSERT INTO `lang_definitions` VALUES (5893, 585, 4, 'Fertiggestellt');
INSERT INTO `lang_definitions` VALUES (5894, 589, 4, 'Schlußfolgerungen');
INSERT INTO `lang_definitions` VALUES (5895, 590, 4, 'kongenital');
INSERT INTO `lang_definitions` VALUES (5896, 591, 4, 'Konjunktiva, Pupillen');
INSERT INTO `lang_definitions` VALUES (5897, 592, 4, 'Konstante');
INSERT INTO `lang_definitions` VALUES (5898, 593, 4, 'Konstantenname');
INSERT INTO `lang_definitions` VALUES (5899, 594, 4, 'Konstanten');
INSERT INTO `lang_definitions` VALUES (5900, 595, 4, 'Obstipation');
INSERT INTO `lang_definitions` VALUES (5901, 596, 4, 'Konstitutionell');
INSERT INTO `lang_definitions` VALUES (5902, 597, 4, 'Kurzbeschreibung der Konsultation');
INSERT INTO `lang_definitions` VALUES (5903, 598, 4, 'Kontakt');
INSERT INTO `lang_definitions` VALUES (5904, 599, 4, 'Email-Kontakt');
INSERT INTO `lang_definitions` VALUES (5905, 600, 4, 'Email-Kontaktadresse');
INSERT INTO `lang_definitions` VALUES (5906, 601, 4, 'Kontaktinformation');
INSERT INTO `lang_definitions` VALUES (5907, 602, 4, 'Kontaktlinsen');
INSERT INTO `lang_definitions` VALUES (5908, 603, 4, 'Kontaktname');
INSERT INTO `lang_definitions` VALUES (5909, 604, 4, 'Kontaktperson');
INSERT INTO `lang_definitions` VALUES (5910, 605, 4, 'Kontakttelefonnummer');
INSERT INTO `lang_definitions` VALUES (5911, 606, 4, 'Inhalt');
INSERT INTO `lang_definitions` VALUES (5912, 607, 4, 'Inhalt');
INSERT INTO `lang_definitions` VALUES (5913, 608, 4, 'Weiter');
INSERT INTO `lang_definitions` VALUES (5914, 610, 4, 'Empfängnisverhütung');
INSERT INTO `lang_definitions` VALUES (5915, 611, 4, 'Probleme mit Empfängnisverhütung');
INSERT INTO `lang_definitions` VALUES (5916, 613, 4, 'Verhütungsmethode');
INSERT INTO `lang_definitions` VALUES (5917, 621, 4, 'COPD');
INSERT INTO `lang_definitions` VALUES (5918, 624, 4, 'Lizenzbestimmungen');
INSERT INTO `lang_definitions` VALUES (5919, 625, 4, 'Koronarerarterieller Bypass');
INSERT INTO `lang_definitions` VALUES (5920, 626, 4, 'Husten');
INSERT INTO `lang_definitions` VALUES (5921, 627, 4, 'Husten:');
INSERT INTO `lang_definitions` VALUES (5922, 628, 4, 'Konnte Email wegen Server-Problemen nicht senden,');
INSERT INTO `lang_definitions` VALUES (5923, 645, 4, 'Sahne');
INSERT INTO `lang_definitions` VALUES (5924, 646, 4, 'Ereignis erstellen');
INSERT INTO `lang_definitions` VALUES (5925, 647, 4, 'Vollbackup erstellung und herunterladen');
INSERT INTO `lang_definitions` VALUES (5926, 648, 4, 'Backup erstellen');
INSERT INTO `lang_definitions` VALUES (5927, 649, 4, 'Neuen Patienten anlegen');
INSERT INTO `lang_definitions` VALUES (5928, 651, 4, 'Angelegt');
INSERT INTO `lang_definitions` VALUES (5929, 652, 4, 'Datei exportieren');
INSERT INTO `lang_definitions` VALUES (5930, 653, 4, 'Kredit');
INSERT INTO `lang_definitions` VALUES (5931, 654, 4, 'Kredite');
INSERT INTO `lang_definitions` VALUES (5932, 655, 4, 'Morbus Crohn');
INSERT INTO `lang_definitions` VALUES (5933, 656, 4, 'Morbus Crohn');
INSERT INTO `lang_definitions` VALUES (5934, 657, 4, 'CSV-Datei');
INSERT INTO `lang_definitions` VALUES (5935, 658, 4, 'Aktuell');
INSERT INTO `lang_definitions` VALUES (5936, 659, 4, 'Aktuelle Konsultation');
INSERT INTO `lang_definitions` VALUES (5937, 665, 4, 'Cushing-Syndrom');
INSERT INTO `lang_definitions` VALUES (5938, 666, 4, 'Cushing-Syndrom');
INSERT INTO `lang_definitions` VALUES (5939, 667, 4, 'Angepasst');
INSERT INTO `lang_definitions` VALUES (5940, 672, 4, 'D');
INSERT INTO `lang_definitions` VALUES (5941, 675, 4, 'Geb');
INSERT INTO `lang_definitions` VALUES (5942, 676, 4, 'täglich');
INSERT INTO `lang_definitions` VALUES (5943, 679, 4, 'Daten-Spalten');
INSERT INTO `lang_definitions` VALUES (5944, 680, 4, 'Daten-Typen');
INSERT INTO `lang_definitions` VALUES (5945, 681, 4, 'Datenbank');
INSERT INTO `lang_definitions` VALUES (5946, 682, 4, 'Datenbankbericht');
INSERT INTO `lang_definitions` VALUES (5947, 683, 4, 'Datenspalten-Numerierung muß zwischen 1 und 999 liegen');
INSERT INTO `lang_definitions` VALUES (5948, 684, 4, 'Datum');
INSERT INTO `lang_definitions` VALUES (5949, 685, 4, 'Datum');
INSERT INTO `lang_definitions` VALUES (5950, 686, 4, 'Datum der Administration');
INSERT INTO `lang_definitions` VALUES (5951, 689, 4, 'Datumsanzeige-Format');
INSERT INTO `lang_definitions` VALUES (5952, 698, 4, 'Geburtsdatum');
INSERT INTO `lang_definitions` VALUES (5953, 699, 4, 'Geburtsdatum');
INSERT INTO `lang_definitions` VALUES (5954, 700, 4, 'Unfallzeitpunkt');
INSERT INTO `lang_definitions` VALUES (5955, 701, 4, 'Datum der Bezahlung tt-mm-jjjj');
INSERT INTO `lang_definitions` VALUES (5956, 707, 4, 'Datum der Unterschrift');
INSERT INTO `lang_definitions` VALUES (5957, 713, 4, 'Tag');
INSERT INTO `lang_definitions` VALUES (5958, 714, 4, 'Tag');
INSERT INTO `lang_definitions` VALUES (5959, 715, 4, 'Tagesansicht');
INSERT INTO `lang_definitions` VALUES (5960, 716, 4, 'Tag(e)');
INSERT INTO `lang_definitions` VALUES (5961, 717, 4, 'Werktag(e)');
INSERT INTO `lang_definitions` VALUES (5962, 718, 4, 'Tage');
INSERT INTO `lang_definitions` VALUES (5963, 719, 4, 'Tage');
INSERT INTO `lang_definitions` VALUES (5964, 721, 4, 'Tage seit letztem Fall');
INSERT INTO `lang_definitions` VALUES (5965, 722, 4, 'Tage pro Spalte');
INSERT INTO `lang_definitions` VALUES (5966, 723, 4, 'Datenbank installiert');
INSERT INTO `lang_definitions` VALUES (5967, 725, 4, 'Debug-Information');
INSERT INTO `lang_definitions` VALUES (5968, 726, 4, 'Dezember');
INSERT INTO `lang_definitions` VALUES (5969, 727, 4, 'Voreinstellung');
INSERT INTO `lang_definitions` VALUES (5970, 728, 4, 'Kalenderansicht Grundeinstellung');
INSERT INTO `lang_definitions` VALUES (5971, 729, 4, 'Voreingestellte Einrichtung');
INSERT INTO `lang_definitions` VALUES (5972, 730, 4, 'Voreingestellte Liste (schreibbar, optional nur hinzufügen erlaubt)');
INSERT INTO `lang_definitions` VALUES (5973, 731, 4, 'Voreingestellte Methode');
INSERT INTO `lang_definitions` VALUES (5974, 732, 4, 'Voreingestellter Zulieferer');
INSERT INTO `lang_definitions` VALUES (5975, 734, 4, 'Voreingestellter Wert');
INSERT INTO `lang_definitions` VALUES (5976, 735, 4, 'Voreingestellter X12-Partner');
INSERT INTO `lang_definitions` VALUES (5977, 736, 4, 'Voreingestellt/Global');
INSERT INTO `lang_definitions` VALUES (5978, 739, 4, 'Entfernen');
INSERT INTO `lang_definitions` VALUES (5979, 740, 4, 'entfernen');
INSERT INTO `lang_definitions` VALUES (5980, 741, 4, 'Lösche Kategorien mit ID(s):');
INSERT INTO `lang_definitions` VALUES (5981, 742, 4, 'Gruppe entfernen');
INSERT INTO `lang_definitions` VALUES (5982, 743, 4, 'Liste entfernen');
INSERT INTO `lang_definitions` VALUES (5983, 744, 4, 'Seiten entfernen');
INSERT INTO `lang_definitions` VALUES (5984, 745, 4, 'Lösche Patient, Fall, Formular, Problem, Dokument, Zahlungsvorgang, Berechung, Transaktion');
INSERT INTO `lang_definitions` VALUES (5985, 747, 4, 'Löschen erfolgreich');
INSERT INTO `lang_definitions` VALUES (5986, 748, 4, 'Lösche dieses Dokument');
INSERT INTO `lang_definitions` VALUES (5987, 749, 4, 'Lösche dieses Formular');
INSERT INTO `lang_definitions` VALUES (5988, 750, 4, 'Lösche diese Anmerkung');
INSERT INTO `lang_definitions` VALUES (5989, 751, 4, 'Demenz');
INSERT INTO `lang_definitions` VALUES (5990, 752, 4, 'Demographische Daten');
INSERT INTO `lang_definitions` VALUES (5991, 753, 4, 'Demographische Daten (schreibbar, optional nur hinzufügen erlaubt)');
INSERT INTO `lang_definitions` VALUES (5992, 754, 4, 'Änderung der demographischen Daten nicht erlaubt');
INSERT INTO `lang_definitions` VALUES (5993, 755, 4, 'Änderung der demographischen Daten nicht erlaubt.');
INSERT INTO `lang_definitions` VALUES (5994, 756, 4, 'Zähne betreffend(e)');
INSERT INTO `lang_definitions` VALUES (5995, 757, 4, 'Zahnbeschwerden');
INSERT INTO `lang_definitions` VALUES (5996, 760, 4, 'deprimiert');
INSERT INTO `lang_definitions` VALUES (5997, 761, 4, 'Depression');
INSERT INTO `lang_definitions` VALUES (5998, 762, 4, 'Beschreibung');
INSERT INTO `lang_definitions` VALUES (5999, 763, 4, 'Beschreibung');
INSERT INTO `lang_definitions` VALUES (6000, 764, 4, 'Übersetzung der Beschreibung');
INSERT INTO `lang_definitions` VALUES (6001, 765, 4, 'Ziel');
INSERT INTO `lang_definitions` VALUES (6002, 766, 4, 'Nummer verwerfen');
INSERT INTO `lang_definitions` VALUES (6003, 767, 4, 'Verwerfen...');
INSERT INTO `lang_definitions` VALUES (6004, 768, 4, 'Verworfen');
INSERT INTO `lang_definitions` VALUES (6005, 769, 4, 'Medikamente verwerfen');
INSERT INTO `lang_definitions` VALUES (6006, 770, 4, 'Bericht über verworfene Medikamente');
INSERT INTO `lang_definitions` VALUES (6007, 771, 4, 'Details');
INSERT INTO `lang_definitions` VALUES (6008, 772, 4, 'Entwicklungsstörung');
INSERT INTO `lang_definitions` VALUES (6009, 773, 4, 'Diabetes');
INSERT INTO `lang_definitions` VALUES (6010, 774, 4, 'Diag');
INSERT INTO `lang_definitions` VALUES (6011, 775, 4, 'Diagnose');
INSERT INTO `lang_definitions` VALUES (6012, 776, 4, 'Diagnose muß in einem verknüpften Fall kodiert werden');
INSERT INTO `lang_definitions` VALUES (6013, 777, 4, 'Diagnose:');
INSERT INTO `lang_definitions` VALUES (6014, 778, 4, 'Diagnose:');
INSERT INTO `lang_definitions` VALUES (6015, 779, 4, 'Diagnostischer Test:');
INSERT INTO `lang_definitions` VALUES (6016, 782, 4, 'Diarrhoe');
INSERT INTO `lang_definitions` VALUES (6017, 783, 4, 'Diktat');
INSERT INTO `lang_definitions` VALUES (6018, 784, 4, 'Diktat:');
INSERT INTO `lang_definitions` VALUES (6019, 800, 4, 'Erkrankung');
INSERT INTO `lang_definitions` VALUES (6020, 801, 4, 'Dislokation');
INSERT INTO `lang_definitions` VALUES (6021, 814, 4, 'Divertikulitis');
INSERT INTO `lang_definitions` VALUES (6022, 815, 4, 'Divertikulitis-Chirurgie');
INSERT INTO `lang_definitions` VALUES (6023, 816, 4, 'Divertikulitis');
INSERT INTO `lang_definitions` VALUES (6024, 818, 4, 'Geschieden');
INSERT INTO `lang_definitions` VALUES (6025, 820, 4, 'nicht speichern');
INSERT INTO `lang_definitions` VALUES (6026, 821, 4, 'nicht ersetzen');
INSERT INTO `lang_definitions` VALUES (6027, 833, 4, 'Dokument');
INSERT INTO `lang_definitions` VALUES (6028, 834, 4, 'Dokument');
INSERT INTO `lang_definitions` VALUES (6029, 835, 4, 'Dokumenten-Kategorie');
INSERT INTO `lang_definitions` VALUES (6030, 846, 4, 'Nicht speichern');
INSERT INTO `lang_definitions` VALUES (6031, 847, 4, 'Nicht speichern');
INSERT INTO `lang_definitions` VALUES (6032, 848, 4, 'Änderungen nicht speichern');
INSERT INTO `lang_definitions` VALUES (6033, 849, 4, 'Fertig');
INSERT INTO `lang_definitions` VALUES (6034, 850, 4, 'Fertig mit:');
INSERT INTO `lang_definitions` VALUES (6035, 851, 4, 'Fertig. Download erfolgt jetzt.');
INSERT INTO `lang_definitions` VALUES (6036, 853, 4, 'Dosierung');
INSERT INTO `lang_definitions` VALUES (6037, 854, 4, 'Doppelclick, um zu editieren');
INSERT INTO `lang_definitions` VALUES (6038, 857, 4, 'Konfigurationsdaten herunterladen');
INSERT INTO `lang_definitions` VALUES (6039, 859, 4, 'Visite');
INSERT INTO `lang_definitions` VALUES (6040, 860, 4, 'Dr.');
INSERT INTO `lang_definitions` VALUES (6041, 863, 4, 'Medikament');
INSERT INTO `lang_definitions` VALUES (6042, 871, 4, 'Medikamente');
INSERT INTO `lang_definitions` VALUES (6043, 872, 4, 'Trockener Mund');
INSERT INTO `lang_definitions` VALUES (6044, 895, 4, 'Dauer');
INSERT INTO `lang_definitions` VALUES (6045, 896, 4, 'Dauer');
INSERT INTO `lang_definitions` VALUES (6046, 897, 4, 'Niederländisch');
INSERT INTO `lang_definitions` VALUES (6047, 898, 4, 'Dysphagie');
INSERT INTO `lang_definitions` VALUES (6048, 899, 4, 'Dyspnoe:');
INSERT INTO `lang_definitions` VALUES (6049, 900, 4, 'Dysurie');
INSERT INTO `lang_definitions` VALUES (6050, 901, 4, 'Frühes Wiederauftreten (<2 Monate)');
INSERT INTO `lang_definitions` VALUES (6051, 902, 4, 'Ohren');
INSERT INTO `lang_definitions` VALUES (6052, 903, 4, 'EKG');
INSERT INTO `lang_definitions` VALUES (6053, 904, 4, 'Oedem');
INSERT INTO `lang_definitions` VALUES (6054, 905, 4, 'Bearbeiten');
INSERT INTO `lang_definitions` VALUES (6055, 906, 4, 'Allergien bearbeiten');
INSERT INTO `lang_definitions` VALUES (6056, 907, 4, 'Kategorien bearbeiten');
INSERT INTO `lang_definitions` VALUES (6057, 908, 4, 'Definitionen bearbeiten');
INSERT INTO `lang_definitions` VALUES (6058, 909, 4, 'Diagnosen bearbeiten');
INSERT INTO `lang_definitions` VALUES (6059, 910, 4, 'Einrichtungen bearbeiten');
INSERT INTO `lang_definitions` VALUES (6060, 911, 4, 'Informationen über Einrichtung bearbeiten');
INSERT INTO `lang_definitions` VALUES (6061, 912, 4, 'Formular bearbeiten');
INSERT INTO `lang_definitions` VALUES (6062, 913, 4, 'Layout bearbeiten');
INSERT INTO `lang_definitions` VALUES (6063, 914, 4, 'Liste bearbeiten');
INSERT INTO `lang_definitions` VALUES (6064, 916, 4, 'Ausbildung');
INSERT INTO `lang_definitions` VALUES (6065, 919, 4, 'Effektives Datum');
INSERT INTO `lang_definitions` VALUES (6066, 920, 4, 'Effektivität');
INSERT INTO `lang_definitions` VALUES (6067, 921, 4, 'Ejakulationen');
INSERT INTO `lang_definitions` VALUES (6068, 922, 4, 'Ellbogen');
INSERT INTO `lang_definitions` VALUES (6069, 923, 4, 'Ellbogen-Beschwerden');
INSERT INTO `lang_definitions` VALUES (6070, 925, 4, 'Email');
INSERT INTO `lang_definitions` VALUES (6071, 932, 4, 'Kontakt für Notfälle');
INSERT INTO `lang_definitions` VALUES (6072, 936, 4, 'Telefonkontakt für Notfälle');
INSERT INTO `lang_definitions` VALUES (6073, 937, 4, 'Emphysem');
INSERT INTO `lang_definitions` VALUES (6074, 938, 4, 'Arbeitnehmer');
INSERT INTO `lang_definitions` VALUES (6075, 939, 4, 'Arbeitgeber');
INSERT INTO `lang_definitions` VALUES (6076, 940, 4, 'Anschrift des Arbeitgebers');
INSERT INTO `lang_definitions` VALUES (6077, 941, 4, 'Daten des Arbeitgebers');
INSERT INTO `lang_definitions` VALUES (6078, 942, 4, 'Name des Arbeitgebers');
INSERT INTO `lang_definitions` VALUES (6079, 943, 4, 'Leer');
INSERT INTO `lang_definitions` VALUES (6080, 954, 4, 'Fall');
INSERT INTO `lang_definitions` VALUES (6081, 955, 4, 'Fall');
INSERT INTO `lang_definitions` VALUES (6082, 956, 4, 'Fall');
INSERT INTO `lang_definitions` VALUES (6083, 957, 4, 'Fall');
INSERT INTO `lang_definitions` VALUES (6084, 958, 4, 'Fall-Formular');
INSERT INTO `lang_definitions` VALUES (6085, 959, 4, 'Fallnummer');
INSERT INTO `lang_definitions` VALUES (6086, 960, 4, 'Fall wurde kodiert');
INSERT INTO `lang_definitions` VALUES (6087, 961, 4, 'Fall:');
INSERT INTO `lang_definitions` VALUES (6088, 962, 4, 'Fälle');
INSERT INTO `lang_definitions` VALUES (6089, 968, 4, 'Ende');
INSERT INTO `lang_definitions` VALUES (6090, 969, 4, 'Ende (tt.mm.jjjj)');
INSERT INTO `lang_definitions` VALUES (6091, 970, 4, 'Enddatum');
INSERT INTO `lang_definitions` VALUES (6092, 971, 4, 'Enddatum');
INSERT INTO `lang_definitions` VALUES (6093, 972, 4, 'Enddatum');
INSERT INTO `lang_definitions` VALUES (6094, 973, 4, 'Endzeit');
INSERT INTO `lang_definitions` VALUES (6095, 979, 4, 'Englisch');
INSERT INTO `lang_definitions` VALUES (6096, 980, 4, 'Englisch');
INSERT INTO `lang_definitions` VALUES (6097, 981, 4, 'Englisch (Indisch)');
INSERT INTO `lang_definitions` VALUES (6098, 982, 4, 'Englisch (Standard)');
INSERT INTO `lang_definitions` VALUES (6099, 983, 4, 'OpenEMR muß Schreibrechte im Verzeichnis haben');
INSERT INTO `lang_definitions` VALUES (6100, 997, 4, 'Epilepsie');
INSERT INTO `lang_definitions` VALUES (6101, 998, 4, 'Löschen');
INSERT INTO `lang_definitions` VALUES (6102, 999, 4, 'Errektionen');
INSERT INTO `lang_definitions` VALUES (6103, 1000, 4, 'Fehler');
INSERT INTO `lang_definitions` VALUES (6104, 1001, 4, 'Fehler in der Geschlechtsauswahl');
INSERT INTO `lang_definitions` VALUES (6105, 1018, 4, 'Fehler');
INSERT INTO `lang_definitions` VALUES (6106, 1019, 4, 'Erythem:');
INSERT INTO `lang_definitions` VALUES (6107, 1021, 4, 'Ethnik oder Rasse');
INSERT INTO `lang_definitions` VALUES (6108, 1024, 4, 'Ereignis');
INSERT INTO `lang_definitions` VALUES (6109, 1025, 4, 'Ereignis beginnt');
INSERT INTO `lang_definitions` VALUES (6110, 1026, 4, 'Ereignis-Kategorie');
INSERT INTO `lang_definitions` VALUES (6111, 1027, 4, 'Ereignisdatum');
INSERT INTO `lang_definitions` VALUES (6112, 1028, 4, 'Ereignisbeschreibung');
INSERT INTO `lang_definitions` VALUES (6113, 1046, 4, 'alle 3 Stunden');
INSERT INTO `lang_definitions` VALUES (6114, 1047, 4, 'alle 4 Stunden');
INSERT INTO `lang_definitions` VALUES (6115, 1048, 4, 'alle 5 Stunden');
INSERT INTO `lang_definitions` VALUES (6116, 1049, 4, 'alle 6 Stunden');
INSERT INTO `lang_definitions` VALUES (6117, 1050, 4, 'alle 8 Stunden');
INSERT INTO `lang_definitions` VALUES (6118, 1056, 4, 'Untersuchungsergebnis');
INSERT INTO `lang_definitions` VALUES (6119, 1057, 4, 'Untersuchungsdatum');
INSERT INTO `lang_definitions` VALUES (6120, 1065, 4, 'Erweiterte Ansicht');
INSERT INTO `lang_definitions` VALUES (6121, 1067, 4, 'Verfallen');
INSERT INTO `lang_definitions` VALUES (6122, 1068, 4, 'Verfalldatum');
INSERT INTO `lang_definitions` VALUES (6123, 1069, 4, 'Verfällt');
INSERT INTO `lang_definitions` VALUES (6124, 1070, 4, 'Exportieren');
INSERT INTO `lang_definitions` VALUES (6125, 1071, 4, 'Exportieren als CSV');
INSERT INTO `lang_definitions` VALUES (6126, 1072, 4, 'Exportieren der Konfiguration');
INSERT INTO `lang_definitions` VALUES (6127, 1076, 4, 'Zu CSV exportieren');
INSERT INTO `lang_definitions` VALUES (6128, 1077, 4, 'In externes Abrechnungssystem exportieren');
INSERT INTO `lang_definitions` VALUES (6129, 1080, 4, 'Extern');
INSERT INTO `lang_definitions` VALUES (6130, 1081, 4, 'Externe ID');
INSERT INTO `lang_definitions` VALUES (6131, 1089, 4, 'Augen-Irritation');
INSERT INTO `lang_definitions` VALUES (6132, 1090, 4, 'Augen-Schmerzen');
INSERT INTO `lang_definitions` VALUES (6133, 1091, 4, 'Augenrötung');
INSERT INTO `lang_definitions` VALUES (6134, 1092, 4, 'Augen');
INSERT INTO `lang_definitions` VALUES (6135, 1096, 4, 'Einrichtungen');
INSERT INTO `lang_definitions` VALUES (6136, 1097, 4, 'Einrichtung');
INSERT INTO `lang_definitions` VALUES (6137, 1098, 4, 'Einrichtung');
INSERT INTO `lang_definitions` VALUES (6138, 1100, 4, 'Einrichtungs-Code');
INSERT INTO `lang_definitions` VALUES (6139, 1102, 4, 'Einrichtung:');
INSERT INTO `lang_definitions` VALUES (6140, 1103, 4, 'Fehlgeschlagen');
INSERT INTO `lang_definitions` VALUES (6141, 1105, 4, 'Fehler');
INSERT INTO `lang_definitions` VALUES (6142, 1106, 4, 'Familiäre Anamnese');
INSERT INTO `lang_definitions` VALUES (6143, 1107, 4, 'Familienanamnese bzgl. Glaukom');
INSERT INTO `lang_definitions` VALUES (6144, 1108, 4, 'Familiärer Hintergrund');
INSERT INTO `lang_definitions` VALUES (6145, 1109, 4, 'Größe der Familie');
INSERT INTO `lang_definitions` VALUES (6146, 1111, 4, 'Vater');
INSERT INTO `lang_definitions` VALUES (6147, 1112, 4, 'Müdigkeit');
INSERT INTO `lang_definitions` VALUES (6148, 1113, 4, 'Müde');
INSERT INTO `lang_definitions` VALUES (6149, 1114, 4, 'Fax');
INSERT INTO `lang_definitions` VALUES (6150, 1115, 4, 'Faxnummer');
INSERT INTO `lang_definitions` VALUES (6151, 1116, 4, 'Fax/Scanner');
INSERT INTO `lang_definitions` VALUES (6152, 1117, 4, 'Fax-Eingang');
INSERT INTO `lang_definitions` VALUES (6153, 1118, 4, 'Fax-Ausgang');
INSERT INTO `lang_definitions` VALUES (6154, 1119, 4, 'Februar');
INSERT INTO `lang_definitions` VALUES (6155, 1123, 4, 'Steuernummer');
INSERT INTO `lang_definitions` VALUES (6156, 1124, 4, 'Gebühr');
INSERT INTO `lang_definitions` VALUES (6157, 1125, 4, 'Gebühr');
INSERT INTO `lang_definitions` VALUES (6158, 1126, 4, 'Gebühr ist nicht erlaubt');
INSERT INTO `lang_definitions` VALUES (6159, 1129, 4, 'Gebühren');
INSERT INTO `lang_definitions` VALUES (6160, 1130, 4, 'weiblich');
INSERT INTO `lang_definitions` VALUES (6161, 1138, 4, 'Fieber');
INSERT INTO `lang_definitions` VALUES (6162, 1139, 4, 'Fieber');
INSERT INTO `lang_definitions` VALUES (6163, 1142, 4, 'Datei');
INSERT INTO `lang_definitions` VALUES (6164, 1146, 4, 'mailanschrift');
INSERT INTO `lang_definitions` VALUES (6165, 1147, 4, 'nur ausfüllen, wenn der Patient mit email benachrichtigt werden soll');
INSERT INTO `lang_definitions` VALUES (6166, 1148, 4, 'Filter');
INSERT INTO `lang_definitions` VALUES (6167, 1150, 4, 'Filter');
INSERT INTO `lang_definitions` VALUES (6168, 1151, 4, 'Schlußdiagnose');
INSERT INTO `lang_definitions` VALUES (6169, 1152, 4, 'Schlußdiagnose durch Facharzt');
INSERT INTO `lang_definitions` VALUES (6170, 1157, 4, 'Finden');
INSERT INTO `lang_definitions` VALUES (6171, 1158, 4, 'Erhältliche finden');
INSERT INTO `lang_definitions` VALUES (6172, 1159, 4, 'Freie Termine finden');
INSERT INTO `lang_definitions` VALUES (6173, 1160, 4, 'Patienten finden');
INSERT INTO `lang_definitions` VALUES (6174, 1163, 4, 'Fein');
INSERT INTO `lang_definitions` VALUES (6175, 1164, 4, 'Erster');
INSERT INTO `lang_definitions` VALUES (6176, 1165, 4, 'Erster Tag der Woche');
INSERT INTO `lang_definitions` VALUES (6177, 1166, 4, 'Vorname');
INSERT INTO `lang_definitions` VALUES (6178, 1167, 4, 'Vorname');
INSERT INTO `lang_definitions` VALUES (6179, 1168, 4, 'Vorname:');
INSERT INTO `lang_definitions` VALUES (6180, 1169, 4, 'Fitness');
INSERT INTO `lang_definitions` VALUES (6181, 1172, 4, 'Beheben');
INSERT INTO `lang_definitions` VALUES (6182, 1173, 4, 'Flatulenz');
INSERT INTO `lang_definitions` VALUES (6183, 1174, 4, 'Fluß');
INSERT INTO `lang_definitions` VALUES (6184, 1175, 4, 'Grippe-Impfung');
INSERT INTO `lang_definitions` VALUES (6185, 1176, 4, 'Flüssigkeits- und Elektrolytstörung');
INSERT INTO `lang_definitions` VALUES (6186, 1179, 4, 'Nahrungsmittelunverträglichkeit');
INSERT INTO `lang_definitions` VALUES (6187, 1180, 4, 'Fuß');
INSERT INTO `lang_definitions` VALUES (6188, 1181, 4, 'Fuß-Beschwerden');
INSERT INTO `lang_definitions` VALUES (6189, 1182, 4, 'Fuß:');
INSERT INTO `lang_definitions` VALUES (6190, 1183, 4, 'Football-Verletzung');
INSERT INTO `lang_definitions` VALUES (6191, 1305, 4, 'Kopf');
INSERT INTO `lang_definitions` VALUES (6192, 1306, 4, 'Kopfumfang');
INSERT INTO `lang_definitions` VALUES (6193, 1307, 4, 'Kopfumfang');
INSERT INTO `lang_definitions` VALUES (6194, 1308, 4, 'Kopfschmerz');
INSERT INTO `lang_definitions` VALUES (6195, 1309, 4, 'Kopfschmerzen');
INSERT INTO `lang_definitions` VALUES (6196, 1314, 4, 'Herzinfarkt');
INSERT INTO `lang_definitions` VALUES (6197, 1315, 4, 'Herzerkrankung');
INSERT INTO `lang_definitions` VALUES (6198, 1316, 4, 'Herzversagen');
INSERT INTO `lang_definitions` VALUES (6199, 1317, 4, 'Herzproblem');
INSERT INTO `lang_definitions` VALUES (6200, 1318, 4, 'Herzprobleme');
INSERT INTO `lang_definitions` VALUES (6201, 1319, 4, 'Kardiochirurgie');
INSERT INTO `lang_definitions` VALUES (6202, 1320, 4, 'Herztransplantation');
INSERT INTO `lang_definitions` VALUES (6203, 1321, 4, 'Herz:');
INSERT INTO `lang_definitions` VALUES (6204, 1325, 4, 'Hebräisch');
INSERT INTO `lang_definitions` VALUES (6205, 1327, 4, 'Körpergröße');
INSERT INTO `lang_definitions` VALUES (6206, 1328, 4, 'Hilfe');
INSERT INTO `lang_definitions` VALUES (6207, 1329, 4, 'Hilfe');
INSERT INTO `lang_definitions` VALUES (6208, 1330, 4, 'Hämatemesis');
INSERT INTO `lang_definitions` VALUES (6209, 1334, 4, 'Hämoglobin');
INSERT INTO `lang_definitions` VALUES (6210, 1335, 4, 'Hämoptoe');
INSERT INTO `lang_definitions` VALUES (6211, 1336, 4, 'Hepatitis');
INSERT INTO `lang_definitions` VALUES (6212, 1337, 4, 'Hepatitis A 1');
INSERT INTO `lang_definitions` VALUES (6213, 1338, 4, 'Hepatitis A 2');
INSERT INTO `lang_definitions` VALUES (6214, 1339, 4, 'Hepatitis B 1');
INSERT INTO `lang_definitions` VALUES (6215, 1340, 4, 'Hepatitis B 2');
INSERT INTO `lang_definitions` VALUES (6216, 1341, 4, 'Hepatitis B 3');
INSERT INTO `lang_definitions` VALUES (6217, 1342, 4, 'hier');
INSERT INTO `lang_definitions` VALUES (6218, 1343, 4, 'Hernienversorgung');
INSERT INTO `lang_definitions` VALUES (6219, 1345, 4, 'Herpes');
INSERT INTO `lang_definitions` VALUES (6220, 1370, 4, 'HIV');
INSERT INTO `lang_definitions` VALUES (6221, 1371, 4, 'HL7 Viewer');
INSERT INTO `lang_definitions` VALUES (6222, 1375, 4, 'Heimanschrift');
INSERT INTO `lang_definitions` VALUES (6223, 1381, 4, 'Stunden');
INSERT INTO `lang_definitions` VALUES (6224, 1394, 4, 'Ich bin derzeit beschäftigt.');
INSERT INTO `lang_definitions` VALUES (6225, 1395, 4, 'Ich habe keine Leserechte');
INSERT INTO `lang_definitions` VALUES (6226, 1396, 4, 'ICD');
INSERT INTO `lang_definitions` VALUES (6227, 1398, 4, 'ID');
INSERT INTO `lang_definitions` VALUES (6228, 1399, 4, 'ID kann nicht leer sein');
INSERT INTO `lang_definitions` VALUES (6229, 1411, 4, 'Impfung');
INSERT INTO `lang_definitions` VALUES (6230, 1417, 4, 'Implantate');
INSERT INTO `lang_definitions` VALUES (6231, 1447, 4, 'Abtreibung');
INSERT INTO `lang_definitions` VALUES (6232, 1449, 4, 'Infektionen');
INSERT INTO `lang_definitions` VALUES (6233, 1451, 4, 'Unfruchtbarkeit');
INSERT INTO `lang_definitions` VALUES (6234, 1452, 4, 'Influenza 1');
INSERT INTO `lang_definitions` VALUES (6235, 1453, 4, 'Influenza 2');
INSERT INTO `lang_definitions` VALUES (6236, 1454, 4, 'Info');
INSERT INTO `lang_definitions` VALUES (6237, 1461, 4, 'Inhalationen');
INSERT INTO `lang_definitions` VALUES (6238, 1462, 4, 'Inhalationen');
INSERT INTO `lang_definitions` VALUES (6239, 1471, 4, 'Eingabefelder');
INSERT INTO `lang_definitions` VALUES (6240, 1580, 4, 'Knie');
INSERT INTO `lang_definitions` VALUES (6241, 1581, 4, 'Knieprobleme');
INSERT INTO `lang_definitions` VALUES (6242, 1582, 4, 'Knieprothese');
INSERT INTO `lang_definitions` VALUES (6243, 1583, 4, 'Labor');
INSERT INTO `lang_definitions` VALUES (6244, 1584, 4, 'Laborbericht');
INSERT INTO `lang_definitions` VALUES (6245, 1585, 4, 'Etikett');
INSERT INTO `lang_definitions` VALUES (6246, 1586, 4, 'Etikett darf nicht leer sein');
INSERT INTO `lang_definitions` VALUES (6247, 1587, 4, 'Etikettenspalten');
INSERT INTO `lang_definitions` VALUES (6248, 1589, 4, 'Etiketten');
INSERT INTO `lang_definitions` VALUES (6249, 1593, 4, 'Sprache');
INSERT INTO `lang_definitions` VALUES (6250, 1594, 4, 'Sprachcode');
INSERT INTO `lang_definitions` VALUES (6251, 1692, 4, 'Mittagessen');
INSERT INTO `lang_definitions` VALUES (6252, 1693, 4, 'Mittagessen');
INSERT INTO `lang_definitions` VALUES (6253, 1694, 4, 'Lungenkrebs');
INSERT INTO `lang_definitions` VALUES (6254, 1695, 4, 'Thoraxchirurgie bei Lungenkrebs');
INSERT INTO `lang_definitions` VALUES (6255, 1696, 4, 'Lungen:');
INSERT INTO `lang_definitions` VALUES (6256, 1697, 4, 'Lungen:');
INSERT INTO `lang_definitions` VALUES (6257, 1698, 4, 'Lupus');
INSERT INTO `lang_definitions` VALUES (6258, 1708, 4, 'Mammogramm');
INSERT INTO `lang_definitions` VALUES (6259, 1709, 4, 'Management');
INSERT INTO `lang_definitions` VALUES (6260, 1711, 4, 'Hersteller');
INSERT INTO `lang_definitions` VALUES (6261, 1712, 4, 'März');
INSERT INTO `lang_definitions` VALUES (6262, 1713, 4, 'Famlilienstand');
INSERT INTO `lang_definitions` VALUES (6263, 1723, 4, 'Malleolus medialis:');
INSERT INTO `lang_definitions` VALUES (6264, 1741, 4, 'Männer');
INSERT INTO `lang_definitions` VALUES (6265, 1742, 4, 'Männer und Frauen');
INSERT INTO `lang_definitions` VALUES (6266, 1743, 4, 'Nur Männer');
INSERT INTO `lang_definitions` VALUES (6267, 1745, 4, 'Menopause');
INSERT INTO `lang_definitions` VALUES (6268, 1748, 4, 'Menstruationskrankheit');
INSERT INTO `lang_definitions` VALUES (6269, 1749, 4, 'Nachricht');
INSERT INTO `lang_definitions` VALUES (6270, 1750, 4, 'Nachricht');
INSERT INTO `lang_definitions` VALUES (6271, 1751, 4, 'Methode');
INSERT INTO `lang_definitions` VALUES (6272, 1767, 4, 'Minuten');
INSERT INTO `lang_definitions` VALUES (6273, 1768, 4, 'Minuten');
INSERT INTO `lang_definitions` VALUES (6274, 1774, 4, 'Verfehlt');
INSERT INTO `lang_definitions` VALUES (6275, 1775, 4, 'Fehlende Gebühr');
INSERT INTO `lang_definitions` VALUES (6276, 1776, 4, 'Fehlende PID');
INSERT INTO `lang_definitions` VALUES (6277, 1778, 4, 'Gemischt');
INSERT INTO `lang_definitions` VALUES (6278, 1779, 4, 'ml');
INSERT INTO `lang_definitions` VALUES (6279, 1780, 4, 'mm/Hg');
INSERT INTO `lang_definitions` VALUES (6280, 1783, 4, 'Mobil');
INSERT INTO `lang_definitions` VALUES (6281, 1784, 4, 'Mobiltelefon');
INSERT INTO `lang_definitions` VALUES (6282, 1787, 4, 'Mo');
INSERT INTO `lang_definitions` VALUES (6283, 1788, 4, 'Mo bis Fr');
INSERT INTO `lang_definitions` VALUES (6284, 1789, 4, 'Mo, Mi &amp; Fr');
INSERT INTO `lang_definitions` VALUES (6285, 1790, 4, 'Montag');
INSERT INTO `lang_definitions` VALUES (6286, 1791, 4, 'Monat');
INSERT INTO `lang_definitions` VALUES (6287, 1792, 4, 'Monat');
INSERT INTO `lang_definitions` VALUES (6288, 1793, 4, 'Monatsansicht');
INSERT INTO `lang_definitions` VALUES (6289, 1794, 4, 'Monat(e)');
INSERT INTO `lang_definitions` VALUES (6290, 1795, 4, 'Monatseinkommen');
INSERT INTO `lang_definitions` VALUES (6291, 1796, 4, 'Mehr als 100 Treffer, genauer suchen.');
INSERT INTO `lang_definitions` VALUES (6292, 1797, 4, 'Mehr als 50 Treffer, genauer suchen.');
INSERT INTO `lang_definitions` VALUES (6293, 1798, 4, 'Mutter');
INSERT INTO `lang_definitions` VALUES (6294, 1799, 4, 'Mund');
INSERT INTO `lang_definitions` VALUES (6295, 1800, 4, 'Bewegen');
INSERT INTO `lang_definitions` VALUES (6296, 1801, 4, 'Dokumentenkategorie verschieben:');
INSERT INTO `lang_definitions` VALUES (6297, 1802, 4, 'Herunterschieben');
INSERT INTO `lang_definitions` VALUES (6298, 1803, 4, 'Zu Patienten verschieben');
INSERT INTO `lang_definitions` VALUES (6299, 1804, 4, 'Hochschieben...');
INSERT INTO `lang_definitions` VALUES (6300, 1805, 4, 'Hochschieben');
INSERT INTO `lang_definitions` VALUES (6301, 1806, 4, 'Hr.');
INSERT INTO `lang_definitions` VALUES (6302, 1807, 4, 'Fr.');
INSERT INTO `lang_definitions` VALUES (6303, 1808, 4, 'Fr.');
INSERT INTO `lang_definitions` VALUES (6304, 1809, 4, 'Mehrsprachen-Tool');
INSERT INTO `lang_definitions` VALUES (6305, 1810, 4, 'Viele Felder');
INSERT INTO `lang_definitions` VALUES (6306, 1811, 4, 'Geräusch:');
INSERT INTO `lang_definitions` VALUES (6307, 1812, 4, 'Muskelschmerz');
INSERT INTO `lang_definitions` VALUES (6308, 1813, 4, 'Muskelschmerz');
INSERT INTO `lang_definitions` VALUES (6309, 1814, 4, 'Muskelrötung');
INSERT INTO `lang_definitions` VALUES (6310, 1815, 4, 'Muskelsteifheit');
INSERT INTO `lang_definitions` VALUES (6311, 1816, 4, 'Muskelschwellung');
INSERT INTO `lang_definitions` VALUES (6312, 1817, 4, 'Muskelwärme');
INSERT INTO `lang_definitions` VALUES (6313, 1818, 4, 'Muskel');
INSERT INTO `lang_definitions` VALUES (6314, 1819, 4, 'Muskelverletzung');
INSERT INTO `lang_definitions` VALUES (6315, 1820, 4, 'Muskuloskeletal');
INSERT INTO `lang_definitions` VALUES (6316, 1823, 4, 'Fehlt');
INSERT INTO `lang_definitions` VALUES (6317, 1824, 4, 'Fehlt');
INSERT INTO `lang_definitions` VALUES (6318, 1825, 4, 'Name');
INSERT INTO `lang_definitions` VALUES (6319, 1826, 4, 'Name 1');
INSERT INTO `lang_definitions` VALUES (6320, 1827, 4, 'Name 2');
INSERT INTO `lang_definitions` VALUES (6321, 1828, 4, 'Name und Bezeichnung des Impfstoffherstellers');
INSERT INTO `lang_definitions` VALUES (6322, 1829, 4, 'Name der Versicherungsgesellschaft');
INSERT INTO `lang_definitions` VALUES (6323, 1833, 4, 'Name:');
INSERT INTO `lang_definitions` VALUES (6324, 1837, 4, 'Nationalität');
INSERT INTO `lang_definitions` VALUES (6325, 1838, 4, 'Erbrechen');
INSERT INTO `lang_definitions` VALUES (6326, 1839, 4, 'Navigation');
INSERT INTO `lang_definitions` VALUES (6327, 1842, 4, 'Nacken');
INSERT INTO `lang_definitions` VALUES (6328, 1843, 4, 'Nackenprobleme');
INSERT INTO `lang_definitions` VALUES (6329, 1852, 4, 'Nervenverletzung');
INSERT INTO `lang_definitions` VALUES (6330, 1856, 4, 'Neurologisch');
INSERT INTO `lang_definitions` VALUES (6331, 1857, 4, 'Neu');
INSERT INTO `lang_definitions` VALUES (6332, 1858, 4, 'Neu =>');
INSERT INTO `lang_definitions` VALUES (6333, 1860, 4, 'Neue Allergien');
INSERT INTO `lang_definitions` VALUES (6334, 1861, 4, 'Neue Termine');
INSERT INTO `lang_definitions` VALUES (6335, 1862, 4, 'Neue Kategorien');
INSERT INTO `lang_definitions` VALUES (6336, 1863, 4, 'Neue Kategorie');
INSERT INTO `lang_definitions` VALUES (6337, 1864, 4, 'Neue Klienten');
INSERT INTO `lang_definitions` VALUES (6338, 1865, 4, 'Neue Konsultation');
INSERT INTO `lang_definitions` VALUES (6339, 1866, 4, 'Neue Definitionen hinzugefügt');
INSERT INTO `lang_definitions` VALUES (6340, 1867, 4, 'Neues Dokument');
INSERT INTO `lang_definitions` VALUES (6341, 1868, 4, 'Neues Fall-Formular');
INSERT INTO `lang_definitions` VALUES (6342, 1869, 4, 'Neue Fälle nicht erlaubt');
INSERT INTO `lang_definitions` VALUES (6343, 1871, 4, 'Informationen zu neuer Einrichtung');
INSERT INTO `lang_definitions` VALUES (6344, 1872, 4, 'Neue Gruppe');
INSERT INTO `lang_definitions` VALUES (6345, 1873, 4, 'Informationen zu neuer Gruppe');
INSERT INTO `lang_definitions` VALUES (6346, 1874, 4, 'Neues Limit für Ereignisse');
INSERT INTO `lang_definitions` VALUES (6347, 1875, 4, 'Neue Liste');
INSERT INTO `lang_definitions` VALUES (6348, 1876, 4, 'Neuer Patient');
INSERT INTO `lang_definitions` VALUES (6349, 1877, 4, 'Neues Patienten-Fallformular');
INSERT INTO `lang_definitions` VALUES (6350, 1878, 4, 'Neue Patienten-ID');
INSERT INTO `lang_definitions` VALUES (6351, 1879, 4, 'Neuer Patient');
INSERT INTO `lang_definitions` VALUES (6352, 1881, 4, 'Neuer Benutzer');
INSERT INTO `lang_definitions` VALUES (6353, 1882, 4, 'Neue Visite');
INSERT INTO `lang_definitions` VALUES (6354, 1883, 4, 'Neu/Suche');
INSERT INTO `lang_definitions` VALUES (6355, 1884, 4, 'Zeitung');
INSERT INTO `lang_definitions` VALUES (6356, 1885, 4, 'Weiter');
INSERT INTO `lang_definitions` VALUES (6357, 1886, 4, 'Nächster Tag');
INSERT INTO `lang_definitions` VALUES (6358, 1887, 4, 'Nächster Monat');
INSERT INTO `lang_definitions` VALUES (6359, 1888, 4, 'Nächste Woche');
INSERT INTO `lang_definitions` VALUES (6360, 1889, 4, 'Spitzname');
INSERT INTO `lang_definitions` VALUES (6361, 1890, 4, 'Nächtliches Schwitzen');
INSERT INTO `lang_definitions` VALUES (6362, 1891, 4, 'Unauffälliges äußeres Genitale, vaginale Mukosa, Zervix');
INSERT INTO `lang_definitions` VALUES (6363, 1892, 4, 'Nein');
INSERT INTO `lang_definitions` VALUES (6364, 1893, 4, 'Nein');
INSERT INTO `lang_definitions` VALUES (6365, 1894, 4, 'Kein Zugriff');
INSERT INTO `lang_definitions` VALUES (6366, 1900, 4, 'Keine Diagnose');
INSERT INTO `lang_definitions` VALUES (6367, 1901, 4, 'Kein Enddatum');
INSERT INTO `lang_definitions` VALUES (6368, 1902, 4, 'Keine Einträge gefunden, Formular unten zum Hinzufügen verwenden.');
INSERT INTO `lang_definitions` VALUES (6369, 1903, 4, 'Keine Ereignisse');
INSERT INTO `lang_definitions` VALUES (6370, 1904, 4, 'Keine Gruppe ausgewählt');
INSERT INTO `lang_definitions` VALUES (6371, 1905, 4, 'Keine Hernie');
INSERT INTO `lang_definitions` VALUES (6372, 1906, 4, 'Keine Versicherungsgesellschaft gefunden');
INSERT INTO `lang_definitions` VALUES (6373, 1907, 4, 'Keine Auswahl getroffen!');
INSERT INTO `lang_definitions` VALUES (6374, 1909, 4, 'Keine Bemerkungen');
INSERT INTO `lang_definitions` VALUES (6375, 1910, 4, 'Keine Organomegalie');
INSERT INTO `lang_definitions` VALUES (6376, 1912, 4, 'Keine Partner gefunden');
INSERT INTO `lang_definitions` VALUES (6377, 1913, 4, 'Keine peripheren Ödeme');
INSERT INTO `lang_definitions` VALUES (6378, 1914, 4, 'Keine Apotheken gefunden');
INSERT INTO `lang_definitions` VALUES (6379, 1915, 4, 'Keine Verschreibungen gefunden');
INSERT INTO `lang_definitions` VALUES (6380, 1916, 4, 'Keine Angabe von Erkrankung/Verletzung');
INSERT INTO `lang_definitions` VALUES (6381, 1917, 4, 'Keine Zulieferer gefunden');
INSERT INTO `lang_definitions` VALUES (6382, 1919, 4, 'Keine Einträge gefunden. Suche weiter formulieren.');
INSERT INTO `lang_definitions` VALUES (6383, 1920, 4, 'Keine Treffer');
INSERT INTO `lang_definitions` VALUES (6384, 1921, 4, 'Keine Treffer für die Suche gefunden');
INSERT INTO `lang_definitions` VALUES (6385, 1922, 4, 'Keine Treffer, nochmal versuchen.');
INSERT INTO `lang_definitions` VALUES (6386, 1923, 4, 'Keine Treffer, nochmal versuchen.');
INSERT INTO `lang_definitions` VALUES (6387, 1924, 4, 'Keine Anzeige');
INSERT INTO `lang_definitions` VALUES (6388, 1931, 4, 'Nein:');
INSERT INTO `lang_definitions` VALUES (6389, 1937, 4, 'Nichts');
INSERT INTO `lang_definitions` VALUES (6390, 1938, 4, 'Nichts');
INSERT INTO `lang_definitions` VALUES (6391, 1939, 4, 'Keiner der oben genannten');
INSERT INTO `lang_definitions` VALUES (6392, 1942, 4, 'Unauffällig');
INSERT INTO `lang_definitions` VALUES (6393, 1952, 4, 'Normale Ansicht');
INSERT INTO `lang_definitions` VALUES (6394, 1953, 4, 'normal:');
INSERT INTO `lang_definitions` VALUES (6395, 1954, 4, 'Norwegisch');
INSERT INTO `lang_definitions` VALUES (6396, 1955, 4, 'Nase');
INSERT INTO `lang_definitions` VALUES (6397, 1956, 4, 'Nasenbluten');
INSERT INTO `lang_definitions` VALUES (6398, 2089, 4, 'postprandial');
INSERT INTO `lang_definitions` VALUES (6399, 2090, 4, 'nachmittags');
INSERT INTO `lang_definitions` VALUES (6400, 2092, 4, 'Pädiatrisch');
INSERT INTO `lang_definitions` VALUES (6401, 2093, 4, 'Seite');
INSERT INTO `lang_definitions` VALUES (6402, 2094, 4, 'Seiten');
INSERT INTO `lang_definitions` VALUES (6403, 2098, 4, 'Schmerz');
INSERT INTO `lang_definitions` VALUES (6404, 2103, 4, 'Lebensgefährte');
INSERT INTO `lang_definitions` VALUES (6405, 2104, 4, 'Kennwort');
INSERT INTO `lang_definitions` VALUES (6406, 2105, 4, 'Kennwortänderung');
INSERT INTO `lang_definitions` VALUES (6407, 2106, 4, 'Kennwortänderung erfolgreich');
INSERT INTO `lang_definitions` VALUES (6408, 2107, 4, 'Kennwort für SMS Gateway');
INSERT INTO `lang_definitions` VALUES (6409, 2108, 4, 'Kennwort:');
INSERT INTO `lang_definitions` VALUES (6410, 2109, 4, 'Frühere Fälle');
INSERT INTO `lang_definitions` VALUES (6411, 2110, 4, 'Frühere Fälle und Dokumente');
INSERT INTO `lang_definitions` VALUES (6412, 2114, 4, 'Patient');
INSERT INTO `lang_definitions` VALUES (6413, 2115, 4, 'Patient');
INSERT INTO `lang_definitions` VALUES (6414, 2116, 4, 'Patient');
INSERT INTO `lang_definitions` VALUES (6415, 3155, 4, 'Benutzer');
INSERT INTO `lang_definitions` VALUES (6416, 3179, 4, 'Benutzername');
INSERT INTO `lang_definitions` VALUES (6417, 3360, 4, 'but aber es war');
INSERT INTO `lang_definitions` VALUES (6418, 3361, 4, 'nicht zugegriffen');
INSERT INTO `lang_definitions` VALUES (6419, 3363, 4, 'Medikament');
INSERT INTO `lang_definitions` VALUES (6420, 3365, 4, 'auf');
INSERT INTO `lang_definitions` VALUES (6421, 3368, 4, 'Geschichte');
INSERT INTO `lang_definitions` VALUES (6422, 3378, 4, 'bis');
INSERT INTO `lang_definitions` VALUES (6423, 3398, 4, '(Neue Patient)');
INSERT INTO `lang_definitions` VALUES (6424, 3400, 4, '(Patient Noten)');
INSERT INTO `lang_definitions` VALUES (6425, 3415, 4, '3 monate');
INSERT INTO `lang_definitions` VALUES (6426, 3420, 4, '4 monate');
INSERT INTO `lang_definitions` VALUES (6427, 3455, 4, '[nicht empfohlen]');
INSERT INTO `lang_definitions` VALUES (6428, 3456, 4, '[Anzahl Fälle]');
INSERT INTO `lang_definitions` VALUES (6429, 3457, 4, '[Berichte]');
INSERT INTO `lang_definitions` VALUES (6430, 3458, 4, '[Alles auswählen]');
INSERT INTO `lang_definitions` VALUES (6431, 3459, 4, '[SQL-Ledger]');
INSERT INTO `lang_definitions` VALUES (6432, 3460, 4, '[Starten der Batch-Bearbeitung]');
INSERT INTO `lang_definitions` VALUES (6433, 3461, 4, '[Log anzeigen]');
INSERT INTO `lang_definitions` VALUES (6434, 1, 5, 'A');
INSERT INTO `lang_definitions` VALUES (6435, 2, 5, 'Chequenummer of claimnummer om betaling te identificeren');
INSERT INTO `lang_definitions` VALUES (6436, 3, 5, 'Een CGAC visite formulier hoort bij dit bezoek.');
INSERT INTO `lang_definitions` VALUES (6437, 4, 5, 'Een lot # is vereist!');
INSERT INTO `lang_definitions` VALUES (6438, 5, 5, 'Een overeenkomstige IPPF code is noodzakelijk!');
INSERT INTO `lang_definitions` VALUES (6439, 6, 5, 'Een unieke waarde om dit gebied te identificeren, niet zichtbaar voor de gebruiker');
INSERT INTO `lang_definitions` VALUES (6440, 7, 5, 'voor ontbijt');
INSERT INTO `lang_definitions` VALUES (6441, 8, 5, 'in de morgen');
INSERT INTO `lang_definitions` VALUES (6442, 9, 5, 'A/F Niveau rechts:');
INSERT INTO `lang_definitions` VALUES (6443, 10, 5, 'AB');
INSERT INTO `lang_definitions` VALUES (6444, 11, 5, 'Afkorting');
INSERT INTO `lang_definitions` VALUES (6445, 12, 5, 'Abces');
INSERT INTO `lang_definitions` VALUES (6446, 13, 5, 'Abdominaal');
INSERT INTO `lang_definitions` VALUES (6447, 14, 5, 'Vier stappenplan voor toename gewichtsbelasting: ');
INSERT INTO `lang_definitions` VALUES (6448, 15, 5, 'Abn');
INSERT INTO `lang_definitions` VALUES (6449, 16, 5, 'ABN1');
INSERT INTO `lang_definitions` VALUES (6450, 17, 5, 'Abnormaal');
INSERT INTO `lang_definitions` VALUES (6451, 18, 5, 'Abnormale bloedtest');
INSERT INTO `lang_definitions` VALUES (6452, 19, 5, 'Abnormale haargroei');
INSERT INTO `lang_definitions` VALUES (6453, 20, 5, 'Abnormaal mammogram');
INSERT INTO `lang_definitions` VALUES (6454, 21, 5, 'Abortus');
INSERT INTO `lang_definitions` VALUES (6455, 22, 5, 'Abortusproblematiek');
INSERT INTO `lang_definitions` VALUES (6456, 23, 5, 'Abortusmethode');
INSERT INTO `lang_definitions` VALUES (6457, 24, 5, 'Abortus gerelateerde categorieen');
INSERT INTO `lang_definitions` VALUES (6458, 25, 5, 'Abortussen');
INSERT INTO `lang_definitions` VALUES (6459, 26, 5, 'Diagnose met absences');
INSERT INTO `lang_definitions` VALUES (6460, 27, 5, 'Aanstelling accepteren');
INSERT INTO `lang_definitions` VALUES (6461, 28, 5, 'Accepteer betaling voor');
INSERT INTO `lang_definitions` VALUES (6462, 29, 5, 'Accepteert opdracht');
INSERT INTO `lang_definitions` VALUES (6463, 30, 5, 'Toegangscontrole');
INSERT INTO `lang_definitions` VALUES (6464, 31, 5, 'Toegangscontrolelijsten administratie');
INSERT INTO `lang_definitions` VALUES (6465, 32, 5, 'Boekhouding');
INSERT INTO `lang_definitions` VALUES (6466, 33, 5, 'Pijn');
INSERT INTO `lang_definitions` VALUES (6467, 35, 5, 'ACL');
INSERT INTO `lang_definitions` VALUES (6468, 36, 5, 'ACL administratie');
INSERT INTO `lang_definitions` VALUES (6469, 37, 5, 'ACL-administratie niet toegestaan');
INSERT INTO `lang_definitions` VALUES (6470, 38, 5, 'Acne');
INSERT INTO `lang_definitions` VALUES (6471, 39, 5, 'Act');
INSERT INTO `lang_definitions` VALUES (6472, 40, 5, 'Act datum');
INSERT INTO `lang_definitions` VALUES (6473, 41, 5, 'Actief');
INSERT INTO `lang_definitions` VALUES (6474, 42, 5, 'Lopend contact');
INSERT INTO `lang_definitions` VALUES (6475, 43, 5, 'Actieve lijst');
INSERT INTO `lang_definitions` VALUES (6476, 44, 5, 'U bekijkt nu patient');
INSERT INTO `lang_definitions` VALUES (6477, 45, 5, 'Soort activiteit');
INSERT INTO `lang_definitions` VALUES (6478, 46, 5, 'Acuut of chronisch');
INSERT INTO `lang_definitions` VALUES (6479, 47, 5, 'Add');
INSERT INTO `lang_definitions` VALUES (6480, 49, 5, 'Voeg maatschappij toe');
INSERT INTO `lang_definitions` VALUES (6481, 50, 5, 'Voeg apotheek toe');
INSERT INTO `lang_definitions` VALUES (6482, 51, 5, 'voeg gebeurtenis toe voor');
INSERT INTO `lang_definitions` VALUES (6483, 52, 5, 'Toevoegen als nieuwe notitie');
INSERT INTO `lang_definitions` VALUES (6484, 53, 5, 'Voeg toe als nieuw');
INSERT INTO `lang_definitions` VALUES (6485, 54, 5, 'Categorie toevoegen');
INSERT INTO `lang_definitions` VALUES (6486, 55, 5, 'Voeg constante toe');
INSERT INTO `lang_definitions` VALUES (6487, 56, 5, 'Eigen bijdrage toevoegen');
INSERT INTO `lang_definitions` VALUES (6488, 57, 5, 'Medicatie toevoegen');
INSERT INTO `lang_definitions` VALUES (6489, 58, 5, 'Contact toevoegen');
INSERT INTO `lang_definitions` VALUES (6490, 59, 5, 'Lokatie toevoegen');
INSERT INTO `lang_definitions` VALUES (6491, 60, 5, 'Veld toevoegen');
INSERT INTO `lang_definitions` VALUES (6492, 61, 5, 'Groep toevoegen');
INSERT INTO `lang_definitions` VALUES (6493, 62, 5, 'Voeg Codering toe');
INSERT INTO `lang_definitions` VALUES (6494, 63, 5, 'Voeg problemen toe');
INSERT INTO `lang_definitions` VALUES (6495, 64, 5, 'Taal aanmaken');
INSERT INTO `lang_definitions` VALUES (6496, 65, 5, 'Nieuwe toevoegen');
INSERT INTO `lang_definitions` VALUES (6497, 66, 5, 'Nieuwe categorie toevoegen');
INSERT INTO `lang_definitions` VALUES (6498, 67, 5, 'Nieuwe groep toevoegen');
INSERT INTO `lang_definitions` VALUES (6499, 68, 5, 'Voeg nieuwe notitie toe');
INSERT INTO `lang_definitions` VALUES (6500, 69, 5, 'Voeg nieuwe notitie toe');
INSERT INTO `lang_definitions` VALUES (6501, 70, 5, 'Nieuwe partner toevoegen');
INSERT INTO `lang_definitions` VALUES (6502, 71, 5, 'Voeg notitie toe');
INSERT INTO `lang_definitions` VALUES (6503, 72, 5, 'Status van patient aanmaken');
INSERT INTO `lang_definitions` VALUES (6504, 73, 5, 'Recept aanmaken');
INSERT INTO `lang_definitions` VALUES (6505, 75, 5, 'Aan medicatielijst toevoegen');
INSERT INTO `lang_definitions` VALUES (6506, 76, 5, 'Transactie toevoegen');
INSERT INTO `lang_definitions` VALUES (6507, 77, 5, 'Voeg gebruiker toe');
INSERT INTO `lang_definitions` VALUES (6508, 78, 5, 'Gebruiker aan groep toevoegen');
INSERT INTO `lang_definitions` VALUES (6509, 79, 5, 'toegevoegd');
INSERT INTO `lang_definitions` VALUES (6510, 80, 5, 'Toevoegen persoonsgeg.niet geautoriseerd');
INSERT INTO `lang_definitions` VALUES (6511, 81, 5, 'Addison Syndroom');
INSERT INTO `lang_definitions` VALUES (6512, 82, 5, 'Addison Syndroom');
INSERT INTO `lang_definitions` VALUES (6513, 83, 5, 'Aanvullende diagnose:');
INSERT INTO `lang_definitions` VALUES (6514, 84, 5, 'Aanvullende voorgeschiedenis');
INSERT INTO `lang_definitions` VALUES (6515, 85, 5, 'Extra voorgeschiedenis notities');
INSERT INTO `lang_definitions` VALUES (6516, 86, 5, 'Extra info');
INSERT INTO `lang_definitions` VALUES (6517, 87, 5, 'Extra labonderzoeken');
INSERT INTO `lang_definitions` VALUES (6518, 88, 5, 'Extra notities');
INSERT INTO `lang_definitions` VALUES (6519, 89, 5, 'Extra notities');
INSERT INTO `lang_definitions` VALUES (6520, 90, 5, 'Extra notities:');
INSERT INTO `lang_definitions` VALUES (6521, 91, 5, 'Extra rontgenfoto notities:');
INSERT INTO `lang_definitions` VALUES (6522, 92, 5, 'Alleen toevoegen');
INSERT INTO `lang_definitions` VALUES (6523, 93, 5, 'Adresboek');
INSERT INTO `lang_definitions` VALUES (6524, 94, 5, 'Adresboek');
INSERT INTO `lang_definitions` VALUES (6525, 95, 5, 'Adres');
INSERT INTO `lang_definitions` VALUES (6526, 96, 5, 'Adresboek');
INSERT INTO `lang_definitions` VALUES (6527, 97, 5, 'Adres1');
INSERT INTO `lang_definitions` VALUES (6528, 98, 5, 'Adres2');
INSERT INTO `lang_definitions` VALUES (6529, 99, 5, 'Adj');
INSERT INTO `lang_definitions` VALUES (6530, 100, 5, 'Aanpassen');
INSERT INTO `lang_definitions` VALUES (6531, 101, 5, 'Reden voor aanpassingen');
INSERT INTO `lang_definitions` VALUES (6532, 102, 5, 'Verandering waarde voor code');
INSERT INTO `lang_definitions` VALUES (6533, 103, 5, 'Aanpassing');
INSERT INTO `lang_definitions` VALUES (6534, 104, 5, 'Adm aanpassing');
INSERT INTO `lang_definitions` VALUES (6535, 105, 5, 'Administratie');
INSERT INTO `lang_definitions` VALUES (6536, 106, 5, 'Administratie e-mailadres');
INSERT INTO `lang_definitions` VALUES (6537, 107, 5, 'Geadministreerd');
INSERT INTO `lang_definitions` VALUES (6538, 108, 5, 'Geadministreerd door');
INSERT INTO `lang_definitions` VALUES (6539, 109, 5, 'Administratie');
INSERT INTO `lang_definitions` VALUES (6540, 110, 5, 'Beheerders');
INSERT INTO `lang_definitions` VALUES (6541, 111, 5, 'Beheerders kunnen alles doen');
INSERT INTO `lang_definitions` VALUES (6542, 112, 5, 'Geavanceerd');
INSERT INTO `lang_definitions` VALUES (6543, 113, 5, 'Advies');
INSERT INTO `lang_definitions` VALUES (6544, 114, 5, 'Normaal effect');
INSERT INTO `lang_definitions` VALUES (6545, 115, 5, 'Oproep na spreekuur');
INSERT INTO `lang_definitions` VALUES (6546, 116, 5, 'Na bewaren via PDF, klik op [view log] om op fouten te controlen.');
INSERT INTO `lang_definitions` VALUES (6547, 117, 5, 'Na bewaren van batch, klik op [view log] om op fouten te controleren.');
INSERT INTO `lang_definitions` VALUES (6548, 118, 5, 'Klik op de Bewaren knop, nadat de informatie juist is ingevoerd');
INSERT INTO `lang_definitions` VALUES (6549, 119, 5, 'Opnieuw');
INSERT INTO `lang_definitions` VALUES (6550, 120, 5, 'Lft');
INSERT INTO `lang_definitions` VALUES (6551, 121, 5, 'Gesorteerd op');
INSERT INTO `lang_definitions` VALUES (6552, 122, 5, 'Lft.categorie');
INSERT INTO `lang_definitions` VALUES (6553, 123, 5, 'Leeftijd datum valt buiten gebied.');
INSERT INTO `lang_definitions` VALUES (6554, 124, 5, 'Leeftijd \"format\" is niet juist');
INSERT INTO `lang_definitions` VALUES (6555, 125, 5, 'Leeftijd \"format\" is niet juist');
INSERT INTO `lang_definitions` VALUES (6556, 126, 5, 'Lft vanaf');
INSERT INTO `lang_definitions` VALUES (6557, 127, 5, 'Aging Columns:');
INSERT INTO `lang_definitions` VALUES (6558, 128, 5, 'Alcohol');
INSERT INTO `lang_definitions` VALUES (6559, 129, 5, 'Alcoholconsumptie');
INSERT INTO `lang_definitions` VALUES (6560, 130, 5, 'Allemaal');
INSERT INTO `lang_definitions` VALUES (6561, 131, 5, 'Alle categorieen');
INSERT INTO `lang_definitions` VALUES (6562, 132, 5, 'Gehele dag');
INSERT INTO `lang_definitions` VALUES (6563, 133, 5, 'Gebeurtenis voor hele dag');
INSERT INTO `lang_definitions` VALUES (6564, 134, 5, 'Alle Lokaties');
INSERT INTO `lang_definitions` VALUES (6565, 135, 5, 'Alles of gedeelte van voornaam');
INSERT INTO `lang_definitions` VALUES (6566, 136, 5, 'Alles of gedeelte van achternaam');
INSERT INTO `lang_definitions` VALUES (6567, 137, 5, 'Alle zorgverleners');
INSERT INTO `lang_definitions` VALUES (6568, 138, 5, 'Alles nagekeken en negatief:');
INSERT INTO `lang_definitions` VALUES (6569, 139, 5, 'Alle onderwerpen');
INSERT INTO `lang_definitions` VALUES (6570, 140, 5, 'Alle gebruikers');
INSERT INTO `lang_definitions` VALUES (6571, 141, 5, 'Allergisch');
INSERT INTO `lang_definitions` VALUES (6572, 142, 5, 'Allergieen');
INSERT INTO `lang_definitions` VALUES (6573, 143, 5, 'Allergieen:');
INSERT INTO `lang_definitions` VALUES (6574, 144, 5, 'Allergie');
INSERT INTO `lang_definitions` VALUES (6575, 145, 5, 'E-mail toestaan');
INSERT INTO `lang_definitions` VALUES (6576, 146, 5, 'E-mailberichten toestaan?');
INSERT INTO `lang_definitions` VALUES (6577, 147, 5, 'E-mail toestaan?');
INSERT INTO `lang_definitions` VALUES (6578, 148, 5, 'Bericht per post toestaan');
INSERT INTO `lang_definitions` VALUES (6579, 149, 5, 'SMS toestaan');
INSERT INTO `lang_definitions` VALUES (6580, 150, 5, 'SMS (tekstberichten) toestaan?');
INSERT INTO `lang_definitions` VALUES (6581, 151, 5, 'Toestaan om gebeurtenissen meteen actief te maken?');
INSERT INTO `lang_definitions` VALUES (6582, 152, 5, 'Telefoonberichten toestaan?');
INSERT INTO `lang_definitions` VALUES (6583, 153, 5, 'Gebruikers toestaan om algemene gebeurtenissen te publiceren');
INSERT INTO `lang_definitions` VALUES (6584, 154, 5, 'Gebruikers toestaan om prive-agenda´s te publiceren');
INSERT INTO `lang_definitions` VALUES (6585, 155, 5, 'Voicemail toestaan');
INSERT INTO `lang_definitions` VALUES (6586, 156, 5, 'Toegestaan');
INSERT INTO `lang_definitions` VALUES (6587, 157, 5, 'bestaat al');
INSERT INTO `lang_definitions` VALUES (6588, 158, 5, 'Reeds in gebruik, kies een andere identificator');
INSERT INTO `lang_definitions` VALUES (6589, 159, 5, 'Reeds in gebruik kies een andere titel');
INSERT INTO `lang_definitions` VALUES (6590, 160, 5, 'Alternatief adres');
INSERT INTO `lang_definitions` VALUES (6591, 162, 5, 'Je zou ook de SEARCH pagina kunnen gebruiken om een electronisch overschrijvingsbestand (X12 835) te uploaden van de betalende instantie. Je kunt dit doen door op de BROWSE knop te drukken en het juiste bestand te selecteren om te uploaden. Dan op SEARCH klikken om dit te effectueren en de daarbij behorende invoices te laten zien op het scherm. In dit geval zijn bovenstaande parameters niet nodig en worden genegeerd. Uploaden SAVE-s het bestand maar verwerkt de inhoud niet- dit wordt apart uitgevoerd zoals hier beneden beschreven');
INSERT INTO `lang_definitions` VALUES (6592, 163, 5, 'AM');
INSERT INTO `lang_definitions` VALUES (6593, 164, 5, 'Pas de bestaande notitie aan');
INSERT INTO `lang_definitions` VALUES (6594, 165, 5, 'AMEX');
INSERT INTO `lang_definitions` VALUES (6595, 166, 5, 'Bedrag');
INSERT INTO `lang_definitions` VALUES (6596, 167, 5, 'Verschuldigd bedrag');
INSERT INTO `lang_definitions` VALUES (6597, 168, 5, 'Bedrag voor overschrijding balans');
INSERT INTO `lang_definitions` VALUES (6598, 169, 5, 'Bedrag voor dit bezoek');
INSERT INTO `lang_definitions` VALUES (6599, 170, 5, 'Bedrag betaald.');
INSERT INTO `lang_definitions` VALUES (6600, 171, 5, 'Aantal/Bedrag');
INSERT INTO `lang_definitions` VALUES (6601, 175, 5, 'Een onvolledig GCAC \"iets\" is aangemaakt met een link. Moet nog later afgemaakt worden. Onvolledig.');
INSERT INTO `lang_definitions` VALUES (6602, 176, 5, 'en');
INSERT INTO `lang_definitions` VALUES (6603, 177, 5, 'EN');
INSERT INTO `lang_definitions` VALUES (6604, 178, 5, 'en');
INSERT INTO `lang_definitions` VALUES (6605, 179, 5, 'en');
INSERT INTO `lang_definitions` VALUES (6606, 180, 5, 'en alle onderliggende data? Deze actie wordt vastgelegd');
INSERT INTO `lang_definitions` VALUES (6607, 181, 5, 'Anemie');
INSERT INTO `lang_definitions` VALUES (6608, 182, 5, 'Enkel');
INSERT INTO `lang_definitions` VALUES (6609, 183, 5, 'Enkel + hiel');
INSERT INTO `lang_definitions` VALUES (6610, 184, 5, 'Evaluatie formulier voor enkelletsel');
INSERT INTO `lang_definitions` VALUES (6611, 185, 5, 'Enkelproblemen');
INSERT INTO `lang_definitions` VALUES (6612, 186, 5, 'Ankylosis Spondilitica');
INSERT INTO `lang_definitions` VALUES (6613, 187, 5, 'Ankylosis Spondilitica');
INSERT INTO `lang_definitions` VALUES (6614, 188, 5, 'Anorexia');
INSERT INTO `lang_definitions` VALUES (6615, 189, 5, 'Iets anders wat je kan doen in de PostingWindow is verzoeken om een rekening op tweede niveau. Als je dit SELECTEERT voordat je opslaat, dan wordt de originele claim opnieuw geopend en als lijst op de rekeningpagina getoond en wordt deze tijdens de volgende ronde in rekening gebracht.');
INSERT INTO `lang_definitions` VALUES (6616, 190, 5, 'voor');
INSERT INTO `lang_definitions` VALUES (6617, 191, 5, 'Anus normaal, geen rectale gevoeligheid/massa');
INSERT INTO `lang_definitions` VALUES (6618, 192, 5, 'Opwinding');
INSERT INTO `lang_definitions` VALUES (6619, 193, 5, 'Alles');
INSERT INTO `lang_definitions` VALUES (6620, 194, 5, 'Welke categorie');
INSERT INTO `lang_definitions` VALUES (6621, 195, 5, 'Gedeelte van gewenste code of omschrijving');
INSERT INTO `lang_definitions` VALUES (6622, 196, 5, 'Gedeelte van gewenste specialisatie');
INSERT INTO `lang_definitions` VALUES (6623, 197, 5, 'Gedeelte van patient naam of \"achternm, voorn), of \"X-Y\"');
INSERT INTO `lang_definitions` VALUES (6624, 198, 5, 'Apnea');
INSERT INTO `lang_definitions` VALUES (6625, 199, 5, 'Weergave');
INSERT INTO `lang_definitions` VALUES (6626, 200, 5, 'Weergave:');
INSERT INTO `lang_definitions` VALUES (6627, 201, 5, 'Toevoegen aan bestaande notitie');
INSERT INTO `lang_definitions` VALUES (6628, 202, 5, 'Toevoegen aan deze notitie');
INSERT INTO `lang_definitions` VALUES (6629, 203, 5, 'Deze notitie toevoegen');
INSERT INTO `lang_definitions` VALUES (6630, 204, 5, 'Appendectomie');
INSERT INTO `lang_definitions` VALUES (6631, 206, 5, 'Op aangedane gebied aanbrengen');
INSERT INTO `lang_definitions` VALUES (6632, 207, 5, 'Op de huid smeren');
INSERT INTO `lang_definitions` VALUES (6633, 208, 5, 'wordt toegepast');
INSERT INTO `lang_definitions` VALUES (6634, 209, 5, 'Datum afspraak');
INSERT INTO `lang_definitions` VALUES (6635, 210, 5, 'Status van afspraak');
INSERT INTO `lang_definitions` VALUES (6636, 211, 5, 'Afspraak tussen');
INSERT INTO `lang_definitions` VALUES (6637, 212, 5, 'Afspraken');
INSERT INTO `lang_definitions` VALUES (6638, 213, 5, 'Afspraken (schrijven optioneel)');
INSERT INTO `lang_definitions` VALUES (6639, 214, 5, 'Afspraken en contacten');
INSERT INTO `lang_definitions` VALUES (6640, 215, 5, 'Rapport afspraken');
INSERT INTO `lang_definitions` VALUES (6641, 216, 5, 'Rapport afspraken-contacten');
INSERT INTO `lang_definitions` VALUES (6642, 217, 5, 'Toestaan');
INSERT INTO `lang_definitions` VALUES (6643, 218, 5, 'Toegestaan');
INSERT INTO `lang_definitions` VALUES (6644, 219, 5, 'Administratie van toegestane gebeurtenis(sen)');
INSERT INTO `lang_definitions` VALUES (6645, 220, 5, 'Afspr.-Cont.');
INSERT INTO `lang_definitions` VALUES (6646, 221, 5, 'Afspr.');
INSERT INTO `lang_definitions` VALUES (6647, 222, 5, 'April');
INSERT INTO `lang_definitions` VALUES (6648, 224, 5, 'Bent u voorbereid om een nieuwe GCAC issue voor dit bezoek af te maken?');
INSERT INTO `lang_definitions` VALUES (6649, 225, 5, 'WIlt u zeker deze gebeurtenis goedkeuren?');
INSERT INTO `lang_definitions` VALUES (6650, 226, 5, 'Bent u er zeker van dit Formulier definitief te verwijderen?');
INSERT INTO `lang_definitions` VALUES (6651, 227, 5, 'Zeker deze gebeurtenis verwijderen?');
INSERT INTO `lang_definitions` VALUES (6652, 229, 5, 'Bent u er zeker van deze notitie te verwijderen?');
INSERT INTO `lang_definitions` VALUES (6653, 230, 5, 'Zeker deze gebeurtenis aanpassen?');
INSERT INTO `lang_definitions` VALUES (6654, 231, 5, 'Zeker deze gebeurtenissen verbergen?');
INSERT INTO `lang_definitions` VALUES (6655, 232, 5, 'Zeker deze gebeurtenis(sen) inzien?');
INSERT INTO `lang_definitions` VALUES (6656, 233, 5, 'Gaat u de hele groep verwijderen met de volgende naam ');
INSERT INTO `lang_definitions` VALUES (6657, 234, 5, 'Weet u zeker dat u de gehele lijst wilt verwijderen');
INSERT INTO `lang_definitions` VALUES (6658, 235, 5, 'Weet u zeker dat u het veld wilt verwijderen in');
INSERT INTO `lang_definitions` VALUES (6659, 236, 5, 'Wilt u zeker de geselecteerde velden verwijderen?');
INSERT INTO `lang_definitions` VALUES (6660, 237, 5, 'Weet u zeker dat u met deze acties wilt doorgaan?');
INSERT INTO `lang_definitions` VALUES (6661, 238, 5, 'Gebied niet nader gespecificeerd');
INSERT INTO `lang_definitions` VALUES (6662, 239, 5, 'Armeens');
INSERT INTO `lang_definitions` VALUES (6663, 240, 5, 'Arytmie');
INSERT INTO `lang_definitions` VALUES (6664, 241, 5, 'Artritis');
INSERT INTO `lang_definitions` VALUES (6665, 242, 5, 'Artritis/degeneratieve gewr. aandoening');
INSERT INTO `lang_definitions` VALUES (6666, 243, 5, 'Artritis/degeneratieve gewr. aandoening');
INSERT INTO `lang_definitions` VALUES (6667, 244, 5, 'zoals');
INSERT INTO `lang_definitions` VALUES (6668, 245, 5, 'vanaf');
INSERT INTO `lang_definitions` VALUES (6669, 246, 5, 'Aziatisch');
INSERT INTO `lang_definitions` VALUES (6670, 247, 5, 'Evaluatie');
INSERT INTO `lang_definitions` VALUES (6671, 248, 5, 'Toegewezen aan');
INSERT INTO `lang_definitions` VALUES (6672, 249, 5, 'Assistent');
INSERT INTO `lang_definitions` VALUES (6673, 250, 5, 'Astma');
INSERT INTO `lang_definitions` VALUES (6674, 251, 5, 'bij');
INSERT INTO `lang_definitions` VALUES (6675, 252, 5, 'Bij de naviculare');
INSERT INTO `lang_definitions` VALUES (6676, 253, 5, 'Bij de naviculare:');
INSERT INTO `lang_definitions` VALUES (6677, 254, 5, 'Sportblessure');
INSERT INTO `lang_definitions` VALUES (6678, 255, 5, 'Attentie');
INSERT INTO `lang_definitions` VALUES (6679, 256, 5, 'Attn');
INSERT INTO `lang_definitions` VALUES (6680, 257, 5, 'Augustus');
INSERT INTO `lang_definitions` VALUES (6681, 258, 5, 'Aut');
INSERT INTO `lang_definitions` VALUES (6682, 259, 5, 'Aut/Notities');
INSERT INTO `lang_definitions` VALUES (6683, 260, 5, 'Autorisatie');
INSERT INTO `lang_definitions` VALUES (6684, 261, 5, 'Autoriseer');
INSERT INTO `lang_definitions` VALUES (6685, 262, 5, 'Autoriseer - consult naar keuze');
INSERT INTO `lang_definitions` VALUES (6686, 263, 5, 'Autoriseer - consulten alleen van mij');
INSERT INTO `lang_definitions` VALUES (6687, 264, 5, 'Geautoriseerd');
INSERT INTO `lang_definitions` VALUES (6688, 265, 5, 'Sturen via');
INSERT INTO `lang_definitions` VALUES (6689, 266, 5, 'Zelf gegenererend');
INSERT INTO `lang_definitions` VALUES (6690, 267, 5, 'Automobiel medisch');
INSERT INTO `lang_definitions` VALUES (6691, 268, 5, 'autosaved');
INSERT INTO `lang_definitions` VALUES (6692, 269, 5, 'Beschikbare tijden');
INSERT INTO `lang_definitions` VALUES (6693, 270, 5, 'Avulsie / avulsie fractuur');
INSERT INTO `lang_definitions` VALUES (6694, 271, 5, 'Avulsie laterale malleolus');
INSERT INTO `lang_definitions` VALUES (6695, 272, 5, 'Avulsie mediale malleolus');
INSERT INTO `lang_definitions` VALUES (6696, 273, 5, 'Op basis van waarneming');
INSERT INTO `lang_definitions` VALUES (6697, 274, 5, 'Axillair');
INSERT INTO `lang_definitions` VALUES (6698, 275, 5, '2 x daags');
INSERT INTO `lang_definitions` VALUES (6699, 276, 5, 'terug');
INSERT INTO `lang_definitions` VALUES (6700, 277, 5, 'Terug');
INSERT INTO `lang_definitions` VALUES (6701, 284, 5, 'Rugproblemen');
INSERT INTO `lang_definitions` VALUES (6702, 287, 5, 'Rug chirurgie');
INSERT INTO `lang_definitions` VALUES (6703, 292, 5, 'Back-up');
INSERT INTO `lang_definitions` VALUES (6704, 293, 5, 'Backupbestand is aangemaakt. Downloaden begint.');
INSERT INTO `lang_definitions` VALUES (6705, 294, 5, 'Ongedekte cheque');
INSERT INTO `lang_definitions` VALUES (6706, 295, 5, 'Achterstallige schulden');
INSERT INTO `lang_definitions` VALUES (6707, 296, 5, 'Bahasa Indonesia');
INSERT INTO `lang_definitions` VALUES (6708, 297, 5, 'Bal');
INSERT INTO `lang_definitions` VALUES (6709, 298, 5, 'Balans');
INSERT INTO `lang_definitions` VALUES (6710, 299, 5, 'Uitstaande schuld');
INSERT INTO `lang_definitions` VALUES (6711, 300, 5, 'Te betalen');
INSERT INTO `lang_definitions` VALUES (6712, 301, 5, 'Basis van metatarsale 5');
INSERT INTO `lang_definitions` VALUES (6713, 302, 5, 'Basis van metatarsale 5:');
INSERT INTO `lang_definitions` VALUES (6714, 303, 5, 'Gereedschap voor batch-communicatie');
INSERT INTO `lang_definitions` VALUES (6715, 304, 5, 'Batch-verwerking begonnen, kan even duren');
INSERT INTO `lang_definitions` VALUES (6716, 305, 5, 'BatchCom');
INSERT INTO `lang_definitions` VALUES (6717, 306, 5, 'omdat dat ID niet bestaat.');
INSERT INTO `lang_definitions` VALUES (6718, 307, 5, 'Start');
INSERT INTO `lang_definitions` VALUES (6719, 308, 5, 'Startdatum');
INSERT INTO `lang_definitions` VALUES (6720, 309, 5, 'Begindatum Service jjjj-mm-dd');
INSERT INTO `lang_definitions` VALUES (6721, 310, 5, 'Oprispingen');
INSERT INTO `lang_definitions` VALUES (6722, 311, 5, 'tussen');
INSERT INTO `lang_definitions` VALUES (6723, 312, 5, 'Bilateraal');
INSERT INTO `lang_definitions` VALUES (6724, 313, 5, 'Datum rekening');
INSERT INTO `lang_definitions` VALUES (6725, 314, 5, 'Rekening/Innen');
INSERT INTO `lang_definitions` VALUES (6726, 315, 5, 'In rekening gebracht');
INSERT INTO `lang_definitions` VALUES (6727, 316, 5, 'Rekening aanmaken');
INSERT INTO `lang_definitions` VALUES (6728, 317, 5, 'In rekening brengen (met schrijf optie)');
INSERT INTO `lang_definitions` VALUES (6729, 318, 5, 'Rekening t.a.v.');
INSERT INTO `lang_definitions` VALUES (6730, 319, 5, 'Rekening code voor aangevraagde Service');
INSERT INTO `lang_definitions` VALUES (6731, 320, 5, 'Codering voor rekeningen');
INSERT INTO `lang_definitions` VALUES (6732, 321, 5, 'Rekeninginformatie');
INSERT INTO `lang_definitions` VALUES (6733, 322, 5, 'Rekeninglokatie');
INSERT INTO `lang_definitions` VALUES (6734, 323, 5, 'Rekeningnotitie');
INSERT INTO `lang_definitions` VALUES (6735, 324, 5, 'Rekeningnotitie voor');
INSERT INTO `lang_definitions` VALUES (6736, 325, 5, 'Rekeningnotitie');
INSERT INTO `lang_definitions` VALUES (6737, 326, 5, 'Rekeningwachtrij resultaat:');
INSERT INTO `lang_definitions` VALUES (6738, 327, 5, 'Rekeningenscherm');
INSERT INTO `lang_definitions` VALUES (6739, 328, 5, 'Rekening voor');
INSERT INTO `lang_definitions` VALUES (6740, 329, 5, 'Biopsie');
INSERT INTO `lang_definitions` VALUES (6741, 330, 5, 'Geboortedatum');
INSERT INTO `lang_definitions` VALUES (6742, 331, 5, 'Negroide');
INSERT INTO `lang_definitions` VALUES (6743, 332, 5, 'Blaaskanker');
INSERT INTO `lang_definitions` VALUES (6744, 333, 5, 'Blaasinfectie');
INSERT INTO `lang_definitions` VALUES (6745, 334, 5, 'Lege formulieren');
INSERT INTO `lang_definitions` VALUES (6746, 335, 5, 'Problemen met bloedingen');
INSERT INTO `lang_definitions` VALUES (6747, 336, 5, 'Blinde vlekken');
INSERT INTO `lang_definitions` VALUES (6748, 337, 5, 'Opzwellen');
INSERT INTO `lang_definitions` VALUES (6749, 338, 5, 'Geblokkeerd');
INSERT INTO `lang_definitions` VALUES (6750, 339, 5, 'Bloeddruk');
INSERT INTO `lang_definitions` VALUES (6751, 340, 5, 'Bloeddruk');
INSERT INTO `lang_definitions` VALUES (6752, 341, 5, 'Bloedneus');
INSERT INTO `lang_definitions` VALUES (6753, 342, 5, 'Blue Cross Blue Shield');
INSERT INTO `lang_definitions` VALUES (6754, 343, 5, 'Blauwe lijnen in dit verslag zijn informeel. Zwarte lijnen tonen vooraf bestaande informatie. Groene lijnen tonen veranderingen die met succes werden doorgevoerd. Rode lijnen tonen fouten of veranderingen die niet doorgevoerd werden; deze moeten handmatig doorgevoerd worden. De afgewezen claims en teruggevorderd geld worden niet automatisch verwerkt en worden in rood getoond.');
INSERT INTO `lang_definitions` VALUES (6755, 344, 5, 'Wazig zien');
INSERT INTO `lang_definitions` VALUES (6756, 345, 5, 'BMI');
INSERT INTO `lang_definitions` VALUES (6757, 346, 5, 'BMI-waarde');
INSERT INTO `lang_definitions` VALUES (6758, 347, 5, 'Gebied van het lichaam');
INSERT INTO `lang_definitions` VALUES (6759, 348, 5, 'Botpijn');
INSERT INTO `lang_definitions` VALUES (6760, 349, 5, 'Botpijn: mediale malleolus');
INSERT INTO `lang_definitions` VALUES (6761, 350, 5, 'Boolean');
INSERT INTO `lang_definitions` VALUES (6762, 351, 5, 'Laag');
INSERT INTO `lang_definitions` VALUES (6763, 352, 5, 'Beide oren');
INSERT INTO `lang_definitions` VALUES (6764, 353, 5, 'beide oren');
INSERT INTO `lang_definitions` VALUES (6765, 354, 5, 'Laag');
INSERT INTO `lang_definitions` VALUES (6766, 355, 5, 'Box 10 A Werk gerelateerd');
INSERT INTO `lang_definitions` VALUES (6767, 356, 5, 'Box 10 B Auto ongeval');
INSERT INTO `lang_definitions` VALUES (6768, 357, 5, 'Box 10 C Ander ongeval');
INSERT INTO `lang_definitions` VALUES (6769, 358, 5, 'Box 16 Begindatum arbeidsongeschiktheid (jjjj-mm-dd)');
INSERT INTO `lang_definitions` VALUES (6770, 359, 5, 'Box 16 Datum AO tot (jjjj-mm-dd)');
INSERT INTO `lang_definitions` VALUES (6771, 360, 5, 'Box 18 Opname in hospitaal (jjjj-mm-dd) ');
INSERT INTO `lang_definitions` VALUES (6772, 361, 5, 'Box 18 Laatste dag in hospitaal (jjjj-mm-dd)');
INSERT INTO `lang_definitions` VALUES (6773, 362, 5, 'Box 20 \"Buiten laboratorium\" gebruikt?');
INSERT INTO `lang_definitions` VALUES (6774, 363, 5, 'Box 22 Medicaide Code om opnieuw te sturen (ICPC)');
INSERT INTO `lang_definitions` VALUES (6775, 364, 5, 'Box 23 Vorige autorisatienummer');
INSERT INTO `lang_definitions` VALUES (6776, 366, 5, 'Diastolische RR');
INSERT INTO `lang_definitions` VALUES (6777, 367, 5, 'Systolische RR');
INSERT INTO `lang_definitions` VALUES (6778, 368, 5, 'RRd');
INSERT INTO `lang_definitions` VALUES (6779, 369, 5, 'RRs');
INSERT INTO `lang_definitions` VALUES (6780, 370, 5, 'Braziliaans-Portugees');
INSERT INTO `lang_definitions` VALUES (6781, 371, 5, 'Mamma');
INSERT INTO `lang_definitions` VALUES (6782, 372, 5, 'Biopsie van mamma');
INSERT INTO `lang_definitions` VALUES (6783, 373, 5, 'Afscheiding mamma');
INSERT INTO `lang_definitions` VALUES (6784, 374, 5, 'Ziekte van de mammae');
INSERT INTO `lang_definitions` VALUES (6785, 375, 5, 'Borstonderzoek');
INSERT INTO `lang_definitions` VALUES (6786, 376, 5, 'Massa in mamma');
INSERT INTO `lang_definitions` VALUES (6787, 377, 5, 'Ademgeluiden:');
INSERT INTO `lang_definitions` VALUES (6788, 378, 5, 'Gebroken botten');
INSERT INTO `lang_definitions` VALUES (6789, 379, 5, 'Bronchitis formulier');
INSERT INTO `lang_definitions` VALUES (6790, 380, 5, 'Doorzoeken');
INSERT INTO `lang_definitions` VALUES (6791, 381, 5, 'Zoek naar status');
INSERT INTO `lang_definitions` VALUES (6792, 382, 5, 'Kneuzing/Hematoom');
INSERT INTO `lang_definitions` VALUES (6793, 383, 5, 'Uitpuilend rechts:');
INSERT INTO `lang_definitions` VALUES (6794, 384, 5, 'Branden tijdens plassen');
INSERT INTO `lang_definitions` VALUES (6795, 385, 5, 'Brandende mictie');
INSERT INTO `lang_definitions` VALUES (6796, 386, 5, 'Bezig');
INSERT INTO `lang_definitions` VALUES (6797, 387, 5, 'Zitvlak + S.I.');
INSERT INTO `lang_definitions` VALUES (6798, 388, 5, 'dmv');
INSERT INTO `lang_definitions` VALUES (6799, 389, 5, 'Oraal');
INSERT INTO `lang_definitions` VALUES (6800, 390, 5, 'Door/Oorsprong');
INSERT INTO `lang_definitions` VALUES (6801, 391, 5, 'door:');
INSERT INTO `lang_definitions` VALUES (6802, 392, 5, 'C');
INSERT INTO `lang_definitions` VALUES (6803, 393, 5, 'Cache duur (in seconden)');
INSERT INTO `lang_definitions` VALUES (6804, 394, 5, 'Cache template output?');
INSERT INTO `lang_definitions` VALUES (6805, 395, 5, 'Cafeineconsumptie');
INSERT INTO `lang_definitions` VALUES (6806, 396, 5, 'Agenda');
INSERT INTO `lang_definitions` VALUES (6807, 397, 5, 'Agenda-instellingen');
INSERT INTO `lang_definitions` VALUES (6808, 398, 5, 'Agenda-UI');
INSERT INTO `lang_definitions` VALUES (6809, 399, 5, 'Agendaweergave');
INSERT INTO `lang_definitions` VALUES (6810, 400, 5, 'Telefoontje naar addForm() komt hier terecht');
INSERT INTO `lang_definitions` VALUES (6811, 402, 5, 'CAMOS');
INSERT INTO `lang_definitions` VALUES (6812, 403, 5, 'Annuleren');
INSERT INTO `lang_definitions` VALUES (6813, 404, 5, 'Kanker');
INSERT INTO `lang_definitions` VALUES (6814, 405, 5, 'Kan deze invoer niet toevoegen, omdat hij reeds bestaat!');
INSERT INTO `lang_definitions` VALUES (6815, 406, 5, 'Kan deze invoer niet toevoegen/updaten omdat er al een duplicaat bestaat!');
INSERT INTO `lang_definitions` VALUES (6816, 407, 5, 'kan niet naar JPEG omgezet worden. Is ImageMagick wel geinstalleerd?');
INSERT INTO `lang_definitions` VALUES (6817, 408, 5, 'kan niet inline getoond worden, dit type wordt niet ondersteund door BROWSER');
INSERT INTO `lang_definitions` VALUES (6818, 409, 5, 'kan niet inline getoond worden, dit type wordt niet ondersteund door BROWSER');
INSERT INTO `lang_definitions` VALUES (6819, 410, 5, 'kan niet inline getoond worden, dit type wordt niet ondersteund door BROWSER');
INSERT INTO `lang_definitions` VALUES (6820, 411, 5, 'Aanmaken mislukt');
INSERT INTO `lang_definitions` VALUES (6821, 412, 5, 'Zoeken mislukt');
INSERT INTO `lang_definitions` VALUES (6822, 413, 5, 'Patient kan niet gevonden worden in SQL-boekhouding via Klant ID');
INSERT INTO `lang_definitions` VALUES (6823, 414, 5, 'Postscript documentreferentie niet gevonden in');
INSERT INTO `lang_definitions` VALUES (6824, 415, 5, 'Behandelaar kan niet gevonden worden in werknemers SQL boekhouding');
INSERT INTO `lang_definitions` VALUES (6825, 416, 5, 'Openen mislukt');
INSERT INTO `lang_definitions` VALUES (6826, 417, 5, 'Kan niet lezen');
INSERT INTO `lang_definitions` VALUES (6827, 418, 5, 'Updaten mislukt omdat er geen bestaande entiteit wordt bewerkt');
INSERT INTO `lang_definitions` VALUES (6828, 419, 5, 'capsule');
INSERT INTO `lang_definitions` VALUES (6829, 420, 5, 'Hartcatheterisatie');
INSERT INTO `lang_definitions` VALUES (6830, 421, 5, 'Echo van het hart');
INSERT INTO `lang_definitions` VALUES (6831, 422, 5, 'Cardiovasculair');
INSERT INTO `lang_definitions` VALUES (6832, 423, 5, 'Kraakbeen/chondraal/beschadiging tussenwervelschijf');
INSERT INTO `lang_definitions` VALUES (6833, 424, 5, 'Kraakbeenbeschadiging');
INSERT INTO `lang_definitions` VALUES (6834, 425, 5, 'Carotiden pulstaies normaal, pedal puls nl');
INSERT INTO `lang_definitions` VALUES (6835, 426, 5, 'contant');
INSERT INTO `lang_definitions` VALUES (6836, 427, 5, 'Contant');
INSERT INTO `lang_definitions` VALUES (6837, 428, 5, 'Per Kas ontv.');
INSERT INTO `lang_definitions` VALUES (6838, 429, 5, 'Kwitanties per behandelaar');
INSERT INTO `lang_definitions` VALUES (6839, 430, 5, 'Cataractoperatie');
INSERT INTO `lang_definitions` VALUES (6840, 431, 5, 'Cataracten');
INSERT INTO `lang_definitions` VALUES (6841, 432, 5, 'Categorieen');
INSERT INTO `lang_definitions` VALUES (6842, 433, 5, 'Categorie');
INSERT INTO `lang_definitions` VALUES (6843, 434, 5, 'categorie');
INSERT INTO `lang_definitions` VALUES (6844, 435, 5, 'Categorie');
INSERT INTO `lang_definitions` VALUES (6845, 436, 5, 'Categorie details');
INSERT INTO `lang_definitions` VALUES (6846, 437, 5, 'Categorie limieten');
INSERT INTO `lang_definitions` VALUES (6847, 438, 5, 'Categorie naam');
INSERT INTO `lang_definitions` VALUES (6848, 439, 5, 'Caucasisch');
INSERT INTO `lang_definitions` VALUES (6849, 440, 5, 'Portable tel');
INSERT INTO `lang_definitions` VALUES (6850, 441, 5, 'Mobiel nummer');
INSERT INTO `lang_definitions` VALUES (6851, 442, 5, 'Categorie Certificering');
INSERT INTO `lang_definitions` VALUES (6852, 443, 5, 'cfirst($instype) . \' Ins');
INSERT INTO `lang_definitions` VALUES (6853, 444, 5, 'ChampUS');
INSERT INTO `lang_definitions` VALUES (6854, 445, 5, 'ChampUSVA');
INSERT INTO `lang_definitions` VALUES (6855, 446, 5, 'wijzig');
INSERT INTO `lang_definitions` VALUES (6856, 448, 5, 'Wijzig activiteit');
INSERT INTO `lang_definitions` VALUES (6857, 449, 5, 'Verandering visus');
INSERT INTO `lang_definitions` VALUES (6858, 450, 5, 'Verandering visus');
INSERT INTO `lang_definitions` VALUES (6859, 451, 5, 'Gewijzigd');
INSERT INTO `lang_definitions` VALUES (6860, 452, 5, 'Veranderd def patroon');
INSERT INTO `lang_definitions` VALUES (6861, 453, 5, 'Bereken');
INSERT INTO `lang_definitions` VALUES (6862, 454, 5, 'Kosten');
INSERT INTO `lang_definitions` VALUES (6863, 455, 5, 'Kaart');
INSERT INTO `lang_definitions` VALUES (6864, 456, 5, 'Activiteit van de kaart');
INSERT INTO `lang_definitions` VALUES (6865, 457, 5, 'Kaart voor binnenkomst- en vertrekactiviteiten rapport');
INSERT INTO `lang_definitions` VALUES (6866, 458, 5, 'Statusnummer');
INSERT INTO `lang_definitions` VALUES (6867, 459, 5, 'Statusnummer:');
INSERT INTO `lang_definitions` VALUES (6868, 460, 5, 'Kaart voor locatie activiteiten');
INSERT INTO `lang_definitions` VALUES (6869, 461, 5, 'Notitie voor status');
INSERT INTO `lang_definitions` VALUES (6870, 462, 5, 'Plaats van status');
INSERT INTO `lang_definitions` VALUES (6871, 463, 5, 'Lokatie van de status');
INSERT INTO `lang_definitions` VALUES (6872, 464, 5, 'Kaart trk');
INSERT INTO `lang_definitions` VALUES (6873, 465, 5, 'Kaarten uitgechecked');
INSERT INTO `lang_definitions` VALUES (6874, 466, 5, 'Kaarten uit');
INSERT INTO `lang_definitions` VALUES (6875, 467, 5, 'controle');
INSERT INTO `lang_definitions` VALUES (6876, 468, 5, 'Controle');
INSERT INTO `lang_definitions` VALUES (6877, 469, 5, 'Alles selecteren');
INSERT INTO `lang_definitions` VALUES (6878, 470, 5, 'Nieuwe locatie');
INSERT INTO `lang_definitions` VALUES (6879, 471, 5, 'Check ingevoerde data');
INSERT INTO `lang_definitions` VALUES (6880, 472, 5, 'Chequenummer');
INSERT INTO `lang_definitions` VALUES (6881, 473, 5, 'Check/EOB Datum:');
INSERT INTO `lang_definitions` VALUES (6882, 474, 5, 'Check/EOB No.:');
INSERT INTO `lang_definitions` VALUES (6883, 475, 5, 'Check/Ref.nummer');
INSERT INTO `lang_definitions` VALUES (6884, 476, 5, 'Check/Referentienummer');
INSERT INTO `lang_definitions` VALUES (6885, 477, 5, 'Checkbox lijst');
INSERT INTO `lang_definitions` VALUES (6886, 478, 5, 'checkbox lijst');
INSERT INTO `lang_definitions` VALUES (6887, 479, 5, 'checkbox met tekst');
INSERT INTO `lang_definitions` VALUES (6888, 480, 5, 'Checkbox met tekst');
INSERT INTO `lang_definitions` VALUES (6889, 481, 5, 'Aangevinkte box=ja, leeg=nee');
INSERT INTO `lang_definitions` VALUES (6890, 482, 5, 'Vertrek');
INSERT INTO `lang_definitions` VALUES (6891, 483, 5, 'Thorax');
INSERT INTO `lang_definitions` VALUES (6892, 484, 5, 'Thoracx CTAB');
INSERT INTO `lang_definitions` VALUES (6893, 485, 5, 'Pijn in thorax');
INSERT INTO `lang_definitions` VALUES (6894, 486, 5, 'Pijn in thorax');
INSERT INTO `lang_definitions` VALUES (6895, 487, 5, 'Pijn in thorax');
INSERT INTO `lang_definitions` VALUES (6896, 488, 5, 'Chg');
INSERT INTO `lang_definitions` VALUES (6897, 490, 5, 'Kind');
INSERT INTO `lang_definitions` VALUES (6898, 491, 5, 'Rillingen');
INSERT INTO `lang_definitions` VALUES (6899, 492, 5, 'Chinees');
INSERT INTO `lang_definitions` VALUES (6900, 493, 5, 'Keuzes');
INSERT INTO `lang_definitions` VALUES (6901, 494, 5, 'Cholecystectomie');
INSERT INTO `lang_definitions` VALUES (6902, 495, 5, 'Cholecystectomie');
INSERT INTO `lang_definitions` VALUES (6903, 496, 5, 'Kies');
INSERT INTO `lang_definitions` VALUES (6904, 497, 5, 'Maak een keuze en KLIK op het onderdeel, in de andere sectie zie je de gerelateerde zaken en kan in dat deel KLIKKEN voor relaties toevoegen of verwijderen');
INSERT INTO `lang_definitions` VALUES (6905, 498, 5, 'Kies een lijst');
INSERT INTO `lang_definitions` VALUES (6906, 500, 5, 'Chronische bronchitis');
INSERT INTO `lang_definitions` VALUES (6907, 501, 5, 'Chronische gewrichts pijn');
INSERT INTO `lang_definitions` VALUES (6908, 502, 5, 'Chronische synovitis / opzwellen / gewrichtspijn / jicht');
INSERT INTO `lang_definitions` VALUES (6909, 503, 5, 'Chronisch/terugkerend');
INSERT INTO `lang_definitions` VALUES (6910, 504, 5, 'Levercirrose');
INSERT INTO `lang_definitions` VALUES (6911, 505, 5, 'Levercirrose');
INSERT INTO `lang_definitions` VALUES (6912, 506, 5, 'Stad');
INSERT INTO `lang_definitions` VALUES (6913, 507, 5, 'Naam vd stad');
INSERT INTO `lang_definitions` VALUES (6914, 508, 5, 'Stad, Staat');
INSERT INTO `lang_definitions` VALUES (6915, 509, 5, 'Stad, Zip code');
INSERT INTO `lang_definitions` VALUES (6916, 510, 5, 'Stad/Staat');
INSERT INTO `lang_definitions` VALUES (6917, 512, 5, 'Tegoed');
INSERT INTO `lang_definitions` VALUES (6918, 513, 5, 'Tegoed test is aangemaakt en klaar');
INSERT INTO `lang_definitions` VALUES (6919, 514, 5, 'Claim is als bestand aangemaakt');
INSERT INTO `lang_definitions` VALUES (6920, 515, 5, 'Classificatie');
INSERT INTO `lang_definitions` VALUES (6921, 516, 5, 'Schonen');
INSERT INTO `lang_definitions` VALUES (6922, 517, 5, 'Alles verwijderen');
INSERT INTO `lang_definitions` VALUES (6923, 518, 5, 'Justify verwijderen');
INSERT INTO `lang_definitions` VALUES (6924, 519, 5, 'Smarty Cache schonen');
INSERT INTO `lang_definitions` VALUES (6925, 520, 5, 'CLIA-nummer');
INSERT INTO `lang_definitions` VALUES (6926, 521, 5, 'Klik');
INSERT INTO `lang_definitions` VALUES (6927, 523, 5, 'klik voor meer');
INSERT INTO `lang_definitions` VALUES (6928, 524, 5, 'Klik hier om datum te kiezen');
INSERT INTO `lang_definitions` VALUES (6929, 525, 5, 'Klik hier voor aanpassing van Volgorde, Categorie en getoonde veld namen');
INSERT INTO `lang_definitions` VALUES (6930, 526, 5, 'Klik hier om alles te zien');
INSERT INTO `lang_definitions` VALUES (6931, 527, 5, 'Klik om te downloaden');
INSERT INTO `lang_definitions` VALUES (6932, 528, 5, 'Klik om aan te passen');
INSERT INTO `lang_definitions` VALUES (6933, 529, 5, 'Klik om deze gebeurtenis aan te passen');
INSERT INTO `lang_definitions` VALUES (6934, 530, 5, 'Klik om rapport te maken');
INSERT INTO `lang_definitions` VALUES (6935, 531, 5, 'Klik om af te drukken');
INSERT INTO `lang_definitions` VALUES (6936, 532, 5, 'Kilk om een nieuwe voorraad te ontvangen/toe te voegen');
INSERT INTO `lang_definitions` VALUES (6937, 533, 5, 'Klik om te selecteren');
INSERT INTO `lang_definitions` VALUES (6938, 534, 5, 'Klik om te selecteren of de diagnose te veranderen');
INSERT INTO `lang_definitions` VALUES (6939, 535, 5, 'Klik om patient te selecteren');
INSERT INTO `lang_definitions` VALUES (6940, 536, 5, 'Klik om de gerelateerde code te selecteren');
INSERT INTO `lang_definitions` VALUES (6941, 537, 5, 'Klik om te kijken');
INSERT INTO `lang_definitions` VALUES (6942, 538, 5, 'Klik om te bekijken of aan te passen');
INSERT INTO `lang_definitions` VALUES (6943, 539, 5, 'Klik om te bekijken/veranderen');
INSERT INTO `lang_definitions` VALUES (6944, 540, 5, 'Klik:');
INSERT INTO `lang_definitions` VALUES (6945, 542, 5, 'Samenvatting med. historie client');
INSERT INTO `lang_definitions` VALUES (6946, 543, 5, 'Cliëntprofiel- Nieuwe client');
INSERT INTO `lang_definitions` VALUES (6947, 544, 5, 'Cliëntprofiel-Unieke client');
INSERT INTO `lang_definitions` VALUES (6948, 545, 5, 'Cliënten');
INSERT INTO `lang_definitions` VALUES (6949, 546, 5, 'Kliniek');
INSERT INTO `lang_definitions` VALUES (6950, 548, 5, 'Dagoverzicht kliniek');
INSERT INTO `lang_definitions` VALUES (6951, 549, 5, 'ID van Locatie');
INSERT INTO `lang_definitions` VALUES (6952, 550, 5, 'Kliniekmedewerkers');
INSERT INTO `lang_definitions` VALUES (6953, 553, 5, 'Sluit');
INSERT INTO `lang_definitions` VALUES (6954, 554, 5, 'Sluit venster');
INSERT INTO `lang_definitions` VALUES (6955, 555, 5, 'Gesloten');
INSERT INTO `lang_definitions` VALUES (6956, 556, 5, 'cm');
INSERT INTO `lang_definitions` VALUES (6957, 558, 5, 'CMS-ID');
INSERT INTO `lang_definitions` VALUES (6958, 559, 5, 'CN2-12 intact');
INSERT INTO `lang_definitions` VALUES (6959, 560, 5, 'Code');
INSERT INTO `lang_definitions` VALUES (6960, 561, 5, 'code');
INSERT INTO `lang_definitions` VALUES (6961, 562, 5, 'Zoek code');
INSERT INTO `lang_definitions` VALUES (6962, 563, 5, 'Code moet twee kleine letters zijn');
INSERT INTO `lang_definitions` VALUES (6963, 564, 5, 'Type code');
INSERT INTO `lang_definitions` VALUES (6964, 565, 5, 'Codering');
INSERT INTO `lang_definitions` VALUES (6965, 566, 5, 'Coderen niet toegestaan');
INSERT INTO `lang_definitions` VALUES (6966, 567, 5, 'Coderen - contact naar keuze (schrijven, met sommige optioneel)');
INSERT INTO `lang_definitions` VALUES (6967, 568, 5, 'Coderen - mijn (schrijven, met sommige optioneel)');
INSERT INTO `lang_definitions` VALUES (6968, 569, 5, 'Niet geautoriseerde codering');
INSERT INTO `lang_definitions` VALUES (6969, 570, 5, 'Koffie');
INSERT INTO `lang_definitions` VALUES (6970, 571, 5, 'Coll w/o');
INSERT INTO `lang_definitions` VALUES (6971, 572, 5, 'Alles inklappen');
INSERT INTO `lang_definitions` VALUES (6972, 573, 5, 'Verzamelingen');
INSERT INTO `lang_definitions` VALUES (6973, 574, 5, 'Ontvangen bedragen rapport');
INSERT INTO `lang_definitions` VALUES (6974, 575, 5, 'Colonkanker');
INSERT INTO `lang_definitions` VALUES (6975, 576, 5, 'Colonkanker chirurgie');
INSERT INTO `lang_definitions` VALUES (6976, 577, 5, 'Coloscopie');
INSERT INTO `lang_definitions` VALUES (6977, 578, 5, 'Coloscopie');
INSERT INTO `lang_definitions` VALUES (6978, 579, 5, 'Kleur');
INSERT INTO `lang_definitions` VALUES (6979, 580, 5, 'Kolommen');
INSERT INTO `lang_definitions` VALUES (6980, 581, 5, 'Commentaren');
INSERT INTO `lang_definitions` VALUES (6981, 582, 5, 'Commercieel verzekeringsmaatschappij');
INSERT INTO `lang_definitions` VALUES (6982, 583, 5, 'Wijzigingen doorvoeren');
INSERT INTO `lang_definitions` VALUES (6983, 584, 5, 'Communicaties');
INSERT INTO `lang_definitions` VALUES (6984, 585, 5, 'Afgerond');
INSERT INTO `lang_definitions` VALUES (6985, 586, 5, 'Complicaties bij Service gevende');
INSERT INTO `lang_definitions` VALUES (6986, 587, 5, 'Complicaties van abortus');
INSERT INTO `lang_definitions` VALUES (6987, 588, 5, 'Computergestuurd ordersysteem');
INSERT INTO `lang_definitions` VALUES (6988, 589, 5, 'Conclusies');
INSERT INTO `lang_definitions` VALUES (6989, 590, 5, 'Congenitaal');
INSERT INTO `lang_definitions` VALUES (6990, 591, 5, 'Aangeboren');
INSERT INTO `lang_definitions` VALUES (6991, 592, 5, 'Constante');
INSERT INTO `lang_definitions` VALUES (6992, 593, 5, 'naam van constante');
INSERT INTO `lang_definitions` VALUES (6993, 594, 5, 'Constanten');
INSERT INTO `lang_definitions` VALUES (6994, 595, 5, 'Obstipatie');
INSERT INTO `lang_definitions` VALUES (6995, 596, 5, 'Constitutie');
INSERT INTO `lang_definitions` VALUES (6996, 597, 5, 'Korte omschrijving consult');
INSERT INTO `lang_definitions` VALUES (6997, 598, 5, 'Contact');
INSERT INTO `lang_definitions` VALUES (6998, 599, 5, 'Contact e-mail');
INSERT INTO `lang_definitions` VALUES (6999, 600, 5, 'Contact e-mailadres');
INSERT INTO `lang_definitions` VALUES (7000, 601, 5, 'Contact info');
INSERT INTO `lang_definitions` VALUES (7001, 602, 5, 'Contact lenzen');
INSERT INTO `lang_definitions` VALUES (7002, 603, 5, 'Naam contact');
INSERT INTO `lang_definitions` VALUES (7003, 604, 5, 'Contactpersoon');
INSERT INTO `lang_definitions` VALUES (7004, 605, 5, 'Telefoon contactpersoon');
INSERT INTO `lang_definitions` VALUES (7005, 606, 5, 'Inhoud');
INSERT INTO `lang_definitions` VALUES (7006, 607, 5, 'inhoud');
INSERT INTO `lang_definitions` VALUES (7007, 608, 5, 'Doorgaan');
INSERT INTO `lang_definitions` VALUES (7008, 609, 5, 'Contra clienten');
INSERT INTO `lang_definitions` VALUES (7009, 610, 5, 'Anticonceptie');
INSERT INTO `lang_definitions` VALUES (7010, 611, 5, 'Anticonceptie problematiek');
INSERT INTO `lang_definitions` VALUES (7011, 612, 5, 'Anticonceptie complicatie (specificeren)');
INSERT INTO `lang_definitions` VALUES (7012, 613, 5, 'Anticonceptiemethode');
INSERT INTO `lang_definitions` VALUES (7013, 614, 5, 'Vorige anticonceptiemethode');
INSERT INTO `lang_definitions` VALUES (7014, 615, 5, 'Begin anticonceptie');
INSERT INTO `lang_definitions` VALUES (7015, 616, 5, 'Controle nummer');
INSERT INTO `lang_definitions` VALUES (7016, 617, 5, 'Eigen Bijdrage');
INSERT INTO `lang_definitions` VALUES (7017, 618, 5, 'Eigen Bijdrage');
INSERT INTO `lang_definitions` VALUES (7018, 619, 5, 'Copay moet pos zijn');
INSERT INTO `lang_definitions` VALUES (7019, 620, 5, 'Eigen Bijdragen');
INSERT INTO `lang_definitions` VALUES (7020, 621, 5, 'COPD');
INSERT INTO `lang_definitions` VALUES (7021, 622, 5, 'Kopieer blz naar kaart van pt');
INSERT INTO `lang_definitions` VALUES (7022, 623, 5, 'Waarden kopieren');
INSERT INTO `lang_definitions` VALUES (7023, 624, 5, 'Copyright');
INSERT INTO `lang_definitions` VALUES (7024, 625, 5, 'Coronair Ateriele Bypass');
INSERT INTO `lang_definitions` VALUES (7025, 626, 5, 'Hoest');
INSERT INTO `lang_definitions` VALUES (7026, 627, 5, 'Hoest:');
INSERT INTO `lang_definitions` VALUES (7027, 628, 5, 'E-mail werd niet verzonden door serverprobleem');
INSERT INTO `lang_definitions` VALUES (7028, 633, 5, 'Telling dmv methode');
INSERT INTO `lang_definitions` VALUES (7029, 634, 5, 'Begeleiding');
INSERT INTO `lang_definitions` VALUES (7030, 635, 5, 'Begeleidingsactiviteiten');
INSERT INTO `lang_definitions` VALUES (7031, 636, 5, 'Terug verwijzingsformulier');
INSERT INTO `lang_definitions` VALUES (7032, 637, 5, 'Terug verwijzing');
INSERT INTO `lang_definitions` VALUES (7033, 638, 5, 'Land');
INSERT INTO `lang_definitions` VALUES (7034, 639, 5, 'Landenlijst (schrijven,toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (7035, 640, 5, 'regio');
INSERT INTO `lang_definitions` VALUES (7036, 641, 5, 'Coupon');
INSERT INTO `lang_definitions` VALUES (7037, 642, 5, 'CPT');
INSERT INTO `lang_definitions` VALUES (7038, 643, 5, 'CPT-codes');
INSERT INTO `lang_definitions` VALUES (7039, 644, 5, 'Knisperend:');
INSERT INTO `lang_definitions` VALUES (7040, 645, 5, 'creme');
INSERT INTO `lang_definitions` VALUES (7041, 646, 5, 'Maak gebeurtenis aan');
INSERT INTO `lang_definitions` VALUES (7042, 647, 5, 'Maak en download een totale backup');
INSERT INTO `lang_definitions` VALUES (7043, 648, 5, 'Maak backup');
INSERT INTO `lang_definitions` VALUES (7044, 649, 5, 'Maak nieuwe patient aan');
INSERT INTO `lang_definitions` VALUES (7045, 650, 5, 'Maak notitie voor patient');
INSERT INTO `lang_definitions` VALUES (7046, 651, 5, 'Aangemaakt');
INSERT INTO `lang_definitions` VALUES (7047, 652, 5, 'Maak export file');
INSERT INTO `lang_definitions` VALUES (7048, 653, 5, 'krediet');
INSERT INTO `lang_definitions` VALUES (7049, 654, 5, 'kredieten');
INSERT INTO `lang_definitions` VALUES (7050, 655, 5, 'Ziekte van Crohn');
INSERT INTO `lang_definitions` VALUES (7051, 656, 5, 'Ziekte van Crohn');
INSERT INTO `lang_definitions` VALUES (7052, 657, 5, 'CSV-bestand');
INSERT INTO `lang_definitions` VALUES (7053, 658, 5, 'Lopende');
INSERT INTO `lang_definitions` VALUES (7054, 659, 5, 'Lopende consultatie');
INSERT INTO `lang_definitions` VALUES (7055, 660, 5, 'Kleur van lopende dag');
INSERT INTO `lang_definitions` VALUES (7056, 661, 5, 'De huidige bestandsnaam is veranderd in');
INSERT INTO `lang_definitions` VALUES (7057, 662, 5, 'Huidige locatie');
INSERT INTO `lang_definitions` VALUES (7058, 663, 5, 'Nu aanwezige patient');
INSERT INTO `lang_definitions` VALUES (7059, 664, 5, 'Nu actief');
INSERT INTO `lang_definitions` VALUES (7060, 665, 5, 'Cushing syndroom');
INSERT INTO `lang_definitions` VALUES (7061, 666, 5, 'Cushing syndroom');
INSERT INTO `lang_definitions` VALUES (7062, 667, 5, 'Gewoonte');
INSERT INTO `lang_definitions` VALUES (7063, 669, 5, 'CYP');
INSERT INTO `lang_definitions` VALUES (7064, 670, 5, 'CYP-factor');
INSERT INTO `lang_definitions` VALUES (7065, 671, 5, 'CYP-verslag');
INSERT INTO `lang_definitions` VALUES (7066, 672, 5, 'D');
INSERT INTO `lang_definitions` VALUES (7067, 673, 5, 'D&C');
INSERT INTO `lang_definitions` VALUES (7068, 674, 5, 'D&E');
INSERT INTO `lang_definitions` VALUES (7069, 675, 5, 'GEB');
INSERT INTO `lang_definitions` VALUES (7070, 676, 5, 'dagelijks');
INSERT INTO `lang_definitions` VALUES (7071, 677, 5, 'Soortgelijke data zit al in databank, wijzig de code en/of omschrijving');
INSERT INTO `lang_definitions` VALUES (7072, 678, 5, 'Soortgelijke data zit al in databank, verander de naam van de constante');
INSERT INTO `lang_definitions` VALUES (7073, 679, 5, 'Gegevens Cols');
INSERT INTO `lang_definitions` VALUES (7074, 680, 5, 'Gegevenstype');
INSERT INTO `lang_definitions` VALUES (7075, 681, 5, 'Databank');
INSERT INTO `lang_definitions` VALUES (7076, 682, 5, 'Databank rapportage');
INSERT INTO `lang_definitions` VALUES (7077, 683, 5, 'Data kolommen moeten nummer hebben tussen 1 en 999');
INSERT INTO `lang_definitions` VALUES (7078, 684, 5, 'Datum');
INSERT INTO `lang_definitions` VALUES (7079, 685, 5, 'DATUM');
INSERT INTO `lang_definitions` VALUES (7080, 686, 5, 'Geadministreerde datum');
INSERT INTO `lang_definitions` VALUES (7081, 687, 5, 'Aanvankelijke begindatum anticonceptie');
INSERT INTO `lang_definitions` VALUES (7082, 688, 5, 'Datum vernietigd');
INSERT INTO `lang_definitions` VALUES (7083, 689, 5, 'Format van de datum invoer');
INSERT INTO `lang_definitions` VALUES (7084, 690, 5, 'Datum voor \"einde afspraak\" is niet geldig');
INSERT INTO `lang_definitions` VALUES (7085, 691, 5, 'Datum van begin afspraak is niet geldig');
INSERT INTO `lang_definitions` VALUES (7086, 692, 5, 'Datum format voor \"volgende afspraak is niet geldig');
INSERT INTO `lang_definitions` VALUES (7087, 693, 5, 'Datum voor \"niet gezien sinds\" is ongeldig');
INSERT INTO `lang_definitions` VALUES (7088, 694, 5, 'Datum voor \"geziens sinds\" is niet geldig');
INSERT INTO `lang_definitions` VALUES (7089, 695, 5, 'Datum van start thuisdialyse');
INSERT INTO `lang_definitions` VALUES (7090, 696, 5, 'Dag voor deze code is niet ingevuld');
INSERT INTO `lang_definitions` VALUES (7091, 697, 5, 'Datum bankdeposito jjjj-mm-dd');
INSERT INTO `lang_definitions` VALUES (7092, 698, 5, 'Geboortedatum');
INSERT INTO `lang_definitions` VALUES (7093, 699, 5, 'Geboortedatum');
INSERT INTO `lang_definitions` VALUES (7094, 700, 5, 'Datum van letsel');
INSERT INTO `lang_definitions` VALUES (7095, 701, 5, 'Datum van betaling jjjj-mm-dd');
INSERT INTO `lang_definitions` VALUES (7096, 702, 5, 'Datum van verwijzing');
INSERT INTO `lang_definitions` VALUES (7097, 703, 5, 'Datum van antwoord');
INSERT INTO `lang_definitions` VALUES (7098, 704, 5, 'Datrum van dienstverlening');
INSERT INTO `lang_definitions` VALUES (7099, 705, 5, 'Datum van dienstverlening mm/dd/jjjj');
INSERT INTO `lang_definitions` VALUES (7100, 706, 5, 'Datum van dienstverlening');
INSERT INTO `lang_definitions` VALUES (7101, 707, 5, 'Datum van handtekening');
INSERT INTO `lang_definitions` VALUES (7102, 708, 5, 'Datum VIS verklaring');
INSERT INTO `lang_definitions` VALUES (7103, 709, 5, 'Datum/Bez.');
INSERT INTO `lang_definitions` VALUES (7104, 710, 5, 'Datum/Notitie');
INSERT INTO `lang_definitions` VALUES (7105, 711, 5, 'Datum/Notitie van laatste');
INSERT INTO `lang_definitions` VALUES (7106, 712, 5, 'Datum:');
INSERT INTO `lang_definitions` VALUES (7107, 713, 5, 'dag');
INSERT INTO `lang_definitions` VALUES (7108, 714, 5, 'Dag');
INSERT INTO `lang_definitions` VALUES (7109, 715, 5, 'Dagoverzicht');
INSERT INTO `lang_definitions` VALUES (7110, 716, 5, 'Dag(en)');
INSERT INTO `lang_definitions` VALUES (7111, 717, 5, 'Dag(en) Ma - Vr');
INSERT INTO `lang_definitions` VALUES (7112, 718, 5, 'dagen');
INSERT INTO `lang_definitions` VALUES (7113, 719, 5, 'Dagen');
INSERT INTO `lang_definitions` VALUES (7114, 720, 5, 'Dagen en spelen gemist');
INSERT INTO `lang_definitions` VALUES (7115, 721, 5, 'Dagen vanaf laatste contact');
INSERT INTO `lang_definitions` VALUES (7116, 722, 5, 'Dagen per kolom:');
INSERT INTO `lang_definitions` VALUES (7117, 723, 5, 'DB geinstalleerd');
INSERT INTO `lang_definitions` VALUES (7118, 724, 5, 'DEA');
INSERT INTO `lang_definitions` VALUES (7119, 725, 5, 'Informatie om fout te zoeken');
INSERT INTO `lang_definitions` VALUES (7120, 726, 5, 'December');
INSERT INTO `lang_definitions` VALUES (7121, 727, 5, 'Standaard');
INSERT INTO `lang_definitions` VALUES (7122, 728, 5, 'Standaard agendaweergave');
INSERT INTO `lang_definitions` VALUES (7123, 729, 5, 'Voorkeurskliniek');
INSERT INTO `lang_definitions` VALUES (7124, 730, 5, 'Standaardlijst (schrijven,toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (7125, 731, 5, 'Standaardmethode');
INSERT INTO `lang_definitions` VALUES (7126, 732, 5, 'Standaard behandelaar');
INSERT INTO `lang_definitions` VALUES (7127, 733, 5, 'Standaardsjabloon');
INSERT INTO `lang_definitions` VALUES (7128, 734, 5, 'Standaardwaarde');
INSERT INTO `lang_definitions` VALUES (7129, 735, 5, 'Standaard X12 partner');
INSERT INTO `lang_definitions` VALUES (7130, 736, 5, 'Standaard/Algemeen');
INSERT INTO `lang_definitions` VALUES (7131, 738, 5, 'Verlaat recidief (>12 mndn)');
INSERT INTO `lang_definitions` VALUES (7132, 739, 5, 'Verwijder');
INSERT INTO `lang_definitions` VALUES (7133, 740, 5, 'verwijder');
INSERT INTO `lang_definitions` VALUES (7134, 741, 5, 'Verwijder categorieen met ID(s):');
INSERT INTO `lang_definitions` VALUES (7135, 742, 5, 'Verwijder groep');
INSERT INTO `lang_definitions` VALUES (7136, 743, 5, 'Verwijder lijst');
INSERT INTO `lang_definitions` VALUES (7137, 744, 5, 'Verwijder pagina´s');
INSERT INTO `lang_definitions` VALUES (7138, 745, 5, 'Verwijder patient, contact, formulier, probleem, document, betaling, rekening of transactie');
INSERT INTO `lang_definitions` VALUES (7139, 747, 5, 'Verwijderen gelukt.');
INSERT INTO `lang_definitions` VALUES (7140, 748, 5, 'Verwijder dit document');
INSERT INTO `lang_definitions` VALUES (7141, 749, 5, 'Verwijder dit formulier');
INSERT INTO `lang_definitions` VALUES (7142, 750, 5, 'Verwijder deze notitie');
INSERT INTO `lang_definitions` VALUES (7143, 751, 5, 'Dementie');
INSERT INTO `lang_definitions` VALUES (7144, 752, 5, 'Persoonsgegevens');
INSERT INTO `lang_definitions` VALUES (7145, 753, 5, 'Persoonsgegevens (schrijven,toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (7146, 754, 5, 'Persoonsgegevens niet geautoriseerd');
INSERT INTO `lang_definitions` VALUES (7147, 755, 5, 'Persoonsgegevens nog niet geautoriseerd');
INSERT INTO `lang_definitions` VALUES (7148, 756, 5, 'Gebit');
INSERT INTO `lang_definitions` VALUES (7149, 757, 5, 'Gebitsproblemen');
INSERT INTO `lang_definitions` VALUES (7150, 758, 5, 'Afhankelijk van het type rekening dat u test, ziet u HCFA gelijkende output op een lege pagina voor HCFA rekeningen, u zult vele regels van enigszins verdraaide tekst en informatie zien, als u een X12 claim test. Deze verdraaide tekst is in het X12 EDI 4010A formaat. Soms zult u eigenaardige tekens zien die op dominostenen of squiglies lijken, dit zijn controletekens zoals nieuwe pagina beginnen en zijn normaal. ');
INSERT INTO `lang_definitions` VALUES (7151, 759, 5, 'Datum deposito');
INSERT INTO `lang_definitions` VALUES (7152, 760, 5, 'Depressief');
INSERT INTO `lang_definitions` VALUES (7153, 761, 5, 'Depressie');
INSERT INTO `lang_definitions` VALUES (7154, 762, 5, 'Omschrijving');
INSERT INTO `lang_definitions` VALUES (7155, 763, 5, 'omschrijving');
INSERT INTO `lang_definitions` VALUES (7156, 764, 5, 'Omschrijving vertaling');
INSERT INTO `lang_definitions` VALUES (7157, 765, 5, 'Bestemming');
INSERT INTO `lang_definitions` VALUES (7158, 766, 5, 'Vernietig Lot');
INSERT INTO `lang_definitions` VALUES (7159, 767, 5, 'Vernietigen...');
INSERT INTO `lang_definitions` VALUES (7160, 768, 5, 'Vernietigd');
INSERT INTO `lang_definitions` VALUES (7161, 769, 5, 'Vernietigde medicijnen');
INSERT INTO `lang_definitions` VALUES (7162, 770, 5, 'Vernietigde medicijnrapport');
INSERT INTO `lang_definitions` VALUES (7163, 771, 5, 'Detaillering');
INSERT INTO `lang_definitions` VALUES (7164, 772, 5, 'Ontwikkelings abnormaliteit');
INSERT INTO `lang_definitions` VALUES (7165, 773, 5, 'Diabetes');
INSERT INTO `lang_definitions` VALUES (7166, 774, 5, 'Diag');
INSERT INTO `lang_definitions` VALUES (7167, 775, 5, 'Diagnose');
INSERT INTO `lang_definitions` VALUES (7168, 776, 5, 'Diagnose moet aan code verbonden zijn');
INSERT INTO `lang_definitions` VALUES (7169, 777, 5, 'Diagnose:');
INSERT INTO `lang_definitions` VALUES (7170, 778, 5, 'Diagnose:');
INSERT INTO `lang_definitions` VALUES (7171, 779, 5, 'Diagnostische testen');
INSERT INTO `lang_definitions` VALUES (7172, 780, 5, 'Dials');
INSERT INTO `lang_definitions` VALUES (7173, 781, 5, 'Diafragma/Caps');
INSERT INTO `lang_definitions` VALUES (7174, 782, 5, 'Diarree');
INSERT INTO `lang_definitions` VALUES (7175, 783, 5, 'Dictaat');
INSERT INTO `lang_definitions` VALUES (7176, 784, 5, 'Gesproken tekst');
INSERT INTO `lang_definitions` VALUES (7177, 785, 5, 'Heeft u een kopie gekregen van de HIPAA Notitie');
INSERT INTO `lang_definitions` VALUES (7178, 786, 5, 'Diffuus:');
INSERT INTO `lang_definitions` VALUES (7179, 788, 5, 'Kerende post');
INSERT INTO `lang_definitions` VALUES (7180, 789, 5, 'Handicap');
INSERT INTO `lang_definitions` VALUES (7181, 790, 5, 'inactief');
INSERT INTO `lang_definitions` VALUES (7182, 791, 5, 'Invalide');
INSERT INTO `lang_definitions` VALUES (7183, 792, 5, 'DISC');
INSERT INTO `lang_definitions` VALUES (7184, 793, 5, 'Afscheiding');
INSERT INTO `lang_definitions` VALUES (7185, 794, 5, 'Afscheiding uit Urethra');
INSERT INTO `lang_definitions` VALUES (7186, 795, 5, 'Afscheiding rechts');
INSERT INTO `lang_definitions` VALUES (7187, 796, 5, 'Afscheiding rechts:');
INSERT INTO `lang_definitions` VALUES (7188, 797, 5, 'Korting');
INSERT INTO `lang_definitions` VALUES (7189, 798, 5, 'Kortingsbedrag');
INSERT INTO `lang_definitions` VALUES (7190, 799, 5, 'Kortingsniveau');
INSERT INTO `lang_definitions` VALUES (7191, 800, 5, 'Ziekte');
INSERT INTO `lang_definitions` VALUES (7192, 801, 5, 'Dislocatie');
INSERT INTO `lang_definitions` VALUES (7193, 802, 5, 'Disp #');
INSERT INTO `lang_definitions` VALUES (7194, 803, 5, 'Lever af');
INSERT INTO `lang_definitions` VALUES (7195, 804, 5, 'Lever ontvangen document af');
INSERT INTO `lang_definitions` VALUES (7196, 805, 5, 'Afgegeven');
INSERT INTO `lang_definitions` VALUES (7197, 806, 5, 'Data gebeurtenissen in blok tonen?');
INSERT INTO `lang_definitions` VALUES (7198, 807, 5, 'Hoeveelheid gebeurtenissen tonen?');
INSERT INTO `lang_definitions` VALUES (7199, 808, 5, 'Locatie in blok tonen?');
INSERT INTO `lang_definitions` VALUES (7200, 809, 5, 'De agenda tonen?');
INSERT INTO `lang_definitions` VALUES (7201, 810, 5, 'Gebeurtenissen van vandaag in blok tonen?');
INSERT INTO `lang_definitions` VALUES (7202, 811, 5, 'Onderwerp in blok tonen?');
INSERT INTO `lang_definitions` VALUES (7203, 812, 5, 'Komende gebeurtenissen in blok tonen?');
INSERT INTO `lang_definitions` VALUES (7204, 813, 5, 'Verdeling');
INSERT INTO `lang_definitions` VALUES (7205, 814, 5, 'Diverticulitis');
INSERT INTO `lang_definitions` VALUES (7206, 815, 5, 'Diverticulitis chirurgie');
INSERT INTO `lang_definitions` VALUES (7207, 816, 5, 'Diverticulitis');
INSERT INTO `lang_definitions` VALUES (7208, 817, 5, 'Diverticulitis chirurgie');
INSERT INTO `lang_definitions` VALUES (7209, 818, 5, 'Gescheiden');
INSERT INTO `lang_definitions` VALUES (7210, 819, 5, 'Duizeligheid');
INSERT INTO `lang_definitions` VALUES (7211, 820, 5, 'niet bewaren');
INSERT INTO `lang_definitions` VALUES (7212, 821, 5, 'niet vervangen');
INSERT INTO `lang_definitions` VALUES (7213, 823, 5, 'Wilt u zeker deze groep verwijderen?');
INSERT INTO `lang_definitions` VALUES (7214, 824, 5, 'Wilt u doorgaan met deze nieuwe client toe te voegen?');
INSERT INTO `lang_definitions` VALUES (7215, 825, 5, 'Wilt u verder gaan met de nieuwe naam?');
INSERT INTO `lang_definitions` VALUES (7216, 826, 5, 'WIlt u dit immunisatie verslag PERMANENT verwijderen?');
INSERT INTO `lang_definitions` VALUES (7217, 827, 5, 'GEB');
INSERT INTO `lang_definitions` VALUES (7218, 828, 5, 'Geb datum niet ingevuld');
INSERT INTO `lang_definitions` VALUES (7219, 829, 5, 'Docs');
INSERT INTO `lang_definitions` VALUES (7220, 830, 5, 'Dokter');
INSERT INTO `lang_definitions` VALUES (7221, 831, 5, 'Dr:');
INSERT INTO `lang_definitions` VALUES (7222, 832, 5, 'Naam en handtekening Arts');
INSERT INTO `lang_definitions` VALUES (7223, 833, 5, 'Document');
INSERT INTO `lang_definitions` VALUES (7224, 834, 5, 'document');
INSERT INTO `lang_definitions` VALUES (7225, 835, 5, 'Document categorieen');
INSERT INTO `lang_definitions` VALUES (7226, 836, 5, 'Document kon niet naar Cleint ID verzet worden');
INSERT INTO `lang_definitions` VALUES (7227, 837, 5, 'Datum van document');
INSERT INTO `lang_definitions` VALUES (7228, 838, 5, 'Datum van document en klachten aangepast');
INSERT INTO `lang_definitions` VALUES (7229, 839, 5, 'Ducument verzet naar nieuwe categorie');
INSERT INTO `lang_definitions` VALUES (7230, 840, 5, 'Dokument verzet naar patient ID');
INSERT INTO `lang_definitions` VALUES (7231, 841, 5, 'Bewaarplaats van document/afbeelding');
INSERT INTO `lang_definitions` VALUES (7232, 842, 5, 'Documenten');
INSERT INTO `lang_definitions` VALUES (7233, 843, 5, 'Documenten (schrijven,toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (7234, 844, 5, 'DOE');
INSERT INTO `lang_definitions` VALUES (7235, 845, 5, 'Levenspartner');
INSERT INTO `lang_definitions` VALUES (7236, 846, 5, 'Niet bewaren');
INSERT INTO `lang_definitions` VALUES (7237, 847, 5, 'Niet bewaren');
INSERT INTO `lang_definitions` VALUES (7238, 848, 5, 'Wijzigingen niet bewaren');
INSERT INTO `lang_definitions` VALUES (7239, 849, 5, 'Klaar');
INSERT INTO `lang_definitions` VALUES (7240, 850, 5, 'Gedaan met:');
INSERT INTO `lang_definitions` VALUES (7241, 851, 5, 'Klaar. Download wordt verstuurd');
INSERT INTO `lang_definitions` VALUES (7242, 852, 5, 'DOS');
INSERT INTO `lang_definitions` VALUES (7243, 853, 5, 'Dosering');
INSERT INTO `lang_definitions` VALUES (7244, 854, 5, 'Dubbel klikken om te veranderen');
INSERT INTO `lang_definitions` VALUES (7245, 855, 5, 'Dubbel zien');
INSERT INTO `lang_definitions` VALUES (7246, 856, 5, 'Download factureringsbestand, verstuur naar boekhouding en markeer als gefactureerd');
INSERT INTO `lang_definitions` VALUES (7247, 857, 5, 'Download coniguratie data');
INSERT INTO `lang_definitions` VALUES (7248, 858, 5, 'Dr. Controle');
INSERT INTO `lang_definitions` VALUES (7249, 859, 5, 'Dr. Bezoek');
INSERT INTO `lang_definitions` VALUES (7250, 860, 5, 'Dr.');
INSERT INTO `lang_definitions` VALUES (7251, 861, 5, 'Kwijlen');
INSERT INTO `lang_definitions` VALUES (7252, 862, 5, 'Rijbewijs of BSN');
INSERT INTO `lang_definitions` VALUES (7253, 863, 5, 'Medicatie');
INSERT INTO `lang_definitions` VALUES (7254, 864, 5, 'Medicatieformulier');
INSERT INTO `lang_definitions` VALUES (7255, 865, 5, 'Medicatie ID afwezig!');
INSERT INTO `lang_definitions` VALUES (7256, 866, 5, 'Medicatie-intervallen');
INSERT INTO `lang_definitions` VALUES (7257, 867, 5, 'Medicijnen voorraadbeheer');
INSERT INTO `lang_definitions` VALUES (7258, 868, 5, 'Naam medicatie');
INSERT INTO `lang_definitions` VALUES (7259, 869, 5, 'Wijze van toedienen');
INSERT INTO `lang_definitions` VALUES (7260, 870, 5, 'Medicatie-eenheden');
INSERT INTO `lang_definitions` VALUES (7261, 871, 5, 'Medicijnen');
INSERT INTO `lang_definitions` VALUES (7262, 872, 5, 'Droge mond');
INSERT INTO `lang_definitions` VALUES (7263, 873, 5, 'DT1');
INSERT INTO `lang_definitions` VALUES (7264, 874, 5, 'DT2');
INSERT INTO `lang_definitions` VALUES (7265, 875, 5, 'DT3');
INSERT INTO `lang_definitions` VALUES (7266, 876, 5, 'DT4');
INSERT INTO `lang_definitions` VALUES (7267, 877, 5, 'DT5');
INSERT INTO `lang_definitions` VALUES (7268, 878, 5, 'DTaP1');
INSERT INTO `lang_definitions` VALUES (7269, 879, 5, 'DTaP2');
INSERT INTO `lang_definitions` VALUES (7270, 880, 5, 'DTaP3');
INSERT INTO `lang_definitions` VALUES (7271, 881, 5, 'DTaP4');
INSERT INTO `lang_definitions` VALUES (7272, 882, 5, 'DTaP5');
INSERT INTO `lang_definitions` VALUES (7273, 883, 5, 'Datum bevalling');
INSERT INTO `lang_definitions` VALUES (7274, 884, 5, 'Datum bev. mm/dd/jjjj of jjjj-mm-dd');
INSERT INTO `lang_definitions` VALUES (7275, 885, 5, 'Datum bevalling:');
INSERT INTO `lang_definitions` VALUES (7276, 886, 5, 'Vanwege Ins');
INSERT INTO `lang_definitions` VALUES (7277, 887, 5, 'Vanwege Pt');
INSERT INTO `lang_definitions` VALUES (7278, 888, 5, 'Dumping OpenEMR database');
INSERT INTO `lang_definitions` VALUES (7279, 889, 5, 'Dumping OpenEMR web directory tree');
INSERT INTO `lang_definitions` VALUES (7280, 890, 5, 'Dumping phpGACL database');
INSERT INTO `lang_definitions` VALUES (7281, 891, 5, 'Dumping phpGACL web directory tree');
INSERT INTO `lang_definitions` VALUES (7282, 892, 5, 'Dumping SQL-Ledger database');
INSERT INTO `lang_definitions` VALUES (7283, 893, 5, 'Dumping SQL-Ledger web directory tree');
INSERT INTO `lang_definitions` VALUES (7284, 894, 5, 'Waarschuwing tegen duplicatie');
INSERT INTO `lang_definitions` VALUES (7285, 895, 5, 'duur');
INSERT INTO `lang_definitions` VALUES (7286, 896, 5, 'Duur');
INSERT INTO `lang_definitions` VALUES (7287, 897, 5, 'Nederlands');
INSERT INTO `lang_definitions` VALUES (7288, 898, 5, 'Dysphagie');
INSERT INTO `lang_definitions` VALUES (7289, 899, 5, 'Dyspnoe');
INSERT INTO `lang_definitions` VALUES (7290, 900, 5, 'Dysurie');
INSERT INTO `lang_definitions` VALUES (7291, 901, 5, 'Vroeg recidief (<2mnd)');
INSERT INTO `lang_definitions` VALUES (7292, 902, 5, 'Oren');
INSERT INTO `lang_definitions` VALUES (7293, 903, 5, 'ECG');
INSERT INTO `lang_definitions` VALUES (7294, 904, 5, 'Oedeem');
INSERT INTO `lang_definitions` VALUES (7295, 905, 5, 'Aanpassen');
INSERT INTO `lang_definitions` VALUES (7296, 906, 5, 'Allergien aanpassen');
INSERT INTO `lang_definitions` VALUES (7297, 907, 5, 'Categorieen aanpassen');
INSERT INTO `lang_definitions` VALUES (7298, 908, 5, 'Definities aanpassen');
INSERT INTO `lang_definitions` VALUES (7299, 909, 5, 'Diagnoses aanpassen voor');
INSERT INTO `lang_definitions` VALUES (7300, 910, 5, 'Locatie aanpassen');
INSERT INTO `lang_definitions` VALUES (7301, 911, 5, 'Locatie-informatie aanpassen');
INSERT INTO `lang_definitions` VALUES (7302, 912, 5, 'Pas formulier aan');
INSERT INTO `lang_definitions` VALUES (7303, 913, 5, 'Pas vormgeving aan');
INSERT INTO `lang_definitions` VALUES (7304, 914, 5, 'Pas lijst aan');
INSERT INTO `lang_definitions` VALUES (7305, 915, 5, 'Structuur aanpassen');
INSERT INTO `lang_definitions` VALUES (7306, 916, 5, 'Opleiding');
INSERT INTO `lang_definitions` VALUES (7307, 917, 5, 'Opleidingsdatum');
INSERT INTO `lang_definitions` VALUES (7308, 918, 5, 'ee * Licentie voor algemeen gebruik onder GNU voorwaarden, voor meer details. * * U zou een exemplaar van de LicentieVergunning voor algemeen gebruik van GNU voorwaarden* samen met dit programma ontvangen moeten hebben; indien niet onvangen, schrijf naar Vrije');
INSERT INTO `lang_definitions` VALUES (7309, 919, 5, 'Ingangsdatum');
INSERT INTO `lang_definitions` VALUES (7310, 920, 5, 'Effectiviteit');
INSERT INTO `lang_definitions` VALUES (7311, 921, 5, 'Ejaculaties');
INSERT INTO `lang_definitions` VALUES (7312, 922, 5, 'Elleboog');
INSERT INTO `lang_definitions` VALUES (7313, 923, 5, 'Problemen met elleboog');
INSERT INTO `lang_definitions` VALUES (7314, 924, 5, 'Electronische overschrijvingen');
INSERT INTO `lang_definitions` VALUES (7315, 925, 5, 'E-mail');
INSERT INTO `lang_definitions` VALUES (7316, 926, 5, 'Berichtgeving per e-mail');
INSERT INTO `lang_definitions` VALUES (7317, 927, 5, 'E-mail aanmelding');
INSERT INTO `lang_definitions` VALUES (7318, 928, 5, 'E-mal eerder verzonden');
INSERT INTO `lang_definitions` VALUES (7319, 929, 5, 'E-mail afzender');
INSERT INTO `lang_definitions` VALUES (7320, 930, 5, 'E-mail onderwerp');
INSERT INTO `lang_definitions` VALUES (7321, 931, 5, 'E-mailadres: Tekst, Bruikbare Tag: *** *** NAAM, dwz Geachte NAAM *** ***');
INSERT INTO `lang_definitions` VALUES (7322, 932, 5, 'Spoedconsult');
INSERT INTO `lang_definitions` VALUES (7323, 933, 5, 'Contactpersoon igv SPOED');
INSERT INTO `lang_definitions` VALUES (7324, 934, 5, 'Bij SPOED bel:');
INSERT INTO `lang_definitions` VALUES (7325, 935, 5, 'Nood contraceptie');
INSERT INTO `lang_definitions` VALUES (7326, 936, 5, 'Noodtelefoonnr');
INSERT INTO `lang_definitions` VALUES (7327, 937, 5, 'Emfyseem');
INSERT INTO `lang_definitions` VALUES (7328, 938, 5, 'Werknemer');
INSERT INTO `lang_definitions` VALUES (7329, 939, 5, 'Werkgever');
INSERT INTO `lang_definitions` VALUES (7330, 940, 5, 'Adres werkgever');
INSERT INTO `lang_definitions` VALUES (7331, 941, 5, 'Gegevens werkgever');
INSERT INTO `lang_definitions` VALUES (7332, 942, 5, 'Naam werkgever');
INSERT INTO `lang_definitions` VALUES (7333, 943, 5, 'Leeg');
INSERT INTO `lang_definitions` VALUES (7334, 944, 5, 'Lege waarde \"E-mail uren\"');
INSERT INTO `lang_definitions` VALUES (7335, 945, 5, 'Lege waarde \"E-mail afzender\"');
INSERT INTO `lang_definitions` VALUES (7336, 946, 5, 'Lege waarde \"E-mail onderwerp\"');
INSERT INTO `lang_definitions` VALUES (7337, 947, 5, 'Lege waarde \"E-mail tekst\"');
INSERT INTO `lang_definitions` VALUES (7338, 948, 5, 'Lege waarde \"Naam behandelaar\"');
INSERT INTO `lang_definitions` VALUES (7339, 949, 5, 'Lege waarde \"Wachtwoord\"');
INSERT INTO `lang_definitions` VALUES (7340, 950, 5, 'Lege waarde \"SMS uren\"');
INSERT INTO `lang_definitions` VALUES (7341, 951, 5, 'Lege waarde \"SMS tekst');
INSERT INTO `lang_definitions` VALUES (7342, 952, 5, 'Lege waarde \"Gebruikersnaam\"');
INSERT INTO `lang_definitions` VALUES (7343, 953, 5, 'geactiveerd');
INSERT INTO `lang_definitions` VALUES (7344, 954, 5, 'Epis');
INSERT INTO `lang_definitions` VALUES (7345, 955, 5, 'episode');
INSERT INTO `lang_definitions` VALUES (7346, 956, 5, 'Episode');
INSERT INTO `lang_definitions` VALUES (7347, 957, 5, 'Episode');
INSERT INTO `lang_definitions` VALUES (7348, 958, 5, 'Episode Formulier');
INSERT INTO `lang_definitions` VALUES (7349, 959, 5, 'Episode nummer');
INSERT INTO `lang_definitions` VALUES (7350, 960, 5, 'Episode werd gecodeerd');
INSERT INTO `lang_definitions` VALUES (7351, 961, 5, 'Episode:');
INSERT INTO `lang_definitions` VALUES (7352, 962, 5, 'Episoden');
INSERT INTO `lang_definitions` VALUES (7353, 963, 5, 'Episoden en Formulieren');
INSERT INTO `lang_definitions` VALUES (7354, 964, 5, 'Episoden & Formulieren');
INSERT INTO `lang_definitions` VALUES (7355, 965, 5, 'Episoden niet geautoriseerd');
INSERT INTO `lang_definitions` VALUES (7356, 966, 5, 'Episoden rapportage');
INSERT INTO `lang_definitions` VALUES (7357, 967, 5, 'Episodesectie');
INSERT INTO `lang_definitions` VALUES (7358, 968, 5, 'Einde');
INSERT INTO `lang_definitions` VALUES (7359, 969, 5, 'Eind (jjjj-mm-dd):');
INSERT INTO `lang_definitions` VALUES (7360, 970, 5, 'Einddatum');
INSERT INTO `lang_definitions` VALUES (7361, 971, 5, 'Einddatum');
INSERT INTO `lang_definitions` VALUES (7362, 972, 5, 'Einddatum:');
INSERT INTO `lang_definitions` VALUES (7363, 973, 5, 'Eindtijd');
INSERT INTO `lang_definitions` VALUES (7364, 974, 5, 'Datum einde van Service jjjj-mm-dd');
INSERT INTO `lang_definitions` VALUES (7365, 975, 5, 'Einddatum DOS mm/dd/jjjj als u een periode wilt invullen');
INSERT INTO `lang_definitions` VALUES (7366, 976, 5, 'Inwendig abnormaal bloedverlies');
INSERT INTO `lang_definitions` VALUES (7367, 977, 5, 'Endocrien');
INSERT INTO `lang_definitions` VALUES (7368, 978, 5, 'Endoscopie');
INSERT INTO `lang_definitions` VALUES (7369, 979, 5, 'Engels');
INSERT INTO `lang_definitions` VALUES (7370, 980, 5, 'Engels');
INSERT INTO `lang_definitions` VALUES (7371, 981, 5, 'Engels (India)');
INSERT INTO `lang_definitions` VALUES (7372, 982, 5, 'Engels (Standaard)');
INSERT INTO `lang_definitions` VALUES (7373, 983, 5, 'Zorg ervoor dat OpenEMR schrijf privileges heeft');
INSERT INTO `lang_definitions` VALUES (7374, 984, 5, 'KNO afscheiding');
INSERT INTO `lang_definitions` VALUES (7375, 985, 5, 'KNO pijn');
INSERT INTO `lang_definitions` VALUES (7376, 986, 5, 'Voer diagnosecode in om alle facturen uit te sluiten die het NIET bevatten');
INSERT INTO `lang_definitions` VALUES (7377, 987, 5, 'Hier de BODY van brief invullen');
INSERT INTO `lang_definitions` VALUES (7378, 988, 5, 'Nieuwe provinvie/eiland toevoegen');
INSERT INTO `lang_definitions` VALUES (7379, 989, 5, 'Vul uw zoek criteria hierboven in');
INSERT INTO `lang_definitions` VALUES (7380, 990, 5, 'Omgeving gebonden');
INSERT INTO `lang_definitions` VALUES (7381, 991, 5, 'EOB Data Invoer');
INSERT INTO `lang_definitions` VALUES (7382, 992, 5, 'EOB Detachering - Elektronische geldovermakingen');
INSERT INTO `lang_definitions` VALUES (7383, 993, 5, 'EOB Detachering - Instructies');
INSERT INTO `lang_definitions` VALUES (7384, 994, 5, 'EOB Detachering - Factuur');
INSERT INTO `lang_definitions` VALUES (7385, 995, 5, 'EOB Detachering - Patient opmerking');
INSERT INTO `lang_definitions` VALUES (7386, 996, 5, 'EOB Detachering - Zoeken');
INSERT INTO `lang_definitions` VALUES (7387, 997, 5, 'Epilepsie');
INSERT INTO `lang_definitions` VALUES (7388, 998, 5, 'Doorhalen');
INSERT INTO `lang_definitions` VALUES (7389, 999, 5, 'Erecties');
INSERT INTO `lang_definitions` VALUES (7390, 1000, 5, 'Fout');
INSERT INTO `lang_definitions` VALUES (7391, 1001, 5, 'Foute keuze geslacht');
INSERT INTO `lang_definitions` VALUES (7392, 1002, 5, 'Foute HIPAA selectie');
INSERT INTO `lang_definitions` VALUES (7393, 1003, 5, 'Fout in Verwerking keuze');
INSERT INTO `lang_definitions` VALUES (7394, 1004, 5, 'Fout bij het SMS Gateway selectie');
INSERT INTO `lang_definitions` VALUES (7395, 1005, 5, 'Fout in \"Sorteren op\" keuze');
INSERT INTO `lang_definitions` VALUES (7396, 1007, 5, 'Fout in JA of NEE keuze');
INSERT INTO `lang_definitions` VALUES (7397, 1009, 5, 'fout tijdens registreren van formulier');
INSERT INTO `lang_definitions` VALUES (7398, 1010, 5, 'Fout tijdens bewaren van bestand opgetreden');
INSERT INTO `lang_definitions` VALUES (7399, 1011, 5, 'Fout tijdens schrijven naar bestand');
INSERT INTO `lang_definitions` VALUES (7400, 1012, 5, 'FOUT, kon geen data van server ophalen');
INSERT INTO `lang_definitions` VALUES (7401, 1014, 5, 'FOUT: kon tabel.sql niet openen, gebroken form?');
INSERT INTO `lang_definitions` VALUES (7402, 1016, 5, 'Fout: wachtwoorden komen niet overeen. Controleer op typfouten');
INSERT INTO `lang_definitions` VALUES (7403, 1018, 5, 'Fouten');
INSERT INTO `lang_definitions` VALUES (7404, 1019, 5, 'Erytema');
INSERT INTO `lang_definitions` VALUES (7405, 1020, 5, 'Bekende patient');
INSERT INTO `lang_definitions` VALUES (7406, 1021, 5, 'Ras of afkomst');
INSERT INTO `lang_definitions` VALUES (7407, 1022, 5, 'Afkomst-Ras lijst (schrijven,toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (7408, 1023, 5, 'ETIN');
INSERT INTO `lang_definitions` VALUES (7409, 1024, 5, 'Gebeurtenis');
INSERT INTO `lang_definitions` VALUES (7410, 1025, 5, 'Start gebeurtenis');
INSERT INTO `lang_definitions` VALUES (7411, 1026, 5, 'Gebeurtenis categorie');
INSERT INTO `lang_definitions` VALUES (7412, 1027, 5, 'Gebeurtenis datum');
INSERT INTO `lang_definitions` VALUES (7413, 1028, 5, 'Gebeurtenis omschrijving');
INSERT INTO `lang_definitions` VALUES (7414, 1029, 5, 'Gebeurtenis details');
INSERT INTO `lang_definitions` VALUES (7415, 1030, 5, 'Gebeurtenis zonder herhaling');
INSERT INTO `lang_definitions` VALUES (7416, 1031, 5, 'Duur van gebeurtenis');
INSERT INTO `lang_definitions` VALUES (7417, 1032, 5, 'Duur gebeurtenis in minuten');
INSERT INTO `lang_definitions` VALUES (7418, 1033, 5, 'Bedrag van gebeurtenis');
INSERT INTO `lang_definitions` VALUES (7419, 1034, 5, 'Locatie gebeurtenis');
INSERT INTO `lang_definitions` VALUES (7420, 1035, 5, 'Gebeurtenis herhaalt zich iedere');
INSERT INTO `lang_definitions` VALUES (7421, 1036, 5, 'Gebeurtenius herhaalt zich op');
INSERT INTO `lang_definitions` VALUES (7422, 1037, 5, 'Gebeurtenis startdatum');
INSERT INTO `lang_definitions` VALUES (7423, 1038, 5, 'Gebeurtenis titel');
INSERT INTO `lang_definitions` VALUES (7424, 1039, 5, 'Gebeurtenis titel');
INSERT INTO `lang_definitions` VALUES (7425, 1040, 5, 'Website gebeurtenis');
INSERT INTO `lang_definitions` VALUES (7426, 1041, 5, 'Gebeurtenissen in blok laten zien');
INSERT INTO `lang_definitions` VALUES (7427, 1042, 5, 'Gebeurtenissen voor');
INSERT INTO `lang_definitions` VALUES (7428, 1043, 5, 'Gebeurtenis opent nieuw venster');
INSERT INTO `lang_definitions` VALUES (7429, 1044, 5, 'iedere');
INSERT INTO `lang_definitions` VALUES (7430, 1045, 5, 'Iedere');
INSERT INTO `lang_definitions` VALUES (7431, 1046, 5, 'iedere 3 uur');
INSERT INTO `lang_definitions` VALUES (7432, 1047, 5, 'iedere 4 uur');
INSERT INTO `lang_definitions` VALUES (7433, 1048, 5, 'iedere 5 uur');
INSERT INTO `lang_definitions` VALUES (7434, 1049, 5, 'iedere 6 uur');
INSERT INTO `lang_definitions` VALUES (7435, 1050, 5, 'iedere 8 uur');
INSERT INTO `lang_definitions` VALUES (7436, 1051, 5, 'Iedere vierde');
INSERT INTO `lang_definitions` VALUES (7437, 1052, 5, 'Ieder ander');
INSERT INTO `lang_definitions` VALUES (7438, 1053, 5, 'Iedere derde');
INSERT INTO `lang_definitions` VALUES (7439, 1054, 5, 'Iedere, om de, iedere 3e, etc.');
INSERT INTO `lang_definitions` VALUES (7440, 1055, 5, 'Onderzoeks- en testresultaten');
INSERT INTO `lang_definitions` VALUES (7441, 1056, 5, 'Onderzoekresultaten');
INSERT INTO `lang_definitions` VALUES (7442, 1057, 5, 'Datum onderzoek');
INSERT INTO `lang_definitions` VALUES (7443, 1058, 5, 'Onderzoeken/Testen');
INSERT INTO `lang_definitions` VALUES (7444, 1059, 5, 'Buitengewoon scheuren');
INSERT INTO `lang_definitions` VALUES (7445, 1060, 5, 'Exclusieve Organisatie van behandelaar (EPO)');
INSERT INTO `lang_definitions` VALUES (7446, 1061, 5, 'Soort oefeningen');
INSERT INTO `lang_definitions` VALUES (7447, 1062, 5, 'Soort oefeningen');
INSERT INTO `lang_definitions` VALUES (7448, 1063, 5, 'Uit Admin weggaan');
INSERT INTO `lang_definitions` VALUES (7449, 1064, 5, 'Exp');
INSERT INTO `lang_definitions` VALUES (7450, 1065, 5, 'Uitgevouwen scherm');
INSERT INTO `lang_definitions` VALUES (7451, 1066, 5, 'Verwacht formulier_ontmoeting. pid om te zijn');
INSERT INTO `lang_definitions` VALUES (7452, 1067, 5, 'Verloopdatum');
INSERT INTO `lang_definitions` VALUES (7453, 1068, 5, 'Vervaldatum');
INSERT INTO `lang_definitions` VALUES (7454, 1069, 5, 'Verloopt');
INSERT INTO `lang_definitions` VALUES (7455, 1070, 5, 'Exporteren');
INSERT INTO `lang_definitions` VALUES (7456, 1071, 5, 'Exporteren als CSV');
INSERT INTO `lang_definitions` VALUES (7457, 1072, 5, 'Configuratie exporteren');
INSERT INTO `lang_definitions` VALUES (7458, 1073, 5, 'Exporteer patientpersoonsgegevens');
INSERT INTO `lang_definitions` VALUES (7459, 1074, 5, 'Exporteer geselecteerde als CSV');
INSERT INTO `lang_definitions` VALUES (7460, 1075, 5, 'Exporteer geselecteerde naar Verzamelingen');
INSERT INTO `lang_definitions` VALUES (7461, 1076, 5, 'Exporteren naar CSV');
INSERT INTO `lang_definitions` VALUES (7462, 1077, 5, 'Exporteren naar extern factureringssysteem');
INSERT INTO `lang_definitions` VALUES (7463, 1078, 5, 'Is in buitenland geweest');
INSERT INTO `lang_definitions` VALUES (7464, 1079, 5, 'Komt recent uit buitenland');
INSERT INTO `lang_definitions` VALUES (7465, 1080, 5, 'Uitwendig');
INSERT INTO `lang_definitions` VALUES (7466, 1081, 5, 'Extern-ID');
INSERT INTO `lang_definitions` VALUES (7467, 1082, 5, 'Extern-ID');
INSERT INTO `lang_definitions` VALUES (7468, 1083, 5, 'Alleen uitwendig');
INSERT INTO `lang_definitions` VALUES (7469, 1084, 5, 'Verwijzing naar elders');
INSERT INTO `lang_definitions` VALUES (7470, 1085, 5, 'Verwijzing naar leders Follow-ups');
INSERT INTO `lang_definitions` VALUES (7471, 1086, 5, 'Verwijzing naar elders?');
INSERT INTO `lang_definitions` VALUES (7472, 1087, 5, 'Externe verwijzingen');
INSERT INTO `lang_definitions` VALUES (7473, 1088, 5, 'Exudaat:');
INSERT INTO `lang_definitions` VALUES (7474, 1089, 5, 'Oogirritatie');
INSERT INTO `lang_definitions` VALUES (7475, 1090, 5, 'Oogpijn');
INSERT INTO `lang_definitions` VALUES (7476, 1091, 5, 'Roodheid oog');
INSERT INTO `lang_definitions` VALUES (7477, 1092, 5, 'Ogen');
INSERT INTO `lang_definitions` VALUES (7478, 1093, 5, 'F');
INSERT INTO `lang_definitions` VALUES (7479, 1094, 5, 'FH Bloedproblemen');
INSERT INTO `lang_definitions` VALUES (7480, 1095, 5, 'FH Vrouw Hirsutisme/Striea');
INSERT INTO `lang_definitions` VALUES (7481, 1096, 5, 'Locaties');
INSERT INTO `lang_definitions` VALUES (7482, 1097, 5, 'Locatie');
INSERT INTO `lang_definitions` VALUES (7483, 1098, 5, 'locatie');
INSERT INTO `lang_definitions` VALUES (7484, 1099, 5, 'Administratie locatie');
INSERT INTO `lang_definitions` VALUES (7485, 1100, 5, 'Lokatie-Code');
INSERT INTO `lang_definitions` VALUES (7486, 1101, 5, 'Registr.# van Locatie');
INSERT INTO `lang_definitions` VALUES (7487, 1102, 5, 'Locatie:');
INSERT INTO `lang_definitions` VALUES (7488, 1103, 5, 'Mislukt');
INSERT INTO `lang_definitions` VALUES (7489, 1105, 5, 'Mislukking');
INSERT INTO `lang_definitions` VALUES (7490, 1106, 5, 'Familiegeschiedenis');
INSERT INTO `lang_definitions` VALUES (7491, 1107, 5, 'Familiegeschiedenis van Glaucoom');
INSERT INTO `lang_definitions` VALUES (7492, 1108, 5, 'Familiegeschiedenis:');
INSERT INTO `lang_definitions` VALUES (7493, 1109, 5, 'Familiegrootte');
INSERT INTO `lang_definitions` VALUES (7494, 1110, 5, 'Fancy');
INSERT INTO `lang_definitions` VALUES (7495, 1111, 5, 'Vader');
INSERT INTO `lang_definitions` VALUES (7496, 1112, 5, 'Vermoeidheid');
INSERT INTO `lang_definitions` VALUES (7497, 1113, 5, 'Vermoeid');
INSERT INTO `lang_definitions` VALUES (7498, 1114, 5, 'Fax');
INSERT INTO `lang_definitions` VALUES (7499, 1115, 5, 'Faxnummer');
INSERT INTO `lang_definitions` VALUES (7500, 1116, 5, 'Fax/Scan');
INSERT INTO `lang_definitions` VALUES (7501, 1117, 5, 'Fax ingekomen');
INSERT INTO `lang_definitions` VALUES (7502, 1118, 5, 'Fax uitgegaan');
INSERT INTO `lang_definitions` VALUES (7503, 1119, 5, 'Februari');
INSERT INTO `lang_definitions` VALUES (7504, 1120, 5, 'FECA');
INSERT INTO `lang_definitions` VALUES (7505, 1121, 5, 'Medicijn ID-nummer overheid');
INSERT INTO `lang_definitions` VALUES (7506, 1122, 5, 'Federale EIN');
INSERT INTO `lang_definitions` VALUES (7507, 1123, 5, 'CRIB nummer');
INSERT INTO `lang_definitions` VALUES (7508, 1124, 5, 'Tarief');
INSERT INTO `lang_definitions` VALUES (7509, 1125, 5, 'tarief');
INSERT INTO `lang_definitions` VALUES (7510, 1126, 5, 'Kan niet in rekening gebracht worden');
INSERT INTO `lang_definitions` VALUES (7511, 1127, 5, 'Tarieven werkblad');
INSERT INTO `lang_definitions` VALUES (7512, 1128, 5, 'Optie voor Honorarium formulier');
INSERT INTO `lang_definitions` VALUES (7513, 1129, 5, 'Tarieven');
INSERT INTO `lang_definitions` VALUES (7514, 1130, 5, 'Vrouw');
INSERT INTO `lang_definitions` VALUES (7515, 1131, 5, 'Vrouw AP');
INSERT INTO `lang_definitions` VALUES (7516, 1132, 5, 'Vrouwencondoom');
INSERT INTO `lang_definitions` VALUES (7517, 1133, 5, 'Vrouw G');
INSERT INTO `lang_definitions` VALUES (7518, 1134, 5, 'Vrouw LC');
INSERT INTO `lang_definitions` VALUES (7519, 1135, 5, 'Vrouw P');
INSERT INTO `lang_definitions` VALUES (7520, 1136, 5, 'Symptomen vrouw');
INSERT INTO `lang_definitions` VALUES (7521, 1137, 5, 'Vrouw VSC');
INSERT INTO `lang_definitions` VALUES (7522, 1138, 5, 'Koorts');
INSERT INTO `lang_definitions` VALUES (7523, 1139, 5, 'Koorts:');
INSERT INTO `lang_definitions` VALUES (7524, 1140, 5, 'FH Bloedproblemen');
INSERT INTO `lang_definitions` VALUES (7525, 1141, 5, 'Fibroiden');
INSERT INTO `lang_definitions` VALUES (7526, 1142, 5, 'Bestand');
INSERT INTO `lang_definitions` VALUES (7527, 1143, 5, 'Archiefruimte');
INSERT INTO `lang_definitions` VALUES (7528, 1144, 5, 'File om te uploaden');
INSERT INTO `lang_definitions` VALUES (7529, 1145, 5, 'Bestand met dezelfde naam bestaat reeds op locatie:');
INSERT INTO `lang_definitions` VALUES (7530, 1146, 5, 'Bestandsnaam');
INSERT INTO `lang_definitions` VALUES (7531, 1147, 5, 'Dit alleen invullen als de patient een e-mail bericht krijgt');
INSERT INTO `lang_definitions` VALUES (7532, 1148, 5, 'Filter');
INSERT INTO `lang_definitions` VALUES (7533, 1149, 5, 'Filter voor Constanten');
INSERT INTO `lang_definitions` VALUES (7534, 1150, 5, 'Filters');
INSERT INTO `lang_definitions` VALUES (7535, 1151, 5, 'Einddiagnose');
INSERT INTO `lang_definitions` VALUES (7536, 1152, 5, 'Einddiagnose volgens specialist');
INSERT INTO `lang_definitions` VALUES (7537, 1153, 5, 'Financieel');
INSERT INTO `lang_definitions` VALUES (7538, 1154, 5, 'Financieel overzicht - alles');
INSERT INTO `lang_definitions` VALUES (7539, 1155, 5, 'Financieel overzicht - mijn contacten');
INSERT INTO `lang_definitions` VALUES (7540, 1156, 5, 'Datum financiele aanpassingen');
INSERT INTO `lang_definitions` VALUES (7541, 1157, 5, 'Zoek');
INSERT INTO `lang_definitions` VALUES (7542, 1158, 5, 'Zoek beschikbare ');
INSERT INTO `lang_definitions` VALUES (7543, 1159, 5, 'Zoek beschikbare afspraaktijden');
INSERT INTO `lang_definitions` VALUES (7544, 1160, 5, 'Zoek pt');
INSERT INTO `lang_definitions` VALUES (7545, 1161, 5, 'Evaluatie');
INSERT INTO `lang_definitions` VALUES (7546, 1162, 5, 'Evaluatie gegevens specialist');
INSERT INTO `lang_definitions` VALUES (7547, 1163, 5, 'Boete');
INSERT INTO `lang_definitions` VALUES (7548, 1164, 5, 'Eerste');
INSERT INTO `lang_definitions` VALUES (7549, 1165, 5, 'Eerste weekdag');
INSERT INTO `lang_definitions` VALUES (7550, 1166, 5, 'Voornaam');
INSERT INTO `lang_definitions` VALUES (7551, 1167, 5, 'Voornaam');
INSERT INTO `lang_definitions` VALUES (7552, 1168, 5, 'Voornaam:');
INSERT INTO `lang_definitions` VALUES (7553, 1169, 5, 'Recreatie Sporten');
INSERT INTO `lang_definitions` VALUES (7554, 1170, 5, 'Gezond om te spelen');
INSERT INTO `lang_definitions` VALUES (7555, 1171, 5, 'Herstel contactdatums- maak een keuze');
INSERT INTO `lang_definitions` VALUES (7556, 1172, 5, 'Herstellen');
INSERT INTO `lang_definitions` VALUES (7557, 1173, 5, 'Flatulentie');
INSERT INTO `lang_definitions` VALUES (7558, 1174, 5, 'Stroom');
INSERT INTO `lang_definitions` VALUES (7559, 1175, 5, 'Griepprik');
INSERT INTO `lang_definitions` VALUES (7560, 1176, 5, 'Probleem met vloeistof en electrolyten');
INSERT INTO `lang_definitions` VALUES (7561, 1177, 5, 'FMS');
INSERT INTO `lang_definitions` VALUES (7562, 1178, 5, 'Handmatig controleren');
INSERT INTO `lang_definitions` VALUES (7563, 1179, 5, 'Voedselallergie');
INSERT INTO `lang_definitions` VALUES (7564, 1180, 5, 'Voet ');
INSERT INTO `lang_definitions` VALUES (7565, 1181, 5, 'Voetproblemen');
INSERT INTO `lang_definitions` VALUES (7566, 1182, 5, 'Voet:');
INSERT INTO `lang_definitions` VALUES (7567, 1183, 5, 'Voetbalblessure');
INSERT INTO `lang_definitions` VALUES (7568, 1184, 5, 'Voetbalblessure rapport ');
INSERT INTO `lang_definitions` VALUES (7569, 1185, 5, 'Soort schoeisel');
INSERT INTO `lang_definitions` VALUES (7570, 1186, 5, 'voor');
INSERT INTO `lang_definitions` VALUES (7571, 1189, 5, 'voor:');
INSERT INTO `lang_definitions` VALUES (7572, 1190, 5, 'Onderarm');
INSERT INTO `lang_definitions` VALUES (7573, 1191, 5, 'Formulier');
INSERT INTO `lang_definitions` VALUES (7574, 1192, 5, 'formulier');
INSERT INTO `lang_definitions` VALUES (7575, 1193, 5, 'formaat');
INSERT INTO `lang_definitions` VALUES (7576, 1194, 5, 'Vormgeving');
INSERT INTO `lang_definitions` VALUES (7577, 1195, 5, 'Formaat ongeschikt voor Med Code');
INSERT INTO `lang_definitions` VALUES (7578, 1196, 5, 'Formulieren');
INSERT INTO `lang_definitions` VALUES (7579, 1197, 5, 'Administratie van formulieren');
INSERT INTO `lang_definitions` VALUES (7580, 1198, 5, 'Stuur pagina\'s door met Fax');
INSERT INTO `lang_definitions` VALUES (7581, 1199, 5, '4e');
INSERT INTO `lang_definitions` VALUES (7582, 1200, 5, 'Fractuur');
INSERT INTO `lang_definitions` VALUES (7583, 1201, 5, 'Fractuur thv Naviculare');
INSERT INTO `lang_definitions` VALUES (7584, 1202, 5, 'Fractuur malleolus lat.');
INSERT INTO `lang_definitions` VALUES (7585, 1203, 5, 'Fractuur malleolus med.');
INSERT INTO `lang_definitions` VALUES (7586, 1204, 5, 'Fractuur basis metatarsale 5');
INSERT INTO `lang_definitions` VALUES (7587, 1205, 5, 'Frans');
INSERT INTO `lang_definitions` VALUES (7588, 1206, 5, 'Frequentie');
INSERT INTO `lang_definitions` VALUES (7589, 1207, 5, 'Frequentie verkoudheid');
INSERT INTO `lang_definitions` VALUES (7590, 1208, 5, 'Frequente ziekte');
INSERT INTO `lang_definitions` VALUES (7591, 1209, 5, 'Vrij');
INSERT INTO `lang_definitions` VALUES (7592, 1210, 5, 'Vrijdag');
INSERT INTO `lang_definitions` VALUES (7593, 1211, 5, 'Van');
INSERT INTO `lang_definitions` VALUES (7594, 1212, 5, 'VAN');
INSERT INTO `lang_definitions` VALUES (7595, 1213, 5, 'Van:');
INSERT INTO `lang_definitions` VALUES (7596, 1214, 5, 'Van:');
INSERT INTO `lang_definitions` VALUES (7597, 1215, 5, 'VAN_STAD');
INSERT INTO `lang_definitions` VALUES (7598, 1216, 5, 'VAN_VNAAM');
INSERT INTO `lang_definitions` VALUES (7599, 1217, 5, 'VAN_ANAAM');
INSERT INTO `lang_definitions` VALUES (7600, 1218, 5, 'VAN_MNAAM');
INSERT INTO `lang_definitions` VALUES (7601, 1219, 5, 'VAN_MOBIELTEL');
INSERT INTO `lang_definitions` VALUES (7602, 1220, 5, 'VAN_POSTCODE');
INSERT INTO `lang_definitions` VALUES (7603, 1221, 5, 'VAN_STAAT');
INSERT INTO `lang_definitions` VALUES (7604, 1222, 5, 'VAN_STRAAT');
INSERT INTO `lang_definitions` VALUES (7605, 1223, 5, 'VAN_TITEL');
INSERT INTO `lang_definitions` VALUES (7606, 1224, 5, 'VAN_VALEDICTORY');
INSERT INTO `lang_definitions` VALUES (7607, 1225, 5, 'Balie');
INSERT INTO `lang_definitions` VALUES (7608, 1226, 5, 'Front Office kwitantie');
INSERT INTO `lang_definitions` VALUES (7609, 1227, 5, 'Samenvatting Baliekwitanties');
INSERT INTO `lang_definitions` VALUES (7610, 1228, 5, 'Kwitantie Balie');
INSERT INTO `lang_definitions` VALUES (7611, 1229, 5, 'Frontaal rechts');
INSERT INTO `lang_definitions` VALUES (7612, 1230, 5, 'Volledige naam');
INSERT INTO `lang_definitions` VALUES (7613, 1231, 5, 'Volledige spelen');
INSERT INTO `lang_definitions` VALUES (7614, 1232, 5, 'Volledige training');
INSERT INTO `lang_definitions` VALUES (7615, 1233, 5, 'G');
INSERT INTO `lang_definitions` VALUES (7616, 1234, 5, 'Galblaasconditie');
INSERT INTO `lang_definitions` VALUES (7617, 1235, 5, 'Galstenen');
INSERT INTO `lang_definitions` VALUES (7618, 1236, 5, 'Wedstrijdduur');
INSERT INTO `lang_definitions` VALUES (7619, 1237, 5, 'Spellen');
INSERT INTO `lang_definitions` VALUES (7620, 1238, 5, 'Spelen/Gebeurtenissen');
INSERT INTO `lang_definitions` VALUES (7621, 1239, 5, 'Spelen/Gemiste gebeurtenissen');
INSERT INTO `lang_definitions` VALUES (7622, 1240, 5, 'Gastritis');
INSERT INTO `lang_definitions` VALUES (7623, 1241, 5, 'Maagpijn');
INSERT INTO `lang_definitions` VALUES (7624, 1242, 5, 'Gastro-Intestinaal');
INSERT INTO `lang_definitions` VALUES (7625, 1243, 5, 'GCAC Statistiek verslag');
INSERT INTO `lang_definitions` VALUES (7626, 1244, 5, 'GCAC bezoek formulier afwezig');
INSERT INTO `lang_definitions` VALUES (7627, 1245, 5, 'Geslacht');
INSERT INTO `lang_definitions` VALUES (7628, 1246, 5, 'Geslacht');
INSERT INTO `lang_definitions` VALUES (7629, 1247, 5, 'Algemeen');
INSERT INTO `lang_definitions` VALUES (7630, 1248, 5, 'Categorie voor Algemene Service');
INSERT INTO `lang_definitions` VALUES (7631, 1249, 5, 'Schriftelijk Claimformulier HCFA 1500 aanmaken en downloaden');
INSERT INTO `lang_definitions` VALUES (7632, 1250, 5, 'Aanmaken en downloaden X12 batch');
INSERT INTO `lang_definitions` VALUES (7633, 1253, 5, 'HCFA aanmaken');
INSERT INTO `lang_definitions` VALUES (7634, 1254, 5, 'Brief aanmaken');
INSERT INTO `lang_definitions` VALUES (7635, 1255, 5, 'Maak brief aangaande');
INSERT INTO `lang_definitions` VALUES (7636, 1256, 5, 'Rapport aanmaken');
INSERT INTO `lang_definitions` VALUES (7637, 1257, 5, 'X12 aanmaken');
INSERT INTO `lang_definitions` VALUES (7638, 1259, 5, 'Aangemaakt op');
INSERT INTO `lang_definitions` VALUES (7639, 1260, 5, 'Genereert');
INSERT INTO `lang_definitions` VALUES (7640, 1261, 5, 'Genito-Urinair');
INSERT INTO `lang_definitions` VALUES (7641, 1262, 5, 'Duits');
INSERT INTO `lang_definitions` VALUES (7642, 1263, 5, 'Glaucoom');
INSERT INTO `lang_definitions` VALUES (7643, 1264, 5, 'Familiegeschiedenis van Glaucoom');
INSERT INTO `lang_definitions` VALUES (7644, 1265, 5, 'Globaal');
INSERT INTO `lang_definitions` VALUES (7645, 1266, 5, 'Global ID');
INSERT INTO `lang_definitions` VALUES (7646, 1267, 5, 'ga');
INSERT INTO `lang_definitions` VALUES (7647, 1268, 5, 'Ga');
INSERT INTO `lang_definitions` VALUES (7648, 1269, 5, 'Ga naar');
INSERT INTO `lang_definitions` VALUES (7649, 1270, 5, 'Ga naar de week van');
INSERT INTO `lang_definitions` VALUES (7650, 1271, 5, 'Graad:');
INSERT INTO `lang_definitions` VALUES (7651, 1272, 5, 'gram');
INSERT INTO `lang_definitions` VALUES (7652, 1273, 5, 'Totaal van alles');
INSERT INTO `lang_definitions` VALUES (7653, 1274, 5, 'Totalen van alles');
INSERT INTO `lang_definitions` VALUES (7654, 1275, 5, 'Grieks');
INSERT INTO `lang_definitions` VALUES (7655, 1276, 5, 'Groep');
INSERT INTO `lang_definitions` VALUES (7656, 1277, 5, 'Groepsnaam');
INSERT INTO `lang_definitions` VALUES (7657, 1278, 5, 'Groepsnamen kunnen niet blanco zijn');
INSERT INTO `lang_definitions` VALUES (7658, 1279, 5, 'Groepsnamen kunnen niet met nummers of spaties beginnen');
INSERT INTO `lang_definitions` VALUES (7659, 1280, 5, 'Groepsnamen mogen niet met cijfers beginnen.');
INSERT INTO `lang_definitions` VALUES (7660, 1281, 5, 'Groepsnummer');
INSERT INTO `lang_definitions` VALUES (7661, 1282, 5, 'Groep:');
INSERT INTO `lang_definitions` VALUES (7662, 1283, 5, 'Groepsnaam');
INSERT INTO `lang_definitions` VALUES (7663, 1284, 5, 'Groeps- en toegangscontroles');
INSERT INTO `lang_definitions` VALUES (7664, 1285, 5, 'Groei Curves');
INSERT INTO `lang_definitions` VALUES (7665, 1286, 5, 'Groei Curves');
INSERT INTO `lang_definitions` VALUES (7666, 1287, 5, 'druppels');
INSERT INTO `lang_definitions` VALUES (7667, 1288, 5, 'Gynaecologisch onderzoek');
INSERT INTO `lang_definitions` VALUES (7668, 1289, 5, 'h');
INSERT INTO `lang_definitions` VALUES (7669, 1290, 5, 'h.s.');
INSERT INTO `lang_definitions` VALUES (7670, 1291, 5, 'HO Hepatitis');
INSERT INTO `lang_definitions` VALUES (7671, 1292, 5, 'Succesvol verwijderd. De eventueel aanwezige subcategorieen zijn verplaatst naar onderen');
INSERT INTO `lang_definitions` VALUES (7672, 1293, 5, 'Hematoom/kneuzing');
INSERT INTO `lang_definitions` VALUES (7673, 1294, 5, 'HAI status');
INSERT INTO `lang_definitions` VALUES (7674, 1295, 5, 'Hand en vingers');
INSERT INTO `lang_definitions` VALUES (7675, 1296, 5, 'Problemen van de hand');
INSERT INTO `lang_definitions` VALUES (7676, 1297, 5, 'Tegenslag met/zonder');
INSERT INTO `lang_definitions` VALUES (7677, 1298, 5, 'is gekoppeld aan visite');
INSERT INTO `lang_definitions` VALUES (7678, 1299, 5, 'Gevaarlijke activiteiten');
INSERT INTO `lang_definitions` VALUES (7679, 1300, 5, 'Gevaarlijke activiteiten');
INSERT INTO `lang_definitions` VALUES (7680, 1301, 5, 'Linkermarge HCFA in punten');
INSERT INTO `lang_definitions` VALUES (7681, 1302, 5, 'Marges HCFA');
INSERT INTO `lang_definitions` VALUES (7682, 1303, 5, 'Bovenmarge in punten');
INSERT INTO `lang_definitions` VALUES (7683, 1304, 5, 'he PostCalendar');
INSERT INTO `lang_definitions` VALUES (7684, 1305, 5, 'Hoofd');
INSERT INTO `lang_definitions` VALUES (7685, 1306, 5, 'Hoofdomt.');
INSERT INTO `lang_definitions` VALUES (7686, 1307, 5, 'Hoofdomtrek');
INSERT INTO `lang_definitions` VALUES (7687, 1308, 5, 'Hoofdpijn');
INSERT INTO `lang_definitions` VALUES (7688, 1309, 5, 'Hoofdpijnen');
INSERT INTO `lang_definitions` VALUES (7689, 1310, 5, 'Gezondheidscentrum/Kliniek');
INSERT INTO `lang_definitions` VALUES (7690, 1311, 5, 'HMO');
INSERT INTO `lang_definitions` VALUES (7691, 1312, 5, 'HMO midicare risicos');
INSERT INTO `lang_definitions` VALUES (7692, 1313, 5, 'Gehoorverlies');
INSERT INTO `lang_definitions` VALUES (7693, 1314, 5, 'Hartaanval');
INSERT INTO `lang_definitions` VALUES (7694, 1315, 5, 'Hartziekte');
INSERT INTO `lang_definitions` VALUES (7695, 1316, 5, 'Decompensatio Cordis');
INSERT INTO `lang_definitions` VALUES (7696, 1317, 5, 'Hartprobleem');
INSERT INTO `lang_definitions` VALUES (7697, 1318, 5, 'Hartproblemen');
INSERT INTO `lang_definitions` VALUES (7698, 1319, 5, 'Hartchirurgie');
INSERT INTO `lang_definitions` VALUES (7699, 1320, 5, 'Harttransplantatie');
INSERT INTO `lang_definitions` VALUES (7700, 1321, 5, 'HART:');
INSERT INTO `lang_definitions` VALUES (7701, 1322, 5, 'Hartbranden');
INSERT INTO `lang_definitions` VALUES (7702, 1323, 5, 'Warm of koud');
INSERT INTO `lang_definitions` VALUES (7703, 1324, 5, 'Warm of koud');
INSERT INTO `lang_definitions` VALUES (7704, 1325, 5, 'Hebreeuws');
INSERT INTO `lang_definitions` VALUES (7705, 1326, 5, 'HEENT');
INSERT INTO `lang_definitions` VALUES (7706, 1327, 5, 'Lengte');
INSERT INTO `lang_definitions` VALUES (7707, 1328, 5, 'Help');
INSERT INTO `lang_definitions` VALUES (7708, 1329, 5, 'help');
INSERT INTO `lang_definitions` VALUES (7709, 1330, 5, 'Hematemesis');
INSERT INTO `lang_definitions` VALUES (7710, 1331, 5, 'Hematochezia');
INSERT INTO `lang_definitions` VALUES (7711, 1332, 5, 'Hematologisch');
INSERT INTO `lang_definitions` VALUES (7712, 1333, 5, 'Hematurie');
INSERT INTO `lang_definitions` VALUES (7713, 1334, 5, 'Hemoglobine');
INSERT INTO `lang_definitions` VALUES (7714, 1335, 5, 'Hemopton');
INSERT INTO `lang_definitions` VALUES (7715, 1336, 5, 'Hepatitis');
INSERT INTO `lang_definitions` VALUES (7716, 1337, 5, 'Hepatitis A 1');
INSERT INTO `lang_definitions` VALUES (7717, 1338, 5, 'Hepatitis A 2');
INSERT INTO `lang_definitions` VALUES (7718, 1339, 5, 'Hepatitis B 1');
INSERT INTO `lang_definitions` VALUES (7719, 1340, 5, 'Hepatitis B 2');
INSERT INTO `lang_definitions` VALUES (7720, 1341, 5, 'Hepatitis B 3');
INSERT INTO `lang_definitions` VALUES (7721, 1342, 5, 'hier');
INSERT INTO `lang_definitions` VALUES (7722, 1343, 5, 'Hernia herstel');
INSERT INTO `lang_definitions` VALUES (7723, 1344, 5, 'HNP');
INSERT INTO `lang_definitions` VALUES (7724, 1345, 5, 'Herpes');
INSERT INTO `lang_definitions` VALUES (7725, 1346, 5, 'Aarzelend');
INSERT INTO `lang_definitions` VALUES (7726, 1347, 5, 'hallo daar, je bent hier geweest voor');
INSERT INTO `lang_definitions` VALUES (7727, 1348, 5, 'HIB 1');
INSERT INTO `lang_definitions` VALUES (7728, 1349, 5, 'HIB 2');
INSERT INTO `lang_definitions` VALUES (7729, 1350, 5, 'HIB 3');
INSERT INTO `lang_definitions` VALUES (7730, 1351, 5, 'HIB 4');
INSERT INTO `lang_definitions` VALUES (7731, 1352, 5, 'Verborgen');
INSERT INTO `lang_definitions` VALUES (7732, 1353, 5, 'Verborgen gebeurtenis administratie');
INSERT INTO `lang_definitions` VALUES (7733, 1354, 5, 'Verbergen');
INSERT INTO `lang_definitions` VALUES (7734, 1355, 5, 'Verberg details');
INSERT INTO `lang_definitions` VALUES (7735, 1357, 5, 'Hoog');
INSERT INTO `lang_definitions` VALUES (7736, 1358, 5, 'Hoge bloeddruk');
INSERT INTO `lang_definitions` VALUES (7737, 1359, 5, 'Heup en liezen');
INSERT INTO `lang_definitions` VALUES (7738, 1360, 5, 'Heup en liezen');
INSERT INTO `lang_definitions` VALUES (7739, 1361, 5, 'Heupproblemen');
INSERT INTO `lang_definitions` VALUES (7740, 1362, 5, 'Heupvervanging');
INSERT INTO `lang_definitions` VALUES (7741, 1363, 5, 'HIPAA notitie ontvangen');
INSERT INTO `lang_definitions` VALUES (7742, 1364, 5, 'Hirsutisme/Striae');
INSERT INTO `lang_definitions` VALUES (7743, 1365, 5, 'Spaans');
INSERT INTO `lang_definitions` VALUES (7744, 1366, 5, 'Historie');
INSERT INTO `lang_definitions` VALUES (7745, 1367, 5, 'Voorgeschiedenis');
INSERT INTO `lang_definitions` VALUES (7746, 1368, 5, 'Historie van geluid');
INSERT INTO `lang_definitions` VALUES (7747, 1369, 5, 'Historie van hart geluid');
INSERT INTO `lang_definitions` VALUES (7748, 1370, 5, 'HIV');
INSERT INTO `lang_definitions` VALUES (7749, 1371, 5, 'HL7 bekijken');
INSERT INTO `lang_definitions` VALUES (7750, 1372, 5, 'Druk op [Ctrl] voor meerdere keuze\'s of om selectie ongedaan te maken');
INSERT INTO `lang_definitions` VALUES (7751, 1373, 5, 'Druk op Ctrl om meerdere items te selecteren');
INSERT INTO `lang_definitions` VALUES (7752, 1374, 5, 'Druk op Ctrl om meerdere groepen te selecteren');
INSERT INTO `lang_definitions` VALUES (7753, 1375, 5, 'Thuis');
INSERT INTO `lang_definitions` VALUES (7754, 1376, 5, 'Tel. prive');
INSERT INTO `lang_definitions` VALUES (7755, 1377, 5, 'Tel. prive');
INSERT INTO `lang_definitions` VALUES (7756, 1378, 5, 'Dakloos of vergelijkbaar');
INSERT INTO `lang_definitions` VALUES (7757, 1379, 5, 'Dakloos, enz');
INSERT INTO `lang_definitions` VALUES (7758, 1380, 5, 'Dakloos enz.');
INSERT INTO `lang_definitions` VALUES (7759, 1381, 5, 'Uren');
INSERT INTO `lang_definitions` VALUES (7760, 1382, 5, 'Hoe ontstond letsel?');
INSERT INTO `lang_definitions` VALUES (7761, 1383, 5, 'Hoe ontstond letsel?:');
INSERT INTO `lang_definitions` VALUES (7762, 1384, 5, 'Hoeveel maanden wilt u vooruit zoeken voor de lopende gebeurtenissen?');
INSERT INTO `lang_definitions` VALUES (7763, 1385, 5, 'HPI:');
INSERT INTO `lang_definitions` VALUES (7764, 1387, 5, 'HTML');
INSERT INTO `lang_definitions` VALUES (7765, 1388, 5, 'Hyperactief');
INSERT INTO `lang_definitions` VALUES (7766, 1389, 5, 'Hoge bloeddruk');
INSERT INTO `lang_definitions` VALUES (7767, 1390, 5, 'Hyperthyreoidie');
INSERT INTO `lang_definitions` VALUES (7768, 1391, 5, 'Hypothyreoidie');
INSERT INTO `lang_definitions` VALUES (7769, 1392, 5, 'Hysterectomie');
INSERT INTO `lang_definitions` VALUES (7770, 1393, 5, 'I');
INSERT INTO `lang_definitions` VALUES (7771, 1394, 5, 'In deze tijd ben ik bezig.');
INSERT INTO `lang_definitions` VALUES (7772, 1395, 5, 'Ik mag dit niet lezen');
INSERT INTO `lang_definitions` VALUES (7773, 1396, 5, 'REK');
INSERT INTO `lang_definitions` VALUES (7774, 1398, 5, 'ID');
INSERT INTO `lang_definitions` VALUES (7775, 1399, 5, 'ID kan niet Blanco zijn');
INSERT INTO `lang_definitions` VALUES (7776, 1400, 5, 'IDagen');
INSERT INTO `lang_definitions` VALUES (7777, 1401, 5, 'geidentificeerd als');
INSERT INTO `lang_definitions` VALUES (7778, 1402, 5, 'Identifier(een woord)');
INSERT INTO `lang_definitions` VALUES (7779, 1403, 5, 'Als alle gegevens voor alle kolommen volledig zijn voor dit formulier');
INSERT INTO `lang_definitions` VALUES (7780, 1404, 5, 'Als naam, een deel van achternaam of achternaam, voornaam');
INSERT INTO `lang_definitions` VALUES (7781, 1405, 5, 'indien werkloos gebruik Student');
INSERT INTO `lang_definitions` VALUES (7782, 1406, 5, 'Als u heeft gekozen voor het uploaden van elektronisch afdrachten, dan zal het zoekvenster opnieuw zelf met de bijbehorende facturen van de X12-bestand invullen. U klikt op een van deze factuurnummers (zoals hieronder beschreven), indien u eventuele correcties wil maken voordat de afdracht informatie wordt toegepast Voor de toepassing van de wijzigingen, klikt u op het proces ERA File knop aan de onderkant van de pagina. Dit zal een nieuw venster met een gedetailleerd rapport tonen.');
INSERT INTO `lang_definitions` VALUES (7783, 1407, 5, 'Als u een Pay Datum in de zoekresultaten pagina invoert, zal dit voorrang krijgen op de terbeschikkingstelling datum van de betalingen en de aanpassingen die anders uit de X12-bestand worden opgehaald. Dit kan handig zijn voor rapportage doeleinden, als u wilt dat uw inkomsten rapportage gebruik je je posting datum eerder dan de verzekeringsmaatschappij de verwerking datum. Merk op dat dit ook invloed heeft op de data van voorafgaande betalingen en aanpassingen die in het secundaire claims zijn gedaan.');
INSERT INTO `lang_definitions` VALUES (7784, 1408, 5, 'Als u data types wilt wijzigen, of rijen of kolommen wilt toevoegen');
INSERT INTO `lang_definitions` VALUES (7785, 1409, 5, 'Ziekte');
INSERT INTO `lang_definitions` VALUES (7786, 1410, 5, 'IM');
INSERT INTO `lang_definitions` VALUES (7787, 1411, 5, 'Vaccinatie');
INSERT INTO `lang_definitions` VALUES (7788, 1412, 5, 'Lotnummer van vaccinatie');
INSERT INTO `lang_definitions` VALUES (7789, 1413, 5, 'Fabrikant van vaccinatie');
INSERT INTO `lang_definitions` VALUES (7790, 1414, 5, 'Vaccinaties');
INSERT INTO `lang_definitions` VALUES (7791, 1415, 5, 'Vaccineren');
INSERT INTO `lang_definitions` VALUES (7792, 1416, 5, 'Immunologisch');
INSERT INTO `lang_definitions` VALUES (7793, 1417, 5, 'Implantaties');
INSERT INTO `lang_definitions` VALUES (7794, 1418, 5, 'Importeren');
INSERT INTO `lang_definitions` VALUES (7795, 1419, 5, 'Configuratie importeren');
INSERT INTO `lang_definitions` VALUES (7796, 1420, 5, 'Importeer patient');
INSERT INTO `lang_definitions` VALUES (7797, 1421, 5, 'Importeer persoonsgeg. van client');
INSERT INTO `lang_definitions` VALUES (7798, 1422, 5, 'Geimporteerd van accountantrekening');
INSERT INTO `lang_definitions` VALUES (7799, 1423, 5, 'Verbeterd');
INSERT INTO `lang_definitions` VALUES (7800, 1424, 5, 'in');
INSERT INTO `lang_definitions` VALUES (7801, 1425, 5, 'IN');
INSERT INTO `lang_definitions` VALUES (7802, 1426, 5, 'in beide ogen');
INSERT INTO `lang_definitions` VALUES (7803, 1427, 5, 'in linkeroog');
INSERT INTO `lang_definitions` VALUES (7804, 1428, 5, 'in neusgat');
INSERT INTO `lang_definitions` VALUES (7805, 1429, 5, 'Op kantoor');
INSERT INTO `lang_definitions` VALUES (7806, 1430, 5, 'in rechteroog');
INSERT INTO `lang_definitions` VALUES (7807, 1431, 5, 'op voorraad');
INSERT INTO `lang_definitions` VALUES (7808, 1432, 5, 'Inactief');
INSERT INTO `lang_definitions` VALUES (7809, 1433, 5, 'Dagen inactiviteit');
INSERT INTO `lang_definitions` VALUES (7810, 1434, 5, 'Ook de inactieve gebruikers');
INSERT INTO `lang_definitions` VALUES (7811, 1435, 5, 'Ook de ongecategoriseerde');
INSERT INTO `lang_definitions` VALUES (7812, 1436, 5, 'Vitals toevoegen');
INSERT INTO `lang_definitions` VALUES (7813, 1437, 5, 'Data van Vitals toevoegen?');
INSERT INTO `lang_definitions` VALUES (7814, 1438, 5, 'Inkomsten');
INSERT INTO `lang_definitions` VALUES (7815, 1439, 5, 'Onvolledige abortusbehandeling');
INSERT INTO `lang_definitions` VALUES (7816, 1440, 5, 'Incontinentie');
INSERT INTO `lang_definitions` VALUES (7817, 1441, 5, 'Verhoogd:');
INSERT INTO `lang_definitions` VALUES (7818, 1442, 5, 'Vrijwaring Verzekeringen');
INSERT INTO `lang_definitions` VALUES (7819, 1443, 5, 'Onbepaald');
INSERT INTO `lang_definitions` VALUES (7820, 1444, 5, 'Geef aan of dit probleem nu actief is');
INSERT INTO `lang_definitions` VALUES (7821, 1445, 5, 'Rapport armlastige ptn');
INSERT INTO `lang_definitions` VALUES (7822, 1446, 5, 'Minvermogend');
INSERT INTO `lang_definitions` VALUES (7823, 1447, 5, 'Opgewekte abortus');
INSERT INTO `lang_definitions` VALUES (7824, 1448, 5, 'Infectie/Abces');
INSERT INTO `lang_definitions` VALUES (7825, 1449, 5, 'Infecties');
INSERT INTO `lang_definitions` VALUES (7826, 1450, 5, 'Couns.voor Infert');
INSERT INTO `lang_definitions` VALUES (7827, 1451, 5, 'Onvruchtbaar');
INSERT INTO `lang_definitions` VALUES (7828, 1452, 5, 'Influenza 1');
INSERT INTO `lang_definitions` VALUES (7829, 1453, 5, 'Influenza 2');
INSERT INTO `lang_definitions` VALUES (7830, 1454, 5, 'Info');
INSERT INTO `lang_definitions` VALUES (7831, 1455, 5, 'Info test 1');
INSERT INTO `lang_definitions` VALUES (7832, 1456, 5, 'Info test 2');
INSERT INTO `lang_definitions` VALUES (7833, 1457, 5, 'Info test 3');
INSERT INTO `lang_definitions` VALUES (7834, 1458, 5, 'Info test 4');
INSERT INTO `lang_definitions` VALUES (7835, 1459, 5, 'Info test 5');
INSERT INTO `lang_definitions` VALUES (7836, 1460, 5, 'Info test 6');
INSERT INTO `lang_definitions` VALUES (7837, 1461, 5, 'inhalaties');
INSERT INTO `lang_definitions` VALUES (7838, 1462, 5, 'inhilaties');
INSERT INTO `lang_definitions` VALUES (7839, 1463, 5, 'Eerste gebruiker');
INSERT INTO `lang_definitions` VALUES (7840, 1464, 5, 'Injecteerbaar');
INSERT INTO `lang_definitions` VALUES (7841, 1465, 5, 'Gewond vertrokken');
INSERT INTO `lang_definitions` VALUES (7842, 1466, 5, 'Letsel');
INSERT INTO `lang_definitions` VALUES (7843, 1467, 5, 'Schade Mechanisme');
INSERT INTO `lang_definitions` VALUES (7844, 1468, 5, 'Overzicht letsel rapport');
INSERT INTO `lang_definitions` VALUES (7845, 1469, 5, 'Letsel surveillance');
INSERT INTO `lang_definitions` VALUES (7846, 1470, 5, 'Soort ongeval');
INSERT INTO `lang_definitions` VALUES (7847, 1471, 5, 'Invoervelden');
INSERT INTO `lang_definitions` VALUES (7848, 1472, 5, 'Ins aanpassen');
INSERT INTO `lang_definitions` VALUES (7849, 1473, 5, 'Ins bundeling');
INSERT INTO `lang_definitions` VALUES (7850, 1474, 5, 'Ins te veel betaald');
INSERT INTO `lang_definitions` VALUES (7851, 1475, 5, 'Ins restitutie');
INSERT INTO `lang_definitions` VALUES (7852, 1476, 5, 'Ins samenvatting');
INSERT INTO `lang_definitions` VALUES (7853, 1477, 5, 'INS1');
INSERT INTO `lang_definitions` VALUES (7854, 1478, 5, 'INS2');
INSERT INTO `lang_definitions` VALUES (7855, 1479, 5, 'INS3');
INSERT INTO `lang_definitions` VALUES (7856, 1480, 5, 'Invoegen mislukt:');
INSERT INTO `lang_definitions` VALUES (7857, 1481, 5, 'Voeg oude gebeurtenis toe aan tabel');
INSERT INTO `lang_definitions` VALUES (7858, 1482, 5, 'Slapeloosheid');
INSERT INTO `lang_definitions` VALUES (7859, 1483, 5, 'Inspectie');
INSERT INTO `lang_definitions` VALUES (7860, 1484, 5, 'Onstabiliteit/Subluxatie');
INSERT INTO `lang_definitions` VALUES (7861, 1485, 5, 'installeer DB');
INSERT INTO `lang_definitions` VALUES (7862, 1486, 5, 'Geinstrueerd');
INSERT INTO `lang_definitions` VALUES (7863, 1487, 5, 'Instructies:');
INSERT INTO `lang_definitions` VALUES (7864, 1488, 5, 'IDDM');
INSERT INTO `lang_definitions` VALUES (7865, 1489, 5, 'Vezekering');
INSERT INTO `lang_definitions` VALUES (7866, 1490, 5, 'verzekering');
INSERT INTO `lang_definitions` VALUES (7867, 1491, 5, 'Verzekeringsmaatschappijen');
INSERT INTO `lang_definitions` VALUES (7868, 1492, 5, 'Verzekeringsmaatschappij');
INSERT INTO `lang_definitions` VALUES (7869, 1493, 5, 'Verzekeringsmaatschappij zoeken/toevoegen');
INSERT INTO `lang_definitions` VALUES (7870, 1494, 5, 'Verzekeringsgegevens');
INSERT INTO `lang_definitions` VALUES (7871, 1495, 5, 'Verzekering toelevergegevens');
INSERT INTO `lang_definitions` VALUES (7872, 1496, 5, 'Betalende Instantie');
INSERT INTO `lang_definitions` VALUES (7873, 1497, 5, 'Intakegesprek');
INSERT INTO `lang_definitions` VALUES (7874, 1498, 5, 'Intakedatum');
INSERT INTO `lang_definitions` VALUES (7875, 1499, 5, 'Intellectuele achteruitgang');
INSERT INTO `lang_definitions` VALUES (7876, 1500, 5, 'Foutje - er werden geen paginas geselecteerd!');
INSERT INTO `lang_definitions` VALUES (7877, 1501, 5, 'Foutje - geen patient ID ingevoerd!');
INSERT INTO `lang_definitions` VALUES (7878, 1502, 5, 'Foutje- de ge-upload-de file kan niet gelezen worden');
INSERT INTO `lang_definitions` VALUES (7879, 1503, 5, 'Intern foutje');
INSERT INTO `lang_definitions` VALUES (7880, 1504, 5, 'Intern foutje, geen medicatie ID aangegeven!');
INSERT INTO `lang_definitions` VALUES (7881, 1505, 5, 'Foutje - schuld');
INSERT INTO `lang_definitions` VALUES (7882, 1506, 5, 'Foutje - contact \'');
INSERT INTO `lang_definitions` VALUES (7883, 1507, 5, 'Foutje - pid of contact is kwijt.');
INSERT INTO `lang_definitions` VALUES (7884, 1508, 5, 'Inetrn gebruikte ID (pid)');
INSERT INTO `lang_definitions` VALUES (7885, 1509, 5, 'Interne verwijzingen');
INSERT INTO `lang_definitions` VALUES (7886, 1510, 5, 'Internationale Dienst');
INSERT INTO `lang_definitions` VALUES (7887, 1511, 5, 'Tolk');
INSERT INTO `lang_definitions` VALUES (7888, 1512, 5, 'Tolk nodig?');
INSERT INTO `lang_definitions` VALUES (7889, 1513, 5, 'Interstitiele longziekte');
INSERT INTO `lang_definitions` VALUES (7890, 1514, 5, 'Interval');
INSERT INTO `lang_definitions` VALUES (7891, 1515, 5, 'Intolerantie');
INSERT INTO `lang_definitions` VALUES (7892, 1516, 5, 'intramusculair');
INSERT INTO `lang_definitions` VALUES (7893, 1517, 5, 'intraveneus');
INSERT INTO `lang_definitions` VALUES (7894, 1518, 5, 'Introductie');
INSERT INTO `lang_definitions` VALUES (7895, 1519, 5, 'Ongeldige of ontbrekende betaler bron voor code');
INSERT INTO `lang_definitions` VALUES (7896, 1520, 5, 'Ongeldige Service Codes');
INSERT INTO `lang_definitions` VALUES (7897, 1521, 5, 'Ongeldige bron bestemming');
INSERT INTO `lang_definitions` VALUES (7898, 1522, 5, 'InvAmt');
INSERT INTO `lang_definitions` VALUES (7899, 1523, 5, 'Inventaris');
INSERT INTO `lang_definitions` VALUES (7900, 1524, 5, 'Inventaris is niet beschikbaar voor deze bestelling.');
INSERT INTO `lang_definitions` VALUES (7901, 1525, 5, 'Inventarislijst');
INSERT INTO `lang_definitions` VALUES (7902, 1526, 5, 'Rekening');
INSERT INTO `lang_definitions` VALUES (7903, 1527, 5, 'rekening');
INSERT INTO `lang_definitions` VALUES (7904, 1528, 5, 'Datum rekening');
INSERT INTO `lang_definitions` VALUES (7905, 1529, 5, 'Rekening heeft geen datum');
INSERT INTO `lang_definitions` VALUES (7906, 1530, 5, 'Rekening:');
INSERT INTO `lang_definitions` VALUES (7907, 1531, 5, 'IPPF SRH Gegevens voor');
INSERT INTO `lang_definitions` VALUES (7908, 1532, 5, 'IPPF Statistiekenverslag');
INSERT INTO `lang_definitions` VALUES (7909, 1533, 5, 'IPV 1');
INSERT INTO `lang_definitions` VALUES (7910, 1534, 5, 'IPV 2');
INSERT INTO `lang_definitions` VALUES (7911, 1535, 5, 'IPV 3');
INSERT INTO `lang_definitions` VALUES (7912, 1536, 5, 'IPV 4');
INSERT INTO `lang_definitions` VALUES (7913, 1537, 5, 'Onregelmatige hartslag');
INSERT INTO `lang_definitions` VALUES (7914, 1538, 5, 'Geirriteerd');
INSERT INTO `lang_definitions` VALUES (7915, 1539, 5, 'Irritatie');
INSERT INTO `lang_definitions` VALUES (7916, 1540, 5, 'Verplicht veld.');
INSERT INTO `lang_definitions` VALUES (7917, 1541, 5, 'dit is een basis node en kan niet verwijderd worden');
INSERT INTO `lang_definitions` VALUES (7918, 1542, 5, 'is niet geldig (decimale breuken OK).');
INSERT INTO `lang_definitions` VALUES (7919, 1543, 5, 'Werkt PHP in veilige modus?');
INSERT INTO `lang_definitions` VALUES (7920, 1545, 5, 'probleem');
INSERT INTO `lang_definitions` VALUES (7921, 1546, 5, 'Probleem');
INSERT INTO `lang_definitions` VALUES (7922, 1547, 5, 'Problemen');
INSERT INTO `lang_definitions` VALUES (7923, 1548, 5, 'Problemen (Letsel/Medisch/Allergie):');
INSERT INTO `lang_definitions` VALUES (7924, 1549, 5, 'Problemen en Contacten');
INSERT INTO `lang_definitions` VALUES (7925, 1550, 5, 'Problemen en Contacten voor');
INSERT INTO `lang_definitions` VALUES (7926, 1551, 5, 'Niet geautoriseerde problemen');
INSERT INTO `lang_definitions` VALUES (7927, 1552, 5, 'Problemensectie');
INSERT INTO `lang_definitions` VALUES (7928, 1553, 5, 'Item');
INSERT INTO `lang_definitions` VALUES (7929, 1554, 5, 'item');
INSERT INTO `lang_definitions` VALUES (7930, 1555, 5, 'Items laden is mislukt');
INSERT INTO `lang_definitions` VALUES (7931, 1556, 5, 'IUD');
INSERT INTO `lang_definitions` VALUES (7932, 1557, 5, 'IV');
INSERT INTO `lang_definitions` VALUES (7933, 1558, 5, 'Januari');
INSERT INTO `lang_definitions` VALUES (7934, 1559, 5, 'Icterus');
INSERT INTO `lang_definitions` VALUES (7935, 1560, 5, 'Functie-omschrijving');
INSERT INTO `lang_definitions` VALUES (7936, 1561, 5, 'Functie-ID ');
INSERT INTO `lang_definitions` VALUES (7937, 1562, 5, 'Gewricht uit de kom geschoten');
INSERT INTO `lang_definitions` VALUES (7938, 1563, 5, 'Gewrichtspijn');
INSERT INTO `lang_definitions` VALUES (7939, 1564, 5, 'Verstuikt gewricht');
INSERT INTO `lang_definitions` VALUES (7940, 1565, 5, 'Juli');
INSERT INTO `lang_definitions` VALUES (7941, 1566, 5, 'Juni');
INSERT INTO `lang_definitions` VALUES (7942, 1567, 5, 'Net onder de controle-informatie is een blauwe zone waar je in je zoekopdracht parameters kunt invoeren. U kunt zoeken op naam patiënt, kaart nummer, ontmoetings nummer of op datum dienstverlening, of een combinatie hiervan. U kunt ook kiezen of u alle facturen, openstaande facturen of alleen de facturen die verschuldigd zijn (door de patiënt) wilt zien. Klik op de knop ZOEKEN om de opdracht uit te voeren.');
INSERT INTO `lang_definitions` VALUES (7943, 1568, 5, 'Alleen die van mij');
INSERT INTO `lang_definitions` VALUES (7944, 1569, 5, 'Rechtvaardigen');
INSERT INTO `lang_definitions` VALUES (7945, 1570, 5, 'Rechtvaardigen /Opslaan');
INSERT INTO `lang_definitions` VALUES (7946, 1571, 5, 'k, hier is de rest');
INSERT INTO `lang_definitions` VALUES (7947, 1572, 5, 'Sleutelwoorden');
INSERT INTO `lang_definitions` VALUES (7948, 1573, 5, 'kg');
INSERT INTO `lang_definitions` VALUES (7949, 1574, 5, 'kg/m^2');
INSERT INTO `lang_definitions` VALUES (7950, 1575, 5, 'Nierkanker');
INSERT INTO `lang_definitions` VALUES (7951, 1576, 5, 'Nierfalen ');
INSERT INTO `lang_definitions` VALUES (7952, 1577, 5, 'Nierinfectie');
INSERT INTO `lang_definitions` VALUES (7953, 1578, 5, 'Nierstenen');
INSERT INTO `lang_definitions` VALUES (7954, 1579, 5, 'Niertransplantatie');
INSERT INTO `lang_definitions` VALUES (7955, 1580, 5, 'Knie');
INSERT INTO `lang_definitions` VALUES (7956, 1581, 5, 'Knieproblemen');
INSERT INTO `lang_definitions` VALUES (7957, 1582, 5, 'Knievervanging');
INSERT INTO `lang_definitions` VALUES (7958, 1583, 5, 'Lab');
INSERT INTO `lang_definitions` VALUES (7959, 1584, 5, 'Labrapport');
INSERT INTO `lang_definitions` VALUES (7960, 1585, 5, 'Label');
INSERT INTO `lang_definitions` VALUES (7961, 1586, 5, 'Label mag niet leeg zijn');
INSERT INTO `lang_definitions` VALUES (7962, 1587, 5, 'Label Cols');
INSERT INTO `lang_definitions` VALUES (7963, 1588, 5, 'LabelCols met een getal tussen 1 en 999 zijn');
INSERT INTO `lang_definitions` VALUES (7964, 1589, 5, 'Labels');
INSERT INTO `lang_definitions` VALUES (7965, 1590, 5, 'Labs');
INSERT INTO `lang_definitions` VALUES (7966, 1591, 5, 'Scheurwond/huidprobleem');
INSERT INTO `lang_definitions` VALUES (7967, 1592, 5, 'Scheurwond/schaafwond');
INSERT INTO `lang_definitions` VALUES (7968, 1593, 5, 'Spreektaal');
INSERT INTO `lang_definitions` VALUES (7969, 1594, 5, 'Code vd taal');
INSERT INTO `lang_definitions` VALUES (7970, 1595, 5, 'Taaldefinitie toegevoegd');
INSERT INTO `lang_definitions` VALUES (7971, 1596, 5, 'Taalinterface gereedschap');
INSERT INTO `lang_definitions` VALUES (7972, 1597, 5, 'Talenlijst (schrijven,toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (7973, 1598, 5, 'Naam van de taal');
INSERT INTO `lang_definitions` VALUES (7974, 1599, 5, 'Spreektaal');
INSERT INTO `lang_definitions` VALUES (7975, 1600, 5, 'Laatste');
INSERT INTO `lang_definitions` VALUES (7976, 1601, 5, 'Laatste activiteitdatum');
INSERT INTO `lang_definitions` VALUES (7977, 1602, 5, 'Laatste rekeningdatum');
INSERT INTO `lang_definitions` VALUES (7978, 1603, 5, 'Laatste Episode');
INSERT INTO `lang_definitions` VALUES (7979, 1604, 5, 'Achternaam');
INSERT INTO `lang_definitions` VALUES (7980, 1605, 5, 'Achternaam');
INSERT INTO `lang_definitions` VALUES (7981, 1606, 5, 'Achternaam:');
INSERT INTO `lang_definitions` VALUES (7982, 1607, 5, 'Laatst bewaard');
INSERT INTO `lang_definitions` VALUES (7983, 1608, 5, 'Laatste update door');
INSERT INTO `lang_definitions` VALUES (7984, 1609, 5, 'Laatste bezoek');
INSERT INTO `lang_definitions` VALUES (7985, 1610, 5, 'Laat recidief (2-12 mnd)');
INSERT INTO `lang_definitions` VALUES (7986, 1611, 5, 'Laterale malleolus');
INSERT INTO `lang_definitions` VALUES (7987, 1612, 5, 'Laterale malleolus:');
INSERT INTO `lang_definitions` VALUES (7988, 1613, 5, 'lateraal verplaatste PMI:');
INSERT INTO `lang_definitions` VALUES (7989, 1614, 5, 'Gebasserd op Layout');
INSERT INTO `lang_definitions` VALUES (7990, 1615, 5, 'Weergave-editor');
INSERT INTO `lang_definitions` VALUES (7991, 1616, 5, 'Layout groepen');
INSERT INTO `lang_definitions` VALUES (7992, 1617, 5, 'Layout gebaseerde formulieren');
INSERT INTO `lang_definitions` VALUES (7993, 1618, 5, 'Weergave');
INSERT INTO `lang_definitions` VALUES (7994, 1619, 5, 'lb');
INSERT INTO `lang_definitions` VALUES (7995, 1620, 5, 'lbs');
INSERT INTO `lang_definitions` VALUES (7996, 1621, 5, 'LDL');
INSERT INTO `lang_definitions` VALUES (7997, 1622, 5, 'Leeglaten indien nog steeds actief');
INSERT INTO `lang_definitions` VALUES (7998, 1623, 5, 'LEEGLATEN om wachtwoord te behouden');
INSERT INTO `lang_definitions` VALUES (7999, 1624, 5, 'Laat bericht achter bij');
INSERT INTO `lang_definitions` VALUES (8000, 1625, 5, 'Stoppen');
INSERT INTO `lang_definitions` VALUES (8001, 1626, 5, 'Links');
INSERT INTO `lang_definitions` VALUES (8002, 1627, 5, 'Linkeroor');
INSERT INTO `lang_definitions` VALUES (8003, 1628, 5, 'linkeroor');
INSERT INTO `lang_definitions` VALUES (8004, 1629, 5, 'Links:');
INSERT INTO `lang_definitions` VALUES (8005, 1630, 5, 'Links:');
INSERT INTO `lang_definitions` VALUES (8006, 1631, 5, 'Pijn in been/Kramp');
INSERT INTO `lang_definitions` VALUES (8007, 1632, 5, 'Juridisch');
INSERT INTO `lang_definitions` VALUES (8008, 1633, 5, 'Legenda:');
INSERT INTO `lang_definitions` VALUES (8009, 1634, 5, 'Lengte');
INSERT INTO `lang_definitions` VALUES (8010, 1635, 5, 'Minder prive-informatie (schrijven,toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (8011, 1636, 5, 'Brief');
INSERT INTO `lang_definitions` VALUES (8012, 1637, 5, 'Brief aanmaken');
INSERT INTO `lang_definitions` VALUES (8013, 1640, 5, 'Hoeveel spoed');
INSERT INTO `lang_definitions` VALUES (8014, 1641, 5, 'Aansprakelijkheid');
INSERT INTO `lang_definitions` VALUES (8015, 1642, 5, 'Medische aansprakelijkheid');
INSERT INTO `lang_definitions` VALUES (8016, 1643, 5, 'Rijbewijs/ID');
INSERT INTO `lang_definitions` VALUES (8017, 1644, 5, 'Levensstijl');
INSERT INTO `lang_definitions` VALUES (8018, 1645, 5, 'Ligament scheur of verzwikt');
INSERT INTO `lang_definitions` VALUES (8019, 1646, 5, 'Maximaal aantal gebeurtenissen');
INSERT INTO `lang_definitions` VALUES (8020, 1649, 5, 'Lijst');
INSERT INTO `lang_definitions` VALUES (8021, 1650, 5, 'Lijst box');
INSERT INTO `lang_definitions` VALUES (8022, 1651, 5, 'box met lijst');
INSERT INTO `lang_definitions` VALUES (8023, 1652, 5, 'Box met lijst en toevoeg');
INSERT INTO `lang_definitions` VALUES (8024, 1653, 5, 'Box met lijst en toevoeg');
INSERT INTO `lang_definitions` VALUES (8025, 1654, 5, 'Lijsteditor');
INSERT INTO `lang_definitions` VALUES (8026, 1655, 5, 'Groepslijsten');
INSERT INTO `lang_definitions` VALUES (8027, 1656, 5, 'Lijst verzekeringsmaatschappijen');
INSERT INTO `lang_definitions` VALUES (8028, 1657, 5, 'Lijst onderdelen kunnen niet met een nummer beginnen');
INSERT INTO `lang_definitions` VALUES (8029, 1658, 5, 'Lijst onderdelen bevat illegale letterteken(s)');
INSERT INTO `lang_definitions` VALUES (8030, 1659, 5, 'Lijsten tonen');
INSERT INTO `lang_definitions` VALUES (8031, 1660, 5, 'Lijstnaam');
INSERT INTO `lang_definitions` VALUES (8032, 1661, 5, 'Lijstnamen mogen niet met cijfers beginnen');
INSERT INTO `lang_definitions` VALUES (8033, 1662, 5, 'Lijst medicatie');
INSERT INTO `lang_definitions` VALUES (8034, 1663, 5, 'Lijsten');
INSERT INTO `lang_definitions` VALUES (8035, 1664, 5, 'LLL:');
INSERT INTO `lang_definitions` VALUES (8036, 1665, 5, 'LMP');
INSERT INTO `lang_definitions` VALUES (8037, 1666, 5, 'Definities laden');
INSERT INTO `lang_definitions` VALUES (8038, 1667, 5, 'Aan het laden');
INSERT INTO `lang_definitions` VALUES (8039, 1668, 5, 'LOC');
INSERT INTO `lang_definitions` VALUES (8040, 1669, 5, 'Lokaal');
INSERT INTO `lang_definitions` VALUES (8041, 1670, 5, 'Lokaliteit');
INSERT INTO `lang_definitions` VALUES (8042, 1671, 5, 'Locatie:');
INSERT INTO `lang_definitions` VALUES (8043, 1672, 5, 'Locatie niet gespecificeerd');
INSERT INTO `lang_definitions` VALUES (8044, 1673, 5, 'Locatie:');
INSERT INTO `lang_definitions` VALUES (8045, 1675, 5, 'Ingelogd');
INSERT INTO `lang_definitions` VALUES (8046, 1676, 5, 'Huidige gebruiker ');
INSERT INTO `lang_definitions` VALUES (8047, 1677, 5, 'Huidige gebruiker: ');
INSERT INTO `lang_definitions` VALUES (8048, 1678, 5, 'Afgemeld.');
INSERT INTO `lang_definitions` VALUES (8049, 1679, 5, 'Inloggen');
INSERT INTO `lang_definitions` VALUES (8050, 1680, 5, 'Inloggen');
INSERT INTO `lang_definitions` VALUES (8051, 1681, 5, 'Afmelden');
INSERT INTO `lang_definitions` VALUES (8052, 1682, 5, 'Afmelden');
INSERT INTO `lang_definitions` VALUES (8053, 1683, 5, 'Logs');
INSERT INTO `lang_definitions` VALUES (8054, 1684, 5, 'Logviewer');
INSERT INTO `lang_definitions` VALUES (8055, 1685, 5, 'Opzoeken');
INSERT INTO `lang_definitions` VALUES (8056, 1686, 5, 'Perceel');
INSERT INTO `lang_definitions` VALUES (8057, 1687, 5, 'ID ontbreekt voor voorraad');
INSERT INTO `lang_definitions` VALUES (8058, 1688, 5, 'Perc. Nummer');
INSERT INTO `lang_definitions` VALUES (8059, 1689, 5, 'Laag');
INSERT INTO `lang_definitions` VALUES (8060, 1690, 5, 'Onderbeen');
INSERT INTO `lang_definitions` VALUES (8061, 1691, 5, 'Lumbale wervelkolom');
INSERT INTO `lang_definitions` VALUES (8062, 1692, 5, 'LUNCH');
INSERT INTO `lang_definitions` VALUES (8063, 1693, 5, 'Lunch');
INSERT INTO `lang_definitions` VALUES (8064, 1694, 5, 'Longkanker');
INSERT INTO `lang_definitions` VALUES (8065, 1695, 5, 'Longkanker chirurgie');
INSERT INTO `lang_definitions` VALUES (8066, 1696, 5, 'LONGEN:');
INSERT INTO `lang_definitions` VALUES (8067, 1697, 5, 'Longen');
INSERT INTO `lang_definitions` VALUES (8068, 1698, 5, 'Lupus');
INSERT INTO `lang_definitions` VALUES (8069, 1699, 5, 'M');
INSERT INTO `lang_definitions` VALUES (8070, 1700, 5, 'Memb.Association Categorie');
INSERT INTO `lang_definitions` VALUES (8071, 1701, 5, 'Hoofdadres');
INSERT INTO `lang_definitions` VALUES (8072, 1702, 5, 'Wijzig de huidige categorieën.');
INSERT INTO `lang_definitions` VALUES (8073, 1703, 5, 'Verzeker je ervan \"');
INSERT INTO `lang_definitions` VALUES (8074, 1704, 5, 'Malaise:');
INSERT INTO `lang_definitions` VALUES (8075, 1705, 5, 'Man');
INSERT INTO `lang_definitions` VALUES (8076, 1706, 5, 'Condoom voor man');
INSERT INTO `lang_definitions` VALUES (8077, 1707, 5, 'Mannelijk VSC');
INSERT INTO `lang_definitions` VALUES (8078, 1708, 5, 'Mammogram');
INSERT INTO `lang_definitions` VALUES (8079, 1709, 5, 'Basis gegevens');
INSERT INTO `lang_definitions` VALUES (8080, 1710, 5, 'Invoeren met de hand');
INSERT INTO `lang_definitions` VALUES (8081, 1711, 5, 'Fabrikant');
INSERT INTO `lang_definitions` VALUES (8082, 1712, 5, 'Maart');
INSERT INTO `lang_definitions` VALUES (8083, 1713, 5, 'Huwelijkse staat');
INSERT INTO `lang_definitions` VALUES (8084, 1714, 5, 'Aanvinken als in rekening gebracht, maar niet versturen');
INSERT INTO `lang_definitions` VALUES (8085, 1715, 5, 'Aanvinken als geaccepteerd');
INSERT INTO `lang_definitions` VALUES (8086, 1716, 5, 'Aanvinken als geen rekening gestuurd');
INSERT INTO `lang_definitions` VALUES (8087, 1717, 5, 'Aanvinken als geaccepteerd');
INSERT INTO `lang_definitions` VALUES (8088, 1718, 5, 'Getrouwd');
INSERT INTO `lang_definitions` VALUES (8089, 1719, 5, 'Rechts maxillair');
INSERT INTO `lang_definitions` VALUES (8090, 1720, 5, 'Mei');
INSERT INTO `lang_definitions` VALUES (8091, 1721, 5, 'MC');
INSERT INTO `lang_definitions` VALUES (8092, 1722, 5, 'mcg');
INSERT INTO `lang_definitions` VALUES (8093, 1723, 5, 'Mediale malleolus');
INSERT INTO `lang_definitions` VALUES (8094, 1724, 5, 'Medicaid');
INSERT INTO `lang_definitions` VALUES (8095, 1725, 5, 'Medisch');
INSERT INTO `lang_definitions` VALUES (8096, 1726, 5, 'Medische abortus');
INSERT INTO `lang_definitions` VALUES (8097, 1727, 5, 'Medisch probleem');
INSERT INTO `lang_definitions` VALUES (8098, 1728, 5, 'Medische problemen');
INSERT INTO `lang_definitions` VALUES (8099, 1729, 5, 'Medisch dossier');
INSERT INTO `lang_definitions` VALUES (8100, 1730, 5, 'Medisch dossier #');
INSERT INTO `lang_definitions` VALUES (8101, 1731, 5, 'Medische dossiers');
INSERT INTO `lang_definitions` VALUES (8102, 1732, 5, 'Medische voorgesch. (schrijven,toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (8103, 1733, 5, 'Medicare Part B');
INSERT INTO `lang_definitions` VALUES (8104, 1734, 5, 'Medicijn');
INSERT INTO `lang_definitions` VALUES (8105, 1735, 5, 'Medicijnen');
INSERT INTO `lang_definitions` VALUES (8106, 1736, 5, 'Medicijnen:');
INSERT INTO `lang_definitions` VALUES (8107, 1737, 5, 'Medicatie eenheden');
INSERT INTO `lang_definitions` VALUES (8108, 1738, 5, 'Medium');
INSERT INTO `lang_definitions` VALUES (8109, 1739, 5, 'Lid Vereniging Statistiek Verslag');
INSERT INTO `lang_definitions` VALUES (8110, 1740, 5, 'Geheugenproblemen');
INSERT INTO `lang_definitions` VALUES (8111, 1741, 5, 'Mannen');
INSERT INTO `lang_definitions` VALUES (8112, 1742, 5, 'Mannen en vrouwen');
INSERT INTO `lang_definitions` VALUES (8113, 1743, 5, 'Allen voor mannen');
INSERT INTO `lang_definitions` VALUES (8114, 1744, 5, 'Menarche');
INSERT INTO `lang_definitions` VALUES (8115, 1745, 5, 'Menopauze');
INSERT INTO `lang_definitions` VALUES (8116, 1746, 5, 'Menstruatie hoeveelheid(stroom)');
INSERT INTO `lang_definitions` VALUES (8117, 1747, 5, 'Menstruatiecyclus');
INSERT INTO `lang_definitions` VALUES (8118, 1748, 5, 'Geestesziekte');
INSERT INTO `lang_definitions` VALUES (8119, 1749, 5, 'Boodschap');
INSERT INTO `lang_definitions` VALUES (8120, 1750, 5, 'BOODSCHAP:');
INSERT INTO `lang_definitions` VALUES (8121, 1751, 5, 'Methode');
INSERT INTO `lang_definitions` VALUES (8122, 1752, 5, 'Methode van vernietiging');
INSERT INTO `lang_definitions` VALUES (8123, 1753, 5, 'mg');
INSERT INTO `lang_definitions` VALUES (8124, 1754, 5, 'mg/1ml');
INSERT INTO `lang_definitions` VALUES (8125, 1755, 5, 'mg/2ml');
INSERT INTO `lang_definitions` VALUES (8126, 1756, 5, 'mg/3ml');
INSERT INTO `lang_definitions` VALUES (8127, 1757, 5, 'mg/4ml');
INSERT INTO `lang_definitions` VALUES (8128, 1758, 5, 'mg/5ml');
INSERT INTO `lang_definitions` VALUES (8129, 1759, 5, 'Midden');
INSERT INTO `lang_definitions` VALUES (8130, 1760, 5, 'Intialen/tussenvoegsel');
INSERT INTO `lang_definitions` VALUES (8131, 1761, 5, 'Initialen/tussenvoegsel');
INSERT INTO `lang_definitions` VALUES (8132, 1762, 5, 'Migrant of seizoensarbeider?');
INSERT INTO `lang_definitions` VALUES (8133, 1763, 5, 'Migrerend/Seizoensgebonden');
INSERT INTO `lang_definitions` VALUES (8134, 1764, 5, 'Mimetype');
INSERT INTO `lang_definitions` VALUES (8135, 1765, 5, 'min');
INSERT INTO `lang_definitions` VALUES (8136, 1766, 5, 'Distorsie +/- synovitis');
INSERT INTO `lang_definitions` VALUES (8137, 1767, 5, 'minuten');
INSERT INTO `lang_definitions` VALUES (8138, 1768, 5, 'Minuten');
INSERT INTO `lang_definitions` VALUES (8139, 1769, 5, 'Div.');
INSERT INTO `lang_definitions` VALUES (8140, 1770, 5, 'Extra rekening opties');
INSERT INTO `lang_definitions` VALUES (8141, 1771, 5, 'Extra rekening opties voor HCFA-1500');
INSERT INTO `lang_definitions` VALUES (8142, 1772, 5, 'Extra rekening opties HCFA');
INSERT INTO `lang_definitions` VALUES (8143, 1773, 5, 'Diversen');
INSERT INTO `lang_definitions` VALUES (8144, 1774, 5, 'Gemist');
INSERT INTO `lang_definitions` VALUES (8145, 1775, 5, 'Bedrag ontbreekt');
INSERT INTO `lang_definitions` VALUES (8146, 1776, 5, 'PID ontbreekt');
INSERT INTO `lang_definitions` VALUES (8147, 1777, 5, 'De slash na betaler in broncode wordt gemist');
INSERT INTO `lang_definitions` VALUES (8148, 1778, 5, 'Gemengd');
INSERT INTO `lang_definitions` VALUES (8149, 1779, 5, 'ml');
INSERT INTO `lang_definitions` VALUES (8150, 1780, 5, 'mm kwik');
INSERT INTO `lang_definitions` VALUES (8151, 1781, 5, 'MMR 1');
INSERT INTO `lang_definitions` VALUES (8152, 1782, 5, 'MMR 2');
INSERT INTO `lang_definitions` VALUES (8153, 1783, 5, 'Mobiel');
INSERT INTO `lang_definitions` VALUES (8154, 1784, 5, 'Mobiele telefoon');
INSERT INTO `lang_definitions` VALUES (8155, 1785, 5, 'Mod');
INSERT INTO `lang_definitions` VALUES (8156, 1786, 5, 'Aanpassing');
INSERT INTO `lang_definitions` VALUES (8157, 1787, 5, 'Ma');
INSERT INTO `lang_definitions` VALUES (8158, 1788, 5, 'Ma tm vrij');
INSERT INTO `lang_definitions` VALUES (8159, 1789, 5, 'Ma, woe, vrij');
INSERT INTO `lang_definitions` VALUES (8160, 1790, 5, 'Maandag');
INSERT INTO `lang_definitions` VALUES (8161, 1791, 5, 'maand');
INSERT INTO `lang_definitions` VALUES (8162, 1792, 5, 'Maand');
INSERT INTO `lang_definitions` VALUES (8163, 1793, 5, 'Maandoverzicht');
INSERT INTO `lang_definitions` VALUES (8164, 1794, 5, 'Maand(en)');
INSERT INTO `lang_definitions` VALUES (8165, 1795, 5, 'Maandelijks inkomen');
INSERT INTO `lang_definitions` VALUES (8166, 1796, 5, 'Meer dan 100 resultaten gevonden, specificeer uw zoekactie.');
INSERT INTO `lang_definitions` VALUES (8167, 1797, 5, 'Meer dan 50 gevonden, specificeer de zoekactie.');
INSERT INTO `lang_definitions` VALUES (8168, 1798, 5, 'Moeder');
INSERT INTO `lang_definitions` VALUES (8169, 1799, 5, 'Mond');
INSERT INTO `lang_definitions` VALUES (8170, 1800, 5, 'Verplaats');
INSERT INTO `lang_definitions` VALUES (8171, 1801, 5, 'Verplaats document naar categorie:');
INSERT INTO `lang_definitions` VALUES (8172, 1802, 5, 'Naar beneden');
INSERT INTO `lang_definitions` VALUES (8173, 1803, 5, 'Ga naar patient');
INSERT INTO `lang_definitions` VALUES (8174, 1804, 5, 'Ga naar..');
INSERT INTO `lang_definitions` VALUES (8175, 1805, 5, 'Naar boven');
INSERT INTO `lang_definitions` VALUES (8176, 1806, 5, 'Dhr.');
INSERT INTO `lang_definitions` VALUES (8177, 1807, 5, 'Mvr.');
INSERT INTO `lang_definitions` VALUES (8178, 1808, 5, 'Mej.');
INSERT INTO `lang_definitions` VALUES (8179, 1809, 5, 'Meerdere talen hulpprogramma');
INSERT INTO `lang_definitions` VALUES (8180, 1810, 5, 'Diverse plekken');
INSERT INTO `lang_definitions` VALUES (8181, 1811, 5, 'Geruis:');
INSERT INTO `lang_definitions` VALUES (8182, 1812, 5, 'Spierpijn');
INSERT INTO `lang_definitions` VALUES (8183, 1813, 5, 'Spierpijnen');
INSERT INTO `lang_definitions` VALUES (8184, 1814, 5, 'Roodheid spieren');
INSERT INTO `lang_definitions` VALUES (8185, 1815, 5, 'Stijfheid spieren');
INSERT INTO `lang_definitions` VALUES (8186, 1816, 5, 'Spier zwelling');
INSERT INTO `lang_definitions` VALUES (8187, 1817, 5, 'Warme spieren');
INSERT INTO `lang_definitions` VALUES (8188, 1818, 5, 'Spieren');
INSERT INTO `lang_definitions` VALUES (8189, 1819, 5, 'Spierkwetsuur');
INSERT INTO `lang_definitions` VALUES (8190, 1820, 5, 'Musculoskelatair');
INSERT INTO `lang_definitions` VALUES (8191, 1821, 5, 'Afgesproken in samenspraak');
INSERT INTO `lang_definitions` VALUES (8192, 1822, 5, 'MVA');
INSERT INTO `lang_definitions` VALUES (8193, 1823, 5, 'N/A');
INSERT INTO `lang_definitions` VALUES (8194, 1824, 5, 'n/a');
INSERT INTO `lang_definitions` VALUES (8195, 1825, 5, 'Naam');
INSERT INTO `lang_definitions` VALUES (8196, 1826, 5, 'Naam 1');
INSERT INTO `lang_definitions` VALUES (8197, 1827, 5, 'Naam 2');
INSERT INTO `lang_definitions` VALUES (8198, 1828, 5, 'Vaccinatie gegeven door');
INSERT INTO `lang_definitions` VALUES (8199, 1829, 5, 'Naam verzekeringsmaatschappij');
INSERT INTO `lang_definitions` VALUES (8200, 1830, 5, 'Naam behandelaar');
INSERT INTO `lang_definitions` VALUES (8201, 1831, 5, 'Naam vertaling');
INSERT INTO `lang_definitions` VALUES (8202, 1832, 5, 'Naam/Waarde');
INSERT INTO `lang_definitions` VALUES (8203, 1833, 5, 'Naam:');
INSERT INTO `lang_definitions` VALUES (8204, 1834, 5, 'NARES:');
INSERT INTO `lang_definitions` VALUES (8205, 1835, 5, 'NARES: Normaal Rechts');
INSERT INTO `lang_definitions` VALUES (8206, 1836, 5, 'Neusslijmvliezen rose, septum op middenlijn');
INSERT INTO `lang_definitions` VALUES (8207, 1837, 5, 'Nationaliteit');
INSERT INTO `lang_definitions` VALUES (8208, 1838, 5, 'Misselijkheid');
INSERT INTO `lang_definitions` VALUES (8209, 1839, 5, 'Navigatie');
INSERT INTO `lang_definitions` VALUES (8210, 1840, 5, 'Nat.Med.Code');
INSERT INTO `lang_definitions` VALUES (8211, 1841, 5, 'NDC nummer');
INSERT INTO `lang_definitions` VALUES (8212, 1842, 5, 'Nek');
INSERT INTO `lang_definitions` VALUES (8213, 1843, 5, 'Nekproblemen');
INSERT INTO `lang_definitions` VALUES (8214, 1844, 5, 'Nek soepel');
INSERT INTO `lang_definitions` VALUES (8215, 1845, 5, 'Omschrijving moet ingevoerd worden');
INSERT INTO `lang_definitions` VALUES (8216, 1846, 5, 'Waarde voor terugsturen moet nog ingevuld worden');
INSERT INTO `lang_definitions` VALUES (8217, 1847, 5, 'Identificator moet nog ingevuld worden');
INSERT INTO `lang_definitions` VALUES (8218, 1848, 5, 'Titel moet nog ingevoerd worden');
INSERT INTO `lang_definitions` VALUES (8219, 1849, 5, 'Authorisatie verplicht');
INSERT INTO `lang_definitions` VALUES (8220, 1850, 5, 'Behoort bij acoorderen');
INSERT INTO `lang_definitions` VALUES (8221, 1851, 5, 'Moet nog extra in rekening gebracht worden');
INSERT INTO `lang_definitions` VALUES (8222, 1852, 5, 'Zenuw trauma');
INSERT INTO `lang_definitions` VALUES (8223, 1853, 5, 'Zenuwaandoening / zenuwletsel');
INSERT INTO `lang_definitions` VALUES (8224, 1854, 5, 'Zenuwdoofheid');
INSERT INTO `lang_definitions` VALUES (8225, 1855, 5, 'Zenuwzwakte');
INSERT INTO `lang_definitions` VALUES (8226, 1856, 5, 'Neurologisch');
INSERT INTO `lang_definitions` VALUES (8227, 1857, 5, 'Nieuw');
INSERT INTO `lang_definitions` VALUES (8228, 1858, 5, 'Nieuw =>');
INSERT INTO `lang_definitions` VALUES (8229, 1859, 5, 'Nieuw geaccepteerden');
INSERT INTO `lang_definitions` VALUES (8230, 1860, 5, 'Nieuwe allergie');
INSERT INTO `lang_definitions` VALUES (8231, 1861, 5, 'Nieuwe afspraak');
INSERT INTO `lang_definitions` VALUES (8232, 1862, 5, 'Nieuwe categorie');
INSERT INTO `lang_definitions` VALUES (8233, 1863, 5, 'Nieuwe categorie');
INSERT INTO `lang_definitions` VALUES (8234, 1864, 5, 'Nieuwe client');
INSERT INTO `lang_definitions` VALUES (8235, 1865, 5, 'Nieuw consult');
INSERT INTO `lang_definitions` VALUES (8236, 1866, 5, 'Nieuwe definitie set toegevoegd');
INSERT INTO `lang_definitions` VALUES (8237, 1867, 5, 'Nieuw document');
INSERT INTO `lang_definitions` VALUES (8238, 1868, 5, 'Nieuw contact formulier');
INSERT INTO `lang_definitions` VALUES (8239, 1869, 5, 'Nieuw contact niet geautoriseerd');
INSERT INTO `lang_definitions` VALUES (8240, 1870, 5, 'Nieuw contact');
INSERT INTO `lang_definitions` VALUES (8241, 1871, 5, 'Informatie nieuwe locatie');
INSERT INTO `lang_definitions` VALUES (8242, 1872, 5, 'Nieuwe groep');
INSERT INTO `lang_definitions` VALUES (8243, 1873, 5, 'Nieuwe groepsinformatie');
INSERT INTO `lang_definitions` VALUES (8244, 1874, 5, 'Nieuwe limiet voor gebeurtenissen');
INSERT INTO `lang_definitions` VALUES (8245, 1875, 5, 'Nieuwe lijst');
INSERT INTO `lang_definitions` VALUES (8246, 1876, 5, 'Nieuwe patient');
INSERT INTO `lang_definitions` VALUES (8247, 1877, 5, 'Nieuw patientencontact');
INSERT INTO `lang_definitions` VALUES (8248, 1878, 5, 'ID nieuwe patient');
INSERT INTO `lang_definitions` VALUES (8249, 1879, 5, 'Nieuwe pt');
INSERT INTO `lang_definitions` VALUES (8250, 1880, 5, 'Nieuw toevoeging');
INSERT INTO `lang_definitions` VALUES (8251, 1881, 5, 'Nieuwe gebruiker');
INSERT INTO `lang_definitions` VALUES (8252, 1882, 5, 'Nieuw consult');
INSERT INTO `lang_definitions` VALUES (8253, 1883, 5, 'Nieuw/Zoeken');
INSERT INTO `lang_definitions` VALUES (8254, 1884, 5, 'Krant');
INSERT INTO `lang_definitions` VALUES (8255, 1885, 5, 'Volgende ');
INSERT INTO `lang_definitions` VALUES (8256, 1886, 5, 'Volgende dag');
INSERT INTO `lang_definitions` VALUES (8257, 1887, 5, 'Volgende maand');
INSERT INTO `lang_definitions` VALUES (8258, 1888, 5, 'Volgende week');
INSERT INTO `lang_definitions` VALUES (8259, 1889, 5, 'Alias');
INSERT INTO `lang_definitions` VALUES (8260, 1890, 5, 'Nacht zweten');
INSERT INTO `lang_definitions` VALUES (8261, 1891, 5, 'Normale ext genitalien, vag mucose, cervix');
INSERT INTO `lang_definitions` VALUES (8262, 1892, 5, 'NEE');
INSERT INTO `lang_definitions` VALUES (8263, 1893, 5, 'Nee');
INSERT INTO `lang_definitions` VALUES (8264, 1894, 5, 'Geen toegang');
INSERT INTO `lang_definitions` VALUES (8265, 1895, 5, 'Geen adenopathie (2 gebieden nodig)');
INSERT INTO `lang_definitions` VALUES (8266, 1896, 5, 'Adnexa zonder gevoeligheid of massa');
INSERT INTO `lang_definitions` VALUES (8267, 1897, 5, 'Er is momenteel geen factureringssysteem actief');
INSERT INTO `lang_definitions` VALUES (8268, 1898, 5, 'Geen rekeningen gevonden om in OFX Export bij te voegen<br>');
INSERT INTO `lang_definitions` VALUES (8269, 1899, 5, 'Geen code gespecificeerd');
INSERT INTO `lang_definitions` VALUES (8270, 1900, 5, 'Geen diagnose');
INSERT INTO `lang_definitions` VALUES (8271, 1901, 5, 'Geen einddatum');
INSERT INTO `lang_definitions` VALUES (8272, 1902, 5, 'Geen invoer vonden, gebruik het volgende formulier om invoer toe te voegen. ');
INSERT INTO `lang_definitions` VALUES (8273, 1903, 5, 'Geen gebeurtenissen');
INSERT INTO `lang_definitions` VALUES (8274, 1904, 5, 'Er is geen groep geselecteerd');
INSERT INTO `lang_definitions` VALUES (8275, 1905, 5, 'Geen hernia');
INSERT INTO `lang_definitions` VALUES (8276, 1906, 5, 'Geen verzekeringsmaatschappij gevonden');
INSERT INTO `lang_definitions` VALUES (8277, 1907, 5, 'Geen items geselecteerd');
INSERT INTO `lang_definitions` VALUES (8278, 1908, 5, 'Geen massa, gevoelig');
INSERT INTO `lang_definitions` VALUES (8279, 1909, 5, 'Geen notities');
INSERT INTO `lang_definitions` VALUES (8280, 1910, 5, 'Geen organomegaly');
INSERT INTO `lang_definitions` VALUES (8281, 1911, 5, 'Geen vrije plaatsen gevonden voor deze periode');
INSERT INTO `lang_definitions` VALUES (8282, 1912, 5, 'Geen Partners gevonden');
INSERT INTO `lang_definitions` VALUES (8283, 1913, 5, 'Geen perifeer oedeem');
INSERT INTO `lang_definitions` VALUES (8284, 1914, 5, 'Geen apotheken gevonden');
INSERT INTO `lang_definitions` VALUES (8285, 1915, 5, 'Geen recepten gevonden');
INSERT INTO `lang_definitions` VALUES (8286, 1916, 5, 'Geen ziekte of letsel aantoonbaar');
INSERT INTO `lang_definitions` VALUES (8287, 1917, 5, 'Geen behandelaars gevonden');
INSERT INTO `lang_definitions` VALUES (8288, 1918, 5, 'Geen uitslag of abnormale lesies');
INSERT INTO `lang_definitions` VALUES (8289, 1919, 5, 'Geen resultaten gevonden. Breidt uw zoekopdracht uit.');
INSERT INTO `lang_definitions` VALUES (8290, 1920, 5, 'Geen resultaten');
INSERT INTO `lang_definitions` VALUES (8291, 1921, 5, 'Geen resultaten gevonden voor zoekopdracht');
INSERT INTO `lang_definitions` VALUES (8292, 1922, 5, 'Geen resultaten, zoek nogmaals');
INSERT INTO `lang_definitions` VALUES (8293, 1923, 5, 'Geen resultaten, zoek nogmaals');
INSERT INTO `lang_definitions` VALUES (8294, 1924, 5, 'Niet gekomen');
INSERT INTO `lang_definitions` VALUES (8295, 1925, 5, 'Geen sinus gevoeligheid');
INSERT INTO `lang_definitions` VALUES (8296, 1926, 5, 'Geen huidintrekkingen of borstknobbels');
INSERT INTO `lang_definitions` VALUES (8297, 1927, 5, 'Gee testiculaire gevoeligheid of knobbeltjes');
INSERT INTO `lang_definitions` VALUES (8298, 1928, 5, 'Geen thrills of heaves');
INSERT INTO `lang_definitions` VALUES (8299, 1929, 5, 'Geen bezoek');
INSERT INTO `lang_definitions` VALUES (8300, 1930, 5, 'Nee, annuleren');
INSERT INTO `lang_definitions` VALUES (8301, 1931, 5, 'Nee:');
INSERT INTO `lang_definitions` VALUES (8302, 1932, 5, 'Nycturie');
INSERT INTO `lang_definitions` VALUES (8303, 1933, 5, 'Geen specifiek letsel');
INSERT INTO `lang_definitions` VALUES (8304, 1934, 5, 'NIDDM');
INSERT INTO `lang_definitions` VALUES (8305, 1935, 5, 'Niet-SRH Medisch');
INSERT INTO `lang_definitions` VALUES (8306, 1936, 5, 'Niet-SRH niet-medisch');
INSERT INTO `lang_definitions` VALUES (8307, 1937, 5, 'Geen');
INSERT INTO `lang_definitions` VALUES (8308, 1938, 5, 'geen');
INSERT INTO `lang_definitions` VALUES (8309, 1939, 5, 'Geen van bovenstaande');
INSERT INTO `lang_definitions` VALUES (8310, 1940, 5, 'NIDDM');
INSERT INTO `lang_definitions` VALUES (8311, 1941, 5, 'Nor');
INSERT INTO `lang_definitions` VALUES (8312, 1942, 5, 'Normaal');
INSERT INTO `lang_definitions` VALUES (8313, 1943, 5, 'Normale BL');
INSERT INTO `lang_definitions` VALUES (8314, 1944, 5, 'Normaal cardiologische examen');
INSERT INTO `lang_definitions` VALUES (8315, 1945, 5, 'Normaal cardiologisch onderzoek');
INSERT INTO `lang_definitions` VALUES (8316, 1946, 5, 'Normaal longonderzoek:');
INSERT INTO `lang_definitions` VALUES (8317, 1947, 5, 'Normaal longonderzoek:');
INSERT INTO `lang_definitions` VALUES (8318, 1948, 5, 'Normaal kantoorbezoek');
INSERT INTO `lang_definitions` VALUES (8319, 1949, 5, 'Normale oropharynx');
INSERT INTO `lang_definitions` VALUES (8320, 1950, 5, 'Normaal rechts');
INSERT INTO `lang_definitions` VALUES (8321, 1951, 5, 'Normaal rechts:');
INSERT INTO `lang_definitions` VALUES (8322, 1952, 5, 'Normale weergave');
INSERT INTO `lang_definitions` VALUES (8323, 1953, 5, 'normaal:');
INSERT INTO `lang_definitions` VALUES (8324, 1954, 5, 'Noors');
INSERT INTO `lang_definitions` VALUES (8325, 1955, 5, 'Neus');
INSERT INTO `lang_definitions` VALUES (8326, 1956, 5, 'Bloedneus');
INSERT INTO `lang_definitions` VALUES (8327, 1957, 5, 'Niet alle velden zijn noodzakelijk voor code of code type');
INSERT INTO `lang_definitions` VALUES (8328, 1958, 5, 'Niet toegestaan');
INSERT INTO `lang_definitions` VALUES (8329, 1959, 5, 'Niet toegestaan om administratiegroepen te verwijderen');
INSERT INTO `lang_definitions` VALUES (8330, 1960, 5, 'Niet toegestaan om alle veiligheidsmaatregels te inactiveren');
INSERT INTO `lang_definitions` VALUES (8331, 1961, 5, 'Niet toegestaan om ook maar iets van ACL administrateurs te inactiveren');
INSERT INTO `lang_definitions` VALUES (8332, 1962, 5, 'Niet toegestaan om Gebruiker admin te verwijderen van de administrateursgroep');
INSERT INTO `lang_definitions` VALUES (8333, 1963, 5, 'Geen toegang tot PostCalendar module');
INSERT INTO `lang_definitions` VALUES (8334, 1964, 5, 'Niet geautoriseerd');
INSERT INTO `lang_definitions` VALUES (8335, 1965, 5, 'Niet geautoriseerd voor deze ploeg');
INSERT INTO `lang_definitions` VALUES (8336, 1966, 5, 'Niet beschikbaar');
INSERT INTO `lang_definitions` VALUES (8337, 1967, 5, 'Niet in rekening gebracht');
INSERT INTO `lang_definitions` VALUES (8338, 1968, 5, 'Niet uitgechecked');
INSERT INTO `lang_definitions` VALUES (8339, 1969, 5, 'Niet onderzocht');
INSERT INTO `lang_definitions` VALUES (8340, 1970, 5, 'Niet onderzocht:');
INSERT INTO `lang_definitions` VALUES (8341, 1971, 5, 'Niet onderzocht:');
INSERT INTO `lang_definitions` VALUES (8342, 1972, 5, 'niet gevonden');
INSERT INTO `lang_definitions` VALUES (8343, 1973, 5, 'niet gevonden!');
INSERT INTO `lang_definitions` VALUES (8344, 1974, 5, 'Niet gezien sinds');
INSERT INTO `lang_definitions` VALUES (8345, 1975, 5, 'Notitie');
INSERT INTO `lang_definitions` VALUES (8346, 1976, 5, 'Soort notitie');
INSERT INTO `lang_definitions` VALUES (8347, 1977, 5, 'N.B: Deze code werd niet door een gemachtigde Gebruiker ingevoerd. Alleen geaccepteerde codes mogen naar het Open Medische Facturering Netwerk worden gestuurd voor verwerking. Indien u deze codes wilt uploaden, selecteer dan hier een gemachtigde gebruiker. ');
INSERT INTO `lang_definitions` VALUES (8348, 1978, 5, 'N.B: Geuploade bestanden met dezelfde naam worden automatisch hernoemd. Bijvoorbeeld \'<i>file.jpg</i>\' zal worden\'<i>file.jpg.1</i>\'. Bestandsnamen zijn per patiënt uniek, niet per categorie. ');
INSERT INTO `lang_definitions` VALUES (8349, 1979, 5, 'Notities');
INSERT INTO `lang_definitions` VALUES (8350, 1980, 5, 'Notities - een contact (schrijven, toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (8351, 1981, 5, 'Notities - mijn contacten (schrijven,toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (8352, 1982, 5, 'Notities niet geautoriseerd');
INSERT INTO `lang_definitions` VALUES (8353, 1983, 5, 'Niets geselecteerd');
INSERT INTO `lang_definitions` VALUES (8354, 1984, 5, 'MEDEDELING: PostCalendar Toekennen/Wijziging');
INSERT INTO `lang_definitions` VALUES (8355, 1985, 5, 'Bericht');
INSERT INTO `lang_definitions` VALUES (8356, 1986, 5, 'Informeer Admin over Gebeurtenis Toewijzing/Wijziging? ');
INSERT INTO `lang_definitions` VALUES (8357, 1987, 5, 'November');
INSERT INTO `lang_definitions` VALUES (8358, 1988, 5, 'Nu aanmelden voor: ');
INSERT INTO `lang_definitions` VALUES (8359, 1989, 5, 'Nu afdrukken $stmt_count verklaringen en bijwerken van ontmoetingen.');
INSERT INTO `lang_definitions` VALUES (8360, 1990, 5, 'Printen van $stmt_count verklaringen en bijwerken van facturen.');
INSERT INTO `lang_definitions` VALUES (8361, 1991, 5, 'Printen van $stmt_count verklaringen en bijwerken van overzichten; ontmoetingen zullen niet worden bijgewerkt.');
INSERT INTO `lang_definitions` VALUES (8362, 1992, 5, 'Printen van $stmt_count verklaringen; facturen zullen niet worden bijgewerkt.');
INSERT INTO `lang_definitions` VALUES (8363, 1993, 5, 'BIG');
INSERT INTO `lang_definitions` VALUES (8364, 1994, 5, 'Nr.');
INSERT INTO `lang_definitions` VALUES (8365, 1995, 5, 'Aantal kolommen in jaaroverzicht.');
INSERT INTO `lang_definitions` VALUES (8366, 1996, 5, 'Aantal gemiste spelen of gebeurtenissen, indien van toepassing');
INSERT INTO `lang_definitions` VALUES (8367, 1997, 5, 'Doofheid');
INSERT INTO `lang_definitions` VALUES (8368, 1998, 5, 'O.A.F.V.');
INSERT INTO `lang_definitions` VALUES (8369, 2000, 5, 'Obesitas 1');
INSERT INTO `lang_definitions` VALUES (8370, 2001, 5, 'Obesitas 2');
INSERT INTO `lang_definitions` VALUES (8371, 2002, 5, 'Obesitas 3');
INSERT INTO `lang_definitions` VALUES (8372, 2003, 5, 'Objectief');
INSERT INTO `lang_definitions` VALUES (8373, 2004, 5, 'Beroep');
INSERT INTO `lang_definitions` VALUES (8374, 2005, 5, 'Acuut / Chron / enz.');
INSERT INTO `lang_definitions` VALUES (8375, 2006, 5, 'Oktober');
INSERT INTO `lang_definitions` VALUES (8376, 2007, 5, 'OD');
INSERT INTO `lang_definitions` VALUES (8377, 2008, 5, 'hoeveelheid');
INSERT INTO `lang_definitions` VALUES (8378, 2009, 5, 'tabletten');
INSERT INTO `lang_definitions` VALUES (8379, 2010, 5, 'van de maand ieder');
INSERT INTO `lang_definitions` VALUES (8380, 2011, 5, 'Kant. Notities');
INSERT INTO `lang_definitions` VALUES (8381, 2012, 5, 'Kantoornotities');
INSERT INTO `lang_definitions` VALUES (8382, 2013, 5, 'Kantoorbezoek');
INSERT INTO `lang_definitions` VALUES (8383, 2014, 5, 'Nakomelingen');
INSERT INTO `lang_definitions` VALUES (8384, 2015, 5, 'zalf');
INSERT INTO `lang_definitions` VALUES (8385, 2016, 5, 'OK');
INSERT INTO `lang_definitions` VALUES (8386, 2017, 5, 'OK om de gedateerde GCAC issue te linken');
INSERT INTO `lang_definitions` VALUES (8387, 2018, 5, 'Oude clienten');
INSERT INTO `lang_definitions` VALUES (8388, 2019, 5, 'Oude fractuur geen botverbinding');
INSERT INTO `lang_definitions` VALUES (8389, 2020, 5, 'Interne gebruikers uitsluiten?');
INSERT INTO `lang_definitions` VALUES (8390, 2021, 5, 'Automatisch reg.nummer toekennen');
INSERT INTO `lang_definitions` VALUES (8391, 2022, 5, 'op');
INSERT INTO `lang_definitions` VALUES (8392, 2023, 5, 'In voorraad');
INSERT INTO `lang_definitions` VALUES (8393, 2024, 5, 'In bestelling');
INSERT INTO `lang_definitions` VALUES (8394, 2025, 5, 'Na wijziging wachtwoord opnieuw inloggen');
INSERT INTO `lang_definitions` VALUES (8395, 2026, 5, 'Online ondersteuning');
INSERT INTO `lang_definitions` VALUES (8396, 2027, 5, 'Alleen actieven');
INSERT INTO `lang_definitions` VALUES (8397, 2028, 5, 'alleen indien rekening locatie');
INSERT INTO `lang_definitions` VALUES (8398, 2029, 5, 'Alleen inactieven');
INSERT INTO `lang_definitions` VALUES (8399, 2030, 5, 'Alleen die van mij');
INSERT INTO `lang_definitions` VALUES (8400, 2031, 5, 'Begin ziekte:');
INSERT INTO `lang_definitions` VALUES (8401, 2032, 5, 'Begin ziekte:');
INSERT INTO `lang_definitions` VALUES (8402, 2033, 5, 'Begin zwelling:');
INSERT INTO `lang_definitions` VALUES (8403, 2034, 5, 'Begindatum hospitalisatie:');
INSERT INTO `lang_definitions` VALUES (8404, 2035, 5, 'Open');
INSERT INTO `lang_definitions` VALUES (8405, 2036, 5, 'OpenEMR heeft Javascript nodig voor toegangscontrole. ');
INSERT INTO `lang_definitions` VALUES (8406, 2037, 5, 'OpenEMR gebruikers');
INSERT INTO `lang_definitions` VALUES (8407, 2038, 5, 'Mogelijkheid');
INSERT INTO `lang_definitions` VALUES (8408, 2039, 5, 'Keuze mogelijkheid');
INSERT INTO `lang_definitions` VALUES (8409, 2040, 5, 'Medicatienaam optioneel, gebruik % als wildcard');
INSERT INTO `lang_definitions` VALUES (8410, 2041, 5, 'Mogelijkheid om informatie te geven over gebeurtenis');
INSERT INTO `lang_definitions` VALUES (8411, 2042, 5, 'Lotnummer optioneel, gebruik % als wildcard');
INSERT INTO `lang_definitions` VALUES (8412, 2043, 5, 'Numeriek client ID naar optioneel');
INSERT INTO `lang_definitions` VALUES (8413, 2044, 5, 'Facultatieve procedurecode');
INSERT INTO `lang_definitions` VALUES (8414, 2045, 5, 'of');
INSERT INTO `lang_definitions` VALUES (8415, 2046, 5, 'of kies');
INSERT INTO `lang_definitions` VALUES (8416, 2047, 5, 'of selecteer');
INSERT INTO `lang_definitions` VALUES (8417, 2048, 5, 'Kaart bij:');
INSERT INTO `lang_definitions` VALUES (8418, 2049, 5, 'Of upload ERA dossier:');
INSERT INTO `lang_definitions` VALUES (8419, 2050, 5, 'Oraal');
INSERT INTO `lang_definitions` VALUES (8420, 2051, 5, 'Orale mucosa is roze, keel schoon');
INSERT INTO `lang_definitions` VALUES (8421, 2052, 5, 'Volgorde');
INSERT INTO `lang_definitions` VALUES (8422, 2053, 5, 'Bestelling moet een nummer tussen 1 en 999 zijn');
INSERT INTO `lang_definitions` VALUES (8423, 2054, 5, 'Orgaanletsel');
INSERT INTO `lang_definitions` VALUES (8424, 2055, 5, 'Organisatie');
INSERT INTO `lang_definitions` VALUES (8425, 2056, 5, 'Organisaties');
INSERT INTO `lang_definitions` VALUES (8426, 2057, 5, 'Georiënteerd x 3');
INSERT INTO `lang_definitions` VALUES (8427, 2058, 5, 'Origineel');
INSERT INTO `lang_definitions` VALUES (8428, 2059, 5, 'Orofarynx');
INSERT INTO `lang_definitions` VALUES (8429, 2060, 5, 'Ortopnea');
INSERT INTO `lang_definitions` VALUES (8430, 2061, 5, 'OS');
INSERT INTO `lang_definitions` VALUES (8431, 2062, 5, 'Osteoartritis');
INSERT INTO `lang_definitions` VALUES (8432, 2063, 5, 'Ander');
INSERT INTO `lang_definitions` VALUES (8433, 2064, 5, 'ander');
INSERT INTO `lang_definitions` VALUES (8434, 2065, 5, 'Ander (specificeer)');
INSERT INTO `lang_definitions` VALUES (8435, 2066, 5, 'Onder overheidsprogramma');
INSERT INTO `lang_definitions` VALUES (8436, 2067, 5, 'Andere HCFA');
INSERT INTO `lang_definitions` VALUES (8437, 2068, 5, 'Nadere kwetsuur nergens anders gespecificeerd');
INSERT INTO `lang_definitions` VALUES (8438, 2069, 5, 'andere maand');
INSERT INTO `lang_definitions` VALUES (8439, 2070, 5, 'Ander niet overheidsprogramma');
INSERT INTO `lang_definitions` VALUES (8440, 2071, 5, 'Andere notities');
INSERT INTO `lang_definitions` VALUES (8441, 2072, 5, 'Andere duidelijke symptomen');
INSERT INTO `lang_definitions` VALUES (8442, 2073, 5, 'Andere duidelijke symptomen:');
INSERT INTO `lang_definitions` VALUES (8443, 2074, 5, 'Ander stress/overbelastings letsel');
INSERT INTO `lang_definitions` VALUES (8444, 2075, 5, 'Ander chirurgisch');
INSERT INTO `lang_definitions` VALUES (8445, 2076, 5, 'Ander/Generisch ivm abortus');
INSERT INTO `lang_definitions` VALUES (8446, 2077, 5, 'anders verminkt u de verwijzingen tussen bestaande data');
INSERT INTO `lang_definitions` VALUES (8447, 2078, 5, 'Ottawa enkel reglement');
INSERT INTO `lang_definitions` VALUES (8448, 2079, 5, 'OU');
INSERT INTO `lang_definitions` VALUES (8449, 2080, 5, 'UIT');
INSERT INTO `lang_definitions` VALUES (8450, 2081, 5, 'Kantoor verlaten');
INSERT INTO `lang_definitions` VALUES (8451, 2082, 5, 'Resultaat');
INSERT INTO `lang_definitions` VALUES (8452, 2083, 5, 'Outlook');
INSERT INTO `lang_definitions` VALUES (8453, 2084, 5, 'Overbelast');
INSERT INTO `lang_definitions` VALUES (8454, 2085, 5, 'Overgewicht');
INSERT INTO `lang_definitions` VALUES (8455, 2086, 5, 'Overschrijf HIPAA keuze');
INSERT INTO `lang_definitions` VALUES (8456, 2087, 5, 'Zuurstof saturatie');
INSERT INTO `lang_definitions` VALUES (8457, 2088, 5, 'P');
INSERT INTO `lang_definitions` VALUES (8458, 2089, 5, 'p.c.');
INSERT INTO `lang_definitions` VALUES (8459, 2090, 5, 'p.m.');
INSERT INTO `lang_definitions` VALUES (8460, 2091, 5, 'zo nodig');
INSERT INTO `lang_definitions` VALUES (8461, 2092, 5, 'Pediatrisch');
INSERT INTO `lang_definitions` VALUES (8462, 2093, 5, 'Pagina');
INSERT INTO `lang_definitions` VALUES (8463, 2094, 5, 'Pagina´s');
INSERT INTO `lang_definitions` VALUES (8464, 2095, 5, 'Betaald');
INSERT INTO `lang_definitions` VALUES (8465, 2096, 5, 'Betaald bedrag dat u will plaatsen');
INSERT INTO `lang_definitions` VALUES (8466, 2097, 5, 'Betaald per');
INSERT INTO `lang_definitions` VALUES (8467, 2098, 5, 'Pijn');
INSERT INTO `lang_definitions` VALUES (8468, 2099, 5, 'Palpitatie');
INSERT INTO `lang_definitions` VALUES (8469, 2100, 5, 'PAP smear');
INSERT INTO `lang_definitions` VALUES (8470, 2101, 5, 'Paralyse');
INSERT INTO `lang_definitions` VALUES (8471, 2102, 5, 'Parse HL7');
INSERT INTO `lang_definitions` VALUES (8472, 2103, 5, 'Partner');
INSERT INTO `lang_definitions` VALUES (8473, 2104, 5, 'Wachtwoord');
INSERT INTO `lang_definitions` VALUES (8474, 2105, 5, 'Wachtwoord wijzigen');
INSERT INTO `lang_definitions` VALUES (8475, 2106, 5, 'Wachtwoord wijzigen gelukt.');
INSERT INTO `lang_definitions` VALUES (8476, 2107, 5, 'Wachtwoord voor SMS Toegang');
INSERT INTO `lang_definitions` VALUES (8477, 2108, 5, 'Wachtwoord:');
INSERT INTO `lang_definitions` VALUES (8478, 2109, 5, 'Episode geschiedenis');
INSERT INTO `lang_definitions` VALUES (8479, 2110, 5, 'Episode geschiedenis en Documenten');
INSERT INTO `lang_definitions` VALUES (8480, 2111, 5, 'HL7 data invoegen');
INSERT INTO `lang_definitions` VALUES (8481, 2112, 5, 'Plak de te importeren data in het tekstveld hieronder:');
INSERT INTO `lang_definitions` VALUES (8482, 2113, 5, 'Patch');
INSERT INTO `lang_definitions` VALUES (8483, 2114, 5, 'Patiënt');
INSERT INTO `lang_definitions` VALUES (8484, 2115, 5, 'patient');
INSERT INTO `lang_definitions` VALUES (8485, 2116, 5, 'PATIENT');
INSERT INTO `lang_definitions` VALUES (8486, 2117, 5, 'Allergieen van pt');
INSERT INTO `lang_definitions` VALUES (8487, 2118, 5, 'Allergieen van pt');
INSERT INTO `lang_definitions` VALUES (8488, 2119, 5, 'Afspraak van pt');
INSERT INTO `lang_definitions` VALUES (8489, 2120, 5, 'Patientkaart-ID');
INSERT INTO `lang_definitions` VALUES (8490, 2121, 5, 'Patient vertrokken');
INSERT INTO `lang_definitions` VALUES (8491, 2122, 5, 'Patient vertrokken voor');
INSERT INTO `lang_definitions` VALUES (8492, 2123, 5, 'Patiënt communicatie verzonden');
INSERT INTO `lang_definitions` VALUES (8493, 2124, 5, 'Patiënt Communicatie Verzonden');
INSERT INTO `lang_definitions` VALUES (8494, 2125, 5, 'Data van patient');
INSERT INTO `lang_definitions` VALUES (8495, 2126, 5, 'Document van patient');
INSERT INTO `lang_definitions` VALUES (8496, 2127, 5, 'Patientencontact');
INSERT INTO `lang_definitions` VALUES (8497, 2128, 5, 'Patientencontactformulier');
INSERT INTO `lang_definitions` VALUES (8498, 2129, 5, 'Patiëntencontacten');
INSERT INTO `lang_definitions` VALUES (8499, 2130, 5, 'Patiënt opzoeken');
INSERT INTO `lang_definitions` VALUES (8500, 2131, 5, 'Historie van patient');
INSERT INTO `lang_definitions` VALUES (8501, 2132, 5, 'Historie en leefstijlgegevens pt');
INSERT INTO `lang_definitions` VALUES (8502, 2133, 5, 'Patiënt-ID');
INSERT INTO `lang_definitions` VALUES (8503, 2134, 5, 'Patient-ID');
INSERT INTO `lang_definitions` VALUES (8504, 2135, 5, 'Vaccinatie van patient');
INSERT INTO `lang_definitions` VALUES (8505, 2136, 5, 'Patientinformatie');
INSERT INTO `lang_definitions` VALUES (8506, 2137, 5, 'Patient verdeeld naar verzekering');
INSERT INTO `lang_definitions` VALUES (8507, 2138, 5, 'Rapport patientverdeling per verzekering');
INSERT INTO `lang_definitions` VALUES (8508, 2139, 5, 'Problemen van patient');
INSERT INTO `lang_definitions` VALUES (8509, 2140, 5, 'Patientenoverzicht');
INSERT INTO `lang_definitions` VALUES (8510, 2141, 5, 'Patienten Medische Problemen');
INSERT INTO `lang_definitions` VALUES (8511, 2142, 5, 'Medicatie patient');
INSERT INTO `lang_definitions` VALUES (8512, 2143, 5, 'Naam en adres patient');
INSERT INTO `lang_definitions` VALUES (8513, 2144, 5, 'Soort patientnotitie');
INSERT INTO `lang_definitions` VALUES (8514, 2145, 5, 'Patientnotities');
INSERT INTO `lang_definitions` VALUES (8515, 2146, 5, 'Patientnotities (schrijven en toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (8516, 2147, 5, 'Patientnummer');
INSERT INTO `lang_definitions` VALUES (8517, 2148, 5, 'Afdruk van Pt rapport');
INSERT INTO `lang_definitions` VALUES (8518, 2149, 5, 'Verslag van Patientgegevens');
INSERT INTO `lang_definitions` VALUES (8519, 2150, 5, 'Rapportage over patient');
INSERT INTO `lang_definitions` VALUES (8520, 2151, 5, 'Verzoek van patient');
INSERT INTO `lang_definitions` VALUES (8521, 2152, 5, 'Samenvatting over deze patient');
INSERT INTO `lang_definitions` VALUES (8522, 2153, 5, 'Transacties van patienten');
INSERT INTO `lang_definitions` VALUES (8523, 2154, 5, 'patient(en) die overeenkomen met de demografische gegevens die u invoerdde.');
INSERT INTO `lang_definitions` VALUES (8524, 2155, 5, 'Clienten');
INSERT INTO `lang_definitions` VALUES (8525, 2156, 5, 'Patiënt:');
INSERT INTO `lang_definitions` VALUES (8526, 2157, 5, 'Patienten');
INSERT INTO `lang_definitions` VALUES (8527, 2158, 5, 'Betalen');
INSERT INTO `lang_definitions` VALUES (8528, 2159, 5, 'Let extra op bij de Gedaan met keuzevakjes. Nadat de verzekeringen als compleet zijn gemarkeerd, zullen we aan de patient vragen om het openstaande bedrag te betalen; wanneer u vergeet om alle verzekeringen als compleet te markeren, dan zal het openstaande bedrag niet ontvangen worden!! Als de patient nog een restbedrag moet betalen, stel dan de vervaldatum overeenkomstig in, omdat dit gevolgen heeft voor de taal die op de patient verklaringen komen te staan.');
INSERT INTO `lang_definitions` VALUES (8529, 2160, 5, 'Betalingsdatum');
INSERT INTO `lang_definitions` VALUES (8530, 2161, 5, 'Betaald door');
INSERT INTO `lang_definitions` VALUES (8531, 2162, 5, 'Betaler type');
INSERT INTO `lang_definitions` VALUES (8532, 2163, 5, 'Betalend');
INSERT INTO `lang_definitions` VALUES (8533, 2164, 5, 'Betaling');
INSERT INTO `lang_definitions` VALUES (8534, 2165, 5, 'betaling');
INSERT INTO `lang_definitions` VALUES (8535, 2166, 5, 'Datum betaling');
INSERT INTO `lang_definitions` VALUES (8536, 2167, 5, 'betaling ingevoerd op');
INSERT INTO `lang_definitions` VALUES (8537, 2168, 5, 'Betalingsmethode');
INSERT INTO `lang_definitions` VALUES (8538, 2169, 5, 'Betaling waarde voor code');
INSERT INTO `lang_definitions` VALUES (8539, 2170, 5, 'Betalingen');
INSERT INTO `lang_definitions` VALUES (8540, 2171, 5, 'PDF');
INSERT INTO `lang_definitions` VALUES (8541, 2172, 5, 'Bekken en billen');
INSERT INTO `lang_definitions` VALUES (8542, 2173, 5, 'Pemphigus');
INSERT INTO `lang_definitions` VALUES (8543, 2174, 5, 'Hangende');
INSERT INTO `lang_definitions` VALUES (8544, 2175, 5, 'Hangende het vervolg');
INSERT INTO `lang_definitions` VALUES (8545, 2176, 5, 'Pennington Firm OpenEMR v');
INSERT INTO `lang_definitions` VALUES (8546, 2177, 5, 'Maagzweer/Ulcus Pepticum');
INSERT INTO `lang_definitions` VALUES (8547, 2178, 5, 'per min');
INSERT INTO `lang_definitions` VALUES (8548, 2179, 5, 'Per neusgat');
INSERT INTO `lang_definitions` VALUES (8549, 2180, 5, 'per neusgat');
INSERT INTO `lang_definitions` VALUES (8550, 2181, 5, 'Oraal');
INSERT INTO `lang_definitions` VALUES (8551, 2182, 5, 'oraal');
INSERT INTO `lang_definitions` VALUES (8552, 2183, 5, 'Anaal');
INSERT INTO `lang_definitions` VALUES (8553, 2184, 5, 'anaal');
INSERT INTO `lang_definitions` VALUES (8554, 2185, 5, 'Rechts geperforeerd');
INSERT INTO `lang_definitions` VALUES (8555, 2186, 5, 'Begin zoekactie');
INSERT INTO `lang_definitions` VALUES (8556, 2187, 5, 'Deze actie uitvoeren');
INSERT INTO `lang_definitions` VALUES (8557, 2188, 5, 'Perifeer');
INSERT INTO `lang_definitions` VALUES (8558, 2189, 5, 'Persoon');
INSERT INTO `lang_definitions` VALUES (8559, 2190, 5, 'Apotheken');
INSERT INTO `lang_definitions` VALUES (8560, 2191, 5, 'Apotheek');
INSERT INTO `lang_definitions` VALUES (8561, 2192, 5, 'Apotheek Afd. Receptuur');
INSERT INTO `lang_definitions` VALUES (8562, 2193, 5, 'Pheumothorax');
INSERT INTO `lang_definitions` VALUES (8563, 2194, 5, 'Telefoon');
INSERT INTO `lang_definitions` VALUES (8564, 2195, 5, 'Telefoon oproeplijst');
INSERT INTO `lang_definitions` VALUES (8565, 2196, 5, 'Telefoonnummer');
INSERT INTO `lang_definitions` VALUES (8566, 2197, 5, 'Fotofobie');
INSERT INTO `lang_definitions` VALUES (8567, 2198, 5, 'Via PHP opgezocht');
INSERT INTO `lang_definitions` VALUES (8568, 2199, 5, 'PHP geëxtraheerd');
INSERT INTO `lang_definitions` VALUES (8569, 2200, 5, 'php-GACL toegangscontroles zijn uitgeschakeld');
INSERT INTO `lang_definitions` VALUES (8570, 2201, 5, 'PHP-gacl is niet geïnstalleerd');
INSERT INTO `lang_definitions` VALUES (8571, 2202, 5, 'Fysiek onderzoek');
INSERT INTO `lang_definitions` VALUES (8572, 2203, 5, 'Aanvraag door arts');
INSERT INTO `lang_definitions` VALUES (8573, 2204, 5, 'Handtekening arts');
INSERT INTO `lang_definitions` VALUES (8574, 2205, 5, 'Doktoren');
INSERT INTO `lang_definitions` VALUES (8575, 2206, 5, 'kies');
INSERT INTO `lang_definitions` VALUES (8576, 2207, 5, 'PID');
INSERT INTO `lang_definitions` VALUES (8577, 2208, 5, 'PID (Pelvic Infl. Disease)');
INSERT INTO `lang_definitions` VALUES (8578, 2209, 5, 'Pil grootte');
INSERT INTO `lang_definitions` VALUES (8579, 2210, 5, 'Pillen');
INSERT INTO `lang_definitions` VALUES (8580, 2211, 5, 'Placeholder');
INSERT INTO `lang_definitions` VALUES (8581, 2212, 5, 'Placeholder (vult lege ACLs op)');
INSERT INTO `lang_definitions` VALUES (8582, 2213, 5, 'Vlakke tekst');
INSERT INTO `lang_definitions` VALUES (8583, 2214, 5, 'Plan');
INSERT INTO `lang_definitions` VALUES (8584, 2215, 5, 'Naam plan');
INSERT INTO `lang_definitions` VALUES (8585, 2216, 5, 'Plan:');
INSERT INTO `lang_definitions` VALUES (8586, 2217, 5, 'Speler');
INSERT INTO `lang_definitions` VALUES (8587, 2218, 5, 'Spel positie');
INSERT INTO `lang_definitions` VALUES (8588, 2219, 5, 'Maak a.u.b. een geldige keuze uit de lijst');
INSERT INTO `lang_definitions` VALUES (8589, 2220, 5, 'Kies een valide selectie');
INSERT INTO `lang_definitions` VALUES (8590, 2221, 5, 'Selecteer een waarde voor');
INSERT INTO `lang_definitions` VALUES (8591, 2222, 5, 'Sluit dit venster a.u.b af');
INSERT INTO `lang_definitions` VALUES (8592, 2223, 5, 'Vergelijk a.u.b. de nieuwe naam');
INSERT INTO `lang_definitions` VALUES (8593, 2224, 5, 'Accepteer dit recept a.u.b. niet, tenzij u het heeft ontvangen per fax.');
INSERT INTO `lang_definitions` VALUES (8594, 2225, 5, 'Maak GEEN gebruik van uw browser met de STOP of RELOAD knop terwijl deze pagina actief is, als er meer dan 10 minuten zijn verstreken, zal dit niet tot gevolg hebben dat het proces wordt gestopt op de server en onnodige resources zal gebruiken.');
INSERT INTO `lang_definitions` VALUES (8595, 2226, 5, 'Voer a.u.b. een bedrag in met alleen cijfers en een punt.');
INSERT INTO `lang_definitions` VALUES (8596, 2227, 5, 'Voer a.u.b. een titel in!');
INSERT INTO `lang_definitions` VALUES (8597, 2228, 5, 'Houd er rekening mee dat dit erg lang kan duren, zelfs tot enkele minuten, uw webbrowser lijkt niet erg actief in deze tijd, maar het genereren van een factuur is een ingewikkeld proces en uw webbrowser is slechts in afwachting van meer informatie.');
INSERT INTO `lang_definitions` VALUES (8598, 2229, 5, 'Let op: constanten zijn hoofdlettergevoelig en iedere string is toegestaan.');
INSERT INTO `lang_definitions` VALUES (8599, 2230, 5, 'Gebruik alleen letters');
INSERT INTO `lang_definitions` VALUES (8600, 2231, 5, 'Gebruik alleen letters zonder spaties');
INSERT INTO `lang_definitions` VALUES (8601, 2232, 5, 'Gelieve dit bedrag betalen');
INSERT INTO `lang_definitions` VALUES (8602, 2233, 5, 'Selecteer een reden voor aanpassing van code');
INSERT INTO `lang_definitions` VALUES (8603, 2234, 5, 'Selecteer gebeurtenis');
INSERT INTO `lang_definitions` VALUES (8604, 2235, 5, 'Selecteer de gewenste pagina\'s om te kopiëren of door te sturen:');
INSERT INTO `lang_definitions` VALUES (8605, 2236, 5, 'PM');
INSERT INTO `lang_definitions` VALUES (8606, 2237, 5, 'Methode van betaling');
INSERT INTO `lang_definitions` VALUES (8607, 2238, 5, 'PND');
INSERT INTO `lang_definitions` VALUES (8608, 2239, 5, 'Pneumococ Conj 1');
INSERT INTO `lang_definitions` VALUES (8609, 2240, 5, 'Pneumococ Conj 2');
INSERT INTO `lang_definitions` VALUES (8610, 2241, 5, 'Pneumococ Conj 3');
INSERT INTO `lang_definitions` VALUES (8611, 2242, 5, 'Pneumococ Conj 4');
INSERT INTO `lang_definitions` VALUES (8612, 2243, 5, 'Pneumonie Vaccinatie');
INSERT INTO `lang_definitions` VALUES (8613, 2244, 5, 'Point of Service (POS)');
INSERT INTO `lang_definitions` VALUES (8614, 2245, 5, 'Beleid');
INSERT INTO `lang_definitions` VALUES (8615, 2246, 5, 'Polisnummer');
INSERT INTO `lang_definitions` VALUES (8616, 2247, 5, 'Polydipsie');
INSERT INTO `lang_definitions` VALUES (8617, 2248, 5, 'Poliepen');
INSERT INTO `lang_definitions` VALUES (8618, 2249, 5, 'Polyurie');
INSERT INTO `lang_definitions` VALUES (8619, 2250, 5, 'Slechte eetlust');
INSERT INTO `lang_definitions` VALUES (8620, 2251, 5, 'Slechte circulatie');
INSERT INTO `lang_definitions` VALUES (8621, 2252, 5, 'Verminderd gehoor');
INSERT INTO `lang_definitions` VALUES (8622, 2253, 5, 'Jaaroverzicht vullen met gebeurtenissen?');
INSERT INTO `lang_definitions` VALUES (8623, 2254, 5, 'Overzicht');
INSERT INTO `lang_definitions` VALUES (8624, 2255, 5, 'Portugees (Brazilie)');
INSERT INTO `lang_definitions` VALUES (8625, 2256, 5, 'Portugees (Europa)');
INSERT INTO `lang_definitions` VALUES (8626, 2257, 5, 'POS-code');
INSERT INTO `lang_definitions` VALUES (8627, 2258, 5, 'Post Nasal Drip');
INSERT INTO `lang_definitions` VALUES (8628, 2259, 5, 'Na chirurgische');
INSERT INTO `lang_definitions` VALUES (8629, 2260, 5, 'Verzenden naar de boekhouding en markeren als gefactureerd');
INSERT INTO `lang_definitions` VALUES (8630, 2261, 5, 'Abortus nazorg');
INSERT INTO `lang_definitions` VALUES (8631, 2262, 5, 'Post-abortus anticonceptie');
INSERT INTO `lang_definitions` VALUES (8632, 2263, 5, 'Post-abortus begeleiding');
INSERT INTO `lang_definitions` VALUES (8633, 2264, 5, 'Post-abortus controle');
INSERT INTO `lang_definitions` VALUES (8634, 2265, 5, 'Per post');
INSERT INTO `lang_definitions` VALUES (8635, 2266, 5, 'Postcode');
INSERT INTO `lang_definitions` VALUES (8636, 2267, 5, 'Postcode');
INSERT INTO `lang_definitions` VALUES (8637, 2268, 5, 'PostCalendar');
INSERT INTO `lang_definitions` VALUES (8638, 2269, 5, 'PostCalendar administratie');
INSERT INTO `lang_definitions` VALUES (8639, 2270, 5, 'PostCalendar categorie-instellingen');
INSERT INTO `lang_definitions` VALUES (8640, 2271, 5, 'PostCalendar Global Settings');
INSERT INTO `lang_definitions` VALUES (8641, 2272, 5, 'Geplaatst op');
INSERT INTO `lang_definitions` VALUES (8642, 2273, 5, 'Datum plaatsing');
INSERT INTO `lang_definitions` VALUES (8643, 2275, 5, 'Praktijk');
INSERT INTO `lang_definitions` VALUES (8644, 2276, 5, 'Praktijk-instellingen');
INSERT INTO `lang_definitions` VALUES (8645, 2277, 5, 'Behandelaar');
INSERT INTO `lang_definitions` VALUES (8646, 2278, 5, 'Consultatie pre-abortus');
INSERT INTO `lang_definitions` VALUES (8647, 2279, 5, 'Pre-abortus begeleiding');
INSERT INTO `lang_definitions` VALUES (8648, 2280, 5, 'Pref Cat');
INSERT INTO `lang_definitions` VALUES (8649, 2281, 5, 'Voorkeurs gebeurtenissen categorie');
INSERT INTO `lang_definitions` VALUES (8650, 2282, 5, 'Voorkeurstaal');
INSERT INTO `lang_definitions` VALUES (8651, 2283, 5, 'Voorkeursapotheek');
INSERT INTO `lang_definitions` VALUES (8652, 2284, 5, 'Preferred Provider Organization (PPO)');
INSERT INTO `lang_definitions` VALUES (8653, 2285, 5, 'Zwang.test');
INSERT INTO `lang_definitions` VALUES (8654, 2286, 5, 'Vooruitbetalen');
INSERT INTO `lang_definitions` VALUES (8655, 2287, 5, 'Recept');
INSERT INTO `lang_definitions` VALUES (8656, 2288, 5, 'Receptlabel');
INSERT INTO `lang_definitions` VALUES (8657, 2289, 5, 'Recept');
INSERT INTO `lang_definitions` VALUES (8658, 2290, 5, 'Voorschriften en Ontheffingen');
INSERT INTO `lang_definitions` VALUES (8659, 2291, 5, 'Voorschriften en andere verwijzingen');
INSERT INTO `lang_definitions` VALUES (8660, 2292, 5, 'Voorschriften en/of verwijzing door specialist');
INSERT INTO `lang_definitions` VALUES (8661, 2293, 5, 'Verslag van recepten');
INSERT INTO `lang_definitions` VALUES (8662, 2294, 5, 'Voorschriften/Verwijzingen');
INSERT INTO `lang_definitions` VALUES (8663, 2295, 5, 'Klacht zoals gepresenteerd');
INSERT INTO `lang_definitions` VALUES (8664, 2296, 5, 'Druk op Doorgaan om verder te gaan');
INSERT INTO `lang_definitions` VALUES (8665, 2297, 5, 'Voorlopige diagnose');
INSERT INTO `lang_definitions` VALUES (8666, 2298, 5, 'Vermoedelijke diagnose van specialist');
INSERT INTO `lang_definitions` VALUES (8667, 2299, 5, 'Terug');
INSERT INTO `lang_definitions` VALUES (8668, 2300, 5, 'Gebeurtenis preview');
INSERT INTO `lang_definitions` VALUES (8669, 2301, 5, 'Vorig');
INSERT INTO `lang_definitions` VALUES (8670, 2302, 5, 'Eerdere consultaties');
INSERT INTO `lang_definitions` VALUES (8671, 2303, 5, 'Vorige dag');
INSERT INTO `lang_definitions` VALUES (8672, 2304, 5, 'Vorige Historie/Controles');
INSERT INTO `lang_definitions` VALUES (8673, 2305, 5, 'Vorige maand');
INSERT INTO `lang_definitions` VALUES (8674, 2306, 5, 'Vorige week');
INSERT INTO `lang_definitions` VALUES (8675, 2307, 5, 'Prijs');
INSERT INTO `lang_definitions` VALUES (8676, 2308, 5, 'Korting');
INSERT INTO `lang_definitions` VALUES (8677, 2309, 5, 'Prijsniveau');
INSERT INTO `lang_definitions` VALUES (8678, 2310, 5, 'Prijsniveau:');
INSERT INTO `lang_definitions` VALUES (8679, 2311, 5, 'Bedragen');
INSERT INTO `lang_definitions` VALUES (8680, 2312, 5, 'Primaire');
INSERT INTO `lang_definitions` VALUES (8681, 2313, 5, 'Hoofdverz.');
INSERT INTO `lang_definitions` VALUES (8682, 2314, 5, 'Hoofdverzekering');
INSERT INTO `lang_definitions` VALUES (8683, 2315, 5, 'Data van hoofdverzekering');
INSERT INTO `lang_definitions` VALUES (8684, 2316, 5, 'Verstrekker hoofdverzekering');
INSERT INTO `lang_definitions` VALUES (8685, 2317, 5, 'Eerste behandelaar');
INSERT INTO `lang_definitions` VALUES (8686, 2318, 5, 'Print');
INSERT INTO `lang_definitions` VALUES (8687, 2322, 5, 'Druk blanco verwijzingsformulier af');
INSERT INTO `lang_definitions` VALUES (8688, 2323, 5, 'Afdrukformaat');
INSERT INTO `lang_definitions` VALUES (8689, 2324, 5, 'Print vier rec. op A4');
INSERT INTO `lang_definitions` VALUES (8690, 2325, 5, 'Meerdere recepten afdrukken');
INSERT INTO `lang_definitions` VALUES (8691, 2326, 5, 'Meerdere afdrukken naar fax');
INSERT INTO `lang_definitions` VALUES (8692, 2329, 5, 'Pagina 1 afdrukken');
INSERT INTO `lang_definitions` VALUES (8693, 2330, 5, 'Pagina 2 afdrukken');
INSERT INTO `lang_definitions` VALUES (8694, 2331, 5, 'Print Status');
INSERT INTO `lang_definitions` VALUES (8695, 2332, 5, 'Print Vacc.verslag');
INSERT INTO `lang_definitions` VALUES (8696, 2334, 5, 'Print deze notitie');
INSERT INTO `lang_definitions` VALUES (8697, 2335, 5, 'Print dmv Fax');
INSERT INTO `lang_definitions` VALUES (8698, 2336, 5, 'Afdrukken naar fax');
INSERT INTO `lang_definitions` VALUES (8699, 2337, 5, 'Afdrukvoorbeeld');
INSERT INTO `lang_definitions` VALUES (8700, 2338, 5, 'Afdrukbaar');
INSERT INTO `lang_definitions` VALUES (8701, 2339, 5, 'Afdrukbare versie');
INSERT INTO `lang_definitions` VALUES (8702, 2340, 5, 'Afgedrukt');
INSERT INTO `lang_definitions` VALUES (8703, 2341, 5, 'Afdrukresultaten:');
INSERT INTO `lang_definitions` VALUES (8704, 2342, 5, 'Afdrukken overgeslagen; zie testresultaat in');
INSERT INTO `lang_definitions` VALUES (8705, 2343, 5, 'Eerst Autor');
INSERT INTO `lang_definitions` VALUES (8706, 2344, 5, 'Eerst autoriseren formulier');
INSERT INTO `lang_definitions` VALUES (8707, 2345, 5, 'Voorkeur');
INSERT INTO `lang_definitions` VALUES (8708, 2346, 5, 'Prive');
INSERT INTO `lang_definitions` VALUES (8709, 2347, 5, 'Probleem');
INSERT INTO `lang_definitions` VALUES (8710, 2348, 5, 'Probleemlijst');
INSERT INTO `lang_definitions` VALUES (8711, 2349, 5, 'Problemen/Ziekten');
INSERT INTO `lang_definitions` VALUES (8712, 2350, 5, 'Procedure');
INSERT INTO `lang_definitions` VALUES (8713, 2351, 5, 'Procedures');
INSERT INTO `lang_definitions` VALUES (8714, 2352, 5, 'Verwerken');
INSERT INTO `lang_definitions` VALUES (8715, 2353, 5, 'Verwerking');
INSERT INTO `lang_definitions` VALUES (8716, 2354, 5, 'Producten');
INSERT INTO `lang_definitions` VALUES (8717, 2355, 5, 'Prof.');
INSERT INTO `lang_definitions` VALUES (8718, 2357, 5, 'Prostaatkanker');
INSERT INTO `lang_definitions` VALUES (8719, 2358, 5, 'Prostaatonderzoek');
INSERT INTO `lang_definitions` VALUES (8720, 2359, 5, 'Prostaatproblemen');
INSERT INTO `lang_definitions` VALUES (8721, 2360, 5, 'Prostaat met/of vergroting, knobbels, gevoeligheid');
INSERT INTO `lang_definitions` VALUES (8722, 2361, 5, 'Behandelaar');
INSERT INTO `lang_definitions` VALUES (8723, 2362, 5, 'Nummer van behandelaar');
INSERT INTO `lang_definitions` VALUES (8724, 2363, 5, 'Behandelaar:');
INSERT INTO `lang_definitions` VALUES (8725, 2364, 5, 'Behandelaars');
INSERT INTO `lang_definitions` VALUES (8726, 2365, 5, 'Behandelaar\'s NIP');
INSERT INTO `lang_definitions` VALUES (8727, 2366, 5, 'Beh.');
INSERT INTO `lang_definitions` VALUES (8728, 2367, 5, 'PSA');
INSERT INTO `lang_definitions` VALUES (8729, 2368, 5, 'Psoriasis');
INSERT INTO `lang_definitions` VALUES (8730, 2369, 5, 'Psychische diagnose');
INSERT INTO `lang_definitions` VALUES (8731, 2370, 5, 'Psychische medicatie');
INSERT INTO `lang_definitions` VALUES (8732, 2371, 5, 'Psychisch');
INSERT INTO `lang_definitions` VALUES (8733, 2372, 5, 'Psychische brief ');
INSERT INTO `lang_definitions` VALUES (8734, 2373, 5, 'Psychische diagnose');
INSERT INTO `lang_definitions` VALUES (8735, 2374, 5, 'Psychisch onderzoek');
INSERT INTO `lang_definitions` VALUES (8736, 2375, 5, 'Psychische historie');
INSERT INTO `lang_definitions` VALUES (8737, 2376, 5, 'Psychische intake');
INSERT INTO `lang_definitions` VALUES (8738, 2377, 5, 'Psychische medicatie');
INSERT INTO `lang_definitions` VALUES (8739, 2378, 5, 'Pt %');
INSERT INTO `lang_definitions` VALUES (8740, 2379, 5, 'Pt.notitie');
INSERT INTO `lang_definitions` VALUES (8741, 2380, 5, 'Pt.notitie/autor.');
INSERT INTO `lang_definitions` VALUES (8742, 2381, 5, 'Pt.teveel');
INSERT INTO `lang_definitions` VALUES (8743, 2382, 5, 'Pt.Betaald');
INSERT INTO `lang_definitions` VALUES (8744, 2383, 5, 'Pt.restitutie');
INSERT INTO `lang_definitions` VALUES (8745, 2384, 5, 'Pt.ontslagen');
INSERT INTO `lang_definitions` VALUES (8746, 2385, 5, 'Rapport van patient');
INSERT INTO `lang_definitions` VALUES (8747, 2386, 5, 'PT Student, of leeg laten');
INSERT INTO `lang_definitions` VALUES (8748, 2388, 5, 'PT_GEB');
INSERT INTO `lang_definitions` VALUES (8749, 2389, 5, 'PT_VNAAM');
INSERT INTO `lang_definitions` VALUES (8750, 2390, 5, 'PT_ANAAM');
INSERT INTO `lang_definitions` VALUES (8751, 2391, 5, 'PT_MNAAM');
INSERT INTO `lang_definitions` VALUES (8752, 2395, 5, 'Openbaar');
INSERT INTO `lang_definitions` VALUES (8753, 2396, 5, 'Pulmonale');
INSERT INTO `lang_definitions` VALUES (8754, 2397, 5, 'Pols');
INSERT INTO `lang_definitions` VALUES (8755, 2398, 5, 'iedere 3 uur');
INSERT INTO `lang_definitions` VALUES (8756, 2399, 5, 'iedere 4 uur');
INSERT INTO `lang_definitions` VALUES (8757, 2400, 5, 'iedere 5 uur');
INSERT INTO `lang_definitions` VALUES (8758, 2401, 5, 'ieder 6 uur');
INSERT INTO `lang_definitions` VALUES (8759, 2402, 5, 'iedere 8 uur');
INSERT INTO `lang_definitions` VALUES (8760, 2403, 5, 'qd');
INSERT INTO `lang_definitions` VALUES (8761, 2404, 5, 'qid');
INSERT INTO `lang_definitions` VALUES (8762, 2405, 5, 'QOH');
INSERT INTO `lang_definitions` VALUES (8763, 2406, 5, 'Aant');
INSERT INTO `lang_definitions` VALUES (8764, 2407, 5, 'KWT');
INSERT INTO `lang_definitions` VALUES (8765, 2408, 5, 'Kwaliteit');
INSERT INTO `lang_definitions` VALUES (8766, 2409, 5, 'Hoeveelheid');
INSERT INTO `lang_definitions` VALUES (8767, 2410, 5, 'Hoeveelheid voor NDC');
INSERT INTO `lang_definitions` VALUES (8768, 2411, 5, 'Hoeveelheid ter beschikking');
INSERT INTO `lang_definitions` VALUES (8769, 2412, 5, 'Wachtrij voor HCFA batch-verwerking');
INSERT INTO `lang_definitions` VALUES (8770, 2413, 5, 'Wachtrij voor HCFA batch-verwerking en afdrukken');
INSERT INTO `lang_definitions` VALUES (8771, 2414, 5, 'Wachtrij voor de UB-92 batch-verwerking');
INSERT INTO `lang_definitions` VALUES (8772, 2415, 5, 'Wachtrij voor de UB-92 batch-verwerking en afdrukken');
INSERT INTO `lang_definitions` VALUES (8773, 2416, 5, 'In wachtrij');
INSERT INTO `lang_definitions` VALUES (8774, 2417, 5, 'Evenementen administratie in wachtrij');
INSERT INTO `lang_definitions` VALUES (8775, 2418, 5, 'Wachtrij voor');
INSERT INTO `lang_definitions` VALUES (8776, 2419, 5, 'In wachtrij voor toezending aan administratie');
INSERT INTO `lang_definitions` VALUES (8777, 2420, 5, 'R');
INSERT INTO `lang_definitions` VALUES (8778, 2421, 5, 'Ras');
INSERT INTO `lang_definitions` VALUES (8779, 2422, 5, 'Roots/Etnische achtergrond');
INSERT INTO `lang_definitions` VALUES (8780, 2423, 5, 'Radio');
INSERT INTO `lang_definitions` VALUES (8781, 2424, 5, 'Radio knoppen');
INSERT INTO `lang_definitions` VALUES (8782, 2425, 5, 'Huiduitslag');
INSERT INTO `lang_definitions` VALUES (8783, 2426, 5, 'Tarief');
INSERT INTO `lang_definitions` VALUES (8784, 2427, 5, 'Opnieuw openen');
INSERT INTO `lang_definitions` VALUES (8785, 2428, 5, 'Heropend');
INSERT INTO `lang_definitions` VALUES (8786, 2429, 5, 'Reacties');
INSERT INTO `lang_definitions` VALUES (8787, 2430, 5, 'Echte naam');
INSERT INTO `lang_definitions` VALUES (8788, 2431, 5, 'Reden');
INSERT INTO `lang_definitions` VALUES (8789, 2432, 5, 'Reden verwijzing');
INSERT INTO `lang_definitions` VALUES (8790, 2433, 5, 'Reden van bezoek');
INSERT INTO `lang_definitions` VALUES (8791, 2434, 5, 'Reden / Form');
INSERT INTO `lang_definitions` VALUES (8792, 2435, 5, 'Recu');
INSERT INTO `lang_definitions` VALUES (8793, 2436, 5, 'Betalingsbewijs');
INSERT INTO `lang_definitions` VALUES (8794, 2437, 5, 'Recu aangemaakt');
INSERT INTO `lang_definitions` VALUES (8795, 2438, 5, 'Verslag manier van betalingen');
INSERT INTO `lang_definitions` VALUES (8796, 2439, 5, 'Samenvatting ontvangstbewijzen');
INSERT INTO `lang_definitions` VALUES (8797, 2440, 5, 'Ontvangen');
INSERT INTO `lang_definitions` VALUES (8798, 2441, 5, 'Ontvangen door');
INSERT INTO `lang_definitions` VALUES (8799, 2442, 5, 'Ontvangen faxen');
INSERT INTO `lang_definitions` VALUES (8800, 2443, 5, 'Ontvanger');
INSERT INTO `lang_definitions` VALUES (8801, 2444, 5, 'ID van ontvanger');
INSERT INTO `lang_definitions` VALUES (8802, 2447, 5, 'Aanbevelingen');
INSERT INTO `lang_definitions` VALUES (8803, 2448, 5, 'Aanbevelingen en behandeling');
INSERT INTO `lang_definitions` VALUES (8804, 2449, 5, 'Aanbevelingen door specialist');
INSERT INTO `lang_definitions` VALUES (8805, 2450, 5, 'Betaling vastleggen');
INSERT INTO `lang_definitions` VALUES (8806, 2451, 5, 'Status gevonden');
INSERT INTO `lang_definitions` VALUES (8807, 2452, 5, 'Rectaal');
INSERT INTO `lang_definitions` VALUES (8808, 2453, 5, 'Rectaalonderzoek');
INSERT INTO `lang_definitions` VALUES (8809, 2454, 5, 'rectaal');
INSERT INTO `lang_definitions` VALUES (8810, 2455, 5, 'Roodheid');
INSERT INTO `lang_definitions` VALUES (8811, 2456, 5, 'verminderd:');
INSERT INTO `lang_definitions` VALUES (8812, 2457, 5, 'Verwijzen');
INSERT INTO `lang_definitions` VALUES (8813, 2458, 5, 'Verwijzing door');
INSERT INTO `lang_definitions` VALUES (8814, 2459, 5, 'Datum verwijzing');
INSERT INTO `lang_definitions` VALUES (8815, 2460, 5, 'Verwijs naar');
INSERT INTO `lang_definitions` VALUES (8816, 2461, 5, 'Classificatie verwijzing (risiconiveau)');
INSERT INTO `lang_definitions` VALUES (8817, 2462, 5, 'Reden verwijzing');
INSERT INTO `lang_definitions` VALUES (8818, 2463, 5, 'Naam en handtekening verwijzer');
INSERT INTO `lang_definitions` VALUES (8819, 2464, 5, 'Verwijzing');
INSERT INTO `lang_definitions` VALUES (8820, 2465, 5, 'Verwijzing door');
INSERT INTO `lang_definitions` VALUES (8821, 2466, 5, 'Verwijskaart');
INSERT INTO `lang_definitions` VALUES (8822, 2467, 5, 'Verwijsdatum');
INSERT INTO `lang_definitions` VALUES (8823, 2468, 5, 'Verwijzingsformulier');
INSERT INTO `lang_definitions` VALUES (8824, 2469, 5, 'VERWIJZINGSFORMULIER');
INSERT INTO `lang_definitions` VALUES (8825, 2470, 5, 'Verwezen door');
INSERT INTO `lang_definitions` VALUES (8826, 2471, 5, 'Verwijzing naar');
INSERT INTO `lang_definitions` VALUES (8827, 2472, 5, 'Verwijzingen');
INSERT INTO `lang_definitions` VALUES (8828, 2473, 5, 'Verslag van verwijzingen');
INSERT INTO `lang_definitions` VALUES (8829, 2474, 5, 'Verwezen door');
INSERT INTO `lang_definitions` VALUES (8830, 2475, 5, 'Verwezen door');
INSERT INTO `lang_definitions` VALUES (8831, 2476, 5, 'Verwezen naar');
INSERT INTO `lang_definitions` VALUES (8832, 2477, 5, 'Verwijzer');
INSERT INTO `lang_definitions` VALUES (8833, 2478, 5, 'Diagnose van verwijzer');
INSERT INTO `lang_definitions` VALUES (8834, 2479, 5, 'Diagnose van verwijzer');
INSERT INTO `lang_definitions` VALUES (8835, 2480, 5, 'Dokter en praktijkgegevens van verwijzer');
INSERT INTO `lang_definitions` VALUES (8836, 2481, 5, 'Verwijzende behandelaar');
INSERT INTO `lang_definitions` VALUES (8837, 2482, 5, 'Herhalingen');
INSERT INTO `lang_definitions` VALUES (8838, 2483, 5, 'herhalingen');
INSERT INTO `lang_definitions` VALUES (8839, 2484, 5, 'Normale reflexen');
INSERT INTO `lang_definitions` VALUES (8840, 2485, 5, 'Vernieuwen');
INSERT INTO `lang_definitions` VALUES (8841, 2486, 5, 'reg_re');
INSERT INTO `lang_definitions` VALUES (8842, 2487, 5, 'registreren');
INSERT INTO `lang_definitions` VALUES (8843, 2488, 5, 'Geregistreerd');
INSERT INTO `lang_definitions` VALUES (8844, 2489, 5, 'geregistreerd');
INSERT INTO `lang_definitions` VALUES (8845, 2490, 5, 'Registratiedatum');
INSERT INTO `lang_definitions` VALUES (8846, 2491, 5, 'Registratieformulier');
INSERT INTO `lang_definitions` VALUES (8847, 2492, 5, 'Herstel');
INSERT INTO `lang_definitions` VALUES (8848, 2493, 5, 'Gerelateerd aan');
INSERT INTO `lang_definitions` VALUES (8849, 2494, 5, 'Gerelateerd');
INSERT INTO `lang_definitions` VALUES (8850, 2495, 5, 'Relatie(s)/Kinderen');
INSERT INTO `lang_definitions` VALUES (8851, 2496, 5, 'Relatie');
INSERT INTO `lang_definitions` VALUES (8852, 2497, 5, 'Familieband');
INSERT INTO `lang_definitions` VALUES (8853, 2498, 5, 'Relay Health geloofsbrieven ontbreken van deze gebruikersaccount.');
INSERT INTO `lang_definitions` VALUES (8854, 2499, 5, 'Relay Health ID');
INSERT INTO `lang_definitions` VALUES (8855, 2500, 5, 'Religie');
INSERT INTO `lang_definitions` VALUES (8856, 2501, 5, 'Opnieuw inloggen');
INSERT INTO `lang_definitions` VALUES (8857, 2502, 5, 'Verwijderen');
INSERT INTO `lang_definitions` VALUES (8858, 2503, 5, 'Groep verwijderen');
INSERT INTO `lang_definitions` VALUES (8859, 2504, 5, 'Groepsformulier verwijderen');
INSERT INTO `lang_definitions` VALUES (8860, 2505, 5, 'Nierstenen');
INSERT INTO `lang_definitions` VALUES (8861, 2506, 5, 'Groep hernoemen');
INSERT INTO `lang_definitions` VALUES (8862, 2507, 5, 'Weergavestijl');
INSERT INTO `lang_definitions` VALUES (8863, 2508, 5, 'Weergavestijl behandelaar');
INSERT INTO `lang_definitions` VALUES (8864, 2509, 5, 'Weergavestijl behandelaar nummer');
INSERT INTO `lang_definitions` VALUES (8865, 2510, 5, 'Nabestelling bij');
INSERT INTO `lang_definitions` VALUES (8866, 2511, 5, 'Terugkerende Info:');
INSERT INTO `lang_definitions` VALUES (8867, 2512, 5, 'Herhalingen');
INSERT INTO `lang_definitions` VALUES (8868, 2513, 5, 'Antwoord datum');
INSERT INTO `lang_definitions` VALUES (8869, 2514, 5, 'Antwoord van');
INSERT INTO `lang_definitions` VALUES (8870, 2515, 5, 'Verslag');
INSERT INTO `lang_definitions` VALUES (8871, 2516, 5, 'Rapportage door');
INSERT INTO `lang_definitions` VALUES (8872, 2517, 5, 'Totalen rapport');
INSERT INTO `lang_definitions` VALUES (8873, 2518, 5, 'Rapportage');
INSERT INTO `lang_definitions` VALUES (8874, 2519, 5, 'Verzoek genegeerd - schadeafhandeling wordt al uitgevoerd!');
INSERT INTO `lang_definitions` VALUES (8875, 2520, 5, 'Aangevraagde Service');
INSERT INTO `lang_definitions` VALUES (8876, 2521, 5, 'Verplicht');
INSERT INTO `lang_definitions` VALUES (8877, 2522, 5, 'GERESERVEERD');
INSERT INTO `lang_definitions` VALUES (8878, 2523, 5, 'Gereserveerd');
INSERT INTO `lang_definitions` VALUES (8879, 2524, 5, 'Gereserveerd voor vakantie');
INSERT INTO `lang_definitions` VALUES (8880, 2525, 5, 'Gereserveerd om voor behandelaar vast te leggen als er geen afspraken meer daarna gemaakt kunnen worden.');
INSERT INTO `lang_definitions` VALUES (8881, 2526, 5, 'Gereserveerd om vast te leggen dat gebeurtenis niet als verwacht gebeurde.');
INSERT INTO `lang_definitions` VALUES (8882, 2527, 5, 'Gereserveerd voor de behandelaar indien er nog afspraken erna gemaakt kunnen worden.');
INSERT INTO `lang_definitions` VALUES (8883, 2528, 5, 'Opgelost');
INSERT INTO `lang_definitions` VALUES (8884, 2529, 5, 'Ademhaling');
INSERT INTO `lang_definitions` VALUES (8885, 2530, 5, 'Gasmasker inspanning unlabored');
INSERT INTO `lang_definitions` VALUES (8886, 2531, 5, 'Gerelateerd aan ademhaling');
INSERT INTO `lang_definitions` VALUES (8887, 2532, 5, 'Beperkte training');
INSERT INTO `lang_definitions` VALUES (8888, 2533, 5, 'Resultaten');
INSERT INTO `lang_definitions` VALUES (8889, 2534, 5, 'Resultaten gevonden voor zoeken');
INSERT INTO `lang_definitions` VALUES (8890, 2535, 5, 'Onderzoek van de Retina');
INSERT INTO `lang_definitions` VALUES (8891, 2536, 5, 'Teruggetrokken rechts:');
INSERT INTO `lang_definitions` VALUES (8892, 2537, 5, 'Geef waarde weer');
INSERT INTO `lang_definitions` VALUES (8893, 2538, 5, 'Terug naar kalender');
INSERT INTO `lang_definitions` VALUES (8894, 2539, 5, 'Resultaat');
INSERT INTO `lang_definitions` VALUES (8895, 2540, 5, 'Tegenbezoek');
INSERT INTO `lang_definitions` VALUES (8896, 2541, 5, 'Terug om te spelen');
INSERT INTO `lang_definitions` VALUES (8897, 2542, 5, 'Herziening van de PMH:');
INSERT INTO `lang_definitions` VALUES (8898, 2543, 5, 'Alg. syst. onderzoek');
INSERT INTO `lang_definitions` VALUES (8899, 2544, 5, 'Checklijst med. afw.');
INSERT INTO `lang_definitions` VALUES (8900, 2545, 5, 'Revisie');
INSERT INTO `lang_definitions` VALUES (8901, 2546, 5, 'Rheumatoide Artritis');
INSERT INTO `lang_definitions` VALUES (8902, 2547, 5, 'Recht');
INSERT INTO `lang_definitions` VALUES (8903, 2548, 5, 'Rechteroor');
INSERT INTO `lang_definitions` VALUES (8904, 2549, 5, 'rechteroor');
INSERT INTO `lang_definitions` VALUES (8905, 2550, 5, 'Recht:');
INSERT INTO `lang_definitions` VALUES (8906, 2551, 5, 'Fluittoon in oren');
INSERT INTO `lang_definitions` VALUES (8907, 2552, 5, 'Fluittoon in oren');
INSERT INTO `lang_definitions` VALUES (8908, 2553, 5, 'Risicofactoren');
INSERT INTO `lang_definitions` VALUES (8909, 2554, 5, 'Mate van risico');
INSERT INTO `lang_definitions` VALUES (8910, 2555, 5, 'RLL:');
INSERT INTO `lang_definitions` VALUES (8911, 2556, 5, 'ROM');
INSERT INTO `lang_definitions` VALUES (8912, 2557, 5, 'Rooster');
INSERT INTO `lang_definitions` VALUES (8913, 2558, 5, 'Route');
INSERT INTO `lang_definitions` VALUES (8914, 2559, 5, 'Kolommen');
INSERT INTO `lang_definitions` VALUES (8915, 2560, 5, 'RRR zonder MOR');
INSERT INTO `lang_definitions` VALUES (8916, 2561, 5, 'Inwrijven:');
INSERT INTO `lang_definitions` VALUES (8917, 2562, 5, 'Wrijft:');
INSERT INTO `lang_definitions` VALUES (8918, 2563, 5, 'Opdracht uitvoeren:');
INSERT INTO `lang_definitions` VALUES (8919, 2564, 5, 'Gescheurd');
INSERT INTO `lang_definitions` VALUES (8920, 2565, 5, 'Russisch');
INSERT INTO `lang_definitions` VALUES (8921, 2566, 5, 'Rx');
INSERT INTO `lang_definitions` VALUES (8922, 2567, 5, 'Rx');
INSERT INTO `lang_definitions` VALUES (8923, 2568, 5, 'S');
INSERT INTO `lang_definitions` VALUES (8924, 2569, 5, 'ID-NA');
INSERT INTO `lang_definitions` VALUES (8925, 2570, 5, 'S3:');
INSERT INTO `lang_definitions` VALUES (8926, 2571, 5, 'S4:');
INSERT INTO `lang_definitions` VALUES (8927, 2572, 5, 'SA * * Om de licentie te lezen, leest u het docs / license.txt of bezoek http://www.gnu.org/copyleft/gpl.html * * * / //============ ================================================== =========== / /');
INSERT INTO `lang_definitions` VALUES (8928, 2573, 5, 'Verkoop');
INSERT INTO `lang_definitions` VALUES (8929, 2574, 5, 'Verkoop per item');
INSERT INTO `lang_definitions` VALUES (8930, 2575, 5, 'Verslag omzet per product');
INSERT INTO `lang_definitions` VALUES (8931, 2576, 5, 'Zelfde dag');
INSERT INTO `lang_definitions` VALUES (8932, 2577, 5, 'Voorbeeld');
INSERT INTO `lang_definitions` VALUES (8933, 2578, 5, 'Type sanctie');
INSERT INTO `lang_definitions` VALUES (8934, 2579, 5, 'Zat');
INSERT INTO `lang_definitions` VALUES (8935, 2580, 5, 'Zat - Zon');
INSERT INTO `lang_definitions` VALUES (8936, 2581, 5, 'Zaterdag');
INSERT INTO `lang_definitions` VALUES (8937, 2582, 5, 'Bewaren');
INSERT INTO `lang_definitions` VALUES (8938, 2583, 5, 'Save en Verstrek');
INSERT INTO `lang_definitions` VALUES (8939, 2584, 5, 'Bewaar als nieuw');
INSERT INTO `lang_definitions` VALUES (8940, 2585, 5, 'Bewaar wijzigingen');
INSERT INTO `lang_definitions` VALUES (8941, 2586, 5, 'Bewaar');
INSERT INTO `lang_definitions` VALUES (8942, 2587, 5, 'Bewaar');
INSERT INTO `lang_definitions` VALUES (8943, 2588, 5, 'Bewaar nieuw veld ');
INSERT INTO `lang_definitions` VALUES (8944, 2589, 5, 'Bewaar nieuwe groep');
INSERT INTO `lang_definitions` VALUES (8945, 2590, 5, 'Bewaar nieuwe lijst');
INSERT INTO `lang_definitions` VALUES (8946, 2591, 5, 'Nieuw sjabloon bewaren');
INSERT INTO `lang_definitions` VALUES (8947, 2592, 5, 'Bewaar pers. gegevens');
INSERT INTO `lang_definitions` VALUES (8948, 2593, 5, 'Status-ID bewaard');
INSERT INTO `lang_definitions` VALUES (8949, 2594, 5, 'Transactie bewaren');
INSERT INTO `lang_definitions` VALUES (8950, 2595, 5, 'Gescanned');
INSERT INTO `lang_definitions` VALUES (8951, 2596, 5, 'Gescannde notitie dit bezoek');
INSERT INTO `lang_definitions` VALUES (8952, 2597, 5, 'In de scanner');
INSERT INTO `lang_definitions` VALUES (8953, 2598, 5, 'Schema');
INSERT INTO `lang_definitions` VALUES (8954, 2599, 5, 'Agenda voor Lokatie:');
INSERT INTO `lang_definitions` VALUES (8955, 2600, 5, 'Briefje voor school');
INSERT INTO `lang_definitions` VALUES (8956, 2601, 5, 'Scoliose');
INSERT INTO `lang_definitions` VALUES (8957, 2602, 5, 'SE');
INSERT INTO `lang_definitions` VALUES (8958, 2603, 5, 'SE Adres');
INSERT INTO `lang_definitions` VALUES (8959, 2604, 5, 'SE Stad');
INSERT INTO `lang_definitions` VALUES (8960, 2605, 5, 'SE Land');
INSERT INTO `lang_definitions` VALUES (8961, 2606, 5, 'SE Localiteit');
INSERT INTO `lang_definitions` VALUES (8962, 2607, 5, 'SE Postcode');
INSERT INTO `lang_definitions` VALUES (8963, 2608, 5, 'SE Staat');
INSERT INTO `lang_definitions` VALUES (8964, 2609, 5, 'SE Postcode');
INSERT INTO `lang_definitions` VALUES (8965, 2610, 5, 'Zoeken');
INSERT INTO `lang_definitions` VALUES (8966, 2611, 5, 'zoeken');
INSERT INTO `lang_definitions` VALUES (8967, 2612, 5, 'opnieuw zoeken');
INSERT INTO `lang_definitions` VALUES (8968, 2613, 5, 'Zoek op:');
INSERT INTO `lang_definitions` VALUES (8969, 2614, 5, 'Zoek naar:');
INSERT INTO `lang_definitions` VALUES (8970, 2615, 5, 'Pt zoeken of toevoegen');
INSERT INTO `lang_definitions` VALUES (8971, 2616, 5, 'Resultaten zoekactie:');
INSERT INTO `lang_definitions` VALUES (8972, 2618, 5, 'Gebeurtenissen zoeken');
INSERT INTO `lang_definitions` VALUES (8973, 2619, 5, 'Verzekeraar zoeken/toevoegen');
INSERT INTO `lang_definitions` VALUES (8974, 2620, 5, 'Zoeken naar afspraken');
INSERT INTO `lang_definitions` VALUES (8975, 2621, 5, 'Zoeken.....');
INSERT INTO `lang_definitions` VALUES (8976, 2622, 5, 'Gebruik veiligheidsgordel');
INSERT INTO `lang_definitions` VALUES (8977, 2623, 5, 'Gebruik veiligheidsgordel');
INSERT INTO `lang_definitions` VALUES (8978, 2624, 5, 'Tweede');
INSERT INTO `lang_definitions` VALUES (8979, 2625, 5, 'Secundair');
INSERT INTO `lang_definitions` VALUES (8980, 2626, 5, 'Secundaire verzekering');
INSERT INTO `lang_definitions` VALUES (8981, 2627, 5, 'Secundaire verzekeringsgegevens');
INSERT INTO `lang_definitions` VALUES (8982, 2628, 5, 'Tweede verzekeraar');
INSERT INTO `lang_definitions` VALUES (8983, 2629, 5, 'Bekijk iedereen');
INSERT INTO `lang_definitions` VALUES (8984, 2630, 5, 'Bekijk machtigingen');
INSERT INTO `lang_definitions` VALUES (8985, 2631, 5, 'Bekijk Groeicurve');
INSERT INTO `lang_definitions` VALUES (8986, 2632, 5, 'Bekijk bericht over recentst aangemaakte rekeningen');
INSERT INTO `lang_definitions` VALUES (8987, 2633, 5, 'Vorige bezoek');
INSERT INTO `lang_definitions` VALUES (8988, 2634, 5, 'Aanvallen');
INSERT INTO `lang_definitions` VALUES (8989, 2635, 5, 'Sel');
INSERT INTO `lang_definitions` VALUES (8990, 2636, 5, 'Selecteren');
INSERT INTO `lang_definitions` VALUES (8991, 2637, 5, 'Kies allemaal');
INSERT INTO `lang_definitions` VALUES (8992, 2639, 5, 'Kies veld');
INSERT INTO `lang_definitions` VALUES (8993, 2640, 5, 'Selecteer velden');
INSERT INTO `lang_definitions` VALUES (8994, 2641, 5, 'Selecteer voor afdrukken');
INSERT INTO `lang_definitions` VALUES (8995, 2642, 5, 'Probleem selecteren');
INSERT INTO `lang_definitions` VALUES (8996, 2643, 5, 'Selecteer de items voor exporteren');
INSERT INTO `lang_definitions` VALUES (8997, 2644, 5, 'Kies JA voor groeps gewijs verwijderen');
INSERT INTO `lang_definitions` VALUES (8998, 2645, 5, 'Zelf');
INSERT INTO `lang_definitions` VALUES (8999, 2646, 5, 'Betaald zelf');
INSERT INTO `lang_definitions` VALUES (9000, 2647, 5, 'Bezig met verzenden');
INSERT INTO `lang_definitions` VALUES (9001, 2649, 5, 'Afzender');
INSERT INTO `lang_definitions` VALUES (9002, 2650, 5, 'ID van afzender');
INSERT INTO `lang_definitions` VALUES (9003, 2653, 5, 'Gevoeligheden');
INSERT INTO `lang_definitions` VALUES (9004, 2654, 5, 'Gevoeligheid:');
INSERT INTO `lang_definitions` VALUES (9005, 2655, 5, 'Sensorisch onderzoek normaal');
INSERT INTO `lang_definitions` VALUES (9006, 2656, 5, 'Verzenden is gelukt');
INSERT INTO `lang_definitions` VALUES (9007, 2657, 5, 'Verstuur naar printer');
INSERT INTO `lang_definitions` VALUES (9008, 2658, 5, 'Gescheiden');
INSERT INTO `lang_definitions` VALUES (9009, 2659, 5, 'September');
INSERT INTO `lang_definitions` VALUES (9010, 2660, 5, 'Categorie verleende Service');
INSERT INTO `lang_definitions` VALUES (9011, 2661, 5, 'Dienst datum');
INSERT INTO `lang_definitions` VALUES (9012, 2662, 5, 'Service datum');
INSERT INTO `lang_definitions` VALUES (9013, 2663, 5, 'Service locatie');
INSERT INTO `lang_definitions` VALUES (9014, 2664, 5, 'Dienstverlening door specialist');
INSERT INTO `lang_definitions` VALUES (9015, 2665, 5, 'Verleende diensten');
INSERT INTO `lang_definitions` VALUES (9016, 2666, 5, 'Diensten per Categorie');
INSERT INTO `lang_definitions` VALUES (9017, 2667, 5, 'Verleende diensten');
INSERT INTO `lang_definitions` VALUES (9018, 2668, 5, 'Verleende diensten');
INSERT INTO `lang_definitions` VALUES (9019, 2669, 5, 'Instellingen');
INSERT INTO `lang_definitions` VALUES (9020, 2670, 5, 'Zware migraine');
INSERT INTO `lang_definitions` VALUES (9021, 2671, 5, 'Ernst van de pijn');
INSERT INTO `lang_definitions` VALUES (9022, 2672, 5, 'Ernst van de pijn:');
INSERT INTO `lang_definitions` VALUES (9023, 2673, 5, 'Gesl');
INSERT INTO `lang_definitions` VALUES (9024, 2674, 5, 'SOA');
INSERT INTO `lang_definitions` VALUES (9025, 2675, 5, 'Delen met');
INSERT INTO `lang_definitions` VALUES (9026, 2676, 5, 'Kortademig');
INSERT INTO `lang_definitions` VALUES (9027, 2677, 5, 'Kortademig');
INSERT INTO `lang_definitions` VALUES (9028, 2678, 5, 'Kortademig 2');
INSERT INTO `lang_definitions` VALUES (9029, 2679, 5, 'Vaccinatie bewijs');
INSERT INTO `lang_definitions` VALUES (9030, 2680, 5, 'Vaccinaties vanaf:');
INSERT INTO `lang_definitions` VALUES (9031, 2681, 5, 'Moet zijn conform nnnn-nnnn-nn');
INSERT INTO `lang_definitions` VALUES (9032, 2682, 5, 'Schouder');
INSERT INTO `lang_definitions` VALUES (9033, 2683, 5, 'Schouder en Clavicula');
INSERT INTO `lang_definitions` VALUES (9034, 2684, 5, 'Schouderproblemen');
INSERT INTO `lang_definitions` VALUES (9035, 2685, 5, 'Laat zien');
INSERT INTO `lang_definitions` VALUES (9036, 2686, 5, 'Bezig');
INSERT INTO `lang_definitions` VALUES (9037, 2687, 5, 'Alleen geautorizeerden');
INSERT INTO `lang_definitions` VALUES (9038, 2688, 5, 'Toon details');
INSERT INTO `lang_definitions` VALUES (9039, 2689, 5, 'Laat gebeurtenis tekst zien bij muis over');
INSERT INTO `lang_definitions` VALUES (9040, 2690, 5, 'Hoeveelheid gebeurtenissen tonen op Admin Pagina?');
INSERT INTO `lang_definitions` VALUES (9041, 2692, 5, 'Rapport tonen');
INSERT INTO `lang_definitions` VALUES (9042, 2693, 5, 'Toon rapport');
INSERT INTO `lang_definitions` VALUES (9043, 2694, 5, 'Toon alleen niet in REK gebracht');
INSERT INTO `lang_definitions` VALUES (9044, 2695, 5, 'Kinderen');
INSERT INTO `lang_definitions` VALUES (9045, 2696, 5, 'Sikkelcel');
INSERT INTO `lang_definitions` VALUES (9046, 2697, 5, 'Sig');
INSERT INTO `lang_definitions` VALUES (9047, 2698, 5, 'Sigmoid/Coloscopie');
INSERT INTO `lang_definitions` VALUES (9048, 2699, 5, 'Handtekening');
INSERT INTO `lang_definitions` VALUES (9049, 2700, 5, 'Handtekening:');
INSERT INTO `lang_definitions` VALUES (9050, 2702, 5, 'Aanzienlijke zwelling:');
INSERT INTO `lang_definitions` VALUES (9051, 2703, 5, 'Sinds');
INSERT INTO `lang_definitions` VALUES (9052, 2705, 5, 'Alleen');
INSERT INTO `lang_definitions` VALUES (9053, 2706, 5, 'Sinusproblemen');
INSERT INTO `lang_definitions` VALUES (9054, 2707, 5, 'Chirurgie van de sinus');
INSERT INTO `lang_definitions` VALUES (9055, 2708, 5, 'SINUS GEVOELIGHEID:');
INSERT INTO `lang_definitions` VALUES (9056, 2709, 5, 'Sinusitis');
INSERT INTO `lang_definitions` VALUES (9057, 2710, 5, 'Maat');
INSERT INTO `lang_definitions` VALUES (9058, 2711, 5, 'Maat moet een getal zijn tussen 1 en 999');
INSERT INTO `lang_definitions` VALUES (9059, 2712, 5, 'Maat/Lijst');
INSERT INTO `lang_definitions` VALUES (9060, 2713, 5, 'Huid');
INSERT INTO `lang_definitions` VALUES (9061, 2714, 5, 'Huidkanker');
INSERT INTO `lang_definitions` VALUES (9062, 2715, 5, 'Huidziekte');
INSERT INTO `lang_definitions` VALUES (9063, 2716, 5, 'Anders huid');
INSERT INTO `lang_definitions` VALUES (9064, 2718, 5, 'Slaappatroon');
INSERT INTO `lang_definitions` VALUES (9065, 2719, 5, 'Slaappatroon');
INSERT INTO `lang_definitions` VALUES (9066, 2720, 5, 'Slapen');
INSERT INTO `lang_definitions` VALUES (9067, 2721, 5, 'Slovaaks');
INSERT INTO `lang_definitions` VALUES (9068, 2722, 5, 'Sm schuld w / o');
INSERT INTO `lang_definitions` VALUES (9069, 2723, 5, 'Smarty cache is gewist');
INSERT INTO `lang_definitions` VALUES (9070, 2724, 5, 'SMS Gateway');
INSERT INTO `lang_definitions` VALUES (9071, 2725, 5, 'SMS Gateway API-sleutel');
INSERT INTO `lang_definitions` VALUES (9072, 2726, 5, 'SMS-melding');
INSERT INTO `lang_definitions` VALUES (9073, 2727, 5, 'SMS sturen vóór');
INSERT INTO `lang_definitions` VALUES (9074, 2728, 5, 'SMS Tekst, Bruikbare Tag: NAAM *** *** *** *** AANBIEDENDE, DATUM *** *** *** Begintijd *** *** *** ENDTIME br dwz Beste ** * Naam ***');
INSERT INTO `lang_definitions` VALUES (9075, 2729, 5, 'SMS/E-mail waarschuwingsinstellingen');
INSERT INTO `lang_definitions` VALUES (9076, 2730, 5, 'Snurken');
INSERT INTO `lang_definitions` VALUES (9077, 2731, 5, 'SOEP');
INSERT INTO `lang_definitions` VALUES (9078, 2732, 5, 'Sociale problemen');
INSERT INTO `lang_definitions` VALUES (9079, 2733, 5, 'Sociale voorgesch.');
INSERT INTO `lang_definitions` VALUES (9080, 2734, 5, 'BSN');
INSERT INTO `lang_definitions` VALUES (9081, 2735, 5, 'oplossing');
INSERT INTO `lang_definitions` VALUES (9082, 2736, 5, 'Somatische context');
INSERT INTO `lang_definitions` VALUES (9083, 2737, 5, 'Sommige machtigingen werden niet getoond. Klik hier om ze allemaal te zien');
INSERT INTO `lang_definitions` VALUES (9084, 2738, 5, 'Sommige codes werden niet getoond. ');
INSERT INTO `lang_definitions` VALUES (9085, 2739, 5, 'Sommige bezoeken werden niet getoond. Klik hier om alles te zien. ');
INSERT INTO `lang_definitions` VALUES (9086, 2740, 5, 'Enkele notities werden niet getoond');
INSERT INTO `lang_definitions` VALUES (9087, 2741, 5, 'enkele woorden');
INSERT INTO `lang_definitions` VALUES (9088, 2742, 5, 'Zere keel');
INSERT INTO `lang_definitions` VALUES (9089, 2743, 5, 'Sorteren op');
INSERT INTO `lang_definitions` VALUES (9090, 2744, 5, 'Sorteren op commentaar');
INSERT INTO `lang_definitions` VALUES (9091, 2745, 5, 'Sorteren op datum');
INSERT INTO `lang_definitions` VALUES (9092, 2746, 5, 'Sorteren op datum/tijd');
INSERT INTO `lang_definitions` VALUES (9093, 2747, 5, 'Sorteren op gebeurtenis');
INSERT INTO `lang_definitions` VALUES (9094, 2748, 5, 'Sorteren op groep');
INSERT INTO `lang_definitions` VALUES (9095, 2749, 5, 'Sorteren op gebruiker');
INSERT INTO `lang_definitions` VALUES (9096, 2750, 5, 'Sorteren op vaccinatie');
INSERT INTO `lang_definitions` VALUES (9097, 2751, 5, 'Bron');
INSERT INTO `lang_definitions` VALUES (9098, 2752, 5, 'Bron is niet in code opgenomen');
INSERT INTO `lang_definitions` VALUES (9099, 2753, 5, 'Bron:');
INSERT INTO `lang_definitions` VALUES (9100, 2754, 5, 'Spaans');
INSERT INTO `lang_definitions` VALUES (9101, 2755, 5, 'Naam en handtekening specialist');
INSERT INTO `lang_definitions` VALUES (9102, 2756, 5, 'Specialisatie');
INSERT INTO `lang_definitions` VALUES (9103, 2757, 5, 'Gespecificeerde systemen');
INSERT INTO `lang_definitions` VALUES (9104, 2758, 5, 'Specialisatie:');
INSERT INTO `lang_definitions` VALUES (9105, 2759, 5, 'Specifiek');
INSERT INTO `lang_definitions` VALUES (9106, 2760, 5, 'Specifieke Service');
INSERT INTO `lang_definitions` VALUES (9107, 2761, 5, 'Spraak invoer');
INSERT INTO `lang_definitions` VALUES (9108, 2762, 5, 'Spermiciden');
INSERT INTO `lang_definitions` VALUES (9109, 2763, 5, 'Milt extracie');
INSERT INTO `lang_definitions` VALUES (9110, 2764, 5, 'Echtgenoot');
INSERT INTO `lang_definitions` VALUES (9111, 2765, 5, 'Sputum');
INSERT INTO `lang_definitions` VALUES (9112, 2766, 5, 'Sputum:');
INSERT INTO `lang_definitions` VALUES (9113, 2767, 5, 'SQ');
INSERT INTO `lang_definitions` VALUES (9114, 2768, 5, 'Ploeg');
INSERT INTO `lang_definitions` VALUES (9115, 2769, 5, 'Ploeglidmaatschap');
INSERT INTO `lang_definitions` VALUES (9116, 2770, 5, 'Ploegen');
INSERT INTO `lang_definitions` VALUES (9117, 2771, 5, 'SRH');
INSERT INTO `lang_definitions` VALUES (9118, 2772, 5, 'SRH - Family Planning');
INSERT INTO `lang_definitions` VALUES (9119, 2773, 5, 'SRH Geen Family Planning');
INSERT INTO `lang_definitions` VALUES (9120, 2774, 5, 'SRH verwijzingen');
INSERT INTO `lang_definitions` VALUES (9121, 2775, 5, 'SRH Bezoekformulier');
INSERT INTO `lang_definitions` VALUES (9122, 2776, 5, 'ID-NA');
INSERT INTO `lang_definitions` VALUES (9123, 2777, 5, 'BSN');
INSERT INTO `lang_definitions` VALUES (9124, 2778, 5, 'Stabilitiet');
INSERT INTO `lang_definitions` VALUES (9125, 2779, 5, 'Standaard');
INSERT INTO `lang_definitions` VALUES (9126, 2780, 5, 'Begin');
INSERT INTO `lang_definitions` VALUES (9127, 2781, 5, 'Start (jjjj-mm-dd):');
INSERT INTO `lang_definitions` VALUES (9128, 2782, 5, 'Begindatum');
INSERT INTO `lang_definitions` VALUES (9129, 2783, 5, 'Begindatum bij deze kliniek');
INSERT INTO `lang_definitions` VALUES (9130, 2784, 5, 'Begindatum:');
INSERT INTO `lang_definitions` VALUES (9131, 2785, 5, 'Begindatum:');
INSERT INTO `lang_definitions` VALUES (9132, 2786, 5, 'Starttijd');
INSERT INTO `lang_definitions` VALUES (9133, 2787, 5, 'Begindatum');
INSERT INTO `lang_definitions` VALUES (9134, 2788, 5, 'nu');
INSERT INTO `lang_definitions` VALUES (9135, 2789, 5, 'Staat');
INSERT INTO `lang_definitions` VALUES (9136, 2790, 5, 'Provincie-/Eilandgebiedlijst (schrijven,toevoegen optioneel)');
INSERT INTO `lang_definitions` VALUES (9137, 2791, 5, 'Staat/Localiteit');
INSERT INTO `lang_definitions` VALUES (9138, 2792, 5, 'Bario/Parochie');
INSERT INTO `lang_definitions` VALUES (9139, 2793, 5, 'Statistieken');
INSERT INTO `lang_definitions` VALUES (9140, 2794, 5, 'Statistieken');
INSERT INTO `lang_definitions` VALUES (9141, 2795, 5, 'Status');
INSERT INTO `lang_definitions` VALUES (9142, 2796, 5, 'Status quo');
INSERT INTO `lang_definitions` VALUES (9143, 2797, 5, 'SOA / AIDS Couns');
INSERT INTO `lang_definitions` VALUES (9144, 2798, 5, 'Sterkte en conditionering');
INSERT INTO `lang_definitions` VALUES (9145, 2799, 5, 'Stijve gewrichten');
INSERT INTO `lang_definitions` VALUES (9146, 2800, 5, 'Stijfheid');
INSERT INTO `lang_definitions` VALUES (9147, 2801, 5, 'Maagpijn');
INSERT INTO `lang_definitions` VALUES (9148, 2802, 5, 'Verrekte spier');
INSERT INTO `lang_definitions` VALUES (9149, 2803, 5, 'Stroming');
INSERT INTO `lang_definitions` VALUES (9150, 2804, 5, 'Straat');
INSERT INTO `lang_definitions` VALUES (9151, 2806, 5, 'Straat en nummer');
INSERT INTO `lang_definitions` VALUES (9152, 2807, 5, 'Kracht');
INSERT INTO `lang_definitions` VALUES (9153, 2808, 5, 'Strep keel onst.');
INSERT INTO `lang_definitions` VALUES (9154, 2809, 5, 'Stress fractuur');
INSERT INTO `lang_definitions` VALUES (9155, 2810, 5, 'Stress Test');
INSERT INTO `lang_definitions` VALUES (9156, 2811, 5, 'CVA');
INSERT INTO `lang_definitions` VALUES (9157, 2812, 5, 'Subcategorie');
INSERT INTO `lang_definitions` VALUES (9158, 2813, 5, 'Subtotaal');
INSERT INTO `lang_definitions` VALUES (9159, 2814, 5, 'Subcategorie');
INSERT INTO `lang_definitions` VALUES (9160, 2815, 5, 'subcategorie');
INSERT INTO `lang_definitions` VALUES (9161, 2816, 5, 'onderhuids');
INSERT INTO `lang_definitions` VALUES (9162, 2817, 5, 'Subjectief');
INSERT INTO `lang_definitions` VALUES (9163, 2818, 5, 'Onder de tong');
INSERT INTO `lang_definitions` VALUES (9164, 2819, 5, 'onder de tong');
INSERT INTO `lang_definitions` VALUES (9165, 2820, 5, 'Verstuur');
INSERT INTO `lang_definitions` VALUES (9166, 2822, 5, 'Gebeurtenis toevoegen');
INSERT INTO `lang_definitions` VALUES (9167, 2823, 5, 'formulier versturen');
INSERT INTO `lang_definitions` VALUES (9168, 2826, 5, 'Verstuurd door');
INSERT INTO `lang_definitions` VALUES (9169, 2828, 5, 'Verzekeringnemer');
INSERT INTO `lang_definitions` VALUES (9170, 2829, 5, 'Adres verzekeringnemer');
INSERT INTO `lang_definitions` VALUES (9171, 2830, 5, 'Werkgever verzekeringnemer ');
INSERT INTO `lang_definitions` VALUES (9172, 2831, 5, 'Werkgever verzekeringnemer (SE)');
INSERT INTO `lang_definitions` VALUES (9173, 2832, 5, 'WV adres');
INSERT INTO `lang_definitions` VALUES (9174, 2833, 5, 'WV stad');
INSERT INTO `lang_definitions` VALUES (9175, 2834, 5, 'WV land');
INSERT INTO `lang_definitions` VALUES (9176, 2835, 5, 'WV staat');
INSERT INTO `lang_definitions` VALUES (9177, 2836, 5, 'WV postcode');
INSERT INTO `lang_definitions` VALUES (9178, 2837, 5, 'Tel.verzkr.nemer');
INSERT INTO `lang_definitions` VALUES (9179, 2838, 5, 'Verzekeringnemer relatie');
INSERT INTO `lang_definitions` VALUES (9180, 2839, 5, 'Verzekeringnemer relatie is niet Zelf maar de naam is wel hetzelfde! Is dit juist?');
INSERT INTO `lang_definitions` VALUES (9181, 2840, 5, 'Verzekeringnemer relatie is niet Zelf maar BSN nummer is wel hetzelfde!');
INSERT INTO `lang_definitions` VALUES (9182, 2841, 5, 'Verzekeringnemer relatie is Zelf maar de naam is niet hetzelfde! Is dit juist?');
INSERT INTO `lang_definitions` VALUES (9183, 2842, 5, 'Verzekeringnemer relatie is Zelf maar BSN nummer is niet hetzelfde!');
INSERT INTO `lang_definitions` VALUES (9184, 2843, 5, 'Gesl. verzekeringsnemer');
INSERT INTO `lang_definitions` VALUES (9185, 2844, 5, 'Vervanging');
INSERT INTO `lang_definitions` VALUES (9186, 2845, 5, 'substitutie toegestaan');
INSERT INTO `lang_definitions` VALUES (9187, 2846, 5, 'succes');
INSERT INTO `lang_definitions` VALUES (9188, 2847, 5, 'Toegevoegd aan categorie gelukt');
INSERT INTO `lang_definitions` VALUES (9189, 2848, 5, 'Opslaan gelukt');
INSERT INTO `lang_definitions` VALUES (9190, 2849, 5, 'Succesvol');
INSERT INTO `lang_definitions` VALUES (9191, 2850, 5, 'Zelfmoord');
INSERT INTO `lang_definitions` VALUES (9192, 2851, 5, 'Samenvatting');
INSERT INTO `lang_definitions` VALUES (9193, 2852, 5, 'Zon');
INSERT INTO `lang_definitions` VALUES (9194, 2853, 5, 'Zondag');
INSERT INTO `lang_definitions` VALUES (9195, 2854, 5, 'Superbill');
INSERT INTO `lang_definitions` VALUES (9196, 2855, 5, 'Superbill Codes');
INSERT INTO `lang_definitions` VALUES (9197, 2856, 5, 'Supebill Codes Administratie');
INSERT INTO `lang_definitions` VALUES (9198, 2857, 5, 'Superbill Verslag');
INSERT INTO `lang_definitions` VALUES (9199, 2858, 5, 'Superbills, ook wel Contactformulieren of Routing Slips genoemd, vormen een belangrijk deel van de meeste medische praktijken.');
INSERT INTO `lang_definitions` VALUES (9200, 2859, 5, 'Supergebruiker');
INSERT INTO `lang_definitions` VALUES (9201, 2860, 5, 'Supervisie');
INSERT INTO `lang_definitions` VALUES (9202, 2861, 5, 'Surface Type');
INSERT INTO `lang_definitions` VALUES (9203, 2862, 5, 'Operaties');
INSERT INTO `lang_definitions` VALUES (9204, 2863, 5, 'Chirurgie');
INSERT INTO `lang_definitions` VALUES (9205, 2864, 5, 'Geschorst');
INSERT INTO `lang_definitions` VALUES (9206, 2865, 5, 'suspensie');
INSERT INTO `lang_definitions` VALUES (9207, 2866, 5, 'Svc Datum');
INSERT INTO `lang_definitions` VALUES (9208, 2867, 5, 'Svc Datum:');
INSERT INTO `lang_definitions` VALUES (9209, 2868, 5, 'Zweten:');
INSERT INTO `lang_definitions` VALUES (9210, 2869, 5, 'Zweeds');
INSERT INTO `lang_definitions` VALUES (9211, 2870, 5, 'Zwelling');
INSERT INTO `lang_definitions` VALUES (9212, 2871, 5, 'Zwelling rechts');
INSERT INTO `lang_definitions` VALUES (9213, 2872, 5, 'Gezwollen gewrichten');
INSERT INTO `lang_definitions` VALUES (9214, 2873, 5, 'Gezwollen lymfeklieren');
INSERT INTO `lang_definitions` VALUES (9215, 2874, 5, 'Symptomen');
INSERT INTO `lang_definitions` VALUES (9216, 2875, 5, 'Syncope');
INSERT INTO `lang_definitions` VALUES (9217, 2876, 5, 'Synovitis, beknelling, bursitis');
INSERT INTO `lang_definitions` VALUES (9218, 2877, 5, 'Systeem');
INSERT INTO `lang_definitions` VALUES (9219, 2878, 5, 'T');
INSERT INTO `lang_definitions` VALUES (9220, 2879, 5, '3 x daags');
INSERT INTO `lang_definitions` VALUES (9221, 2880, 5, 'T.V.');
INSERT INTO `lang_definitions` VALUES (9222, 2881, 5, 'Aanmaken tabel mislukt');
INSERT INTO `lang_definitions` VALUES (9223, 2882, 5, 'Vernieuwen van tabel mislukt');
INSERT INTO `lang_definitions` VALUES (9224, 2883, 5, 'tablet');
INSERT INTO `lang_definitions` VALUES (9225, 2884, 5, 'Neem');
INSERT INTO `lang_definitions` VALUES (9226, 2885, 5, 'Duurt lang');
INSERT INTO `lang_definitions` VALUES (9227, 2886, 5, 'Belastingtarief');
INSERT INTO `lang_definitions` VALUES (9228, 2887, 5, 'Belasting');
INSERT INTO `lang_definitions` VALUES (9229, 2888, 5, 'Taxonomie');
INSERT INTO `lang_definitions` VALUES (9230, 2889, 5, 'Td');
INSERT INTO `lang_definitions` VALUES (9231, 2890, 5, 'Overzicht van teamletsels');
INSERT INTO `lang_definitions` VALUES (9232, 2891, 5, 'Teamrooster');
INSERT INTO `lang_definitions` VALUES (9233, 2892, 5, 'Overzicht van teamrooster');
INSERT INTO `lang_definitions` VALUES (9234, 2893, 5, 'Tel');
INSERT INTO `lang_definitions` VALUES (9235, 2895, 5, 'Plaats temp.');
INSERT INTO `lang_definitions` VALUES (9236, 2896, 5, 'Methode Temp');
INSERT INTO `lang_definitions` VALUES (9237, 2897, 5, 'Temperatuur');
INSERT INTO `lang_definitions` VALUES (9238, 2898, 5, 'Sjabloon');
INSERT INTO `lang_definitions` VALUES (9239, 2899, 5, 'Naam sjabloon');
INSERT INTO `lang_definitions` VALUES (9240, 2900, 5, 'Namen van sjablonen mogen niet starten met cijfers.');
INSERT INTO `lang_definitions` VALUES (9241, 2901, 5, 'Sjabloon:');
INSERT INTO `lang_definitions` VALUES (9242, 2902, 5, 'Sjablonen');
INSERT INTO `lang_definitions` VALUES (9243, 2903, 5, 'Arteria Temporalis');
INSERT INTO `lang_definitions` VALUES (9244, 2904, 5, 'Peesblesure');
INSERT INTO `lang_definitions` VALUES (9245, 2905, 5, 'Tendinitis /ositis / bursitis');
INSERT INTO `lang_definitions` VALUES (9246, 2906, 5, 'Derde');
INSERT INTO `lang_definitions` VALUES (9247, 2907, 5, 'Derde verzekering');
INSERT INTO `lang_definitions` VALUES (9248, 2908, 5, 'Derde verzekeringsgegevens');
INSERT INTO `lang_definitions` VALUES (9249, 2909, 5, 'Derde verzekeraar ');
INSERT INTO `lang_definitions` VALUES (9250, 2910, 5, 'Test Inplanning');
INSERT INTO `lang_definitions` VALUES (9251, 2911, 5, 'Test het systeem');
INSERT INTO `lang_definitions` VALUES (9252, 2912, 5, 'Datum van tekst');
INSERT INTO `lang_definitions` VALUES (9253, 2913, 5, 'Datum van tekst');
INSERT INTO `lang_definitions` VALUES (9254, 2914, 5, 'Invoerblok voor tekst');
INSERT INTO `lang_definitions` VALUES (9255, 2915, 5, 'Plaats voor tekst');
INSERT INTO `lang_definitions` VALUES (9256, 2916, 5, 'Tekstvak');
INSERT INTO `lang_definitions` VALUES (9257, 2917, 5, 'Tekstvak');
INSERT INTO `lang_definitions` VALUES (9258, 2918, 5, 'Tekstvak lijst');
INSERT INTO `lang_definitions` VALUES (9259, 2919, 5, 'tekstvak lijst');
INSERT INTO `lang_definitions` VALUES (9260, 2920, 5, 'Dank U');
INSERT INTO `lang_definitions` VALUES (9261, 2921, 5, 'Uw claimbestand:');
INSERT INTO `lang_definitions` VALUES (9262, 2922, 5, 'Het bedoelde formulier is afgesloten; er kan geen actie volgen op uw keuze');
INSERT INTO `lang_definitions` VALUES (9263, 2923, 5, 'Gebeurtenis(sen) is goegekeurd');
INSERT INTO `lang_definitions` VALUES (9264, 2924, 5, 'Gebeurtenis(sen) zijn verborgen');
INSERT INTO `lang_definitions` VALUES (9265, 2925, 5, 'De geexporteerde data verschijnt in het tekstveld hieronder. U kunt het kopieren en plakken in een e-mail of iets anders.');
INSERT INTO `lang_definitions` VALUES (9266, 2926, 5, 'De volgende agendagebeurenis is goedgekeurd');
INSERT INTO `lang_definitions` VALUES (9267, 2927, 5, 'De volgende agendagebeurtenis is gewijzigd');
INSERT INTO `lang_definitions` VALUES (9268, 2928, 5, 'De volgende fouten zijn opgetreden');
INSERT INTO `lang_definitions` VALUES (9269, 2929, 5, 'Het oorspronkelijke venster is het factuur zoekpagina. Aan de bovenzijde kunt u een bron (bijvoorbeeld controlenummer), betaaldatum en controlebedrag invoeren. De reden voor de bron en betaaldatum is, dat u ze niet steeds hoeft in te voeren voor elke vordering. Het bedrag dat u invoert zal worden verlaagd voor elke factuur die wordt gegeven met een deel van de betaling, en hopelijk zal eindigen op nul als u klaar bent met betalen.');
INSERT INTO `lang_definitions` VALUES (9270, 2930, 5, 'Het label dat aan de gebruiker wordt getoond op het Formulier');
INSERT INTO `lang_definitions` VALUES (9271, 2931, 5, 'De nieuwe categorie wordt een sub-categorie van');
INSERT INTO `lang_definitions` VALUES (9272, 2932, 5, 'De overige informatie hieronder is alleen van toepassing als u handmatig invoert, of als u handmatige correcties toepast.');
INSERT INTO `lang_definitions` VALUES (9273, 2933, 5, 'Dit gevraagde document is niet aanwezig op de verwachte locatie van het bestandssysteem of u heeft te weinig rechten voor dit document.');
INSERT INTO `lang_definitions` VALUES (9274, 2934, 5, 'De Bron en Datum kolommen zijn gekopieerd van de eerste pagina, dus normaliter hoeft u dit niet aan te passen. U kunt een bedrag in de kolom Betalen invoeren, een aanpassingsbedrag in de kolom Aanpassen invoeren of beide. U kunt ook klikken op \"W\" aan de rechterkant om automatisch een correctie te berekenen, die het restant van de kosten afschrijft.');
INSERT INTO `lang_definitions` VALUES (9275, 2935, 5, 'Het vertaalde label dat wordt weergegeven op het formulier in de huidige taal');
INSERT INTO `lang_definitions` VALUES (9276, 2936, 5, 'De vertaalde titel die zal verschijnen in de huidige taal');
INSERT INTO `lang_definitions` VALUES (9277, 2937, 5, 'De vertaling van de beschrijving in de huidige taal');
INSERT INTO `lang_definitions` VALUES (9278, 2938, 5, 'De X12-bestanden evenals de resulterende HTML output rapporten worden gearchiveerd in de \"ERA\" submap van de hoofd OpenEMR installatie directory. U wilt soms verwijzen naar deze archieven. De URL is');
INSERT INTO `lang_definitions` VALUES (9279, 2939, 5, 'Therapeutische injecties');
INSERT INTO `lang_definitions` VALUES (9280, 2940, 5, 'Er zijn');
INSERT INTO `lang_definitions` VALUES (9281, 2941, 5, 'Er zijn fouten met uw toezending. Deze worden hieronder beschreven.');
INSERT INTO `lang_definitions` VALUES (9282, 2942, 5, 'Er is niets nieuws toegevoegd');
INSERT INTO `lang_definitions` VALUES (9283, 2943, 5, 'Foutje bij versturen van e-mail naar');
INSERT INTO `lang_definitions` VALUES (9284, 2947, 5, 'ER is geen COA ingevoerd voor AR rekening');
INSERT INTO `lang_definitions` VALUES (9285, 2948, 5, 'ER is geen COA ingevoerd voor Cash rekening');
INSERT INTO `lang_definitions` VALUES (9286, 2949, 5, 'Er is geen COA ingevoerd voor inkomsten rekening');
INSERT INTO `lang_definitions` VALUES (9287, 2950, 5, 'Er is geen match voor de factuur id');
INSERT INTO `lang_definitions` VALUES (9288, 2951, 5, 'Er is geen match voor de factuur id =');
INSERT INTO `lang_definitions` VALUES (9289, 2952, 5, 'Er is geen onderdelen invoer mogelijk voor diensten ID');
INSERT INTO `lang_definitions` VALUES (9290, 2953, 5, 'Er is een fout opgetreden bij het verwerken van uw verzoek.');
INSERT INTO `lang_definitions` VALUES (9291, 2954, 5, 'Verdikt rechts');
INSERT INTO `lang_definitions` VALUES (9292, 2955, 5, 'Dijbeen');
INSERT INTO `lang_definitions` VALUES (9293, 2956, 5, 'Dij en hamstrings');
INSERT INTO `lang_definitions` VALUES (9294, 2957, 5, 'Dingen die backoffice kunnen lezen maar niet aanpassen');
INSERT INTO `lang_definitions` VALUES (9295, 2958, 5, 'Dingen die door boekhouding etc. gelezen en aangepast mogen worden');
INSERT INTO `lang_definitions` VALUES (9296, 2959, 5, 'Dingen die kliniekmedewerkers kunnen lezen en invoeren maar niet aanpassen');
INSERT INTO `lang_definitions` VALUES (9297, 2960, 5, 'Dingen die kliniekmedewerkers kunnen lezen en aanpassen');
INSERT INTO `lang_definitions` VALUES (9298, 2961, 5, 'Dingen die de balie kan lezen maar niet aanpassen');
INSERT INTO `lang_definitions` VALUES (9299, 2962, 5, 'Dingen die de balie kan lezen en aanpassen');
INSERT INTO `lang_definitions` VALUES (9300, 2963, 5, 'Dingen die doktoren kunnen lezen en invoeren maar niet aanpassen');
INSERT INTO `lang_definitions` VALUES (9301, 2964, 5, 'Dingen die doktoren kunnen lezen en aanpassen');
INSERT INTO `lang_definitions` VALUES (9302, 2965, 5, 'Derde');
INSERT INTO `lang_definitions` VALUES (9303, 2966, 5, 'Deze actie kan niet ongedaan worden gamaakt.');
INSERT INTO `lang_definitions` VALUES (9304, 2967, 5, 'Deze actie kan NIET ongedaan worden gemaakt.');
INSERT INTO `lang_definitions` VALUES (9305, 2968, 5, 'Dit tyoe code gaat niet samen met relaties.');
INSERT INTO `lang_definitions` VALUES (9306, 2969, 5, 'Dit bezoek');
INSERT INTO `lang_definitions` VALUES (9307, 2971, 5, 'Invoice nummer verandert in');
INSERT INTO `lang_definitions` VALUES (9308, 2972, 5, 'Deze module is in test-modus. De database zal niet worden gewijzigd.');
INSERT INTO `lang_definitions` VALUES (9309, 2973, 5, 'Deze module bevordert efficiënte toegang van EOB gegevens.');
INSERT INTO `lang_definitions` VALUES (9310, 2974, 5, 'Deze pagina zal de login pagina inline toevoegen, zodat we niet ieder keer opnieuw hoeven in te loggen.');
INSERT INTO `lang_definitions` VALUES (9311, 2975, 5, 'Deze patiënt is inacief.');
INSERT INTO `lang_definitions` VALUES (9312, 2976, 5, 'Deze patiënt-ID is al in gebruik!');
INSERT INTO `lang_definitions` VALUES (9313, 2977, 5, 'Deze gebruiker is geen lid van een groep');
INSERT INTO `lang_definitions` VALUES (9314, 2978, 5, 'Het bezoek begint met nieuw contraceptie gebruik');
INSERT INTO `lang_definitions` VALUES (9315, 2979, 5, 'Dit zal een backup aanmaken in tar-formaat, die daarna naar uw webbrowser wordt gezonden zodat u het kunt bewaren');
INSERT INTO `lang_definitions` VALUES (9316, 2980, 5, 'Thoracale wervelkolom');
INSERT INTO `lang_definitions` VALUES (9317, 2981, 5, 'Keel');
INSERT INTO `lang_definitions` VALUES (9318, 2982, 5, 'Keelkanker');
INSERT INTO `lang_definitions` VALUES (9319, 2983, 5, 'Keelkanker chirurgie');
INSERT INTO `lang_definitions` VALUES (9320, 2984, 5, 'Trombose/CVA');
INSERT INTO `lang_definitions` VALUES (9321, 2985, 5, 'don');
INSERT INTO `lang_definitions` VALUES (9322, 2986, 5, 'Donderdag');
INSERT INTO `lang_definitions` VALUES (9323, 2987, 5, 'Donderdag');
INSERT INTO `lang_definitions` VALUES (9324, 2988, 5, 'Schildklier normaal');
INSERT INTO `lang_definitions` VALUES (9325, 2989, 5, 'Schildklierproblemen');
INSERT INTO `lang_definitions` VALUES (9326, 2990, 5, 'TIA');
INSERT INTO `lang_definitions` VALUES (9327, 2991, 5, 'Tijd');
INSERT INTO `lang_definitions` VALUES (9328, 2992, 5, 'Tijdstoename voor Toevoegen (minuten 1-60)');
INSERT INTO `lang_definitions` VALUES (9329, 2993, 5, 'Tijdgebonden gebeurtenis');
INSERT INTO `lang_definitions` VALUES (9330, 2994, 5, 'Keer array (N / A)');
INSERT INTO `lang_definitions` VALUES (9331, 2995, 5, 'Tijdstip en tekst');
INSERT INTO `lang_definitions` VALUES (9332, 2996, 5, 'TIN');
INSERT INTO `lang_definitions` VALUES (9333, 2997, 5, 'Tinnitus');
INSERT INTO `lang_definitions` VALUES (9334, 2998, 5, 'Titel');
INSERT INTO `lang_definitions` VALUES (9335, 2999, 5, 'Titel V');
INSERT INTO `lang_definitions` VALUES (9336, 3000, 5, 'Titels van kolommen moeten nummer hebben tussen 1 en 999');
INSERT INTO `lang_definitions` VALUES (9337, 3001, 5, 'Titels');
INSERT INTO `lang_definitions` VALUES (9338, 3002, 5, 'TM\'S:');
INSERT INTO `lang_definitions` VALUES (9339, 3003, 5, 'TMs / EAM\'s / EE, ext neus');
INSERT INTO `lang_definitions` VALUES (9340, 3004, 5, 'Tot');
INSERT INTO `lang_definitions` VALUES (9341, 3005, 5, 'NAAR');
INSERT INTO `lang_definitions` VALUES (9342, 3006, 5, 'tot');
INSERT INTO `lang_definitions` VALUES (9343, 3007, 5, 'Op aangedane gebied');
INSERT INTO `lang_definitions` VALUES (9344, 3008, 5, 'op aangedane gebied');
INSERT INTO `lang_definitions` VALUES (9345, 3009, 5, 'Naar rekening overzicht');
INSERT INTO `lang_definitions` VALUES (9346, 3010, 5, 'naar categorie');
INSERT INTO `lang_definitions` VALUES (9347, 3011, 5, 'Naar klinisch overzicht');
INSERT INTO `lang_definitions` VALUES (9348, 3012, 5, 'Naar COPAY');
INSERT INTO `lang_definitions` VALUES (9349, 3013, 5, 'Naar akorting');
INSERT INTO `lang_definitions` VALUES (9350, 3014, 5, 'Naar Dems');
INSERT INTO `lang_definitions` VALUES (9351, 3015, 5, 'Naar consultatie');
INSERT INTO `lang_definitions` VALUES (9352, 3016, 5, 'Scheiding adhv geslacht');
INSERT INTO `lang_definitions` VALUES (9353, 3017, 5, 'Naar Historie');
INSERT INTO `lang_definitions` VALUES (9354, 3018, 5, 'Naar problemen');
INSERT INTO `lang_definitions` VALUES (9355, 3019, 5, 'Om dit contact aan een reeds bestaand probleem te koppelen, klikt u op het gewenste probleem hierboven en daarna op [Bewaren]. Houd de [Ctrl] toets ingedrukt als u meerdere problemen tegelijkertijd wilt selecteren.');
INSERT INTO `lang_definitions` VALUES (9356, 3020, 5, 'opnieuw naar inloggen');
INSERT INTO `lang_definitions` VALUES (9357, 3021, 5, 'Op de huid');
INSERT INTO `lang_definitions` VALUES (9358, 3022, 5, 'op de huid');
INSERT INTO `lang_definitions` VALUES (9359, 3023, 5, 'naar deze visite?');
INSERT INTO `lang_definitions` VALUES (9360, 3024, 5, 'Tot:');
INSERT INTO `lang_definitions` VALUES (9361, 3025, 5, 'Tot: ');
INSERT INTO `lang_definitions` VALUES (9362, 3026, 5, 'NAAR_STAD');
INSERT INTO `lang_definitions` VALUES (9363, 3027, 5, 'NAAR_FAX');
INSERT INTO `lang_definitions` VALUES (9364, 3028, 5, 'NAAR_VNAAM');
INSERT INTO `lang_definitions` VALUES (9365, 3029, 5, 'NAAR_ANAAM');
INSERT INTO `lang_definitions` VALUES (9366, 3030, 5, 'NAAR_MNAAM');
INSERT INTO `lang_definitions` VALUES (9367, 3031, 5, 'NAAR_ORGANISATIE');
INSERT INTO `lang_definitions` VALUES (9368, 3032, 5, 'NAAR_POSTKANTOOR');
INSERT INTO `lang_definitions` VALUES (9369, 3033, 5, 'NAAR _STAAT');
INSERT INTO `lang_definitions` VALUES (9370, 3034, 5, 'NAAR_STRAAT');
INSERT INTO `lang_definitions` VALUES (9371, 3035, 5, 'NAAR_TITEL');
INSERT INTO `lang_definitions` VALUES (9372, 3036, 5, 'NAAR_EXTRA-TITELS');
INSERT INTO `lang_definitions` VALUES (9373, 3037, 5, 'Tabak');
INSERT INTO `lang_definitions` VALUES (9374, 3038, 5, 'Tabaksgebruik');
INSERT INTO `lang_definitions` VALUES (9375, 3039, 5, 'Vandaag');
INSERT INTO `lang_definitions` VALUES (9376, 3040, 5, 'Datum van vandaag');
INSERT INTO `lang_definitions` VALUES (9377, 3041, 5, 'Gebeurtenis(sen) vandaag');
INSERT INTO `lang_definitions` VALUES (9378, 3042, 5, 'Tonsilectomie');
INSERT INTO `lang_definitions` VALUES (9379, 3043, 5, 'Hoog');
INSERT INTO `lang_definitions` VALUES (9380, 3044, 5, 'Onderdeel');
INSERT INTO `lang_definitions` VALUES (9381, 3045, 5, 'totaal');
INSERT INTO `lang_definitions` VALUES (9382, 3046, 5, 'Totaal');
INSERT INTO `lang_definitions` VALUES (9383, 3047, 5, 'Totaalbedrag betaald');
INSERT INTO `lang_definitions` VALUES (9384, 3048, 5, 'Totale extra betalingen');
INSERT INTO `lang_definitions` VALUES (9385, 3049, 5, 'Totaal aantal clienten');
INSERT INTO `lang_definitions` VALUES (9386, 3050, 5, 'Totaal voor');
INSERT INTO `lang_definitions` VALUES (9387, 3051, 5, 'Totaal voor ');
INSERT INTO `lang_definitions` VALUES (9388, 3052, 5, 'Toaal voor categorie');
INSERT INTO `lang_definitions` VALUES (9389, 3053, 5, 'Totaal aantal patienten');
INSERT INTO `lang_definitions` VALUES (9390, 3054, 5, 'Totaal SRH & Family planning');
INSERT INTO `lang_definitions` VALUES (9391, 3055, 5, 'Totalen');
INSERT INTO `lang_definitions` VALUES (9392, 3056, 5, 'Totalen voor');
INSERT INTO `lang_definitions` VALUES (9393, 3057, 5, 'Totalen voor');
INSERT INTO `lang_definitions` VALUES (9394, 3058, 5, 'Soort training');
INSERT INTO `lang_definitions` VALUES (9395, 3059, 5, 'Transactie');
INSERT INTO `lang_definitions` VALUES (9396, 3060, 5, 'transactie');
INSERT INTO `lang_definitions` VALUES (9397, 3061, 5, 'Transactie');
INSERT INTO `lang_definitions` VALUES (9398, 3062, 5, 'Transactie type');
INSERT INTO `lang_definitions` VALUES (9399, 3063, 5, 'Transacties');
INSERT INTO `lang_definitions` VALUES (9400, 3064, 5, 'Transacties (schrijven optioneel)');
INSERT INTO `lang_definitions` VALUES (9401, 3065, 5, 'Transactie/Verwijzingen');
INSERT INTO `lang_definitions` VALUES (9402, 3066, 5, 'vertaal dit');
INSERT INTO `lang_definitions` VALUES (9403, 3067, 5, 'Vertaling');
INSERT INTO `lang_definitions` VALUES (9404, 3068, 5, 'Vertalingen');
INSERT INTO `lang_definitions` VALUES (9405, 3069, 5, 'Ongeval');
INSERT INTO `lang_definitions` VALUES (9406, 3070, 5, 'Behandelingsdoelen');
INSERT INTO `lang_definitions` VALUES (9407, 3071, 5, 'Behandelingsplan');
INSERT INTO `lang_definitions` VALUES (9408, 3072, 5, 'Behandeling:');
INSERT INTO `lang_definitions` VALUES (9409, 3073, 5, 'Behandeling:');
INSERT INTO `lang_definitions` VALUES (9410, 3074, 5, 'trftime($month_format, mktime(0, 0, 0, $i, 1, 2000)) ); $month_value');
INSERT INTO `lang_definitions` VALUES (9411, 3075, 5, 'Trigger punt / Compartement Syndroom / DOMS /Cramp');
INSERT INTO `lang_definitions` VALUES (9412, 3076, 5, 'Trimalleolair');
INSERT INTO `lang_definitions` VALUES (9413, 3077, 5, 'Tring[,\'r\'[,');
INSERT INTO `lang_definitions` VALUES (9414, 3078, 5, 'Romp en Abdomen');
INSERT INTO `lang_definitions` VALUES (9415, 3079, 5, 'theelepel');
INSERT INTO `lang_definitions` VALUES (9416, 3080, 5, 'TTS');
INSERT INTO `lang_definitions` VALUES (9417, 3081, 5, 'Tuberculose');
INSERT INTO `lang_definitions` VALUES (9418, 3082, 5, 'Din');
INSERT INTO `lang_definitions` VALUES (9419, 3083, 5, 'Dinsd-Dond');
INSERT INTO `lang_definitions` VALUES (9420, 3084, 5, 'Dinsdag');
INSERT INTO `lang_definitions` VALUES (9421, 3085, 5, 'Tumor');
INSERT INTO `lang_definitions` VALUES (9422, 3086, 5, '2 x daags');
INSERT INTO `lang_definitions` VALUES (9423, 3087, 5, 'Trommelvlies');
INSERT INTO `lang_definitions` VALUES (9424, 3088, 5, 'Soort');
INSERT INTO `lang_definitions` VALUES (9425, 3089, 5, 'Type of scan de patiënt identificator hier');
INSERT INTO `lang_definitions` VALUES (9426, 3090, 5, 'UCSMC codes die door de Universiteit van Calgary Sports Medicine Centre gegeven zijn');
INSERT INTO `lang_definitions` VALUES (9427, 3091, 5, 'Ulceraties');
INSERT INTO `lang_definitions` VALUES (9428, 3092, 5, 'Ulceratieve Colitis');
INSERT INTO `lang_definitions` VALUES (9429, 3093, 5, 'Ulcers:');
INSERT INTO `lang_definitions` VALUES (9430, 3094, 5, 'Maak een keuze');
INSERT INTO `lang_definitions` VALUES (9431, 3095, 5, 'Toegang niet geautoriseerd');
INSERT INTO `lang_definitions` VALUES (9432, 3096, 5, 'onder de tong');
INSERT INTO `lang_definitions` VALUES (9433, 3097, 5, 'Ondergewicht');
INSERT INTO `lang_definitions` VALUES (9434, 3098, 5, 'Niet gediagnostiseerd');
INSERT INTO `lang_definitions` VALUES (9435, 3099, 5, 'Maak Checkout ongedaan');
INSERT INTO `lang_definitions` VALUES (9436, 3100, 5, 'Unieke Klanten');
INSERT INTO `lang_definitions` VALUES (9437, 3101, 5, 'Unieke nieuwe klanten');
INSERT INTO `lang_definitions` VALUES (9438, 3102, 5, 'Unieke Patiënten die gezien werden');
INSERT INTO `lang_definitions` VALUES (9439, 3103, 5, 'Verslag van Unieke Patiënten dee gezien werden');
INSERT INTO `lang_definitions` VALUES (9440, 3104, 5, 'Unieke SP');
INSERT INTO `lang_definitions` VALUES (9441, 3105, 5, 'Eenheid');
INSERT INTO `lang_definitions` VALUES (9442, 3106, 5, 'Eenheden');
INSERT INTO `lang_definitions` VALUES (9443, 3107, 5, 'eenheden');
INSERT INTO `lang_definitions` VALUES (9444, 3108, 5, 'Eenheden moeten een nummer zijn');
INSERT INTO `lang_definitions` VALUES (9445, 3109, 5, 'Onbekend of N/A');
INSERT INTO `lang_definitions` VALUES (9446, 3110, 5, 'Onbekend of N/A');
INSERT INTO `lang_definitions` VALUES (9447, 3111, 5, 'Niet met name genoemd verzekeringsmaatschappij');
INSERT INTO `lang_definitions` VALUES (9448, 3112, 5, 'Niet geregistreerd');
INSERT INTO `lang_definitions` VALUES (9449, 3113, 5, 'Alles deselecteren');
INSERT INTO `lang_definitions` VALUES (9450, 3114, 5, 'Niet geselecteerd');
INSERT INTO `lang_definitions` VALUES (9451, 3115, 5, 'Ongespecificeerd');
INSERT INTO `lang_definitions` VALUES (9452, 3116, 5, 'tot');
INSERT INTO `lang_definitions` VALUES (9453, 3117, 5, 'Onverwachtte aanvulling');
INSERT INTO `lang_definitions` VALUES (9454, 3118, 5, 'Ongebruikt');
INSERT INTO `lang_definitions` VALUES (9455, 3119, 5, 'UOR');
INSERT INTO `lang_definitions` VALUES (9456, 3120, 5, 'Lft tot');
INSERT INTO `lang_definitions` VALUES (9457, 3121, 5, 'Lopende afspraken');
INSERT INTO `lang_definitions` VALUES (9458, 3122, 5, 'Lopende gebeurtenissen');
INSERT INTO `lang_definitions` VALUES (9459, 3123, 5, 'Updaten');
INSERT INTO `lang_definitions` VALUES (9460, 3124, 5, 'Update');
INSERT INTO `lang_definitions` VALUES (9461, 3125, 5, 'Bestanden updaten');
INSERT INTO `lang_definitions` VALUES (9462, 3126, 5, 'Info updaten');
INSERT INTO `lang_definitions` VALUES (9463, 3130, 5, 'Persoonsgegevens updaten is niet toegestaan');
INSERT INTO `lang_definitions` VALUES (9464, 3131, 5, 'Old NPI');
INSERT INTO `lang_definitions` VALUES (9465, 3132, 5, 'Uploaden');
INSERT INTO `lang_definitions` VALUES (9466, 3133, 5, 'Opladen configuratie data');
INSERT INTO `lang_definitions` VALUES (9467, 3134, 5, 'Document uploaden');
INSERT INTO `lang_definitions` VALUES (9468, 3135, 5, 'Uploaden mislukt!');
INSERT INTO `lang_definitions` VALUES (9469, 3136, 5, 'Importbestand uploaden:');
INSERT INTO `lang_definitions` VALUES (9470, 3137, 5, 'Rapport uploaden');
INSERT INTO `lang_definitions` VALUES (9471, 3138, 5, 'Dit bestand uploaden');
INSERT INTO `lang_definitions` VALUES (9472, 3139, 5, 'Bij het klikken op een invoice nummer verschijnt het \"handleiding posting venster\". Hier kunt u de datum en notities voor de factuur veranderen, de naam selecteren voor wie je invoert en de verzekeringen selecteren waarvoor alle te verwachen betalingen zijn ontvangen. Belangrijker, voor elke facturerings code waarvoor een bedrag in rekening werd gebracht, kunt u de betaling en informatie aanpassen.');
INSERT INTO `lang_definitions` VALUES (9473, 3140, 5, 'Bij het zoeken wordt u een lijst van facturen getoond. U klikt op een van de factuurnummers om een tweede venster te openen, waarbij gegevensinvoer in de pagina handmatig gedaan kan worden. U kunt ook klikken op de naam van een patiënt als u een notitie wilt maken voor de front office medewerkers, zodat deze kunnen zien wanneer de patiënt aankomt en u kunt de facturen selecteren die op de statements van de patiënt verschijnen en deze statements afdrukken.');
INSERT INTO `lang_definitions` VALUES (9474, 3141, 5, 'Bovenarm');
INSERT INTO `lang_definitions` VALUES (9475, 3142, 5, 'Urgentie');
INSERT INTO `lang_definitions` VALUES (9476, 3143, 5, 'Urineverlies');
INSERT INTO `lang_definitions` VALUES (9477, 3144, 5, 'Frequentie van mictie');
INSERT INTO `lang_definitions` VALUES (9478, 3145, 5, 'Moeizaam op gang komen mictie');
INSERT INTO `lang_definitions` VALUES (9479, 3146, 5, 'Straal van mictie');
INSERT INTO `lang_definitions` VALUES (9480, 3147, 5, 'Mictie drang');
INSERT INTO `lang_definitions` VALUES (9481, 3148, 5, 'URL');
INSERT INTO `lang_definitions` VALUES (9482, 3150, 5, '24-uurs tijdnotatie?');
INSERT INTO `lang_definitions` VALUES (9483, 3151, 5, 'Gebruik standaard');
INSERT INTO `lang_definitions` VALUES (9484, 3152, 5, 'Gebruik internationale datumstijl?');
INSERT INTO `lang_definitions` VALUES (9485, 3153, 5, 'Gebruik deze mogelijkheid allen bij NIEUW geinstalleerde site,');
INSERT INTO `lang_definitions` VALUES (9486, 3154, 5, 'Gebruik onderwerpen?');
INSERT INTO `lang_definitions` VALUES (9487, 3155, 5, 'Gebruiker');
INSERT INTO `lang_definitions` VALUES (9488, 3156, 5, 'Gebruikers administratie');
INSERT INTO `lang_definitions` VALUES (9489, 3157, 5, 'Gebruiker- en lokatiebeheer');
INSERT INTO `lang_definitions` VALUES (9490, 3158, 5, 'Gebruiker- en groepsbeheer');
INSERT INTO `lang_definitions` VALUES (9491, 3159, 5, 'Door gebruiker aangemaakt');
INSERT INTO `lang_definitions` VALUES (9492, 3160, 5, 'Door gebruiker aangemaakte locatie 11');
INSERT INTO `lang_definitions` VALUES (9493, 3161, 5, 'Door gebruiker aangemaakte locatie 12');
INSERT INTO `lang_definitions` VALUES (9494, 3162, 5, 'Door gebruiker aangemaakt veld');
INSERT INTO `lang_definitions` VALUES (9495, 3163, 5, 'Door gebruiker aangemaakte lijst 1');
INSERT INTO `lang_definitions` VALUES (9496, 3164, 5, 'Door gebruiker aangemaakte lijst 2');
INSERT INTO `lang_definitions` VALUES (9497, 3165, 5, 'Door gebruiker aangemaakte lijst 3');
INSERT INTO `lang_definitions` VALUES (9498, 3166, 5, 'Door gebruiker aangemaakte lijst 4');
INSERT INTO `lang_definitions` VALUES (9499, 3167, 5, 'Door gebruiker aangemakte lijst 5');
INSERT INTO `lang_definitions` VALUES (9500, 3168, 5, 'Door gebruiker aangemakte lijst 6');
INSERT INTO `lang_definitions` VALUES (9501, 3169, 5, 'Door gebruiker aangemakte lijst 7');
INSERT INTO `lang_definitions` VALUES (9502, 3170, 5, 'Door gebruiker aangemaakte tekst 1');
INSERT INTO `lang_definitions` VALUES (9503, 3171, 5, 'Door gebruiker aangemaakte tekst 2');
INSERT INTO `lang_definitions` VALUES (9504, 3172, 5, 'Door gebruiker aangemaakte tekst 3');
INSERT INTO `lang_definitions` VALUES (9505, 3173, 5, 'Door gebruiker aangemaakte tekst 4');
INSERT INTO `lang_definitions` VALUES (9506, 3174, 5, 'Door gebruiker aangemaakte tekst 5');
INSERT INTO `lang_definitions` VALUES (9507, 3175, 5, 'Door gebruiker aangemaakte tekst 6');
INSERT INTO `lang_definitions` VALUES (9508, 3176, 5, 'Door gebruiker aangemaakte tekst 7');
INSERT INTO `lang_definitions` VALUES (9509, 3177, 5, 'Door gebruiker aangemaakte tekst 8');
INSERT INTO `lang_definitions` VALUES (9510, 3178, 5, 'Gebruikers handleiding');
INSERT INTO `lang_definitions` VALUES (9511, 3179, 5, 'Gebruiker groepsindeling');
INSERT INTO `lang_definitions` VALUES (9512, 3180, 5, 'Gebruiker');
INSERT INTO `lang_definitions` VALUES (9513, 3181, 5, 'Gebruikersnaam voor SMS Gateway');
INSERT INTO `lang_definitions` VALUES (9514, 3182, 5, 'Gebruiker:');
INSERT INTO `lang_definitions` VALUES (9515, 3183, 5, 'Gebruikers');
INSERT INTO `lang_definitions` VALUES (9516, 3184, 5, 'Gebruikers/Groepen/Logs/Administratie');
INSERT INTO `lang_definitions` VALUES (9517, 3185, 5, 'gebruikt php <a href=\"http://php.net/strftime\"></a> format');
INSERT INTO `lang_definitions` VALUES (9518, 3186, 5, 'UTI');
INSERT INTO `lang_definitions` VALUES (9519, 3187, 5, 'VAKANTIE');
INSERT INTO `lang_definitions` VALUES (9520, 3188, 5, 'Vakantie');
INSERT INTO `lang_definitions` VALUES (9521, 3189, 5, 'Vaccin');
INSERT INTO `lang_definitions` VALUES (9522, 3190, 5, 'Pessarium');
INSERT INTO `lang_definitions` VALUES (9523, 3191, 5, 'Extra Titels');
INSERT INTO `lang_definitions` VALUES (9524, 3192, 5, 'Waarde 1');
INSERT INTO `lang_definitions` VALUES (9525, 3193, 5, 'Waarde 2');
INSERT INTO `lang_definitions` VALUES (9526, 3194, 5, 'Var1');
INSERT INTO `lang_definitions` VALUES (9527, 3195, 5, 'Var2');
INSERT INTO `lang_definitions` VALUES (9528, 3196, 5, 'Varicella');
INSERT INTO `lang_definitions` VALUES (9529, 3197, 5, 'Varicella');
INSERT INTO `lang_definitions` VALUES (9530, 3198, 5, 'Spataderen');
INSERT INTO `lang_definitions` VALUES (9531, 3199, 5, 'Vaatconditie');
INSERT INTO `lang_definitions` VALUES (9532, 3200, 5, 'Vasculair ongeluk');
INSERT INTO `lang_definitions` VALUES (9533, 3201, 5, 'Vaatchirurgie');
INSERT INTO `lang_definitions` VALUES (9534, 3202, 5, 'Versie');
INSERT INTO `lang_definitions` VALUES (9535, 3203, 5, 'Vertigo');
INSERT INTO `lang_definitions` VALUES (9536, 3204, 5, 'Veterans Administration Plan');
INSERT INTO `lang_definitions` VALUES (9537, 3205, 5, 'Scherm');
INSERT INTO `lang_definitions` VALUES (9538, 3206, 5, 'Bekijken');
INSERT INTO `lang_definitions` VALUES (9539, 3207, 5, 'Bekijk allergien');
INSERT INTO `lang_definitions` VALUES (9540, 3208, 5, 'Bekijk beknopt rapport van patient');
INSERT INTO `lang_definitions` VALUES (9541, 3209, 5, 'Bekijk document');
INSERT INTO `lang_definitions` VALUES (9542, 3210, 5, 'Bekijk contact');
INSERT INTO `lang_definitions` VALUES (9543, 3211, 5, 'Evenementen in een popup-venster bekijken?');
INSERT INTO `lang_definitions` VALUES (9544, 3212, 5, 'Bekijk pagina 1');
INSERT INTO `lang_definitions` VALUES (9545, 3213, 5, 'Bekijk pagina 2');
INSERT INTO `lang_definitions` VALUES (9546, 3214, 5, 'Bekijk gerelateerde contacten');
INSERT INTO `lang_definitions` VALUES (9547, 3216, 5, 'Scherm:');
INSERT INTO `lang_definitions` VALUES (9548, 3217, 5, 'VISA');
INSERT INTO `lang_definitions` VALUES (9549, 3218, 5, 'Viscerale schade / trauma / chirurgie');
INSERT INTO `lang_definitions` VALUES (9550, 3219, 5, 'Contact categorie:');
INSERT INTO `lang_definitions` VALUES (9551, 3220, 5, 'Datum contact');
INSERT INTO `lang_definitions` VALUES (9552, 3221, 5, 'Bezoek formulier');
INSERT INTO `lang_definitions` VALUES (9553, 3222, 5, 'Consultatie');
INSERT INTO `lang_definitions` VALUES (9554, 3223, 5, 'Bezoeken vanaf');
INSERT INTO `lang_definitions` VALUES (9555, 3225, 5, 'Vitale geg.');
INSERT INTO `lang_definitions` VALUES (9556, 3226, 5, 'Vitale geg.(Metriek OUD)');
INSERT INTO `lang_definitions` VALUES (9557, 3228, 5, 'Braken');
INSERT INTO `lang_definitions` VALUES (9558, 3229, 5, 'W');
INSERT INTO `lang_definitions` VALUES (9559, 3230, 5, 'Buikomv');
INSERT INTO `lang_definitions` VALUES (9560, 3231, 5, 'Buikomvang');
INSERT INTO `lang_definitions` VALUES (9561, 3232, 5, 'Wachtende');
INSERT INTO `lang_definitions` VALUES (9562, 3233, 5, 'Binnen gelopen');
INSERT INTO `lang_definitions` VALUES (9563, 3234, 5, 'Walt Pennington ( Pimm en Rob; een klein beetje) ');
INSERT INTO `lang_definitions` VALUES (9564, 3235, 5, 'Warm');
INSERT INTO `lang_definitions` VALUES (9565, 3236, 5, 'Waarschuwing');
INSERT INTO `lang_definitions` VALUES (9566, 3237, 5, 'Waarschuwing: Er is vandaag voor deze patiënt al een bezoek aangemaakt!');
INSERT INTO `lang_definitions` VALUES (9567, 3238, 5, 'Waarschuwing: patiënt-ID is niet uniek!');
INSERT INTO `lang_definitions` VALUES (9568, 3239, 5, 'WAARSCHUWING: Data worden overschreven met ge-upload-de file');
INSERT INTO `lang_definitions` VALUES (9569, 3240, 5, 'We hebben de bovenstaande patient voor evaluatie en behandeling gezien op onze psychiatrische polikliniek. Bedankt voor deze verwijzing.');
INSERT INTO `lang_definitions` VALUES (9570, 3241, 5, 'Zwakheid');
INSERT INTO `lang_definitions` VALUES (9571, 3242, 5, 'Website');
INSERT INTO `lang_definitions` VALUES (9572, 3243, 5, 'Woe');
INSERT INTO `lang_definitions` VALUES (9573, 3244, 5, 'Woensdag');
INSERT INTO `lang_definitions` VALUES (9574, 3245, 5, 'week');
INSERT INTO `lang_definitions` VALUES (9575, 3246, 5, 'week');
INSERT INTO `lang_definitions` VALUES (9576, 3247, 5, 'Weekoverzicht');
INSERT INTO `lang_definitions` VALUES (9577, 3248, 5, 'Week(en)');
INSERT INTO `lang_definitions` VALUES (9578, 3249, 5, 'Gewicht');
INSERT INTO `lang_definitions` VALUES (9579, 3250, 5, 'Gewichtverandering');
INSERT INTO `lang_definitions` VALUES (9580, 3251, 5, 'Gewichtsverlies');
INSERT INTO `lang_definitions` VALUES (9581, 3252, 5, 'Wat moet geteld worden?');
INSERT INTO `lang_definitions` VALUES (9582, 3253, 5, 'Piepende:');
INSERT INTO `lang_definitions` VALUES (9583, 3254, 5, 'Piepend');
INSERT INTO `lang_definitions` VALUES (9584, 3255, 5, 'Piepende ademhaling:');
INSERT INTO `lang_definitions` VALUES (9585, 3256, 5, 'Waar kunnen gescande of papieren documenten worden gevonden?');
INSERT INTO `lang_definitions` VALUES (9586, 3257, 5, 'Whiplash');
INSERT INTO `lang_definitions` VALUES (9587, 3258, 5, 'Wie');
INSERT INTO `lang_definitions` VALUES (9588, 3259, 5, 'Wie antwoordde?');
INSERT INTO `lang_definitions` VALUES (9589, 3260, 5, 'Partner overleden');
INSERT INTO `lang_definitions` VALUES (9590, 3261, 5, 'Met geselecteerd als:');
INSERT INTO `lang_definitions` VALUES (9591, 3262, 5, 'met de oude naam');
INSERT INTO `lang_definitions` VALUES (9592, 3263, 5, 'Bij wie kunnen we een bericht achterlaten?');
INSERT INTO `lang_definitions` VALUES (9593, 3264, 5, 'binnen de uren');
INSERT INTO `lang_definitions` VALUES (9594, 3265, 5, 'binnen de uren:');
INSERT INTO `lang_definitions` VALUES (9595, 3266, 5, 'binnen minuten');
INSERT INTO `lang_definitions` VALUES (9596, 3267, 5, 'binnen minuten:');
INSERT INTO `lang_definitions` VALUES (9597, 3268, 5, 'Zonder update');
INSERT INTO `lang_definitions` VALUES (9598, 3269, 5, 'Getuige');
INSERT INTO `lang_definitions` VALUES (9599, 3270, 5, 'WNL');
INSERT INTO `lang_definitions` VALUES (9600, 3271, 5, 'Vrouwen');
INSERT INTO `lang_definitions` VALUES (9601, 3272, 5, 'Alleen vrouwen');
INSERT INTO `lang_definitions` VALUES (9602, 3273, 5, 'Werk');
INSERT INTO `lang_definitions` VALUES (9603, 3274, 5, 'WERKNOTITIE');
INSERT INTO `lang_definitions` VALUES (9604, 3275, 5, 'Telefoon werk');
INSERT INTO `lang_definitions` VALUES (9605, 3276, 5, 'Telefoon werk');
INSERT INTO `lang_definitions` VALUES (9606, 3277, 5, 'Werk gerelateerd?');
INSERT INTO `lang_definitions` VALUES (9607, 3278, 5, 'Werk/Scholing/Hobbies');
INSERT INTO `lang_definitions` VALUES (9608, 3279, 5, 'Werk-/Schoolverklaring');
INSERT INTO `lang_definitions` VALUES (9609, 3280, 5, 'werkdag');
INSERT INTO `lang_definitions` VALUES (9610, 3281, 5, 'Arbeidsongeschiktheidsvoorziening');
INSERT INTO `lang_definitions` VALUES (9611, 3282, 5, 'Verslechterd');
INSERT INTO `lang_definitions` VALUES (9612, 3283, 5, 'Pols');
INSERT INTO `lang_definitions` VALUES (9613, 3284, 5, 'Pols en hand');
INSERT INTO `lang_definitions` VALUES (9614, 3285, 5, 'Polsproblemen');
INSERT INTO `lang_definitions` VALUES (9615, 3286, 5, 'schrijven');
INSERT INTO `lang_definitions` VALUES (9616, 3287, 5, 'Afschrijving');
INSERT INTO `lang_definitions` VALUES (9617, 3288, 5, 'met enkele');
INSERT INTO `lang_definitions` VALUES (9618, 3290, 5, 'x Geannulleerd');
INSERT INTO `lang_definitions` VALUES (9619, 3291, 5, 'Rontgenfoto');
INSERT INTO `lang_definitions` VALUES (9620, 3292, 5, 'Rontgenverslag:');
INSERT INTO `lang_definitions` VALUES (9621, 3293, 5, 'Rontgenverslag:');
INSERT INTO `lang_definitions` VALUES (9622, 3294, 5, 'Alleen X12: Vervangingsclaim');
INSERT INTO `lang_definitions` VALUES (9623, 3295, 5, 'X12-partner');
INSERT INTO `lang_definitions` VALUES (9624, 3296, 5, 'X12-partners');
INSERT INTO `lang_definitions` VALUES (9625, 3297, 5, 'Y');
INSERT INTO `lang_definitions` VALUES (9626, 3298, 5, 'jaar');
INSERT INTO `lang_definitions` VALUES (9627, 3299, 5, 'Jaar');
INSERT INTO `lang_definitions` VALUES (9628, 3300, 5, 'Jaaroverzicht');
INSERT INTO `lang_definitions` VALUES (9629, 3301, 5, 'Jaar(en)');
INSERT INTO `lang_definitions` VALUES (9630, 3302, 5, 'JA');
INSERT INTO `lang_definitions` VALUES (9631, 3303, 5, 'Ja');
INSERT INTO `lang_definitions` VALUES (9632, 3304, 5, 'ja');
INSERT INTO `lang_definitions` VALUES (9633, 3305, 5, 'JA !!');
INSERT INTO `lang_definitions` VALUES (9634, 3306, 5, 'Ja, Verwijderen en Log maken');
INSERT INTO `lang_definitions` VALUES (9635, 3307, 5, 'Ja/Nee');
INSERT INTO `lang_definitions` VALUES (9636, 3308, 5, 'Ja:');
INSERT INTO `lang_definitions` VALUES (9637, 3309, 5, 'U gaat dit bestaande sjabloon voorgoed vervangen. Wilt u doorgaan?');
INSERT INTO `lang_definitions` VALUES (9638, 3310, 5, 'U mag deze gebeurtenis niet verwijderen');
INSERT INTO `lang_definitions` VALUES (9639, 3311, 5, 'U mag deze gebeurtenis niet anpasssen');
INSERT INTO `lang_definitions` VALUES (9640, 3312, 5, 'U bent hiervoor niet geautoriseerd');
INSERT INTO `lang_definitions` VALUES (9641, 3313, 5, 'U heeft geen bevoegdheid voor deze ploeg');
INSERT INTO `lang_definitions` VALUES (9642, 3314, 5, 'U heeft geen bevoegdheid om problemen toe te voegen/aan te passen');
INSERT INTO `lang_definitions` VALUES (9643, 3315, 5, 'U heeft geen bevoegdheid om dit contact te bekijken.');
INSERT INTO `lang_definitions` VALUES (9644, 3316, 5, 'U kunt deze functie niet direct benaderen');
INSERT INTO `lang_definitions` VALUES (9645, 3317, 5, 'U kunt deze pagina niet direct benaderen');
INSERT INTO `lang_definitions` VALUES (9646, 3321, 5, 'U heeft geen keuze gemaakt');
INSERT INTO `lang_definitions` VALUES (9647, 3322, 5, 'U heeft geen toegang om deze notitie te bekijken/aan te passen');
INSERT INTO `lang_definitions` VALUES (9648, 3324, 5, 'Uw moet eerst een patient selecteren of toevoegen.');
INSERT INTO `lang_definitions` VALUES (9649, 3325, 5, 'U moet eerst een bezoek selecteren of aanmaken. ');
INSERT INTO `lang_definitions` VALUES (9650, 3326, 5, 'U moet enige velden selecteren om door te gaan.');
INSERT INTO `lang_definitions` VALUES (9651, 3327, 5, 'U moet deze test uitvoeren indien deze claim met succes gegenereerd is, maar de daadwerkelijke claim-file geen gegevens bevat of slechts een onvoltooid gedeelte van de hoeveelheid gegevens die zij geacht wordt te bevatten. Het is duidelijk met HCFA vorderingen, omdat ze de menselijke leesbare tekst aanmaken. Met X12 claims is proces matig moeilijker om te bepalen of de claim juist is aangemaakt.');
INSERT INTO `lang_definitions` VALUES (9652, 3328, 5, 'Uw eindatum is ongeldig');
INSERT INTO `lang_definitions` VALUES (9653, 3329, 5, 'Uw gebeurtenis is verwijderd.');
INSERT INTO `lang_definitions` VALUES (9654, 3330, 5, 'Gebeurtenis is aangepast.');
INSERT INTO `lang_definitions` VALUES (9655, 3331, 5, 'Gebeurtenis is toegevoegd.');
INSERT INTO `lang_definitions` VALUES (9656, 3332, 5, 'U lijstnaam is veranderd om aan de naamvereisten tegemoet te komen.');
INSERT INTO `lang_definitions` VALUES (9657, 3333, 5, 'Uw PostCalender configuratie is hersteld naar de oorspronkelijke gegevens');
INSERT INTO `lang_definitions` VALUES (9658, 3334, 5, 'Us PostCalender configuratie is aangepast');
INSERT INTO `lang_definitions` VALUES (9659, 3335, 5, 'Uw herhalingsfrequentie moet een getal zijn');
INSERT INTO `lang_definitions` VALUES (9660, 3336, 5, 'Aantal herhalingen moet minstens 1 zijn');
INSERT INTO `lang_definitions` VALUES (9661, 3337, 5, 'Uw begindatum is later dan einddatum');
INSERT INTO `lang_definitions` VALUES (9662, 3338, 5, 'Uw begindatum is ongeldig');
INSERT INTO `lang_definitions` VALUES (9663, 3339, 5, 'Uw toezending is mislukt');
INSERT INTO `lang_definitions` VALUES (9664, 3340, 5, 'jjjj-mm-dd');
INSERT INTO `lang_definitions` VALUES (9665, 3341, 5, 'jjjj-mm-dd datum geassocieerd met dit document');
INSERT INTO `lang_definitions` VALUES (9666, 3342, 5, 'jjjj-mm-dd datum vernietigd');
INSERT INTO `lang_definitions` VALUES (9667, 3343, 5, 'jjjj-mm-dd Geb Datum');
INSERT INTO `lang_definitions` VALUES (9668, 3344, 5, 'jjjj-mm-dd geb datum');
INSERT INTO `lang_definitions` VALUES (9669, 3345, 5, 'jjjj-mm-dd datum verloop');
INSERT INTO `lang_definitions` VALUES (9670, 3346, 5, 'jjjj-mm-dd datun begin hospitalisatie');
INSERT INTO `lang_definitions` VALUES (9671, 3347, 5, 'jjjj-mm-dd datum begin, chirurgie, of begin medicatie');
INSERT INTO `lang_definitions` VALUES (9672, 3348, 5, 'jjjj-mm-dd datum van herstel of beeindiging medicatie');
INSERT INTO `lang_definitions` VALUES (9673, 3349, 5, 'jjjj-mm-dd datum return wedstrijd');
INSERT INTO `lang_definitions` VALUES (9674, 3350, 5, 'jjjj-mm-dd datum van Service');
INSERT INTO `lang_definitions` VALUES (9675, 3351, 5, 'jjjj-mm-dd datum van deze brief');
INSERT INTO `lang_definitions` VALUES (9676, 3352, 5, 'jjjj-mm-dd datum van return wedstrijd');
INSERT INTO `lang_definitions` VALUES (9677, 3353, 5, 'jjjj-mm-dd datum dit document');
INSERT INTO `lang_definitions` VALUES (9678, 3354, 5, 'jjjj-mm-dd gebeurtenis of begindatum');
INSERT INTO `lang_definitions` VALUES (9679, 3355, 5, 'jjjj-mm-dd laatste datum van gebeurtenis');
INSERT INTO `lang_definitions` VALUES (9680, 3356, 5, 'Nul');
INSERT INTO `lang_definitions` VALUES (9681, 3357, 5, 'Postcode');
INSERT INTO `lang_definitions` VALUES (9682, 3358, 5, 'Postcode');
INSERT INTO `lang_definitions` VALUES (9683, 3359, 5, 'Postcode/Land:');
INSERT INTO `lang_definitions` VALUES (9684, 3360, 5, 'maar was');
INSERT INTO `lang_definitions` VALUES (9685, 3361, 5, 'kon niet bereikt worden');
INSERT INTO `lang_definitions` VALUES (9686, 3362, 5, 'ZEKER verwijderen?');
INSERT INTO `lang_definitions` VALUES (9687, 3363, 5, 'Medicijn');
INSERT INTO `lang_definitions` VALUES (9688, 3364, 5, 'e-mails niet verzonden');
INSERT INTO `lang_definitions` VALUES (9689, 3365, 5, 'van');
INSERT INTO `lang_definitions` VALUES (9690, 3366, 5, 'is aangemaakt');
INSERT INTO `lang_definitions` VALUES (9691, 3367, 5, 'is opnieuw geopend');
INSERT INTO `lang_definitions` VALUES (9692, 3368, 5, 'Geschiedenis');
INSERT INTO `lang_definitions` VALUES (9693, 3369, 5, 'het is geen nummer');
INSERT INTO `lang_definitions` VALUES (9694, 3370, 5, 'opnieuw rekening sturen OK');
INSERT INTO `lang_definitions` VALUES (9695, 3371, 5, 'LLL:');
INSERT INTO `lang_definitions` VALUES (9696, 3372, 5, 'Perceel');
INSERT INTO `lang_definitions` VALUES (9697, 3373, 5, 'Origineel Medicaid Referentie No.');
INSERT INTO `lang_definitions` VALUES (9698, 3374, 5, 'min');
INSERT INTO `lang_definitions` VALUES (9699, 3375, 5, 'niet gevonden!');
INSERT INTO `lang_definitions` VALUES (9700, 3376, 5, 'Onverwachte resultaten in bepaalde BROWSERS kunnen er de oorzaak van zijn dat de tekst in schokken op het scherm komt met lange pauzes, waardoor het lijkt of het programma vastgelopen is. Uiteindelijk komt het resultaat lijn voor lijn op het scherm.Er kunnen daarna sequentiele nummers getoond worden, dit is hoewel er niets lijkt te gebeuren er nog wel degelijk programma activiteit gaande is. Deze nummers worden getoond met tussenvoeging van stukjes opgemaakte rekeningen en dit alles is normaal.');
INSERT INTO `lang_definitions` VALUES (9701, 3377, 5, 'voorschrift heeft limiet bereikt van');
INSERT INTO `lang_definitions` VALUES (9702, 3378, 5, 'tot');
INSERT INTO `lang_definitions` VALUES (9703, 3379, 5, 'update mislukt, niet in DB?');
INSERT INTO `lang_definitions` VALUES (9704, 3380, 5, 'gemarkeerd als \"alleen factureren\"');
INSERT INTO `lang_definitions` VALUES (9705, 3381, 5, 'succesvol in wachtrij');
INSERT INTO `lang_definitions` VALUES (9706, 3382, 5, '! Vertrokken zonder bezoek Dr');
INSERT INTO `lang_definitions` VALUES (9707, 3383, 5, '\" voor code');
INSERT INTO `lang_definitions` VALUES (9708, 3384, 5, '\" is geCHECKED in POST CALENDER settings');
INSERT INTO `lang_definitions` VALUES (9709, 3385, 5, '# ins/fin probleem');
INSERT INTO `lang_definitions` VALUES (9710, 3386, 5, '# aantal tabletten');
INSERT INTO `lang_definitions` VALUES (9711, 3387, 5, 'NAF');
INSERT INTO `lang_definitions` VALUES (9712, 3388, 5, '$ Gecodeerd');
INSERT INTO `lang_definitions` VALUES (9713, 3389, 5, 'NAF 1,00');
INSERT INTO `lang_definitions` VALUES (9714, 3390, 5, '$label (jjjj-mm-dd)');
INSERT INTO `lang_definitions` VALUES (9715, 3391, 5, '%');
INSERT INTO `lang_definitions` VALUES (9716, 3392, 5, '% Geannulleerd < 24 uur');
INSERT INTO `lang_definitions` VALUES (9717, 3393, 5, 'zou moeten bestaan maar bestaat niet');
INSERT INTO `lang_definitions` VALUES (9718, 3394, 5, '(% komt overeen met elke string _ komt overeen met elk teken)');
INSERT INTO `lang_definitions` VALUES (9719, 3395, 5, '(Terug)');
INSERT INTO `lang_definitions` VALUES (9720, 3396, 5, '(Klik om aan te passen)');
INSERT INTO `lang_definitions` VALUES (9721, 3397, 5, '(meer)');
INSERT INTO `lang_definitions` VALUES (9722, 3398, 5, '(Nieuwe patient)');
INSERT INTO `lang_definitions` VALUES (9723, 3399, 5, '(Notities en Autorisaties)');
INSERT INTO `lang_definitions` VALUES (9724, 3400, 5, '(Patient Notitie)');
INSERT INTO `lang_definitions` VALUES (9725, 3401, 5, '(Selecteer een van deze of voer uw eigen titel in)');
INSERT INTO `lang_definitions` VALUES (9726, 3402, 5, '* Herinnering verstuurd');
INSERT INTO `lang_definitions` VALUES (9727, 3403, 5, '** AUB verplaats chirurgie naar problemen!');
INSERT INTO `lang_definitions` VALUES (9728, 3404, 5, '*Verplicht');
INSERT INTO `lang_definitions` VALUES (9729, 3405, 5, '+ Status opgezocht');
INSERT INTO `lang_definitions` VALUES (9730, 3406, 5, '.');
INSERT INTO `lang_definitions` VALUES (9731, 3407, 5, '0-10');
INSERT INTO `lang_definitions` VALUES (9732, 3408, 5, '1. Rust houden 2. IJscompressen gedurende twee dagen 3. Druk uitoefenen, laat verband zitten tenzij de voet gevoelloos wordt of bleek 4. Voet en been hoogleggen');
INSERT INTO `lang_definitions` VALUES (9733, 3409, 5, '11/14/09');
INSERT INTO `lang_definitions` VALUES (9734, 3410, 5, '15-19');
INSERT INTO `lang_definitions` VALUES (9735, 3411, 5, '20-24');
INSERT INTO `lang_definitions` VALUES (9736, 3412, 5, '2111-13');
INSERT INTO `lang_definitions` VALUES (9737, 3413, 5, '25-29');
INSERT INTO `lang_definitions` VALUES (9738, 3414, 5, '2e');
INSERT INTO `lang_definitions` VALUES (9739, 3415, 5, '3 maanden');
INSERT INTO `lang_definitions` VALUES (9740, 3416, 5, '3 x daags');
INSERT INTO `lang_definitions` VALUES (9741, 3417, 5, '30-34');
INSERT INTO `lang_definitions` VALUES (9742, 3418, 5, '35-39');
INSERT INTO `lang_definitions` VALUES (9743, 3419, 5, '3e');
INSERT INTO `lang_definitions` VALUES (9744, 3420, 5, '4 maanden');
INSERT INTO `lang_definitions` VALUES (9745, 3421, 5, '4 x daags');
INSERT INTO `lang_definitions` VALUES (9746, 3422, 5, '40-44');
INSERT INTO `lang_definitions` VALUES (9747, 3423, 5, '45');
INSERT INTO `lang_definitions` VALUES (9748, 3424, 5, '465.9, Bovenste luchtweg inf');
INSERT INTO `lang_definitions` VALUES (9749, 3425, 5, '466.0 Bronchitis, Acuut Niet nader gespecificeerd');
INSERT INTO `lang_definitions` VALUES (9750, 3426, 5, '486.0, Pneumonie, Acuut');
INSERT INTO `lang_definitions` VALUES (9751, 3427, 5, '491.21, COPD Exacerbatie');
INSERT INTO `lang_definitions` VALUES (9752, 3428, 5, '481.8 Bronchitis, Chronisch');
INSERT INTO `lang_definitions` VALUES (9753, 3429, 5, '483.92 Astma, Acute exacerbatie');
INSERT INTO `lang_definitions` VALUES (9754, 3430, 5, '496,0 COPD');
INSERT INTO `lang_definitions` VALUES (9755, 3431, 5, '4e');
INSERT INTO `lang_definitions` VALUES (9756, 3432, 5, '519.7, Bronchospasme');
INSERT INTO `lang_definitions` VALUES (9757, 3433, 5, '5e');
INSERT INTO `lang_definitions` VALUES (9758, 3434, 5, '6 maanden');
INSERT INTO `lang_definitions` VALUES (9759, 3435, 5, '6e');
INSERT INTO `lang_definitions` VALUES (9760, 3436, 5, '824.0 Fractuur, mediale malleolus, gesloten');
INSERT INTO `lang_definitions` VALUES (9761, 3437, 5, '824.2 Fractuur, laterale malleolus, gesloten');
INSERT INTO `lang_definitions` VALUES (9762, 3438, 5, '824.6 Fractruur, trimeleoliar, gesloten');
INSERT INTO `lang_definitions` VALUES (9763, 3439, 5, '825.32, Fractuur os naviculare (enkel)');
INSERT INTO `lang_definitions` VALUES (9764, 3440, 5, '824.35 Fractuur, basis 5e metatarsale');
INSERT INTO `lang_definitions` VALUES (9765, 3441, 5, '845.00 Enkel verstuiking NS');
INSERT INTO `lang_definitions` VALUES (9766, 3442, 5, '845.01 Verstuiking mediale (Deltoideus) Lig.');
INSERT INTO `lang_definitions` VALUES (9767, 3443, 5, '845.02 Verstuiking, calcaneo-fibulare');
INSERT INTO `lang_definitions` VALUES (9768, 3444, 5, '99212 Vastgesteld - ongecompliceerd');
INSERT INTO `lang_definitions` VALUES (9769, 3445, 5, '99213 Vastgesteld - weinig complex');
INSERT INTO `lang_definitions` VALUES (9770, 3446, 5, '< In onderzoekskamer');
INSERT INTO `lang_definitions` VALUES (9771, 3447, 5, '> Weggegaan');
INSERT INTO `lang_definitions` VALUES (9772, 3448, 5, '? Niet verschenen');
INSERT INTO `lang_definitions` VALUES (9773, 3449, 5, '@ Is verschenen');
INSERT INTO `lang_definitions` VALUES (9774, 3450, 5, '[Verander scherm]');
INSERT INTO `lang_definitions` VALUES (9775, 3451, 5, '[Datum laatste bezoek]');
INSERT INTO `lang_definitions` VALUES (9776, 3452, 5, '[Dgn sinds vorige bezoek]');
INSERT INTO `lang_definitions` VALUES (9777, 3453, 5, '[EOBs]');
INSERT INTO `lang_definitions` VALUES (9778, 3454, 5, '[Export OFX]');
INSERT INTO `lang_definitions` VALUES (9779, 3455, 5, '[niet aanbevolen]');
INSERT INTO `lang_definitions` VALUES (9780, 3456, 5, '[Aantal bezoeken]');
INSERT INTO `lang_definitions` VALUES (9781, 3457, 5, '[Verslagen]');
INSERT INTO `lang_definitions` VALUES (9782, 3458, 5, '[Selecteer alles]');
INSERT INTO `lang_definitions` VALUES (9783, 3459, 5, '[SQL Grootboek]');
INSERT INTO `lang_definitions` VALUES (9784, 3460, 5, '[Begin batch-verwerking]');
INSERT INTO `lang_definitions` VALUES (9785, 3461, 5, '[bekijk log]');
INSERT INTO `lang_definitions` VALUES (9786, 3462, 5, '[Bekijk voorbeeld]');
INSERT INTO `lang_definitions` VALUES (9787, 3463, 5, '_PC_DUR_HOURS');
INSERT INTO `lang_definitions` VALUES (9788, 3464, 5, '_PC_DUR_MINUTES');
INSERT INTO `lang_definitions` VALUES (9789, 3465, 5, '_PC_LOCALE');
INSERT INTO `lang_definitions` VALUES (9790, 3466, 5, '~ Te laat aangekomen');
INSERT INTO `lang_definitions` VALUES (9791, 2, 7, 'numero de cheque ou numero de reclamation pour identifiier le paiement.');
INSERT INTO `lang_definitions` VALUES (9792, 4, 7, 'numero de lot est exige!');
INSERT INTO `lang_definitions` VALUES (9793, 5, 7, 'le code relatif au IPPF.');
INSERT INTO `lang_definitions` VALUES (9794, 6, 7, 'Une valeur unique afin d\'identifier le domaine non visible pour l\'utilisateur.');
INSERT INTO `lang_definitions` VALUES (9795, 7, 7, 'Avant les repas');
INSERT INTO `lang_definitions` VALUES (9796, 8, 7, 'Le matin');
INSERT INTO `lang_definitions` VALUES (9797, 9, 7, 'Fluiditte d\'air au niveau de l\'oreille droite');
INSERT INTO `lang_definitions` VALUES (9798, 12, 7, 'Absces');
INSERT INTO `lang_definitions` VALUES (9799, 13, 7, 'Abdominal');
INSERT INTO `lang_definitions` VALUES (9800, 14, 7, 'capable de supporter le poids de 4 marches');
INSERT INTO `lang_definitions` VALUES (9801, 22, 7, 'Probleme medical relatif a l\'avortement');
INSERT INTO `lang_definitions` VALUES (9802, 23, 7, 'Methode d\'avortement');
INSERT INTO `lang_definitions` VALUES (9803, 24, 7, 'Categories relative a l\'avortement');
INSERT INTO `lang_definitions` VALUES (9804, 28, 7, 'Acceptation de paiement');
INSERT INTO `lang_definitions` VALUES (9805, 30, 7, 'Acces de controle particulier');
INSERT INTO `lang_definitions` VALUES (9806, 31, 7, 'Liste de controle d\'acces administratif');
INSERT INTO `lang_definitions` VALUES (9807, 35, 7, 'LCAA');
INSERT INTO `lang_definitions` VALUES (9808, 37, 7, 'LCAA non autorisee');
INSERT INTO `lang_definitions` VALUES (9809, 40, 7, 'Date d\'activite');
INSERT INTO `lang_definitions` VALUES (9810, 41, 7, 'Effective');
INSERT INTO `lang_definitions` VALUES (9811, 42, 7, 'Rencontre active');
INSERT INTO `lang_definitions` VALUES (9812, 44, 7, 'Patient actif');
INSERT INTO `lang_definitions` VALUES (9813, 45, 7, 'type d\'activite');
INSERT INTO `lang_definitions` VALUES (9814, 46, 7, 'Intensification de maladie chronique');
INSERT INTO `lang_definitions` VALUES (9815, 47, 7, 'Inserer');
INSERT INTO `lang_definitions` VALUES (9816, 49, 7, 'Inserer une societe d\'assurance');
INSERT INTO `lang_definitions` VALUES (9817, 50, 7, 'Inserer une pharmacie');
INSERT INTO `lang_definitions` VALUES (9818, 51, 7, 'Inserer un evenement pour');
INSERT INTO `lang_definitions` VALUES (9819, 53, 7, 'Inserer du neuf');
INSERT INTO `lang_definitions` VALUES (9820, 54, 7, 'Inserer une categorie');
INSERT INTO `lang_definitions` VALUES (9821, 55, 7, 'Inserer un constant');
INSERT INTO `lang_definitions` VALUES (9822, 56, 7, 'Inserer recption de paiement');
INSERT INTO `lang_definitions` VALUES (9823, 57, 7, 'Inserer de nouveau medicament');
INSERT INTO `lang_definitions` VALUES (9824, 58, 7, 'Inserer une rencontre');
INSERT INTO `lang_definitions` VALUES (9825, 59, 7, 'Inserer une facilite medical');
INSERT INTO `lang_definitions` VALUES (9826, 61, 7, 'Inserer une societe medicale');
INSERT INTO `lang_definitions` VALUES (9827, 62, 7, 'Inserer le code de ICD');
INSERT INTO `lang_definitions` VALUES (9828, 63, 7, 'Inserer le probleme medical');
INSERT INTO `lang_definitions` VALUES (9829, 64, 7, 'Inserer le langage');
INSERT INTO `lang_definitions` VALUES (9830, 65, 7, 'Inserer du nouveau');
INSERT INTO `lang_definitions` VALUES (9831, 66, 7, 'Inserer une nouvelle categorie');
INSERT INTO `lang_definitions` VALUES (9832, 2, 8, 'Et betalingsnummer til å identifisere betalingen');
INSERT INTO `lang_definitions` VALUES (9833, 4, 8, 'Et serie nummer trenges!');
INSERT INTO `lang_definitions` VALUES (9834, 5, 8, 'En relatert IPPF kode trenges');
INSERT INTO `lang_definitions` VALUES (9835, 22, 8, 'Avsluttelses vansker');
INSERT INTO `lang_definitions` VALUES (9836, 23, 8, 'Avsluttelses metoder');
INSERT INTO `lang_definitions` VALUES (9837, 27, 8, 'Akseptere Job');
INSERT INTO `lang_definitions` VALUES (9838, 28, 8, 'Akseptere penger for');
INSERT INTO `lang_definitions` VALUES (9839, 29, 8, 'Akseptere job');
INSERT INTO `lang_definitions` VALUES (9840, 30, 8, 'Tilgangs kontroll');
INSERT INTO `lang_definitions` VALUES (9841, 41, 8, 'Aktiv');
INSERT INTO `lang_definitions` VALUES (9842, 42, 8, 'Aktivt møte');
INSERT INTO `lang_definitions` VALUES (9843, 44, 8, 'Aktiv pasient');
INSERT INTO `lang_definitions` VALUES (9844, 45, 8, 'Aktivitets type');
INSERT INTO `lang_definitions` VALUES (9845, 47, 8, 'Legg til');
INSERT INTO `lang_definitions` VALUES (9846, 49, 8, 'Legg til en Bedrift');
INSERT INTO `lang_definitions` VALUES (9847, 50, 8, 'Legg til et Apotek');
INSERT INTO `lang_definitions` VALUES (9848, 51, 8, 'Legg til en hendelse for');
INSERT INTO `lang_definitions` VALUES (9849, 53, 8, 'Legg til som ny');
INSERT INTO `lang_definitions` VALUES (9850, 54, 8, 'Legg til kategori');
INSERT INTO `lang_definitions` VALUES (9851, 55, 8, 'Legg til konstant');
INSERT INTO `lang_definitions` VALUES (9852, 57, 8, 'Legg til medisin');
INSERT INTO `lang_definitions` VALUES (9853, 58, 8, 'Legg til Møte');
INSERT INTO `lang_definitions` VALUES (9854, 59, 8, 'Legg til Lokale');
INSERT INTO `lang_definitions` VALUES (9855, 61, 8, 'Legg til gruppe');
INSERT INTO `lang_definitions` VALUES (9856, 63, 8, 'Legg til problem');
INSERT INTO `lang_definitions` VALUES (9857, 64, 8, 'Legg til språk');
INSERT INTO `lang_definitions` VALUES (9858, 65, 8, 'Legg til ny');
INSERT INTO `lang_definitions` VALUES (9859, 66, 8, 'Legg til ny kategori:');
INSERT INTO `lang_definitions` VALUES (9860, 67, 8, 'Legg til ny gruppe');
INSERT INTO `lang_definitions` VALUES (9861, 68, 8, 'Legg til nytt notat');
INSERT INTO `lang_definitions` VALUES (9862, 70, 8, 'Legg til ny partner');
INSERT INTO `lang_definitions` VALUES (9863, 71, 8, 'Legg til notat');
INSERT INTO `lang_definitions` VALUES (9864, 72, 8, 'Legg til pasient historie');
INSERT INTO `lang_definitions` VALUES (9865, 73, 8, 'Legg til Resept');
INSERT INTO `lang_definitions` VALUES (9866, 75, 8, 'Legg til medisin liste');
INSERT INTO `lang_definitions` VALUES (9867, 77, 8, 'Legg til bruker');
INSERT INTO `lang_definitions` VALUES (9868, 78, 8, 'Legg til bruker til gruppe');
INSERT INTO `lang_definitions` VALUES (9869, 83, 8, 'Flere diagnoser:');
INSERT INTO `lang_definitions` VALUES (9870, 84, 8, 'Mere historie');
INSERT INTO `lang_definitions` VALUES (9871, 86, 8, 'Mere info');
INSERT INTO `lang_definitions` VALUES (9872, 89, 8, 'Flere notater:');
INSERT INTO `lang_definitions` VALUES (9873, 90, 8, 'Flere notater:');
INSERT INTO `lang_definitions` VALUES (9874, 91, 8, 'Flere røntgen notater:');
INSERT INTO `lang_definitions` VALUES (9875, 95, 8, 'adresse');
INSERT INTO `lang_definitions` VALUES (9876, 96, 8, 'adresse bok');
INSERT INTO `lang_definitions` VALUES (9877, 97, 8, 'adresse1');
INSERT INTO `lang_definitions` VALUES (9878, 98, 8, 'adresse2');
INSERT INTO `lang_definitions` VALUES (9879, 100, 8, 'Juster');
INSERT INTO `lang_definitions` VALUES (9880, 102, 8, 'Justerings verdi for kode');
INSERT INTO `lang_definitions` VALUES (9881, 103, 8, 'Justeringer');
INSERT INTO `lang_definitions` VALUES (9882, 104, 8, 'Adm juster');
INSERT INTO `lang_definitions` VALUES (9883, 105, 8, 'Admin');
INSERT INTO `lang_definitions` VALUES (9884, 106, 8, 'Admin Email Adresse');
INSERT INTO `lang_definitions` VALUES (9885, 108, 8, 'Administrert Av');
INSERT INTO `lang_definitions` VALUES (9886, 109, 8, 'Administrasjon');
INSERT INTO `lang_definitions` VALUES (9887, 113, 8, 'Råd');
INSERT INTO `lang_definitions` VALUES (9888, 114, 8, 'Påvirker normalt');
INSERT INTO `lang_definitions` VALUES (9889, 115, 8, 'Ringninger etter stengetid');
INSERT INTO `lang_definitions` VALUES (9890, 118, 8, 'Etter informasjonen er skrevet inn slik den skal, trykk lagre knappen');
INSERT INTO `lang_definitions` VALUES (9891, 119, 8, 'Igjen');
INSERT INTO `lang_definitions` VALUES (9892, 120, 8, 'Alder');
INSERT INTO `lang_definitions` VALUES (9893, 121, 8, 'Alder etter');
INSERT INTO `lang_definitions` VALUES (9894, 122, 8, 'Alder kategori');
INSERT INTO `lang_definitions` VALUES (9895, 124, 8, 'Alder formatet for \"Age fra\" er ikke gyldig');
INSERT INTO `lang_definitions` VALUES (9896, 125, 8, 'Alder formatet for \"alder opp til\" er ikke gyldig');
INSERT INTO `lang_definitions` VALUES (9897, 126, 8, 'Alder fra');
INSERT INTO `lang_definitions` VALUES (9898, 127, 8, 'Aldrings kolonner:');
INSERT INTO `lang_definitions` VALUES (9899, 128, 8, 'Alkohol');
INSERT INTO `lang_definitions` VALUES (9900, 130, 8, 'Alle');
INSERT INTO `lang_definitions` VALUES (9901, 131, 8, 'Alle kategorier');
INSERT INTO `lang_definitions` VALUES (9902, 132, 8, 'Alle dager');
INSERT INTO `lang_definitions` VALUES (9903, 133, 8, 'Heldags hendelse');
INSERT INTO `lang_definitions` VALUES (9904, 134, 8, 'Alle Lokaler');
INSERT INTO `lang_definitions` VALUES (9905, 135, 8, 'Alt eller deler av det fornavnet');
INSERT INTO `lang_definitions` VALUES (9906, 136, 8, 'Alt eller deler av etternavnet');
INSERT INTO `lang_definitions` VALUES (9907, 138, 8, 'Alt Gjennomsett og Negative:');
INSERT INTO `lang_definitions` VALUES (9908, 139, 8, 'Alle Emner');
INSERT INTO `lang_definitions` VALUES (9909, 140, 8, 'Alle Brukere');
INSERT INTO `lang_definitions` VALUES (9910, 142, 8, 'Allergier:');
INSERT INTO `lang_definitions` VALUES (9911, 143, 8, 'Allergier:');
INSERT INTO `lang_definitions` VALUES (9912, 151, 8, 'Tillatt sendte hendelser til å bli gjort aktive nå?');
INSERT INTO `lang_definitions` VALUES (9913, 153, 8, 'Tillatt bruker å publisere Globale Hendelser');
INSERT INTO `lang_definitions` VALUES (9914, 154, 8, 'Tillat brukere til å publisere Personlige kallendere');
INSERT INTO `lang_definitions` VALUES (9915, 156, 8, 'Tillatt');
INSERT INTO `lang_definitions` VALUES (9916, 158, 8, 'Allerede i bruk, velg en annen ');
INSERT INTO `lang_definitions` VALUES (9917, 159, 8, 'Allerede i bruk, velg en annen titel');
INSERT INTO `lang_definitions` VALUES (9918, 160, 8, 'Alternativ adresse');
INSERT INTO `lang_definitions` VALUES (9919, 166, 8, 'Mengde');
INSERT INTO `lang_definitions` VALUES (9920, 169, 8, 'Mengde for dette besøket');
INSERT INTO `lang_definitions` VALUES (9921, 170, 8, 'Mengde Betalt');
INSERT INTO `lang_definitions` VALUES (9922, 171, 8, 'Mengde:');
INSERT INTO `lang_definitions` VALUES (9923, 176, 8, 'Og');
INSERT INTO `lang_definitions` VALUES (9924, 179, 8, 'og');
INSERT INTO `lang_definitions` VALUES (9925, 182, 8, 'Ankel');
INSERT INTO `lang_definitions` VALUES (9926, 183, 8, 'Ankel + hel');
INSERT INTO `lang_definitions` VALUES (9927, 184, 8, 'Ankel Evaluerings Skjema');
INSERT INTO `lang_definitions` VALUES (9928, 185, 8, 'Ankel Problemer');
INSERT INTO `lang_definitions` VALUES (9929, 193, 8, 'Hvilken som helst');
INSERT INTO `lang_definitions` VALUES (9930, 195, 8, 'Hvilken som helst av den ønskede kode eller dens forklarinng');
INSERT INTO `lang_definitions` VALUES (9931, 199, 8, 'Utseende');
INSERT INTO `lang_definitions` VALUES (9932, 200, 8, 'Utseende:');
INSERT INTO `lang_definitions` VALUES (9933, 203, 8, 'Henvis til denne notisen');
INSERT INTO `lang_definitions` VALUES (9934, 206, 8, 'Bruk på påvirket område');
INSERT INTO `lang_definitions` VALUES (9935, 207, 8, 'Bruk på hud');
INSERT INTO `lang_definitions` VALUES (9936, 209, 8, 'Avtale dato');
INSERT INTO `lang_definitions` VALUES (9937, 210, 8, 'Avtale status');
INSERT INTO `lang_definitions` VALUES (9938, 211, 8, 'Avtale innenfor');
INSERT INTO `lang_definitions` VALUES (9939, 212, 8, 'Avtaler');
INSERT INTO `lang_definitions` VALUES (9940, 214, 8, 'Avtaler og hendelser');
INSERT INTO `lang_definitions` VALUES (9941, 215, 8, 'Avtale rapport');
INSERT INTO `lang_definitions` VALUES (9942, 216, 8, 'Avtale-Hendelses Rapport');
INSERT INTO `lang_definitions` VALUES (9943, 217, 8, 'Godkjenn');
INSERT INTO `lang_definitions` VALUES (9944, 218, 8, 'Godkjent');
INSERT INTO `lang_definitions` VALUES (9945, 222, 8, 'April');
INSERT INTO `lang_definitions` VALUES (9946, 225, 8, 'Er du sikker på at du vil godkjenne disse hendelsene?');
INSERT INTO `lang_definitions` VALUES (9947, 227, 8, 'Er du sikker på at du vil slette disse hendelsene?');
INSERT INTO `lang_definitions` VALUES (9948, 230, 8, 'Er du sikker på at du vil redigere disse hendelsene?');
INSERT INTO `lang_definitions` VALUES (9949, 231, 8, 'Er du sikker på at du vil skjule disse hendelsene?');
INSERT INTO `lang_definitions` VALUES (9950, 232, 8, 'Er du sikker på at du vil se på disse hendelsene?');
INSERT INTO `lang_definitions` VALUES (9951, 237, 8, 'Er du sikker på at du vil fortsette med disse handlingene?');
INSERT INTO `lang_definitions` VALUES (9952, 238, 8, 'Område ikke spesifisert');
INSERT INTO `lang_definitions` VALUES (9953, 245, 8, 'Fra og med');
INSERT INTO `lang_definitions` VALUES (9954, 249, 8, 'Assistent');
INSERT INTO `lang_definitions` VALUES (9955, 254, 8, 'Atletisk/skade');
INSERT INTO `lang_definitions` VALUES (9956, 255, 8, 'Oppmerksomhet');
INSERT INTO `lang_definitions` VALUES (9957, 257, 8, 'August');
INSERT INTO `lang_definitions` VALUES (9958, 260, 8, 'Tilganger');
INSERT INTO `lang_definitions` VALUES (9959, 261, 8, 'Gi tilgang');
INSERT INTO `lang_definitions` VALUES (9960, 264, 8, 'Har tilgang');
INSERT INTO `lang_definitions` VALUES (9961, 265, 8, 'Auto send');
INSERT INTO `lang_definitions` VALUES (9962, 269, 8, 'Tilgjengelige tider');
INSERT INTO `lang_definitions` VALUES (9963, 276, 8, 'rygg');
INSERT INTO `lang_definitions` VALUES (9964, 277, 8, 'Rygg');
INSERT INTO `lang_definitions` VALUES (9965, 284, 8, 'Rygg Problemer');
INSERT INTO `lang_definitions` VALUES (9966, 287, 8, 'Rygg operasjon');
INSERT INTO `lang_definitions` VALUES (9967, 292, 8, 'Sikkerhets kopi');
INSERT INTO `lang_definitions` VALUES (9968, 298, 8, 'Balanse');
INSERT INTO `lang_definitions` VALUES (9969, 307, 8, 'Start');
INSERT INTO `lang_definitions` VALUES (9970, 308, 8, 'Start Dato');
INSERT INTO `lang_definitions` VALUES (9971, 309, 8, 'Start dato for service åååå-mm-dd');
INSERT INTO `lang_definitions` VALUES (9972, 313, 8, 'Regnings Dato:');
INSERT INTO `lang_definitions` VALUES (9973, 327, 8, 'Rapport for regninger');
INSERT INTO `lang_definitions` VALUES (9974, 328, 8, 'Regning til');
INSERT INTO `lang_definitions` VALUES (9975, 330, 8, 'Fødelses Dato');
INSERT INTO `lang_definitions` VALUES (9976, 332, 8, 'Blære kreft');
INSERT INTO `lang_definitions` VALUES (9977, 333, 8, 'Blære infeksjon');
INSERT INTO `lang_definitions` VALUES (9978, 338, 8, 'Blokkert');
INSERT INTO `lang_definitions` VALUES (9979, 341, 8, 'Blodig nese');
INSERT INTO `lang_definitions` VALUES (9980, 344, 8, 'Tåkete syn');
INSERT INTO `lang_definitions` VALUES (9981, 347, 8, 'Kropps region');
INSERT INTO `lang_definitions` VALUES (9982, 353, 8, 'Begge ører');
INSERT INTO `lang_definitions` VALUES (9983, 354, 8, 'Bunn');
INSERT INTO `lang_definitions` VALUES (9984, 355, 8, 'BOX 10 A. Ansettelses relatert');
INSERT INTO `lang_definitions` VALUES (9985, 356, 8, 'BOX 10 B. Bil ulykke');
INSERT INTO `lang_definitions` VALUES (9986, 357, 8, 'BOX 10 C. Annen ulykke');
INSERT INTO `lang_definitions` VALUES (9987, 358, 8, 'BOX 16. Kan ikke arbeide fra dato (åååå-mm-dd):');
INSERT INTO `lang_definitions` VALUES (9988, 359, 8, 'BOX 16. Kan ikke arbeide til dato (åååå-mm-dd)');
INSERT INTO `lang_definitions` VALUES (9989, 377, 8, 'Puste Lyder:');
INSERT INTO `lang_definitions` VALUES (9990, 378, 8, 'Brukne Bein');
INSERT INTO `lang_definitions` VALUES (9991, 380, 8, 'Se igjennom');
INSERT INTO `lang_definitions` VALUES (9992, 386, 8, 'Opptatt');
INSERT INTO `lang_definitions` VALUES (9993, 388, 8, 'av');
INSERT INTO `lang_definitions` VALUES (9994, 389, 8, 'av mund');
INSERT INTO `lang_definitions` VALUES (9995, 390, 8, 'Av/Skilde');
INSERT INTO `lang_definitions` VALUES (9996, 391, 8, 'Av:');
INSERT INTO `lang_definitions` VALUES (9997, 396, 8, 'Kalender');
INSERT INTO `lang_definitions` VALUES (9998, 398, 8, 'Kalender UI');
INSERT INTO `lang_definitions` VALUES (9999, 403, 8, 'avbryt');
INSERT INTO `lang_definitions` VALUES (10000, 404, 8, 'Kreft');
INSERT INTO `lang_definitions` VALUES (10001, 411, 8, 'Kan ikke lage');
INSERT INTO `lang_definitions` VALUES (10002, 412, 8, 'Kan ikke finne');
INSERT INTO `lang_definitions` VALUES (10003, 416, 8, 'Kan ikke åpne');
INSERT INTO `lang_definitions` VALUES (10004, 419, 8, 'Kapsul');
INSERT INTO `lang_definitions` VALUES (10005, 426, 8, 'penger');
INSERT INTO `lang_definitions` VALUES (10006, 427, 8, 'Penger');
INSERT INTO `lang_definitions` VALUES (10007, 432, 8, 'Kategorier');
INSERT INTO `lang_definitions` VALUES (10008, 433, 8, 'Kategori');
INSERT INTO `lang_definitions` VALUES (10009, 434, 8, 'kategori');
INSERT INTO `lang_definitions` VALUES (10010, 435, 8, 'Kategori');
INSERT INTO `lang_definitions` VALUES (10011, 436, 8, 'Kategori Detaljer');
INSERT INTO `lang_definitions` VALUES (10012, 437, 8, 'Kategori Grenser');
INSERT INTO `lang_definitions` VALUES (10013, 438, 8, 'Kategori navn');
INSERT INTO `lang_definitions` VALUES (10014, 442, 8, 'sentral sertifikasjon');
INSERT INTO `lang_definitions` VALUES (10015, 446, 8, 'Forandre');
INSERT INTO `lang_definitions` VALUES (10016, 448, 8, 'Forandre Aktivitet');
INSERT INTO `lang_definitions` VALUES (10017, 451, 8, 'Forandret');
INSERT INTO `lang_definitions` VALUES (10018, 467, 8, 'sjekk');
INSERT INTO `lang_definitions` VALUES (10019, 468, 8, 'Sjekk');
INSERT INTO `lang_definitions` VALUES (10020, 482, 8, 'Sjekk ut');
INSERT INTO `lang_definitions` VALUES (10021, 483, 8, 'Bryst');
INSERT INTO `lang_definitions` VALUES (10022, 486, 8, 'Bryst Smerte:');
INSERT INTO `lang_definitions` VALUES (10023, 487, 8, 'Bryst Smerter');
INSERT INTO `lang_definitions` VALUES (10024, 491, 8, 'Grøssninger');
INSERT INTO `lang_definitions` VALUES (10025, 500, 8, 'Kronisk bronkit');
INSERT INTO `lang_definitions` VALUES (10026, 506, 8, 'By');
INSERT INTO `lang_definitions` VALUES (10027, 508, 8, 'By, landsdel');
INSERT INTO `lang_definitions` VALUES (10028, 510, 8, 'By/landsdel');
INSERT INTO `lang_definitions` VALUES (10029, 515, 8, 'Klassifisert');
INSERT INTO `lang_definitions` VALUES (10030, 516, 8, 'Tøm');
INSERT INTO `lang_definitions` VALUES (10031, 517, 8, 'Tøm alle');
INSERT INTO `lang_definitions` VALUES (10032, 523, 8, 'Klikk for mere');
INSERT INTO `lang_definitions` VALUES (10033, 524, 8, 'Klikk her for å velge en dato');
INSERT INTO `lang_definitions` VALUES (10034, 525, 8, 'Klikk her for å oppdatere prioritet, kategori og kallenavn instillinger');
INSERT INTO `lang_definitions` VALUES (10035, 527, 8, 'Klikk for å laste ned');
INSERT INTO `lang_definitions` VALUES (10036, 530, 8, 'Klikk for å generere rapport');
INSERT INTO `lang_definitions` VALUES (10037, 533, 8, 'Klikk for å velge');
INSERT INTO `lang_definitions` VALUES (10038, 534, 8, 'Klikk for å velge eller forandre diagnose');
INSERT INTO `lang_definitions` VALUES (10039, 535, 8, 'Klikk for å velge en pasient');
INSERT INTO `lang_definitions` VALUES (10040, 536, 8, 'Klikk for å velge relatert kode');
INSERT INTO `lang_definitions` VALUES (10041, 540, 8, 'Klikk:');
INSERT INTO `lang_definitions` VALUES (10042, 545, 8, 'Klienter');
INSERT INTO `lang_definitions` VALUES (10043, 546, 8, 'Klinikk');
INSERT INTO `lang_definitions` VALUES (10044, 553, 8, 'Steng');
INSERT INTO `lang_definitions` VALUES (10045, 554, 8, 'Steng vindu');
INSERT INTO `lang_definitions` VALUES (10046, 555, 8, 'Stengt');
INSERT INTO `lang_definitions` VALUES (10047, 560, 8, 'Kode');
INSERT INTO `lang_definitions` VALUES (10048, 561, 8, 'kode');
INSERT INTO `lang_definitions` VALUES (10049, 562, 8, 'Kode finner');
INSERT INTO `lang_definitions` VALUES (10050, 563, 8, 'Koden må inneholde 2 små bokstaver');
INSERT INTO `lang_definitions` VALUES (10051, 565, 8, 'Koder');
INSERT INTO `lang_definitions` VALUES (10052, 566, 8, 'Koding');
INSERT INTO `lang_definitions` VALUES (10053, 569, 8, 'Koding ikke tillatt');
INSERT INTO `lang_definitions` VALUES (10054, 570, 8, 'Kaffe');
INSERT INTO `lang_definitions` VALUES (10055, 579, 8, 'Farge');
INSERT INTO `lang_definitions` VALUES (10056, 580, 8, 'Kolonner');
INSERT INTO `lang_definitions` VALUES (10057, 581, 8, 'Kommentarer');
INSERT INTO `lang_definitions` VALUES (10058, 583, 8, 'Fullfør Endringer');
INSERT INTO `lang_definitions` VALUES (10059, 585, 8, 'Fullført');
INSERT INTO `lang_definitions` VALUES (10060, 587, 8, 'Komplikasjoner ved abort');
INSERT INTO `lang_definitions` VALUES (10061, 598, 8, 'Kontakt');
INSERT INTO `lang_definitions` VALUES (10062, 599, 8, 'Kontakt Epost');
INSERT INTO `lang_definitions` VALUES (10063, 603, 8, 'Kontakt navn');
INSERT INTO `lang_definitions` VALUES (10064, 604, 8, 'Kontakt person');
INSERT INTO `lang_definitions` VALUES (10065, 605, 8, 'Kontakt Tlf');
INSERT INTO `lang_definitions` VALUES (10066, 606, 8, 'Innhold');
INSERT INTO `lang_definitions` VALUES (10067, 607, 8, 'innhold');
INSERT INTO `lang_definitions` VALUES (10068, 623, 8, 'Kopier verdier');
INSERT INTO `lang_definitions` VALUES (10069, 627, 8, 'Hoste:');
INSERT INTO `lang_definitions` VALUES (10070, 628, 8, 'Kunne ikke sende epost grunnet et problem med serveren');
INSERT INTO `lang_definitions` VALUES (10071, 634, 8, 'Rådgiving');
INSERT INTO `lang_definitions` VALUES (10072, 638, 8, 'Land');
INSERT INTO `lang_definitions` VALUES (10073, 645, 8, 'krem');
INSERT INTO `lang_definitions` VALUES (10074, 646, 8, 'Lag en ny Hendelse');
INSERT INTO `lang_definitions` VALUES (10075, 649, 8, 'Lag en Ny Pasient');
INSERT INTO `lang_definitions` VALUES (10076, 650, 8, 'Lag et Pasient Notis');
INSERT INTO `lang_definitions` VALUES (10077, 651, 8, 'Laget');
INSERT INTO `lang_definitions` VALUES (10078, 653, 8, 'Kreditt');
INSERT INTO `lang_definitions` VALUES (10079, 654, 8, 'Kreditter');
INSERT INTO `lang_definitions` VALUES (10080, 664, 8, 'For øyeblikket aktiv');
INSERT INTO `lang_definitions` VALUES (10081, 676, 8, 'Daglig');
INSERT INTO `lang_definitions` VALUES (10082, 680, 8, 'Data Type');
INSERT INTO `lang_definitions` VALUES (10083, 681, 8, 'Database');
INSERT INTO `lang_definitions` VALUES (10084, 684, 8, 'Dato');
INSERT INTO `lang_definitions` VALUES (10085, 688, 8, 'Dato Ødelagt');
INSERT INTO `lang_definitions` VALUES (10086, 689, 8, 'Dato Vis Format');
INSERT INTO `lang_definitions` VALUES (10087, 697, 8, 'Dato for bank innskudd åååå-mm-dd');
INSERT INTO `lang_definitions` VALUES (10088, 700, 8, 'Dato Når Skaden Intraff');
INSERT INTO `lang_definitions` VALUES (10089, 701, 8, 'Betalings dato åååå-mm-dd');
INSERT INTO `lang_definitions` VALUES (10090, 704, 8, 'Service Dato');
INSERT INTO `lang_definitions` VALUES (10091, 705, 8, 'Service dato mm/dd/åååå');
INSERT INTO `lang_definitions` VALUES (10092, 706, 8, 'Service Dato:');
INSERT INTO `lang_definitions` VALUES (10093, 712, 8, 'Dato:');
INSERT INTO `lang_definitions` VALUES (10094, 714, 8, 'Dag');
INSERT INTO `lang_definitions` VALUES (10095, 715, 8, 'Dags oversikt');
INSERT INTO `lang_definitions` VALUES (10096, 716, 8, 'Dag(er)');
INSERT INTO `lang_definitions` VALUES (10097, 717, 8, 'Dag(er) M-F');
INSERT INTO `lang_definitions` VALUES (10098, 718, 8, 'dager');
INSERT INTO `lang_definitions` VALUES (10099, 719, 8, 'Dager');
INSERT INTO `lang_definitions` VALUES (10100, 722, 8, 'Dager per Kolonne:');
INSERT INTO `lang_definitions` VALUES (10101, 725, 8, 'Informasjon om feilen');
INSERT INTO `lang_definitions` VALUES (10102, 726, 8, 'Desember');
INSERT INTO `lang_definitions` VALUES (10103, 727, 8, 'Vanlig');
INSERT INTO `lang_definitions` VALUES (10104, 728, 8, 'Vanlig kallender perspektiv');
INSERT INTO `lang_definitions` VALUES (10105, 729, 8, 'Vanlige lokale');
INSERT INTO `lang_definitions` VALUES (10106, 731, 8, 'Vanlig metode');
INSERT INTO `lang_definitions` VALUES (10107, 734, 8, 'Vanlig Verdi');
INSERT INTO `lang_definitions` VALUES (10108, 736, 8, 'Vanlig/Global');
INSERT INTO `lang_definitions` VALUES (10109, 739, 8, 'Slett');
INSERT INTO `lang_definitions` VALUES (10110, 741, 8, 'Slett Kategorier med ID(s):');
INSERT INTO `lang_definitions` VALUES (10111, 744, 8, 'Slett Sider');
INSERT INTO `lang_definitions` VALUES (10112, 759, 8, 'Innskudds Dato:');
INSERT INTO `lang_definitions` VALUES (10113, 760, 8, 'Deprimert');
INSERT INTO `lang_definitions` VALUES (10114, 762, 8, 'Forklaring');
INSERT INTO `lang_definitions` VALUES (10115, 763, 8, 'forklaring');
INSERT INTO `lang_definitions` VALUES (10116, 765, 8, 'Mål');
INSERT INTO `lang_definitions` VALUES (10117, 767, 8, 'Ødelegg...');
INSERT INTO `lang_definitions` VALUES (10118, 769, 8, 'Ødelegg Medisiner');
INSERT INTO `lang_definitions` VALUES (10119, 770, 8, 'Ødelegg Medisin Rapport');
INSERT INTO `lang_definitions` VALUES (10120, 771, 8, 'Detaljer');
INSERT INTO `lang_definitions` VALUES (10121, 773, 8, 'Diabetes');
INSERT INTO `lang_definitions` VALUES (10122, 775, 8, 'Diagnose');
INSERT INTO `lang_definitions` VALUES (10123, 777, 8, 'Diagnose:');
INSERT INTO `lang_definitions` VALUES (10124, 778, 8, 'Diagnose:');
INSERT INTO `lang_definitions` VALUES (10125, 784, 8, 'Diktering:');
INSERT INTO `lang_definitions` VALUES (10126, 790, 8, 'avslått');
INSERT INTO `lang_definitions` VALUES (10127, 791, 8, 'Avslått');
INSERT INTO `lang_definitions` VALUES (10128, 797, 8, 'Rabatt');
INSERT INTO `lang_definitions` VALUES (10129, 798, 8, 'Rabatt Mengde');
INSERT INTO `lang_definitions` VALUES (10130, 809, 8, 'Viss kalenderen?');
INSERT INTO `lang_definitions` VALUES (10131, 819, 8, 'Svimmelhet:');
INSERT INTO `lang_definitions` VALUES (10132, 820, 8, 'ikke lagre');
INSERT INTO `lang_definitions` VALUES (10133, 821, 8, 'ikke bytt ut');
INSERT INTO `lang_definitions` VALUES (10134, 823, 8, 'Vil du virkelig slette denne gruppen');
INSERT INTO `lang_definitions` VALUES (10135, 828, 8, 'DOB mangler, Skriv in hvis mulig');
INSERT INTO `lang_definitions` VALUES (10136, 831, 8, 'Doktor:');
INSERT INTO `lang_definitions` VALUES (10137, 833, 8, 'Dokument');
INSERT INTO `lang_definitions` VALUES (10138, 835, 8, 'Dokument Kategori');
INSERT INTO `lang_definitions` VALUES (10139, 837, 8, 'Dokumentasjons Dato');
INSERT INTO `lang_definitions` VALUES (10140, 842, 8, 'Dokumenter');
INSERT INTO `lang_definitions` VALUES (10141, 847, 8, 'Ikke lagre');
INSERT INTO `lang_definitions` VALUES (10142, 848, 8, 'Ikke lagre Endringer');
INSERT INTO `lang_definitions` VALUES (10143, 850, 8, 'Ferdig Med:');
INSERT INTO `lang_definitions` VALUES (10144, 853, 8, 'Dosering');
INSERT INTO `lang_definitions` VALUES (10145, 855, 8, 'Dobbelt syn');
INSERT INTO `lang_definitions` VALUES (10146, 858, 8, 'Dr Sjekk');
INSERT INTO `lang_definitions` VALUES (10147, 859, 8, 'Dr Besøk');
INSERT INTO `lang_definitions` VALUES (10148, 863, 8, 'Medisin');
INSERT INTO `lang_definitions` VALUES (10149, 867, 8, 'Medisin Inventar');
INSERT INTO `lang_definitions` VALUES (10150, 868, 8, 'Medisin navn');
INSERT INTO `lang_definitions` VALUES (10151, 871, 8, 'Medisiner');
INSERT INTO `lang_definitions` VALUES (10152, 872, 8, 'Tørr munn');
INSERT INTO `lang_definitions` VALUES (10153, 895, 8, 'varighet');
INSERT INTO `lang_definitions` VALUES (10154, 896, 8, 'Varighet');
INSERT INTO `lang_definitions` VALUES (10155, 905, 8, 'Rediger');
INSERT INTO `lang_definitions` VALUES (10156, 907, 8, 'Rediger Kategorier');
INSERT INTO `lang_definitions` VALUES (10157, 908, 8, 'Rediger Definisjoner');
INSERT INTO `lang_definitions` VALUES (10158, 909, 8, 'Rediger Diagnoser for');
INSERT INTO `lang_definitions` VALUES (10159, 910, 8, 'Rediger Lokaler');
INSERT INTO `lang_definitions` VALUES (10160, 911, 8, 'Rediger Informasjon om Lokaler');
INSERT INTO `lang_definitions` VALUES (10161, 915, 8, 'Rediger Struktur');
INSERT INTO `lang_definitions` VALUES (10162, 916, 8, 'Utdannelse');
INSERT INTO `lang_definitions` VALUES (10163, 917, 8, 'Utdannelses Dato');
INSERT INTO `lang_definitions` VALUES (10164, 922, 8, 'Albue');
INSERT INTO `lang_definitions` VALUES (10165, 923, 8, 'Albue problemer');
INSERT INTO `lang_definitions` VALUES (10166, 925, 8, 'Epost');
INSERT INTO `lang_definitions` VALUES (10167, 926, 8, 'Epost fra Batchcom');
INSERT INTO `lang_definitions` VALUES (10168, 927, 8, 'Epost Påmindelse');
INSERT INTO `lang_definitions` VALUES (10169, 928, 8, 'Epost send før');
INSERT INTO `lang_definitions` VALUES (10170, 929, 8, 'Epost Sender');
INSERT INTO `lang_definitions` VALUES (10171, 930, 8, 'Epost Emne');
INSERT INTO `lang_definitions` VALUES (10172, 932, 8, 'Nød kontakt');
INSERT INTO `lang_definitions` VALUES (10173, 939, 8, 'Arbeidsgiver');
INSERT INTO `lang_definitions` VALUES (10174, 940, 8, 'Arbeidsgivers adresse');
INSERT INTO `lang_definitions` VALUES (10175, 941, 8, 'Arbeidsgiver Data');
INSERT INTO `lang_definitions` VALUES (10176, 943, 8, 'Tom');
INSERT INTO `lang_definitions` VALUES (10177, 944, 8, 'Tom verdi i \"Epost Timer\"');
INSERT INTO `lang_definitions` VALUES (10178, 945, 8, 'Tom verdi i \"Epost Sender\"');
INSERT INTO `lang_definitions` VALUES (10179, 946, 8, 'Tom verdi i \"Epost Emne\"');
INSERT INTO `lang_definitions` VALUES (10180, 947, 8, 'Tom verdi i \"Epost Tekst\"');
INSERT INTO `lang_definitions` VALUES (10181, 949, 8, 'Tom verdi i \"Passord\"');
INSERT INTO `lang_definitions` VALUES (10182, 950, 8, 'Tom verdi i \"SMS Timer\"');
INSERT INTO `lang_definitions` VALUES (10183, 951, 8, 'Tom verdi i \"SMS Tekst\"');
INSERT INTO `lang_definitions` VALUES (10184, 952, 8, 'Tom verdi i \"Brukernavn\"');
INSERT INTO `lang_definitions` VALUES (10185, 953, 8, 'på');
INSERT INTO `lang_definitions` VALUES (10186, 956, 8, 'Møte');
INSERT INTO `lang_definitions` VALUES (10187, 957, 8, 'Møte');
INSERT INTO `lang_definitions` VALUES (10188, 958, 8, 'Møte skjerma');
INSERT INTO `lang_definitions` VALUES (10189, 959, 8, 'Møte nummer');
INSERT INTO `lang_definitions` VALUES (10190, 961, 8, 'Møte:');
INSERT INTO `lang_definitions` VALUES (10191, 962, 8, 'Møter');
INSERT INTO `lang_definitions` VALUES (10192, 963, 8, 'Møter & skjemaer');
INSERT INTO `lang_definitions` VALUES (10193, 965, 8, 'Møter ikke tilatt');
INSERT INTO `lang_definitions` VALUES (10194, 966, 8, 'Rapport for Møter');
INSERT INTO `lang_definitions` VALUES (10195, 967, 8, 'Møte seksjon');
INSERT INTO `lang_definitions` VALUES (10196, 968, 8, 'Slutt');
INSERT INTO `lang_definitions` VALUES (10197, 969, 8, 'Slutt (åååå-mm-dd):');
INSERT INTO `lang_definitions` VALUES (10198, 970, 8, 'Slutt dato');
INSERT INTO `lang_definitions` VALUES (10199, 971, 8, 'Slutt Dato');
INSERT INTO `lang_definitions` VALUES (10200, 972, 8, 'Slutt Dato:');
INSERT INTO `lang_definitions` VALUES (10201, 973, 8, 'Slutt Tid');
INSERT INTO `lang_definitions` VALUES (10202, 997, 8, 'Epilepsi');
INSERT INTO `lang_definitions` VALUES (10203, 998, 8, 'Slett');
INSERT INTO `lang_definitions` VALUES (10204, 1000, 8, 'Feil');
INSERT INTO `lang_definitions` VALUES (10205, 1001, 8, 'Feil i \"Kjønn\" valg');
INSERT INTO `lang_definitions` VALUES (10206, 1007, 8, 'Error i JA eller NEI valg');
INSERT INTO `lang_definitions` VALUES (10207, 1018, 8, 'Flere Feil');
INSERT INTO `lang_definitions` VALUES (10208, 1024, 8, 'Hendelse');
INSERT INTO `lang_definitions` VALUES (10209, 1025, 8, 'Hendelse begynner');
INSERT INTO `lang_definitions` VALUES (10210, 1026, 8, 'Hendelse Kategori');
INSERT INTO `lang_definitions` VALUES (10211, 1027, 8, 'Hendelses dato');
INSERT INTO `lang_definitions` VALUES (10212, 1028, 8, 'Forklaring av hendelsen');
INSERT INTO `lang_definitions` VALUES (10213, 1029, 8, 'Hendelses detaljer');
INSERT INTO `lang_definitions` VALUES (10214, 1030, 8, 'Hendelse gjentaes ikke');
INSERT INTO `lang_definitions` VALUES (10215, 1031, 8, 'Hendelses varighet');
INSERT INTO `lang_definitions` VALUES (10216, 1032, 8, 'Hendelses varighet i minutter');
INSERT INTO `lang_definitions` VALUES (10217, 1034, 8, 'Hendelses sted');
INSERT INTO `lang_definitions` VALUES (10218, 1035, 8, 'Hendelse gjentar seg hver');
INSERT INTO `lang_definitions` VALUES (10219, 1036, 8, 'Hendelse gjentar seg på');
INSERT INTO `lang_definitions` VALUES (10220, 1037, 8, 'Start tid for hendelsen');
INSERT INTO `lang_definitions` VALUES (10221, 1038, 8, 'Hendelses titel');
INSERT INTO `lang_definitions` VALUES (10222, 1039, 8, 'Hendelses titel');
INSERT INTO `lang_definitions` VALUES (10223, 1041, 8, 'Hendelser');
INSERT INTO `lang_definitions` VALUES (10224, 1042, 8, 'Hendelser for');
INSERT INTO `lang_definitions` VALUES (10225, 1043, 8, 'Hendelser åpnes i et nytt vindu');
INSERT INTO `lang_definitions` VALUES (10226, 1045, 8, 'Hver');
INSERT INTO `lang_definitions` VALUES (10227, 1046, 8, 'hver 3 time');
INSERT INTO `lang_definitions` VALUES (10228, 1047, 8, 'hver 4 time');
INSERT INTO `lang_definitions` VALUES (10229, 1048, 8, 'hver 5 time');
INSERT INTO `lang_definitions` VALUES (10230, 1049, 8, 'hver 6 time');
INSERT INTO `lang_definitions` VALUES (10231, 1050, 8, 'hver 8 time');
INSERT INTO `lang_definitions` VALUES (10232, 1051, 8, 'Hver Fjerde');
INSERT INTO `lang_definitions` VALUES (10233, 1052, 8, 'Annen hver');
INSERT INTO `lang_definitions` VALUES (10234, 1053, 8, 'Hver Tredje');
INSERT INTO `lang_definitions` VALUES (10235, 1062, 8, 'Øvnings Mønstre');
INSERT INTO `lang_definitions` VALUES (10236, 1063, 8, 'Avslutt fra administrasjon');
INSERT INTO `lang_definitions` VALUES (10237, 1065, 8, 'Utvidet oversikt');
INSERT INTO `lang_definitions` VALUES (10238, 1067, 8, 'Utløps');
INSERT INTO `lang_definitions` VALUES (10239, 1068, 8, 'Utløps Dato');
INSERT INTO `lang_definitions` VALUES (10240, 1069, 8, 'Utløper');
INSERT INTO `lang_definitions` VALUES (10241, 1070, 8, 'Eksporter');
INSERT INTO `lang_definitions` VALUES (10242, 1087, 8, 'Eksterne Refferanser');
INSERT INTO `lang_definitions` VALUES (10243, 1097, 8, 'Lokale');
INSERT INTO `lang_definitions` VALUES (10244, 1098, 8, 'lokale');
INSERT INTO `lang_definitions` VALUES (10245, 1102, 8, 'Lokale:');
INSERT INTO `lang_definitions` VALUES (10246, 1103, 8, 'Mislykket');
INSERT INTO `lang_definitions` VALUES (10247, 1106, 8, 'Familie Historie');
INSERT INTO `lang_definitions` VALUES (10248, 1108, 8, 'Familie Historie:');
INSERT INTO `lang_definitions` VALUES (10249, 1109, 8, 'Familie størrelse');
INSERT INTO `lang_definitions` VALUES (10250, 1111, 8, 'Far');
INSERT INTO `lang_definitions` VALUES (10251, 1113, 8, 'utmattet');
INSERT INTO `lang_definitions` VALUES (10252, 1114, 8, 'Faks');
INSERT INTO `lang_definitions` VALUES (10253, 1117, 8, 'Inkommende Fakser');
INSERT INTO `lang_definitions` VALUES (10254, 1118, 8, 'Utgående Fakser');
INSERT INTO `lang_definitions` VALUES (10255, 1119, 8, 'Februar');
INSERT INTO `lang_definitions` VALUES (10256, 1124, 8, 'Avgift');
INSERT INTO `lang_definitions` VALUES (10257, 1125, 8, 'avgift');
INSERT INTO `lang_definitions` VALUES (10258, 1127, 8, 'Avgifts skjema');
INSERT INTO `lang_definitions` VALUES (10259, 1129, 8, 'Avgifter');
INSERT INTO `lang_definitions` VALUES (10260, 1130, 8, 'Kvinnelig');
INSERT INTO `lang_definitions` VALUES (10261, 1132, 8, 'Kvinnelige Kondommer');
INSERT INTO `lang_definitions` VALUES (10262, 1138, 8, 'Feber');
INSERT INTO `lang_definitions` VALUES (10263, 1139, 8, 'Feber:');
INSERT INTO `lang_definitions` VALUES (10264, 1146, 8, 'Filnavn');
INSERT INTO `lang_definitions` VALUES (10265, 1147, 8, 'Fyll inn her hvis du skal sende email påmindelser til pasient');
INSERT INTO `lang_definitions` VALUES (10266, 1150, 8, 'Filter');
INSERT INTO `lang_definitions` VALUES (10267, 1153, 8, 'finans');
INSERT INTO `lang_definitions` VALUES (10268, 1157, 8, 'Finn');
INSERT INTO `lang_definitions` VALUES (10269, 1158, 8, 'Finn Tilgjengelige');
INSERT INTO `lang_definitions` VALUES (10270, 1159, 8, 'Finn Tilgjengelige Avtaler ');
INSERT INTO `lang_definitions` VALUES (10271, 1160, 8, 'Finn Pasient');
INSERT INTO `lang_definitions` VALUES (10272, 1164, 8, 'Først');
INSERT INTO `lang_definitions` VALUES (10273, 1165, 8, 'Første dag i uken');
INSERT INTO `lang_definitions` VALUES (10274, 1166, 8, 'Fornavn');
INSERT INTO `lang_definitions` VALUES (10275, 1168, 8, 'Fornavn:');
INSERT INTO `lang_definitions` VALUES (10276, 1169, 8, 'Form');
INSERT INTO `lang_definitions` VALUES (10277, 1175, 8, 'Influensa vaksinasjon');
INSERT INTO `lang_definitions` VALUES (10278, 1178, 8, 'Følg manuelt');
INSERT INTO `lang_definitions` VALUES (10279, 1180, 8, 'Fot');
INSERT INTO `lang_definitions` VALUES (10280, 1181, 8, 'Fot Problemer');
INSERT INTO `lang_definitions` VALUES (10281, 1182, 8, 'Fot:');
INSERT INTO `lang_definitions` VALUES (10282, 1184, 8, 'Fotball Skade Rapport');
INSERT INTO `lang_definitions` VALUES (10283, 1185, 8, 'Fotplagg Type');
INSERT INTO `lang_definitions` VALUES (10284, 1186, 8, 'for');
INSERT INTO `lang_definitions` VALUES (10285, 1189, 8, 'for:');
INSERT INTO `lang_definitions` VALUES (10286, 1190, 8, 'Forarm');
INSERT INTO `lang_definitions` VALUES (10287, 1191, 8, 'Skjema');
INSERT INTO `lang_definitions` VALUES (10288, 1194, 8, 'Format');
INSERT INTO `lang_definitions` VALUES (10289, 1196, 8, 'Skjemaer');
INSERT INTO `lang_definitions` VALUES (10290, 1197, 8, 'Skjema Administrasjon');
INSERT INTO `lang_definitions` VALUES (10291, 1198, 8, 'Send videre via Fax');
INSERT INTO `lang_definitions` VALUES (10292, 1199, 8, 'Fjerde');
INSERT INTO `lang_definitions` VALUES (10293, 1200, 8, 'Brudd');
INSERT INTO `lang_definitions` VALUES (10294, 1210, 8, 'Fredag');
INSERT INTO `lang_definitions` VALUES (10295, 1211, 8, 'Fra');
INSERT INTO `lang_definitions` VALUES (10296, 1213, 8, 'Fra:');
INSERT INTO `lang_definitions` VALUES (10297, 1214, 8, 'Fra:');
INSERT INTO `lang_definitions` VALUES (10298, 1232, 8, 'Full Trenning');
INSERT INTO `lang_definitions` VALUES (10299, 1235, 8, 'Galle Steiner');
INSERT INTO `lang_definitions` VALUES (10300, 1236, 8, 'Spill periode');
INSERT INTO `lang_definitions` VALUES (10301, 1237, 8, 'Spill');
INSERT INTO `lang_definitions` VALUES (10302, 1246, 8, 'Kjønn');
INSERT INTO `lang_definitions` VALUES (10303, 1247, 8, 'Generelt');
INSERT INTO `lang_definitions` VALUES (10304, 1248, 8, 'Generel Service Kategori');
INSERT INTO `lang_definitions` VALUES (10305, 1255, 8, 'Generer brev som omhandler');
INSERT INTO `lang_definitions` VALUES (10306, 1256, 8, 'Generer rapport');
INSERT INTO `lang_definitions` VALUES (10307, 1259, 8, 'Generert på');
INSERT INTO `lang_definitions` VALUES (10308, 1260, 8, 'Genererer');
INSERT INTO `lang_definitions` VALUES (10309, 1265, 8, 'Global');
INSERT INTO `lang_definitions` VALUES (10310, 1276, 8, 'Gruppe');
INSERT INTO `lang_definitions` VALUES (10311, 1281, 8, 'Gruppe Nummer');
INSERT INTO `lang_definitions` VALUES (10312, 1282, 8, 'Gruppe:');
INSERT INTO `lang_definitions` VALUES (10313, 1283, 8, 'Gruppenavn');
INSERT INTO `lang_definitions` VALUES (10314, 1295, 8, 'Hender + Fingre');
INSERT INTO `lang_definitions` VALUES (10315, 1296, 8, 'Hånd Problemer');
INSERT INTO `lang_definitions` VALUES (10316, 1300, 8, 'Skadelige Aktiviteter');
INSERT INTO `lang_definitions` VALUES (10317, 1305, 8, 'Hode');
INSERT INTO `lang_definitions` VALUES (10318, 1309, 8, 'Hodepine');
INSERT INTO `lang_definitions` VALUES (10319, 1314, 8, 'Hjerte Infarkt');
INSERT INTO `lang_definitions` VALUES (10320, 1316, 8, 'Hjerte Svikt');
INSERT INTO `lang_definitions` VALUES (10321, 1318, 8, 'Hjerte Problemer');
INSERT INTO `lang_definitions` VALUES (10322, 1319, 8, 'Hjerte Operasjon');
INSERT INTO `lang_definitions` VALUES (10323, 1320, 8, 'Hjerte Transplantasjon');
INSERT INTO `lang_definitions` VALUES (10324, 1321, 8, 'HJERTE:');
INSERT INTO `lang_definitions` VALUES (10325, 1328, 8, 'Hjelp');
INSERT INTO `lang_definitions` VALUES (10326, 1329, 8, 'hjelp');
INSERT INTO `lang_definitions` VALUES (10327, 1345, 8, 'Herpes');
INSERT INTO `lang_definitions` VALUES (10328, 1352, 8, 'Skjult');
INSERT INTO `lang_definitions` VALUES (10329, 1354, 8, 'Skjul');
INSERT INTO `lang_definitions` VALUES (10330, 1355, 8, 'Skjul Detaljer');
INSERT INTO `lang_definitions` VALUES (10331, 1358, 8, 'Høyt Bloodtrykk');
INSERT INTO `lang_definitions` VALUES (10332, 1359, 8, 'Hofte + lysk');
INSERT INTO `lang_definitions` VALUES (10333, 1360, 8, 'Hofte og lysk');
INSERT INTO `lang_definitions` VALUES (10334, 1361, 8, 'Hofte Problemer');
INSERT INTO `lang_definitions` VALUES (10335, 1362, 8, 'Hofte Erstatning');
INSERT INTO `lang_definitions` VALUES (10336, 1366, 8, 'Historie');
INSERT INTO `lang_definitions` VALUES (10337, 1372, 8, 'Hold nede [Ctrl] for å velge flere eller til å ta bort individuelle');
INSERT INTO `lang_definitions` VALUES (10338, 1376, 8, 'Hjemme Telefon');
INSERT INTO `lang_definitions` VALUES (10339, 1379, 8, 'Hjemløs, osv');
INSERT INTO `lang_definitions` VALUES (10340, 1381, 8, 'Timer');
INSERT INTO `lang_definitions` VALUES (10341, 1382, 8, 'Hvordan inntraff skaden?');
INSERT INTO `lang_definitions` VALUES (10342, 1383, 8, 'Hvordan inntraff skaden?:');
INSERT INTO `lang_definitions` VALUES (10343, 1387, 8, 'HTML');
INSERT INTO `lang_definitions` VALUES (10344, 1388, 8, 'Hyperaktiv');
INSERT INTO `lang_definitions` VALUES (10345, 1394, 8, 'Jeg er opptatt under denne perioden.');
INSERT INTO `lang_definitions` VALUES (10346, 1395, 8, 'Jeg har ikke tilgang til å lese');
INSERT INTO `lang_definitions` VALUES (10347, 1405, 8, 'Hvis arbeidsløs skriv inn Student');
INSERT INTO `lang_definitions` VALUES (10348, 1408, 8, 'Hvis du vil forandre data typer, eller legge til rader eller kolonner');
INSERT INTO `lang_definitions` VALUES (10349, 1409, 8, 'Sykdom');
INSERT INTO `lang_definitions` VALUES (10350, 1411, 8, 'Immunisering');
INSERT INTO `lang_definitions` VALUES (10351, 1414, 8, 'Immuniseringer');
INSERT INTO `lang_definitions` VALUES (10352, 1417, 8, 'Implantater');
INSERT INTO `lang_definitions` VALUES (10353, 1418, 8, 'Import');
INSERT INTO `lang_definitions` VALUES (10354, 1422, 8, 'Importert fra Økonomi');
INSERT INTO `lang_definitions` VALUES (10355, 1424, 8, 'i');
INSERT INTO `lang_definitions` VALUES (10356, 1426, 8, 'i hvert øye');
INSERT INTO `lang_definitions` VALUES (10357, 1427, 8, 'i venstre øye');
INSERT INTO `lang_definitions` VALUES (10358, 1428, 8, 'i nesa');
INSERT INTO `lang_definitions` VALUES (10359, 1430, 8, 'i høyre øye');
INSERT INTO `lang_definitions` VALUES (10360, 1431, 8, 'innom hus');
INSERT INTO `lang_definitions` VALUES (10361, 1438, 8, 'innkom');
INSERT INTO `lang_definitions` VALUES (10362, 1441, 8, 'øket:');
INSERT INTO `lang_definitions` VALUES (10363, 1449, 8, 'Infeksjoner');
INSERT INTO `lang_definitions` VALUES (10364, 1454, 8, 'Info');
INSERT INTO `lang_definitions` VALUES (10365, 1455, 8, 'Info test 1');
INSERT INTO `lang_definitions` VALUES (10366, 1456, 8, 'Info test 2');
INSERT INTO `lang_definitions` VALUES (10367, 1457, 8, 'Info test 3');
INSERT INTO `lang_definitions` VALUES (10368, 1458, 8, 'Info test 4');
INSERT INTO `lang_definitions` VALUES (10369, 1459, 8, 'Info test 5');
INSERT INTO `lang_definitions` VALUES (10370, 1460, 8, 'Info test 6');
INSERT INTO `lang_definitions` VALUES (10371, 1468, 8, 'Oversikts Rapport Over Skade');
INSERT INTO `lang_definitions` VALUES (10372, 1470, 8, 'Skade Type');
INSERT INTO `lang_definitions` VALUES (10373, 1482, 8, 'Søvnløshet');
INSERT INTO `lang_definitions` VALUES (10374, 1483, 8, 'Inspisering');
INSERT INTO `lang_definitions` VALUES (10375, 1485, 8, 'Installer DB');
INSERT INTO `lang_definitions` VALUES (10376, 1487, 8, 'Instrukser:');
INSERT INTO `lang_definitions` VALUES (10377, 1489, 8, 'Forsikring');
INSERT INTO `lang_definitions` VALUES (10378, 1490, 8, 'forsikring');
INSERT INTO `lang_definitions` VALUES (10379, 1491, 8, 'Forsikrings Selskaper');
INSERT INTO `lang_definitions` VALUES (10380, 1492, 8, 'Forsikrings Selskap');
INSERT INTO `lang_definitions` VALUES (10381, 1493, 8, 'Forsikrings Selskap Søk/Legg til');
INSERT INTO `lang_definitions` VALUES (10382, 1494, 8, 'Forsikrings Data');
INSERT INTO `lang_definitions` VALUES (10383, 1495, 8, 'Forsikrings Nummer');
INSERT INTO `lang_definitions` VALUES (10384, 1496, 8, 'Forsikrings Giver');
INSERT INTO `lang_definitions` VALUES (10385, 1500, 8, 'Intern feil - ingen sider var valgt!');
INSERT INTO `lang_definitions` VALUES (10386, 1501, 8, 'Intern feil - Pasient ID var ikke oppgitt!');
INSERT INTO `lang_definitions` VALUES (10387, 1511, 8, 'Tolker');
INSERT INTO `lang_definitions` VALUES (10388, 1514, 8, 'Interval');
INSERT INTO `lang_definitions` VALUES (10389, 1520, 8, 'Ugyldige service koder');
INSERT INTO `lang_definitions` VALUES (10390, 1521, 8, 'Ugyldig kilde valg \"');
INSERT INTO `lang_definitions` VALUES (10391, 1525, 8, 'Inventar Liste');
INSERT INTO `lang_definitions` VALUES (10392, 1537, 8, 'Uvanlig Hjerte Rytme');
INSERT INTO `lang_definitions` VALUES (10393, 1540, 8, 'feltet krever utfylling.');
INSERT INTO `lang_definitions` VALUES (10394, 1542, 8, 'Ikke gyldig (desimal fraksjoner er OK).');
INSERT INTO `lang_definitions` VALUES (10395, 1543, 8, 'Bruker PHP sikker modus?');
INSERT INTO `lang_definitions` VALUES (10396, 1546, 8, 'Problem');
INSERT INTO `lang_definitions` VALUES (10397, 1547, 8, 'Problemer');
INSERT INTO `lang_definitions` VALUES (10398, 1548, 8, 'Problemer (Skader/medisinske/allergi):');
INSERT INTO `lang_definitions` VALUES (10399, 1549, 8, 'Problemer og Møter');
INSERT INTO `lang_definitions` VALUES (10400, 1550, 8, 'Problemer og Møter for');
INSERT INTO `lang_definitions` VALUES (10401, 1551, 8, 'Problemer ikke tilgjengelig');
INSERT INTO `lang_definitions` VALUES (10402, 1552, 8, 'Problem seksjon');
INSERT INTO `lang_definitions` VALUES (10403, 1558, 8, 'Januar');
INSERT INTO `lang_definitions` VALUES (10404, 1560, 8, 'Beskrivelse av Jobb');
INSERT INTO `lang_definitions` VALUES (10405, 1565, 8, 'Juli');
INSERT INTO `lang_definitions` VALUES (10406, 1566, 8, 'Juni');
INSERT INTO `lang_definitions` VALUES (10407, 1569, 8, 'Begrunne');
INSERT INTO `lang_definitions` VALUES (10408, 1570, 8, 'Begrunne/Lagre');
INSERT INTO `lang_definitions` VALUES (10409, 1571, 8, 'ok, her er resten');
INSERT INTO `lang_definitions` VALUES (10410, 1572, 8, 'Nøkkelord');
INSERT INTO `lang_definitions` VALUES (10411, 1575, 8, 'Nyre kreft');
INSERT INTO `lang_definitions` VALUES (10412, 1576, 8, 'Nyre Svikt');
INSERT INTO `lang_definitions` VALUES (10413, 1577, 8, 'Nyre infeksjoner');
INSERT INTO `lang_definitions` VALUES (10414, 1578, 8, 'Nyre steiner');
INSERT INTO `lang_definitions` VALUES (10415, 1579, 8, 'Nyre transplantasjon');
INSERT INTO `lang_definitions` VALUES (10416, 1580, 8, 'Kne');
INSERT INTO `lang_definitions` VALUES (10417, 1581, 8, 'Kne Problemer');
INSERT INTO `lang_definitions` VALUES (10418, 1582, 8, 'Kne Erstatning');
INSERT INTO `lang_definitions` VALUES (10419, 1585, 8, 'Merke');
INSERT INTO `lang_definitions` VALUES (10420, 1589, 8, 'Merker');
INSERT INTO `lang_definitions` VALUES (10421, 1591, 8, 'Blødning/ Hudens kondisjon');
INSERT INTO `lang_definitions` VALUES (10422, 1593, 8, 'Språk');
INSERT INTO `lang_definitions` VALUES (10423, 1594, 8, 'Språk kode');
INSERT INTO `lang_definitions` VALUES (10424, 1595, 8, 'Språk definisjon lagt til');
INSERT INTO `lang_definitions` VALUES (10425, 1598, 8, 'Språk navn');
INSERT INTO `lang_definitions` VALUES (10426, 1600, 8, 'Siste');
INSERT INTO `lang_definitions` VALUES (10427, 1603, 8, 'Siste møte');
INSERT INTO `lang_definitions` VALUES (10428, 1604, 8, 'Etternavn');
INSERT INTO `lang_definitions` VALUES (10429, 1606, 8, 'Etternavn:');
INSERT INTO `lang_definitions` VALUES (10430, 1609, 8, 'Sist Besøk');
INSERT INTO `lang_definitions` VALUES (10431, 1623, 8, 'La være blankt for å holde passordet uforandret.');
INSERT INTO `lang_definitions` VALUES (10432, 1625, 8, 'Forlatt skjema');
INSERT INTO `lang_definitions` VALUES (10433, 1626, 8, 'Venstre');
INSERT INTO `lang_definitions` VALUES (10434, 1628, 8, 'venstre øre');
INSERT INTO `lang_definitions` VALUES (10435, 1629, 8, 'Venstre:');
INSERT INTO `lang_definitions` VALUES (10436, 1630, 8, 'Venstre:');
INSERT INTO `lang_definitions` VALUES (10437, 1632, 8, 'Lovlig');
INSERT INTO `lang_definitions` VALUES (10438, 1634, 8, 'Lengde');
INSERT INTO `lang_definitions` VALUES (10439, 1636, 8, 'Brev');
INSERT INTO `lang_definitions` VALUES (10440, 1644, 8, 'Livsstill');
INSERT INTO `lang_definitions` VALUES (10441, 1656, 8, 'Hvis Forsikrings selskaper');
INSERT INTO `lang_definitions` VALUES (10442, 1659, 8, 'Hvis lister');
INSERT INTO `lang_definitions` VALUES (10443, 1662, 8, 'Hvis Resepter');
INSERT INTO `lang_definitions` VALUES (10444, 1663, 8, 'Lister');
INSERT INTO `lang_definitions` VALUES (10445, 1667, 8, 'LASTER');
INSERT INTO `lang_definitions` VALUES (10446, 1669, 8, 'Lokal');
INSERT INTO `lang_definitions` VALUES (10447, 1675, 8, 'Inlogget');
INSERT INTO `lang_definitions` VALUES (10448, 1676, 8, 'Logget in som');
INSERT INTO `lang_definitions` VALUES (10449, 1677, 8, 'Logget in som:');
INSERT INTO `lang_definitions` VALUES (10450, 1678, 8, 'Logget ut.');
INSERT INTO `lang_definitions` VALUES (10451, 1679, 8, 'Log in');
INSERT INTO `lang_definitions` VALUES (10452, 1681, 8, 'Log ut');
INSERT INTO `lang_definitions` VALUES (10453, 1683, 8, 'Logger');
INSERT INTO `lang_definitions` VALUES (10454, 1694, 8, 'Lunge Kreft');
INSERT INTO `lang_definitions` VALUES (10455, 1696, 8, 'LUNGER:');
INSERT INTO `lang_definitions` VALUES (10456, 1697, 8, 'Lunger:');
INSERT INTO `lang_definitions` VALUES (10457, 1701, 8, 'Hoved Adresse');
INSERT INTO `lang_definitions` VALUES (10458, 1705, 8, 'Manlig');
INSERT INTO `lang_definitions` VALUES (10459, 1706, 8, 'Kondommer');
INSERT INTO `lang_definitions` VALUES (10460, 1725, 8, 'Medisinsk');
INSERT INTO `lang_definitions` VALUES (10461, 1727, 8, 'Medisinsk problem');
INSERT INTO `lang_definitions` VALUES (10462, 1728, 8, 'Medisinske Problemer');
INSERT INTO `lang_definitions` VALUES (10463, 1729, 8, 'Medisinsk Historie');
INSERT INTO `lang_definitions` VALUES (10464, 1735, 8, 'Medisiner');
INSERT INTO `lang_definitions` VALUES (10465, 1736, 8, 'Medisiner:');
INSERT INTO `lang_definitions` VALUES (10466, 1741, 8, 'Menn');
INSERT INTO `lang_definitions` VALUES (10467, 1742, 8, 'Menn og Kvinner');
INSERT INTO `lang_definitions` VALUES (10468, 1743, 8, 'Bare Menn');
INSERT INTO `lang_definitions` VALUES (10469, 1748, 8, 'Psykisk Sykdom');
INSERT INTO `lang_definitions` VALUES (10470, 1749, 8, 'Melding');
INSERT INTO `lang_definitions` VALUES (10471, 1750, 8, 'MELDING:');
INSERT INTO `lang_definitions` VALUES (10472, 1751, 8, 'Metode');
INSERT INTO `lang_definitions` VALUES (10473, 1752, 8, 'Ødeleggelses Metode');
INSERT INTO `lang_definitions` VALUES (10474, 1760, 8, 'Mellom Navn');
INSERT INTO `lang_definitions` VALUES (10475, 1767, 8, 'minutter');
INSERT INTO `lang_definitions` VALUES (10476, 1768, 8, 'Minutter');
INSERT INTO `lang_definitions` VALUES (10477, 1774, 8, 'Bommet');
INSERT INTO `lang_definitions` VALUES (10478, 1778, 8, 'Mikset');
INSERT INTO `lang_definitions` VALUES (10479, 1783, 8, 'Mobil');
INSERT INTO `lang_definitions` VALUES (10480, 1787, 8, 'Man');
INSERT INTO `lang_definitions` VALUES (10481, 1788, 8, 'Man til Fre');
INSERT INTO `lang_definitions` VALUES (10482, 1790, 8, 'Mandag');
INSERT INTO `lang_definitions` VALUES (10483, 1791, 8, 'måned');
INSERT INTO `lang_definitions` VALUES (10484, 1792, 8, 'Måned');
INSERT INTO `lang_definitions` VALUES (10485, 1793, 8, 'Månedlig Perspektiv');
INSERT INTO `lang_definitions` VALUES (10486, 1794, 8, 'Måned(er)');
INSERT INTO `lang_definitions` VALUES (10487, 1798, 8, 'Mor');
INSERT INTO `lang_definitions` VALUES (10488, 1800, 8, 'Flytt');
INSERT INTO `lang_definitions` VALUES (10489, 1803, 8, 'Flytt til Pasient');
INSERT INTO `lang_definitions` VALUES (10490, 1810, 8, 'Flere steder');
INSERT INTO `lang_definitions` VALUES (10491, 1819, 8, 'Muskel skade');
INSERT INTO `lang_definitions` VALUES (10492, 1821, 8, 'Gjensidig Definert');
INSERT INTO `lang_definitions` VALUES (10493, 1825, 8, 'Navn');
INSERT INTO `lang_definitions` VALUES (10494, 1829, 8, 'Forsikrings Selskapets Navn');
INSERT INTO `lang_definitions` VALUES (10495, 1833, 8, 'Navn:');
INSERT INTO `lang_definitions` VALUES (10496, 1837, 8, 'Nasjonalitet');
INSERT INTO `lang_definitions` VALUES (10497, 1842, 8, 'Nakke');
INSERT INTO `lang_definitions` VALUES (10498, 1843, 8, 'Nakke Problemer');
INSERT INTO `lang_definitions` VALUES (10499, 1852, 8, 'Nerve skade');
INSERT INTO `lang_definitions` VALUES (10500, 1857, 8, 'Ny');
INSERT INTO `lang_definitions` VALUES (10501, 1858, 8, 'Ny=>');
INSERT INTO `lang_definitions` VALUES (10502, 1861, 8, 'Ny Avtale');
INSERT INTO `lang_definitions` VALUES (10503, 1862, 8, 'Nye Kategorier');
INSERT INTO `lang_definitions` VALUES (10504, 1864, 8, 'Nye Klienter');
INSERT INTO `lang_definitions` VALUES (10505, 1872, 8, 'Ny Gruppe');
INSERT INTO `lang_definitions` VALUES (10506, 1876, 8, 'Ny Pasient');
INSERT INTO `lang_definitions` VALUES (10507, 1881, 8, 'Ny Bruker');
INSERT INTO `lang_definitions` VALUES (10508, 1885, 8, 'Neste');
INSERT INTO `lang_definitions` VALUES (10509, 1886, 8, 'Neste Dag');
INSERT INTO `lang_definitions` VALUES (10510, 1887, 8, 'Neste Måned');
INSERT INTO `lang_definitions` VALUES (10511, 1888, 8, 'Neste Uke');
INSERT INTO `lang_definitions` VALUES (10512, 1889, 8, 'Kallenavn');
INSERT INTO `lang_definitions` VALUES (10513, 1892, 8, 'NEI');
INSERT INTO `lang_definitions` VALUES (10514, 1893, 8, 'Nei');
INSERT INTO `lang_definitions` VALUES (10515, 1894, 8, 'Ingen tilgang');
INSERT INTO `lang_definitions` VALUES (10516, 1900, 8, 'Ingen Diagnose');
INSERT INTO `lang_definitions` VALUES (10517, 1901, 8, 'Ingen slutt dato');
INSERT INTO `lang_definitions` VALUES (10518, 1904, 8, 'Ingen gruppe var valgt');
INSERT INTO `lang_definitions` VALUES (10519, 1906, 8, 'Ingen Forsikrings Selskap Funnet');
INSERT INTO `lang_definitions` VALUES (10520, 1912, 8, 'Ingen Partnere Funnet');
INSERT INTO `lang_definitions` VALUES (10521, 1937, 8, 'Ingen');
INSERT INTO `lang_definitions` VALUES (10522, 1938, 8, 'ingen');
INSERT INTO `lang_definitions` VALUES (10523, 1939, 8, 'Ingen av de ovenfor');
INSERT INTO `lang_definitions` VALUES (10524, 1942, 8, 'Normal');
INSERT INTO `lang_definitions` VALUES (10525, 1946, 8, 'Normal Lunge Eksaminering:');
INSERT INTO `lang_definitions` VALUES (10526, 1947, 8, 'Normal Lunge Eksaminering:');
INSERT INTO `lang_definitions` VALUES (10527, 1950, 8, 'Normal Høyre');
INSERT INTO `lang_definitions` VALUES (10528, 1951, 8, 'Normal Høyre:');
INSERT INTO `lang_definitions` VALUES (10529, 1953, 8, 'normal:');
INSERT INTO `lang_definitions` VALUES (10530, 1958, 8, 'Ikke Tilatt');
INSERT INTO `lang_definitions` VALUES (10531, 1959, 8, 'Ikke tilatt å slette administrators gruppe');
INSERT INTO `lang_definitions` VALUES (10532, 1969, 8, 'Ikke Eksaminert');
INSERT INTO `lang_definitions` VALUES (10533, 1970, 8, 'Ikke Eksaminert:');
INSERT INTO `lang_definitions` VALUES (10534, 1971, 8, 'Ikke Eksaminert:');
INSERT INTO `lang_definitions` VALUES (10535, 1974, 8, 'Ikke sett siden');
INSERT INTO `lang_definitions` VALUES (10536, 1975, 8, 'Notat');
INSERT INTO `lang_definitions` VALUES (10537, 1983, 8, 'Ingenting var valgt');
INSERT INTO `lang_definitions` VALUES (10538, 1987, 8, 'November');
INSERT INTO `lang_definitions` VALUES (10539, 1994, 8, 'Nummer');
INSERT INTO `lang_definitions` VALUES (10540, 2004, 8, 'Okkupering');
INSERT INTO `lang_definitions` VALUES (10541, 2006, 8, 'Oktober');
INSERT INTO `lang_definitions` VALUES (10542, 2009, 8, 'av tabletter');
INSERT INTO `lang_definitions` VALUES (10543, 2012, 8, 'Kontor Notater');
INSERT INTO `lang_definitions` VALUES (10544, 2014, 8, 'Avkom');
INSERT INTO `lang_definitions` VALUES (10545, 2016, 8, 'OK');
INSERT INTO `lang_definitions` VALUES (10546, 2018, 8, 'Gamle Klienter');
INSERT INTO `lang_definitions` VALUES (10547, 2022, 8, 'På');
INSERT INTO `lang_definitions` VALUES (10548, 2023, 8, 'På Hånden');
INSERT INTO `lang_definitions` VALUES (10549, 2027, 8, 'Bare Aktiv');
INSERT INTO `lang_definitions` VALUES (10550, 2035, 8, 'Åpen');
INSERT INTO `lang_definitions` VALUES (10551, 2038, 8, 'Valg');
INSERT INTO `lang_definitions` VALUES (10552, 2039, 8, 'Valgfritt');
INSERT INTO `lang_definitions` VALUES (10553, 2045, 8, 'Eller');
INSERT INTO `lang_definitions` VALUES (10554, 2052, 8, 'Bestilling');
INSERT INTO `lang_definitions` VALUES (10555, 2054, 8, 'Organ skade');
INSERT INTO `lang_definitions` VALUES (10556, 2055, 8, 'Organisasjon');
INSERT INTO `lang_definitions` VALUES (10557, 2063, 8, 'Annet');
INSERT INTO `lang_definitions` VALUES (10558, 2064, 8, 'annet');
INSERT INTO `lang_definitions` VALUES (10559, 2069, 8, 'annen måned');
INSERT INTO `lang_definitions` VALUES (10560, 2082, 8, 'Utfall');
INSERT INTO `lang_definitions` VALUES (10561, 2094, 8, 'Sider');
INSERT INTO `lang_definitions` VALUES (10562, 2095, 8, 'Betalt');
INSERT INTO `lang_definitions` VALUES (10563, 2097, 8, 'Betalt Via');
INSERT INTO `lang_definitions` VALUES (10564, 2103, 8, 'Partner');
INSERT INTO `lang_definitions` VALUES (10565, 2104, 8, 'Passord');
INSERT INTO `lang_definitions` VALUES (10566, 2105, 8, 'Endre Passord');
INSERT INTO `lang_definitions` VALUES (10567, 2108, 8, 'Passord:');
INSERT INTO `lang_definitions` VALUES (10568, 2109, 8, 'Tidligere Møter');
INSERT INTO `lang_definitions` VALUES (10569, 2110, 8, 'Tidligere Møter og Dokumenter');
INSERT INTO `lang_definitions` VALUES (10570, 2114, 8, 'Pasient');
INSERT INTO `lang_definitions` VALUES (10571, 2117, 8, 'Pasient Allergier');
INSERT INTO `lang_definitions` VALUES (10572, 2119, 8, 'Pasient Avtale');
INSERT INTO `lang_definitions` VALUES (10573, 2126, 8, 'Pasient Dokument');
INSERT INTO `lang_definitions` VALUES (10574, 2131, 8, 'Pasient Historie');
INSERT INTO `lang_definitions` VALUES (10575, 2132, 8, 'Pasient Historie / Livsstill');
INSERT INTO `lang_definitions` VALUES (10576, 2139, 8, 'Pasient Problemer');
INSERT INTO `lang_definitions` VALUES (10577, 2141, 8, 'Pasientens Medisinske Problemer');
INSERT INTO `lang_definitions` VALUES (10578, 2145, 8, 'Pasient Notater');
INSERT INTO `lang_definitions` VALUES (10579, 2147, 8, 'Pasient Nummer');
INSERT INTO `lang_definitions` VALUES (10580, 2150, 8, 'Pasient Rapport');
INSERT INTO `lang_definitions` VALUES (10581, 2155, 8, 'Pasient/Klient');
INSERT INTO `lang_definitions` VALUES (10582, 2156, 8, 'Pasient:');
INSERT INTO `lang_definitions` VALUES (10583, 2157, 8, 'Pasienter');
INSERT INTO `lang_definitions` VALUES (10584, 2160, 8, 'Betalings Dato:');
INSERT INTO `lang_definitions` VALUES (10585, 2163, 8, 'Betaler');
INSERT INTO `lang_definitions` VALUES (10586, 2174, 8, 'Venter');
INSERT INTO `lang_definitions` VALUES (10587, 2194, 8, 'Telefon');
INSERT INTO `lang_definitions` VALUES (10588, 2196, 8, 'Telefon Nummer');
INSERT INTO `lang_definitions` VALUES (10589, 2210, 8, 'Piller');
INSERT INTO `lang_definitions` VALUES (10590, 2232, 8, 'Vær vennlig å betal denne summen');
INSERT INTO `lang_definitions` VALUES (10591, 2245, 8, 'Polise');
INSERT INTO `lang_definitions` VALUES (10592, 2250, 8, 'Dårlig Appetit');
INSERT INTO `lang_definitions` VALUES (10593, 2251, 8, 'Dårlig Sirkulasjon');
INSERT INTO `lang_definitions` VALUES (10594, 2252, 8, 'Dårlig Hørsel');
INSERT INTO `lang_definitions` VALUES (10595, 3202, 8, 'versjon');
INSERT INTO `lang_definitions` VALUES (10596, 3205, 8, 'Se');
INSERT INTO `lang_definitions` VALUES (10597, 3208, 8, 'Viss omfattende pasient rapport');
INSERT INTO `lang_definitions` VALUES (10598, 3211, 8, 'Se handlinger i et popup vindu?');
INSERT INTO `lang_definitions` VALUES (10599, 3216, 8, 'Se:');
INSERT INTO `lang_definitions` VALUES (10600, 3219, 8, 'Besøks Kategori:');
INSERT INTO `lang_definitions` VALUES (10601, 3220, 8, 'Besøks dato');
INSERT INTO `lang_definitions` VALUES (10602, 3222, 8, 'Besøk');
INSERT INTO `lang_definitions` VALUES (10603, 3223, 8, 'Besøk Fra');
INSERT INTO `lang_definitions` VALUES (10604, 3229, 8, 'W');
INSERT INTO `lang_definitions` VALUES (10605, 3232, 8, 'venter');
INSERT INTO `lang_definitions` VALUES (10606, 3242, 8, 'Web side');
INSERT INTO `lang_definitions` VALUES (10607, 3243, 8, 'Ons');
INSERT INTO `lang_definitions` VALUES (10608, 3244, 8, 'Onsdag');
INSERT INTO `lang_definitions` VALUES (10609, 3245, 8, 'uke');
INSERT INTO `lang_definitions` VALUES (10610, 3246, 8, 'Uke');
INSERT INTO `lang_definitions` VALUES (10611, 3247, 8, 'Uke oversikt');
INSERT INTO `lang_definitions` VALUES (10612, 3248, 8, 'Uke(r)');
INSERT INTO `lang_definitions` VALUES (10613, 3251, 8, 'Vekt tap');
INSERT INTO `lang_definitions` VALUES (10614, 3252, 8, 'Var servicen relatert til en nødsituasjon?');
INSERT INTO `lang_definitions` VALUES (10615, 3253, 8, 'Hva skal taes med i betraktning?');
INSERT INTO `lang_definitions` VALUES (10616, 3255, 8, 'veser');
INSERT INTO `lang_definitions` VALUES (10617, 3257, 8, 'vesing');
INSERT INTO `lang_definitions` VALUES (10618, 3264, 8, 'innen timer');
INSERT INTO `lang_definitions` VALUES (10619, 3265, 8, 'innen timer:');
INSERT INTO `lang_definitions` VALUES (10620, 3266, 8, 'innen minuter');
INSERT INTO `lang_definitions` VALUES (10621, 3267, 8, 'innen minuter:');
INSERT INTO `lang_definitions` VALUES (10622, 3268, 8, 'Foruten oppdatering');
INSERT INTO `lang_definitions` VALUES (10623, 3269, 8, 'Vitne');
INSERT INTO `lang_definitions` VALUES (10624, 3271, 8, 'Kvinner');
INSERT INTO `lang_definitions` VALUES (10625, 3272, 8, 'Kun kvinner');
INSERT INTO `lang_definitions` VALUES (10626, 3273, 8, 'Arbeid');
INSERT INTO `lang_definitions` VALUES (10627, 3274, 8, 'ARBEIDS NOTIS');
INSERT INTO `lang_definitions` VALUES (10628, 3275, 8, 'Jobb telefon');
INSERT INTO `lang_definitions` VALUES (10629, 3277, 8, 'Arbeids relatert?');
INSERT INTO `lang_definitions` VALUES (10630, 3279, 8, 'Arbeid/Skole notis');
INSERT INTO `lang_definitions` VALUES (10631, 3283, 8, 'Håndledd');
INSERT INTO `lang_definitions` VALUES (10632, 3284, 8, 'Håndledd og hånd');
INSERT INTO `lang_definitions` VALUES (10633, 3285, 8, 'Håndledds problemer');
INSERT INTO `lang_definitions` VALUES (10634, 3287, 8, 'skriv av');
INSERT INTO `lang_definitions` VALUES (10635, 3290, 8, 'x kansellert');
INSERT INTO `lang_definitions` VALUES (10636, 3291, 8, 'Røntgen');
INSERT INTO `lang_definitions` VALUES (10637, 3298, 8, 'år');
INSERT INTO `lang_definitions` VALUES (10638, 3299, 8, 'År');
INSERT INTO `lang_definitions` VALUES (10639, 3300, 8, 'År oversikt');
INSERT INTO `lang_definitions` VALUES (10640, 3301, 8, 'År');
INSERT INTO `lang_definitions` VALUES (10641, 3302, 8, 'JA');
INSERT INTO `lang_definitions` VALUES (10642, 3303, 8, 'Ja');
INSERT INTO `lang_definitions` VALUES (10643, 3304, 8, 'ja');
INSERT INTO `lang_definitions` VALUES (10644, 3305, 8, 'JA!');
INSERT INTO `lang_definitions` VALUES (10645, 3308, 8, 'Ja:');
INSERT INTO `lang_definitions` VALUES (10646, 3310, 8, 'Du har ikke tilgang til å slette denne hendelsen');
INSERT INTO `lang_definitions` VALUES (10647, 3311, 8, 'Du har ikke tilgang til å forandre på denne hendelsen');
INSERT INTO `lang_definitions` VALUES (10648, 3312, 8, 'Du har ikke tilgang til dette');
INSERT INTO `lang_definitions` VALUES (10649, 3316, 8, 'Du får ikke tilgang til denne funksjonen direkte');
INSERT INTO `lang_definitions` VALUES (10650, 3317, 8, 'Du får ikke tilgang til denne siden direkte');
INSERT INTO `lang_definitions` VALUES (10651, 3321, 8, 'Du valgte ingen hendelser');
INSERT INTO `lang_definitions` VALUES (10652, 3324, 8, 'Velg eller lag en pasient først');
INSERT INTO `lang_definitions` VALUES (10653, 3325, 8, 'Velg eller lag et møte');
INSERT INTO `lang_definitions` VALUES (10654, 3328, 8, 'Din slutt dato er ugyldig');
INSERT INTO `lang_definitions` VALUES (10655, 3329, 8, 'Din sak har blitt slettet');
INSERT INTO `lang_definitions` VALUES (10656, 3330, 8, 'Din sak har blitt forandret');
INSERT INTO `lang_definitions` VALUES (10657, 3331, 8, 'Din sak har blitt sendtDin ');
INSERT INTO `lang_definitions` VALUES (10658, 3333, 8, 'postkallenderen dins konfigurasjon har blitt tilbakestilt til utganspunktet ');
INSERT INTO `lang_definitions` VALUES (10659, 3334, 8, 'Postkallenderen dins konfigurasjon har blitt oppdatert');
INSERT INTO `lang_definitions` VALUES (10660, 3335, 8, 'Din gjentagelses frekvens må være et siffer.');
INSERT INTO `lang_definitions` VALUES (10661, 3336, 8, 'Din gjentagelses frekvens må være minst 1.');
INSERT INTO `lang_definitions` VALUES (10662, 3337, 8, 'Din start dato er større en din slutt dato');
INSERT INTO `lang_definitions` VALUES (10663, 3338, 8, 'Din start dato er ikke gyldig');
INSERT INTO `lang_definitions` VALUES (10664, 3340, 8, 'åååå-mm-dd');
INSERT INTO `lang_definitions` VALUES (10665, 3341, 8, 'åååå-mm-dd datoer assosiert med dette dokumentet');
INSERT INTO `lang_definitions` VALUES (10666, 3343, 8, 'åååå-mm-dd Fødselsdato');
INSERT INTO `lang_definitions` VALUES (10667, 3344, 8, 'åååå-mm-dd fødselsdato');
INSERT INTO `lang_definitions` VALUES (10668, 3349, 8, 'åååå-mm-dd dato for bedring eller slutt av medikament');
INSERT INTO `lang_definitions` VALUES (10669, 3351, 8, 'åååå-mm-dd dato for service');
INSERT INTO `lang_definitions` VALUES (10670, 3352, 8, 'åååå-mm-dd datoen til dette brevet');
INSERT INTO `lang_definitions` VALUES (10671, 3354, 8, 'åååå-mm-dd hendelses dato eller start dato');
INSERT INTO `lang_definitions` VALUES (10672, 3355, 8, 'åååå-mm-dd siste dato for denne hendelsen');
INSERT INTO `lang_definitions` VALUES (10673, 3357, 8, 'Postnummer');
INSERT INTO `lang_definitions` VALUES (10674, 3358, 8, 'Postnummer');
INSERT INTO `lang_definitions` VALUES (10675, 3359, 8, 'Postnummer');
INSERT INTO `lang_definitions` VALUES (10676, 3360, 8, 'men var');
INSERT INTO `lang_definitions` VALUES (10677, 3361, 8, 'kunne ikke få tilgang');
INSERT INTO `lang_definitions` VALUES (10678, 3362, 8, 'er du sikker på at du vil slette dette?');
INSERT INTO `lang_definitions` VALUES (10679, 3363, 8, 'medisin');
INSERT INTO `lang_definitions` VALUES (10680, 3364, 8, 'epost ikke sendt');
INSERT INTO `lang_definitions` VALUES (10681, 3365, 8, 'fra');
INSERT INTO `lang_definitions` VALUES (10682, 3366, 8, 'har blitt laget');
INSERT INTO `lang_definitions` VALUES (10683, 3367, 8, 'har blitt åpnet igjen');
INSERT INTO `lang_definitions` VALUES (10684, 3368, 8, 'Historie');
INSERT INTO `lang_definitions` VALUES (10685, 3369, 8, 'er ikke et nummer');
INSERT INTO `lang_definitions` VALUES (10686, 3370, 8, 'er klar for sending av regning om igjen');
INSERT INTO `lang_definitions` VALUES (10687, 3373, 8, 'original medicaid referanse Nr');
INSERT INTO `lang_definitions` VALUES (10688, 3375, 8, 'ikke funnet!');
INSERT INTO `lang_definitions` VALUES (10689, 3377, 8, 'reseptet har nådd grensen sin av');
INSERT INTO `lang_definitions` VALUES (10690, 3378, 8, 'inntil');
INSERT INTO `lang_definitions` VALUES (10691, 3379, 8, 'oppdatering feilet, ikke i databasen?');
INSERT INTO `lang_definitions` VALUES (10692, 3381, 8, 'var vellyket satt i kø');
INSERT INTO `lang_definitions` VALUES (10693, 3382, 8, '! Dro uten besøk');
INSERT INTO `lang_definitions` VALUES (10694, 3383, 8, '\"for kode');
INSERT INTO `lang_definitions` VALUES (10695, 3384, 8, '\"er SJEKKET av i Postkalender instillinger!');
INSERT INTO `lang_definitions` VALUES (10696, 3386, 8, '# av tabletter:');
INSERT INTO `lang_definitions` VALUES (10697, 3388, 8, '$ Koding ferdig');
INSERT INTO `lang_definitions` VALUES (10698, 3389, 8, '$1.00');
INSERT INTO `lang_definitions` VALUES (10699, 3390, 8, '$merket (åååå-mm-dd):');
INSERT INTO `lang_definitions` VALUES (10700, 3392, 8, '% Kansellert < 24t');
INSERT INTO `lang_definitions` VALUES (10701, 3393, 8, 'burde eksistere men gjør ikke det.');
INSERT INTO `lang_definitions` VALUES (10702, 3398, 8, '(Ny pasient)');
INSERT INTO `lang_definitions` VALUES (10703, 3399, 8, '(Notater og Tillatelser)');
INSERT INTO `lang_definitions` VALUES (10704, 3400, 8, '(Pasient Notater)');
INSERT INTO `lang_definitions` VALUES (10705, 3402, 8, '*Påminnelse gjort');
INSERT INTO `lang_definitions` VALUES (10706, 3403, 8, '**Flytt operasjoner til Problemer!');
INSERT INTO `lang_definitions` VALUES (10707, 3404, 8, '*Nødvendig');
INSERT INTO `lang_definitions` VALUES (10708, 3407, 8, '0-10');
INSERT INTO `lang_definitions` VALUES (10709, 3415, 8, '3 måneder');
INSERT INTO `lang_definitions` VALUES (10710, 3416, 8, '3 ganger daglig');
INSERT INTO `lang_definitions` VALUES (10711, 3420, 8, '4 måneder');
INSERT INTO `lang_definitions` VALUES (10712, 3421, 8, '4 ganger daglig');
INSERT INTO `lang_definitions` VALUES (10713, 3425, 8, '466.0, akut bronkit');
INSERT INTO `lang_definitions` VALUES (10714, 3428, 8, '491.8, Kronisk bronkit');
INSERT INTO `lang_definitions` VALUES (10715, 3429, 8, '493.92, Akut astma');
INSERT INTO `lang_definitions` VALUES (10716, 3434, 8, '6 måneder');
INSERT INTO `lang_definitions` VALUES (10717, 3444, 8, '99212 Opprettet - Ukomplisert');
INSERT INTO `lang_definitions` VALUES (10718, 3445, 8, '99213 Opprettet - lite komplisert');
INSERT INTO `lang_definitions` VALUES (10719, 3446, 8, '< i undersøkelses rommet');
INSERT INTO `lang_definitions` VALUES (10720, 3447, 8, '> Sjekket ut');
INSERT INTO `lang_definitions` VALUES (10721, 3448, 8, '? Ikke vist seg');
INSERT INTO `lang_definitions` VALUES (10722, 3449, 8, '@ Ankommet');
INSERT INTO `lang_definitions` VALUES (10723, 3450, 8, '[Skifte perspektiv]');
INSERT INTO `lang_definitions` VALUES (10724, 3451, 8, '[Dato for siste besøk]');
INSERT INTO `lang_definitions` VALUES (10725, 3452, 8, '[Dager siden siste besøk]');
INSERT INTO `lang_definitions` VALUES (10726, 3455, 8, '[ikke anbefalt]');
INSERT INTO `lang_definitions` VALUES (10727, 3456, 8, '[Antall besøk]');
INSERT INTO `lang_definitions` VALUES (10728, 3457, 8, '[Rapporter]');
INSERT INTO `lang_definitions` VALUES (10729, 3458, 8, '[Velg alle]');
INSERT INTO `lang_definitions` VALUES (10730, 3460, 8, '[Start Batch prosessering]');
INSERT INTO `lang_definitions` VALUES (10731, 3461, 8, '[Se logg]');
INSERT INTO `lang_definitions` VALUES (10732, 3462, 8, '[Se printvennlig versjon av Rapport]');
INSERT INTO `lang_definitions` VALUES (10733, 3466, 8, '~ Ankom sent');
INSERT INTO `lang_definitions` VALUES (10734, 2, 9, '用来查询付帐的支票号码或支付申请号码');
INSERT INTO `lang_definitions` VALUES (10735, 4, 9, '很多号码是需要！');
INSERT INTO `lang_definitions` VALUES (10736, 5, 9, '一个相关的计生联的代码需要！');
INSERT INTO `lang_definitions` VALUES (10737, 6, 9, '独特的价值，以确定这一领域，不可见的用户');
INSERT INTO `lang_definitions` VALUES (10738, 7, 9, 'a.c.');
INSERT INTO `lang_definitions` VALUES (10739, 8, 9, '上午');
INSERT INTO `lang_definitions` VALUES (10740, 9, 9, '的A / F级右：');
INSERT INTO `lang_definitions` VALUES (10741, 10, 9, 'AB公司');
INSERT INTO `lang_definitions` VALUES (10742, 11, 9, '缩写');
INSERT INTO `lang_definitions` VALUES (10743, 12, 9, '脓肿：');
INSERT INTO `lang_definitions` VALUES (10744, 13, 9, '腹部');
INSERT INTO `lang_definitions` VALUES (10745, 14, 9, '能承受重量四（ 4 ）步骤：');
INSERT INTO `lang_definitions` VALUES (10746, 15, 9, '荷银');
INSERT INTO `lang_definitions` VALUES (10747, 16, 9, 'ABN1');
INSERT INTO `lang_definitions` VALUES (10748, 17, 9, '不正常的');
INSERT INTO `lang_definitions` VALUES (10749, 18, 9, '不正常的血液试验');
INSERT INTO `lang_definitions` VALUES (10750, 19, 9, '不规则的毛发生长');
INSERT INTO `lang_definitions` VALUES (10751, 20, 9, '不正常的乳房X线照片');
INSERT INTO `lang_definitions` VALUES (10752, 21, 9, '堕胎');
INSERT INTO `lang_definitions` VALUES (10753, 22, 9, '堕胎问题');
INSERT INTO `lang_definitions` VALUES (10754, 23, 9, '堕胎法');
INSERT INTO `lang_definitions` VALUES (10755, 24, 9, '与堕胎有关的分类');
INSERT INTO `lang_definitions` VALUES (10756, 26, 9, '缺勤的诊断');
INSERT INTO `lang_definitions` VALUES (10757, 27, 9, '接受指派');
INSERT INTO `lang_definitions` VALUES (10758, 28, 9, '接受付款');
INSERT INTO `lang_definitions` VALUES (10759, 29, 9, '接受指派');
INSERT INTO `lang_definitions` VALUES (10760, 30, 9, '访问控制');
INSERT INTO `lang_definitions` VALUES (10761, 31, 9, '访问控制列表管理');
INSERT INTO `lang_definitions` VALUES (10762, 32, 9, '会计学；会计');
INSERT INTO `lang_definitions` VALUES (10763, 33, 9, '疼痛');
INSERT INTO `lang_definitions` VALUES (10764, 35, 9, '前交叉韧带');
INSERT INTO `lang_definitions` VALUES (10765, 37, 9, '政府没有授权的ACL');
INSERT INTO `lang_definitions` VALUES (10766, 38, 9, '粉刺');
INSERT INTO `lang_definitions` VALUES (10767, 39, 9, '行为');
INSERT INTO `lang_definitions` VALUES (10768, 40, 9, '法日期');
INSERT INTO `lang_definitions` VALUES (10769, 41, 9, '活跃');
INSERT INTO `lang_definitions` VALUES (10770, 42, 9, '积极接触');
INSERT INTO `lang_definitions` VALUES (10771, 44, 9, '积极病人');
INSERT INTO `lang_definitions` VALUES (10772, 45, 9, '活动类型');
INSERT INTO `lang_definitions` VALUES (10773, 46, 9, '急性慢性');
INSERT INTO `lang_definitions` VALUES (10774, 47, 9, '添加');
INSERT INTO `lang_definitions` VALUES (10775, 49, 9, '添加公司');
INSERT INTO `lang_definitions` VALUES (10776, 50, 9, '添加药剂');
INSERT INTO `lang_definitions` VALUES (10777, 51, 9, '新增的事件');
INSERT INTO `lang_definitions` VALUES (10778, 53, 9, '新增为新');
INSERT INTO `lang_definitions` VALUES (10779, 54, 9, '新增分类');
INSERT INTO `lang_definitions` VALUES (10780, 55, 9, '新增常数');
INSERT INTO `lang_definitions` VALUES (10781, 56, 9, '购买Copay');
INSERT INTO `lang_definitions` VALUES (10782, 57, 9, '添加药物');
INSERT INTO `lang_definitions` VALUES (10783, 58, 9, '购买座谈会');
INSERT INTO `lang_definitions` VALUES (10784, 59, 9, '购买基金');
INSERT INTO `lang_definitions` VALUES (10785, 61, 9, '添加组');
INSERT INTO `lang_definitions` VALUES (10786, 62, 9, '新增的ICD码');
INSERT INTO `lang_definitions` VALUES (10787, 63, 9, '购买问题');
INSERT INTO `lang_definitions` VALUES (10788, 64, 9, '新增语言');
INSERT INTO `lang_definitions` VALUES (10789, 65, 9, '添加新');
INSERT INTO `lang_definitions` VALUES (10790, 66, 9, '添加新的类别：');
INSERT INTO `lang_definitions` VALUES (10791, 67, 9, '添加新的组');
INSERT INTO `lang_definitions` VALUES (10792, 68, 9, '添加新注');
INSERT INTO `lang_definitions` VALUES (10793, 69, 9, '添加新的说明');
INSERT INTO `lang_definitions` VALUES (10794, 70, 9, '添加新的合作伙伴');
INSERT INTO `lang_definitions` VALUES (10795, 71, 9, '购买注意：');
INSERT INTO `lang_definitions` VALUES (10796, 72, 9, '购买病历');
INSERT INTO `lang_definitions` VALUES (10797, 73, 9, '购买处方');
INSERT INTO `lang_definitions` VALUES (10798, 75, 9, '购买药品的名单');
INSERT INTO `lang_definitions` VALUES (10799, 77, 9, '添加用户');
INSERT INTO `lang_definitions` VALUES (10800, 78, 9, '新增用户组');
INSERT INTO `lang_definitions` VALUES (10801, 80, 9, '新增人口数据统计未经审定');
INSERT INTO `lang_definitions` VALUES (10802, 81, 9, '艾迪综合征');
INSERT INTO `lang_definitions` VALUES (10803, 82, 9, '艾迪综合征');
INSERT INTO `lang_definitions` VALUES (10804, 83, 9, '附加诊断：');
INSERT INTO `lang_definitions` VALUES (10805, 84, 9, '更多历史');
INSERT INTO `lang_definitions` VALUES (10806, 85, 9, '附加说明历史');
INSERT INTO `lang_definitions` VALUES (10807, 86, 9, '其它信息');
INSERT INTO `lang_definitions` VALUES (10808, 87, 9, '附加实验室');
INSERT INTO `lang_definitions` VALUES (10809, 88, 9, '补充说明');
INSERT INTO `lang_definitions` VALUES (10810, 89, 9, '其他注意事项：');
INSERT INTO `lang_definitions` VALUES (10811, 90, 9, '其他注意事项：');
INSERT INTO `lang_definitions` VALUES (10812, 91, 9, '额外的X射线注：');
INSERT INTO `lang_definitions` VALUES (10813, 93, 9, '地址浅滩');
INSERT INTO `lang_definitions` VALUES (10814, 94, 9, '地址簿');
INSERT INTO `lang_definitions` VALUES (10815, 95, 9, '地址');
INSERT INTO `lang_definitions` VALUES (10816, 96, 9, '地址簿');
INSERT INTO `lang_definitions` VALUES (10817, 97, 9, '地址');
INSERT INTO `lang_definitions` VALUES (10818, 98, 9, '地址');
INSERT INTO `lang_definitions` VALUES (10819, 99, 9, '形容词');
INSERT INTO `lang_definitions` VALUES (10820, 100, 9, '调整');
INSERT INTO `lang_definitions` VALUES (10821, 101, 9, '调整原因');
INSERT INTO `lang_definitions` VALUES (10822, 102, 9, '调整值为代码');
INSERT INTO `lang_definitions` VALUES (10823, 103, 9, '调整');
INSERT INTO `lang_definitions` VALUES (10824, 104, 9, '行政调整');
INSERT INTO `lang_definitions` VALUES (10825, 105, 9, '管理员');
INSERT INTO `lang_definitions` VALUES (10826, 106, 9, '管理员电子邮件地址');
INSERT INTO `lang_definitions` VALUES (10827, 107, 9, '管制的');
INSERT INTO `lang_definitions` VALUES (10828, 108, 9, '经管');
INSERT INTO `lang_definitions` VALUES (10829, 109, 9, '行政');
INSERT INTO `lang_definitions` VALUES (10830, 110, 9, '管理员');
INSERT INTO `lang_definitions` VALUES (10831, 111, 9, '管理员可以做任何事');
INSERT INTO `lang_definitions` VALUES (10832, 112, 9, '高级的');
INSERT INTO `lang_definitions` VALUES (10833, 113, 9, '建议');
INSERT INTO `lang_definitions` VALUES (10834, 114, 9, '影响正常');
INSERT INTO `lang_definitions` VALUES (10835, 115, 9, '经过小时通话');
INSERT INTO `lang_definitions` VALUES (10836, 116, 9, '保存PDF文件后，再点击查看日志来检查错误');
INSERT INTO `lang_definitions` VALUES (10837, 118, 9, '在输入正确的信息，点击保存按钮。');
INSERT INTO `lang_definitions` VALUES (10838, 119, 9, '再次');
INSERT INTO `lang_definitions` VALUES (10839, 120, 9, '年龄');
INSERT INTO `lang_definitions` VALUES (10840, 121, 9, '年龄');
INSERT INTO `lang_definitions` VALUES (10841, 122, 9, '年龄分类');
INSERT INTO `lang_definitions` VALUES (10842, 123, 9, '年龄数据超出范围');
INSERT INTO `lang_definitions` VALUES (10843, 124, 9, '年龄格式“年龄”是无效的');
INSERT INTO `lang_definitions` VALUES (10844, 125, 9, '年龄格式“年龄最多”是无效的');
INSERT INTO `lang_definitions` VALUES (10845, 126, 9, '自（某个）年代（年龄）起');
INSERT INTO `lang_definitions` VALUES (10846, 127, 9, '老化专栏：');
INSERT INTO `lang_definitions` VALUES (10847, 128, 9, '酒精');
INSERT INTO `lang_definitions` VALUES (10848, 129, 9, '酒类消费');
INSERT INTO `lang_definitions` VALUES (10849, 130, 9, '全部');
INSERT INTO `lang_definitions` VALUES (10850, 131, 9, '所有类别');
INSERT INTO `lang_definitions` VALUES (10851, 132, 9, '整天');
INSERT INTO `lang_definitions` VALUES (10852, 133, 9, '全天活动');
INSERT INTO `lang_definitions` VALUES (10853, 134, 9, '所有设施');
INSERT INTO `lang_definitions` VALUES (10854, 135, 9, '全部或部分名字');
INSERT INTO `lang_definitions` VALUES (10855, 136, 9, '全部或部分姓氏');
INSERT INTO `lang_definitions` VALUES (10856, 137, 9, '所有供应者');
INSERT INTO `lang_definitions` VALUES (10857, 138, 9, '所有评论和否定：');
INSERT INTO `lang_definitions` VALUES (10858, 139, 9, '所有主题');
INSERT INTO `lang_definitions` VALUES (10859, 140, 9, '所有用户');
INSERT INTO `lang_definitions` VALUES (10860, 141, 9, '全部用户');
INSERT INTO `lang_definitions` VALUES (10861, 142, 9, '过敏');
INSERT INTO `lang_definitions` VALUES (10862, 143, 9, '过敏：');
INSERT INTO `lang_definitions` VALUES (10863, 145, 9, '接收邮件');
INSERT INTO `lang_definitions` VALUES (10864, 148, 9, '允许邮件讯息');
INSERT INTO `lang_definitions` VALUES (10865, 149, 9, '允许短讯');
INSERT INTO `lang_definitions` VALUES (10866, 151, 9, '允许将提交事件作出了积极的吗？');
INSERT INTO `lang_definitions` VALUES (10867, 153, 9, '允许用户发布的全球活动');
INSERT INTO `lang_definitions` VALUES (10868, 154, 9, '允许用户发布个人日历');
INSERT INTO `lang_definitions` VALUES (10869, 155, 9, '使语音邮件');
INSERT INTO `lang_definitions` VALUES (10870, 156, 9, '允许的');
INSERT INTO `lang_definitions` VALUES (10871, 158, 9, '已经使用，选择另一个标识符');
INSERT INTO `lang_definitions` VALUES (10872, 159, 9, '已经使用，请选择其他名称');
INSERT INTO `lang_definitions` VALUES (10873, 160, 9, '备选地址');
INSERT INTO `lang_definitions` VALUES (10874, 162, 9, '另外，您也可以使用搜索网页，上载电子汇款（ X12 835 ）文件，您获得您的付款人或交换。为此，您可以通过点击浏览按钮并选择要上传的文件，然后单击搜索以执行上传，并显示相应的发票。在这种情况下，其他参数上述不适用，并会被忽略。上传保存文件，但还没有处理的内容-这就是做分别叙述如下。');
INSERT INTO `lang_definitions` VALUES (10875, 163, 9, '上午');
INSERT INTO `lang_definitions` VALUES (10876, 164, 9, '修订现有注意');
INSERT INTO `lang_definitions` VALUES (10877, 165, 9, '美国证券交易所');
INSERT INTO `lang_definitions` VALUES (10878, 166, 9, '数量');
INSERT INTO `lang_definitions` VALUES (10879, 168, 9, '金额为过去的平衡');
INSERT INTO `lang_definitions` VALUES (10880, 169, 9, '金额为这次访问');
INSERT INTO `lang_definitions` VALUES (10881, 170, 9, '支付的金额');
INSERT INTO `lang_definitions` VALUES (10882, 171, 9, '金额：');
INSERT INTO `lang_definitions` VALUES (10883, 176, 9, '和');
INSERT INTO `lang_definitions` VALUES (10884, 179, 9, '和');
INSERT INTO `lang_definitions` VALUES (10885, 180, 9, '和所有下属的数据？这一行动将被记录');
INSERT INTO `lang_definitions` VALUES (10886, 182, 9, '踝关节');
INSERT INTO `lang_definitions` VALUES (10887, 183, 9, '踝关节+足跟');
INSERT INTO `lang_definitions` VALUES (10888, 184, 9, '踝评价表');
INSERT INTO `lang_definitions` VALUES (10889, 185, 9, '踝关节问题');
INSERT INTO `lang_definitions` VALUES (10890, 186, 9, '强直性Sondlilitis');
INSERT INTO `lang_definitions` VALUES (10891, 187, 9, '强直性Spondlilitis');
INSERT INTO `lang_definitions` VALUES (10892, 188, 9, '厌食');
INSERT INTO `lang_definitions` VALUES (10893, 189, 9, '另一件事你可以在窗口张贴二次结算的要求。如果您选中此复选框，然后才能保存，然后是原始索赔将会重开，并排队的帐单网页，将在今后处理帐单运行。');
INSERT INTO `lang_definitions` VALUES (10894, 190, 9, '宰前');
INSERT INTO `lang_definitions` VALUES (10895, 191, 9, '肛门荷，没有直肠压痛/质谱');
INSERT INTO `lang_definitions` VALUES (10896, 192, 9, '忧虑');
INSERT INTO `lang_definitions` VALUES (10897, 193, 9, '任何');
INSERT INTO `lang_definitions` VALUES (10898, 195, 9, '任何部分或其所需的代码说明');
INSERT INTO `lang_definitions` VALUES (10899, 196, 9, '任何部分的理想专业');
INSERT INTO `lang_definitions` VALUES (10900, 197, 9, '任何部分的病人的姓名，或“上，第一次”或“代理”');
INSERT INTO `lang_definitions` VALUES (10901, 199, 9, '外观');
INSERT INTO `lang_definitions` VALUES (10902, 200, 9, '外观：');
INSERT INTO `lang_definitions` VALUES (10903, 202, 9, '附加于本说明');
INSERT INTO `lang_definitions` VALUES (10904, 203, 9, '附加于本说明');
INSERT INTO `lang_definitions` VALUES (10905, 204, 9, '阑尾');
INSERT INTO `lang_definitions` VALUES (10906, 206, 9, '适用于受影响地区');
INSERT INTO `lang_definitions` VALUES (10907, 207, 9, '适用于皮肤');
INSERT INTO `lang_definitions` VALUES (10908, 209, 9, '预约日期');
INSERT INTO `lang_definitions` VALUES (10909, 210, 9, '任用地位');
INSERT INTO `lang_definitions` VALUES (10910, 211, 9, '任命内');
INSERT INTO `lang_definitions` VALUES (10911, 212, 9, '任命');
INSERT INTO `lang_definitions` VALUES (10912, 214, 9, '任用和接触');
INSERT INTO `lang_definitions` VALUES (10913, 215, 9, '任命报告');
INSERT INTO `lang_definitions` VALUES (10914, 216, 9, '任用-邂逅报告');
INSERT INTO `lang_definitions` VALUES (10915, 217, 9, '批准');
INSERT INTO `lang_definitions` VALUES (10916, 218, 9, '批准');
INSERT INTO `lang_definitions` VALUES (10917, 219, 9, '行政部门批准的活动');
INSERT INTO `lang_definitions` VALUES (10918, 220, 9, 'Appt ，电子海图');
INSERT INTO `lang_definitions` VALUES (10919, 221, 9, 'Appts');
INSERT INTO `lang_definitions` VALUES (10920, 222, 9, '4月');
INSERT INTO `lang_definitions` VALUES (10921, 225, 9, '您确定要批准这些事件？');
INSERT INTO `lang_definitions` VALUES (10922, 227, 9, '您确定要删除此活动？');
INSERT INTO `lang_definitions` VALUES (10923, 230, 9, '您确定要修改这些事件？');
INSERT INTO `lang_definitions` VALUES (10924, 231, 9, '您确定要隐藏这些事件？');
INSERT INTO `lang_definitions` VALUES (10925, 232, 9, '您确定要查看这些事件？');
INSERT INTO `lang_definitions` VALUES (10926, 237, 9, '您确定要继续进行这些行动？');
INSERT INTO `lang_definitions` VALUES (10927, 238, 9, '区未指定');
INSERT INTO `lang_definitions` VALUES (10928, 239, 9, '亚美尼亚语');
INSERT INTO `lang_definitions` VALUES (10929, 241, 9, '关节炎');
INSERT INTO `lang_definitions` VALUES (10930, 242, 9, '关节炎/德劲联合病');
INSERT INTO `lang_definitions` VALUES (10931, 243, 9, '关节炎/根关节病');
INSERT INTO `lang_definitions` VALUES (10932, 244, 9, '同样地');
INSERT INTO `lang_definitions` VALUES (10933, 245, 9, '截至');
INSERT INTO `lang_definitions` VALUES (10934, 246, 9, '亚洲');
INSERT INTO `lang_definitions` VALUES (10935, 247, 9, '评价');
INSERT INTO `lang_definitions` VALUES (10936, 249, 9, '助理');
INSERT INTO `lang_definitions` VALUES (10937, 250, 9, '哮喘');
INSERT INTO `lang_definitions` VALUES (10938, 252, 9, '在舟');
INSERT INTO `lang_definitions` VALUES (10939, 253, 9, '在舟：');
INSERT INTO `lang_definitions` VALUES (10940, 254, 9, '田径/损伤');
INSERT INTO `lang_definitions` VALUES (10941, 255, 9, '注意');
INSERT INTO `lang_definitions` VALUES (10942, 256, 9, '经办人');
INSERT INTO `lang_definitions` VALUES (10943, 257, 9, '8月');
INSERT INTO `lang_definitions` VALUES (10944, 258, 9, '认证');
INSERT INTO `lang_definitions` VALUES (10945, 259, 9, '认证/笔记');
INSERT INTO `lang_definitions` VALUES (10946, 260, 9, '授权');
INSERT INTO `lang_definitions` VALUES (10947, 261, 9, '授权');
INSERT INTO `lang_definitions` VALUES (10948, 264, 9, '授权');
INSERT INTO `lang_definitions` VALUES (10949, 265, 9, '自动发送');
INSERT INTO `lang_definitions` VALUES (10950, 267, 9, '汽车医疗');
INSERT INTO `lang_definitions` VALUES (10951, 269, 9, '可用时报');
INSERT INTO `lang_definitions` VALUES (10952, 270, 9, '撕脱/撕脱骨折');
INSERT INTO `lang_definitions` VALUES (10953, 271, 9, '外踝撕脱伤');
INSERT INTO `lang_definitions` VALUES (10954, 272, 9, '撕脱内踝');
INSERT INTO `lang_definitions` VALUES (10955, 273, 9, '认识基');
INSERT INTO `lang_definitions` VALUES (10956, 275, 9, '一天两次');
INSERT INTO `lang_definitions` VALUES (10957, 276, 9, '后面');
INSERT INTO `lang_definitions` VALUES (10958, 277, 9, '后面');
INSERT INTO `lang_definitions` VALUES (10959, 284, 9, '回到问题');
INSERT INTO `lang_definitions` VALUES (10960, 287, 9, '脊柱手术');
INSERT INTO `lang_definitions` VALUES (10961, 292, 9, '备份');
INSERT INTO `lang_definitions` VALUES (10962, 294, 9, '坏检查');
INSERT INTO `lang_definitions` VALUES (10963, 295, 9, '坏帐');
INSERT INTO `lang_definitions` VALUES (10964, 298, 9, '平衡');
INSERT INTO `lang_definitions` VALUES (10965, 299, 9, '平衡');
INSERT INTO `lang_definitions` VALUES (10966, 300, 9, '应付余额');
INSERT INTO `lang_definitions` VALUES (10967, 301, 9, '基地的第五（ 5 ） Metarsal');
INSERT INTO `lang_definitions` VALUES (10968, 302, 9, '基地的第五（ 5 ） Metarsal ：');
INSERT INTO `lang_definitions` VALUES (10969, 303, 9, '一批通讯工具');
INSERT INTO `lang_definitions` VALUES (10970, 304, 9, '批处理启动，这可能需要一段时间。');
INSERT INTO `lang_definitions` VALUES (10971, 305, 9, 'BatchCom');
INSERT INTO `lang_definitions` VALUES (10972, 307, 9, '开始');
INSERT INTO `lang_definitions` VALUES (10973, 308, 9, '开始日期');
INSERT INTO `lang_definitions` VALUES (10974, 309, 9, '服务开始日期格式yyyy - mm -日');
INSERT INTO `lang_definitions` VALUES (10975, 312, 9, '双边：');
INSERT INTO `lang_definitions` VALUES (10976, 313, 9, '比尔日期：');
INSERT INTO `lang_definitions` VALUES (10977, 315, 9, '结算');
INSERT INTO `lang_definitions` VALUES (10978, 316, 9, '帐单');
INSERT INTO `lang_definitions` VALUES (10979, 318, 9, '结算经办人');
INSERT INTO `lang_definitions` VALUES (10980, 319, 9, '结算规范要求的服务');
INSERT INTO `lang_definitions` VALUES (10981, 320, 9, '结算代码');
INSERT INTO `lang_definitions` VALUES (10982, 321, 9, '结算信息');
INSERT INTO `lang_definitions` VALUES (10983, 322, 9, '帐单位置');
INSERT INTO `lang_definitions` VALUES (10984, 323, 9, '结算说明');
INSERT INTO `lang_definitions` VALUES (10985, 324, 9, '结算说明');
INSERT INTO `lang_definitions` VALUES (10986, 325, 9, '帐单注意：');
INSERT INTO `lang_definitions` VALUES (10987, 326, 9, '结算队列结果：');
INSERT INTO `lang_definitions` VALUES (10988, 327, 9, '结算报告');
INSERT INTO `lang_definitions` VALUES (10989, 328, 9, '帐单');
INSERT INTO `lang_definitions` VALUES (10990, 330, 9, '出生日期');
INSERT INTO `lang_definitions` VALUES (10991, 331, 9, '黑色');
INSERT INTO `lang_definitions` VALUES (10992, 332, 9, '膀胱癌');
INSERT INTO `lang_definitions` VALUES (10993, 333, 9, '膀胱感染');
INSERT INTO `lang_definitions` VALUES (10994, 334, 9, '空白表格');
INSERT INTO `lang_definitions` VALUES (10995, 336, 9, '盲点');
INSERT INTO `lang_definitions` VALUES (10996, 337, 9, '膨胀');
INSERT INTO `lang_definitions` VALUES (10997, 338, 9, '封锁');
INSERT INTO `lang_definitions` VALUES (10998, 339, 9, '血压');
INSERT INTO `lang_definitions` VALUES (10999, 341, 9, '鼻子出血');
INSERT INTO `lang_definitions` VALUES (11000, 342, 9, '蓝盾');
INSERT INTO `lang_definitions` VALUES (11001, 343, 9, '蓝线是在本报告中的信息。黑线查看以前的现有信息。绿线显示的变化是成功的应用。红线显示错误，或改变，不适用，这些必须是人工处理。目前被剥夺索赔和支付倒退没有自动处理，因此会出现在红色。');
INSERT INTO `lang_definitions` VALUES (11002, 344, 9, '视力模糊');
INSERT INTO `lang_definitions` VALUES (11003, 347, 9, '机构区');
INSERT INTO `lang_definitions` VALUES (11004, 348, 9, '骨嫩：');
INSERT INTO `lang_definitions` VALUES (11005, 349, 9, '骨嫩：内踝');
INSERT INTO `lang_definitions` VALUES (11006, 351, 9, '博特');
INSERT INTO `lang_definitions` VALUES (11007, 353, 9, '双耳');
INSERT INTO `lang_definitions` VALUES (11008, 354, 9, '底部');
INSERT INTO `lang_definitions` VALUES (11009, 355, 9, '方框10 A.就业相关');
INSERT INTO `lang_definitions` VALUES (11010, 356, 9, '方框10湾车祸');
INSERT INTO `lang_definitions` VALUES (11011, 357, 9, '方框10 C.其他事故');
INSERT INTO `lang_definitions` VALUES (11012, 358, 9, '方框16 。日期无法工作（格式yyyy - mm - DD ）的：');
INSERT INTO `lang_definitions` VALUES (11013, 359, 9, '方框16 。日期无法工作（格式yyyy - mm - DD ）的：');
INSERT INTO `lang_definitions` VALUES (11014, 360, 9, '箱18 。住院日（格式yyyy - mm - DD ）的：');
INSERT INTO `lang_definitions` VALUES (11015, 361, 9, '箱18 。住院日期（格式yyyy - mm - DD ）的：');
INSERT INTO `lang_definitions` VALUES (11016, 362, 9, '箱20 。境外实验室使用？');
INSERT INTO `lang_definitions` VALUES (11017, 363, 9, '箱22 。医疗重新码（的ICD - 9 ）');
INSERT INTO `lang_definitions` VALUES (11018, 364, 9, '箱23 。事先授权号');
INSERT INTO `lang_definitions` VALUES (11019, 366, 9, '舒张压');
INSERT INTO `lang_definitions` VALUES (11020, 367, 9, '收缩压');
INSERT INTO `lang_definitions` VALUES (11021, 371, 9, '乳房');
INSERT INTO `lang_definitions` VALUES (11022, 374, 9, '乳腺疾病');
INSERT INTO `lang_definitions` VALUES (11023, 375, 9, '乳房检查');
INSERT INTO `lang_definitions` VALUES (11024, 376, 9, '乳房肿块');
INSERT INTO `lang_definitions` VALUES (11025, 377, 9, '呼吸音：');
INSERT INTO `lang_definitions` VALUES (11026, 378, 9, '骨折');
INSERT INTO `lang_definitions` VALUES (11027, 379, 9, '支气管炎表格');
INSERT INTO `lang_definitions` VALUES (11028, 380, 9, '浏览');
INSERT INTO `lang_definitions` VALUES (11029, 381, 9, '浏览记录');
INSERT INTO `lang_definitions` VALUES (11030, 382, 9, '青肿/血肿');
INSERT INTO `lang_definitions` VALUES (11031, 383, 9, '胀右：');
INSERT INTO `lang_definitions` VALUES (11032, 384, 9, '燃烧排尿');
INSERT INTO `lang_definitions` VALUES (11033, 386, 9, '忙碌的');
INSERT INTO `lang_definitions` VALUES (11034, 387, 9, '臀部+副省长');
INSERT INTO `lang_definitions` VALUES (11035, 388, 9, '通过');
INSERT INTO `lang_definitions` VALUES (11036, 389, 9, '经口');
INSERT INTO `lang_definitions` VALUES (11037, 390, 9, '文/来源');
INSERT INTO `lang_definitions` VALUES (11038, 391, 9, '方式：');
INSERT INTO `lang_definitions` VALUES (11039, 393, 9, '缓存寿命（秒）');
INSERT INTO `lang_definitions` VALUES (11040, 394, 9, '缓存模板输出？');
INSERT INTO `lang_definitions` VALUES (11041, 395, 9, '喝咖啡');
INSERT INTO `lang_definitions` VALUES (11042, 396, 9, '日历');
INSERT INTO `lang_definitions` VALUES (11043, 398, 9, '日历界面');
INSERT INTO `lang_definitions` VALUES (11044, 399, 9, '日历视图');
INSERT INTO `lang_definitions` VALUES (11045, 400, 9, '呼吁addForm （ ）这里。 <br>');
INSERT INTO `lang_definitions` VALUES (11046, 402, 9, 'CAMOS');
INSERT INTO `lang_definitions` VALUES (11047, 403, 9, '取消');
INSERT INTO `lang_definitions` VALUES (11048, 404, 9, '癌症');
INSERT INTO `lang_definitions` VALUES (11049, 407, 9, '不能转换为JPEG格式。也许ImageMagick没有安装？');
INSERT INTO `lang_definitions` VALUES (11050, 408, 9, '无法显示内置类型，因为它不支持的浏览器。');
INSERT INTO `lang_definitions` VALUES (11051, 409, 9, '无法显示内置类型，因为它不支持的浏览器');
INSERT INTO `lang_definitions` VALUES (11052, 410, 9, '无法显示内置类型，因为它不支持的浏览器。');
INSERT INTO `lang_definitions` VALUES (11053, 411, 9, '无法创建');
INSERT INTO `lang_definitions` VALUES (11054, 412, 9, '无法找到');
INSERT INTO `lang_definitions` VALUES (11055, 413, 9, '找不到病人从SQL查问客户ID');
INSERT INTO `lang_definitions` VALUES (11056, 414, 9, '找不到后记中提到的文件');
INSERT INTO `lang_definitions` VALUES (11057, 415, 9, '找不到提供商从SQL查问雇员=');
INSERT INTO `lang_definitions` VALUES (11058, 416, 9, '无法打开');
INSERT INTO `lang_definitions` VALUES (11059, 418, 9, '不能更新，是因为您没有编辑现有条目！');
INSERT INTO `lang_definitions` VALUES (11060, 419, 9, '胶囊');
INSERT INTO `lang_definitions` VALUES (11061, 420, 9, '心导管');
INSERT INTO `lang_definitions` VALUES (11062, 421, 9, '心脏回声');
INSERT INTO `lang_definitions` VALUES (11063, 422, 9, '心血管');
INSERT INTO `lang_definitions` VALUES (11064, 423, 9, '软骨/软骨/椎间盘损伤');
INSERT INTO `lang_definitions` VALUES (11065, 424, 9, '软骨损伤');
INSERT INTO `lang_definitions` VALUES (11066, 425, 9, 'Cartoid脉动荷，踏板脉冲荷');
INSERT INTO `lang_definitions` VALUES (11067, 426, 9, '现金');
INSERT INTO `lang_definitions` VALUES (11068, 427, 9, '现金');
INSERT INTO `lang_definitions` VALUES (11069, 428, 9, '现金市盈率');
INSERT INTO `lang_definitions` VALUES (11070, 429, 9, '现金收据的供应商');
INSERT INTO `lang_definitions` VALUES (11071, 430, 9, '白内障手术');
INSERT INTO `lang_definitions` VALUES (11072, 431, 9, '白内障');
INSERT INTO `lang_definitions` VALUES (11073, 432, 9, '分类');
INSERT INTO `lang_definitions` VALUES (11074, 433, 9, '分类');
INSERT INTO `lang_definitions` VALUES (11075, 434, 9, '分类');
INSERT INTO `lang_definitions` VALUES (11076, 435, 9, '分类');
INSERT INTO `lang_definitions` VALUES (11077, 436, 9, '分类信息');
INSERT INTO `lang_definitions` VALUES (11078, 437, 9, '分类界限');
INSERT INTO `lang_definitions` VALUES (11079, 438, 9, '分类名称');
INSERT INTO `lang_definitions` VALUES (11080, 439, 9, '高加索');
INSERT INTO `lang_definitions` VALUES (11081, 442, 9, '中央认证');
INSERT INTO `lang_definitions` VALUES (11082, 443, 9, 'cfirst （ $ instype ） 。 \'集');
INSERT INTO `lang_definitions` VALUES (11083, 444, 9, 'ChampUS');
INSERT INTO `lang_definitions` VALUES (11084, 445, 9, 'ChampUSVA');
INSERT INTO `lang_definitions` VALUES (11085, 446, 9, '更改');
INSERT INTO `lang_definitions` VALUES (11086, 448, 9, '变更活动');
INSERT INTO `lang_definitions` VALUES (11087, 451, 9, '改变');
INSERT INTO `lang_definitions` VALUES (11088, 453, 9, '电荷');
INSERT INTO `lang_definitions` VALUES (11089, 454, 9, '收费');
INSERT INTO `lang_definitions` VALUES (11090, 455, 9, '图');
INSERT INTO `lang_definitions` VALUES (11091, 456, 9, '图活动');
INSERT INTO `lang_definitions` VALUES (11092, 457, 9, '图Check-in/out活动报告');
INSERT INTO `lang_definitions` VALUES (11093, 459, 9, '图编号：');
INSERT INTO `lang_definitions` VALUES (11094, 460, 9, '图地点活动');
INSERT INTO `lang_definitions` VALUES (11095, 463, 9, '图表跟踪');
INSERT INTO `lang_definitions` VALUES (11096, 464, 9, '图蒂尔克');
INSERT INTO `lang_definitions` VALUES (11097, 465, 9, '图表借出');
INSERT INTO `lang_definitions` VALUES (11098, 466, 9, '图表输出');
INSERT INTO `lang_definitions` VALUES (11099, 467, 9, '检查');
INSERT INTO `lang_definitions` VALUES (11100, 468, 9, '检查');
INSERT INTO `lang_definitions` VALUES (11101, 469, 9, '检查所有');
INSERT INTO `lang_definitions` VALUES (11102, 471, 9, '检查输入数据');
INSERT INTO `lang_definitions` VALUES (11103, 473, 9, '检查/ EOB日期：');
INSERT INTO `lang_definitions` VALUES (11104, 474, 9, '检查/ EOB编号：');
INSERT INTO `lang_definitions` VALUES (11105, 475, 9, '检查/参考编号');
INSERT INTO `lang_definitions` VALUES (11106, 476, 9, '检查/编号');
INSERT INTO `lang_definitions` VALUES (11107, 478, 9, '复选框列表');
INSERT INTO `lang_definitions` VALUES (11108, 479, 9, '复选框瓦特/文');
INSERT INTO `lang_definitions` VALUES (11109, 481, 9, '检查中=是的，没有空=');
INSERT INTO `lang_definitions` VALUES (11110, 482, 9, '结帐');
INSERT INTO `lang_definitions` VALUES (11111, 483, 9, '胸膛');
INSERT INTO `lang_definitions` VALUES (11112, 484, 9, '公益金的CTAB');
INSERT INTO `lang_definitions` VALUES (11113, 486, 9, '胸痛：');
INSERT INTO `lang_definitions` VALUES (11114, 487, 9, '胸部疼痛');
INSERT INTO `lang_definitions` VALUES (11115, 491, 9, '冷');
INSERT INTO `lang_definitions` VALUES (11116, 492, 9, '中文');
INSERT INTO `lang_definitions` VALUES (11117, 493, 9, '选择');
INSERT INTO `lang_definitions` VALUES (11118, 494, 9, '胆囊切除术');
INSERT INTO `lang_definitions` VALUES (11119, 495, 9, 'Cholecystestomy');
INSERT INTO `lang_definitions` VALUES (11120, 497, 9, '选择一个部分，并点击一个项目内，然后在其他部分，你将看到有关项目突出，您可以点击在这一节中添加和删除的关系。');
INSERT INTO `lang_definitions` VALUES (11121, 500, 9, '慢性支气管炎');
INSERT INTO `lang_definitions` VALUES (11122, 502, 9, '慢性滑膜炎/积液/关节疼痛/痛风');
INSERT INTO `lang_definitions` VALUES (11123, 503, 9, '慢性/复发');
INSERT INTO `lang_definitions` VALUES (11124, 504, 9, '肝硬化');
INSERT INTO `lang_definitions` VALUES (11125, 506, 9, '城市');
INSERT INTO `lang_definitions` VALUES (11126, 507, 9, '城市名称');
INSERT INTO `lang_definitions` VALUES (11127, 508, 9, '城市，州');
INSERT INTO `lang_definitions` VALUES (11128, 509, 9, '城市，州邮编');
INSERT INTO `lang_definitions` VALUES (11129, 510, 9, '城市/州');
INSERT INTO `lang_definitions` VALUES (11130, 512, 9, '主张');
INSERT INTO `lang_definitions` VALUES (11131, 513, 9, '索赔运行测试已完成');
INSERT INTO `lang_definitions` VALUES (11132, 514, 9, '索赔产生的文件');
INSERT INTO `lang_definitions` VALUES (11133, 515, 9, '分类');
INSERT INTO `lang_definitions` VALUES (11134, 516, 9, '清楚的');
INSERT INTO `lang_definitions` VALUES (11135, 517, 9, '全部清除');
INSERT INTO `lang_definitions` VALUES (11136, 518, 9, '明确的理由');
INSERT INTO `lang_definitions` VALUES (11137, 519, 9, '明确Smarty缓存');
INSERT INTO `lang_definitions` VALUES (11138, 520, 9, '集数');
INSERT INTO `lang_definitions` VALUES (11139, 523, 9, '点击查看更多');
INSERT INTO `lang_definitions` VALUES (11140, 524, 9, '点击这里选择日期');
INSERT INTO `lang_definitions` VALUES (11141, 525, 9, '请点击这里更新优先，分类和昵称设置');
INSERT INTO `lang_definitions` VALUES (11142, 527, 9, '点击下载');
INSERT INTO `lang_definitions` VALUES (11143, 530, 9, '点击生成报告');
INSERT INTO `lang_definitions` VALUES (11144, 533, 9, '单击以选中');
INSERT INTO `lang_definitions` VALUES (11145, 534, 9, '单击以选中或改变诊断');
INSERT INTO `lang_definitions` VALUES (11146, 535, 9, '单击以选中病人');
INSERT INTO `lang_definitions` VALUES (11147, 536, 9, '单击以选中相关的代码');
INSERT INTO `lang_definitions` VALUES (11148, 540, 9, '点击：');
INSERT INTO `lang_definitions` VALUES (11149, 543, 9, '客户简介-新客户');
INSERT INTO `lang_definitions` VALUES (11150, 544, 9, '客户简介-独特的客户');
INSERT INTO `lang_definitions` VALUES (11151, 545, 9, '客户');
INSERT INTO `lang_definitions` VALUES (11152, 546, 9, '诊所');
INSERT INTO `lang_definitions` VALUES (11153, 548, 9, '诊所每日纪录');
INSERT INTO `lang_definitions` VALUES (11154, 553, 9, '关闭');
INSERT INTO `lang_definitions` VALUES (11155, 554, 9, '关闭窗口');
INSERT INTO `lang_definitions` VALUES (11156, 555, 9, '公开');
INSERT INTO `lang_definitions` VALUES (11157, 558, 9, '不育系编号');
INSERT INTO `lang_definitions` VALUES (11158, 559, 9, 'CN2网络- 12完整');
INSERT INTO `lang_definitions` VALUES (11159, 560, 9, '码');
INSERT INTO `lang_definitions` VALUES (11160, 561, 9, '代码');
INSERT INTO `lang_definitions` VALUES (11161, 562, 9, '代码查找');
INSERT INTO `lang_definitions` VALUES (11162, 563, 9, '代码必须是两个字母小写');
INSERT INTO `lang_definitions` VALUES (11163, 564, 9, '代码类型');
INSERT INTO `lang_definitions` VALUES (11164, 565, 9, '码');
INSERT INTO `lang_definitions` VALUES (11165, 566, 9, '编码');
INSERT INTO `lang_definitions` VALUES (11166, 569, 9, '编码未授权');
INSERT INTO `lang_definitions` VALUES (11167, 570, 9, '咖啡');
INSERT INTO `lang_definitions` VALUES (11168, 571, 9, '科尔W / O型');
INSERT INTO `lang_definitions` VALUES (11169, 572, 9, '全部折叠');
INSERT INTO `lang_definitions` VALUES (11170, 573, 9, '集合');
INSERT INTO `lang_definitions` VALUES (11171, 574, 9, '馆藏报告');
INSERT INTO `lang_definitions` VALUES (11172, 575, 9, '结肠癌');
INSERT INTO `lang_definitions` VALUES (11173, 576, 9, '结肠癌手术');
INSERT INTO `lang_definitions` VALUES (11174, 577, 9, '结肠镜检查');
INSERT INTO `lang_definitions` VALUES (11175, 578, 9, '结肠镜检查');
INSERT INTO `lang_definitions` VALUES (11176, 579, 9, '彩色');
INSERT INTO `lang_definitions` VALUES (11177, 580, 9, '专栏');
INSERT INTO `lang_definitions` VALUES (11178, 581, 9, '评论');
INSERT INTO `lang_definitions` VALUES (11179, 582, 9, '商业保险有限公司');
INSERT INTO `lang_definitions` VALUES (11180, 583, 9, '承诺更改');
INSERT INTO `lang_definitions` VALUES (11181, 584, 9, '通信');
INSERT INTO `lang_definitions` VALUES (11182, 585, 9, '完成');
INSERT INTO `lang_definitions` VALUES (11183, 586, 9, '并发症的服务提供商');
INSERT INTO `lang_definitions` VALUES (11184, 587, 9, '堕胎并发症');
INSERT INTO `lang_definitions` VALUES (11185, 588, 9, '医学计算机辅助订货系统');
INSERT INTO `lang_definitions` VALUES (11186, 590, 9, '先天性');
INSERT INTO `lang_definitions` VALUES (11187, 591, 9, 'Conjuntiva ，学生');
INSERT INTO `lang_definitions` VALUES (11188, 593, 9, '常量名');
INSERT INTO `lang_definitions` VALUES (11189, 594, 9, '常数');
INSERT INTO `lang_definitions` VALUES (11190, 597, 9, '咨询简介');
INSERT INTO `lang_definitions` VALUES (11191, 598, 9, '联系方式');
INSERT INTO `lang_definitions` VALUES (11192, 599, 9, '联系人电子邮件');
INSERT INTO `lang_definitions` VALUES (11193, 602, 9, '隐形眼镜');
INSERT INTO `lang_definitions` VALUES (11194, 603, 9, '联系人姓名');
INSERT INTO `lang_definitions` VALUES (11195, 604, 9, '联系人');
INSERT INTO `lang_definitions` VALUES (11196, 605, 9, '联系电话号码');
INSERT INTO `lang_definitions` VALUES (11197, 606, 9, '内容');
INSERT INTO `lang_definitions` VALUES (11198, 607, 9, '内容');
INSERT INTO `lang_definitions` VALUES (11199, 609, 9, '康特拉客户');
INSERT INTO `lang_definitions` VALUES (11200, 611, 9, '避孕的问题');
INSERT INTO `lang_definitions` VALUES (11201, 612, 9, '避孕并发症（具体说明）');
INSERT INTO `lang_definitions` VALUES (11202, 613, 9, '避孕方法');
INSERT INTO `lang_definitions` VALUES (11203, 614, 9, '避孕服务以前开始');
INSERT INTO `lang_definitions` VALUES (11204, 615, 9, '避孕药开始');
INSERT INTO `lang_definitions` VALUES (11205, 617, 9, 'Copay');
INSERT INTO `lang_definitions` VALUES (11206, 618, 9, 'CoPay');
INSERT INTO `lang_definitions` VALUES (11207, 620, 9, 'Copays');
INSERT INTO `lang_definitions` VALUES (11208, 622, 9, '复制页面病人图');
INSERT INTO `lang_definitions` VALUES (11209, 623, 9, '复制价值观');
INSERT INTO `lang_definitions` VALUES (11210, 624, 9, '版权声明');
INSERT INTO `lang_definitions` VALUES (11211, 625, 9, '冠状动脉搭桥');
INSERT INTO `lang_definitions` VALUES (11212, 627, 9, '咳嗽：');
INSERT INTO `lang_definitions` VALUES (11213, 628, 9, '不能发送电子邮件由于服务器问题，');
INSERT INTO `lang_definitions` VALUES (11214, 633, 9, 'Couns法');
INSERT INTO `lang_definitions` VALUES (11215, 634, 9, '咨询');
INSERT INTO `lang_definitions` VALUES (11216, 635, 9, '咨询活动');
INSERT INTO `lang_definitions` VALUES (11217, 638, 9, '国家');
INSERT INTO `lang_definitions` VALUES (11218, 641, 9, '优惠券');
INSERT INTO `lang_definitions` VALUES (11219, 642, 9, '中华映管');
INSERT INTO `lang_definitions` VALUES (11220, 643, 9, '中华映管码');
INSERT INTO `lang_definitions` VALUES (11221, 644, 9, '裂纹：');
INSERT INTO `lang_definitions` VALUES (11222, 645, 9, '奶油');
INSERT INTO `lang_definitions` VALUES (11223, 646, 9, '创建活动');
INSERT INTO `lang_definitions` VALUES (11224, 649, 9, '创造新的病人');
INSERT INTO `lang_definitions` VALUES (11225, 650, 9, '创建患者注意');
INSERT INTO `lang_definitions` VALUES (11226, 651, 9, '创建');
INSERT INTO `lang_definitions` VALUES (11227, 653, 9, '信贷');
INSERT INTO `lang_definitions` VALUES (11228, 654, 9, '学分');
INSERT INTO `lang_definitions` VALUES (11229, 655, 9, '克罗恩病');
INSERT INTO `lang_definitions` VALUES (11230, 657, 9, 'CSV文件');
INSERT INTO `lang_definitions` VALUES (11231, 658, 9, '当前的');
INSERT INTO `lang_definitions` VALUES (11232, 659, 9, '目前的协商');
INSERT INTO `lang_definitions` VALUES (11233, 660, 9, '当天标明颜色');
INSERT INTO `lang_definitions` VALUES (11234, 663, 9, '目前病人');
INSERT INTO `lang_definitions` VALUES (11235, 664, 9, '目前活跃');
INSERT INTO `lang_definitions` VALUES (11236, 665, 9, '柯兴综合征');
INSERT INTO `lang_definitions` VALUES (11237, 666, 9, '柯兴综合征');
INSERT INTO `lang_definitions` VALUES (11238, 667, 9, '风俗');
INSERT INTO `lang_definitions` VALUES (11239, 669, 9, '色素');
INSERT INTO `lang_definitions` VALUES (11240, 670, 9, '色素因子');
INSERT INTO `lang_definitions` VALUES (11241, 671, 9, '色素报告');
INSERT INTO `lang_definitions` VALUES (11242, 673, 9, '发展和ç');
INSERT INTO `lang_definitions` VALUES (11243, 674, 9, '发展和é');
INSERT INTO `lang_definitions` VALUES (11244, 675, 9, 'D.O.B.');
INSERT INTO `lang_definitions` VALUES (11245, 676, 9, '每日');
INSERT INTO `lang_definitions` VALUES (11246, 677, 9, '数据已经在相同的数据库，请更改代码和/或描述');
INSERT INTO `lang_definitions` VALUES (11247, 679, 9, '数据列');
INSERT INTO `lang_definitions` VALUES (11248, 680, 9, '数据类型');
INSERT INTO `lang_definitions` VALUES (11249, 681, 9, '数据库');
INSERT INTO `lang_definitions` VALUES (11250, 684, 9, '日期');
INSERT INTO `lang_definitions` VALUES (11251, 686, 9, '日期经管');
INSERT INTO `lang_definitions` VALUES (11252, 687, 9, '日期最初提供避孕服务');
INSERT INTO `lang_definitions` VALUES (11253, 688, 9, '日期毁坏');
INSERT INTO `lang_definitions` VALUES (11254, 689, 9, '日期显示格式');
INSERT INTO `lang_definitions` VALUES (11255, 690, 9, '日期格式为“任命结束”是无效的');
INSERT INTO `lang_definitions` VALUES (11256, 691, 9, '日期格式为“任命开始”是无效的');
INSERT INTO `lang_definitions` VALUES (11257, 692, 9, '日期格式“下一个约会”是无效的');
INSERT INTO `lang_definitions` VALUES (11258, 693, 9, '日期格式“以来从未见过的”无效');
INSERT INTO `lang_definitions` VALUES (11259, 694, 9, '日期格式“以来”是无效的');
INSERT INTO `lang_definitions` VALUES (11260, 695, 9, '日期免疫信息陈述');
INSERT INTO `lang_definitions` VALUES (11261, 696, 9, '日期代码遗失');
INSERT INTO `lang_definitions` VALUES (11262, 697, 9, '银行存款的日期格式yyyy - mm -日');
INSERT INTO `lang_definitions` VALUES (11263, 698, 9, '生日');
INSERT INTO `lang_definitions` VALUES (11264, 700, 9, '日期损伤');
INSERT INTO `lang_definitions` VALUES (11265, 701, 9, '付款日期格式yyyy - mm -日');
INSERT INTO `lang_definitions` VALUES (11266, 702, 9, '推介日期');
INSERT INTO `lang_definitions` VALUES (11267, 703, 9, '答复日期');
INSERT INTO `lang_definitions` VALUES (11268, 704, 9, '送达日期');
INSERT INTO `lang_definitions` VALUES (11269, 705, 9, '送达日期月/日/年');
INSERT INTO `lang_definitions` VALUES (11270, 706, 9, '送达日期：');
INSERT INTO `lang_definitions` VALUES (11271, 708, 9, '日期可见声明');
INSERT INTO `lang_definitions` VALUES (11272, 711, 9, '日期/笔记的最后');
INSERT INTO `lang_definitions` VALUES (11273, 712, 9, '日期：');
INSERT INTO `lang_definitions` VALUES (11274, 714, 9, '白天');
INSERT INTO `lang_definitions` VALUES (11275, 715, 9, '每天检视');
INSERT INTO `lang_definitions` VALUES (11276, 716, 9, '日（县）');
INSERT INTO `lang_definitions` VALUES (11277, 717, 9, '日（县）中氟');
INSERT INTO `lang_definitions` VALUES (11278, 718, 9, '天');
INSERT INTO `lang_definitions` VALUES (11279, 719, 9, '天');
INSERT INTO `lang_definitions` VALUES (11280, 720, 9, '天和奥运会漏诊');
INSERT INTO `lang_definitions` VALUES (11281, 722, 9, '天数列：');
INSERT INTO `lang_definitions` VALUES (11282, 723, 9, '数据库安装');
INSERT INTO `lang_definitions` VALUES (11283, 725, 9, '调试信息');
INSERT INTO `lang_definitions` VALUES (11284, 726, 9, '12月');
INSERT INTO `lang_definitions` VALUES (11285, 727, 9, '默认');
INSERT INTO `lang_definitions` VALUES (11286, 728, 9, '默认日历视图');
INSERT INTO `lang_definitions` VALUES (11287, 729, 9, '默认基金');
INSERT INTO `lang_definitions` VALUES (11288, 731, 9, '默认方法');
INSERT INTO `lang_definitions` VALUES (11289, 733, 9, '默认模板');
INSERT INTO `lang_definitions` VALUES (11290, 734, 9, '默认值');
INSERT INTO `lang_definitions` VALUES (11291, 735, 9, '默认X12合作伙伴');
INSERT INTO `lang_definitions` VALUES (11292, 736, 9, '默认/全球');
INSERT INTO `lang_definitions` VALUES (11293, 738, 9, '延迟复发（ “ 12沫）');
INSERT INTO `lang_definitions` VALUES (11294, 739, 9, '删除');
INSERT INTO `lang_definitions` VALUES (11295, 741, 9, '删除类别编号（补） ：');
INSERT INTO `lang_definitions` VALUES (11296, 744, 9, '删除页面');
INSERT INTO `lang_definitions` VALUES (11297, 745, 9, '删除病人，遇到表格，问题，文件，付款，结算或交易');
INSERT INTO `lang_definitions` VALUES (11298, 752, 9, '人口统计');
INSERT INTO `lang_definitions` VALUES (11299, 754, 9, '人口未授权');
INSERT INTO `lang_definitions` VALUES (11300, 758, 9, '根据不同的类型的法案是要测试你会看到类似的输出HCFA一个空白页的HCFA账单，你会看到很多行有点乱码文字和信息如果您正在测试一种X12 索赔。这乱码文字X12电子数据交换4010A格式。有时你会看到奇怪的字符，像多米诺骨牌或squiglies ，这些控制字符，如饲料和网页是正常的。');
INSERT INTO `lang_definitions` VALUES (11301, 759, 9, '存款日期：');
INSERT INTO `lang_definitions` VALUES (11302, 760, 9, '抑郁症');
INSERT INTO `lang_definitions` VALUES (11303, 761, 9, '抑郁症');
INSERT INTO `lang_definitions` VALUES (11304, 762, 9, '描述');
INSERT INTO `lang_definitions` VALUES (11305, 763, 9, '描述');
INSERT INTO `lang_definitions` VALUES (11306, 765, 9, '目的地');
INSERT INTO `lang_definitions` VALUES (11307, 766, 9, '摧毁地段');
INSERT INTO `lang_definitions` VALUES (11308, 767, 9, '销毁...');
INSERT INTO `lang_definitions` VALUES (11309, 768, 9, '销毁');
INSERT INTO `lang_definitions` VALUES (11310, 769, 9, '销毁毒品');
INSERT INTO `lang_definitions` VALUES (11311, 770, 9, '摧毁毒品报告');
INSERT INTO `lang_definitions` VALUES (11312, 771, 9, '详情');
INSERT INTO `lang_definitions` VALUES (11313, 772, 9, '发育异常');
INSERT INTO `lang_definitions` VALUES (11314, 773, 9, '糖尿病');
INSERT INTO `lang_definitions` VALUES (11315, 774, 9, '诊断');
INSERT INTO `lang_definitions` VALUES (11316, 775, 9, '诊断');
INSERT INTO `lang_definitions` VALUES (11317, 776, 9, '诊断必须编码成一个挂钩遇到');
INSERT INTO `lang_definitions` VALUES (11318, 777, 9, '诊断：');
INSERT INTO `lang_definitions` VALUES (11319, 778, 9, '诊断：');
INSERT INTO `lang_definitions` VALUES (11320, 779, 9, '诊断测试：');
INSERT INTO `lang_definitions` VALUES (11321, 780, 9, '转盘');
INSERT INTO `lang_definitions` VALUES (11322, 781, 9, '隔膜/帽');
INSERT INTO `lang_definitions` VALUES (11323, 782, 9, '腹泻');
INSERT INTO `lang_definitions` VALUES (11324, 783, 9, '听写');
INSERT INTO `lang_definitions` VALUES (11325, 784, 9, '听写：');
INSERT INTO `lang_definitions` VALUES (11326, 786, 9, '弥漫：');
INSERT INTO `lang_definitions` VALUES (11327, 788, 9, '直接邮寄');
INSERT INTO `lang_definitions` VALUES (11328, 789, 9, '残疾');
INSERT INTO `lang_definitions` VALUES (11329, 790, 9, '残疾人');
INSERT INTO `lang_definitions` VALUES (11330, 791, 9, '残疾人');
INSERT INTO `lang_definitions` VALUES (11331, 792, 9, '圆盘');
INSERT INTO `lang_definitions` VALUES (11332, 794, 9, '解除尿道');
INSERT INTO `lang_definitions` VALUES (11333, 795, 9, '排放权');
INSERT INTO `lang_definitions` VALUES (11334, 796, 9, '排放权：');
INSERT INTO `lang_definitions` VALUES (11335, 797, 9, '折扣');
INSERT INTO `lang_definitions` VALUES (11336, 798, 9, '折扣数额');
INSERT INTO `lang_definitions` VALUES (11337, 801, 9, '脱位');
INSERT INTO `lang_definitions` VALUES (11338, 803, 9, '调度');
INSERT INTO `lang_definitions` VALUES (11339, 804, 9, '调度收稿文件');
INSERT INTO `lang_definitions` VALUES (11340, 805, 9, '配药');
INSERT INTO `lang_definitions` VALUES (11341, 806, 9, '展示活动日期块？');
INSERT INTO `lang_definitions` VALUES (11342, 807, 9, '显示多少个活动？');
INSERT INTO `lang_definitions` VALUES (11343, 808, 9, '显示位置块？');
INSERT INTO `lang_definitions` VALUES (11344, 809, 9, '显示日历？');
INSERT INTO `lang_definitions` VALUES (11345, 810, 9, '显示今天的事件块？');
INSERT INTO `lang_definitions` VALUES (11346, 811, 9, '显示话题块？');
INSERT INTO `lang_definitions` VALUES (11347, 812, 9, '即将举行的活动中显示块？');
INSERT INTO `lang_definitions` VALUES (11348, 813, 9, '分布');
INSERT INTO `lang_definitions` VALUES (11349, 814, 9, '憩室炎');
INSERT INTO `lang_definitions` VALUES (11350, 815, 9, '憩室炎手术');
INSERT INTO `lang_definitions` VALUES (11351, 816, 9, 'Divirticulitis');
INSERT INTO `lang_definitions` VALUES (11352, 817, 9, 'Divirticulitis手术');
INSERT INTO `lang_definitions` VALUES (11353, 818, 9, '离婚');
INSERT INTO `lang_definitions` VALUES (11354, 819, 9, '头晕：');
INSERT INTO `lang_definitions` VALUES (11355, 820, 9, '不保存');
INSERT INTO `lang_definitions` VALUES (11356, 821, 9, '不替代');
INSERT INTO `lang_definitions` VALUES (11357, 823, 9, '你真的要删除此组');
INSERT INTO `lang_definitions` VALUES (11358, 827, 9, '出生日期');
INSERT INTO `lang_definitions` VALUES (11359, 828, 9, '出生日期丢失，请输入可能的话');
INSERT INTO `lang_definitions` VALUES (11360, 829, 9, '文件');
INSERT INTO `lang_definitions` VALUES (11361, 831, 9, '医生：');
INSERT INTO `lang_definitions` VALUES (11362, 833, 9, '文件');
INSERT INTO `lang_definitions` VALUES (11363, 835, 9, '文件分类');
INSERT INTO `lang_definitions` VALUES (11364, 837, 9, '文件日期');
INSERT INTO `lang_definitions` VALUES (11365, 841, 9, '文件/影像店');
INSERT INTO `lang_definitions` VALUES (11366, 842, 9, '文件');
INSERT INTO `lang_definitions` VALUES (11367, 845, 9, '国内伙伴');
INSERT INTO `lang_definitions` VALUES (11368, 847, 9, '不要保存');
INSERT INTO `lang_definitions` VALUES (11369, 848, 9, '不要保存更改');
INSERT INTO `lang_definitions` VALUES (11370, 850, 9, '完成：');
INSERT INTO `lang_definitions` VALUES (11371, 852, 9, '司');
INSERT INTO `lang_definitions` VALUES (11372, 853, 9, '用量');
INSERT INTO `lang_definitions` VALUES (11373, 855, 9, '双瞳');
INSERT INTO `lang_definitions` VALUES (11374, 856, 9, '下载结算文件后，以会计和结算商标');
INSERT INTO `lang_definitions` VALUES (11375, 858, 9, '医生检查');
INSERT INTO `lang_definitions` VALUES (11376, 859, 9, '博士访问');
INSERT INTO `lang_definitions` VALUES (11377, 863, 9, '药物');
INSERT INTO `lang_definitions` VALUES (11378, 867, 9, '药物清单');
INSERT INTO `lang_definitions` VALUES (11379, 868, 9, '药名');
INSERT INTO `lang_definitions` VALUES (11380, 871, 9, '药品');
INSERT INTO `lang_definitions` VALUES (11381, 872, 9, '口干');
INSERT INTO `lang_definitions` VALUES (11382, 873, 9, '白喉，破伤风疫苗 1');
INSERT INTO `lang_definitions` VALUES (11383, 874, 9, '白喉，破伤风疫苗 2');
INSERT INTO `lang_definitions` VALUES (11384, 875, 9, '白喉，破伤风疫苗 3');
INSERT INTO `lang_definitions` VALUES (11385, 876, 9, '白喉，破伤风疫苗 4');
INSERT INTO `lang_definitions` VALUES (11386, 877, 9, '白喉，破伤风疫苗 5');
INSERT INTO `lang_definitions` VALUES (11387, 878, 9, '百白破三联疫苗 1');
INSERT INTO `lang_definitions` VALUES (11388, 879, 9, '百白破三联疫苗 2');
INSERT INTO `lang_definitions` VALUES (11389, 880, 9, '百白破三联疫苗 3');
INSERT INTO `lang_definitions` VALUES (11390, 881, 9, '百白破三联疫苗 4');
INSERT INTO `lang_definitions` VALUES (11391, 882, 9, '百白破三联疫苗 5');
INSERT INTO `lang_definitions` VALUES (11392, 883, 9, '截止日期');
INSERT INTO `lang_definitions` VALUES (11393, 884, 9, '截止日期月/日/年或格式yyyy - mm -日');
INSERT INTO `lang_definitions` VALUES (11394, 885, 9, '截止日期：');
INSERT INTO `lang_definitions` VALUES (11395, 886, 9, '由于集');
INSERT INTO `lang_definitions` VALUES (11396, 887, 9, '由于铂');
INSERT INTO `lang_definitions` VALUES (11397, 895, 9, '期限');
INSERT INTO `lang_definitions` VALUES (11398, 896, 9, '有效期');
INSERT INTO `lang_definitions` VALUES (11399, 897, 9, '荷兰文');
INSERT INTO `lang_definitions` VALUES (11400, 899, 9, '呼吸困难：');
INSERT INTO `lang_definitions` VALUES (11401, 901, 9, '早期复发“ （ < 2沫）');
INSERT INTO `lang_definitions` VALUES (11402, 903, 9, '心电图');
INSERT INTO `lang_definitions` VALUES (11403, 905, 9, '编辑');
INSERT INTO `lang_definitions` VALUES (11404, 906, 9, '编辑过敏');
INSERT INTO `lang_definitions` VALUES (11405, 907, 9, '编辑类别');
INSERT INTO `lang_definitions` VALUES (11406, 908, 9, '编辑定义');
INSERT INTO `lang_definitions` VALUES (11407, 909, 9, '编辑诊断');
INSERT INTO `lang_definitions` VALUES (11408, 910, 9, '编辑设施');
INSERT INTO `lang_definitions` VALUES (11409, 911, 9, '编辑基金信息');
INSERT INTO `lang_definitions` VALUES (11410, 915, 9, '编辑结构');
INSERT INTO `lang_definitions` VALUES (11411, 916, 9, '教育');
INSERT INTO `lang_definitions` VALUES (11412, 917, 9, '教育日期');
INSERT INTO `lang_definitions` VALUES (11413, 918, 9, '电子工程专辑的* GNU通用公共许可证的更多细节。 * *您应该已经收到一份GNU通用公共许可证*程式一起如果没有，写信给： Free');
INSERT INTO `lang_definitions` VALUES (11414, 919, 9, '生效日期');
INSERT INTO `lang_definitions` VALUES (11415, 920, 9, '效力');
INSERT INTO `lang_definitions` VALUES (11416, 922, 9, '肘关节');
INSERT INTO `lang_definitions` VALUES (11417, 923, 9, '肘关节问题');
INSERT INTO `lang_definitions` VALUES (11418, 924, 9, '电子回执');
INSERT INTO `lang_definitions` VALUES (11419, 925, 9, '电邮');
INSERT INTO `lang_definitions` VALUES (11420, 926, 9, '电子邮件Batchcom');
INSERT INTO `lang_definitions` VALUES (11421, 927, 9, '电子邮件通知');
INSERT INTO `lang_definitions` VALUES (11422, 928, 9, '寄给前');
INSERT INTO `lang_definitions` VALUES (11423, 929, 9, '电子邮件发件人');
INSERT INTO `lang_definitions` VALUES (11424, 930, 9, '电子邮件的主题');
INSERT INTO `lang_definitions` VALUES (11425, 931, 9, '电子邮件正文，可用标签： ***姓名*** ，即亲爱的***姓名***');
INSERT INTO `lang_definitions` VALUES (11426, 932, 9, '紧急联络');
INSERT INTO `lang_definitions` VALUES (11427, 935, 9, '紧急避孕');
INSERT INTO `lang_definitions` VALUES (11428, 936, 9, '紧急电话');
INSERT INTO `lang_definitions` VALUES (11429, 937, 9, '肺气肿');
INSERT INTO `lang_definitions` VALUES (11430, 938, 9, '雇员');
INSERT INTO `lang_definitions` VALUES (11431, 939, 9, '雇主');
INSERT INTO `lang_definitions` VALUES (11432, 940, 9, '雇主地址');
INSERT INTO `lang_definitions` VALUES (11433, 941, 9, '雇主数据');
INSERT INTO `lang_definitions` VALUES (11434, 942, 9, '雇主名称');
INSERT INTO `lang_definitions` VALUES (11435, 943, 9, '空的');
INSERT INTO `lang_definitions` VALUES (11436, 944, 9, '空值在“电子邮件时间”');
INSERT INTO `lang_definitions` VALUES (11437, 945, 9, '空值在“电子邮件发件人”');
INSERT INTO `lang_definitions` VALUES (11438, 946, 9, '空值在“电子邮件的主题”');
INSERT INTO `lang_definitions` VALUES (11439, 947, 9, '空值在“电子邮件正文”');
INSERT INTO `lang_definitions` VALUES (11440, 948, 9, '空值在“名称的提供者”');
INSERT INTO `lang_definitions` VALUES (11441, 949, 9, '空值在“密码”');
INSERT INTO `lang_definitions` VALUES (11442, 950, 9, '空值在“短信时间”');
INSERT INTO `lang_definitions` VALUES (11443, 951, 9, '空值在“短信”');
INSERT INTO `lang_definitions` VALUES (11444, 952, 9, '空值在“用户名”');
INSERT INTO `lang_definitions` VALUES (11445, 953, 9, '启用');
INSERT INTO `lang_definitions` VALUES (11446, 954, 9, '电子海图');
INSERT INTO `lang_definitions` VALUES (11447, 956, 9, '遇到');
INSERT INTO `lang_definitions` VALUES (11448, 957, 9, '遇到');
INSERT INTO `lang_definitions` VALUES (11449, 958, 9, '遇到形式');
INSERT INTO `lang_definitions` VALUES (11450, 959, 9, '遇到一些');
INSERT INTO `lang_definitions` VALUES (11451, 960, 9, '遇到编码');
INSERT INTO `lang_definitions` VALUES (11452, 961, 9, '遇到：');
INSERT INTO `lang_definitions` VALUES (11453, 962, 9, '邂逅');
INSERT INTO `lang_definitions` VALUES (11454, 963, 9, '遇到与形式');
INSERT INTO `lang_definitions` VALUES (11455, 964, 9, '遇到与形式');
INSERT INTO `lang_definitions` VALUES (11456, 965, 9, '遇到未授权');
INSERT INTO `lang_definitions` VALUES (11457, 966, 9, '座谈会报告');
INSERT INTO `lang_definitions` VALUES (11458, 967, 9, '遇到科');
INSERT INTO `lang_definitions` VALUES (11459, 968, 9, '末端');
INSERT INTO `lang_definitions` VALUES (11460, 969, 9, '完（格式yyyy - mm - DD ）的：');
INSERT INTO `lang_definitions` VALUES (11461, 970, 9, '结束日期');
INSERT INTO `lang_definitions` VALUES (11462, 971, 9, '结束日期');
INSERT INTO `lang_definitions` VALUES (11463, 972, 9, '结束日期：');
INSERT INTO `lang_definitions` VALUES (11464, 973, 9, '结束时间');
INSERT INTO `lang_definitions` VALUES (11465, 974, 9, '服务结束日期格式yyyy - mm -日');
INSERT INTO `lang_definitions` VALUES (11466, 975, 9, '截至司月/日/年如果你想输入某个范围');
INSERT INTO `lang_definitions` VALUES (11467, 977, 9, '内分泌');
INSERT INTO `lang_definitions` VALUES (11468, 978, 9, '内窥镜');
INSERT INTO `lang_definitions` VALUES (11469, 979, 9, '英文');
INSERT INTO `lang_definitions` VALUES (11470, 986, 9, '输入诊断代码排除所有发票不包含它');
INSERT INTO `lang_definitions` VALUES (11471, 990, 9, '环境');
INSERT INTO `lang_definitions` VALUES (11472, 991, 9, 'EOB数据录入');
INSERT INTO `lang_definitions` VALUES (11473, 992, 9, 'EOB发布-电子汇款');
INSERT INTO `lang_definitions` VALUES (11474, 993, 9, 'EOB张贴-说明');
INSERT INTO `lang_definitions` VALUES (11475, 994, 9, 'EOB发布-发票');
INSERT INTO `lang_definitions` VALUES (11476, 995, 9, 'EOB张贴-患者请注意');
INSERT INTO `lang_definitions` VALUES (11477, 996, 9, 'EOB发布-搜索');
INSERT INTO `lang_definitions` VALUES (11478, 997, 9, '癫痫');
INSERT INTO `lang_definitions` VALUES (11479, 998, 9, '擦除');
INSERT INTO `lang_definitions` VALUES (11480, 1000, 9, '错误');
INSERT INTO `lang_definitions` VALUES (11481, 1001, 9, '中的错误“性别”的选择');
INSERT INTO `lang_definitions` VALUES (11482, 1002, 9, '中的错误“法案”的选择');
INSERT INTO `lang_definitions` VALUES (11483, 1003, 9, '中的错误“过程”选择');
INSERT INTO `lang_definitions` VALUES (11484, 1004, 9, '错误的“短信网关”选择');
INSERT INTO `lang_definitions` VALUES (11485, 1005, 9, '中的错误“排序方式”的选择');
INSERT INTO `lang_definitions` VALUES (11486, 1007, 9, '中的错误是或否的选择');
INSERT INTO `lang_definitions` VALUES (11487, 1016, 9, '错误：密码不匹配，请检查拼写');
INSERT INTO `lang_definitions` VALUES (11488, 1018, 9, '错误');
INSERT INTO `lang_definitions` VALUES (11489, 1019, 9, '红斑：');
INSERT INTO `lang_definitions` VALUES (11490, 1021, 9, '族裔或种族');
INSERT INTO `lang_definitions` VALUES (11491, 1023, 9, '生成');
INSERT INTO `lang_definitions` VALUES (11492, 1024, 9, '事件');
INSERT INTO `lang_definitions` VALUES (11493, 1025, 9, '活动开始');
INSERT INTO `lang_definitions` VALUES (11494, 1026, 9, '事件类别');
INSERT INTO `lang_definitions` VALUES (11495, 1027, 9, '活动日期');
INSERT INTO `lang_definitions` VALUES (11496, 1028, 9, '事件描述');
INSERT INTO `lang_definitions` VALUES (11497, 1029, 9, '活动详情');
INSERT INTO `lang_definitions` VALUES (11498, 1030, 9, '事件不会重演');
INSERT INTO `lang_definitions` VALUES (11499, 1031, 9, '事件时间');
INSERT INTO `lang_definitions` VALUES (11500, 1032, 9, '活动期间在几分钟');
INSERT INTO `lang_definitions` VALUES (11501, 1033, 9, '活动费');
INSERT INTO `lang_definitions` VALUES (11502, 1034, 9, '活动地点');
INSERT INTO `lang_definitions` VALUES (11503, 1035, 9, '每一个事件重复');
INSERT INTO `lang_definitions` VALUES (11504, 1036, 9, '事件重复的');
INSERT INTO `lang_definitions` VALUES (11505, 1037, 9, '活动开始时间');
INSERT INTO `lang_definitions` VALUES (11506, 1038, 9, '活动名称');
INSERT INTO `lang_definitions` VALUES (11507, 1039, 9, '活动名称');
INSERT INTO `lang_definitions` VALUES (11508, 1040, 9, '网址');
INSERT INTO `lang_definitions` VALUES (11509, 1041, 9, '事件');
INSERT INTO `lang_definitions` VALUES (11510, 1042, 9, '事件');
INSERT INTO `lang_definitions` VALUES (11511, 1043, 9, '活动在新视窗开启');
INSERT INTO `lang_definitions` VALUES (11512, 1045, 9, '每个的');
INSERT INTO `lang_definitions` VALUES (11513, 1046, 9, '每3小时');
INSERT INTO `lang_definitions` VALUES (11514, 1047, 9, '每4小时');
INSERT INTO `lang_definitions` VALUES (11515, 1048, 9, '每5个小时');
INSERT INTO `lang_definitions` VALUES (11516, 1049, 9, '每6小时');
INSERT INTO `lang_definitions` VALUES (11517, 1050, 9, '每隔8小时');
INSERT INTO `lang_definitions` VALUES (11518, 1051, 9, '每4名');
INSERT INTO `lang_definitions` VALUES (11519, 1052, 9, '所有其他');
INSERT INTO `lang_definitions` VALUES (11520, 1053, 9, '每三');
INSERT INTO `lang_definitions` VALUES (11521, 1055, 9, '考试和测试结果');
INSERT INTO `lang_definitions` VALUES (11522, 1056, 9, '考试结果');
INSERT INTO `lang_definitions` VALUES (11523, 1058, 9, '考试/测试');
INSERT INTO `lang_definitions` VALUES (11524, 1060, 9, '独家供应商组织（促红细胞生成素）');
INSERT INTO `lang_definitions` VALUES (11525, 1062, 9, '运动模式');
INSERT INTO `lang_definitions` VALUES (11526, 1063, 9, '退出管理');
INSERT INTO `lang_definitions` VALUES (11527, 1065, 9, '扩展视图');
INSERT INTO `lang_definitions` VALUES (11528, 1066, 9, '预计form_encounter.pid将');
INSERT INTO `lang_definitions` VALUES (11529, 1067, 9, '到期');
INSERT INTO `lang_definitions` VALUES (11530, 1068, 9, '到期日期');
INSERT INTO `lang_definitions` VALUES (11531, 1069, 9, '到期');
INSERT INTO `lang_definitions` VALUES (11532, 1070, 9, '出口');
INSERT INTO `lang_definitions` VALUES (11533, 1071, 9, '导出为CSV格式');
INSERT INTO `lang_definitions` VALUES (11534, 1076, 9, '汇出成');
INSERT INTO `lang_definitions` VALUES (11535, 1077, 9, '导出到外部结算系统');
INSERT INTO `lang_definitions` VALUES (11536, 1078, 9, '接触到国外');
INSERT INTO `lang_definitions` VALUES (11537, 1081, 9, '外部ID');
INSERT INTO `lang_definitions` VALUES (11538, 1084, 9, '对外推介');
INSERT INTO `lang_definitions` VALUES (11539, 1086, 9, '对外推介？');
INSERT INTO `lang_definitions` VALUES (11540, 1087, 9, '对外推介');
INSERT INTO `lang_definitions` VALUES (11541, 1088, 9, '分泌物：');
INSERT INTO `lang_definitions` VALUES (11542, 1089, 9, '眼刺痛');
INSERT INTO `lang_definitions` VALUES (11543, 1090, 9, '眼睛疼痛');
INSERT INTO `lang_definitions` VALUES (11544, 1091, 9, '眼睛发红');
INSERT INTO `lang_definitions` VALUES (11545, 1092, 9, '双眼');
INSERT INTO `lang_definitions` VALUES (11546, 1093, 9, 'F');
INSERT INTO `lang_definitions` VALUES (11547, 1096, 9, '设备，工具');
INSERT INTO `lang_definitions` VALUES (11548, 1097, 9, '基金');
INSERT INTO `lang_definitions` VALUES (11549, 1098, 9, '设施');
INSERT INTO `lang_definitions` VALUES (11550, 1099, 9, '行政机构');
INSERT INTO `lang_definitions` VALUES (11551, 1102, 9, '设施：');
INSERT INTO `lang_definitions` VALUES (11552, 1103, 9, '失败');
INSERT INTO `lang_definitions` VALUES (11553, 1106, 9, '家族史');
INSERT INTO `lang_definitions` VALUES (11554, 1108, 9, '家族病史：');
INSERT INTO `lang_definitions` VALUES (11555, 1109, 9, '家庭规模');
INSERT INTO `lang_definitions` VALUES (11556, 1110, 9, '花式');
INSERT INTO `lang_definitions` VALUES (11557, 1111, 9, '父亲');
INSERT INTO `lang_definitions` VALUES (11558, 1112, 9, '疲惫');
INSERT INTO `lang_definitions` VALUES (11559, 1113, 9, '疲惫');
INSERT INTO `lang_definitions` VALUES (11560, 1114, 9, '传真');
INSERT INTO `lang_definitions` VALUES (11561, 1115, 9, '传真号码');
INSERT INTO `lang_definitions` VALUES (11562, 1116, 9, '传真/扫描');
INSERT INTO `lang_definitions` VALUES (11563, 1117, 9, '传真在');
INSERT INTO `lang_definitions` VALUES (11564, 1118, 9, '传真输出');
INSERT INTO `lang_definitions` VALUES (11565, 1119, 9, '二月');
INSERT INTO `lang_definitions` VALUES (11566, 1120, 9, 'FECA');
INSERT INTO `lang_definitions` VALUES (11567, 1121, 9, '联邦药品编号');
INSERT INTO `lang_definitions` VALUES (11568, 1122, 9, '联邦艾因');
INSERT INTO `lang_definitions` VALUES (11569, 1123, 9, '联邦税务ID');
INSERT INTO `lang_definitions` VALUES (11570, 1124, 9, '酬金');
INSERT INTO `lang_definitions` VALUES (11571, 1125, 9, '酬金');
INSERT INTO `lang_definitions` VALUES (11572, 1127, 9, '收费表');
INSERT INTO `lang_definitions` VALUES (11573, 1129, 9, '收费');
INSERT INTO `lang_definitions` VALUES (11574, 1130, 9, '女性');
INSERT INTO `lang_definitions` VALUES (11575, 1132, 9, '女用避孕套');
INSERT INTO `lang_definitions` VALUES (11576, 1137, 9, '女变结构控制');
INSERT INTO `lang_definitions` VALUES (11577, 1138, 9, '热');
INSERT INTO `lang_definitions` VALUES (11578, 1139, 9, '发烧：');
INSERT INTO `lang_definitions` VALUES (11579, 1141, 9, '肌瘤');
INSERT INTO `lang_definitions` VALUES (11580, 1143, 9, '档案室');
INSERT INTO `lang_definitions` VALUES (11581, 1146, 9, '文件名');
INSERT INTO `lang_definitions` VALUES (11582, 1147, 9, '只有在这里填写发送电子邮件通知患者');
INSERT INTO `lang_definitions` VALUES (11583, 1150, 9, '过滤器');
INSERT INTO `lang_definitions` VALUES (11584, 1151, 9, '最后诊断');
INSERT INTO `lang_definitions` VALUES (11585, 1152, 9, '最后诊断专家');
INSERT INTO `lang_definitions` VALUES (11586, 1153, 9, '金融');
INSERT INTO `lang_definitions` VALUES (11587, 1156, 9, '财务审查日期');
INSERT INTO `lang_definitions` VALUES (11588, 1157, 9, '查找');
INSERT INTO `lang_definitions` VALUES (11589, 1158, 9, '寻找可用');
INSERT INTO `lang_definitions` VALUES (11590, 1159, 9, '寻找可用的任命');
INSERT INTO `lang_definitions` VALUES (11591, 1160, 9, '发现病人');
INSERT INTO `lang_definitions` VALUES (11592, 1161, 9, '调查结果');
INSERT INTO `lang_definitions` VALUES (11593, 1162, 9, '调查结果由专业');
INSERT INTO `lang_definitions` VALUES (11594, 1163, 9, '美好的');
INSERT INTO `lang_definitions` VALUES (11595, 1164, 9, '首先');
INSERT INTO `lang_definitions` VALUES (11596, 1165, 9, '第一天的一周');
INSERT INTO `lang_definitions` VALUES (11597, 1166, 9, '名字');
INSERT INTO `lang_definitions` VALUES (11598, 1168, 9, '第一名称：');
INSERT INTO `lang_definitions` VALUES (11599, 1169, 9, '健身');
INSERT INTO `lang_definitions` VALUES (11600, 1170, 9, '健身游戏');
INSERT INTO `lang_definitions` VALUES (11601, 1175, 9, '接种流感疫苗');
INSERT INTO `lang_definitions` VALUES (11602, 1176, 9, '液体和电解质的问题');
INSERT INTO `lang_definitions` VALUES (11603, 1178, 9, '后续手动');
INSERT INTO `lang_definitions` VALUES (11604, 1180, 9, '脚');
INSERT INTO `lang_definitions` VALUES (11605, 1181, 9, '足部');
INSERT INTO `lang_definitions` VALUES (11606, 1182, 9, '步行：');
INSERT INTO `lang_definitions` VALUES (11607, 1184, 9, '足球损伤报告');
INSERT INTO `lang_definitions` VALUES (11608, 1185, 9, '鞋型');
INSERT INTO `lang_definitions` VALUES (11609, 1186, 9, '为了');
INSERT INTO `lang_definitions` VALUES (11610, 1189, 9, '为：');
INSERT INTO `lang_definitions` VALUES (11611, 1190, 9, '前臂');
INSERT INTO `lang_definitions` VALUES (11612, 1191, 9, '表格');
INSERT INTO `lang_definitions` VALUES (11613, 1194, 9, '格式');
INSERT INTO `lang_definitions` VALUES (11614, 1195, 9, '格式不正确的国防委员会');
INSERT INTO `lang_definitions` VALUES (11615, 1196, 9, '形式');
INSERT INTO `lang_definitions` VALUES (11616, 1197, 9, '形式管理');
INSERT INTO `lang_definitions` VALUES (11617, 1198, 9, '转寄页通过传真');
INSERT INTO `lang_definitions` VALUES (11618, 1199, 9, '第四次');
INSERT INTO `lang_definitions` VALUES (11619, 1200, 9, '骨折');
INSERT INTO `lang_definitions` VALUES (11620, 1201, 9, '骨折在舟');
INSERT INTO `lang_definitions` VALUES (11621, 1202, 9, '外踝骨折');
INSERT INTO `lang_definitions` VALUES (11622, 1203, 9, '内踝骨折');
INSERT INTO `lang_definitions` VALUES (11623, 1204, 9, '骨折，基地的第五次（第5次）跖骨');
INSERT INTO `lang_definitions` VALUES (11624, 1205, 9, '法文');
INSERT INTO `lang_definitions` VALUES (11625, 1206, 9, '频繁；频率');
INSERT INTO `lang_definitions` VALUES (11626, 1207, 9, '频发性感冒');
INSERT INTO `lang_definitions` VALUES (11627, 1208, 9, '频发性疾病');
INSERT INTO `lang_definitions` VALUES (11628, 1209, 9, '星期五');
INSERT INTO `lang_definitions` VALUES (11629, 1210, 9, '星期五');
INSERT INTO `lang_definitions` VALUES (11630, 1211, 9, '自');
INSERT INTO `lang_definitions` VALUES (11631, 1213, 9, '来自：');
INSERT INTO `lang_definitions` VALUES (11632, 1214, 9, '来自：');
INSERT INTO `lang_definitions` VALUES (11633, 1226, 9, '接待办公室收据');
INSERT INTO `lang_definitions` VALUES (11634, 1227, 9, '接待办公室收益报告');
INSERT INTO `lang_definitions` VALUES (11635, 1228, 9, '接待建议');
INSERT INTO `lang_definitions` VALUES (11636, 1229, 9, '正面右：');
INSERT INTO `lang_definitions` VALUES (11637, 1231, 9, '充分发挥');
INSERT INTO `lang_definitions` VALUES (11638, 1232, 9, '训练');
INSERT INTO `lang_definitions` VALUES (11639, 1234, 9, '胆囊条件');
INSERT INTO `lang_definitions` VALUES (11640, 1235, 9, '胆结石');
INSERT INTO `lang_definitions` VALUES (11641, 1236, 9, '游戏时代');
INSERT INTO `lang_definitions` VALUES (11642, 1237, 9, '运动会');
INSERT INTO `lang_definitions` VALUES (11643, 1238, 9, '游戏/事件');
INSERT INTO `lang_definitions` VALUES (11644, 1239, 9, '游戏/活动漏诊');
INSERT INTO `lang_definitions` VALUES (11645, 1240, 9, '胃炎');
INSERT INTO `lang_definitions` VALUES (11646, 1242, 9, '胃肠道');
INSERT INTO `lang_definitions` VALUES (11647, 1243, 9, 'GCAC统计报告');
INSERT INTO `lang_definitions` VALUES (11648, 1246, 9, '性别');
INSERT INTO `lang_definitions` VALUES (11649, 1247, 9, '一般');
INSERT INTO `lang_definitions` VALUES (11650, 1248, 9, '一般事务类');
INSERT INTO `lang_definitions` VALUES (11651, 1249, 9, '生成和下载HCFA 1500年书面索赔');
INSERT INTO `lang_definitions` VALUES (11652, 1250, 9, '生成并下载X12批次');
INSERT INTO `lang_definitions` VALUES (11653, 1255, 9, '产生来信');
INSERT INTO `lang_definitions` VALUES (11654, 1256, 9, '生成报告');
INSERT INTO `lang_definitions` VALUES (11655, 1259, 9, '产生');
INSERT INTO `lang_definitions` VALUES (11656, 1260, 9, '生成');
INSERT INTO `lang_definitions` VALUES (11657, 1261, 9, '泌尿生殖');
INSERT INTO `lang_definitions` VALUES (11658, 1262, 9, '德语');
INSERT INTO `lang_definitions` VALUES (11659, 1263, 9, '青光眼');
INSERT INTO `lang_definitions` VALUES (11660, 1265, 9, '全球');
INSERT INTO `lang_definitions` VALUES (11661, 1267, 9, '离去');
INSERT INTO `lang_definitions` VALUES (11662, 1268, 9, '离去');
INSERT INTO `lang_definitions` VALUES (11663, 1271, 9, '等级：');
INSERT INTO `lang_definitions` VALUES (11664, 1272, 9, '克');
INSERT INTO `lang_definitions` VALUES (11665, 1273, 9, '总计');
INSERT INTO `lang_definitions` VALUES (11666, 1274, 9, '总计');
INSERT INTO `lang_definitions` VALUES (11667, 1276, 9, '组');
INSERT INTO `lang_definitions` VALUES (11668, 1281, 9, '组数');
INSERT INTO `lang_definitions` VALUES (11669, 1282, 9, '组：');
INSERT INTO `lang_definitions` VALUES (11670, 1283, 9, '群组');
INSERT INTO `lang_definitions` VALUES (11671, 1284, 9, '团体和访问控制');
INSERT INTO `lang_definitions` VALUES (11672, 1287, 9, 'gtts （滴）');
INSERT INTO `lang_definitions` VALUES (11673, 1288, 9, '妇科考试');
INSERT INTO `lang_definitions` VALUES (11674, 1289, 9, 'h');
INSERT INTO `lang_definitions` VALUES (11675, 1290, 9, 'h.s.');
INSERT INTO `lang_definitions` VALUES (11676, 1293, 9, '血肿/瘀伤');
INSERT INTO `lang_definitions` VALUES (11677, 1295, 9, '另一方面+手指');
INSERT INTO `lang_definitions` VALUES (11678, 1296, 9, '另一方面问题');
INSERT INTO `lang_definitions` VALUES (11679, 1297, 9, '艰苦W / O型');
INSERT INTO `lang_definitions` VALUES (11680, 1300, 9, '危险活动');
INSERT INTO `lang_definitions` VALUES (11681, 1304, 9, '他PostCalendar');
INSERT INTO `lang_definitions` VALUES (11682, 1305, 9, '头');
INSERT INTO `lang_definitions` VALUES (11683, 1309, 9, '头痛');
INSERT INTO `lang_definitions` VALUES (11684, 1311, 9, '健康维护组织');
INSERT INTO `lang_definitions` VALUES (11685, 1312, 9, '健康维护组织（健保组织）医疗风险');
INSERT INTO `lang_definitions` VALUES (11686, 1314, 9, '心脏病发作');
INSERT INTO `lang_definitions` VALUES (11687, 1315, 9, '心脏病');
INSERT INTO `lang_definitions` VALUES (11688, 1316, 9, '心力衰竭');
INSERT INTO `lang_definitions` VALUES (11689, 1318, 9, '心脏问题');
INSERT INTO `lang_definitions` VALUES (11690, 1319, 9, '心脏手术');
INSERT INTO `lang_definitions` VALUES (11691, 1320, 9, '心脏移植');
INSERT INTO `lang_definitions` VALUES (11692, 1321, 9, '心：');
INSERT INTO `lang_definitions` VALUES (11693, 1325, 9, '希伯来语');
INSERT INTO `lang_definitions` VALUES (11694, 1326, 9, 'HEENT');
INSERT INTO `lang_definitions` VALUES (11695, 1328, 9, '帮助');
INSERT INTO `lang_definitions` VALUES (11696, 1329, 9, '帮助');
INSERT INTO `lang_definitions` VALUES (11697, 1334, 9, '血红蛋白');
INSERT INTO `lang_definitions` VALUES (11698, 1336, 9, '肝炎');
INSERT INTO `lang_definitions` VALUES (11699, 1343, 9, '疝修补术');
INSERT INTO `lang_definitions` VALUES (11700, 1344, 9, '腰椎间盘突出');
INSERT INTO `lang_definitions` VALUES (11701, 1345, 9, '疱疹');
INSERT INTO `lang_definitions` VALUES (11702, 1347, 9, 'heyyo 。你在这里');
INSERT INTO `lang_definitions` VALUES (11703, 1348, 9, 'B型流感嗜血杆菌结合疫苗 1');
INSERT INTO `lang_definitions` VALUES (11704, 1349, 9, 'B型流感嗜血杆菌结合疫苗 2');
INSERT INTO `lang_definitions` VALUES (11705, 1350, 9, 'B型流感嗜血杆菌结合疫苗 3');
INSERT INTO `lang_definitions` VALUES (11706, 1351, 9, 'B型流感嗜血杆菌结合疫苗 4');
INSERT INTO `lang_definitions` VALUES (11707, 1352, 9, '隐藏');
INSERT INTO `lang_definitions` VALUES (11708, 1353, 9, '隐藏活动管理');
INSERT INTO `lang_definitions` VALUES (11709, 1354, 9, '隐藏');
INSERT INTO `lang_definitions` VALUES (11710, 1355, 9, '隐藏详细信息');
INSERT INTO `lang_definitions` VALUES (11711, 1357, 9, '高的');
INSERT INTO `lang_definitions` VALUES (11712, 1358, 9, '血压高');
INSERT INTO `lang_definitions` VALUES (11713, 1359, 9, '嘻哈+腹股沟');
INSERT INTO `lang_definitions` VALUES (11714, 1360, 9, '髋部和腹股沟');
INSERT INTO `lang_definitions` VALUES (11715, 1361, 9, '髋关节的问题');
INSERT INTO `lang_definitions` VALUES (11716, 1362, 9, '髋关节置换术');
INSERT INTO `lang_definitions` VALUES (11717, 1363, 9, 'HIPAA标准的通知收稿');
INSERT INTO `lang_definitions` VALUES (11718, 1365, 9, '西班牙裔');
INSERT INTO `lang_definitions` VALUES (11719, 1366, 9, '历史');
INSERT INTO `lang_definitions` VALUES (11720, 1367, 9, '历史数据');
INSERT INTO `lang_definitions` VALUES (11721, 1368, 9, '心脏杂音病史');
INSERT INTO `lang_definitions` VALUES (11722, 1369, 9, '心脏杂音病史');
INSERT INTO `lang_definitions` VALUES (11723, 1370, 9, '人体免疫缺损病毒，艾滋病病毒 ');
INSERT INTO `lang_definitions` VALUES (11724, 1371, 9, 'HL7标准浏览器');
INSERT INTO `lang_definitions` VALUES (11725, 1372, 9, '按住[ Ctrl键]以便进行多项选择或取消');
INSERT INTO `lang_definitions` VALUES (11726, 1373, 9, '按住CTRL键选择多个项目');
INSERT INTO `lang_definitions` VALUES (11727, 1374, 9, '按住CTRL键选择多个敢死队');
INSERT INTO `lang_definitions` VALUES (11728, 1375, 9, '家');
INSERT INTO `lang_definitions` VALUES (11729, 1376, 9, '家庭电话');
INSERT INTO `lang_definitions` VALUES (11730, 1378, 9, '无家可归或类似？');
INSERT INTO `lang_definitions` VALUES (11731, 1379, 9, '无家可归等');
INSERT INTO `lang_definitions` VALUES (11732, 1380, 9, '无家可归等');
INSERT INTO `lang_definitions` VALUES (11733, 1381, 9, '小时');
INSERT INTO `lang_definitions` VALUES (11734, 1382, 9, '怎么损伤发生？');
INSERT INTO `lang_definitions` VALUES (11735, 1383, 9, '怎么损伤发生？ ：');
INSERT INTO `lang_definitions` VALUES (11736, 1384, 9, '有多少未来几个月来查询即将举行的活动？');
INSERT INTO `lang_definitions` VALUES (11737, 1385, 9, '液相色谱法：');
INSERT INTO `lang_definitions` VALUES (11738, 1387, 9, '的HTML');
INSERT INTO `lang_definitions` VALUES (11739, 1388, 9, '动');
INSERT INTO `lang_definitions` VALUES (11740, 1389, 9, '高血压');
INSERT INTO `lang_definitions` VALUES (11741, 1390, 9, '甲状腺功能亢进症');
INSERT INTO `lang_definitions` VALUES (11742, 1391, 9, '甲状腺功能减退症');
INSERT INTO `lang_definitions` VALUES (11743, 1392, 9, '子宫切除术');
INSERT INTO `lang_definitions` VALUES (11744, 1394, 9, '我在这段时间里忙碌。');
INSERT INTO `lang_definitions` VALUES (11745, 1395, 9, '我没有权限读取');
INSERT INTO `lang_definitions` VALUES (11746, 1396, 9, '国际疾病分类');
INSERT INTO `lang_definitions` VALUES (11747, 1398, 9, '编号');
INSERT INTO `lang_definitions` VALUES (11748, 1400, 9, 'IDays');
INSERT INTO `lang_definitions` VALUES (11749, 1401, 9, '经鉴定为');
INSERT INTO `lang_definitions` VALUES (11750, 1402, 9, '标识符（一个字）');
INSERT INTO `lang_definitions` VALUES (11751, 1403, 9, '如果所有的数据都列有完整的这种形式');
INSERT INTO `lang_definitions` VALUES (11752, 1404, 9, '如果姓名，任何部分的姓氏或姓氏，名字');
INSERT INTO `lang_definitions` VALUES (11753, 1405, 9, '如果失业者进入学生');
INSERT INTO `lang_definitions` VALUES (11754, 1406, 9, '如果您选择上传电子汇款，然后在搜索窗口将重新本身的匹配发票X12文件。您可以点击任何这些发票号码（如下所述）如果您想进行任何修改之前，汇款信息应用。以应用更改，请单击过程自责文件按钮，在页面底部。这将产生一个新窗口的详细报告。');
INSERT INTO `lang_definitions` VALUES (11755, 1407, 9, '如果您已进入了一个付费日期在搜索页面上，这将取代张贴日期付款和调整，否则，从X12文件。这可能是有益的报告的目的，如果您希望您的收益报告使用您的发布日期，而不是保险公司的处理日期。请注意，这也将影响到日期之前支付和调整，投入二次索赔。');
INSERT INTO `lang_definitions` VALUES (11756, 1408, 9, '如果您想更改数据类型，或添加行或列');
INSERT INTO `lang_definitions` VALUES (11757, 1409, 9, '疾病');
INSERT INTO `lang_definitions` VALUES (11758, 1410, 9, '即时通讯');
INSERT INTO `lang_definitions` VALUES (11759, 1411, 9, '免疫');
INSERT INTO `lang_definitions` VALUES (11760, 1412, 9, '免疫批号');
INSERT INTO `lang_definitions` VALUES (11761, 1413, 9, '免疫制造商');
INSERT INTO `lang_definitions` VALUES (11762, 1414, 9, '免疫接种');
INSERT INTO `lang_definitions` VALUES (11763, 1415, 9, '免疫接种');
INSERT INTO `lang_definitions` VALUES (11764, 1417, 9, '种植体');
INSERT INTO `lang_definitions` VALUES (11765, 1418, 9, '进口');
INSERT INTO `lang_definitions` VALUES (11766, 1420, 9, '输入性病人');
INSERT INTO `lang_definitions` VALUES (11767, 1421, 9, '输入性病人统计数据');
INSERT INTO `lang_definitions` VALUES (11768, 1422, 9, '进口会计');
INSERT INTO `lang_definitions` VALUES (11769, 1423, 9, '改良的');
INSERT INTO `lang_definitions` VALUES (11770, 1424, 9, '在');
INSERT INTO `lang_definitions` VALUES (11771, 1426, 9, '在每只眼睛');
INSERT INTO `lang_definitions` VALUES (11772, 1427, 9, '在左眼');
INSERT INTO `lang_definitions` VALUES (11773, 1428, 9, '在鼻孔');
INSERT INTO `lang_definitions` VALUES (11774, 1430, 9, '在右眼');
INSERT INTO `lang_definitions` VALUES (11775, 1431, 9, '在内部');
INSERT INTO `lang_definitions` VALUES (11776, 1433, 9, '无效天');
INSERT INTO `lang_definitions` VALUES (11777, 1436, 9, '包括命脉');
INSERT INTO `lang_definitions` VALUES (11778, 1437, 9, '包括命脉数据？');
INSERT INTO `lang_definitions` VALUES (11779, 1438, 9, '收入');
INSERT INTO `lang_definitions` VALUES (11780, 1439, 9, '不完全流产治疗');
INSERT INTO `lang_definitions` VALUES (11781, 1440, 9, '失禁');
INSERT INTO `lang_definitions` VALUES (11782, 1441, 9, '增加：');
INSERT INTO `lang_definitions` VALUES (11783, 1442, 9, '弥偿保险');
INSERT INTO `lang_definitions` VALUES (11784, 1443, 9, '不定');
INSERT INTO `lang_definitions` VALUES (11785, 1444, 9, '表明，如果这个问题目前正在积极');
INSERT INTO `lang_definitions` VALUES (11786, 1445, 9, '贫困患者报告');
INSERT INTO `lang_definitions` VALUES (11787, 1446, 9, '贫困');
INSERT INTO `lang_definitions` VALUES (11788, 1447, 9, '人工流产');
INSERT INTO `lang_definitions` VALUES (11789, 1448, 9, '感染/脓肿');
INSERT INTO `lang_definitions` VALUES (11790, 1449, 9, '感染');
INSERT INTO `lang_definitions` VALUES (11791, 1450, 9, 'Infert Couns');
INSERT INTO `lang_definitions` VALUES (11792, 1451, 9, '不孕症');
INSERT INTO `lang_definitions` VALUES (11793, 1452, 9, '1 型流感');
INSERT INTO `lang_definitions` VALUES (11794, 1453, 9, '2 型流感');
INSERT INTO `lang_definitions` VALUES (11795, 1454, 9, '信息');
INSERT INTO `lang_definitions` VALUES (11796, 1455, 9, '信息测试1');
INSERT INTO `lang_definitions` VALUES (11797, 1456, 9, '信息测试2');
INSERT INTO `lang_definitions` VALUES (11798, 1457, 9, '信息测试3');
INSERT INTO `lang_definitions` VALUES (11799, 1458, 9, '信息测试4');
INSERT INTO `lang_definitions` VALUES (11800, 1459, 9, '信息测试5');
INSERT INTO `lang_definitions` VALUES (11801, 1460, 9, '信息测试6');
INSERT INTO `lang_definitions` VALUES (11802, 1461, 9, '吸入');
INSERT INTO `lang_definitions` VALUES (11803, 1462, 9, 'inhilations');
INSERT INTO `lang_definitions` VALUES (11804, 1463, 9, '首位使用者');
INSERT INTO `lang_definitions` VALUES (11805, 1464, 9, '血管注射剂， 可注射的');
INSERT INTO `lang_definitions` VALUES (11806, 1466, 9, '受伤');
INSERT INTO `lang_definitions` VALUES (11807, 1482, 9, '失眠');
INSERT INTO `lang_definitions` VALUES (11808, 1483, 9, '检查；视察');
INSERT INTO `lang_definitions` VALUES (11809, 1484, 9, '不全脱位');
INSERT INTO `lang_definitions` VALUES (11810, 1486, 9, '受教育的');
INSERT INTO `lang_definitions` VALUES (11811, 1487, 9, '介绍');
INSERT INTO `lang_definitions` VALUES (11812, 1488, 9, '胰岛素依赖型病人');
INSERT INTO `lang_definitions` VALUES (11813, 1489, 9, '保险');
INSERT INTO `lang_definitions` VALUES (11814, 1491, 9, '保险公司');
INSERT INTO `lang_definitions` VALUES (11815, 1492, 9, '保险公司');
INSERT INTO `lang_definitions` VALUES (11816, 1496, 9, '保险提供者');
INSERT INTO `lang_definitions` VALUES (11817, 1497, 9, '摄入总量');
INSERT INTO `lang_definitions` VALUES (11818, 1498, 9, '摄入日期');
INSERT INTO `lang_definitions` VALUES (11819, 1500, 9, '内部错误-无选定页面');
INSERT INTO `lang_definitions` VALUES (11820, 1501, 9, '内部错误-无病人身份证明');
INSERT INTO `lang_definitions` VALUES (11821, 1503, 9, '内部错误');
INSERT INTO `lang_definitions` VALUES (11822, 1509, 9, '内部转诊病人');
INSERT INTO `lang_definitions` VALUES (11823, 1510, 9, '国际责任');
INSERT INTO `lang_definitions` VALUES (11824, 1511, 9, '译员，口译者');
INSERT INTO `lang_definitions` VALUES (11825, 1512, 9, '需要口译？');
INSERT INTO `lang_definitions` VALUES (11826, 1513, 9, '间质性肺炎');
INSERT INTO `lang_definitions` VALUES (11827, 1514, 9, '间隔');
INSERT INTO `lang_definitions` VALUES (11828, 1515, 9, '耐受');
INSERT INTO `lang_definitions` VALUES (11829, 1516, 9, '肌肉的');
INSERT INTO `lang_definitions` VALUES (11830, 1517, 9, '静脉注射地');
INSERT INTO `lang_definitions` VALUES (11831, 1518, 9, '介绍');
INSERT INTO `lang_definitions` VALUES (11832, 1519, 9, '无效或者缺失支付人来源的代码');
INSERT INTO `lang_definitions` VALUES (11833, 1520, 9, '无效服务代码');
INSERT INTO `lang_definitions` VALUES (11834, 1523, 9, '存货清单');
INSERT INTO `lang_definitions` VALUES (11835, 1524, 9, '此订单的详细目录不存在');
INSERT INTO `lang_definitions` VALUES (11836, 1525, 9, '盘存清单');
INSERT INTO `lang_definitions` VALUES (11837, 1526, 9, '发票');
INSERT INTO `lang_definitions` VALUES (11838, 1528, 9, '发票日期');
INSERT INTO `lang_definitions` VALUES (11839, 1529, 9, '发票无日期');
INSERT INTO `lang_definitions` VALUES (11840, 1533, 9, '灭活脊髓灰质炎疫苗 1');
INSERT INTO `lang_definitions` VALUES (11841, 1534, 9, '灭活脊髓灰质炎疫苗 2');
INSERT INTO `lang_definitions` VALUES (11842, 1535, 9, '灭活脊髓灰质炎疫苗 3');
INSERT INTO `lang_definitions` VALUES (11843, 1536, 9, '灭活脊髓灰质炎疫苗 4');
INSERT INTO `lang_definitions` VALUES (11844, 1537, 9, '无规律心跳');
INSERT INTO `lang_definitions` VALUES (11845, 1538, 9, '兴奋性');
INSERT INTO `lang_definitions` VALUES (11846, 1539, 9, '刺激物');
INSERT INTO `lang_definitions` VALUES (11847, 1545, 9, '发行物；争论点');
INSERT INTO `lang_definitions` VALUES (11848, 1546, 9, '发行；流出');
INSERT INTO `lang_definitions` VALUES (11849, 1547, 9, '议题');
INSERT INTO `lang_definitions` VALUES (11850, 1548, 9, '议题（受伤/医疗/过敏）');
INSERT INTO `lang_definitions` VALUES (11851, 1556, 9, '宫内节育器');
INSERT INTO `lang_definitions` VALUES (11852, 1557, 9, '静脉点滴');
INSERT INTO `lang_definitions` VALUES (11853, 1558, 9, '一月');
INSERT INTO `lang_definitions` VALUES (11854, 1559, 9, '黄疸');
INSERT INTO `lang_definitions` VALUES (11855, 1560, 9, '工作描述');
INSERT INTO `lang_definitions` VALUES (11856, 1561, 9, '工作卡');
INSERT INTO `lang_definitions` VALUES (11857, 1562, 9, '关节错位');
INSERT INTO `lang_definitions` VALUES (11858, 1563, 9, '关节疼痛');
INSERT INTO `lang_definitions` VALUES (11859, 1564, 9, '关节扭伤');
INSERT INTO `lang_definitions` VALUES (11860, 1565, 9, '七月');
INSERT INTO `lang_definitions` VALUES (11861, 1566, 9, '六月');
INSERT INTO `lang_definitions` VALUES (11862, 1568, 9, '正好是我的');
INSERT INTO `lang_definitions` VALUES (11863, 1569, 9, '调整');
INSERT INTO `lang_definitions` VALUES (11864, 1570, 9, '调整、保存');
INSERT INTO `lang_definitions` VALUES (11865, 1572, 9, '关键字');
INSERT INTO `lang_definitions` VALUES (11866, 1573, 9, '千克');
INSERT INTO `lang_definitions` VALUES (11867, 1574, 9, '千克/平方米');
INSERT INTO `lang_definitions` VALUES (11868, 1575, 9, '肾癌');
INSERT INTO `lang_definitions` VALUES (11869, 1576, 9, '肾衰竭');
INSERT INTO `lang_definitions` VALUES (11870, 1577, 9, '肾炎');
INSERT INTO `lang_definitions` VALUES (11871, 1578, 9, '肾结石');
INSERT INTO `lang_definitions` VALUES (11872, 1579, 9, '肾移植');
INSERT INTO `lang_definitions` VALUES (11873, 1580, 9, '膝盖');
INSERT INTO `lang_definitions` VALUES (11874, 1581, 9, '膝盖问题');
INSERT INTO `lang_definitions` VALUES (11875, 1582, 9, '人工膝关节');
INSERT INTO `lang_definitions` VALUES (11876, 1583, 9, '实验室');
INSERT INTO `lang_definitions` VALUES (11877, 1584, 9, '实验检查报告');
INSERT INTO `lang_definitions` VALUES (11878, 1585, 9, '标签');
INSERT INTO `lang_definitions` VALUES (11879, 1586, 9, '标签不能是空的');
INSERT INTO `lang_definitions` VALUES (11880, 1591, 9, '撕裂伤/皮肤问题');
INSERT INTO `lang_definitions` VALUES (11881, 1592, 9, '撕裂/磨损伤口');
INSERT INTO `lang_definitions` VALUES (11882, 1593, 9, '语言');
INSERT INTO `lang_definitions` VALUES (11883, 1594, 9, '语言代码');
INSERT INTO `lang_definitions` VALUES (11884, 1595, 9, '附加语言定义');
INSERT INTO `lang_definitions` VALUES (11885, 1596, 9, '语言界面工具');
INSERT INTO `lang_definitions` VALUES (11886, 1598, 9, '语言名称');
INSERT INTO `lang_definitions` VALUES (11887, 1600, 9, '最后的/上次的');
INSERT INTO `lang_definitions` VALUES (11888, 1601, 9, '上次激活日期');
INSERT INTO `lang_definitions` VALUES (11889, 1602, 9, '上次账单日期');
INSERT INTO `lang_definitions` VALUES (11890, 1604, 9, '姓');
INSERT INTO `lang_definitions` VALUES (11891, 1607, 9, '上次保存的');
INSERT INTO `lang_definitions` VALUES (11892, 1608, 9, '上次更新');
INSERT INTO `lang_definitions` VALUES (11893, 1609, 9, '上次拜访');
INSERT INTO `lang_definitions` VALUES (11894, 1611, 9, '外侧踝');
INSERT INTO `lang_definitions` VALUES (11895, 1612, 9, '外侧踝');
INSERT INTO `lang_definitions` VALUES (11896, 1623, 9, '留空格来更换密码');
INSERT INTO `lang_definitions` VALUES (11897, 1624, 9, '留消息');
INSERT INTO `lang_definitions` VALUES (11898, 1626, 9, '左侧');
INSERT INTO `lang_definitions` VALUES (11899, 1627, 9, '左耳');
INSERT INTO `lang_definitions` VALUES (11900, 1632, 9, '合法的');
INSERT INTO `lang_definitions` VALUES (11901, 1633, 9, '神话');
INSERT INTO `lang_definitions` VALUES (11902, 1634, 9, '长度');
INSERT INTO `lang_definitions` VALUES (11903, 1635, 9, '较少的个人信息');
INSERT INTO `lang_definitions` VALUES (11904, 1636, 9, '信件');
INSERT INTO `lang_definitions` VALUES (11905, 1640, 9, '紧急程度');
INSERT INTO `lang_definitions` VALUES (11906, 1641, 9, '责任');
INSERT INTO `lang_definitions` VALUES (11907, 1642, 9, '医疗责任');
INSERT INTO `lang_definitions` VALUES (11908, 1643, 9, '执照/身份证');
INSERT INTO `lang_definitions` VALUES (11909, 1644, 9, '生活方式');
INSERT INTO `lang_definitions` VALUES (11910, 1645, 9, '韧带撕裂或扭伤');
INSERT INTO `lang_definitions` VALUES (11911, 1646, 9, '事件限制');
INSERT INTO `lang_definitions` VALUES (11912, 1649, 9, '目录/名单');
INSERT INTO `lang_definitions` VALUES (11913, 1651, 9, '列表框');
INSERT INTO `lang_definitions` VALUES (11914, 1652, 9, '增加列表框');
INSERT INTO `lang_definitions` VALUES (11915, 1654, 9, '目录编辑');
INSERT INTO `lang_definitions` VALUES (11916, 1656, 9, '保险公司目录');
INSERT INTO `lang_definitions` VALUES (11917, 1659, 9, '列出目录');
INSERT INTO `lang_definitions` VALUES (11918, 1660, 9, '姓名目录');
INSERT INTO `lang_definitions` VALUES (11919, 1662, 9, '药方清单');
INSERT INTO `lang_definitions` VALUES (11920, 1663, 9, '目录');
INSERT INTO `lang_definitions` VALUES (11921, 1667, 9, '装载/负荷');
INSERT INTO `lang_definitions` VALUES (11922, 1669, 9, '地方性的/局限的');
INSERT INTO `lang_definitions` VALUES (11923, 1670, 9, '地方/位置');
INSERT INTO `lang_definitions` VALUES (11924, 1671, 9, '地点');
INSERT INTO `lang_definitions` VALUES (11925, 1672, 9, '未指定位置');
INSERT INTO `lang_definitions` VALUES (11926, 1675, 9, '登录');
INSERT INTO `lang_definitions` VALUES (11927, 1676, 9, '登录身份为');
INSERT INTO `lang_definitions` VALUES (11928, 1678, 9, '登出');
INSERT INTO `lang_definitions` VALUES (11929, 1679, 9, '登录');
INSERT INTO `lang_definitions` VALUES (11930, 1681, 9, '登出');
INSERT INTO `lang_definitions` VALUES (11931, 1683, 9, '文件夹');
INSERT INTO `lang_definitions` VALUES (11932, 1684, 9, '日志浏览器');
INSERT INTO `lang_definitions` VALUES (11933, 1685, 9, '查阅');
INSERT INTO `lang_definitions` VALUES (11934, 1686, 9, '批号');
INSERT INTO `lang_definitions` VALUES (11935, 1687, 9, '批号缺失');
INSERT INTO `lang_definitions` VALUES (11936, 1688, 9, '批量编号');
INSERT INTO `lang_definitions` VALUES (11937, 1689, 9, '低的');
INSERT INTO `lang_definitions` VALUES (11938, 1690, 9, '小腿');
INSERT INTO `lang_definitions` VALUES (11939, 1691, 9, '腰脊柱');
INSERT INTO `lang_definitions` VALUES (11940, 1692, 9, '午餐');
INSERT INTO `lang_definitions` VALUES (11941, 1694, 9, '肺癌');
INSERT INTO `lang_definitions` VALUES (11942, 1695, 9, '肺癌手术');
INSERT INTO `lang_definitions` VALUES (11943, 1698, 9, '狼疮');
INSERT INTO `lang_definitions` VALUES (11944, 1701, 9, '主要地址');
INSERT INTO `lang_definitions` VALUES (11945, 1702, 9, '修改最近的分类');
INSERT INTO `lang_definitions` VALUES (11946, 1703, 9, '确定');
INSERT INTO `lang_definitions` VALUES (11947, 1704, 9, '不舒服');
INSERT INTO `lang_definitions` VALUES (11948, 1705, 9, '男性');
INSERT INTO `lang_definitions` VALUES (11949, 1706, 9, '男性避孕套');
INSERT INTO `lang_definitions` VALUES (11950, 1707, 9, '男性输精管结扎术');
INSERT INTO `lang_definitions` VALUES (11951, 1708, 9, '乳房X线照片');
INSERT INTO `lang_definitions` VALUES (11952, 1709, 9, '管理');
INSERT INTO `lang_definitions` VALUES (11953, 1710, 9, '手动记录');
INSERT INTO `lang_definitions` VALUES (11954, 1711, 9, '制造商');
INSERT INTO `lang_definitions` VALUES (11955, 1712, 9, '三月');
INSERT INTO `lang_definitions` VALUES (11956, 1713, 9, '婚姻状况');
INSERT INTO `lang_definitions` VALUES (11957, 1714, 9, '标记为已出账单但是略过记账');
INSERT INTO `lang_definitions` VALUES (11958, 1715, 9, '标记为已清除');
INSERT INTO `lang_definitions` VALUES (11959, 1716, 9, '标记为未出账单');
INSERT INTO `lang_definitions` VALUES (11960, 1717, 9, '标记为未清除');
INSERT INTO `lang_definitions` VALUES (11961, 1718, 9, '已婚的');
INSERT INTO `lang_definitions` VALUES (11962, 1719, 9, '右侧颚骨');
INSERT INTO `lang_definitions` VALUES (11963, 1720, 9, '五月');
INSERT INTO `lang_definitions` VALUES (11964, 1722, 9, '微克');
INSERT INTO `lang_definitions` VALUES (11965, 1723, 9, '内踝');
INSERT INTO `lang_definitions` VALUES (11966, 1724, 9, '医疗补助');
INSERT INTO `lang_definitions` VALUES (11967, 1725, 9, '医学的/内科的');
INSERT INTO `lang_definitions` VALUES (11968, 1726, 9, '药物堕胎');
INSERT INTO `lang_definitions` VALUES (11969, 1727, 9, '医疗问题');
INSERT INTO `lang_definitions` VALUES (11970, 1729, 9, '医学');
INSERT INTO `lang_definitions` VALUES (11971, 1732, 9, '病史');
INSERT INTO `lang_definitions` VALUES (11972, 1733, 9, '医疗保险的B部分');
INSERT INTO `lang_definitions` VALUES (11973, 1734, 9, '药物');
INSERT INTO `lang_definitions` VALUES (11974, 1737, 9, '内科');
INSERT INTO `lang_definitions` VALUES (11975, 1738, 9, '媒体');
INSERT INTO `lang_definitions` VALUES (11976, 1739, 9, '会员协会数据报告');
INSERT INTO `lang_definitions` VALUES (11977, 1740, 9, '记忆问题');
INSERT INTO `lang_definitions` VALUES (11978, 1741, 9, '男性');
INSERT INTO `lang_definitions` VALUES (11979, 1742, 9, '男性和女性');
INSERT INTO `lang_definitions` VALUES (11980, 1743, 9, '只有男性');
INSERT INTO `lang_definitions` VALUES (11981, 1744, 9, '月经初潮');
INSERT INTO `lang_definitions` VALUES (11982, 1745, 9, '停经期，更年期');
INSERT INTO `lang_definitions` VALUES (11983, 1746, 9, '月经');
INSERT INTO `lang_definitions` VALUES (11984, 1747, 9, '月经频率');
INSERT INTO `lang_definitions` VALUES (11985, 1748, 9, '心理疾病');
INSERT INTO `lang_definitions` VALUES (11986, 1749, 9, '消息');
INSERT INTO `lang_definitions` VALUES (11987, 1750, 9, '消息');
INSERT INTO `lang_definitions` VALUES (11988, 1751, 9, '方法');
INSERT INTO `lang_definitions` VALUES (11989, 1752, 9, '破坏性方法');
INSERT INTO `lang_definitions` VALUES (11990, 1753, 9, '毫克');
INSERT INTO `lang_definitions` VALUES (11991, 1754, 9, '毫克/1立方厘米');
INSERT INTO `lang_definitions` VALUES (11992, 1755, 9, '毫克/2立方厘米');
INSERT INTO `lang_definitions` VALUES (11993, 1756, 9, '毫克/3立方厘米');
INSERT INTO `lang_definitions` VALUES (11994, 1757, 9, '毫克/4立方厘米');
INSERT INTO `lang_definitions` VALUES (11995, 1758, 9, '毫克/5立方厘');
INSERT INTO `lang_definitions` VALUES (11996, 1759, 9, '中间');
INSERT INTO `lang_definitions` VALUES (11997, 1760, 9, '名和姓之间的名字');
INSERT INTO `lang_definitions` VALUES (11998, 2681, 9, '应该类似于nnnnn-nnnn-nn');
INSERT INTO `lang_definitions` VALUES (11999, 2682, 9, '肩膀');
INSERT INTO `lang_definitions` VALUES (12000, 2683, 9, '肩膀加锁骨');
INSERT INTO `lang_definitions` VALUES (12001, 2684, 9, '肩膀问题');
INSERT INTO `lang_definitions` VALUES (12002, 2685, 9, '显示');
INSERT INTO `lang_definitions` VALUES (12003, 2686, 9, '显示为正忙');
INSERT INTO `lang_definitions` VALUES (12004, 2713, 9, '皮肤');
INSERT INTO `lang_definitions` VALUES (12005, 2719, 9, '睡眠模式');
INSERT INTO `lang_definitions` VALUES (12006, 2720, 9, '睡美人');
INSERT INTO `lang_definitions` VALUES (12007, 2721, 9, '斯洛伐克文');
INSERT INTO `lang_definitions` VALUES (12008, 2722, 9, '钐债务W / O型');
INSERT INTO `lang_definitions` VALUES (12009, 2723, 9, 'Smarty缓存已被清除');
INSERT INTO `lang_definitions` VALUES (12010, 2724, 9, '短信网关');
INSERT INTO `lang_definitions` VALUES (12011, 2725, 9, '短信网关API密钥');
INSERT INTO `lang_definitions` VALUES (12012, 2726, 9, 'SMS通知');
INSERT INTO `lang_definitions` VALUES (12013, 2727, 9, '发送短信之前');
INSERT INTO `lang_definitions` VALUES (12014, 2728, 9, '短信，可用标签： ***姓名*** ， ***供应商*** ， ***日期*** ， *** STARTTIME *** ， *** *** <br>即ENDTIME亲爱的***姓名***');
INSERT INTO `lang_definitions` VALUES (12015, 2729, 9, '短信/电子邮件警报设置');
INSERT INTO `lang_definitions` VALUES (12016, 2733, 9, '社会史：');
INSERT INTO `lang_definitions` VALUES (12017, 2735, 9, '解决方案');
INSERT INTO `lang_definitions` VALUES (12018, 2737, 9, '一些授权是不显示的。点击这里查看所有');
INSERT INTO `lang_definitions` VALUES (12019, 2738, 9, '一些代码不显示的。');
INSERT INTO `lang_definitions` VALUES (12020, 2739, 9, '有些遇到没有显示出来。点击这里查看所有。');
INSERT INTO `lang_definitions` VALUES (12021, 2741, 9, '一些话');
INSERT INTO `lang_definitions` VALUES (12022, 2743, 9, '排序方式');
INSERT INTO `lang_definitions` VALUES (12023, 2751, 9, '来源');
INSERT INTO `lang_definitions` VALUES (12024, 2752, 9, '源代码是失踪');
INSERT INTO `lang_definitions` VALUES (12025, 2753, 9, '来源：');
INSERT INTO `lang_definitions` VALUES (12026, 2754, 9, '西班牙语');
INSERT INTO `lang_definitions` VALUES (12027, 2756, 9, '专业');
INSERT INTO `lang_definitions` VALUES (12028, 2758, 9, '专业：');
INSERT INTO `lang_definitions` VALUES (12029, 2759, 9, '具体');
INSERT INTO `lang_definitions` VALUES (12030, 2760, 9, '具体服务');
INSERT INTO `lang_definitions` VALUES (12031, 2761, 9, '语音听写');
INSERT INTO `lang_definitions` VALUES (12032, 2762, 9, 'Spermicides');
INSERT INTO `lang_definitions` VALUES (12033, 2763, 9, '脾切除术');
INSERT INTO `lang_definitions` VALUES (12034, 2764, 9, '配偶');
INSERT INTO `lang_definitions` VALUES (12035, 2766, 9, '痰：');
INSERT INTO `lang_definitions` VALUES (12036, 2767, 9, '倚强');
INSERT INTO `lang_definitions` VALUES (12037, 2768, 9, '队');
INSERT INTO `lang_definitions` VALUES (12038, 2770, 9, '队');
INSERT INTO `lang_definitions` VALUES (12039, 2772, 9, '性健康和生殖健康-计划生育');
INSERT INTO `lang_definitions` VALUES (12040, 2773, 9, '非计划生育生殖健康');
INSERT INTO `lang_definitions` VALUES (12041, 2774, 9, '性健康和生殖健康推荐');
INSERT INTO `lang_definitions` VALUES (12042, 2775, 9, '性健康和生殖健康访问表');
INSERT INTO `lang_definitions` VALUES (12043, 2776, 9, '党卫军');
INSERT INTO `lang_definitions` VALUES (12044, 2777, 9, '炙');
INSERT INTO `lang_definitions` VALUES (12045, 2778, 9, '稳定');
INSERT INTO `lang_definitions` VALUES (12046, 2779, 9, '标准');
INSERT INTO `lang_definitions` VALUES (12047, 2780, 9, '开始');
INSERT INTO `lang_definitions` VALUES (12048, 2781, 9, '启动（格式yyyy - mm - DD ）的：');
INSERT INTO `lang_definitions` VALUES (12049, 2782, 9, '开始日期');
INSERT INTO `lang_definitions` VALUES (12050, 2783, 9, '开始日期在这个诊所');
INSERT INTO `lang_definitions` VALUES (12051, 2784, 9, '开始日期：');
INSERT INTO `lang_definitions` VALUES (12052, 2785, 9, '起始日期：');
INSERT INTO `lang_definitions` VALUES (12053, 2786, 9, '开始时间');
INSERT INTO `lang_definitions` VALUES (12054, 2787, 9, '起始日期');
INSERT INTO `lang_definitions` VALUES (12055, 2788, 9, '统计');
INSERT INTO `lang_definitions` VALUES (12056, 2789, 9, '状态');
INSERT INTO `lang_definitions` VALUES (12057, 2791, 9, '国家/地点');
INSERT INTO `lang_definitions` VALUES (12058, 2792, 9, '国家/帕里什');
INSERT INTO `lang_definitions` VALUES (12059, 2793, 9, '统计');
INSERT INTO `lang_definitions` VALUES (12060, 2794, 9, '统计');
INSERT INTO `lang_definitions` VALUES (12061, 2795, 9, '身份');
INSERT INTO `lang_definitions` VALUES (12062, 2797, 9, '性病/艾滋病Couns');
INSERT INTO `lang_definitions` VALUES (12063, 2798, 9, '强度和空调');
INSERT INTO `lang_definitions` VALUES (12064, 2799, 9, '关节僵硬');
INSERT INTO `lang_definitions` VALUES (12065, 2801, 9, '胃痛');
INSERT INTO `lang_definitions` VALUES (12066, 2802, 9, '应变的肌肉');
INSERT INTO `lang_definitions` VALUES (12067, 2804, 9, '街');
INSERT INTO `lang_definitions` VALUES (12068, 2806, 9, '街及编号');
INSERT INTO `lang_definitions` VALUES (12069, 2807, 9, '实力');
INSERT INTO `lang_definitions` VALUES (12070, 2808, 9, '链球菌性喉炎');
INSERT INTO `lang_definitions` VALUES (12071, 2809, 9, '应力性骨折');
INSERT INTO `lang_definitions` VALUES (12072, 2810, 9, '应力测试');
INSERT INTO `lang_definitions` VALUES (12073, 2811, 9, '敲击');
INSERT INTO `lang_definitions` VALUES (12074, 2813, 9, '小计');
INSERT INTO `lang_definitions` VALUES (12075, 2814, 9, '分类');
INSERT INTO `lang_definitions` VALUES (12076, 2815, 9, '分类');
INSERT INTO `lang_definitions` VALUES (12077, 2816, 9, '皮下');
INSERT INTO `lang_definitions` VALUES (12078, 2818, 9, '舌下');
INSERT INTO `lang_definitions` VALUES (12079, 2819, 9, '舌下');
INSERT INTO `lang_definitions` VALUES (12080, 2820, 9, '提交');
INSERT INTO `lang_definitions` VALUES (12081, 2822, 9, '提交事件');
INSERT INTO `lang_definitions` VALUES (12082, 2823, 9, '提交表单');
INSERT INTO `lang_definitions` VALUES (12083, 2826, 9, '提交');
INSERT INTO `lang_definitions` VALUES (12084, 2828, 9, '用户');
INSERT INTO `lang_definitions` VALUES (12085, 2829, 9, '用户地址');
INSERT INTO `lang_definitions` VALUES (12086, 2830, 9, '用户雇主');
INSERT INTO `lang_definitions` VALUES (12087, 2831, 9, '用户雇主（东南）');
INSERT INTO `lang_definitions` VALUES (12088, 2832, 9, '用户雇主地址');
INSERT INTO `lang_definitions` VALUES (12089, 2833, 9, '用户雇主市');
INSERT INTO `lang_definitions` VALUES (12090, 2834, 9, '用户雇主国家');
INSERT INTO `lang_definitions` VALUES (12091, 2835, 9, '用户雇主国');
INSERT INTO `lang_definitions` VALUES (12092, 2836, 9, '用户雇主邮编');
INSERT INTO `lang_definitions` VALUES (12093, 2837, 9, '用户电话');
INSERT INTO `lang_definitions` VALUES (12094, 2843, 9, '用户性别');
INSERT INTO `lang_definitions` VALUES (12095, 2844, 9, '换人');
INSERT INTO `lang_definitions` VALUES (12096, 2845, 9, '替代允许');
INSERT INTO `lang_definitions` VALUES (12097, 2850, 9, '自杀');
INSERT INTO `lang_definitions` VALUES (12098, 2851, 9, '摘要');
INSERT INTO `lang_definitions` VALUES (12099, 2852, 9, '太阳');
INSERT INTO `lang_definitions` VALUES (12100, 2853, 9, '星期日');
INSERT INTO `lang_definitions` VALUES (12101, 2854, 9, 'Superbill');
INSERT INTO `lang_definitions` VALUES (12102, 2855, 9, 'Superbill码');
INSERT INTO `lang_definitions` VALUES (12103, 2857, 9, 'Superbill报告');
INSERT INTO `lang_definitions` VALUES (12104, 2861, 9, '表面类型');
INSERT INTO `lang_definitions` VALUES (12105, 2864, 9, '暂停');
INSERT INTO `lang_definitions` VALUES (12106, 2865, 9, '暂停');
INSERT INTO `lang_definitions` VALUES (12107, 2866, 9, '日期的SVC');
INSERT INTO `lang_definitions` VALUES (12108, 2867, 9, '静止无功补偿器日期：');
INSERT INTO `lang_definitions` VALUES (12109, 2868, 9, '出汗：');
INSERT INTO `lang_definitions` VALUES (12110, 2869, 9, '瑞典文');
INSERT INTO `lang_definitions` VALUES (12111, 2871, 9, '右侧溶胀');
INSERT INTO `lang_definitions` VALUES (12112, 2872, 9, '关节肿胀');
INSERT INTO `lang_definitions` VALUES (12113, 2873, 9, '淋巴结肿大');
INSERT INTO `lang_definitions` VALUES (12114, 2876, 9, '结节性滑膜炎，撞击，滑囊炎');
INSERT INTO `lang_definitions` VALUES (12115, 2877, 9, '系统');
INSERT INTO `lang_definitions` VALUES (12116, 2878, 9, 'Ť');
INSERT INTO `lang_definitions` VALUES (12117, 2879, 9, '每日三次');
INSERT INTO `lang_definitions` VALUES (12118, 2880, 9, 'T.V.');
INSERT INTO `lang_definitions` VALUES (12119, 2881, 9, '表创建失败');
INSERT INTO `lang_definitions` VALUES (12120, 2882, 9, '表更新失败');
INSERT INTO `lang_definitions` VALUES (12121, 2883, 9, '片剂');
INSERT INTO `lang_definitions` VALUES (12122, 2884, 9, '拿');
INSERT INTO `lang_definitions` VALUES (12123, 2885, 9, '持续时间较长');
INSERT INTO `lang_definitions` VALUES (12124, 2887, 9, '税');
INSERT INTO `lang_definitions` VALUES (12125, 2888, 9, '分类');
INSERT INTO `lang_definitions` VALUES (12126, 2890, 9, '小组损伤概况');
INSERT INTO `lang_definitions` VALUES (12127, 2891, 9, '小组名册');
INSERT INTO `lang_definitions` VALUES (12128, 2892, 9, '小组名册查看');
INSERT INTO `lang_definitions` VALUES (12129, 2898, 9, '模板');
INSERT INTO `lang_definitions` VALUES (12130, 2901, 9, '模板：');
INSERT INTO `lang_definitions` VALUES (12131, 2904, 9, '肌腱损伤');
INSERT INTO `lang_definitions` VALUES (12132, 2905, 9, '肌腱炎/尘埃沉着病/滑囊炎');
INSERT INTO `lang_definitions` VALUES (12133, 2906, 9, '第三纪');
INSERT INTO `lang_definitions` VALUES (12134, 2907, 9, '第三保险');
INSERT INTO `lang_definitions` VALUES (12135, 2908, 9, '第三保险数据');
INSERT INTO `lang_definitions` VALUES (12136, 2909, 9, '第三保险提供商');
INSERT INTO `lang_definitions` VALUES (12137, 2911, 9, '测试系统');
INSERT INTO `lang_definitions` VALUES (12138, 2913, 9, '文字日期');
INSERT INTO `lang_definitions` VALUES (12139, 2915, 9, '文本');
INSERT INTO `lang_definitions` VALUES (12140, 2917, 9, '文本');
INSERT INTO `lang_definitions` VALUES (12141, 2919, 9, '文本清单');
INSERT INTO `lang_definitions` VALUES (12142, 2920, 9, '谢谢您');
INSERT INTO `lang_definitions` VALUES (12143, 2921, 9, '索赔文件：');
INSERT INTO `lang_definitions` VALUES (12144, 2922, 9, '目的地形式封闭;我不能采取行动，您的选择。');
INSERT INTO `lang_definitions` VALUES (12145, 2923, 9, '事件（县）已被批准。');
INSERT INTO `lang_definitions` VALUES (12146, 2924, 9, '事件（县）已被隐藏。');
INSERT INTO `lang_definitions` VALUES (12147, 2926, 9, '以下日历事件已新增：');
INSERT INTO `lang_definitions` VALUES (12148, 2927, 9, '以下日历事件已改性：');
INSERT INTO `lang_definitions` VALUES (12149, 2929, 9, '最初的窗口发票搜索页。上方您可以输入来源（如支票号码） ，支付日期和支票的金额。的原因，来源和支付日期，让您不需要输入他们一遍一遍每一索赔。在您输入金额将减少对每张发票即给予部分付款，并希望将结束零当您完成。');
INSERT INTO `lang_definitions` VALUES (12150, 2930, 9, '标签显示给用户的形式');
INSERT INTO `lang_definitions` VALUES (12151, 2931, 9, '新的分类将是一个分类别');
INSERT INTO `lang_definitions` VALUES (12152, 2932, 9, '其余的以下信息只适用于如果您张贴手动，或者如果您正在做手工更正。');
INSERT INTO `lang_definitions` VALUES (12153, 2934, 9, '的来源和日期栏将被复制从第一页，所以通常你不需要接触这些。您可以将付款金额在收费栏，调整数额的调整栏，或两者兼而有之。您也可以按一下“宽”的权利自动计算调整值写入了剩余的费用该项目。');
INSERT INTO `lang_definitions` VALUES (12154, 2935, 9, '翻译标签，会出现在当前的形式语言');
INSERT INTO `lang_definitions` VALUES (12155, 2936, 9, '翻译标题将出现在当前的语言');
INSERT INTO `lang_definitions` VALUES (12156, 2937, 9, '翻译的语言描述在当前');
INSERT INTO `lang_definitions` VALUES (12157, 2938, 9, '在X12的文件以及由此产生的HTML输出报告的存档中的“时代”子目录主要OpenEMR安装目录。您将要提及这些档案不时。网址是');
INSERT INTO `lang_definitions` VALUES (12158, 2939, 9, '注射治疗');
INSERT INTO `lang_definitions` VALUES (12159, 2941, 9, '有错误的意见。这些概述如下。');
INSERT INTO `lang_definitions` VALUES (12160, 2942, 9, '没有新的划界案');
INSERT INTO `lang_definitions` VALUES (12161, 2947, 9, '有没有真品进入阿肯色州帐户');
INSERT INTO `lang_definitions` VALUES (12162, 2948, 9, '有没有真品入境的现金帐户');
INSERT INTO `lang_definitions` VALUES (12163, 2949, 9, '有没有真品入境的收入帐户');
INSERT INTO `lang_definitions` VALUES (12164, 2950, 9, '没有匹配的发票编号');
INSERT INTO `lang_definitions` VALUES (12165, 2951, 9, '没有匹配的发票编号=');
INSERT INTO `lang_definitions` VALUES (12166, 2952, 9, '没有任何部分进入服务编号');
INSERT INTO `lang_definitions` VALUES (12167, 2953, 9, '时发生错误处理您的请求。');
INSERT INTO `lang_definitions` VALUES (12168, 2954, 9, '增厚的权利：');
INSERT INTO `lang_definitions` VALUES (12169, 2955, 9, '大腿');
INSERT INTO `lang_definitions` VALUES (12170, 2956, 9, '大腿+腿筋');
INSERT INTO `lang_definitions` VALUES (12171, 2965, 9, '第三');
INSERT INTO `lang_definitions` VALUES (12172, 2968, 9, '此代码类型不接受关系。');
INSERT INTO `lang_definitions` VALUES (12173, 2969, 9, '这相遇');
INSERT INTO `lang_definitions` VALUES (12174, 2971, 9, '这发票号码已变更为');
INSERT INTO `lang_definitions` VALUES (12175, 2972, 9, '该模块在测试模式。该数据库将不会改变。');
INSERT INTO `lang_definitions` VALUES (12176, 2973, 9, '此模块促进有效入境EOB数据。');
INSERT INTO `lang_definitions` VALUES (12177, 2974, 9, '此页将内置包括登录页面，这样我们不必每次点击relogin 。');
INSERT INTO `lang_definitions` VALUES (12178, 2975, 9, '这个病人没有活动。');
INSERT INTO `lang_definitions` VALUES (12179, 2976, 9, '这名患者已在使用中！');
INSERT INTO `lang_definitions` VALUES (12180, 2978, 9, '这次访问，开始新的避孕药具的使用');
INSERT INTO `lang_definitions` VALUES (12181, 2980, 9, '胸椎');
INSERT INTO `lang_definitions` VALUES (12182, 2981, 9, '咽喉');
INSERT INTO `lang_definitions` VALUES (12183, 2982, 9, '咽喉癌');
INSERT INTO `lang_definitions` VALUES (12184, 2983, 9, '咽喉癌手术');
INSERT INTO `lang_definitions` VALUES (12185, 2984, 9, '血栓/中风');
INSERT INTO `lang_definitions` VALUES (12186, 2985, 9, '星期四');
INSERT INTO `lang_definitions` VALUES (12187, 2986, 9, 'Thurdsay');
INSERT INTO `lang_definitions` VALUES (12188, 2987, 9, '星期四');
INSERT INTO `lang_definitions` VALUES (12189, 2988, 9, '甲状腺正常');
INSERT INTO `lang_definitions` VALUES (12190, 2989, 9, '甲状腺问题');
INSERT INTO `lang_definitions` VALUES (12191, 2991, 9, '时间');
INSERT INTO `lang_definitions` VALUES (12192, 2992, 9, '时间增量的添加（分钟1-60 ）');
INSERT INTO `lang_definitions` VALUES (12193, 2993, 9, '时间事件');
INSERT INTO `lang_definitions` VALUES (12194, 2994, 9, '时报阵列（ ñ /解放军）');
INSERT INTO `lang_definitions` VALUES (12195, 2995, 9, '时间戳和文字');
INSERT INTO `lang_definitions` VALUES (12196, 2998, 9, '标题');
INSERT INTO `lang_definitions` VALUES (12197, 2999, 9, '第五章');
INSERT INTO `lang_definitions` VALUES (12198, 3002, 9, '商标的：');
INSERT INTO `lang_definitions` VALUES (12199, 3003, 9, '汤姆逊/ EAMs /电擦除，分机鼻子');
INSERT INTO `lang_definitions` VALUES (12200, 3004, 9, '至');
INSERT INTO `lang_definitions` VALUES (12201, 3006, 9, '至');
INSERT INTO `lang_definitions` VALUES (12202, 3007, 9, '受影响的地区');
INSERT INTO `lang_definitions` VALUES (12203, 3008, 9, '受影响的地区');
INSERT INTO `lang_definitions` VALUES (12204, 3010, 9, '类');
INSERT INTO `lang_definitions` VALUES (12205, 3012, 9, '为了copay');
INSERT INTO `lang_definitions` VALUES (12206, 3013, 9, '为了ded\'ble');
INSERT INTO `lang_definitions` VALUES (12207, 3016, 9, '按性别过滤');
INSERT INTO `lang_definitions` VALUES (12208, 3017, 9, '历史');
INSERT INTO `lang_definitions` VALUES (12209, 3018, 9, '问题');
INSERT INTO `lang_definitions` VALUES (12210, 3021, 9, '皮肤');
INSERT INTO `lang_definitions` VALUES (12211, 3022, 9, '皮肤');
INSERT INTO `lang_definitions` VALUES (12212, 3024, 9, '到：');
INSERT INTO `lang_definitions` VALUES (12213, 3025, 9, '到：');
INSERT INTO `lang_definitions` VALUES (12214, 3037, 9, '烟草');
INSERT INTO `lang_definitions` VALUES (12215, 3038, 9, '烟草使用');
INSERT INTO `lang_definitions` VALUES (12216, 3039, 9, '今天');
INSERT INTO `lang_definitions` VALUES (12217, 3041, 9, '今天的活动');
INSERT INTO `lang_definitions` VALUES (12218, 3042, 9, '扁桃体');
INSERT INTO `lang_definitions` VALUES (12219, 3043, 9, '顶端');
INSERT INTO `lang_definitions` VALUES (12220, 3044, 9, '专题');
INSERT INTO `lang_definitions` VALUES (12221, 3045, 9, '总');
INSERT INTO `lang_definitions` VALUES (12222, 3046, 9, '共计');
INSERT INTO `lang_definitions` VALUES (12223, 3047, 9, '所支付的款项总额');
INSERT INTO `lang_definitions` VALUES (12224, 3048, 9, '总费用');
INSERT INTO `lang_definitions` VALUES (12225, 3049, 9, '共计客户');
INSERT INTO `lang_definitions` VALUES (12226, 3050, 9, '共计');
INSERT INTO `lang_definitions` VALUES (12227, 3051, 9, '共计');
INSERT INTO `lang_definitions` VALUES (12228, 3052, 9, '总类');
INSERT INTO `lang_definitions` VALUES (12229, 3053, 9, '的病人总数');
INSERT INTO `lang_definitions` VALUES (12230, 3054, 9, '共计生殖健康与计划生育');
INSERT INTO `lang_definitions` VALUES (12231, 3055, 9, '总计');
INSERT INTO `lang_definitions` VALUES (12232, 3057, 9, '总计');
INSERT INTO `lang_definitions` VALUES (12233, 3058, 9, '培训类型');
INSERT INTO `lang_definitions` VALUES (12234, 3059, 9, '交易');
INSERT INTO `lang_definitions` VALUES (12235, 3061, 9, '交易');
INSERT INTO `lang_definitions` VALUES (12236, 3062, 9, '交易类型');
INSERT INTO `lang_definitions` VALUES (12237, 3063, 9, '交易');
INSERT INTO `lang_definitions` VALUES (12238, 3065, 9, '交易/推介');
INSERT INTO `lang_definitions` VALUES (12239, 3066, 9, '把这种');
INSERT INTO `lang_definitions` VALUES (12240, 3067, 9, '翻译');
INSERT INTO `lang_definitions` VALUES (12241, 3069, 9, '外伤');
INSERT INTO `lang_definitions` VALUES (12242, 3072, 9, '治疗：');
INSERT INTO `lang_definitions` VALUES (12243, 3073, 9, '治疗：');
INSERT INTO `lang_definitions` VALUES (12244, 3074, 9, 'trftime （ $ month_format ， mktime （ 0 ， 0 ， 0 ， $一， 1 ， 2000 ） ） ） ; $ month_value');
INSERT INTO `lang_definitions` VALUES (12245, 3075, 9, '触发点/隔综合征/ DOMS /抽筋');
INSERT INTO `lang_definitions` VALUES (12246, 3076, 9, '三踝');
INSERT INTO `lang_definitions` VALUES (12247, 3077, 9, '特灵[ ， \' R \'等[ ，');
INSERT INTO `lang_definitions` VALUES (12248, 3078, 9, '躯干和腹部');
INSERT INTO `lang_definitions` VALUES (12249, 3079, 9, '小勺');
INSERT INTO `lang_definitions` VALUES (12250, 3080, 9, '语音合成');
INSERT INTO `lang_definitions` VALUES (12251, 3081, 9, '结核病');
INSERT INTO `lang_definitions` VALUES (12252, 3082, 9, '星期二');
INSERT INTO `lang_definitions` VALUES (12253, 3083, 9, '星期二及星期四');
INSERT INTO `lang_definitions` VALUES (12254, 3084, 9, '星期二');
INSERT INTO `lang_definitions` VALUES (12255, 3085, 9, '肿瘤');
INSERT INTO `lang_definitions` VALUES (12256, 3086, 9, '每天两次');
INSERT INTO `lang_definitions` VALUES (12257, 3088, 9, '类型');
INSERT INTO `lang_definitions` VALUES (12258, 3089, 9, '输入或扫描病人标识符这里');
INSERT INTO `lang_definitions` VALUES (12259, 3090, 9, 'UCSMC代码提供了卡尔加里大学运动医学中心');
INSERT INTO `lang_definitions` VALUES (12260, 3091, 9, '溃疡');
INSERT INTO `lang_definitions` VALUES (12261, 3092, 9, '溃疡性结肠炎');
INSERT INTO `lang_definitions` VALUES (12262, 3093, 9, '溃疡：');
INSERT INTO `lang_definitions` VALUES (12263, 3094, 9, '未指定');
INSERT INTO `lang_definitions` VALUES (12264, 3095, 9, '未经授权的访问。');
INSERT INTO `lang_definitions` VALUES (12265, 3096, 9, '根据舌');
INSERT INTO `lang_definitions` VALUES (12266, 3098, 9, '确诊');
INSERT INTO `lang_definitions` VALUES (12267, 3099, 9, '撤消结帐');
INSERT INTO `lang_definitions` VALUES (12268, 3100, 9, '独特的客户');
INSERT INTO `lang_definitions` VALUES (12269, 3101, 9, '独特的新客户');
INSERT INTO `lang_definitions` VALUES (12270, 3102, 9, '独特的看病人');
INSERT INTO `lang_definitions` VALUES (12271, 3103, 9, '独特的看病人的报告');
INSERT INTO `lang_definitions` VALUES (12272, 3104, 9, '独特的警司');
INSERT INTO `lang_definitions` VALUES (12273, 3105, 9, '股');
INSERT INTO `lang_definitions` VALUES (12274, 3106, 9, '单位');
INSERT INTO `lang_definitions` VALUES (12275, 3107, 9, '单位');
INSERT INTO `lang_definitions` VALUES (12276, 3109, 9, '未知');
INSERT INTO `lang_definitions` VALUES (12277, 3110, 9, '未知或N /阿');
INSERT INTO `lang_definitions` VALUES (12278, 3111, 9, '无名保险公司');
INSERT INTO `lang_definitions` VALUES (12279, 3112, 9, '未注册');
INSERT INTO `lang_definitions` VALUES (12280, 3114, 9, '反选');
INSERT INTO `lang_definitions` VALUES (12281, 3116, 9, '直到');
INSERT INTO `lang_definitions` VALUES (12282, 3117, 9, '过早备案');
INSERT INTO `lang_definitions` VALUES (12283, 3118, 9, '未使用');
INSERT INTO `lang_definitions` VALUES (12284, 3119, 9, 'UOR');
INSERT INTO `lang_definitions` VALUES (12285, 3120, 9, '最多');
INSERT INTO `lang_definitions` VALUES (12286, 3121, 9, '即将到来的约会');
INSERT INTO `lang_definitions` VALUES (12287, 3122, 9, '即将举行的活动');
INSERT INTO `lang_definitions` VALUES (12288, 3123, 9, '更新');
INSERT INTO `lang_definitions` VALUES (12289, 3124, 9, '更新');
INSERT INTO `lang_definitions` VALUES (12290, 3125, 9, '更新文件');
INSERT INTO `lang_definitions` VALUES (12291, 3126, 9, '更新信息');
INSERT INTO `lang_definitions` VALUES (12292, 3131, 9, 'UPIN');
INSERT INTO `lang_definitions` VALUES (12293, 3132, 9, '上传');
INSERT INTO `lang_definitions` VALUES (12294, 3134, 9, '上传文件');
INSERT INTO `lang_definitions` VALUES (12295, 3136, 9, '上传导入文件：');
INSERT INTO `lang_definitions` VALUES (12296, 3137, 9, '上传报告');
INSERT INTO `lang_definitions` VALUES (12297, 3138, 9, '上传此文件：');
INSERT INTO `lang_definitions` VALUES (12298, 3139, 9, '经点击发票号码的“手册张贴窗口”出现。在这里您可以改变的到期日期，并注意到该发票中，选择党为谁您要留言，并选择保险的一切预期paymants已经收到。最重要的是，为每个帐单代码其中被指控，您可以输入支付和调整的信息。');
INSERT INTO `lang_definitions` VALUES (12299, 3140, 9, '经搜查后您提交了一份清单，发票。您可以点击其中的发票编号，以开放的第二个窗口，这是数据输入网页手册张贴。您也可以点击一个病人的名字如果你想进入一个注意，前方办事处的工作人员时将看到病人检查，你可以选择的发票上显示病人报表和打印这些报表。');
INSERT INTO `lang_definitions` VALUES (12300, 3141, 9, '上臂');
INSERT INTO `lang_definitions` VALUES (12301, 3148, 9, '网址');
INSERT INTO `lang_definitions` VALUES (12302, 3150, 9, '使用24小时时间格式？');
INSERT INTO `lang_definitions` VALUES (12303, 3151, 9, '使用默认值');
INSERT INTO `lang_definitions` VALUES (12304, 3152, 9, '利用国际最新的风格？');
INSERT INTO `lang_definitions` VALUES (12305, 3154, 9, '使用主题？');
INSERT INTO `lang_definitions` VALUES (12306, 3155, 9, '用户');
INSERT INTO `lang_definitions` VALUES (12307, 3156, 9, '用户管理');
INSERT INTO `lang_definitions` VALUES (12308, 3157, 9, '用户和基金管理');
INSERT INTO `lang_definitions` VALUES (12309, 3159, 9, '用户定义');
INSERT INTO `lang_definitions` VALUES (12310, 3179, 9, '用户会员资格');
INSERT INTO `lang_definitions` VALUES (12311, 3180, 9, '用户名');
INSERT INTO `lang_definitions` VALUES (12312, 3181, 9, '用户的短信网关');
INSERT INTO `lang_definitions` VALUES (12313, 3182, 9, '用户名：');
INSERT INTO `lang_definitions` VALUES (12314, 3183, 9, '用户');
INSERT INTO `lang_definitions` VALUES (12315, 3185, 9, '使用的PHP的<a href=\"http://php.net/strftime\">它将“ / 1 ”的格式');
INSERT INTO `lang_definitions` VALUES (12316, 3189, 9, '疫苗');
INSERT INTO `lang_definitions` VALUES (12317, 3190, 9, '阴道环');
INSERT INTO `lang_definitions` VALUES (12318, 3191, 9, '告别');
INSERT INTO `lang_definitions` VALUES (12319, 3194, 9, 'Var1');
INSERT INTO `lang_definitions` VALUES (12320, 3195, 9, 'Var2');
INSERT INTO `lang_definitions` VALUES (12321, 3198, 9, '静脉曲张');
INSERT INTO `lang_definitions` VALUES (12322, 3199, 9, '血管条件');
INSERT INTO `lang_definitions` VALUES (12323, 3200, 9, '血管损伤');
INSERT INTO `lang_definitions` VALUES (12324, 3201, 9, '血管外科手术');
INSERT INTO `lang_definitions` VALUES (12325, 3202, 9, '版本');
INSERT INTO `lang_definitions` VALUES (12326, 3204, 9, '退伍军人管理局计划');
INSERT INTO `lang_definitions` VALUES (12327, 3205, 9, '查看');
INSERT INTO `lang_definitions` VALUES (12328, 3207, 9, '查看过敏');
INSERT INTO `lang_definitions` VALUES (12329, 3208, 9, '查看综合病人报告');
INSERT INTO `lang_definitions` VALUES (12330, 3211, 9, '鉴于事件的弹出一个窗口？');
INSERT INTO `lang_definitions` VALUES (12331, 3216, 9, '查看：');
INSERT INTO `lang_definitions` VALUES (12332, 3217, 9, '签证');
INSERT INTO `lang_definitions` VALUES (12333, 3218, 9, '内脏损害/损伤/外科手术');
INSERT INTO `lang_definitions` VALUES (12334, 3219, 9, '访问类别：');
INSERT INTO `lang_definitions` VALUES (12335, 3220, 9, '访问日期');
INSERT INTO `lang_definitions` VALUES (12336, 3222, 9, '访问');
INSERT INTO `lang_definitions` VALUES (12337, 3223, 9, '访问');
INSERT INTO `lang_definitions` VALUES (12338, 3229, 9, 'W');
INSERT INTO `lang_definitions` VALUES (12339, 3232, 9, '等待');
INSERT INTO `lang_definitions` VALUES (12340, 3233, 9, '门市');
INSERT INTO `lang_definitions` VALUES (12341, 3234, 9, '华顿');
INSERT INTO `lang_definitions` VALUES (12342, 3237, 9, '警告：访问已创建的这个病人今天！');
INSERT INTO `lang_definitions` VALUES (12343, 3238, 9, '警告：病人的ID是不是唯一的！');
INSERT INTO `lang_definitions` VALUES (12344, 3242, 9, '网站');
INSERT INTO `lang_definitions` VALUES (12345, 3243, 9, '星期三');
INSERT INTO `lang_definitions` VALUES (12346, 3244, 9, '星期三');
INSERT INTO `lang_definitions` VALUES (12347, 3245, 9, '周');
INSERT INTO `lang_definitions` VALUES (12348, 3246, 9, '周');
INSERT INTO `lang_definitions` VALUES (12349, 3247, 9, '周视图');
INSERT INTO `lang_definitions` VALUES (12350, 3248, 9, '本周（县）');
INSERT INTO `lang_definitions` VALUES (12351, 3251, 9, '体重减轻');
INSERT INTO `lang_definitions` VALUES (12352, 3252, 9, '怎么计算？');
INSERT INTO `lang_definitions` VALUES (12353, 3253, 9, 'Wheezes ：');
INSERT INTO `lang_definitions` VALUES (12354, 3255, 9, '气喘：');
INSERT INTO `lang_definitions` VALUES (12355, 3256, 9, '凡可能相关的纸质文件扫描或发现？');
INSERT INTO `lang_definitions` VALUES (12356, 3257, 9, '鞭');
INSERT INTO `lang_definitions` VALUES (12357, 3258, 9, '谁');
INSERT INTO `lang_definitions` VALUES (12358, 3259, 9, '谁回答？');
INSERT INTO `lang_definitions` VALUES (12359, 3260, 9, '丧偶');
INSERT INTO `lang_definitions` VALUES (12360, 3264, 9, '在几个小时内');
INSERT INTO `lang_definitions` VALUES (12361, 3265, 9, '在几个小时内：');
INSERT INTO `lang_definitions` VALUES (12362, 3266, 9, '几分钟之内');
INSERT INTO `lang_definitions` VALUES (12363, 3267, 9, '几分钟之内：');
INSERT INTO `lang_definitions` VALUES (12364, 3268, 9, '没有更新');
INSERT INTO `lang_definitions` VALUES (12365, 3269, 9, '证人');
INSERT INTO `lang_definitions` VALUES (12366, 3270, 9, 'WNL');
INSERT INTO `lang_definitions` VALUES (12367, 3271, 9, '妇女');
INSERT INTO `lang_definitions` VALUES (12368, 3272, 9, '妇女只');
INSERT INTO `lang_definitions` VALUES (12369, 3273, 9, '工作');
INSERT INTO `lang_definitions` VALUES (12370, 3274, 9, 'work注意');
INSERT INTO `lang_definitions` VALUES (12371, 3275, 9, '工作电话');
INSERT INTO `lang_definitions` VALUES (12372, 3277, 9, '有关的工作？');
INSERT INTO `lang_definitions` VALUES (12373, 3279, 9, '工作/学校请注意');
INSERT INTO `lang_definitions` VALUES (12374, 3281, 9, '工人赔偿健康计划');
INSERT INTO `lang_definitions` VALUES (12375, 3283, 9, '手腕');
INSERT INTO `lang_definitions` VALUES (12376, 3284, 9, '手腕和手');
INSERT INTO `lang_definitions` VALUES (12377, 3285, 9, '手腕问题');
INSERT INTO `lang_definitions` VALUES (12378, 3287, 9, '注销');
INSERT INTO `lang_definitions` VALUES (12379, 3290, 9, 'x作废');
INSERT INTO `lang_definitions` VALUES (12380, 3291, 9, '透视');
INSERT INTO `lang_definitions` VALUES (12381, 3292, 9, 'X射线释义：');
INSERT INTO `lang_definitions` VALUES (12382, 3293, 9, 'X射线释义：');
INSERT INTO `lang_definitions` VALUES (12383, 3294, 9, 'X12只：更换索赔');
INSERT INTO `lang_definitions` VALUES (12384, 3295, 9, 'X12合作伙伴');
INSERT INTO `lang_definitions` VALUES (12385, 3296, 9, 'X12合作伙伴');
INSERT INTO `lang_definitions` VALUES (12386, 3298, 9, '年');
INSERT INTO `lang_definitions` VALUES (12387, 3299, 9, '年');
INSERT INTO `lang_definitions` VALUES (12388, 3300, 9, '今年查看');
INSERT INTO `lang_definitions` VALUES (12389, 3301, 9, '（些）年份');
INSERT INTO `lang_definitions` VALUES (12390, 3302, 9, '是');
INSERT INTO `lang_definitions` VALUES (12391, 3303, 9, '是');
INSERT INTO `lang_definitions` VALUES (12392, 3304, 9, '是');
INSERT INTO `lang_definitions` VALUES (12393, 3305, 9, '是！');
INSERT INTO `lang_definitions` VALUES (12394, 3308, 9, '是：');
INSERT INTO `lang_definitions` VALUES (12395, 3310, 9, '您不可以删除此活动');
INSERT INTO `lang_definitions` VALUES (12396, 3311, 9, '不允许您编辑此事件');
INSERT INTO `lang_definitions` VALUES (12397, 3312, 9, '您未获授权的。');
INSERT INTO `lang_definitions` VALUES (12398, 3316, 9, '您不能使用此功能直接。');
INSERT INTO `lang_definitions` VALUES (12399, 3317, 9, '您无法直接访问此页。');
INSERT INTO `lang_definitions` VALUES (12400, 3321, 9, '你没有选择任何行动。');
INSERT INTO `lang_definitions` VALUES (12401, 3324, 9, '您必须先选择或添加一个病人。');
INSERT INTO `lang_definitions` VALUES (12402, 3325, 9, '您必须先选择或创建一个遇到。');
INSERT INTO `lang_definitions` VALUES (12403, 3327, 9, '您应该运行此测试，如果这种说法似乎是成功的，但产生的实际索赔的文件中不包含任何数据或只有一个未完成部分的数据量，这是为了遏制。很显然与HCFA声称，因为它们是人类可读的，与X12声称这是一个更加艰难的过程，以决定是否要求妥善完成。');
INSERT INTO `lang_definitions` VALUES (12404, 3328, 9, '您的结束日期无效');
INSERT INTO `lang_definitions` VALUES (12405, 3329, 9, '您的活动已被删除。');
INSERT INTO `lang_definitions` VALUES (12406, 3330, 9, '您的活动已被修改。');
INSERT INTO `lang_definitions` VALUES (12407, 3331, 9, '您的活动已提交。');
INSERT INTO `lang_definitions` VALUES (12408, 3333, 9, '您PostCalendar配置已重置为使用默认值。');
INSERT INTO `lang_definitions` VALUES (12409, 3334, 9, '您PostCalendar配置已更新。');
INSERT INTO `lang_definitions` VALUES (12410, 3335, 9, '您的重复频率必须是整数。');
INSERT INTO `lang_definitions` VALUES (12411, 3336, 9, '您的重复频率必须至少为1 。');
INSERT INTO `lang_definitions` VALUES (12412, 3337, 9, '您的开始日期大于结束日期');
INSERT INTO `lang_definitions` VALUES (12413, 3338, 9, '您的开始日期是无效的');
INSERT INTO `lang_definitions` VALUES (12414, 3339, 9, '您提交失败。');
INSERT INTO `lang_definitions` VALUES (12415, 3340, 9, '格式yyyy - mm -日');
INSERT INTO `lang_definitions` VALUES (12416, 3341, 9, '格式yyyy - mm -日日期与此相关的文件');
INSERT INTO `lang_definitions` VALUES (12417, 3343, 9, '格式yyyy - mm -日出生日期');
INSERT INTO `lang_definitions` VALUES (12418, 3344, 9, '格式yyyy - mm -日出生日期');
INSERT INTO `lang_definitions` VALUES (12419, 3346, 9, '格式yyyy - mm -日发病日期或住院');
INSERT INTO `lang_definitions` VALUES (12420, 3347, 9, '格式yyyy - mm -日发病日期，手术或药物治疗开始');
INSERT INTO `lang_definitions` VALUES (12421, 3348, 9, '格式yyyy - mm -日之日起恢复或结尾的药物');
INSERT INTO `lang_definitions` VALUES (12422, 3349, 9, '格式yyyy - mm -日返回日期发挥');
INSERT INTO `lang_definitions` VALUES (12423, 3350, 9, '格式yyyy - mm -日送达日期');
INSERT INTO `lang_definitions` VALUES (12424, 3351, 9, '格式yyyy - mm -日本函之日起');
INSERT INTO `lang_definitions` VALUES (12425, 3352, 9, '格式yyyy - mm -日返回日期发挥');
INSERT INTO `lang_definitions` VALUES (12426, 3353, 9, '格式yyyy - mm -日文件日期');
INSERT INTO `lang_definitions` VALUES (12427, 3354, 9, '格式yyyy - mm -日活动日期或开始日期');
INSERT INTO `lang_definitions` VALUES (12428, 3355, 9, '格式yyyy - mm -日最后日期这一事件');
INSERT INTO `lang_definitions` VALUES (12429, 3357, 9, '邮编');
INSERT INTO `lang_definitions` VALUES (12430, 3358, 9, '邮编');
INSERT INTO `lang_definitions` VALUES (12431, 3359, 9, '邮编/国家：');
INSERT INTO `lang_definitions` VALUES (12432, 3360, 9, '但却是');
INSERT INTO `lang_definitions` VALUES (12433, 3361, 9, '不允许访问');
INSERT INTO `lang_definitions` VALUES (12434, 3362, 9, '你真的想删除吗');
INSERT INTO `lang_definitions` VALUES (12435, 3363, 9, '药品');
INSERT INTO `lang_definitions` VALUES (12436, 3364, 9, '邮件没有送出');
INSERT INTO `lang_definitions` VALUES (12437, 3365, 9, '从');
INSERT INTO `lang_definitions` VALUES (12438, 3366, 9, '已创建');
INSERT INTO `lang_definitions` VALUES (12439, 3367, 9, '已重新打开');
INSERT INTO `lang_definitions` VALUES (12440, 3368, 9, '历史');
INSERT INTO `lang_definitions` VALUES (12441, 3369, 9, '不是一个数字');
INSERT INTO `lang_definitions` VALUES (12442, 3370, 9, '可以重新送帐单了');
INSERT INTO `lang_definitions` VALUES (12443, 3373, 9, '医疗补助原始参考号码');
INSERT INTO `lang_definitions` VALUES (12444, 3375, 9, '没有找到');
INSERT INTO `lang_definitions` VALUES (12445, 3377, 9, '药方已达到限度');
INSERT INTO `lang_definitions` VALUES (12446, 3378, 9, '直到');
INSERT INTO `lang_definitions` VALUES (12447, 3379, 9, '更新没有成功, 不在数据库中?');
INSERT INTO `lang_definitions` VALUES (12448, 3380, 9, '被标记为只送了帐单');
INSERT INTO `lang_definitions` VALUES (12449, 3381, 9, '被成功加入队列');
INSERT INTO `lang_definitions` VALUES (12450, 3382, 9, '! 没访问就离开');
INSERT INTO `lang_definitions` VALUES (12451, 3384, 9, '\" 在公布日历的配置中是记上的');
INSERT INTO `lang_definitions` VALUES (12452, 3385, 9, '# 保险/财务问题');
INSERT INTO `lang_definitions` VALUES (12453, 3386, 9, '药片的数量');
INSERT INTO `lang_definitions` VALUES (12454, 3388, 9, '$ 已编好号');
INSERT INTO `lang_definitions` VALUES (12455, 3392, 9, '% 已取消 < 24小时');
INSERT INTO `lang_definitions` VALUES (12456, 3393, 9, '应该存在但不存在');
INSERT INTO `lang_definitions` VALUES (12457, 3398, 9, '(新病人)');
INSERT INTO `lang_definitions` VALUES (12458, 3399, 9, '(备注和授权)');
INSERT INTO `lang_definitions` VALUES (12459, 3400, 9, '(病人备注)');
INSERT INTO `lang_definitions` VALUES (12460, 3402, 9, '* 催函已备');
INSERT INTO `lang_definitions` VALUES (12461, 3403, 9, '** 请将手术移到问题');
INSERT INTO `lang_definitions` VALUES (12462, 3404, 9, '*要求的');
INSERT INTO `lang_definitions` VALUES (12463, 3405, 9, '图表展开了');
INSERT INTO `lang_definitions` VALUES (12464, 3408, 9, '1. 休息 2. 敷冰两天 3. 压紧, 脚不麻木或不显苍白色,将绑带保持好位置');
INSERT INTO `lang_definitions` VALUES (12465, 3415, 9, '三个月');
INSERT INTO `lang_definitions` VALUES (12466, 3416, 9, '每天三次');
INSERT INTO `lang_definitions` VALUES (12467, 3420, 9, '四个月');
INSERT INTO `lang_definitions` VALUES (12468, 3421, 9, '每天四次');
INSERT INTO `lang_definitions` VALUES (12469, 3424, 9, '465.9, 上呼吸道感染');
INSERT INTO `lang_definitions` VALUES (12470, 3425, 9, '466.0, 急性支气管炎 NOS');
INSERT INTO `lang_definitions` VALUES (12471, 3426, 9, '486.0, 小儿急性肺炎');
INSERT INTO `lang_definitions` VALUES (12472, 3427, 9, '491.21, 慢性阻塞性肺疾病加剧');
INSERT INTO `lang_definitions` VALUES (12473, 3428, 9, '491.8, 慢性支气管炎');
INSERT INTO `lang_definitions` VALUES (12474, 3429, 9, '493.92, 哮喘急性发作');
INSERT INTO `lang_definitions` VALUES (12475, 3430, 9, '496.0, 慢性阻塞性肺疾病');
INSERT INTO `lang_definitions` VALUES (12476, 3432, 9, '519.7, 支气管痙挛');
INSERT INTO `lang_definitions` VALUES (12477, 3434, 9, '六个月');
INSERT INTO `lang_definitions` VALUES (12478, 3436, 9, '824.0 闭合性内踝骨折');
INSERT INTO `lang_definitions` VALUES (12479, 3437, 9, '824.2 闭合性外踝骨折');
INSERT INTO `lang_definitions` VALUES (12480, 3438, 9, '824.6 闭合性三踝骨折');
INSERT INTO `lang_definitions` VALUES (12481, 3439, 9, '825.32 舟狀踝关节骨折');
INSERT INTO `lang_definitions` VALUES (12482, 3440, 9, '825.35 第五跖骨底部骨折');
INSERT INTO `lang_definitions` VALUES (12483, 3441, 9, '845.00 踝关节扭伤 NOS');
INSERT INTO `lang_definitions` VALUES (12484, 3442, 9, '845.00 踝关节三角韧带扭伤');
INSERT INTO `lang_definitions` VALUES (12485, 3443, 9, '845.02 跟骨腓侧扭伤');
INSERT INTO `lang_definitions` VALUES (12486, 3444, 9, '99212 已建立 - 简单的');
INSERT INTO `lang_definitions` VALUES (12487, 3445, 9, '99213 已建立 - 低复杂度');
INSERT INTO `lang_definitions` VALUES (12488, 3446, 9, '< 在检查室');
INSERT INTO `lang_definitions` VALUES (12489, 3447, 9, '>已结帐');
INSERT INTO `lang_definitions` VALUES (12490, 3448, 9, '? 没出现');
INSERT INTO `lang_definitions` VALUES (12491, 3449, 9, '@ 已到达');
INSERT INTO `lang_definitions` VALUES (12492, 3450, 9, '[转换显示]');
INSERT INTO `lang_definitions` VALUES (12493, 3451, 9, '[上一次看诊的日期]');
INSERT INTO `lang_definitions` VALUES (12494, 3452, 9, '[离上一次看诊的天数]');
INSERT INTO `lang_definitions` VALUES (12495, 3455, 9, '[不推荐]');
INSERT INTO `lang_definitions` VALUES (12496, 3456, 9, '[看诊的次数]');
INSERT INTO `lang_definitions` VALUES (12497, 3457, 9, '[报告]');
INSERT INTO `lang_definitions` VALUES (12498, 3458, 9, '[选择所有]');
INSERT INTO `lang_definitions` VALUES (12499, 3460, 9, '[开始批量处理]');
INSERT INTO `lang_definitions` VALUES (12500, 3461, 9, '[查看记录]');
INSERT INTO `lang_definitions` VALUES (12501, 3462, 9, '[查看可打印的报告]');
INSERT INTO `lang_definitions` VALUES (12502, 2, 10, 'Проверка номера или требований для идентификации оплаты');
INSERT INTO `lang_definitions` VALUES (12503, 4, 10, 'Требуется лучший номер.');
INSERT INTO `lang_definitions` VALUES (12504, 5, 10, 'Связанный IPPF код требуется.');
INSERT INTO `lang_definitions` VALUES (12505, 6, 10, 'Уникальное значение, определяющее это поле не видимо для пользователя. ');
INSERT INTO `lang_definitions` VALUES (12506, 30, 10, 'Управление конролем');
INSERT INTO `lang_definitions` VALUES (12507, 31, 10, 'Управление списком контроля доступа (ACL) ');
INSERT INTO `lang_definitions` VALUES (12508, 35, 10, 'ACL');
INSERT INTO `lang_definitions` VALUES (12509, 37, 10, 'ACL управление не разрешено.');
INSERT INTO `lang_definitions` VALUES (12510, 41, 10, 'Активный');
INSERT INTO `lang_definitions` VALUES (12511, 42, 10, 'Активная встреча ');
INSERT INTO `lang_definitions` VALUES (12512, 44, 10, 'Активный пациент');
INSERT INTO `lang_definitions` VALUES (12513, 45, 10, 'Активный тип');
INSERT INTO `lang_definitions` VALUES (12514, 47, 10, 'Добавить');
INSERT INTO `lang_definitions` VALUES (12515, 49, 10, 'Добавить Компанию ');
INSERT INTO `lang_definitions` VALUES (12516, 50, 10, 'Добавить Аптеку');
INSERT INTO `lang_definitions` VALUES (12517, 51, 10, 'Добавить событие для ');
INSERT INTO `lang_definitions` VALUES (12518, 53, 10, 'Добавить как Новая');
INSERT INTO `lang_definitions` VALUES (12519, 54, 10, 'Добавить Категорию');
INSERT INTO `lang_definitions` VALUES (12520, 55, 10, 'Добавить Константу');
INSERT INTO `lang_definitions` VALUES (12521, 56, 10, 'Добавить Оплату Пациента ');
INSERT INTO `lang_definitions` VALUES (12522, 57, 10, 'Добавить Лекарство');
INSERT INTO `lang_definitions` VALUES (12523, 61, 10, 'Добавить Группу ');
INSERT INTO `lang_definitions` VALUES (12524, 62, 10, 'Добавить ICD Код');
INSERT INTO `lang_definitions` VALUES (12525, 63, 10, 'Добавить Выпуск');
INSERT INTO `lang_definitions` VALUES (12526, 64, 10, 'Добавить Язык ');
INSERT INTO `lang_definitions` VALUES (12527, 65, 10, 'Добавить Новая');
INSERT INTO `lang_definitions` VALUES (12528, 66, 10, 'Добавить новую категорию');
INSERT INTO `lang_definitions` VALUES (12529, 67, 10, 'Добавить Новую Группу');
INSERT INTO `lang_definitions` VALUES (12530, 68, 10, 'Добавить Новую Запись');
INSERT INTO `lang_definitions` VALUES (12531, 69, 10, 'Добавить новую записку');
INSERT INTO `lang_definitions` VALUES (12532, 70, 10, 'Добавить Новый Партнер ');
INSERT INTO `lang_definitions` VALUES (12533, 71, 10, 'Добавить Запись');
INSERT INTO `lang_definitions` VALUES (12534, 72, 10, 'Добавить Запись Пациента');
INSERT INTO `lang_definitions` VALUES (12535, 73, 10, 'Добавить Рецепт');
INSERT INTO `lang_definitions` VALUES (12536, 75, 10, 'Добавить к Списку Лекарст');
INSERT INTO `lang_definitions` VALUES (12537, 77, 10, 'Добавить Пользователя');
INSERT INTO `lang_definitions` VALUES (12538, 78, 10, 'Добавить Пользователя к Группе');
INSERT INTO `lang_definitions` VALUES (12539, 81, 10, 'Синдром Эддисона');
INSERT INTO `lang_definitions` VALUES (12540, 82, 10, 'Синдром Эддисона');
INSERT INTO `lang_definitions` VALUES (12541, 83, 10, 'Дополнительный Диагноз:');
INSERT INTO `lang_definitions` VALUES (12542, 94, 10, 'Адресная Книга');
INSERT INTO `lang_definitions` VALUES (12543, 95, 10, 'Адрес');
INSERT INTO `lang_definitions` VALUES (12544, 96, 10, 'Адресная Книга');
INSERT INTO `lang_definitions` VALUES (12545, 97, 10, 'Адрес 1');
INSERT INTO `lang_definitions` VALUES (12546, 98, 10, 'Адрес 2');
INSERT INTO `lang_definitions` VALUES (12547, 119, 10, 'Опять');
INSERT INTO `lang_definitions` VALUES (12548, 120, 10, 'Возраст');
INSERT INTO `lang_definitions` VALUES (12549, 121, 10, 'Возраст');
INSERT INTO `lang_definitions` VALUES (12550, 122, 10, 'Категория Возраста');
INSERT INTO `lang_definitions` VALUES (12551, 139, 10, 'Все Разделы');
INSERT INTO `lang_definitions` VALUES (12552, 140, 10, 'Все Пользователи');
INSERT INTO `lang_definitions` VALUES (12553, 142, 10, 'Аллергии');
INSERT INTO `lang_definitions` VALUES (12554, 143, 10, 'Аллергии:');
INSERT INTO `lang_definitions` VALUES (12555, 145, 10, 'Разрешать Email');
INSERT INTO `lang_definitions` VALUES (12556, 148, 10, 'Разрешать Почтовое Извещение');
INSERT INTO `lang_definitions` VALUES (12557, 3360, 10, 'но было');
INSERT INTO `lang_definitions` VALUES (12558, 3361, 10, 'не может быть доступным');
INSERT INTO `lang_definitions` VALUES (12559, 3362, 10, 'Вы действительно хотите удалить.');
INSERT INTO `lang_definitions` VALUES (12560, 3363, 10, 'Лекарство.');
INSERT INTO `lang_definitions` VALUES (12561, 3364, 10, 'Электронная почта не послана.');
INSERT INTO `lang_definitions` VALUES (12562, 3365, 10, 'от');
INSERT INTO `lang_definitions` VALUES (12563, 3366, 10, 'должна быть создана.');
INSERT INTO `lang_definitions` VALUES (12564, 3367, 10, 'должна быть повторно открыта. ');
INSERT INTO `lang_definitions` VALUES (12565, 3368, 10, 'История.');
INSERT INTO `lang_definitions` VALUES (12566, 3369, 10, 'это не номер.');
INSERT INTO `lang_definitions` VALUES (12567, 3370, 10, 'готово для повторного счета.');
INSERT INTO `lang_definitions` VALUES (12568, 3372, 10, 'Доля');
INSERT INTO `lang_definitions` VALUES (12569, 3373, 10, 'Номер официальной медицинской ссылки. ');
INSERT INTO `lang_definitions` VALUES (12570, 3374, 10, 'минимум');
INSERT INTO `lang_definitions` VALUES (12571, 3375, 10, 'не найдена!');
INSERT INTO `lang_definitions` VALUES (12572, 3377, 10, 'разрешения на использования рецепта достигла лимита. ');
INSERT INTO `lang_definitions` VALUES (12573, 3378, 10, 'до');
INSERT INTO `lang_definitions` VALUES (12574, 3379, 10, 'измениния не завершились успешно, не в базе данных?');
INSERT INTO `lang_definitions` VALUES (12575, 3380, 10, 'бвло отмечено как счет. ');
INSERT INTO `lang_definitions` VALUES (12576, 3381, 10, 'было включено в очередь. ');
INSERT INTO `lang_definitions` VALUES (12577, 3382, 10, 'Я покинул без визита.');
INSERT INTO `lang_definitions` VALUES (12578, 3383, 10, '\" для кода');
INSERT INTO `lang_definitions` VALUES (12579, 3384, 10, '\" было ОТМЕЧЕНО в установке календаря.');
INSERT INTO `lang_definitions` VALUES (12580, 3388, 10, '$ Кодирование сделано');
INSERT INTO `lang_definitions` VALUES (12581, 3390, 10, '$метка времени (yyyy-mm-dd)');
INSERT INTO `lang_definitions` VALUES (12582, 3392, 10, '% Аннулировано < 24 часа');
INSERT INTO `lang_definitions` VALUES (12583, 3393, 10, 'должен существовать но не существует');
INSERT INTO `lang_definitions` VALUES (12584, 3398, 10, '(Новый пациент)');
INSERT INTO `lang_definitions` VALUES (12585, 3399, 10, '(записи и полномочия)');
INSERT INTO `lang_definitions` VALUES (12586, 3400, 10, '(Записи о пациенте)');
INSERT INTO `lang_definitions` VALUES (12587, 3402, 10, '* Напоминание сделано');
INSERT INTO `lang_definitions` VALUES (12588, 3403, 10, '** Пожалуйста оставьте волнение ');
INSERT INTO `lang_definitions` VALUES (12589, 3404, 10, '* Требуется');
INSERT INTO `lang_definitions` VALUES (12590, 3405, 10, '\"+\" Диаграмма сделана');
INSERT INTO `lang_definitions` VALUES (12591, 1, 13, 'A');
INSERT INTO `lang_definitions` VALUES (12592, 2, 13, 'Um número de cheque ou de crédito para identificar o pagamento');
INSERT INTO `lang_definitions` VALUES (12593, 3, 13, 'Um formulário GCAC deve ser acrescentado a esta visita');
INSERT INTO `lang_definitions` VALUES (12594, 4, 13, 'Um número de lote é necessário!');
INSERT INTO `lang_definitions` VALUES (12595, 5, 13, 'Um código IPPF relacionado é necessário!');
INSERT INTO `lang_definitions` VALUES (12596, 6, 13, 'Um valor único para identificar este campo, não visível para o usuário');
INSERT INTO `lang_definitions` VALUES (12597, 7, 13, 'c.a.');
INSERT INTO `lang_definitions` VALUES (12598, 8, 13, 'AM');
INSERT INTO `lang_definitions` VALUES (12599, 9, 13, 'A / F Nível Direita:');
INSERT INTO `lang_definitions` VALUES (12600, 10, 13, 'Agenda');
INSERT INTO `lang_definitions` VALUES (12601, 11, 13, 'Abreviatura');
INSERT INTO `lang_definitions` VALUES (12602, 12, 13, 'Abscesso:');
INSERT INTO `lang_definitions` VALUES (12603, 13, 13, 'Abdominal');
INSERT INTO `lang_definitions` VALUES (12604, 14, 13, 'Capaz de suportar o peso por quatro (4) passos:');
INSERT INTO `lang_definitions` VALUES (12605, 15, 13, 'ABN');
INSERT INTO `lang_definitions` VALUES (12606, 16, 13, 'ABN1');
INSERT INTO `lang_definitions` VALUES (12607, 17, 13, 'Anormal');
INSERT INTO `lang_definitions` VALUES (12608, 18, 13, 'Teste de Sangue Anormal');
INSERT INTO `lang_definitions` VALUES (12609, 19, 13, 'Crescimento anormal dos cabelos');
INSERT INTO `lang_definitions` VALUES (12610, 20, 13, 'Mamografia anormal');
INSERT INTO `lang_definitions` VALUES (12611, 21, 13, 'Aborto');
INSERT INTO `lang_definitions` VALUES (12612, 22, 13, 'Questões do Aborto');
INSERT INTO `lang_definitions` VALUES (12613, 23, 13, 'O método do aborto');
INSERT INTO `lang_definitions` VALUES (12614, 24, 13, 'Categorias Relacionadas ao Aborto');
INSERT INTO `lang_definitions` VALUES (12615, 25, 13, 'Abortos');
INSERT INTO `lang_definitions` VALUES (12616, 26, 13, 'Ausências por Diagnóstico');
INSERT INTO `lang_definitions` VALUES (12617, 27, 13, 'Aceitar Tarefa');
INSERT INTO `lang_definitions` VALUES (12618, 28, 13, 'Aceita pagamento para');
INSERT INTO `lang_definitions` VALUES (12619, 29, 13, 'Aceita Tarefa');
INSERT INTO `lang_definitions` VALUES (12620, 30, 13, 'Controle de Acesso');
INSERT INTO `lang_definitions` VALUES (12621, 31, 13, 'Controle de Acesso da Lista de Administração');
INSERT INTO `lang_definitions` VALUES (12622, 32, 13, 'Contabilidade');
INSERT INTO `lang_definitions` VALUES (12623, 33, 13, 'Dores');
INSERT INTO `lang_definitions` VALUES (12624, 35, 13, 'Acesso');
INSERT INTO `lang_definitions` VALUES (12625, 36, 13, 'Administração de Acesso');
INSERT INTO `lang_definitions` VALUES (12626, 37, 13, 'Administração de Acesso Não Autorizada');
INSERT INTO `lang_definitions` VALUES (12627, 38, 13, 'Acne');
INSERT INTO `lang_definitions` VALUES (12628, 39, 13, 'Procedimento');
INSERT INTO `lang_definitions` VALUES (12629, 40, 13, 'Data do Procedimento');
INSERT INTO `lang_definitions` VALUES (12630, 41, 13, 'Ativo');
INSERT INTO `lang_definitions` VALUES (12631, 42, 13, 'Consulta Ativa');
INSERT INTO `lang_definitions` VALUES (12632, 43, 13, 'Listas ativas');
INSERT INTO `lang_definitions` VALUES (12633, 44, 13, 'Paciente Ativo');
INSERT INTO `lang_definitions` VALUES (12634, 45, 13, 'Tipo de Atividade');
INSERT INTO `lang_definitions` VALUES (12635, 46, 13, 'Aguda sobre crônica');
INSERT INTO `lang_definitions` VALUES (12636, 47, 13, 'Adicionar');
INSERT INTO `lang_definitions` VALUES (12637, 49, 13, 'Adicionar uma Empresa');
INSERT INTO `lang_definitions` VALUES (12638, 50, 13, 'Adicionar uma Farmácia');
INSERT INTO `lang_definitions` VALUES (12639, 51, 13, 'adicionar um evento para');
INSERT INTO `lang_definitions` VALUES (12640, 52, 13, 'adicionar como uma nova nota');
INSERT INTO `lang_definitions` VALUES (12641, 53, 13, 'Adicionar como Novo');
INSERT INTO `lang_definitions` VALUES (12642, 54, 13, 'Adicionar Categoria');
INSERT INTO `lang_definitions` VALUES (12643, 55, 13, 'Adicionar Constante');
INSERT INTO `lang_definitions` VALUES (12644, 56, 13, 'Adicionar Copay');
INSERT INTO `lang_definitions` VALUES (12645, 57, 13, 'Adicionar Medicamento');
INSERT INTO `lang_definitions` VALUES (12646, 58, 13, 'Adicionar Consulta');
INSERT INTO `lang_definitions` VALUES (12647, 59, 13, 'Adicionar Clínica');
INSERT INTO `lang_definitions` VALUES (12648, 60, 13, 'Adicionar Campo');
INSERT INTO `lang_definitions` VALUES (12649, 61, 13, 'Adicionar Grupo');
INSERT INTO `lang_definitions` VALUES (12650, 62, 13, 'Adicionar Código CID');
INSERT INTO `lang_definitions` VALUES (12651, 63, 13, 'Adicionar Ocorrência');
INSERT INTO `lang_definitions` VALUES (12652, 64, 13, 'Adicionar Idioma');
INSERT INTO `lang_definitions` VALUES (12653, 65, 13, 'Adicionar Novo');
INSERT INTO `lang_definitions` VALUES (12654, 66, 13, 'Adicionar nova categoria:');
INSERT INTO `lang_definitions` VALUES (12655, 67, 13, 'Adicionar Novo Grupo');
INSERT INTO `lang_definitions` VALUES (12656, 68, 13, 'Adicionar Nova Nota');
INSERT INTO `lang_definitions` VALUES (12657, 69, 13, 'Adicionar nova nota');
INSERT INTO `lang_definitions` VALUES (12658, 70, 13, 'Adicionar Novo Parceiro');
INSERT INTO `lang_definitions` VALUES (12659, 71, 13, 'Adicionar Nota');
INSERT INTO `lang_definitions` VALUES (12660, 72, 13, 'Adicionar Registro de Paciente');
INSERT INTO `lang_definitions` VALUES (12661, 73, 13, 'Adicionar Receita');
INSERT INTO `lang_definitions` VALUES (12662, 75, 13, 'Adicionar a Lista de Medicamentos');
INSERT INTO `lang_definitions` VALUES (12663, 76, 13, 'Adicionar Transação');
INSERT INTO `lang_definitions` VALUES (12664, 77, 13, 'Adicionar Usuário');
INSERT INTO `lang_definitions` VALUES (12665, 78, 13, 'Adicionar Usuário ao Grupo');
INSERT INTO `lang_definitions` VALUES (12666, 79, 13, 'acrescentado');
INSERT INTO `lang_definitions` VALUES (12667, 80, 13, 'Adicionar dados cadastrais não é autorizado.');
INSERT INTO `lang_definitions` VALUES (12668, 81, 13, 'Síndrome de Addison');
INSERT INTO `lang_definitions` VALUES (12669, 82, 13, 'Síndrome de Addison');
INSERT INTO `lang_definitions` VALUES (12670, 83, 13, 'Diagnósticos Complementares:');
INSERT INTO `lang_definitions` VALUES (12671, 84, 13, 'Histórico Adicional');
INSERT INTO `lang_definitions` VALUES (12672, 85, 13, 'Informações adicionais do histórico');
INSERT INTO `lang_definitions` VALUES (12673, 86, 13, 'Informações Adicionais');
INSERT INTO `lang_definitions` VALUES (12674, 87, 13, 'Laboratórios Complementares');
INSERT INTO `lang_definitions` VALUES (12675, 88, 13, 'Notas Adicionais');
INSERT INTO `lang_definitions` VALUES (12676, 89, 13, 'Notas Adicionais:');
INSERT INTO `lang_definitions` VALUES (12677, 90, 13, 'Notas Adicionais:');
INSERT INTO `lang_definitions` VALUES (12678, 91, 13, 'Notas Adicionais do Raio-X:');
INSERT INTO `lang_definitions` VALUES (12679, 92, 13, 'somente adicionar');
INSERT INTO `lang_definitions` VALUES (12680, 93, 13, 'Agenda');
INSERT INTO `lang_definitions` VALUES (12681, 94, 13, 'Agenda');
INSERT INTO `lang_definitions` VALUES (12682, 95, 13, 'Endereço');
INSERT INTO `lang_definitions` VALUES (12683, 96, 13, 'Endereços');
INSERT INTO `lang_definitions` VALUES (12684, 97, 13, 'Endereço1');
INSERT INTO `lang_definitions` VALUES (12685, 98, 13, 'Endereço2');
INSERT INTO `lang_definitions` VALUES (12686, 99, 13, 'Adj');
INSERT INTO `lang_definitions` VALUES (12687, 100, 13, 'Ajuste');
INSERT INTO `lang_definitions` VALUES (12688, 101, 13, 'Razões de Ajustamento');
INSERT INTO `lang_definitions` VALUES (12689, 102, 13, 'Ajuste de valor para o código');
INSERT INTO `lang_definitions` VALUES (12690, 103, 13, 'Ajustes');
INSERT INTO `lang_definitions` VALUES (12691, 104, 13, 'Adm ajustar');
INSERT INTO `lang_definitions` VALUES (12692, 105, 13, 'Admin');
INSERT INTO `lang_definitions` VALUES (12693, 106, 13, 'Endereço de E-mail do Administrador');
INSERT INTO `lang_definitions` VALUES (12694, 107, 13, 'Administrado');
INSERT INTO `lang_definitions` VALUES (12695, 108, 13, 'Administrado Por');
INSERT INTO `lang_definitions` VALUES (12696, 109, 13, 'Administração');
INSERT INTO `lang_definitions` VALUES (12697, 110, 13, 'Administradores');
INSERT INTO `lang_definitions` VALUES (12698, 111, 13, 'Administradores podem fazer qualquer operação');
INSERT INTO `lang_definitions` VALUES (12699, 112, 13, 'Avançado');
INSERT INTO `lang_definitions` VALUES (12700, 113, 13, 'Recomendação');
INSERT INTO `lang_definitions` VALUES (12701, 114, 13, 'Afetado normal');
INSERT INTO `lang_definitions` VALUES (12702, 115, 13, 'Chamadas após hrs');
INSERT INTO `lang_definitions` VALUES (12703, 116, 13, 'Após salvar o PDF, clique em [Visualizar Log] para verificar erros.');
INSERT INTO `lang_definitions` VALUES (12704, 117, 13, 'Após salvar o seu lote, clique em [Visualizar Log] para verificar erros');
INSERT INTO `lang_definitions` VALUES (12705, 118, 13, 'Após inserir corretamente os dados, clique no botão Salvar.');
INSERT INTO `lang_definitions` VALUES (12706, 119, 13, 'Novamente');
INSERT INTO `lang_definitions` VALUES (12707, 120, 13, 'Idade');
INSERT INTO `lang_definitions` VALUES (12708, 121, 13, 'Por idade');
INSERT INTO `lang_definitions` VALUES (12709, 122, 13, 'Idade Categoria');
INSERT INTO `lang_definitions` VALUES (12710, 123, 13, 'Dados de idade está fora do intervalo.');
INSERT INTO `lang_definitions` VALUES (12711, 124, 13, 'Idade formato para \"\"idade de \"\" não é válido');
INSERT INTO `lang_definitions` VALUES (12712, 125, 13, 'Idade formato para \"\"idade para \"\" não é válido');
INSERT INTO `lang_definitions` VALUES (12713, 126, 13, 'De Idade');
INSERT INTO `lang_definitions` VALUES (12714, 127, 13, 'Colunas Envelhecimento:');
INSERT INTO `lang_definitions` VALUES (12715, 128, 13, 'Álcool');
INSERT INTO `lang_definitions` VALUES (12716, 129, 13, 'Consumo de álcool');
INSERT INTO `lang_definitions` VALUES (12717, 130, 13, 'Todos');
INSERT INTO `lang_definitions` VALUES (12718, 131, 13, 'Todas as Categorias');
INSERT INTO `lang_definitions` VALUES (12719, 132, 13, 'O Dia Inteiro');
INSERT INTO `lang_definitions` VALUES (12720, 133, 13, 'Evento durante o dia inteiro');
INSERT INTO `lang_definitions` VALUES (12721, 134, 13, 'Todas as Clínicas');
INSERT INTO `lang_definitions` VALUES (12722, 135, 13, 'Parte ou todo primeiro nome');
INSERT INTO `lang_definitions` VALUES (12723, 136, 13, 'Parte ou todo sobrenome');
INSERT INTO `lang_definitions` VALUES (12724, 137, 13, 'Todos os Médicos');
INSERT INTO `lang_definitions` VALUES (12725, 138, 13, 'Todos Opinião e negativos:');
INSERT INTO `lang_definitions` VALUES (12726, 139, 13, 'Todos os Tópicos');
INSERT INTO `lang_definitions` VALUES (12727, 140, 13, 'Todos os Médicos');
INSERT INTO `lang_definitions` VALUES (12728, 141, 13, 'Alérgica');
INSERT INTO `lang_definitions` VALUES (12729, 142, 13, 'Alergias');
INSERT INTO `lang_definitions` VALUES (12730, 143, 13, 'Alergias:');
INSERT INTO `lang_definitions` VALUES (12731, 144, 13, 'Alergia');
INSERT INTO `lang_definitions` VALUES (12732, 145, 13, 'Permitir Mala Direta');
INSERT INTO `lang_definitions` VALUES (12733, 146, 13, 'Permitir mensagens de e-mail?');
INSERT INTO `lang_definitions` VALUES (12734, 147, 13, 'Permitir Mala Direta?');
INSERT INTO `lang_definitions` VALUES (12735, 148, 13, 'Permitir Mensagem de e-mail');
INSERT INTO `lang_definitions` VALUES (12736, 149, 13, 'Permitir SMS');
INSERT INTO `lang_definitions` VALUES (12737, 150, 13, 'Permitir mensagens SMS (texto)?');
INSERT INTO `lang_definitions` VALUES (12738, 151, 13, 'Permitir que os eventos submetidos a ser feito ativo imediatamente?');
INSERT INTO `lang_definitions` VALUES (12739, 152, 13, 'Permitir mensagens de telefone?');
INSERT INTO `lang_definitions` VALUES (12740, 153, 13, 'Permitir que os usuários publiquem Eventos globais');
INSERT INTO `lang_definitions` VALUES (12741, 154, 13, 'Permitir que os usuários publiquem calendários pessoais');
INSERT INTO `lang_definitions` VALUES (12742, 155, 13, 'Permitir Correio de Voz');
INSERT INTO `lang_definitions` VALUES (12743, 156, 13, 'Permitido');
INSERT INTO `lang_definitions` VALUES (12744, 157, 13, 'Já existe.');
INSERT INTO `lang_definitions` VALUES (12745, 158, 13, 'Já utilizados, escolha outro identificador');
INSERT INTO `lang_definitions` VALUES (12746, 159, 13, 'Já usado, escolher um outro título');
INSERT INTO `lang_definitions` VALUES (12747, 160, 13, 'Alt Endereço');
INSERT INTO `lang_definitions` VALUES (12748, 162, 13, 'Alternativamente, você pode utilizar a página de pesquisa para enviar uma remessa eletrônica (X12 835 arquivos) que você tenha obtido a partir do seu autor ou câmara de compensação. Você pode fazer isso clicando no botão Procurar e selecionar o arquivo para upload, e depois clique em Procurar para realizar o upload e mostrar as faturas correspondentes. Neste caso, os outros parâmetros mencionados acima não se aplicam e serão ignorados. Uploading salva o arquivo, mas não ainda processo seu conteúdo - que é feito separadamente, como descrito abaixo.');
INSERT INTO `lang_definitions` VALUES (12749, 163, 13, 'AM');
INSERT INTO `lang_definitions` VALUES (12750, 164, 13, 'Alterar a nota existente');
INSERT INTO `lang_definitions` VALUES (12751, 165, 13, 'AMEX');
INSERT INTO `lang_definitions` VALUES (12752, 166, 13, 'Valor');
INSERT INTO `lang_definitions` VALUES (12753, 167, 13, 'Total de valores');
INSERT INTO `lang_definitions` VALUES (12754, 168, 13, 'Quantidade de passadas de balanço');
INSERT INTO `lang_definitions` VALUES (12755, 169, 13, 'Montante para esta consulta');
INSERT INTO `lang_definitions` VALUES (12756, 170, 13, 'Valor pago');
INSERT INTO `lang_definitions` VALUES (12757, 171, 13, 'Valor:');
INSERT INTO `lang_definitions` VALUES (12758, 175, 13, 'Uma questão GCAC incompleta foi criado e vinculado. Alguém terá de concluí-lo mais tarde.');
INSERT INTO `lang_definitions` VALUES (12759, 176, 13, 'E');
INSERT INTO `lang_definitions` VALUES (12760, 177, 13, 'E');
INSERT INTO `lang_definitions` VALUES (12761, 178, 13, 'e');
INSERT INTO `lang_definitions` VALUES (12762, 179, 13, 'e');
INSERT INTO `lang_definitions` VALUES (12763, 180, 13, 'e todos os dados referentes à ele? Esta ação será registrada');
INSERT INTO `lang_definitions` VALUES (12764, 181, 13, 'Anemia');
INSERT INTO `lang_definitions` VALUES (12765, 182, 13, 'Tornozelo');
INSERT INTO `lang_definitions` VALUES (12766, 183, 13, 'Tornozelo + calcanhar');
INSERT INTO `lang_definitions` VALUES (12767, 184, 13, 'Tornozelo Formulário de Avaliação');
INSERT INTO `lang_definitions` VALUES (12768, 185, 13, 'Problemas do Tornozelo');
INSERT INTO `lang_definitions` VALUES (12769, 186, 13, 'Espondilite Sondlilitis');
INSERT INTO `lang_definitions` VALUES (12770, 187, 13, 'Espondilite Spondlilitis');
INSERT INTO `lang_definitions` VALUES (12771, 188, 13, 'Anorexia');
INSERT INTO `lang_definitions` VALUES (12772, 189, 13, 'Outra coisa que você pode fazer na janela de postagem é de faturamento pedido secundário. Se você selecionar esta opção antes de salvar, em seguida, o pedido inicial será re-aberto e em fila na página de faturamento, e será processada durante a execução do próximo pagamento.');
INSERT INTO `lang_definitions` VALUES (12773, 190, 13, 'ante');
INSERT INTO `lang_definitions` VALUES (12774, 191, 13, 'Nl ânus, sem ternura retal / massa');
INSERT INTO `lang_definitions` VALUES (12775, 192, 13, 'Ansiedade');
INSERT INTO `lang_definitions` VALUES (12776, 193, 13, 'Tds');
INSERT INTO `lang_definitions` VALUES (12777, 194, 13, 'Qualquer Categoria');
INSERT INTO `lang_definitions` VALUES (12778, 195, 13, 'Qualquer parte do código desejado ou sua descrição');
INSERT INTO `lang_definitions` VALUES (12779, 196, 13, 'Qualquer parte da especialidade pretendida');
INSERT INTO `lang_definitions` VALUES (12780, 197, 13, 'Qualquer parte do nome do paciente, ou \"\"último, primeiro \"\" ou \"\"XY \"\"');
INSERT INTO `lang_definitions` VALUES (12781, 198, 13, 'Apnéia');
INSERT INTO `lang_definitions` VALUES (12782, 199, 13, 'Aparência');
INSERT INTO `lang_definitions` VALUES (12783, 200, 13, 'Aparência:');
INSERT INTO `lang_definitions` VALUES (12784, 201, 13, 'Anexar à nota existente');
INSERT INTO `lang_definitions` VALUES (12785, 202, 13, 'Acrescentar a esta nota');
INSERT INTO `lang_definitions` VALUES (12786, 203, 13, 'Acrescentar a esta nota');
INSERT INTO `lang_definitions` VALUES (12787, 204, 13, 'Apendicectomia');
INSERT INTO `lang_definitions` VALUES (12788, 206, 13, 'Aplicar a zona afetada');
INSERT INTO `lang_definitions` VALUES (12789, 207, 13, 'Aplicar na pele');
INSERT INTO `lang_definitions` VALUES (12790, 208, 13, 'Aplicando');
INSERT INTO `lang_definitions` VALUES (12791, 209, 13, 'Data Nomeação');
INSERT INTO `lang_definitions` VALUES (12792, 210, 13, 'Nomeação de status');
INSERT INTO `lang_definitions` VALUES (12793, 211, 13, 'Nomeação dentro');
INSERT INTO `lang_definitions` VALUES (12794, 212, 13, 'Nomeações');
INSERT INTO `lang_definitions` VALUES (12795, 213, 13, 'Nomeações (escrever opcional)');
INSERT INTO `lang_definitions` VALUES (12796, 214, 13, 'Nomeações e Consultas');
INSERT INTO `lang_definitions` VALUES (12797, 215, 13, 'Nomeações Relatório');
INSERT INTO `lang_definitions` VALUES (12798, 216, 13, 'Nomeações Consultas Relatório');
INSERT INTO `lang_definitions` VALUES (12799, 217, 13, 'Aprovar');
INSERT INTO `lang_definitions` VALUES (12800, 218, 13, 'Aprovado');
INSERT INTO `lang_definitions` VALUES (12801, 219, 13, 'Aprovado Eventos Administração');
INSERT INTO `lang_definitions` VALUES (12802, 220, 13, 'Consulta');
INSERT INTO `lang_definitions` VALUES (12803, 221, 13, 'Consultas');
INSERT INTO `lang_definitions` VALUES (12804, 222, 13, 'Abril');
INSERT INTO `lang_definitions` VALUES (12805, 224, 13, 'Você está preparado para completar um problema GCAC novo para essa visita?');
INSERT INTO `lang_definitions` VALUES (12806, 225, 13, 'Tem certeza que deseja aprovar esses eventos?');
INSERT INTO `lang_definitions` VALUES (12807, 226, 13, 'Você tem certeza que quer remover completamente este formulário?');
INSERT INTO `lang_definitions` VALUES (12808, 227, 13, 'Tem certeza de que deseja excluir este evento?');
INSERT INTO `lang_definitions` VALUES (12809, 229, 13, 'Tem certeza de que deseja excluir esta nota?');
INSERT INTO `lang_definitions` VALUES (12810, 230, 13, 'Tem certeza que deseja editar estes eventos?');
INSERT INTO `lang_definitions` VALUES (12811, 231, 13, 'Tem certeza que deseja ocultar estes eventos?');
INSERT INTO `lang_definitions` VALUES (12812, 232, 13, 'Você tem certeza que quer ver estes eventos?');
INSERT INTO `lang_definitions` VALUES (12813, 233, 13, 'Tem certeza de que deseja apagar todo o grupo denominado');
INSERT INTO `lang_definitions` VALUES (12814, 234, 13, 'Tem certeza de que deseja apagar toda a lista');
INSERT INTO `lang_definitions` VALUES (12815, 235, 13, 'Tem certeza de que deseja excluir o campo em');
INSERT INTO `lang_definitions` VALUES (12816, 236, 13, 'Tem certeza de que deseja apagar os campos selecionados?');
INSERT INTO `lang_definitions` VALUES (12817, 237, 13, 'Tem certeza de que deseja continuar com estas ações?');
INSERT INTO `lang_definitions` VALUES (12818, 238, 13, 'Área não especificada');
INSERT INTO `lang_definitions` VALUES (12819, 239, 13, 'Armênio');
INSERT INTO `lang_definitions` VALUES (12820, 240, 13, 'Arritmia');
INSERT INTO `lang_definitions` VALUES (12821, 241, 13, 'Artrite');
INSERT INTO `lang_definitions` VALUES (12822, 242, 13, 'Artrite / Doenças Degenerativas conjunta');
INSERT INTO `lang_definitions` VALUES (12823, 243, 13, 'Artrite / doença articular Degenerativa');
INSERT INTO `lang_definitions` VALUES (12824, 244, 13, 'como');
INSERT INTO `lang_definitions` VALUES (12825, 245, 13, 'Como De');
INSERT INTO `lang_definitions` VALUES (12826, 246, 13, 'Asiático');
INSERT INTO `lang_definitions` VALUES (12827, 247, 13, 'EFE');
INSERT INTO `lang_definitions` VALUES (12828, 248, 13, 'Atribuído a');
INSERT INTO `lang_definitions` VALUES (12829, 249, 13, 'Assistente');
INSERT INTO `lang_definitions` VALUES (12830, 250, 13, 'Asma');
INSERT INTO `lang_definitions` VALUES (12831, 251, 13, 'em');
INSERT INTO `lang_definitions` VALUES (12832, 252, 13, 'No navicular');
INSERT INTO `lang_definitions` VALUES (12833, 253, 13, 'At the navicular:');
INSERT INTO `lang_definitions` VALUES (12834, 254, 13, 'Atlético / Prejuízo');
INSERT INTO `lang_definitions` VALUES (12835, 255, 13, 'Atenção');
INSERT INTO `lang_definitions` VALUES (12836, 256, 13, 'À atenção de');
INSERT INTO `lang_definitions` VALUES (12837, 257, 13, 'Agosto');
INSERT INTO `lang_definitions` VALUES (12838, 258, 13, 'Aut.');
INSERT INTO `lang_definitions` VALUES (12839, 259, 13, 'Aut. / notas');
INSERT INTO `lang_definitions` VALUES (12840, 260, 13, 'Autorizações');
INSERT INTO `lang_definitions` VALUES (12841, 261, 13, 'Autorizar');
INSERT INTO `lang_definitions` VALUES (12842, 262, 13, 'Autorizar - quaisquer Consultas');
INSERT INTO `lang_definitions` VALUES (12843, 263, 13, 'Autorizar - minhas Consultas');
INSERT INTO `lang_definitions` VALUES (12844, 264, 13, 'Autorizado');
INSERT INTO `lang_definitions` VALUES (12845, 265, 13, 'Auto Enviar');
INSERT INTO `lang_definitions` VALUES (12846, 266, 13, 'Auto-gerar');
INSERT INTO `lang_definitions` VALUES (12847, 267, 13, 'Automóvel Médico');
INSERT INTO `lang_definitions` VALUES (12848, 268, 13, 'salvar automático');
INSERT INTO `lang_definitions` VALUES (12849, 269, 13, 'Horário Disponível');
INSERT INTO `lang_definitions` VALUES (12850, 270, 13, 'A fratura por avulsão /');
INSERT INTO `lang_definitions` VALUES (12851, 271, 13, 'Avulsão do maléolo lateral');
INSERT INTO `lang_definitions` VALUES (12852, 272, 13, 'Avulsão do maléolo medial');
INSERT INTO `lang_definitions` VALUES (12853, 273, 13, 'Conscientização-Based');
INSERT INTO `lang_definitions` VALUES (12854, 274, 13, 'Axilar');
INSERT INTO `lang_definitions` VALUES (12855, 275, 13, 'b.i.d.');
INSERT INTO `lang_definitions` VALUES (12856, 276, 13, 'voltar');
INSERT INTO `lang_definitions` VALUES (12857, 277, 13, 'Voltar');
INSERT INTO `lang_definitions` VALUES (12858, 284, 13, 'Problemas nas costas');
INSERT INTO `lang_definitions` VALUES (12859, 287, 13, 'Voltar Cirurgia');
INSERT INTO `lang_definitions` VALUES (12860, 292, 13, 'Backup');
INSERT INTO `lang_definitions` VALUES (12861, 293, 13, 'O arquivo de backup foi criado. Agora enviará o download.');
INSERT INTO `lang_definitions` VALUES (12862, 294, 13, 'Check ruim');
INSERT INTO `lang_definitions` VALUES (12863, 295, 13, 'Bad dívida');
INSERT INTO `lang_definitions` VALUES (12864, 296, 13, 'Bahasa Indonésia');
INSERT INTO `lang_definitions` VALUES (12865, 297, 13, 'Sal');
INSERT INTO `lang_definitions` VALUES (12866, 298, 13, 'Saldo');
INSERT INTO `lang_definitions` VALUES (12867, 299, 13, 'equilíbrio');
INSERT INTO `lang_definitions` VALUES (12868, 300, 13, 'Saldo devedor');
INSERT INTO `lang_definitions` VALUES (12869, 301, 13, 'Base de quinta (5) Metarsal');
INSERT INTO `lang_definitions` VALUES (12870, 302, 13, 'Base de quinta (5) Metarsal:');
INSERT INTO `lang_definitions` VALUES (12871, 303, 13, 'Lote Ferramenta de Comunicação');
INSERT INTO `lang_definitions` VALUES (12872, 304, 13, 'O processamento em lote iniciado, o que pode demorar um pouco.');
INSERT INTO `lang_definitions` VALUES (12873, 305, 13, 'BatchCom');
INSERT INTO `lang_definitions` VALUES (12874, 306, 13, 'porque esse id não existe.');
INSERT INTO `lang_definitions` VALUES (12875, 307, 13, 'Começo');
INSERT INTO `lang_definitions` VALUES (12876, 308, 13, 'Data inicial');
INSERT INTO `lang_definitions` VALUES (12877, 309, 13, 'Data de início do serviço aaaa-mm-dd');
INSERT INTO `lang_definitions` VALUES (12878, 310, 13, 'Arroto');
INSERT INTO `lang_definitions` VALUES (12879, 311, 13, 'entre');
INSERT INTO `lang_definitions` VALUES (12880, 312, 13, 'Bilateral:');
INSERT INTO `lang_definitions` VALUES (12881, 313, 13, 'Data da Conta:');
INSERT INTO `lang_definitions` VALUES (12882, 314, 13, 'Conta / Recolher');
INSERT INTO `lang_definitions` VALUES (12883, 315, 13, 'Faturado');
INSERT INTO `lang_definitions` VALUES (12884, 316, 13, 'Faturamento');
INSERT INTO `lang_definitions` VALUES (12885, 317, 13, 'Faturamento (escrever opcional)');
INSERT INTO `lang_definitions` VALUES (12886, 318, 13, 'À atenção de faturamento');
INSERT INTO `lang_definitions` VALUES (12887, 319, 13, 'Código de faturamento para os serviços solicitados');
INSERT INTO `lang_definitions` VALUES (12888, 320, 13, 'Códigos de faturamento');
INSERT INTO `lang_definitions` VALUES (12889, 321, 13, 'Informações de faturamento');
INSERT INTO `lang_definitions` VALUES (12890, 322, 13, 'Faturamento Localização');
INSERT INTO `lang_definitions` VALUES (12891, 323, 13, 'Nota de faturamento');
INSERT INTO `lang_definitions` VALUES (12892, 324, 13, 'Nota de faturamento para');
INSERT INTO `lang_definitions` VALUES (12893, 325, 13, 'Nota de faturamento');
INSERT INTO `lang_definitions` VALUES (12894, 326, 13, 'Fila resultados de faturamento');
INSERT INTO `lang_definitions` VALUES (12895, 327, 13, 'Relatório de faturamento');
INSERT INTO `lang_definitions` VALUES (12896, 328, 13, 'faturamento para');
INSERT INTO `lang_definitions` VALUES (12897, 329, 13, 'Biópsia');
INSERT INTO `lang_definitions` VALUES (12898, 330, 13, 'Data de Nascimento');
INSERT INTO `lang_definitions` VALUES (12899, 331, 13, 'Preto');
INSERT INTO `lang_definitions` VALUES (12900, 332, 13, 'Cancro da bexiga');
INSERT INTO `lang_definitions` VALUES (12901, 333, 13, 'As infecções da bexiga');
INSERT INTO `lang_definitions` VALUES (12902, 334, 13, 'Formulários em branco');
INSERT INTO `lang_definitions` VALUES (12903, 335, 13, 'Problemas de sangramento');
INSERT INTO `lang_definitions` VALUES (12904, 336, 13, 'Pontos cegos');
INSERT INTO `lang_definitions` VALUES (12905, 337, 13, 'Inchação');
INSERT INTO `lang_definitions` VALUES (12906, 338, 13, 'Bloqueados');
INSERT INTO `lang_definitions` VALUES (12907, 339, 13, 'Pressão Arterial');
INSERT INTO `lang_definitions` VALUES (12908, 340, 13, 'A pressão arterial');
INSERT INTO `lang_definitions` VALUES (12909, 341, 13, 'Nariz Ensang.');
INSERT INTO `lang_definitions` VALUES (12910, 342, 13, 'Blue Cross Blue Shield');
INSERT INTO `lang_definitions` VALUES (12911, 343, 13, 'As linhas azuis neste relatório são informativos. Linhas pretas mostram informações previamente existentes. Linhas verdes mostram as alterações que foram aplicadas com êxito. As linhas vermelhas indicam erros ou alterações que não foram aplicadas, estas deverão ser processadas manualmente. Atualmente, negou as acusações e reversões de pagamento não é feito automaticamente e assim que aparecem em vermelho.');
INSERT INTO `lang_definitions` VALUES (12912, 344, 13, 'Visão turva');
INSERT INTO `lang_definitions` VALUES (12913, 345, 13, 'IMC');
INSERT INTO `lang_definitions` VALUES (12914, 346, 13, 'IMC Status');
INSERT INTO `lang_definitions` VALUES (12915, 347, 13, 'Corpo Região');
INSERT INTO `lang_definitions` VALUES (12916, 348, 13, 'Ternura Bone:');
INSERT INTO `lang_definitions` VALUES (12917, 349, 13, 'Bone Ternura: do maléolo medial');
INSERT INTO `lang_definitions` VALUES (12918, 350, 13, 'Boolean');
INSERT INTO `lang_definitions` VALUES (12919, 351, 13, 'Inf.');
INSERT INTO `lang_definitions` VALUES (12920, 352, 13, 'Ambas as orelhas');
INSERT INTO `lang_definitions` VALUES (12921, 353, 13, 'ambas as orelhas');
INSERT INTO `lang_definitions` VALUES (12922, 354, 13, 'Fundo');
INSERT INTO `lang_definitions` VALUES (12923, 355, 13, 'BOX Emprego A. 10 relacionados');
INSERT INTO `lang_definitions` VALUES (12924, 356, 13, 'BOX 10 B. Auto Accident');
INSERT INTO `lang_definitions` VALUES (12925, 357, 13, 'BOX 10 C. Outros Acidentes');
INSERT INTO `lang_definitions` VALUES (12926, 358, 13, 'BOX 16. Data incapaz de trabalhar a partir de (aaaa-mm-dd):');
INSERT INTO `lang_definitions` VALUES (12927, 359, 13, 'BOX 16. Data incapaz de trabalhar a (aaaa-mm-dd):');
INSERT INTO `lang_definitions` VALUES (12928, 360, 13, 'BOX 18. Data de Internação (aaaa-mm-dd):');
INSERT INTO `lang_definitions` VALUES (12929, 361, 13, 'BOX 18. Data de Internação (aaaa-mm-dd):');
INSERT INTO `lang_definitions` VALUES (12930, 362, 13, 'BOX 20. Fora do laboratório é utilizado?');
INSERT INTO `lang_definitions` VALUES (12931, 363, 13, 'BOX 22. Medicaid Reapresentação Código (CID-9)');
INSERT INTO `lang_definitions` VALUES (12932, 364, 13, 'BOX 23. º Autorização prévia');
INSERT INTO `lang_definitions` VALUES (12933, 366, 13, 'PA diastólica');
INSERT INTO `lang_definitions` VALUES (12934, 367, 13, 'PA sistólica');
INSERT INTO `lang_definitions` VALUES (12935, 368, 13, 'Bpd');
INSERT INTO `lang_definitions` VALUES (12936, 369, 13, 'Bps');
INSERT INTO `lang_definitions` VALUES (12937, 370, 13, 'Português do Brasil');
INSERT INTO `lang_definitions` VALUES (12938, 371, 13, 'Mama');
INSERT INTO `lang_definitions` VALUES (12939, 372, 13, 'Biópsia de mama');
INSERT INTO `lang_definitions` VALUES (12940, 373, 13, 'Quitação de mama');
INSERT INTO `lang_definitions` VALUES (12941, 374, 13, 'Doença da Mama');
INSERT INTO `lang_definitions` VALUES (12942, 375, 13, 'Exame de Mama');
INSERT INTO `lang_definitions` VALUES (12943, 376, 13, 'Massa de mama');
INSERT INTO `lang_definitions` VALUES (12944, 377, 13, 'Respiração:');
INSERT INTO `lang_definitions` VALUES (12945, 378, 13, 'Fratura Osséa');
INSERT INTO `lang_definitions` VALUES (12946, 379, 13, 'Bronquite Forma');
INSERT INTO `lang_definitions` VALUES (12947, 380, 13, 'Navegue');
INSERT INTO `lang_definitions` VALUES (12948, 381, 13, 'Navegue para Registrar');
INSERT INTO `lang_definitions` VALUES (12949, 382, 13, 'Contusão / hematoma');
INSERT INTO `lang_definitions` VALUES (12950, 383, 13, 'Abaulamento Direita:');
INSERT INTO `lang_definitions` VALUES (12951, 384, 13, 'Ardor ao urinar');
INSERT INTO `lang_definitions` VALUES (12952, 385, 13, 'Ardor ao urinar');
INSERT INTO `lang_definitions` VALUES (12953, 386, 13, 'Ocupado');
INSERT INTO `lang_definitions` VALUES (12954, 387, 13, 'Nádega + S.I.');
INSERT INTO `lang_definitions` VALUES (12955, 388, 13, 'por');
INSERT INTO `lang_definitions` VALUES (12956, 389, 13, 'pela boca');
INSERT INTO `lang_definitions` VALUES (12957, 390, 13, 'Por / Fonte');
INSERT INTO `lang_definitions` VALUES (12958, 391, 13, 'Por:');
INSERT INTO `lang_definitions` VALUES (12959, 392, 13, 'C');
INSERT INTO `lang_definitions` VALUES (12960, 393, 13, 'Cache Lifetime (em segundos)');
INSERT INTO `lang_definitions` VALUES (12961, 394, 13, 'Cache modelo de produção?');
INSERT INTO `lang_definitions` VALUES (12962, 395, 13, 'O consumo de cafeína');
INSERT INTO `lang_definitions` VALUES (12963, 396, 13, 'Calendário');
INSERT INTO `lang_definitions` VALUES (12964, 397, 13, 'Definições do calendário');
INSERT INTO `lang_definitions` VALUES (12965, 398, 13, 'Calendário UI');
INSERT INTO `lang_definitions` VALUES (12966, 399, 13, 'Ver Calendário');
INSERT INTO `lang_definitions` VALUES (12967, 400, 13, 'Chamar a atenção para addForm () vai aqui. <br>');
INSERT INTO `lang_definitions` VALUES (12968, 402, 13, 'CAMOS');
INSERT INTO `lang_definitions` VALUES (12969, 403, 13, 'Cancelar');
INSERT INTO `lang_definitions` VALUES (12970, 404, 13, 'Câncer');
INSERT INTO `lang_definitions` VALUES (12971, 405, 13, 'Não é possível adicionar esta entrada, porque já existe!');
INSERT INTO `lang_definitions` VALUES (12972, 406, 13, 'Não é possível adicionar / atualizar esta entrada, porque já existe um duplicado!');
INSERT INTO `lang_definitions` VALUES (12973, 407, 13, 'não pode ser convertido para JPEG. Talvez ImageMagick não está instalado?');
INSERT INTO `lang_definitions` VALUES (12974, 408, 13, 'não pode ser exibido inline porque seu tipo não é suportado pelo navegador.');
INSERT INTO `lang_definitions` VALUES (12975, 409, 13, 'não pode ser exibido inline porque seu tipo não é suportado pelo browser');
INSERT INTO `lang_definitions` VALUES (12976, 410, 13, 'não pode ser exibido inline porque seu tipo não é suportado pelo navegador.');
INSERT INTO `lang_definitions` VALUES (12977, 411, 13, 'Não é possível criar');
INSERT INTO `lang_definitions` VALUES (12978, 412, 13, 'Não é possível localizar');
INSERT INTO `lang_definitions` VALUES (12979, 413, 13, 'Não é possível encontrar pacientes de SQL-Ledger ID do cliente');
INSERT INTO `lang_definitions` VALUES (12980, 414, 13, 'Não é possível encontrar referência do documento em PostScript');
INSERT INTO `lang_definitions` VALUES (12981, 415, 13, 'Não é possível encontrar fornecedor de SQL-Ledger empregado =');
INSERT INTO `lang_definitions` VALUES (12982, 416, 13, 'Não é possível abrir');
INSERT INTO `lang_definitions` VALUES (12983, 417, 13, 'Não é possível ler');
INSERT INTO `lang_definitions` VALUES (12984, 418, 13, 'Não é possível atualizar porque você não está editando uma entrada existente!');
INSERT INTO `lang_definitions` VALUES (12985, 419, 13, 'cápsula');
INSERT INTO `lang_definitions` VALUES (12986, 420, 13, 'Cateterismo Cardíaco');
INSERT INTO `lang_definitions` VALUES (12987, 421, 13, 'Remédio Cardíaco');
INSERT INTO `lang_definitions` VALUES (12988, 422, 13, 'Cardiovascular');
INSERT INTO `lang_definitions` VALUES (12989, 423, 13, 'Danos na cartilagem / condral / disco');
INSERT INTO `lang_definitions` VALUES (12990, 424, 13, 'Lesão da cartilagem');
INSERT INTO `lang_definitions` VALUES (12991, 425, 13, 'Pulsações Cartoid nl, nl dos pulsos');
INSERT INTO `lang_definitions` VALUES (12992, 426, 13, 'dinheiro');
INSERT INTO `lang_definitions` VALUES (12993, 427, 13, 'Dinheiro');
INSERT INTO `lang_definitions` VALUES (12994, 428, 13, 'Dinheiro Rec');
INSERT INTO `lang_definitions` VALUES (12995, 429, 13, 'Pagamentos Recebidos pela Operadora');
INSERT INTO `lang_definitions` VALUES (12996, 430, 13, 'Cirurgia de Catarata');
INSERT INTO `lang_definitions` VALUES (12997, 431, 13, 'Catarata');
INSERT INTO `lang_definitions` VALUES (12998, 432, 13, 'Categorias');
INSERT INTO `lang_definitions` VALUES (12999, 433, 13, 'Categoria');
INSERT INTO `lang_definitions` VALUES (13000, 434, 13, 'categoria');
INSERT INTO `lang_definitions` VALUES (13001, 435, 13, 'Categoria');
INSERT INTO `lang_definitions` VALUES (13002, 436, 13, 'Categoria Detalhes');
INSERT INTO `lang_definitions` VALUES (13003, 437, 13, 'Limites de Categoria');
INSERT INTO `lang_definitions` VALUES (13004, 438, 13, 'Nome da Categoria');
INSERT INTO `lang_definitions` VALUES (13005, 439, 13, 'Asiático');
INSERT INTO `lang_definitions` VALUES (13006, 440, 13, 'Telefone Celular');
INSERT INTO `lang_definitions` VALUES (13007, 441, 13, 'Número de Telefone Celular');
INSERT INTO `lang_definitions` VALUES (13008, 442, 13, 'Central de Certificação');
INSERT INTO `lang_definitions` VALUES (13009, 443, 13, 'cfirst($instype) . \'Ins');
INSERT INTO `lang_definitions` VALUES (13010, 444, 13, 'Mastigação');
INSERT INTO `lang_definitions` VALUES (13011, 445, 13, 'ChampUSVA');
INSERT INTO `lang_definitions` VALUES (13012, 446, 13, 'alterar');
INSERT INTO `lang_definitions` VALUES (13013, 448, 13, 'Mudança de Atividade');
INSERT INTO `lang_definitions` VALUES (13014, 449, 13, 'Mudança na visão');
INSERT INTO `lang_definitions` VALUES (13015, 450, 13, 'Mudança na visão');
INSERT INTO `lang_definitions` VALUES (13016, 451, 13, 'Mudado');
INSERT INTO `lang_definitions` VALUES (13017, 452, 13, 'Mudança Intestinal');
INSERT INTO `lang_definitions` VALUES (13018, 453, 13, 'Carregar');
INSERT INTO `lang_definitions` VALUES (13019, 454, 13, 'Charges');
INSERT INTO `lang_definitions` VALUES (13020, 455, 13, 'Gráfico');
INSERT INTO `lang_definitions` VALUES (13021, 456, 13, 'Gráfico de Atividade');
INSERT INTO `lang_definitions` VALUES (13022, 457, 13, 'Gráfico Check-in/out Relatório de Atividade');
INSERT INTO `lang_definitions` VALUES (13023, 458, 13, 'Chart ID');
INSERT INTO `lang_definitions` VALUES (13024, 459, 13, 'Chart ID:');
INSERT INTO `lang_definitions` VALUES (13025, 460, 13, 'Gráfico Local Atividade');
INSERT INTO `lang_definitions` VALUES (13026, 461, 13, 'Note Chart');
INSERT INTO `lang_definitions` VALUES (13027, 462, 13, 'Gráfico Locais de armazenamento');
INSERT INTO `lang_definitions` VALUES (13028, 463, 13, 'Gráfico Tracker');
INSERT INTO `lang_definitions` VALUES (13029, 464, 13, 'Gráfico Trk');
INSERT INTO `lang_definitions` VALUES (13030, 465, 13, 'Gráficos Check-out');
INSERT INTO `lang_definitions` VALUES (13031, 466, 13, 'Gráficos Out');
INSERT INTO `lang_definitions` VALUES (13032, 467, 13, 'verificar');
INSERT INTO `lang_definitions` VALUES (13033, 468, 13, 'Verificar');
INSERT INTO `lang_definitions` VALUES (13034, 469, 13, 'Check All');
INSERT INTO `lang_definitions` VALUES (13035, 470, 13, 'Check-in Para');
INSERT INTO `lang_definitions` VALUES (13036, 471, 13, 'Verificar dados de entrada');
INSERT INTO `lang_definitions` VALUES (13037, 472, 13, 'Verificar Número');
INSERT INTO `lang_definitions` VALUES (13038, 473, 13, 'Verificar / EOB Data:');
INSERT INTO `lang_definitions` VALUES (13039, 474, 13, 'Verificar / EOB No.:');
INSERT INTO `lang_definitions` VALUES (13040, 475, 13, 'Verificar / Número de Referência');
INSERT INTO `lang_definitions` VALUES (13041, 476, 13, 'Verificar / Número de Referência');
INSERT INTO `lang_definitions` VALUES (13042, 477, 13, 'Lista Checkbox');
INSERT INTO `lang_definitions` VALUES (13043, 478, 13, 'lista de seleção');
INSERT INTO `lang_definitions` VALUES (13044, 479, 13, 'w caixa / texto');
INSERT INTO `lang_definitions` VALUES (13045, 480, 13, 'Checkbox w / texto');
INSERT INTO `lang_definitions` VALUES (13046, 481, 13, 'Checked caixa = sim, em branco = não');
INSERT INTO `lang_definitions` VALUES (13047, 482, 13, 'Checkout');
INSERT INTO `lang_definitions` VALUES (13048, 483, 13, 'Peito');
INSERT INTO `lang_definitions` VALUES (13049, 484, 13, 'Tórax CTAB');
INSERT INTO `lang_definitions` VALUES (13050, 485, 13, 'Dor Torácica');
INSERT INTO `lang_definitions` VALUES (13051, 486, 13, 'Dor no peito:');
INSERT INTO `lang_definitions` VALUES (13052, 487, 13, 'Dores no peito');
INSERT INTO `lang_definitions` VALUES (13053, 488, 13, 'Var');
INSERT INTO `lang_definitions` VALUES (13054, 490, 13, 'Criança');
INSERT INTO `lang_definitions` VALUES (13055, 491, 13, 'Calafrios');
INSERT INTO `lang_definitions` VALUES (13056, 492, 13, 'Chinês');
INSERT INTO `lang_definitions` VALUES (13057, 493, 13, 'Escolhas');
INSERT INTO `lang_definitions` VALUES (13058, 494, 13, 'Colecistectomia');
INSERT INTO `lang_definitions` VALUES (13059, 495, 13, 'Colecistectomia');
INSERT INTO `lang_definitions` VALUES (13060, 496, 13, 'Escolher');
INSERT INTO `lang_definitions` VALUES (13061, 497, 13, 'Escolha uma seção e clique em um item dentro dela e, depois, em outra seção você verá os itens relacionados em destaque, e você pode clicar nesse ponto para adicionar e excluir relacionamentos.');
INSERT INTO `lang_definitions` VALUES (13062, 498, 13, 'Escolha lista');
INSERT INTO `lang_definitions` VALUES (13063, 500, 13, 'Bronquite crônica');
INSERT INTO `lang_definitions` VALUES (13064, 501, 13, 'Dor Crônica na Articulação');
INSERT INTO `lang_definitions` VALUES (13065, 502, 13, 'Sinovite crônica / derrame / dor nas articulações / gota');
INSERT INTO `lang_definitions` VALUES (13066, 503, 13, 'Crônica / recorrente');
INSERT INTO `lang_definitions` VALUES (13067, 504, 13, 'Cirrose do fígado');
INSERT INTO `lang_definitions` VALUES (13068, 505, 13, 'A cirrose hepática');
INSERT INTO `lang_definitions` VALUES (13069, 506, 13, 'Cidade');
INSERT INTO `lang_definitions` VALUES (13070, 507, 13, 'Nome Cidade');
INSERT INTO `lang_definitions` VALUES (13071, 508, 13, 'Cidade, Estado');
INSERT INTO `lang_definitions` VALUES (13072, 509, 13, 'Cidade, Estado CEP');
INSERT INTO `lang_definitions` VALUES (13073, 510, 13, 'Cidade / Estado');
INSERT INTO `lang_definitions` VALUES (13074, 512, 13, 'Reclamar');
INSERT INTO `lang_definitions` VALUES (13075, 513, 13, 'Reivindicação de teste estiver concluído');
INSERT INTO `lang_definitions` VALUES (13076, 514, 13, 'Reivindicação foi gerada para arquivo');
INSERT INTO `lang_definitions` VALUES (13077, 515, 13, 'Classificação');
INSERT INTO `lang_definitions` VALUES (13078, 516, 13, 'Apagar');
INSERT INTO `lang_definitions` VALUES (13079, 517, 13, 'Apagar Tudo');
INSERT INTO `lang_definitions` VALUES (13080, 518, 13, 'Limpar Justificação');
INSERT INTO `lang_definitions` VALUES (13081, 519, 13, 'Limpar Smarty Cache');
INSERT INTO `lang_definitions` VALUES (13082, 520, 13, 'Número de CLIA');
INSERT INTO `lang_definitions` VALUES (13083, 521, 13, 'Clique');
INSERT INTO `lang_definitions` VALUES (13084, 523, 13, 'clique para saber mais');
INSERT INTO `lang_definitions` VALUES (13085, 524, 13, 'Clique aqui para escolher uma data');
INSERT INTO `lang_definitions` VALUES (13086, 525, 13, 'clique aqui para atualizar prioridade, a categoria e o apelido configurações');
INSERT INTO `lang_definitions` VALUES (13087, 526, 13, 'Clique aqui para ver todos.');
INSERT INTO `lang_definitions` VALUES (13088, 527, 13, 'Clique para fazer download');
INSERT INTO `lang_definitions` VALUES (13089, 528, 13, 'Clique para editar');
INSERT INTO `lang_definitions` VALUES (13090, 529, 13, 'Clique para editar este evento');
INSERT INTO `lang_definitions` VALUES (13091, 530, 13, 'Clique para gerar o relatório');
INSERT INTO `lang_definitions` VALUES (13092, 531, 13, 'Clique para imprimir');
INSERT INTO `lang_definitions` VALUES (13093, 532, 13, 'Clique para receber (add) novo lote');
INSERT INTO `lang_definitions` VALUES (13094, 533, 13, 'Clique para selecionar');
INSERT INTO `lang_definitions` VALUES (13095, 534, 13, 'Clique para seleccionar ou alterar diagnósticos');
INSERT INTO `lang_definitions` VALUES (13096, 535, 13, 'Clique para selecionar pacientes');
INSERT INTO `lang_definitions` VALUES (13097, 536, 13, 'Clique para selecionar o código relacionado');
INSERT INTO `lang_definitions` VALUES (13098, 537, 13, 'Clique para ver');
INSERT INTO `lang_definitions` VALUES (13099, 538, 13, 'Clique aqui para visualizar ou editar');
INSERT INTO `lang_definitions` VALUES (13100, 539, 13, 'Clique para ver / editar');
INSERT INTO `lang_definitions` VALUES (13101, 540, 13, 'Clique em:');
INSERT INTO `lang_definitions` VALUES (13102, 542, 13, 'Resumo do histórico médico do paciente');
INSERT INTO `lang_definitions` VALUES (13103, 543, 13, 'Perfil do Paciente - Novos Pacientes');
INSERT INTO `lang_definitions` VALUES (13104, 544, 13, 'Perfil do Paciente- Pacientes Únicos');
INSERT INTO `lang_definitions` VALUES (13105, 545, 13, 'Pacientes');
INSERT INTO `lang_definitions` VALUES (13106, 546, 13, 'Clínica');
INSERT INTO `lang_definitions` VALUES (13107, 548, 13, 'Anotação Diária da Clínica');
INSERT INTO `lang_definitions` VALUES (13108, 549, 13, 'Clínica ID');
INSERT INTO `lang_definitions` VALUES (13109, 550, 13, 'Clínicos');
INSERT INTO `lang_definitions` VALUES (13110, 553, 13, 'Fechar');
INSERT INTO `lang_definitions` VALUES (13111, 554, 13, 'Fechar a janela');
INSERT INTO `lang_definitions` VALUES (13112, 555, 13, 'Fechado');
INSERT INTO `lang_definitions` VALUES (13113, 556, 13, 'centímetro');
INSERT INTO `lang_definitions` VALUES (13114, 558, 13, 'CMS ID');
INSERT INTO `lang_definitions` VALUES (13115, 559, 13, 'CN2-12 intactas');
INSERT INTO `lang_definitions` VALUES (13116, 560, 13, 'Código');
INSERT INTO `lang_definitions` VALUES (13117, 561, 13, 'código');
INSERT INTO `lang_definitions` VALUES (13118, 562, 13, 'Código');
INSERT INTO `lang_definitions` VALUES (13119, 563, 13, 'Código devem ser dois letra minúscula');
INSERT INTO `lang_definitions` VALUES (13120, 564, 13, 'digite o código');
INSERT INTO `lang_definitions` VALUES (13121, 565, 13, 'Códigos');
INSERT INTO `lang_definitions` VALUES (13122, 566, 13, 'Coding');
INSERT INTO `lang_definitions` VALUES (13123, 567, 13, 'Codificação - quaisquer Consultas (escrever, wsome opcional)');
INSERT INTO `lang_definitions` VALUES (13124, 568, 13, 'Coding - minhas Consultas (escrever, wsome opcional)');
INSERT INTO `lang_definitions` VALUES (13125, 569, 13, 'Codificação não autorizado');
INSERT INTO `lang_definitions` VALUES (13126, 570, 13, 'Café');
INSERT INTO `lang_definitions` VALUES (13127, 571, 13, 'Coll w / o');
INSERT INTO `lang_definitions` VALUES (13128, 572, 13, 'Recolher todas');
INSERT INTO `lang_definitions` VALUES (13129, 573, 13, 'Recolher');
INSERT INTO `lang_definitions` VALUES (13130, 574, 13, 'Recolher Relatórios');
INSERT INTO `lang_definitions` VALUES (13131, 575, 13, 'Cancro do cólon');
INSERT INTO `lang_definitions` VALUES (13132, 576, 13, 'Cirurgia de Câncer do Cólon');
INSERT INTO `lang_definitions` VALUES (13133, 577, 13, 'Colonoscopia');
INSERT INTO `lang_definitions` VALUES (13134, 578, 13, 'colonoscopia');
INSERT INTO `lang_definitions` VALUES (13135, 579, 13, 'Cor');
INSERT INTO `lang_definitions` VALUES (13136, 580, 13, 'Colunas');
INSERT INTO `lang_definitions` VALUES (13137, 581, 13, 'Comentários');
INSERT INTO `lang_definitions` VALUES (13138, 582, 13, 'Commercial Insurance Co.');
INSERT INTO `lang_definitions` VALUES (13139, 583, 13, 'Commit Changes');
INSERT INTO `lang_definitions` VALUES (13140, 584, 13, 'Comunicações');
INSERT INTO `lang_definitions` VALUES (13141, 585, 13, 'Concluído');
INSERT INTO `lang_definitions` VALUES (13142, 586, 13, 'Complicações pelo Provedor de Serviço');
INSERT INTO `lang_definitions` VALUES (13143, 587, 13, 'Complicações do Aborto');
INSERT INTO `lang_definitions` VALUES (13144, 588, 13, 'Computer Aided Médica Sistema de Pedidos');
INSERT INTO `lang_definitions` VALUES (13145, 589, 13, 'Conclusões');
INSERT INTO `lang_definitions` VALUES (13146, 590, 13, 'Congênita');
INSERT INTO `lang_definitions` VALUES (13147, 591, 13, 'Conjuntiva, os alunos');
INSERT INTO `lang_definitions` VALUES (13148, 592, 13, 'Constante');
INSERT INTO `lang_definitions` VALUES (13149, 593, 13, 'nome constante');
INSERT INTO `lang_definitions` VALUES (13150, 594, 13, 'Constantes');
INSERT INTO `lang_definitions` VALUES (13151, 595, 13, 'Constipação');
INSERT INTO `lang_definitions` VALUES (13152, 596, 13, 'Constitucional');
INSERT INTO `lang_definitions` VALUES (13153, 597, 13, 'Consulta Breve Descrição');
INSERT INTO `lang_definitions` VALUES (13154, 598, 13, 'Contato');
INSERT INTO `lang_definitions` VALUES (13155, 599, 13, 'Email para Contato');
INSERT INTO `lang_definitions` VALUES (13156, 600, 13, 'Endereço de Email para Contato');
INSERT INTO `lang_definitions` VALUES (13157, 601, 13, 'Informações de contato');
INSERT INTO `lang_definitions` VALUES (13158, 602, 13, 'Lentes de Contato');
INSERT INTO `lang_definitions` VALUES (13159, 603, 13, 'Nome de contato');
INSERT INTO `lang_definitions` VALUES (13160, 604, 13, 'Pessoa de Contato');
INSERT INTO `lang_definitions` VALUES (13161, 605, 13, 'Número de telefone');
INSERT INTO `lang_definitions` VALUES (13162, 606, 13, 'Conteúdo');
INSERT INTO `lang_definitions` VALUES (13163, 607, 13, 'conteúdo');
INSERT INTO `lang_definitions` VALUES (13164, 608, 13, 'Continue');
INSERT INTO `lang_definitions` VALUES (13165, 609, 13, 'Contra clientes');
INSERT INTO `lang_definitions` VALUES (13166, 610, 13, 'Contracepção');
INSERT INTO `lang_definitions` VALUES (13167, 611, 13, 'Questões Contracepção');
INSERT INTO `lang_definitions` VALUES (13168, 612, 13, 'Anticoncepcionais Complicação (especificar)');
INSERT INTO `lang_definitions` VALUES (13169, 613, 13, 'Método Anticoncepcional');
INSERT INTO `lang_definitions` VALUES (13170, 614, 13, 'Serviços de contracepção já começou');
INSERT INTO `lang_definitions` VALUES (13171, 615, 13, 'Contraceptivos Início');
INSERT INTO `lang_definitions` VALUES (13172, 616, 13, 'N º de Controle');
INSERT INTO `lang_definitions` VALUES (13173, 617, 13, 'Copay');
INSERT INTO `lang_definitions` VALUES (13174, 618, 13, 'Copay');
INSERT INTO `lang_definitions` VALUES (13175, 619, 13, 'Copay não positivo');
INSERT INTO `lang_definitions` VALUES (13176, 620, 13, 'Copays');
INSERT INTO `lang_definitions` VALUES (13177, 621, 13, 'DPOC');
INSERT INTO `lang_definitions` VALUES (13178, 622, 13, 'Copiar páginas para Paciente Gráfico');
INSERT INTO `lang_definitions` VALUES (13179, 623, 13, 'Copiar Valores');
INSERT INTO `lang_definitions` VALUES (13180, 624, 13, 'Direitos Autorais');
INSERT INTO `lang_definitions` VALUES (13181, 625, 13, 'Artéria Coronária Bypass');
INSERT INTO `lang_definitions` VALUES (13182, 626, 13, 'Tosse');
INSERT INTO `lang_definitions` VALUES (13183, 627, 13, 'Tosse:');
INSERT INTO `lang_definitions` VALUES (13184, 628, 13, 'Não foi possível enviar e-mail devido a um problema de servidor,');
INSERT INTO `lang_definitions` VALUES (13185, 633, 13, 'Couns pelo método');
INSERT INTO `lang_definitions` VALUES (13186, 634, 13, 'Aconselhamento');
INSERT INTO `lang_definitions` VALUES (13187, 635, 13, 'Atividades de aconselhamento');
INSERT INTO `lang_definitions` VALUES (13188, 636, 13, 'CONTADOR NO FORMULÁRIO');
INSERT INTO `lang_definitions` VALUES (13189, 637, 13, 'Contra-referência');
INSERT INTO `lang_definitions` VALUES (13190, 638, 13, 'País');
INSERT INTO `lang_definitions` VALUES (13191, 639, 13, 'Lista de Países (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (13192, 640, 13, 'país');
INSERT INTO `lang_definitions` VALUES (13193, 641, 13, 'Cupom');
INSERT INTO `lang_definitions` VALUES (13194, 642, 13, 'CPT');
INSERT INTO `lang_definitions` VALUES (13195, 643, 13, 'Códigos de CPT');
INSERT INTO `lang_definitions` VALUES (13196, 644, 13, 'Crepitações:');
INSERT INTO `lang_definitions` VALUES (13197, 645, 13, 'creme');
INSERT INTO `lang_definitions` VALUES (13198, 646, 13, 'Criar um Evento');
INSERT INTO `lang_definitions` VALUES (13199, 647, 13, 'Criar e fazer download de um backup completo');
INSERT INTO `lang_definitions` VALUES (13200, 648, 13, 'Criar backup');
INSERT INTO `lang_definitions` VALUES (13201, 649, 13, 'Criar novo paciente');
INSERT INTO `lang_definitions` VALUES (13202, 650, 13, 'Criar Paciente Nota');
INSERT INTO `lang_definitions` VALUES (13203, 651, 13, 'Criado');
INSERT INTO `lang_definitions` VALUES (13204, 652, 13, 'Criando arquivo de exportação');
INSERT INTO `lang_definitions` VALUES (13205, 653, 13, 'crédito');
INSERT INTO `lang_definitions` VALUES (13206, 654, 13, 'Créditos');
INSERT INTO `lang_definitions` VALUES (13207, 655, 13, 'Doença de Crohn');
INSERT INTO `lang_definitions` VALUES (13208, 656, 13, 'Doença de Crohn');
INSERT INTO `lang_definitions` VALUES (13209, 657, 13, 'Arquivo CSV');
INSERT INTO `lang_definitions` VALUES (13210, 658, 13, 'Atual');
INSERT INTO `lang_definitions` VALUES (13211, 659, 13, 'Atual de consulta');
INSERT INTO `lang_definitions` VALUES (13212, 660, 13, 'Cor de realce atual dias');
INSERT INTO `lang_definitions` VALUES (13213, 661, 13, 'Nome do arquivo atual foi alterado para');
INSERT INTO `lang_definitions` VALUES (13214, 662, 13, 'Current Location');
INSERT INTO `lang_definitions` VALUES (13215, 663, 13, 'Atual do paciente');
INSERT INTO `lang_definitions` VALUES (13216, 664, 13, 'Atualmente Ativo');
INSERT INTO `lang_definitions` VALUES (13217, 665, 13, 'Síndrome de Cushing');
INSERT INTO `lang_definitions` VALUES (13218, 666, 13, 'Síndrome de Cushing');
INSERT INTO `lang_definitions` VALUES (13219, 667, 13, 'Clínica');
INSERT INTO `lang_definitions` VALUES (13220, 669, 13, 'CYP');
INSERT INTO `lang_definitions` VALUES (13221, 670, 13, 'Fator CYP');
INSERT INTO `lang_definitions` VALUES (13222, 671, 13, 'CYP Relatório');
INSERT INTO `lang_definitions` VALUES (13223, 672, 13, 'D');
INSERT INTO `lang_definitions` VALUES (13224, 673, 13, 'D & C');
INSERT INTO `lang_definitions` VALUES (13225, 674, 13, 'D & E');
INSERT INTO `lang_definitions` VALUES (13226, 675, 13, 'Data Nascimento');
INSERT INTO `lang_definitions` VALUES (13227, 676, 13, 'diária');
INSERT INTO `lang_definitions` VALUES (13228, 677, 13, 'Dados Alike já está no banco de dados, por código de alteração e / ou descrição');
INSERT INTO `lang_definitions` VALUES (13229, 678, 13, 'Dados Alike já está no banco de dados, por favor mude o nome constante');
INSERT INTO `lang_definitions` VALUES (13230, 679, 13, 'Dados Cols');
INSERT INTO `lang_definitions` VALUES (13231, 680, 13, 'Tipo de dados');
INSERT INTO `lang_definitions` VALUES (13232, 681, 13, 'Banco de Dados');
INSERT INTO `lang_definitions` VALUES (13233, 682, 13, 'Banco de dados Relação');
INSERT INTO `lang_definitions` VALUES (13234, 683, 13, 'DataCols deve ser um número entre 1 e 999');
INSERT INTO `lang_definitions` VALUES (13235, 684, 13, 'Data');
INSERT INTO `lang_definitions` VALUES (13236, 685, 13, 'DATA');
INSERT INTO `lang_definitions` VALUES (13237, 686, 13, 'Data Administrado');
INSERT INTO `lang_definitions` VALUES (13238, 687, 13, 'Data de serviços contraceptivos inicialmente previsto');
INSERT INTO `lang_definitions` VALUES (13239, 688, 13, 'Data Destroyed');
INSERT INTO `lang_definitions` VALUES (13240, 689, 13, 'Formato Data');
INSERT INTO `lang_definitions` VALUES (13241, 690, 13, 'Formato de data para \"\"end nomeação \"\" não é válido');
INSERT INTO `lang_definitions` VALUES (13242, 691, 13, 'Formato de data para \"\"start nomeação \"\" não é válido');
INSERT INTO `lang_definitions` VALUES (13243, 692, 13, 'Formato de data para \"\"próximo compromisso \"\" não é válido');
INSERT INTO `lang_definitions` VALUES (13244, 693, 13, 'Formato de data para \"\"não visto desde \"\" não é válido');
INSERT INTO `lang_definitions` VALUES (13245, 694, 13, 'Formato de data para \"\"visita uma vez que \"\" não é válido');
INSERT INTO `lang_definitions` VALUES (13246, 695, 13, 'Demonstrações Data de Vacinação informações fornecidas');
INSERT INTO `lang_definitions` VALUES (13247, 696, 13, 'Data está faltando para o código');
INSERT INTO `lang_definitions` VALUES (13248, 697, 13, 'Data de depósito bancário aaaa-mm-dd');
INSERT INTO `lang_definitions` VALUES (13249, 698, 13, 'Data de Nascimento');
INSERT INTO `lang_definitions` VALUES (13250, 699, 13, 'Data de nascimento');
INSERT INTO `lang_definitions` VALUES (13251, 700, 13, 'Data de Lesão');
INSERT INTO `lang_definitions` VALUES (13252, 701, 13, 'Data de pagamento aaaa-mm-dd');
INSERT INTO `lang_definitions` VALUES (13253, 702, 13, 'Data de envio');
INSERT INTO `lang_definitions` VALUES (13254, 703, 13, 'Data da Resposta');
INSERT INTO `lang_definitions` VALUES (13255, 704, 13, 'Data do Serviço');
INSERT INTO `lang_definitions` VALUES (13256, 705, 13, 'Data de milímetro de serviço / dd / aaaa');
INSERT INTO `lang_definitions` VALUES (13257, 706, 13, 'Data do Serviço:');
INSERT INTO `lang_definitions` VALUES (13258, 707, 13, 'Data de Assinatura');
INSERT INTO `lang_definitions` VALUES (13259, 708, 13, 'Data de VIS Statement');
INSERT INTO `lang_definitions` VALUES (13260, 709, 13, 'Data / Appt');
INSERT INTO `lang_definitions` VALUES (13261, 710, 13, 'Data do Exame / Comentários');
INSERT INTO `lang_definitions` VALUES (13262, 711, 13, 'Data / Notas de Última');
INSERT INTO `lang_definitions` VALUES (13263, 712, 13, 'Data:');
INSERT INTO `lang_definitions` VALUES (13264, 713, 13, 'dia');
INSERT INTO `lang_definitions` VALUES (13265, 714, 13, 'Dia');
INSERT INTO `lang_definitions` VALUES (13266, 715, 13, 'Ver dia');
INSERT INTO `lang_definitions` VALUES (13267, 716, 13, 'Dia(s)');
INSERT INTO `lang_definitions` VALUES (13268, 717, 13, 'Dia (s) M-F');
INSERT INTO `lang_definitions` VALUES (13269, 718, 13, 'dias');
INSERT INTO `lang_definitions` VALUES (13270, 719, 13, 'Dias');
INSERT INTO `lang_definitions` VALUES (13271, 720, 13, 'Dias e Jogos Missed');
INSERT INTO `lang_definitions` VALUES (13272, 721, 13, 'Dias da última Consulta');
INSERT INTO `lang_definitions` VALUES (13273, 722, 13, 'Dias em cada coluna:');
INSERT INTO `lang_definitions` VALUES (13274, 723, 13, 'DB instalado');
INSERT INTO `lang_definitions` VALUES (13275, 724, 13, 'DEA');
INSERT INTO `lang_definitions` VALUES (13276, 725, 13, 'Informações de Depuração');
INSERT INTO `lang_definitions` VALUES (13277, 726, 13, 'Dezembro');
INSERT INTO `lang_definitions` VALUES (13278, 727, 13, 'Padrão');
INSERT INTO `lang_definitions` VALUES (13279, 728, 13, 'Vista Padrão de Calendário');
INSERT INTO `lang_definitions` VALUES (13280, 729, 13, 'Clínica padrão');
INSERT INTO `lang_definitions` VALUES (13281, 730, 13, 'Lista Padrão (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (13282, 731, 13, 'Método padrão');
INSERT INTO `lang_definitions` VALUES (13283, 732, 13, 'Provedor padrão');
INSERT INTO `lang_definitions` VALUES (13284, 733, 13, 'Modelo Padrão');
INSERT INTO `lang_definitions` VALUES (13285, 734, 13, 'Valor padrão');
INSERT INTO `lang_definitions` VALUES (13286, 735, 13, 'Padrão X12 Partner');
INSERT INTO `lang_definitions` VALUES (13287, 736, 13, 'Padrão / Global');
INSERT INTO `lang_definitions` VALUES (13288, 738, 13, 'Recorrência tardia (> 12 Mo)');
INSERT INTO `lang_definitions` VALUES (13289, 739, 13, 'Excluir');
INSERT INTO `lang_definitions` VALUES (13290, 740, 13, 'excluir');
INSERT INTO `lang_definitions` VALUES (13291, 741, 13, 'Excluir categorias com ID (s):');
INSERT INTO `lang_definitions` VALUES (13292, 742, 13, 'Apagar Grupo');
INSERT INTO `lang_definitions` VALUES (13293, 743, 13, 'Apagar lista');
INSERT INTO `lang_definitions` VALUES (13294, 744, 13, 'Excluir páginas');
INSERT INTO `lang_definitions` VALUES (13295, 745, 13, 'Excluir Paciente, Consulta, Forma, edição, documentos, pagamento, cobrança ou transação');
INSERT INTO `lang_definitions` VALUES (13296, 747, 13, 'Excluir sucesso.');
INSERT INTO `lang_definitions` VALUES (13297, 748, 13, 'Excluir este documento');
INSERT INTO `lang_definitions` VALUES (13298, 749, 13, 'Excluir este formulário');
INSERT INTO `lang_definitions` VALUES (13299, 750, 13, 'Excluir este lembrete');
INSERT INTO `lang_definitions` VALUES (13300, 751, 13, 'Demência');
INSERT INTO `lang_definitions` VALUES (13301, 752, 13, 'Informações');
INSERT INTO `lang_definitions` VALUES (13302, 753, 13, 'Informações (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (13303, 754, 13, 'Informações não autorizadas');
INSERT INTO `lang_definitions` VALUES (13304, 755, 13, 'Informações não autorizadas.');
INSERT INTO `lang_definitions` VALUES (13305, 756, 13, 'Dental');
INSERT INTO `lang_definitions` VALUES (13306, 757, 13, 'Problemas dentários');
INSERT INTO `lang_definitions` VALUES (13307, 758, 13, 'Dependendo do tipo de conta que você está testando você vai ver HCFA como a saída em uma página em branco para HCFA contas, você vai ver várias linhas de texto um tanto truncado e as informações se você está testando uma reivindicação X12. Esse texto ilegível é o X12 EDI 4010 formato. Ocasionalmente você vai ver caracteres estranhos que parecem dominós ou squiglies, estes são caracteres de controle como de alimentos e são normais.');
INSERT INTO `lang_definitions` VALUES (13308, 759, 13, 'Data de Depósito:');
INSERT INTO `lang_definitions` VALUES (13309, 760, 13, 'Deprimido');
INSERT INTO `lang_definitions` VALUES (13310, 761, 13, 'Depressão');
INSERT INTO `lang_definitions` VALUES (13311, 762, 13, 'Descrição');
INSERT INTO `lang_definitions` VALUES (13312, 763, 13, 'Descrição');
INSERT INTO `lang_definitions` VALUES (13313, 764, 13, 'Tradução Descrição');
INSERT INTO `lang_definitions` VALUES (13314, 765, 13, 'Destino');
INSERT INTO `lang_definitions` VALUES (13315, 766, 13, 'Lote Destruir');
INSERT INTO `lang_definitions` VALUES (13316, 767, 13, 'Destruir ...');
INSERT INTO `lang_definitions` VALUES (13317, 768, 13, 'Destroyed');
INSERT INTO `lang_definitions` VALUES (13318, 769, 13, 'Droga Destroyed');
INSERT INTO `lang_definitions` VALUES (13319, 770, 13, 'Destruídos Drogas Relatório');
INSERT INTO `lang_definitions` VALUES (13320, 771, 13, 'Detalhes');
INSERT INTO `lang_definitions` VALUES (13321, 772, 13, 'Anormalidade Desenvolvida');
INSERT INTO `lang_definitions` VALUES (13322, 773, 13, 'Diabetes');
INSERT INTO `lang_definitions` VALUES (13323, 774, 13, 'Diag');
INSERT INTO `lang_definitions` VALUES (13324, 775, 13, 'Diagnóstico');
INSERT INTO `lang_definitions` VALUES (13325, 776, 13, 'O diagnóstico deve ser codificado em uma Consulta ligado');
INSERT INTO `lang_definitions` VALUES (13326, 777, 13, 'Diagnóstico:');
INSERT INTO `lang_definitions` VALUES (13327, 778, 13, 'Diagnóstico:');
INSERT INTO `lang_definitions` VALUES (13328, 779, 13, 'Testes de Diagnóstico:');
INSERT INTO `lang_definitions` VALUES (13329, 780, 13, 'Dials');
INSERT INTO `lang_definitions` VALUES (13330, 781, 13, 'Diafragmas / Bonés');
INSERT INTO `lang_definitions` VALUES (13331, 782, 13, 'Diarréia');
INSERT INTO `lang_definitions` VALUES (13332, 783, 13, 'Ditado');
INSERT INTO `lang_definitions` VALUES (13333, 784, 13, 'Ditado:');
INSERT INTO `lang_definitions` VALUES (13334, 785, 13, 'Você receberá uma cópia da comunicação HIPAA?');
INSERT INTO `lang_definitions` VALUES (13335, 786, 13, 'Difuso:');
INSERT INTO `lang_definitions` VALUES (13336, 788, 13, 'Direct Mail');
INSERT INTO `lang_definitions` VALUES (13337, 789, 13, 'Deficiência');
INSERT INTO `lang_definitions` VALUES (13338, 790, 13, 'deficientes');
INSERT INTO `lang_definitions` VALUES (13339, 791, 13, 'Pessoas com mobilidade condicionada');
INSERT INTO `lang_definitions` VALUES (13340, 792, 13, 'DISC');
INSERT INTO `lang_definitions` VALUES (13341, 793, 13, 'Quitação');
INSERT INTO `lang_definitions` VALUES (13342, 794, 13, 'Quitação da uretra');
INSERT INTO `lang_definitions` VALUES (13343, 795, 13, 'Quitação com o botão direito');
INSERT INTO `lang_definitions` VALUES (13344, 796, 13, 'Quitação com o botão direito:');
INSERT INTO `lang_definitions` VALUES (13345, 797, 13, 'Desconto');
INSERT INTO `lang_definitions` VALUES (13346, 798, 13, 'Valor do desconto');
INSERT INTO `lang_definitions` VALUES (13347, 799, 13, 'Nível de desconto');
INSERT INTO `lang_definitions` VALUES (13348, 800, 13, 'Doença');
INSERT INTO `lang_definitions` VALUES (13349, 801, 13, 'Luxação');
INSERT INTO `lang_definitions` VALUES (13350, 802, 13, 'Disp #');
INSERT INTO `lang_definitions` VALUES (13351, 803, 13, 'Expedição');
INSERT INTO `lang_definitions` VALUES (13352, 804, 13, 'Expedição do documento recebido');
INSERT INTO `lang_definitions` VALUES (13353, 805, 13, 'Dispensada');
INSERT INTO `lang_definitions` VALUES (13354, 806, 13, 'Mostrar datas de eventos em bloco?');
INSERT INTO `lang_definitions` VALUES (13355, 807, 13, 'Mostrar quantos eventos?');
INSERT INTO `lang_definitions` VALUES (13356, 808, 13, 'Local de exibição no bloco?');
INSERT INTO `lang_definitions` VALUES (13357, 809, 13, 'Mostrar o calendário?');
INSERT INTO `lang_definitions` VALUES (13358, 810, 13, 'Mostra os eventos de hoje no bloco?');
INSERT INTO `lang_definitions` VALUES (13359, 811, 13, 'Mostrar o tópico no bloco?');
INSERT INTO `lang_definitions` VALUES (13360, 812, 13, 'Mostrar eventos programados no bloco?');
INSERT INTO `lang_definitions` VALUES (13361, 813, 13, 'Distribuição');
INSERT INTO `lang_definitions` VALUES (13362, 814, 13, 'Diverticulite');
INSERT INTO `lang_definitions` VALUES (13363, 815, 13, 'Diverticulite Cirurgia');
INSERT INTO `lang_definitions` VALUES (13364, 816, 13, 'Divirticulitis');
INSERT INTO `lang_definitions` VALUES (13365, 817, 13, 'Divirticulitis Cirurgia');
INSERT INTO `lang_definitions` VALUES (13366, 818, 13, 'Divorciado');
INSERT INTO `lang_definitions` VALUES (13367, 819, 13, 'Tonturas:');
INSERT INTO `lang_definitions` VALUES (13368, 820, 13, 'não guarde');
INSERT INTO `lang_definitions` VALUES (13369, 821, 13, 'Não substitua');
INSERT INTO `lang_definitions` VALUES (13370, 823, 13, 'Você realmente quer apagar este grupo');
INSERT INTO `lang_definitions` VALUES (13371, 824, 13, 'Deseja continuar a adicionar este novo paciente?');
INSERT INTO `lang_definitions` VALUES (13372, 825, 13, 'Deseja continuar com o novo nome?');
INSERT INTO `lang_definitions` VALUES (13373, 826, 13, 'Deseja excluir permanentemente esta recorde de Vacinação?');
INSERT INTO `lang_definitions` VALUES (13374, 827, 13, 'Data de nascimento');
INSERT INTO `lang_definitions` VALUES (13375, 828, 13, 'Data de nascimento está faltando, entre se possível');
INSERT INTO `lang_definitions` VALUES (13376, 829, 13, 'Médicos');
INSERT INTO `lang_definitions` VALUES (13377, 830, 13, 'Médico');
INSERT INTO `lang_definitions` VALUES (13378, 831, 13, 'Médico:');
INSERT INTO `lang_definitions` VALUES (13379, 832, 13, 'Nome do médico e assinatura');
INSERT INTO `lang_definitions` VALUES (13380, 833, 13, 'Documento');
INSERT INTO `lang_definitions` VALUES (13381, 834, 13, 'documento');
INSERT INTO `lang_definitions` VALUES (13382, 835, 13, 'Documento Categorias');
INSERT INTO `lang_definitions` VALUES (13383, 836, 13, 'O documento não poderia ser transferido para identificação do paciente');
INSERT INTO `lang_definitions` VALUES (13384, 837, 13, 'Data do documento');
INSERT INTO `lang_definitions` VALUES (13385, 838, 13, 'Documento data de emissão e atualizado com sucesso');
INSERT INTO `lang_definitions` VALUES (13386, 839, 13, 'Documento mudou-se para nova categoria');
INSERT INTO `lang_definitions` VALUES (13387, 840, 13, 'Documento mudou-se para identificação do paciente');
INSERT INTO `lang_definitions` VALUES (13388, 841, 13, 'Documento / Imagem Armazenada');
INSERT INTO `lang_definitions` VALUES (13389, 842, 13, 'Documentos');
INSERT INTO `lang_definitions` VALUES (13390, 843, 13, 'Documentos (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (13391, 844, 13, 'DOE');
INSERT INTO `lang_definitions` VALUES (13392, 845, 13, 'Relação Estável');
INSERT INTO `lang_definitions` VALUES (13393, 846, 13, 'Não salvar');
INSERT INTO `lang_definitions` VALUES (13394, 847, 13, 'Não salvar');
INSERT INTO `lang_definitions` VALUES (13395, 848, 13, 'Não salvar as alterações');
INSERT INTO `lang_definitions` VALUES (13396, 849, 13, 'Feito');
INSERT INTO `lang_definitions` VALUES (13397, 850, 13, 'Feito com:');
INSERT INTO `lang_definitions` VALUES (13398, 851, 13, 'Feito. Agora enviará o download.');
INSERT INTO `lang_definitions` VALUES (13399, 852, 13, 'DOS');
INSERT INTO `lang_definitions` VALUES (13400, 853, 13, 'Dosagem');
INSERT INTO `lang_definitions` VALUES (13401, 854, 13, 'duplo clique para editar');
INSERT INTO `lang_definitions` VALUES (13402, 855, 13, 'Visão Dupla');
INSERT INTO `lang_definitions` VALUES (13403, 856, 13, 'Download de arquivos de faturamento, posto à contabilidade e marca como faturado');
INSERT INTO `lang_definitions` VALUES (13404, 857, 13, 'Transferir dados de configuração');
INSERT INTO `lang_definitions` VALUES (13405, 858, 13, 'Dr Check');
INSERT INTO `lang_definitions` VALUES (13406, 859, 13, 'Dr Visite');
INSERT INTO `lang_definitions` VALUES (13407, 860, 13, 'Dr.');
INSERT INTO `lang_definitions` VALUES (13408, 861, 13, 'Dribbling');
INSERT INTO `lang_definitions` VALUES (13409, 862, 13, 'Carteira de Motorista ou de Estado-ID');
INSERT INTO `lang_definitions` VALUES (13410, 863, 13, 'Drogas');
INSERT INTO `lang_definitions` VALUES (13411, 864, 13, 'Formas de drogas');
INSERT INTO `lang_definitions` VALUES (13412, 865, 13, 'Drogas ID faltando!');
INSERT INTO `lang_definitions` VALUES (13413, 866, 13, 'Intervalos de drogas');
INSERT INTO `lang_definitions` VALUES (13414, 867, 13, 'Inventário de drogas');
INSERT INTO `lang_definitions` VALUES (13415, 868, 13, 'Nome da droga');
INSERT INTO `lang_definitions` VALUES (13416, 869, 13, 'Drogas Rotas');
INSERT INTO `lang_definitions` VALUES (13417, 870, 13, 'Unidades de drogas');
INSERT INTO `lang_definitions` VALUES (13418, 871, 13, 'Drogas');
INSERT INTO `lang_definitions` VALUES (13419, 872, 13, 'Boca seca');
INSERT INTO `lang_definitions` VALUES (13420, 873, 13, 'DT 1');
INSERT INTO `lang_definitions` VALUES (13421, 874, 13, 'DT 2');
INSERT INTO `lang_definitions` VALUES (13422, 875, 13, 'DT 3');
INSERT INTO `lang_definitions` VALUES (13423, 876, 13, 'DT 4');
INSERT INTO `lang_definitions` VALUES (13424, 877, 13, 'DT 5');
INSERT INTO `lang_definitions` VALUES (13425, 878, 13, 'DTaP 1');
INSERT INTO `lang_definitions` VALUES (13426, 879, 13, 'DTaP 2');
INSERT INTO `lang_definitions` VALUES (13427, 880, 13, 'DTaP 3');
INSERT INTO `lang_definitions` VALUES (13428, 881, 13, 'DTaP 4');
INSERT INTO `lang_definitions` VALUES (13429, 882, 13, 'DTaP 5');
INSERT INTO `lang_definitions` VALUES (13430, 883, 13, 'Data de Vencimento');
INSERT INTO `lang_definitions` VALUES (13431, 884, 13, 'Milímetro Vencimento / dd / aaaa ou aaaa-mm-dd');
INSERT INTO `lang_definitions` VALUES (13432, 885, 13, 'Data de Vencimento:');
INSERT INTO `lang_definitions` VALUES (13433, 886, 13, 'Ins Devido');
INSERT INTO `lang_definitions` VALUES (13434, 887, 13, 'Devido Pt');
INSERT INTO `lang_definitions` VALUES (13435, 888, 13, 'Dumping banco OpenEMR');
INSERT INTO `lang_definitions` VALUES (13436, 889, 13, 'Dumping OpenEMR árvore de diretórios web');
INSERT INTO `lang_definitions` VALUES (13437, 890, 13, 'Dumping banco phpgacl');
INSERT INTO `lang_definitions` VALUES (13438, 891, 13, 'Dumping árvore de diretórios phpgacl web');
INSERT INTO `lang_definitions` VALUES (13439, 892, 13, 'Dumping banco de dados SQL-Ledger');
INSERT INTO `lang_definitions` VALUES (13440, 893, 13, 'Dumping SQL-Ledger árvore de diretórios web');
INSERT INTO `lang_definitions` VALUES (13441, 894, 13, 'AVISO DUPLICAÇÃO');
INSERT INTO `lang_definitions` VALUES (13442, 895, 13, 'Duração');
INSERT INTO `lang_definitions` VALUES (13443, 896, 13, 'Duração');
INSERT INTO `lang_definitions` VALUES (13444, 897, 13, 'Holandês');
INSERT INTO `lang_definitions` VALUES (13445, 898, 13, 'Disfagia');
INSERT INTO `lang_definitions` VALUES (13446, 899, 13, 'Dispnéia:');
INSERT INTO `lang_definitions` VALUES (13447, 900, 13, 'Disúria');
INSERT INTO `lang_definitions` VALUES (13448, 901, 13, 'A recidiva precoce (<2 Mo)');
INSERT INTO `lang_definitions` VALUES (13449, 902, 13, 'Orelhas');
INSERT INTO `lang_definitions` VALUES (13450, 903, 13, 'ECG');
INSERT INTO `lang_definitions` VALUES (13451, 904, 13, 'Edema');
INSERT INTO `lang_definitions` VALUES (13452, 905, 13, 'Editar');
INSERT INTO `lang_definitions` VALUES (13453, 906, 13, 'Editar Alergias');
INSERT INTO `lang_definitions` VALUES (13454, 907, 13, 'Editar categorias');
INSERT INTO `lang_definitions` VALUES (13455, 908, 13, 'Editar definições');
INSERT INTO `lang_definitions` VALUES (13456, 909, 13, 'Editar Diagnósticos para');
INSERT INTO `lang_definitions` VALUES (13457, 910, 13, 'Editar Clínicas');
INSERT INTO `lang_definitions` VALUES (13458, 911, 13, 'Editar Informações da Clínica');
INSERT INTO `lang_definitions` VALUES (13459, 912, 13, 'Formulário Editar');
INSERT INTO `lang_definitions` VALUES (13460, 913, 13, 'Editar layout');
INSERT INTO `lang_definitions` VALUES (13461, 914, 13, 'Editar lista');
INSERT INTO `lang_definitions` VALUES (13462, 915, 13, 'Editar Estrutura');
INSERT INTO `lang_definitions` VALUES (13463, 916, 13, 'Educação');
INSERT INTO `lang_definitions` VALUES (13464, 917, 13, 'Data da Educação');
INSERT INTO `lang_definitions` VALUES (13465, 918, 13, 'ee a GNU General Public License para mais detalhes. * Você deve ter recebido uma cópia da Licença Pública Geral GNU * junto com este programa, se não, escreva para a Free');
INSERT INTO `lang_definitions` VALUES (13466, 919, 13, 'Data Efetiva');
INSERT INTO `lang_definitions` VALUES (13467, 920, 13, 'Eficácia');
INSERT INTO `lang_definitions` VALUES (13468, 921, 13, 'Ejaculações');
INSERT INTO `lang_definitions` VALUES (13469, 922, 13, 'Elbow');
INSERT INTO `lang_definitions` VALUES (13470, 923, 13, 'Elbow Problemas');
INSERT INTO `lang_definitions` VALUES (13471, 924, 13, 'Eletrônica da competência');
INSERT INTO `lang_definitions` VALUES (13472, 925, 13, 'Email');
INSERT INTO `lang_definitions` VALUES (13473, 926, 13, 'E-mail de Batchcom');
INSERT INTO `lang_definitions` VALUES (13474, 927, 13, 'Email Notificação');
INSERT INTO `lang_definitions` VALUES (13475, 928, 13, 'Enviar e-mail antes');
INSERT INTO `lang_definitions` VALUES (13476, 929, 13, 'Email Enviar');
INSERT INTO `lang_definitions` VALUES (13477, 930, 13, 'E-mail Assunto');
INSERT INTO `lang_definitions` VALUES (13478, 931, 13, 'E-mail de texto, Útil Tag: *** NOME ***, ou seja, Caro *** NOME ***');
INSERT INTO `lang_definitions` VALUES (13479, 932, 13, 'Contato de emergência');
INSERT INTO `lang_definitions` VALUES (13480, 933, 13, 'Contato de Emergência');
INSERT INTO `lang_definitions` VALUES (13481, 934, 13, 'Número de telefone de emergência');
INSERT INTO `lang_definitions` VALUES (13482, 935, 13, 'Contracepção de Emergência');
INSERT INTO `lang_definitions` VALUES (13483, 936, 13, 'Telefone de emergência');
INSERT INTO `lang_definitions` VALUES (13484, 937, 13, 'Enfisema');
INSERT INTO `lang_definitions` VALUES (13485, 938, 13, 'Empregado');
INSERT INTO `lang_definitions` VALUES (13486, 939, 13, 'Empresa');
INSERT INTO `lang_definitions` VALUES (13487, 940, 13, 'Endereço da Empresa');
INSERT INTO `lang_definitions` VALUES (13488, 941, 13, 'Admissão da Empresa');
INSERT INTO `lang_definitions` VALUES (13489, 942, 13, 'Nome da Empresa');
INSERT INTO `lang_definitions` VALUES (13490, 943, 13, 'Vazio');
INSERT INTO `lang_definitions` VALUES (13491, 944, 13, 'Valor vazio em \"\"Horas-mail \"\"');
INSERT INTO `lang_definitions` VALUES (13492, 945, 13, 'Valor vazio em \"\"Email Sender \"\"');
INSERT INTO `lang_definitions` VALUES (13493, 946, 13, 'Valor vazio em \"\"Assunto do Email \"\"');
INSERT INTO `lang_definitions` VALUES (13494, 947, 13, 'Valor vazio em \"\"E-mail Texto \"\"');
INSERT INTO `lang_definitions` VALUES (13495, 948, 13, 'Valor vazio em \"\"Nome do Provedor \"\"');
INSERT INTO `lang_definitions` VALUES (13496, 949, 13, 'Valor vazio em \"\"Password \"\"');
INSERT INTO `lang_definitions` VALUES (13497, 950, 13, 'Valor vazio em \"\"Horas SMS \"\"');
INSERT INTO `lang_definitions` VALUES (13498, 951, 13, 'Valor vazio em \"\"de texto SMS \"\"');
INSERT INTO `lang_definitions` VALUES (13499, 952, 13, 'Valor vazio em \"\"Nome \"\"');
INSERT INTO `lang_definitions` VALUES (13500, 953, 13, 'habilitado');
INSERT INTO `lang_definitions` VALUES (13501, 954, 13, 'Enc');
INSERT INTO `lang_definitions` VALUES (13502, 955, 13, 'Consulta');
INSERT INTO `lang_definitions` VALUES (13503, 956, 13, 'Consulta');
INSERT INTO `lang_definitions` VALUES (13504, 957, 13, 'Consulta');
INSERT INTO `lang_definitions` VALUES (13505, 958, 13, 'Consulta Formulários');
INSERT INTO `lang_definitions` VALUES (13506, 959, 13, 'Número Consulta');
INSERT INTO `lang_definitions` VALUES (13507, 960, 13, 'Consulta foi codificada');
INSERT INTO `lang_definitions` VALUES (13508, 961, 13, 'Consulta:');
INSERT INTO `lang_definitions` VALUES (13509, 962, 13, 'Consultas');
INSERT INTO `lang_definitions` VALUES (13510, 963, 13, 'Consultas & Formulários');
INSERT INTO `lang_definitions` VALUES (13511, 964, 13, 'Consultas & Formulários');
INSERT INTO `lang_definitions` VALUES (13512, 965, 13, 'Consultas não autorizado');
INSERT INTO `lang_definitions` VALUES (13513, 966, 13, 'Consultas Relatório');
INSERT INTO `lang_definitions` VALUES (13514, 967, 13, 'Consultas Seção');
INSERT INTO `lang_definitions` VALUES (13515, 968, 13, 'Fim');
INSERT INTO `lang_definitions` VALUES (13516, 969, 13, 'Fim (aaaa-mm-dd):');
INSERT INTO `lang_definitions` VALUES (13517, 970, 13, 'Com data final');
INSERT INTO `lang_definitions` VALUES (13518, 971, 13, 'Data final');
INSERT INTO `lang_definitions` VALUES (13519, 972, 13, 'Data final:');
INSERT INTO `lang_definitions` VALUES (13520, 973, 13, 'End Time');
INSERT INTO `lang_definitions` VALUES (13521, 974, 13, 'Data de término do serviço aaaa-mm-dd');
INSERT INTO `lang_definitions` VALUES (13522, 975, 13, 'Ending milímetros DOS / dd / yyyy se deseja introduzir um intervalo');
INSERT INTO `lang_definitions` VALUES (13523, 976, 13, 'Endo sanguíneos anormais');
INSERT INTO `lang_definitions` VALUES (13524, 977, 13, 'Endócrino');
INSERT INTO `lang_definitions` VALUES (13525, 978, 13, 'Endoscopia');
INSERT INTO `lang_definitions` VALUES (13526, 979, 13, 'Inglês');
INSERT INTO `lang_definitions` VALUES (13527, 980, 13, 'Inglês');
INSERT INTO `lang_definitions` VALUES (13528, 981, 13, 'Inglês (indiana)');
INSERT INTO `lang_definitions` VALUES (13529, 982, 13, 'Inglês (Standard)');
INSERT INTO `lang_definitions` VALUES (13530, 983, 13, 'Assegurar OpenEMR tem privilégios de gravação para o diretório');
INSERT INTO `lang_definitions` VALUES (13531, 984, 13, 'ENT Quitação');
INSERT INTO `lang_definitions` VALUES (13532, 985, 13, 'ENT Pain');
INSERT INTO `lang_definitions` VALUES (13533, 986, 13, 'Digite um código de diagnóstico para excluir todas as faturas que não contenham a');
INSERT INTO `lang_definitions` VALUES (13534, 987, 13, 'Entrar no corpo da carta aqui');
INSERT INTO `lang_definitions` VALUES (13535, 988, 13, 'Entrar novo Estado');
INSERT INTO `lang_definitions` VALUES (13536, 989, 13, 'Digite seu critério de pesquisa acima');
INSERT INTO `lang_definitions` VALUES (13537, 990, 13, 'Ambiental');
INSERT INTO `lang_definitions` VALUES (13538, 991, 13, 'EOB de entrada de dados');
INSERT INTO `lang_definitions` VALUES (13539, 992, 13, 'EOB Destacamento - Electronic Remessas');
INSERT INTO `lang_definitions` VALUES (13540, 993, 13, 'EOB Posting - Instruções');
INSERT INTO `lang_definitions` VALUES (13541, 994, 13, 'EOB Destacamento - Invoice');
INSERT INTO `lang_definitions` VALUES (13542, 995, 13, 'EOB Destacamento - Paciente Nota');
INSERT INTO `lang_definitions` VALUES (13543, 996, 13, 'EOB Destacamento - Busca');
INSERT INTO `lang_definitions` VALUES (13544, 997, 13, 'Epilepsia');
INSERT INTO `lang_definitions` VALUES (13545, 998, 13, 'Erase');
INSERT INTO `lang_definitions` VALUES (13546, 999, 13, 'Ereções');
INSERT INTO `lang_definitions` VALUES (13547, 1000, 13, 'Erro');
INSERT INTO `lang_definitions` VALUES (13548, 1001, 13, 'Erro na \"\"Sexo \"\" seleção');
INSERT INTO `lang_definitions` VALUES (13549, 1002, 13, 'Erro na \"\"HIPAA \"\" seleção');
INSERT INTO `lang_definitions` VALUES (13550, 1003, 13, 'Erro na \"\"Processo \"\" seleção');
INSERT INTO `lang_definitions` VALUES (13551, 1004, 13, 'Erro na \"\"SMS Gateway \"\" seleção');
INSERT INTO `lang_definitions` VALUES (13552, 1005, 13, 'Erro na \"\"Ordenar por \"\" seleção');
INSERT INTO `lang_definitions` VALUES (13553, 1007, 13, 'Erro na opção SIM ou NÃO');
INSERT INTO `lang_definitions` VALUES (13554, 1009, 13, 'erro ao registrar formulário!');
INSERT INTO `lang_definitions` VALUES (13555, 1010, 13, 'Erro ao salvar o arquivo');
INSERT INTO `lang_definitions` VALUES (13556, 1011, 13, 'Erro ao gravar no arquivo');
INSERT INTO `lang_definitions` VALUES (13557, 1012, 13, 'Erro, incapaz de coletar dados de servidor');
INSERT INTO `lang_definitions` VALUES (13558, 1014, 13, 'ERRO: não pôde abrir table.sql, forma quebrado?');
INSERT INTO `lang_definitions` VALUES (13559, 1016, 13, 'Erro: Senha inválida. Verifique sua digitação.');
INSERT INTO `lang_definitions` VALUES (13560, 1018, 13, 'Erros');
INSERT INTO `lang_definitions` VALUES (13561, 1019, 13, 'Eritema:');
INSERT INTO `lang_definitions` VALUES (13562, 1020, 13, 'Paciente Antigo');
INSERT INTO `lang_definitions` VALUES (13563, 1021, 13, 'Etnia ou raça');
INSERT INTO `lang_definitions` VALUES (13564, 1022, 13, 'Étnico-Lista Raça (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (13565, 1023, 13, 'Etin');
INSERT INTO `lang_definitions` VALUES (13566, 1024, 13, 'Evento');
INSERT INTO `lang_definitions` VALUES (13567, 1025, 13, 'Evento começa');
INSERT INTO `lang_definitions` VALUES (13568, 1026, 13, 'Categoria do evento');
INSERT INTO `lang_definitions` VALUES (13569, 1027, 13, 'Data do Evento');
INSERT INTO `lang_definitions` VALUES (13570, 1028, 13, 'Descrição do evento');
INSERT INTO `lang_definitions` VALUES (13571, 1029, 13, 'Detalhes do evento');
INSERT INTO `lang_definitions` VALUES (13572, 1030, 13, 'Evento não se repete');
INSERT INTO `lang_definitions` VALUES (13573, 1031, 13, 'Duração do evento');
INSERT INTO `lang_definitions` VALUES (13574, 1032, 13, 'Evento duração em minutos');
INSERT INTO `lang_definitions` VALUES (13575, 1033, 13, 'Taxa de Eventos');
INSERT INTO `lang_definitions` VALUES (13576, 1034, 13, 'Local do evento');
INSERT INTO `lang_definitions` VALUES (13577, 1035, 13, 'Evento se repete');
INSERT INTO `lang_definitions` VALUES (13578, 1036, 13, 'Evento se repete no');
INSERT INTO `lang_definitions` VALUES (13579, 1037, 13, 'Evento hora de início');
INSERT INTO `lang_definitions` VALUES (13580, 1038, 13, 'Título do evento');
INSERT INTO `lang_definitions` VALUES (13581, 1039, 13, 'Título do Evento');
INSERT INTO `lang_definitions` VALUES (13582, 1040, 13, 'Website do evento');
INSERT INTO `lang_definitions` VALUES (13583, 1041, 13, 'Eventos');
INSERT INTO `lang_definitions` VALUES (13584, 1042, 13, 'Eventos para');
INSERT INTO `lang_definitions` VALUES (13585, 1043, 13, 'Eventos abrir em uma nova janela');
INSERT INTO `lang_definitions` VALUES (13586, 1044, 13, 'cada um');
INSERT INTO `lang_definitions` VALUES (13587, 1045, 13, 'Cada um');
INSERT INTO `lang_definitions` VALUES (13588, 1046, 13, 'a cada 3 horas');
INSERT INTO `lang_definitions` VALUES (13589, 1047, 13, 'a cada 4 horas');
INSERT INTO `lang_definitions` VALUES (13590, 1048, 13, 'a cada 5 horas');
INSERT INTO `lang_definitions` VALUES (13591, 1049, 13, 'a cada 6 horas');
INSERT INTO `lang_definitions` VALUES (13592, 1050, 13, 'a cada 8 horas');
INSERT INTO `lang_definitions` VALUES (13593, 1051, 13, 'Toda Quarta');
INSERT INTO `lang_definitions` VALUES (13594, 1052, 13, 'Todos os outros');
INSERT INTO `lang_definitions` VALUES (13595, 1053, 13, 'Cada Terceiro');
INSERT INTO `lang_definitions` VALUES (13596, 1054, 13, 'Todos os dias, todas as outras, a cada 3, etc');
INSERT INTO `lang_definitions` VALUES (13597, 1055, 13, 'Os resultados dos exames e teste');
INSERT INTO `lang_definitions` VALUES (13598, 1056, 13, 'Os resultados dos exames');
INSERT INTO `lang_definitions` VALUES (13599, 1057, 13, 'Data Exame');
INSERT INTO `lang_definitions` VALUES (13600, 1058, 13, 'Exames / Testes');
INSERT INTO `lang_definitions` VALUES (13601, 1059, 13, 'Lacrimejamento excessivo');
INSERT INTO `lang_definitions` VALUES (13602, 1060, 13, 'Exclusive Provider Organization (EPO)');
INSERT INTO `lang_definitions` VALUES (13603, 1061, 13, 'Padrões de exercício');
INSERT INTO `lang_definitions` VALUES (13604, 1062, 13, 'Padrões de exercício');
INSERT INTO `lang_definitions` VALUES (13605, 1063, 13, 'Sair do Administração');
INSERT INTO `lang_definitions` VALUES (13606, 1064, 13, 'Exp');
INSERT INTO `lang_definitions` VALUES (13607, 1065, 13, 'Visualização Expandida');
INSERT INTO `lang_definitions` VALUES (13608, 1066, 13, 'Form_encounter.pid Esperado ser');
INSERT INTO `lang_definitions` VALUES (13609, 1067, 13, 'Expiração');
INSERT INTO `lang_definitions` VALUES (13610, 1068, 13, 'Data de Expiração');
INSERT INTO `lang_definitions` VALUES (13611, 1069, 13, 'Expira');
INSERT INTO `lang_definitions` VALUES (13612, 1070, 13, 'Exportação');
INSERT INTO `lang_definitions` VALUES (13613, 1071, 13, 'Exportar como CSV');
INSERT INTO `lang_definitions` VALUES (13614, 1072, 13, 'Exportar configuração');
INSERT INTO `lang_definitions` VALUES (13615, 1073, 13, 'Exportar Informações do Paciente');
INSERT INTO `lang_definitions` VALUES (13616, 1074, 13, 'Exportar como CSV Selecionados');
INSERT INTO `lang_definitions` VALUES (13617, 1075, 13, 'Coleções selecionadas para exportação');
INSERT INTO `lang_definitions` VALUES (13618, 1076, 13, 'Exportar para CSV');
INSERT INTO `lang_definitions` VALUES (13619, 1077, 13, 'Exportar para o sistema de faturamento externo');
INSERT INTO `lang_definitions` VALUES (13620, 1078, 13, 'A exposição ao Estrangeiro');
INSERT INTO `lang_definitions` VALUES (13621, 1079, 13, 'Exposição ao Estrangeiro');
INSERT INTO `lang_definitions` VALUES (13622, 1080, 13, 'Externo');
INSERT INTO `lang_definitions` VALUES (13623, 1081, 13, 'N# Cadastro');
INSERT INTO `lang_definitions` VALUES (13624, 1082, 13, 'Identificador externo');
INSERT INTO `lang_definitions` VALUES (13625, 1083, 13, 'Somente Externo');
INSERT INTO `lang_definitions` VALUES (13626, 1084, 13, 'Consulta externa');
INSERT INTO `lang_definitions` VALUES (13627, 1085, 13, 'Consulta Externa Followups');
INSERT INTO `lang_definitions` VALUES (13628, 1086, 13, 'Externos de referência?');
INSERT INTO `lang_definitions` VALUES (13629, 1087, 13, 'Referências externas');
INSERT INTO `lang_definitions` VALUES (13630, 1088, 13, 'Exsudato:');
INSERT INTO `lang_definitions` VALUES (13631, 1089, 13, 'Irritação dos olhos');
INSERT INTO `lang_definitions` VALUES (13632, 1090, 13, 'Dor ocular');
INSERT INTO `lang_definitions` VALUES (13633, 1091, 13, 'Vermelhidão dos olhos');
INSERT INTO `lang_definitions` VALUES (13634, 1092, 13, 'Olhos');
INSERT INTO `lang_definitions` VALUES (13635, 1093, 13, 'F');
INSERT INTO `lang_definitions` VALUES (13636, 1094, 13, 'F / H problemas do sangue');
INSERT INTO `lang_definitions` VALUES (13637, 1095, 13, 'F / H Feminino Hirsutismo / Estrias');
INSERT INTO `lang_definitions` VALUES (13638, 1096, 13, 'Clínicas');
INSERT INTO `lang_definitions` VALUES (13639, 1097, 13, 'Clínica');
INSERT INTO `lang_definitions` VALUES (13640, 1098, 13, 'Motor');
INSERT INTO `lang_definitions` VALUES (13641, 1099, 13, 'Clínica de Administração');
INSERT INTO `lang_definitions` VALUES (13642, 1100, 13, 'Clínica Código');
INSERT INTO `lang_definitions` VALUES (13643, 1101, 13, 'CNPJ da Clínica');
INSERT INTO `lang_definitions` VALUES (13644, 1102, 13, 'Clínica:');
INSERT INTO `lang_definitions` VALUES (13645, 1103, 13, 'Falha');
INSERT INTO `lang_definitions` VALUES (13646, 1105, 13, 'falha');
INSERT INTO `lang_definitions` VALUES (13647, 1106, 13, 'Histórico da Família');
INSERT INTO `lang_definitions` VALUES (13648, 1107, 13, 'Histórico familiar de glaucoma');
INSERT INTO `lang_definitions` VALUES (13649, 1108, 13, 'Histórico da Família:');
INSERT INTO `lang_definitions` VALUES (13650, 1109, 13, 'Tamanho Família');
INSERT INTO `lang_definitions` VALUES (13651, 1110, 13, 'Fancy');
INSERT INTO `lang_definitions` VALUES (13652, 1111, 13, 'Pai');
INSERT INTO `lang_definitions` VALUES (13653, 1112, 13, 'Fadiga');
INSERT INTO `lang_definitions` VALUES (13654, 1113, 13, 'Fatigado');
INSERT INTO `lang_definitions` VALUES (13655, 1114, 13, 'Fax');
INSERT INTO `lang_definitions` VALUES (13656, 1115, 13, 'Fax');
INSERT INTO `lang_definitions` VALUES (13657, 1116, 13, 'Fax / Digitalização');
INSERT INTO `lang_definitions` VALUES (13658, 1117, 13, 'Faxes no');
INSERT INTO `lang_definitions` VALUES (13659, 1118, 13, 'Faxes Out');
INSERT INTO `lang_definitions` VALUES (13660, 1119, 13, 'Fevereiro');
INSERT INTO `lang_definitions` VALUES (13661, 1120, 13, 'FECA');
INSERT INTO `lang_definitions` VALUES (13662, 1121, 13, 'Estado do CRM');
INSERT INTO `lang_definitions` VALUES (13663, 1122, 13, 'CRM');
INSERT INTO `lang_definitions` VALUES (13664, 1123, 13, 'CRM');
INSERT INTO `lang_definitions` VALUES (13665, 1124, 13, 'Honorários');
INSERT INTO `lang_definitions` VALUES (13666, 1125, 13, 'honorários');
INSERT INTO `lang_definitions` VALUES (13667, 1126, 13, 'Taxa não é permitido');
INSERT INTO `lang_definitions` VALUES (13668, 1127, 13, 'Taxa Folha');
INSERT INTO `lang_definitions` VALUES (13669, 1128, 13, 'Taxa Folha Opções');
INSERT INTO `lang_definitions` VALUES (13670, 1129, 13, 'Taxas');
INSERT INTO `lang_definitions` VALUES (13671, 1130, 13, 'Feminino');
INSERT INTO `lang_definitions` VALUES (13672, 1131, 13, 'Feminino AP');
INSERT INTO `lang_definitions` VALUES (13673, 1132, 13, 'Preservativos Femininos');
INSERT INTO `lang_definitions` VALUES (13674, 1133, 13, 'Mulher G');
INSERT INTO `lang_definitions` VALUES (13675, 1134, 13, 'Feminino LC');
INSERT INTO `lang_definitions` VALUES (13676, 1135, 13, 'P Feminino');
INSERT INTO `lang_definitions` VALUES (13677, 1136, 13, 'Feminino Sintomas');
INSERT INTO `lang_definitions` VALUES (13678, 1137, 13, 'Feminino VSC');
INSERT INTO `lang_definitions` VALUES (13679, 1138, 13, 'Febre');
INSERT INTO `lang_definitions` VALUES (13680, 1139, 13, 'Febre:');
INSERT INTO `lang_definitions` VALUES (13681, 1140, 13, 'FH problemas do sangue');
INSERT INTO `lang_definitions` VALUES (13682, 1141, 13, 'Fibromiomas');
INSERT INTO `lang_definitions` VALUES (13683, 1142, 13, 'Arquivo');
INSERT INTO `lang_definitions` VALUES (13684, 1143, 13, 'Arquivo do quarto');
INSERT INTO `lang_definitions` VALUES (13685, 1144, 13, 'Arquivo para upload');
INSERT INTO `lang_definitions` VALUES (13686, 1145, 13, 'Arquivo com mesmo nome já existe no local:');
INSERT INTO `lang_definitions` VALUES (13687, 1146, 13, 'Filename');
INSERT INTO `lang_definitions` VALUES (13688, 1147, 13, 'Preencha aqui somente se o envio de notificação de e-mail para os pacientes');
INSERT INTO `lang_definitions` VALUES (13689, 1148, 13, 'Geral');
INSERT INTO `lang_definitions` VALUES (13690, 1149, 13, 'Filtro para Constantes');
INSERT INTO `lang_definitions` VALUES (13691, 1150, 13, 'Filtros');
INSERT INTO `lang_definitions` VALUES (13692, 1151, 13, 'Diagnóstico Final');
INSERT INTO `lang_definitions` VALUES (13693, 1152, 13, 'O diagnóstico final pelo especialista');
INSERT INTO `lang_definitions` VALUES (13694, 1153, 13, 'Financeiro');
INSERT INTO `lang_definitions` VALUES (13695, 1154, 13, 'Relato Financeiro - nada');
INSERT INTO `lang_definitions` VALUES (13696, 1155, 13, 'Relato Financeiro - minhas Consultas');
INSERT INTO `lang_definitions` VALUES (13697, 1156, 13, 'Financeiro Revisão Data');
INSERT INTO `lang_definitions` VALUES (13698, 1157, 13, 'Pesq.');
INSERT INTO `lang_definitions` VALUES (13699, 1158, 13, 'Pesquisar Disponível');
INSERT INTO `lang_definitions` VALUES (13700, 1159, 13, 'Pesquisar Nomeações Disponível');
INSERT INTO `lang_definitions` VALUES (13701, 1160, 13, 'Pesquisar Paciente');
INSERT INTO `lang_definitions` VALUES (13702, 1161, 13, 'Apreciação');
INSERT INTO `lang_definitions` VALUES (13703, 1162, 13, 'Descobertas por um especialista');
INSERT INTO `lang_definitions` VALUES (13704, 1163, 13, 'Agradável');
INSERT INTO `lang_definitions` VALUES (13705, 1164, 13, 'Primeiro');
INSERT INTO `lang_definitions` VALUES (13706, 1165, 13, 'Primeiro dia da semana');
INSERT INTO `lang_definitions` VALUES (13707, 1166, 13, 'Nome');
INSERT INTO `lang_definitions` VALUES (13708, 1167, 13, 'Nome');
INSERT INTO `lang_definitions` VALUES (13709, 1168, 13, 'Nome:');
INSERT INTO `lang_definitions` VALUES (13710, 1169, 13, 'Fitness');
INSERT INTO `lang_definitions` VALUES (13711, 1170, 13, 'Aptidão para jogar');
INSERT INTO `lang_definitions` VALUES (13712, 1171, 13, 'Fixar datas Consulta - as Consultas');
INSERT INTO `lang_definitions` VALUES (13713, 1172, 13, 'Fixar este');
INSERT INTO `lang_definitions` VALUES (13714, 1173, 13, 'Flatulência');
INSERT INTO `lang_definitions` VALUES (13715, 1174, 13, 'Fluxo');
INSERT INTO `lang_definitions` VALUES (13716, 1175, 13, 'Vacinação contra a gripe');
INSERT INTO `lang_definitions` VALUES (13717, 1176, 13, 'Problema de líquidos e eletrólitos');
INSERT INTO `lang_definitions` VALUES (13718, 1177, 13, 'FMS');
INSERT INTO `lang_definitions` VALUES (13719, 1178, 13, 'Siga manualmente');
INSERT INTO `lang_definitions` VALUES (13720, 1179, 13, 'Intolerância Alimentar');
INSERT INTO `lang_definitions` VALUES (13721, 1180, 13, 'Pé');
INSERT INTO `lang_definitions` VALUES (13722, 1181, 13, 'Problemas do Pé');
INSERT INTO `lang_definitions` VALUES (13723, 1182, 13, 'Pé:');
INSERT INTO `lang_definitions` VALUES (13724, 1183, 13, 'Football Injuries');
INSERT INTO `lang_definitions` VALUES (13725, 1184, 13, 'Futebol Injury Report');
INSERT INTO `lang_definitions` VALUES (13726, 1185, 13, 'Tipo de calçado');
INSERT INTO `lang_definitions` VALUES (13727, 1186, 13, 'para');
INSERT INTO `lang_definitions` VALUES (13728, 1189, 13, 'para:');
INSERT INTO `lang_definitions` VALUES (13729, 1190, 13, 'Antebraço');
INSERT INTO `lang_definitions` VALUES (13730, 1191, 13, 'Forma');
INSERT INTO `lang_definitions` VALUES (13731, 1192, 13, 'forma');
INSERT INTO `lang_definitions` VALUES (13732, 1193, 13, 'formato');
INSERT INTO `lang_definitions` VALUES (13733, 1194, 13, 'Formato');
INSERT INTO `lang_definitions` VALUES (13734, 1195, 13, 'Formato incorreto para NDC');
INSERT INTO `lang_definitions` VALUES (13735, 1196, 13, 'Formulários');
INSERT INTO `lang_definitions` VALUES (13736, 1197, 13, 'Formas de administração');
INSERT INTO `lang_definitions` VALUES (13737, 1198, 13, 'Páginas transmitir via Fax');
INSERT INTO `lang_definitions` VALUES (13738, 1199, 13, 'Quarta');
INSERT INTO `lang_definitions` VALUES (13739, 1200, 13, 'Fratura');
INSERT INTO `lang_definitions` VALUES (13740, 1201, 13, 'Fratura no Navicula');
INSERT INTO `lang_definitions` VALUES (13741, 1202, 13, 'Fratura do maléolo lateral');
INSERT INTO `lang_definitions` VALUES (13742, 1203, 13, 'A fratura do maléolo medial');
INSERT INTO `lang_definitions` VALUES (13743, 1204, 13, 'Fracture, da Base de quinta (5) Metatarsal');
INSERT INTO `lang_definitions` VALUES (13744, 1205, 13, 'Francês');
INSERT INTO `lang_definitions` VALUES (13745, 1206, 13, 'Freqüência');
INSERT INTO `lang_definitions` VALUES (13746, 1207, 13, 'Resfriados freqüentes');
INSERT INTO `lang_definitions` VALUES (13747, 1208, 13, 'Doenças frequentes');
INSERT INTO `lang_definitions` VALUES (13748, 1209, 13, 'Sex');
INSERT INTO `lang_definitions` VALUES (13749, 1210, 13, 'Sexta-feira');
INSERT INTO `lang_definitions` VALUES (13750, 1211, 13, 'De');
INSERT INTO `lang_definitions` VALUES (13751, 1212, 13, 'DA');
INSERT INTO `lang_definitions` VALUES (13752, 1213, 13, 'De:');
INSERT INTO `lang_definitions` VALUES (13753, 1214, 13, 'De:');
INSERT INTO `lang_definitions` VALUES (13754, 1215, 13, 'FROM_CITY');
INSERT INTO `lang_definitions` VALUES (13755, 1216, 13, 'FROM_FNAME');
INSERT INTO `lang_definitions` VALUES (13756, 1217, 13, 'FROM_LNAME');
INSERT INTO `lang_definitions` VALUES (13757, 1218, 13, 'FROM_MNAME');
INSERT INTO `lang_definitions` VALUES (13758, 1219, 13, 'FROM_PHONECELL');
INSERT INTO `lang_definitions` VALUES (13759, 1220, 13, 'FROM_POSTAL');
INSERT INTO `lang_definitions` VALUES (13760, 1221, 13, 'FROM_STATE');
INSERT INTO `lang_definitions` VALUES (13761, 1222, 13, 'FROM_STREET');
INSERT INTO `lang_definitions` VALUES (13762, 1223, 13, 'FROM_TITLE');
INSERT INTO `lang_definitions` VALUES (13763, 1224, 13, 'FROM_VALEDICTORY');
INSERT INTO `lang_definitions` VALUES (13764, 1225, 13, 'Recepção');
INSERT INTO `lang_definitions` VALUES (13765, 1226, 13, 'Arquivos da Recepção');
INSERT INTO `lang_definitions` VALUES (13766, 1227, 13, 'Relatório de Arquivos da Recepção Relatório');
INSERT INTO `lang_definitions` VALUES (13767, 1228, 13, 'Front Rec');
INSERT INTO `lang_definitions` VALUES (13768, 1229, 13, 'Frontal Direita:');
INSERT INTO `lang_definitions` VALUES (13769, 1230, 13, 'Nome Completo');
INSERT INTO `lang_definitions` VALUES (13770, 1231, 13, 'Completamente Tocar');
INSERT INTO `lang_definitions` VALUES (13771, 1232, 13, 'Full Training');
INSERT INTO `lang_definitions` VALUES (13772, 1233, 13, 'G');
INSERT INTO `lang_definitions` VALUES (13773, 1234, 13, 'Vesícula Biliar Condição');
INSERT INTO `lang_definitions` VALUES (13774, 1235, 13, 'Gall Stones');
INSERT INTO `lang_definitions` VALUES (13775, 1236, 13, 'Jogo Período');
INSERT INTO `lang_definitions` VALUES (13776, 1237, 13, 'Jogos');
INSERT INTO `lang_definitions` VALUES (13777, 1238, 13, 'jogos / eventos');
INSERT INTO `lang_definitions` VALUES (13778, 1239, 13, 'Jogos / Eventos Missed');
INSERT INTO `lang_definitions` VALUES (13779, 1240, 13, 'Gastrite');
INSERT INTO `lang_definitions` VALUES (13780, 1241, 13, 'Gastro Pain');
INSERT INTO `lang_definitions` VALUES (13781, 1242, 13, 'Gastrointestinais');
INSERT INTO `lang_definitions` VALUES (13782, 1243, 13, 'GCAC Statistics Report');
INSERT INTO `lang_definitions` VALUES (13783, 1244, 13, 'GCAC formulário visita está faltando');
INSERT INTO `lang_definitions` VALUES (13784, 1245, 13, 'Gênero');
INSERT INTO `lang_definitions` VALUES (13785, 1246, 13, 'Gênero');
INSERT INTO `lang_definitions` VALUES (13786, 1247, 13, 'Filtro');
INSERT INTO `lang_definitions` VALUES (13787, 1248, 13, 'Categoria de Serviços Gerais');
INSERT INTO `lang_definitions` VALUES (13788, 1249, 13, 'Gerar e transferir créditos HCFA 1500 papel');
INSERT INTO `lang_definitions` VALUES (13789, 1250, 13, 'Gerar e lote X12 download');
INSERT INTO `lang_definitions` VALUES (13790, 1253, 13, 'Gerar HCFA');
INSERT INTO `lang_definitions` VALUES (13791, 1254, 13, 'Gerar Carta');
INSERT INTO `lang_definitions` VALUES (13792, 1255, 13, 'Gerar carta a respeito');
INSERT INTO `lang_definitions` VALUES (13793, 1256, 13, 'Gerar relatório');
INSERT INTO `lang_definitions` VALUES (13794, 1257, 13, 'Gerar X12');
INSERT INTO `lang_definitions` VALUES (13795, 1259, 13, 'Geração de');
INSERT INTO `lang_definitions` VALUES (13796, 1260, 13, 'Gera');
INSERT INTO `lang_definitions` VALUES (13797, 1261, 13, 'Geniturinário');
INSERT INTO `lang_definitions` VALUES (13798, 1262, 13, 'Alemão');
INSERT INTO `lang_definitions` VALUES (13799, 1263, 13, 'Glaucoma');
INSERT INTO `lang_definitions` VALUES (13800, 1264, 13, 'Glaucoma na Família');
INSERT INTO `lang_definitions` VALUES (13801, 1265, 13, 'Global');
INSERT INTO `lang_definitions` VALUES (13802, 1266, 13, 'Global ID');
INSERT INTO `lang_definitions` VALUES (13803, 1267, 13, 'ir');
INSERT INTO `lang_definitions` VALUES (13804, 1268, 13, 'Ir');
INSERT INTO `lang_definitions` VALUES (13805, 1269, 13, 'Ir para');
INSERT INTO `lang_definitions` VALUES (13806, 1270, 13, 'Ir para a semana de');
INSERT INTO `lang_definitions` VALUES (13807, 1271, 13, 'Votação:');
INSERT INTO `lang_definitions` VALUES (13808, 1272, 13, 'gramas');
INSERT INTO `lang_definitions` VALUES (13809, 1273, 13, 'Total Geral');
INSERT INTO `lang_definitions` VALUES (13810, 1274, 13, 'Totais Gerais');
INSERT INTO `lang_definitions` VALUES (13811, 1275, 13, 'Grego');
INSERT INTO `lang_definitions` VALUES (13812, 1276, 13, 'Grupo');
INSERT INTO `lang_definitions` VALUES (13813, 1277, 13, 'Nome do Grupo');
INSERT INTO `lang_definitions` VALUES (13814, 1278, 13, 'Os nomes dos grupos não pode estar em branco');
INSERT INTO `lang_definitions` VALUES (13815, 1279, 13, 'Os nomes dos grupos não pode começar com números ou espaços.');
INSERT INTO `lang_definitions` VALUES (13816, 1280, 13, 'Os nomes dos grupos não pode começar com números.');
INSERT INTO `lang_definitions` VALUES (13817, 1281, 13, 'Produto');
INSERT INTO `lang_definitions` VALUES (13818, 1282, 13, 'Grupo:');
INSERT INTO `lang_definitions` VALUES (13819, 1283, 13, 'Nome do Grupo');
INSERT INTO `lang_definitions` VALUES (13820, 1284, 13, 'Grupos e Controles de Acesso');
INSERT INTO `lang_definitions` VALUES (13821, 1285, 13, 'Growth Chart');
INSERT INTO `lang_definitions` VALUES (13822, 1286, 13, 'Growth-chart');
INSERT INTO `lang_definitions` VALUES (13823, 1287, 13, 'Gotas');
INSERT INTO `lang_definitions` VALUES (13824, 1288, 13, 'Exame ginecológico');
INSERT INTO `lang_definitions` VALUES (13825, 1289, 13, 'h');
INSERT INTO `lang_definitions` VALUES (13826, 1290, 13, 'H.S.');
INSERT INTO `lang_definitions` VALUES (13827, 1291, 13, 'H / O Hepatite');
INSERT INTO `lang_definitions` VALUES (13828, 1292, 13, 'tinha sido excluído com sucesso. Qualquer sub-categorias se apresentam foram movidos abaixo');
INSERT INTO `lang_definitions` VALUES (13829, 1293, 13, 'Hematoma / contusão');
INSERT INTO `lang_definitions` VALUES (13830, 1294, 13, 'HAI Status');
INSERT INTO `lang_definitions` VALUES (13831, 1295, 13, 'Mão + dedos');
INSERT INTO `lang_definitions` VALUES (13832, 1296, 13, 'Mão Problemas');
INSERT INTO `lang_definitions` VALUES (13833, 1297, 13, 'Hardship w / o');
INSERT INTO `lang_definitions` VALUES (13834, 1298, 13, 'tem sido associada a visitar');
INSERT INTO `lang_definitions` VALUES (13835, 1299, 13, 'Atividades perigosas');
INSERT INTO `lang_definitions` VALUES (13836, 1300, 13, 'Atividades perigosas');
INSERT INTO `lang_definitions` VALUES (13837, 1301, 13, 'HCFA margem esquerda em pontos');
INSERT INTO `lang_definitions` VALUES (13838, 1302, 13, 'Margens HCFA');
INSERT INTO `lang_definitions` VALUES (13839, 1303, 13, 'HCFA margem superior nos pontos');
INSERT INTO `lang_definitions` VALUES (13840, 1304, 13, 'ele PostCalendar');
INSERT INTO `lang_definitions` VALUES (13841, 1305, 13, 'Cabeça');
INSERT INTO `lang_definitions` VALUES (13842, 1306, 13, 'Chefe Circ');
INSERT INTO `lang_definitions` VALUES (13843, 1307, 13, 'Perímetro cefálico');
INSERT INTO `lang_definitions` VALUES (13844, 1308, 13, 'Dor de cabeça');
INSERT INTO `lang_definitions` VALUES (13845, 1309, 13, 'Dores de cabeça');
INSERT INTO `lang_definitions` VALUES (13846, 1310, 13, 'Centro de saúde / clínica');
INSERT INTO `lang_definitions` VALUES (13847, 1311, 13, 'Organização em Defesa da Saúde');
INSERT INTO `lang_definitions` VALUES (13848, 1312, 13, 'Organização em Defesa da Saúde (HMO) Medicare Risk');
INSERT INTO `lang_definitions` VALUES (13849, 1313, 13, 'Perda de Audição');
INSERT INTO `lang_definitions` VALUES (13850, 1314, 13, 'Ataque do Coração');
INSERT INTO `lang_definitions` VALUES (13851, 1315, 13, 'Doenças do Coração');
INSERT INTO `lang_definitions` VALUES (13852, 1316, 13, 'Insuficiência Cardíaca');
INSERT INTO `lang_definitions` VALUES (13853, 1317, 13, 'Problema cardíaco');
INSERT INTO `lang_definitions` VALUES (13854, 1318, 13, 'Problemas cardíacos');
INSERT INTO `lang_definitions` VALUES (13855, 1319, 13, 'Cirurgia de Coração');
INSERT INTO `lang_definitions` VALUES (13856, 1320, 13, 'Transplante de Coração');
INSERT INTO `lang_definitions` VALUES (13857, 1321, 13, 'CORAÇÃO:');
INSERT INTO `lang_definitions` VALUES (13858, 1322, 13, 'Azia');
INSERT INTO `lang_definitions` VALUES (13859, 1323, 13, 'Quente ou Frio');
INSERT INTO `lang_definitions` VALUES (13860, 1324, 13, 'Quente ou Frio');
INSERT INTO `lang_definitions` VALUES (13861, 1325, 13, 'Hebraico');
INSERT INTO `lang_definitions` VALUES (13862, 1326, 13, 'HEENT');
INSERT INTO `lang_definitions` VALUES (13863, 1327, 13, 'Altura');
INSERT INTO `lang_definitions` VALUES (13864, 1328, 13, 'Ajuda');
INSERT INTO `lang_definitions` VALUES (13865, 1329, 13, 'ajuda');
INSERT INTO `lang_definitions` VALUES (13866, 1330, 13, 'Hematêmese');
INSERT INTO `lang_definitions` VALUES (13867, 1331, 13, 'Hematoquezia');
INSERT INTO `lang_definitions` VALUES (13868, 1332, 13, 'Hematológico');
INSERT INTO `lang_definitions` VALUES (13869, 1333, 13, 'Hematuria');
INSERT INTO `lang_definitions` VALUES (13870, 1334, 13, 'Hemoglobina');
INSERT INTO `lang_definitions` VALUES (13871, 1335, 13, 'Hemoptise');
INSERT INTO `lang_definitions` VALUES (13872, 1336, 13, 'Hepatite');
INSERT INTO `lang_definitions` VALUES (13873, 1337, 13, 'Hepatite A 1');
INSERT INTO `lang_definitions` VALUES (13874, 1338, 13, 'Hepatite A 2');
INSERT INTO `lang_definitions` VALUES (13875, 1339, 13, 'Hepatite B 1');
INSERT INTO `lang_definitions` VALUES (13876, 1340, 13, 'Hepatite B 2');
INSERT INTO `lang_definitions` VALUES (13877, 1341, 13, 'Hepatite B 3');
INSERT INTO `lang_definitions` VALUES (13878, 1342, 13, 'aqui');
INSERT INTO `lang_definitions` VALUES (13879, 1343, 13, 'Hernia Repair');
INSERT INTO `lang_definitions` VALUES (13880, 1344, 13, 'Hérnia de disco');
INSERT INTO `lang_definitions` VALUES (13881, 1345, 13, 'Herpes');
INSERT INTO `lang_definitions` VALUES (13882, 1346, 13, 'Hesitação');
INSERT INTO `lang_definitions` VALUES (13883, 1347, 13, 'Olá. Você está por aqui há');
INSERT INTO `lang_definitions` VALUES (13884, 1348, 13, 'Hib 1');
INSERT INTO `lang_definitions` VALUES (13885, 1349, 13, 'Hib 2');
INSERT INTO `lang_definitions` VALUES (13886, 1350, 13, 'Hib 3');
INSERT INTO `lang_definitions` VALUES (13887, 1351, 13, 'Hib 4');
INSERT INTO `lang_definitions` VALUES (13888, 1352, 13, 'Oculto');
INSERT INTO `lang_definitions` VALUES (13889, 1353, 13, 'Administração de Eventos Ocultos');
INSERT INTO `lang_definitions` VALUES (13890, 1354, 13, 'Ocultar');
INSERT INTO `lang_definitions` VALUES (13891, 1355, 13, 'Ocultar Detalhes');
INSERT INTO `lang_definitions` VALUES (13892, 1357, 13, 'Alto');
INSERT INTO `lang_definitions` VALUES (13893, 1358, 13, 'Alta Pressão Sanguínea');
INSERT INTO `lang_definitions` VALUES (13894, 1359, 13, 'Quadril + virilha');
INSERT INTO `lang_definitions` VALUES (13895, 1360, 13, 'Quadril e virilha');
INSERT INTO `lang_definitions` VALUES (13896, 1361, 13, 'Problemas no Quadril');
INSERT INTO `lang_definitions` VALUES (13897, 1362, 13, 'Quadril Replacement');
INSERT INTO `lang_definitions` VALUES (13898, 1363, 13, 'HIPAA Aviso Recebido');
INSERT INTO `lang_definitions` VALUES (13899, 1364, 13, 'Hirsutismo / Estrias');
INSERT INTO `lang_definitions` VALUES (13900, 1365, 13, 'Hispânico');
INSERT INTO `lang_definitions` VALUES (13901, 1366, 13, 'Histórico');
INSERT INTO `lang_definitions` VALUES (13902, 1367, 13, 'Dados Históricos');
INSERT INTO `lang_definitions` VALUES (13903, 1368, 13, 'História Murmur');
INSERT INTO `lang_definitions` VALUES (13904, 1369, 13, 'History of Heart Murmur');
INSERT INTO `lang_definitions` VALUES (13905, 1370, 13, 'HIV');
INSERT INTO `lang_definitions` VALUES (13906, 1371, 13, 'HL7 Viewer');
INSERT INTO `lang_definitions` VALUES (13907, 1372, 13, 'Segure a tecla [Ctrl] para seleção múltipla ou desfazer seleção');
INSERT INTO `lang_definitions` VALUES (13908, 1373, 13, 'Segue a tecla [Ctrl] para selecionar múltiplos itens');
INSERT INTO `lang_definitions` VALUES (13909, 1374, 13, 'Segure a tecla [Ctrl] para selecionar vários esquadrões');
INSERT INTO `lang_definitions` VALUES (13910, 1375, 13, 'Início');
INSERT INTO `lang_definitions` VALUES (13911, 1376, 13, 'Telefone Residencial');
INSERT INTO `lang_definitions` VALUES (13912, 1377, 13, 'Número de telefone residencial');
INSERT INTO `lang_definitions` VALUES (13913, 1378, 13, 'Sem-teto ou similar?');
INSERT INTO `lang_definitions` VALUES (13914, 1379, 13, 'Sem-teto, etc');
INSERT INTO `lang_definitions` VALUES (13915, 1380, 13, 'Sem-teto, etc.');
INSERT INTO `lang_definitions` VALUES (13916, 1381, 13, 'Horas');
INSERT INTO `lang_definitions` VALUES (13917, 1382, 13, 'Como a Lesão Ocorreu?');
INSERT INTO `lang_definitions` VALUES (13918, 1383, 13, 'Como a Lesão Ocorreu?:');
INSERT INTO `lang_definitions` VALUES (13919, 1384, 13, 'Quantos meses à frente para consultar os próximos eventos?');
INSERT INTO `lang_definitions` VALUES (13920, 1385, 13, 'HPI:');
INSERT INTO `lang_definitions` VALUES (13921, 1387, 13, 'HTML');
INSERT INTO `lang_definitions` VALUES (13922, 1388, 13, 'Hiperatividade');
INSERT INTO `lang_definitions` VALUES (13923, 1389, 13, 'Hipertensão');
INSERT INTO `lang_definitions` VALUES (13924, 1390, 13, 'Hipertireoidismo');
INSERT INTO `lang_definitions` VALUES (13925, 1391, 13, 'Hipotireoidismo');
INSERT INTO `lang_definitions` VALUES (13926, 1392, 13, 'Histerectomia');
INSERT INTO `lang_definitions` VALUES (13927, 1393, 13, 'I');
INSERT INTO `lang_definitions` VALUES (13928, 1394, 13, 'Estou ocupado durante esse tempo.');
INSERT INTO `lang_definitions` VALUES (13929, 1395, 13, 'Eu não tenho permissão para ler');
INSERT INTO `lang_definitions` VALUES (13930, 1396, 13, 'CID');
INSERT INTO `lang_definitions` VALUES (13931, 1398, 13, 'RG');
INSERT INTO `lang_definitions` VALUES (13932, 1399, 13, 'Identificação não pode estar em branco');
INSERT INTO `lang_definitions` VALUES (13933, 1400, 13, 'IDays');
INSERT INTO `lang_definitions` VALUES (13934, 1401, 13, 'logado como');
INSERT INTO `lang_definitions` VALUES (13935, 1402, 13, '(Identificador de uma palavra)');
INSERT INTO `lang_definitions` VALUES (13936, 1403, 13, 'Se todos os dados para todas as colunas são completos para este formulário');
INSERT INTO `lang_definitions` VALUES (13937, 1404, 13, 'Se o nome, qualquer parte do apelido, ou sobrenome, nome');
INSERT INTO `lang_definitions` VALUES (13938, 1405, 13, 'Se desempregado entra Estudante');
INSERT INTO `lang_definitions` VALUES (13939, 1406, 13, 'Se você tiver escolhido para carregar as remessas eletrônicas, em seguida, a janela de pesquisa redisplays com as faturas correspondentes a partir do arquivo X12. Você pode clicar em qualquer um destes números de fatura (como descrito abaixo) se você deseja fazer as correções antes do envio de informações é aplicada. Para aplicar as alterações, clique no botão Arquivo Processo ERA, na parte inferior da página. Isto produzirá uma nova janela com um relatório detalhado.');
INSERT INTO `lang_definitions` VALUES (13940, 1407, 13, 'Se você digitou uma data de pagamento na página de pesquisa, esta irá substituir a data de lançamento de pagamentos e ajustes que são de outra tiradas do arquivo X12. Isso pode ser útil para fins de notificação, se você quiser que o seu relatório de receitas para usar a sua data de lançamento, em vez de a companhia de seguros da data de processamento. Note que isso vai afetar também as datas de pagamentos, antes e ajustes que são postos em créditos secundário.');
INSERT INTO `lang_definitions` VALUES (13941, 1408, 13, 'Se pretender alterar os tipos de dados, ou adicionar linhas ou colunas');
INSERT INTO `lang_definitions` VALUES (13942, 1409, 13, 'Doença');
INSERT INTO `lang_definitions` VALUES (13943, 1410, 13, 'IM');
INSERT INTO `lang_definitions` VALUES (13944, 1411, 13, 'Vacinação');
INSERT INTO `lang_definitions` VALUES (13945, 1412, 13, 'Lote Número da Vacina');
INSERT INTO `lang_definitions` VALUES (13946, 1413, 13, 'Fabricante da Vacina');
INSERT INTO `lang_definitions` VALUES (13947, 1414, 13, 'Vacinas');
INSERT INTO `lang_definitions` VALUES (13948, 1415, 13, 'Vacinar');
INSERT INTO `lang_definitions` VALUES (13949, 1416, 13, 'Imunológicos');
INSERT INTO `lang_definitions` VALUES (13950, 1417, 13, 'Implantes');
INSERT INTO `lang_definitions` VALUES (13951, 1418, 13, 'Importar');
INSERT INTO `lang_definitions` VALUES (13952, 1419, 13, 'Importar configuração');
INSERT INTO `lang_definitions` VALUES (13953, 1420, 13, 'Paciente de Importação');
INSERT INTO `lang_definitions` VALUES (13954, 1421, 13, 'Importar Informações do Paciente');
INSERT INTO `lang_definitions` VALUES (13955, 1422, 13, 'Importado da Contabilidade');
INSERT INTO `lang_definitions` VALUES (13956, 1423, 13, 'Melhoria');
INSERT INTO `lang_definitions` VALUES (13957, 1424, 13, 'em');
INSERT INTO `lang_definitions` VALUES (13958, 1425, 13, 'EM');
INSERT INTO `lang_definitions` VALUES (13959, 1426, 13, 'em cada olho');
INSERT INTO `lang_definitions` VALUES (13960, 1427, 13, 'no olho esquerdo');
INSERT INTO `lang_definitions` VALUES (13961, 1428, 13, 'na narina');
INSERT INTO `lang_definitions` VALUES (13962, 1429, 13, 'Na Clínica - Disponível');
INSERT INTO `lang_definitions` VALUES (13963, 1430, 13, 'no olho direito');
INSERT INTO `lang_definitions` VALUES (13964, 1431, 13, 'em casa');
INSERT INTO `lang_definitions` VALUES (13965, 1432, 13, 'Inativo');
INSERT INTO `lang_definitions` VALUES (13966, 1433, 13, 'Inativo Dias');
INSERT INTO `lang_definitions` VALUES (13967, 1434, 13, 'Incluir os usuários inativos');
INSERT INTO `lang_definitions` VALUES (13968, 1435, 13, 'Incluir Uncategorized');
INSERT INTO `lang_definitions` VALUES (13969, 1436, 13, 'Incluir dados vitais');
INSERT INTO `lang_definitions` VALUES (13970, 1437, 13, 'Incluir dados vitais?');
INSERT INTO `lang_definitions` VALUES (13971, 1438, 13, 'Renda');
INSERT INTO `lang_definitions` VALUES (13972, 1439, 13, 'Aborto incompleto Tratamento');
INSERT INTO `lang_definitions` VALUES (13973, 1440, 13, 'Incontinência');
INSERT INTO `lang_definitions` VALUES (13974, 1441, 13, 'aumentou:');
INSERT INTO `lang_definitions` VALUES (13975, 1442, 13, 'Seguro de Indenização');
INSERT INTO `lang_definitions` VALUES (13976, 1443, 13, 'Indeterminado');
INSERT INTO `lang_definitions` VALUES (13977, 1444, 13, 'Indica se este problema está atualmente ativo');
INSERT INTO `lang_definitions` VALUES (13978, 1445, 13, 'Indigentes pacientes relatam');
INSERT INTO `lang_definitions` VALUES (13979, 1446, 13, 'Indigentes');
INSERT INTO `lang_definitions` VALUES (13980, 1447, 13, 'Aborto induzido');
INSERT INTO `lang_definitions` VALUES (13981, 1448, 13, 'Infecção / Abscesso');
INSERT INTO `lang_definitions` VALUES (13982, 1449, 13, 'Infecções');
INSERT INTO `lang_definitions` VALUES (13983, 1450, 13, 'Infertil Couns');
INSERT INTO `lang_definitions` VALUES (13984, 1451, 13, 'Infertilidade');
INSERT INTO `lang_definitions` VALUES (13985, 1452, 13, 'Influenza 1');
INSERT INTO `lang_definitions` VALUES (13986, 1453, 13, 'Influenza 2');
INSERT INTO `lang_definitions` VALUES (13987, 1454, 13, 'Info');
INSERT INTO `lang_definitions` VALUES (13988, 1455, 13, 'Info teste 1');
INSERT INTO `lang_definitions` VALUES (13989, 1456, 13, 'Info teste 2');
INSERT INTO `lang_definitions` VALUES (13990, 1457, 13, 'Info teste 3');
INSERT INTO `lang_definitions` VALUES (13991, 1458, 13, 'Info teste 4');
INSERT INTO `lang_definitions` VALUES (13992, 1459, 13, 'Info teste 5');
INSERT INTO `lang_definitions` VALUES (13993, 1460, 13, 'Info teste 6');
INSERT INTO `lang_definitions` VALUES (13994, 1461, 13, 'inalações');
INSERT INTO `lang_definitions` VALUES (13995, 1462, 13, 'inhilations');
INSERT INTO `lang_definitions` VALUES (13996, 1463, 13, 'Usuário inicial');
INSERT INTO `lang_definitions` VALUES (13997, 1464, 13, 'Injetáveis');
INSERT INTO `lang_definitions` VALUES (13998, 1465, 13, 'Feridos Out');
INSERT INTO `lang_definitions` VALUES (13999, 1466, 13, 'Lesão');
INSERT INTO `lang_definitions` VALUES (14000, 1467, 13, 'Mecanismo de lesão');
INSERT INTO `lang_definitions` VALUES (14001, 1468, 13, 'Lesão relatório geral');
INSERT INTO `lang_definitions` VALUES (14002, 1469, 13, 'Vigilância de Lesões');
INSERT INTO `lang_definitions` VALUES (14003, 1470, 13, 'Tipo de lesão');
INSERT INTO `lang_definitions` VALUES (14004, 1471, 13, 'Input Fields');
INSERT INTO `lang_definitions` VALUES (14005, 1472, 13, 'Ins ajustar');
INSERT INTO `lang_definitions` VALUES (14006, 1473, 13, 'Ins agregação');
INSERT INTO `lang_definitions` VALUES (14007, 1474, 13, 'Ins excesso');
INSERT INTO `lang_definitions` VALUES (14008, 1475, 13, 'Restituição Ins');
INSERT INTO `lang_definitions` VALUES (14009, 1476, 13, 'Ins Resumo');
INSERT INTO `lang_definitions` VALUES (14010, 1477, 13, 'Ins1');
INSERT INTO `lang_definitions` VALUES (14011, 1478, 13, 'Ins2');
INSERT INTO `lang_definitions` VALUES (14012, 1479, 13, 'Ins3');
INSERT INTO `lang_definitions` VALUES (14013, 1480, 13, 'Inserir falhou:');
INSERT INTO `lang_definitions` VALUES (14014, 1481, 13, 'Inserir eventos antigos em tabelas');
INSERT INTO `lang_definitions` VALUES (14015, 1482, 13, 'Insonia');
INSERT INTO `lang_definitions` VALUES (14016, 1483, 13, 'Inspeção');
INSERT INTO `lang_definitions` VALUES (14017, 1484, 13, 'Instabilidade / subluxação');
INSERT INTO `lang_definitions` VALUES (14018, 1485, 13, 'instalar DB');
INSERT INTO `lang_definitions` VALUES (14019, 1486, 13, 'Instruída');
INSERT INTO `lang_definitions` VALUES (14020, 1487, 13, 'Instruções:');
INSERT INTO `lang_definitions` VALUES (14021, 1488, 13, 'Insulino-dependente');
INSERT INTO `lang_definitions` VALUES (14022, 1489, 13, 'Seguros');
INSERT INTO `lang_definitions` VALUES (14023, 1490, 13, 'seguro');
INSERT INTO `lang_definitions` VALUES (14024, 1491, 13, 'Seguradoras');
INSERT INTO `lang_definitions` VALUES (14025, 1492, 13, 'Companhia de Seguros');
INSERT INTO `lang_definitions` VALUES (14026, 1493, 13, 'Companhia de Seguros de Pesquisa / Adicionar');
INSERT INTO `lang_definitions` VALUES (14027, 1494, 13, 'Dados Seguros');
INSERT INTO `lang_definitions` VALUES (14028, 1495, 13, 'Seguros Números');
INSERT INTO `lang_definitions` VALUES (14029, 1496, 13, 'Operadora de Seguros');
INSERT INTO `lang_definitions` VALUES (14030, 1497, 13, 'Ingestão de Conclusão');
INSERT INTO `lang_definitions` VALUES (14031, 1498, 13, 'Data de admissão');
INSERT INTO `lang_definitions` VALUES (14032, 1499, 13, 'Declínio Intelectual');
INSERT INTO `lang_definitions` VALUES (14033, 1500, 13, 'Erro interno - sem páginas foram selecionados!');
INSERT INTO `lang_definitions` VALUES (14034, 1501, 13, 'Erro interno - identificação do paciente não foi fornecida!');
INSERT INTO `lang_definitions` VALUES (14035, 1502, 13, 'Interno erro ao aceder ao ficheiro uploaded!');
INSERT INTO `lang_definitions` VALUES (14036, 1503, 13, 'Erro interno!');
INSERT INTO `lang_definitions` VALUES (14037, 1504, 13, 'Erro interno, nenhuma droga ID especificado!');
INSERT INTO `lang_definitions` VALUES (14038, 1505, 13, 'Erro interno: reclamação');
INSERT INTO `lang_definitions` VALUES (14039, 1506, 13, 'Erro interno: consulta \'');
INSERT INTO `lang_definitions` VALUES (14040, 1507, 13, 'Erro interno: PID ou Consulta está faltando.');
INSERT INTO `lang_definitions` VALUES (14041, 1508, 13, 'Interno Identifier (PID)');
INSERT INTO `lang_definitions` VALUES (14042, 1509, 13, 'Interno Referências');
INSERT INTO `lang_definitions` VALUES (14043, 1510, 13, 'Direito Internacional');
INSERT INTO `lang_definitions` VALUES (14044, 1511, 13, 'Intérprete');
INSERT INTO `lang_definitions` VALUES (14045, 1512, 13, 'Interpreter needed?');
INSERT INTO `lang_definitions` VALUES (14046, 1513, 13, 'Interstitial Lung Disease');
INSERT INTO `lang_definitions` VALUES (14047, 1514, 13, 'Intervalo');
INSERT INTO `lang_definitions` VALUES (14048, 1515, 13, 'Intolerância');
INSERT INTO `lang_definitions` VALUES (14049, 1516, 13, 'intramuscular');
INSERT INTO `lang_definitions` VALUES (14050, 1517, 13, 'intravenosa');
INSERT INTO `lang_definitions` VALUES (14051, 1518, 13, 'Introdução');
INSERT INTO `lang_definitions` VALUES (14052, 1519, 13, 'Inválido ou faltando ordenante na fonte para o código');
INSERT INTO `lang_definitions` VALUES (14053, 1520, 13, 'Invalid Service Códigos');
INSERT INTO `lang_definitions` VALUES (14054, 1521, 13, 'Invalid denominação de origem \"\"');
INSERT INTO `lang_definitions` VALUES (14055, 1522, 13, 'InvAmt');
INSERT INTO `lang_definitions` VALUES (14056, 1523, 13, 'Inventário');
INSERT INTO `lang_definitions` VALUES (14057, 1524, 13, 'Inventário não está disponível para este fim.');
INSERT INTO `lang_definitions` VALUES (14058, 1525, 13, 'Inventário');
INSERT INTO `lang_definitions` VALUES (14059, 1526, 13, 'Fatura');
INSERT INTO `lang_definitions` VALUES (14060, 1527, 13, 'fatura');
INSERT INTO `lang_definitions` VALUES (14061, 1528, 13, 'Data da fatura');
INSERT INTO `lang_definitions` VALUES (14062, 1529, 13, 'Fatura não tem data!');
INSERT INTO `lang_definitions` VALUES (14063, 1530, 13, 'Fatura:');
INSERT INTO `lang_definitions` VALUES (14064, 1531, 13, 'IPPF SRH dados para');
INSERT INTO `lang_definitions` VALUES (14065, 1532, 13, 'IPPF Relatório de Estatísticas');
INSERT INTO `lang_definitions` VALUES (14066, 1533, 13, 'VPI 1');
INSERT INTO `lang_definitions` VALUES (14067, 1534, 13, 'VPI 2');
INSERT INTO `lang_definitions` VALUES (14068, 1535, 13, 'VPI 3');
INSERT INTO `lang_definitions` VALUES (14069, 1536, 13, 'VPI 4');
INSERT INTO `lang_definitions` VALUES (14070, 1537, 13, 'Batimento cardíaco irregular');
INSERT INTO `lang_definitions` VALUES (14071, 1538, 13, 'Irritabilidade');
INSERT INTO `lang_definitions` VALUES (14072, 1539, 13, 'Irritação');
INSERT INTO `lang_definitions` VALUES (14073, 1540, 13, 'é um campo obrigatório.');
INSERT INTO `lang_definitions` VALUES (14074, 1541, 13, 'é um nó raiz e não pode ser excluído.');
INSERT INTO `lang_definitions` VALUES (14075, 1542, 13, 'não é válida (frações decimais são OK).');
INSERT INTO `lang_definitions` VALUES (14076, 1543, 13, 'PHP é utilizando o modo de segurança?');
INSERT INTO `lang_definitions` VALUES (14077, 1545, 13, 'problema');
INSERT INTO `lang_definitions` VALUES (14078, 1546, 13, 'Problema');
INSERT INTO `lang_definitions` VALUES (14079, 1547, 13, 'Questões');
INSERT INTO `lang_definitions` VALUES (14080, 1548, 13, 'Ocorrências (Lesões / Medical / Alergia):');
INSERT INTO `lang_definitions` VALUES (14081, 1549, 13, 'Questões e Consultas');
INSERT INTO `lang_definitions` VALUES (14082, 1550, 13, 'Questões e Consultas para');
INSERT INTO `lang_definitions` VALUES (14083, 1551, 13, 'Questões não autorizado');
INSERT INTO `lang_definitions` VALUES (14084, 1552, 13, 'A seção');
INSERT INTO `lang_definitions` VALUES (14085, 1553, 13, 'Item');
INSERT INTO `lang_definitions` VALUES (14086, 1554, 13, 'item');
INSERT INTO `lang_definitions` VALUES (14087, 1555, 13, 'Carregar itens não');
INSERT INTO `lang_definitions` VALUES (14088, 1556, 13, 'DIU');
INSERT INTO `lang_definitions` VALUES (14089, 1557, 13, 'IV');
INSERT INTO `lang_definitions` VALUES (14090, 1558, 13, 'Janeiro');
INSERT INTO `lang_definitions` VALUES (14091, 1559, 13, 'Icterícia');
INSERT INTO `lang_definitions` VALUES (14092, 1560, 13, 'Especialidade');
INSERT INTO `lang_definitions` VALUES (14093, 1561, 13, 'Job ID');
INSERT INTO `lang_definitions` VALUES (14094, 1562, 13, 'Luxações articulares');
INSERT INTO `lang_definitions` VALUES (14095, 1563, 13, 'Dor nas Articulações');
INSERT INTO `lang_definitions` VALUES (14096, 1564, 13, 'Entorses Comum');
INSERT INTO `lang_definitions` VALUES (14097, 1565, 13, 'Julho');
INSERT INTO `lang_definitions` VALUES (14098, 1566, 13, 'Junho');
INSERT INTO `lang_definitions` VALUES (14099, 1567, 13, 'Logo abaixo as informações de seleção é uma área azul onde você colocou em seus parâmetros de busca. Você pode pesquisar por nome do paciente, número de registro, número ou a data da Consulta de serviço, ou qualquer combinação destes. Você também pode selecionar se você quiser ver todas as notas fiscais, faturas em aberto, ou que são apenas faturas devidas (pelo paciente). Clique no botão Procurar para executar a pesquisa.');
INSERT INTO `lang_definitions` VALUES (14100, 1568, 13, 'Somente Minhas');
INSERT INTO `lang_definitions` VALUES (14101, 1569, 13, 'Justificar');
INSERT INTO `lang_definitions` VALUES (14102, 1570, 13, 'Justificar / Save');
INSERT INTO `lang_definitions` VALUES (14103, 1571, 13, 'ok, aqui está o resto');
INSERT INTO `lang_definitions` VALUES (14104, 1572, 13, 'Palavras-chave');
INSERT INTO `lang_definitions` VALUES (14105, 1573, 13, 'kg');
INSERT INTO `lang_definitions` VALUES (14106, 1574, 13, 'kg / m ^ 2');
INSERT INTO `lang_definitions` VALUES (14107, 1575, 13, 'Kidney Cancer');
INSERT INTO `lang_definitions` VALUES (14108, 1576, 13, 'Insuficiência Renal');
INSERT INTO `lang_definitions` VALUES (14109, 1577, 13, 'Infecções do Rim');
INSERT INTO `lang_definitions` VALUES (14110, 1578, 13, 'Pedras nos rins');
INSERT INTO `lang_definitions` VALUES (14111, 1579, 13, 'Transplante renal');
INSERT INTO `lang_definitions` VALUES (14112, 1580, 13, 'Joelho');
INSERT INTO `lang_definitions` VALUES (14113, 1581, 13, 'Problemas do Joelho');
INSERT INTO `lang_definitions` VALUES (14114, 1582, 13, 'Recolocação do joelho');
INSERT INTO `lang_definitions` VALUES (14115, 1583, 13, 'Lab');
INSERT INTO `lang_definitions` VALUES (14116, 1584, 13, 'Lab Report');
INSERT INTO `lang_definitions` VALUES (14117, 1585, 13, 'Rótulo');
INSERT INTO `lang_definitions` VALUES (14118, 1586, 13, 'Rótulo não pode estar em branco');
INSERT INTO `lang_definitions` VALUES (14119, 1587, 13, 'Label Cols');
INSERT INTO `lang_definitions` VALUES (14120, 1588, 13, 'LabelCols deve ser um número entre 1 e 999');
INSERT INTO `lang_definitions` VALUES (14121, 1589, 13, 'Labels');
INSERT INTO `lang_definitions` VALUES (14122, 1590, 13, 'Labs');
INSERT INTO `lang_definitions` VALUES (14123, 1591, 13, 'Laceração condição de pele /');
INSERT INTO `lang_definitions` VALUES (14124, 1592, 13, 'Laceração / abrasão');
INSERT INTO `lang_definitions` VALUES (14125, 1593, 13, 'Linguagem');
INSERT INTO `lang_definitions` VALUES (14126, 1594, 13, 'Código de idioma');
INSERT INTO `lang_definitions` VALUES (14127, 1595, 13, 'Definição de linguagem acrescentado');
INSERT INTO `lang_definitions` VALUES (14128, 1596, 13, 'Language Interface Tool');
INSERT INTO `lang_definitions` VALUES (14129, 1597, 13, 'Lista de Língua (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (14130, 1598, 13, 'Nome Language');
INSERT INTO `lang_definitions` VALUES (14131, 1599, 13, 'Idioma:');
INSERT INTO `lang_definitions` VALUES (14132, 1600, 13, 'Último');
INSERT INTO `lang_definitions` VALUES (14133, 1601, 13, 'Data Última');
INSERT INTO `lang_definitions` VALUES (14134, 1602, 13, 'Data da última fatura:');
INSERT INTO `lang_definitions` VALUES (14135, 1603, 13, 'Última Consulta');
INSERT INTO `lang_definitions` VALUES (14136, 1604, 13, 'Sobrenome');
INSERT INTO `lang_definitions` VALUES (14137, 1605, 13, 'Sobrenome');
INSERT INTO `lang_definitions` VALUES (14138, 1606, 13, 'Sobrenome');
INSERT INTO `lang_definitions` VALUES (14139, 1607, 13, 'Last Saved');
INSERT INTO `lang_definitions` VALUES (14140, 1608, 13, 'Última atualização por');
INSERT INTO `lang_definitions` VALUES (14141, 1609, 13, 'Sua última visita');
INSERT INTO `lang_definitions` VALUES (14142, 1610, 13, 'A recorrência tardia (2-12 Mo)');
INSERT INTO `lang_definitions` VALUES (14143, 1611, 13, 'Do maléolo lateral');
INSERT INTO `lang_definitions` VALUES (14144, 1612, 13, 'Maléolo lateral:');
INSERT INTO `lang_definitions` VALUES (14145, 1613, 13, 'deslocada lateralmente PMI:');
INSERT INTO `lang_definitions` VALUES (14146, 1614, 13, 'Layout Baseado');
INSERT INTO `lang_definitions` VALUES (14147, 1615, 13, 'Editor de Layout');
INSERT INTO `lang_definitions` VALUES (14148, 1616, 13, 'Grupos Layout');
INSERT INTO `lang_definitions` VALUES (14149, 1617, 13, 'Layout baseado Visite Formulários');
INSERT INTO `lang_definitions` VALUES (14150, 1618, 13, 'Layouts');
INSERT INTO `lang_definitions` VALUES (14151, 1619, 13, 'lb');
INSERT INTO `lang_definitions` VALUES (14152, 1620, 13, 'lbs');
INSERT INTO `lang_definitions` VALUES (14153, 1621, 13, 'LDL');
INSERT INTO `lang_definitions` VALUES (14154, 1622, 13, 'deixe em branco se ainda está ativo');
INSERT INTO `lang_definitions` VALUES (14155, 1623, 13, 'Deixe em branco para manter inalterada a senha.');
INSERT INTO `lang_definitions` VALUES (14156, 1624, 13, 'Deixar recado com');
INSERT INTO `lang_definitions` VALUES (14157, 1625, 13, 'Deixe o formulário');
INSERT INTO `lang_definitions` VALUES (14158, 1626, 13, 'Esquerdo');
INSERT INTO `lang_definitions` VALUES (14159, 1627, 13, 'Orelha Esquerda');
INSERT INTO `lang_definitions` VALUES (14160, 1628, 13, 'orelha esquerda');
INSERT INTO `lang_definitions` VALUES (14161, 1629, 13, 'Esquerda:');
INSERT INTO `lang_definitions` VALUES (14162, 1630, 13, 'Esquerda:');
INSERT INTO `lang_definitions` VALUES (14163, 1631, 13, 'Dor na Perna / cólicas');
INSERT INTO `lang_definitions` VALUES (14164, 1632, 13, 'Legal');
INSERT INTO `lang_definitions` VALUES (14165, 1633, 13, 'Legenda:');
INSERT INTO `lang_definitions` VALUES (14166, 1634, 13, 'Comprimento');
INSERT INTO `lang_definitions` VALUES (14167, 1635, 13, 'Menos de informações privado (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (14168, 1636, 13, 'Carta');
INSERT INTO `lang_definitions` VALUES (14169, 1637, 13, 'Letter Generator');
INSERT INTO `lang_definitions` VALUES (14170, 1640, 13, 'Nível de urgência');
INSERT INTO `lang_definitions` VALUES (14171, 1641, 13, 'Responsabilidade');
INSERT INTO `lang_definitions` VALUES (14172, 1642, 13, 'Responsabilidade Médica');
INSERT INTO `lang_definitions` VALUES (14173, 1643, 13, 'RG');
INSERT INTO `lang_definitions` VALUES (14174, 1644, 13, 'Hábitos');
INSERT INTO `lang_definitions` VALUES (14175, 1645, 13, 'Ligamento lágrima ou entorse');
INSERT INTO `lang_definitions` VALUES (14176, 1646, 13, 'Limite de Eventos');
INSERT INTO `lang_definitions` VALUES (14177, 1649, 13, 'Lista');
INSERT INTO `lang_definitions` VALUES (14178, 1650, 13, 'Caixa de lista');
INSERT INTO `lang_definitions` VALUES (14179, 1651, 13, 'caixa de lista');
INSERT INTO `lang_definitions` VALUES (14180, 1652, 13, 'w caixa de lista / add');
INSERT INTO `lang_definitions` VALUES (14181, 1653, 13, 'W Lista de caixa / add');
INSERT INTO `lang_definitions` VALUES (14182, 1654, 13, 'List Editor');
INSERT INTO `lang_definitions` VALUES (14183, 1655, 13, 'Lista de grupos');
INSERT INTO `lang_definitions` VALUES (14184, 1656, 13, 'Seguradoras Lista');
INSERT INTO `lang_definitions` VALUES (14185, 1657, 13, 'Os itens da lista não pode começar com um número.');
INSERT INTO `lang_definitions` VALUES (14186, 1658, 13, 'Os itens da lista contém caracteres ilegais (s).');
INSERT INTO `lang_definitions` VALUES (14187, 1659, 13, 'Lista de listas');
INSERT INTO `lang_definitions` VALUES (14188, 1660, 13, 'Nome da lista');
INSERT INTO `lang_definitions` VALUES (14189, 1661, 13, 'Lista de nomes não podem começar com números.');
INSERT INTO `lang_definitions` VALUES (14190, 1662, 13, 'Prescrição List');
INSERT INTO `lang_definitions` VALUES (14191, 1663, 13, 'Listas');
INSERT INTO `lang_definitions` VALUES (14192, 1664, 13, 'LLL:');
INSERT INTO `lang_definitions` VALUES (14193, 1665, 13, 'LMP');
INSERT INTO `lang_definitions` VALUES (14194, 1666, 13, 'Definições de carga');
INSERT INTO `lang_definitions` VALUES (14195, 1667, 13, 'CARGA');
INSERT INTO `lang_definitions` VALUES (14196, 1668, 13, 'LOC');
INSERT INTO `lang_definitions` VALUES (14197, 1669, 13, 'Local');
INSERT INTO `lang_definitions` VALUES (14198, 1670, 13, 'Estado');
INSERT INTO `lang_definitions` VALUES (14199, 1671, 13, 'Local');
INSERT INTO `lang_definitions` VALUES (14200, 1672, 13, 'Localização não especificada');
INSERT INTO `lang_definitions` VALUES (14201, 1673, 13, 'Localização:');
INSERT INTO `lang_definitions` VALUES (14202, 1675, 13, 'Logado');
INSERT INTO `lang_definitions` VALUES (14203, 1676, 13, 'Logado como');
INSERT INTO `lang_definitions` VALUES (14204, 1677, 13, 'Logado como:');
INSERT INTO `lang_definitions` VALUES (14205, 1678, 13, 'Desconectado.');
INSERT INTO `lang_definitions` VALUES (14206, 1679, 13, 'Login');
INSERT INTO `lang_definitions` VALUES (14207, 1680, 13, 'login');
INSERT INTO `lang_definitions` VALUES (14208, 1681, 13, 'Sair');
INSERT INTO `lang_definitions` VALUES (14209, 1682, 13, 'sair');
INSERT INTO `lang_definitions` VALUES (14210, 1683, 13, 'Históricos');
INSERT INTO `lang_definitions` VALUES (14211, 1684, 13, 'Históricos Viewer');
INSERT INTO `lang_definitions` VALUES (14212, 1685, 13, 'Look Up');
INSERT INTO `lang_definitions` VALUES (14213, 1686, 13, 'Lote');
INSERT INTO `lang_definitions` VALUES (14214, 1687, 13, 'Lote ID faltando!');
INSERT INTO `lang_definitions` VALUES (14215, 1688, 13, 'Número de lote');
INSERT INTO `lang_definitions` VALUES (14216, 1689, 13, 'Baixo');
INSERT INTO `lang_definitions` VALUES (14217, 1690, 13, 'Perna');
INSERT INTO `lang_definitions` VALUES (14218, 1691, 13, 'Coluna lombar');
INSERT INTO `lang_definitions` VALUES (14219, 1692, 13, 'Horário de Almoço');
INSERT INTO `lang_definitions` VALUES (14220, 1693, 13, 'Horário de Almoço');
INSERT INTO `lang_definitions` VALUES (14221, 1694, 13, 'Câncer de Pulmão');
INSERT INTO `lang_definitions` VALUES (14222, 1695, 13, 'Cirurgia de Câncer de Pulmão');
INSERT INTO `lang_definitions` VALUES (14223, 1696, 13, 'Pulmões:');
INSERT INTO `lang_definitions` VALUES (14224, 1697, 13, 'Pulmões:');
INSERT INTO `lang_definitions` VALUES (14225, 1698, 13, 'Lupus');
INSERT INTO `lang_definitions` VALUES (14226, 1699, 13, 'M');
INSERT INTO `lang_definitions` VALUES (14227, 1700, 13, 'MA Categoria');
INSERT INTO `lang_definitions` VALUES (14228, 1701, 13, 'Endereço principal');
INSERT INTO `lang_definitions` VALUES (14229, 1702, 13, 'Faça modificações categorias atuais.');
INSERT INTO `lang_definitions` VALUES (14230, 1703, 13, 'Certifique-se de \"\"');
INSERT INTO `lang_definitions` VALUES (14231, 1704, 13, 'Mal-estar:');
INSERT INTO `lang_definitions` VALUES (14232, 1705, 13, 'Masculino');
INSERT INTO `lang_definitions` VALUES (14233, 1706, 13, 'Preservativos Masculinos');
INSERT INTO `lang_definitions` VALUES (14234, 1707, 13, 'Masculino VSC');
INSERT INTO `lang_definitions` VALUES (14235, 1708, 13, 'Mamografia');
INSERT INTO `lang_definitions` VALUES (14236, 1709, 13, 'Gerenciamento');
INSERT INTO `lang_definitions` VALUES (14237, 1710, 13, 'Lançamento manual');
INSERT INTO `lang_definitions` VALUES (14238, 1711, 13, 'Fabricante');
INSERT INTO `lang_definitions` VALUES (14239, 1712, 13, 'Março');
INSERT INTO `lang_definitions` VALUES (14240, 1713, 13, 'Estado Civil');
INSERT INTO `lang_definitions` VALUES (14241, 1714, 13, 'Marcar como bico, mas pular de faturamento');
INSERT INTO `lang_definitions` VALUES (14242, 1715, 13, 'Marcar como Cleared');
INSERT INTO `lang_definitions` VALUES (14243, 1716, 13, 'Marcar como não faturado');
INSERT INTO `lang_definitions` VALUES (14244, 1717, 13, 'Marcado como apuradas');
INSERT INTO `lang_definitions` VALUES (14245, 1718, 13, 'Casado');
INSERT INTO `lang_definitions` VALUES (14246, 1719, 13, 'Maxilar direito:');
INSERT INTO `lang_definitions` VALUES (14247, 1720, 13, 'Maio');
INSERT INTO `lang_definitions` VALUES (14248, 1721, 13, 'MC');
INSERT INTO `lang_definitions` VALUES (14249, 1722, 13, 'mcg');
INSERT INTO `lang_definitions` VALUES (14250, 1723, 13, 'Maléolo medial:');
INSERT INTO `lang_definitions` VALUES (14251, 1724, 13, 'Medicaid');
INSERT INTO `lang_definitions` VALUES (14252, 1725, 13, 'Medicina');
INSERT INTO `lang_definitions` VALUES (14253, 1726, 13, 'Aborto Medicinal');
INSERT INTO `lang_definitions` VALUES (14254, 1727, 13, 'Problema médico');
INSERT INTO `lang_definitions` VALUES (14255, 1728, 13, 'Anotações do Paciente');
INSERT INTO `lang_definitions` VALUES (14256, 1729, 13, 'Histórico');
INSERT INTO `lang_definitions` VALUES (14257, 1730, 13, 'Histórico #');
INSERT INTO `lang_definitions` VALUES (14258, 1731, 13, 'Registros Médicos');
INSERT INTO `lang_definitions` VALUES (14259, 1732, 13, 'Medicina / História (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (14260, 1733, 13, 'Medicare Part B');
INSERT INTO `lang_definitions` VALUES (14261, 1734, 13, 'Medicação');
INSERT INTO `lang_definitions` VALUES (14262, 1735, 13, 'Medicações');
INSERT INTO `lang_definitions` VALUES (14263, 1736, 13, 'Medicamentos:');
INSERT INTO `lang_definitions` VALUES (14264, 1737, 13, 'Unidades de Medicina');
INSERT INTO `lang_definitions` VALUES (14265, 1738, 13, 'Médio');
INSERT INTO `lang_definitions` VALUES (14266, 1739, 13, 'Membro da Associação Relatório de Estatísticas');
INSERT INTO `lang_definitions` VALUES (14267, 1740, 13, 'Problemas de memória');
INSERT INTO `lang_definitions` VALUES (14268, 1741, 13, 'Homens');
INSERT INTO `lang_definitions` VALUES (14269, 1742, 13, 'Homens e Mulheres');
INSERT INTO `lang_definitions` VALUES (14270, 1743, 13, 'Men Only');
INSERT INTO `lang_definitions` VALUES (14271, 1744, 13, 'Menarca');
INSERT INTO `lang_definitions` VALUES (14272, 1745, 13, 'Menopausa');
INSERT INTO `lang_definitions` VALUES (14273, 1746, 13, 'Fluxo menstrual');
INSERT INTO `lang_definitions` VALUES (14274, 1747, 13, 'Menstrual Freqüência');
INSERT INTO `lang_definitions` VALUES (14275, 1748, 13, 'Doença Mental');
INSERT INTO `lang_definitions` VALUES (14276, 1749, 13, 'Mensagem');
INSERT INTO `lang_definitions` VALUES (14277, 1750, 13, 'MENSAGEM:');
INSERT INTO `lang_definitions` VALUES (14278, 1751, 13, 'Método');
INSERT INTO `lang_definitions` VALUES (14279, 1752, 13, 'Método de Destruição');
INSERT INTO `lang_definitions` VALUES (14280, 1753, 13, 'mg');
INSERT INTO `lang_definitions` VALUES (14281, 1754, 13, 'mg/1cc');
INSERT INTO `lang_definitions` VALUES (14282, 1755, 13, 'mg/2cc');
INSERT INTO `lang_definitions` VALUES (14283, 1756, 13, 'mg/3cc');
INSERT INTO `lang_definitions` VALUES (14284, 1757, 13, 'mg/4cc');
INSERT INTO `lang_definitions` VALUES (14285, 1758, 13, 'mg/5cc');
INSERT INTO `lang_definitions` VALUES (14286, 1759, 13, 'Médio');
INSERT INTO `lang_definitions` VALUES (14287, 1760, 13, 'Nome do Meio');
INSERT INTO `lang_definitions` VALUES (14288, 1761, 13, 'Nome do meio');
INSERT INTO `lang_definitions` VALUES (14289, 1762, 13, 'Migrantes ou sazonal?');
INSERT INTO `lang_definitions` VALUES (14290, 1763, 13, 'Migrantes / Seasonal');
INSERT INTO `lang_definitions` VALUES (14291, 1764, 13, 'MimeType');
INSERT INTO `lang_definitions` VALUES (14292, 1765, 13, 'min');
INSERT INTO `lang_definitions` VALUES (14293, 1766, 13, 'Menor tensão comum + / - sinovite');
INSERT INTO `lang_definitions` VALUES (14294, 1767, 13, 'minutos');
INSERT INTO `lang_definitions` VALUES (14295, 1768, 13, 'Minutos');
INSERT INTO `lang_definitions` VALUES (14296, 1769, 13, 'Misc');
INSERT INTO `lang_definitions` VALUES (14297, 1770, 13, 'Opções de Pagamento Misc');
INSERT INTO `lang_definitions` VALUES (14298, 1771, 13, 'Opções de Faturamento Misc para HCFA-1500');
INSERT INTO `lang_definitions` VALUES (14299, 1772, 13, 'Faturamento Misc Opções HCFA');
INSERT INTO `lang_definitions` VALUES (14300, 1773, 13, 'Diversos');
INSERT INTO `lang_definitions` VALUES (14301, 1774, 13, 'Missed');
INSERT INTO `lang_definitions` VALUES (14302, 1775, 13, 'Missing Fee');
INSERT INTO `lang_definitions` VALUES (14303, 1776, 13, 'Missing PID.');
INSERT INTO `lang_definitions` VALUES (14304, 1777, 13, 'Missing barra depois ordenante na origem para o código');
INSERT INTO `lang_definitions` VALUES (14305, 1778, 13, 'Mixed');
INSERT INTO `lang_definitions` VALUES (14306, 1779, 13, 'ml');
INSERT INTO `lang_definitions` VALUES (14307, 1780, 13, 'mm / Hg');
INSERT INTO `lang_definitions` VALUES (14308, 1781, 13, 'VASPR 1');
INSERT INTO `lang_definitions` VALUES (14309, 1782, 13, 'MMR 2');
INSERT INTO `lang_definitions` VALUES (14310, 1783, 13, 'Móvel');
INSERT INTO `lang_definitions` VALUES (14311, 1784, 13, 'Telefone Celular');
INSERT INTO `lang_definitions` VALUES (14312, 1785, 13, 'Mod');
INSERT INTO `lang_definitions` VALUES (14313, 1786, 13, 'Modifier');
INSERT INTO `lang_definitions` VALUES (14314, 1787, 13, 'Seg');
INSERT INTO `lang_definitions` VALUES (14315, 1788, 13, 'Seg à Sex');
INSERT INTO `lang_definitions` VALUES (14316, 1789, 13, 'Seg, Qua e Sex');
INSERT INTO `lang_definitions` VALUES (14317, 1790, 13, 'Segunda-feira');
INSERT INTO `lang_definitions` VALUES (14318, 1791, 13, 'mês');
INSERT INTO `lang_definitions` VALUES (14319, 1792, 13, 'Mês');
INSERT INTO `lang_definitions` VALUES (14320, 1793, 13, 'Ver mês');
INSERT INTO `lang_definitions` VALUES (14321, 1794, 13, 'Mês (s)');
INSERT INTO `lang_definitions` VALUES (14322, 1795, 13, 'Renda Mensal');
INSERT INTO `lang_definitions` VALUES (14323, 1796, 13, 'Mais de 100 registros encontrados. Restrinja a sua pesquisa.');
INSERT INTO `lang_definitions` VALUES (14324, 1797, 13, 'Mais de 50 resultados, por favor faça sua busca mais específica.');
INSERT INTO `lang_definitions` VALUES (14325, 1798, 13, 'Mãe');
INSERT INTO `lang_definitions` VALUES (14326, 1799, 13, 'Boca');
INSERT INTO `lang_definitions` VALUES (14327, 1800, 13, 'Mover');
INSERT INTO `lang_definitions` VALUES (14328, 1801, 13, 'Mover documento para a categoria:');
INSERT INTO `lang_definitions` VALUES (14329, 1802, 13, 'Mover para baixo');
INSERT INTO `lang_definitions` VALUES (14330, 1803, 13, 'Mover-se para Paciente');
INSERT INTO `lang_definitions` VALUES (14331, 1804, 13, 'Mover para...');
INSERT INTO `lang_definitions` VALUES (14332, 1805, 13, 'Mover para cima');
INSERT INTO `lang_definitions` VALUES (14333, 1806, 13, 'Sr.');
INSERT INTO `lang_definitions` VALUES (14334, 1807, 13, 'Sra.');
INSERT INTO `lang_definitions` VALUES (14335, 1808, 13, 'Srta.');
INSERT INTO `lang_definitions` VALUES (14336, 1809, 13, 'Ferramenta Multi Linguagens');
INSERT INTO `lang_definitions` VALUES (14337, 1810, 13, 'Várias áreas');
INSERT INTO `lang_definitions` VALUES (14338, 1811, 13, 'Murmur:');
INSERT INTO `lang_definitions` VALUES (14339, 1812, 13, 'Musc Dor');
INSERT INTO `lang_definitions` VALUES (14340, 1813, 13, 'Musc Dores');
INSERT INTO `lang_definitions` VALUES (14341, 1814, 13, 'Vermelhidão Musc');
INSERT INTO `lang_definitions` VALUES (14342, 1815, 13, 'Musc Rigidez');
INSERT INTO `lang_definitions` VALUES (14343, 1816, 13, 'Musc Inchaço');
INSERT INTO `lang_definitions` VALUES (14344, 1817, 13, 'Warm Musc');
INSERT INTO `lang_definitions` VALUES (14345, 1818, 13, 'Músculo');
INSERT INTO `lang_definitions` VALUES (14346, 1819, 13, 'Lesão muscular');
INSERT INTO `lang_definitions` VALUES (14347, 1820, 13, 'Musculosqueléticas');
INSERT INTO `lang_definitions` VALUES (14348, 1821, 13, 'Definido mutuamente');
INSERT INTO `lang_definitions` VALUES (14349, 1822, 13, 'MVA');
INSERT INTO `lang_definitions` VALUES (14350, 1823, 13, 'N / A');
INSERT INTO `lang_definitions` VALUES (14351, 1824, 13, 'n / a');
INSERT INTO `lang_definitions` VALUES (14352, 1825, 13, 'Nome');
INSERT INTO `lang_definitions` VALUES (14353, 1826, 13, 'Nome 1');
INSERT INTO `lang_definitions` VALUES (14354, 1827, 13, 'Nome 2');
INSERT INTO `lang_definitions` VALUES (14355, 1828, 13, 'Gerenciamento de Vacinas');
INSERT INTO `lang_definitions` VALUES (14356, 1829, 13, 'Nome da seguradora');
INSERT INTO `lang_definitions` VALUES (14357, 1830, 13, 'Nome da Operadora');
INSERT INTO `lang_definitions` VALUES (14358, 1831, 13, 'Tradução Nome');
INSERT INTO `lang_definitions` VALUES (14359, 1832, 13, 'Nome / Valor');
INSERT INTO `lang_definitions` VALUES (14360, 1833, 13, 'Nome:');
INSERT INTO `lang_definitions` VALUES (14361, 1834, 13, 'NARES:');
INSERT INTO `lang_definitions` VALUES (14362, 1835, 13, 'NARES: Normal Direito');
INSERT INTO `lang_definitions` VALUES (14363, 1836, 13, 'Mucosa nasal mediana-de-rosa, septo');
INSERT INTO `lang_definitions` VALUES (14364, 1837, 13, 'Nacionalidade');
INSERT INTO `lang_definitions` VALUES (14365, 1838, 13, 'Náuseas');
INSERT INTO `lang_definitions` VALUES (14366, 1839, 13, 'Navegação');
INSERT INTO `lang_definitions` VALUES (14367, 1840, 13, 'NDC');
INSERT INTO `lang_definitions` VALUES (14368, 1841, 13, 'Número do NDC');
INSERT INTO `lang_definitions` VALUES (14369, 1842, 13, 'Pescoço');
INSERT INTO `lang_definitions` VALUES (14370, 1843, 13, 'Problemas no pescoço');
INSERT INTO `lang_definitions` VALUES (14371, 1844, 13, 'Pescoço flexível');
INSERT INTO `lang_definitions` VALUES (14372, 1845, 13, 'Necessidade de introduzir uma descrição');
INSERT INTO `lang_definitions` VALUES (14373, 1846, 13, 'Necessidade de introduzir um valor de retorno');
INSERT INTO `lang_definitions` VALUES (14374, 1847, 13, 'Necessidade de introduzir identificador');
INSERT INTO `lang_definitions` VALUES (14375, 1848, 13, 'Necessidade de introduzir o título');
INSERT INTO `lang_definitions` VALUES (14376, 1849, 13, 'Necessidades Auth');
INSERT INTO `lang_definitions` VALUES (14377, 1850, 13, 'Necessidades Justify');
INSERT INTO `lang_definitions` VALUES (14378, 1851, 13, 'Necessidades de faturamento secundário');
INSERT INTO `lang_definitions` VALUES (14379, 1852, 13, 'A lesão nervosa');
INSERT INTO `lang_definitions` VALUES (14380, 1853, 13, 'Condição Neural / dano nervoso');
INSERT INTO `lang_definitions` VALUES (14381, 1854, 13, 'Neuro Dormência');
INSERT INTO `lang_definitions` VALUES (14382, 1855, 13, 'Fraqueza Neuro');
INSERT INTO `lang_definitions` VALUES (14383, 1856, 13, 'Neurológicas');
INSERT INTO `lang_definitions` VALUES (14384, 1857, 13, 'Novo');
INSERT INTO `lang_definitions` VALUES (14385, 1858, 13, 'Novo =>');
INSERT INTO `lang_definitions` VALUES (14386, 1859, 13, 'Nova Aceitadores');
INSERT INTO `lang_definitions` VALUES (14387, 1860, 13, 'Nova Alergia');
INSERT INTO `lang_definitions` VALUES (14388, 1861, 13, 'Nova Consulta');
INSERT INTO `lang_definitions` VALUES (14389, 1862, 13, 'Novas Categorias');
INSERT INTO `lang_definitions` VALUES (14390, 1863, 13, 'Nova Categoria');
INSERT INTO `lang_definitions` VALUES (14391, 1864, 13, 'Novos pacientes');
INSERT INTO `lang_definitions` VALUES (14392, 1865, 13, 'Nova Consulta');
INSERT INTO `lang_definitions` VALUES (14393, 1866, 13, 'Novo conjunto de definições adicionados');
INSERT INTO `lang_definitions` VALUES (14394, 1867, 13, 'Novo Documento');
INSERT INTO `lang_definitions` VALUES (14395, 1868, 13, 'Formulário de nova consulta');
INSERT INTO `lang_definitions` VALUES (14396, 1869, 13, 'Nova consulta não autorizada');
INSERT INTO `lang_definitions` VALUES (14397, 1870, 13, 'Nova Consulta');
INSERT INTO `lang_definitions` VALUES (14398, 1871, 13, 'Informações da Nova Clínica');
INSERT INTO `lang_definitions` VALUES (14399, 1872, 13, 'Novo Grupo');
INSERT INTO `lang_definitions` VALUES (14400, 1873, 13, 'Novo Grupo de Informação');
INSERT INTO `lang_definitions` VALUES (14401, 1874, 13, 'New Limit de Eventos');
INSERT INTO `lang_definitions` VALUES (14402, 1875, 13, 'Nova Lista');
INSERT INTO `lang_definitions` VALUES (14403, 1876, 13, 'Novo Paciente');
INSERT INTO `lang_definitions` VALUES (14404, 1877, 13, 'Consulta de novo paciente');
INSERT INTO `lang_definitions` VALUES (14405, 1878, 13, 'Novo Paciente ID');
INSERT INTO `lang_definitions` VALUES (14406, 1879, 13, 'Novo Pt');
INSERT INTO `lang_definitions` VALUES (14407, 1880, 13, 'Submissões Novo');
INSERT INTO `lang_definitions` VALUES (14408, 1881, 13, 'Novo Usuário');
INSERT INTO `lang_definitions` VALUES (14409, 1882, 13, 'Nova Visita');
INSERT INTO `lang_definitions` VALUES (14410, 1883, 13, 'Novo / Buscar');
INSERT INTO `lang_definitions` VALUES (14411, 1884, 13, 'Jornal');
INSERT INTO `lang_definitions` VALUES (14412, 1885, 13, 'Próximo');
INSERT INTO `lang_definitions` VALUES (14413, 1886, 13, 'Próximo Dia');
INSERT INTO `lang_definitions` VALUES (14414, 1887, 13, 'Próximo Mês');
INSERT INTO `lang_definitions` VALUES (14415, 1888, 13, 'Próxima Semana');
INSERT INTO `lang_definitions` VALUES (14416, 1889, 13, 'Apelido');
INSERT INTO `lang_definitions` VALUES (14417, 1890, 13, 'Suores noturnos');
INSERT INTO `lang_definitions` VALUES (14418, 1891, 13, 'Genitais ext Nl, vag mucosa, colo do útero');
INSERT INTO `lang_definitions` VALUES (14419, 1892, 13, 'Não');
INSERT INTO `lang_definitions` VALUES (14420, 1893, 13, 'Não');
INSERT INTO `lang_definitions` VALUES (14421, 1894, 13, 'Sem acesso');
INSERT INTO `lang_definitions` VALUES (14422, 1895, 13, 'No adenopatia (2 áreas necessárias)');
INSERT INTO `lang_definitions` VALUES (14423, 1896, 13, 'No ternura adnexal / massas');
INSERT INTO `lang_definitions` VALUES (14424, 1897, 13, 'No sistema de faturamento está atualmente activo');
INSERT INTO `lang_definitions` VALUES (14425, 1898, 13, 'Nenhum Bills a incluir em OFX Exportação <br>');
INSERT INTO `lang_definitions` VALUES (14426, 1899, 13, 'Nenhum código foi especificado!');
INSERT INTO `lang_definitions` VALUES (14427, 1900, 13, 'Nenhum diagnóstico');
INSERT INTO `lang_definitions` VALUES (14428, 1901, 13, 'Sem data final');
INSERT INTO `lang_definitions` VALUES (14429, 1902, 13, 'Não foram encontradas entradas, use o formulário abaixo para adicionar uma entrada.');
INSERT INTO `lang_definitions` VALUES (14430, 1903, 13, 'Não há eventos');
INSERT INTO `lang_definitions` VALUES (14431, 1904, 13, 'Nenhum grupo foi selecionado');
INSERT INTO `lang_definitions` VALUES (14432, 1905, 13, 'No hérnia');
INSERT INTO `lang_definitions` VALUES (14433, 1906, 13, 'No Seguradoras Encontrada');
INSERT INTO `lang_definitions` VALUES (14434, 1907, 13, 'Nenhum item foi selecionado!');
INSERT INTO `lang_definitions` VALUES (14435, 1908, 13, 'No massas, ternura');
INSERT INTO `lang_definitions` VALUES (14436, 1909, 13, 'No notes');
INSERT INTO `lang_definitions` VALUES (14437, 1910, 13, 'No ogrganomegoly');
INSERT INTO `lang_definitions` VALUES (14438, 1911, 13, 'Não foram encontradas vagas para este período.');
INSERT INTO `lang_definitions` VALUES (14439, 1912, 13, 'Não encontrou parceiros');
INSERT INTO `lang_definitions` VALUES (14440, 1913, 13, 'Não havia edema periférico');
INSERT INTO `lang_definitions` VALUES (14441, 1914, 13, 'Nenhuma Farmácias');
INSERT INTO `lang_definitions` VALUES (14442, 1915, 13, 'Nenhuma Prescrição');
INSERT INTO `lang_definitions` VALUES (14443, 1916, 13, 'Nenhuma doença que apresenta / lesão');
INSERT INTO `lang_definitions` VALUES (14444, 1917, 13, 'Sem Indicação');
INSERT INTO `lang_definitions` VALUES (14445, 1918, 13, 'Ausência de lesões cutânea ou anormal');
INSERT INTO `lang_definitions` VALUES (14446, 1919, 13, 'Não foram encontrados registos. Por favor, expandir os seus critérios de busca.');
INSERT INTO `lang_definitions` VALUES (14447, 1920, 13, 'Nenhum resultado');
INSERT INTO `lang_definitions` VALUES (14448, 1921, 13, 'Nenhum resultados de busca');
INSERT INTO `lang_definitions` VALUES (14449, 1922, 13, 'Não há resultados, por favor bandeja novamente.');
INSERT INTO `lang_definitions` VALUES (14450, 1923, 13, 'Não há resultados, por favor, tente novamente.');
INSERT INTO `lang_definitions` VALUES (14451, 1924, 13, 'Não Compareceu');
INSERT INTO `lang_definitions` VALUES (14452, 1925, 13, 'No Tenderness Sinus:');
INSERT INTO `lang_definitions` VALUES (14453, 1926, 13, 'Nódulos no ondear da pele ou da mama');
INSERT INTO `lang_definitions` VALUES (14454, 1927, 13, 'No ternura testicular, massas');
INSERT INTO `lang_definitions` VALUES (14455, 1928, 13, 'No emoções ou heaves');
INSERT INTO `lang_definitions` VALUES (14456, 1929, 13, 'Nenhuma visita');
INSERT INTO `lang_definitions` VALUES (14457, 1930, 13, 'Não, Cancelar');
INSERT INTO `lang_definitions` VALUES (14458, 1931, 13, 'Não:');
INSERT INTO `lang_definitions` VALUES (14459, 1932, 13, 'Noctúria');
INSERT INTO `lang_definitions` VALUES (14460, 1933, 13, 'Non lesão específica');
INSERT INTO `lang_definitions` VALUES (14461, 1934, 13, 'Não-insulino-dependente');
INSERT INTO `lang_definitions` VALUES (14462, 1935, 13, 'Non-SRH Médica');
INSERT INTO `lang_definitions` VALUES (14463, 1936, 13, 'Non-SRH não-médicos');
INSERT INTO `lang_definitions` VALUES (14464, 1937, 13, 'Nenhum');
INSERT INTO `lang_definitions` VALUES (14465, 1938, 13, 'nenhum');
INSERT INTO `lang_definitions` VALUES (14466, 1939, 13, 'Nenhuma das anteriores');
INSERT INTO `lang_definitions` VALUES (14467, 1940, 13, 'Noninsulin Dependent Diabetes');
INSERT INTO `lang_definitions` VALUES (14468, 1941, 13, 'Nem');
INSERT INTO `lang_definitions` VALUES (14469, 1942, 13, 'Normal');
INSERT INTO `lang_definitions` VALUES (14470, 1943, 13, 'Normal BL');
INSERT INTO `lang_definitions` VALUES (14471, 1944, 13, 'Exame cardíaco normal:');
INSERT INTO `lang_definitions` VALUES (14472, 1945, 13, 'Exame cardíaco normal:');
INSERT INTO `lang_definitions` VALUES (14473, 1946, 13, 'Exame Pulmonar Normal:');
INSERT INTO `lang_definitions` VALUES (14474, 1947, 13, 'Exame Pulmonar Normal:');
INSERT INTO `lang_definitions` VALUES (14475, 1948, 13, 'Normal Office Visite');
INSERT INTO `lang_definitions` VALUES (14476, 1949, 13, 'Orofaringe normal:');
INSERT INTO `lang_definitions` VALUES (14477, 1950, 13, 'Normal Direito');
INSERT INTO `lang_definitions` VALUES (14478, 1951, 13, 'Normal Direito:');
INSERT INTO `lang_definitions` VALUES (14479, 1952, 13, 'Normal View');
INSERT INTO `lang_definitions` VALUES (14480, 1953, 13, 'normal:');
INSERT INTO `lang_definitions` VALUES (14481, 1954, 13, 'Norueguês');
INSERT INTO `lang_definitions` VALUES (14482, 1955, 13, 'Nariz');
INSERT INTO `lang_definitions` VALUES (14483, 1956, 13, 'Nariz bleed');
INSERT INTO `lang_definitions` VALUES (14484, 1957, 13, 'Nem todos os campos são obrigatórios para todos os tipos de códigos ou códigos.');
INSERT INTO `lang_definitions` VALUES (14485, 1958, 13, 'Não Desejados');
INSERT INTO `lang_definitions` VALUES (14486, 1959, 13, 'Não é permitida a exclusão do grupo de administradores');
INSERT INTO `lang_definitions` VALUES (14487, 1960, 13, 'Não é permitida a desativação de todos os objetos de segurança');
INSERT INTO `lang_definitions` VALUES (14488, 1961, 13, 'Não permitido para inativar qualquer coisa da Segurança dos Administradores');
INSERT INTO `lang_definitions` VALUES (14489, 1962, 13, 'Não é permitido remover o usuário Administrador do grupo Administradores');
INSERT INTO `lang_definitions` VALUES (14490, 1963, 13, 'Não autorizadas a ter acesso módulo PostCalendar');
INSERT INTO `lang_definitions` VALUES (14491, 1964, 13, 'Não autorizado');
INSERT INTO `lang_definitions` VALUES (14492, 1965, 13, 'Não autorizado para este plantel.');
INSERT INTO `lang_definitions` VALUES (14493, 1966, 13, 'Não Disponível');
INSERT INTO `lang_definitions` VALUES (14494, 1967, 13, 'Não faturado');
INSERT INTO `lang_definitions` VALUES (14495, 1968, 13, 'Não verificado');
INSERT INTO `lang_definitions` VALUES (14496, 1969, 13, 'Não examinados');
INSERT INTO `lang_definitions` VALUES (14497, 1970, 13, 'Não examinados:');
INSERT INTO `lang_definitions` VALUES (14498, 1971, 13, 'Não examinados:');
INSERT INTO `lang_definitions` VALUES (14499, 1972, 13, 'não encontrado');
INSERT INTO `lang_definitions` VALUES (14500, 1973, 13, 'não encontrado!');
INSERT INTO `lang_definitions` VALUES (14501, 1974, 13, 'Não visto desde');
INSERT INTO `lang_definitions` VALUES (14502, 1975, 13, 'Nota');
INSERT INTO `lang_definitions` VALUES (14503, 1976, 13, 'Tipo de nota');
INSERT INTO `lang_definitions` VALUES (14504, 1977, 13, 'Nota: Este código não foi inserido por um usuário autorizado. Apenas códigos autorizados podem ser enviados para o médico do faturamento de uma rede aberta para processamento. Se você deseja enviar esses códigos, selecione um usuário autorizado aqui.');
INSERT INTO `lang_definitions` VALUES (14505, 1978, 13, 'NOTA: Envio de arquivos com nomes duplicados fará com que os arquivos a serem renomeados automaticamente. Por exemplo, file.jpg se tornará file.jpg.1 . Nomes de arquivos são considerados únicos por paciente e não por categoria.');
INSERT INTO `lang_definitions` VALUES (14506, 1979, 13, 'Notas');
INSERT INTO `lang_definitions` VALUES (14507, 1980, 13, 'Notas - quaisquer encontros (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (14508, 1981, 13, 'Notas - meus encontros (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (14509, 1982, 13, 'Notas não autorizadas');
INSERT INTO `lang_definitions` VALUES (14510, 1983, 13, 'Nada foi selecionado');
INSERT INTO `lang_definitions` VALUES (14511, 1984, 13, 'AVISO: PostCalendar Submission / Modificação');
INSERT INTO `lang_definitions` VALUES (14512, 1985, 13, 'Notificação');
INSERT INTO `lang_definitions` VALUES (14513, 1986, 13, 'Informe-Admin Sobre o Evento Apresentação / modificação?');
INSERT INTO `lang_definitions` VALUES (14514, 1987, 13, 'Novembro');
INSERT INTO `lang_definitions` VALUES (14515, 1988, 13, 'Agora enviar para:');
INSERT INTO `lang_definitions` VALUES (14516, 1989, 13, 'Agora impressão declarações $ stmt_count e encontros de atualização.');
INSERT INTO `lang_definitions` VALUES (14517, 1990, 13, 'Agora impressão declarações $ stmt_count e faturas de atualização.');
INSERT INTO `lang_definitions` VALUES (14518, 1991, 13, 'Agora impressão declarações $ stmt_count; encontros não serão atualizados.');
INSERT INTO `lang_definitions` VALUES (14519, 1992, 13, 'Agora impressão declarações $ stmt_count; facturas não serão atualizados.');
INSERT INTO `lang_definitions` VALUES (14520, 1993, 13, 'RG');
INSERT INTO `lang_definitions` VALUES (14521, 1994, 13, 'Número');
INSERT INTO `lang_definitions` VALUES (14522, 1995, 13, 'Número de colunas, tendo em conta o ano.');
INSERT INTO `lang_definitions` VALUES (14523, 1996, 13, 'Número de jogos ou eventos perdidos, se houver');
INSERT INTO `lang_definitions` VALUES (14524, 1997, 13, 'Dormência');
INSERT INTO `lang_definitions` VALUES (14525, 1998, 13, 'O.A.F.V.');
INSERT INTO `lang_definitions` VALUES (14526, 2000, 13, 'Obesidade I');
INSERT INTO `lang_definitions` VALUES (14527, 2001, 13, 'Obesidade II');
INSERT INTO `lang_definitions` VALUES (14528, 2002, 13, 'Obesidade III');
INSERT INTO `lang_definitions` VALUES (14529, 2003, 13, 'HMA');
INSERT INTO `lang_definitions` VALUES (14530, 2004, 13, 'Ocupação');
INSERT INTO `lang_definitions` VALUES (14531, 2005, 13, 'Ocorrência');
INSERT INTO `lang_definitions` VALUES (14532, 2006, 13, 'Outubro');
INSERT INTO `lang_definitions` VALUES (14533, 2007, 13, 'OD');
INSERT INTO `lang_definitions` VALUES (14534, 2008, 13, 'de quantidade');
INSERT INTO `lang_definitions` VALUES (14535, 2009, 13, 'de comprimidos');
INSERT INTO `lang_definitions` VALUES (14536, 2010, 13, 'de cada mês');
INSERT INTO `lang_definitions` VALUES (14537, 2011, 13, 'Mensagens');
INSERT INTO `lang_definitions` VALUES (14538, 2012, 13, 'Mensagens Internas');
INSERT INTO `lang_definitions` VALUES (14539, 2013, 13, 'Consulta');
INSERT INTO `lang_definitions` VALUES (14540, 2014, 13, 'Filhos');
INSERT INTO `lang_definitions` VALUES (14541, 2015, 13, 'pomada');
INSERT INTO `lang_definitions` VALUES (14542, 2016, 13, 'OK');
INSERT INTO `lang_definitions` VALUES (14543, 2017, 13, 'OK relacionar a questão GCAC datado');
INSERT INTO `lang_definitions` VALUES (14544, 2018, 13, 'Pacientes antigos');
INSERT INTO `lang_definitions` VALUES (14545, 2019, 13, 'Old não fratura / malunion');
INSERT INTO `lang_definitions` VALUES (14546, 2020, 13, 'Omitir os usuários internos?');
INSERT INTO `lang_definitions` VALUES (14547, 2021, 13, 'omitir a autoassign');
INSERT INTO `lang_definitions` VALUES (14548, 2022, 13, 'ligado');
INSERT INTO `lang_definitions` VALUES (14549, 2023, 13, 'On Hand');
INSERT INTO `lang_definitions` VALUES (14550, 2024, 13, 'Em Ordem');
INSERT INTO `lang_definitions` VALUES (14551, 2025, 13, 'Uma vez que você alterar sua senha, você terá que re-login.');
INSERT INTO `lang_definitions` VALUES (14552, 2026, 13, 'Suporte On-line');
INSERT INTO `lang_definitions` VALUES (14553, 2027, 13, 'Apenas Ativo');
INSERT INTO `lang_definitions` VALUES (14554, 2028, 13, 'apenas se a localização de faturamento');
INSERT INTO `lang_definitions` VALUES (14555, 2029, 13, 'Apenas inativos');
INSERT INTO `lang_definitions` VALUES (14556, 2030, 13, 'Somente Próprias');
INSERT INTO `lang_definitions` VALUES (14557, 2031, 13, 'Início da doença:');
INSERT INTO `lang_definitions` VALUES (14558, 2032, 13, 'O início da Ilness:');
INSERT INTO `lang_definitions` VALUES (14559, 2033, 13, 'Aparecimento de edema:');
INSERT INTO `lang_definitions` VALUES (14560, 2034, 13, 'Onset / hosp. Data:');
INSERT INTO `lang_definitions` VALUES (14561, 2035, 13, 'Abrir');
INSERT INTO `lang_definitions` VALUES (14562, 2036, 13, 'OpenEMR requer que o Javascript para realizar a autenticação do usuário.');
INSERT INTO `lang_definitions` VALUES (14563, 2037, 13, 'Usuários OpenEMR');
INSERT INTO `lang_definitions` VALUES (14564, 2038, 13, 'Opção');
INSERT INTO `lang_definitions` VALUES (14565, 2039, 13, 'Opcional');
INSERT INTO `lang_definitions` VALUES (14566, 2040, 13, 'Nome do medicamento opcional, use% como curinga');
INSERT INTO `lang_definitions` VALUES (14567, 2041, 13, 'Opcional informações sobre este evento');
INSERT INTO `lang_definitions` VALUES (14568, 2042, 13, 'Número de lote, opcional, use% como curinga');
INSERT INTO `lang_definitions` VALUES (14569, 2043, 13, 'Paciente numérico opcional ID');
INSERT INTO `lang_definitions` VALUES (14570, 2044, 13, 'Código Procedimento');
INSERT INTO `lang_definitions` VALUES (14571, 2045, 13, 'Ou');
INSERT INTO `lang_definitions` VALUES (14572, 2046, 13, 'Ou');
INSERT INTO `lang_definitions` VALUES (14573, 2047, 13, 'ou escolha');
INSERT INTO `lang_definitions` VALUES (14574, 2048, 13, 'Ou para fora ao');
INSERT INTO `lang_definitions` VALUES (14575, 2049, 13, 'ERA ou o arquivo de upload:');
INSERT INTO `lang_definitions` VALUES (14576, 2050, 13, 'Oral');
INSERT INTO `lang_definitions` VALUES (14577, 2051, 13, 'Mucosa Oral-de-rosa, a garganta clara');
INSERT INTO `lang_definitions` VALUES (14578, 2052, 13, 'Pedido');
INSERT INTO `lang_definitions` VALUES (14579, 2053, 13, 'Ordem deve ser um número entre 1 e 999');
INSERT INTO `lang_definitions` VALUES (14580, 2054, 13, 'Lesões de órgãos');
INSERT INTO `lang_definitions` VALUES (14581, 2055, 13, 'Pessoa Jurídica');
INSERT INTO `lang_definitions` VALUES (14582, 2056, 13, 'Pessoas Jurídicas');
INSERT INTO `lang_definitions` VALUES (14583, 2057, 13, 'Orientado x 3');
INSERT INTO `lang_definitions` VALUES (14584, 2058, 13, 'Original');
INSERT INTO `lang_definitions` VALUES (14585, 2059, 13, 'Orofaringe:');
INSERT INTO `lang_definitions` VALUES (14586, 2060, 13, 'Ortopnéia');
INSERT INTO `lang_definitions` VALUES (14587, 2061, 13, 'OS');
INSERT INTO `lang_definitions` VALUES (14588, 2062, 13, 'Osetoarthritis');
INSERT INTO `lang_definitions` VALUES (14589, 2063, 13, 'Outro');
INSERT INTO `lang_definitions` VALUES (14590, 2064, 13, 'outro');
INSERT INTO `lang_definitions` VALUES (14591, 2065, 13, 'Outro (especificar)');
INSERT INTO `lang_definitions` VALUES (14592, 2066, 13, 'Outros Programas Governamentais');
INSERT INTO `lang_definitions` VALUES (14593, 2067, 13, 'HCFA Outros');
INSERT INTO `lang_definitions` VALUES (14594, 2068, 13, 'Outros danos não especificados');
INSERT INTO `lang_definitions` VALUES (14595, 2069, 13, 'outro mês');
INSERT INTO `lang_definitions` VALUES (14596, 2070, 13, 'Outros Programas não Governamentais');
INSERT INTO `lang_definitions` VALUES (14597, 2071, 13, 'Outras Notas');
INSERT INTO `lang_definitions` VALUES (14598, 2072, 13, 'Outros sintomas Pertinente');
INSERT INTO `lang_definitions` VALUES (14599, 2073, 13, 'Outros sintomas pertinentes:');
INSERT INTO `lang_definitions` VALUES (14600, 2074, 13, 'Outros stress / Mais de utilização de prejuízo');
INSERT INTO `lang_definitions` VALUES (14601, 2075, 13, 'Cirúrgicos Outros');
INSERT INTO `lang_definitions` VALUES (14602, 2076, 13, 'Outros / Generic relacionadas ao aborto');
INSERT INTO `lang_definitions` VALUES (14603, 2077, 13, 'caso contrário, você irá destruir as referências para / de dados existentes.');
INSERT INTO `lang_definitions` VALUES (14604, 2078, 13, 'Otava Ankle Regras');
INSERT INTO `lang_definitions` VALUES (14605, 2079, 13, 'OU');
INSERT INTO `lang_definitions` VALUES (14606, 2080, 13, 'OUT');
INSERT INTO `lang_definitions` VALUES (14607, 2081, 13, 'Out Of Office');
INSERT INTO `lang_definitions` VALUES (14608, 2082, 13, 'Resultado');
INSERT INTO `lang_definitions` VALUES (14609, 2083, 13, 'Outlook');
INSERT INTO `lang_definitions` VALUES (14610, 2084, 13, 'O uso excessivo');
INSERT INTO `lang_definitions` VALUES (14611, 2085, 13, 'Sobrepeso');
INSERT INTO `lang_definitions` VALUES (14612, 2086, 13, 'Substituir escolha HIPAA');
INSERT INTO `lang_definitions` VALUES (14613, 2087, 13, 'Saturação de Oxigênio');
INSERT INTO `lang_definitions` VALUES (14614, 2088, 13, 'P');
INSERT INTO `lang_definitions` VALUES (14615, 2089, 13, 'P.C.');
INSERT INTO `lang_definitions` VALUES (14616, 2090, 13, 'p.m.');
INSERT INTO `lang_definitions` VALUES (14617, 2091, 13, 'P.R.N.');
INSERT INTO `lang_definitions` VALUES (14618, 2092, 13, 'Pediátricos');
INSERT INTO `lang_definitions` VALUES (14619, 2093, 13, 'Página');
INSERT INTO `lang_definitions` VALUES (14620, 2094, 13, 'Páginas');
INSERT INTO `lang_definitions` VALUES (14621, 2095, 13, 'Pago');
INSERT INTO `lang_definitions` VALUES (14622, 2096, 13, 'Montante pago que você vai alocar');
INSERT INTO `lang_definitions` VALUES (14623, 2097, 13, 'Via Paid');
INSERT INTO `lang_definitions` VALUES (14624, 2098, 13, 'Dor');
INSERT INTO `lang_definitions` VALUES (14625, 2099, 13, 'Palpitações');
INSERT INTO `lang_definitions` VALUES (14626, 2100, 13, 'Papanicolau');
INSERT INTO `lang_definitions` VALUES (14627, 2101, 13, 'Paralisia');
INSERT INTO `lang_definitions` VALUES (14628, 2102, 13, 'Parse HL7');
INSERT INTO `lang_definitions` VALUES (14629, 2103, 13, 'Partner');
INSERT INTO `lang_definitions` VALUES (14630, 2104, 13, 'Senha');
INSERT INTO `lang_definitions` VALUES (14631, 2105, 13, 'Alterar Senha');
INSERT INTO `lang_definitions` VALUES (14632, 2106, 13, 'Mudança de senha bem sucedida.');
INSERT INTO `lang_definitions` VALUES (14633, 2107, 13, 'Senha para o SMS Gateway');
INSERT INTO `lang_definitions` VALUES (14634, 2108, 13, 'Senha:');
INSERT INTO `lang_definitions` VALUES (14635, 2109, 13, 'Consultas passadas');
INSERT INTO `lang_definitions` VALUES (14636, 2110, 13, 'Consultas Passadas e Documentos');
INSERT INTO `lang_definitions` VALUES (14637, 2111, 13, 'Colar HL7 Dados');
INSERT INTO `lang_definitions` VALUES (14638, 2112, 13, 'Cole os dados da importação para a área de texto abaixo:');
INSERT INTO `lang_definitions` VALUES (14639, 2113, 13, 'Patch');
INSERT INTO `lang_definitions` VALUES (14640, 2114, 13, 'Paciente');
INSERT INTO `lang_definitions` VALUES (14641, 2115, 13, 'paciente');
INSERT INTO `lang_definitions` VALUES (14642, 2116, 13, 'PACIENTE');
INSERT INTO `lang_definitions` VALUES (14643, 2117, 13, 'Paciente Alergias');
INSERT INTO `lang_definitions` VALUES (14644, 2118, 13, 'Paciente alergias');
INSERT INTO `lang_definitions` VALUES (14645, 2119, 13, 'Nomeação do Paciente');
INSERT INTO `lang_definitions` VALUES (14646, 2120, 13, 'Prontuário ID');
INSERT INTO `lang_definitions` VALUES (14647, 2121, 13, 'Paciente Checkout');
INSERT INTO `lang_definitions` VALUES (14648, 2122, 13, 'Paciente Checkout');
INSERT INTO `lang_definitions` VALUES (14649, 2123, 13, 'Paciente Comunicação enviado');
INSERT INTO `lang_definitions` VALUES (14650, 2124, 13, 'Paciente Comunication Enviados');
INSERT INTO `lang_definitions` VALUES (14651, 2125, 13, 'Dados do paciente');
INSERT INTO `lang_definitions` VALUES (14652, 2126, 13, 'Documento do paciente');
INSERT INTO `lang_definitions` VALUES (14653, 2127, 13, 'Patient Encounter');
INSERT INTO `lang_definitions` VALUES (14654, 2128, 13, 'Patient Encounter Forma');
INSERT INTO `lang_definitions` VALUES (14655, 2129, 13, 'Paciente Encounters');
INSERT INTO `lang_definitions` VALUES (14656, 2130, 13, 'Paciente Encontrado');
INSERT INTO `lang_definitions` VALUES (14657, 2131, 13, 'Histórico do Paciente');
INSERT INTO `lang_definitions` VALUES (14658, 2132, 13, 'Histórico do Paciente / Hábitos');
INSERT INTO `lang_definitions` VALUES (14659, 2133, 13, 'ID do Paciente');
INSERT INTO `lang_definitions` VALUES (14660, 2134, 13, 'Paciente cartão de identificação');
INSERT INTO `lang_definitions` VALUES (14661, 2135, 13, 'Paciente de Vacinação');
INSERT INTO `lang_definitions` VALUES (14662, 2136, 13, 'Informação do Paciente');
INSERT INTO `lang_definitions` VALUES (14663, 2137, 13, 'A distribuição dos pacientes de Seguros');
INSERT INTO `lang_definitions` VALUES (14664, 2138, 13, 'A distribuição dos pacientes Insurance Report');
INSERT INTO `lang_definitions` VALUES (14665, 2139, 13, 'Paciente Questões');
INSERT INTO `lang_definitions` VALUES (14666, 2140, 13, 'Lista de pacientes');
INSERT INTO `lang_definitions` VALUES (14667, 2141, 13, 'Anotações do Paciente');
INSERT INTO `lang_definitions` VALUES (14668, 2142, 13, 'Paciente Medications');
INSERT INTO `lang_definitions` VALUES (14669, 2143, 13, 'Nome e endereço do paciente');
INSERT INTO `lang_definitions` VALUES (14670, 2144, 13, 'Paciente Nota Tipos');
INSERT INTO `lang_definitions` VALUES (14671, 2145, 13, 'Anotações do Paciente');
INSERT INTO `lang_definitions` VALUES (14672, 2146, 13, 'Anotações do Paciente (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (14673, 2147, 13, 'Número de doentes');
INSERT INTO `lang_definitions` VALUES (14674, 2148, 13, 'Paciente Relatório Impresso');
INSERT INTO `lang_definitions` VALUES (14675, 2149, 13, 'Registrar Relatório do Paciente');
INSERT INTO `lang_definitions` VALUES (14676, 2150, 13, 'Relatório do paciente');
INSERT INTO `lang_definitions` VALUES (14677, 2151, 13, 'Paciente Pedido');
INSERT INTO `lang_definitions` VALUES (14678, 2152, 13, 'Resumo do paciente');
INSERT INTO `lang_definitions` VALUES (14679, 2153, 13, 'Transações do Paciente');
INSERT INTO `lang_definitions` VALUES (14680, 2154, 13, 'paciente (s) no banco de dados que correspondem às informações demográficas que você entrou.');
INSERT INTO `lang_definitions` VALUES (14681, 2155, 13, 'Paciente');
INSERT INTO `lang_definitions` VALUES (14682, 2156, 13, 'Paciente:');
INSERT INTO `lang_definitions` VALUES (14683, 2157, 13, 'Pacientes');
INSERT INTO `lang_definitions` VALUES (14684, 2158, 13, 'Pago');
INSERT INTO `lang_definitions` VALUES (14685, 2159, 13, 'Preste atenção ao \"\"Feito com \"\" caixas. Depois que os seguros são marcadas completa, então vamos começar a pedir o paciente para o pagamento do saldo remanescente, se você deixar de marcar todos os seguros, em seguida, completar o valor restante não será coletado! Além disso, se há um equilíbrio que o paciente deve pagar, em seguida, defina a data de vencimento de forma adequada, como isso vai afetar o idioma que aparece sobre as declarações do paciente.');
INSERT INTO `lang_definitions` VALUES (14686, 2160, 13, 'Data de pagamento:');
INSERT INTO `lang_definitions` VALUES (14687, 2161, 13, 'Pagamento');
INSERT INTO `lang_definitions` VALUES (14688, 2162, 13, 'Tipo de Pagamento');
INSERT INTO `lang_definitions` VALUES (14689, 2163, 13, 'Pagar');
INSERT INTO `lang_definitions` VALUES (14690, 2164, 13, 'Pagamento');
INSERT INTO `lang_definitions` VALUES (14691, 2165, 13, 'pagamento');
INSERT INTO `lang_definitions` VALUES (14692, 2166, 13, 'Data de Pagamento');
INSERT INTO `lang_definitions` VALUES (14693, 2167, 13, 'pagamento inscritas no');
INSERT INTO `lang_definitions` VALUES (14694, 2168, 13, 'Método de Pagamento');
INSERT INTO `lang_definitions` VALUES (14695, 2169, 13, 'Valor do pagamento para o código');
INSERT INTO `lang_definitions` VALUES (14696, 2170, 13, 'Pagamentos');
INSERT INTO `lang_definitions` VALUES (14697, 2171, 13, 'PDF');
INSERT INTO `lang_definitions` VALUES (14698, 2172, 13, 'Pelve e nádega');
INSERT INTO `lang_definitions` VALUES (14699, 2173, 13, 'Pênfigo');
INSERT INTO `lang_definitions` VALUES (14700, 2174, 13, 'Pendente');
INSERT INTO `lang_definitions` VALUES (14701, 2175, 13, 'Followup Pending');
INSERT INTO `lang_definitions` VALUES (14702, 2176, 13, 'Empresa Pennington OpenEMR v');
INSERT INTO `lang_definitions` VALUES (14703, 2177, 13, 'Úlcera Péptica Doença');
INSERT INTO `lang_definitions` VALUES (14704, 2178, 13, 'por minuto');
INSERT INTO `lang_definitions` VALUES (14705, 2179, 13, 'Por Narina');
INSERT INTO `lang_definitions` VALUES (14706, 2180, 13, 'por narina');
INSERT INTO `lang_definitions` VALUES (14707, 2181, 13, 'Por Oris');
INSERT INTO `lang_definitions` VALUES (14708, 2182, 13, 'por oris');
INSERT INTO `lang_definitions` VALUES (14709, 2183, 13, 'Por Reto');
INSERT INTO `lang_definitions` VALUES (14710, 2184, 13, 'por reto');
INSERT INTO `lang_definitions` VALUES (14711, 2185, 13, 'Perfurado Direita:');
INSERT INTO `lang_definitions` VALUES (14712, 2186, 13, 'Execute Busca');
INSERT INTO `lang_definitions` VALUES (14713, 2187, 13, 'Realizar esta ação');
INSERT INTO `lang_definitions` VALUES (14714, 2188, 13, 'Periférico');
INSERT INTO `lang_definitions` VALUES (14715, 2189, 13, 'Pessoa');
INSERT INTO `lang_definitions` VALUES (14716, 2190, 13, 'Farmácias');
INSERT INTO `lang_definitions` VALUES (14717, 2191, 13, 'Farmácia');
INSERT INTO `lang_definitions` VALUES (14718, 2192, 13, 'Farmácia Dispensário');
INSERT INTO `lang_definitions` VALUES (14719, 2193, 13, 'Pheumothorax');
INSERT INTO `lang_definitions` VALUES (14720, 2194, 13, 'Telefone');
INSERT INTO `lang_definitions` VALUES (14721, 2195, 13, 'Telefone lista de chamadas');
INSERT INTO `lang_definitions` VALUES (14722, 2196, 13, 'Telefone');
INSERT INTO `lang_definitions` VALUES (14723, 2197, 13, 'Fotofobia');
INSERT INTO `lang_definitions` VALUES (14724, 2198, 13, 'PHP comprimido');
INSERT INTO `lang_definitions` VALUES (14725, 2199, 13, 'PHP extraída');
INSERT INTO `lang_definitions` VALUES (14726, 2200, 13, 'php controles de acesso GACL são desligados');
INSERT INTO `lang_definitions` VALUES (14727, 2201, 13, 'PHP-GACL não está instalado');
INSERT INTO `lang_definitions` VALUES (14728, 2202, 13, 'Exame Físico');
INSERT INTO `lang_definitions` VALUES (14729, 2203, 13, 'Pedido médico');
INSERT INTO `lang_definitions` VALUES (14730, 2204, 13, 'Assinatura do Médico');
INSERT INTO `lang_definitions` VALUES (14731, 2205, 13, 'Médicos');
INSERT INTO `lang_definitions` VALUES (14732, 2206, 13, 'cores');
INSERT INTO `lang_definitions` VALUES (14733, 2207, 13, 'PID');
INSERT INTO `lang_definitions` VALUES (14734, 2208, 13, 'PID (Doença Inflamatória Pélvica)');
INSERT INTO `lang_definitions` VALUES (14735, 2209, 13, 'Tamanho Comprimido');
INSERT INTO `lang_definitions` VALUES (14736, 2210, 13, 'Pills');
INSERT INTO `lang_definitions` VALUES (14737, 2211, 13, 'Espaço reservado');
INSERT INTO `lang_definitions` VALUES (14738, 2212, 13, 'Espaço reservado (Mantém vazio ACLs)');
INSERT INTO `lang_definitions` VALUES (14739, 2213, 13, 'Plain Text');
INSERT INTO `lang_definitions` VALUES (14740, 2214, 13, 'Conduta');
INSERT INTO `lang_definitions` VALUES (14741, 2215, 13, 'Nome do Plano');
INSERT INTO `lang_definitions` VALUES (14742, 2216, 13, 'Plano:');
INSERT INTO `lang_definitions` VALUES (14743, 2217, 13, 'Jogador');
INSERT INTO `lang_definitions` VALUES (14744, 2218, 13, 'Jogando Posição');
INSERT INTO `lang_definitions` VALUES (14745, 2219, 13, 'Por favor, escolha uma selecção válida a partir da lista.');
INSERT INTO `lang_definitions` VALUES (14746, 2220, 13, 'Por favor, escolha uma selecção válida.');
INSERT INTO `lang_definitions` VALUES (14747, 2221, 13, 'Por favor, escolha um valor para');
INSERT INTO `lang_definitions` VALUES (14748, 2222, 13, 'Por favor, feche esta janela.');
INSERT INTO `lang_definitions` VALUES (14749, 2223, 13, 'Por favor, compare o novo nome');
INSERT INTO `lang_definitions` VALUES (14750, 2224, 13, 'Por favor, não aceitamos essa receita que não tenha sido recebido através facimile.');
INSERT INTO `lang_definitions` VALUES (14751, 2225, 13, 'Por favor, não use o seu navegador ou parar botão Recarregar enquanto esta página está em execução a menos que mais de 10 minutos se passaram, isso não fará com que o processo parar no servidor e vai consumir recursos uneccesary.');
INSERT INTO `lang_definitions` VALUES (14752, 2226, 13, 'Por favor, indique um valor monetário usando apenas números e um ponto decimal.');
INSERT INTO `lang_definitions` VALUES (14753, 2227, 13, 'Por favor, indique uma descrição!');
INSERT INTO `lang_definitions` VALUES (14754, 2228, 13, 'Por favor, note que isso pode levar um tempo muito longo, até vários minutos, o seu navegador pode não aparecer muito ativo durante este tempo, mas gerando um projeto de lei é um processo complicado e seu navegador está apenas à espera de mais informações.');
INSERT INTO `lang_definitions` VALUES (14755, 2229, 13, 'Atenção: as constantes são caso sensível e qualquer seqüência de caracteres é permitida.');
INSERT INTO `lang_definitions` VALUES (14756, 2230, 13, 'Por favor, utilize apenas caracteres alfabéticos');
INSERT INTO `lang_definitions` VALUES (14757, 2231, 13, 'Por favor, utilize apenas caracteres alfabéticos sem espaços');
INSERT INTO `lang_definitions` VALUES (14758, 2232, 13, 'Por favor, o pagamento deste montante');
INSERT INTO `lang_definitions` VALUES (14759, 2233, 13, 'Por favor selecione uma razão de ajuste para o código');
INSERT INTO `lang_definitions` VALUES (14760, 2234, 13, 'Por favor selecione um evento');
INSERT INTO `lang_definitions` VALUES (14761, 2235, 13, 'Por favor, selecione as páginas desejadas para copiar ou para a frente:');
INSERT INTO `lang_definitions` VALUES (14762, 2236, 13, 'PM');
INSERT INTO `lang_definitions` VALUES (14763, 2237, 13, 'PMT Método');
INSERT INTO `lang_definitions` VALUES (14764, 2238, 13, 'PND');
INSERT INTO `lang_definitions` VALUES (14765, 2239, 13, 'Pneumocócica conjugada 1');
INSERT INTO `lang_definitions` VALUES (14766, 2240, 13, 'Pneumocócica conjugada 2');
INSERT INTO `lang_definitions` VALUES (14767, 2241, 13, 'Pneumocócica conjugada 3');
INSERT INTO `lang_definitions` VALUES (14768, 2242, 13, 'Pneumocócica conjugada 4');
INSERT INTO `lang_definitions` VALUES (14769, 2243, 13, 'Pneumonia Vacinação');
INSERT INTO `lang_definitions` VALUES (14770, 2244, 13, 'Point of Service (POS)');
INSERT INTO `lang_definitions` VALUES (14771, 2245, 13, 'Política');
INSERT INTO `lang_definitions` VALUES (14772, 2246, 13, 'Número da apólice');
INSERT INTO `lang_definitions` VALUES (14773, 2247, 13, 'Polidipsia');
INSERT INTO `lang_definitions` VALUES (14774, 2248, 13, 'Pólipos');
INSERT INTO `lang_definitions` VALUES (14775, 2249, 13, 'Poliúria');
INSERT INTO `lang_definitions` VALUES (14776, 2250, 13, 'Falta de Apetite');
INSERT INTO `lang_definitions` VALUES (14777, 2251, 13, 'Baixa Circulação');
INSERT INTO `lang_definitions` VALUES (14778, 2252, 13, 'Baixa Audição');
INSERT INTO `lang_definitions` VALUES (14779, 2253, 13, 'Preencher a visão anos com eventos?');
INSERT INTO `lang_definitions` VALUES (14780, 2254, 13, 'Popups');
INSERT INTO `lang_definitions` VALUES (14781, 2255, 13, 'Português (Brasil)');
INSERT INTO `lang_definitions` VALUES (14782, 2256, 13, 'Português (Europeu)');
INSERT INTO `lang_definitions` VALUES (14783, 2257, 13, 'POS Código');
INSERT INTO `lang_definitions` VALUES (14784, 2258, 13, 'Post Nasal Drip');
INSERT INTO `lang_definitions` VALUES (14785, 2259, 13, 'Pós cirúrgico');
INSERT INTO `lang_definitions` VALUES (14786, 2260, 13, 'Post a contabilidade e marcar como faturado');
INSERT INTO `lang_definitions` VALUES (14787, 2261, 13, 'Post-Abortion Care');
INSERT INTO `lang_definitions` VALUES (14788, 2262, 13, 'A contracepção pós-aborto');
INSERT INTO `lang_definitions` VALUES (14789, 2263, 13, 'Aconselhamento pós-aborto');
INSERT INTO `lang_definitions` VALUES (14790, 2264, 13, 'Pós-aborto Followup');
INSERT INTO `lang_definitions` VALUES (14791, 2265, 13, 'Postal');
INSERT INTO `lang_definitions` VALUES (14792, 2266, 13, 'CEP');
INSERT INTO `lang_definitions` VALUES (14793, 2267, 13, 'CEP');
INSERT INTO `lang_definitions` VALUES (14794, 2268, 13, 'PostCalendar');
INSERT INTO `lang_definitions` VALUES (14795, 2269, 13, 'PostCalendar Administração');
INSERT INTO `lang_definitions` VALUES (14796, 2270, 13, 'PostCalendar Categoria Definições');
INSERT INTO `lang_definitions` VALUES (14797, 2271, 13, 'PostCalendar Global Settings');
INSERT INTO `lang_definitions` VALUES (14798, 2272, 13, 'Postado em');
INSERT INTO `lang_definitions` VALUES (14799, 2273, 13, 'Data de lançamento');
INSERT INTO `lang_definitions` VALUES (14800, 2275, 13, 'Clínica');
INSERT INTO `lang_definitions` VALUES (14801, 2276, 13, 'Definições da Clínica');
INSERT INTO `lang_definitions` VALUES (14802, 2277, 13, 'Profissional');
INSERT INTO `lang_definitions` VALUES (14803, 2278, 13, 'Consulta pré-aborto');
INSERT INTO `lang_definitions` VALUES (14804, 2279, 13, 'Aconselhamento pré-aborto');
INSERT INTO `lang_definitions` VALUES (14805, 2280, 13, 'Pref Cat');
INSERT INTO `lang_definitions` VALUES (14806, 2281, 13, 'Preferidos Categoria do evento');
INSERT INTO `lang_definitions` VALUES (14807, 2282, 13, 'Idioma preferido');
INSERT INTO `lang_definitions` VALUES (14808, 2283, 13, 'Preferidos Farmácia');
INSERT INTO `lang_definitions` VALUES (14809, 2284, 13, 'Preferred Provider Organization (PPO)');
INSERT INTO `lang_definitions` VALUES (14810, 2285, 13, 'Teste de gravidez');
INSERT INTO `lang_definitions` VALUES (14811, 2286, 13, 'Pagamento antecipado');
INSERT INTO `lang_definitions` VALUES (14812, 2287, 13, 'Prescrição');
INSERT INTO `lang_definitions` VALUES (14813, 2288, 13, 'Prescrição Label');
INSERT INTO `lang_definitions` VALUES (14814, 2289, 13, 'Prescrição');
INSERT INTO `lang_definitions` VALUES (14815, 2290, 13, 'Prescrição e dispensas');
INSERT INTO `lang_definitions` VALUES (14816, 2291, 13, 'Prescrições e outras referências');
INSERT INTO `lang_definitions` VALUES (14817, 2292, 13, 'Prescrições e / ou referências do especialista');
INSERT INTO `lang_definitions` VALUES (14818, 2293, 13, 'Prescrição Relatório');
INSERT INTO `lang_definitions` VALUES (14819, 2294, 13, 'Prescrição / Registo');
INSERT INTO `lang_definitions` VALUES (14820, 2295, 13, 'Apresentar Queixa');
INSERT INTO `lang_definitions` VALUES (14821, 2296, 13, 'Pressione Continuar para prosseguir');
INSERT INTO `lang_definitions` VALUES (14822, 2297, 13, 'Presume-Diagnóstico');
INSERT INTO `lang_definitions` VALUES (14823, 2298, 13, 'Diagnóstico presumido por especialista');
INSERT INTO `lang_definitions` VALUES (14824, 2299, 13, 'Anterior');
INSERT INTO `lang_definitions` VALUES (14825, 2300, 13, 'Preview Event');
INSERT INTO `lang_definitions` VALUES (14826, 2301, 13, 'Anterior');
INSERT INTO `lang_definitions` VALUES (14827, 2302, 13, 'Consultas anteriores');
INSERT INTO `lang_definitions` VALUES (14828, 2303, 13, 'Dia Anterior');
INSERT INTO `lang_definitions` VALUES (14829, 2304, 13, 'História Anterior / Screening');
INSERT INTO `lang_definitions` VALUES (14830, 2305, 13, 'Mês anterior');
INSERT INTO `lang_definitions` VALUES (14831, 2306, 13, 'Semana anterior');
INSERT INTO `lang_definitions` VALUES (14832, 2307, 13, 'Preço');
INSERT INTO `lang_definitions` VALUES (14833, 2308, 13, 'Valor Desconto');
INSERT INTO `lang_definitions` VALUES (14834, 2309, 13, 'Nível de Preços');
INSERT INTO `lang_definitions` VALUES (14835, 2310, 13, 'Nível de Preços:');
INSERT INTO `lang_definitions` VALUES (14836, 2311, 13, 'Preços');
INSERT INTO `lang_definitions` VALUES (14837, 2312, 13, 'Primário');
INSERT INTO `lang_definitions` VALUES (14838, 2313, 13, 'Ins Primário');
INSERT INTO `lang_definitions` VALUES (14839, 2314, 13, 'Seguro Primário');
INSERT INTO `lang_definitions` VALUES (14840, 2315, 13, 'Primária de Seguro de Dados');
INSERT INTO `lang_definitions` VALUES (14841, 2316, 13, 'Primeiro Convênio');
INSERT INTO `lang_definitions` VALUES (14842, 2317, 13, 'Provedor primário');
INSERT INTO `lang_definitions` VALUES (14843, 2318, 13, 'Imprimir');
INSERT INTO `lang_definitions` VALUES (14844, 2322, 13, 'Print Blank Referral Forma');
INSERT INTO `lang_definitions` VALUES (14845, 2323, 13, 'Formato de Impressão');
INSERT INTO `lang_definitions` VALUES (14846, 2324, 13, 'Imprimir Quatro Painel');
INSERT INTO `lang_definitions` VALUES (14847, 2325, 13, 'Imprimir múltiplas');
INSERT INTO `lang_definitions` VALUES (14848, 2326, 13, 'Para imprimir várias Fax');
INSERT INTO `lang_definitions` VALUES (14849, 2329, 13, 'Imprimir Página 1');
INSERT INTO `lang_definitions` VALUES (14850, 2330, 13, 'Imprimir página 2');
INSERT INTO `lang_definitions` VALUES (14851, 2331, 13, 'Imprimir Anotação');
INSERT INTO `lang_definitions` VALUES (14852, 2332, 13, 'Imprimir Shot Record');
INSERT INTO `lang_definitions` VALUES (14853, 2334, 13, 'Imprimir esta nota');
INSERT INTO `lang_definitions` VALUES (14854, 2335, 13, 'Imprimir esta nota');
INSERT INTO `lang_definitions` VALUES (14855, 2336, 13, 'Imprimir para Fax');
INSERT INTO `lang_definitions` VALUES (14856, 2337, 13, 'Versão para impressão');
INSERT INTO `lang_definitions` VALUES (14857, 2338, 13, 'Imprimir Proposta');
INSERT INTO `lang_definitions` VALUES (14858, 2339, 13, 'Printable Version');
INSERT INTO `lang_definitions` VALUES (14859, 2340, 13, 'Impresso');
INSERT INTO `lang_definitions` VALUES (14860, 2341, 13, 'Impressão de resultados:');
INSERT INTO `lang_definitions` VALUES (14861, 2342, 13, 'Imprensa ignorado; ver a saída de teste em');
INSERT INTO `lang_definitions` VALUES (14862, 2343, 13, 'Antes Auth');
INSERT INTO `lang_definitions` VALUES (14863, 2344, 13, 'Formulário de Autorização Prévia');
INSERT INTO `lang_definitions` VALUES (14864, 2345, 13, 'Prioridade');
INSERT INTO `lang_definitions` VALUES (14865, 2346, 13, 'Privado');
INSERT INTO `lang_definitions` VALUES (14866, 2347, 13, 'Problema');
INSERT INTO `lang_definitions` VALUES (14867, 2348, 13, 'Lista Problema');
INSERT INTO `lang_definitions` VALUES (14868, 2349, 13, 'Problemas / Questões');
INSERT INTO `lang_definitions` VALUES (14869, 2350, 13, 'Processo');
INSERT INTO `lang_definitions` VALUES (14870, 2351, 13, 'Procedimentos');
INSERT INTO `lang_definitions` VALUES (14871, 2352, 13, 'Processo');
INSERT INTO `lang_definitions` VALUES (14872, 2353, 13, 'Processamento');
INSERT INTO `lang_definitions` VALUES (14873, 2354, 13, 'Produtos');
INSERT INTO `lang_definitions` VALUES (14874, 2355, 13, 'Prof');
INSERT INTO `lang_definitions` VALUES (14875, 2357, 13, 'Câncer de Próstata');
INSERT INTO `lang_definitions` VALUES (14876, 2358, 13, 'Exame de próstata');
INSERT INTO `lang_definitions` VALUES (14877, 2359, 13, 'Problemas da Próstata');
INSERT INTO `lang_definitions` VALUES (14878, 2360, 13, 'Próstata w / o enlrgmt, nódulos, concurso');
INSERT INTO `lang_definitions` VALUES (14879, 2361, 13, 'Médico');
INSERT INTO `lang_definitions` VALUES (14880, 2362, 13, 'Número do Médico');
INSERT INTO `lang_definitions` VALUES (14881, 2363, 13, 'Operadora:');
INSERT INTO `lang_definitions` VALUES (14882, 2364, 13, 'Médicos');
INSERT INTO `lang_definitions` VALUES (14883, 2365, 13, 'RG dos Médicos');
INSERT INTO `lang_definitions` VALUES (14884, 2366, 13, 'Prv');
INSERT INTO `lang_definitions` VALUES (14885, 2367, 13, 'PSA');
INSERT INTO `lang_definitions` VALUES (14886, 2368, 13, 'Psoríase');
INSERT INTO `lang_definitions` VALUES (14887, 2369, 13, 'Psych Diagnóstico');
INSERT INTO `lang_definitions` VALUES (14888, 2370, 13, 'Psych Medication');
INSERT INTO `lang_definitions` VALUES (14889, 2371, 13, 'Psychiatric');
INSERT INTO `lang_definitions` VALUES (14890, 2372, 13, 'Psiquiátrica Breve Carta');
INSERT INTO `lang_definitions` VALUES (14891, 2373, 13, 'Diagnóstico psiquiátrico');
INSERT INTO `lang_definitions` VALUES (14892, 2374, 13, 'Exame psiquiátrico');
INSERT INTO `lang_definitions` VALUES (14893, 2375, 13, 'Histórico psiquiátrico');
INSERT INTO `lang_definitions` VALUES (14894, 2376, 13, 'Psiquiátrica Intake');
INSERT INTO `lang_definitions` VALUES (14895, 2377, 13, 'Medicação Psiquiátrica');
INSERT INTO `lang_definitions` VALUES (14896, 2378, 13, '% Pt');
INSERT INTO `lang_definitions` VALUES (14897, 2379, 13, 'Pt Notas');
INSERT INTO `lang_definitions` VALUES (14898, 2380, 13, 'Pt Notas / Auth');
INSERT INTO `lang_definitions` VALUES (14899, 2381, 13, 'Pt excesso');
INSERT INTO `lang_definitions` VALUES (14900, 2382, 13, 'Pt Paid');
INSERT INTO `lang_definitions` VALUES (14901, 2383, 13, 'Restituição Pt');
INSERT INTO `lang_definitions` VALUES (14902, 2384, 13, 'Pt liberado');
INSERT INTO `lang_definitions` VALUES (14903, 2385, 13, 'Pt Relatório');
INSERT INTO `lang_definitions` VALUES (14904, 2386, 13, 'PT Estudante, ou deixar em branco');
INSERT INTO `lang_definitions` VALUES (14905, 2388, 13, 'PT_DOB');
INSERT INTO `lang_definitions` VALUES (14906, 2389, 13, 'PT_FNAME');
INSERT INTO `lang_definitions` VALUES (14907, 2390, 13, 'PT_LNAME');
INSERT INTO `lang_definitions` VALUES (14908, 2391, 13, 'PT_MNAME');
INSERT INTO `lang_definitions` VALUES (14909, 2395, 13, 'Público');
INSERT INTO `lang_definitions` VALUES (14910, 2396, 13, 'Pulmonar');
INSERT INTO `lang_definitions` VALUES (14911, 2397, 13, 'Pulse');
INSERT INTO `lang_definitions` VALUES (14912, 2398, 13, 'q.3h');
INSERT INTO `lang_definitions` VALUES (14913, 2399, 13, 'q.4h');
INSERT INTO `lang_definitions` VALUES (14914, 2400, 13, 'q.5h');
INSERT INTO `lang_definitions` VALUES (14915, 2401, 13, 'q.6h');
INSERT INTO `lang_definitions` VALUES (14916, 2402, 13, 'q.8h');
INSERT INTO `lang_definitions` VALUES (14917, 2403, 13, 'q.d.');
INSERT INTO `lang_definitions` VALUES (14918, 2404, 13, 'q.i.d.');
INSERT INTO `lang_definitions` VALUES (14919, 2405, 13, 'Ecl');
INSERT INTO `lang_definitions` VALUES (14920, 2406, 13, 'Qtde');
INSERT INTO `lang_definitions` VALUES (14921, 2407, 13, 'QTD');
INSERT INTO `lang_definitions` VALUES (14922, 2408, 13, 'Qualidade');
INSERT INTO `lang_definitions` VALUES (14923, 2409, 13, 'Quantidade');
INSERT INTO `lang_definitions` VALUES (14924, 2410, 13, 'Quantidade de NDC');
INSERT INTO `lang_definitions` VALUES (14925, 2411, 13, 'Quantidade On Hand');
INSERT INTO `lang_definitions` VALUES (14926, 2412, 13, 'HCFA fila para processamento em lote');
INSERT INTO `lang_definitions` VALUES (14927, 2413, 13, 'HCFA fila para processamento em lote e impressão');
INSERT INTO `lang_definitions` VALUES (14928, 2414, 13, 'Fila para o UB-92 lotes de processamento');
INSERT INTO `lang_definitions` VALUES (14929, 2415, 13, 'Fila para o UB-92 lotes de processamento e impressão');
INSERT INTO `lang_definitions` VALUES (14930, 2416, 13, 'Enfileirado');
INSERT INTO `lang_definitions` VALUES (14931, 2417, 13, 'Em fila de espera de eventos Administração');
INSERT INTO `lang_definitions` VALUES (14932, 2418, 13, 'Em fila de espera para');
INSERT INTO `lang_definitions` VALUES (14933, 2419, 13, 'Submissões fila Administração');
INSERT INTO `lang_definitions` VALUES (14934, 2420, 13, 'R');
INSERT INTO `lang_definitions` VALUES (14935, 2421, 13, 'Raça');
INSERT INTO `lang_definitions` VALUES (14936, 2422, 13, 'Raça / Etnia');
INSERT INTO `lang_definitions` VALUES (14937, 2423, 13, 'Rádio');
INSERT INTO `lang_definitions` VALUES (14938, 2424, 13, 'Radio buttons');
INSERT INTO `lang_definitions` VALUES (14939, 2425, 13, 'Pruridos');
INSERT INTO `lang_definitions` VALUES (14940, 2426, 13, 'Categoria');
INSERT INTO `lang_definitions` VALUES (14941, 2427, 13, 'Reaberto');
INSERT INTO `lang_definitions` VALUES (14942, 2428, 13, 'Reaberto');
INSERT INTO `lang_definitions` VALUES (14943, 2429, 13, 'Reações');
INSERT INTO `lang_definitions` VALUES (14944, 2430, 13, 'Nome real');
INSERT INTO `lang_definitions` VALUES (14945, 2431, 13, 'Motivo');
INSERT INTO `lang_definitions` VALUES (14946, 2432, 13, 'Motivo do encaminhamento');
INSERT INTO `lang_definitions` VALUES (14947, 2433, 13, 'Motivo da visita');
INSERT INTO `lang_definitions` VALUES (14948, 2434, 13, 'Motivo / Forma');
INSERT INTO `lang_definitions` VALUES (14949, 2435, 13, 'Recibo');
INSERT INTO `lang_definitions` VALUES (14950, 2436, 13, 'Recibo de pagamento');
INSERT INTO `lang_definitions` VALUES (14951, 2437, 13, 'Recibo Gerado');
INSERT INTO `lang_definitions` VALUES (14952, 2438, 13, 'Recibos de Pagamento Relatório');
INSERT INTO `lang_definitions` VALUES (14953, 2439, 13, 'Recibos Resumo');
INSERT INTO `lang_definitions` VALUES (14954, 2440, 13, 'Recebido');
INSERT INTO `lang_definitions` VALUES (14955, 2441, 13, 'Recebido Por');
INSERT INTO `lang_definitions` VALUES (14956, 2442, 13, 'Os faxes recebidos');
INSERT INTO `lang_definitions` VALUES (14957, 2443, 13, 'Receptor');
INSERT INTO `lang_definitions` VALUES (14958, 2444, 13, 'Identificação do receptor');
INSERT INTO `lang_definitions` VALUES (14959, 2447, 13, 'Recomendações');
INSERT INTO `lang_definitions` VALUES (14960, 2448, 13, 'Recomendações e tratamento');
INSERT INTO `lang_definitions` VALUES (14961, 2449, 13, 'Recomendações do especialista');
INSERT INTO `lang_definitions` VALUES (14962, 2450, 13, 'Registro de Pagamento');
INSERT INTO `lang_definitions` VALUES (14963, 2451, 13, 'registros encontrados.');
INSERT INTO `lang_definitions` VALUES (14964, 2452, 13, 'Retal');
INSERT INTO `lang_definitions` VALUES (14965, 2453, 13, 'Exame Retal');
INSERT INTO `lang_definitions` VALUES (14966, 2454, 13, 'retal');
INSERT INTO `lang_definitions` VALUES (14967, 2455, 13, 'Vermelhidão');
INSERT INTO `lang_definitions` VALUES (14968, 2456, 13, 'reduzido:');
INSERT INTO `lang_definitions` VALUES (14969, 2457, 13, 'Consulte');
INSERT INTO `lang_definitions` VALUES (14970, 2458, 13, 'Ao se referir');
INSERT INTO `lang_definitions` VALUES (14971, 2459, 13, 'Data Consulte');
INSERT INTO `lang_definitions` VALUES (14972, 2460, 13, 'Consulte');
INSERT INTO `lang_definitions` VALUES (14973, 2461, 13, 'Referência classificação (nível de risco)');
INSERT INTO `lang_definitions` VALUES (14974, 2462, 13, 'Referência Reason');
INSERT INTO `lang_definitions` VALUES (14975, 2463, 13, 'Atribuir nome e assinatura');
INSERT INTO `lang_definitions` VALUES (14976, 2464, 13, 'Atribuir');
INSERT INTO `lang_definitions` VALUES (14977, 2465, 13, 'Por remessa');
INSERT INTO `lang_definitions` VALUES (14978, 2466, 13, 'Atribuir Cartão');
INSERT INTO `lang_definitions` VALUES (14979, 2467, 13, 'Data de remessa');
INSERT INTO `lang_definitions` VALUES (14980, 2468, 13, 'Consulta Formulário');
INSERT INTO `lang_definitions` VALUES (14981, 2469, 13, 'FORMA DE REMESSA');
INSERT INTO `lang_definitions` VALUES (14982, 2470, 13, 'Fonte de referência');
INSERT INTO `lang_definitions` VALUES (14983, 2471, 13, 'Consulta de');
INSERT INTO `lang_definitions` VALUES (14984, 2472, 13, 'Diagnósticos');
INSERT INTO `lang_definitions` VALUES (14985, 2473, 13, 'Relatório de Diagnósticos');
INSERT INTO `lang_definitions` VALUES (14986, 2474, 13, 'Diagnosticado por');
INSERT INTO `lang_definitions` VALUES (14987, 2475, 13, 'Diagnosticados por');
INSERT INTO `lang_definitions` VALUES (14988, 2476, 13, 'Diagnosticado');
INSERT INTO `lang_definitions` VALUES (14989, 2477, 13, 'Médico');
INSERT INTO `lang_definitions` VALUES (14990, 2478, 13, 'Diagnóstico do médico');
INSERT INTO `lang_definitions` VALUES (14991, 2479, 13, 'Diagnóstico Referido');
INSERT INTO `lang_definitions` VALUES (14992, 2480, 13, 'Referindo-se médico e clínica');
INSERT INTO `lang_definitions` VALUES (14993, 2481, 13, 'Referindo-Médico');
INSERT INTO `lang_definitions` VALUES (14994, 2482, 13, 'Recargas');
INSERT INTO `lang_definitions` VALUES (14995, 2483, 13, 'recargas');
INSERT INTO `lang_definitions` VALUES (14996, 2484, 13, 'Reflexos normais');
INSERT INTO `lang_definitions` VALUES (14997, 2485, 13, 'Refresh');
INSERT INTO `lang_definitions` VALUES (14998, 2486, 13, 'reg_re');
INSERT INTO `lang_definitions` VALUES (14999, 2487, 13, 'Registre-se');
INSERT INTO `lang_definitions` VALUES (15000, 2488, 13, 'Registado');
INSERT INTO `lang_definitions` VALUES (15001, 2489, 13, 'registada');
INSERT INTO `lang_definitions` VALUES (15002, 2490, 13, 'Data de Registro');
INSERT INTO `lang_definitions` VALUES (15003, 2491, 13, 'Formulário de Inscrição');
INSERT INTO `lang_definitions` VALUES (15004, 2492, 13, 'Reabilitação');
INSERT INTO `lang_definitions` VALUES (15005, 2493, 13, 'Relate To');
INSERT INTO `lang_definitions` VALUES (15006, 2494, 13, 'Relacionados');
INSERT INTO `lang_definitions` VALUES (15007, 2495, 13, 'Relação (s) / Crianças');
INSERT INTO `lang_definitions` VALUES (15008, 2496, 13, 'Parentesco');
INSERT INTO `lang_definitions` VALUES (15009, 2497, 13, 'Parentes');
INSERT INTO `lang_definitions` VALUES (15010, 2498, 13, 'Credenciais Relay Saúde estão em falta a partir desta conta de usuário.');
INSERT INTO `lang_definitions` VALUES (15011, 2499, 13, 'Relay Saúde ID');
INSERT INTO `lang_definitions` VALUES (15012, 2500, 13, 'Religião');
INSERT INTO `lang_definitions` VALUES (15013, 2501, 13, 'Relogin');
INSERT INTO `lang_definitions` VALUES (15014, 2502, 13, 'Remover');
INSERT INTO `lang_definitions` VALUES (15015, 2503, 13, 'Remover Grupo');
INSERT INTO `lang_definitions` VALUES (15016, 2504, 13, 'Remover Grupo Forma');
INSERT INTO `lang_definitions` VALUES (15017, 2505, 13, 'Renal Stones');
INSERT INTO `lang_definitions` VALUES (15018, 2506, 13, 'Renomear Grupo');
INSERT INTO `lang_definitions` VALUES (15019, 2507, 13, 'Rendering');
INSERT INTO `lang_definitions` VALUES (15020, 2508, 13, 'Rendering Provider');
INSERT INTO `lang_definitions` VALUES (15021, 2509, 13, 'Rendering Provider Number');
INSERT INTO `lang_definitions` VALUES (15022, 2510, 13, 'Ao reordenar');
INSERT INTO `lang_definitions` VALUES (15023, 2511, 13, 'Info Repetindo:');
INSERT INTO `lang_definitions` VALUES (15024, 2512, 13, 'Repete');
INSERT INTO `lang_definitions` VALUES (15025, 2513, 13, 'Data Responder');
INSERT INTO `lang_definitions` VALUES (15026, 2514, 13, 'De Responder');
INSERT INTO `lang_definitions` VALUES (15027, 2515, 13, 'Relatório');
INSERT INTO `lang_definitions` VALUES (15028, 2516, 13, 'Relatório');
INSERT INTO `lang_definitions` VALUES (15029, 2517, 13, 'Totals Report');
INSERT INTO `lang_definitions` VALUES (15030, 2518, 13, 'Relatórios');
INSERT INTO `lang_definitions` VALUES (15031, 2519, 13, 'Pedido ignorado - tratamento dos pedidos já está em execução!');
INSERT INTO `lang_definitions` VALUES (15032, 2520, 13, 'Serviço solicitado');
INSERT INTO `lang_definitions` VALUES (15033, 2521, 13, 'Necessário');
INSERT INTO `lang_definitions` VALUES (15034, 2522, 13, 'RESERVADO');
INSERT INTO `lang_definitions` VALUES (15035, 2523, 13, 'Reservado');
INSERT INTO `lang_definitions` VALUES (15036, 2524, 13, 'Reservado para uso para definir o tempo de férias agendadas');
INSERT INTO `lang_definitions` VALUES (15037, 2525, 13, 'Reservado para definir quando um fornecedor pode não ter disponível após a nomeação.');
INSERT INTO `lang_definitions` VALUES (15038, 2526, 13, 'Reservado para definir quando um evento não ocorreu, conforme especificado.');
INSERT INTO `lang_definitions` VALUES (15039, 2527, 13, 'Tempo disponível na clínica.');
INSERT INTO `lang_definitions` VALUES (15040, 2528, 13, 'Resolvidas');
INSERT INTO `lang_definitions` VALUES (15041, 2529, 13, 'Respiração');
INSERT INTO `lang_definitions` VALUES (15042, 2530, 13, 'Esforço Respirador unlabored');
INSERT INTO `lang_definitions` VALUES (15043, 2531, 13, 'Respiratory');
INSERT INTO `lang_definitions` VALUES (15044, 2532, 13, 'Restrita Formação');
INSERT INTO `lang_definitions` VALUES (15045, 2533, 13, 'Resultado');
INSERT INTO `lang_definitions` VALUES (15046, 2534, 13, 'Resultados encontrados para pesquisa');
INSERT INTO `lang_definitions` VALUES (15047, 2535, 13, 'Exame da retina');
INSERT INTO `lang_definitions` VALUES (15048, 2536, 13, 'Retraído Direita:');
INSERT INTO `lang_definitions` VALUES (15049, 2537, 13, 'Retorno');
INSERT INTO `lang_definitions` VALUES (15050, 2538, 13, 'Voltar à agenda');
INSERT INTO `lang_definitions` VALUES (15051, 2539, 13, 'Valor de retorno');
INSERT INTO `lang_definitions` VALUES (15052, 2540, 13, 'Visite Retorno');
INSERT INTO `lang_definitions` VALUES (15053, 2541, 13, 'Voltou a jogar');
INSERT INTO `lang_definitions` VALUES (15054, 2542, 13, 'Revisão do PMH');
INSERT INTO `lang_definitions` VALUES (15055, 2543, 13, 'Revisão dos sistemas');
INSERT INTO `lang_definitions` VALUES (15056, 2544, 13, 'Antecedentes Pessoais');
INSERT INTO `lang_definitions` VALUES (15057, 2545, 13, 'Revisão');
INSERT INTO `lang_definitions` VALUES (15058, 2546, 13, 'Rheumotoid Arthritis');
INSERT INTO `lang_definitions` VALUES (15059, 2547, 13, 'Direito');
INSERT INTO `lang_definitions` VALUES (15060, 2548, 13, 'Orelha Direita');
INSERT INTO `lang_definitions` VALUES (15061, 2549, 13, 'orelha direita');
INSERT INTO `lang_definitions` VALUES (15062, 2550, 13, 'Direita:');
INSERT INTO `lang_definitions` VALUES (15063, 2551, 13, 'Zumbidos nos ouvidos');
INSERT INTO `lang_definitions` VALUES (15064, 2552, 13, 'Zumbidos nos ouvidos');
INSERT INTO `lang_definitions` VALUES (15065, 2553, 13, 'Fatores de Risco');
INSERT INTO `lang_definitions` VALUES (15066, 2554, 13, 'Nível de Risco');
INSERT INTO `lang_definitions` VALUES (15067, 2555, 13, 'RLL:');
INSERT INTO `lang_definitions` VALUES (15068, 2556, 13, 'ROM');
INSERT INTO `lang_definitions` VALUES (15069, 2557, 13, 'Plantel');
INSERT INTO `lang_definitions` VALUES (15070, 2558, 13, 'Rota');
INSERT INTO `lang_definitions` VALUES (15071, 2559, 13, 'Filas');
INSERT INTO `lang_definitions` VALUES (15072, 2560, 13, 'RRR sem MOR');
INSERT INTO `lang_definitions` VALUES (15073, 2561, 13, 'Rub:');
INSERT INTO `lang_definitions` VALUES (15074, 2562, 13, 'Rubs:');
INSERT INTO `lang_definitions` VALUES (15075, 2563, 13, 'Comando de duração:');
INSERT INTO `lang_definitions` VALUES (15076, 2564, 13, 'Ruptura');
INSERT INTO `lang_definitions` VALUES (15077, 2565, 13, 'Russo');
INSERT INTO `lang_definitions` VALUES (15078, 2566, 13, 'Rx');
INSERT INTO `lang_definitions` VALUES (15079, 2567, 13, 'RX');
INSERT INTO `lang_definitions` VALUES (15080, 2568, 13, 'S');
INSERT INTO `lang_definitions` VALUES (15081, 2569, 13, 'CPF');
INSERT INTO `lang_definitions` VALUES (15082, 2570, 13, 'S3:');
INSERT INTO `lang_definitions` VALUES (15083, 2571, 13, 'S4:');
INSERT INTO `lang_definitions` VALUES (15084, 2572, 13, 'SA * * Para ler a licença, por favor leia o docs / license.txt ou visite http://www.gnu.org/copyleft/gpl.html * * * / //============ ================================================== =========== / /');
INSERT INTO `lang_definitions` VALUES (15085, 2573, 13, 'Vendas');
INSERT INTO `lang_definitions` VALUES (15086, 2574, 13, 'Vendas por Item');
INSERT INTO `lang_definitions` VALUES (15087, 2575, 13, 'Relatório de vendas por produto');
INSERT INTO `lang_definitions` VALUES (15088, 2576, 13, 'Mesmo dia');
INSERT INTO `lang_definitions` VALUES (15089, 2577, 13, 'Amostra');
INSERT INTO `lang_definitions` VALUES (15090, 2578, 13, 'Sanção Tipo');
INSERT INTO `lang_definitions` VALUES (15091, 2579, 13, 'Sáb');
INSERT INTO `lang_definitions` VALUES (15092, 2580, 13, 'Sáb & Dom');
INSERT INTO `lang_definitions` VALUES (15093, 2581, 13, 'Sábado');
INSERT INTO `lang_definitions` VALUES (15094, 2582, 13, 'Salvar');
INSERT INTO `lang_definitions` VALUES (15095, 2583, 13, 'Salvar e Dispense');
INSERT INTO `lang_definitions` VALUES (15096, 2584, 13, 'Salvar como nova');
INSERT INTO `lang_definitions` VALUES (15097, 2585, 13, 'Salvar alterações');
INSERT INTO `lang_definitions` VALUES (15098, 2586, 13, 'Salvar Form');
INSERT INTO `lang_definitions` VALUES (15099, 2587, 13, 'Salvar Vacinação');
INSERT INTO `lang_definitions` VALUES (15100, 2588, 13, 'Salvar Novo Campo');
INSERT INTO `lang_definitions` VALUES (15101, 2589, 13, 'Salvar Novo Grupo');
INSERT INTO `lang_definitions` VALUES (15102, 2590, 13, 'Salvar Lista');
INSERT INTO `lang_definitions` VALUES (15103, 2591, 13, 'Salvar novo modelo');
INSERT INTO `lang_definitions` VALUES (15104, 2592, 13, 'Salvar Informações do Paciente');
INSERT INTO `lang_definitions` VALUES (15105, 2593, 13, 'Guarde bem sucedido para gráfico ID');
INSERT INTO `lang_definitions` VALUES (15106, 2594, 13, 'Salvar Operação');
INSERT INTO `lang_definitions` VALUES (15107, 2595, 13, 'Digitalizada');
INSERT INTO `lang_definitions` VALUES (15108, 2596, 13, 'Scanned Nota Encounter');
INSERT INTO `lang_definitions` VALUES (15109, 2597, 13, 'Em Scanner');
INSERT INTO `lang_definitions` VALUES (15110, 2598, 13, 'Cronograma');
INSERT INTO `lang_definitions` VALUES (15111, 2599, 13, 'Agenda da Clínica:');
INSERT INTO `lang_definitions` VALUES (15112, 2600, 13, 'NOTA ESCOLA');
INSERT INTO `lang_definitions` VALUES (15113, 2601, 13, 'Escoliose');
INSERT INTO `lang_definitions` VALUES (15114, 2602, 13, 'SE');
INSERT INTO `lang_definitions` VALUES (15115, 2603, 13, 'SE Endereço');
INSERT INTO `lang_definitions` VALUES (15116, 2604, 13, 'SE Cidade');
INSERT INTO `lang_definitions` VALUES (15117, 2605, 13, 'SE País');
INSERT INTO `lang_definitions` VALUES (15118, 2606, 13, 'SE Bairro');
INSERT INTO `lang_definitions` VALUES (15119, 2607, 13, 'SE CEP');
INSERT INTO `lang_definitions` VALUES (15120, 2608, 13, 'SE Estado');
INSERT INTO `lang_definitions` VALUES (15121, 2609, 13, 'SE CEP');
INSERT INTO `lang_definitions` VALUES (15122, 2610, 13, 'Pesquisa');
INSERT INTO `lang_definitions` VALUES (15123, 2611, 13, 'pesquisa');
INSERT INTO `lang_definitions` VALUES (15124, 2612, 13, 'busca novamente');
INSERT INTO `lang_definitions` VALUES (15125, 2613, 13, 'Busca por:');
INSERT INTO `lang_definitions` VALUES (15126, 2614, 13, 'Busca por:');
INSERT INTO `lang_definitions` VALUES (15127, 2615, 13, 'Procurar ou Adicionar Paciente');
INSERT INTO `lang_definitions` VALUES (15128, 2616, 13, 'Resultados da Pesquisa:');
INSERT INTO `lang_definitions` VALUES (15129, 2618, 13, 'Pesquisa de Eventos');
INSERT INTO `lang_definitions` VALUES (15130, 2619, 13, 'Buscar / Adicionar Seguradora');
INSERT INTO `lang_definitions` VALUES (15131, 2620, 13, 'Procurando nomeações');
INSERT INTO `lang_definitions` VALUES (15132, 2621, 13, 'Pesquisando ...');
INSERT INTO `lang_definitions` VALUES (15133, 2622, 13, 'Uso do cinto');
INSERT INTO `lang_definitions` VALUES (15134, 2623, 13, 'Use cinto de segurança');
INSERT INTO `lang_definitions` VALUES (15135, 2624, 13, 'Segunda');
INSERT INTO `lang_definitions` VALUES (15136, 2625, 13, 'Segundo');
INSERT INTO `lang_definitions` VALUES (15137, 2626, 13, 'Segundo Convênio');
INSERT INTO `lang_definitions` VALUES (15138, 2627, 13, 'Dados do Segundo Convênio');
INSERT INTO `lang_definitions` VALUES (15139, 2628, 13, 'Segundo Convênio');
INSERT INTO `lang_definitions` VALUES (15140, 2629, 13, 'Todos Médicos');
INSERT INTO `lang_definitions` VALUES (15141, 2630, 13, 'Veja Autorizações');
INSERT INTO `lang_definitions` VALUES (15142, 2631, 13, 'Veja Growth-chart');
INSERT INTO `lang_definitions` VALUES (15143, 2632, 13, 'Veja mensagens do último conjunto de créditos gerados');
INSERT INTO `lang_definitions` VALUES (15144, 2633, 13, 'Atividade desde');
INSERT INTO `lang_definitions` VALUES (15145, 2634, 13, 'Apreensões');
INSERT INTO `lang_definitions` VALUES (15146, 2635, 13, 'Sel');
INSERT INTO `lang_definitions` VALUES (15147, 2636, 13, 'Selecione');
INSERT INTO `lang_definitions` VALUES (15148, 2637, 13, 'Selecionar Tudo');
INSERT INTO `lang_definitions` VALUES (15149, 2639, 13, 'Selecionar campo');
INSERT INTO `lang_definitions` VALUES (15150, 2640, 13, 'Selecione Campo');
INSERT INTO `lang_definitions` VALUES (15151, 2641, 13, 'Selecionar para impressão');
INSERT INTO `lang_definitions` VALUES (15152, 2642, 13, 'Emissão Selecione');
INSERT INTO `lang_definitions` VALUES (15153, 2643, 13, 'Selecione os itens de configuração para exportação');
INSERT INTO `lang_definitions` VALUES (15154, 2644, 13, 'Selecione Sim para confirmar a exclusão do grupo');
INSERT INTO `lang_definitions` VALUES (15155, 2645, 13, 'Self');
INSERT INTO `lang_definitions` VALUES (15156, 2646, 13, 'Pagamento Self');
INSERT INTO `lang_definitions` VALUES (15157, 2647, 13, 'Enviar em andamento');
INSERT INTO `lang_definitions` VALUES (15158, 2649, 13, 'Remetente');
INSERT INTO `lang_definitions` VALUES (15159, 2650, 13, 'Remetente ID');
INSERT INTO `lang_definitions` VALUES (15160, 2653, 13, 'Sensibilidades');
INSERT INTO `lang_definitions` VALUES (15161, 2654, 13, 'Sensibilidade:');
INSERT INTO `lang_definitions` VALUES (15162, 2655, 13, 'Sensorial exame normal');
INSERT INTO `lang_definitions` VALUES (15163, 2656, 13, 'Enviada com sucesso!');
INSERT INTO `lang_definitions` VALUES (15164, 2657, 13, 'enviadas para a impressora.');
INSERT INTO `lang_definitions` VALUES (15165, 2658, 13, 'Separado');
INSERT INTO `lang_definitions` VALUES (15166, 2659, 13, 'Setembro');
INSERT INTO `lang_definitions` VALUES (15167, 2660, 13, 'Categoria de Serviço');
INSERT INTO `lang_definitions` VALUES (15168, 2661, 13, 'Data Serviço');
INSERT INTO `lang_definitions` VALUES (15169, 2662, 13, 'Data Serviço:');
INSERT INTO `lang_definitions` VALUES (15170, 2663, 13, 'Localização');
INSERT INTO `lang_definitions` VALUES (15171, 2664, 13, 'Serviço prestado pelo especialista');
INSERT INTO `lang_definitions` VALUES (15172, 2665, 13, 'Serviços');
INSERT INTO `lang_definitions` VALUES (15173, 2666, 13, 'Serviços por Categoria');
INSERT INTO `lang_definitions` VALUES (15174, 2667, 13, 'Serviços prestados');
INSERT INTO `lang_definitions` VALUES (15175, 2668, 13, 'Serviços Prestados');
INSERT INTO `lang_definitions` VALUES (15176, 2669, 13, 'Definições');
INSERT INTO `lang_definitions` VALUES (15177, 2670, 13, 'Severe Migraine');
INSERT INTO `lang_definitions` VALUES (15178, 2671, 13, 'Severidade da dor');
INSERT INTO `lang_definitions` VALUES (15179, 2672, 13, 'Severidade da dor:');
INSERT INTO `lang_definitions` VALUES (15180, 2673, 13, 'Sexo');
INSERT INTO `lang_definitions` VALUES (15181, 2674, 13, 'Doenças Sexualmente Transmissíveis');
INSERT INTO `lang_definitions` VALUES (15182, 2675, 13, 'Compartilhamento');
INSERT INTO `lang_definitions` VALUES (15183, 2676, 13, 'Falta de ar');
INSERT INTO `lang_definitions` VALUES (15184, 2677, 13, 'Shortness de respiração');
INSERT INTO `lang_definitions` VALUES (15185, 2678, 13, 'Shortness de respiração 2');
INSERT INTO `lang_definitions` VALUES (15186, 2679, 13, 'Shot Record');
INSERT INTO `lang_definitions` VALUES (15187, 2680, 13, 'Shot Record a partir de:');
INSERT INTO `lang_definitions` VALUES (15188, 2681, 13, 'deve ser como nnnnn nnnn-nn');
INSERT INTO `lang_definitions` VALUES (15189, 2682, 13, 'Ombro');
INSERT INTO `lang_definitions` VALUES (15190, 2683, 13, 'Ombro + clavícula');
INSERT INTO `lang_definitions` VALUES (15191, 2684, 13, 'Problemas de ombro');
INSERT INTO `lang_definitions` VALUES (15192, 2685, 13, 'Mostrar');
INSERT INTO `lang_definitions` VALUES (15193, 2686, 13, 'Mostrar como Ocupado');
INSERT INTO `lang_definitions` VALUES (15194, 2687, 13, 'Mostrar apenas autorizado');
INSERT INTO `lang_definitions` VALUES (15195, 2688, 13, 'Mostrar Detalhes');
INSERT INTO `lang_definitions` VALUES (15196, 2689, 13, 'Mostrar texto de eventos que paira sobre mouseover?');
INSERT INTO `lang_definitions` VALUES (15197, 2690, 13, 'Mostrar eventos como muitas páginas de administração?');
INSERT INTO `lang_definitions` VALUES (15198, 2692, 13, 'Mostrar Relatório');
INSERT INTO `lang_definitions` VALUES (15199, 2693, 13, 'Mostrar / Buscar - apresentar links em bloco?');
INSERT INTO `lang_definitions` VALUES (15200, 2694, 13, 'Mostrar só não faturada');
INSERT INTO `lang_definitions` VALUES (15201, 2695, 13, 'Irmãos');
INSERT INTO `lang_definitions` VALUES (15202, 2696, 13, 'Sickle Cell');
INSERT INTO `lang_definitions` VALUES (15203, 2697, 13, 'Sig');
INSERT INTO `lang_definitions` VALUES (15204, 2698, 13, 'Sigmóide / Colonoscopia');
INSERT INTO `lang_definitions` VALUES (15205, 2699, 13, 'Assinatura');
INSERT INTO `lang_definitions` VALUES (15206, 2700, 13, 'Assinatura:');
INSERT INTO `lang_definitions` VALUES (15207, 2702, 13, 'Inchaço significativo:');
INSERT INTO `lang_definitions` VALUES (15208, 2703, 13, 'Desde');
INSERT INTO `lang_definitions` VALUES (15209, 2705, 13, 'Solteiro');
INSERT INTO `lang_definitions` VALUES (15210, 2706, 13, 'Problemas do seio');
INSERT INTO `lang_definitions` VALUES (15211, 2707, 13, 'Sinus Cirurgia');
INSERT INTO `lang_definitions` VALUES (15212, 2708, 13, 'SINUS ternura:');
INSERT INTO `lang_definitions` VALUES (15213, 2709, 13, 'Sinusite');
INSERT INTO `lang_definitions` VALUES (15214, 2710, 13, 'Tamanho');
INSERT INTO `lang_definitions` VALUES (15215, 2711, 13, 'Tamanho deve ser um número entre 1 e 999');
INSERT INTO `lang_definitions` VALUES (15216, 2712, 13, 'Tamanho / Lista');
INSERT INTO `lang_definitions` VALUES (15217, 2713, 13, 'Pele');
INSERT INTO `lang_definitions` VALUES (15218, 2714, 13, 'Câncer de Pele');
INSERT INTO `lang_definitions` VALUES (15219, 2715, 13, 'Doença de pele');
INSERT INTO `lang_definitions` VALUES (15220, 2716, 13, 'De pele Outros');
INSERT INTO `lang_definitions` VALUES (15221, 2718, 13, 'Os padrões de sono');
INSERT INTO `lang_definitions` VALUES (15222, 2719, 13, 'Os padrões de sono');
INSERT INTO `lang_definitions` VALUES (15223, 2720, 13, 'Sono');
INSERT INTO `lang_definitions` VALUES (15224, 2721, 13, 'Eslovaco');
INSERT INTO `lang_definitions` VALUES (15225, 2722, 13, 'Sm dívida w / o');
INSERT INTO `lang_definitions` VALUES (15226, 2723, 13, 'Smarty Cache foi limpo');
INSERT INTO `lang_definitions` VALUES (15227, 2724, 13, 'SMS Gateway');
INSERT INTO `lang_definitions` VALUES (15228, 2725, 13, 'SMS Gateway API chave');
INSERT INTO `lang_definitions` VALUES (15229, 2726, 13, 'Notificação de SMS');
INSERT INTO `lang_definitions` VALUES (15230, 2727, 13, 'Antes de enviar SMS');
INSERT INTO `lang_definitions` VALUES (15231, 2728, 13, 'Texto SMS, Usable Tag: *** NOME ***, *** Médico ***, *** DATA ***, *** STARTTIME ***, *** *** ENDTIME <br> ou seja, Dear *** NOME ***');
INSERT INTO `lang_definitions` VALUES (15232, 2729, 13, 'SMS / Email configurações de alerta');
INSERT INTO `lang_definitions` VALUES (15233, 2730, 13, 'Ronco');
INSERT INTO `lang_definitions` VALUES (15234, 2731, 13, 'Anamnese');
INSERT INTO `lang_definitions` VALUES (15235, 2732, 13, 'Dificuldades Social');
INSERT INTO `lang_definitions` VALUES (15236, 2733, 13, 'Histórico Social:');
INSERT INTO `lang_definitions` VALUES (15237, 2734, 13, 'Social Security Number');
INSERT INTO `lang_definitions` VALUES (15238, 2735, 13, 'solução');
INSERT INTO `lang_definitions` VALUES (15239, 2736, 13, 'Somatic Contexto');
INSERT INTO `lang_definitions` VALUES (15240, 2737, 13, 'Algumas autorizações não foram exibidos. Clique aqui para ver todos');
INSERT INTO `lang_definitions` VALUES (15241, 2738, 13, 'Alguns códigos não eram exibidas.');
INSERT INTO `lang_definitions` VALUES (15242, 2739, 13, 'Alguns encontros não foram exibidos. Clique aqui para ver todos.');
INSERT INTO `lang_definitions` VALUES (15243, 2740, 13, 'Algumas notas não eram exibidas.');
INSERT INTO `lang_definitions` VALUES (15244, 2741, 13, 'algumas palavras');
INSERT INTO `lang_definitions` VALUES (15245, 2742, 13, 'Sore Throat');
INSERT INTO `lang_definitions` VALUES (15246, 2743, 13, 'Ordenar por');
INSERT INTO `lang_definitions` VALUES (15247, 2744, 13, 'Ordenar por Comentários');
INSERT INTO `lang_definitions` VALUES (15248, 2745, 13, 'Classificar por data');
INSERT INTO `lang_definitions` VALUES (15249, 2746, 13, 'Classificar por data / hora');
INSERT INTO `lang_definitions` VALUES (15250, 2747, 13, 'Ordenar por evento');
INSERT INTO `lang_definitions` VALUES (15251, 2748, 13, 'Classificar por grupo');
INSERT INTO `lang_definitions` VALUES (15252, 2749, 13, 'Ordenar por Usuário');
INSERT INTO `lang_definitions` VALUES (15253, 2750, 13, 'Ordenar por vacinas');
INSERT INTO `lang_definitions` VALUES (15254, 2751, 13, 'Fonte');
INSERT INTO `lang_definitions` VALUES (15255, 2752, 13, 'Fonte está faltando para o código');
INSERT INTO `lang_definitions` VALUES (15256, 2753, 13, 'Fonte:');
INSERT INTO `lang_definitions` VALUES (15257, 2754, 13, 'Espanhol');
INSERT INTO `lang_definitions` VALUES (15258, 2755, 13, 'Especialista em nome e assinatura');
INSERT INTO `lang_definitions` VALUES (15259, 2756, 13, 'Especialidade');
INSERT INTO `lang_definitions` VALUES (15260, 2757, 13, 'Especialidade Systems');
INSERT INTO `lang_definitions` VALUES (15261, 2758, 13, 'Especialidade:');
INSERT INTO `lang_definitions` VALUES (15262, 2759, 13, 'Específicos');
INSERT INTO `lang_definitions` VALUES (15263, 2760, 13, 'Específica');
INSERT INTO `lang_definitions` VALUES (15264, 2761, 13, 'Ditado Speech');
INSERT INTO `lang_definitions` VALUES (15265, 2762, 13, 'Espermicidas');
INSERT INTO `lang_definitions` VALUES (15266, 2763, 13, 'Esplenectomia');
INSERT INTO `lang_definitions` VALUES (15267, 2764, 13, 'Cônjuge');
INSERT INTO `lang_definitions` VALUES (15268, 2765, 13, 'Escarro');
INSERT INTO `lang_definitions` VALUES (15269, 2766, 13, 'Escarro:');
INSERT INTO `lang_definitions` VALUES (15270, 2767, 13, 'SQ');
INSERT INTO `lang_definitions` VALUES (15271, 2768, 13, 'Plantel');
INSERT INTO `lang_definitions` VALUES (15272, 2769, 13, 'Squad Sócio');
INSERT INTO `lang_definitions` VALUES (15273, 2770, 13, 'Esquadrões');
INSERT INTO `lang_definitions` VALUES (15274, 2771, 13, 'SRH');
INSERT INTO `lang_definitions` VALUES (15275, 2772, 13, 'SRH - Planejamento Familiar');
INSERT INTO `lang_definitions` VALUES (15276, 2773, 13, 'SRH Non Planejamento Familiar');
INSERT INTO `lang_definitions` VALUES (15277, 2774, 13, 'SRH Referências');
INSERT INTO `lang_definitions` VALUES (15278, 2775, 13, 'SRH Ficha de Visita');
INSERT INTO `lang_definitions` VALUES (15279, 2776, 13, 'CPF');
INSERT INTO `lang_definitions` VALUES (15280, 2777, 13, 'CPF');
INSERT INTO `lang_definitions` VALUES (15281, 2778, 13, 'Estabilidade');
INSERT INTO `lang_definitions` VALUES (15282, 2779, 13, 'Normal');
INSERT INTO `lang_definitions` VALUES (15283, 2780, 13, 'Iniciar');
INSERT INTO `lang_definitions` VALUES (15284, 2781, 13, 'Start (aaaa-mm-dd):');
INSERT INTO `lang_definitions` VALUES (15285, 2782, 13, 'Data de Início');
INSERT INTO `lang_definitions` VALUES (15286, 2783, 13, 'Data de início na clínica');
INSERT INTO `lang_definitions` VALUES (15287, 2784, 13, 'Data de início:');
INSERT INTO `lang_definitions` VALUES (15288, 2785, 13, 'Data de início:');
INSERT INTO `lang_definitions` VALUES (15289, 2786, 13, 'Data de Início');
INSERT INTO `lang_definitions` VALUES (15290, 2787, 13, 'Data de início');
INSERT INTO `lang_definitions` VALUES (15291, 2788, 13, 'Estado');
INSERT INTO `lang_definitions` VALUES (15292, 2789, 13, 'Estado');
INSERT INTO `lang_definitions` VALUES (15293, 2790, 13, 'Lista Estado (escrever, adicionar opcional)');
INSERT INTO `lang_definitions` VALUES (15294, 2791, 13, 'Estado / Local');
INSERT INTO `lang_definitions` VALUES (15295, 2792, 13, 'Estado / Parish');
INSERT INTO `lang_definitions` VALUES (15296, 2793, 13, 'Estatísticas');
INSERT INTO `lang_definitions` VALUES (15297, 2794, 13, 'Stats');
INSERT INTO `lang_definitions` VALUES (15298, 2795, 13, 'Status');
INSERT INTO `lang_definitions` VALUES (15299, 2796, 13, 'Status quo');
INSERT INTO `lang_definitions` VALUES (15300, 2797, 13, 'DST / AIDS Couns');
INSERT INTO `lang_definitions` VALUES (15301, 2798, 13, 'Stength e Condicionamento');
INSERT INTO `lang_definitions` VALUES (15302, 2799, 13, 'Stiff Articulações');
INSERT INTO `lang_definitions` VALUES (15303, 2800, 13, 'Rigidez');
INSERT INTO `lang_definitions` VALUES (15304, 2801, 13, 'Dores de estômago');
INSERT INTO `lang_definitions` VALUES (15305, 2802, 13, 'Tensão do músculo');
INSERT INTO `lang_definitions` VALUES (15306, 2803, 13, 'Fluxo');
INSERT INTO `lang_definitions` VALUES (15307, 2804, 13, 'Rua');
INSERT INTO `lang_definitions` VALUES (15308, 2806, 13, 'Rua e número');
INSERT INTO `lang_definitions` VALUES (15309, 2807, 13, 'Força');
INSERT INTO `lang_definitions` VALUES (15310, 2808, 13, 'Strep Throat');
INSERT INTO `lang_definitions` VALUES (15311, 2809, 13, 'Fratura de estresse');
INSERT INTO `lang_definitions` VALUES (15312, 2810, 13, 'Teste de Stress');
INSERT INTO `lang_definitions` VALUES (15313, 2811, 13, 'Enfarte');
INSERT INTO `lang_definitions` VALUES (15314, 2812, 13, 'Sub-categoria');
INSERT INTO `lang_definitions` VALUES (15315, 2813, 13, 'Sub-Total');
INSERT INTO `lang_definitions` VALUES (15316, 2814, 13, 'Subcategoria');
INSERT INTO `lang_definitions` VALUES (15317, 2815, 13, 'subcategoria');
INSERT INTO `lang_definitions` VALUES (15318, 2816, 13, 'subcutânea');
INSERT INTO `lang_definitions` VALUES (15319, 2817, 13, 'QeD');
INSERT INTO `lang_definitions` VALUES (15320, 2818, 13, 'Sublingual');
INSERT INTO `lang_definitions` VALUES (15321, 2819, 13, 'sublingual');
INSERT INTO `lang_definitions` VALUES (15322, 2820, 13, 'Enviar');
INSERT INTO `lang_definitions` VALUES (15323, 2822, 13, 'Submeter evento');
INSERT INTO `lang_definitions` VALUES (15324, 2823, 13, 'enviar o formulário');
INSERT INTO `lang_definitions` VALUES (15325, 2826, 13, 'Enviado por');
INSERT INTO `lang_definitions` VALUES (15326, 2828, 13, 'Titular');
INSERT INTO `lang_definitions` VALUES (15327, 2829, 13, 'Endereço do Titular');
INSERT INTO `lang_definitions` VALUES (15328, 2830, 13, 'Empresa Titular');
INSERT INTO `lang_definitions` VALUES (15329, 2831, 13, 'Empresa Titular(SE)');
INSERT INTO `lang_definitions` VALUES (15330, 2832, 13, 'Endereço da Empresa Titular');
INSERT INTO `lang_definitions` VALUES (15331, 2833, 13, 'Cidade da Empresa Titular');
INSERT INTO `lang_definitions` VALUES (15332, 2834, 13, 'País da Empresa Titular');
INSERT INTO `lang_definitions` VALUES (15333, 2835, 13, 'Estado da Empresa Titular');
INSERT INTO `lang_definitions` VALUES (15334, 2836, 13, 'CEP da Empresa Titular');
INSERT INTO `lang_definitions` VALUES (15335, 2837, 13, 'Telefone Titular');
INSERT INTO `lang_definitions` VALUES (15336, 2838, 13, 'Titular Parentesco');
INSERT INTO `lang_definitions` VALUES (15337, 2839, 13, 'Titular Parentesco não é auto mas o nome é o mesmo! Is this OK?');
INSERT INTO `lang_definitions` VALUES (15338, 2840, 13, 'Titular Parentesco não é auto-SS, mas o número é o mesmo!');
INSERT INTO `lang_definitions` VALUES (15339, 2841, 13, 'Relação de Titular é auto mas o nome é diferente! Is this OK?');
INSERT INTO `lang_definitions` VALUES (15340, 2842, 13, 'Relação de Titular é auto, mas número de SS é diferente!');
INSERT INTO `lang_definitions` VALUES (15341, 2843, 13, 'Sexo do Titular');
INSERT INTO `lang_definitions` VALUES (15342, 2844, 13, 'Substituição');
INSERT INTO `lang_definitions` VALUES (15343, 2845, 13, 'substituição permitiu');
INSERT INTO `lang_definitions` VALUES (15344, 2846, 13, 'sucesso');
INSERT INTO `lang_definitions` VALUES (15345, 2847, 13, 'adicionado com êxito para a categoria,');
INSERT INTO `lang_definitions` VALUES (15346, 2848, 13, 'armazenados com êxito.');
INSERT INTO `lang_definitions` VALUES (15347, 2849, 13, 'com êxito.');
INSERT INTO `lang_definitions` VALUES (15348, 2850, 13, 'Suicídio');
INSERT INTO `lang_definitions` VALUES (15349, 2851, 13, 'Resumo');
INSERT INTO `lang_definitions` VALUES (15350, 2852, 13, 'Dom');
INSERT INTO `lang_definitions` VALUES (15351, 2853, 13, 'Domingo');
INSERT INTO `lang_definitions` VALUES (15352, 2854, 13, 'Superbill');
INSERT INTO `lang_definitions` VALUES (15353, 2855, 13, 'Superbill Códigos');
INSERT INTO `lang_definitions` VALUES (15354, 2856, 13, 'Superbill Códigos Administração');
INSERT INTO `lang_definitions` VALUES (15355, 2857, 13, 'Superbill Relatório');
INSERT INTO `lang_definitions` VALUES (15356, 2858, 13, 'Superbills, às vezes chamado de Encontro Forms ou deslizamentos de roteamento, são uma parte essencial da maioria das práticas médicas.');
INSERT INTO `lang_definitions` VALUES (15357, 2859, 13, 'Superusuário');
INSERT INTO `lang_definitions` VALUES (15358, 2860, 13, 'Supervisão');
INSERT INTO `lang_definitions` VALUES (15359, 2861, 13, 'Tipo de superfície');
INSERT INTO `lang_definitions` VALUES (15360, 2862, 13, 'Cirurgias');
INSERT INTO `lang_definitions` VALUES (15361, 2863, 13, 'Cirurgia');
INSERT INTO `lang_definitions` VALUES (15362, 2864, 13, 'Suspenso');
INSERT INTO `lang_definitions` VALUES (15363, 2865, 13, 'suspensão');
INSERT INTO `lang_definitions` VALUES (15364, 2866, 13, 'Data Svc');
INSERT INTO `lang_definitions` VALUES (15365, 2867, 13, 'Data Svc:');
INSERT INTO `lang_definitions` VALUES (15366, 2868, 13, 'Transpiração:');
INSERT INTO `lang_definitions` VALUES (15367, 2869, 13, 'Sueco');
INSERT INTO `lang_definitions` VALUES (15368, 2870, 13, 'Inchaço');
INSERT INTO `lang_definitions` VALUES (15369, 2871, 13, 'Inchaço Direito');
INSERT INTO `lang_definitions` VALUES (15370, 2872, 13, 'Articulações inchadas');
INSERT INTO `lang_definitions` VALUES (15371, 2873, 13, 'Linfonodos inchados');
INSERT INTO `lang_definitions` VALUES (15372, 2874, 13, 'Sintomas');
INSERT INTO `lang_definitions` VALUES (15373, 2875, 13, 'Síncope');
INSERT INTO `lang_definitions` VALUES (15374, 2876, 13, 'Sinovite, choque, bursite');
INSERT INTO `lang_definitions` VALUES (15375, 2877, 13, 'Sistema');
INSERT INTO `lang_definitions` VALUES (15376, 2878, 13, 'T');
INSERT INTO `lang_definitions` VALUES (15377, 2879, 13, 't.i.d.');
INSERT INTO `lang_definitions` VALUES (15378, 2880, 13, 'T.V.');
INSERT INTO `lang_definitions` VALUES (15379, 2881, 13, 'Criação da tabela falhou');
INSERT INTO `lang_definitions` VALUES (15380, 2882, 13, 'Tabela de atualização falhou');
INSERT INTO `lang_definitions` VALUES (15381, 2883, 13, 'comprimido');
INSERT INTO `lang_definitions` VALUES (15382, 2884, 13, 'Pegar');
INSERT INTO `lang_definitions` VALUES (15383, 2885, 13, 'Leva tempo');
INSERT INTO `lang_definitions` VALUES (15384, 2886, 13, 'Taxa de imposto');
INSERT INTO `lang_definitions` VALUES (15385, 2887, 13, 'Impostos');
INSERT INTO `lang_definitions` VALUES (15386, 2888, 13, 'Taxonomia');
INSERT INTO `lang_definitions` VALUES (15387, 2889, 13, 'Td');
INSERT INTO `lang_definitions` VALUES (15388, 2890, 13, 'Team Injury Visão');
INSERT INTO `lang_definitions` VALUES (15389, 2891, 13, 'Team Ordem de Serviço');
INSERT INTO `lang_definitions` VALUES (15390, 2892, 13, 'Team Ordem de Serviço Ver');
INSERT INTO `lang_definitions` VALUES (15391, 2893, 13, 'Tel');
INSERT INTO `lang_definitions` VALUES (15392, 2895, 13, 'Temp Localização');
INSERT INTO `lang_definitions` VALUES (15393, 2896, 13, 'Temp Método');
INSERT INTO `lang_definitions` VALUES (15394, 2897, 13, 'Temperatura');
INSERT INTO `lang_definitions` VALUES (15395, 2898, 13, 'Template');
INSERT INTO `lang_definitions` VALUES (15396, 2899, 13, 'Nome do Modelo');
INSERT INTO `lang_definitions` VALUES (15397, 2900, 13, 'Template nomes não podem começar com números.');
INSERT INTO `lang_definitions` VALUES (15398, 2901, 13, 'Modelo:');
INSERT INTO `lang_definitions` VALUES (15399, 2902, 13, 'Modelos');
INSERT INTO `lang_definitions` VALUES (15400, 2903, 13, 'Têmpora');
INSERT INTO `lang_definitions` VALUES (15401, 2904, 13, 'Lesão no tendão');
INSERT INTO `lang_definitions` VALUES (15402, 2905, 13, 'Tendinite / osis / bursite');
INSERT INTO `lang_definitions` VALUES (15403, 2906, 13, 'Terceiro');
INSERT INTO `lang_definitions` VALUES (15404, 2907, 13, 'Terceiro Convênio');
INSERT INTO `lang_definitions` VALUES (15405, 2908, 13, 'Dados do Terceiro Convênio');
INSERT INTO `lang_definitions` VALUES (15406, 2909, 13, 'Terceiro Convênio');
INSERT INTO `lang_definitions` VALUES (15407, 2910, 13, 'Programação de Teste');
INSERT INTO `lang_definitions` VALUES (15408, 2911, 13, 'Test System');
INSERT INTO `lang_definitions` VALUES (15409, 2912, 13, 'Text-data');
INSERT INTO `lang_definitions` VALUES (15410, 2913, 13, 'text-data');
INSERT INTO `lang_definitions` VALUES (15411, 2914, 13, 'Textarea');
INSERT INTO `lang_definitions` VALUES (15412, 2915, 13, 'textarea');
INSERT INTO `lang_definitions` VALUES (15413, 2916, 13, 'Textbox');
INSERT INTO `lang_definitions` VALUES (15414, 2917, 13, 'textbox');
INSERT INTO `lang_definitions` VALUES (15415, 2918, 13, 'Lista Textbox');
INSERT INTO `lang_definitions` VALUES (15416, 2919, 13, 'lista de texto');
INSERT INTO `lang_definitions` VALUES (15417, 2920, 13, 'Obrigado');
INSERT INTO `lang_definitions` VALUES (15418, 2921, 13, 'A alegação de arquivo:');
INSERT INTO `lang_definitions` VALUES (15419, 2922, 13, 'O formulário de destino foi fechado, não posso agir em sua seleção.');
INSERT INTO `lang_definitions` VALUES (15420, 2923, 13, 'O evento (s) foram aprovados.');
INSERT INTO `lang_definitions` VALUES (15421, 2924, 13, 'O evento (s) foram escondidos.');
INSERT INTO `lang_definitions` VALUES (15422, 2925, 13, 'Os dados exportados aparece na área de texto abaixo. Você pode copiar e colar as informações em um e-mail ou para qualquer outro destino desejado.');
INSERT INTO `lang_definitions` VALUES (15423, 2926, 13, 'O calendário de eventos a seguir foi adicionado:');
INSERT INTO `lang_definitions` VALUES (15424, 2927, 13, 'O calendário de eventos que se segue foi modifed:');
INSERT INTO `lang_definitions` VALUES (15425, 2928, 13, 'Os seguintes erros ocorreram');
INSERT INTO `lang_definitions` VALUES (15426, 2929, 13, 'A janela inicial é a página de pesquisa na factura. No topo você pode inserir um código (número do cheque, por exemplo), pagamento de data e quantidade de seleção. A razão para isto é não ter que inseri-las uma e outra vez de cada pedido. A quantidade que você inserir será reduzida para cada nota fiscal que é dado parte do pagamento, e esperamos que vai terminar em zero quando você está feito.');
INSERT INTO `lang_definitions` VALUES (15427, 2930, 13, 'O rótulo que aparece para o usuário sobre a forma');
INSERT INTO `lang_definitions` VALUES (15428, 2931, 13, 'A nova categoria será uma sub-categoria de');
INSERT INTO `lang_definitions` VALUES (15429, 2932, 13, 'As demais informações a seguir só se aplica se você está postando manualmente, ou se você está fazendo correções manuais.');
INSERT INTO `lang_definitions` VALUES (15430, 2933, 13, 'O documento solicitado não está presente no local previsto no sistema de arquivos ou não existem permissões suficientes para acessá-lo.');
INSERT INTO `lang_definitions` VALUES (15431, 2934, 13, 'As colunas de origem e data são copiados da primeira página, assim que normalmente você não vai precisar tocar essas. Você pode colocar um valor de pagamento na coluna Pay, um ajuste no montante de Ajuste de coluna, ou ambos. Você também pode clicar no \"\"W \"\" sobre o direito de computar automaticamente um valor de ajuste que escreve fora do restante da carga para esse item.');
INSERT INTO `lang_definitions` VALUES (15432, 2935, 13, 'O rótulo traduzido que irá aparecer no formulário em linguagem corrente');
INSERT INTO `lang_definitions` VALUES (15433, 2936, 13, 'O título traduzido que aparecerá na linguagem corrente');
INSERT INTO `lang_definitions` VALUES (15434, 2937, 13, 'A tradução da descrição em linguagem corrente');
INSERT INTO `lang_definitions` VALUES (15435, 2938, 13, 'O X12 arquivos, bem como os relatórios resultantes de saída HTML são arquivados na pasta \"\"era \"\" subdiretório do diretório principal OpenEMR instalação. Você vai querer referir-se a estes arquivos de vez em quando. O URL é');
INSERT INTO `lang_definitions` VALUES (15436, 2939, 13, 'Injeções terapêuticas');
INSERT INTO `lang_definitions` VALUES (15437, 2940, 13, 'Há');
INSERT INTO `lang_definitions` VALUES (15438, 2941, 13, 'Há erros com a sua apresentação. Estes são descritos abaixo.');
INSERT INTO `lang_definitions` VALUES (15439, 2942, 13, 'Não existem argumentos Novos');
INSERT INTO `lang_definitions` VALUES (15440, 2943, 13, 'Houve um erro de envio de email para');
INSERT INTO `lang_definitions` VALUES (15441, 2947, 13, 'Não há entrada para o COA AR conta');
INSERT INTO `lang_definitions` VALUES (15442, 2948, 13, 'Não há entrada de dinheiro por conta COA');
INSERT INTO `lang_definitions` VALUES (15443, 2949, 13, 'Não há entrada do COA de balança de rendimentos');
INSERT INTO `lang_definitions` VALUES (15444, 2950, 13, 'Não há correspondência para id fatura');
INSERT INTO `lang_definitions` VALUES (15445, 2951, 13, 'Não há correspondência para fatura id =');
INSERT INTO `lang_definitions` VALUES (15446, 2952, 13, 'Não há entrada de peças para os serviços de identificação');
INSERT INTO `lang_definitions` VALUES (15447, 2953, 13, 'Houve um erro ao processar seu pedido.');
INSERT INTO `lang_definitions` VALUES (15448, 2954, 13, 'Engrossado Direita:');
INSERT INTO `lang_definitions` VALUES (15449, 2955, 13, 'Coxa');
INSERT INTO `lang_definitions` VALUES (15450, 2956, 13, 'Coxa + tendão');
INSERT INTO `lang_definitions` VALUES (15451, 2957, 13, 'Coisas que a administração pode ler e digitar, mas não modificar');
INSERT INTO `lang_definitions` VALUES (15452, 2958, 13, 'Coisas que a administração pode ler e modificar');
INSERT INTO `lang_definitions` VALUES (15453, 2959, 13, 'Coisas que os clínicos podem ler e entrar, mas não modificar');
INSERT INTO `lang_definitions` VALUES (15454, 2960, 13, 'Coisas que os clínicos podem ler e modificar');
INSERT INTO `lang_definitions` VALUES (15455, 2961, 13, 'Coisas que o escritório da frente pode ler e digitar, mas não modificar');
INSERT INTO `lang_definitions` VALUES (15456, 2962, 13, 'Coisas que o escritório da frente pode ler e modificar');
INSERT INTO `lang_definitions` VALUES (15457, 2963, 13, 'Coisas que os médicos podem ler e entrar, mas não modificar');
INSERT INTO `lang_definitions` VALUES (15458, 2964, 13, 'Coisas que os médicos podem ler e modificar');
INSERT INTO `lang_definitions` VALUES (15459, 2965, 13, 'Terceira');
INSERT INTO `lang_definitions` VALUES (15460, 2966, 13, 'Essa ação não pode ser desfeita.');
INSERT INTO `lang_definitions` VALUES (15461, 2967, 13, 'Essa ação não pode ser desfeita.');
INSERT INTO `lang_definitions` VALUES (15462, 2968, 13, 'Este tipo de código não aceita as relações.');
INSERT INTO `lang_definitions` VALUES (15463, 2969, 13, 'Este Encontro');
INSERT INTO `lang_definitions` VALUES (15464, 2971, 13, 'Este número da fatura foi alterado para');
INSERT INTO `lang_definitions` VALUES (15465, 2972, 13, 'Este módulo está em modo de teste. O banco de dados não serão alterados.');
INSERT INTO `lang_definitions` VALUES (15466, 2973, 13, 'Este módulo promove a entrada eficiente de dados EOB.');
INSERT INTO `lang_definitions` VALUES (15467, 2974, 13, 'Esta página irá incluir inline na página de login, de modo que não temos a relogin clique de cada vez.');
INSERT INTO `lang_definitions` VALUES (15468, 2975, 13, 'Este paciente não tem atividade.');
INSERT INTO `lang_definitions` VALUES (15469, 2976, 13, 'Este paciente ID já está em uso!');
INSERT INTO `lang_definitions` VALUES (15470, 2977, 13, 'Este usuário não é um membro de qualquer grupo');
INSERT INTO `lang_definitions` VALUES (15471, 2978, 13, 'Esta visita começa o uso de anticoncepcionais novo');
INSERT INTO `lang_definitions` VALUES (15472, 2979, 13, 'Isto irá criar um backup no formato tar e depois enviá-lo para seu navegador para que você possa salvá-lo');
INSERT INTO `lang_definitions` VALUES (15473, 2980, 13, 'A coluna torácica');
INSERT INTO `lang_definitions` VALUES (15474, 2981, 13, 'Garganta');
INSERT INTO `lang_definitions` VALUES (15475, 2982, 13, 'Cancro da garganta');
INSERT INTO `lang_definitions` VALUES (15476, 2983, 13, 'Cirurgia de Câncer de Garganta');
INSERT INTO `lang_definitions` VALUES (15477, 2984, 13, 'Trombose / Curso');
INSERT INTO `lang_definitions` VALUES (15478, 2985, 13, 'Qui');
INSERT INTO `lang_definitions` VALUES (15479, 2986, 13, 'Quinta');
INSERT INTO `lang_definitions` VALUES (15480, 2987, 13, 'Quinta-feira');
INSERT INTO `lang_definitions` VALUES (15481, 2988, 13, 'Tiróide normal');
INSERT INTO `lang_definitions` VALUES (15482, 2989, 13, 'Problemas do Tiróide');
INSERT INTO `lang_definitions` VALUES (15483, 2990, 13, 'TIA');
INSERT INTO `lang_definitions` VALUES (15484, 2991, 13, 'Horário');
INSERT INTO `lang_definitions` VALUES (15485, 2992, 13, 'Incremento de tempo para Add (minutos 1-60)');
INSERT INTO `lang_definitions` VALUES (15486, 2993, 13, 'Evento Temporário');
INSERT INTO `lang_definitions` VALUES (15487, 2994, 13, 'Matriz Times (N / A)');
INSERT INTO `lang_definitions` VALUES (15488, 2995, 13, 'Timestamp e Texto');
INSERT INTO `lang_definitions` VALUES (15489, 2996, 13, 'TIN');
INSERT INTO `lang_definitions` VALUES (15490, 2997, 13, 'Zumbido');
INSERT INTO `lang_definitions` VALUES (15491, 2998, 13, 'Queixa');
INSERT INTO `lang_definitions` VALUES (15492, 2999, 13, 'Título V');
INSERT INTO `lang_definitions` VALUES (15493, 3000, 13, 'TitleCols deve ser um número entre 1 e 999');
INSERT INTO `lang_definitions` VALUES (15494, 3001, 13, 'Queixas');
INSERT INTO `lang_definitions` VALUES (15495, 3002, 13, 'TMs / AEM / EE, ext nariz');
INSERT INTO `lang_definitions` VALUES (15496, 3003, 13, 'TMs');
INSERT INTO `lang_definitions` VALUES (15497, 3004, 13, 'Para');
INSERT INTO `lang_definitions` VALUES (15498, 3005, 13, 'TO');
INSERT INTO `lang_definitions` VALUES (15499, 3006, 13, 'para');
INSERT INTO `lang_definitions` VALUES (15500, 3007, 13, 'A área afetada');
INSERT INTO `lang_definitions` VALUES (15501, 3008, 13, 'a área afetada');
INSERT INTO `lang_definitions` VALUES (15502, 3009, 13, 'Para Ver Faturamento');
INSERT INTO `lang_definitions` VALUES (15503, 3010, 13, 'a categoria');
INSERT INTO `lang_definitions` VALUES (15504, 3011, 13, 'Ver a Clínica');
INSERT INTO `lang_definitions` VALUES (15505, 3012, 13, 'Para copay');
INSERT INTO `lang_definitions` VALUES (15506, 3013, 13, 'Para DED ');
INSERT INTO `lang_definitions` VALUES (15507, 3014, 13, 'Para Dems');
INSERT INTO `lang_definitions` VALUES (15508, 3015, 13, 'Para Enctr');
INSERT INTO `lang_definitions` VALUES (15509, 3016, 13, 'Para filtrar por sexo');
INSERT INTO `lang_definitions` VALUES (15510, 3017, 13, 'Acrescentar/Consultar Histórico');
INSERT INTO `lang_definitions` VALUES (15511, 3018, 13, 'Para Questões');
INSERT INTO `lang_definitions` VALUES (15512, 3019, 13, 'Para vincular este encontro / consulta a um problema existente, clique na edição desejada acima para destacá-lo e, em seguida, clique em [Salvar]. Mantenha pressionada a tecla [Ctrl] para seleccionar várias questões.');
INSERT INTO `lang_definitions` VALUES (15513, 3020, 13, 'Para fazer o login novamente');
INSERT INTO `lang_definitions` VALUES (15514, 3021, 13, 'To Skin');
INSERT INTO `lang_definitions` VALUES (15515, 3022, 13, 'para a pele');
INSERT INTO `lang_definitions` VALUES (15516, 3023, 13, 'a esta visita?');
INSERT INTO `lang_definitions` VALUES (15517, 3024, 13, 'Para:');
INSERT INTO `lang_definitions` VALUES (15518, 3025, 13, 'Para:');
INSERT INTO `lang_definitions` VALUES (15519, 3026, 13, 'To_city');
INSERT INTO `lang_definitions` VALUES (15520, 3027, 13, 'TO_FAX');
INSERT INTO `lang_definitions` VALUES (15521, 3028, 13, 'TO_FNAME');
INSERT INTO `lang_definitions` VALUES (15522, 3029, 13, 'TO_LNAME');
INSERT INTO `lang_definitions` VALUES (15523, 3030, 13, 'TO_MNAME');
INSERT INTO `lang_definitions` VALUES (15524, 3031, 13, 'TO_ORGANIZATION');
INSERT INTO `lang_definitions` VALUES (15525, 3032, 13, 'TO_POSTAL');
INSERT INTO `lang_definitions` VALUES (15526, 3033, 13, 'TO_STATE');
INSERT INTO `lang_definitions` VALUES (15527, 3034, 13, 'TO_STREET');
INSERT INTO `lang_definitions` VALUES (15528, 3035, 13, 'TO_TITLE');
INSERT INTO `lang_definitions` VALUES (15529, 3036, 13, 'TO_VALEDICTORY');
INSERT INTO `lang_definitions` VALUES (15530, 3037, 13, 'Tabaco');
INSERT INTO `lang_definitions` VALUES (15531, 3038, 13, 'O uso do tabaco');
INSERT INTO `lang_definitions` VALUES (15532, 3039, 13, 'Hoje');
INSERT INTO `lang_definitions` VALUES (15533, 3040, 13, 'Data de Hoje');
INSERT INTO `lang_definitions` VALUES (15534, 3041, 13, 'Eventos de Hoje');
INSERT INTO `lang_definitions` VALUES (15535, 3042, 13, 'Amigdalectomia');
INSERT INTO `lang_definitions` VALUES (15536, 3043, 13, 'Sup.');
INSERT INTO `lang_definitions` VALUES (15537, 3044, 13, 'Tópico');
INSERT INTO `lang_definitions` VALUES (15538, 3045, 13, 'total');
INSERT INTO `lang_definitions` VALUES (15539, 3046, 13, 'Consultas');
INSERT INTO `lang_definitions` VALUES (15540, 3047, 13, 'Valor Total Pago');
INSERT INTO `lang_definitions` VALUES (15541, 3048, 13, 'Total de despesas');
INSERT INTO `lang_definitions` VALUES (15542, 3049, 13, 'Total de pacientes');
INSERT INTO `lang_definitions` VALUES (15543, 3050, 13, 'Total de');
INSERT INTO `lang_definitions` VALUES (15544, 3051, 13, 'Total de');
INSERT INTO `lang_definitions` VALUES (15545, 3052, 13, 'Total por categoria');
INSERT INTO `lang_definitions` VALUES (15546, 3053, 13, 'Número total de pacientes');
INSERT INTO `lang_definitions` VALUES (15547, 3054, 13, 'Total SRH & Planeamento Familiar');
INSERT INTO `lang_definitions` VALUES (15548, 3055, 13, 'Totais');
INSERT INTO `lang_definitions` VALUES (15549, 3056, 13, 'Total para');
INSERT INTO `lang_definitions` VALUES (15550, 3057, 13, 'Total para');
INSERT INTO `lang_definitions` VALUES (15551, 3058, 13, 'Tipo de Formação');
INSERT INTO `lang_definitions` VALUES (15552, 3059, 13, 'Transact');
INSERT INTO `lang_definitions` VALUES (15553, 3060, 13, 'transação');
INSERT INTO `lang_definitions` VALUES (15554, 3061, 13, 'Transação');
INSERT INTO `lang_definitions` VALUES (15555, 3062, 13, 'Tipo de Transação');
INSERT INTO `lang_definitions` VALUES (15556, 3063, 13, 'Transações');
INSERT INTO `lang_definitions` VALUES (15557, 3064, 13, 'Transações (escrever opcional)');
INSERT INTO `lang_definitions` VALUES (15558, 3065, 13, 'Transações / Registo');
INSERT INTO `lang_definitions` VALUES (15559, 3066, 13, 'traduzir este');
INSERT INTO `lang_definitions` VALUES (15560, 3067, 13, 'Tradução');
INSERT INTO `lang_definitions` VALUES (15561, 3068, 13, 'Traduções');
INSERT INTO `lang_definitions` VALUES (15562, 3069, 13, 'Trauma');
INSERT INTO `lang_definitions` VALUES (15563, 3070, 13, 'Tratamento Gols');
INSERT INTO `lang_definitions` VALUES (15564, 3071, 13, 'Plano de Tratamento');
INSERT INTO `lang_definitions` VALUES (15565, 3072, 13, 'Tratamento:');
INSERT INTO `lang_definitions` VALUES (15566, 3073, 13, 'Tratamento:');
INSERT INTO `lang_definitions` VALUES (15567, 3074, 13, 'trftime ($ month_format, mktime (0, 0, 0, $ i, 1, 2000))); $ month_value');
INSERT INTO `lang_definitions` VALUES (15568, 3075, 13, 'Trigger Point / síndrome de compartimento / DOM / grampo');
INSERT INTO `lang_definitions` VALUES (15569, 3076, 13, 'Trimalleolar');
INSERT INTO `lang_definitions` VALUES (15570, 3077, 13, 'tring[,\'r\'[,');
INSERT INTO `lang_definitions` VALUES (15571, 3078, 13, 'Tronco e abdome');
INSERT INTO `lang_definitions` VALUES (15572, 3079, 13, 'Colher(es) de chá');
INSERT INTO `lang_definitions` VALUES (15573, 3080, 13, 'TTS');
INSERT INTO `lang_definitions` VALUES (15574, 3081, 13, 'Tuberculose');
INSERT INTO `lang_definitions` VALUES (15575, 3082, 13, 'Ter');
INSERT INTO `lang_definitions` VALUES (15576, 3083, 13, 'Ter & Qui');
INSERT INTO `lang_definitions` VALUES (15577, 3084, 13, 'Terça-feira');
INSERT INTO `lang_definitions` VALUES (15578, 3085, 13, 'Tumor');
INSERT INTO `lang_definitions` VALUES (15579, 3086, 13, 'duas vezes por dia');
INSERT INTO `lang_definitions` VALUES (15580, 3087, 13, 'Via Auricular');
INSERT INTO `lang_definitions` VALUES (15581, 3088, 13, 'Tipo');
INSERT INTO `lang_definitions` VALUES (15582, 3089, 13, 'Tipo de digitalização ou o identificador do paciente aqui');
INSERT INTO `lang_definitions` VALUES (15583, 3090, 13, 'UCSMC códigos fornecidos pela Universidade de Calgary Centro de Medicina Esportiva');
INSERT INTO `lang_definitions` VALUES (15584, 3091, 13, 'Ulcerações');
INSERT INTO `lang_definitions` VALUES (15585, 3092, 13, 'Colite ulcerosa');
INSERT INTO `lang_definitions` VALUES (15586, 3093, 13, 'Úlceras:');
INSERT INTO `lang_definitions` VALUES (15587, 3094, 13, 'Selecione');
INSERT INTO `lang_definitions` VALUES (15588, 3095, 13, 'O acesso não autorizado.');
INSERT INTO `lang_definitions` VALUES (15589, 3096, 13, 'debaixo da língua');
INSERT INTO `lang_definitions` VALUES (15590, 3097, 13, 'Debaixo de');
INSERT INTO `lang_definitions` VALUES (15591, 3098, 13, 'Undiagnosed');
INSERT INTO `lang_definitions` VALUES (15592, 3099, 13, 'Undo Checkout');
INSERT INTO `lang_definitions` VALUES (15593, 3100, 13, 'Pacientes Únicos');
INSERT INTO `lang_definitions` VALUES (15594, 3101, 13, 'Pacientes Únicos Novos');
INSERT INTO `lang_definitions` VALUES (15595, 3102, 13, 'Única atividade Pacientes');
INSERT INTO `lang_definitions` VALUES (15596, 3103, 13, 'Única atividade pacientes relatam');
INSERT INTO `lang_definitions` VALUES (15597, 3104, 13, 'Unique SP');
INSERT INTO `lang_definitions` VALUES (15598, 3105, 13, 'Unidade');
INSERT INTO `lang_definitions` VALUES (15599, 3106, 13, 'Unidades');
INSERT INTO `lang_definitions` VALUES (15600, 3107, 13, 'unidades');
INSERT INTO `lang_definitions` VALUES (15601, 3108, 13, 'Unidades deve ser um número');
INSERT INTO `lang_definitions` VALUES (15602, 3109, 13, 'Desconhecido');
INSERT INTO `lang_definitions` VALUES (15603, 3110, 13, 'Desconhecido ou N / A');
INSERT INTO `lang_definitions` VALUES (15604, 3111, 13, 'Companhia de seguros Unnamed');
INSERT INTO `lang_definitions` VALUES (15605, 3112, 13, 'Unregistered');
INSERT INTO `lang_definitions` VALUES (15606, 3113, 13, 'Desmarcar Todos');
INSERT INTO `lang_definitions` VALUES (15607, 3114, 13, 'Não Selecionado');
INSERT INTO `lang_definitions` VALUES (15608, 3115, 13, 'Unspecified');
INSERT INTO `lang_definitions` VALUES (15609, 3116, 13, 'até');
INSERT INTO `lang_definitions` VALUES (15610, 3117, 13, 'Prematura de arquivamento');
INSERT INTO `lang_definitions` VALUES (15611, 3118, 13, 'Não Usado');
INSERT INTO `lang_definitions` VALUES (15612, 3119, 13, 'UOR');
INSERT INTO `lang_definitions` VALUES (15613, 3120, 13, 'Até');
INSERT INTO `lang_definitions` VALUES (15614, 3121, 13, 'Próximos Eventos');
INSERT INTO `lang_definitions` VALUES (15615, 3122, 13, 'Próximos Eventos');
INSERT INTO `lang_definitions` VALUES (15616, 3123, 13, 'Atualizar');
INSERT INTO `lang_definitions` VALUES (15617, 3124, 13, 'atualizar');
INSERT INTO `lang_definitions` VALUES (15618, 3125, 13, 'Os arquivos de atualização');
INSERT INTO `lang_definitions` VALUES (15619, 3126, 13, 'Update Info');
INSERT INTO `lang_definitions` VALUES (15620, 3130, 13, 'Atualizando a informações não está autorizada.');
INSERT INTO `lang_definitions` VALUES (15621, 3131, 13, 'CPF');
INSERT INTO `lang_definitions` VALUES (15622, 3132, 13, 'Upload');
INSERT INTO `lang_definitions` VALUES (15623, 3133, 13, 'Upload de dados de configuração');
INSERT INTO `lang_definitions` VALUES (15624, 3134, 13, 'Carregar Documento');
INSERT INTO `lang_definitions` VALUES (15625, 3135, 13, 'Upload falhou!');
INSERT INTO `lang_definitions` VALUES (15626, 3136, 13, 'Arquivo de importação de Upload:');
INSERT INTO `lang_definitions` VALUES (15627, 3137, 13, 'Upload Relatório');
INSERT INTO `lang_definitions` VALUES (15628, 3138, 13, 'Carregar arquivo isto:');
INSERT INTO `lang_definitions` VALUES (15629, 3139, 13, 'Ao clicar em um número da factura a \"\"janela de lançamento manual \"\" aparece. Aqui você pode mudar a data de vencimento e as notas para a factura, selecione o partido para o qual você está postando, e selecione os seguros para a qual todos os paymants esperados foram recebidos. Mais importante ainda, para cada código de faturamento para as quais foi cobrada uma quantia, você pode inserir informações de pagamento e de ajustamento.');
INSERT INTO `lang_definitions` VALUES (15630, 3140, 13, 'Após a pesquisa que você é apresentado com uma lista de faturas. Você pode clicar em um dos números de factura para abrir uma segunda janela, que é a página de entrada de dados para lançamento manual. Você também pode clicar no nome do paciente, se você deseja inserir uma nota que o pessoal do escritório da frente vai ver quando as verificações no paciente, e você pode selecionar as facturas para aparecer em declarações paciente e imprimir essas declarações.');
INSERT INTO `lang_definitions` VALUES (15631, 3141, 13, 'Braço');
INSERT INTO `lang_definitions` VALUES (15632, 3142, 13, 'Urgência');
INSERT INTO `lang_definitions` VALUES (15633, 3143, 13, 'Urina Dribbling');
INSERT INTO `lang_definitions` VALUES (15634, 3144, 13, 'Urina de Freqüência');
INSERT INTO `lang_definitions` VALUES (15635, 3145, 13, 'Urina Hesitação');
INSERT INTO `lang_definitions` VALUES (15636, 3146, 13, 'Urina Stream');
INSERT INTO `lang_definitions` VALUES (15637, 3147, 13, 'Urina Urgência');
INSERT INTO `lang_definitions` VALUES (15638, 3148, 13, 'URL');
INSERT INTO `lang_definitions` VALUES (15639, 3150, 13, 'Use 24 formato de hora a hora?');
INSERT INTO `lang_definitions` VALUES (15640, 3151, 13, 'Usar Padrões');
INSERT INTO `lang_definitions` VALUES (15641, 3152, 13, 'Use estilo de data internacional?');
INSERT INTO `lang_definitions` VALUES (15642, 3153, 13, 'Use este recurso apenas com sites recém-instalado,');
INSERT INTO `lang_definitions` VALUES (15643, 3154, 13, 'Use tópicos?');
INSERT INTO `lang_definitions` VALUES (15644, 3155, 13, 'Usuário');
INSERT INTO `lang_definitions` VALUES (15645, 3156, 13, 'Administração de Usuários');
INSERT INTO `lang_definitions` VALUES (15646, 3157, 13, 'Usuário de Clínica e Administração');
INSERT INTO `lang_definitions` VALUES (15647, 3158, 13, 'Usuário e Grupo de Administração');
INSERT INTO `lang_definitions` VALUES (15648, 3159, 13, 'Filiação');
INSERT INTO `lang_definitions` VALUES (15649, 3160, 13, 'Definido pelo usuário Área 11');
INSERT INTO `lang_definitions` VALUES (15650, 3161, 13, 'Definido pelo usuário Area 12');
INSERT INTO `lang_definitions` VALUES (15651, 3162, 13, 'Campo definido pelo usuário');
INSERT INTO `lang_definitions` VALUES (15652, 3163, 13, 'Manual de lista definida 1');
INSERT INTO `lang_definitions` VALUES (15653, 3164, 13, 'Manual de lista definida 2');
INSERT INTO `lang_definitions` VALUES (15654, 3165, 13, 'Manual de lista definida 3');
INSERT INTO `lang_definitions` VALUES (15655, 3166, 13, 'Manual de lista definida 4');
INSERT INTO `lang_definitions` VALUES (15656, 3167, 13, 'Manual de lista definida 5');
INSERT INTO `lang_definitions` VALUES (15657, 3168, 13, 'Manual de lista definida 6');
INSERT INTO `lang_definitions` VALUES (15658, 3169, 13, 'Manual de lista definida 7');
INSERT INTO `lang_definitions` VALUES (15659, 3170, 13, 'Texto Definido pelo Usuário 1');
INSERT INTO `lang_definitions` VALUES (15660, 3171, 13, 'Texto Definido pelo Usuário 2');
INSERT INTO `lang_definitions` VALUES (15661, 3172, 13, 'Texto Definido pelo Usuário 3');
INSERT INTO `lang_definitions` VALUES (15662, 3173, 13, 'Texto Definido pelo Usuário 4');
INSERT INTO `lang_definitions` VALUES (15663, 3174, 13, 'Texto Definido pelo Usuário 5');
INSERT INTO `lang_definitions` VALUES (15664, 3175, 13, 'Texto Definido pelo Usuário 6');
INSERT INTO `lang_definitions` VALUES (15665, 3176, 13, 'Texto Definido pelo Usuário 7');
INSERT INTO `lang_definitions` VALUES (15666, 3177, 13, 'Texto Definido pelo Usuário 8');
INSERT INTO `lang_definitions` VALUES (15667, 3178, 13, 'Manual do Usuário');
INSERT INTO `lang_definitions` VALUES (15668, 3179, 13, 'Associações de');
INSERT INTO `lang_definitions` VALUES (15669, 3180, 13, 'Nome de Usuário');
INSERT INTO `lang_definitions` VALUES (15670, 3181, 13, 'Nome de usuário para o SMS Gateway');
INSERT INTO `lang_definitions` VALUES (15671, 3182, 13, 'Nome de usuário:');
INSERT INTO `lang_definitions` VALUES (15672, 3183, 13, 'Usuários');
INSERT INTO `lang_definitions` VALUES (15673, 3184, 13, 'Usuários / Grupos / Logs Administração');
INSERT INTO `lang_definitions` VALUES (15674, 3185, 13, 'usa <a php href=\"\"http://php.net/strftime\"\"> strftime </ a> formato');
INSERT INTO `lang_definitions` VALUES (15675, 3186, 13, 'UTIs');
INSERT INTO `lang_definitions` VALUES (15676, 3187, 13, 'FÉRIAS');
INSERT INTO `lang_definitions` VALUES (15677, 3188, 13, 'Férias');
INSERT INTO `lang_definitions` VALUES (15678, 3189, 13, 'Vacina');
INSERT INTO `lang_definitions` VALUES (15679, 3190, 13, 'Anel Vaginal');
INSERT INTO `lang_definitions` VALUES (15680, 3191, 13, 'Despedida');
INSERT INTO `lang_definitions` VALUES (15681, 3192, 13, 'Valor 1');
INSERT INTO `lang_definitions` VALUES (15682, 3193, 13, 'Valor 2');
INSERT INTO `lang_definitions` VALUES (15683, 3194, 13, 'Var1');
INSERT INTO `lang_definitions` VALUES (15684, 3195, 13, 'Var2');
INSERT INTO `lang_definitions` VALUES (15685, 3196, 13, 'Varicela 1');
INSERT INTO `lang_definitions` VALUES (15686, 3197, 13, 'Varicela 2');
INSERT INTO `lang_definitions` VALUES (15687, 3198, 13, 'Varizes');
INSERT INTO `lang_definitions` VALUES (15688, 3199, 13, 'Condição Vascular');
INSERT INTO `lang_definitions` VALUES (15689, 3200, 13, 'A lesão vascular');
INSERT INTO `lang_definitions` VALUES (15690, 3201, 13, 'Cirurgia Vascular');
INSERT INTO `lang_definitions` VALUES (15691, 3202, 13, 'Versão');
INSERT INTO `lang_definitions` VALUES (15692, 3203, 13, 'Vertigo');
INSERT INTO `lang_definitions` VALUES (15693, 3204, 13, 'Veterans Administration Plan');
INSERT INTO `lang_definitions` VALUES (15694, 3205, 13, 'Visualizar');
INSERT INTO `lang_definitions` VALUES (15695, 3206, 13, 'visualizar');
INSERT INTO `lang_definitions` VALUES (15696, 3207, 13, 'Ver Alergias');
INSERT INTO `lang_definitions` VALUES (15697, 3208, 13, 'Ver Relatório detalhado do paciente');
INSERT INTO `lang_definitions` VALUES (15698, 3209, 13, 'Ver documento');
INSERT INTO `lang_definitions` VALUES (15699, 3210, 13, 'Exibir encontro');
INSERT INTO `lang_definitions` VALUES (15700, 3211, 13, 'Ver eventos em uma janela popup?');
INSERT INTO `lang_definitions` VALUES (15701, 3212, 13, 'Ver página 1');
INSERT INTO `lang_definitions` VALUES (15702, 3213, 13, 'Ver página 2');
INSERT INTO `lang_definitions` VALUES (15703, 3214, 13, 'Encontros Ver relacionados');
INSERT INTO `lang_definitions` VALUES (15704, 3216, 13, 'Ver:');
INSERT INTO `lang_definitions` VALUES (15705, 3217, 13, 'VISA');
INSERT INTO `lang_definitions` VALUES (15706, 3218, 13, 'Danos Visceral / trauma / cirurgia');
INSERT INTO `lang_definitions` VALUES (15707, 3219, 13, 'Visite Categoria:');
INSERT INTO `lang_definitions` VALUES (15708, 3220, 13, 'Data da visita');
INSERT INTO `lang_definitions` VALUES (15709, 3221, 13, 'Visite Formulários');
INSERT INTO `lang_definitions` VALUES (15710, 3222, 13, 'Consultas');
INSERT INTO `lang_definitions` VALUES (15711, 3223, 13, 'Total De');
INSERT INTO `lang_definitions` VALUES (15712, 3225, 13, 'Exame Físico Geral');
INSERT INTO `lang_definitions` VALUES (15713, 3226, 13, 'Exame Físico Geral (Metrico)');
INSERT INTO `lang_definitions` VALUES (15714, 3228, 13, 'Vômitos');
INSERT INTO `lang_definitions` VALUES (15715, 3229, 13, 'W');
INSERT INTO `lang_definitions` VALUES (15716, 3230, 13, 'Circ');
INSERT INTO `lang_definitions` VALUES (15717, 3231, 13, 'Circunferência da cintura');
INSERT INTO `lang_definitions` VALUES (15718, 3232, 13, 'Esperando');
INSERT INTO `lang_definitions` VALUES (15719, 3233, 13, 'Walk-in');
INSERT INTO `lang_definitions` VALUES (15720, 3234, 13, 'Walt Pennington');
INSERT INTO `lang_definitions` VALUES (15721, 3235, 13, 'Quente');
INSERT INTO `lang_definitions` VALUES (15722, 3236, 13, 'AVISO');
INSERT INTO `lang_definitions` VALUES (15723, 3237, 13, 'Atenção: A visita foi já criado para este paciente hoje!');
INSERT INTO `lang_definitions` VALUES (15724, 3238, 13, 'Atenção: identificação do paciente não é único!');
INSERT INTO `lang_definitions` VALUES (15725, 3239, 13, 'AVISO: Isto irá substituir as informações de configuração com os dados do arquivo enviado!');
INSERT INTO `lang_definitions` VALUES (15726, 3240, 13, 'vimos acima do seu paciente para avaliação e tratamento em nossa clínica psiquiátrica ambulatorial. Obrigado por esta referência.');
INSERT INTO `lang_definitions` VALUES (15727, 3241, 13, 'Fraqueza');
INSERT INTO `lang_definitions` VALUES (15728, 3242, 13, 'Website');
INSERT INTO `lang_definitions` VALUES (15729, 3243, 13, 'Qua');
INSERT INTO `lang_definitions` VALUES (15730, 3244, 13, 'Quarta-feira');
INSERT INTO `lang_definitions` VALUES (15731, 3245, 13, 'semana');
INSERT INTO `lang_definitions` VALUES (15732, 3246, 13, 'Semana');
INSERT INTO `lang_definitions` VALUES (15733, 3247, 13, 'Ver semana');
INSERT INTO `lang_definitions` VALUES (15734, 3248, 13, 'Semana (s)');
INSERT INTO `lang_definitions` VALUES (15735, 3249, 13, 'Peso');
INSERT INTO `lang_definitions` VALUES (15736, 3250, 13, 'Variação de peso');
INSERT INTO `lang_definitions` VALUES (15737, 3251, 13, 'Perda de peso');
INSERT INTO `lang_definitions` VALUES (15738, 3252, 13, 'O que deve ser contada?');
INSERT INTO `lang_definitions` VALUES (15739, 3253, 13, 'Sibilos:');
INSERT INTO `lang_definitions` VALUES (15740, 3254, 13, 'Chiado');
INSERT INTO `lang_definitions` VALUES (15741, 3255, 13, 'Chiado:');
INSERT INTO `lang_definitions` VALUES (15742, 3256, 13, 'Onde pode relacionados digitalizados ou documentos em papel pode ser encontrado?');
INSERT INTO `lang_definitions` VALUES (15743, 3257, 13, 'Whiplash');
INSERT INTO `lang_definitions` VALUES (15744, 3258, 13, 'Quem');
INSERT INTO `lang_definitions` VALUES (15745, 3259, 13, 'Quem respondeu?');
INSERT INTO `lang_definitions` VALUES (15746, 3260, 13, 'Viúvo');
INSERT INTO `lang_definitions` VALUES (15747, 3261, 13, 'Com selecionado:');
INSERT INTO `lang_definitions` VALUES (15748, 3262, 13, 'com o nome antigo');
INSERT INTO `lang_definitions` VALUES (15749, 3263, 13, 'Com quem podemos deixar uma mensagem?');
INSERT INTO `lang_definitions` VALUES (15750, 3264, 13, 'na hora');
INSERT INTO `lang_definitions` VALUES (15751, 3265, 13, 'na hora:');
INSERT INTO `lang_definitions` VALUES (15752, 3266, 13, 'dentro de minutos');
INSERT INTO `lang_definitions` VALUES (15753, 3267, 13, 'em minutos:');
INSERT INTO `lang_definitions` VALUES (15754, 3268, 13, 'Sem atualização');
INSERT INTO `lang_definitions` VALUES (15755, 3269, 13, 'Testemunha');
INSERT INTO `lang_definitions` VALUES (15756, 3270, 13, 'WNL');
INSERT INTO `lang_definitions` VALUES (15757, 3271, 13, 'Mulheres');
INSERT INTO `lang_definitions` VALUES (15758, 3272, 13, 'Apenas as mulheres');
INSERT INTO `lang_definitions` VALUES (15759, 3273, 13, 'Trabalho');
INSERT INTO `lang_definitions` VALUES (15760, 3274, 13, 'TRABALHO NOTA');
INSERT INTO `lang_definitions` VALUES (15761, 3275, 13, 'Telefone Comercial');
INSERT INTO `lang_definitions` VALUES (15762, 3276, 13, 'Telefone Comercial');
INSERT INTO `lang_definitions` VALUES (15763, 3277, 13, 'Trabalho relacionado?');
INSERT INTO `lang_definitions` VALUES (15764, 3278, 13, 'Trabalho / Educação / Emprego');
INSERT INTO `lang_definitions` VALUES (15765, 3279, 13, 'Trabalho / Escola Nota');
INSERT INTO `lang_definitions` VALUES (15766, 3280, 13, 'jornada de trabalho');
INSERT INTO `lang_definitions` VALUES (15767, 3281, 13, 'Trabalhadores Compensação Plano de Saúde');
INSERT INTO `lang_definitions` VALUES (15768, 3282, 13, 'Pior');
INSERT INTO `lang_definitions` VALUES (15769, 3283, 13, 'Pulso');
INSERT INTO `lang_definitions` VALUES (15770, 3284, 13, 'Punho e da mão');
INSERT INTO `lang_definitions` VALUES (15771, 3285, 13, 'Problemas no pulso');
INSERT INTO `lang_definitions` VALUES (15772, 3286, 13, 'escrever');
INSERT INTO `lang_definitions` VALUES (15773, 3287, 13, 'amortizar');
INSERT INTO `lang_definitions` VALUES (15774, 3288, 13, 'wsome');
INSERT INTO `lang_definitions` VALUES (15775, 3290, 13, 'x Cancelado');
INSERT INTO `lang_definitions` VALUES (15776, 3291, 13, 'X-ray');
INSERT INTO `lang_definitions` VALUES (15777, 3292, 13, 'X-RAY Interpretação:');
INSERT INTO `lang_definitions` VALUES (15778, 3293, 13, 'X-Ray Interpretação:');
INSERT INTO `lang_definitions` VALUES (15779, 3294, 13, 'X12 apenas: Substituição de Reivindicação');
INSERT INTO `lang_definitions` VALUES (15780, 3295, 13, 'X12 Partner');
INSERT INTO `lang_definitions` VALUES (15781, 3296, 13, 'X12 Parceiros');
INSERT INTO `lang_definitions` VALUES (15782, 3297, 13, 'Y');
INSERT INTO `lang_definitions` VALUES (15783, 3298, 13, 'ano');
INSERT INTO `lang_definitions` VALUES (15784, 3299, 13, 'Ano');
INSERT INTO `lang_definitions` VALUES (15785, 3300, 13, 'Ver Ano');
INSERT INTO `lang_definitions` VALUES (15786, 3301, 13, 'Ano (s)');
INSERT INTO `lang_definitions` VALUES (15787, 3302, 13, 'SIM');
INSERT INTO `lang_definitions` VALUES (15788, 3303, 13, 'Sim');
INSERT INTO `lang_definitions` VALUES (15789, 3304, 13, 'sim');
INSERT INTO `lang_definitions` VALUES (15790, 3305, 13, 'SIM!');
INSERT INTO `lang_definitions` VALUES (15791, 3306, 13, 'Sim, Excluir e Log');
INSERT INTO `lang_definitions` VALUES (15792, 3307, 13, 'Sim / Não');
INSERT INTO `lang_definitions` VALUES (15793, 3308, 13, 'Sim:');
INSERT INTO `lang_definitions` VALUES (15794, 3309, 13, 'Você está prestes a substituir permanentemente o modelo existente. Tem certeza de que deseja continuar?');
INSERT INTO `lang_definitions` VALUES (15795, 3310, 13, 'Você não tem permissão para excluir este evento');
INSERT INTO `lang_definitions` VALUES (15796, 3311, 13, 'Você não tem permissão para editar este evento');
INSERT INTO `lang_definitions` VALUES (15797, 3312, 13, 'Você não está autorizado para isso.');
INSERT INTO `lang_definitions` VALUES (15798, 3313, 13, 'Você não está autorizado a aceder a este plantel.');
INSERT INTO `lang_definitions` VALUES (15799, 3314, 13, 'Você não está autorizado a adicionar / editar questões');
INSERT INTO `lang_definitions` VALUES (15800, 3315, 13, 'Você não está autorizado a ver este encontro.');
INSERT INTO `lang_definitions` VALUES (15801, 3316, 13, 'Você não pode acessar esta função diretamente.');
INSERT INTO `lang_definitions` VALUES (15802, 3317, 13, 'Você não pode acessar a página diretamente.');
INSERT INTO `lang_definitions` VALUES (15803, 3321, 13, 'Você não escolheu nenhuma ação.');
INSERT INTO `lang_definitions` VALUES (15804, 3322, 13, 'Você não tem permissão para acessar / editar esta nota');
INSERT INTO `lang_definitions` VALUES (15805, 3324, 13, 'Você deve primeiro selecionar ou adicionar um paciente.');
INSERT INTO `lang_definitions` VALUES (15806, 3325, 13, 'Você deve primeiro selecionar ou criar um encontro.');
INSERT INTO `lang_definitions` VALUES (15807, 3326, 13, 'Você deve selecionar alguns campos para continuar.');
INSERT INTO `lang_definitions` VALUES (15808, 3327, 13, 'Você deve estar executando esse teste, se essa reivindicação surgiu para gerar com êxito, mas o pedido real arquivo não contém quaisquer dados ou apenas uma parte inacabada da quantidade de dados que é suposto que contêm. É óbvio com reivindicações HCFA porque são legível, com X12 afirma que é um processo mais difícil de determinar se o pedido está devidamente completo.');
INSERT INTO `lang_definitions` VALUES (15809, 3328, 13, 'A data final é inválido');
INSERT INTO `lang_definitions` VALUES (15810, 3329, 13, 'Seu evento foi eliminada.');
INSERT INTO `lang_definitions` VALUES (15811, 3330, 13, 'Seu evento foi modificada.');
INSERT INTO `lang_definitions` VALUES (15812, 3331, 13, 'Seu caso foi apresentado.');
INSERT INTO `lang_definitions` VALUES (15813, 3332, 13, 'Seu nome da lista foi alterado para atender aos requisitos de nomeação.');
INSERT INTO `lang_definitions` VALUES (15814, 3333, 13, 'Sua configuração PostCalendar foi redefinir para usar os padrões.');
INSERT INTO `lang_definitions` VALUES (15815, 3334, 13, 'Sua configuração PostCalendar foi atualizado.');
INSERT INTO `lang_definitions` VALUES (15816, 3335, 13, 'Sua freqüência de repetição deve ser um inteiro.');
INSERT INTO `lang_definitions` VALUES (15817, 3336, 13, 'Sua freqüência de repetição deve ser pelo menos 1.');
INSERT INTO `lang_definitions` VALUES (15818, 3337, 13, 'Sua data de início é maior do que a data de término');
INSERT INTO `lang_definitions` VALUES (15819, 3338, 13, 'Sua data de início é inválida');
INSERT INTO `lang_definitions` VALUES (15820, 3339, 13, 'Sua submissão falhou.');
INSERT INTO `lang_definitions` VALUES (15821, 3340, 13, 'aaaa-mm-dd');
INSERT INTO `lang_definitions` VALUES (15822, 3341, 13, 'aaaa-mm-dd data associado a este documento');
INSERT INTO `lang_definitions` VALUES (15823, 3342, 13, 'aaaa-mm-dd data destruído');
INSERT INTO `lang_definitions` VALUES (15824, 3343, 13, 'aaaa-mm-dd Data de Nascimento');
INSERT INTO `lang_definitions` VALUES (15825, 3344, 13, 'aaaa-mm-dd data de nascimento');
INSERT INTO `lang_definitions` VALUES (15826, 3345, 13, 'aaaa-mm-dd data de expiração');
INSERT INTO `lang_definitions` VALUES (15827, 3346, 13, 'aaaa-mm-dd Data de início ou de internação');
INSERT INTO `lang_definitions` VALUES (15828, 3347, 13, 'aaaa-mm-dd data de início, a cirurgia ou início da medicação');
INSERT INTO `lang_definitions` VALUES (15829, 3348, 13, 'aaaa-mm-dd data de recuperação ou no final de medicação');
INSERT INTO `lang_definitions` VALUES (15830, 3349, 13, 'aaaa-mm-dd Data de voltar a jogar');
INSERT INTO `lang_definitions` VALUES (15831, 3350, 13, 'aaaa-mm-dd Data de serviço');
INSERT INTO `lang_definitions` VALUES (15832, 3351, 13, 'aaaa-mm-dd data da presente carta');
INSERT INTO `lang_definitions` VALUES (15833, 3352, 13, 'aaaa-mm-dd data voltou a jogar');
INSERT INTO `lang_definitions` VALUES (15834, 3353, 13, 'aaaa-mm-dd data do documento');
INSERT INTO `lang_definitions` VALUES (15835, 3354, 13, 'aaaa-mm-dd data do evento ou a data de início');
INSERT INTO `lang_definitions` VALUES (15836, 3355, 13, 'aaaa-mm-dd última data deste evento');
INSERT INTO `lang_definitions` VALUES (15837, 3356, 13, 'Zero');
INSERT INTO `lang_definitions` VALUES (15838, 3357, 13, 'Zip');
INSERT INTO `lang_definitions` VALUES (15839, 3358, 13, 'CEP');
INSERT INTO `lang_definitions` VALUES (15840, 3359, 13, 'CEP / País:');
INSERT INTO `lang_definitions` VALUES (15841, 3360, 13, 'mas foi');
INSERT INTO `lang_definitions` VALUES (15842, 3361, 13, 'não pôde ser acessado.');
INSERT INTO `lang_definitions` VALUES (15843, 3362, 13, 'Você realmente deseja apagar');
INSERT INTO `lang_definitions` VALUES (15844, 3363, 13, 'Drogas');
INSERT INTO `lang_definitions` VALUES (15845, 3364, 13, 'e-mails não enviados');
INSERT INTO `lang_definitions` VALUES (15846, 3365, 13, 'de');
INSERT INTO `lang_definitions` VALUES (15847, 3366, 13, 'foi criado.');
INSERT INTO `lang_definitions` VALUES (15848, 3367, 13, 'foi re-aberto.');
INSERT INTO `lang_definitions` VALUES (15849, 3368, 13, 'Histórico');
INSERT INTO `lang_definitions` VALUES (15850, 3369, 13, 'não é um número');
INSERT INTO `lang_definitions` VALUES (15851, 3370, 13, 'está pronto para re-faturamento.');
INSERT INTO `lang_definitions` VALUES (15852, 3371, 13, 'LLL:');
INSERT INTO `lang_definitions` VALUES (15853, 3372, 13, 'Lote');
INSERT INTO `lang_definitions` VALUES (15854, 3373, 13, 'Medicaid original Reference No.');
INSERT INTO `lang_definitions` VALUES (15855, 3374, 13, 'min');
INSERT INTO `lang_definitions` VALUES (15856, 3375, 13, 'não encontrado!');
INSERT INTO `lang_definitions` VALUES (15857, 3376, 13, 'Peculiaridades em vários navegadores pode significar que a saída abaixo entra em sua tela em empurrões súbita e que há longas pausas de vários segundos, onde parece que as coisas podem ter deixado de funcionar. Isso não é o caso, você acabará por ver a saída que sai de linha por linha. Pode haver números seqüenciais que aparecem abaixo, é para indicar que, mesmo que nada mais pode estar exibindo há uma atividade em curso. Estes números serão intercaladas com o conteúdo do faturamento e que é normal.');
INSERT INTO `lang_definitions` VALUES (15858, 3377, 13, 'receita atingiu seu limite de');
INSERT INTO `lang_definitions` VALUES (15859, 3378, 13, 'até');
INSERT INTO `lang_definitions` VALUES (15860, 3379, 13, 'Falha na atualização, e não no banco de dados?');
INSERT INTO `lang_definitions` VALUES (15861, 3380, 13, 'foi marcado como faturado apenas.');
INSERT INTO `lang_definitions` VALUES (15862, 3381, 13, 'estava na fila com êxito.');
INSERT INTO `lang_definitions` VALUES (15863, 3382, 13, '! Esquerda w / visitar o');
INSERT INTO `lang_definitions` VALUES (15864, 3383, 13, '\"\"Para o código');
INSERT INTO `lang_definitions` VALUES (15865, 3384, 13, '\"\"Está marcada em PostCalendar Configurações!');
INSERT INTO `lang_definitions` VALUES (15866, 3385, 13, '# Ins / questão fin');
INSERT INTO `lang_definitions` VALUES (15867, 3386, 13, 'N º de comprimidos:');
INSERT INTO `lang_definitions` VALUES (15868, 3387, 13, '$');
INSERT INTO `lang_definitions` VALUES (15869, 3388, 13, '$ Codificação feito');
INSERT INTO `lang_definitions` VALUES (15870, 3389, 13, '1');
INSERT INTO `lang_definitions` VALUES (15871, 3390, 13, '$ label (aaaa-mm-dd):');
INSERT INTO `lang_definitions` VALUES (15872, 3391, 13, '%');
INSERT INTO `lang_definitions` VALUES (15873, 3392, 13, 'Cancelado% <24h');
INSERT INTO `lang_definitions` VALUES (15874, 3393, 13, '\"\"Deve existir, mas não.');
INSERT INTO `lang_definitions` VALUES (15875, 3394, 13, '(% Corresponde a qualquer cadeia _ corresponde a qualquer caractere)');
INSERT INTO `lang_definitions` VALUES (15876, 3395, 13, '(Voltar)');
INSERT INTO `lang_definitions` VALUES (15877, 3396, 13, '(Clique para editar)');
INSERT INTO `lang_definitions` VALUES (15878, 3397, 13, '(Mais)');
INSERT INTO `lang_definitions` VALUES (15879, 3398, 13, '(Paciente Novo)');
INSERT INTO `lang_definitions` VALUES (15880, 3399, 13, '(Notas e Autorizações)');
INSERT INTO `lang_definitions` VALUES (15881, 3400, 13, '(Notas do Paciente)');
INSERT INTO `lang_definitions` VALUES (15882, 3401, 13, '(Escolha uma dessas, ou escreva a sua própria descrição)');
INSERT INTO `lang_definitions` VALUES (15883, 3402, 13, '* Lembrete feito');
INSERT INTO `lang_definitions` VALUES (15884, 3403, 13, '** Por favor mover cirurgias para problemas!');
INSERT INTO `lang_definitions` VALUES (15885, 3404, 13, '* Obrigatório');
INSERT INTO `lang_definitions` VALUES (15886, 3405, 13, 'Carta puxado');
INSERT INTO `lang_definitions` VALUES (15887, 3406, 13, '.');
INSERT INTO `lang_definitions` VALUES (15888, 3407, 13, '0-10');
INSERT INTO `lang_definitions` VALUES (15889, 3408, 13, '1.Rest 2. Gelo durante dois dias 3. Compressão, deixar o curativo no local a menos que o pé se desenvolve dormência ou cor pálida 4. Elevar o pé e perna');
INSERT INTO `lang_definitions` VALUES (15890, 3409, 13, '11/14/09');
INSERT INTO `lang_definitions` VALUES (15891, 3410, 13, '15-19');
INSERT INTO `lang_definitions` VALUES (15892, 3411, 13, '20-24');
INSERT INTO `lang_definitions` VALUES (15893, 3412, 13, '2111-13');
INSERT INTO `lang_definitions` VALUES (15894, 3413, 13, '25-29');
INSERT INTO `lang_definitions` VALUES (15895, 3414, 13, '2');
INSERT INTO `lang_definitions` VALUES (15896, 3415, 13, '3 meses');
INSERT INTO `lang_definitions` VALUES (15897, 3416, 13, '3 vezes ao dia');
INSERT INTO `lang_definitions` VALUES (15898, 3417, 13, '30-34');
INSERT INTO `lang_definitions` VALUES (15899, 3418, 13, '35-39');
INSERT INTO `lang_definitions` VALUES (15900, 3419, 13, '3');
INSERT INTO `lang_definitions` VALUES (15901, 3420, 13, '4 meses');
INSERT INTO `lang_definitions` VALUES (15902, 3421, 13, '4 vezes ao dia');
INSERT INTO `lang_definitions` VALUES (15903, 3422, 13, '40-44');
INSERT INTO `lang_definitions` VALUES (15904, 3423, 13, '45');
INSERT INTO `lang_definitions` VALUES (15905, 3424, 13, '465,9, URI');
INSERT INTO `lang_definitions` VALUES (15906, 3425, 13, '466,0, Bronquite aguda SOE');
INSERT INTO `lang_definitions` VALUES (15907, 3426, 13, '486,0, Pneumonia aguda');
INSERT INTO `lang_definitions` VALUES (15908, 3427, 13, '491,21, exacerbação de DPOC');
INSERT INTO `lang_definitions` VALUES (15909, 3428, 13, '491,8, Bronquite crônica');
INSERT INTO `lang_definitions` VALUES (15910, 3429, 13, '493,92, Asma Aguda EXAC.');
INSERT INTO `lang_definitions` VALUES (15911, 3430, 13, '496,0, a DPOC');
INSERT INTO `lang_definitions` VALUES (15912, 3431, 13, '4');
INSERT INTO `lang_definitions` VALUES (15913, 3432, 13, '519,7, broncoespasmo');
INSERT INTO `lang_definitions` VALUES (15914, 3433, 13, '5');
INSERT INTO `lang_definitions` VALUES (15915, 3434, 13, '6 meses');
INSERT INTO `lang_definitions` VALUES (15916, 3435, 13, '6');
INSERT INTO `lang_definitions` VALUES (15917, 3436, 13, '824,0 Fratura do maléolo medial, fechado');
INSERT INTO `lang_definitions` VALUES (15918, 3437, 13, '824,2 Fracture, maléolo lateral, fechado');
INSERT INTO `lang_definitions` VALUES (15919, 3438, 13, '824,6 Fracture, Trimalleolar, fechado');
INSERT INTO `lang_definitions` VALUES (15920, 3439, 13, '825,32 Fracture, do navicular (tornozelo)');
INSERT INTO `lang_definitions` VALUES (15921, 3440, 13, '825,35 Fracture, Base de quinta (5) Metatarsal');
INSERT INTO `lang_definitions` VALUES (15922, 3441, 13, '845,00 NOS entorse de tornozelo');
INSERT INTO `lang_definitions` VALUES (15923, 3442, 13, '845,01 Entorse medial (deltóide) Lig.');
INSERT INTO `lang_definitions` VALUES (15924, 3443, 13, '845,02 entorse, calcâneo fibular');
INSERT INTO `lang_definitions` VALUES (15925, 3444, 13, '99212 Fundação - Uncomplicated');
INSERT INTO `lang_definitions` VALUES (15926, 3445, 13, '99213 Fundação - Baixa Complexidade');
INSERT INTO `lang_definitions` VALUES (15927, 3446, 13, '<Na sala de exame');
INSERT INTO `lang_definitions` VALUES (15928, 3447, 13, '> Check-out');
INSERT INTO `lang_definitions` VALUES (15929, 3448, 13, '? Não Compareceu');
INSERT INTO `lang_definitions` VALUES (15930, 3449, 13, 'Arrived');
INSERT INTO `lang_definitions` VALUES (15931, 3450, 13, '[Alterar View]');
INSERT INTO `lang_definitions` VALUES (15932, 3451, 13, '[Data da última consulta]');
INSERT INTO `lang_definitions` VALUES (15933, 3452, 13, 'Dias [Desde a última consulta]');
INSERT INTO `lang_definitions` VALUES (15934, 3453, 13, '[EOBs]');
INSERT INTO `lang_definitions` VALUES (15935, 3454, 13, '[Export OFX]');
INSERT INTO `lang_definitions` VALUES (15936, 3455, 13, '[não recomendado]');
INSERT INTO `lang_definitions` VALUES (15937, 3456, 13, '[Número de encontros]');
INSERT INTO `lang_definitions` VALUES (15938, 3457, 13, '[Relatórios]');
INSERT INTO `lang_definitions` VALUES (15939, 3458, 13, '[Select All]');
INSERT INTO `lang_definitions` VALUES (15940, 3459, 13, '[SQL-Ledger]');
INSERT INTO `lang_definitions` VALUES (15941, 3460, 13, '[Start Batch Processing]');
INSERT INTO `lang_definitions` VALUES (15942, 3461, 13, '[Ver o log]');
INSERT INTO `lang_definitions` VALUES (15943, 3462, 13, '[Ver Printable Report]');
INSERT INTO `lang_definitions` VALUES (15944, 3463, 13, '_PC_DUR_HOURS');
INSERT INTO `lang_definitions` VALUES (15945, 3464, 13, '_PC_DUR_MINUTES');
INSERT INTO `lang_definitions` VALUES (15946, 3465, 13, '_PC_LOCALE');
INSERT INTO `lang_definitions` VALUES (15947, 3466, 13, '~ Chegou atrasado');
INSERT INTO `lang_definitions` VALUES (15948, 2, 14, 'Cek nomor atau nomor klaim untuk mengidentifikasi pembayaran');
INSERT INTO `lang_definitions` VALUES (15949, 4, 14, 'Dibutuhkan nomor LOT!');
INSERT INTO `lang_definitions` VALUES (15950, 5, 14, 'Diperlukan kode yang berhubungan dengan IPPF!');
INSERT INTO `lang_definitions` VALUES (15951, 6, 14, 'Nilai yang unik untuk mengidentifikasi bidang ini, tidak terlihat ke pengguna');
INSERT INTO `lang_definitions` VALUES (15952, 7, 14, 'Sebelum makan');
INSERT INTO `lang_definitions` VALUES (15953, 8, 14, 'Pagi Hari');
INSERT INTO `lang_definitions` VALUES (15954, 10, 14, 'AB');
INSERT INTO `lang_definitions` VALUES (15955, 12, 14, 'Abses');
INSERT INTO `lang_definitions` VALUES (15956, 13, 14, 'Perut');
INSERT INTO `lang_definitions` VALUES (15957, 14, 14, 'Mampu Berjalan empat (4) langkah:');
INSERT INTO `lang_definitions` VALUES (15958, 15, 14, 'ABN');
INSERT INTO `lang_definitions` VALUES (15959, 16, 14, 'ABN1');
INSERT INTO `lang_definitions` VALUES (15960, 22, 14, 'Isu aborsi');
INSERT INTO `lang_definitions` VALUES (15961, 23, 14, 'Metode aborsi');
INSERT INTO `lang_definitions` VALUES (15962, 24, 14, 'Kategori yang Berhubungan dengan Aborsi');
INSERT INTO `lang_definitions` VALUES (15963, 27, 14, 'Terima Penugasan');
INSERT INTO `lang_definitions` VALUES (15964, 28, 14, 'Menerima Pembayaran');
INSERT INTO `lang_definitions` VALUES (15965, 29, 14, 'Menerima Penugasan');
INSERT INTO `lang_definitions` VALUES (15966, 30, 14, 'Kontrol Akses');
INSERT INTO `lang_definitions` VALUES (15967, 31, 14, 'Administrasi Daftar Kontrol Akses');
INSERT INTO `lang_definitions` VALUES (15968, 35, 14, 'ACL');
INSERT INTO `lang_definitions` VALUES (15969, 37, 14, 'Administrasi ACL Tidak Disetujui');
INSERT INTO `lang_definitions` VALUES (15970, 40, 14, 'Tanggal tindakan');
INSERT INTO `lang_definitions` VALUES (15971, 41, 14, 'Aktif');
INSERT INTO `lang_definitions` VALUES (15972, 42, 14, 'Konsultasi Hari Ini');
INSERT INTO `lang_definitions` VALUES (15973, 44, 14, 'Pasien aktif');
INSERT INTO `lang_definitions` VALUES (15974, 45, 14, 'Tipe Kegiatan');
INSERT INTO `lang_definitions` VALUES (15975, 46, 14, 'Akut pada kronis');
INSERT INTO `lang_definitions` VALUES (15976, 47, 14, 'Tambah');
INSERT INTO `lang_definitions` VALUES (15977, 49, 14, 'Tambah Perusahaan');
INSERT INTO `lang_definitions` VALUES (15978, 50, 14, 'Tambah Farmasi');
INSERT INTO `lang_definitions` VALUES (15979, 51, 14, 'menambahkan kegiatan');
INSERT INTO `lang_definitions` VALUES (15980, 53, 14, 'Tambahkan sebagai Baru');
INSERT INTO `lang_definitions` VALUES (15981, 54, 14, 'Tambahkan Kategori');
INSERT INTO `lang_definitions` VALUES (15982, 55, 14, 'Tambahkan Konstanta');
INSERT INTO `lang_definitions` VALUES (15983, 56, 14, 'Tambahkan Copay');
INSERT INTO `lang_definitions` VALUES (15984, 57, 14, 'Tambahkan Obat');
INSERT INTO `lang_definitions` VALUES (15985, 58, 14, 'Tambahkan Konsultasi');
INSERT INTO `lang_definitions` VALUES (15986, 59, 14, 'Tambahkan Prasarana');
INSERT INTO `lang_definitions` VALUES (15987, 61, 14, 'Tambah Grup');
INSERT INTO `lang_definitions` VALUES (15988, 62, 14, 'Tambahkan Kode ICD');
INSERT INTO `lang_definitions` VALUES (15989, 63, 14, 'Tambahkan Isu');
INSERT INTO `lang_definitions` VALUES (15990, 64, 14, 'Tambahkan Bahasa');
INSERT INTO `lang_definitions` VALUES (15991, 65, 14, 'Tambahkan Baru');
INSERT INTO `lang_definitions` VALUES (15992, 66, 14, 'Tambahkan kategori baru:');
INSERT INTO `lang_definitions` VALUES (15993, 67, 14, 'Tambahkan Grup Baru');
INSERT INTO `lang_definitions` VALUES (15994, 68, 14, 'Tambahkan Catatan Baru');
INSERT INTO `lang_definitions` VALUES (15995, 69, 14, 'Tambahkan catatan baru');
INSERT INTO `lang_definitions` VALUES (15996, 70, 14, 'Tambahkan Mitra Baru');
INSERT INTO `lang_definitions` VALUES (15997, 71, 14, 'Tambahkan Catatan');
INSERT INTO `lang_definitions` VALUES (15998, 72, 14, 'Tambahkan Rekam Medis Pasien');
INSERT INTO `lang_definitions` VALUES (15999, 73, 14, 'Tambahkan Resep');
INSERT INTO `lang_definitions` VALUES (16000, 75, 14, 'Tambahkan ke Daftar Obat');
INSERT INTO `lang_definitions` VALUES (16001, 77, 14, 'Tambah Pengguna');
INSERT INTO `lang_definitions` VALUES (16002, 78, 14, 'Tambahkan Pengguna Pada Grup');
INSERT INTO `lang_definitions` VALUES (16003, 81, 14, 'Sindroma Addison');
INSERT INTO `lang_definitions` VALUES (16004, 82, 14, 'Sindroma Addison');
INSERT INTO `lang_definitions` VALUES (16005, 83, 14, 'Diagnosis Tambahan:');
INSERT INTO `lang_definitions` VALUES (16006, 84, 14, 'Tambahan Riwayat Sakit');
INSERT INTO `lang_definitions` VALUES (16007, 85, 14, 'Catatan Tambahan Riwayat Sakit ');
INSERT INTO `lang_definitions` VALUES (16008, 86, 14, 'Info Tambahan');
INSERT INTO `lang_definitions` VALUES (16009, 87, 14, 'Tambahan Laboratorium');
INSERT INTO `lang_definitions` VALUES (16010, 88, 14, 'Catatan tambahan');
INSERT INTO `lang_definitions` VALUES (16011, 89, 14, 'Catatan tambahan:');
INSERT INTO `lang_definitions` VALUES (16012, 90, 14, 'Catatan tambahan:');
INSERT INTO `lang_definitions` VALUES (16013, 91, 14, 'Catatan Tambahan X-RAY:');
INSERT INTO `lang_definitions` VALUES (16014, 93, 14, 'Buku Alamat');
INSERT INTO `lang_definitions` VALUES (16015, 94, 14, 'Buku Alamat');
INSERT INTO `lang_definitions` VALUES (16016, 95, 14, 'Alamat');
INSERT INTO `lang_definitions` VALUES (16017, 96, 14, 'Buku Alamat');
INSERT INTO `lang_definitions` VALUES (16018, 97, 14, 'Alamat1');
INSERT INTO `lang_definitions` VALUES (16019, 98, 14, 'Alamat2');
INSERT INTO `lang_definitions` VALUES (16020, 100, 14, 'Menyesuaikan');
INSERT INTO `lang_definitions` VALUES (16021, 102, 14, 'Penyesuaian nilai untuk kode');
INSERT INTO `lang_definitions` VALUES (16022, 103, 14, 'Penyesuaian');
INSERT INTO `lang_definitions` VALUES (16023, 104, 14, 'Adm menyesuaikan');
INSERT INTO `lang_definitions` VALUES (16024, 105, 14, 'Admin');
INSERT INTO `lang_definitions` VALUES (16025, 106, 14, 'Alamat Email Admin');
INSERT INTO `lang_definitions` VALUES (16026, 108, 14, 'Dimasukan Oleh');
INSERT INTO `lang_definitions` VALUES (16027, 109, 14, 'Administrasi');
INSERT INTO `lang_definitions` VALUES (16028, 113, 14, 'Saran');
INSERT INTO `lang_definitions` VALUES (16029, 114, 14, 'Mempengaruhi normal');
INSERT INTO `lang_definitions` VALUES (16030, 115, 14, 'Panggilan Diluar jam kerja');
INSERT INTO `lang_definitions` VALUES (16031, 118, 14, 'Setelah memasukkan informasi dengan benar, tekan tombol Simpan.');
INSERT INTO `lang_definitions` VALUES (16032, 119, 14, 'Lagi');
INSERT INTO `lang_definitions` VALUES (16033, 120, 14, 'Usia');
INSERT INTO `lang_definitions` VALUES (16034, 122, 14, 'Kategori usia');
INSERT INTO `lang_definitions` VALUES (16035, 124, 14, 'Format Umur Untuk \"umur dari\" tidak valid');
INSERT INTO `lang_definitions` VALUES (16036, 125, 14, 'Format umur untuk \"sampai usia\" tidak berlaku');
INSERT INTO `lang_definitions` VALUES (16037, 126, 14, 'Umur Dari');
INSERT INTO `lang_definitions` VALUES (16038, 128, 14, 'Alkohol');
INSERT INTO `lang_definitions` VALUES (16039, 129, 14, 'Konsumsi alkohol');
INSERT INTO `lang_definitions` VALUES (16040, 130, 14, 'Semua');
INSERT INTO `lang_definitions` VALUES (16041, 131, 14, 'Semua Kategori');
INSERT INTO `lang_definitions` VALUES (16042, 132, 14, 'Semua Hari');
INSERT INTO `lang_definitions` VALUES (16043, 134, 14, 'Semua Fasilitas');
INSERT INTO `lang_definitions` VALUES (16044, 135, 14, 'Semua atau bagian dari nama depan');
INSERT INTO `lang_definitions` VALUES (16045, 136, 14, 'Semua atau bagian dari nama belakang');
INSERT INTO `lang_definitions` VALUES (16046, 138, 14, 'Semua diulas dan Negatif:');
INSERT INTO `lang_definitions` VALUES (16047, 139, 14, 'Semua Topik');
INSERT INTO `lang_definitions` VALUES (16048, 140, 14, 'Semua Pengguna');
INSERT INTO `lang_definitions` VALUES (16049, 142, 14, 'Alergi');
INSERT INTO `lang_definitions` VALUES (16050, 143, 14, 'Alergi:');
INSERT INTO `lang_definitions` VALUES (16051, 145, 14, 'Boleh Lewat Email');
INSERT INTO `lang_definitions` VALUES (16052, 148, 14, 'Boleh Lewat Surat');
INSERT INTO `lang_definitions` VALUES (16053, 149, 14, 'Boleh Lewat Pesan Singkat');
INSERT INTO `lang_definitions` VALUES (16054, 151, 14, 'Boleh mengirimkan peristiwa yang akan dibuat aktif secara instant?');
INSERT INTO `lang_definitions` VALUES (16055, 153, 14, 'Memungkinkan pengguna untuk mempublikasikan Global Terkini');
INSERT INTO `lang_definitions` VALUES (16056, 154, 14, 'Memungkinkan pengguna untuk mempublikasikan Kalender Pribadi');
INSERT INTO `lang_definitions` VALUES (16057, 155, 14, 'Izinkan Pesan suara');
INSERT INTO `lang_definitions` VALUES (16058, 156, 14, 'Diizinkan');
INSERT INTO `lang_definitions` VALUES (16059, 158, 14, 'Telah digunakan, pilih identitas lain');
INSERT INTO `lang_definitions` VALUES (16060, 159, 14, 'Yang digunakan, pilih gelar lain');
INSERT INTO `lang_definitions` VALUES (16061, 160, 14, 'Alt Alamat');
INSERT INTO `lang_definitions` VALUES (16062, 162, 14, 'Sebagai alternatif, Anda dapat menggunakan halaman pencarian untuk mengupload sebuah uang elektronik (X12 835) file yang telah diperoleh dari pembayar atau clearinghouse. Anda dapat melakukannya dengan mengklik tombol Browse dan memilih file untuk di-upload, kemudian klik Cari untuk melakukan upload dan menampilkan sesuai tagihan. Dalam hal ini parameter yang lain yang disebutkan di atas tidak berlaku dan akan diabaikan. Mengupload menyimpan file tetapi belum memproses isinya - yang dilakukan secara terpisah seperti yang dijelaskan di bawah ini.');
INSERT INTO `lang_definitions` VALUES (16063, 163, 14, 'Pagi hari');
INSERT INTO `lang_definitions` VALUES (16064, 164, 14, 'Merubah Catatan yang ada');
INSERT INTO `lang_definitions` VALUES (16065, 165, 14, 'AMEX');
INSERT INTO `lang_definitions` VALUES (16066, 166, 14, 'Jumlah');
INSERT INTO `lang_definitions` VALUES (16067, 168, 14, 'Jumlah Saldo Akhir');
INSERT INTO `lang_definitions` VALUES (16068, 169, 14, 'Jumlah untuk Kunjungan ini');
INSERT INTO `lang_definitions` VALUES (16069, 170, 14, 'Jumlah Dibayar');
INSERT INTO `lang_definitions` VALUES (16070, 171, 14, 'Jumlah:');
INSERT INTO `lang_definitions` VALUES (16071, 176, 14, 'Dan');
INSERT INTO `lang_definitions` VALUES (16072, 179, 14, 'dan');
INSERT INTO `lang_definitions` VALUES (16073, 180, 14, 'Dan semua data subordinat? Tindakan ini akan dicatat');
INSERT INTO `lang_definitions` VALUES (16074, 182, 14, 'Pergelangan Kaki');
INSERT INTO `lang_definitions` VALUES (16075, 183, 14, 'Pergelangan Kaki + Tumit');
INSERT INTO `lang_definitions` VALUES (16076, 184, 14, 'Formulir Evaluasi Pergelangan Kaki');
INSERT INTO `lang_definitions` VALUES (16077, 185, 14, 'Masalah Pergelangan Kaki');
INSERT INTO `lang_definitions` VALUES (16078, 186, 14, 'Ankylosing Sondlilitis');
INSERT INTO `lang_definitions` VALUES (16079, 187, 14, 'Ankylosing Spondlilitis');
INSERT INTO `lang_definitions` VALUES (16080, 189, 14, 'Satu hal yang dapat Anda lakukan di jendela posting adalah permintaan tagihan kedua. Jika Anda memilih kotak centang sebelum menyimpannya, maka klaim asli akan dibuka kembali dan antri di halaman Penagihan, dan akan diproses selama menjalankan penagihan berikutnya.');
INSERT INTO `lang_definitions` VALUES (16081, 190, 14, 'Sebelum');
INSERT INTO `lang_definitions` VALUES (16082, 191, 14, 'Anus nl, tidak ada nyeri dubur / massa');
INSERT INTO `lang_definitions` VALUES (16083, 193, 14, 'Sembarang');
INSERT INTO `lang_definitions` VALUES (16084, 195, 14, 'Setiap bagian dari kode yang dikehendaki atau deskripsi');
INSERT INTO `lang_definitions` VALUES (16085, 196, 14, 'Salah satu bagian khusus yang dikehendaki');
INSERT INTO `lang_definitions` VALUES (16086, 197, 14, 'Bagian dari nama pasien, atau \"terakhir, pertama\", atau \"X-Y\"');
INSERT INTO `lang_definitions` VALUES (16087, 199, 14, 'Tampilan');
INSERT INTO `lang_definitions` VALUES (16088, 200, 14, 'Penampilan:');
INSERT INTO `lang_definitions` VALUES (16089, 202, 14, 'Menambahkan ke catatan ini');
INSERT INTO `lang_definitions` VALUES (16090, 203, 14, 'Menambahkan ke catatan ini');
INSERT INTO `lang_definitions` VALUES (16091, 204, 14, 'Appendectomy');
INSERT INTO `lang_definitions` VALUES (16092, 206, 14, 'Pakailah pada daerah yang sakit');
INSERT INTO `lang_definitions` VALUES (16093, 207, 14, 'Dipakai untuk kulit');
INSERT INTO `lang_definitions` VALUES (16094, 209, 14, 'Tanggal janji temu');
INSERT INTO `lang_definitions` VALUES (16095, 210, 14, 'Status janji temu');
INSERT INTO `lang_definitions` VALUES (16096, 211, 14, 'Janji temu dalam');
INSERT INTO `lang_definitions` VALUES (16097, 212, 14, 'Janji temu');
INSERT INTO `lang_definitions` VALUES (16098, 214, 14, 'Janji temu dan konsultasi');
INSERT INTO `lang_definitions` VALUES (16099, 215, 14, 'Laporan Janji Temu');
INSERT INTO `lang_definitions` VALUES (16100, 216, 14, 'Laporan Janji temu-Konsultasi');
INSERT INTO `lang_definitions` VALUES (16101, 217, 14, 'Menyetujui');
INSERT INTO `lang_definitions` VALUES (16102, 218, 14, 'Disetujui');
INSERT INTO `lang_definitions` VALUES (16103, 219, 14, 'Disetujui Kegiatan Administrasi');
INSERT INTO `lang_definitions` VALUES (16104, 220, 14, 'Appt-Enc');
INSERT INTO `lang_definitions` VALUES (16105, 221, 14, 'Appts');
INSERT INTO `lang_definitions` VALUES (16106, 222, 14, 'April');
INSERT INTO `lang_definitions` VALUES (16107, 225, 14, 'Apakah Anda yakin ingin menyetujui event ini?');
INSERT INTO `lang_definitions` VALUES (16108, 227, 14, 'Apakah Anda yakin ingin menghapus event ini?');
INSERT INTO `lang_definitions` VALUES (16109, 230, 14, 'Apakah Anda yakin ingin mengedit event ini?');
INSERT INTO `lang_definitions` VALUES (16110, 231, 14, 'Apakah Anda yakin ingin menyembunyikan event ini?');
INSERT INTO `lang_definitions` VALUES (16111, 232, 14, 'Apakah Anda yakin ingin melihat event ini?');
INSERT INTO `lang_definitions` VALUES (16112, 237, 14, 'Apakah Anda yakin ingin melanjutkan dengan tindakan?');
INSERT INTO `lang_definitions` VALUES (16113, 238, 14, 'Wilayah tidak ditentukan');
INSERT INTO `lang_definitions` VALUES (16114, 239, 14, 'Armenia');
INSERT INTO `lang_definitions` VALUES (16115, 241, 14, 'Arthritis');
INSERT INTO `lang_definitions` VALUES (16116, 242, 14, 'Arthritis / penyakit sendi degen');
INSERT INTO `lang_definitions` VALUES (16117, 243, 14, 'Arthritis / penyakit sendi degen');
INSERT INTO `lang_definitions` VALUES (16118, 244, 14, 'sebagai');
INSERT INTO `lang_definitions` VALUES (16119, 245, 14, 'Tentu sebagai');
INSERT INTO `lang_definitions` VALUES (16120, 246, 14, 'Asia');
INSERT INTO `lang_definitions` VALUES (16121, 249, 14, 'Asisten');
INSERT INTO `lang_definitions` VALUES (16122, 250, 14, 'Asma');
INSERT INTO `lang_definitions` VALUES (16123, 252, 14, 'Pada Navicular');
INSERT INTO `lang_definitions` VALUES (16124, 253, 14, 'Pada Navicular:');
INSERT INTO `lang_definitions` VALUES (16125, 254, 14, 'Athletic / Trauma');
INSERT INTO `lang_definitions` VALUES (16126, 255, 14, 'Perhatian');
INSERT INTO `lang_definitions` VALUES (16127, 256, 14, 'Attn');
INSERT INTO `lang_definitions` VALUES (16128, 257, 14, 'Agustus');
INSERT INTO `lang_definitions` VALUES (16129, 258, 14, 'Auth');
INSERT INTO `lang_definitions` VALUES (16130, 259, 14, 'Auth / catatan');
INSERT INTO `lang_definitions` VALUES (16131, 260, 14, 'Kewenangan');
INSERT INTO `lang_definitions` VALUES (16132, 261, 14, 'Otorisasi');
INSERT INTO `lang_definitions` VALUES (16133, 264, 14, 'Berwenang');
INSERT INTO `lang_definitions` VALUES (16134, 265, 14, 'Auto Kirim');
INSERT INTO `lang_definitions` VALUES (16135, 267, 14, 'Automobile Kedokteran');
INSERT INTO `lang_definitions` VALUES (16136, 269, 14, 'Tersedia Times');
INSERT INTO `lang_definitions` VALUES (16137, 270, 14, 'Avulsion / avulsion pematahan');
INSERT INTO `lang_definitions` VALUES (16138, 271, 14, 'Avulsion lateral malleolus');
INSERT INTO `lang_definitions` VALUES (16139, 272, 14, 'Avulsion di tengah-tengah malleolus');
INSERT INTO `lang_definitions` VALUES (16140, 273, 14, 'Kesadaran Berbasis');
INSERT INTO `lang_definitions` VALUES (16141, 275, 14, 'b.i.d.');
INSERT INTO `lang_definitions` VALUES (16142, 276, 14, 'belakang');
INSERT INTO `lang_definitions` VALUES (16143, 277, 14, 'Belakang');
INSERT INTO `lang_definitions` VALUES (16144, 284, 14, 'Masalah Punggung');
INSERT INTO `lang_definitions` VALUES (16145, 287, 14, 'Bedah Punggung');
INSERT INTO `lang_definitions` VALUES (16146, 292, 14, 'Cadangan');
INSERT INTO `lang_definitions` VALUES (16147, 294, 14, 'Buruk memeriksa');
INSERT INTO `lang_definitions` VALUES (16148, 295, 14, 'Buruk hutang');
INSERT INTO `lang_definitions` VALUES (16149, 298, 14, 'Keseimbangan');
INSERT INTO `lang_definitions` VALUES (16150, 299, 14, 'keseimbangan');
INSERT INTO `lang_definitions` VALUES (16151, 300, 14, 'Utang Saldo');
INSERT INTO `lang_definitions` VALUES (16152, 301, 14, 'Dasar kelima (5.) Metarsal');
INSERT INTO `lang_definitions` VALUES (16153, 302, 14, 'Dasar kelima (5.) Metarsal:');
INSERT INTO `lang_definitions` VALUES (16154, 303, 14, 'Batch Alat Komunikasi');
INSERT INTO `lang_definitions` VALUES (16155, 304, 14, 'Batch processing dimulai; hal ini dapat memakan waktu cukup lama.');
INSERT INTO `lang_definitions` VALUES (16156, 305, 14, 'BatchCom');
INSERT INTO `lang_definitions` VALUES (16157, 307, 14, 'Mulai');
INSERT INTO `lang_definitions` VALUES (16158, 308, 14, 'Tanggal Mulai');
INSERT INTO `lang_definitions` VALUES (16159, 309, 14, 'Mulai tanggal layanan yyyy-mm-dd');
INSERT INTO `lang_definitions` VALUES (16160, 312, 14, 'Bilateral:');
INSERT INTO `lang_definitions` VALUES (16161, 313, 14, 'Tanggal tagihan:');
INSERT INTO `lang_definitions` VALUES (16162, 315, 14, 'Tagihan');
INSERT INTO `lang_definitions` VALUES (16163, 316, 14, 'Penagihan');
INSERT INTO `lang_definitions` VALUES (16164, 318, 14, 'Penagihan Attn');
INSERT INTO `lang_definitions` VALUES (16165, 319, 14, 'Kode penagihan untuk Layanan Diminta');
INSERT INTO `lang_definitions` VALUES (16166, 320, 14, 'Penagihan kode');
INSERT INTO `lang_definitions` VALUES (16167, 321, 14, 'Informasi Tagihan');
INSERT INTO `lang_definitions` VALUES (16168, 322, 14, 'Lokasi penagihan');
INSERT INTO `lang_definitions` VALUES (16169, 323, 14, 'Catatan tagihan');
INSERT INTO `lang_definitions` VALUES (16170, 324, 14, 'Catatan untuk penagihan');
INSERT INTO `lang_definitions` VALUES (16171, 325, 14, 'Penagihan Catatan:');
INSERT INTO `lang_definitions` VALUES (16172, 326, 14, 'Penagihan hasil antrian:');
INSERT INTO `lang_definitions` VALUES (16173, 327, 14, 'Penagihan Lapor');
INSERT INTO `lang_definitions` VALUES (16174, 328, 14, 'penagihan ke');
INSERT INTO `lang_definitions` VALUES (16175, 330, 14, 'Tanggal Lahir');
INSERT INTO `lang_definitions` VALUES (16176, 331, 14, 'Hitam');
INSERT INTO `lang_definitions` VALUES (16177, 332, 14, 'Kanker kandung kemih');
INSERT INTO `lang_definitions` VALUES (16178, 333, 14, 'Infeksi kandung kemih');
INSERT INTO `lang_definitions` VALUES (16179, 334, 14, 'Formulir kosong');
INSERT INTO `lang_definitions` VALUES (16180, 338, 14, 'Diblokir');
INSERT INTO `lang_definitions` VALUES (16181, 341, 14, 'Hidung berdarah');
INSERT INTO `lang_definitions` VALUES (16182, 342, 14, 'Blue Cross Blue Shield');
INSERT INTO `lang_definitions` VALUES (16183, 343, 14, 'Biru baris dalam laporan ini adalah informasi. Hitam menunjukkan baris informasi yang ada sebelumnya. Garis hijau menunjukkan perubahan yang telah berhasil diterapkan. Garis-garis merah menunjukkan kesalahan, atau perubahan yang tidak diterapkan, ini harus diproses secara manual. Saat ini ditolak dan pembayaran klaim reversals tidak ditangani secara otomatis dan seterusnya akan muncul dalam warna merah.');
INSERT INTO `lang_definitions` VALUES (16184, 344, 14, 'Visi kabur');
INSERT INTO `lang_definitions` VALUES (16185, 347, 14, 'Badan Daerah');
INSERT INTO `lang_definitions` VALUES (16186, 348, 14, 'Kesakitan tulang:');
INSERT INTO `lang_definitions` VALUES (16187, 349, 14, 'Bone kelembutan: Malleolus di tengah-tengah');
INSERT INTO `lang_definitions` VALUES (16188, 351, 14, 'Bot');
INSERT INTO `lang_definitions` VALUES (16189, 353, 14, 'kedua telinga');
INSERT INTO `lang_definitions` VALUES (16190, 354, 14, 'Dasar');
INSERT INTO `lang_definitions` VALUES (16191, 355, 14, 'BOX 10 A. Pekerjaan yang berhubungan');
INSERT INTO `lang_definitions` VALUES (16192, 356, 14, 'BOX 10 B. Otomatis Kecelakaan');
INSERT INTO `lang_definitions` VALUES (16193, 357, 14, 'BOX 10 Kecelakaan C. Lain-lain');
INSERT INTO `lang_definitions` VALUES (16194, 358, 14, 'BOX 16. Tanggal tidak dapat bekerja dari (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (16195, 359, 14, 'BOX 16. Tanggal tidak dapat bekerja untuk (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (16196, 360, 14, 'BOX 18. Rumah sakit dari tanggal (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (16197, 361, 14, 'BOX 18. Ke rumah sakit tanggal (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (16198, 362, 14, 'BOX 20. Di luar itu digunakan Lab?');
INSERT INTO `lang_definitions` VALUES (16199, 363, 14, 'BOX 22. Medicaid Resubmission Kode (ICD-9)');
INSERT INTO `lang_definitions` VALUES (16200, 364, 14, 'BOX 23. Sebelum Otorisasi No');
INSERT INTO `lang_definitions` VALUES (16201, 374, 14, 'Penyakit payudara');
INSERT INTO `lang_definitions` VALUES (16202, 375, 14, 'Breast Exam');
INSERT INTO `lang_definitions` VALUES (16203, 377, 14, 'Nafas Sounds:');
INSERT INTO `lang_definitions` VALUES (16204, 378, 14, 'Broken Bones');
INSERT INTO `lang_definitions` VALUES (16205, 379, 14, 'Bronkitis Formulir');
INSERT INTO `lang_definitions` VALUES (16206, 380, 14, 'People');
INSERT INTO `lang_definitions` VALUES (16207, 381, 14, 'Telusuri Rekam');
INSERT INTO `lang_definitions` VALUES (16208, 382, 14, 'Bruising / haematoma');
INSERT INTO `lang_definitions` VALUES (16209, 383, 14, 'Bodong Kanan:');
INSERT INTO `lang_definitions` VALUES (16210, 384, 14, 'Pembakaran dengan hajat');
INSERT INTO `lang_definitions` VALUES (16211, 386, 14, 'Sibuk');
INSERT INTO `lang_definitions` VALUES (16212, 387, 14, 'Buttock + S.I.');
INSERT INTO `lang_definitions` VALUES (16213, 388, 14, 'oleh');
INSERT INTO `lang_definitions` VALUES (16214, 389, 14, 'oleh mulut');
INSERT INTO `lang_definitions` VALUES (16215, 390, 14, 'Oleh / Sumber');
INSERT INTO `lang_definitions` VALUES (16216, 391, 14, 'Oleh:');
INSERT INTO `lang_definitions` VALUES (16217, 393, 14, 'Lifetime cache (dalam detik)');
INSERT INTO `lang_definitions` VALUES (16218, 394, 14, 'Cache output template?');
INSERT INTO `lang_definitions` VALUES (16219, 395, 14, 'Konsumsi kafein');
INSERT INTO `lang_definitions` VALUES (16220, 396, 14, 'Kalender');
INSERT INTO `lang_definitions` VALUES (16221, 398, 14, 'Kalender UI');
INSERT INTO `lang_definitions` VALUES (16222, 399, 14, 'Lihat kalender');
INSERT INTO `lang_definitions` VALUES (16223, 400, 14, 'Panggilan ke addForm () di sini. <br>');
INSERT INTO `lang_definitions` VALUES (16224, 402, 14, 'CAMOS');
INSERT INTO `lang_definitions` VALUES (16225, 403, 14, 'Membatalkan');
INSERT INTO `lang_definitions` VALUES (16226, 404, 14, 'Kanker');
INSERT INTO `lang_definitions` VALUES (16227, 407, 14, 'tidak dapat dikonversi ke JPEG. ImageMagick mungkin tidak diinstal?');
INSERT INTO `lang_definitions` VALUES (16228, 408, 14, 'tidak dapat ditampilkan inline karena jenis ini tidak didukung oleh browser.');
INSERT INTO `lang_definitions` VALUES (16229, 409, 14, 'tidak dapat ditampilkan inline karena jenis ini tidak didukung oleh browser');
INSERT INTO `lang_definitions` VALUES (16230, 410, 14, 'tidak dapat ditampilkan inline karena jenis ini tidak didukung oleh browser.');
INSERT INTO `lang_definitions` VALUES (16231, 411, 14, 'Tidak dapat membuat');
INSERT INTO `lang_definitions` VALUES (16232, 412, 14, 'Tidak dapat menemukan');
INSERT INTO `lang_definitions` VALUES (16233, 413, 14, 'Tidak bisa menemukan pasien dari SQL-Ledger id pelanggan');
INSERT INTO `lang_definitions` VALUES (16234, 414, 14, 'Tidak dapat menemukan kata-kata dalam dokumen acuan');
INSERT INTO `lang_definitions` VALUES (16235, 415, 14, 'Tidak dapat menemukan selular dari SQL-Ledger karyawan =');
INSERT INTO `lang_definitions` VALUES (16236, 416, 14, 'Tidak bisa buka');
INSERT INTO `lang_definitions` VALUES (16237, 418, 14, 'Tidak dapat diperbarui karena Anda tidak mengedit catatan yang ada!');
INSERT INTO `lang_definitions` VALUES (16238, 419, 14, 'kapsul');
INSERT INTO `lang_definitions` VALUES (16239, 420, 14, 'Jantung Catheterization');
INSERT INTO `lang_definitions` VALUES (16240, 421, 14, 'Jantung Nemo');
INSERT INTO `lang_definitions` VALUES (16241, 422, 14, 'Cardiovascular');
INSERT INTO `lang_definitions` VALUES (16242, 423, 14, 'Tulang muda / chondral / disc kerusakan');
INSERT INTO `lang_definitions` VALUES (16243, 424, 14, 'Cedera tulang rawan');
INSERT INTO `lang_definitions` VALUES (16244, 425, 14, 'Cartoid pulsations nl, pedal pulses nl');
INSERT INTO `lang_definitions` VALUES (16245, 426, 14, 'uang tunai');
INSERT INTO `lang_definitions` VALUES (16246, 427, 14, 'Uang tunai');
INSERT INTO `lang_definitions` VALUES (16247, 428, 14, 'Tunai Rec');
INSERT INTO `lang_definitions` VALUES (16248, 429, 14, 'Penerimaan uang oleh Provider');
INSERT INTO `lang_definitions` VALUES (16249, 430, 14, 'Bedah katarak');
INSERT INTO `lang_definitions` VALUES (16250, 431, 14, 'Katarak');
INSERT INTO `lang_definitions` VALUES (16251, 432, 14, 'Kategori');
INSERT INTO `lang_definitions` VALUES (16252, 433, 14, 'Kategori');
INSERT INTO `lang_definitions` VALUES (16253, 434, 14, 'kategori');
INSERT INTO `lang_definitions` VALUES (16254, 435, 14, 'Kategori');
INSERT INTO `lang_definitions` VALUES (16255, 436, 14, 'Detail kategori');
INSERT INTO `lang_definitions` VALUES (16256, 437, 14, 'Kategori Batas');
INSERT INTO `lang_definitions` VALUES (16257, 438, 14, 'Nama Kategori');
INSERT INTO `lang_definitions` VALUES (16258, 439, 14, 'Kaukasus');
INSERT INTO `lang_definitions` VALUES (16259, 442, 14, 'Balai Sertifikasi');
INSERT INTO `lang_definitions` VALUES (16260, 443, 14, 'cfirst ($ instype). \'Ins');
INSERT INTO `lang_definitions` VALUES (16261, 444, 14, 'ChampUS');
INSERT INTO `lang_definitions` VALUES (16262, 445, 14, 'ChampUSVA');
INSERT INTO `lang_definitions` VALUES (16263, 446, 14, 'mengubah');
INSERT INTO `lang_definitions` VALUES (16264, 448, 14, 'Ubah Ringkasan');
INSERT INTO `lang_definitions` VALUES (16265, 451, 14, 'Berubah');
INSERT INTO `lang_definitions` VALUES (16266, 453, 14, 'Menagih');
INSERT INTO `lang_definitions` VALUES (16267, 454, 14, 'Biaya');
INSERT INTO `lang_definitions` VALUES (16268, 455, 14, 'Bagan');
INSERT INTO `lang_definitions` VALUES (16269, 456, 14, 'Ringkasan Chart');
INSERT INTO `lang_definitions` VALUES (16270, 457, 14, 'Lagu Check-in/out Laporan Kegiatan');
INSERT INTO `lang_definitions` VALUES (16271, 459, 14, 'Chart ID:');
INSERT INTO `lang_definitions` VALUES (16272, 460, 14, 'Lokasi Ringkasan Chart');
INSERT INTO `lang_definitions` VALUES (16273, 463, 14, 'Lagu Tracker');
INSERT INTO `lang_definitions` VALUES (16274, 464, 14, 'Lagu trk');
INSERT INTO `lang_definitions` VALUES (16275, 465, 14, 'Grafik Dicentang Keluar');
INSERT INTO `lang_definitions` VALUES (16276, 466, 14, 'Grafik Keluar');
INSERT INTO `lang_definitions` VALUES (16277, 467, 14, 'periksa');
INSERT INTO `lang_definitions` VALUES (16278, 468, 14, 'Periksa');
INSERT INTO `lang_definitions` VALUES (16279, 469, 14, 'Periksa Semua');
INSERT INTO `lang_definitions` VALUES (16280, 471, 14, 'Periksa Input Data');
INSERT INTO `lang_definitions` VALUES (16281, 473, 14, 'Periksa / EOB Tanggal:');
INSERT INTO `lang_definitions` VALUES (16282, 474, 14, 'Periksa / EOB No:');
INSERT INTO `lang_definitions` VALUES (16283, 475, 14, 'Periksa / Ref Pajak');
INSERT INTO `lang_definitions` VALUES (16284, 476, 14, 'Periksa / Nomor Referensi');
INSERT INTO `lang_definitions` VALUES (16285, 478, 14, 'centang daftar');
INSERT INTO `lang_definitions` VALUES (16286, 479, 14, 'centang w / teks');
INSERT INTO `lang_definitions` VALUES (16287, 481, 14, 'Kotak dicentang = yes, kosong = tidak');
INSERT INTO `lang_definitions` VALUES (16288, 482, 14, 'Checkout');
INSERT INTO `lang_definitions` VALUES (16289, 483, 14, 'Catur');
INSERT INTO `lang_definitions` VALUES (16290, 484, 14, 'Dada CTAB');
INSERT INTO `lang_definitions` VALUES (16291, 486, 14, 'Dada Rasa:');
INSERT INTO `lang_definitions` VALUES (16292, 487, 14, 'Chest Pains');
INSERT INTO `lang_definitions` VALUES (16293, 491, 14, 'Chills');
INSERT INTO `lang_definitions` VALUES (16294, 492, 14, 'Cina');
INSERT INTO `lang_definitions` VALUES (16295, 493, 14, 'Pilihan');
INSERT INTO `lang_definitions` VALUES (16296, 494, 14, 'Cholecystectomy');
INSERT INTO `lang_definitions` VALUES (16297, 495, 14, 'Cholecystestomy');
INSERT INTO `lang_definitions` VALUES (16298, 497, 14, 'Pilih seksi dan klik item yang ada, kemudian di bagian lain, Anda akan melihat item terkait disorot, dan Anda dapat klik di bagian untuk menambahkan dan menghapus hubungan.');
INSERT INTO `lang_definitions` VALUES (16299, 500, 14, 'Bronkitis kronis');
INSERT INTO `lang_definitions` VALUES (16300, 502, 14, 'Kronis synovitis / cairan / sakit / encok');
INSERT INTO `lang_definitions` VALUES (16301, 503, 14, 'Kronis / berulang');
INSERT INTO `lang_definitions` VALUES (16302, 504, 14, 'Sirosis of the Liver');
INSERT INTO `lang_definitions` VALUES (16303, 506, 14, 'Kota');
INSERT INTO `lang_definitions` VALUES (16304, 507, 14, 'Nama Kota');
INSERT INTO `lang_definitions` VALUES (16305, 508, 14, 'Kota, Negara');
INSERT INTO `lang_definitions` VALUES (16306, 509, 14, 'City, State Zip');
INSERT INTO `lang_definitions` VALUES (16307, 510, 14, 'Kota / Negara');
INSERT INTO `lang_definitions` VALUES (16308, 512, 14, 'Klaim');
INSERT INTO `lang_definitions` VALUES (16309, 513, 14, 'Klaim tes telah selesai menjalankan');
INSERT INTO `lang_definitions` VALUES (16310, 514, 14, 'Klaim dibuat ke file');
INSERT INTO `lang_definitions` VALUES (16311, 515, 14, 'Klasifikasi');
INSERT INTO `lang_definitions` VALUES (16312, 516, 14, 'Bersih');
INSERT INTO `lang_definitions` VALUES (16313, 517, 14, 'Hapus Semua');
INSERT INTO `lang_definitions` VALUES (16314, 518, 14, 'Jelas Justification');
INSERT INTO `lang_definitions` VALUES (16315, 519, 14, 'Jelas Smarty Cache');
INSERT INTO `lang_definitions` VALUES (16316, 520, 14, 'CLIA Pajak');
INSERT INTO `lang_definitions` VALUES (16317, 523, 14, 'klik untuk lebih');
INSERT INTO `lang_definitions` VALUES (16318, 524, 14, 'Klik di sini untuk memilih tanggal');
INSERT INTO `lang_definitions` VALUES (16319, 525, 14, 'klik di sini untuk memperbarui prioritas, kategori dan pengaturan panggilan');
INSERT INTO `lang_definitions` VALUES (16320, 527, 14, 'Klik untuk mendownload');
INSERT INTO `lang_definitions` VALUES (16321, 530, 14, 'Klik untuk menghasilkan laporan');
INSERT INTO `lang_definitions` VALUES (16322, 533, 14, 'Klik untuk memilih');
INSERT INTO `lang_definitions` VALUES (16323, 534, 14, 'Klik untuk memilih atau mengubah diagnosa');
INSERT INTO `lang_definitions` VALUES (16324, 535, 14, 'Klik untuk memilih pasien');
INSERT INTO `lang_definitions` VALUES (16325, 536, 14, 'Klik untuk memilih kode yang terkait');
INSERT INTO `lang_definitions` VALUES (16326, 540, 14, 'Klik:');
INSERT INTO `lang_definitions` VALUES (16327, 543, 14, 'Profil klien - Klien Baru');
INSERT INTO `lang_definitions` VALUES (16328, 544, 14, 'Profil klien - Klien Unik');
INSERT INTO `lang_definitions` VALUES (16329, 545, 14, 'Klien');
INSERT INTO `lang_definitions` VALUES (16330, 546, 14, 'Klinik');
INSERT INTO `lang_definitions` VALUES (16331, 548, 14, 'Klinik Rekam Harian');
INSERT INTO `lang_definitions` VALUES (16332, 553, 14, 'Tutup');
INSERT INTO `lang_definitions` VALUES (16333, 554, 14, 'dekat jendela');
INSERT INTO `lang_definitions` VALUES (16334, 555, 14, 'Ditutup');
INSERT INTO `lang_definitions` VALUES (16335, 558, 14, 'CMS ID');
INSERT INTO `lang_definitions` VALUES (16336, 559, 14, 'CN2-12 utuh');
INSERT INTO `lang_definitions` VALUES (16337, 560, 14, 'Kode');
INSERT INTO `lang_definitions` VALUES (16338, 561, 14, 'kode');
INSERT INTO `lang_definitions` VALUES (16339, 562, 14, 'Kode Finder');
INSERT INTO `lang_definitions` VALUES (16340, 563, 14, 'Kode harus dua huruf lowercase');
INSERT INTO `lang_definitions` VALUES (16341, 564, 14, 'kode jenis');
INSERT INTO `lang_definitions` VALUES (16342, 565, 14, 'Kode');
INSERT INTO `lang_definitions` VALUES (16343, 566, 14, 'Coding');
INSERT INTO `lang_definitions` VALUES (16344, 569, 14, 'Coding tidak diizinkan');
INSERT INTO `lang_definitions` VALUES (16345, 570, 14, 'Kopi');
INSERT INTO `lang_definitions` VALUES (16346, 571, 14, 'Coll w / o');
INSERT INTO `lang_definitions` VALUES (16347, 572, 14, 'runtuh semua');
INSERT INTO `lang_definitions` VALUES (16348, 573, 14, 'Koleksi');
INSERT INTO `lang_definitions` VALUES (16349, 574, 14, 'Koleksi Lapor');
INSERT INTO `lang_definitions` VALUES (16350, 575, 14, 'Kanker usus besar');
INSERT INTO `lang_definitions` VALUES (16351, 576, 14, 'Colon Cancer Surgery');
INSERT INTO `lang_definitions` VALUES (16352, 577, 14, 'Colonoscopy');
INSERT INTO `lang_definitions` VALUES (16353, 578, 14, 'colonoscopy');
INSERT INTO `lang_definitions` VALUES (16354, 579, 14, 'Warna');
INSERT INTO `lang_definitions` VALUES (16355, 580, 14, 'Kolom');
INSERT INTO `lang_definitions` VALUES (16356, 581, 14, 'Komentar');
INSERT INTO `lang_definitions` VALUES (16357, 582, 14, 'Asuransi komersial Co');
INSERT INTO `lang_definitions` VALUES (16358, 583, 14, 'Komit Perubahan');
INSERT INTO `lang_definitions` VALUES (16359, 584, 14, 'Komunikasi');
INSERT INTO `lang_definitions` VALUES (16360, 585, 14, 'Selesai');
INSERT INTO `lang_definitions` VALUES (16361, 586, 14, 'Komplikasi oleh Service Provider');
INSERT INTO `lang_definitions` VALUES (16362, 587, 14, 'Komplikasi dari Abortion');
INSERT INTO `lang_definitions` VALUES (16363, 588, 14, 'Dibantu komputer Kedokteran Diurutkan Sistem');
INSERT INTO `lang_definitions` VALUES (16364, 590, 14, 'Bawaan');
INSERT INTO `lang_definitions` VALUES (16365, 591, 14, 'Conjuntiva, murid');
INSERT INTO `lang_definitions` VALUES (16366, 593, 14, 'konstan nama');
INSERT INTO `lang_definitions` VALUES (16367, 594, 14, 'konstan');
INSERT INTO `lang_definitions` VALUES (16368, 597, 14, 'Konsultasi Brief Description');
INSERT INTO `lang_definitions` VALUES (16369, 598, 14, 'Kontak');
INSERT INTO `lang_definitions` VALUES (16370, 599, 14, 'Email Kontak');
INSERT INTO `lang_definitions` VALUES (16371, 602, 14, 'Lensa Kontak');
INSERT INTO `lang_definitions` VALUES (16372, 603, 14, 'Nama kontak');
INSERT INTO `lang_definitions` VALUES (16373, 604, 14, 'Contact Person');
INSERT INTO `lang_definitions` VALUES (16374, 605, 14, 'Hubungi Nomor Telepon');
INSERT INTO `lang_definitions` VALUES (16375, 606, 14, 'Isi');
INSERT INTO `lang_definitions` VALUES (16376, 607, 14, 'isi');
INSERT INTO `lang_definitions` VALUES (16377, 609, 14, 'Kontra Klien');
INSERT INTO `lang_definitions` VALUES (16378, 611, 14, 'Isu kontrasepsi');
INSERT INTO `lang_definitions` VALUES (16379, 612, 14, 'Kontrasepsi komplikasi (sebutkan)');
INSERT INTO `lang_definitions` VALUES (16380, 613, 14, 'Metode kontrasepsi');
INSERT INTO `lang_definitions` VALUES (16381, 614, 14, 'Kontrasepsi layanan sebelumnya mulai');
INSERT INTO `lang_definitions` VALUES (16382, 615, 14, 'Mulai kontrasepsi');
INSERT INTO `lang_definitions` VALUES (16383, 617, 14, 'Copay');
INSERT INTO `lang_definitions` VALUES (16384, 618, 14, 'CoPay');
INSERT INTO `lang_definitions` VALUES (16385, 620, 14, 'Copays');
INSERT INTO `lang_definitions` VALUES (16386, 622, 14, 'Salin ke Halaman Pasien Chart');
INSERT INTO `lang_definitions` VALUES (16387, 623, 14, 'Salin Nilai');
INSERT INTO `lang_definitions` VALUES (16388, 624, 14, 'Copyright Notice');
INSERT INTO `lang_definitions` VALUES (16389, 625, 14, 'Artery koroner Bypass');
INSERT INTO `lang_definitions` VALUES (16390, 627, 14, 'Batuk:');
INSERT INTO `lang_definitions` VALUES (16391, 628, 14, 'Tidak dapat mengirim email ke server karena masalah,');
INSERT INTO `lang_definitions` VALUES (16392, 633, 14, 'Couns oleh Metode');
INSERT INTO `lang_definitions` VALUES (16393, 634, 14, 'Konseling');
INSERT INTO `lang_definitions` VALUES (16394, 635, 14, 'Konseling kegiatan');
INSERT INTO `lang_definitions` VALUES (16395, 638, 14, 'Negara');
INSERT INTO `lang_definitions` VALUES (16396, 641, 14, 'Kupon');
INSERT INTO `lang_definitions` VALUES (16397, 642, 14, 'CPT');
INSERT INTO `lang_definitions` VALUES (16398, 643, 14, 'CPT Codes');
INSERT INTO `lang_definitions` VALUES (16399, 644, 14, 'Crackles:');
INSERT INTO `lang_definitions` VALUES (16400, 645, 14, 'krim');
INSERT INTO `lang_definitions` VALUES (16401, 646, 14, 'Buat Event');
INSERT INTO `lang_definitions` VALUES (16402, 649, 14, 'Buat Baru Pasien');
INSERT INTO `lang_definitions` VALUES (16403, 650, 14, 'Buat Pasien Catatan');
INSERT INTO `lang_definitions` VALUES (16404, 651, 14, 'Dibuat');
INSERT INTO `lang_definitions` VALUES (16405, 653, 14, 'kredit');
INSERT INTO `lang_definitions` VALUES (16406, 654, 14, 'Kredit');
INSERT INTO `lang_definitions` VALUES (16407, 655, 14, 'Crohn\'s Disease');
INSERT INTO `lang_definitions` VALUES (16408, 657, 14, 'File CSV');
INSERT INTO `lang_definitions` VALUES (16409, 658, 14, 'Saat ini');
INSERT INTO `lang_definitions` VALUES (16410, 659, 14, 'Peristiwa Konsultasi');
INSERT INTO `lang_definitions` VALUES (16411, 660, 14, 'Peristiwa hari sorot warna');
INSERT INTO `lang_definitions` VALUES (16412, 663, 14, 'Peristiwa Pasien');
INSERT INTO `lang_definitions` VALUES (16413, 664, 14, 'Sedang aktif');
INSERT INTO `lang_definitions` VALUES (16414, 665, 14, 'Cushing Syndrom');
INSERT INTO `lang_definitions` VALUES (16415, 666, 14, 'Cushing Syndrome');
INSERT INTO `lang_definitions` VALUES (16416, 667, 14, 'Kebiasaan');
INSERT INTO `lang_definitions` VALUES (16417, 669, 14, 'CYP');
INSERT INTO `lang_definitions` VALUES (16418, 670, 14, 'CYP Factor');
INSERT INTO `lang_definitions` VALUES (16419, 671, 14, 'CYP Lapor');
INSERT INTO `lang_definitions` VALUES (16420, 673, 14, 'D & C');
INSERT INTO `lang_definitions` VALUES (16421, 674, 14, 'D & E');
INSERT INTO `lang_definitions` VALUES (16422, 675, 14, 'D.O.B.');
INSERT INTO `lang_definitions` VALUES (16423, 676, 14, 'harian');
INSERT INTO `lang_definitions` VALUES (16424, 677, 14, 'Alike data sudah di database, silahkan ganti kode dan / atau keterangan');
INSERT INTO `lang_definitions` VALUES (16425, 679, 14, 'Data cols');
INSERT INTO `lang_definitions` VALUES (16426, 680, 14, 'Jenis data');
INSERT INTO `lang_definitions` VALUES (16427, 681, 14, 'Database');
INSERT INTO `lang_definitions` VALUES (16428, 684, 14, 'Tanggal');
INSERT INTO `lang_definitions` VALUES (16429, 686, 14, 'Tanggal administratif');
INSERT INTO `lang_definitions` VALUES (16430, 687, 14, 'Tanggal kontrasepsi layanan yang diberikan pada awalnya');
INSERT INTO `lang_definitions` VALUES (16431, 688, 14, 'Tanggal DESTROYED');
INSERT INTO `lang_definitions` VALUES (16432, 689, 14, 'Tampilan Format tanggal');
INSERT INTO `lang_definitions` VALUES (16433, 690, 14, 'Format tanggal untuk \"janji akhir\" tidak valid');
INSERT INTO `lang_definitions` VALUES (16434, 691, 14, 'Format tanggal untuk \"janji mulai\" tidak valid');
INSERT INTO `lang_definitions` VALUES (16435, 692, 14, 'Format tanggal untuk \"Berikut Penunjukan\" tidak valid');
INSERT INTO `lang_definitions` VALUES (16436, 693, 14, 'Format tanggal untuk \"tidak terlihat sejak\" tidak valid');
INSERT INTO `lang_definitions` VALUES (16437, 694, 14, 'Format tanggal untuk \"terlihat sejak\" tidak valid');
INSERT INTO `lang_definitions` VALUES (16438, 695, 14, 'Tanggal Pernyataan Informasi imunisasi Mengingat');
INSERT INTO `lang_definitions` VALUES (16439, 696, 14, 'Tanggal tersebut tidak ada untuk kode');
INSERT INTO `lang_definitions` VALUES (16440, 697, 14, 'Tanggal deposito bank yyyy-mm-dd');
INSERT INTO `lang_definitions` VALUES (16441, 700, 14, 'Tanggal Cedera');
INSERT INTO `lang_definitions` VALUES (16442, 701, 14, 'Tanggal pembayaran yyyy-mm-dd');
INSERT INTO `lang_definitions` VALUES (16443, 702, 14, 'Tanggal arahan');
INSERT INTO `lang_definitions` VALUES (16444, 703, 14, 'Tanggal balasan');
INSERT INTO `lang_definitions` VALUES (16445, 704, 14, 'Tanggal Pelayanan');
INSERT INTO `lang_definitions` VALUES (16446, 705, 14, 'Tanggal layanan mm / dd / yyyy');
INSERT INTO `lang_definitions` VALUES (16447, 706, 14, 'Tanggal Service:');
INSERT INTO `lang_definitions` VALUES (16448, 708, 14, 'Tanggal Vis Pernyataan');
INSERT INTO `lang_definitions` VALUES (16449, 711, 14, 'Tanggal / Catatan dari Terakhir');
INSERT INTO `lang_definitions` VALUES (16450, 712, 14, 'Tanggal:');
INSERT INTO `lang_definitions` VALUES (16451, 714, 14, 'Hari');
INSERT INTO `lang_definitions` VALUES (16452, 715, 14, 'Hari Lihat');
INSERT INTO `lang_definitions` VALUES (16453, 716, 14, 'Hari (s)');
INSERT INTO `lang_definitions` VALUES (16454, 717, 14, 'Hari (s) M-F');
INSERT INTO `lang_definitions` VALUES (16455, 718, 14, 'bulan');
INSERT INTO `lang_definitions` VALUES (16456, 719, 14, 'Bulan');
INSERT INTO `lang_definitions` VALUES (16457, 720, 14, 'Bulan dan Permainan Missed');
INSERT INTO `lang_definitions` VALUES (16458, 722, 14, 'Kolom per hari:');
INSERT INTO `lang_definitions` VALUES (16459, 723, 14, 'DB diinstal');
INSERT INTO `lang_definitions` VALUES (16460, 725, 14, 'Informasi debug');
INSERT INTO `lang_definitions` VALUES (16461, 726, 14, 'Desember');
INSERT INTO `lang_definitions` VALUES (16462, 727, 14, 'Default');
INSERT INTO `lang_definitions` VALUES (16463, 728, 14, 'Standar Lihat Kalender');
INSERT INTO `lang_definitions` VALUES (16464, 729, 14, 'Fasilitas standar');
INSERT INTO `lang_definitions` VALUES (16465, 731, 14, 'Metode default');
INSERT INTO `lang_definitions` VALUES (16466, 733, 14, 'Default Template');
INSERT INTO `lang_definitions` VALUES (16467, 734, 14, 'Nilai Default');
INSERT INTO `lang_definitions` VALUES (16468, 735, 14, 'Default X12 Mitra');
INSERT INTO `lang_definitions` VALUES (16469, 736, 14, 'Default / Global');
INSERT INTO `lang_definitions` VALUES (16470, 738, 14, 'Tertunda kambuh (> 12 Mo)');
INSERT INTO `lang_definitions` VALUES (16471, 739, 14, 'Menghapus');
INSERT INTO `lang_definitions` VALUES (16472, 741, 14, 'Kategori menghapus dengan ID (s):');
INSERT INTO `lang_definitions` VALUES (16473, 744, 14, 'Hapus Halaman');
INSERT INTO `lang_definitions` VALUES (16474, 745, 14, 'Hapus Pasien, Encounter, Formulir, Issue, Dokumen, Pembayaran, Penagihan atau Transaksi');
INSERT INTO `lang_definitions` VALUES (16475, 752, 14, 'Demografi');
INSERT INTO `lang_definitions` VALUES (16476, 754, 14, 'Demografi tidak diizinkan');
INSERT INTO `lang_definitions` VALUES (16477, 758, 14, 'Tergantung pada jenis menagih Anda uji HCFA anda akan melihat output seperti di halaman kosong untuk HCFA tagihan, Anda akan melihat banyak baris teks agak kacau dan informasi jika anda menguji sebuah X12 klaim. Teks yang kacau adalah X12 IPUS 4010A format. Kadang-kadang Anda akan melihat karakter yang aneh seperti domino atau squiglies, ini adalah karakter kontrol seperti halaman feed dan normal.');
INSERT INTO `lang_definitions` VALUES (16478, 759, 14, 'Tanggal deposit:');
INSERT INTO `lang_definitions` VALUES (16479, 760, 14, 'Depressed');
INSERT INTO `lang_definitions` VALUES (16480, 761, 14, 'Depresi');
INSERT INTO `lang_definitions` VALUES (16481, 762, 14, 'Keterangan');
INSERT INTO `lang_definitions` VALUES (16482, 763, 14, 'deskripsi');
INSERT INTO `lang_definitions` VALUES (16483, 765, 14, 'Tujuan');
INSERT INTO `lang_definitions` VALUES (16484, 766, 14, 'Hancurkan Lot');
INSERT INTO `lang_definitions` VALUES (16485, 767, 14, 'Hancurkan ...');
INSERT INTO `lang_definitions` VALUES (16486, 768, 14, 'Hancur');
INSERT INTO `lang_definitions` VALUES (16487, 769, 14, 'Hancur Narkoba');
INSERT INTO `lang_definitions` VALUES (16488, 770, 14, 'Hancur Obat Lapor');
INSERT INTO `lang_definitions` VALUES (16489, 771, 14, 'Detail');
INSERT INTO `lang_definitions` VALUES (16490, 772, 14, 'Pembangunan keabnormalan');
INSERT INTO `lang_definitions` VALUES (16491, 773, 14, 'Diabetes');
INSERT INTO `lang_definitions` VALUES (16492, 774, 14, 'Diag');
INSERT INTO `lang_definitions` VALUES (16493, 775, 14, 'Diagnosis');
INSERT INTO `lang_definitions` VALUES (16494, 776, 14, 'Diagnosis kode harus terhubung ke sebuah perjumpaan');
INSERT INTO `lang_definitions` VALUES (16495, 777, 14, 'Diagnosa:');
INSERT INTO `lang_definitions` VALUES (16496, 778, 14, 'Diagnosa:');
INSERT INTO `lang_definitions` VALUES (16497, 779, 14, 'Pengujian diagnostik:');
INSERT INTO `lang_definitions` VALUES (16498, 780, 14, 'Cepat');
INSERT INTO `lang_definitions` VALUES (16499, 781, 14, 'Diaphragms / Caps');
INSERT INTO `lang_definitions` VALUES (16500, 784, 14, 'Dikte:');
INSERT INTO `lang_definitions` VALUES (16501, 786, 14, 'Tersebar:');
INSERT INTO `lang_definitions` VALUES (16502, 788, 14, 'Surat langsung');
INSERT INTO `lang_definitions` VALUES (16503, 789, 14, 'Cacat');
INSERT INTO `lang_definitions` VALUES (16504, 790, 14, 'cacat');
INSERT INTO `lang_definitions` VALUES (16505, 791, 14, 'Cacat');
INSERT INTO `lang_definitions` VALUES (16506, 792, 14, 'DISC');
INSERT INTO `lang_definitions` VALUES (16507, 794, 14, 'Dari discharge pekencingan');
INSERT INTO `lang_definitions` VALUES (16508, 795, 14, 'Discharge Tepat');
INSERT INTO `lang_definitions` VALUES (16509, 796, 14, 'Discharge Kanan:');
INSERT INTO `lang_definitions` VALUES (16510, 797, 14, 'Diskon');
INSERT INTO `lang_definitions` VALUES (16511, 798, 14, 'Diskon Jumlah');
INSERT INTO `lang_definitions` VALUES (16512, 801, 14, 'Dislokasi');
INSERT INTO `lang_definitions` VALUES (16513, 803, 14, 'Dispatch');
INSERT INTO `lang_definitions` VALUES (16514, 804, 14, 'Dispatch Dokumen Diterima');
INSERT INTO `lang_definitions` VALUES (16515, 805, 14, 'Dispensed');
INSERT INTO `lang_definitions` VALUES (16516, 806, 14, 'Menampilkan tanggal dalam acara blok?');
INSERT INTO `lang_definitions` VALUES (16517, 807, 14, 'Menampilkan berapa banyak acara?');
INSERT INTO `lang_definitions` VALUES (16518, 808, 14, 'Menampilkan lokasi di blok?');
INSERT INTO `lang_definitions` VALUES (16519, 809, 14, 'Menampilkan kalender?');
INSERT INTO `lang_definitions` VALUES (16520, 810, 14, 'Tampilan hari ini acara di blok?');
INSERT INTO `lang_definitions` VALUES (16521, 811, 14, 'Tampilkan topik di blok?');
INSERT INTO `lang_definitions` VALUES (16522, 812, 14, 'Menampilkan acara mendatang di blok?');
INSERT INTO `lang_definitions` VALUES (16523, 813, 14, 'Distribusi');
INSERT INTO `lang_definitions` VALUES (16524, 814, 14, 'Diverticulitis');
INSERT INTO `lang_definitions` VALUES (16525, 815, 14, 'Diverticulitis Bedah');
INSERT INTO `lang_definitions` VALUES (16526, 816, 14, 'Divirticulitis');
INSERT INTO `lang_definitions` VALUES (16527, 817, 14, 'Divirticulitis Bedah');
INSERT INTO `lang_definitions` VALUES (16528, 818, 14, 'Bercerai');
INSERT INTO `lang_definitions` VALUES (16529, 819, 14, 'Pusing:');
INSERT INTO `lang_definitions` VALUES (16530, 820, 14, 'tidak menyimpan');
INSERT INTO `lang_definitions` VALUES (16531, 821, 14, 'tidak menggantikan');
INSERT INTO `lang_definitions` VALUES (16532, 823, 14, 'Apakah Anda benar-benar ingin menghapus grup ini');
INSERT INTO `lang_definitions` VALUES (16533, 827, 14, 'DOB');
INSERT INTO `lang_definitions` VALUES (16534, 828, 14, 'DOB tersebut tidak ada, jika memungkinkan masukkan');
INSERT INTO `lang_definitions` VALUES (16535, 829, 14, 'Docs');
INSERT INTO `lang_definitions` VALUES (16536, 831, 14, 'Dokter:');
INSERT INTO `lang_definitions` VALUES (16537, 833, 14, 'Dokumen');
INSERT INTO `lang_definitions` VALUES (16538, 835, 14, 'Kategori dokumen');
INSERT INTO `lang_definitions` VALUES (16539, 837, 14, 'Tanggal Dokumen');
INSERT INTO `lang_definitions` VALUES (16540, 841, 14, 'Dokumen / Olahgmbar Kedai');
INSERT INTO `lang_definitions` VALUES (16541, 842, 14, 'Dokumen');
INSERT INTO `lang_definitions` VALUES (16542, 845, 14, 'Mitra domestik');
INSERT INTO `lang_definitions` VALUES (16543, 847, 14, 'Jangan Simpan');
INSERT INTO `lang_definitions` VALUES (16544, 848, 14, 'Jangan Simpan Perubahan');
INSERT INTO `lang_definitions` VALUES (16545, 850, 14, 'Dilakukan dengan:');
INSERT INTO `lang_definitions` VALUES (16546, 852, 14, 'DOS');
INSERT INTO `lang_definitions` VALUES (16547, 853, 14, 'Dosis');
INSERT INTO `lang_definitions` VALUES (16548, 855, 14, 'Double Visi');
INSERT INTO `lang_definitions` VALUES (16549, 856, 14, 'Penagihan download file, dikirim ke akuntansi dan tandai sebagai tagihan');
INSERT INTO `lang_definitions` VALUES (16550, 858, 14, 'Dr Periksa');
INSERT INTO `lang_definitions` VALUES (16551, 859, 14, 'Dr Kunjungi');
INSERT INTO `lang_definitions` VALUES (16552, 863, 14, 'Narkoba');
INSERT INTO `lang_definitions` VALUES (16553, 867, 14, 'Persediaan obat');
INSERT INTO `lang_definitions` VALUES (16554, 868, 14, 'Nama obat');
INSERT INTO `lang_definitions` VALUES (16555, 871, 14, 'Narkoba');
INSERT INTO `lang_definitions` VALUES (16556, 872, 14, 'Dry Mouth');
INSERT INTO `lang_definitions` VALUES (16557, 883, 14, 'Tanggal Jatuh Tempo');
INSERT INTO `lang_definitions` VALUES (16558, 884, 14, 'Karena tanggal mm / dd / yyyy atau yyyy-mm-dd');
INSERT INTO `lang_definitions` VALUES (16559, 885, 14, 'Tanggal Jatuh Tempo:');
INSERT INTO `lang_definitions` VALUES (16560, 886, 14, 'Karena Ins');
INSERT INTO `lang_definitions` VALUES (16561, 887, 14, 'Karena Pt');
INSERT INTO `lang_definitions` VALUES (16562, 895, 14, 'Lama');
INSERT INTO `lang_definitions` VALUES (16563, 896, 14, 'Durasi');
INSERT INTO `lang_definitions` VALUES (16564, 897, 14, 'Belanda');
INSERT INTO `lang_definitions` VALUES (16565, 899, 14, 'Nafas yg sulit:');
INSERT INTO `lang_definitions` VALUES (16566, 901, 14, 'Bentan awal (<2 Mo)');
INSERT INTO `lang_definitions` VALUES (16567, 903, 14, 'ECG');
INSERT INTO `lang_definitions` VALUES (16568, 905, 14, 'Edit');
INSERT INTO `lang_definitions` VALUES (16569, 906, 14, 'Edit Alergi');
INSERT INTO `lang_definitions` VALUES (16570, 907, 14, 'Edit Kategori');
INSERT INTO `lang_definitions` VALUES (16571, 908, 14, 'Edit definisi');
INSERT INTO `lang_definitions` VALUES (16572, 909, 14, 'Edit untuk diagnosa');
INSERT INTO `lang_definitions` VALUES (16573, 910, 14, 'Edit Fasilitas');
INSERT INTO `lang_definitions` VALUES (16574, 911, 14, 'Fasilitas mengedit Informasi');
INSERT INTO `lang_definitions` VALUES (16575, 915, 14, 'Sunting Struktur');
INSERT INTO `lang_definitions` VALUES (16576, 916, 14, 'Pendidikan');
INSERT INTO `lang_definitions` VALUES (16577, 917, 14, 'Tanggal pendidikan');
INSERT INTO `lang_definitions` VALUES (16578, 918, 14, 'ee * the GNU General Public License untuk rincian lebih lanjut. * * Anda harus menerima salinan GNU General Public License * bersama-sama dengan program ini, jika tidak, tulis ke Free');
INSERT INTO `lang_definitions` VALUES (16579, 919, 14, 'Tanggal efektif');
INSERT INTO `lang_definitions` VALUES (16580, 920, 14, 'Efektivitas');
INSERT INTO `lang_definitions` VALUES (16581, 922, 14, 'Siku');
INSERT INTO `lang_definitions` VALUES (16582, 923, 14, 'Masalah siku');
INSERT INTO `lang_definitions` VALUES (16583, 924, 14, 'Elektronik Remits');
INSERT INTO `lang_definitions` VALUES (16584, 925, 14, 'Email');
INSERT INTO `lang_definitions` VALUES (16585, 926, 14, 'Email dari Batchcom');
INSERT INTO `lang_definitions` VALUES (16586, 927, 14, 'Notifikasi email');
INSERT INTO `lang_definitions` VALUES (16587, 928, 14, 'Sebelum mengirim email');
INSERT INTO `lang_definitions` VALUES (16588, 929, 14, 'Email Pengirim');
INSERT INTO `lang_definitions` VALUES (16589, 930, 14, 'Subjek email');
INSERT INTO `lang_definitions` VALUES (16590, 931, 14, 'Teks email, dapat digunakan Tag: *** NAMA ***, yakni Dear *** NAMA ***');
INSERT INTO `lang_definitions` VALUES (16591, 932, 14, 'Hubungi darurat');
INSERT INTO `lang_definitions` VALUES (16592, 935, 14, 'Darurat Contraception');
INSERT INTO `lang_definitions` VALUES (16593, 936, 14, 'Telepon Darurat');
INSERT INTO `lang_definitions` VALUES (16594, 937, 14, 'Emphysema');
INSERT INTO `lang_definitions` VALUES (16595, 938, 14, 'Karyawan');
INSERT INTO `lang_definitions` VALUES (16596, 939, 14, 'Majikan');
INSERT INTO `lang_definitions` VALUES (16597, 940, 14, 'Alamat Perusahaan');
INSERT INTO `lang_definitions` VALUES (16598, 941, 14, 'Data Perusahaan');
INSERT INTO `lang_definitions` VALUES (16599, 942, 14, 'Nama Perusahaan');
INSERT INTO `lang_definitions` VALUES (16600, 943, 14, 'Kosong');
INSERT INTO `lang_definitions` VALUES (16601, 944, 14, 'Nilai kosong pada \"Email Jam\"');
INSERT INTO `lang_definitions` VALUES (16602, 945, 14, 'Nilai kosong pada \"Pengirim Email\"');
INSERT INTO `lang_definitions` VALUES (16603, 946, 14, 'Nilai kosong pada \"Email Subject\"');
INSERT INTO `lang_definitions` VALUES (16604, 947, 14, 'Nilai kosong pada \"Email Teks\"');
INSERT INTO `lang_definitions` VALUES (16605, 948, 14, 'Nilai kosong pada \"Nama Provider\"');
INSERT INTO `lang_definitions` VALUES (16606, 949, 14, 'Nilai kosong pada \"Password\"');
INSERT INTO `lang_definitions` VALUES (16607, 950, 14, 'Nilai kosong pada \"SMS Jam\"');
INSERT INTO `lang_definitions` VALUES (16608, 951, 14, 'Nilai kosong pada \"Teks SMS\"');
INSERT INTO `lang_definitions` VALUES (16609, 952, 14, 'Nilai kosong pada \"pengguna\"');
INSERT INTO `lang_definitions` VALUES (16610, 953, 14, 'diaktifkan');
INSERT INTO `lang_definitions` VALUES (16611, 954, 14, 'Enc');
INSERT INTO `lang_definitions` VALUES (16612, 956, 14, 'Encounter');
INSERT INTO `lang_definitions` VALUES (16613, 957, 14, 'Encounter');
INSERT INTO `lang_definitions` VALUES (16614, 958, 14, 'Encounter Formulir');
INSERT INTO `lang_definitions` VALUES (16615, 959, 14, 'Menemukan nomor');
INSERT INTO `lang_definitions` VALUES (16616, 960, 14, 'Encounter adalah kode');
INSERT INTO `lang_definitions` VALUES (16617, 961, 14, 'Encounter:');
INSERT INTO `lang_definitions` VALUES (16618, 962, 14, 'Encounters');
INSERT INTO `lang_definitions` VALUES (16619, 963, 14, 'Encounters & Formulir');
INSERT INTO `lang_definitions` VALUES (16620, 964, 14, 'Encounters & Formulir');
INSERT INTO `lang_definitions` VALUES (16621, 965, 14, 'Encounters tidak resmi');
INSERT INTO `lang_definitions` VALUES (16622, 966, 14, 'Encounters Lapor');
INSERT INTO `lang_definitions` VALUES (16623, 967, 14, 'Encounters Bagian');
INSERT INTO `lang_definitions` VALUES (16624, 968, 14, 'Akhir');
INSERT INTO `lang_definitions` VALUES (16625, 969, 14, 'Akhir (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (16626, 970, 14, 'Tanggal akhir');
INSERT INTO `lang_definitions` VALUES (16627, 971, 14, 'Tanggal Akhir');
INSERT INTO `lang_definitions` VALUES (16628, 972, 14, 'Tanggal Berakhir:');
INSERT INTO `lang_definitions` VALUES (16629, 973, 14, 'Waktu Akhir');
INSERT INTO `lang_definitions` VALUES (16630, 974, 14, 'Berakhir tanggal layanan yyyy-mm-dd');
INSERT INTO `lang_definitions` VALUES (16631, 975, 14, 'Ending DOS mm / dd / yyyy jika anda ingin memasukkan kisaran');
INSERT INTO `lang_definitions` VALUES (16632, 977, 14, 'Kelenjar endokrin');
INSERT INTO `lang_definitions` VALUES (16633, 978, 14, 'Endoskopi');
INSERT INTO `lang_definitions` VALUES (16634, 979, 14, 'Inggris');
INSERT INTO `lang_definitions` VALUES (16635, 986, 14, 'Masukkan kode diagnosa untuk mengecualikan semua tagihan yang tidak mengandung');
INSERT INTO `lang_definitions` VALUES (16636, 990, 14, 'Lingkungan');
INSERT INTO `lang_definitions` VALUES (16637, 991, 14, 'EOB Data Entry');
INSERT INTO `lang_definitions` VALUES (16638, 992, 14, 'Posting EOB - Layanan pengiriman uang');
INSERT INTO `lang_definitions` VALUES (16639, 993, 14, 'Posting EOB - Instruksi');
INSERT INTO `lang_definitions` VALUES (16640, 994, 14, 'Posting EOB - Faktur');
INSERT INTO `lang_definitions` VALUES (16641, 995, 14, 'Posting EOB - Pasien Catatan');
INSERT INTO `lang_definitions` VALUES (16642, 996, 14, 'Posting EOB - Cari');
INSERT INTO `lang_definitions` VALUES (16643, 997, 14, 'Epilepsi');
INSERT INTO `lang_definitions` VALUES (16644, 998, 14, 'Menghapus');
INSERT INTO `lang_definitions` VALUES (16645, 1000, 14, 'Kesalahan');
INSERT INTO `lang_definitions` VALUES (16646, 1001, 14, 'Kesalahan dalam \"Jender\" pilihan');
INSERT INTO `lang_definitions` VALUES (16647, 1002, 14, 'Kesalahan dalam \"HIPAA\" pilihan');
INSERT INTO `lang_definitions` VALUES (16648, 1003, 14, 'Kesalahan dalam \"Proses\" seleksi');
INSERT INTO `lang_definitions` VALUES (16649, 1004, 14, 'Kesalahan dalam \"SMS Gateway\" pilihan');
INSERT INTO `lang_definitions` VALUES (16650, 1005, 14, 'Kesalahan dalam \"Sort By\" pilihan');
INSERT INTO `lang_definitions` VALUES (16651, 1007, 14, 'Kesalahan dalam pilihan YA atau TIDAK');
INSERT INTO `lang_definitions` VALUES (16652, 1018, 14, 'Kesalahan');
INSERT INTO `lang_definitions` VALUES (16653, 1019, 14, 'Erythema:');
INSERT INTO `lang_definitions` VALUES (16654, 1021, 14, 'Etnis atau Festival');
INSERT INTO `lang_definitions` VALUES (16655, 1023, 14, 'ETIN');
INSERT INTO `lang_definitions` VALUES (16656, 1024, 14, 'Event');
INSERT INTO `lang_definitions` VALUES (16657, 1025, 14, 'Acara Dimulai');
INSERT INTO `lang_definitions` VALUES (16658, 1026, 14, 'Kategori event');
INSERT INTO `lang_definitions` VALUES (16659, 1027, 14, 'Tanggal event');
INSERT INTO `lang_definitions` VALUES (16660, 1028, 14, 'Event Description');
INSERT INTO `lang_definitions` VALUES (16661, 1029, 14, 'Rincian acara');
INSERT INTO `lang_definitions` VALUES (16662, 1030, 14, 'Event tidak mengulangi');
INSERT INTO `lang_definitions` VALUES (16663, 1031, 14, 'Durasi event');
INSERT INTO `lang_definitions` VALUES (16664, 1032, 14, 'Event lama dalam menit');
INSERT INTO `lang_definitions` VALUES (16665, 1033, 14, 'Biaya event');
INSERT INTO `lang_definitions` VALUES (16666, 1034, 14, 'Lokasi acara');
INSERT INTO `lang_definitions` VALUES (16667, 1035, 14, 'Setiap event repeats');
INSERT INTO `lang_definitions` VALUES (16668, 1036, 14, 'Pada event repeats');
INSERT INTO `lang_definitions` VALUES (16669, 1037, 14, 'Event waktu mulai');
INSERT INTO `lang_definitions` VALUES (16670, 1038, 14, 'Judul Even');
INSERT INTO `lang_definitions` VALUES (16671, 1039, 14, 'Judul Even');
INSERT INTO `lang_definitions` VALUES (16672, 1040, 14, 'Event Website');
INSERT INTO `lang_definitions` VALUES (16673, 1041, 14, 'Peristiwa');
INSERT INTO `lang_definitions` VALUES (16674, 1042, 14, 'Kegiatan untuk');
INSERT INTO `lang_definitions` VALUES (16675, 1043, 14, 'Acara buka di jendela baru');
INSERT INTO `lang_definitions` VALUES (16676, 1045, 14, 'Setiap');
INSERT INTO `lang_definitions` VALUES (16677, 1046, 14, 'setiap 3 bulan');
INSERT INTO `lang_definitions` VALUES (16678, 1047, 14, 'setiap 4 jam');
INSERT INTO `lang_definitions` VALUES (16679, 1048, 14, 'setiap 5 jam');
INSERT INTO `lang_definitions` VALUES (16680, 1049, 14, 'setiap 6 bulan');
INSERT INTO `lang_definitions` VALUES (16681, 1050, 14, 'setiap 8 jam');
INSERT INTO `lang_definitions` VALUES (16682, 1051, 14, 'Keempat setiap');
INSERT INTO `lang_definitions` VALUES (16683, 1052, 14, 'Setiap Lain-lain');
INSERT INTO `lang_definitions` VALUES (16684, 1053, 14, 'Setiap Ketiga');
INSERT INTO `lang_definitions` VALUES (16685, 1055, 14, 'Ujian dan hasil ujian');
INSERT INTO `lang_definitions` VALUES (16686, 1056, 14, 'Hasil ujian');
INSERT INTO `lang_definitions` VALUES (16687, 1058, 14, 'Ujian / Tes');
INSERT INTO `lang_definitions` VALUES (16688, 1060, 14, 'Organisasi eksklusif Provider (EPO)');
INSERT INTO `lang_definitions` VALUES (16689, 1062, 14, 'Pola Latihan');
INSERT INTO `lang_definitions` VALUES (16690, 1063, 14, 'Keluar dari Administrasi');
INSERT INTO `lang_definitions` VALUES (16691, 1065, 14, 'Lihat diperluas');
INSERT INTO `lang_definitions` VALUES (16692, 1066, 14, 'Form_encounter.pid diharapkan akan');
INSERT INTO `lang_definitions` VALUES (16693, 1067, 14, 'Kadaluarsa');
INSERT INTO `lang_definitions` VALUES (16694, 1068, 14, 'Tanggal Kadaluarsa');
INSERT INTO `lang_definitions` VALUES (16695, 1069, 14, 'Berakhir');
INSERT INTO `lang_definitions` VALUES (16696, 1070, 14, 'Ekspor');
INSERT INTO `lang_definitions` VALUES (16697, 1071, 14, 'Ekspor sebagai CSV');
INSERT INTO `lang_definitions` VALUES (16698, 1076, 14, 'Ekspor ke CSV');
INSERT INTO `lang_definitions` VALUES (16699, 1077, 14, 'Ekspor ke luar sistem penagihan');
INSERT INTO `lang_definitions` VALUES (16700, 1078, 14, 'Eksposur ke Negara Asing');
INSERT INTO `lang_definitions` VALUES (16701, 1081, 14, 'Eksternal ID');
INSERT INTO `lang_definitions` VALUES (16702, 1084, 14, 'Arahan eksternal');
INSERT INTO `lang_definitions` VALUES (16703, 1086, 14, 'Eksternal arahan?');
INSERT INTO `lang_definitions` VALUES (16704, 1087, 14, 'Arahan eksternal');
INSERT INTO `lang_definitions` VALUES (16705, 1088, 14, 'Exudate:');
INSERT INTO `lang_definitions` VALUES (16706, 1093, 14, 'M');
INSERT INTO `lang_definitions` VALUES (16707, 1097, 14, 'Fasilitas');
INSERT INTO `lang_definitions` VALUES (16708, 1098, 14, 'fasilitas');
INSERT INTO `lang_definitions` VALUES (16709, 1102, 14, 'Fasilitas:');
INSERT INTO `lang_definitions` VALUES (16710, 1103, 14, 'Gagal');
INSERT INTO `lang_definitions` VALUES (16711, 1106, 14, 'Sejarah keluarga');
INSERT INTO `lang_definitions` VALUES (16712, 1108, 14, 'Sejarah keluarga:');
INSERT INTO `lang_definitions` VALUES (16713, 1109, 14, 'Ukuran Keluarga');
INSERT INTO `lang_definitions` VALUES (16714, 1110, 14, 'Fancy');
INSERT INTO `lang_definitions` VALUES (16715, 1111, 14, 'Ayah');
INSERT INTO `lang_definitions` VALUES (16716, 1113, 14, 'Kejerihan');
INSERT INTO `lang_definitions` VALUES (16717, 1114, 14, 'Fax');
INSERT INTO `lang_definitions` VALUES (16718, 1116, 14, 'Fax / Pindai');
INSERT INTO `lang_definitions` VALUES (16719, 1117, 14, 'Dalam faks');
INSERT INTO `lang_definitions` VALUES (16720, 1118, 14, 'Faks Keluar');
INSERT INTO `lang_definitions` VALUES (16721, 1119, 14, 'Februari');
INSERT INTO `lang_definitions` VALUES (16722, 1120, 14, 'FECA');
INSERT INTO `lang_definitions` VALUES (16723, 1121, 14, 'Federal Narkoba ID');
INSERT INTO `lang_definitions` VALUES (16724, 1122, 14, 'Federal ein');
INSERT INTO `lang_definitions` VALUES (16725, 1123, 14, 'Federal Nomor ID');
INSERT INTO `lang_definitions` VALUES (16726, 1124, 14, 'Ongkos');
INSERT INTO `lang_definitions` VALUES (16727, 1125, 14, 'ongkos');
INSERT INTO `lang_definitions` VALUES (16728, 1127, 14, 'Biaya Lembar');
INSERT INTO `lang_definitions` VALUES (16729, 1129, 14, 'Biaya');
INSERT INTO `lang_definitions` VALUES (16730, 1130, 14, 'Perempuan');
INSERT INTO `lang_definitions` VALUES (16731, 1132, 14, 'Kondom wanita');
INSERT INTO `lang_definitions` VALUES (16732, 1137, 14, 'Perempuan VSC');
INSERT INTO `lang_definitions` VALUES (16733, 1138, 14, 'Demam');
INSERT INTO `lang_definitions` VALUES (16734, 1139, 14, 'Demam:');
INSERT INTO `lang_definitions` VALUES (16735, 1141, 14, 'Fibroids');
INSERT INTO `lang_definitions` VALUES (16736, 1143, 14, 'File Kamar');
INSERT INTO `lang_definitions` VALUES (16737, 1146, 14, 'Filename');
INSERT INTO `lang_definitions` VALUES (16738, 1147, 14, 'Isi di sini hanya jika mengirim email pemberitahuan kepada pasien');
INSERT INTO `lang_definitions` VALUES (16739, 1150, 14, 'Penyaring');
INSERT INTO `lang_definitions` VALUES (16740, 1151, 14, 'Diagnosis akhir');
INSERT INTO `lang_definitions` VALUES (16741, 1152, 14, 'Diagnosa akhir oleh pakar');
INSERT INTO `lang_definitions` VALUES (16742, 1153, 14, 'Keuangan');
INSERT INTO `lang_definitions` VALUES (16743, 1156, 14, 'Tinjauan Keuangan Tanggal');
INSERT INTO `lang_definitions` VALUES (16744, 1157, 14, 'Menemukan');
INSERT INTO `lang_definitions` VALUES (16745, 1158, 14, 'Menemukan Tersedia');
INSERT INTO `lang_definitions` VALUES (16746, 1159, 14, 'Tersedia menemukan Appointments');
INSERT INTO `lang_definitions` VALUES (16747, 1160, 14, 'Cari Pasien');
INSERT INTO `lang_definitions` VALUES (16748, 1161, 14, 'Temuan');
INSERT INTO `lang_definitions` VALUES (16749, 1162, 14, 'Temuan oleh pakar');
INSERT INTO `lang_definitions` VALUES (16750, 1163, 14, 'Baik');
INSERT INTO `lang_definitions` VALUES (16751, 1164, 14, 'Pertama');
INSERT INTO `lang_definitions` VALUES (16752, 1165, 14, 'Hari pertama dalam minggu');
INSERT INTO `lang_definitions` VALUES (16753, 1166, 14, 'Nama Depan');
INSERT INTO `lang_definitions` VALUES (16754, 1168, 14, 'First Name:');
INSERT INTO `lang_definitions` VALUES (16755, 1169, 14, 'Kebugaran');
INSERT INTO `lang_definitions` VALUES (16756, 1170, 14, 'Bermain kebugaran');
INSERT INTO `lang_definitions` VALUES (16757, 1175, 14, 'Vaksinasi flu');
INSERT INTO `lang_definitions` VALUES (16758, 1176, 14, 'Cairan elektrolit dan masalah');
INSERT INTO `lang_definitions` VALUES (16759, 1178, 14, 'Mengikuti secara manual');
INSERT INTO `lang_definitions` VALUES (16760, 1180, 14, 'Kaki');
INSERT INTO `lang_definitions` VALUES (16761, 1181, 14, 'Masalah kaki');
INSERT INTO `lang_definitions` VALUES (16762, 1182, 14, 'Kaki:');
INSERT INTO `lang_definitions` VALUES (16763, 1184, 14, 'Sepak Cedera Lapor');
INSERT INTO `lang_definitions` VALUES (16764, 1185, 14, 'Jenis alas kaki');
INSERT INTO `lang_definitions` VALUES (16765, 1186, 14, 'untuk');
INSERT INTO `lang_definitions` VALUES (16766, 1189, 14, 'untuk:');
INSERT INTO `lang_definitions` VALUES (16767, 1190, 14, 'Sebelumnya');
INSERT INTO `lang_definitions` VALUES (16768, 1191, 14, 'Formulir');
INSERT INTO `lang_definitions` VALUES (16769, 1194, 14, 'Format');
INSERT INTO `lang_definitions` VALUES (16770, 1195, 14, 'Salah format untuk NDC');
INSERT INTO `lang_definitions` VALUES (16771, 1196, 14, 'Formulir');
INSERT INTO `lang_definitions` VALUES (16772, 1197, 14, 'Formulir Administrasi');
INSERT INTO `lang_definitions` VALUES (16773, 1198, 14, 'Halaman maju melalui Fax');
INSERT INTO `lang_definitions` VALUES (16774, 1199, 14, 'Keempat');
INSERT INTO `lang_definitions` VALUES (16775, 1200, 14, 'Pematahan');
INSERT INTO `lang_definitions` VALUES (16776, 1201, 14, 'Retak di Navicula');
INSERT INTO `lang_definitions` VALUES (16777, 1202, 14, 'Patah tulang rusuk malleolus');
INSERT INTO `lang_definitions` VALUES (16778, 1203, 14, 'Patah di tengah-tengah malleolus');
INSERT INTO `lang_definitions` VALUES (16779, 1204, 14, 'Pematahan, Berdasarkan dari kelima (5.) Metatarsal');
INSERT INTO `lang_definitions` VALUES (16780, 1205, 14, 'Perancis');
INSERT INTO `lang_definitions` VALUES (16781, 1209, 14, 'Jumat');
INSERT INTO `lang_definitions` VALUES (16782, 1210, 14, 'Jumat');
INSERT INTO `lang_definitions` VALUES (16783, 1211, 14, 'Dari');
INSERT INTO `lang_definitions` VALUES (16784, 1213, 14, 'Dari:');
INSERT INTO `lang_definitions` VALUES (16785, 1214, 14, 'Dari:');
INSERT INTO `lang_definitions` VALUES (16786, 1226, 14, 'Front Office Penerimaan');
INSERT INTO `lang_definitions` VALUES (16787, 1227, 14, 'Front Office Penerimaan Lapor');
INSERT INTO `lang_definitions` VALUES (16788, 1228, 14, 'Muka Rec');
INSERT INTO `lang_definitions` VALUES (16789, 1229, 14, 'Frontal Kanan:');
INSERT INTO `lang_definitions` VALUES (16790, 1231, 14, 'Penuh Putar');
INSERT INTO `lang_definitions` VALUES (16791, 1232, 14, 'Pelatihan penuh');
INSERT INTO `lang_definitions` VALUES (16792, 1234, 14, 'Kandung empedu Kondisi');
INSERT INTO `lang_definitions` VALUES (16793, 1235, 14, 'Batu empedu');
INSERT INTO `lang_definitions` VALUES (16794, 1236, 14, 'Periode permainan');
INSERT INTO `lang_definitions` VALUES (16795, 1237, 14, 'Game');
INSERT INTO `lang_definitions` VALUES (16796, 1238, 14, 'permainan / acara');
INSERT INTO `lang_definitions` VALUES (16797, 1239, 14, 'Permainan / Terkini Missed');
INSERT INTO `lang_definitions` VALUES (16798, 1240, 14, 'Radang perut');
INSERT INTO `lang_definitions` VALUES (16799, 1242, 14, 'Gastrointestinal');
INSERT INTO `lang_definitions` VALUES (16800, 1243, 14, 'Statistik GCAC Lapor');
INSERT INTO `lang_definitions` VALUES (16801, 1246, 14, 'Jender');
INSERT INTO `lang_definitions` VALUES (16802, 1247, 14, 'Lain-lain');
INSERT INTO `lang_definitions` VALUES (16803, 1248, 14, 'Layanan Umum Kategori');
INSERT INTO `lang_definitions` VALUES (16804, 1249, 14, 'Menghasilkan dan men-download HCFA 1500 klaim kertas');
INSERT INTO `lang_definitions` VALUES (16805, 1250, 14, 'Menghasilkan dan men-download X12 batch');
INSERT INTO `lang_definitions` VALUES (16806, 1255, 14, 'Menghasilkan Banding tentang');
INSERT INTO `lang_definitions` VALUES (16807, 1256, 14, 'Menghasilkan Lapor');
INSERT INTO `lang_definitions` VALUES (16808, 1259, 14, 'Pada');
INSERT INTO `lang_definitions` VALUES (16809, 1260, 14, 'Menghasilkan');
INSERT INTO `lang_definitions` VALUES (16810, 1261, 14, 'Genitourinary');
INSERT INTO `lang_definitions` VALUES (16811, 1262, 14, 'Jerman');
INSERT INTO `lang_definitions` VALUES (16812, 1263, 14, 'Glaukoma');
INSERT INTO `lang_definitions` VALUES (16813, 1265, 14, 'Global');
INSERT INTO `lang_definitions` VALUES (16814, 1267, 14, 'pergi');
INSERT INTO `lang_definitions` VALUES (16815, 1268, 14, 'Pergi');
INSERT INTO `lang_definitions` VALUES (16816, 1271, 14, 'Grade:');
INSERT INTO `lang_definitions` VALUES (16817, 1272, 14, 'gram');
INSERT INTO `lang_definitions` VALUES (16818, 1273, 14, 'Grand Total');
INSERT INTO `lang_definitions` VALUES (16819, 1274, 14, 'Grand total');
INSERT INTO `lang_definitions` VALUES (16820, 1276, 14, 'Grup');
INSERT INTO `lang_definitions` VALUES (16821, 1281, 14, 'Grup Pajak');
INSERT INTO `lang_definitions` VALUES (16822, 1282, 14, 'Group:');
INSERT INTO `lang_definitions` VALUES (16823, 1283, 14, 'Groupname');
INSERT INTO `lang_definitions` VALUES (16824, 1284, 14, 'Kelompok dan Akses Kontrol');
INSERT INTO `lang_definitions` VALUES (16825, 1287, 14, 'gtts (tetes)');
INSERT INTO `lang_definitions` VALUES (16826, 1288, 14, 'Gynecological Ujian');
INSERT INTO `lang_definitions` VALUES (16827, 1289, 14, 'h');
INSERT INTO `lang_definitions` VALUES (16828, 1290, 14, 'h.s.');
INSERT INTO `lang_definitions` VALUES (16829, 1293, 14, 'Haematoma / bruising');
INSERT INTO `lang_definitions` VALUES (16830, 1295, 14, 'Jari tangan +');
INSERT INTO `lang_definitions` VALUES (16831, 1296, 14, 'Tangan Masalah');
INSERT INTO `lang_definitions` VALUES (16832, 1297, 14, 'Kesulitan w / o');
INSERT INTO `lang_definitions` VALUES (16833, 1300, 14, 'Berbahaya Kegiatan');
INSERT INTO `lang_definitions` VALUES (16834, 1304, 14, 'PostCalendar dia');
INSERT INTO `lang_definitions` VALUES (16835, 1305, 14, 'Kepala');
INSERT INTO `lang_definitions` VALUES (16836, 1309, 14, 'Sakit kepala');
INSERT INTO `lang_definitions` VALUES (16837, 1311, 14, 'Organisasi Pemeliharaan Kesehatan');
INSERT INTO `lang_definitions` VALUES (16838, 1312, 14, 'Organisasi Pemeliharaan Kesehatan (HMO) Medicare Risiko');
INSERT INTO `lang_definitions` VALUES (16839, 1314, 14, 'Heart Attack');
INSERT INTO `lang_definitions` VALUES (16840, 1315, 14, 'Penyakit jantung');
INSERT INTO `lang_definitions` VALUES (16841, 1316, 14, 'Gagal jantung');
INSERT INTO `lang_definitions` VALUES (16842, 1318, 14, 'Masalah jantung');
INSERT INTO `lang_definitions` VALUES (16843, 1319, 14, 'Bedah jantung');
INSERT INTO `lang_definitions` VALUES (16844, 1320, 14, 'Transplantasi jantung');
INSERT INTO `lang_definitions` VALUES (16845, 1321, 14, 'HEART:');
INSERT INTO `lang_definitions` VALUES (16846, 1325, 14, 'Ibrani');
INSERT INTO `lang_definitions` VALUES (16847, 1326, 14, 'HEENT');
INSERT INTO `lang_definitions` VALUES (16848, 1328, 14, 'Membantu');
INSERT INTO `lang_definitions` VALUES (16849, 1329, 14, 'membantu');
INSERT INTO `lang_definitions` VALUES (16850, 1334, 14, 'Hemoglobin');
INSERT INTO `lang_definitions` VALUES (16851, 1336, 14, 'Hepatitis');
INSERT INTO `lang_definitions` VALUES (16852, 1343, 14, 'Hernia Repair');
INSERT INTO `lang_definitions` VALUES (16853, 1344, 14, 'Herniated Disc');
INSERT INTO `lang_definitions` VALUES (16854, 1345, 14, 'Herpes');
INSERT INTO `lang_definitions` VALUES (16855, 1347, 14, 'heyyo. Anda telah di sini untuk');
INSERT INTO `lang_definitions` VALUES (16856, 1352, 14, 'Tersembunyi');
INSERT INTO `lang_definitions` VALUES (16857, 1353, 14, 'Peristiwa tersembunyi Administrasi');
INSERT INTO `lang_definitions` VALUES (16858, 1354, 14, 'Sembunyi');
INSERT INTO `lang_definitions` VALUES (16859, 1355, 14, 'Sembunyikan Detail');
INSERT INTO `lang_definitions` VALUES (16860, 1357, 14, 'Tinggi');
INSERT INTO `lang_definitions` VALUES (16861, 1358, 14, 'Tekanan Darah tinggi');
INSERT INTO `lang_definitions` VALUES (16862, 1359, 14, 'Hip + kunci paha');
INSERT INTO `lang_definitions` VALUES (16863, 1360, 14, 'Kunci paha dan hip');
INSERT INTO `lang_definitions` VALUES (16864, 1361, 14, 'Hip Masalah');
INSERT INTO `lang_definitions` VALUES (16865, 1362, 14, 'Hip Replacement');
INSERT INTO `lang_definitions` VALUES (16866, 1363, 14, 'HIPAA Notice Diterima');
INSERT INTO `lang_definitions` VALUES (16867, 1365, 14, 'Hispanic');
INSERT INTO `lang_definitions` VALUES (16868, 1366, 14, 'Sejarah');
INSERT INTO `lang_definitions` VALUES (16869, 1367, 14, 'Sejarah Data');
INSERT INTO `lang_definitions` VALUES (16870, 1371, 14, 'HL7 Viewer');
INSERT INTO `lang_definitions` VALUES (16871, 1372, 14, 'Menekan [Ctrl] untuk beberapa pilihan atau unselect');
INSERT INTO `lang_definitions` VALUES (16872, 1373, 14, 'Menekan Ctrl untuk memilih beberapa item');
INSERT INTO `lang_definitions` VALUES (16873, 1374, 14, 'Menekan Ctrl untuk memilih beberapa squads');
INSERT INTO `lang_definitions` VALUES (16874, 1375, 14, 'Rumah');
INSERT INTO `lang_definitions` VALUES (16875, 1376, 14, 'Telepon Rumah');
INSERT INTO `lang_definitions` VALUES (16876, 1378, 14, 'Wisma atau sama?');
INSERT INTO `lang_definitions` VALUES (16877, 1379, 14, 'Tunawisma, dll');
INSERT INTO `lang_definitions` VALUES (16878, 1380, 14, 'Tunawisma, dll');
INSERT INTO `lang_definitions` VALUES (16879, 1381, 14, 'Jam');
INSERT INTO `lang_definitions` VALUES (16880, 1382, 14, 'Bagaimana Cedera terjadi?');
INSERT INTO `lang_definitions` VALUES (16881, 1383, 14, 'Bagaimana Cedera terjadi:');
INSERT INTO `lang_definitions` VALUES (16882, 1384, 14, 'Berapa bulan ke depan permintaan untuk acara mendatang?');
INSERT INTO `lang_definitions` VALUES (16883, 1385, 14, 'HPI:');
INSERT INTO `lang_definitions` VALUES (16884, 1387, 14, 'HTML');
INSERT INTO `lang_definitions` VALUES (16885, 1388, 14, 'Hyperactive');
INSERT INTO `lang_definitions` VALUES (16886, 1389, 14, 'Hipertensi');
INSERT INTO `lang_definitions` VALUES (16887, 1390, 14, 'Hyperthyroidism');
INSERT INTO `lang_definitions` VALUES (16888, 1391, 14, 'Hypothyroidism');
INSERT INTO `lang_definitions` VALUES (16889, 1392, 14, 'Hysterectomy');
INSERT INTO `lang_definitions` VALUES (16890, 1394, 14, 'Aku sibuk selama ini.');
INSERT INTO `lang_definitions` VALUES (16891, 1395, 14, 'Saya tidak memiliki izin untuk membaca');
INSERT INTO `lang_definitions` VALUES (16892, 1396, 14, 'ICD');
INSERT INTO `lang_definitions` VALUES (16893, 1398, 14, 'ID');
INSERT INTO `lang_definitions` VALUES (16894, 1400, 14, 'IDays');
INSERT INTO `lang_definitions` VALUES (16895, 1402, 14, 'Identifier (satu kata)');
INSERT INTO `lang_definitions` VALUES (16896, 1403, 14, 'Jika semua data untuk semua kolom ini adalah untuk melengkapi formulir');
INSERT INTO `lang_definitions` VALUES (16897, 1404, 14, 'Jika nama, salah satu bagian belakang atau belakang, firstname');
INSERT INTO `lang_definitions` VALUES (16898, 1405, 14, 'jika menganggur masukkan Siswa');
INSERT INTO `lang_definitions` VALUES (16899, 1406, 14, 'Jika Anda memilih untuk meng-upload pengiriman uang elektronik, maka jendela pencarian redisplays sendiri dengan pencocokan tagihan dari X12 file. Anda bisa mengklik pada salah satu nomor faktur (seperti yang dijelaskan di bawah) jika anda ingin melakukan koreksi sebelum uang informasi diterapkan. Untuk menerapkan perubahan, klik tombol Proses ERA File di bagian bawah halaman. Ini akan menghasilkan sebuah jendela baru dengan laporan rinci.');
INSERT INTO `lang_definitions` VALUES (16900, 1407, 14, 'Jika Anda telah memasuki Tanggal Bayar di halaman pencarian, ini akan menimpa postingan tanggal pembayaran dan penyesuaian lain yang diambil dari file X12. Ini mungkin berguna untuk keperluan laporan, jika Anda ingin menggunakan penerimaan laporan tanggal posting Anda daripada asuransi perusahaan pengolahan tanggal. Catatan bahwa ini juga akan mempengaruhi sebelum tanggal pembayaran dan penyesuaian yang kedua dimasukkan ke dalam klaim.');
INSERT INTO `lang_definitions` VALUES (16901, 1408, 14, 'Jika Anda ingin mengubah jenis data, atau tambahkan baris atau kolom');
INSERT INTO `lang_definitions` VALUES (16902, 1409, 14, 'Penyakit');
INSERT INTO `lang_definitions` VALUES (16903, 1410, 14, 'Instan');
INSERT INTO `lang_definitions` VALUES (16904, 1411, 14, 'Imunisasi');
INSERT INTO `lang_definitions` VALUES (16905, 1412, 14, 'Imunisasi Lot Pajak');
INSERT INTO `lang_definitions` VALUES (16906, 1413, 14, 'Produsen imunisasi');
INSERT INTO `lang_definitions` VALUES (16907, 1414, 14, 'Imunisasi');
INSERT INTO `lang_definitions` VALUES (16908, 1415, 14, 'Mengebalkan');
INSERT INTO `lang_definitions` VALUES (16909, 1417, 14, 'Implants');
INSERT INTO `lang_definitions` VALUES (16910, 1418, 14, 'Impor');
INSERT INTO `lang_definitions` VALUES (16911, 1422, 14, 'Diimpor dari Akuntansi');
INSERT INTO `lang_definitions` VALUES (16912, 1424, 14, 'di');
INSERT INTO `lang_definitions` VALUES (16913, 1426, 14, 'di setiap mata');
INSERT INTO `lang_definitions` VALUES (16914, 1427, 14, 'di mata kiri');
INSERT INTO `lang_definitions` VALUES (16915, 1428, 14, 'dalam lubang hidung');
INSERT INTO `lang_definitions` VALUES (16916, 1430, 14, 'di mata kanan');
INSERT INTO `lang_definitions` VALUES (16917, 1431, 14, 'in-house');
INSERT INTO `lang_definitions` VALUES (16918, 1433, 14, 'Hari tidak aktif');
INSERT INTO `lang_definitions` VALUES (16919, 1436, 14, 'Termasuk badan yg vital untuk hidup');
INSERT INTO `lang_definitions` VALUES (16920, 1437, 14, 'Termasuk data badan yg vital untuk hidup?');
INSERT INTO `lang_definitions` VALUES (16921, 1438, 14, 'Pendapatan');
INSERT INTO `lang_definitions` VALUES (16922, 1439, 14, 'Incomplete Abortion Treatment');
INSERT INTO `lang_definitions` VALUES (16923, 1441, 14, 'peningkatan:');
INSERT INTO `lang_definitions` VALUES (16924, 1442, 14, 'Asuransi ganti rugi');
INSERT INTO `lang_definitions` VALUES (16925, 1443, 14, 'Tdk tetap');
INSERT INTO `lang_definitions` VALUES (16926, 1444, 14, 'Menunjukkan jika masalah ini saat ini aktif');
INSERT INTO `lang_definitions` VALUES (16927, 1445, 14, 'Pasien miskin Lapor');
INSERT INTO `lang_definitions` VALUES (16928, 1446, 14, 'Indigents');
INSERT INTO `lang_definitions` VALUES (16929, 1447, 14, 'Abortion induced');
INSERT INTO `lang_definitions` VALUES (16930, 1448, 14, 'Infeksi / Abscess');
INSERT INTO `lang_definitions` VALUES (16931, 1449, 14, 'Infeksi');
INSERT INTO `lang_definitions` VALUES (16932, 1450, 14, 'Infert Couns');
INSERT INTO `lang_definitions` VALUES (16933, 1451, 14, 'Kemandulan');
INSERT INTO `lang_definitions` VALUES (16934, 1454, 14, 'Info');
INSERT INTO `lang_definitions` VALUES (16935, 1455, 14, 'Info test 1');
INSERT INTO `lang_definitions` VALUES (16936, 1456, 14, 'Info tes 2');
INSERT INTO `lang_definitions` VALUES (16937, 1457, 14, 'Info tes 3');
INSERT INTO `lang_definitions` VALUES (16938, 1458, 14, 'Info tes 4');
INSERT INTO `lang_definitions` VALUES (16939, 1459, 14, 'Info ujian 5');
INSERT INTO `lang_definitions` VALUES (16940, 1460, 14, 'Info tes 6');
INSERT INTO `lang_definitions` VALUES (16941, 1461, 14, 'inhalations');
INSERT INTO `lang_definitions` VALUES (16942, 1462, 14, 'inhilations');
INSERT INTO `lang_definitions` VALUES (16943, 1463, 14, 'Awal Pengguna');
INSERT INTO `lang_definitions` VALUES (16944, 1464, 14, 'Injectables');
INSERT INTO `lang_definitions` VALUES (16945, 1465, 14, 'Luka Keluar');
INSERT INTO `lang_definitions` VALUES (16946, 1467, 14, 'Mekanisme cedera');
INSERT INTO `lang_definitions` VALUES (16947, 1468, 14, 'Sekilas cedera Lapor');
INSERT INTO `lang_definitions` VALUES (16948, 1469, 14, 'Cedera Surveillance');
INSERT INTO `lang_definitions` VALUES (16949, 1470, 14, 'Jenis cedera');
INSERT INTO `lang_definitions` VALUES (16950, 1471, 14, 'Input Fields');
INSERT INTO `lang_definitions` VALUES (16951, 1472, 14, 'Ins menyesuaikan');
INSERT INTO `lang_definitions` VALUES (16952, 1473, 14, 'Ins bundling');
INSERT INTO `lang_definitions` VALUES (16953, 1474, 14, 'Ins lebih');
INSERT INTO `lang_definitions` VALUES (16954, 1475, 14, 'Ins pengembalian dana');
INSERT INTO `lang_definitions` VALUES (16955, 1476, 14, 'Ins Aktivitas');
INSERT INTO `lang_definitions` VALUES (16956, 1477, 14, 'Ins1');
INSERT INTO `lang_definitions` VALUES (16957, 1478, 14, 'Ins2');
INSERT INTO `lang_definitions` VALUES (16958, 1479, 14, 'Ins3');
INSERT INTO `lang_definitions` VALUES (16959, 1480, 14, 'Gagal insert:');
INSERT INTO `lang_definitions` VALUES (16960, 1481, 14, 'Masukkan lama kegiatan dalam tabel');
INSERT INTO `lang_definitions` VALUES (16961, 1482, 14, 'Insomnia');
INSERT INTO `lang_definitions` VALUES (16962, 1483, 14, 'Inspeksi');
INSERT INTO `lang_definitions` VALUES (16963, 1484, 14, 'Ketidakstabilan / subluxation');
INSERT INTO `lang_definitions` VALUES (16964, 1485, 14, 'memasang DB');
INSERT INTO `lang_definitions` VALUES (16965, 1486, 14, 'Diinstruksikan');
INSERT INTO `lang_definitions` VALUES (16966, 1487, 14, 'Petunjuk:');
INSERT INTO `lang_definitions` VALUES (16967, 1488, 14, 'Tergantung insulin Diabetes');
INSERT INTO `lang_definitions` VALUES (16968, 1489, 14, 'Asuransi');
INSERT INTO `lang_definitions` VALUES (16969, 1490, 14, 'asuransi');
INSERT INTO `lang_definitions` VALUES (16970, 1491, 14, 'Perusahaan asuransi');
INSERT INTO `lang_definitions` VALUES (16971, 1492, 14, 'Perusahaan asuransi');
INSERT INTO `lang_definitions` VALUES (16972, 1493, 14, 'Perusahaan asuransi Cari / Tambahkan');
INSERT INTO `lang_definitions` VALUES (16973, 1494, 14, 'Data Asuransi');
INSERT INTO `lang_definitions` VALUES (16974, 1495, 14, 'Bilangan asuransi');
INSERT INTO `lang_definitions` VALUES (16975, 1496, 14, 'Asuransi Provider');
INSERT INTO `lang_definitions` VALUES (16976, 1500, 14, 'Internal error - halaman tidak terpilih!');
INSERT INTO `lang_definitions` VALUES (16977, 1501, 14, 'Internal error - ID pasien tidak diberikan!');
INSERT INTO `lang_definitions` VALUES (16978, 1505, 14, 'Internal error: klaim');
INSERT INTO `lang_definitions` VALUES (16979, 1506, 14, 'Internal error: menghadapi \'');
INSERT INTO `lang_definitions` VALUES (16980, 1509, 14, 'Arahan internal');
INSERT INTO `lang_definitions` VALUES (16981, 1510, 14, 'Tugas internasional');
INSERT INTO `lang_definitions` VALUES (16982, 1511, 14, 'Juru');
INSERT INTO `lang_definitions` VALUES (16983, 1512, 14, 'Interpreter needed?');
INSERT INTO `lang_definitions` VALUES (16984, 1513, 14, 'Interstisial Penyakit Paru');
INSERT INTO `lang_definitions` VALUES (16985, 1514, 14, 'Interval');
INSERT INTO `lang_definitions` VALUES (16986, 1516, 14, 'intramuscularly');
INSERT INTO `lang_definitions` VALUES (16987, 1517, 14, 'urat nadi');
INSERT INTO `lang_definitions` VALUES (16988, 1519, 14, 'Tidak sah atau hilang pembayar dalam kode sumber untuk');
INSERT INTO `lang_definitions` VALUES (16989, 1520, 14, 'Layanan yang tidak sah Codes');
INSERT INTO `lang_definitions` VALUES (16990, 1521, 14, 'Penyebutan sumber yang tidak valid \"');
INSERT INTO `lang_definitions` VALUES (16991, 1522, 14, 'InvAmt');
INSERT INTO `lang_definitions` VALUES (16992, 1523, 14, 'Inventarisasi');
INSERT INTO `lang_definitions` VALUES (16993, 1525, 14, 'Daftar inventaris');
INSERT INTO `lang_definitions` VALUES (16994, 1526, 14, 'Tagihan');
INSERT INTO `lang_definitions` VALUES (16995, 1528, 14, 'Tanggal Faktur');
INSERT INTO `lang_definitions` VALUES (16996, 1529, 14, 'Faktur tidak memiliki tanggal!');
INSERT INTO `lang_definitions` VALUES (16997, 1530, 14, 'Faktur:');
INSERT INTO `lang_definitions` VALUES (16998, 1531, 14, 'Data untuk IPPF SRH');
INSERT INTO `lang_definitions` VALUES (16999, 1532, 14, 'IPPF Statistik Lapor');
INSERT INTO `lang_definitions` VALUES (17000, 1537, 14, 'Irregular Heart Beat');
INSERT INTO `lang_definitions` VALUES (17001, 1540, 14, 'adalah field yang dibutuhkan.');
INSERT INTO `lang_definitions` VALUES (17002, 1542, 14, 'tidak valid (desimal pecahannya adalah OK).');
INSERT INTO `lang_definitions` VALUES (17003, 1543, 14, 'PHP adalah menggunakan Safe Mode?');
INSERT INTO `lang_definitions` VALUES (17004, 1546, 14, 'Persoalan');
INSERT INTO `lang_definitions` VALUES (17005, 1547, 14, 'Isu');
INSERT INTO `lang_definitions` VALUES (17006, 1548, 14, 'Isu (Kesehatan / Kedokteran / Allergy):');
INSERT INTO `lang_definitions` VALUES (17007, 1549, 14, 'Isu dan Encounters');
INSERT INTO `lang_definitions` VALUES (17008, 1550, 14, 'Masalah dan untuk Encounters');
INSERT INTO `lang_definitions` VALUES (17009, 1551, 14, 'Isu tidak diizinkan');
INSERT INTO `lang_definitions` VALUES (17010, 1552, 14, 'Isu Bagian');
INSERT INTO `lang_definitions` VALUES (17011, 1553, 14, 'Item');
INSERT INTO `lang_definitions` VALUES (17012, 1554, 14, 'item');
INSERT INTO `lang_definitions` VALUES (17013, 1555, 14, 'Item memuat gagal');
INSERT INTO `lang_definitions` VALUES (17014, 1556, 14, 'IUD');
INSERT INTO `lang_definitions` VALUES (17015, 1557, 14, 'IV');
INSERT INTO `lang_definitions` VALUES (17016, 1558, 14, 'Januari');
INSERT INTO `lang_definitions` VALUES (17017, 1560, 14, 'Deskripsi Jabatan');
INSERT INTO `lang_definitions` VALUES (17018, 1561, 14, 'Job ID');
INSERT INTO `lang_definitions` VALUES (17019, 1562, 14, 'Bersama dislocations');
INSERT INTO `lang_definitions` VALUES (17020, 1564, 14, 'Bersama sprains');
INSERT INTO `lang_definitions` VALUES (17021, 1565, 14, 'Juli');
INSERT INTO `lang_definitions` VALUES (17022, 1566, 14, 'Juni');
INSERT INTO `lang_definitions` VALUES (17023, 1567, 14, 'Tepat di bawah cek informasi adalah biru daerah di mana Anda meletakkan dalam pencarian parameter. Anda dapat mencari berdasarkan nama pasien, angka grafik, menemukan nomor atau tanggal pelayanan, atau kombinasi ini. Anda juga dapat memilih apakah Anda ingin melihat semua tagihan, buka faktur atau tagihan yang hanya karena (oleh pasien). Klik tombol Search untuk melakukan pencarian.');
INSERT INTO `lang_definitions` VALUES (17024, 1568, 14, 'Just Mine');
INSERT INTO `lang_definitions` VALUES (17025, 1569, 14, 'Membenarkan');
INSERT INTO `lang_definitions` VALUES (17026, 1570, 14, 'Justify / Simpan');
INSERT INTO `lang_definitions` VALUES (17027, 1571, 14, 'k, here\'s the rest');
INSERT INTO `lang_definitions` VALUES (17028, 1572, 14, 'Kata kunci');
INSERT INTO `lang_definitions` VALUES (17029, 1575, 14, 'Kanker ginjal');
INSERT INTO `lang_definitions` VALUES (17030, 1576, 14, 'Gagal ginjal');
INSERT INTO `lang_definitions` VALUES (17031, 1577, 14, 'Infeksi ginjal');
INSERT INTO `lang_definitions` VALUES (17032, 1578, 14, 'Batu ginjal');
INSERT INTO `lang_definitions` VALUES (17033, 1579, 14, 'Transplantasi ginjal');
INSERT INTO `lang_definitions` VALUES (17034, 1580, 14, 'Knee');
INSERT INTO `lang_definitions` VALUES (17035, 1581, 14, 'Masalah knee');
INSERT INTO `lang_definitions` VALUES (17036, 1582, 14, 'Knee Replacement');
INSERT INTO `lang_definitions` VALUES (17037, 1583, 14, 'Lab');
INSERT INTO `lang_definitions` VALUES (17038, 1585, 14, 'Label');
INSERT INTO `lang_definitions` VALUES (17039, 1587, 14, 'Label cols');
INSERT INTO `lang_definitions` VALUES (17040, 1589, 14, 'Label');
INSERT INTO `lang_definitions` VALUES (17041, 1590, 14, 'Labs');
INSERT INTO `lang_definitions` VALUES (17042, 1591, 14, 'Pengoyakan / kondisi kulit');
INSERT INTO `lang_definitions` VALUES (17043, 1592, 14, 'Pengoyakan / abrasi');
INSERT INTO `lang_definitions` VALUES (17044, 1593, 14, 'Bahasa');
INSERT INTO `lang_definitions` VALUES (17045, 1594, 14, 'Kode bahasa');
INSERT INTO `lang_definitions` VALUES (17046, 1595, 14, 'Definisi bahasa ditambahkan');
INSERT INTO `lang_definitions` VALUES (17047, 1598, 14, 'Bahasa Nama');
INSERT INTO `lang_definitions` VALUES (17048, 1599, 14, 'Bahasa:');
INSERT INTO `lang_definitions` VALUES (17049, 1600, 14, 'Terakhir');
INSERT INTO `lang_definitions` VALUES (17050, 1603, 14, 'Terakhir Encounter');
INSERT INTO `lang_definitions` VALUES (17051, 1604, 14, 'Nama belakang');
INSERT INTO `lang_definitions` VALUES (17052, 1606, 14, 'Last Name:');
INSERT INTO `lang_definitions` VALUES (17053, 1609, 14, 'Kunjungan Terakhir');
INSERT INTO `lang_definitions` VALUES (17054, 1610, 14, 'Akhir perulangan (2-12 Mo)');
INSERT INTO `lang_definitions` VALUES (17055, 1611, 14, 'Lateral Malleolus');
INSERT INTO `lang_definitions` VALUES (17056, 1612, 14, 'Lateral malleolus:');
INSERT INTO `lang_definitions` VALUES (17057, 1613, 14, 'laterally pengungsi PMI:');
INSERT INTO `lang_definitions` VALUES (17058, 1615, 14, 'Layout Editor');
INSERT INTO `lang_definitions` VALUES (17059, 1618, 14, 'Layouts');
INSERT INTO `lang_definitions` VALUES (17060, 1621, 14, 'LDL');
INSERT INTO `lang_definitions` VALUES (17061, 1622, 14, 'biarkan kosong jika masih aktif');
INSERT INTO `lang_definitions` VALUES (17062, 1623, 14, 'Biarkan kosong untuk password tetap tidak berubah.');
INSERT INTO `lang_definitions` VALUES (17063, 1624, 14, 'Dengan meninggalkan Pesan');
INSERT INTO `lang_definitions` VALUES (17064, 1625, 14, 'Meninggalkan The Form');
INSERT INTO `lang_definitions` VALUES (17065, 1626, 14, 'Kiri');
INSERT INTO `lang_definitions` VALUES (17066, 1628, 14, 'telinga kiri');
INSERT INTO `lang_definitions` VALUES (17067, 1629, 14, 'Kiri:');
INSERT INTO `lang_definitions` VALUES (17068, 1630, 14, 'Kiri:');
INSERT INTO `lang_definitions` VALUES (17069, 1632, 14, 'Hukum');
INSERT INTO `lang_definitions` VALUES (17070, 1633, 14, 'Legend:');
INSERT INTO `lang_definitions` VALUES (17071, 1634, 14, 'Panjang');
INSERT INTO `lang_definitions` VALUES (17072, 1636, 14, 'Banding');
INSERT INTO `lang_definitions` VALUES (17073, 1637, 14, 'Huruf Generator');
INSERT INTO `lang_definitions` VALUES (17074, 1640, 14, 'Tingkat urgensi');
INSERT INTO `lang_definitions` VALUES (17075, 1641, 14, 'Kewajiban');
INSERT INTO `lang_definitions` VALUES (17076, 1642, 14, 'Kewajiban Kedokteran');
INSERT INTO `lang_definitions` VALUES (17077, 1643, 14, 'License / ID');
INSERT INTO `lang_definitions` VALUES (17078, 1644, 14, 'Gaya Hidup');
INSERT INTO `lang_definitions` VALUES (17079, 1645, 14, 'Ikat robek atau keseleo');
INSERT INTO `lang_definitions` VALUES (17080, 1646, 14, 'Batas Kegiatan');
INSERT INTO `lang_definitions` VALUES (17081, 1649, 14, 'Daftar');
INSERT INTO `lang_definitions` VALUES (17082, 1651, 14, 'daftar kotak');
INSERT INTO `lang_definitions` VALUES (17083, 1652, 14, 'daftar kotak w / menambahkan');
INSERT INTO `lang_definitions` VALUES (17084, 1654, 14, 'Daftar Editor');
INSERT INTO `lang_definitions` VALUES (17085, 1656, 14, 'Daftar Perusahaan Asuransi');
INSERT INTO `lang_definitions` VALUES (17086, 1659, 14, 'Daftar daftar');
INSERT INTO `lang_definitions` VALUES (17087, 1662, 14, 'Daftar resep');
INSERT INTO `lang_definitions` VALUES (17088, 1663, 14, 'Daftar');
INSERT INTO `lang_definitions` VALUES (17089, 1664, 14, 'LLL:');
INSERT INTO `lang_definitions` VALUES (17090, 1667, 14, 'Loading');
INSERT INTO `lang_definitions` VALUES (17091, 1669, 14, 'Lokal');
INSERT INTO `lang_definitions` VALUES (17092, 1671, 14, 'Lokasi');
INSERT INTO `lang_definitions` VALUES (17093, 1672, 14, 'Lokasi yg tak ditentukan');
INSERT INTO `lang_definitions` VALUES (17094, 1673, 14, 'Lokasi:');
INSERT INTO `lang_definitions` VALUES (17095, 1675, 14, 'Login');
INSERT INTO `lang_definitions` VALUES (17096, 1676, 14, 'Login sebagai');
INSERT INTO `lang_definitions` VALUES (17097, 1677, 14, 'Login sebagai:');
INSERT INTO `lang_definitions` VALUES (17098, 1678, 14, 'Keluar.');
INSERT INTO `lang_definitions` VALUES (17099, 1679, 14, 'Login');
INSERT INTO `lang_definitions` VALUES (17100, 1681, 14, 'Logout');
INSERT INTO `lang_definitions` VALUES (17101, 1683, 14, 'Log');
INSERT INTO `lang_definitions` VALUES (17102, 1684, 14, 'Log Viewer');
INSERT INTO `lang_definitions` VALUES (17103, 1685, 14, 'Look Up');
INSERT INTO `lang_definitions` VALUES (17104, 1686, 14, 'Banyak');
INSERT INTO `lang_definitions` VALUES (17105, 1688, 14, 'Jumlah banyak');
INSERT INTO `lang_definitions` VALUES (17106, 1689, 14, 'Rendah');
INSERT INTO `lang_definitions` VALUES (17107, 1690, 14, 'Rendah kaki');
INSERT INTO `lang_definitions` VALUES (17108, 1691, 14, 'Lumbar spine');
INSERT INTO `lang_definitions` VALUES (17109, 1694, 14, 'Kanker paru-paru');
INSERT INTO `lang_definitions` VALUES (17110, 1695, 14, 'Kanker Paru Bedah');
INSERT INTO `lang_definitions` VALUES (17111, 1696, 14, 'Paru-paru:');
INSERT INTO `lang_definitions` VALUES (17112, 1697, 14, 'Paru-paru:');
INSERT INTO `lang_definitions` VALUES (17113, 1698, 14, 'Lupus');
INSERT INTO `lang_definitions` VALUES (17114, 1699, 14, 'M');
INSERT INTO `lang_definitions` VALUES (17115, 1700, 14, 'MA Kategori');
INSERT INTO `lang_definitions` VALUES (17116, 1701, 14, 'Alamat utama');
INSERT INTO `lang_definitions` VALUES (17117, 1702, 14, 'Memodifikasi kategori.');
INSERT INTO `lang_definitions` VALUES (17118, 1703, 14, 'Pastikan \"');
INSERT INTO `lang_definitions` VALUES (17119, 1704, 14, 'Rasa tidak enak:');
INSERT INTO `lang_definitions` VALUES (17120, 1705, 14, 'Laki-laki');
INSERT INTO `lang_definitions` VALUES (17121, 1706, 14, 'Kondom laki-laki');
INSERT INTO `lang_definitions` VALUES (17122, 1707, 14, 'Laki-laki VSC');
INSERT INTO `lang_definitions` VALUES (17123, 1708, 14, 'Mammogram');
INSERT INTO `lang_definitions` VALUES (17124, 1709, 14, 'Manajemen');
INSERT INTO `lang_definitions` VALUES (17125, 1710, 14, 'Manual Posting');
INSERT INTO `lang_definitions` VALUES (17126, 1711, 14, 'Pabrikan');
INSERT INTO `lang_definitions` VALUES (17127, 1712, 14, 'Mar.');
INSERT INTO `lang_definitions` VALUES (17128, 1713, 14, 'Status');
INSERT INTO `lang_definitions` VALUES (17129, 1714, 14, 'Tandai tagihan tetapi melewati penagihan');
INSERT INTO `lang_definitions` VALUES (17130, 1716, 14, 'Tandai belum ditagih');
INSERT INTO `lang_definitions` VALUES (17131, 1717, 14, 'Ditandai sebagai dihapus');
INSERT INTO `lang_definitions` VALUES (17132, 1718, 14, 'Menikah');
INSERT INTO `lang_definitions` VALUES (17133, 1719, 14, 'Rahang atas kanan:');
INSERT INTO `lang_definitions` VALUES (17134, 1720, 14, 'Boleh');
INSERT INTO `lang_definitions` VALUES (17135, 1721, 14, 'MC');
INSERT INTO `lang_definitions` VALUES (17136, 1722, 14, 'mcg');
INSERT INTO `lang_definitions` VALUES (17137, 1723, 14, 'Di tengah-tengah malleolus:');
INSERT INTO `lang_definitions` VALUES (17138, 1724, 14, 'Medicaid');
INSERT INTO `lang_definitions` VALUES (17139, 1725, 14, 'Medis');
INSERT INTO `lang_definitions` VALUES (17140, 1726, 14, 'Medis Abortion');
INSERT INTO `lang_definitions` VALUES (17141, 1727, 14, 'Masalah medis');
INSERT INTO `lang_definitions` VALUES (17142, 1728, 14, 'Masalah medis');
INSERT INTO `lang_definitions` VALUES (17143, 1729, 14, 'Rekam medis');
INSERT INTO `lang_definitions` VALUES (17144, 1731, 14, 'Medical Records');
INSERT INTO `lang_definitions` VALUES (17145, 1733, 14, 'Medicare Bagian B');
INSERT INTO `lang_definitions` VALUES (17146, 1735, 14, 'Obat');
INSERT INTO `lang_definitions` VALUES (17147, 1736, 14, 'Obat:');
INSERT INTO `lang_definitions` VALUES (17148, 1737, 14, 'Obat Unit');
INSERT INTO `lang_definitions` VALUES (17149, 1738, 14, 'Sedang');
INSERT INTO `lang_definitions` VALUES (17150, 1739, 14, 'Statistik anggota Asosiasi Lapor');
INSERT INTO `lang_definitions` VALUES (17151, 1741, 14, 'Pria-pria');
INSERT INTO `lang_definitions` VALUES (17152, 1742, 14, 'Laki-laki dan perempuan');
INSERT INTO `lang_definitions` VALUES (17153, 1743, 14, 'Hanya laki-laki');
INSERT INTO `lang_definitions` VALUES (17154, 1748, 14, 'Penyakit mental');
INSERT INTO `lang_definitions` VALUES (17155, 1749, 14, 'Pesan');
INSERT INTO `lang_definitions` VALUES (17156, 1750, 14, 'PESAN:');
INSERT INTO `lang_definitions` VALUES (17157, 1751, 14, 'Metode');
INSERT INTO `lang_definitions` VALUES (17158, 1752, 14, 'Metode Destruction');
INSERT INTO `lang_definitions` VALUES (17159, 1753, 14, 'mg');
INSERT INTO `lang_definitions` VALUES (17160, 1754, 14, 'mg/1cc');
INSERT INTO `lang_definitions` VALUES (17161, 1755, 14, 'mg/2cc');
INSERT INTO `lang_definitions` VALUES (17162, 1756, 14, 'mg/3cc');
INSERT INTO `lang_definitions` VALUES (17163, 1757, 14, 'mg/4cc');
INSERT INTO `lang_definitions` VALUES (17164, 1758, 14, 'mg/5cc');
INSERT INTO `lang_definitions` VALUES (17165, 1760, 14, 'Nama tengah');
INSERT INTO `lang_definitions` VALUES (17166, 1762, 14, 'Migran musiman atau pekerja?');
INSERT INTO `lang_definitions` VALUES (17167, 1763, 14, 'Migran / Musiman');
INSERT INTO `lang_definitions` VALUES (17168, 1764, 14, 'Mimetype');
INSERT INTO `lang_definitions` VALUES (17169, 1766, 14, 'Minor joint strain + / - synovitis');
INSERT INTO `lang_definitions` VALUES (17170, 1767, 14, 'menit');
INSERT INTO `lang_definitions` VALUES (17171, 1768, 14, 'Menit');
INSERT INTO `lang_definitions` VALUES (17172, 1773, 14, 'Miscellaneous');
INSERT INTO `lang_definitions` VALUES (17173, 1774, 14, 'Missed');
INSERT INTO `lang_definitions` VALUES (17174, 1777, 14, 'Hilang setelah slash pembayar dalam kode sumber untuk');
INSERT INTO `lang_definitions` VALUES (17175, 1778, 14, 'Dicampur');
INSERT INTO `lang_definitions` VALUES (17176, 1779, 14, 'ml');
INSERT INTO `lang_definitions` VALUES (17177, 1783, 14, 'Mobile');
INSERT INTO `lang_definitions` VALUES (17178, 1784, 14, 'Mobile Phone');
INSERT INTO `lang_definitions` VALUES (17179, 1785, 14, 'Mod');
INSERT INTO `lang_definitions` VALUES (17180, 1786, 14, 'Pengubah');
INSERT INTO `lang_definitions` VALUES (17181, 1787, 14, 'Senin');
INSERT INTO `lang_definitions` VALUES (17182, 1788, 14, 'Senin sampai Jumat');
INSERT INTO `lang_definitions` VALUES (17183, 1789, 14, 'Senin, Rabu & Jumat');
INSERT INTO `lang_definitions` VALUES (17184, 1790, 14, 'Senin');
INSERT INTO `lang_definitions` VALUES (17185, 1791, 14, 'bulan');
INSERT INTO `lang_definitions` VALUES (17186, 1792, 14, 'Bulan');
INSERT INTO `lang_definitions` VALUES (17187, 1793, 14, 'Lihat bulan');
INSERT INTO `lang_definitions` VALUES (17188, 1794, 14, 'Bulan (s)');
INSERT INTO `lang_definitions` VALUES (17189, 1795, 14, 'Pendapatan Bulanan');
INSERT INTO `lang_definitions` VALUES (17190, 1797, 14, 'Lebih dari 50 hasil, lakukan pencarian Anda lebih spesifik.');
INSERT INTO `lang_definitions` VALUES (17191, 1798, 14, 'Ibu');
INSERT INTO `lang_definitions` VALUES (17192, 1800, 14, 'Pindah');
INSERT INTO `lang_definitions` VALUES (17193, 1803, 14, 'Pindah ke Pasien');
INSERT INTO `lang_definitions` VALUES (17194, 1809, 14, 'Multi Perangkat Bahasa');
INSERT INTO `lang_definitions` VALUES (17195, 1810, 14, 'Beberapa daerah');
INSERT INTO `lang_definitions` VALUES (17196, 1811, 14, 'Dengut:');
INSERT INTO `lang_definitions` VALUES (17197, 1819, 14, 'Cedera otot');
INSERT INTO `lang_definitions` VALUES (17198, 1820, 14, 'Musculoskeletal');
INSERT INTO `lang_definitions` VALUES (17199, 1821, 14, 'Saling Ditetapkan');
INSERT INTO `lang_definitions` VALUES (17200, 1822, 14, 'MVA');
INSERT INTO `lang_definitions` VALUES (17201, 1825, 14, 'Nama');
INSERT INTO `lang_definitions` VALUES (17202, 1828, 14, 'Nama dan Judul imunisasi dari Administrator');
INSERT INTO `lang_definitions` VALUES (17203, 1829, 14, 'Nama perusahaan asuransi');
INSERT INTO `lang_definitions` VALUES (17204, 1830, 14, 'Nama Provider');
INSERT INTO `lang_definitions` VALUES (17205, 1832, 14, 'Nama / Nilai');
INSERT INTO `lang_definitions` VALUES (17206, 1833, 14, 'Nama:');
INSERT INTO `lang_definitions` VALUES (17207, 1834, 14, 'NARES:');
INSERT INTO `lang_definitions` VALUES (17208, 1835, 14, 'NARES: Normal Tepat');
INSERT INTO `lang_definitions` VALUES (17209, 1836, 14, 'Nasal mucosa pink, septum midline');
INSERT INTO `lang_definitions` VALUES (17210, 1837, 14, 'Kebangsaan');
INSERT INTO `lang_definitions` VALUES (17211, 1839, 14, 'Navigasi');
INSERT INTO `lang_definitions` VALUES (17212, 1840, 14, 'NDC');
INSERT INTO `lang_definitions` VALUES (17213, 1841, 14, 'NDC Pajak');
INSERT INTO `lang_definitions` VALUES (17214, 1842, 14, 'Leher');
INSERT INTO `lang_definitions` VALUES (17215, 1843, 14, 'Masalah leher');
INSERT INTO `lang_definitions` VALUES (17216, 1844, 14, 'Lemas leher');
INSERT INTO `lang_definitions` VALUES (17217, 1845, 14, 'Harus memasukkan keterangan');
INSERT INTO `lang_definitions` VALUES (17218, 1846, 14, 'Harus memasukkan Kembali Nilai');
INSERT INTO `lang_definitions` VALUES (17219, 1847, 14, 'Harus memasukkan identifier');
INSERT INTO `lang_definitions` VALUES (17220, 1848, 14, 'Harus memasukkan judul');
INSERT INTO `lang_definitions` VALUES (17221, 1851, 14, 'Kebutuhan sekunder penagihan');
INSERT INTO `lang_definitions` VALUES (17222, 1852, 14, 'Cedera otot');
INSERT INTO `lang_definitions` VALUES (17223, 1853, 14, 'Neural kondisi / kerusakan saraf');
INSERT INTO `lang_definitions` VALUES (17224, 1857, 14, 'Baru');
INSERT INTO `lang_definitions` VALUES (17225, 1858, 14, 'Baru =>');
INSERT INTO `lang_definitions` VALUES (17226, 1859, 14, 'Baru Acceptors');
INSERT INTO `lang_definitions` VALUES (17227, 1860, 14, 'Baru Allergy');
INSERT INTO `lang_definitions` VALUES (17228, 1861, 14, 'Baru Penunjukan');
INSERT INTO `lang_definitions` VALUES (17229, 1862, 14, 'Kategori Baru');
INSERT INTO `lang_definitions` VALUES (17230, 1864, 14, 'Klien Baru');
INSERT INTO `lang_definitions` VALUES (17231, 1865, 14, 'Konsultasi baru');
INSERT INTO `lang_definitions` VALUES (17232, 1866, 14, 'Definisi baru menetapkan ditambahkan');
INSERT INTO `lang_definitions` VALUES (17233, 1868, 14, 'Formulir baru Encounter');
INSERT INTO `lang_definitions` VALUES (17234, 1869, 14, 'Baru menemukan tidak diizinkan');
INSERT INTO `lang_definitions` VALUES (17235, 1870, 14, 'Baru Enctr');
INSERT INTO `lang_definitions` VALUES (17236, 1871, 14, 'Informasi Fasilitas Baru');
INSERT INTO `lang_definitions` VALUES (17237, 1872, 14, 'Grup Baru');
INSERT INTO `lang_definitions` VALUES (17238, 1874, 14, 'Batas Acara baru');
INSERT INTO `lang_definitions` VALUES (17239, 1876, 14, 'Pasien baru');
INSERT INTO `lang_definitions` VALUES (17240, 1877, 14, 'Pasien baru Encounter');
INSERT INTO `lang_definitions` VALUES (17241, 1878, 14, 'Pasien baru ID');
INSERT INTO `lang_definitions` VALUES (17242, 1879, 14, 'Baru Pt');
INSERT INTO `lang_definitions` VALUES (17243, 1880, 14, 'Baru Submissions');
INSERT INTO `lang_definitions` VALUES (17244, 1881, 14, 'Pengguna Baru');
INSERT INTO `lang_definitions` VALUES (17245, 1882, 14, 'Kunjungi baru');
INSERT INTO `lang_definitions` VALUES (17246, 1883, 14, 'Baru / Cari');
INSERT INTO `lang_definitions` VALUES (17247, 1884, 14, 'Koran');
INSERT INTO `lang_definitions` VALUES (17248, 1885, 14, 'Berikutnya');
INSERT INTO `lang_definitions` VALUES (17249, 1886, 14, 'Hari Berikutnya');
INSERT INTO `lang_definitions` VALUES (17250, 1887, 14, 'Bulan berikutnya');
INSERT INTO `lang_definitions` VALUES (17251, 1888, 14, 'Minggu berikutnya');
INSERT INTO `lang_definitions` VALUES (17252, 1889, 14, 'Nickname');
INSERT INTO `lang_definitions` VALUES (17253, 1890, 14, 'Night Sweats');
INSERT INTO `lang_definitions` VALUES (17254, 1891, 14, 'Nl ext kemaluan, vag mucosa, tengkuk');
INSERT INTO `lang_definitions` VALUES (17255, 1892, 14, 'NO');
INSERT INTO `lang_definitions` VALUES (17256, 1893, 14, 'Tidak');
INSERT INTO `lang_definitions` VALUES (17257, 1894, 14, 'Tidak ada akses');
INSERT INTO `lang_definitions` VALUES (17258, 1895, 14, 'Tidak adenopathy (2 daerah diperlukan)');
INSERT INTO `lang_definitions` VALUES (17259, 1896, 14, 'Tidak ada kesakitan adnexal / massa');
INSERT INTO `lang_definitions` VALUES (17260, 1897, 14, 'Tidak ada sistem penagihan yang sedang aktif');
INSERT INTO `lang_definitions` VALUES (17261, 1898, 14, 'Tidak Ditemukan Bills Termasuk ke dalam OFX Ekspor <br>');
INSERT INTO `lang_definitions` VALUES (17262, 1899, 14, 'Tidak ada kode telah ditentukan!');
INSERT INTO `lang_definitions` VALUES (17263, 1900, 14, 'Tidak Diagnosis');
INSERT INTO `lang_definitions` VALUES (17264, 1901, 14, 'Tidak ada tanggal');
INSERT INTO `lang_definitions` VALUES (17265, 1902, 14, 'Tidak ada masukan ditemukan, menggunakan formulir di bawah ini untuk memberikan masukan.');
INSERT INTO `lang_definitions` VALUES (17266, 1903, 14, 'Tidak ada event');
INSERT INTO `lang_definitions` VALUES (17267, 1904, 14, 'Tidak ada grup yang dipilih');
INSERT INTO `lang_definitions` VALUES (17268, 1905, 14, 'Tidak burut');
INSERT INTO `lang_definitions` VALUES (17269, 1906, 14, 'Perusahaan Asuransi Tidak Ditemukan');
INSERT INTO `lang_definitions` VALUES (17270, 1908, 14, 'Tidak ada massa, kelembutan');
INSERT INTO `lang_definitions` VALUES (17271, 1910, 14, 'Tidak ogrganomegoly');
INSERT INTO `lang_definitions` VALUES (17272, 1911, 14, 'Tidak ada bukaan ditemukan untuk periode ini.');
INSERT INTO `lang_definitions` VALUES (17273, 1912, 14, 'Tidak Ditemukan Mitra');
INSERT INTO `lang_definitions` VALUES (17274, 1913, 14, 'No pinggiran busung');
INSERT INTO `lang_definitions` VALUES (17275, 1914, 14, 'Apotik tidak Ditemukan');
INSERT INTO `lang_definitions` VALUES (17276, 1915, 14, 'Tidak ada resep Ditemukan');
INSERT INTO `lang_definitions` VALUES (17277, 1916, 14, 'Tidak ada presentasi penyakit / cedera');
INSERT INTO `lang_definitions` VALUES (17278, 1917, 14, 'Tidak Ditemukan Providers');
INSERT INTO `lang_definitions` VALUES (17279, 1918, 14, 'Tidak ada luka ruam atau abnormal');
INSERT INTO `lang_definitions` VALUES (17280, 1921, 14, 'Tidak Ditemukan Hasil Pencarian Untuk');
INSERT INTO `lang_definitions` VALUES (17281, 1922, 14, 'Tidak ada hasil, silakan baki lagi.');
INSERT INTO `lang_definitions` VALUES (17282, 1925, 14, 'Tidak ada kesakitan Sinus:');
INSERT INTO `lang_definitions` VALUES (17283, 1926, 14, 'Tidak ada kulit payudara dimpling atau nodules');
INSERT INTO `lang_definitions` VALUES (17284, 1927, 14, 'Tidak testicular kesakitan, massa');
INSERT INTO `lang_definitions` VALUES (17285, 1928, 14, 'No thrills atau heaves');
INSERT INTO `lang_definitions` VALUES (17286, 1931, 14, 'No:');
INSERT INTO `lang_definitions` VALUES (17287, 1933, 14, 'Non spesifik cedera');
INSERT INTO `lang_definitions` VALUES (17288, 1934, 14, 'Non Insulin Diabetes tergantung');
INSERT INTO `lang_definitions` VALUES (17289, 1935, 14, 'Non-SRH Kedokteran');
INSERT INTO `lang_definitions` VALUES (17290, 1936, 14, 'Non-SRH Non Medis');
INSERT INTO `lang_definitions` VALUES (17291, 1937, 14, 'Tak satupun');
INSERT INTO `lang_definitions` VALUES (17292, 1938, 14, 'tak satupun');
INSERT INTO `lang_definitions` VALUES (17293, 1939, 14, 'None of the above');
INSERT INTO `lang_definitions` VALUES (17294, 1941, 14, 'Maupun');
INSERT INTO `lang_definitions` VALUES (17295, 1942, 14, 'Normal');
INSERT INTO `lang_definitions` VALUES (17296, 1944, 14, 'Normal jantung Ujian:');
INSERT INTO `lang_definitions` VALUES (17297, 1945, 14, 'Normal jantung Ujian:');
INSERT INTO `lang_definitions` VALUES (17298, 1946, 14, 'Normal Paru Ujian:');
INSERT INTO `lang_definitions` VALUES (17299, 1947, 14, 'Normal Paru Ujian:');
INSERT INTO `lang_definitions` VALUES (17300, 1949, 14, 'Normal Oropharynx:');
INSERT INTO `lang_definitions` VALUES (17301, 1950, 14, 'Normal Kanan');
INSERT INTO `lang_definitions` VALUES (17302, 1951, 14, 'Normal Kanan:');
INSERT INTO `lang_definitions` VALUES (17303, 1952, 14, 'Lihat normal');
INSERT INTO `lang_definitions` VALUES (17304, 1953, 14, 'normal:');
INSERT INTO `lang_definitions` VALUES (17305, 1954, 14, 'Norwegian');
INSERT INTO `lang_definitions` VALUES (17306, 1957, 14, 'Tidak semua bidang yang diperlukan untuk semua jenis kode atau kode.');
INSERT INTO `lang_definitions` VALUES (17307, 1958, 14, 'Tidak Boleh');
INSERT INTO `lang_definitions` VALUES (17308, 1959, 14, 'Tidak diperbolehkan untuk menghapus grup Administrator');
INSERT INTO `lang_definitions` VALUES (17309, 1960, 14, 'Tidak diperbolehkan untuk keamanan menonaktipkan semua benda');
INSERT INTO `lang_definitions` VALUES (17310, 1961, 14, 'Tidak diperbolehkan untuk menonaktipkan apapun dari Administrator ACL');
INSERT INTO `lang_definitions` VALUES (17311, 1962, 14, 'Tidak diperbolehkan untuk menghapus admin pengguna dari grup Administrator');
INSERT INTO `lang_definitions` VALUES (17312, 1963, 14, 'Tidak diizinkan untuk mengakses PostCalendar modul');
INSERT INTO `lang_definitions` VALUES (17313, 1969, 14, 'Tidak diperiksa');
INSERT INTO `lang_definitions` VALUES (17314, 1970, 14, 'Tidak diperiksa:');
INSERT INTO `lang_definitions` VALUES (17315, 1971, 14, 'Tidak diperiksa:');
INSERT INTO `lang_definitions` VALUES (17316, 1974, 14, 'Tidak terlihat sejak');
INSERT INTO `lang_definitions` VALUES (17317, 1975, 14, 'Catatan');
INSERT INTO `lang_definitions` VALUES (17318, 1976, 14, 'Jenis Catatan');
INSERT INTO `lang_definitions` VALUES (17319, 1977, 14, 'Catatan: kode ini tidak dimasukkan oleh pengguna yang berwenang. Hanya berwenang kode mungkin upload ke Terselesaikan Kedokteran Jaringan Penagihan untuk diproses. Jika Anda ingin meng-upload kode ini, silahkan pilih salah satu pengguna berwenang di sini.');
INSERT INTO `lang_definitions` VALUES (17320, 1978, 14, 'CATATAN: Mengupload file dengan nama sama akan menyebabkan file yang akan diganti secara otomatis. Misalnya \'<i> file.jpg </ i>\' akan menjadi \'<i> file.jpg.1 </ i>\'. Filenames dianggap unik per pasien, bukan per kategori.');
INSERT INTO `lang_definitions` VALUES (17321, 1979, 14, 'Catatan');
INSERT INTO `lang_definitions` VALUES (17322, 1983, 14, 'Tidak ada yang dipilih');
INSERT INTO `lang_definitions` VALUES (17323, 1984, 14, 'PEMBERITAHUAN:: PostCalendar Submission / Modifikasi');
INSERT INTO `lang_definitions` VALUES (17324, 1985, 14, 'Pemberitahuan');
INSERT INTO `lang_definitions` VALUES (17325, 1986, 14, 'Beritahu Admin Tentang Event Submission / Modifikasi?');
INSERT INTO `lang_definitions` VALUES (17326, 1987, 14, 'November');
INSERT INTO `lang_definitions` VALUES (17327, 1988, 14, 'Sekarang posting untuk:');
INSERT INTO `lang_definitions` VALUES (17328, 1989, 14, 'Sekarang dicetak stmt_count $ pernyataan dan mendapatkan update.');
INSERT INTO `lang_definitions` VALUES (17329, 1990, 14, 'Sekarang dicetak stmt_count $ pernyataan dan memperbarui tagihan.');
INSERT INTO `lang_definitions` VALUES (17330, 1991, 14, 'Sekarang dicetak $ stmt_count pernyataan; menemukan tidak akan diupdate.');
INSERT INTO `lang_definitions` VALUES (17331, 1992, 14, 'Sekarang dicetak $ stmt_count pernyataan; tagihan tidak akan diupdate.');
INSERT INTO `lang_definitions` VALUES (17332, 1993, 14, 'NPI');
INSERT INTO `lang_definitions` VALUES (17333, 1994, 14, 'Nomor');
INSERT INTO `lang_definitions` VALUES (17334, 1995, 14, 'Jumlah kolom pada tahun melihat.');
INSERT INTO `lang_definitions` VALUES (17335, 1996, 14, 'Jumlah permainan atau peristiwa terjawab, jika ada');
INSERT INTO `lang_definitions` VALUES (17336, 1998, 14, 'O.A.F.V.');
INSERT INTO `lang_definitions` VALUES (17337, 2004, 14, 'Pekerjaan');
INSERT INTO `lang_definitions` VALUES (17338, 2005, 14, 'Kejadian');
INSERT INTO `lang_definitions` VALUES (17339, 2006, 14, 'Okt.');
INSERT INTO `lang_definitions` VALUES (17340, 2007, 14, 'OD');
INSERT INTO `lang_definitions` VALUES (17341, 2009, 14, 'dari tablet');
INSERT INTO `lang_definitions` VALUES (17342, 2010, 14, 'pada setiap bulan');
INSERT INTO `lang_definitions` VALUES (17343, 2011, 14, 'Catatan OFC');
INSERT INTO `lang_definitions` VALUES (17344, 2012, 14, 'Kantor Catatan');
INSERT INTO `lang_definitions` VALUES (17345, 2014, 14, 'Keturunan');
INSERT INTO `lang_definitions` VALUES (17346, 2015, 14, 'palit');
INSERT INTO `lang_definitions` VALUES (17347, 2016, 14, 'OK');
INSERT INTO `lang_definitions` VALUES (17348, 2018, 14, 'Lama Klien');
INSERT INTO `lang_definitions` VALUES (17349, 2019, 14, 'Lama tidak patah / malunion');
INSERT INTO `lang_definitions` VALUES (17350, 2021, 14, 'batal ke autoassign');
INSERT INTO `lang_definitions` VALUES (17351, 2022, 14, 'di');
INSERT INTO `lang_definitions` VALUES (17352, 2023, 14, 'Di tangan');
INSERT INTO `lang_definitions` VALUES (17353, 2024, 14, 'Pada Urutan');
INSERT INTO `lang_definitions` VALUES (17354, 2025, 14, 'Setelah Anda mengubah sandi, Anda harus login kembali.');
INSERT INTO `lang_definitions` VALUES (17355, 2027, 14, 'Hanya aktif');
INSERT INTO `lang_definitions` VALUES (17356, 2028, 14, 'hanya jika tagihan lokasi');
INSERT INTO `lang_definitions` VALUES (17357, 2029, 14, 'Hanya Nonaktif');
INSERT INTO `lang_definitions` VALUES (17358, 2030, 14, 'Hanya Mine');
INSERT INTO `lang_definitions` VALUES (17359, 2031, 14, 'Mulai Penyakit:');
INSERT INTO `lang_definitions` VALUES (17360, 2032, 14, 'Mulai Ilness:');
INSERT INTO `lang_definitions` VALUES (17361, 2033, 14, 'Mulai bengkak:');
INSERT INTO `lang_definitions` VALUES (17362, 2034, 14, 'Mulai / hosp. tanggal:');
INSERT INTO `lang_definitions` VALUES (17363, 2035, 14, 'Membuka');
INSERT INTO `lang_definitions` VALUES (17364, 2036, 14, 'OpenEMR memerlukan Javascript untuk melakukan otentikasi pengguna.');
INSERT INTO `lang_definitions` VALUES (17365, 2038, 14, 'Pilihan');
INSERT INTO `lang_definitions` VALUES (17366, 2039, 14, 'Opsional');
INSERT INTO `lang_definitions` VALUES (17367, 2041, 14, 'Opsional informasi tentang acara ini');
INSERT INTO `lang_definitions` VALUES (17368, 2044, 14, 'Opsional prosedur kode');
INSERT INTO `lang_definitions` VALUES (17369, 2045, 14, 'Atau');
INSERT INTO `lang_definitions` VALUES (17370, 2049, 14, 'ERA atau meng-upload file:');
INSERT INTO `lang_definitions` VALUES (17371, 2051, 14, 'Oral mucosa pink, tenggorokan jelas');
INSERT INTO `lang_definitions` VALUES (17372, 2052, 14, 'Urutan');
INSERT INTO `lang_definitions` VALUES (17373, 2054, 14, 'Organ cedera');
INSERT INTO `lang_definitions` VALUES (17374, 2055, 14, 'Organisasi');
INSERT INTO `lang_definitions` VALUES (17375, 2056, 14, 'Organisasi');
INSERT INTO `lang_definitions` VALUES (17376, 2057, 14, 'Berorientasi x 3');
INSERT INTO `lang_definitions` VALUES (17377, 2059, 14, 'OROPHARYNX:');
INSERT INTO `lang_definitions` VALUES (17378, 2061, 14, 'OS');
INSERT INTO `lang_definitions` VALUES (17379, 2062, 14, 'Osetoarthritis');
INSERT INTO `lang_definitions` VALUES (17380, 2063, 14, 'Lain');
INSERT INTO `lang_definitions` VALUES (17381, 2064, 14, 'lain');
INSERT INTO `lang_definitions` VALUES (17382, 2065, 14, 'Lainnya (sebutkan)');
INSERT INTO `lang_definitions` VALUES (17383, 2066, 14, 'Program lainnya Federal');
INSERT INTO `lang_definitions` VALUES (17384, 2067, 14, 'Lainnya HCFA');
INSERT INTO `lang_definitions` VALUES (17385, 2068, 14, 'Lainnya cedera di tempat lain tidak ditentukan');
INSERT INTO `lang_definitions` VALUES (17386, 2069, 14, 'lainnya bulan');
INSERT INTO `lang_definitions` VALUES (17387, 2070, 14, 'Federal lainnya Non Program');
INSERT INTO `lang_definitions` VALUES (17388, 2072, 14, 'Gejala lainnya relevan');
INSERT INTO `lang_definitions` VALUES (17389, 2073, 14, 'Gejala lainnya relevan:');
INSERT INTO `lang_definitions` VALUES (17390, 2074, 14, 'Lainnya stres / Over menggunakan cedera');
INSERT INTO `lang_definitions` VALUES (17391, 2075, 14, 'Lainnya Bedah');
INSERT INTO `lang_definitions` VALUES (17392, 2076, 14, 'Lain-lain / Umum Abortion-Terkait');
INSERT INTO `lang_definitions` VALUES (17393, 2078, 14, 'Ottawa Ankle Aturan');
INSERT INTO `lang_definitions` VALUES (17394, 2079, 14, 'Ou');
INSERT INTO `lang_definitions` VALUES (17395, 2082, 14, 'Hasil');
INSERT INTO `lang_definitions` VALUES (17396, 2083, 14, 'Outlook');
INSERT INTO `lang_definitions` VALUES (17397, 2084, 14, 'Overuse');
INSERT INTO `lang_definitions` VALUES (17398, 2086, 14, 'Menimpa HIPAA pilihan');
INSERT INTO `lang_definitions` VALUES (17399, 2089, 14, 'p.c.');
INSERT INTO `lang_definitions` VALUES (17400, 2090, 14, 'p.m.');
INSERT INTO `lang_definitions` VALUES (17401, 2091, 14, 'p.r.n.');
INSERT INTO `lang_definitions` VALUES (17402, 2092, 14, 'Paedeatric');
INSERT INTO `lang_definitions` VALUES (17403, 2094, 14, 'Halaman');
INSERT INTO `lang_definitions` VALUES (17404, 2095, 14, 'Dibayar');
INSERT INTO `lang_definitions` VALUES (17405, 2096, 14, 'Anda dibayar jumlah yang akan mengalokasikan');
INSERT INTO `lang_definitions` VALUES (17406, 2097, 14, 'Dibayar Via');
INSERT INTO `lang_definitions` VALUES (17407, 2100, 14, 'Pap smear');
INSERT INTO `lang_definitions` VALUES (17408, 2102, 14, 'Parse HL7');
INSERT INTO `lang_definitions` VALUES (17409, 2103, 14, 'Mitra');
INSERT INTO `lang_definitions` VALUES (17410, 2104, 14, 'Password');
INSERT INTO `lang_definitions` VALUES (17411, 2105, 14, 'Ubah password');
INSERT INTO `lang_definitions` VALUES (17412, 2107, 14, 'Password untuk SMS Gateway');
INSERT INTO `lang_definitions` VALUES (17413, 2108, 14, 'Password:');
INSERT INTO `lang_definitions` VALUES (17414, 2109, 14, 'Telah Encounters');
INSERT INTO `lang_definitions` VALUES (17415, 2110, 14, 'Telah Encounters dan Dokumen');
INSERT INTO `lang_definitions` VALUES (17416, 2111, 14, 'Paste HL7 Data');
INSERT INTO `lang_definitions` VALUES (17417, 2113, 14, 'Patch');
INSERT INTO `lang_definitions` VALUES (17418, 2114, 14, 'Pasien');
INSERT INTO `lang_definitions` VALUES (17419, 2117, 14, 'Pasien Alergi');
INSERT INTO `lang_definitions` VALUES (17420, 2118, 14, 'Pasien alergi');
INSERT INTO `lang_definitions` VALUES (17421, 2119, 14, 'Penunjukan pasien');
INSERT INTO `lang_definitions` VALUES (17422, 2120, 14, 'Grafik pasien ID');
INSERT INTO `lang_definitions` VALUES (17423, 2121, 14, 'Pasien Checkout');
INSERT INTO `lang_definitions` VALUES (17424, 2122, 14, 'Checkout untuk pasien');
INSERT INTO `lang_definitions` VALUES (17425, 2123, 14, 'Komunikasi pasien dikirim');
INSERT INTO `lang_definitions` VALUES (17426, 2124, 14, 'Pasien Comunication Terkirim');
INSERT INTO `lang_definitions` VALUES (17427, 2125, 14, 'Data pasien');
INSERT INTO `lang_definitions` VALUES (17428, 2126, 14, 'Pasien Dokumen');
INSERT INTO `lang_definitions` VALUES (17429, 2127, 14, 'Pasien Encounter');
INSERT INTO `lang_definitions` VALUES (17430, 2128, 14, 'Pasien Encounter Formulir');
INSERT INTO `lang_definitions` VALUES (17431, 2129, 14, 'Pasien Encounters');
INSERT INTO `lang_definitions` VALUES (17432, 2130, 14, 'Pasien Finder');
INSERT INTO `lang_definitions` VALUES (17433, 2131, 14, 'Sejarah pasien');
INSERT INTO `lang_definitions` VALUES (17434, 2132, 14, 'Sejarah pasien / Gaya Hidup');
INSERT INTO `lang_definitions` VALUES (17435, 2133, 14, 'Pasien ID');
INSERT INTO `lang_definitions` VALUES (17436, 2135, 14, 'Pasien imunisasi');
INSERT INTO `lang_definitions` VALUES (17437, 2137, 14, 'Pasien Asuransi Distribusi');
INSERT INTO `lang_definitions` VALUES (17438, 2138, 14, 'Pasien Asuransi Distribusi Lapor');
INSERT INTO `lang_definitions` VALUES (17439, 2139, 14, 'Isu pasien');
INSERT INTO `lang_definitions` VALUES (17440, 2140, 14, 'Daftar pasien');
INSERT INTO `lang_definitions` VALUES (17441, 2141, 14, 'Masalah pasien Kedokteran');
INSERT INTO `lang_definitions` VALUES (17442, 2142, 14, 'Pasien Pengobatan');
INSERT INTO `lang_definitions` VALUES (17443, 2145, 14, 'Catatan pasien');
INSERT INTO `lang_definitions` VALUES (17444, 2147, 14, 'Jumlah pasien');
INSERT INTO `lang_definitions` VALUES (17445, 2148, 14, 'Pasien Cetakan Lapor');
INSERT INTO `lang_definitions` VALUES (17446, 2149, 14, 'Pasien Rekam Lapor');
INSERT INTO `lang_definitions` VALUES (17447, 2150, 14, 'Pasien Lapor');
INSERT INTO `lang_definitions` VALUES (17448, 2151, 14, 'Permintaan pasien');
INSERT INTO `lang_definitions` VALUES (17449, 2152, 14, 'Aktivitas pasien');
INSERT INTO `lang_definitions` VALUES (17450, 2153, 14, 'Pasien Transaksi');
INSERT INTO `lang_definitions` VALUES (17451, 2155, 14, 'Pasien / klien');
INSERT INTO `lang_definitions` VALUES (17452, 2156, 14, 'Pasien:');
INSERT INTO `lang_definitions` VALUES (17453, 2157, 14, 'Pasien');
INSERT INTO `lang_definitions` VALUES (17454, 2158, 14, 'Membayar');
INSERT INTO `lang_definitions` VALUES (17455, 2159, 14, 'Perhatikan bagian \"Selesai dengan\" checkbox. Setelah asuransi ditandai selesai maka kita akan mulai menanyakan pasien untuk membayar sisa saldo, jika anda gagal untuk menandai semua asuransi yang lengkap, maka jumlah yang tersisa tidak akan dikumpulkan! Juga jika ada keseimbangan bahwa pasien harus bayar, kemudian menetapkan tanggal jatuh tempo dengan tepat, karena hal ini akan mempengaruhi bahasa yang muncul pada pasien pernyataan.');
INSERT INTO `lang_definitions` VALUES (17456, 2160, 14, 'Tanggal Bayar:');
INSERT INTO `lang_definitions` VALUES (17457, 2161, 14, 'Pembayar');
INSERT INTO `lang_definitions` VALUES (17458, 2162, 14, 'Jenis pembayar');
INSERT INTO `lang_definitions` VALUES (17459, 2163, 14, 'Membayar');
INSERT INTO `lang_definitions` VALUES (17460, 2164, 14, 'Pembayaran');
INSERT INTO `lang_definitions` VALUES (17461, 2166, 14, 'Tanggal Pembayaran');
INSERT INTO `lang_definitions` VALUES (17462, 2168, 14, 'Metode Pembayaran');
INSERT INTO `lang_definitions` VALUES (17463, 2169, 14, 'Pembayaran nilai kode');
INSERT INTO `lang_definitions` VALUES (17464, 2170, 14, 'Pembayaran');
INSERT INTO `lang_definitions` VALUES (17465, 2172, 14, 'Panggul dan buttock');
INSERT INTO `lang_definitions` VALUES (17466, 2173, 14, 'Pemphigus');
INSERT INTO `lang_definitions` VALUES (17467, 2174, 14, 'Tertunda');
INSERT INTO `lang_definitions` VALUES (17468, 2176, 14, 'Pennington Firm OpenEMR v');
INSERT INTO `lang_definitions` VALUES (17469, 2177, 14, 'Penyakit bisul perut');
INSERT INTO `lang_definitions` VALUES (17470, 2179, 14, 'Per lubang hidung');
INSERT INTO `lang_definitions` VALUES (17471, 2180, 14, 'per lubang hidung');
INSERT INTO `lang_definitions` VALUES (17472, 2181, 14, 'Per Oris');
INSERT INTO `lang_definitions` VALUES (17473, 2182, 14, 'per oris');
INSERT INTO `lang_definitions` VALUES (17474, 2183, 14, 'Per dubur');
INSERT INTO `lang_definitions` VALUES (17475, 2184, 14, 'per dubur');
INSERT INTO `lang_definitions` VALUES (17476, 2185, 14, 'Berlubang Kanan:');
INSERT INTO `lang_definitions` VALUES (17477, 2186, 14, 'Melakukan pencarian');
INSERT INTO `lang_definitions` VALUES (17478, 2187, 14, 'Lakukan tindakan ini');
INSERT INTO `lang_definitions` VALUES (17479, 2190, 14, 'Apotek');
INSERT INTO `lang_definitions` VALUES (17480, 2191, 14, 'Farmasi');
INSERT INTO `lang_definitions` VALUES (17481, 2193, 14, 'Pheumothorax');
INSERT INTO `lang_definitions` VALUES (17482, 2194, 14, 'Telepon');
INSERT INTO `lang_definitions` VALUES (17483, 2195, 14, 'Daftar panggilan telepon');
INSERT INTO `lang_definitions` VALUES (17484, 2196, 14, 'Nomor Telepon');
INSERT INTO `lang_definitions` VALUES (17485, 2198, 14, 'PHP dikompresi');
INSERT INTO `lang_definitions` VALUES (17486, 2199, 14, 'PHP diekstraksi');
INSERT INTO `lang_definitions` VALUES (17487, 2200, 14, 'php-GACL akses kontrol akan dimatikan');
INSERT INTO `lang_definitions` VALUES (17488, 2201, 14, 'PHP-gacl tidak diinstal');
INSERT INTO `lang_definitions` VALUES (17489, 2202, 14, 'Ujian fisik');
INSERT INTO `lang_definitions` VALUES (17490, 2203, 14, 'Permintaan dokter');
INSERT INTO `lang_definitions` VALUES (17491, 2204, 14, 'Dokter Signature');
INSERT INTO `lang_definitions` VALUES (17492, 2207, 14, 'PID');
INSERT INTO `lang_definitions` VALUES (17493, 2208, 14, 'PID (kobaran penyakit panggul)');
INSERT INTO `lang_definitions` VALUES (17494, 2209, 14, 'Ukuran pil');
INSERT INTO `lang_definitions` VALUES (17495, 2210, 14, 'Pills');
INSERT INTO `lang_definitions` VALUES (17496, 2213, 14, 'Teks Biasa');
INSERT INTO `lang_definitions` VALUES (17497, 2215, 14, 'Rencana Nama');
INSERT INTO `lang_definitions` VALUES (17498, 2216, 14, 'Rencana:');
INSERT INTO `lang_definitions` VALUES (17499, 2217, 14, 'Player');
INSERT INTO `lang_definitions` VALUES (17500, 2218, 14, 'Posisi bermain');
INSERT INTO `lang_definitions` VALUES (17501, 2225, 14, 'Harap jangan menggunakan browser atau menghentikan sementara tombol reload halaman ini, kecuali jika sedang berjalan lebih dari 10 menit berlalu, ini tidak akan menyebabkan proses untuk berhenti pada server dan akan mengkonsumsi sumber daya uneccesary.');
INSERT INTO `lang_definitions` VALUES (17502, 2228, 14, 'Perlu diketahui bahwa hal ini bisa memakan waktu yang cukup lama, hingga beberapa menit, browser Anda mungkin tidak muncul sangat aktif saat ini, tetapi dalam waktu yang tagihan adalah proses yang rumit dan browser web Anda hanya menunggu untuk informasi lebih lanjut.');
INSERT INTO `lang_definitions` VALUES (17503, 2229, 14, 'Harap Catatan: konstan adalah sensitif huruf, dan setiap string diperbolehkan.');
INSERT INTO `lang_definitions` VALUES (17504, 2230, 14, 'Harap hanya menggunakan huruf AZ');
INSERT INTO `lang_definitions` VALUES (17505, 2231, 14, 'Harap hanya menggunakan abjad karakter tanpa spasi');
INSERT INTO `lang_definitions` VALUES (17506, 2232, 14, 'Harap membayar jumlah ini');
INSERT INTO `lang_definitions` VALUES (17507, 2233, 14, 'Silakan pilih salah satu alasan untuk penyesuaian kode');
INSERT INTO `lang_definitions` VALUES (17508, 2234, 14, 'Silakan pilih sebuah event');
INSERT INTO `lang_definitions` VALUES (17509, 2235, 14, 'Silakan pilih halaman yang dikehendaki untuk menyalin atau meneruskan:');
INSERT INTO `lang_definitions` VALUES (17510, 2236, 14, 'PM');
INSERT INTO `lang_definitions` VALUES (17511, 2237, 14, 'Metode pmt');
INSERT INTO `lang_definitions` VALUES (17512, 2243, 14, 'Vaksinasi radang paru-paru');
INSERT INTO `lang_definitions` VALUES (17513, 2244, 14, 'Point of Service (POS)');
INSERT INTO `lang_definitions` VALUES (17514, 2245, 14, 'Kebijakan');
INSERT INTO `lang_definitions` VALUES (17515, 2246, 14, 'Kebijakan Pajak');
INSERT INTO `lang_definitions` VALUES (17516, 2248, 14, 'Polyps');
INSERT INTO `lang_definitions` VALUES (17517, 2250, 14, 'Miskin Appetite');
INSERT INTO `lang_definitions` VALUES (17518, 2251, 14, 'Miskin Sirkulasi');
INSERT INTO `lang_definitions` VALUES (17519, 2252, 14, 'Kurang Pendengaran');
INSERT INTO `lang_definitions` VALUES (17520, 2253, 14, 'Populate tahun dengan melihat acara?');
INSERT INTO `lang_definitions` VALUES (17521, 2254, 14, 'Popup');
INSERT INTO `lang_definitions` VALUES (17522, 2257, 14, 'Kode POS');
INSERT INTO `lang_definitions` VALUES (17523, 2259, 14, 'Pasca bedah');
INSERT INTO `lang_definitions` VALUES (17524, 2260, 14, 'Posting ke akuntansi dan tandai sebagai tagihan');
INSERT INTO `lang_definitions` VALUES (17525, 2261, 14, 'Post-Abortion Care');
INSERT INTO `lang_definitions` VALUES (17526, 2262, 14, 'Post-Abortion Contraception');
INSERT INTO `lang_definitions` VALUES (17527, 2263, 14, 'Post-Abortion Konseling');
INSERT INTO `lang_definitions` VALUES (17528, 2264, 14, 'Post-ikutan Abortion');
INSERT INTO `lang_definitions` VALUES (17529, 2265, 14, 'Pos');
INSERT INTO `lang_definitions` VALUES (17530, 2266, 14, 'Kode Pos');
INSERT INTO `lang_definitions` VALUES (17531, 2268, 14, 'PostCalendar');
INSERT INTO `lang_definitions` VALUES (17532, 2269, 14, 'PostCalendar Administrasi');
INSERT INTO `lang_definitions` VALUES (17533, 2270, 14, 'PostCalendar Pengaturan Kategori');
INSERT INTO `lang_definitions` VALUES (17534, 2271, 14, 'PostCalendar Pengaturan Global');
INSERT INTO `lang_definitions` VALUES (17535, 2272, 14, 'Posted on');
INSERT INTO `lang_definitions` VALUES (17536, 2273, 14, 'Tanggal posting');
INSERT INTO `lang_definitions` VALUES (17537, 2275, 14, 'Praktek');
INSERT INTO `lang_definitions` VALUES (17538, 2277, 14, 'Praktisi');
INSERT INTO `lang_definitions` VALUES (17539, 2278, 14, 'Pra-Abortion Konsultasi');
INSERT INTO `lang_definitions` VALUES (17540, 2279, 14, 'Pra-Abortion Konseling');
INSERT INTO `lang_definitions` VALUES (17541, 2280, 14, 'Pref Cat');
INSERT INTO `lang_definitions` VALUES (17542, 2281, 14, 'Even yang dipilih Kategori');
INSERT INTO `lang_definitions` VALUES (17543, 2282, 14, 'Preferred Language');
INSERT INTO `lang_definitions` VALUES (17544, 2284, 14, 'Preferred Provider Organization (PPO)');
INSERT INTO `lang_definitions` VALUES (17545, 2285, 14, 'Uji preg');
INSERT INTO `lang_definitions` VALUES (17546, 2286, 14, 'Prabayar');
INSERT INTO `lang_definitions` VALUES (17547, 2288, 14, 'Resep Label');
INSERT INTO `lang_definitions` VALUES (17548, 2289, 14, 'Resep');
INSERT INTO `lang_definitions` VALUES (17549, 2290, 14, 'Resep dan Dispensations');
INSERT INTO `lang_definitions` VALUES (17550, 2292, 14, 'Resep dan / atau arahan oleh pakar');
INSERT INTO `lang_definitions` VALUES (17551, 2293, 14, 'Resep Lapor');
INSERT INTO `lang_definitions` VALUES (17552, 2294, 14, 'Resep / Arahan');
INSERT INTO `lang_definitions` VALUES (17553, 2295, 14, 'Mempresentasikan Complaint');
INSERT INTO `lang_definitions` VALUES (17554, 2297, 14, 'Disangka Diagnosis');
INSERT INTO `lang_definitions` VALUES (17555, 2298, 14, 'Disangka diagnosa oleh pakar');
INSERT INTO `lang_definitions` VALUES (17556, 2299, 14, 'Prev');
INSERT INTO `lang_definitions` VALUES (17557, 2300, 14, 'Pratinjau Event');
INSERT INTO `lang_definitions` VALUES (17558, 2301, 14, 'Sebelumnya');
INSERT INTO `lang_definitions` VALUES (17559, 2302, 14, 'Konsultasi sebelumnya');
INSERT INTO `lang_definitions` VALUES (17560, 2303, 14, 'Hari sebelumnya');
INSERT INTO `lang_definitions` VALUES (17561, 2304, 14, 'Sejarah sebelumnya / Skrining');
INSERT INTO `lang_definitions` VALUES (17562, 2305, 14, 'Bulan Sebelumnya');
INSERT INTO `lang_definitions` VALUES (17563, 2306, 14, 'Minggu sebelumnya');
INSERT INTO `lang_definitions` VALUES (17564, 2307, 14, 'Harga');
INSERT INTO `lang_definitions` VALUES (17565, 2309, 14, 'Tingkat harga');
INSERT INTO `lang_definitions` VALUES (17566, 2310, 14, 'Tingkat harga:');
INSERT INTO `lang_definitions` VALUES (17567, 2312, 14, 'Utama');
INSERT INTO `lang_definitions` VALUES (17568, 2313, 14, 'Utama Ins');
INSERT INTO `lang_definitions` VALUES (17569, 2314, 14, 'Dasar Asuransi');
INSERT INTO `lang_definitions` VALUES (17570, 2315, 14, 'Data dasar Asuransi');
INSERT INTO `lang_definitions` VALUES (17571, 2316, 14, 'Asuransi utama Provider');
INSERT INTO `lang_definitions` VALUES (17572, 2317, 14, 'Utama Provider');
INSERT INTO `lang_definitions` VALUES (17573, 2318, 14, 'Cetak');
INSERT INTO `lang_definitions` VALUES (17574, 2325, 14, 'Beberapa Cetak');
INSERT INTO `lang_definitions` VALUES (17575, 2332, 14, 'Cetak Shot Rekam');
INSERT INTO `lang_definitions` VALUES (17576, 2334, 14, 'Mencetak catatan ini');
INSERT INTO `lang_definitions` VALUES (17577, 2335, 14, 'Catatan ini mencetak');
INSERT INTO `lang_definitions` VALUES (17578, 2337, 14, 'Lihat Cetak');
INSERT INTO `lang_definitions` VALUES (17579, 2338, 14, 'dicetak');
INSERT INTO `lang_definitions` VALUES (17580, 2339, 14, 'Versi cetak');
INSERT INTO `lang_definitions` VALUES (17581, 2341, 14, 'Mencetak hasil:');
INSERT INTO `lang_definitions` VALUES (17582, 2342, 14, 'Percetakan dilewati; melihat hasil tes di');
INSERT INTO `lang_definitions` VALUES (17583, 2345, 14, 'Prioritas');
INSERT INTO `lang_definitions` VALUES (17584, 2346, 14, 'Swasta');
INSERT INTO `lang_definitions` VALUES (17585, 2349, 14, 'Masalah / Isu');
INSERT INTO `lang_definitions` VALUES (17586, 2350, 14, 'Prosedur');
INSERT INTO `lang_definitions` VALUES (17587, 2351, 14, 'Prosedur');
INSERT INTO `lang_definitions` VALUES (17588, 2352, 14, 'Proses');
INSERT INTO `lang_definitions` VALUES (17589, 2353, 14, 'Pengolahan');
INSERT INTO `lang_definitions` VALUES (17590, 2354, 14, 'Produk');
INSERT INTO `lang_definitions` VALUES (17591, 2355, 14, 'Prof');
INSERT INTO `lang_definitions` VALUES (17592, 2357, 14, 'Prostate Cancer');
INSERT INTO `lang_definitions` VALUES (17593, 2358, 14, 'Prostate Exam');
INSERT INTO `lang_definitions` VALUES (17594, 2359, 14, 'Masalah prostata');
INSERT INTO `lang_definitions` VALUES (17595, 2360, 14, 'Prostata w / o enlrgmt, nodules, tender');
INSERT INTO `lang_definitions` VALUES (17596, 2361, 14, 'Selular');
INSERT INTO `lang_definitions` VALUES (17597, 2362, 14, 'Selular Pajak');
INSERT INTO `lang_definitions` VALUES (17598, 2363, 14, 'Provider:');
INSERT INTO `lang_definitions` VALUES (17599, 2364, 14, 'Selular');
INSERT INTO `lang_definitions` VALUES (17600, 2365, 14, 'Selular NPI');
INSERT INTO `lang_definitions` VALUES (17601, 2366, 14, 'Prv');
INSERT INTO `lang_definitions` VALUES (17602, 2367, 14, 'PSA');
INSERT INTO `lang_definitions` VALUES (17603, 2378, 14, 'Pt%');
INSERT INTO `lang_definitions` VALUES (17604, 2379, 14, 'Catatan pt');
INSERT INTO `lang_definitions` VALUES (17605, 2380, 14, 'Pt Catatan / Auth');
INSERT INTO `lang_definitions` VALUES (17606, 2381, 14, 'Pt lebih');
INSERT INTO `lang_definitions` VALUES (17607, 2382, 14, 'Pt Dibayar');
INSERT INTO `lang_definitions` VALUES (17608, 2383, 14, 'Pt pengembalian dana');
INSERT INTO `lang_definitions` VALUES (17609, 2384, 14, 'Pt dirilis');
INSERT INTO `lang_definitions` VALUES (17610, 2385, 14, 'Pt Lapor');
INSERT INTO `lang_definitions` VALUES (17611, 2386, 14, 'PT Siswa, atau biarkan kosong');
INSERT INTO `lang_definitions` VALUES (17612, 2395, 14, 'Publik');
INSERT INTO `lang_definitions` VALUES (17613, 2396, 14, 'Pulmonary');
INSERT INTO `lang_definitions` VALUES (17614, 2398, 14, 'q.3h');
INSERT INTO `lang_definitions` VALUES (17615, 2399, 14, 'q.4h');
INSERT INTO `lang_definitions` VALUES (17616, 2400, 14, 'q.5h');
INSERT INTO `lang_definitions` VALUES (17617, 2401, 14, 'q.6h');
INSERT INTO `lang_definitions` VALUES (17618, 2402, 14, 'q.8h');
INSERT INTO `lang_definitions` VALUES (17619, 2403, 14, 'q.d.');
INSERT INTO `lang_definitions` VALUES (17620, 2404, 14, 'q.i.d.');
INSERT INTO `lang_definitions` VALUES (17621, 2405, 14, 'QOH');
INSERT INTO `lang_definitions` VALUES (17622, 2406, 14, 'Qty');
INSERT INTO `lang_definitions` VALUES (17623, 2408, 14, 'Kualitas');
INSERT INTO `lang_definitions` VALUES (17624, 2409, 14, 'Kuantitas');
INSERT INTO `lang_definitions` VALUES (17625, 2410, 14, 'Kuantitas untuk NDC');
INSERT INTO `lang_definitions` VALUES (17626, 2411, 14, 'Kuantitas Pada Tangan');
INSERT INTO `lang_definitions` VALUES (17627, 2412, 14, 'Antrian untuk HCFA batch processing');
INSERT INTO `lang_definitions` VALUES (17628, 2413, 14, 'Antrian untuk HCFA batch pengolahan dan pencetakan');
INSERT INTO `lang_definitions` VALUES (17629, 2414, 14, 'Antrian untuk UB-92 batch processing');
INSERT INTO `lang_definitions` VALUES (17630, 2415, 14, 'Antrian untuk UB-92 batch pengolahan dan pencetakan');
INSERT INTO `lang_definitions` VALUES (17631, 2416, 14, 'Antri');
INSERT INTO `lang_definitions` VALUES (17632, 2417, 14, 'Antri Kegiatan Administrasi');
INSERT INTO `lang_definitions` VALUES (17633, 2418, 14, 'Antri untuk');
INSERT INTO `lang_definitions` VALUES (17634, 2419, 14, 'Antri Submissions Administrasi');
INSERT INTO `lang_definitions` VALUES (17635, 2421, 14, 'Ras');
INSERT INTO `lang_definitions` VALUES (17636, 2422, 14, 'Race / Ethnicity');
INSERT INTO `lang_definitions` VALUES (17637, 2423, 14, 'Radio');
INSERT INTO `lang_definitions` VALUES (17638, 2425, 14, 'Rashes');
INSERT INTO `lang_definitions` VALUES (17639, 2426, 14, 'Tingkat');
INSERT INTO `lang_definitions` VALUES (17640, 2428, 14, 'Kembali dibuka');
INSERT INTO `lang_definitions` VALUES (17641, 2429, 14, 'Reaksi');
INSERT INTO `lang_definitions` VALUES (17642, 2430, 14, 'Nama');
INSERT INTO `lang_definitions` VALUES (17643, 2431, 14, 'Alasan');
INSERT INTO `lang_definitions` VALUES (17644, 2432, 14, 'Alasan arahan');
INSERT INTO `lang_definitions` VALUES (17645, 2434, 14, 'Alasan / Formulir');
INSERT INTO `lang_definitions` VALUES (17646, 2435, 14, 'Terima');
INSERT INTO `lang_definitions` VALUES (17647, 2436, 14, 'Terima untuk Pembayaran');
INSERT INTO `lang_definitions` VALUES (17648, 2437, 14, 'Terima Generated');
INSERT INTO `lang_definitions` VALUES (17649, 2438, 14, 'Penerimaan oleh Metode Pembayaran Lapor');
INSERT INTO `lang_definitions` VALUES (17650, 2439, 14, 'Penerimaan Aktivitas');
INSERT INTO `lang_definitions` VALUES (17651, 2440, 14, 'Diterima');
INSERT INTO `lang_definitions` VALUES (17652, 2441, 14, 'Oleh diterima');
INSERT INTO `lang_definitions` VALUES (17653, 2442, 14, 'Faks yang diterima');
INSERT INTO `lang_definitions` VALUES (17654, 2443, 14, 'Penerima');
INSERT INTO `lang_definitions` VALUES (17655, 2444, 14, 'Penerima ID');
INSERT INTO `lang_definitions` VALUES (17656, 2447, 14, 'Rekomendasi');
INSERT INTO `lang_definitions` VALUES (17657, 2449, 14, 'Rekomendasi oleh pakar');
INSERT INTO `lang_definitions` VALUES (17658, 2450, 14, 'Rekam Pembayaran');
INSERT INTO `lang_definitions` VALUES (17659, 2453, 14, 'Ujian dubur');
INSERT INTO `lang_definitions` VALUES (17660, 2454, 14, 'rectally');
INSERT INTO `lang_definitions` VALUES (17661, 2456, 14, 'dikurangi:');
INSERT INTO `lang_definitions` VALUES (17662, 2457, 14, 'Rujuk');
INSERT INTO `lang_definitions` VALUES (17663, 2458, 14, 'Dengan merujuk');
INSERT INTO `lang_definitions` VALUES (17664, 2459, 14, 'Tanggal merujuk');
INSERT INTO `lang_definitions` VALUES (17665, 2460, 14, 'Untuk lihat');
INSERT INTO `lang_definitions` VALUES (17666, 2464, 14, 'Arahan');
INSERT INTO `lang_definitions` VALUES (17667, 2466, 14, 'Arahan Kartu');
INSERT INTO `lang_definitions` VALUES (17668, 2467, 14, 'Tanggal arahan');
INSERT INTO `lang_definitions` VALUES (17669, 2470, 14, 'Sumber rujukan');
INSERT INTO `lang_definitions` VALUES (17670, 2471, 14, 'Untuk arahan');
INSERT INTO `lang_definitions` VALUES (17671, 2472, 14, 'Arahan');
INSERT INTO `lang_definitions` VALUES (17672, 2473, 14, 'Arahan Lapor');
INSERT INTO `lang_definitions` VALUES (17673, 2474, 14, 'Sebagaimana dimaksud oleh');
INSERT INTO `lang_definitions` VALUES (17674, 2475, 14, 'Oleh dirujuk');
INSERT INTO `lang_definitions` VALUES (17675, 2477, 14, 'Referer');
INSERT INTO `lang_definitions` VALUES (17676, 2478, 14, 'Referer Diagnosis');
INSERT INTO `lang_definitions` VALUES (17677, 2480, 14, 'Merujuk dokter dan praktek');
INSERT INTO `lang_definitions` VALUES (17678, 2482, 14, 'Refills');
INSERT INTO `lang_definitions` VALUES (17679, 2483, 14, 'refills');
INSERT INTO `lang_definitions` VALUES (17680, 2484, 14, 'Reflexes normal');
INSERT INTO `lang_definitions` VALUES (17681, 2485, 14, 'Refresh');
INSERT INTO `lang_definitions` VALUES (17682, 2486, 14, 'reg_re');
INSERT INTO `lang_definitions` VALUES (17683, 2488, 14, 'Terdaftar');
INSERT INTO `lang_definitions` VALUES (17684, 2489, 14, 'terdaftar');
INSERT INTO `lang_definitions` VALUES (17685, 2490, 14, 'Tanggal registrasi');
INSERT INTO `lang_definitions` VALUES (17686, 2492, 14, 'Rehabilitasi');
INSERT INTO `lang_definitions` VALUES (17687, 2493, 14, 'Untuk berhubungan');
INSERT INTO `lang_definitions` VALUES (17688, 2494, 14, 'Terkait');
INSERT INTO `lang_definitions` VALUES (17689, 2496, 14, 'Hubungan');
INSERT INTO `lang_definitions` VALUES (17690, 2497, 14, 'Saudara');
INSERT INTO `lang_definitions` VALUES (17691, 2498, 14, 'Relay Kesehatan mandat yang hilang dari account pengguna.');
INSERT INTO `lang_definitions` VALUES (17692, 2499, 14, 'Kesehatan relay ID');
INSERT INTO `lang_definitions` VALUES (17693, 2500, 14, 'Agama');
INSERT INTO `lang_definitions` VALUES (17694, 2501, 14, 'Relogin');
INSERT INTO `lang_definitions` VALUES (17695, 2503, 14, 'Hapus Grup');
INSERT INTO `lang_definitions` VALUES (17696, 2507, 14, 'Rendering');
INSERT INTO `lang_definitions` VALUES (17697, 2508, 14, 'Rendering Provider');
INSERT INTO `lang_definitions` VALUES (17698, 2509, 14, 'Rendering Provider Pajak');
INSERT INTO `lang_definitions` VALUES (17699, 2510, 14, 'Pada menyusun ulang');
INSERT INTO `lang_definitions` VALUES (17700, 2511, 14, 'Mengulangi Info:');
INSERT INTO `lang_definitions` VALUES (17701, 2512, 14, 'Repeats');
INSERT INTO `lang_definitions` VALUES (17702, 2513, 14, 'Balas Tanggal');
INSERT INTO `lang_definitions` VALUES (17703, 2514, 14, 'Dari reply');
INSERT INTO `lang_definitions` VALUES (17704, 2515, 14, 'Lapor');
INSERT INTO `lang_definitions` VALUES (17705, 2518, 14, 'Laporan');
INSERT INTO `lang_definitions` VALUES (17706, 2519, 14, 'Permintaan diabaikan - mengklaim telah menjalankan proses!');
INSERT INTO `lang_definitions` VALUES (17707, 2520, 14, 'Diminta Layanan');
INSERT INTO `lang_definitions` VALUES (17708, 2521, 14, 'Diperlukan');
INSERT INTO `lang_definitions` VALUES (17709, 2530, 14, 'Pernafasan upaya unlabored');
INSERT INTO `lang_definitions` VALUES (17710, 2532, 14, 'Pelatihan Dibatasi');
INSERT INTO `lang_definitions` VALUES (17711, 2533, 14, 'Hasil');
INSERT INTO `lang_definitions` VALUES (17712, 2534, 14, 'Hasil Pencarian Untuk Ditemukan');
INSERT INTO `lang_definitions` VALUES (17713, 2535, 14, 'Retinal Ujian');
INSERT INTO `lang_definitions` VALUES (17714, 2536, 14, 'Retracted Kanan:');
INSERT INTO `lang_definitions` VALUES (17715, 2537, 14, 'Kembali');
INSERT INTO `lang_definitions` VALUES (17716, 2539, 14, 'Kembali Nilai');
INSERT INTO `lang_definitions` VALUES (17717, 2540, 14, 'Kembali Kunjungi');
INSERT INTO `lang_definitions` VALUES (17718, 2541, 14, 'Kembali ke Putar');
INSERT INTO `lang_definitions` VALUES (17719, 2542, 14, 'Tinjauan PMH:');
INSERT INTO `lang_definitions` VALUES (17720, 2544, 14, 'Tinjauan Sistem Cek');
INSERT INTO `lang_definitions` VALUES (17721, 2545, 14, 'Revisi');
INSERT INTO `lang_definitions` VALUES (17722, 2546, 14, 'Rheumotoid Radang Sendi');
INSERT INTO `lang_definitions` VALUES (17723, 2547, 14, 'Kanan');
INSERT INTO `lang_definitions` VALUES (17724, 2549, 14, 'telinga kanan');
INSERT INTO `lang_definitions` VALUES (17725, 2550, 14, 'Right:');
INSERT INTO `lang_definitions` VALUES (17726, 2551, 14, 'Nada di Ears');
INSERT INTO `lang_definitions` VALUES (17727, 2553, 14, 'Faktor-faktor risiko');
INSERT INTO `lang_definitions` VALUES (17728, 2554, 14, 'Tingkat risiko');
INSERT INTO `lang_definitions` VALUES (17729, 2555, 14, 'RLL:');
INSERT INTO `lang_definitions` VALUES (17730, 2556, 14, 'ROM');
INSERT INTO `lang_definitions` VALUES (17731, 2557, 14, 'Roster');
INSERT INTO `lang_definitions` VALUES (17732, 2558, 14, 'Rute');
INSERT INTO `lang_definitions` VALUES (17733, 2559, 14, 'Baris');
INSERT INTO `lang_definitions` VALUES (17734, 2560, 14, 'RRR tanpa Mor');
INSERT INTO `lang_definitions` VALUES (17735, 2561, 14, 'Menggilap:');
INSERT INTO `lang_definitions` VALUES (17736, 2562, 14, 'Rubs:');
INSERT INTO `lang_definitions` VALUES (17737, 2563, 14, 'Menjalankan Perintah:');
INSERT INTO `lang_definitions` VALUES (17738, 2564, 14, 'Perpecahan');
INSERT INTO `lang_definitions` VALUES (17739, 2565, 14, 'Russian');
INSERT INTO `lang_definitions` VALUES (17740, 2566, 14, 'Rx');
INSERT INTO `lang_definitions` VALUES (17741, 2567, 14, 'RX');
INSERT INTO `lang_definitions` VALUES (17742, 2568, 14, 'S');
INSERT INTO `lang_definitions` VALUES (17743, 2569, 14, 'S.S.');
INSERT INTO `lang_definitions` VALUES (17744, 2570, 14, 'S3:');
INSERT INTO `lang_definitions` VALUES (17745, 2571, 14, 'S4:');
INSERT INTO `lang_definitions` VALUES (17746, 2572, 14, 'SA * * Untuk membaca lisensi baca docs / license.txt atau kunjungi http://www.gnu.org/copyleft/gpl.html * * * / //============ ================================================== =========== / /');
INSERT INTO `lang_definitions` VALUES (17747, 2573, 14, 'Penjualan');
INSERT INTO `lang_definitions` VALUES (17748, 2574, 14, 'Penjualan Item');
INSERT INTO `lang_definitions` VALUES (17749, 2575, 14, 'Penjualan Produk Lapor');
INSERT INTO `lang_definitions` VALUES (17750, 2576, 14, 'Hari sama');
INSERT INTO `lang_definitions` VALUES (17751, 2578, 14, 'Jenis sanksi');
INSERT INTO `lang_definitions` VALUES (17752, 2579, 14, 'Sabtu');
INSERT INTO `lang_definitions` VALUES (17753, 2580, 14, 'Sabtu & Minggu');
INSERT INTO `lang_definitions` VALUES (17754, 2581, 14, 'Sabtu');
INSERT INTO `lang_definitions` VALUES (17755, 2582, 14, 'Simpan');
INSERT INTO `lang_definitions` VALUES (17756, 2583, 14, 'Menyimpan dan mengeluarkan');
INSERT INTO `lang_definitions` VALUES (17757, 2584, 14, 'Simpan sebagai Baru');
INSERT INTO `lang_definitions` VALUES (17758, 2585, 14, 'Simpan Perubahan');
INSERT INTO `lang_definitions` VALUES (17759, 2587, 14, 'Simpan imunisasi');
INSERT INTO `lang_definitions` VALUES (17760, 2592, 14, 'Simpan Pasien Demografi');
INSERT INTO `lang_definitions` VALUES (17761, 2594, 14, 'Simpan Transaksi');
INSERT INTO `lang_definitions` VALUES (17762, 2595, 14, 'Discan');
INSERT INTO `lang_definitions` VALUES (17763, 2596, 14, 'Discan Encounter Catatan');
INSERT INTO `lang_definitions` VALUES (17764, 2597, 14, 'Dalam scanner');
INSERT INTO `lang_definitions` VALUES (17765, 2598, 14, 'Jadwal');
INSERT INTO `lang_definitions` VALUES (17766, 2600, 14, 'CATATAN SEKOLAH');
INSERT INTO `lang_definitions` VALUES (17767, 2601, 14, 'Scoliosis');
INSERT INTO `lang_definitions` VALUES (17768, 2602, 14, 'SE');
INSERT INTO `lang_definitions` VALUES (17769, 2603, 14, 'SE Alamat');
INSERT INTO `lang_definitions` VALUES (17770, 2604, 14, 'SE Kota');
INSERT INTO `lang_definitions` VALUES (17771, 2605, 14, 'SE Negara');
INSERT INTO `lang_definitions` VALUES (17772, 2610, 14, 'Mencari');
INSERT INTO `lang_definitions` VALUES (17773, 2611, 14, 'mencari');
INSERT INTO `lang_definitions` VALUES (17774, 2612, 14, 'cari lagi');
INSERT INTO `lang_definitions` VALUES (17775, 2613, 14, 'Search by:');
INSERT INTO `lang_definitions` VALUES (17776, 2614, 14, 'Mencari:');
INSERT INTO `lang_definitions` VALUES (17777, 2615, 14, 'Cari atau Tambah Pasien');
INSERT INTO `lang_definitions` VALUES (17778, 2616, 14, 'Hasil Pencarian:');
INSERT INTO `lang_definitions` VALUES (17779, 2618, 14, 'Cari Event');
INSERT INTO `lang_definitions` VALUES (17780, 2619, 14, 'Cari / Tambahkan asuransi');
INSERT INTO `lang_definitions` VALUES (17781, 2623, 14, 'Gunakan Seatbelt');
INSERT INTO `lang_definitions` VALUES (17782, 2624, 14, 'Kedua');
INSERT INTO `lang_definitions` VALUES (17783, 2625, 14, 'Sekunder');
INSERT INTO `lang_definitions` VALUES (17784, 2626, 14, 'Sekunder Asuransi');
INSERT INTO `lang_definitions` VALUES (17785, 2627, 14, 'Data sekunder Asuransi');
INSERT INTO `lang_definitions` VALUES (17786, 2628, 14, 'Sekunder Asuransi Provider');
INSERT INTO `lang_definitions` VALUES (17787, 2629, 14, 'Lihat Semua');
INSERT INTO `lang_definitions` VALUES (17788, 2630, 14, 'Lihat kewenangan');
INSERT INTO `lang_definitions` VALUES (17789, 2633, 14, 'Terlihat sejak');
INSERT INTO `lang_definitions` VALUES (17790, 2635, 14, 'Sel');
INSERT INTO `lang_definitions` VALUES (17791, 2636, 14, 'Pilih');
INSERT INTO `lang_definitions` VALUES (17792, 2637, 14, 'Pilih Semua');
INSERT INTO `lang_definitions` VALUES (17793, 2646, 14, 'Cukup Bayar');
INSERT INTO `lang_definitions` VALUES (17794, 2647, 14, 'Kirim dalam proses');
INSERT INTO `lang_definitions` VALUES (17795, 2649, 14, 'Pengirim');
INSERT INTO `lang_definitions` VALUES (17796, 2650, 14, 'ID');
INSERT INTO `lang_definitions` VALUES (17797, 2654, 14, 'Sensitivity:');
INSERT INTO `lang_definitions` VALUES (17798, 2655, 14, 'Sensory ujian normal');
INSERT INTO `lang_definitions` VALUES (17799, 2656, 14, 'Berhasil dikirim');
INSERT INTO `lang_definitions` VALUES (17800, 2657, 14, 'dikirim ke printer.');
INSERT INTO `lang_definitions` VALUES (17801, 2658, 14, 'Dipisahkan');
INSERT INTO `lang_definitions` VALUES (17802, 2659, 14, 'September');
INSERT INTO `lang_definitions` VALUES (17803, 2662, 14, 'Layanan Tanggal:');
INSERT INTO `lang_definitions` VALUES (17804, 2663, 14, 'Lokasi Layanan');
INSERT INTO `lang_definitions` VALUES (17805, 2664, 14, 'Layanan yang disediakan oleh pakar');
INSERT INTO `lang_definitions` VALUES (17806, 2665, 14, 'Layanan');
INSERT INTO `lang_definitions` VALUES (17807, 2666, 14, 'Layanan oleh Kategori');
INSERT INTO `lang_definitions` VALUES (17808, 2668, 14, 'Pelayanan');
INSERT INTO `lang_definitions` VALUES (17809, 2669, 14, 'Pengaturan');
INSERT INTO `lang_definitions` VALUES (17810, 2670, 14, 'Parah Migraine');
INSERT INTO `lang_definitions` VALUES (17811, 2671, 14, 'Kerasnya dari Rasa');
INSERT INTO `lang_definitions` VALUES (17812, 2672, 14, 'Kerasnya dari Rasa:');
INSERT INTO `lang_definitions` VALUES (17813, 2673, 14, 'Sex');
INSERT INTO `lang_definitions` VALUES (17814, 2674, 14, 'Penyakit seksual');
INSERT INTO `lang_definitions` VALUES (17815, 2675, 14, 'Berbagi');
INSERT INTO `lang_definitions` VALUES (17816, 2676, 14, 'Sesak Nafas');
INSERT INTO `lang_definitions` VALUES (17817, 2681, 14, 'harus seperti NNNNN-nnnn-nn');
INSERT INTO `lang_definitions` VALUES (17818, 2682, 14, 'Bahu');
INSERT INTO `lang_definitions` VALUES (17819, 2683, 14, 'Bahu + tulang selangka');
INSERT INTO `lang_definitions` VALUES (17820, 2684, 14, 'Masalah bahu');
INSERT INTO `lang_definitions` VALUES (17821, 2685, 14, 'Pertunjukan');
INSERT INTO `lang_definitions` VALUES (17822, 2686, 14, 'Menunjukkan sebagai Sibuk');
INSERT INTO `lang_definitions` VALUES (17823, 2687, 14, 'Hanya menunjukkan Authorized');
INSERT INTO `lang_definitions` VALUES (17824, 2688, 14, 'Tampilkan Rincian');
INSERT INTO `lang_definitions` VALUES (17825, 2689, 14, 'Tampilkan teks pada acara hovering Gunaka mouse di atas?');
INSERT INTO `lang_definitions` VALUES (17826, 2690, 14, 'Menunjukkan bagaimana berbagai aktivitas di halaman admin?');
INSERT INTO `lang_definitions` VALUES (17827, 2692, 14, 'Perlihatkan Lapor');
INSERT INTO `lang_definitions` VALUES (17828, 2693, 14, 'Cari Tampilkan / mengirimkan link di blok?');
INSERT INTO `lang_definitions` VALUES (17829, 2694, 14, 'Hanya menunjukkan Unbilled');
INSERT INTO `lang_definitions` VALUES (17830, 2695, 14, 'Saudara kandung');
INSERT INTO `lang_definitions` VALUES (17831, 2696, 14, 'Sel sabit');
INSERT INTO `lang_definitions` VALUES (17832, 2698, 14, 'Sigmoid / Colonoscopy');
INSERT INTO `lang_definitions` VALUES (17833, 2699, 14, 'Tanda tangan');
INSERT INTO `lang_definitions` VALUES (17834, 2700, 14, 'Signature:');
INSERT INTO `lang_definitions` VALUES (17835, 2702, 14, 'Signifikan pembengkakan:');
INSERT INTO `lang_definitions` VALUES (17836, 2705, 14, 'Tunggal');
INSERT INTO `lang_definitions` VALUES (17837, 2707, 14, 'Bedah Sinus');
INSERT INTO `lang_definitions` VALUES (17838, 2708, 14, 'Sinus kelembutan:');
INSERT INTO `lang_definitions` VALUES (17839, 2709, 14, 'Sinusitis');
INSERT INTO `lang_definitions` VALUES (17840, 2710, 14, 'Ukuran');
INSERT INTO `lang_definitions` VALUES (17841, 2712, 14, 'Ukuran / Daftar');
INSERT INTO `lang_definitions` VALUES (17842, 2713, 14, 'Kulit');
INSERT INTO `lang_definitions` VALUES (17843, 2719, 14, 'Pola tidur');
INSERT INTO `lang_definitions` VALUES (17844, 2720, 14, 'Tidur');
INSERT INTO `lang_definitions` VALUES (17845, 2721, 14, 'Slovak');
INSERT INTO `lang_definitions` VALUES (17846, 2722, 14, 'Sm hutang w / o');
INSERT INTO `lang_definitions` VALUES (17847, 2723, 14, 'Smarty Cache telah dikosongkan');
INSERT INTO `lang_definitions` VALUES (17848, 2724, 14, 'SMS Gateway');
INSERT INTO `lang_definitions` VALUES (17849, 2725, 14, 'SMS Gateway API kunci');
INSERT INTO `lang_definitions` VALUES (17850, 2726, 14, 'SMS Notifikasi');
INSERT INTO `lang_definitions` VALUES (17851, 2727, 14, 'Mengirim SMS sebelum');
INSERT INTO `lang_definitions` VALUES (17852, 2728, 14, 'SMS Teks, bermanfaat Tag: *** NAMA ***, *** *** PROVIDER, TANGGAL *** ***, *** *** STARTTIME, *** *** ENDTIME <br> yakni terhormat *** NAMA ***');
INSERT INTO `lang_definitions` VALUES (17853, 2729, 14, 'SMS / Email Alert Pengaturan');
INSERT INTO `lang_definitions` VALUES (17854, 2733, 14, 'Sejarah sosial:');
INSERT INTO `lang_definitions` VALUES (17855, 2735, 14, 'solusi');
INSERT INTO `lang_definitions` VALUES (17856, 2737, 14, 'Beberapa kewenangan yang tidak ditampilkan. Klik di sini untuk melihat semua');
INSERT INTO `lang_definitions` VALUES (17857, 2738, 14, 'Beberapa kode yang tidak ditampilkan.');
INSERT INTO `lang_definitions` VALUES (17858, 2739, 14, 'Beberapa menemukan tidak ditampilkan. Klik di sini untuk melihat semua.');
INSERT INTO `lang_definitions` VALUES (17859, 2741, 14, 'beberapa kata');
INSERT INTO `lang_definitions` VALUES (17860, 2743, 14, 'Urutkan berdasar');
INSERT INTO `lang_definitions` VALUES (17861, 2751, 14, 'Sumber');
INSERT INTO `lang_definitions` VALUES (17862, 2752, 14, 'Sumber tersebut tidak ada untuk kode');
INSERT INTO `lang_definitions` VALUES (17863, 2753, 14, 'Sumber:');
INSERT INTO `lang_definitions` VALUES (17864, 2754, 14, 'Spanyol');
INSERT INTO `lang_definitions` VALUES (17865, 2756, 14, 'Specialty');
INSERT INTO `lang_definitions` VALUES (17866, 2758, 14, 'Specialty:');
INSERT INTO `lang_definitions` VALUES (17867, 2759, 14, 'Spesifik');
INSERT INTO `lang_definitions` VALUES (17868, 2760, 14, 'Layanan khusus');
INSERT INTO `lang_definitions` VALUES (17869, 2761, 14, 'Ucapan dikte');
INSERT INTO `lang_definitions` VALUES (17870, 2762, 14, 'Spermicides');
INSERT INTO `lang_definitions` VALUES (17871, 2763, 14, 'Splenectomy');
INSERT INTO `lang_definitions` VALUES (17872, 2764, 14, 'Pasangan');
INSERT INTO `lang_definitions` VALUES (17873, 2766, 14, 'Dahak:');
INSERT INTO `lang_definitions` VALUES (17874, 2767, 14, 'SQ');
INSERT INTO `lang_definitions` VALUES (17875, 2768, 14, 'Squad');
INSERT INTO `lang_definitions` VALUES (17876, 2770, 14, 'Squads');
INSERT INTO `lang_definitions` VALUES (17877, 2772, 14, 'SRH - Keluarga Berencana');
INSERT INTO `lang_definitions` VALUES (17878, 2773, 14, 'SRH Non Keluarga Berencana');
INSERT INTO `lang_definitions` VALUES (17879, 2774, 14, 'SRH Arahan');
INSERT INTO `lang_definitions` VALUES (17880, 2775, 14, 'SRH Kunjungi Formulir');
INSERT INTO `lang_definitions` VALUES (17881, 2776, 14, 'SS');
INSERT INTO `lang_definitions` VALUES (17882, 2777, 14, 'SSN');
INSERT INTO `lang_definitions` VALUES (17883, 2778, 14, 'Stabilitas');
INSERT INTO `lang_definitions` VALUES (17884, 2779, 14, 'Standar');
INSERT INTO `lang_definitions` VALUES (17885, 2780, 14, 'Mulai');
INSERT INTO `lang_definitions` VALUES (17886, 2781, 14, 'Start (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (17887, 2782, 14, 'Tanggal Mulai');
INSERT INTO `lang_definitions` VALUES (17888, 2783, 14, 'Tanggal Mulai saat ini Klinik');
INSERT INTO `lang_definitions` VALUES (17889, 2784, 14, 'Tanggal Mulai:');
INSERT INTO `lang_definitions` VALUES (17890, 2785, 14, 'Mulai tanggal:');
INSERT INTO `lang_definitions` VALUES (17891, 2786, 14, 'Waktu mulai');
INSERT INTO `lang_definitions` VALUES (17892, 2787, 14, 'Tanggal mulai');
INSERT INTO `lang_definitions` VALUES (17893, 2788, 14, 'stat');
INSERT INTO `lang_definitions` VALUES (17894, 2789, 14, 'Menyatakan');
INSERT INTO `lang_definitions` VALUES (17895, 2791, 14, 'Negara / daerah');
INSERT INTO `lang_definitions` VALUES (17896, 2792, 14, 'Negara / Parish');
INSERT INTO `lang_definitions` VALUES (17897, 2793, 14, 'Statistik');
INSERT INTO `lang_definitions` VALUES (17898, 2794, 14, 'Status');
INSERT INTO `lang_definitions` VALUES (17899, 2795, 14, 'Status');
INSERT INTO `lang_definitions` VALUES (17900, 2797, 14, 'STD / AIDS Couns');
INSERT INTO `lang_definitions` VALUES (17901, 2798, 14, 'Stength dan Conditioning');
INSERT INTO `lang_definitions` VALUES (17902, 2799, 14, 'Kaku sendi');
INSERT INTO `lang_definitions` VALUES (17903, 2801, 14, 'Stomach Pains');
INSERT INTO `lang_definitions` VALUES (17904, 2802, 14, 'Strain dari otot');
INSERT INTO `lang_definitions` VALUES (17905, 2804, 14, 'Jalan');
INSERT INTO `lang_definitions` VALUES (17906, 2806, 14, 'Jalan dan Nomor');
INSERT INTO `lang_definitions` VALUES (17907, 2807, 14, 'Kekuatan');
INSERT INTO `lang_definitions` VALUES (17908, 2808, 14, 'Strep Throat');
INSERT INTO `lang_definitions` VALUES (17909, 2809, 14, 'Stress pematahan');
INSERT INTO `lang_definitions` VALUES (17910, 2810, 14, 'Stres Test');
INSERT INTO `lang_definitions` VALUES (17911, 2811, 14, 'Langkah');
INSERT INTO `lang_definitions` VALUES (17912, 2813, 14, 'Sub-Total');
INSERT INTO `lang_definitions` VALUES (17913, 2814, 14, 'Subkategori');
INSERT INTO `lang_definitions` VALUES (17914, 2815, 14, 'subkategori');
INSERT INTO `lang_definitions` VALUES (17915, 2816, 14, 'subcutaneously');
INSERT INTO `lang_definitions` VALUES (17916, 2818, 14, 'Sublingual');
INSERT INTO `lang_definitions` VALUES (17917, 2819, 14, 'sublingual');
INSERT INTO `lang_definitions` VALUES (17918, 2820, 14, 'Menyerahkan');
INSERT INTO `lang_definitions` VALUES (17919, 2822, 14, 'Kirim Even');
INSERT INTO `lang_definitions` VALUES (17920, 2823, 14, 'menyerahkan formulir');
INSERT INTO `lang_definitions` VALUES (17921, 2826, 14, 'Dikirim oleh');
INSERT INTO `lang_definitions` VALUES (17922, 2828, 14, 'Pelanggan');
INSERT INTO `lang_definitions` VALUES (17923, 2829, 14, 'Alamat Pelanggan');
INSERT INTO `lang_definitions` VALUES (17924, 2830, 14, 'Pelanggan Perusahaan');
INSERT INTO `lang_definitions` VALUES (17925, 2831, 14, 'Pelanggan Perusahaan (SE)');
INSERT INTO `lang_definitions` VALUES (17926, 2832, 14, 'Pelanggan Perusahaan Alamat');
INSERT INTO `lang_definitions` VALUES (17927, 2833, 14, 'Pelanggan Perusahaan Kota');
INSERT INTO `lang_definitions` VALUES (17928, 2834, 14, 'Pelanggan Perusahaan Negara');
INSERT INTO `lang_definitions` VALUES (17929, 2835, 14, 'Pelanggan Perusahaan Negara');
INSERT INTO `lang_definitions` VALUES (17930, 2836, 14, 'Pelanggan Perusahaan Kode Pos');
INSERT INTO `lang_definitions` VALUES (17931, 2837, 14, 'Pelanggan Telepon');
INSERT INTO `lang_definitions` VALUES (17932, 2843, 14, 'Pelanggan Seks');
INSERT INTO `lang_definitions` VALUES (17933, 2844, 14, 'Substitution');
INSERT INTO `lang_definitions` VALUES (17934, 2845, 14, 'substitution diizinkan');
INSERT INTO `lang_definitions` VALUES (17935, 2850, 14, 'Bunuh diri');
INSERT INTO `lang_definitions` VALUES (17936, 2851, 14, 'Aktivitas');
INSERT INTO `lang_definitions` VALUES (17937, 2852, 14, 'Matahari');
INSERT INTO `lang_definitions` VALUES (17938, 2853, 14, 'Minggu');
INSERT INTO `lang_definitions` VALUES (17939, 2854, 14, 'Superbill');
INSERT INTO `lang_definitions` VALUES (17940, 2855, 14, 'Superbill Codes');
INSERT INTO `lang_definitions` VALUES (17941, 2857, 14, 'Superbill Lapor');
INSERT INTO `lang_definitions` VALUES (17942, 2861, 14, 'Jenis permukaan');
INSERT INTO `lang_definitions` VALUES (17943, 2864, 14, 'Ditangguhkan');
INSERT INTO `lang_definitions` VALUES (17944, 2865, 14, 'skorsing');
INSERT INTO `lang_definitions` VALUES (17945, 2866, 14, 'Tanggal SVC');
INSERT INTO `lang_definitions` VALUES (17946, 2867, 14, 'Tanggal SVC:');
INSERT INTO `lang_definitions` VALUES (17947, 2868, 14, 'Sweating:');
INSERT INTO `lang_definitions` VALUES (17948, 2869, 14, 'Swedia');
INSERT INTO `lang_definitions` VALUES (17949, 2871, 14, 'Pembengkakan Tepat');
INSERT INTO `lang_definitions` VALUES (17950, 2872, 14, 'Bengkak sendi');
INSERT INTO `lang_definitions` VALUES (17951, 2873, 14, 'Kelenjar getah bening bengkak');
INSERT INTO `lang_definitions` VALUES (17952, 2876, 14, 'Synovitis, tubrukan, radang kandung lendir');
INSERT INTO `lang_definitions` VALUES (17953, 2877, 14, 'Sistem');
INSERT INTO `lang_definitions` VALUES (17954, 2878, 14, 'T');
INSERT INTO `lang_definitions` VALUES (17955, 2879, 14, 't.i.d.');
INSERT INTO `lang_definitions` VALUES (17956, 2880, 14, 'T.V.');
INSERT INTO `lang_definitions` VALUES (17957, 2881, 14, 'Tabel penciptaan gagal');
INSERT INTO `lang_definitions` VALUES (17958, 2882, 14, 'Tabel update gagal');
INSERT INTO `lang_definitions` VALUES (17959, 2883, 14, 'tablet');
INSERT INTO `lang_definitions` VALUES (17960, 2884, 14, 'Mengambil');
INSERT INTO `lang_definitions` VALUES (17961, 2885, 14, 'Berlangsung lama');
INSERT INTO `lang_definitions` VALUES (17962, 2887, 14, 'Pajak');
INSERT INTO `lang_definitions` VALUES (17963, 2888, 14, 'Taxonomy');
INSERT INTO `lang_definitions` VALUES (17964, 2890, 14, 'Sekilas tim Cedera');
INSERT INTO `lang_definitions` VALUES (17965, 2891, 14, 'Tim Roster');
INSERT INTO `lang_definitions` VALUES (17966, 2892, 14, 'Lihat tim Roster');
INSERT INTO `lang_definitions` VALUES (17967, 2898, 14, 'Template');
INSERT INTO `lang_definitions` VALUES (17968, 2901, 14, 'Template:');
INSERT INTO `lang_definitions` VALUES (17969, 2904, 14, 'Cedera otot kedang');
INSERT INTO `lang_definitions` VALUES (17970, 2905, 14, 'Tendonitis / OSIS / radang kandung lendir');
INSERT INTO `lang_definitions` VALUES (17971, 2906, 14, 'Perguruan');
INSERT INTO `lang_definitions` VALUES (17972, 2907, 14, 'Perguruan Asuransi');
INSERT INTO `lang_definitions` VALUES (17973, 2908, 14, 'Perguruan Data Asuransi');
INSERT INTO `lang_definitions` VALUES (17974, 2909, 14, 'Perguruan Asuransi selular');
INSERT INTO `lang_definitions` VALUES (17975, 2911, 14, 'Sistem test');
INSERT INTO `lang_definitions` VALUES (17976, 2913, 14, 'text-tanggal');
INSERT INTO `lang_definitions` VALUES (17977, 2915, 14, 'textarea');
INSERT INTO `lang_definitions` VALUES (17978, 2917, 14, 'textbox');
INSERT INTO `lang_definitions` VALUES (17979, 2919, 14, 'textbox daftar');
INSERT INTO `lang_definitions` VALUES (17980, 2920, 14, 'Terima Kasih');
INSERT INTO `lang_definitions` VALUES (17981, 2921, 14, 'Dakwaan file:');
INSERT INTO `lang_definitions` VALUES (17982, 2922, 14, 'Tujuan formulir ditutup, saya tidak bisa bertindak atas pilihan Anda.');
INSERT INTO `lang_definitions` VALUES (17983, 2923, 14, 'Event (s) yang telah disetujui.');
INSERT INTO `lang_definitions` VALUES (17984, 2924, 14, 'Event (s) telah tersembunyi.');
INSERT INTO `lang_definitions` VALUES (17985, 2926, 14, 'Kalender acara berikut telah ditambahkan:');
INSERT INTO `lang_definitions` VALUES (17986, 2927, 14, 'Berikut kalender acara telah modifed:');
INSERT INTO `lang_definitions` VALUES (17987, 2929, 14, 'Awal jendela adalah faktur halaman pencarian. Pada bagian atas Anda bisa memasukkan sumber (misalnya memeriksa angka), dan memeriksa tanggal membayar jumlah tersebut. Alasannya sumber dan membayar tanggal, sehingga Anda tidak perlu memasukkannya berulang lagi untuk setiap klaim. Jumlah yang akan Anda masukkan akan berkurang untuk setiap faktur yang diberikan adalah bagian dari pembayaran, dan diharapkan akan berakhir pada nol setelah selesai.');
INSERT INTO `lang_definitions` VALUES (17988, 2930, 14, 'Label yang muncul bagi pengguna di formulir');
INSERT INTO `lang_definitions` VALUES (17989, 2931, 14, 'Kategori yang baru akan menjadi sub-kategori');
INSERT INTO `lang_definitions` VALUES (17990, 2932, 14, 'Sisa informasi di bawah ini hanya berlaku jika Anda posting secara manual, atau jika Anda melakukan koreksi secara manual.');
INSERT INTO `lang_definitions` VALUES (17991, 2934, 14, 'Sumber dan Tanggal di kolom yang disalin dari halaman pertama, maka biasanya Anda tidak perlu menyentuh mereka. Anda dapat memasukkan jumlah pembayaran di kolom Bayar, sebuah penyesuaian Menyesuaikan jumlah dalam kolom, atau keduanya. Anda juga dapat klik tombol \"W\" di sebelah kanan secara otomatis ke sebuah compute penyesuaian nilai yang menulis di bagian sisa dari biaya untuk item baris.');
INSERT INTO `lang_definitions` VALUES (17992, 2935, 14, 'Terjemahan label yang akan muncul pada saat ini dalam bentuk bahasa');
INSERT INTO `lang_definitions` VALUES (17993, 2936, 14, 'Judul terjemahan yang saat ini akan muncul dalam bahasa');
INSERT INTO `lang_definitions` VALUES (17994, 2937, 14, 'Terjemahan deskripsi dalam bahasa sekarang');
INSERT INTO `lang_definitions` VALUES (17995, 2938, 14, 'File X12 yang juga sebagai hasil laporan hasil HTML diarsipkan dalam \"era\" subdirektori dari direktori instalasi OpenEMR utama. Anda ingin lihat arsip ini dari waktu ke waktu. URL');
INSERT INTO `lang_definitions` VALUES (17996, 2939, 14, 'Terapeutik suntikan');
INSERT INTO `lang_definitions` VALUES (17997, 2941, 14, 'Ada beberapa kesalahan dengan khidmat. Hal ini dijelaskan di bawah ini.');
INSERT INTO `lang_definitions` VALUES (17998, 2942, 14, 'Tidak ada Baru Submissions');
INSERT INTO `lang_definitions` VALUES (17999, 2947, 14, 'COA tidak ada entri untuk account AR');
INSERT INTO `lang_definitions` VALUES (18000, 2948, 14, 'COA tidak ada uang untuk masuk account');
INSERT INTO `lang_definitions` VALUES (18001, 2949, 14, 'COA tidak ada entri untuk pendapatan account');
INSERT INTO `lang_definitions` VALUES (18002, 2950, 14, 'Tidak ada cocok untuk faktur id');
INSERT INTO `lang_definitions` VALUES (18003, 2951, 14, 'Tidak ada cocok untuk faktur id =');
INSERT INTO `lang_definitions` VALUES (18004, 2952, 14, 'Tidak ada yang masuk untuk layanan ID');
INSERT INTO `lang_definitions` VALUES (18005, 2953, 14, 'Ada kesalahan saat memproses permintaan Anda.');
INSERT INTO `lang_definitions` VALUES (18006, 2954, 14, 'Thickened Kanan:');
INSERT INTO `lang_definitions` VALUES (18007, 2955, 14, 'Paha');
INSERT INTO `lang_definitions` VALUES (18008, 2956, 14, 'Paha + mengeting');
INSERT INTO `lang_definitions` VALUES (18009, 2965, 14, 'Ketiga');
INSERT INTO `lang_definitions` VALUES (18010, 2968, 14, 'Kode jenis ini tidak menerima hubungan.');
INSERT INTO `lang_definitions` VALUES (18011, 2969, 14, 'Ini Encounter');
INSERT INTO `lang_definitions` VALUES (18012, 2971, 14, 'Nomor faktur ini telah diubah menjadi');
INSERT INTO `lang_definitions` VALUES (18013, 2972, 14, 'Modul ini dalam mode uji. Basis data tidak akan berubah.');
INSERT INTO `lang_definitions` VALUES (18014, 2973, 14, 'Modul ini mempromosikan efisien masuknya data EOB.');
INSERT INTO `lang_definitions` VALUES (18015, 2974, 14, 'Halaman ini akan menyertakan inline halaman login, sehingga kita tidak perlu klik relogin setiap waktu.');
INSERT INTO `lang_definitions` VALUES (18016, 2975, 14, 'Pasien ini tidak memiliki kegiatan.');
INSERT INTO `lang_definitions` VALUES (18017, 2976, 14, 'ID pasien ini sudah digunakan!');
INSERT INTO `lang_definitions` VALUES (18018, 2978, 14, 'Kunjungan ini baru mulai menggunakan kontrasepsi');
INSERT INTO `lang_definitions` VALUES (18019, 2980, 14, 'Yg berkenaan dgn dada tulang belakang');
INSERT INTO `lang_definitions` VALUES (18020, 2982, 14, 'Kanker Tenggorokan');
INSERT INTO `lang_definitions` VALUES (18021, 2983, 14, 'Kanker Tenggorokan Bedah');
INSERT INTO `lang_definitions` VALUES (18022, 2984, 14, 'Trombosa / Stroke');
INSERT INTO `lang_definitions` VALUES (18023, 2985, 14, 'Thu');
INSERT INTO `lang_definitions` VALUES (18024, 2986, 14, 'Thurdsay');
INSERT INTO `lang_definitions` VALUES (18025, 2987, 14, 'Kamis');
INSERT INTO `lang_definitions` VALUES (18026, 2988, 14, 'Thyroid normal');
INSERT INTO `lang_definitions` VALUES (18027, 2991, 14, 'Waktu');
INSERT INTO `lang_definitions` VALUES (18028, 2992, 14, 'Tambahkan waktu untuk kenaikan (1-60 bulan)');
INSERT INTO `lang_definitions` VALUES (18029, 2993, 14, 'Jangka waktu kegiatan');
INSERT INTO `lang_definitions` VALUES (18030, 2994, 14, 'Kali array (N / A)');
INSERT INTO `lang_definitions` VALUES (18031, 2995, 14, 'Timestamp dan Teks');
INSERT INTO `lang_definitions` VALUES (18032, 2998, 14, 'Judul');
INSERT INTO `lang_definitions` VALUES (18033, 2999, 14, 'Judul V');
INSERT INTO `lang_definitions` VALUES (18034, 3002, 14, 'TM\'S:');
INSERT INTO `lang_definitions` VALUES (18035, 3003, 14, 'TMs / EAMs / EE, ext hidung');
INSERT INTO `lang_definitions` VALUES (18036, 3004, 14, 'Untuk');
INSERT INTO `lang_definitions` VALUES (18037, 3006, 14, 'untuk');
INSERT INTO `lang_definitions` VALUES (18038, 3007, 14, 'Untuk Affected Area');
INSERT INTO `lang_definitions` VALUES (18039, 3008, 14, 'ke daerah yang terkena dampak');
INSERT INTO `lang_definitions` VALUES (18040, 3010, 14, 'untuk kategori');
INSERT INTO `lang_definitions` VALUES (18041, 3012, 14, 'Untuk copay');
INSERT INTO `lang_definitions` VALUES (18042, 3013, 14, 'Untuk ded\'ble');
INSERT INTO `lang_definitions` VALUES (18043, 3016, 14, 'Untuk menyaring oleh seks');
INSERT INTO `lang_definitions` VALUES (18044, 3017, 14, 'Untuk Sejarah');
INSERT INTO `lang_definitions` VALUES (18045, 3018, 14, 'Untuk Isu');
INSERT INTO `lang_definitions` VALUES (18046, 3021, 14, 'Untuk Kulit');
INSERT INTO `lang_definitions` VALUES (18047, 3022, 14, 'untuk kulit');
INSERT INTO `lang_definitions` VALUES (18048, 3024, 14, 'Kepada:');
INSERT INTO `lang_definitions` VALUES (18049, 3025, 14, 'Kepada:');
INSERT INTO `lang_definitions` VALUES (18050, 3037, 14, 'Tembakau');
INSERT INTO `lang_definitions` VALUES (18051, 3038, 14, 'Menggunakan tembakau');
INSERT INTO `lang_definitions` VALUES (18052, 3039, 14, 'Hari ini');
INSERT INTO `lang_definitions` VALUES (18053, 3041, 14, 'Kegiatan Hari Ini');
INSERT INTO `lang_definitions` VALUES (18054, 3042, 14, 'Amandel');
INSERT INTO `lang_definitions` VALUES (18055, 3043, 14, 'Puncak');
INSERT INTO `lang_definitions` VALUES (18056, 3044, 14, 'Topik');
INSERT INTO `lang_definitions` VALUES (18057, 3045, 14, 'total');
INSERT INTO `lang_definitions` VALUES (18058, 3046, 14, 'Total');
INSERT INTO `lang_definitions` VALUES (18059, 3047, 14, 'Jumlah total Dibayar');
INSERT INTO `lang_definitions` VALUES (18060, 3048, 14, 'Biaya total');
INSERT INTO `lang_definitions` VALUES (18061, 3049, 14, 'Total Klien');
INSERT INTO `lang_definitions` VALUES (18062, 3050, 14, 'Total untuk');
INSERT INTO `lang_definitions` VALUES (18063, 3051, 14, 'Total untuk');
INSERT INTO `lang_definitions` VALUES (18064, 3052, 14, 'Total untuk kategori');
INSERT INTO `lang_definitions` VALUES (18065, 3053, 14, 'Total Jumlah Pasien');
INSERT INTO `lang_definitions` VALUES (18066, 3054, 14, 'Total SRH & Keluarga Berencana');
INSERT INTO `lang_definitions` VALUES (18067, 3055, 14, 'Total');
INSERT INTO `lang_definitions` VALUES (18068, 3057, 14, 'Total untuk');
INSERT INTO `lang_definitions` VALUES (18069, 3058, 14, 'Jenis pelatihan');
INSERT INTO `lang_definitions` VALUES (18070, 3059, 14, 'Transact');
INSERT INTO `lang_definitions` VALUES (18071, 3061, 14, 'Transaksi');
INSERT INTO `lang_definitions` VALUES (18072, 3062, 14, 'Jenis transaksi');
INSERT INTO `lang_definitions` VALUES (18073, 3063, 14, 'Transaksi');
INSERT INTO `lang_definitions` VALUES (18074, 3065, 14, 'Transaksi / Arahan');
INSERT INTO `lang_definitions` VALUES (18075, 3066, 14, 'translate');
INSERT INTO `lang_definitions` VALUES (18076, 3067, 14, 'Translation');
INSERT INTO `lang_definitions` VALUES (18077, 3069, 14, 'Trauma');
INSERT INTO `lang_definitions` VALUES (18078, 3072, 14, 'Perawatan:');
INSERT INTO `lang_definitions` VALUES (18079, 3073, 14, 'Perawatan:');
INSERT INTO `lang_definitions` VALUES (18080, 3074, 14, 'trftime ($ month_format, mktime (0, 0, 0, $ i, 1, 2000))); $ month_value');
INSERT INTO `lang_definitions` VALUES (18081, 3075, 14, 'Memicu point / kompartemen sindrom / DOMS / kejang');
INSERT INTO `lang_definitions` VALUES (18082, 3076, 14, 'Trimalleolar');
INSERT INTO `lang_definitions` VALUES (18083, 3077, 14, 'tring [, \'r\' [,');
INSERT INTO `lang_definitions` VALUES (18084, 3078, 14, 'Trunk dan perut');
INSERT INTO `lang_definitions` VALUES (18085, 3079, 14, 'tsp');
INSERT INTO `lang_definitions` VALUES (18086, 3080, 14, 'Tts');
INSERT INTO `lang_definitions` VALUES (18087, 3081, 14, 'Tuberkulosis');
INSERT INTO `lang_definitions` VALUES (18088, 3082, 14, 'Selasa');
INSERT INTO `lang_definitions` VALUES (18089, 3083, 14, 'Selasa & Kamis');
INSERT INTO `lang_definitions` VALUES (18090, 3084, 14, 'Selasa');
INSERT INTO `lang_definitions` VALUES (18091, 3085, 14, 'Tumor');
INSERT INTO `lang_definitions` VALUES (18092, 3086, 14, 'dua kali sehari');
INSERT INTO `lang_definitions` VALUES (18093, 3088, 14, 'Tipe');
INSERT INTO `lang_definitions` VALUES (18094, 3089, 14, 'Ketik atau scan pasien identifier disini');
INSERT INTO `lang_definitions` VALUES (18095, 3090, 14, 'UCSMC kode yang diberikan oleh University of Calgary Kedokteran Olahraga Pusat');
INSERT INTO `lang_definitions` VALUES (18096, 3091, 14, 'Ulcerations');
INSERT INTO `lang_definitions` VALUES (18097, 3092, 14, 'Ulcerative colitis');
INSERT INTO `lang_definitions` VALUES (18098, 3093, 14, 'Ulcers:');
INSERT INTO `lang_definitions` VALUES (18099, 3094, 14, 'Unassigned');
INSERT INTO `lang_definitions` VALUES (18100, 3095, 14, 'Akses yang tidak sah.');
INSERT INTO `lang_definitions` VALUES (18101, 3096, 14, 'di bawah lidah');
INSERT INTO `lang_definitions` VALUES (18102, 3098, 14, 'Undiagnosed');
INSERT INTO `lang_definitions` VALUES (18103, 3099, 14, 'Batalkan Checkout');
INSERT INTO `lang_definitions` VALUES (18104, 3100, 14, 'Klien Unik');
INSERT INTO `lang_definitions` VALUES (18105, 3101, 14, 'Unik Klien Baru');
INSERT INTO `lang_definitions` VALUES (18106, 3102, 14, 'Unik Seen Pasien');
INSERT INTO `lang_definitions` VALUES (18107, 3103, 14, 'Unik Seen Pasien Lapor');
INSERT INTO `lang_definitions` VALUES (18108, 3104, 14, 'Unik SP');
INSERT INTO `lang_definitions` VALUES (18109, 3105, 14, 'Unit');
INSERT INTO `lang_definitions` VALUES (18110, 3106, 14, 'Unit');
INSERT INTO `lang_definitions` VALUES (18111, 3107, 14, 'unit');
INSERT INTO `lang_definitions` VALUES (18112, 3109, 14, 'Unknown');
INSERT INTO `lang_definitions` VALUES (18113, 3110, 14, 'Tidak diketahui atau N / A');
INSERT INTO `lang_definitions` VALUES (18114, 3111, 14, 'Perusahaan asuransi tak dikenal');
INSERT INTO `lang_definitions` VALUES (18115, 3112, 14, 'Anonim');
INSERT INTO `lang_definitions` VALUES (18116, 3114, 14, 'Unselected');
INSERT INTO `lang_definitions` VALUES (18117, 3116, 14, 'sampai');
INSERT INTO `lang_definitions` VALUES (18118, 3117, 14, 'Cepat filing');
INSERT INTO `lang_definitions` VALUES (18119, 3118, 14, 'Unused');
INSERT INTO `lang_definitions` VALUES (18120, 3119, 14, 'UOR');
INSERT INTO `lang_definitions` VALUES (18121, 3120, 14, 'Hingga');
INSERT INTO `lang_definitions` VALUES (18122, 3121, 14, 'Mendatang Appointments');
INSERT INTO `lang_definitions` VALUES (18123, 3122, 14, 'Kegiatan Mendatang');
INSERT INTO `lang_definitions` VALUES (18124, 3123, 14, 'Pembaruan');
INSERT INTO `lang_definitions` VALUES (18125, 3124, 14, 'pembaruan');
INSERT INTO `lang_definitions` VALUES (18126, 3125, 14, 'Update file');
INSERT INTO `lang_definitions` VALUES (18127, 3126, 14, 'Update Info');
INSERT INTO `lang_definitions` VALUES (18128, 3131, 14, 'UPIN');
INSERT INTO `lang_definitions` VALUES (18129, 3132, 14, 'Unggah');
INSERT INTO `lang_definitions` VALUES (18130, 3134, 14, 'Upload Dokumen');
INSERT INTO `lang_definitions` VALUES (18131, 3136, 14, 'Impor upload file:');
INSERT INTO `lang_definitions` VALUES (18132, 3137, 14, 'Upload Lapor');
INSERT INTO `lang_definitions` VALUES (18133, 3138, 14, 'Berkas ini:');
INSERT INTO `lang_definitions` VALUES (18134, 3139, 14, 'Setelah mengklik nomor faktur yang \"manual posting jendela\" muncul. Di sini Anda dapat mengubah tanggal jatuh tempo dan catatan untuk faktur, untuk memilih partai yang Anda posting, dan memilih asuransi yang diharapkan semua paymants telah diterima. Paling penting lagi, untuk setiap tagihan kode untuk jumlah yang telah diisi, Anda dapat memasukkan informasi pembayaran dan penyesuaian.');
INSERT INTO `lang_definitions` VALUES (18135, 3140, 14, 'Setelah pencarian Anda disajikan dengan daftar tagihan. Anda bisa mengklik pada salah satu nomor faktur untuk membuka jendela kedua, yang merupakan data halaman manual untuk memposting. Anda juga dapat mengklik nama pasien jika ingin memasukkan catatan bahwa staf kantor depan akan melihat pasien ketika di cek, dan Anda dapat memilih untuk tampil di tagihan pasien dan mencetak pernyataan pernyataan itu.');
INSERT INTO `lang_definitions` VALUES (18136, 3141, 14, 'Lengan atas');
INSERT INTO `lang_definitions` VALUES (18137, 3148, 14, 'URL');
INSERT INTO `lang_definitions` VALUES (18138, 3150, 14, 'Gunakan format waktu 24 jam?');
INSERT INTO `lang_definitions` VALUES (18139, 3151, 14, 'Gunakan Default');
INSERT INTO `lang_definitions` VALUES (18140, 3152, 14, 'Gunakan internasional tanggal gaya?');
INSERT INTO `lang_definitions` VALUES (18141, 3154, 14, 'Gunakan topik?');
INSERT INTO `lang_definitions` VALUES (18142, 3155, 14, 'Pengguna');
INSERT INTO `lang_definitions` VALUES (18143, 3156, 14, 'Admin User');
INSERT INTO `lang_definitions` VALUES (18144, 3157, 14, 'Administrasi User dan Prasarana');
INSERT INTO `lang_definitions` VALUES (18145, 3159, 14, 'Ditetapkan Pengguna');
INSERT INTO `lang_definitions` VALUES (18146, 3179, 14, 'Pengguna Keanggotaan');
INSERT INTO `lang_definitions` VALUES (18147, 3180, 14, 'Username');
INSERT INTO `lang_definitions` VALUES (18148, 3181, 14, 'Username untuk SMS Gateway');
INSERT INTO `lang_definitions` VALUES (18149, 3182, 14, 'Username:');
INSERT INTO `lang_definitions` VALUES (18150, 3183, 14, 'User');
INSERT INTO `lang_definitions` VALUES (18151, 3185, 14, 'php menggunakan <a href=\"http://php.net/strftime\"> strftime </ a> format');
INSERT INTO `lang_definitions` VALUES (18152, 3189, 14, 'Vaksin');
INSERT INTO `lang_definitions` VALUES (18153, 3190, 14, 'Vaginal Ring');
INSERT INTO `lang_definitions` VALUES (18154, 3191, 14, 'Pidato perpisahan');
INSERT INTO `lang_definitions` VALUES (18155, 3194, 14, 'Var1');
INSERT INTO `lang_definitions` VALUES (18156, 3195, 14, 'Var2');
INSERT INTO `lang_definitions` VALUES (18157, 3198, 14, 'Pembuluh mekar');
INSERT INTO `lang_definitions` VALUES (18158, 3199, 14, 'Vascular kondisi');
INSERT INTO `lang_definitions` VALUES (18159, 3200, 14, 'Vascular cedera');
INSERT INTO `lang_definitions` VALUES (18160, 3201, 14, 'Vascular Bedah');
INSERT INTO `lang_definitions` VALUES (18161, 3202, 14, 'Versi');
INSERT INTO `lang_definitions` VALUES (18162, 3204, 14, 'Veteran Administrasi Rencana');
INSERT INTO `lang_definitions` VALUES (18163, 3205, 14, 'Melihat');
INSERT INTO `lang_definitions` VALUES (18164, 3207, 14, 'Lihat Alergi');
INSERT INTO `lang_definitions` VALUES (18165, 3208, 14, 'Lihat Komprehensif Pasien Lapor');
INSERT INTO `lang_definitions` VALUES (18166, 3211, 14, 'Melihat peristiwa di jendela popup?');
INSERT INTO `lang_definitions` VALUES (18167, 3216, 14, 'Lihat:');
INSERT INTO `lang_definitions` VALUES (18168, 3217, 14, 'VISA');
INSERT INTO `lang_definitions` VALUES (18169, 3218, 14, 'Mendalam kerusakan / trauma / operasi');
INSERT INTO `lang_definitions` VALUES (18170, 3219, 14, 'Kunjungi Kategori:');
INSERT INTO `lang_definitions` VALUES (18171, 3220, 14, 'Tanggal kunjungan');
INSERT INTO `lang_definitions` VALUES (18172, 3222, 14, 'Kunjungan');
INSERT INTO `lang_definitions` VALUES (18173, 3223, 14, 'Dari kunjungan');
INSERT INTO `lang_definitions` VALUES (18174, 3229, 14, 'W');
INSERT INTO `lang_definitions` VALUES (18175, 3232, 14, 'Menunggu');
INSERT INTO `lang_definitions` VALUES (18176, 3233, 14, 'Walk-In');
INSERT INTO `lang_definitions` VALUES (18177, 3234, 14, 'Walt Pennington');
INSERT INTO `lang_definitions` VALUES (18178, 3237, 14, 'Peringatan: Kunjungan telah dibuat untuk pasien today!');
INSERT INTO `lang_definitions` VALUES (18179, 3238, 14, 'Peringatan: Pasien ID tidak unik!');
INSERT INTO `lang_definitions` VALUES (18180, 3242, 14, 'Website');
INSERT INTO `lang_definitions` VALUES (18181, 3243, 14, 'Rabu');
INSERT INTO `lang_definitions` VALUES (18182, 3244, 14, 'Rabu');
INSERT INTO `lang_definitions` VALUES (18183, 3245, 14, 'minggu');
INSERT INTO `lang_definitions` VALUES (18184, 3246, 14, 'Minggu');
INSERT INTO `lang_definitions` VALUES (18185, 3247, 14, 'Lihat bulan');
INSERT INTO `lang_definitions` VALUES (18186, 3248, 14, 'Minggu (s)');
INSERT INTO `lang_definitions` VALUES (18187, 3251, 14, 'Berat Badan');
INSERT INTO `lang_definitions` VALUES (18188, 3252, 14, 'Apa yang akan dihitung?');
INSERT INTO `lang_definitions` VALUES (18189, 3253, 14, 'Wheezes:');
INSERT INTO `lang_definitions` VALUES (18190, 3255, 14, 'Wheezing:');
INSERT INTO `lang_definitions` VALUES (18191, 3256, 14, 'Dimana Mei terkait scan kertas atau dokumen dapat ditemukan?');
INSERT INTO `lang_definitions` VALUES (18192, 3257, 14, 'Pukulan cemeti');
INSERT INTO `lang_definitions` VALUES (18193, 3258, 14, 'Siapa');
INSERT INTO `lang_definitions` VALUES (18194, 3259, 14, 'Siapa yang menjawab?');
INSERT INTO `lang_definitions` VALUES (18195, 3260, 14, 'Janda');
INSERT INTO `lang_definitions` VALUES (18196, 3264, 14, 'dalam bulan');
INSERT INTO `lang_definitions` VALUES (18197, 3265, 14, 'waktu jam:');
INSERT INTO `lang_definitions` VALUES (18198, 3266, 14, 'dalam hitungan menit');
INSERT INTO `lang_definitions` VALUES (18199, 3267, 14, 'dalam beberapa menit:');
INSERT INTO `lang_definitions` VALUES (18200, 3268, 14, 'Tanpa Update');
INSERT INTO `lang_definitions` VALUES (18201, 3269, 14, 'Saksi');
INSERT INTO `lang_definitions` VALUES (18202, 3270, 14, 'WNL');
INSERT INTO `lang_definitions` VALUES (18203, 3271, 14, 'Perempuan');
INSERT INTO `lang_definitions` VALUES (18204, 3272, 14, 'Hanya perempuan');
INSERT INTO `lang_definitions` VALUES (18205, 3273, 14, 'Bekerja');
INSERT INTO `lang_definitions` VALUES (18206, 3274, 14, 'BEKERJA CATATAN');
INSERT INTO `lang_definitions` VALUES (18207, 3275, 14, 'Work Phone');
INSERT INTO `lang_definitions` VALUES (18208, 3277, 14, 'Pekerjaan yang berkaitan?');
INSERT INTO `lang_definitions` VALUES (18209, 3279, 14, 'Kerja / Sekolah Catatan');
INSERT INTO `lang_definitions` VALUES (18210, 3281, 14, 'Kompensasi pekerja Kesehatan Rencana');
INSERT INTO `lang_definitions` VALUES (18211, 3283, 14, 'Pergelangan tangan');
INSERT INTO `lang_definitions` VALUES (18212, 3284, 14, 'Pergelangan tangan dan tangan');
INSERT INTO `lang_definitions` VALUES (18213, 3285, 14, 'Pergelangan tangan Masalah');
INSERT INTO `lang_definitions` VALUES (18214, 3287, 14, 'mencoret');
INSERT INTO `lang_definitions` VALUES (18215, 3290, 14, 'x Dibatalkan');
INSERT INTO `lang_definitions` VALUES (18216, 3291, 14, 'X-ray');
INSERT INTO `lang_definitions` VALUES (18217, 3292, 14, 'X-RAY Interpretation:');
INSERT INTO `lang_definitions` VALUES (18218, 3293, 14, 'X-Ray Interpretation:');
INSERT INTO `lang_definitions` VALUES (18219, 3294, 14, 'X12 hanya: Replacement Klaim');
INSERT INTO `lang_definitions` VALUES (18220, 3295, 14, 'X12 Mitra');
INSERT INTO `lang_definitions` VALUES (18221, 3296, 14, 'X12 Mitra');
INSERT INTO `lang_definitions` VALUES (18222, 3298, 14, 'tahun');
INSERT INTO `lang_definitions` VALUES (18223, 3299, 14, 'Tahun');
INSERT INTO `lang_definitions` VALUES (18224, 3300, 14, 'Lihat Tahun');
INSERT INTO `lang_definitions` VALUES (18225, 3301, 14, 'Tahun (s)');
INSERT INTO `lang_definitions` VALUES (18226, 3302, 14, 'YA');
INSERT INTO `lang_definitions` VALUES (18227, 3303, 14, 'Ya');
INSERT INTO `lang_definitions` VALUES (18228, 3304, 14, 'ya');
INSERT INTO `lang_definitions` VALUES (18229, 3305, 14, 'YA!');
INSERT INTO `lang_definitions` VALUES (18230, 3308, 14, 'Ya:');
INSERT INTO `lang_definitions` VALUES (18231, 3310, 14, 'Anda tidak diperbolehkan untuk menghapus acara ini');
INSERT INTO `lang_definitions` VALUES (18232, 3311, 14, 'Anda tidak diperbolehkan untuk mengedit peristiwa ini');
INSERT INTO `lang_definitions` VALUES (18233, 3312, 14, 'Anda tidak diizinkan untuk ini.');
INSERT INTO `lang_definitions` VALUES (18234, 3316, 14, 'Anda tidak dapat mengakses fungsi ini secara langsung.');
INSERT INTO `lang_definitions` VALUES (18235, 3317, 14, 'Anda tidak dapat mengakses halaman ini secara langsung.');
INSERT INTO `lang_definitions` VALUES (18236, 3321, 14, 'Anda tidak memilih tindakan.');
INSERT INTO `lang_definitions` VALUES (18237, 3324, 14, 'Anda harus terlebih dahulu memilih atau menambahkan pasien.');
INSERT INTO `lang_definitions` VALUES (18238, 3325, 14, 'Anda harus terlebih dahulu memilih atau membuat ditemui.');
INSERT INTO `lang_definitions` VALUES (18239, 3327, 14, 'Anda harus menjalankan tes ini jika tuntutan ini muncul untuk berhasil tetapi sebenarnya klaim file tidak berisi data apapun yang belum selesai atau hanya bagian dari jumlah data yang sudah seharusnya berisi. Hal ini jelas dengan klaim HCFA karena manusia dibaca, dengan X12 klaim itu proses yang lebih sulit untuk menentukan apakah klaim adalah benar selesai.');
INSERT INTO `lang_definitions` VALUES (18240, 3328, 14, 'Tanggal berakhir tidak valid');
INSERT INTO `lang_definitions` VALUES (18241, 3329, 14, 'Acara Anda telah dihapus.');
INSERT INTO `lang_definitions` VALUES (18242, 3330, 14, 'Acara Anda telah dimodifikasi.');
INSERT INTO `lang_definitions` VALUES (18243, 3331, 14, 'Acara Anda telah dikirimkan.');
INSERT INTO `lang_definitions` VALUES (18244, 3333, 14, 'Anda telah PostCalendar konfigurasi ulang untuk menggunakan default.');
INSERT INTO `lang_definitions` VALUES (18245, 3334, 14, 'Anda PostCalendar konfigurasi telah diperbarui.');
INSERT INTO `lang_definitions` VALUES (18246, 3335, 14, 'Anda harus mengulangi frekuensi sebuah integer.');
INSERT INTO `lang_definitions` VALUES (18247, 3336, 14, 'Anda harus mengulangi frekuensi minimal 1.');
INSERT INTO `lang_definitions` VALUES (18248, 3337, 14, 'Anda mulai tanggal lebih besar dari tanggal berakhir');
INSERT INTO `lang_definitions` VALUES (18249, 3338, 14, 'Anda mulai tanggal tidak valid');
INSERT INTO `lang_definitions` VALUES (18250, 3339, 14, 'Anda gagal.');
INSERT INTO `lang_definitions` VALUES (18251, 3340, 14, 'yyyy-mm-dd');
INSERT INTO `lang_definitions` VALUES (18252, 3341, 14, 'yyyy-mm-dd tanggal yang terkait dengan dokumen ini');
INSERT INTO `lang_definitions` VALUES (18253, 3343, 14, 'yyyy-mm-dd Tanggal Lahir');
INSERT INTO `lang_definitions` VALUES (18254, 3344, 14, 'yyyy-mm-dd tanggal lahir');
INSERT INTO `lang_definitions` VALUES (18255, 3346, 14, 'yyyy-mm-dd Tanggal mulai atau rumah sakit');
INSERT INTO `lang_definitions` VALUES (18256, 3347, 14, 'yyyy-mm-dd tanggal mulai, mulai dari operasi atau obat-obatan');
INSERT INTO `lang_definitions` VALUES (18257, 3348, 14, 'yyyy-mm-dd tanggal pemulihan atau akhir obat');
INSERT INTO `lang_definitions` VALUES (18258, 3349, 14, 'yyyy-mm-dd Tanggal kembali bermain');
INSERT INTO `lang_definitions` VALUES (18259, 3350, 14, 'yyyy-mm-dd Tanggal layanan');
INSERT INTO `lang_definitions` VALUES (18260, 3351, 14, 'yyyy-mm-dd tanggal surat ini');
INSERT INTO `lang_definitions` VALUES (18261, 3352, 14, 'yyyy-mm-dd tanggal untuk memutar kembali');
INSERT INTO `lang_definitions` VALUES (18262, 3353, 14, 'yyyy-mm-dd dokumen tanggal');
INSERT INTO `lang_definitions` VALUES (18263, 3354, 14, 'yyyy-mm-dd acara tanggal atau tanggal mulai');
INSERT INTO `lang_definitions` VALUES (18264, 3355, 14, 'yyyy-mm-dd tanggal terakhir dari acara ini');
INSERT INTO `lang_definitions` VALUES (18265, 3357, 14, 'Zip');
INSERT INTO `lang_definitions` VALUES (18266, 3358, 14, 'Kode Pos');
INSERT INTO `lang_definitions` VALUES (18267, 3359, 14, 'Zip / Negara:');
INSERT INTO `lang_definitions` VALUES (18268, 3360, 14, 'Tapi');
INSERT INTO `lang_definitions` VALUES (18269, 3361, 14, 'tidak dapat diakses.');
INSERT INTO `lang_definitions` VALUES (18270, 3362, 14, 'Apakah Anda benar-benar ingin menghapus');
INSERT INTO `lang_definitions` VALUES (18271, 3363, 14, 'Narkoba');
INSERT INTO `lang_definitions` VALUES (18272, 3364, 14, 'email tidak dikirim');
INSERT INTO `lang_definitions` VALUES (18273, 3365, 14, 'dari');
INSERT INTO `lang_definitions` VALUES (18274, 3366, 14, 'telah dibuat.');
INSERT INTO `lang_definitions` VALUES (18275, 3367, 14, 'telah dibuka kembali.');
INSERT INTO `lang_definitions` VALUES (18276, 3368, 14, 'Sejarah');
INSERT INTO `lang_definitions` VALUES (18277, 3369, 14, 'bukan angka');
INSERT INTO `lang_definitions` VALUES (18278, 3370, 14, 'siap kembali penagihan.');
INSERT INTO `lang_definitions` VALUES (18279, 3371, 14, 'LLL:');
INSERT INTO `lang_definitions` VALUES (18280, 3372, 14, 'Banyak');
INSERT INTO `lang_definitions` VALUES (18281, 3373, 14, 'Medicaid Asli Referensi No');
INSERT INTO `lang_definitions` VALUES (18282, 3374, 14, 'min');
INSERT INTO `lang_definitions` VALUES (18283, 3375, 14, 'tidak ditemukan!');
INSERT INTO `lang_definitions` VALUES (18284, 3376, 14, 'Pecularities di banyak browser mungkin berarti bahwa output di bawah layar anda masuk dalam jerks dan tiba-tiba ada jeda panjang dari beberapa detik di mana tampak seolah-olah sesuatu mungkin crashed. Yang tidak terjadi, Anda akan melihat hasil akhirnya keluar baris oleh baris. Mungkin ada berurut nomor yang muncul di bawah, ini adalah untuk menunjukkan bahwa meskipun tidak ada lagi yang dapat menampilkan ada kegiatan terjadi. Angka ini akan interspersed dengan isi dan penagihan yang biasa.');
INSERT INTO `lang_definitions` VALUES (18285, 3377, 14, 'resep telah mencapai batas');
INSERT INTO `lang_definitions` VALUES (18286, 3378, 14, 'sampai');
INSERT INTO `lang_definitions` VALUES (18287, 3379, 14, 'update gagal, bukan di database?');
INSERT INTO `lang_definitions` VALUES (18288, 3380, 14, 'telah ditandai sebagai tagihan saja.');
INSERT INTO `lang_definitions` VALUES (18289, 3381, 14, 'antrean telah berhasil.');
INSERT INTO `lang_definitions` VALUES (18290, 3382, 14, '! Kiri w / o kunjungan');
INSERT INTO `lang_definitions` VALUES (18291, 3383, 14, '\"Untuk kode');
INSERT INTO `lang_definitions` VALUES (18292, 3384, 14, '\"Secara PostCalendar Pengaturan!');
INSERT INTO `lang_definitions` VALUES (18293, 3385, 14, '# Ins / sirip isu');
INSERT INTO `lang_definitions` VALUES (18294, 3386, 14, 'Jumlah tablet:');
INSERT INTO `lang_definitions` VALUES (18295, 3387, 14, '$');
INSERT INTO `lang_definitions` VALUES (18296, 3388, 14, '$ Coding dilakukan');
INSERT INTO `lang_definitions` VALUES (18297, 3389, 14, '$1.00');
INSERT INTO `lang_definitions` VALUES (18298, 3390, 14, '$ label (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (18299, 3392, 14, '% Dibatalkan <24h');
INSERT INTO `lang_definitions` VALUES (18300, 3393, 14, 'harus ada tapi tidak.');
INSERT INTO `lang_definitions` VALUES (18301, 3397, 14, '(Lagi)');
INSERT INTO `lang_definitions` VALUES (18302, 3398, 14, '(Baru Pasien)');
INSERT INTO `lang_definitions` VALUES (18303, 3399, 14, '(Catatan dan kewenangan)');
INSERT INTO `lang_definitions` VALUES (18304, 3400, 14, '(Patient Catatan)');
INSERT INTO `lang_definitions` VALUES (18305, 3402, 14, '* Pengingat dilakukan');
INSERT INTO `lang_definitions` VALUES (18306, 3403, 14, '** Harap pindah ke surgeries Isu!');
INSERT INTO `lang_definitions` VALUES (18307, 3404, 14, '* Diperlukan');
INSERT INTO `lang_definitions` VALUES (18308, 3405, 14, '+ Chart diambil');
INSERT INTO `lang_definitions` VALUES (18309, 3407, 14, '0-10');
INSERT INTO `lang_definitions` VALUES (18310, 3408, 14, '1.Rest 2. Es selama dua hari 3. Kompresi, meninggalkan dressing kecuali di tempat kaki mengembangkan rasa atau warna pucat 4. Meninggikan kaki dan kaki');
INSERT INTO `lang_definitions` VALUES (18311, 3409, 14, '11/14/09');
INSERT INTO `lang_definitions` VALUES (18312, 3410, 14, '15-19');
INSERT INTO `lang_definitions` VALUES (18313, 3411, 14, '20-24');
INSERT INTO `lang_definitions` VALUES (18314, 3412, 14, '2111-13');
INSERT INTO `lang_definitions` VALUES (18315, 3413, 14, '25-29');
INSERT INTO `lang_definitions` VALUES (18316, 3415, 14, '3 bulan');
INSERT INTO `lang_definitions` VALUES (18317, 3416, 14, '3 kali sehari-hari');
INSERT INTO `lang_definitions` VALUES (18318, 3417, 14, '30-34');
INSERT INTO `lang_definitions` VALUES (18319, 3418, 14, '35-39');
INSERT INTO `lang_definitions` VALUES (18320, 3420, 14, '4 bulan');
INSERT INTO `lang_definitions` VALUES (18321, 3421, 14, '4 kali sehari-hari');
INSERT INTO `lang_definitions` VALUES (18322, 3422, 14, '40-44');
INSERT INTO `lang_definitions` VALUES (18323, 3423, 14, '45');
INSERT INTO `lang_definitions` VALUES (18324, 3424, 14, '465,9, URI');
INSERT INTO `lang_definitions` VALUES (18325, 3425, 14, '466,0, bronkitis, akut NOS');
INSERT INTO `lang_definitions` VALUES (18326, 3426, 14, '486,0, radang paru-paru, akut');
INSERT INTO `lang_definitions` VALUES (18327, 3427, 14, '491,21, COPD kekesalan');
INSERT INTO `lang_definitions` VALUES (18328, 3428, 14, '491,8, bronkitis, kronis');
INSERT INTO `lang_definitions` VALUES (18329, 3429, 14, '493,92, Asma, Exac akut.');
INSERT INTO `lang_definitions` VALUES (18330, 3430, 14, '496,0, COPD');
INSERT INTO `lang_definitions` VALUES (18331, 3432, 14, '519,7, Bronchospasm');
INSERT INTO `lang_definitions` VALUES (18332, 3434, 14, '6 bulan');
INSERT INTO `lang_definitions` VALUES (18333, 3436, 14, '824,0 patah, di tengah-tengah malleolus, ditutup');
INSERT INTO `lang_definitions` VALUES (18334, 3437, 14, '824,2 patah, rusuk malleolus, ditutup');
INSERT INTO `lang_definitions` VALUES (18335, 3438, 14, '824,6 retak, Trimalleolar, ditutup');
INSERT INTO `lang_definitions` VALUES (18336, 3439, 14, '825,32 patah, dari Navicular (ankle)');
INSERT INTO `lang_definitions` VALUES (18337, 3440, 14, '825,35 retak, Berdasarkan dari kelima (5.) Metatarsal');
INSERT INTO `lang_definitions` VALUES (18338, 3441, 14, '845,00 kaki mengiatkan NOS');
INSERT INTO `lang_definitions` VALUES (18339, 3442, 14, '845,01 terpelecok di tengah-tengah (delta) Lig.');
INSERT INTO `lang_definitions` VALUES (18340, 3443, 14, '845,02 terpelecok, Calcaneal fibular');
INSERT INTO `lang_definitions` VALUES (18341, 3444, 14, 'Didirikan 99212 - Uncomplicated');
INSERT INTO `lang_definitions` VALUES (18342, 3445, 14, 'Didirikan 99213 - rendah Kompleksitas');
INSERT INTO `lang_definitions` VALUES (18343, 3446, 14, '<Dalam ruang ujian');
INSERT INTO `lang_definitions` VALUES (18344, 3447, 14, '> Dicentang out');
INSERT INTO `lang_definitions` VALUES (18345, 3448, 14, '? Tidak menunjukkan');
INSERT INTO `lang_definitions` VALUES (18346, 3449, 14, '@ Tiba');
INSERT INTO `lang_definitions` VALUES (18347, 3450, 14, '[Ubah Lihat]');
INSERT INTO `lang_definitions` VALUES (18348, 3451, 14, '[Tanggal Terakhir Encounter]');
INSERT INTO `lang_definitions` VALUES (18349, 3452, 14, '[Hari Sejak Terakhir Encounter]');
INSERT INTO `lang_definitions` VALUES (18350, 3453, 14, '[EOBs]');
INSERT INTO `lang_definitions` VALUES (18351, 3454, 14, '[Ekspor OFX]');
INSERT INTO `lang_definitions` VALUES (18352, 3455, 14, '[tidak disarankan]');
INSERT INTO `lang_definitions` VALUES (18353, 3456, 14, '[Jumlah Encounters]');
INSERT INTO `lang_definitions` VALUES (18354, 3457, 14, '[Laporan]');
INSERT INTO `lang_definitions` VALUES (18355, 3458, 14, '[Select All]');
INSERT INTO `lang_definitions` VALUES (18356, 3459, 14, '[SQL-Ledger]');
INSERT INTO `lang_definitions` VALUES (18357, 3460, 14, '[Mulai Memproses Batch]');
INSERT INTO `lang_definitions` VALUES (18358, 3461, 14, '[Lihat Login]');
INSERT INTO `lang_definitions` VALUES (18359, 3462, 14, '[Lihat cetak Lapor]');
INSERT INTO `lang_definitions` VALUES (18360, 3463, 14, '_PC_DUR_HOURS');
INSERT INTO `lang_definitions` VALUES (18361, 3464, 14, '_PC_DUR_MINUTES');
INSERT INTO `lang_definitions` VALUES (18362, 3465, 14, '_PC_LOCALE');
INSERT INTO `lang_definitions` VALUES (18363, 3466, 14, '~ Tiba terlambat');
INSERT INTO `lang_definitions` VALUES (18364, 1, 15, 'Ένα');
INSERT INTO `lang_definitions` VALUES (18365, 2, 15, 'Αναγνωριστικό νούμερο για την ταυτοποίηση της πληρωμής');
INSERT INTO `lang_definitions` VALUES (18366, 3, 15, 'Μια επίσκεψη GCAG πρέπει να προστεθεί σε αυτήν την επισκεψη.');
INSERT INTO `lang_definitions` VALUES (18367, 4, 15, 'Απαιτείται ενας αριθμός παρτίδας');
INSERT INTO `lang_definitions` VALUES (18368, 6, 15, 'Το μοναδικό αναγνωριστικό αυτού του πεδίου, μη ορατό στο χρήστη');
INSERT INTO `lang_definitions` VALUES (18369, 7, 15, 'προ φαγητού');
INSERT INTO `lang_definitions` VALUES (18370, 8, 15, 'πμ');
INSERT INTO `lang_definitions` VALUES (18371, 11, 15, 'Σύντμηση');
INSERT INTO `lang_definitions` VALUES (18372, 12, 15, 'Απόστημα:');
INSERT INTO `lang_definitions` VALUES (18373, 13, 15, 'Κοιλιακό');
INSERT INTO `lang_definitions` VALUES (18374, 14, 15, 'Σε θέση να φέρει βάρος τέσσερα (4) βήματα:');
INSERT INTO `lang_definitions` VALUES (18375, 15, 15, 'Παθολ.');
INSERT INTO `lang_definitions` VALUES (18376, 17, 15, 'Παθολογικό');
INSERT INTO `lang_definitions` VALUES (18377, 18, 15, 'Παθολογική εξέταση αίματος');
INSERT INTO `lang_definitions` VALUES (18378, 19, 15, 'Παθολογική τριχοφυΐα');
INSERT INTO `lang_definitions` VALUES (18379, 20, 15, 'Παθολογική μαστογραφια');
INSERT INTO `lang_definitions` VALUES (18380, 21, 15, 'Άμβλωση');
INSERT INTO `lang_definitions` VALUES (18381, 22, 15, 'Θέματα άμβλωσης');
INSERT INTO `lang_definitions` VALUES (18382, 23, 15, 'Μέθοδος άμβλωσης');
INSERT INTO `lang_definitions` VALUES (18383, 24, 15, 'Θέματα σχετικά με την άμβλωση');
INSERT INTO `lang_definitions` VALUES (18384, 25, 15, 'Αμβλώσεις');
INSERT INTO `lang_definitions` VALUES (18385, 26, 15, 'Απουσίες ανά διάγνωση');
INSERT INTO `lang_definitions` VALUES (18386, 27, 15, 'Αποδοχή ανάθεσης');
INSERT INTO `lang_definitions` VALUES (18387, 28, 15, 'Αποδοχή πληρωμής για');
INSERT INTO `lang_definitions` VALUES (18388, 29, 15, 'Αποδέχεται την ανάθεση');
INSERT INTO `lang_definitions` VALUES (18389, 30, 15, 'Έλεγχος Πρόσβασης ');
INSERT INTO `lang_definitions` VALUES (18390, 31, 15, 'Διαχείριση δικαιωμάτων πρόσβασης');
INSERT INTO `lang_definitions` VALUES (18391, 32, 15, 'Λογιστική');
INSERT INTO `lang_definitions` VALUES (18392, 33, 15, 'Άλγη');
INSERT INTO `lang_definitions` VALUES (18393, 35, 15, 'ΔικαιώμΠρόσβ');
INSERT INTO `lang_definitions` VALUES (18394, 36, 15, 'Διαχείριση ΔΠ');
INSERT INTO `lang_definitions` VALUES (18395, 37, 15, 'Δεν έχετε δικαίωμα να αλλάξετε τα δικαιώματα πρόσβασης');
INSERT INTO `lang_definitions` VALUES (18396, 38, 15, 'Ακμή');
INSERT INTO `lang_definitions` VALUES (18397, 39, 15, 'Ενέργεια');
INSERT INTO `lang_definitions` VALUES (18398, 40, 15, 'Ημερομηνία ενεργείας');
INSERT INTO `lang_definitions` VALUES (18399, 41, 15, 'Ενεργό');
INSERT INTO `lang_definitions` VALUES (18400, 42, 15, 'Ενεργός Επίσκεψη');
INSERT INTO `lang_definitions` VALUES (18401, 43, 15, 'Ενεργοί κατάλογοι');
INSERT INTO `lang_definitions` VALUES (18402, 44, 15, 'Ενεργός Ασθενής');
INSERT INTO `lang_definitions` VALUES (18403, 45, 15, 'Τύπος δραστηριότητας');
INSERT INTO `lang_definitions` VALUES (18404, 46, 15, 'Οξύ επί χρονίου');
INSERT INTO `lang_definitions` VALUES (18405, 47, 15, 'Προσθήκη');
INSERT INTO `lang_definitions` VALUES (18406, 49, 15, 'Προσθήκη Εταιρείας');
INSERT INTO `lang_definitions` VALUES (18407, 50, 15, 'Προσθήκη Φαρμακείου');
INSERT INTO `lang_definitions` VALUES (18408, 51, 15, 'Προσθήκη Συμβάντος');
INSERT INTO `lang_definitions` VALUES (18409, 52, 15, 'Προσθήκη νέας Σημείωσης');
INSERT INTO `lang_definitions` VALUES (18410, 53, 15, 'Προσθήκη ως Νέο');
INSERT INTO `lang_definitions` VALUES (18411, 54, 15, 'Προσθήκη Κατηγορίας');
INSERT INTO `lang_definitions` VALUES (18412, 55, 15, 'Προσθήκη Σταθεράς');
INSERT INTO `lang_definitions` VALUES (18413, 56, 15, 'Προσθήκη Συμμετοχής');
INSERT INTO `lang_definitions` VALUES (18414, 57, 15, 'Προσθήκη Φαρμάκου');
INSERT INTO `lang_definitions` VALUES (18415, 58, 15, 'Προσθήκη Επίσκεψης');
INSERT INTO `lang_definitions` VALUES (18416, 59, 15, 'Προσθήκη Έδρας');
INSERT INTO `lang_definitions` VALUES (18417, 60, 15, 'Προσθήκη Πεδίου');
INSERT INTO `lang_definitions` VALUES (18418, 61, 15, 'Προσθήκη Ομάδας');
INSERT INTO `lang_definitions` VALUES (18419, 62, 15, 'Προσθήκη Κωδικού ICD');
INSERT INTO `lang_definitions` VALUES (18420, 63, 15, 'Προσθήκη Διάγνωσης');
INSERT INTO `lang_definitions` VALUES (18421, 64, 15, 'Προσθήκη Γλώσσας');
INSERT INTO `lang_definitions` VALUES (18422, 65, 15, 'Προσθήκη Νέου');
INSERT INTO `lang_definitions` VALUES (18423, 66, 15, 'Προσθήκη νέας Κατηγορίας');
INSERT INTO `lang_definitions` VALUES (18424, 67, 15, 'Προσθήκη νέας Ομάδας');
INSERT INTO `lang_definitions` VALUES (18425, 68, 15, 'Προσθήκη νέας Σημείωση');
INSERT INTO `lang_definitions` VALUES (18426, 69, 15, 'Προσθήκη νέας σημείωσης');
INSERT INTO `lang_definitions` VALUES (18427, 70, 15, 'Προσθήκη νέου Συνεργάτη');
INSERT INTO `lang_definitions` VALUES (18428, 71, 15, 'Προσθήκη Σημείωσης');
INSERT INTO `lang_definitions` VALUES (18429, 72, 15, 'Προσθήκη Φακέλου Ασθενούς');
INSERT INTO `lang_definitions` VALUES (18430, 73, 15, 'Προσθήκη Συνταγής');
INSERT INTO `lang_definitions` VALUES (18431, 75, 15, 'Προσθήκη στον Κατάλογο');
INSERT INTO `lang_definitions` VALUES (18432, 76, 15, 'Προσθήκη Συναλλαγής');
INSERT INTO `lang_definitions` VALUES (18433, 77, 15, 'Προσθήκη Χρήστη');
INSERT INTO `lang_definitions` VALUES (18434, 78, 15, 'Καταχώρηση Χρήστη σε Ομάδα');
INSERT INTO `lang_definitions` VALUES (18435, 79, 15, 'προστέθηκε');
INSERT INTO `lang_definitions` VALUES (18436, 80, 15, 'Δεν επιτρέπεται η προσθήκη δημογραφικών στοιχείων.');
INSERT INTO `lang_definitions` VALUES (18437, 81, 15, 'Σύνδρομο Addison');
INSERT INTO `lang_definitions` VALUES (18438, 82, 15, 'Σύνδρομο Addison');
INSERT INTO `lang_definitions` VALUES (18439, 83, 15, 'Πρόσθετη Διάγνωση');
INSERT INTO `lang_definitions` VALUES (18440, 84, 15, 'Πρόσθετο Ιστορικό');
INSERT INTO `lang_definitions` VALUES (18441, 85, 15, 'Πρόσθετες σημειώσεις ιστορικού');
INSERT INTO `lang_definitions` VALUES (18442, 86, 15, 'Πρόσθετες πληροφορίες');
INSERT INTO `lang_definitions` VALUES (18443, 87, 15, 'Πρόσθετα Εργαστηριακά');
INSERT INTO `lang_definitions` VALUES (18444, 88, 15, 'Πρόσθετες Σημειώσεις');
INSERT INTO `lang_definitions` VALUES (18445, 89, 15, 'Πρόσθετες Σημειώσεις:');
INSERT INTO `lang_definitions` VALUES (18446, 90, 15, 'Πρόσθετες Σημειώσεις:');
INSERT INTO `lang_definitions` VALUES (18447, 91, 15, 'Πρόσθετες σημειώσεις Ακτινογραφιών:');
INSERT INTO `lang_definitions` VALUES (18448, 92, 15, 'προσθήκη μόνο');
INSERT INTO `lang_definitions` VALUES (18449, 93, 15, 'Κατ Διευθ');
INSERT INTO `lang_definitions` VALUES (18450, 94, 15, 'Καταλ. διευθύσεων');
INSERT INTO `lang_definitions` VALUES (18451, 95, 15, 'Διεύθυνση');
INSERT INTO `lang_definitions` VALUES (18452, 96, 15, 'Κατάλογος Διευθύνσεων');
INSERT INTO `lang_definitions` VALUES (18453, 97, 15, 'Διεύθυνση 1');
INSERT INTO `lang_definitions` VALUES (18454, 98, 15, 'Διεύθυνση 2');
INSERT INTO `lang_definitions` VALUES (18455, 99, 15, 'Ρυθμ');
INSERT INTO `lang_definitions` VALUES (18456, 100, 15, 'Ρύθμισε');
INSERT INTO `lang_definitions` VALUES (18457, 101, 15, 'Λόγοι αναπροσαρμογής');
INSERT INTO `lang_definitions` VALUES (18458, 102, 15, 'Αναπροσαρμογή τιμής για κωδικό');
INSERT INTO `lang_definitions` VALUES (18459, 103, 15, 'Αναπροσαρμογές');
INSERT INTO `lang_definitions` VALUES (18460, 104, 15, 'Αναπροσαρμογή διαχ.');
INSERT INTO `lang_definitions` VALUES (18461, 105, 15, 'Διαχειριστής');
INSERT INTO `lang_definitions` VALUES (18462, 106, 15, 'Email Διαχειριστή');
INSERT INTO `lang_definitions` VALUES (18463, 107, 15, 'Διαχειρίζεται');
INSERT INTO `lang_definitions` VALUES (18464, 108, 15, 'Διαχειρίζεται από');
INSERT INTO `lang_definitions` VALUES (18465, 109, 15, 'ΔΙΑΧΕΙΡΙΣΗ');
INSERT INTO `lang_definitions` VALUES (18466, 110, 15, 'Διαχειριστές');
INSERT INTO `lang_definitions` VALUES (18467, 111, 15, 'Οι διαχειριστές μπορούν να κάνουν τα πάντα');
INSERT INTO `lang_definitions` VALUES (18468, 112, 15, 'Για προχωρημένους');
INSERT INTO `lang_definitions` VALUES (18469, 113, 15, 'Συμβουλή ');
INSERT INTO `lang_definitions` VALUES (18470, 114, 15, 'Επίδραση στο φυσιολογικό');
INSERT INTO `lang_definitions` VALUES (18471, 115, 15, 'Αργοπορημένες κλήσεις ');
INSERT INTO `lang_definitions` VALUES (18472, 116, 15, 'Μετά την αποθήκευση του PDF, κάντε click στο [Προβολή Log] για έλεγχο λαθών');
INSERT INTO `lang_definitions` VALUES (18473, 117, 15, 'Μετά την αποθήκευση της δέσμης ενεργειών σας, κάντε click στο [Προβολή Log] για έλεγχο λαθών');
INSERT INTO `lang_definitions` VALUES (18474, 118, 15, 'Αν οι πληροφορίες που εισάγατε είναι σωστές πατήστε το κουμπί Αποθήκευση');
INSERT INTO `lang_definitions` VALUES (18475, 119, 15, 'Ξανά');
INSERT INTO `lang_definitions` VALUES (18476, 120, 15, 'Ηλικία');
INSERT INTO `lang_definitions` VALUES (18477, 121, 15, 'Ηλικία ανά');
INSERT INTO `lang_definitions` VALUES (18478, 122, 15, 'Κατηγορία ηλικίας');
INSERT INTO `lang_definitions` VALUES (18479, 123, 15, 'Οι πληροφορίες ηλικίας είναι έκτος ορίων');
INSERT INTO `lang_definitions` VALUES (18480, 124, 15, 'Η μορφή της ηλικίας για \"ηλικία από\" δεν είναι έγκυρη ');
INSERT INTO `lang_definitions` VALUES (18481, 125, 15, 'Η μορφή της ηλικίας για \"ηλικία μέχρι\" δεν είναι έγκυρη ');
INSERT INTO `lang_definitions` VALUES (18482, 126, 15, 'Ηλικία Από');
INSERT INTO `lang_definitions` VALUES (18483, 127, 15, 'Στήλες Ηλικίας:');
INSERT INTO `lang_definitions` VALUES (18484, 128, 15, 'Αλκοόλ');
INSERT INTO `lang_definitions` VALUES (18485, 129, 15, 'Κατανάλωση αλκοόλ');
INSERT INTO `lang_definitions` VALUES (18486, 130, 15, 'Όλα');
INSERT INTO `lang_definitions` VALUES (18487, 131, 15, 'Όλες οι κατηγορίες');
INSERT INTO `lang_definitions` VALUES (18488, 132, 15, 'Ολοήμερο');
INSERT INTO `lang_definitions` VALUES (18489, 133, 15, 'Ολοήμερο συμβάν');
INSERT INTO `lang_definitions` VALUES (18490, 134, 15, 'Όλες οι εγκαταστάσεις');
INSERT INTO `lang_definitions` VALUES (18491, 135, 15, 'Όνομα ή μέρος αυτού');
INSERT INTO `lang_definitions` VALUES (18492, 136, 15, 'Επώνυμο ή μέρος αυτού');
INSERT INTO `lang_definitions` VALUES (18493, 137, 15, 'Όλοι οι Παροχοι');
INSERT INTO `lang_definitions` VALUES (18494, 138, 15, 'Όλα ελέγχθηκαν και ήταν αρνητικά:');
INSERT INTO `lang_definitions` VALUES (18495, 139, 15, 'Όλα τα θέματα:');
INSERT INTO `lang_definitions` VALUES (18496, 140, 15, 'Όλοι οι Χρήστες');
INSERT INTO `lang_definitions` VALUES (18497, 141, 15, 'Αλλεργικό');
INSERT INTO `lang_definitions` VALUES (18498, 142, 15, 'Αλλεργίες');
INSERT INTO `lang_definitions` VALUES (18499, 143, 15, 'Αλλεργίες:');
INSERT INTO `lang_definitions` VALUES (18500, 144, 15, 'Αλλεργία');
INSERT INTO `lang_definitions` VALUES (18501, 145, 15, 'Να επιτρέπεται email');
INSERT INTO `lang_definitions` VALUES (18502, 146, 15, 'Να επιτρέπεται η αποστολή email');
INSERT INTO `lang_definitions` VALUES (18503, 147, 15, 'Να επιτρέπεται η αποστολή email');
INSERT INTO `lang_definitions` VALUES (18504, 148, 15, 'Να επιτρέπεται mail message');
INSERT INTO `lang_definitions` VALUES (18505, 149, 15, 'Να επιτρέπονται τα SMS');
INSERT INTO `lang_definitions` VALUES (18506, 150, 15, 'Να επιτρέπονται τα SMS (μυνήματα)?');
INSERT INTO `lang_definitions` VALUES (18507, 151, 15, 'Τα συμβάντα που καταχωρούνται να γίνονται ενεργά αυτόματα;');
INSERT INTO `lang_definitions` VALUES (18508, 152, 15, 'Να επιτρέπονται τα τηλεφωνικά μυνήματα?');
INSERT INTO `lang_definitions` VALUES (18509, 153, 15, 'Οι χρήστες να δημοσιεύουν Ολικά Συμβάντα');
INSERT INTO `lang_definitions` VALUES (18510, 154, 15, 'Οι χρήστες να δημοσιεύουν Προσωπικά Ημερολόγια');
INSERT INTO `lang_definitions` VALUES (18511, 155, 15, 'Να επιτρέπονται τα φωνητικά μυνήματα');
INSERT INTO `lang_definitions` VALUES (18512, 156, 15, 'Επιτρέπεται');
INSERT INTO `lang_definitions` VALUES (18513, 157, 15, 'ήδη υπάρχει,');
INSERT INTO `lang_definitions` VALUES (18514, 158, 15, 'Χρησιμοποιείται ήδη, επιλέξτε διαφορετικό αναγνωριστικό');
INSERT INTO `lang_definitions` VALUES (18515, 159, 15, 'Χρησιμοποιείται ήδη, επιλέξτε διαφορετικό τίτλο');
INSERT INTO `lang_definitions` VALUES (18516, 160, 15, 'Εναλλακτική Διεύθυνση');
INSERT INTO `lang_definitions` VALUES (18517, 162, 15, 'Εναλλακτικά, μπορείτε να χρησιμοποιήσετε τη σελίδα αναζήτησης για να φορτώσετε ένα αρχείο ηλεκτρονικού εμβάσματος (X12 835) που έχετε λάβει από τον πληρωτή ή το γραφείο συμψηφισμού σας. Μπορείτε να το κάνετε αυτό κάνοντας κλικ στο κουμπί \"Περιήγηση\" και επιλέγοντας το αρχείο για να φορτώσετε, και στη συνέχεια, επιλέξτε Αναζήτηση για να εκτελέσει τη μεταφόρτωση και την απεικόνιση των αντίστοιχων τιμολογίων. Στην περίπτωση αυτή, οι λοιπές παράμετροι που αναφέρονται παραπάνω δεν ισχύουν και θα πρέπει να αγνοηθούν. Η μεταφόρτωση αποθηκεύει το αρχείο, αλλά δεν επεξεργάζεται ακόμη το περιεχόμενό του - αυτό γίνεται ξεχωριστά, όπως περιγράφεται κατωτέρω.');
INSERT INTO `lang_definitions` VALUES (18518, 164, 15, 'Τροποποίηση υφιστάμενης σημείωσης');
INSERT INTO `lang_definitions` VALUES (18519, 165, 15, 'AMEX');
INSERT INTO `lang_definitions` VALUES (18520, 166, 15, 'Ποσό');
INSERT INTO `lang_definitions` VALUES (18521, 167, 15, 'Ποσό χρέωσης');
INSERT INTO `lang_definitions` VALUES (18522, 168, 15, 'Ποσό για τον παρών λογαριασμό');
INSERT INTO `lang_definitions` VALUES (18523, 169, 15, 'Ποσό για την παρούσα επίσκεψη');
INSERT INTO `lang_definitions` VALUES (18524, 170, 15, 'Πληρωθέν Ποσό');
INSERT INTO `lang_definitions` VALUES (18525, 171, 15, 'Ποσό:');
INSERT INTO `lang_definitions` VALUES (18526, 175, 15, 'Ένα ατελές θέμα GCAC έχει δημιουργηθεί και συνδεθεί. Κάποιος θα πρέπει να το ολοκληρώσει αργότερα.');
INSERT INTO `lang_definitions` VALUES (18527, 176, 15, 'Και');
INSERT INTO `lang_definitions` VALUES (18528, 177, 15, 'ΚΑΙ');
INSERT INTO `lang_definitions` VALUES (18529, 178, 15, 'και');
INSERT INTO `lang_definitions` VALUES (18530, 179, 15, 'και');
INSERT INTO `lang_definitions` VALUES (18531, 180, 15, 'και όλα τα δευτερεύοντα στοιχεία; Η ενέργεια θα καταγραφεί.');
INSERT INTO `lang_definitions` VALUES (18532, 181, 15, 'Αναιμία');
INSERT INTO `lang_definitions` VALUES (18533, 182, 15, 'Αστράγαλος');
INSERT INTO `lang_definitions` VALUES (18534, 183, 15, 'Αστράγαλος + πτέρνα');
INSERT INTO `lang_definitions` VALUES (18535, 184, 15, 'Έντυπο εκτίμησης του αστραγάλου');
INSERT INTO `lang_definitions` VALUES (18536, 185, 15, 'Προβλήματα αστραγάλου');
INSERT INTO `lang_definitions` VALUES (18537, 186, 15, 'Αγκυλοποιητική Σπονδυλίτιδα');
INSERT INTO `lang_definitions` VALUES (18538, 187, 15, 'Αγκυλοποιητική Σπονδυλίτιδα');
INSERT INTO `lang_definitions` VALUES (18539, 188, 15, 'Ανορεξία');
INSERT INTO `lang_definitions` VALUES (18540, 189, 15, 'Ένα άλλο πράγμα που μπορείτε να κάνετε στο παράθυρο αποστολής είναι αίτηση δευτερεύουσας χρέωσης. Αν επιλέξετε αυτό το πλαίσιο πριν από την αποθήκευση, τότε η αρχική αγωγή θα πρέπει να ανοίξει εκ νέου και να τοποθετηθεί στην ουρά στη σελίδα Χρεώσεων, και θα υποβληθεί σε επεξεργασία κατά τη διάρκεια της επόμενης διαδικασίας χρέωσης.');
INSERT INTO `lang_definitions` VALUES (18541, 191, 15, 'Δακτύλιος κφ, χωρίς ορθική ευαισθησία/μάζα');
INSERT INTO `lang_definitions` VALUES (18542, 192, 15, 'Άγχος');
INSERT INTO `lang_definitions` VALUES (18543, 193, 15, 'Όλοι');
INSERT INTO `lang_definitions` VALUES (18544, 194, 15, 'Κάθε Κατηγορία');
INSERT INTO `lang_definitions` VALUES (18545, 195, 15, 'Κάθε τμήμα του επιθυμητού κωδικού ή της περιγραφής του');
INSERT INTO `lang_definitions` VALUES (18546, 196, 15, 'Κάθε τμήμα της επιθυμητής ειδικότητας');
INSERT INTO `lang_definitions` VALUES (18547, 197, 15, 'Οποιοδήποτε τμήμα του ονόματος του ασθενούς η “επώνυμο,όνομα” η “Χ-Υ”');
INSERT INTO `lang_definitions` VALUES (18548, 198, 15, 'Άπνοια');
INSERT INTO `lang_definitions` VALUES (18549, 199, 15, 'Εμφάνιση ');
INSERT INTO `lang_definitions` VALUES (18550, 200, 15, 'Εμφάνιση: ');
INSERT INTO `lang_definitions` VALUES (18551, 201, 15, 'Προσάρτηση στην υπάρχουσα σημείωση');
INSERT INTO `lang_definitions` VALUES (18552, 202, 15, 'Προσάρτηση σε αυτή τη σημείωση');
INSERT INTO `lang_definitions` VALUES (18553, 203, 15, 'Προσάρτηση σε αυτή τη σημείωση');
INSERT INTO `lang_definitions` VALUES (18554, 204, 15, 'Σκωληκοειδεκτομή');
INSERT INTO `lang_definitions` VALUES (18555, 206, 15, 'εφάρμοσε στην προσβεβλημένη περιοχή');
INSERT INTO `lang_definitions` VALUES (18556, 207, 15, 'εφάρμοσε στο δέρμα');
INSERT INTO `lang_definitions` VALUES (18557, 209, 15, 'Ημερομηνία Ραντεβού');
INSERT INTO `lang_definitions` VALUES (18558, 210, 15, 'Κατάσταση Ραντεβού');
INSERT INTO `lang_definitions` VALUES (18559, 211, 15, 'Ραντεβού εντός');
INSERT INTO `lang_definitions` VALUES (18560, 212, 15, 'Ραντεβού');
INSERT INTO `lang_definitions` VALUES (18561, 213, 15, 'Ραντεβού (εγγραφή προαιρετικά)');
INSERT INTO `lang_definitions` VALUES (18562, 214, 15, 'Ραντεβού και Επισκέψεις');
INSERT INTO `lang_definitions` VALUES (18563, 215, 15, 'Αναφορά Ραντεβού');
INSERT INTO `lang_definitions` VALUES (18564, 216, 15, 'Αναφορά Ραντεβού-Επισκέψεων');
INSERT INTO `lang_definitions` VALUES (18565, 217, 15, 'Επιβεβαίωση');
INSERT INTO `lang_definitions` VALUES (18566, 218, 15, 'Επιβεβαιώθηκε');
INSERT INTO `lang_definitions` VALUES (18567, 219, 15, 'Διαχείριση Επιβεβαιωθέντων συνεδριών');
INSERT INTO `lang_definitions` VALUES (18568, 220, 15, 'Ραντ-Επισκ');
INSERT INTO `lang_definitions` VALUES (18569, 221, 15, 'Ραντ');
INSERT INTO `lang_definitions` VALUES (18570, 222, 15, 'Απρίλιος');
INSERT INTO `lang_definitions` VALUES (18571, 225, 15, 'Είστε σίγουρος ότι θέλετε να επικυρώσετε αυτά τα συμβάντα;');
INSERT INTO `lang_definitions` VALUES (18572, 226, 15, 'Είστε σίγουρος ότι θέλετε να διαγράψετε πλήρως αυτό το Έντυπο;');
INSERT INTO `lang_definitions` VALUES (18573, 227, 15, 'Είστε σίγουρος ότι θέλετε να διαγράψετε αυτό το συμβάν;');
INSERT INTO `lang_definitions` VALUES (18574, 229, 15, 'Είστε σίγουρος ότι θέλετε να διαγράψετε αυτό τη σημείωση;');
INSERT INTO `lang_definitions` VALUES (18575, 230, 15, 'Είστε σίγουρος ότι θέλετε να τροποποιήσετε αυτά τα συμβάντα;');
INSERT INTO `lang_definitions` VALUES (18576, 231, 15, 'Είστε σίγουρος ότι θέλετε να αποκρύψετε αυτά τα συμβάντα;');
INSERT INTO `lang_definitions` VALUES (18577, 232, 15, 'Είστε σίγουρος ότι θέλετε να δείτε αυτά τα συμβάντα;');
INSERT INTO `lang_definitions` VALUES (18578, 233, 15, 'Είστε σίγουρος ότι θέλετε να διαγράψετε το γκρουπ ');
INSERT INTO `lang_definitions` VALUES (18579, 234, 15, 'Είστε σίγουρος ότι θέλετε να διαγράψετε ολόκληρη τη λίστα');
INSERT INTO `lang_definitions` VALUES (18580, 235, 15, 'Είστε σίγουρος ότι θέλετε να διαγράψετε τα περιεχόμενα του πεδίου');
INSERT INTO `lang_definitions` VALUES (18581, 236, 15, 'Είστε σίγουρος ότι θέλετε να διαγράψετε τα επιλεγμένα πεδία;');
INSERT INTO `lang_definitions` VALUES (18582, 237, 15, 'Είστε σίγουρος ότι θέλετε να προχωρήσετε με αυτές τις ενέργειες;');
INSERT INTO `lang_definitions` VALUES (18583, 238, 15, 'Μη καθορισμένη περιοχή');
INSERT INTO `lang_definitions` VALUES (18584, 239, 15, 'Αρμενικά');
INSERT INTO `lang_definitions` VALUES (18585, 240, 15, 'Αρρυθμία');
INSERT INTO `lang_definitions` VALUES (18586, 241, 15, 'Αρθρίτιδα ');
INSERT INTO `lang_definitions` VALUES (18587, 242, 15, 'Αρθρίτιδα / εκφυλιστική νόσος άρθρωσης');
INSERT INTO `lang_definitions` VALUES (18588, 243, 15, 'Αρθρίτιδα / εκφυλ. νόσος άρθρωσης');
INSERT INTO `lang_definitions` VALUES (18589, 244, 15, 'όπως');
INSERT INTO `lang_definitions` VALUES (18590, 245, 15, 'Όπως σαν');
INSERT INTO `lang_definitions` VALUES (18591, 246, 15, 'Ασιατικό');
INSERT INTO `lang_definitions` VALUES (18592, 247, 15, 'Επίκριση');
INSERT INTO `lang_definitions` VALUES (18593, 248, 15, 'Ανατέθηκε στον');
INSERT INTO `lang_definitions` VALUES (18594, 249, 15, 'Επικουρικός');
INSERT INTO `lang_definitions` VALUES (18595, 250, 15, 'Άσθμα');
INSERT INTO `lang_definitions` VALUES (18596, 251, 15, 'στο');
INSERT INTO `lang_definitions` VALUES (18597, 252, 15, 'Στη σκαφοειδική');
INSERT INTO `lang_definitions` VALUES (18598, 253, 15, 'Στη σκαφοειδική:');
INSERT INTO `lang_definitions` VALUES (18599, 254, 15, 'Αθλητικός/Κάκωση');
INSERT INTO `lang_definitions` VALUES (18600, 255, 15, 'Προσοχή');
INSERT INTO `lang_definitions` VALUES (18601, 256, 15, 'Προσοχή');
INSERT INTO `lang_definitions` VALUES (18602, 257, 15, 'Αύγουστος');
INSERT INTO `lang_definitions` VALUES (18603, 258, 15, 'Εξουσ');
INSERT INTO `lang_definitions` VALUES (18604, 259, 15, 'Εξουσ/σημειώσεις');
INSERT INTO `lang_definitions` VALUES (18605, 260, 15, 'Εξουσιοδοτήσεις');
INSERT INTO `lang_definitions` VALUES (18606, 261, 15, 'Εξουσιοδότησε');
INSERT INTO `lang_definitions` VALUES (18607, 262, 15, 'Εξουσιοδότησε – κάθε επίσκεψη');
INSERT INTO `lang_definitions` VALUES (18608, 263, 15, 'Εξουσιοδότησε – οι επισκέψεις μου');
INSERT INTO `lang_definitions` VALUES (18609, 264, 15, 'Εξουσιοδοτημένος');
INSERT INTO `lang_definitions` VALUES (18610, 265, 15, 'Αυτόματη Αποστολή');
INSERT INTO `lang_definitions` VALUES (18611, 266, 15, 'Αυτόματη δημιουργία');
INSERT INTO `lang_definitions` VALUES (18612, 267, 15, 'Ιατρικό αυτοκίνητο');
INSERT INTO `lang_definitions` VALUES (18613, 268, 15, 'αυτόματα αποθηκευμένο');
INSERT INTO `lang_definitions` VALUES (18614, 269, 15, 'Διαθέσιμοι χρόνοι');
INSERT INTO `lang_definitions` VALUES (18615, 270, 15, 'Αποκόλληση / Αποκολληθέν κάταγμα');
INSERT INTO `lang_definitions` VALUES (18616, 271, 15, 'Αποκόλληση έξω σφυρού');
INSERT INTO `lang_definitions` VALUES (18617, 272, 15, 'Αποκόλληση έσω σφυρού');
INSERT INTO `lang_definitions` VALUES (18618, 273, 15, 'Βασισμένος στη γνώση');
INSERT INTO `lang_definitions` VALUES (18619, 274, 15, 'Μασχάλη');
INSERT INTO `lang_definitions` VALUES (18620, 275, 15, '2 φορές την ημέρα');
INSERT INTO `lang_definitions` VALUES (18621, 276, 15, 'επιστροφή');
INSERT INTO `lang_definitions` VALUES (18622, 277, 15, 'Επιστροφή');
INSERT INTO `lang_definitions` VALUES (18623, 284, 15, 'Προβλήματα οσφύος');
INSERT INTO `lang_definitions` VALUES (18624, 287, 15, 'Εγχείρηση στον οσφύ');
INSERT INTO `lang_definitions` VALUES (18625, 292, 15, 'Backup');
INSERT INTO `lang_definitions` VALUES (18626, 293, 15, 'Το αρχείο για το backup δημιουργήθηκε. Είναι έτοιμο για download');
INSERT INTO `lang_definitions` VALUES (18627, 294, 15, 'Κακός έλεγχος');
INSERT INTO `lang_definitions` VALUES (18628, 295, 15, 'Κακό χρέος');
INSERT INTO `lang_definitions` VALUES (18629, 296, 15, 'Ινδονησιακά Bahasa');
INSERT INTO `lang_definitions` VALUES (18630, 298, 15, 'Υπόλοιπο');
INSERT INTO `lang_definitions` VALUES (18631, 299, 15, 'υπόλοιπο');
INSERT INTO `lang_definitions` VALUES (18632, 300, 15, 'Οφειλόμενο υπόλοιπο');
INSERT INTO `lang_definitions` VALUES (18633, 301, 15, 'Βάση του 5ου μεταταρσίου');
INSERT INTO `lang_definitions` VALUES (18634, 302, 15, 'Βάση του 5ου μεταταρσίου:');
INSERT INTO `lang_definitions` VALUES (18635, 303, 15, 'Εργαλείο επικοινωνίας δέσμης ενεργειών');
INSERT INTO `lang_definitions` VALUES (18636, 304, 15, 'Ξεκίνησε η επεξεργασία, μπορεί να διαρκέσει λίγο');
INSERT INTO `lang_definitions` VALUES (18637, 306, 15, 'επειδή εκείνο το αναγνωριστικό δεν υπάρχει');
INSERT INTO `lang_definitions` VALUES (18638, 307, 15, 'Έναρξη');
INSERT INTO `lang_definitions` VALUES (18639, 308, 15, 'Ημερομηνία Έναρξης ');
INSERT INTO `lang_definitions` VALUES (18640, 309, 15, 'Αρχική ημερομηνία υπηρεσίας εεεε-μμ-ηη');
INSERT INTO `lang_definitions` VALUES (18641, 310, 15, 'Ερυγές');
INSERT INTO `lang_definitions` VALUES (18642, 311, 15, 'ενδιάμεσο');
INSERT INTO `lang_definitions` VALUES (18643, 312, 15, 'Αμφοτερόπλευρο');
INSERT INTO `lang_definitions` VALUES (18644, 313, 15, 'Ημερομηνία χρέωσης:');
INSERT INTO `lang_definitions` VALUES (18645, 314, 15, 'Χρέωση/Συλλογή');
INSERT INTO `lang_definitions` VALUES (18646, 315, 15, 'Χρεωμένος');
INSERT INTO `lang_definitions` VALUES (18647, 316, 15, 'Χρέωση');
INSERT INTO `lang_definitions` VALUES (18648, 317, 15, 'Χρέωση (εγγραφή προαιρετικά)');
INSERT INTO `lang_definitions` VALUES (18649, 319, 15, 'Κωδικό χρεώσεων για αιτούμενες υπηρεσίες');
INSERT INTO `lang_definitions` VALUES (18650, 320, 15, 'Κωδικοί χρεώσης');
INSERT INTO `lang_definitions` VALUES (18651, 321, 15, 'Πληροφορίες χρέωσης');
INSERT INTO `lang_definitions` VALUES (18652, 322, 15, 'Τοποθεσίες χρέωσης');
INSERT INTO `lang_definitions` VALUES (18653, 323, 15, 'Σημείωμα χρεώσης');
INSERT INTO `lang_definitions` VALUES (18654, 324, 15, 'Σημείωμα χρεώσης για');
INSERT INTO `lang_definitions` VALUES (18655, 325, 15, 'Σημείωμα χρεώσης:');
INSERT INTO `lang_definitions` VALUES (18656, 326, 15, 'Αποτελέσματα ουράς χρέωσης:');
INSERT INTO `lang_definitions` VALUES (18657, 327, 15, 'Αναφορά χρέωσης:');
INSERT INTO `lang_definitions` VALUES (18658, 328, 15, 'χρέωση στον');
INSERT INTO `lang_definitions` VALUES (18659, 329, 15, 'Βιοψία');
INSERT INTO `lang_definitions` VALUES (18660, 330, 15, 'Ημερομηνία Γέννησης');
INSERT INTO `lang_definitions` VALUES (18661, 331, 15, 'Μαύρος/η/ο');
INSERT INTO `lang_definitions` VALUES (18662, 332, 15, 'Καρκίνος ουροδόχου κύστεως');
INSERT INTO `lang_definitions` VALUES (18663, 333, 15, 'Λοιμώξεις ουροδόχου κύστεως');
INSERT INTO `lang_definitions` VALUES (18664, 334, 15, 'Λευκά Έντυπα');
INSERT INTO `lang_definitions` VALUES (18665, 335, 15, 'Προβλήματα αιμορραγίας');
INSERT INTO `lang_definitions` VALUES (18666, 336, 15, 'Τυφλά σημεία');
INSERT INTO `lang_definitions` VALUES (18667, 337, 15, 'Αίσθημα βάρους');
INSERT INTO `lang_definitions` VALUES (18668, 338, 15, 'Απoκλεισμένο');
INSERT INTO `lang_definitions` VALUES (18669, 339, 15, 'Αρτηριακή Πίεση');
INSERT INTO `lang_definitions` VALUES (18670, 340, 15, 'Αρτηριακή Πίεση');
INSERT INTO `lang_definitions` VALUES (18671, 341, 15, 'Ρινορραγία');
INSERT INTO `lang_definitions` VALUES (18672, 342, 15, 'Μπλε Σημαια του Κυανου Σταυρου');
INSERT INTO `lang_definitions` VALUES (18673, 343, 15, 'Σ\'αυτην την έκθεση, οι μπλέ γραμμές είναι για πληροφόρηση. Οι μαύρες αναφέρονται στα προηγούμενα στοιχεία. Οι πράσινες δείχνουν τις επιτυχημένες αλλαγές. Οι κόκκενες τα λάθη ή της λανθασμένες αλλαγές, οι οποίες πρέπει να επεξεργαστούν με το χέρι. Προς το παρόν οι αρνήσεις και επιστροφές πληρωμών δεν γίνονται αυτόματα');
INSERT INTO `lang_definitions` VALUES (18674, 344, 15, 'Θόλωση όρασης');
INSERT INTO `lang_definitions` VALUES (18675, 345, 15, 'Δείκτης Μάζας Σώματος');
INSERT INTO `lang_definitions` VALUES (18676, 346, 15, 'Κατασταση Δεικτη Μαζας Σωματος');
INSERT INTO `lang_definitions` VALUES (18677, 347, 15, 'Περιοχή σώματος');
INSERT INTO `lang_definitions` VALUES (18678, 348, 15, 'Οστική ευαισθησία:');
INSERT INTO `lang_definitions` VALUES (18679, 349, 15, 'Οστική ευαισθησία: έσω σφυρός');
INSERT INTO `lang_definitions` VALUES (18680, 350, 15, 'Λογική μεταβλητή');
INSERT INTO `lang_definitions` VALUES (18681, 351, 15, 'Κάτω');
INSERT INTO `lang_definitions` VALUES (18682, 352, 15, 'Σε αμφότερα ώτα');
INSERT INTO `lang_definitions` VALUES (18683, 353, 15, 'σε αμφότερα ώτα');
INSERT INTO `lang_definitions` VALUES (18684, 354, 15, 'Κάτω');
INSERT INTO `lang_definitions` VALUES (18685, 355, 15, 'Πεδίο 10 Α. Σχετικός με την απασχόληση');
INSERT INTO `lang_definitions` VALUES (18686, 356, 15, 'Πεδίο 10 Β. Αυτοκινητιστικό Ατύχημα');
INSERT INTO `lang_definitions` VALUES (18687, 357, 15, 'Πεδίο 10 C. Άλλο Ατύχημα');
INSERT INTO `lang_definitions` VALUES (18688, 358, 15, 'Πεδίο 16. Ανικανότητα για εργασία απο (εεεε-μμ-ηη)');
INSERT INTO `lang_definitions` VALUES (18689, 359, 15, 'Πεδίο 16. Ανικανότητα για εργασία έως (εεεε-μμ-ηη)');
INSERT INTO `lang_definitions` VALUES (18690, 360, 15, 'Πεδίο 18. Νοσηλεύθηκε από (εεεε-μμ-ηη)');
INSERT INTO `lang_definitions` VALUES (18691, 361, 15, 'Πεδίο 18. Νοσηλεύθηκε έως (εεεε-μμ-ηη)');
INSERT INTO `lang_definitions` VALUES (18692, 362, 15, 'Πεδίο 20. Χρησιμοποιήθηκε εξωτερικό εργαστήριο;');
INSERT INTO `lang_definitions` VALUES (18693, 363, 15, 'Πεδίο 22. Κωδικος επαναποστολης στο Medicaid (ICD-9)');
INSERT INTO `lang_definitions` VALUES (18694, 364, 15, 'Πεδίο 23. Αριθμός προηγούμενης αδείας.');
INSERT INTO `lang_definitions` VALUES (18695, 366, 15, 'Διαστολικη ΑΠ');
INSERT INTO `lang_definitions` VALUES (18696, 367, 15, 'Συστολικη ΑΠ');
INSERT INTO `lang_definitions` VALUES (18697, 368, 15, 'ΔΑΠ');
INSERT INTO `lang_definitions` VALUES (18698, 369, 15, 'ΣΑΠ');
INSERT INTO `lang_definitions` VALUES (18699, 370, 15, 'Βραζιλιανικα πορτογαλικα');
INSERT INTO `lang_definitions` VALUES (18700, 371, 15, 'Μαστος');
INSERT INTO `lang_definitions` VALUES (18701, 372, 15, 'Βιοψια μαστου');
INSERT INTO `lang_definitions` VALUES (18702, 373, 15, 'Εκκριμα μαστου');
INSERT INTO `lang_definitions` VALUES (18703, 374, 15, 'Νόσος μαστών');
INSERT INTO `lang_definitions` VALUES (18704, 375, 15, 'Εξέταση μαστών');
INSERT INTO `lang_definitions` VALUES (18705, 376, 15, 'Μάζα μαστού');
INSERT INTO `lang_definitions` VALUES (18706, 377, 15, 'Αναπνευστικοί ήχοι:');
INSERT INTO `lang_definitions` VALUES (18707, 378, 15, 'Κατάγματα');
INSERT INTO `lang_definitions` VALUES (18708, 379, 15, 'Εντυπο βρογχίτιδας');
INSERT INTO `lang_definitions` VALUES (18709, 380, 15, 'Αναζήτηση');
INSERT INTO `lang_definitions` VALUES (18710, 381, 15, 'Αναζήτηση Φακέλου');
INSERT INTO `lang_definitions` VALUES (18711, 382, 15, 'Μώλωπας/αιμάτωμα');
INSERT INTO `lang_definitions` VALUES (18712, 383, 15, 'Πρόπτωση Δεξιά:');
INSERT INTO `lang_definitions` VALUES (18713, 384, 15, 'Καύσος με την ούρηση');
INSERT INTO `lang_definitions` VALUES (18714, 385, 15, 'Καύσος με την ούρηση');
INSERT INTO `lang_definitions` VALUES (18715, 386, 15, 'Απασχολημένος ');
INSERT INTO `lang_definitions` VALUES (18716, 387, 15, 'Γλουτός και ιερολαγόνια');
INSERT INTO `lang_definitions` VALUES (18717, 388, 15, 'με το');
INSERT INTO `lang_definitions` VALUES (18718, 389, 15, 'από το στόμα');
INSERT INTO `lang_definitions` VALUES (18719, 390, 15, 'Με/Πηγή');
INSERT INTO `lang_definitions` VALUES (18720, 391, 15, 'Έως:');
INSERT INTO `lang_definitions` VALUES (18721, 392, 15, 'C');
INSERT INTO `lang_definitions` VALUES (18722, 393, 15, 'Διάρκεια αποθήκευσης πρωσωρινών δεδομένων (σε δευτερόλεπτα)');
INSERT INTO `lang_definitions` VALUES (18723, 394, 15, 'Έξοδος cache χωροθέτησης;');
INSERT INTO `lang_definitions` VALUES (18724, 395, 15, 'Κατανάλωση Καφείνης');
INSERT INTO `lang_definitions` VALUES (18725, 396, 15, 'Ημερολόγιο');
INSERT INTO `lang_definitions` VALUES (18726, 397, 15, 'Ρυθμίσεις Ημερολογίου');
INSERT INTO `lang_definitions` VALUES (18727, 398, 15, 'Εμφάνιση Ημερολογίου');
INSERT INTO `lang_definitions` VALUES (18728, 399, 15, 'Προβολή Ημερολογίου');
INSERT INTO `lang_definitions` VALUES (18729, 400, 15, 'Η κληση στην addForm() πηγαινει εδω.<br>');
INSERT INTO `lang_definitions` VALUES (18730, 402, 15, 'CAMOS');
INSERT INTO `lang_definitions` VALUES (18731, 403, 15, 'Ακύρωση ');
INSERT INTO `lang_definitions` VALUES (18732, 404, 15, 'Καρκίνος ');
INSERT INTO `lang_definitions` VALUES (18733, 405, 15, 'Δεν μπορει να προστεθει αυτη η καταχωρηση γιατι υπαρχει ηδη');
INSERT INTO `lang_definitions` VALUES (18734, 406, 15, 'Δεν μπορή να γίνει προσθήκη/αλλαγή - διπλότυπη εγγραφή στη βάση');
INSERT INTO `lang_definitions` VALUES (18735, 407, 15, 'δεν μπορεί να γίνει μετατροπή σε JPEG. Πιθανώς να μην είναι εγκατεστημένο το ImageMagick;');
INSERT INTO `lang_definitions` VALUES (18736, 408, 15, 'δεν είναι δυνατή η εμφάνιση διότι ο browser δεν υποστηρίσει τη εντολή inline');
INSERT INTO `lang_definitions` VALUES (18737, 409, 15, 'δεν είναι δυνατή η εμφάνιση διότι ο browser δεν υποστηρίσει τη εντολή inline');
INSERT INTO `lang_definitions` VALUES (18738, 410, 15, 'δεν είναι δυνατή η εμφάνιση διότι ο browser δεν υποστηρίσει τη εντολή inline');
INSERT INTO `lang_definitions` VALUES (18739, 411, 15, 'Δεν είναι δυνατή η δημιουργία ');
INSERT INTO `lang_definitions` VALUES (18740, 412, 15, 'Δεν είναι δυνατή η εύρεση');
INSERT INTO `lang_definitions` VALUES (18741, 413, 15, 'Δεν είναι δυνατή η εύρεση του ασθενή από το SQL-Ledger με βάση το customer id');
INSERT INTO `lang_definitions` VALUES (18742, 414, 15, 'Δεν είναι δυνατή της αναφοράς στο postscript έγγραφο');
INSERT INTO `lang_definitions` VALUES (18743, 415, 15, 'Δεν είναι δυνατή η εύρεση του παρόχου απόν εργαζόμενο του SQL-Ledger =');
INSERT INTO `lang_definitions` VALUES (18744, 416, 15, 'Δεν είναι δυνατό το άνοιγμα ');
INSERT INTO `lang_definitions` VALUES (18745, 417, 15, 'Δεν είναι δυνατη η αναγνωση');
INSERT INTO `lang_definitions` VALUES (18746, 418, 15, 'Δεν είναι δυνατή η ενημέρωση γιατί δεν επεξεργάζεστε υπάρχουσα καταχώρηση');
INSERT INTO `lang_definitions` VALUES (18747, 419, 15, 'καψάκιο (caps)');
INSERT INTO `lang_definitions` VALUES (18748, 420, 15, 'Καρδιακός καθετηριασμός');
INSERT INTO `lang_definitions` VALUES (18749, 421, 15, 'Καρδιακό υπερηχογράφημα');
INSERT INTO `lang_definitions` VALUES (18750, 422, 15, 'Καρδιαγγειακό');
INSERT INTO `lang_definitions` VALUES (18751, 423, 15, 'Βλάβη χόνδρου / δίσκου');
INSERT INTO `lang_definitions` VALUES (18752, 424, 15, 'Κάκωση χόνδρου');
INSERT INTO `lang_definitions` VALUES (18753, 425, 15, 'Σφύξης καρωτίδας κφ, αρτηριών ποδός κφ');
INSERT INTO `lang_definitions` VALUES (18754, 426, 15, 'μετρητά ');
INSERT INTO `lang_definitions` VALUES (18755, 427, 15, 'Μετρητά ');
INSERT INTO `lang_definitions` VALUES (18756, 428, 15, 'Μετρητά ');
INSERT INTO `lang_definitions` VALUES (18757, 429, 15, 'Αποδείξεις Μετρητών ανά Πάροχο');
INSERT INTO `lang_definitions` VALUES (18758, 430, 15, 'Εγχείρηση καταρράκτη');
INSERT INTO `lang_definitions` VALUES (18759, 431, 15, 'Καταρράκτης ');
INSERT INTO `lang_definitions` VALUES (18760, 432, 15, 'Κατηγορίες ');
INSERT INTO `lang_definitions` VALUES (18761, 433, 15, 'Κατηγορία ');
INSERT INTO `lang_definitions` VALUES (18762, 434, 15, 'κατηγορία ');
INSERT INTO `lang_definitions` VALUES (18763, 435, 15, 'Κατηγορία ');
INSERT INTO `lang_definitions` VALUES (18764, 436, 15, 'Λεπτομέρειες κατηγορίας');
INSERT INTO `lang_definitions` VALUES (18765, 437, 15, 'Όρια κατηγορίας');
INSERT INTO `lang_definitions` VALUES (18766, 438, 15, 'Όνομα κατηγορίας');
INSERT INTO `lang_definitions` VALUES (18767, 439, 15, 'Καυκάσιος/α');
INSERT INTO `lang_definitions` VALUES (18768, 440, 15, 'Κινητό τηλέφωνο');
INSERT INTO `lang_definitions` VALUES (18769, 441, 15, 'Αριθμος κινητου τηλεφωνου');
INSERT INTO `lang_definitions` VALUES (18770, 442, 15, 'Κεντρική Πιστοποίηση');
INSERT INTO `lang_definitions` VALUES (18771, 446, 15, 'αλλαγή');
INSERT INTO `lang_definitions` VALUES (18772, 448, 15, 'Αλλαγή δραστηριότητας');
INSERT INTO `lang_definitions` VALUES (18773, 449, 15, 'Αλλαγή στην όραση');
INSERT INTO `lang_definitions` VALUES (18774, 450, 15, 'Αλλαγή στην όραση');
INSERT INTO `lang_definitions` VALUES (18775, 451, 15, 'Τροποποιήθηκε');
INSERT INTO `lang_definitions` VALUES (18776, 452, 15, 'Χρέωση');
INSERT INTO `lang_definitions` VALUES (18777, 453, 15, 'Χρεώσεις ');
INSERT INTO `lang_definitions` VALUES (18778, 454, 15, 'Γράφημα');
INSERT INTO `lang_definitions` VALUES (18779, 455, 15, 'Γράφημα Δραστηριότητας');
INSERT INTO `lang_definitions` VALUES (18780, 456, 15, 'Γράφημα εισ-/εξαγωγών');
INSERT INTO `lang_definitions` VALUES (18781, 457, 15, 'Αναγνωριστικό γραφήματος');
INSERT INTO `lang_definitions` VALUES (18782, 458, 15, 'Αναγνωριστικό γραφήματος');
INSERT INTO `lang_definitions` VALUES (18783, 459, 15, 'Γράφημα Δραστηριότητας ανά τοποθεσία');
INSERT INTO `lang_definitions` VALUES (18784, 460, 15, 'Γράφημα Σημειωσης');
INSERT INTO `lang_definitions` VALUES (18785, 461, 15, 'Γράφημα Θεσεων Αποθηκευσης');
INSERT INTO `lang_definitions` VALUES (18786, 462, 15, 'Ιχνηλάτης γραφημάτων');
INSERT INTO `lang_definitions` VALUES (18787, 463, 15, 'Ιχν. γραφημ.');
INSERT INTO `lang_definitions` VALUES (18788, 464, 15, 'Ιχν. γραφημ.');
INSERT INTO `lang_definitions` VALUES (18789, 465, 15, 'Γραφήματα αποχώρησης');
INSERT INTO `lang_definitions` VALUES (18790, 466, 15, 'Γραφήματα αποχώρησης');
INSERT INTO `lang_definitions` VALUES (18791, 467, 15, 'έλεγχος');
INSERT INTO `lang_definitions` VALUES (18792, 468, 15, 'Έλεγχος ');
INSERT INTO `lang_definitions` VALUES (18793, 469, 15, 'Έλεγχος όλων');
INSERT INTO `lang_definitions` VALUES (18794, 470, 15, 'Έλεγχος μεσα στο');
INSERT INTO `lang_definitions` VALUES (18795, 471, 15, 'Έλεγχος δεδομένων εισόδου');
INSERT INTO `lang_definitions` VALUES (18796, 472, 15, 'Αριθμος ελεγχου');
INSERT INTO `lang_definitions` VALUES (18797, 473, 15, 'Έλεγχος/Ημερομηνία επεξήγησης των οφειλών');
INSERT INTO `lang_definitions` VALUES (18798, 474, 15, 'Έλεγχος/Αριθμός επεξήγησης των οφειλών');
INSERT INTO `lang_definitions` VALUES (18799, 475, 15, 'Έλεγχος/Αριθμός αναφ');
INSERT INTO `lang_definitions` VALUES (18800, 476, 15, 'Έλεγχος/Αριθμός αναφοράς');
INSERT INTO `lang_definitions` VALUES (18801, 477, 15, 'λίστα πλαισίου επιλογής');
INSERT INTO `lang_definitions` VALUES (18802, 478, 15, 'λίστα πλαισίου επιλογής');
INSERT INTO `lang_definitions` VALUES (18803, 479, 15, 'λίστα πλαισίου εγγρ/κείμενο');
INSERT INTO `lang_definitions` VALUES (18804, 480, 15, 'λίστα πλαισίου εγγρ/κείμενο');
INSERT INTO `lang_definitions` VALUES (18805, 481, 15, 'Επιλεγμένο κουτάκι = ναι, άδειο = όχι');
INSERT INTO `lang_definitions` VALUES (18806, 482, 15, 'Αποχώρηση');
INSERT INTO `lang_definitions` VALUES (18807, 483, 15, 'Θώρακας');
INSERT INTO `lang_definitions` VALUES (18808, 484, 15, 'Ακρόαση πνευμόνων καθαρή άμφω');
INSERT INTO `lang_definitions` VALUES (18809, 485, 15, 'Θωρακικός πόνος');
INSERT INTO `lang_definitions` VALUES (18810, 486, 15, 'Θωρακικός πόνος:');
INSERT INTO `lang_definitions` VALUES (18811, 487, 15, 'Θωρακικοι πόνοι:');
INSERT INTO `lang_definitions` VALUES (18812, 488, 15, 'Αλλ');
INSERT INTO `lang_definitions` VALUES (18813, 490, 15, 'Παιδί');
INSERT INTO `lang_definitions` VALUES (18814, 491, 15, 'Ρίγος');
INSERT INTO `lang_definitions` VALUES (18815, 492, 15, 'Κινεζικά');
INSERT INTO `lang_definitions` VALUES (18816, 493, 15, 'Διάφορα');
INSERT INTO `lang_definitions` VALUES (18817, 494, 15, 'Χολοκυστεκτομή');
INSERT INTO `lang_definitions` VALUES (18818, 495, 15, 'Χολοκυστοστομία');
INSERT INTO `lang_definitions` VALUES (18819, 496, 15, 'Επιλέξτε');
INSERT INTO `lang_definitions` VALUES (18820, 497, 15, 'Επιλέξτε μια ενότητα και κάντε κλικ σε ένα αντικείμενο μέσα σε αυτή. Τότε στο άλλο τμήμα θα δείτε τονισμένα τα σχετικά αντικείμενα και μπορείτε να κάνετε κλικ σε αυτό το τμήμα για να προσθέσετε και να διαγράψετε σχέσεις.');
INSERT INTO `lang_definitions` VALUES (18821, 498, 15, 'Επιλέξτε λίστα');
INSERT INTO `lang_definitions` VALUES (18822, 500, 15, 'Χρόνια βρογχίτιδα');
INSERT INTO `lang_definitions` VALUES (18823, 501, 15, 'Αρθρικός πόνος');
INSERT INTO `lang_definitions` VALUES (18824, 502, 15, 'Χρόνια υμενίτιδα / συλλογή υγρού / αρθραλγία / ποδάγρα');
INSERT INTO `lang_definitions` VALUES (18825, 503, 15, 'Χρόνιο/Υποτροπιάζον');
INSERT INTO `lang_definitions` VALUES (18826, 504, 15, 'Κίρρωση του ήπατος');
INSERT INTO `lang_definitions` VALUES (18827, 505, 15, 'Κίρρωση του ήπατος');
INSERT INTO `lang_definitions` VALUES (18828, 506, 15, 'Πόλη');
INSERT INTO `lang_definitions` VALUES (18829, 507, 15, 'Όνομα πόλης');
INSERT INTO `lang_definitions` VALUES (18830, 508, 15, 'Πόλη, Νομός');
INSERT INTO `lang_definitions` VALUES (18831, 509, 15, 'Πόλη, Νομός ΤΚ');
INSERT INTO `lang_definitions` VALUES (18832, 510, 15, 'Πόλη/Νομός');
INSERT INTO `lang_definitions` VALUES (18833, 512, 15, 'Απαίτηση');
INSERT INTO `lang_definitions` VALUES (18834, 513, 15, 'Ο έλεγχος των απαιτήσεων ολοκληρώθηκε');
INSERT INTO `lang_definitions` VALUES (18835, 514, 15, 'Η απαίτηση δημιουργήθηκε στο αρχείο');
INSERT INTO `lang_definitions` VALUES (18836, 515, 15, 'Ταξινόμηση');
INSERT INTO `lang_definitions` VALUES (18837, 516, 15, 'Καθάρισμα');
INSERT INTO `lang_definitions` VALUES (18838, 517, 15, 'Καθάρισμα όλων');
INSERT INTO `lang_definitions` VALUES (18839, 519, 15, 'Καθαρισμός Ημερολογίου');
INSERT INTO `lang_definitions` VALUES (18840, 520, 15, 'Αριθμός CLIA');
INSERT INTO `lang_definitions` VALUES (18841, 521, 15, 'κλικ');
INSERT INTO `lang_definitions` VALUES (18842, 523, 15, 'κάντε click για περισσότερα');
INSERT INTO `lang_definitions` VALUES (18843, 524, 15, 'Κλικ εδώ για επιλογή ημερομηνίας');
INSERT INTO `lang_definitions` VALUES (18844, 525, 15, 'Κλικ για ενημέρωση προτεραιότητας, κατηγορίας και ψευδωνύμου ρυθμίσεων ');
INSERT INTO `lang_definitions` VALUES (18845, 526, 15, 'Κλικ για προβολή όλων');
INSERT INTO `lang_definitions` VALUES (18846, 527, 15, 'Κλικ για να κατεβάσετε');
INSERT INTO `lang_definitions` VALUES (18847, 528, 15, 'Κλικ για επεξεργασία');
INSERT INTO `lang_definitions` VALUES (18848, 529, 15, 'Κλικ για επεξεργασία αυτού του συμβάματος');
INSERT INTO `lang_definitions` VALUES (18849, 530, 15, 'Κλικ για δημιουργία της αναφοράς');
INSERT INTO `lang_definitions` VALUES (18850, 531, 15, 'Κλικ για εκτύπωση');
INSERT INTO `lang_definitions` VALUES (18851, 532, 15, 'Κλικ για λήψη (προσθήκη) νέας παρτίδας');
INSERT INTO `lang_definitions` VALUES (18852, 533, 15, 'Κλικ για επιλογή');
INSERT INTO `lang_definitions` VALUES (18853, 534, 15, 'Κλικ για επιλογή ή αλλαγή διαγνώσεων');
INSERT INTO `lang_definitions` VALUES (18854, 535, 15, 'Κλικ για επιλογή ασθενούς');
INSERT INTO `lang_definitions` VALUES (18855, 536, 15, 'Κλικ για επιλογή σχετικού κώδικα');
INSERT INTO `lang_definitions` VALUES (18856, 537, 15, 'Kλικ για προβολή');
INSERT INTO `lang_definitions` VALUES (18857, 538, 15, 'Kλικ για προβολή ή επεξεργασία');
INSERT INTO `lang_definitions` VALUES (18858, 539, 15, 'Kλικ για προβολή/επεξεργασία');
INSERT INTO `lang_definitions` VALUES (18859, 540, 15, 'Κλικ:');
INSERT INTO `lang_definitions` VALUES (18860, 542, 15, 'Περιληψη ιατρικου ιστορικου πελατη');
INSERT INTO `lang_definitions` VALUES (18861, 543, 15, 'Προφίλ Πελάτη – Νέοι Πελάτες');
INSERT INTO `lang_definitions` VALUES (18862, 544, 15, 'Προφίλ Πελάτη – Μοναδικοί Πελάτες');
INSERT INTO `lang_definitions` VALUES (18863, 545, 15, 'Ασθενείς');
INSERT INTO `lang_definitions` VALUES (18864, 546, 15, 'Κλινική');
INSERT INTO `lang_definitions` VALUES (18865, 548, 15, 'Ημερήσια αναφορά κλινικής');
INSERT INTO `lang_definitions` VALUES (18866, 549, 15, 'Αναγνωριστικό κλινικης');
INSERT INTO `lang_definitions` VALUES (18867, 550, 15, 'Κλινικοί');
INSERT INTO `lang_definitions` VALUES (18868, 553, 15, 'Κλείσιμο');
INSERT INTO `lang_definitions` VALUES (18869, 554, 15, 'Κλείσιμο παραθύρου');
INSERT INTO `lang_definitions` VALUES (18870, 555, 15, 'Κλεισμένος/η/ο');
INSERT INTO `lang_definitions` VALUES (18871, 556, 15, 'εκατοστά');
INSERT INTO `lang_definitions` VALUES (18872, 559, 15, 'Κρανιακά νεύρα 2-12 ακέραια');
INSERT INTO `lang_definitions` VALUES (18873, 560, 15, 'Κωδικός ');
INSERT INTO `lang_definitions` VALUES (18874, 561, 15, 'Κωδικός ');
INSERT INTO `lang_definitions` VALUES (18875, 562, 15, 'Εύρεση κωδικού');
INSERT INTO `lang_definitions` VALUES (18876, 563, 15, 'Ο κωδικός πρέπει να είναι δύο μικρά γράμματα');
INSERT INTO `lang_definitions` VALUES (18877, 564, 15, 'τύπος κωδικού');
INSERT INTO `lang_definitions` VALUES (18878, 565, 15, 'Κωδικοί');
INSERT INTO `lang_definitions` VALUES (18879, 566, 15, 'Κωδικοποίηση');
INSERT INTO `lang_definitions` VALUES (18880, 567, 15, 'Κωδικοποιηση – καθε επισκεψη (εγγραφή, μερικά προαιρετικά)');
INSERT INTO `lang_definitions` VALUES (18881, 568, 15, 'Κωδικοποιηση – οι επισκεψεις μου (εγγραφή, μερικα προαιρετικά)');
INSERT INTO `lang_definitions` VALUES (18882, 569, 15, 'Η κωδικοποίηση δεν επιτρέπεται');
INSERT INTO `lang_definitions` VALUES (18883, 570, 15, 'Καφές');
INSERT INTO `lang_definitions` VALUES (18884, 572, 15, 'σύμπτυξη όλων ');
INSERT INTO `lang_definitions` VALUES (18885, 573, 15, 'Συλλογές ');
INSERT INTO `lang_definitions` VALUES (18886, 574, 15, 'Αναφορά συλλογών');
INSERT INTO `lang_definitions` VALUES (18887, 575, 15, 'Καρκίνος παχέος εντέρου');
INSERT INTO `lang_definitions` VALUES (18888, 576, 15, 'Εγχείρηση καρκίνου παχέος εντέρου');
INSERT INTO `lang_definitions` VALUES (18889, 577, 15, 'Κολονοσκόπηση');
INSERT INTO `lang_definitions` VALUES (18890, 578, 15, 'Κολονοσκόπηση');
INSERT INTO `lang_definitions` VALUES (18891, 579, 15, 'Χρώμα ');
INSERT INTO `lang_definitions` VALUES (18892, 580, 15, 'Στήλες ');
INSERT INTO `lang_definitions` VALUES (18893, 581, 15, 'Σχόλια ');
INSERT INTO `lang_definitions` VALUES (18894, 582, 15, 'Ετερεια εμπορικων ασφαλισεων');
INSERT INTO `lang_definitions` VALUES (18895, 583, 15, 'Απόπειρα αλλαγών');
INSERT INTO `lang_definitions` VALUES (18896, 584, 15, 'Επικοινωνίες');
INSERT INTO `lang_definitions` VALUES (18897, 585, 15, 'Συμπληρωμένο/η/ο');
INSERT INTO `lang_definitions` VALUES (18898, 586, 15, 'Επιπλοκές ανά Πάροχο Υπηρεσίας');
INSERT INTO `lang_definitions` VALUES (18899, 587, 15, 'Επιπλοκές άμβλωσης');
INSERT INTO `lang_definitions` VALUES (18900, 588, 15, 'Υποβοηθούμενο σύστημα ιατρικής ταξινόμησης (CAMOS)');
INSERT INTO `lang_definitions` VALUES (18901, 589, 15, 'Συμπερασματα');
INSERT INTO `lang_definitions` VALUES (18902, 590, 15, 'Συγγενής ');
INSERT INTO `lang_definitions` VALUES (18903, 591, 15, 'Κερατοειδής, κόρες');
INSERT INTO `lang_definitions` VALUES (18904, 592, 15, 'Σταθερά');
INSERT INTO `lang_definitions` VALUES (18905, 593, 15, 'σταθερό όνομα ');
INSERT INTO `lang_definitions` VALUES (18906, 594, 15, 'σταθερές ');
INSERT INTO `lang_definitions` VALUES (18907, 595, 15, 'Δυσκοιλιοτητα');
INSERT INTO `lang_definitions` VALUES (18908, 596, 15, 'Γενική κατάσταση');
INSERT INTO `lang_definitions` VALUES (18909, 597, 15, 'Σύντομη αναφορά εκτίμησης');
INSERT INTO `lang_definitions` VALUES (18910, 598, 15, 'Διεύθυνση');
INSERT INTO `lang_definitions` VALUES (18911, 599, 15, 'Email');
INSERT INTO `lang_definitions` VALUES (18912, 600, 15, 'Διευθυνση Email Επικοινωνίας');
INSERT INTO `lang_definitions` VALUES (18913, 601, 15, 'Πληροφορίες Επικοινωνίας');
INSERT INTO `lang_definitions` VALUES (18914, 602, 15, 'Φακοί επαφής');
INSERT INTO `lang_definitions` VALUES (18915, 603, 15, 'Όνομα Επικοινωνίας');
INSERT INTO `lang_definitions` VALUES (18916, 604, 15, 'Άτομο Επικοινωνίας');
INSERT INTO `lang_definitions` VALUES (18917, 605, 15, 'Τηλέφωνο Επικοινωνίας');
INSERT INTO `lang_definitions` VALUES (18918, 606, 15, 'Περιεχόμενο ');
INSERT INTO `lang_definitions` VALUES (18919, 607, 15, 'περιεχόμενο ');
INSERT INTO `lang_definitions` VALUES (18920, 608, 15, 'Συνέχιση');
INSERT INTO `lang_definitions` VALUES (18921, 610, 15, 'Αντισυλληψη');
INSERT INTO `lang_definitions` VALUES (18922, 611, 15, 'Θέματα αντισύλληψης');
INSERT INTO `lang_definitions` VALUES (18923, 612, 15, 'Επιπλοκές αντισύλληψης');
INSERT INTO `lang_definitions` VALUES (18924, 613, 15, 'Μέθοδος αντισύλληψης');
INSERT INTO `lang_definitions` VALUES (18925, 614, 15, 'Προηγούμενη έναρξη υπηρεσιών αντισύλληψης ');
INSERT INTO `lang_definitions` VALUES (18926, 615, 15, 'Έναρξη αντισυλληπτικών');
INSERT INTO `lang_definitions` VALUES (18927, 616, 15, 'Αριθμ. Ελεγχου');
INSERT INTO `lang_definitions` VALUES (18928, 617, 15, 'Συμμετοχή');
INSERT INTO `lang_definitions` VALUES (18929, 618, 15, 'Συμμετοχή');
INSERT INTO `lang_definitions` VALUES (18930, 619, 15, 'Συμμετοχές');
INSERT INTO `lang_definitions` VALUES (18931, 621, 15, 'ΧΑΠ');
INSERT INTO `lang_definitions` VALUES (18932, 622, 15, 'Αντιγραφή Σελίδων στο Διάγραμμα ασθενούς');
INSERT INTO `lang_definitions` VALUES (18933, 623, 15, 'Αντιγραφή Τιμών');
INSERT INTO `lang_definitions` VALUES (18934, 624, 15, 'Σημειώμα Πνευματικών Δικαιωμάτων ');
INSERT INTO `lang_definitions` VALUES (18935, 625, 15, 'Αορτοστεφανιαία παράκαμψη');
INSERT INTO `lang_definitions` VALUES (18936, 626, 15, 'Βήχας');
INSERT INTO `lang_definitions` VALUES (18937, 627, 15, 'Βήχας: ');
INSERT INTO `lang_definitions` VALUES (18938, 628, 15, 'Το email δεν μπορεί να αποσταλεί λόγω προβλήματος του εξυπηρετητή,');
INSERT INTO `lang_definitions` VALUES (18939, 633, 15, 'Συμβουλευτική');
INSERT INTO `lang_definitions` VALUES (18940, 634, 15, 'Συμβουλευτικές δραστηριότητες ');
INSERT INTO `lang_definitions` VALUES (18941, 635, 15, 'Δραστηριότητες γνωμάτευσης ');
INSERT INTO `lang_definitions` VALUES (18942, 636, 15, 'Αριθμητής εντύπων παραπομπής');
INSERT INTO `lang_definitions` VALUES (18943, 637, 15, 'Επιστροφή παραπομπής');
INSERT INTO `lang_definitions` VALUES (18944, 638, 15, 'Χώρα');
INSERT INTO `lang_definitions` VALUES (18945, 639, 15, 'Λίστα χωρών (εγγραφή)');
INSERT INTO `lang_definitions` VALUES (18946, 640, 15, 'Επαρχία');
INSERT INTO `lang_definitions` VALUES (18947, 641, 15, 'Κουπόνι ');
INSERT INTO `lang_definitions` VALUES (18948, 642, 15, 'CPT');
INSERT INTO `lang_definitions` VALUES (18949, 643, 15, 'Κωδικοί CPT');
INSERT INTO `lang_definitions` VALUES (18950, 644, 15, 'Ρόγχοι:');
INSERT INTO `lang_definitions` VALUES (18951, 645, 15, 'κρέμα (cream)');
INSERT INTO `lang_definitions` VALUES (18952, 646, 15, 'Δημιουργία Συμβάντος');
INSERT INTO `lang_definitions` VALUES (18953, 647, 15, 'Δημιουργία και κατέβασμα πλήρους Backup');
INSERT INTO `lang_definitions` VALUES (18954, 648, 15, 'Δημιουργία Backup');
INSERT INTO `lang_definitions` VALUES (18955, 649, 15, 'Δημιουργία νέου');
INSERT INTO `lang_definitions` VALUES (18956, 650, 15, 'Δημιουργία σημείωσης');
INSERT INTO `lang_definitions` VALUES (18957, 651, 15, 'Δημιουργήθηκε ');
INSERT INTO `lang_definitions` VALUES (18958, 652, 15, 'Δμηιουργία αρχείου εξαγωγής');
INSERT INTO `lang_definitions` VALUES (18959, 653, 15, 'πίστωση');
INSERT INTO `lang_definitions` VALUES (18960, 654, 15, 'Πιστώσεις');
INSERT INTO `lang_definitions` VALUES (18961, 655, 15, 'Νόσος του Crohn');
INSERT INTO `lang_definitions` VALUES (18962, 656, 15, 'Νόσος του Crohn');
INSERT INTO `lang_definitions` VALUES (18963, 657, 15, 'Αρχείο CSV');
INSERT INTO `lang_definitions` VALUES (18964, 658, 15, 'Τρέχων/ουσα');
INSERT INTO `lang_definitions` VALUES (18965, 659, 15, 'Τρέχουσα εκτίμηση');
INSERT INTO `lang_definitions` VALUES (18966, 660, 15, 'Τονίζον χρώμα της τρέχουσας ημέρας');
INSERT INTO `lang_definitions` VALUES (18967, 661, 15, 'Το τρέχον άνομα αρχείου άλλαξε σε');
INSERT INTO `lang_definitions` VALUES (18968, 662, 15, 'Τρέχουσα θέση');
INSERT INTO `lang_definitions` VALUES (18969, 663, 15, 'Τρέχων Ασθενής');
INSERT INTO `lang_definitions` VALUES (18970, 664, 15, 'Τρέχων ενεργός');
INSERT INTO `lang_definitions` VALUES (18971, 665, 15, 'Σύνδρομο Cushing');
INSERT INTO `lang_definitions` VALUES (18972, 666, 15, 'Σύνδρομο Cushing');
INSERT INTO `lang_definitions` VALUES (18973, 667, 15, 'Συνήθεια');
INSERT INTO `lang_definitions` VALUES (18974, 669, 15, 'Ετη προστασίας ζευγαριού');
INSERT INTO `lang_definitions` VALUES (18975, 670, 15, 'Παράγοντας ετών προστασίας ζευγαριού');
INSERT INTO `lang_definitions` VALUES (18976, 671, 15, 'Αναφορά ετών προστασίας ζευγαριού');
INSERT INTO `lang_definitions` VALUES (18977, 675, 15, 'Ημ.γένν');
INSERT INTO `lang_definitions` VALUES (18978, 676, 15, 'ημερησίως');
INSERT INTO `lang_definitions` VALUES (18979, 677, 15, 'Tα δεδομένα είναι ήδη στη βάση δεδομένων, παρακαλώ αλλάξτε τον κωδικό και/ή την περιγραφή');
INSERT INTO `lang_definitions` VALUES (18980, 678, 15, 'Tα δεδομένα είναι ήδη στη βάση δεδομένων, παρακαλώ αλλάξτε το όνομα της σταθεράς');
INSERT INTO `lang_definitions` VALUES (18981, 679, 15, 'Στήλες δεδομένων');
INSERT INTO `lang_definitions` VALUES (18982, 680, 15, 'Τύπος δεδομένων');
INSERT INTO `lang_definitions` VALUES (18983, 681, 15, 'Βάση');
INSERT INTO `lang_definitions` VALUES (18984, 682, 15, 'Αναφορά βασης δεδομένων');
INSERT INTO `lang_definitions` VALUES (18985, 683, 15, 'Τα Δεδομένα Στηλών πρέπει να είναι αριθμός μεταξύ 1 και 999');
INSERT INTO `lang_definitions` VALUES (18986, 684, 15, 'Ημερομηνία ');
INSERT INTO `lang_definitions` VALUES (18987, 685, 15, 'ΗΜΕΡΟΜΗΝΙΑ');
INSERT INTO `lang_definitions` VALUES (18988, 686, 15, 'Ημερομηνία χορήγησης');
INSERT INTO `lang_definitions` VALUES (18989, 687, 15, 'Ημερομηνία χορήγησης αντισυλληπτικής υπηρεσίας ');
INSERT INTO `lang_definitions` VALUES (18990, 688, 15, 'Ημερομηνία καταστροφής');
INSERT INTO `lang_definitions` VALUES (18991, 689, 15, 'Τρόπος εμφάνισης ημερομηνίας');
INSERT INTO `lang_definitions` VALUES (18992, 690, 15, 'Ο τύπος ημερομηνίας για “τέλος ραντεβού” δεν είναι έγκυρος');
INSERT INTO `lang_definitions` VALUES (18993, 691, 15, 'Ο τύπος ημερομηνίας για “έναρξη ραντεβού” δεν είναι έγκυρος');
INSERT INTO `lang_definitions` VALUES (18994, 692, 15, 'Ο τύπος ημερομηνίας για “επόμενο ραντεβού” δεν είναι έγκυρος');
INSERT INTO `lang_definitions` VALUES (18995, 693, 15, 'Ο τύπος ημερομηνίας για “μη εκτιμηθείς από” δεν είναι έγκυρος');
INSERT INTO `lang_definitions` VALUES (18996, 694, 15, 'Ο τύπος ημερομηνίας για “εκτιμηθείς από” δεν είναι έγκυρος');
INSERT INTO `lang_definitions` VALUES (18997, 695, 15, 'Δόθηκαν πληροφορίες για ημερομηνία ανοσοποίησης');
INSERT INTO `lang_definitions` VALUES (18998, 696, 15, 'Η ημερομηνία για τον κωδικό λείπει');
INSERT INTO `lang_definitions` VALUES (18999, 697, 15, 'Ημερομηνία τραπεζικής κατάθεσης εεεε-μμ-ηη');
INSERT INTO `lang_definitions` VALUES (19000, 698, 15, 'Ημερομηνία γέννησης');
INSERT INTO `lang_definitions` VALUES (19001, 699, 15, 'Ημερομηνία γέννησης');
INSERT INTO `lang_definitions` VALUES (19002, 700, 15, 'Ημερομηνία κάκωσης');
INSERT INTO `lang_definitions` VALUES (19003, 701, 15, 'Ημερομηνία πληρωμής εεεε-μμ-ηη');
INSERT INTO `lang_definitions` VALUES (19004, 702, 15, 'Ημερομηνία παραπομπής ');
INSERT INTO `lang_definitions` VALUES (19005, 703, 15, 'Ημερομηνία απάντησης ');
INSERT INTO `lang_definitions` VALUES (19006, 704, 15, 'Ημερομηνία Υπηρεσίας');
INSERT INTO `lang_definitions` VALUES (19007, 705, 15, 'Ημερομηνία υπηρεσίας μμ-ηη-εεεε');
INSERT INTO `lang_definitions` VALUES (19008, 706, 15, 'Ημερομηνία Υπηρεσίας:');
INSERT INTO `lang_definitions` VALUES (19009, 707, 15, 'Ημερομηνία Υπογραφής');
INSERT INTO `lang_definitions` VALUES (19010, 708, 15, 'Ημερομηνία Έκδοσης Πληροφοριών Εμβολίων');
INSERT INTO `lang_definitions` VALUES (19011, 709, 15, 'Ημερομηνία/Ραντ');
INSERT INTO `lang_definitions` VALUES (19012, 710, 15, 'Ημερομηνία/Σημειώσεις');
INSERT INTO `lang_definitions` VALUES (19013, 711, 15, 'Ημερομηνία/Σημειώσεις του τελευταίου');
INSERT INTO `lang_definitions` VALUES (19014, 712, 15, 'Ημερομηνία: ');
INSERT INTO `lang_definitions` VALUES (19015, 713, 15, 'Ημέρα ');
INSERT INTO `lang_definitions` VALUES (19016, 714, 15, 'Ημέρα ');
INSERT INTO `lang_definitions` VALUES (19017, 715, 15, 'Προβολή Ημέρας');
INSERT INTO `lang_definitions` VALUES (19018, 716, 15, 'Ημέρα(ες) ');
INSERT INTO `lang_definitions` VALUES (19019, 717, 15, 'Ημέρα(ες) Α-Θ');
INSERT INTO `lang_definitions` VALUES (19020, 718, 15, 'Ημέρες ');
INSERT INTO `lang_definitions` VALUES (19021, 719, 15, 'Ημέρες ');
INSERT INTO `lang_definitions` VALUES (19022, 720, 15, 'Χαμένες ημέρες και παιχνίδια');
INSERT INTO `lang_definitions` VALUES (19023, 721, 15, 'Ημέρες από την τελευταία επίσκεψη');
INSERT INTO `lang_definitions` VALUES (19024, 722, 15, 'Ημέρες ανά Στήλη: ');
INSERT INTO `lang_definitions` VALUES (19025, 723, 15, 'Η βάση δεδομένων έχει εγκατασταθεί ');
INSERT INTO `lang_definitions` VALUES (19026, 724, 15, 'Έλεγχος Φαρμάκων');
INSERT INTO `lang_definitions` VALUES (19027, 725, 15, 'Πληροφορίες αποσφαλμάτωσης');
INSERT INTO `lang_definitions` VALUES (19028, 726, 15, 'Δεκέμβριος ');
INSERT INTO `lang_definitions` VALUES (19029, 727, 15, 'Προεπιλογή');
INSERT INTO `lang_definitions` VALUES (19030, 728, 15, 'Προεπιλογή Εμφάνισης Ημερολογίου');
INSERT INTO `lang_definitions` VALUES (19031, 729, 15, 'Προεπιλεγμένη Έδρα');
INSERT INTO `lang_definitions` VALUES (19032, 730, 15, 'Προεπιλεγμένη Λίστα (εγγραφή, προαιρετικά προσθήκη)');
INSERT INTO `lang_definitions` VALUES (19033, 731, 15, 'Προεπιλεγμένη Μέθοδος');
INSERT INTO `lang_definitions` VALUES (19034, 732, 15, 'Προεπιλεγμένος Παροχος');
INSERT INTO `lang_definitions` VALUES (19035, 733, 15, 'Προεπιλεγμένη Χωροθέτηση');
INSERT INTO `lang_definitions` VALUES (19036, 734, 15, 'Προεπιλεγμένη Τιμή');
INSERT INTO `lang_definitions` VALUES (19037, 735, 15, 'Προεπιλεγμένη Χ12 συνεργάτης');
INSERT INTO `lang_definitions` VALUES (19038, 736, 15, 'Προεπιλεγμένος/Γενικός');
INSERT INTO `lang_definitions` VALUES (19039, 738, 15, 'Καθυστερημένη υποτροπή (>12 μήνες)');
INSERT INTO `lang_definitions` VALUES (19040, 739, 15, 'Διαγραφή');
INSERT INTO `lang_definitions` VALUES (19041, 740, 15, 'Διαγραφή');
INSERT INTO `lang_definitions` VALUES (19042, 741, 15, 'Διαγραφή κατηγοριών με αναγνωριστικά:');
INSERT INTO `lang_definitions` VALUES (19043, 742, 15, 'Διαγραφή Ομάδας');
INSERT INTO `lang_definitions` VALUES (19044, 743, 15, 'Διαγραφή Λίστας');
INSERT INTO `lang_definitions` VALUES (19045, 744, 15, 'Διαγραφή Σελίδων');
INSERT INTO `lang_definitions` VALUES (19046, 745, 15, 'Διαγραφή Ασθενούς, Επίσκεψης, Εντύπου, Προβλήματος, Εγγράφου, Πληρωμής, Χρέωσης ή Συναλλαγής');
INSERT INTO `lang_definitions` VALUES (19047, 747, 15, 'Διαγραφή επιτυχής');
INSERT INTO `lang_definitions` VALUES (19048, 748, 15, 'Διαγραφή αυτού του εγγράφου');
INSERT INTO `lang_definitions` VALUES (19049, 749, 15, 'Διαγραφή αυτής του εντύπου');
INSERT INTO `lang_definitions` VALUES (19050, 750, 15, 'Διαγραφή αυτής της σημείωσης');
INSERT INTO `lang_definitions` VALUES (19051, 751, 15, 'Άνοια');
INSERT INTO `lang_definitions` VALUES (19052, 752, 15, 'Δημογραφικά ');
INSERT INTO `lang_definitions` VALUES (19053, 753, 15, 'Δημογραφικά (εγγραφή)');
INSERT INTO `lang_definitions` VALUES (19054, 754, 15, 'Δεν επιτρέπονται Δημογραφικά ');
INSERT INTO `lang_definitions` VALUES (19055, 755, 15, 'Δεν επιτρέπονται Δημογραφικά.');
INSERT INTO `lang_definitions` VALUES (19056, 756, 15, 'Οδοντιατρικός');
INSERT INTO `lang_definitions` VALUES (19057, 757, 15, 'Οδοντιατρικά προβλήματα');
INSERT INTO `lang_definitions` VALUES (19058, 758, 15, 'Ανάλογα με τον τύπο του λογαριασμού που δικομάζετε θα δείτε έξοδο όπως της HCFA σε μια κενή σελίδα για HCFA λογαριασμούς, θα δείτε πολλές γραμμές κάπως δυσανάγνωστου κειμένου και πληροφορίες, αν ελέγχετε μια μια αίτηση X12. Αυτό το δυσανάγνωστο κείμενο είναι η X12 EDI 4010A μορφή. Περιστασιακά θα δείτε περίεργους χαρακτήρες που μοιάζουν με ντόμινο, αυτοί είναι οι χαρακτήρες ελέγχου, όπως η τροφοδοσίες σελίδας και είναι φυσιολογικοί.');
INSERT INTO `lang_definitions` VALUES (19059, 759, 15, 'Ημερομηνία κατάθεσης: ');
INSERT INTO `lang_definitions` VALUES (19060, 760, 15, 'Καταθλιπτικός/ή');
INSERT INTO `lang_definitions` VALUES (19061, 761, 15, 'Κατάθλιψη');
INSERT INTO `lang_definitions` VALUES (19062, 762, 15, 'Περιγραφή ');
INSERT INTO `lang_definitions` VALUES (19063, 763, 15, 'Περιγραφή ');
INSERT INTO `lang_definitions` VALUES (19064, 764, 15, 'Μετάφραση περιγραφής');
INSERT INTO `lang_definitions` VALUES (19065, 765, 15, 'Προορισμός ');
INSERT INTO `lang_definitions` VALUES (19066, 766, 15, 'Απόσυρση παρτίδας');
INSERT INTO `lang_definitions` VALUES (19067, 767, 15, 'Καταστροφή ... ');
INSERT INTO `lang_definitions` VALUES (19068, 768, 15, 'Απόσυρση');
INSERT INTO `lang_definitions` VALUES (19069, 769, 15, 'Απόσυρση φαρμάκων');
INSERT INTO `lang_definitions` VALUES (19070, 770, 15, 'Αναφορά απόσυρσης φαρμάκων');
INSERT INTO `lang_definitions` VALUES (19071, 771, 15, 'Λεπτομέρειες ');
INSERT INTO `lang_definitions` VALUES (19072, 772, 15, 'Αναπτυξιακή ανωμαλία');
INSERT INTO `lang_definitions` VALUES (19073, 773, 15, 'Διαβήτης ');
INSERT INTO `lang_definitions` VALUES (19074, 774, 15, 'Διαγν');
INSERT INTO `lang_definitions` VALUES (19075, 775, 15, 'Διάγνωση');
INSERT INTO `lang_definitions` VALUES (19076, 776, 15, 'Η διάγνωση πρέπει να κωδικοποιηθεί με μια συνδεδεμένη επίσκεψη');
INSERT INTO `lang_definitions` VALUES (19077, 777, 15, 'Διάγνωση:');
INSERT INTO `lang_definitions` VALUES (19078, 778, 15, 'Διάγνωση:');
INSERT INTO `lang_definitions` VALUES (19079, 779, 15, 'Διαγνωστικοί έλεγχοι:');
INSERT INTO `lang_definitions` VALUES (19080, 780, 15, 'Καλεί ');
INSERT INTO `lang_definitions` VALUES (19081, 781, 15, 'Διαφράγματα / Τραχηλικά Cups');
INSERT INTO `lang_definitions` VALUES (19082, 782, 15, 'Διάρροια');
INSERT INTO `lang_definitions` VALUES (19083, 783, 15, 'Ηχογράφηση');
INSERT INTO `lang_definitions` VALUES (19084, 784, 15, 'Ηχογράφηση:');
INSERT INTO `lang_definitions` VALUES (19085, 785, 15, 'Λάβατε το αντίγραφο της ειδοποίησης HIPAA?');
INSERT INTO `lang_definitions` VALUES (19086, 786, 15, 'Διάχυτο:');
INSERT INTO `lang_definitions` VALUES (19087, 788, 15, 'Άμεσο Ταχυδρομείο');
INSERT INTO `lang_definitions` VALUES (19088, 789, 15, 'Αναπηρία ');
INSERT INTO `lang_definitions` VALUES (19089, 790, 15, 'απενεργοποιημένο');
INSERT INTO `lang_definitions` VALUES (19090, 791, 15, 'απενεργοποιημένο');
INSERT INTO `lang_definitions` VALUES (19091, 792, 15, 'Πιστωτική Κάρτα');
INSERT INTO `lang_definitions` VALUES (19092, 793, 15, 'Έκκριμα');
INSERT INTO `lang_definitions` VALUES (19093, 794, 15, 'Έκκριμα από την ουρήθρα');
INSERT INTO `lang_definitions` VALUES (19094, 795, 15, 'Απαλλαγή από διακαιώματα');
INSERT INTO `lang_definitions` VALUES (19095, 796, 15, 'Απαλλαγή από διακαιώματα:');
INSERT INTO `lang_definitions` VALUES (19096, 797, 15, 'Έκπτωση');
INSERT INTO `lang_definitions` VALUES (19097, 798, 15, 'Ποσό έκπτωσης');
INSERT INTO `lang_definitions` VALUES (19098, 799, 15, 'Επίπεδο έκπτωσης');
INSERT INTO `lang_definitions` VALUES (19099, 800, 15, 'Νόσος');
INSERT INTO `lang_definitions` VALUES (19100, 801, 15, 'Εξάρθρωμα');
INSERT INTO `lang_definitions` VALUES (19101, 802, 15, 'Αριθ.αποστ');
INSERT INTO `lang_definitions` VALUES (19102, 803, 15, 'Αποστολή ');
INSERT INTO `lang_definitions` VALUES (19103, 804, 15, 'Έγγραφό λήψης αποστολής ');
INSERT INTO `lang_definitions` VALUES (19104, 805, 15, 'Παραλείπεται ');
INSERT INTO `lang_definitions` VALUES (19105, 806, 15, 'Εμφάνιση ημερομηνιών συμβάντων στο block;');
INSERT INTO `lang_definitions` VALUES (19106, 807, 15, 'Πόσα συμβάντα να εμφανιστούν;');
INSERT INTO `lang_definitions` VALUES (19107, 808, 15, 'Εμφάνιση θέσης στο block;');
INSERT INTO `lang_definitions` VALUES (19108, 809, 15, 'Εμφάνιση ημερολογίου;');
INSERT INTO `lang_definitions` VALUES (19109, 810, 15, 'Εμφάνιση σημερινών συμβάντων στο block;');
INSERT INTO `lang_definitions` VALUES (19110, 811, 15, 'Εμφάνιση συμβάντος σε block;');
INSERT INTO `lang_definitions` VALUES (19111, 812, 15, 'Εμφάνιση επερχόμενων συμβάντων στο block;');
INSERT INTO `lang_definitions` VALUES (19112, 813, 15, 'Διανομή ');
INSERT INTO `lang_definitions` VALUES (19113, 814, 15, 'Εκκολπωματίτιδα ');
INSERT INTO `lang_definitions` VALUES (19114, 815, 15, 'Εγχείρηση εκκολπωματίτιδας');
INSERT INTO `lang_definitions` VALUES (19115, 816, 15, 'Εκκολπωματίτιδα ');
INSERT INTO `lang_definitions` VALUES (19116, 817, 15, 'Εγχείρηση εκκολπωματίτιδας');
INSERT INTO `lang_definitions` VALUES (19117, 818, 15, 'Διαζευγμένος/η');
INSERT INTO `lang_definitions` VALUES (19118, 819, 15, 'Ζάλη: ');
INSERT INTO `lang_definitions` VALUES (19119, 820, 15, 'να μην αποθηκευτεί');
INSERT INTO `lang_definitions` VALUES (19120, 821, 15, 'να μην υποκατασταθεί');
INSERT INTO `lang_definitions` VALUES (19121, 823, 15, 'Είστε σίγουροι ότι θέλετε να διαγραφεί η ομάδα;');
INSERT INTO `lang_definitions` VALUES (19122, 824, 15, 'Επιθυμείτε να συνεχίσετε την πρόσθεση του νέου ασθενή;');
INSERT INTO `lang_definitions` VALUES (19123, 825, 15, 'Επιθυμείτε να συνεχίσετε με το νέο όνομα;');
INSERT INTO `lang_definitions` VALUES (19124, 826, 15, 'Είστε σίγουροι ότι θέλετε να διαγραφεί ΜΟΝΙΜΑ αυτη η καταχωρηση ανοσιας;');
INSERT INTO `lang_definitions` VALUES (19125, 827, 15, 'Ημ.γενν');
INSERT INTO `lang_definitions` VALUES (19126, 828, 15, 'Λείπει η Ημ/νια Γέννησης, αν την γνωρίζετε εισάγετέ την');
INSERT INTO `lang_definitions` VALUES (19127, 829, 15, 'Έγγραφα');
INSERT INTO `lang_definitions` VALUES (19128, 830, 15, 'Ιατρός');
INSERT INTO `lang_definitions` VALUES (19129, 831, 15, 'Ιατρός:');
INSERT INTO `lang_definitions` VALUES (19130, 832, 15, 'Ονομα και υπογραφη Ιατρου');
INSERT INTO `lang_definitions` VALUES (19131, 833, 15, 'Έγγραφο ');
INSERT INTO `lang_definitions` VALUES (19132, 834, 15, 'εγγραφο ');
INSERT INTO `lang_definitions` VALUES (19133, 835, 15, 'Κατηγορίες εγγράφων ');
INSERT INTO `lang_definitions` VALUES (19134, 836, 15, 'Το εγγραφο δεν μπορει να μεταφερθει στο αναγνωριστικο ασθενη');
INSERT INTO `lang_definitions` VALUES (19135, 837, 15, 'Ημερομηνία εγγράφου ');
INSERT INTO `lang_definitions` VALUES (19136, 838, 15, 'Η ημερομηνία και το θεμα του εγγράφου ενημερωθηκαν επιτυχως');
INSERT INTO `lang_definitions` VALUES (19137, 839, 15, 'Το εγγραφο μεταφερθηκε σε νεα κατηγορια');
INSERT INTO `lang_definitions` VALUES (19138, 840, 15, 'Το εγγραφο μεταφερθηκε στο αναγνωριστικο ασθενη');
INSERT INTO `lang_definitions` VALUES (19139, 841, 15, 'Αποθήκη εγγράφου/εικόνας');
INSERT INTO `lang_definitions` VALUES (19140, 842, 15, 'Έγγραφα');
INSERT INTO `lang_definitions` VALUES (19141, 843, 15, 'Έγγραφα (εγγραφή, προαιρετικά προσθήκη)');
INSERT INTO `lang_definitions` VALUES (19142, 845, 15, 'Τοπικός Συνεργάτης');
INSERT INTO `lang_definitions` VALUES (19143, 846, 15, 'Να μην αποθηκευτεί');
INSERT INTO `lang_definitions` VALUES (19144, 847, 15, 'Να μην αποθηκευτεί');
INSERT INTO `lang_definitions` VALUES (19145, 848, 15, 'Να μην αποθηκευτούν οι αλλαγές');
INSERT INTO `lang_definitions` VALUES (19146, 849, 15, 'Έγινε');
INSERT INTO `lang_definitions` VALUES (19147, 850, 15, 'Έγινε με: ');
INSERT INTO `lang_definitions` VALUES (19148, 851, 15, 'Έγινε. Θα σταλεί τώρα το download.');
INSERT INTO `lang_definitions` VALUES (19149, 852, 15, 'Ημερ.Εξέτασης');
INSERT INTO `lang_definitions` VALUES (19150, 853, 15, 'Δοσολογία ');
INSERT INTO `lang_definitions` VALUES (19151, 854, 15, 'Διπλό κλικ για επεξεργασία');
INSERT INTO `lang_definitions` VALUES (19152, 855, 15, 'Διπλωπία');
INSERT INTO `lang_definitions` VALUES (19153, 856, 15, 'Κατεβάστε το αρχείο χρέωσης, στείλτε το στο λογιστήριο και σημειώστε το ως χρεωμένο ');
INSERT INTO `lang_definitions` VALUES (19154, 857, 15, 'Κατέβασμα δεδομένων ρύθμισης.');
INSERT INTO `lang_definitions` VALUES (19155, 858, 15, 'Ιατρ. Έλεγχος');
INSERT INTO `lang_definitions` VALUES (19156, 859, 15, 'Ιατρ. Επίσκεψη');
INSERT INTO `lang_definitions` VALUES (19157, 860, 15, 'Δρ.');
INSERT INTO `lang_definitions` VALUES (19158, 862, 15, 'Αναγνωριστικό Αδείας Οδήγησης ή Πολιτείας');
INSERT INTO `lang_definitions` VALUES (19159, 863, 15, 'Φάρμακο');
INSERT INTO `lang_definitions` VALUES (19160, 864, 15, 'Τύποι φαρμάκου');
INSERT INTO `lang_definitions` VALUES (19161, 865, 15, 'Λείπει το αναγνωριστικό φαρμάκου!');
INSERT INTO `lang_definitions` VALUES (19162, 866, 15, 'Διαστήματα δόσεων');
INSERT INTO `lang_definitions` VALUES (19163, 867, 15, 'Απογραφή φαρμάκων');
INSERT INTO `lang_definitions` VALUES (19164, 868, 15, 'Όνομα φαρμάκου');
INSERT INTO `lang_definitions` VALUES (19165, 869, 15, 'Οδοί χορήγησης');
INSERT INTO `lang_definitions` VALUES (19166, 870, 15, 'Μονάδες φαρμάκου');
INSERT INTO `lang_definitions` VALUES (19167, 871, 15, 'Φάρμακο');
INSERT INTO `lang_definitions` VALUES (19168, 872, 15, 'Ξηροστομία ');
INSERT INTO `lang_definitions` VALUES (19169, 873, 15, 'DT 1');
INSERT INTO `lang_definitions` VALUES (19170, 874, 15, 'DT 2');
INSERT INTO `lang_definitions` VALUES (19171, 875, 15, 'DT 3');
INSERT INTO `lang_definitions` VALUES (19172, 876, 15, 'DT 4');
INSERT INTO `lang_definitions` VALUES (19173, 877, 15, 'DT 5');
INSERT INTO `lang_definitions` VALUES (19174, 878, 15, 'DTaP 1');
INSERT INTO `lang_definitions` VALUES (19175, 879, 15, 'DTaP 2');
INSERT INTO `lang_definitions` VALUES (19176, 880, 15, 'DTaP 3');
INSERT INTO `lang_definitions` VALUES (19177, 881, 15, 'DTaP 4');
INSERT INTO `lang_definitions` VALUES (19178, 882, 15, 'DTaP 5');
INSERT INTO `lang_definitions` VALUES (19179, 883, 15, 'Ημερομηνία καθηκόντων');
INSERT INTO `lang_definitions` VALUES (19180, 884, 15, 'Ημερομηνία καθηκόντων μμ/ηη/εεε ή εεε-μμ-ηη');
INSERT INTO `lang_definitions` VALUES (19181, 885, 15, 'Ημερομηνία καθηκόντων');
INSERT INTO `lang_definitions` VALUES (19182, 886, 15, 'Ασφ καθηκόντων');
INSERT INTO `lang_definitions` VALUES (19183, 887, 15, 'Ασθ καθηκόντων');
INSERT INTO `lang_definitions` VALUES (19184, 894, 15, 'ΠΡΟΕΙΔΟΠΟΙΗΣΗ ΔΙΠΛΑΣΙΑΣΜΟΥ');
INSERT INTO `lang_definitions` VALUES (19185, 895, 15, 'διάρκεια ');
INSERT INTO `lang_definitions` VALUES (19186, 896, 15, 'Διάρκεια ');
INSERT INTO `lang_definitions` VALUES (19187, 897, 15, 'Ολλανδικά ');
INSERT INTO `lang_definitions` VALUES (19188, 898, 15, 'Δυσφαγία');
INSERT INTO `lang_definitions` VALUES (19189, 899, 15, 'Δύσπνοια: ');
INSERT INTO `lang_definitions` VALUES (19190, 900, 15, 'Δυσουρία');
INSERT INTO `lang_definitions` VALUES (19191, 901, 15, 'Πρώιμη επιπλοκή (<2 μήνες)');
INSERT INTO `lang_definitions` VALUES (19192, 902, 15, 'Ώτα');
INSERT INTO `lang_definitions` VALUES (19193, 903, 15, 'ΗΚΓ');
INSERT INTO `lang_definitions` VALUES (19194, 904, 15, 'Οίδημα');
INSERT INTO `lang_definitions` VALUES (19195, 905, 15, 'Επεξεργασία');
INSERT INTO `lang_definitions` VALUES (19196, 906, 15, 'Επεξεργασία αλλεργιών');
INSERT INTO `lang_definitions` VALUES (19197, 907, 15, 'Επεξεργασία κατηγοριών');
INSERT INTO `lang_definitions` VALUES (19198, 908, 15, 'Επεξεργασία ορισμών');
INSERT INTO `lang_definitions` VALUES (19199, 909, 15, 'Επεξεργασία διαγνώσεων για');
INSERT INTO `lang_definitions` VALUES (19200, 910, 15, 'Επεξεργασία Εδρών');
INSERT INTO `lang_definitions` VALUES (19201, 911, 15, 'Επεξεργασία Πληροφοριών Έδρας');
INSERT INTO `lang_definitions` VALUES (19202, 912, 15, 'Επεξεργασία εντύπου');
INSERT INTO `lang_definitions` VALUES (19203, 913, 15, 'Επεξεργασία εμφάνισης');
INSERT INTO `lang_definitions` VALUES (19204, 914, 15, 'Επεξεργασία λίστας');
INSERT INTO `lang_definitions` VALUES (19205, 915, 15, 'Επεξεργασία δομής');
INSERT INTO `lang_definitions` VALUES (19206, 916, 15, 'Εκπαίδευση ');
INSERT INTO `lang_definitions` VALUES (19207, 917, 15, 'Ημερομηνία εκπαίδευσης');
INSERT INTO `lang_definitions` VALUES (19208, 918, 15, 'Αυτό το πρόγραμμα είναι ελεύθερο λογισμικό: Μπορείτε να το αναδιανείμετε και/ή να το τροποποιήσετε σύμφωνα με τους όρους της GNU General Public License όπως δημοσιεύεται από το Free Software Foundation, είτε της έκδοσης 3 της Άδειας ή (κατά την επιλογή σας) οποιαδήποτε μεταγενέστερης έκδοσης. Αυτό το πρόγραμμα διανέμεται με την ελπίδα ότι θα είναι χρήσιμο, αλλά ΧΩΡΙΣ ΟΠΟΙΑΔΗΠΟΤΕ ΕΓΓΥΗΣΗ, ακόμα και χωρίς την υπονοούμενη εγγύηση της ΕΜΠΟΡΕΥΣΙΜΟΤΗΤΑΣ ή ΚΑΤΑΛΛΗΛΟΤΗΤΑΣ ΓΙΑ ΣΥΓΚΕΚΡΙΜΕΝΟ ΣΚΟΠΟ. Δείτε την GNU General Public License για περισσότερες λεπτομέρειες. Θα πρέπει να έχετε λάβει ένα αντίγραφο της GNU General Public License μαζί με αυτό το πρόγραμμα. Αν δεν είναι, δείτε <http://www.gnu.org/licenses/>.');
INSERT INTO `lang_definitions` VALUES (19209, 919, 15, 'Ενεργός ημερομηνία');
INSERT INTO `lang_definitions` VALUES (19210, 920, 15, 'Αποτελεσματικότητα ');
INSERT INTO `lang_definitions` VALUES (19211, 921, 15, 'Εκσπερματώσεις');
INSERT INTO `lang_definitions` VALUES (19212, 922, 15, 'Αγκώνας ');
INSERT INTO `lang_definitions` VALUES (19213, 923, 15, 'Προβλήματα αγκώνα');
INSERT INTO `lang_definitions` VALUES (19214, 924, 15, 'Ηλεκτρονικές αποστολές');
INSERT INTO `lang_definitions` VALUES (19215, 925, 15, 'Email');
INSERT INTO `lang_definitions` VALUES (19216, 927, 15, 'Ειδοποίηση email');
INSERT INTO `lang_definitions` VALUES (19217, 928, 15, 'Το email να σταλεί πριν από');
INSERT INTO `lang_definitions` VALUES (19218, 929, 15, 'Αποστολέας Email');
INSERT INTO `lang_definitions` VALUES (19219, 930, 15, 'Θέμα Email');
INSERT INTO `lang_definitions` VALUES (19220, 931, 15, 'Κείμενο Email, χρησιμοποιήσιμη Ετικέτα: ***ΟΝΟΜΑ*** , δηλαδή Αγαπητέ ***ΟΝΟΜΑ*** ');
INSERT INTO `lang_definitions` VALUES (19221, 932, 15, 'Επικοινωνία ανάγκης');
INSERT INTO `lang_definitions` VALUES (19222, 933, 15, 'Άτομο επικοινωνίας ανάγκης');
INSERT INTO `lang_definitions` VALUES (19223, 934, 15, 'Τηλέφωνο επικοινωνίας ανάγκης');
INSERT INTO `lang_definitions` VALUES (19224, 935, 15, 'Επείγουσα αντισύλληψη ');
INSERT INTO `lang_definitions` VALUES (19225, 936, 15, 'Τηλέφωνο ανάγκης');
INSERT INTO `lang_definitions` VALUES (19226, 937, 15, 'Εμφύσημα ');
INSERT INTO `lang_definitions` VALUES (19227, 938, 15, 'Εργαζόμενος ');
INSERT INTO `lang_definitions` VALUES (19228, 939, 15, 'Εργοδότης ');
INSERT INTO `lang_definitions` VALUES (19229, 940, 15, 'Διεύθυνση εργοδότη');
INSERT INTO `lang_definitions` VALUES (19230, 941, 15, 'Δεδομένα εργοδότη');
INSERT INTO `lang_definitions` VALUES (19231, 942, 15, 'Όνομα εργοδότη');
INSERT INTO `lang_definitions` VALUES (19232, 943, 15, 'Κενό');
INSERT INTO `lang_definitions` VALUES (19233, 944, 15, 'Κενή τιμή στο \"Ώρες Email\"');
INSERT INTO `lang_definitions` VALUES (19234, 945, 15, 'Κενή τιμή στο \"Αποστολέα Email\"');
INSERT INTO `lang_definitions` VALUES (19235, 946, 15, 'Κενή τιμή στο \"Θέμα Email\"');
INSERT INTO `lang_definitions` VALUES (19236, 947, 15, 'Κενή τιμή στο \"Κείμενο Email\" ');
INSERT INTO `lang_definitions` VALUES (19237, 948, 15, 'Κενή τιμή στο \"Όνομα του Παρόχου\" ');
INSERT INTO `lang_definitions` VALUES (19238, 949, 15, 'Κενή τιμή στον \"Κωδικό πρόσβασης\" ');
INSERT INTO `lang_definitions` VALUES (19239, 950, 15, 'Κενή τιμή στο \"Ώρες SMS\" ');
INSERT INTO `lang_definitions` VALUES (19240, 951, 15, 'Κενή τιμή στο \"Κείμενο SMS\" ');
INSERT INTO `lang_definitions` VALUES (19241, 952, 15, 'Κενή τιμή στο \"Όνομα Χρήστη\" ');
INSERT INTO `lang_definitions` VALUES (19242, 953, 15, 'ενεργοποιημένο');
INSERT INTO `lang_definitions` VALUES (19243, 954, 15, 'Επισκ.');
INSERT INTO `lang_definitions` VALUES (19244, 955, 15, 'επίσκεψη');
INSERT INTO `lang_definitions` VALUES (19245, 956, 15, 'Επίσκεψη');
INSERT INTO `lang_definitions` VALUES (19246, 957, 15, 'Επίσκεψη');
INSERT INTO `lang_definitions` VALUES (19247, 958, 15, 'Έντυπα επίσκεψης');
INSERT INTO `lang_definitions` VALUES (19248, 959, 15, 'Αριθμός επίσκεψης');
INSERT INTO `lang_definitions` VALUES (19249, 960, 15, 'Η επίσκεψη κωδικοποιήθηκε');
INSERT INTO `lang_definitions` VALUES (19250, 961, 15, 'Επίσκεψη:');
INSERT INTO `lang_definitions` VALUES (19251, 962, 15, 'Επισκέψεις');
INSERT INTO `lang_definitions` VALUES (19252, 963, 15, 'Επισκέψεις και Έντυπα');
INSERT INTO `lang_definitions` VALUES (19253, 964, 15, 'Επισκέψεις και Έντυπα');
INSERT INTO `lang_definitions` VALUES (19254, 965, 15, 'Μη επιτρεπόμενες επισκέψεις');
INSERT INTO `lang_definitions` VALUES (19255, 966, 15, 'Αναφορά επισκέψεων');
INSERT INTO `lang_definitions` VALUES (19256, 967, 15, 'Τμήμα επισκέψεων');
INSERT INTO `lang_definitions` VALUES (19257, 968, 15, 'Τέλος');
INSERT INTO `lang_definitions` VALUES (19258, 969, 15, 'Τέλος (εεεε-μμ-ηη)');
INSERT INTO `lang_definitions` VALUES (19259, 970, 15, 'Ημερομηνία λήξης');
INSERT INTO `lang_definitions` VALUES (19260, 971, 15, 'Ημερομηνία λήξης:');
INSERT INTO `lang_definitions` VALUES (19261, 972, 15, 'Ημερομηνία λήξης:');
INSERT INTO `lang_definitions` VALUES (19262, 973, 15, 'Ώρα λήξης ');
INSERT INTO `lang_definitions` VALUES (19263, 974, 15, 'Ημερομηνία λήξης της υπηρεσίας εεεε-μμ-ηη');
INSERT INTO `lang_definitions` VALUES (19264, 975, 15, 'Τελική Ημερ.Υπηρεσίας μμ/ηη/εεε αν επιθυμείτε να εισάγεται μια ένα εύρος.');
INSERT INTO `lang_definitions` VALUES (19265, 976, 15, 'Ενδο παθολογικοί αίμα');
INSERT INTO `lang_definitions` VALUES (19266, 977, 15, 'Ενδοκρινικό');
INSERT INTO `lang_definitions` VALUES (19267, 978, 15, 'Ενδοσκόπηση');
INSERT INTO `lang_definitions` VALUES (19268, 979, 15, 'Αγγλικά');
INSERT INTO `lang_definitions` VALUES (19269, 980, 15, 'Αγγλικά');
INSERT INTO `lang_definitions` VALUES (19270, 981, 15, 'Αγγλικά (Ινδικά)');
INSERT INTO `lang_definitions` VALUES (19271, 982, 15, 'Αγγλικά (Standard)');
INSERT INTO `lang_definitions` VALUES (19272, 983, 15, 'Βεβαιώστε ότι το OpenEMR έχει δικαιώματα εγγραφής σε αυτόν τον κατάλογο');
INSERT INTO `lang_definitions` VALUES (19273, 984, 15, 'Έκκριμα ΩΡΛ');
INSERT INTO `lang_definitions` VALUES (19274, 985, 15, 'Πόνος ΩΡΛ');
INSERT INTO `lang_definitions` VALUES (19275, 986, 15, 'Εισάγετε έναν κωδικό διάγνωσης για την εξαίρεση όλων των τιμολογίων που δεν τον περιέχουν');
INSERT INTO `lang_definitions` VALUES (19276, 987, 15, 'Εισάγετε το σώμα του γράμματος εδώ');
INSERT INTO `lang_definitions` VALUES (19277, 988, 15, 'Εισάγετε νέα Πολιτεία');
INSERT INTO `lang_definitions` VALUES (19278, 989, 15, 'Εισάγετε τα κριτήρια αναζήτησης σας παραπάνω');
INSERT INTO `lang_definitions` VALUES (19279, 990, 15, 'Περιβαλλοντικό');
INSERT INTO `lang_definitions` VALUES (19280, 991, 15, 'Εισαγωγή δεδομένων Επεξήγησης Ωφελειών');
INSERT INTO `lang_definitions` VALUES (19281, 992, 15, 'Αποστολή δεδομένων Επεξήγησης Ωφελειών – Ηλεκτρονική Αποστολή');
INSERT INTO `lang_definitions` VALUES (19282, 993, 15, 'Αποστολή δεδομένων Επεξήγησης Ωφελειών – Οδηγίες');
INSERT INTO `lang_definitions` VALUES (19283, 994, 15, 'Αποστολή δεδομένων Επεξήγησης Ωφελειών – Απόδειξη');
INSERT INTO `lang_definitions` VALUES (19284, 995, 15, 'Αποστολή δεδομένων Επεξήγησης Ωφελειών – Σημείωση ασθενή');
INSERT INTO `lang_definitions` VALUES (19285, 996, 15, 'Αποστολή δεδομένων Επεξήγησης Ωφελειών – Αναζήτηση');
INSERT INTO `lang_definitions` VALUES (19286, 997, 15, 'Επιληψία ');
INSERT INTO `lang_definitions` VALUES (19287, 998, 15, 'Διαγραφή ');
INSERT INTO `lang_definitions` VALUES (19288, 999, 15, 'Στύσεις');
INSERT INTO `lang_definitions` VALUES (19289, 1000, 15, 'Σφάλμα ');
INSERT INTO `lang_definitions` VALUES (19290, 1001, 15, 'Σφάλμα στην επιλογή \"Ισότητα”');
INSERT INTO `lang_definitions` VALUES (19291, 1002, 15, 'Σφάλμα στην επιλογή \"HIPAA\"');
INSERT INTO `lang_definitions` VALUES (19292, 1003, 15, 'Σφάλμα στην επιλογή \"Διαδικασία\"');
INSERT INTO `lang_definitions` VALUES (19293, 1004, 15, 'Σφάλμα στην επιλογή \"SMS Gateway\"');
INSERT INTO `lang_definitions` VALUES (19294, 1005, 15, 'Σφάλμα στην επιλογή \"Ταξινόμησε κατά”');
INSERT INTO `lang_definitions` VALUES (19295, 1007, 15, 'Σφάλμα στην επιλογή ΝΑΙ ή ΟΧΙ ');
INSERT INTO `lang_definitions` VALUES (19296, 1009, 15, 'σφάλμα κατά την καταχώρηση του εντύπου!');
INSERT INTO `lang_definitions` VALUES (19297, 1010, 15, 'Σφάλμα κατά την αποθήκευση στο αρχείο');
INSERT INTO `lang_definitions` VALUES (19298, 1011, 15, 'Σφάλμα κατά την εγγραφή σε αρχείο');
INSERT INTO `lang_definitions` VALUES (19299, 1012, 15, 'ΣΦΑΛΜΑ: αδύνατη η συλλογή δεδομένων από τον εξυπηρετητή');
INSERT INTO `lang_definitions` VALUES (19300, 1014, 15, 'ΣΦΑΛΜΑ: αδύνατο το άνοιγμα του table.sql, εσφαλμένο έντυπο?');
INSERT INTO `lang_definitions` VALUES (19301, 1016, 15, 'ΣΦΑΛΜΑ: οι κωδικοί δεν συμφωνούν Παρακαλώ ελέγξτε την πληκτρολόγηση σας.');
INSERT INTO `lang_definitions` VALUES (19302, 1018, 15, 'Σφάλματα');
INSERT INTO `lang_definitions` VALUES (19303, 1019, 15, 'Ερύθημα: ');
INSERT INTO `lang_definitions` VALUES (19304, 1020, 15, 'Βεβαιωμένος ασθενής');
INSERT INTO `lang_definitions` VALUES (19305, 1021, 15, 'Εθνικότητα ή Φυλή');
INSERT INTO `lang_definitions` VALUES (19306, 1022, 15, 'Λίστα Εθνικότητας-Φυλής (εγγραφή, προαιρετικά προσθήκη)');
INSERT INTO `lang_definitions` VALUES (19307, 1023, 15, 'Αναγνωριστικός αριθμός ηλεκτρονικής αποστολής');
INSERT INTO `lang_definitions` VALUES (19308, 1024, 15, 'Γεγονός');
INSERT INTO `lang_definitions` VALUES (19309, 1025, 15, 'Έναρξη γεγονότος');
INSERT INTO `lang_definitions` VALUES (19310, 1026, 15, 'Κατηγορία γεγονότος');
INSERT INTO `lang_definitions` VALUES (19311, 1027, 15, 'Ημερομηνία γεγονότος');
INSERT INTO `lang_definitions` VALUES (19312, 1028, 15, 'Περιγραφή γεγονότος');
INSERT INTO `lang_definitions` VALUES (19313, 1029, 15, 'Λεπτομέρειες συνεδρίας');
INSERT INTO `lang_definitions` VALUES (19314, 1030, 15, 'Το γεγονότος δεν επαναλαμβάνεται');
INSERT INTO `lang_definitions` VALUES (19315, 1031, 15, 'Διάρκεια γεγονότος');
INSERT INTO `lang_definitions` VALUES (19316, 1032, 15, 'Διάρκεια γεγονότος σε λεπτά');
INSERT INTO `lang_definitions` VALUES (19317, 1033, 15, 'Αμοιβή γεγονότος');
INSERT INTO `lang_definitions` VALUES (19318, 1034, 15, 'Τόπος γεγονότος');
INSERT INTO `lang_definitions` VALUES (19319, 1035, 15, 'Το γεγονός επαναλαμβάνεται κάθε');
INSERT INTO `lang_definitions` VALUES (19320, 1036, 15, 'Το γεγονός επαναλαμβάνεται επί');
INSERT INTO `lang_definitions` VALUES (19321, 1037, 15, 'Ώρα έναρξης γεγονότος');
INSERT INTO `lang_definitions` VALUES (19322, 1038, 15, 'Τίτλος γεγονότος');
INSERT INTO `lang_definitions` VALUES (19323, 1039, 15, 'Τίτλος γεγονότος');
INSERT INTO `lang_definitions` VALUES (19324, 1040, 15, 'Ιστοσελίδα γεγονότος');
INSERT INTO `lang_definitions` VALUES (19325, 1041, 15, 'Γεγονότα');
INSERT INTO `lang_definitions` VALUES (19326, 1042, 15, 'Γεγονότα για');
INSERT INTO `lang_definitions` VALUES (19327, 1043, 15, 'Άνοιγμα γεγονότων σε νέο παράθυρο');
INSERT INTO `lang_definitions` VALUES (19328, 1044, 15, 'κάθε');
INSERT INTO `lang_definitions` VALUES (19329, 1045, 15, 'κάθε');
INSERT INTO `lang_definitions` VALUES (19330, 1046, 15, 'κάθε 3 ώρες');
INSERT INTO `lang_definitions` VALUES (19331, 1047, 15, 'κάθε 4 ώρες');
INSERT INTO `lang_definitions` VALUES (19332, 1048, 15, 'κάθε 5 ώρες');
INSERT INTO `lang_definitions` VALUES (19333, 1049, 15, 'κάθε 6 ώρες');
INSERT INTO `lang_definitions` VALUES (19334, 1050, 15, 'κάθε 8 ώρες');
INSERT INTO `lang_definitions` VALUES (19335, 1051, 15, 'Κάθε τέταρτο');
INSERT INTO `lang_definitions` VALUES (19336, 1052, 15, 'Κάθε άλλο');
INSERT INTO `lang_definitions` VALUES (19337, 1053, 15, 'Κάθε τρίτο');
INSERT INTO `lang_definitions` VALUES (19338, 1054, 15, 'Κάθε, κάθε άλλος, κάθε τρίτο, κτλ.');
INSERT INTO `lang_definitions` VALUES (19339, 1055, 15, 'Αποτελέσματα εξετάσεων και δοκιμών');
INSERT INTO `lang_definitions` VALUES (19340, 1056, 15, 'Αποτελέσματα εξετάσεων');
INSERT INTO `lang_definitions` VALUES (19341, 1057, 15, 'Ημερομηνία εξέτασης');
INSERT INTO `lang_definitions` VALUES (19342, 1058, 15, 'Εξετάσεις/Δοκιμασίες');
INSERT INTO `lang_definitions` VALUES (19343, 1060, 15, 'Οργανισμός Αποκλειστικού Παρόχου');
INSERT INTO `lang_definitions` VALUES (19344, 1061, 15, 'Σχήματα εξετάσεων');
INSERT INTO `lang_definitions` VALUES (19345, 1062, 15, 'Μορφές άσκησης');
INSERT INTO `lang_definitions` VALUES (19346, 1063, 15, 'Έξοδος από τη Διαχείριση');
INSERT INTO `lang_definitions` VALUES (19347, 1064, 15, 'Εξ');
INSERT INTO `lang_definitions` VALUES (19348, 1065, 15, 'Λεπτομερής Προβολή');
INSERT INTO `lang_definitions` VALUES (19349, 1066, 15, 'Αναμένεται από το έντυπο_επίσκεψης να είναι ');
INSERT INTO `lang_definitions` VALUES (19350, 1067, 15, 'Λήξη');
INSERT INTO `lang_definitions` VALUES (19351, 1068, 15, 'Ημερομηνία λήξης ');
INSERT INTO `lang_definitions` VALUES (19352, 1069, 15, 'Λήγει ');
INSERT INTO `lang_definitions` VALUES (19353, 1070, 15, 'Εξαγωγή ');
INSERT INTO `lang_definitions` VALUES (19354, 1071, 15, 'Εξαγωγή ως CSV ');
INSERT INTO `lang_definitions` VALUES (19355, 1072, 15, 'Εξαγωγή ρυθμίσεων');
INSERT INTO `lang_definitions` VALUES (19356, 1073, 15, 'Εξαγωγή δημογραφικών ασθενούς');
INSERT INTO `lang_definitions` VALUES (19357, 1074, 15, 'Εξαγωγή επιλεγμένων ως CSV ');
INSERT INTO `lang_definitions` VALUES (19358, 1075, 15, 'Εξαγωγή επιλεγμένων σε συλλογές');
INSERT INTO `lang_definitions` VALUES (19359, 1076, 15, 'Εξαγωγή σε CSV ');
INSERT INTO `lang_definitions` VALUES (19360, 1077, 15, 'Εξαγωγή σε εξωτερικό σύστημα χρέωσης ');
INSERT INTO `lang_definitions` VALUES (19361, 1078, 15, 'Έκθεση σε ξένες χώρες ');
INSERT INTO `lang_definitions` VALUES (19362, 1079, 15, 'Έκθεση σε ξένες χώρες ');
INSERT INTO `lang_definitions` VALUES (19363, 1080, 15, 'Εξωτερικό');
INSERT INTO `lang_definitions` VALUES (19364, 1081, 15, 'Κωδικός');
INSERT INTO `lang_definitions` VALUES (19365, 1082, 15, 'Κωδικός');
INSERT INTO `lang_definitions` VALUES (19366, 1083, 15, 'Μόνο εξωτερικό');
INSERT INTO `lang_definitions` VALUES (19367, 1084, 15, 'Εξωτερική παραπομπή ');
INSERT INTO `lang_definitions` VALUES (19368, 1085, 15, 'Παρακολουθήσεις εξωτερικών Παραπομπών');
INSERT INTO `lang_definitions` VALUES (19369, 1086, 15, 'Εξωτερική παραπομπή;');
INSERT INTO `lang_definitions` VALUES (19370, 1087, 15, 'Εξωτερικές παραπομπές');
INSERT INTO `lang_definitions` VALUES (19371, 1088, 15, 'Εξίδρωμα');
INSERT INTO `lang_definitions` VALUES (19372, 1089, 15, 'Ερεθισμός οφθαλμού');
INSERT INTO `lang_definitions` VALUES (19373, 1090, 15, 'Πόνος οφθαλμού');
INSERT INTO `lang_definitions` VALUES (19374, 1091, 15, 'Ερυθρότητα οφθαλμού');
INSERT INTO `lang_definitions` VALUES (19375, 1092, 15, 'Οφθαλμοί');
INSERT INTO `lang_definitions` VALUES (19376, 1093, 15, 'F');
INSERT INTO `lang_definitions` VALUES (19377, 1096, 15, 'Έδρες');
INSERT INTO `lang_definitions` VALUES (19378, 1097, 15, 'Έδρα');
INSERT INTO `lang_definitions` VALUES (19379, 1098, 15, 'Έδρα');
INSERT INTO `lang_definitions` VALUES (19380, 1099, 15, 'Διαχείριση έδρας');
INSERT INTO `lang_definitions` VALUES (19381, 1100, 15, 'Κωδικός έδρας');
INSERT INTO `lang_definitions` VALUES (19382, 1101, 15, 'Εθνικό Αναγνωριστικό Εδρας');
INSERT INTO `lang_definitions` VALUES (19383, 1102, 15, 'Έδρα:');
INSERT INTO `lang_definitions` VALUES (19384, 1103, 15, 'Απέτυχε');
INSERT INTO `lang_definitions` VALUES (19385, 1105, 15, 'αποτυχία');
INSERT INTO `lang_definitions` VALUES (19386, 1106, 15, 'Οικογενειακό ιστορικό ');
INSERT INTO `lang_definitions` VALUES (19387, 1107, 15, 'Ιστορικό γλαυκώματος');
INSERT INTO `lang_definitions` VALUES (19388, 1108, 15, 'Οικογενειακό ιστορικό: ');
INSERT INTO `lang_definitions` VALUES (19389, 1109, 15, 'Μέγεθος οικογένειας');
INSERT INTO `lang_definitions` VALUES (19390, 1111, 15, 'Πατέρας ');
INSERT INTO `lang_definitions` VALUES (19391, 1112, 15, 'Κόπωση');
INSERT INTO `lang_definitions` VALUES (19392, 1113, 15, 'Κοπωμένο');
INSERT INTO `lang_definitions` VALUES (19393, 1114, 15, 'FAX');
INSERT INTO `lang_definitions` VALUES (19394, 1115, 15, 'Αριθμός FAX');
INSERT INTO `lang_definitions` VALUES (19395, 1116, 15, 'Fax/Scanner');
INSERT INTO `lang_definitions` VALUES (19396, 1117, 15, 'Είσοδος FAX');
INSERT INTO `lang_definitions` VALUES (19397, 1118, 15, 'Έξοδος FAX');
INSERT INTO `lang_definitions` VALUES (19398, 1119, 15, 'Φεβρουάριος ');
INSERT INTO `lang_definitions` VALUES (19399, 1121, 15, 'Κωδικός φαρμάκου');
INSERT INTO `lang_definitions` VALUES (19400, 1122, 15, 'Κωδικός εργαζομένου/εργοδότη');
INSERT INTO `lang_definitions` VALUES (19401, 1123, 15, 'ΑΦΜ');
INSERT INTO `lang_definitions` VALUES (19402, 1124, 15, 'Αμοιβή ');
INSERT INTO `lang_definitions` VALUES (19403, 1125, 15, 'αμοιβή ');
INSERT INTO `lang_definitions` VALUES (19404, 1126, 15, 'Η αμοιβή δεν επιτρέπεται');
INSERT INTO `lang_definitions` VALUES (19405, 1127, 15, 'Έντυπο αμοιβής');
INSERT INTO `lang_definitions` VALUES (19406, 1128, 15, 'Παράμετροι εντύπου αμοιβής');
INSERT INTO `lang_definitions` VALUES (19407, 1129, 15, 'Αμοιβές');
INSERT INTO `lang_definitions` VALUES (19408, 1130, 15, 'Θήλυ');
INSERT INTO `lang_definitions` VALUES (19409, 1132, 15, 'Γυναικεία προφυλακτικά ');
INSERT INTO `lang_definitions` VALUES (19410, 1136, 15, 'Συμπτώματα θήλεως');
INSERT INTO `lang_definitions` VALUES (19411, 1137, 15, 'Οικειοθελής χειρουργική αντισύλληψη γυναίκας');
INSERT INTO `lang_definitions` VALUES (19412, 1138, 15, 'Πυρετός ');
INSERT INTO `lang_definitions` VALUES (19413, 1139, 15, 'Πυρετός: ');
INSERT INTO `lang_definitions` VALUES (19414, 1140, 15, 'Πρόβλημα οικογενούς υπερχοληστερολαιμίας ');
INSERT INTO `lang_definitions` VALUES (19415, 1141, 15, 'Ινομυώματα');
INSERT INTO `lang_definitions` VALUES (19416, 1142, 15, 'Αρχείο');
INSERT INTO `lang_definitions` VALUES (19417, 1143, 15, 'Δώμα αρχείων');
INSERT INTO `lang_definitions` VALUES (19418, 1144, 15, 'Αρχείο για ανέβασμα');
INSERT INTO `lang_definitions` VALUES (19419, 1145, 15, 'Αρχείο με το ίδιο όνομα υπάρχει ήδη στη θέση:');
INSERT INTO `lang_definitions` VALUES (19420, 1146, 15, 'Όνομα αρχείου');
INSERT INTO `lang_definitions` VALUES (19421, 1147, 15, 'Συμπληρώστε εδώ μόνο αν στέλνετε κοινοποίηση με email στους ασθενείς');
INSERT INTO `lang_definitions` VALUES (19422, 1148, 15, 'Φίλτρο');
INSERT INTO `lang_definitions` VALUES (19423, 1149, 15, 'Φίλτρο για σταθερές');
INSERT INTO `lang_definitions` VALUES (19424, 1150, 15, 'Φίλτρα ');
INSERT INTO `lang_definitions` VALUES (19425, 1151, 15, 'Τελική Διάγνωση');
INSERT INTO `lang_definitions` VALUES (19426, 1152, 15, 'Τελική διάγνωση ανά ειδικό');
INSERT INTO `lang_definitions` VALUES (19427, 1153, 15, 'Οικονομικά');
INSERT INTO `lang_definitions` VALUES (19428, 1154, 15, 'Οικονομική αναφορά – οτιδήποτε');
INSERT INTO `lang_definitions` VALUES (19429, 1155, 15, 'Οικονομική αναφορά – επισκέψεις μου');
INSERT INTO `lang_definitions` VALUES (19430, 1156, 15, 'Ημερομηνία οικονομικής ανασκόπησης');
INSERT INTO `lang_definitions` VALUES (19431, 1157, 15, 'Εύρεση');
INSERT INTO `lang_definitions` VALUES (19432, 1158, 15, 'Εύρεση διαθεσίμου');
INSERT INTO `lang_definitions` VALUES (19433, 1159, 15, 'Εύρεση διαθέσιμου ραντεβού');
INSERT INTO `lang_definitions` VALUES (19434, 1160, 15, 'Εύρεση ασθενούς');
INSERT INTO `lang_definitions` VALUES (19435, 1161, 15, 'Ευρήματα');
INSERT INTO `lang_definitions` VALUES (19436, 1162, 15, 'Ευρήματα ανά ειδικό');
INSERT INTO `lang_definitions` VALUES (19437, 1163, 15, 'Πρόστιμο ');
INSERT INTO `lang_definitions` VALUES (19438, 1164, 15, 'Πρώτη φορά');
INSERT INTO `lang_definitions` VALUES (19439, 1165, 15, 'Πρώτη ημέρα της εβδομάδας ');
INSERT INTO `lang_definitions` VALUES (19440, 1166, 15, 'Μικρό όνομα');
INSERT INTO `lang_definitions` VALUES (19441, 1167, 15, 'Μικρό όνομα');
INSERT INTO `lang_definitions` VALUES (19442, 1168, 15, 'Μικρό όνομα:');
INSERT INTO `lang_definitions` VALUES (19443, 1169, 15, 'Σωματική άσκηση');
INSERT INTO `lang_definitions` VALUES (19444, 1171, 15, 'Διορθώστε τις ημερομηνίες των επισκέψεων – κάθε επίσκεψη');
INSERT INTO `lang_definitions` VALUES (19445, 1172, 15, 'Διορθώστε αυτό');
INSERT INTO `lang_definitions` VALUES (19446, 1173, 15, 'Μετεωρισμός');
INSERT INTO `lang_definitions` VALUES (19447, 1174, 15, 'Ροή');
INSERT INTO `lang_definitions` VALUES (19448, 1175, 15, 'Εμβολιασμός γρίπης');
INSERT INTO `lang_definitions` VALUES (19449, 1176, 15, 'Πρόβλημα υγρών και ηλεκτρολυτών');
INSERT INTO `lang_definitions` VALUES (19450, 1177, 15, 'Ινομυαλγία');
INSERT INTO `lang_definitions` VALUES (19451, 1178, 15, 'Ακολουθήστε χειροκίνητα');
INSERT INTO `lang_definitions` VALUES (19452, 1179, 15, 'Δυσανεξία τροφής');
INSERT INTO `lang_definitions` VALUES (19453, 1180, 15, 'Πόδι ');
INSERT INTO `lang_definitions` VALUES (19454, 1181, 15, 'Προβλήματα ποδιού');
INSERT INTO `lang_definitions` VALUES (19455, 1182, 15, 'Πόδι:');
INSERT INTO `lang_definitions` VALUES (19456, 1183, 15, 'Κακώσεις ποδοσφαίρου');
INSERT INTO `lang_definitions` VALUES (19457, 1184, 15, 'Αναφορά ποδοσφαιρικής κάκωσης ');
INSERT INTO `lang_definitions` VALUES (19458, 1185, 15, 'Τύπος υποδημάτων');
INSERT INTO `lang_definitions` VALUES (19459, 1186, 15, 'για ');
INSERT INTO `lang_definitions` VALUES (19460, 1189, 15, 'για: ');
INSERT INTO `lang_definitions` VALUES (19461, 1190, 15, 'Πήχης');
INSERT INTO `lang_definitions` VALUES (19462, 1191, 15, 'Έντυπο');
INSERT INTO `lang_definitions` VALUES (19463, 1192, 15, 'έντυπο');
INSERT INTO `lang_definitions` VALUES (19464, 1193, 15, 'μορφοποίηση ');
INSERT INTO `lang_definitions` VALUES (19465, 1194, 15, 'Μορφοποίηση ');
INSERT INTO `lang_definitions` VALUES (19466, 1196, 15, 'Έντυπα ');
INSERT INTO `lang_definitions` VALUES (19467, 1197, 15, 'Έντυπα διαχείρισης');
INSERT INTO `lang_definitions` VALUES (19468, 1198, 15, 'Προώθηση σελίδων μέσω Fax');
INSERT INTO `lang_definitions` VALUES (19469, 1199, 15, 'Τέταρτο');
INSERT INTO `lang_definitions` VALUES (19470, 1200, 15, 'Κάταγμα');
INSERT INTO `lang_definitions` VALUES (19471, 1201, 15, 'Κάταγμα σκαφοειδούς');
INSERT INTO `lang_definitions` VALUES (19472, 1202, 15, 'Κάταγμα έξω σφυρού');
INSERT INTO `lang_definitions` VALUES (19473, 1203, 15, 'Κάταγμα έσω σφυρού');
INSERT INTO `lang_definitions` VALUES (19474, 1204, 15, 'Κάταγμα βάσης 5ου μεταταρσίου');
INSERT INTO `lang_definitions` VALUES (19475, 1205, 15, 'Γαλλικά ');
INSERT INTO `lang_definitions` VALUES (19476, 1206, 15, 'Συχνότητα');
INSERT INTO `lang_definitions` VALUES (19477, 1207, 15, 'Συχνά κρυώματα');
INSERT INTO `lang_definitions` VALUES (19478, 1208, 15, 'Συχνή νοσηση');
INSERT INTO `lang_definitions` VALUES (19479, 1209, 15, 'Παρ');
INSERT INTO `lang_definitions` VALUES (19480, 1210, 15, 'Παρασκευή ');
INSERT INTO `lang_definitions` VALUES (19481, 1211, 15, 'Από ');
INSERT INTO `lang_definitions` VALUES (19482, 1212, 15, 'ΑΠΟ');
INSERT INTO `lang_definitions` VALUES (19483, 1213, 15, 'Από: ');
INSERT INTO `lang_definitions` VALUES (19484, 1214, 15, 'Από: ');
INSERT INTO `lang_definitions` VALUES (19485, 1225, 15, 'Γραφείο υποδοχής');
INSERT INTO `lang_definitions` VALUES (19486, 1226, 15, 'Αποδείξεις γραφείου υποδοχής');
INSERT INTO `lang_definitions` VALUES (19487, 1227, 15, 'Αναφορά αποδείξεων γραφείου υποδοχής');
INSERT INTO `lang_definitions` VALUES (19488, 1228, 15, 'Γραφείο υποδοχής');
INSERT INTO `lang_definitions` VALUES (19489, 1229, 15, 'Μετωπιαία δεξιά:');
INSERT INTO `lang_definitions` VALUES (19490, 1230, 15, 'Πλήρες όνομα');
INSERT INTO `lang_definitions` VALUES (19491, 1234, 15, 'Διαταραχή χοληδόχου');
INSERT INTO `lang_definitions` VALUES (19492, 1235, 15, 'Χολόλιθοι');
INSERT INTO `lang_definitions` VALUES (19493, 1236, 15, 'Περίοδος παιχνιδιού');
INSERT INTO `lang_definitions` VALUES (19494, 1237, 15, 'Παιχνίδια ');
INSERT INTO `lang_definitions` VALUES (19495, 1238, 15, 'Παιχνίδια/συμβάματα');
INSERT INTO `lang_definitions` VALUES (19496, 1239, 15, 'Απολεσθέντα παιχνίδια/συμβάματα');
INSERT INTO `lang_definitions` VALUES (19497, 1240, 15, 'Γαστρίτιδα ');
INSERT INTO `lang_definitions` VALUES (19498, 1241, 15, 'Στομαχ. πόνος');
INSERT INTO `lang_definitions` VALUES (19499, 1242, 15, 'Γαστρεντερικό');
INSERT INTO `lang_definitions` VALUES (19500, 1243, 15, 'Αναφορά στατιστικών GCAC');
INSERT INTO `lang_definitions` VALUES (19501, 1244, 15, 'Το έντυπο επίσκεψης GCAC λείπει');
INSERT INTO `lang_definitions` VALUES (19502, 1245, 15, 'Φύλο');
INSERT INTO `lang_definitions` VALUES (19503, 1246, 15, 'Φύλο');
INSERT INTO `lang_definitions` VALUES (19504, 1247, 15, 'Γενικά');
INSERT INTO `lang_definitions` VALUES (19505, 1248, 15, 'Γενική κατηγορία υπηρεσιών ');
INSERT INTO `lang_definitions` VALUES (19506, 1249, 15, 'Φύλο');
INSERT INTO `lang_definitions` VALUES (19507, 1254, 15, 'Δημιουργία επιστολής');
INSERT INTO `lang_definitions` VALUES (19508, 1255, 15, 'Δημιουργία επιστολής σχετικά με');
INSERT INTO `lang_definitions` VALUES (19509, 1256, 15, 'Δημιουργία Αναφοράς');
INSERT INTO `lang_definitions` VALUES (19510, 1257, 15, 'Δημιουργία Χ12');
INSERT INTO `lang_definitions` VALUES (19511, 1259, 15, 'Δημιουργήθηκε στις');
INSERT INTO `lang_definitions` VALUES (19512, 1260, 15, 'Δημιουργεί ');
INSERT INTO `lang_definitions` VALUES (19513, 1261, 15, 'Ουρογεννητικό');
INSERT INTO `lang_definitions` VALUES (19514, 1262, 15, 'Γερμανικά ');
INSERT INTO `lang_definitions` VALUES (19515, 1263, 15, 'Γλαύκωμα ');
INSERT INTO `lang_definitions` VALUES (19516, 1264, 15, 'Οικογενειακό ιστορικό γλαυκώματος');
INSERT INTO `lang_definitions` VALUES (19517, 1265, 15, 'Γενικό');
INSERT INTO `lang_definitions` VALUES (19518, 1266, 15, 'Γενικό αναγνωριστικό');
INSERT INTO `lang_definitions` VALUES (19519, 1267, 15, 'ΟΚ');
INSERT INTO `lang_definitions` VALUES (19520, 1268, 15, 'ΟΚ');
INSERT INTO `lang_definitions` VALUES (19521, 1269, 15, 'μετάβαση στο');
INSERT INTO `lang_definitions` VALUES (19522, 1270, 15, 'μετάβαση στην εβδομάδα του');
INSERT INTO `lang_definitions` VALUES (19523, 1271, 15, 'Βαθμός: ');
INSERT INTO `lang_definitions` VALUES (19524, 1272, 15, 'γραμμ.');
INSERT INTO `lang_definitions` VALUES (19525, 1273, 15, 'Γενικό Σύνολο ');
INSERT INTO `lang_definitions` VALUES (19526, 1274, 15, 'Γενικά Σύνολα');
INSERT INTO `lang_definitions` VALUES (19527, 1275, 15, 'Ελληνικά');
INSERT INTO `lang_definitions` VALUES (19528, 1276, 15, 'Ομάδα ');
INSERT INTO `lang_definitions` VALUES (19529, 1277, 15, 'Όνομα ομάδας');
INSERT INTO `lang_definitions` VALUES (19530, 1278, 15, 'Τα ονόματα ομάδας δεν μπορούν να είναι κενά');
INSERT INTO `lang_definitions` VALUES (19531, 1279, 15, 'Τα ονόματα ομάδας δεν μπορούν να αρχίζουν με αριθμούς ή κενά');
INSERT INTO `lang_definitions` VALUES (19532, 1280, 15, 'Τα ονόματα ομάδας δεν μπορούν να αρχίζουν με αριθμούς');
INSERT INTO `lang_definitions` VALUES (19533, 1281, 15, 'Αριθμός ομάδας ');
INSERT INTO `lang_definitions` VALUES (19534, 1282, 15, 'Ομάδα: ');
INSERT INTO `lang_definitions` VALUES (19535, 1283, 15, 'Όνομα ομάδας');
INSERT INTO `lang_definitions` VALUES (19536, 1284, 15, 'Ομάδες και έλεγχος πρόσβασης ');
INSERT INTO `lang_definitions` VALUES (19537, 1285, 15, 'Γράφημα ανάπτυξης');
INSERT INTO `lang_definitions` VALUES (19538, 1286, 15, 'Γράφημα ανάπτυξης');
INSERT INTO `lang_definitions` VALUES (19539, 1287, 15, 'σταγόνες (drops)');
INSERT INTO `lang_definitions` VALUES (19540, 1288, 15, 'Γυναικολογική εξέταση');
INSERT INTO `lang_definitions` VALUES (19541, 1290, 15, 'με την κατάκλιση');
INSERT INTO `lang_definitions` VALUES (19542, 1291, 15, 'Ιστορικό ηπατίτιδας');
INSERT INTO `lang_definitions` VALUES (19543, 1292, 15, 'Γράφημα ανάπτυξης');
INSERT INTO `lang_definitions` VALUES (19544, 1293, 15, 'Αιμάτωμα / μώλωπας');
INSERT INTO `lang_definitions` VALUES (19545, 1295, 15, 'Χέρι + δάκτυλα');
INSERT INTO `lang_definitions` VALUES (19546, 1296, 15, 'Προβλήματα χεριού');
INSERT INTO `lang_definitions` VALUES (19547, 1298, 15, 'συνδέθηκε με επίσκεψη');
INSERT INTO `lang_definitions` VALUES (19548, 1299, 15, 'Επικίνδυνες δραστηριότητες');
INSERT INTO `lang_definitions` VALUES (19549, 1300, 15, 'Επικίνδυνες δραστηριότητες');
INSERT INTO `lang_definitions` VALUES (19550, 1305, 15, 'Κεφαλή');
INSERT INTO `lang_definitions` VALUES (19551, 1306, 15, 'Περιφ. Κεφαλής');
INSERT INTO `lang_definitions` VALUES (19552, 1307, 15, 'Περιφέρεια κεφαλής');
INSERT INTO `lang_definitions` VALUES (19553, 1308, 15, 'Πονοκέφαλος');
INSERT INTO `lang_definitions` VALUES (19554, 1309, 15, 'Πονοκέφαλοι ');
INSERT INTO `lang_definitions` VALUES (19555, 1310, 15, 'Κέντρο υγείας/Κλινική');
INSERT INTO `lang_definitions` VALUES (19556, 1311, 15, 'Οργανισμός Διατήρησης Υγείας ');
INSERT INTO `lang_definitions` VALUES (19557, 1313, 15, 'Απώλεια ακοής');
INSERT INTO `lang_definitions` VALUES (19558, 1314, 15, 'Έμφραγμα μυοκαρδίου');
INSERT INTO `lang_definitions` VALUES (19559, 1315, 15, 'Καρδιοπάθεια ');
INSERT INTO `lang_definitions` VALUES (19560, 1316, 15, 'Καρδιακή ανεπάρκεια ');
INSERT INTO `lang_definitions` VALUES (19561, 1317, 15, 'Πρόβλημα καρδιάς ');
INSERT INTO `lang_definitions` VALUES (19562, 1318, 15, 'Καρδιαγγειακό ');
INSERT INTO `lang_definitions` VALUES (19563, 1319, 15, 'Καρδιολογικά');
INSERT INTO `lang_definitions` VALUES (19564, 1320, 15, 'Μεταμόσχευση καρδιάς ');
INSERT INTO `lang_definitions` VALUES (19565, 1321, 15, 'ΚΑΡΔΙΑ:');
INSERT INTO `lang_definitions` VALUES (19566, 1322, 15, 'Καύσος καρδιάς');
INSERT INTO `lang_definitions` VALUES (19567, 1323, 15, 'Ζέστη ή κρύο');
INSERT INTO `lang_definitions` VALUES (19568, 1324, 15, 'Ζέστη ή κρύο');
INSERT INTO `lang_definitions` VALUES (19569, 1325, 15, 'Εβραϊκά ');
INSERT INTO `lang_definitions` VALUES (19570, 1326, 15, 'Κεφάλι, μάτια, αυτιά, μύτη και φάρυγγας');
INSERT INTO `lang_definitions` VALUES (19571, 1327, 15, 'Ύψος');
INSERT INTO `lang_definitions` VALUES (19572, 1328, 15, 'Βοήθεια ');
INSERT INTO `lang_definitions` VALUES (19573, 1329, 15, 'βοήθεια ');
INSERT INTO `lang_definitions` VALUES (19574, 1330, 15, 'Αιματέμεση');
INSERT INTO `lang_definitions` VALUES (19575, 1331, 15, 'Αιματοχεσία');
INSERT INTO `lang_definitions` VALUES (19576, 1332, 15, 'Αιματολογικό');
INSERT INTO `lang_definitions` VALUES (19577, 1333, 15, 'Αιματουρία');
INSERT INTO `lang_definitions` VALUES (19578, 1334, 15, 'Αιμοσφαιρίνη ');
INSERT INTO `lang_definitions` VALUES (19579, 1335, 15, 'Αιμόπτυση');
INSERT INTO `lang_definitions` VALUES (19580, 1336, 15, 'Ηπατίτιδα');
INSERT INTO `lang_definitions` VALUES (19581, 1337, 15, 'Ηπατίτιδα Α 1');
INSERT INTO `lang_definitions` VALUES (19582, 1338, 15, 'Ηπατίτιδα Α 2');
INSERT INTO `lang_definitions` VALUES (19583, 1339, 15, 'Ηπατίτιδα Β 1');
INSERT INTO `lang_definitions` VALUES (19584, 1340, 15, 'Ηπατίτιδα Β 2');
INSERT INTO `lang_definitions` VALUES (19585, 1341, 15, 'Ηπατίτιδα Β 3');
INSERT INTO `lang_definitions` VALUES (19586, 1342, 15, 'εδώ');
INSERT INTO `lang_definitions` VALUES (19587, 1343, 15, 'Διόρθωση κήλης');
INSERT INTO `lang_definitions` VALUES (19588, 1344, 15, 'Κήλη δίσκου');
INSERT INTO `lang_definitions` VALUES (19589, 1345, 15, 'Έρπης ');
INSERT INTO `lang_definitions` VALUES (19590, 1346, 15, 'Δισταγμός');
INSERT INTO `lang_definitions` VALUES (19591, 1347, 15, 'heyyo. Ήσασταν εδώ για');
INSERT INTO `lang_definitions` VALUES (19592, 1348, 15, 'Αιμόφυλλος της γρίππης 1');
INSERT INTO `lang_definitions` VALUES (19593, 1349, 15, 'Αιμόφυλλος της γρίππης 2');
INSERT INTO `lang_definitions` VALUES (19594, 1350, 15, 'Αιμόφυλλος της γρίππης 3');
INSERT INTO `lang_definitions` VALUES (19595, 1351, 15, 'Αιμόφυλλος της γρίππης 4');
INSERT INTO `lang_definitions` VALUES (19596, 1352, 15, 'Κρυφό');
INSERT INTO `lang_definitions` VALUES (19597, 1353, 15, 'Διαχείριση κρυφών συμβαμάτων');
INSERT INTO `lang_definitions` VALUES (19598, 1354, 15, 'Κρύψιμο');
INSERT INTO `lang_definitions` VALUES (19599, 1355, 15, 'Κρύψιμο πληροφοριών');
INSERT INTO `lang_definitions` VALUES (19600, 1357, 15, 'Υψηλό');
INSERT INTO `lang_definitions` VALUES (19601, 1358, 15, 'Υψηλή πίεση αίματος ');
INSERT INTO `lang_definitions` VALUES (19602, 1359, 15, 'Ισχίο + βουβωνική χώρα');
INSERT INTO `lang_definitions` VALUES (19603, 1360, 15, 'Ισχίο και βουβωνική χώρα');
INSERT INTO `lang_definitions` VALUES (19604, 1361, 15, 'Προβλήματα ισχίου');
INSERT INTO `lang_definitions` VALUES (19605, 1362, 15, 'Αντιακάσταση ισχίου');
INSERT INTO `lang_definitions` VALUES (19606, 1364, 15, 'Υπερτρίχωση');
INSERT INTO `lang_definitions` VALUES (19607, 1365, 15, 'Ισπανόφωνος ');
INSERT INTO `lang_definitions` VALUES (19608, 1366, 15, 'Ιστορικό');
INSERT INTO `lang_definitions` VALUES (19609, 1367, 15, 'Ιστορικά δεδομένα');
INSERT INTO `lang_definitions` VALUES (19610, 1368, 15, 'Ιστορικό φυσημάτων');
INSERT INTO `lang_definitions` VALUES (19611, 1369, 15, 'Ιστορικό φυσημάτων');
INSERT INTO `lang_definitions` VALUES (19612, 1370, 15, 'HIV');
INSERT INTO `lang_definitions` VALUES (19613, 1371, 15, 'HL7 Viewer');
INSERT INTO `lang_definitions` VALUES (19614, 1372, 15, 'Κρατήστε το [Ctrl] πατημένο για πολλαπλή επιλογή ή αποεπιλογή');
INSERT INTO `lang_definitions` VALUES (19615, 1373, 15, 'Κρατήστε το [Ctrl] πατημένο για επιλογή πολλών αντικειμένων');
INSERT INTO `lang_definitions` VALUES (19616, 1374, 15, 'Κρατήστε το [Ctrl] πατημένο για επιλογή πολλών ομάδων');
INSERT INTO `lang_definitions` VALUES (19617, 1375, 15, 'Οικία');
INSERT INTO `lang_definitions` VALUES (19618, 1376, 15, 'Τηλέφωνο οικίας ');
INSERT INTO `lang_definitions` VALUES (19619, 1377, 15, 'Αριθμός τηλεφώνου οικίας ');
INSERT INTO `lang_definitions` VALUES (19620, 1378, 15, 'Άστεγος ή παρόμοιο;');
INSERT INTO `lang_definitions` VALUES (19621, 1379, 15, 'Άστεγος, κτλ');
INSERT INTO `lang_definitions` VALUES (19622, 1380, 15, 'Άστεγος, κτλ');
INSERT INTO `lang_definitions` VALUES (19623, 1381, 15, 'Ώρες ');
INSERT INTO `lang_definitions` VALUES (19624, 1382, 15, 'Πως συνέβη η κάκωση;');
INSERT INTO `lang_definitions` VALUES (19625, 1383, 15, 'Πως συνέβη η κάκωση;');
INSERT INTO `lang_definitions` VALUES (19626, 1384, 15, 'Πόσους μήνες νωρίτερα να ρωτήσω για επερχόμενα συμβάντα;');
INSERT INTO `lang_definitions` VALUES (19627, 1387, 15, 'HTML');
INSERT INTO `lang_definitions` VALUES (19628, 1388, 15, 'Υπερκινητικό');
INSERT INTO `lang_definitions` VALUES (19629, 1389, 15, 'Υπέρταση ');
INSERT INTO `lang_definitions` VALUES (19630, 1390, 15, 'Υπερθυρεοειδισμός ');
INSERT INTO `lang_definitions` VALUES (19631, 1391, 15, 'Υποθυρεοειδισμός ');
INSERT INTO `lang_definitions` VALUES (19632, 1392, 15, 'Υστερεκτομή ');
INSERT INTO `lang_definitions` VALUES (19633, 1393, 15, 'Εγώ');
INSERT INTO `lang_definitions` VALUES (19634, 1394, 15, 'Είμαι απασχολημένος/η αυτόν τον καιρό');
INSERT INTO `lang_definitions` VALUES (19635, 1395, 15, 'Δεν έχω την άδεια να διαβάσω');
INSERT INTO `lang_definitions` VALUES (19636, 1396, 15, 'ICD');
INSERT INTO `lang_definitions` VALUES (19637, 1398, 15, 'Κωδικός');
INSERT INTO `lang_definitions` VALUES (19638, 1399, 15, 'Ο κωδικός δεν μπορεί να είναι κενός');
INSERT INTO `lang_definitions` VALUES (19639, 1401, 15, 'αναγνωρίστηκε ως');
INSERT INTO `lang_definitions` VALUES (19640, 1402, 15, 'Αναγνωριστικό (μία λέξη) ');
INSERT INTO `lang_definitions` VALUES (19641, 1403, 15, 'Αν όλα τα δεδομένα για όλες τις στήλες είναι πλήρη για αυτό το έντυπο');
INSERT INTO `lang_definitions` VALUES (19642, 1404, 15, 'αν όνομα, οποιοδήποτε τμήμα του επωνύμου ή επώνυμο,όνομα');
INSERT INTO `lang_definitions` VALUES (19643, 1405, 15, 'αν άνεργος εισάγετε Φοιτητής ');
INSERT INTO `lang_definitions` VALUES (19644, 1406, 15, 'Εάν έχετε επιλέξει να φορτώσετε ηλεκτρονικά εμβάσματα, τότε το παράθυρο αναζήτησης ίδιο αναπαραουσιάζεται με τα τιμολόγια που ταιριάζουν από το αρχείο X12. Μπορείτε να κάνετε κλικ σε οποιοδήποτε από αυτούς τους αριθμούς τιμολογίου (όπως περιγράφεται παρακάτω), εάν θέλετε να κάνετε διορθώσεις πριν να εφαμροστούν οι πληροφορίες εμβάσματος. Για να εφαρμόσετε τις αλλαγές, κάντε κλικ στο κουμπί του αρχείου Διαδικασίας ERA στο κάτω μέρος της σελίδας. Αυτό θα παραγάγει ένα νέο παράθυρο με μια λεπτομερή αναφορά.');
INSERT INTO `lang_definitions` VALUES (19645, 1407, 15, 'Εάν έχετε εισάγει μια Ημερομηνία Πληρωμής στη σελίδα αναζήτησης, αυτή θα αντικαταστήσει την ημερομηνία αποστολής των πληρωμών και των προσαρμογών που λαμβάνονται ούτως ή άλλως από το αρχείο X12. Αυτό μπορεί να είναι χρήσιμο για σκοπούς αναφοράς, αν θέλετε οι αποδείξεις αναφοράς σας να χρησιμοποιήσουν την ημερομηνία αποστολής σας αντί της ημερομηνίας επεξεργασίας της ασφαλιστικής εταιρείας. Σημειώστε ότι αυτό θα επηρεάσει επίσης τις ημερομηνίες των προηγούμενων πληρωμών και τις προσαρμογές που έχουν τεθεί σε δευτερεύουσες απαιτήσεις.');
INSERT INTO `lang_definitions` VALUES (19646, 1408, 15, 'Αν θέλετε να αλλάξετε τους τύπους δεδομένων, ή να προσθέσετε γραμμές ή στήλες ');
INSERT INTO `lang_definitions` VALUES (19647, 1409, 15, 'Αρρώστια');
INSERT INTO `lang_definitions` VALUES (19648, 1410, 15, 'Ενδομυϊκά');
INSERT INTO `lang_definitions` VALUES (19649, 1411, 15, 'Ανοσοποίηση ');
INSERT INTO `lang_definitions` VALUES (19650, 1412, 15, 'Αριθμό παρτίδας ανοσοποίησης');
INSERT INTO `lang_definitions` VALUES (19651, 1413, 15, 'Κατασκευαστής ανοσοποίησης');
INSERT INTO `lang_definitions` VALUES (19652, 1414, 15, 'Ανοσοποιήσεις');
INSERT INTO `lang_definitions` VALUES (19653, 1415, 15, 'Ανοσοποίηση ');
INSERT INTO `lang_definitions` VALUES (19654, 1416, 15, 'Αναοσολογικό');
INSERT INTO `lang_definitions` VALUES (19655, 1417, 15, 'Εμφυτεύματα ');
INSERT INTO `lang_definitions` VALUES (19656, 1418, 15, 'Εισαγωγή ');
INSERT INTO `lang_definitions` VALUES (19657, 1419, 15, 'Εισαγωγή ρυθμίσεων');
INSERT INTO `lang_definitions` VALUES (19658, 1420, 15, 'Εισαγωγή ασθενή');
INSERT INTO `lang_definitions` VALUES (19659, 1421, 15, 'Εισαγωγή δημογραφικών ασθενή');
INSERT INTO `lang_definitions` VALUES (19660, 1422, 15, 'Εισαγόμενο από το Λογιστήριο ');
INSERT INTO `lang_definitions` VALUES (19661, 1423, 15, 'Βελτιωμένο');
INSERT INTO `lang_definitions` VALUES (19662, 1424, 15, 'ίντσες');
INSERT INTO `lang_definitions` VALUES (19663, 1426, 15, 'σε κάθε οφθαλμό ');
INSERT INTO `lang_definitions` VALUES (19664, 1427, 15, 'στον αριστερό οφθαλμό ');
INSERT INTO `lang_definitions` VALUES (19665, 1428, 15, 'στο ρουθούνι ');
INSERT INTO `lang_definitions` VALUES (19666, 1429, 15, 'Στο γραφείο');
INSERT INTO `lang_definitions` VALUES (19667, 1430, 15, 'Στο δεξί οφθαλμό ');
INSERT INTO `lang_definitions` VALUES (19668, 1431, 15, 'κατ\' οίκον');
INSERT INTO `lang_definitions` VALUES (19669, 1432, 15, 'Ανενεργό');
INSERT INTO `lang_definitions` VALUES (19670, 1433, 15, 'Ανενεργές ημέρες ');
INSERT INTO `lang_definitions` VALUES (19671, 1434, 15, 'Συμπεριέλαβε ανενεργούς χρήστες');
INSERT INTO `lang_definitions` VALUES (19672, 1435, 15, 'Συμπεριέλαβε μη κατηγοριοποιημενα');
INSERT INTO `lang_definitions` VALUES (19673, 1436, 15, 'Να συμπεριληφθούν τα ζωτικά');
INSERT INTO `lang_definitions` VALUES (19674, 1437, 15, 'Να συμπεριληφθούν τα ζωτικά δεδομένα; ');
INSERT INTO `lang_definitions` VALUES (19675, 1438, 15, 'Εισόδημα ');
INSERT INTO `lang_definitions` VALUES (19676, 1439, 15, 'Ατελής θεραπεία άμβλωσης');
INSERT INTO `lang_definitions` VALUES (19677, 1440, 15, 'Ακράτεια');
INSERT INTO `lang_definitions` VALUES (19678, 1441, 15, 'αυξημένο: ');
INSERT INTO `lang_definitions` VALUES (19679, 1442, 15, 'Ασφάλεια αποζημείωσης');
INSERT INTO `lang_definitions` VALUES (19680, 1443, 15, 'Απροσδιόριστο');
INSERT INTO `lang_definitions` VALUES (19681, 1444, 15, 'Υποδηλώνει εάν αυτό το θέμα είναι ενεργό');
INSERT INTO `lang_definitions` VALUES (19682, 1445, 15, 'Αναφορά άπορου ασθενούς ');
INSERT INTO `lang_definitions` VALUES (19683, 1446, 15, 'Άποροι');
INSERT INTO `lang_definitions` VALUES (19684, 1447, 15, 'Προκλητή άμβλωση');
INSERT INTO `lang_definitions` VALUES (19685, 1448, 15, 'Λοίμωξη / Απόστημα ');
INSERT INTO `lang_definitions` VALUES (19686, 1449, 15, 'Λοιμώξεις ');
INSERT INTO `lang_definitions` VALUES (19687, 1450, 15, 'Εκτιμ. Γονιμ.');
INSERT INTO `lang_definitions` VALUES (19688, 1451, 15, 'Υπογονιμότητα');
INSERT INTO `lang_definitions` VALUES (19689, 1452, 15, 'Γρίπη 1');
INSERT INTO `lang_definitions` VALUES (19690, 1453, 15, 'Γρίπη 2');
INSERT INTO `lang_definitions` VALUES (19691, 1454, 15, 'Πληροφορίες ');
INSERT INTO `lang_definitions` VALUES (19692, 1455, 15, 'Έλεγχος πληροφορίας 1');
INSERT INTO `lang_definitions` VALUES (19693, 1456, 15, 'Έλεγχος πληροφορίας 2');
INSERT INTO `lang_definitions` VALUES (19694, 1457, 15, 'Έλεγχος πληροφορίας 3');
INSERT INTO `lang_definitions` VALUES (19695, 1458, 15, 'Έλεγχος πληροφορίας 4');
INSERT INTO `lang_definitions` VALUES (19696, 1459, 15, 'Έλεγχος πληροφορίας 5');
INSERT INTO `lang_definitions` VALUES (19697, 1460, 15, 'Έλεγχος πληροφορίας 6');
INSERT INTO `lang_definitions` VALUES (19698, 1461, 15, 'εισπνοές (inh)');
INSERT INTO `lang_definitions` VALUES (19699, 1462, 15, 'εισπνοές ');
INSERT INTO `lang_definitions` VALUES (19700, 1463, 15, 'Αρχικός χρήστης');
INSERT INTO `lang_definitions` VALUES (19701, 1464, 15, 'ενέσιμα');
INSERT INTO `lang_definitions` VALUES (19702, 1466, 15, 'Κάκωση');
INSERT INTO `lang_definitions` VALUES (19703, 1467, 15, 'Μηχανισμός κάκωσης');
INSERT INTO `lang_definitions` VALUES (19704, 1468, 15, 'Αναφορά περίληψης κάκωσης');
INSERT INTO `lang_definitions` VALUES (19705, 1469, 15, 'Παρακολούθηση κάκωσης');
INSERT INTO `lang_definitions` VALUES (19706, 1470, 15, 'Τύπος κάκωσης');
INSERT INTO `lang_definitions` VALUES (19707, 1471, 15, 'Πεδίου εισόδου');
INSERT INTO `lang_definitions` VALUES (19708, 1472, 15, 'Προσαρμογή ασφ');
INSERT INTO `lang_definitions` VALUES (19709, 1475, 15, 'Επιστροφή χρημάτων ασφ');
INSERT INTO `lang_definitions` VALUES (19710, 1476, 15, 'Περίληψη ασφ');
INSERT INTO `lang_definitions` VALUES (19711, 1477, 15, 'Ασφ1');
INSERT INTO `lang_definitions` VALUES (19712, 1478, 15, 'Ασφ2');
INSERT INTO `lang_definitions` VALUES (19713, 1479, 15, 'Ασφ3');
INSERT INTO `lang_definitions` VALUES (19714, 1480, 15, 'Εισαγωγή απέτυχε: ');
INSERT INTO `lang_definitions` VALUES (19715, 1481, 15, 'Τοποθέτηση παλαιών συμβαμάτων σε πίνακες ');
INSERT INTO `lang_definitions` VALUES (19716, 1482, 15, 'Ακράτεια');
INSERT INTO `lang_definitions` VALUES (19717, 1483, 15, 'Επισκόπηση');
INSERT INTO `lang_definitions` VALUES (19718, 1484, 15, 'Αστάθεια / εξάρθρημα ');
INSERT INTO `lang_definitions` VALUES (19719, 1485, 15, 'Εγκατάσταση ΒΔ');
INSERT INTO `lang_definitions` VALUES (19720, 1486, 15, 'Ενημερωμένος');
INSERT INTO `lang_definitions` VALUES (19721, 1487, 15, 'Οδηγίες: ');
INSERT INTO `lang_definitions` VALUES (19722, 1488, 15, 'Ινσουλινοεξαρτώμενος διαβήτης ');
INSERT INTO `lang_definitions` VALUES (19723, 1489, 15, 'Ασφάλιση');
INSERT INTO `lang_definitions` VALUES (19724, 1490, 15, 'ασφάλιση ');
INSERT INTO `lang_definitions` VALUES (19725, 1491, 15, 'Ασφαλιστικές Εταιρίες ');
INSERT INTO `lang_definitions` VALUES (19726, 1492, 15, 'Ασφαλιστική Εταιρία ');
INSERT INTO `lang_definitions` VALUES (19727, 1493, 15, 'Ασφαλιστική Εταιρία Αναζήτηση/Προσθήκη ');
INSERT INTO `lang_definitions` VALUES (19728, 1494, 15, 'Στοιχεία Ασφάλισης ');
INSERT INTO `lang_definitions` VALUES (19729, 1495, 15, 'Αριθμοί Ασφάλισης ');
INSERT INTO `lang_definitions` VALUES (19730, 1496, 15, 'Πάροχος Ασφάλισης ');
INSERT INTO `lang_definitions` VALUES (19731, 1497, 15, 'Συμπέρασμα λήψης');
INSERT INTO `lang_definitions` VALUES (19732, 1498, 15, 'Ημερομηνία λήψης');
INSERT INTO `lang_definitions` VALUES (19733, 1499, 15, 'Νοητική υστέρηση');
INSERT INTO `lang_definitions` VALUES (19734, 1500, 15, 'Εσωτερικό σφάλμα – δεν επελέγησαν σελίδες! ');
INSERT INTO `lang_definitions` VALUES (19735, 1501, 15, 'Εσωτερικό σφάλμα – το ID ασθενούς δεν δόθηκε! ');
INSERT INTO `lang_definitions` VALUES (19736, 1502, 15, 'Εσωτερικό σφάλμα κατά την προσπέλαση του αρχείου ανεβάσματος!');
INSERT INTO `lang_definitions` VALUES (19737, 1503, 15, 'Εσωτερικό σφάλμα!');
INSERT INTO `lang_definitions` VALUES (19738, 1504, 15, 'Εσωτερικό σφάλμα, δε δόθηκε αναγνωριστικό φαρμάκου!');
INSERT INTO `lang_definitions` VALUES (19739, 1505, 15, 'Εσωτερικό σφάλμα: αξίωση ');
INSERT INTO `lang_definitions` VALUES (19740, 1506, 15, 'Εσωτερικό σφάλμα: επίσκεψη');
INSERT INTO `lang_definitions` VALUES (19741, 1507, 15, 'Εσωτερικό σφάλμα: λείπει αναγνωριστικό ασθενή η επίσκεψης.');
INSERT INTO `lang_definitions` VALUES (19742, 1508, 15, 'Εσωτερικό αναγνωριστικό (pid)');
INSERT INTO `lang_definitions` VALUES (19743, 1509, 15, 'Εσωτερικές παραπομπές');
INSERT INTO `lang_definitions` VALUES (19744, 1510, 15, 'Διεθνές χρέος');
INSERT INTO `lang_definitions` VALUES (19745, 1511, 15, 'Διερμηνέας');
INSERT INTO `lang_definitions` VALUES (19746, 1512, 15, 'Απαιτείται διερμηνέας;');
INSERT INTO `lang_definitions` VALUES (19747, 1513, 15, 'Διάμεση πνευμονική νόσος');
INSERT INTO `lang_definitions` VALUES (19748, 1514, 15, 'Μεσοδιάστημα');
INSERT INTO `lang_definitions` VALUES (19749, 1515, 15, 'Ανοχή');
INSERT INTO `lang_definitions` VALUES (19750, 1516, 15, 'ενδομυικα');
INSERT INTO `lang_definitions` VALUES (19751, 1517, 15, 'ενδοφλέβια');
INSERT INTO `lang_definitions` VALUES (19752, 1518, 15, 'Εισαγωγή ');
INSERT INTO `lang_definitions` VALUES (19753, 1519, 15, 'Άκυρος ή ελλιπής πληρωτής στην πηγή για τον κωδικό ');
INSERT INTO `lang_definitions` VALUES (19754, 1520, 15, 'Άκυροι Κωδικοί Υπηρεσίας ');
INSERT INTO `lang_definitions` VALUES (19755, 1521, 15, 'Άκυρος προσδιορισμός πηγής');
INSERT INTO `lang_definitions` VALUES (19756, 1522, 15, 'Ποσό απογραφής');
INSERT INTO `lang_definitions` VALUES (19757, 1523, 15, 'Απογραφή');
INSERT INTO `lang_definitions` VALUES (19758, 1524, 15, 'Η απογραφή δεν είναι διαθέσιμη για αυτήν την παραγγελία');
INSERT INTO `lang_definitions` VALUES (19759, 1525, 15, 'Λίστα απογραφής');
INSERT INTO `lang_definitions` VALUES (19760, 1526, 15, 'Τιμολόγιο ');
INSERT INTO `lang_definitions` VALUES (19761, 1527, 15, 'Τιμολόγιο ');
INSERT INTO `lang_definitions` VALUES (19762, 1528, 15, 'Ημερομηνία τιμολογίου ');
INSERT INTO `lang_definitions` VALUES (19763, 1529, 15, 'Το τιμολόγιο δεν έχει ημερομηνία! ');
INSERT INTO `lang_definitions` VALUES (19764, 1530, 15, 'Τιμολόγιο: ');
INSERT INTO `lang_definitions` VALUES (19765, 1533, 15, 'Απεν Ιός Θηλώμ (IPV) 1');
INSERT INTO `lang_definitions` VALUES (19766, 1534, 15, 'Απεν Ιός Θηλώμ (IPV) 2');
INSERT INTO `lang_definitions` VALUES (19767, 1535, 15, 'Απεν Ιός Θηλώμ (IPV) 3');
INSERT INTO `lang_definitions` VALUES (19768, 1536, 15, 'Απεν Ιός Θηλώμ (IPV) 4');
INSERT INTO `lang_definitions` VALUES (19769, 1537, 15, 'Άρρυθμος καρδιακός παλμός');
INSERT INTO `lang_definitions` VALUES (19770, 1538, 15, 'Ευερεθιστότητα');
INSERT INTO `lang_definitions` VALUES (19771, 1539, 15, 'Ερεθισμός');
INSERT INTO `lang_definitions` VALUES (19772, 1540, 15, 'είναι υποχρεωτικό πεδίο.');
INSERT INTO `lang_definitions` VALUES (19773, 1541, 15, 'είναι βασικός κόμβος και δεν μπορεί να σβηστεί');
INSERT INTO `lang_definitions` VALUES (19774, 1542, 15, 'δεν είναι έγκυρο (δεκαδικά κλάσματα είναι εντάξει). ');
INSERT INTO `lang_definitions` VALUES (19775, 1543, 15, 'Είναι PHP χρησιμοποιώντας Safe Mode; ');
INSERT INTO `lang_definitions` VALUES (19776, 1545, 15, 'Πρόβλημα');
INSERT INTO `lang_definitions` VALUES (19777, 1546, 15, 'Διάγνωση');
INSERT INTO `lang_definitions` VALUES (19778, 1547, 15, 'Διαγνώσεις');
INSERT INTO `lang_definitions` VALUES (19779, 1548, 15, 'Διαγνώσεις (Κακώσεις/Ιατρικά/Αλλεργία): ');
INSERT INTO `lang_definitions` VALUES (19780, 1549, 15, 'Διαγνώσεις και Επισκέψεις');
INSERT INTO `lang_definitions` VALUES (19781, 1550, 15, 'Διαγνώσεις και Επισκέψεις για');
INSERT INTO `lang_definitions` VALUES (19782, 1551, 15, 'Τα θέματα δεν επιτρέπονται');
INSERT INTO `lang_definitions` VALUES (19783, 1552, 15, 'Τμήμα θεμάτων ');
INSERT INTO `lang_definitions` VALUES (19784, 1553, 15, 'Αντικείμενο ');
INSERT INTO `lang_definitions` VALUES (19785, 1554, 15, 'αντικείμενο ');
INSERT INTO `lang_definitions` VALUES (19786, 1555, 15, 'Η φόρτωση των αντικειμένων απέτυχε ');
INSERT INTO `lang_definitions` VALUES (19787, 1556, 15, 'Ενδομήτρια αντισύλληψη');
INSERT INTO `lang_definitions` VALUES (19788, 1557, 15, 'Ενδοφλέβια');
INSERT INTO `lang_definitions` VALUES (19789, 1558, 15, 'Ιανουάριος ');
INSERT INTO `lang_definitions` VALUES (19790, 1559, 15, 'Ίκτερος');
INSERT INTO `lang_definitions` VALUES (19791, 1560, 15, 'Περιγραφή εργασίας ');
INSERT INTO `lang_definitions` VALUES (19792, 1561, 15, 'Αναγνωριστικό εργασίας');
INSERT INTO `lang_definitions` VALUES (19793, 1562, 15, 'Εξαρθρήματα');
INSERT INTO `lang_definitions` VALUES (19794, 1563, 15, 'Αρθρικός πόνος');
INSERT INTO `lang_definitions` VALUES (19795, 1564, 15, 'Αρθρικός πόνος');
INSERT INTO `lang_definitions` VALUES (19796, 1565, 15, 'Ιούλιος');
INSERT INTO `lang_definitions` VALUES (19797, 1566, 15, 'Ιούνιος');
INSERT INTO `lang_definitions` VALUES (19798, 1567, 15, 'Ακριβώς κάτω από τις πληροφορίες ελέγχου είναι μια μπλε περιοχή όπου τοποθετείτε τις παραμέτρους της αναζήτησής σας. Μπορείτε να αναζητήσετε με βάση το όνομα του ασθενούς, τον αριθμό γραφήματος, τον αριθμό επίσκεψης ή την ημερομηνία της υπηρεσίας, ή οποιοδήποτε συνδυασμό αυτών. Μπορείτε επίσης να επιλέξετε αν θέλετε να δείτε όλα τα τιμολόγια, τα ανοικτά τιμολόγια, ή μόνο τα τιμολόγια που οφείλονται (από τον ασθενή). Κάντε κλικ στο κουμπί Αναζήτηση για να εκτελέσετε την αναζήτηση.');
INSERT INTO `lang_definitions` VALUES (19799, 1568, 15, 'Προβολή μόνο των δικών μου');
INSERT INTO `lang_definitions` VALUES (19800, 1569, 15, 'Επιβεβαίωση');
INSERT INTO `lang_definitions` VALUES (19801, 1570, 15, 'Επιβεβαίωση/Αποθήκευση');
INSERT INTO `lang_definitions` VALUES (19802, 1572, 15, 'Λέξεις κλειδιά');
INSERT INTO `lang_definitions` VALUES (19803, 1573, 15, 'κιλά');
INSERT INTO `lang_definitions` VALUES (19804, 1574, 15, 'kgr/m^2');
INSERT INTO `lang_definitions` VALUES (19805, 1575, 15, 'Καρκίνος νεφρών');
INSERT INTO `lang_definitions` VALUES (19806, 1576, 15, 'Νεφρική ανεπάρκεια ');
INSERT INTO `lang_definitions` VALUES (19807, 1577, 15, 'Λοιμώξεις νεφρού');
INSERT INTO `lang_definitions` VALUES (19808, 1578, 15, 'Λίθοι νεφρών ');
INSERT INTO `lang_definitions` VALUES (19809, 1579, 15, 'Μεταμοσχεύση νεφρού ');
INSERT INTO `lang_definitions` VALUES (19810, 1580, 15, 'Γόνατο');
INSERT INTO `lang_definitions` VALUES (19811, 1581, 15, 'Προβλήματα γονάτου ');
INSERT INTO `lang_definitions` VALUES (19812, 1582, 15, 'Αντικατάσταση γονάτου ');
INSERT INTO `lang_definitions` VALUES (19813, 1583, 15, 'Εργαστήριο');
INSERT INTO `lang_definitions` VALUES (19814, 1584, 15, 'Εργαστηριακά');
INSERT INTO `lang_definitions` VALUES (19815, 1585, 15, 'Ετικέτα ');
INSERT INTO `lang_definitions` VALUES (19816, 1586, 15, 'Η ετικέτα δεν μπορεί να είναι κενή');
INSERT INTO `lang_definitions` VALUES (19817, 1587, 15, 'Στήλες ετικέτας');
INSERT INTO `lang_definitions` VALUES (19818, 1588, 15, 'Οι Στήλες Ετικέτας πρέπει να είναι αριθμός μεταξύ 1 και 999');
INSERT INTO `lang_definitions` VALUES (19819, 1589, 15, 'Ετικέτες ');
INSERT INTO `lang_definitions` VALUES (19820, 1590, 15, 'Εργαστήρια ');
INSERT INTO `lang_definitions` VALUES (19821, 1591, 15, 'Τεμαχισμός/κατάσταση δέρματος ');
INSERT INTO `lang_definitions` VALUES (19822, 1592, 15, 'Τεμαχισμός/εκδορά');
INSERT INTO `lang_definitions` VALUES (19823, 1593, 15, 'Γλώσσα');
INSERT INTO `lang_definitions` VALUES (19824, 1594, 15, 'Κωδικός γλώσσας');
INSERT INTO `lang_definitions` VALUES (19825, 1595, 15, 'Ο ορισμός της γλώσσας προστέθηκε ');
INSERT INTO `lang_definitions` VALUES (19826, 1596, 15, 'Εργαλείο Διεπαφής Γλώσσας');
INSERT INTO `lang_definitions` VALUES (19827, 1597, 15, 'Λίστα γλωσσών (εγγραφή, προαιρετικά προσθήκη)');
INSERT INTO `lang_definitions` VALUES (19828, 1598, 15, 'Όνομα γλώσσας');
INSERT INTO `lang_definitions` VALUES (19829, 1599, 15, 'Γλώσσα:');
INSERT INTO `lang_definitions` VALUES (19830, 1600, 15, 'Τελευταίο');
INSERT INTO `lang_definitions` VALUES (19831, 1601, 15, 'Ημερομηνία τελευταίας δραστηριότητας');
INSERT INTO `lang_definitions` VALUES (19832, 1602, 15, 'Ημερομηνία τελευταίας χρέωσης:');
INSERT INTO `lang_definitions` VALUES (19833, 1603, 15, 'Τελευταία επίσκεψη');
INSERT INTO `lang_definitions` VALUES (19834, 1604, 15, 'Επώνυμο ');
INSERT INTO `lang_definitions` VALUES (19835, 1605, 15, 'Επώνυμο ');
INSERT INTO `lang_definitions` VALUES (19836, 1606, 15, 'Επώνυμο: ');
INSERT INTO `lang_definitions` VALUES (19837, 1607, 15, 'Τελευταία αποθήκευση');
INSERT INTO `lang_definitions` VALUES (19838, 1608, 15, 'Τελευταία ενημέρωση από ');
INSERT INTO `lang_definitions` VALUES (19839, 1609, 15, 'Τελευταία επίσκεψη');
INSERT INTO `lang_definitions` VALUES (19840, 1610, 15, 'Όψιμη υποτροπή (2-12 μήνες)');
INSERT INTO `lang_definitions` VALUES (19841, 1611, 15, 'Έξω σφυρό');
INSERT INTO `lang_definitions` VALUES (19842, 1612, 15, 'Έξω σφυρό:');
INSERT INTO `lang_definitions` VALUES (19843, 1613, 15, 'πλαγίως παρεκτοπισμένο σημείο μέγιστης ακρόασης:');
INSERT INTO `lang_definitions` VALUES (19844, 1614, 15, 'Βασισμένο σε χωροθέτηση');
INSERT INTO `lang_definitions` VALUES (19845, 1615, 15, 'Επεξεργασία της χωροθέτησης');
INSERT INTO `lang_definitions` VALUES (19846, 1616, 15, 'Ομάδες χωροθέτησης');
INSERT INTO `lang_definitions` VALUES (19847, 1617, 15, 'Έντυπα επίσκεψης βασισμένα σε χωροθέτηση');
INSERT INTO `lang_definitions` VALUES (19848, 1618, 15, 'Χωροθετήσεις ');
INSERT INTO `lang_definitions` VALUES (19849, 1619, 15, 'λίβρες');
INSERT INTO `lang_definitions` VALUES (19850, 1620, 15, 'λίβρες');
INSERT INTO `lang_definitions` VALUES (19851, 1621, 15, 'LDL ');
INSERT INTO `lang_definitions` VALUES (19852, 1622, 15, 'αφήστε κενό αν είναι ακόμα ενεργό');
INSERT INTO `lang_definitions` VALUES (19853, 1623, 15, 'Αφήστε κενό για να διατηρηθεί αμετάβλητο ο κωδικός πρόσβασης.');
INSERT INTO `lang_definitions` VALUES (19854, 1624, 15, 'Να σταλεί μήνυμα με');
INSERT INTO `lang_definitions` VALUES (19855, 1625, 15, 'Αφήστε το έντυπο');
INSERT INTO `lang_definitions` VALUES (19856, 1626, 15, 'Αριστερά ');
INSERT INTO `lang_definitions` VALUES (19857, 1627, 15, 'Αριστερό αυτί');
INSERT INTO `lang_definitions` VALUES (19858, 1628, 15, 'αριστερό αυτί ');
INSERT INTO `lang_definitions` VALUES (19859, 1629, 15, 'Αριστερά: ');
INSERT INTO `lang_definitions` VALUES (19860, 1630, 15, 'Αριστερά: ');
INSERT INTO `lang_definitions` VALUES (19861, 1631, 15, 'Άλγος κάτω άκρου/Κράμπα');
INSERT INTO `lang_definitions` VALUES (19862, 1632, 15, 'Νομικός/ή/ο');
INSERT INTO `lang_definitions` VALUES (19863, 1633, 15, 'Υπόμνημα: ');
INSERT INTO `lang_definitions` VALUES (19864, 1634, 15, 'Μήκος ');
INSERT INTO `lang_definitions` VALUES (19865, 1635, 15, 'Ελάσσονες προσωπικές πληροφορίες (εγγραφή, προαιρετικά προσθήκη)');
INSERT INTO `lang_definitions` VALUES (19866, 1636, 15, 'Επιστολή ');
INSERT INTO `lang_definitions` VALUES (19867, 1637, 15, 'Γεννήτρια επιστολής');
INSERT INTO `lang_definitions` VALUES (19868, 1640, 15, 'Επίπεδο του επείγοντος ');
INSERT INTO `lang_definitions` VALUES (19869, 1641, 15, 'Ευθύνη ');
INSERT INTO `lang_definitions` VALUES (19870, 1642, 15, 'Ιατρική ευθύνη ');
INSERT INTO `lang_definitions` VALUES (19871, 1643, 15, 'Αρ.αδείας');
INSERT INTO `lang_definitions` VALUES (19872, 1644, 15, 'Τρόπος ζωής');
INSERT INTO `lang_definitions` VALUES (19873, 1645, 15, 'Διάστρεμμα ή ρήξη συνδέσμου');
INSERT INTO `lang_definitions` VALUES (19874, 1646, 15, 'Όριο Συμβαμάτων');
INSERT INTO `lang_definitions` VALUES (19875, 1649, 15, 'Κατάλογος ');
INSERT INTO `lang_definitions` VALUES (19876, 1650, 15, 'πλαίσιο λίστας ');
INSERT INTO `lang_definitions` VALUES (19877, 1651, 15, 'πλαίσιο λίστας ');
INSERT INTO `lang_definitions` VALUES (19878, 1652, 15, 'πλαίσιο λίστας / προσθήκη');
INSERT INTO `lang_definitions` VALUES (19879, 1653, 15, 'πλαίσιο λίστας / προσθήκη');
INSERT INTO `lang_definitions` VALUES (19880, 1654, 15, 'Κατάλογος Επεξεργαστή');
INSERT INTO `lang_definitions` VALUES (19881, 1655, 15, 'Κατάλογος ομάδων');
INSERT INTO `lang_definitions` VALUES (19882, 1656, 15, 'Κατάλογος Ασφαλιστικών Εταιρειών ');
INSERT INTO `lang_definitions` VALUES (19883, 1657, 15, 'Ο κατάλογος αντικειμένων δεν μπορεί να αρχίζει με αριθμό.');
INSERT INTO `lang_definitions` VALUES (19884, 1658, 15, 'Ο κατάλογος αντικειμένων περιέχει ανεπίτρεπτους χαρακτήρες.');
INSERT INTO `lang_definitions` VALUES (19885, 1659, 15, 'Κατάλογος καταλόγων ');
INSERT INTO `lang_definitions` VALUES (19886, 1660, 15, 'Κατάλογος ονόματος');
INSERT INTO `lang_definitions` VALUES (19887, 1661, 15, 'Τα ονόματα κατάλογου δεν μπορεί να ξεκινούν με αριθμούς. ');
INSERT INTO `lang_definitions` VALUES (19888, 1662, 15, 'Κατάλογος Συνταγών');
INSERT INTO `lang_definitions` VALUES (19889, 1663, 15, 'Κατάλογοι');
INSERT INTO `lang_definitions` VALUES (19890, 1665, 15, 'Τελευταία έμμηνος ρύση');
INSERT INTO `lang_definitions` VALUES (19891, 1666, 15, 'Φόρτωση Ορισμών');
INSERT INTO `lang_definitions` VALUES (19892, 1667, 15, 'ΦΟΡΤΩΝΕΤΑΙ');
INSERT INTO `lang_definitions` VALUES (19893, 1668, 15, 'Επίπεδο συνείδησης');
INSERT INTO `lang_definitions` VALUES (19894, 1669, 15, 'Τοπικό');
INSERT INTO `lang_definitions` VALUES (19895, 1670, 15, 'Τοπικότητα');
INSERT INTO `lang_definitions` VALUES (19896, 1671, 15, 'Τοποθεσία');
INSERT INTO `lang_definitions` VALUES (19897, 1672, 15, 'Άγνωστη Τοποθεσία');
INSERT INTO `lang_definitions` VALUES (19898, 1673, 15, 'Τοποθεσία:');
INSERT INTO `lang_definitions` VALUES (19899, 1675, 15, 'Συνδέθηκε σε');
INSERT INTO `lang_definitions` VALUES (19900, 1676, 15, 'Συνδέθηκε ως');
INSERT INTO `lang_definitions` VALUES (19901, 1677, 15, 'Συνδέθηκε ως:');
INSERT INTO `lang_definitions` VALUES (19902, 1678, 15, 'Αποσυνδέθηκε.');
INSERT INTO `lang_definitions` VALUES (19903, 1679, 15, 'Σύνδεση');
INSERT INTO `lang_definitions` VALUES (19904, 1680, 15, 'σύνδεση');
INSERT INTO `lang_definitions` VALUES (19905, 1681, 15, 'Αποσύνδεση');
INSERT INTO `lang_definitions` VALUES (19906, 1682, 15, 'αποσύνδεση');
INSERT INTO `lang_definitions` VALUES (19907, 1683, 15, 'Logs');
INSERT INTO `lang_definitions` VALUES (19908, 1684, 15, 'Προβολή καταγραφών');
INSERT INTO `lang_definitions` VALUES (19909, 1685, 15, 'Αναζήτηση ');
INSERT INTO `lang_definitions` VALUES (19910, 1686, 15, 'Παρτίδα ');
INSERT INTO `lang_definitions` VALUES (19911, 1687, 15, 'Αναγνωριστικό παρτίδας λείπει');
INSERT INTO `lang_definitions` VALUES (19912, 1688, 15, 'Αριθμός παρτίδας ');
INSERT INTO `lang_definitions` VALUES (19913, 1689, 15, 'Χαμηλό');
INSERT INTO `lang_definitions` VALUES (19914, 1690, 15, 'Κάτω άκρο');
INSERT INTO `lang_definitions` VALUES (19915, 1691, 15, 'Οσφυϊκή μοίρα της σπονδυλικής στήλης ');
INSERT INTO `lang_definitions` VALUES (19916, 1692, 15, 'ΓΕΥΜΑ ');
INSERT INTO `lang_definitions` VALUES (19917, 1693, 15, 'Γεύμα');
INSERT INTO `lang_definitions` VALUES (19918, 1694, 15, 'Καρκίνος του πνεύμονα ');
INSERT INTO `lang_definitions` VALUES (19919, 1695, 15, 'Χειρουργική καρκίνου του πνεύμονα ');
INSERT INTO `lang_definitions` VALUES (19920, 1696, 15, 'ΠΝΕΥΜΟΝΕΣ:');
INSERT INTO `lang_definitions` VALUES (19921, 1697, 15, 'Πνεύμονες: ');
INSERT INTO `lang_definitions` VALUES (19922, 1698, 15, 'Λύκος');
INSERT INTO `lang_definitions` VALUES (19923, 1699, 15, 'Μ');
INSERT INTO `lang_definitions` VALUES (19924, 1701, 15, 'Κύρια Διεύθυνση ');
INSERT INTO `lang_definitions` VALUES (19925, 1702, 15, 'Κάντε αλλαγές στις τρέχουσες κατηγορίες. ');
INSERT INTO `lang_definitions` VALUES (19926, 1703, 15, 'Βεβαιωθείτε ότι \" ');
INSERT INTO `lang_definitions` VALUES (19927, 1704, 15, 'Αδιαθεσία: ');
INSERT INTO `lang_definitions` VALUES (19928, 1705, 15, 'Άρρεν');
INSERT INTO `lang_definitions` VALUES (19929, 1706, 15, 'Ανδρικά προφυλακτικά ');
INSERT INTO `lang_definitions` VALUES (19930, 1707, 15, 'Εκούσια χειρουργική στείρωση του άνδρα');
INSERT INTO `lang_definitions` VALUES (19931, 1708, 15, 'Μαστογραφία ');
INSERT INTO `lang_definitions` VALUES (19932, 1709, 15, 'Διαχείριση ');
INSERT INTO `lang_definitions` VALUES (19933, 1710, 15, 'Χειροκινητη αποστολη');
INSERT INTO `lang_definitions` VALUES (19934, 1711, 15, 'Κατασκευαστής ');
INSERT INTO `lang_definitions` VALUES (19935, 1712, 15, 'Μάρτιος ');
INSERT INTO `lang_definitions` VALUES (19936, 1713, 15, 'Οικογενειακή κατάσταση ');
INSERT INTO `lang_definitions` VALUES (19937, 1714, 15, 'Σημειώστε ως χρεωμένο αλλά παραλείψτε την χρέωση');
INSERT INTO `lang_definitions` VALUES (19938, 1715, 15, 'Σημειώστε ως εκκαθαρισμένο');
INSERT INTO `lang_definitions` VALUES (19939, 1716, 15, 'Σημειώστε ως μη');
INSERT INTO `lang_definitions` VALUES (19940, 1717, 15, 'Σημειωμενο ως εκκαθαρισμένο');
INSERT INTO `lang_definitions` VALUES (19941, 1718, 15, 'Παντρεμένος/η');
INSERT INTO `lang_definitions` VALUES (19942, 1719, 15, 'Δεξιά ανω γνάθος: ');
INSERT INTO `lang_definitions` VALUES (19943, 1720, 15, 'Μάιος');
INSERT INTO `lang_definitions` VALUES (19944, 1721, 15, 'MasterCard');
INSERT INTO `lang_definitions` VALUES (19945, 1722, 15, 'mcg');
INSERT INTO `lang_definitions` VALUES (19946, 1723, 15, 'Έσω σφυρό:');
INSERT INTO `lang_definitions` VALUES (19947, 1725, 15, 'Ιατρικό');
INSERT INTO `lang_definitions` VALUES (19948, 1726, 15, 'Ιατρική άμβλωση ');
INSERT INTO `lang_definitions` VALUES (19949, 1727, 15, 'Ιατρικό πρόβλημα ');
INSERT INTO `lang_definitions` VALUES (19950, 1728, 15, 'Διαγνώσεις');
INSERT INTO `lang_definitions` VALUES (19951, 1729, 15, 'ΦΑΚΕΛΟΣ');
INSERT INTO `lang_definitions` VALUES (19952, 1730, 15, 'Αριθμός φακέλου');
INSERT INTO `lang_definitions` VALUES (19953, 1731, 15, 'Ιατρικοί φάκελοι');
INSERT INTO `lang_definitions` VALUES (19954, 1732, 15, 'Ιατρικό Ιστορικό (εγγραφή, προαιρετικά προσθήκη)');
INSERT INTO `lang_definitions` VALUES (19955, 1734, 15, 'Φάρμακα ');
INSERT INTO `lang_definitions` VALUES (19956, 1735, 15, 'Φάρμακα');
INSERT INTO `lang_definitions` VALUES (19957, 1737, 15, 'Μονάδες');
INSERT INTO `lang_definitions` VALUES (19958, 1738, 15, 'Μέσο');
INSERT INTO `lang_definitions` VALUES (19959, 1739, 15, 'Έκθεση στατιστικών των μελών του συνδέσμου');
INSERT INTO `lang_definitions` VALUES (19960, 1740, 15, 'Προβλήματα μνήμης');
INSERT INTO `lang_definitions` VALUES (19961, 1741, 15, 'Άντρες ');
INSERT INTO `lang_definitions` VALUES (19962, 1742, 15, 'Άνδρες και Γυναίκες ');
INSERT INTO `lang_definitions` VALUES (19963, 1743, 15, 'Μόνο άνδρες ');
INSERT INTO `lang_definitions` VALUES (19964, 1744, 15, 'Εμμηνορυσία');
INSERT INTO `lang_definitions` VALUES (19965, 1745, 15, 'Εμμηνόπαυση');
INSERT INTO `lang_definitions` VALUES (19966, 1746, 15, 'Καταμήνια ροή');
INSERT INTO `lang_definitions` VALUES (19967, 1747, 15, 'Καταμήνια συχνότητα');
INSERT INTO `lang_definitions` VALUES (19968, 1748, 15, 'Ψυχική ασθένεια ');
INSERT INTO `lang_definitions` VALUES (19969, 1749, 15, 'Μήνυμα ');
INSERT INTO `lang_definitions` VALUES (19970, 1750, 15, 'ΜΗΝΥΜΑ: ');
INSERT INTO `lang_definitions` VALUES (19971, 1751, 15, 'Μέθοδος ');
INSERT INTO `lang_definitions` VALUES (19972, 1752, 15, 'Μέθοδος καταστροφής ');
INSERT INTO `lang_definitions` VALUES (19973, 1753, 15, 'mg ');
INSERT INTO `lang_definitions` VALUES (19974, 1754, 15, 'mg/1cc ');
INSERT INTO `lang_definitions` VALUES (19975, 1755, 15, 'mg/2cc ');
INSERT INTO `lang_definitions` VALUES (19976, 1756, 15, 'mg/3cc ');
INSERT INTO `lang_definitions` VALUES (19977, 1757, 15, 'mg/4cc ');
INSERT INTO `lang_definitions` VALUES (19978, 1758, 15, 'mg/5cc ');
INSERT INTO `lang_definitions` VALUES (19979, 1759, 15, 'Μέσο');
INSERT INTO `lang_definitions` VALUES (19980, 1760, 15, 'Μεσαίο όνομα');
INSERT INTO `lang_definitions` VALUES (19981, 1761, 15, 'Μεσαίο όνομα');
INSERT INTO `lang_definitions` VALUES (19982, 1762, 15, 'Μετανάστης ή εποχιακά εργαζόμενος; ');
INSERT INTO `lang_definitions` VALUES (19983, 1763, 15, 'Μετανάστης/Εποχιακός');
INSERT INTO `lang_definitions` VALUES (19984, 1764, 15, 'MimeType');
INSERT INTO `lang_definitions` VALUES (19985, 1765, 15, 'λεπτά');
INSERT INTO `lang_definitions` VALUES (19986, 1766, 15, 'Ήπιο διάστρεμμα άρθρωσης +/- θυλακιτιδα');
INSERT INTO `lang_definitions` VALUES (19987, 1767, 15, 'λεπτά ');
INSERT INTO `lang_definitions` VALUES (19988, 1768, 15, 'λεπτά ');
INSERT INTO `lang_definitions` VALUES (19989, 1769, 15, 'Διαφ');
INSERT INTO `lang_definitions` VALUES (19990, 1772, 15, 'Διαφ επιλογές χρέωσης HCFA');
INSERT INTO `lang_definitions` VALUES (19991, 1773, 15, 'Διάφορα');
INSERT INTO `lang_definitions` VALUES (19992, 1774, 15, 'Λείπει');
INSERT INTO `lang_definitions` VALUES (19993, 1775, 15, 'Αμοιβή λείπει');
INSERT INTO `lang_definitions` VALUES (19994, 1776, 15, 'Αναγνωριστικό ασθενούς λείπει ');
INSERT INTO `lang_definitions` VALUES (19995, 1777, 15, 'Λείπει η κάθετος μετά τον πληρωτή στην πηγή για τον κώδικα');
INSERT INTO `lang_definitions` VALUES (19996, 1778, 15, 'Μικτό');
INSERT INTO `lang_definitions` VALUES (19997, 1779, 15, 'ml ');
INSERT INTO `lang_definitions` VALUES (19998, 1780, 15, 'mm/Hg');
INSERT INTO `lang_definitions` VALUES (19999, 1781, 15, 'MMR 1');
INSERT INTO `lang_definitions` VALUES (20000, 1782, 15, 'MMR 2');
INSERT INTO `lang_definitions` VALUES (20001, 1783, 15, 'Κινητό ');
INSERT INTO `lang_definitions` VALUES (20002, 1784, 15, 'Κινητό τηλέφωνο ');
INSERT INTO `lang_definitions` VALUES (20003, 1785, 15, 'Τροποπ');
INSERT INTO `lang_definitions` VALUES (20004, 1786, 15, 'Τροποποιητής ');
INSERT INTO `lang_definitions` VALUES (20005, 1787, 15, 'Δευ');
INSERT INTO `lang_definitions` VALUES (20006, 1788, 15, 'Δευ με Παρ');
INSERT INTO `lang_definitions` VALUES (20007, 1789, 15, 'Δευ, Τετ & Παρ');
INSERT INTO `lang_definitions` VALUES (20008, 1790, 15, 'Δευτέρα ');
INSERT INTO `lang_definitions` VALUES (20009, 1791, 15, 'Μήνας ');
INSERT INTO `lang_definitions` VALUES (20010, 1792, 15, 'Μήνας ');
INSERT INTO `lang_definitions` VALUES (20011, 1793, 15, 'Προβολή Μηνός');
INSERT INTO `lang_definitions` VALUES (20012, 1794, 15, 'Μήνας(ες) ');
INSERT INTO `lang_definitions` VALUES (20013, 1795, 15, 'Μηνιαίο εισόδημα ');
INSERT INTO `lang_definitions` VALUES (20014, 1796, 15, 'Βρέθηκαν περισσότερες από 100 καταχωρήσεις Παρακαλώ περιορίστε τα κριτήρια αναζήτησης σας.');
INSERT INTO `lang_definitions` VALUES (20015, 1797, 15, 'Περισσότερα από 50 αποτελέσματα, παρακαλώ κάντε την αναζήτηση σας ποιο ειδική');
INSERT INTO `lang_definitions` VALUES (20016, 1798, 15, 'Μητέρα ');
INSERT INTO `lang_definitions` VALUES (20017, 1799, 15, 'Στόμα');
INSERT INTO `lang_definitions` VALUES (20018, 1800, 15, 'Κίνηση ');
INSERT INTO `lang_definitions` VALUES (20019, 1801, 15, 'Μετακίνηση του Εγγράφου σε Κατηγορία:');
INSERT INTO `lang_definitions` VALUES (20020, 1802, 15, 'Μετακίνηση κάτω ');
INSERT INTO `lang_definitions` VALUES (20021, 1803, 15, 'Μετακίνηση σε Ασθενή');
INSERT INTO `lang_definitions` VALUES (20022, 1804, 15, 'Μετακίνηση σε ...');
INSERT INTO `lang_definitions` VALUES (20023, 1805, 15, 'Μετακίνηση άνω');
INSERT INTO `lang_definitions` VALUES (20024, 1806, 15, 'Κύριος');
INSERT INTO `lang_definitions` VALUES (20025, 1807, 15, 'Κυρία');
INSERT INTO `lang_definitions` VALUES (20026, 1808, 15, 'Κυρία');
INSERT INTO `lang_definitions` VALUES (20027, 1809, 15, 'Πολύγλωσσο εργαλείο');
INSERT INTO `lang_definitions` VALUES (20028, 1810, 15, 'Πολλαπλές περιοχές ');
INSERT INTO `lang_definitions` VALUES (20029, 1811, 15, 'Φύσημα:');
INSERT INTO `lang_definitions` VALUES (20030, 1812, 15, 'Μυικ πόνος');
INSERT INTO `lang_definitions` VALUES (20031, 1813, 15, 'Μυικ πόνοι');
INSERT INTO `lang_definitions` VALUES (20032, 1814, 15, 'Μυικ ερυθρότητα');
INSERT INTO `lang_definitions` VALUES (20033, 1815, 15, 'Μυικ δυσκαμψία');
INSERT INTO `lang_definitions` VALUES (20034, 1816, 15, 'Μυικ διόγκωση');
INSERT INTO `lang_definitions` VALUES (20035, 1817, 15, 'Μυικ θερμό');
INSERT INTO `lang_definitions` VALUES (20036, 1818, 15, 'Μυς');
INSERT INTO `lang_definitions` VALUES (20037, 1819, 15, 'Κάκωση μυός');
INSERT INTO `lang_definitions` VALUES (20038, 1820, 15, 'Μυοσκελετικό');
INSERT INTO `lang_definitions` VALUES (20039, 1821, 15, 'Αμοιβαίως ορισμένο ');
INSERT INTO `lang_definitions` VALUES (20040, 1822, 15, 'Αυτοκινητιστικό ατύχημα');
INSERT INTO `lang_definitions` VALUES (20041, 1823, 15, 'ΜΗ ΔΙΑΘ.');
INSERT INTO `lang_definitions` VALUES (20042, 1824, 15, 'μή διαθ.');
INSERT INTO `lang_definitions` VALUES (20043, 1825, 15, 'Όνομα');
INSERT INTO `lang_definitions` VALUES (20044, 1826, 15, 'Όνομα 1 ');
INSERT INTO `lang_definitions` VALUES (20045, 1827, 15, 'Όνομα 2 ');
INSERT INTO `lang_definitions` VALUES (20046, 1828, 15, 'Όνομα και τίτλος του διαχειριστή ανοσοποίησης ');
INSERT INTO `lang_definitions` VALUES (20047, 1829, 15, 'Όνομα της ασφαλιστικής εταιρείας ');
INSERT INTO `lang_definitions` VALUES (20048, 1830, 15, 'Όνομα του Παρόχου');
INSERT INTO `lang_definitions` VALUES (20049, 1831, 15, 'Μετάφραση ονόματος ');
INSERT INTO `lang_definitions` VALUES (20050, 1832, 15, 'Όνομα/Αξία ');
INSERT INTO `lang_definitions` VALUES (20051, 1833, 15, 'Όνομα: ');
INSERT INTO `lang_definitions` VALUES (20052, 1834, 15, 'Ρουθούνια: ');
INSERT INTO `lang_definitions` VALUES (20053, 1835, 15, 'Ρουθούνια: Δεξιά κφ');
INSERT INTO `lang_definitions` VALUES (20054, 1836, 15, 'Ρινικός βλεννογόνος ροζ, διάφραγμα στη μέση γραμμή ');
INSERT INTO `lang_definitions` VALUES (20055, 1837, 15, 'Εθνικότητα ');
INSERT INTO `lang_definitions` VALUES (20056, 1838, 15, 'Ναυτία');
INSERT INTO `lang_definitions` VALUES (20057, 1839, 15, 'Πλοήγηση ');
INSERT INTO `lang_definitions` VALUES (20058, 1840, 15, 'Κωδικός φαρμάκου');
INSERT INTO `lang_definitions` VALUES (20059, 1841, 15, 'Αριθμός κωδικού φαρμάκου');
INSERT INTO `lang_definitions` VALUES (20060, 1842, 15, 'Αυχένας');
INSERT INTO `lang_definitions` VALUES (20061, 1843, 15, 'Προβλήματα αυχένα');
INSERT INTO `lang_definitions` VALUES (20062, 1845, 15, 'Πρέπει να εισάγετε μια περιγραφή ');
INSERT INTO `lang_definitions` VALUES (20063, 1846, 15, 'Πρέπει να εισάγετε μια Τιμή Επιστροφής');
INSERT INTO `lang_definitions` VALUES (20064, 1847, 15, 'Πρέπει να εισάγετε αναγνωριστικό');
INSERT INTO `lang_definitions` VALUES (20065, 1848, 15, 'Πρέπει να εισάγετε τίτλο');
INSERT INTO `lang_definitions` VALUES (20066, 1849, 15, 'Απαιτείται πιστοποίηση');
INSERT INTO `lang_definitions` VALUES (20067, 1850, 15, 'Απαιτείται δικαιολόγηση');
INSERT INTO `lang_definitions` VALUES (20068, 1851, 15, 'Απαιτεί δευτερογενή χρέωση ');
INSERT INTO `lang_definitions` VALUES (20069, 1852, 15, 'Κάκωση νεύρου');
INSERT INTO `lang_definitions` VALUES (20070, 1853, 15, 'Νευρική κατάσταση / καταστροφή νεύρου');
INSERT INTO `lang_definitions` VALUES (20071, 1854, 15, 'Νευρική βαρυκοια');
INSERT INTO `lang_definitions` VALUES (20072, 1855, 15, 'Νευρική αδυναμία');
INSERT INTO `lang_definitions` VALUES (20073, 1856, 15, 'Νευρολογικό');
INSERT INTO `lang_definitions` VALUES (20074, 1857, 15, 'Νέο');
INSERT INTO `lang_definitions` VALUES (20075, 1858, 15, 'Νέο =>');
INSERT INTO `lang_definitions` VALUES (20076, 1859, 15, 'Νέοι αποδέκτες ');
INSERT INTO `lang_definitions` VALUES (20077, 1860, 15, 'Νέα αλλεργία ');
INSERT INTO `lang_definitions` VALUES (20078, 1861, 15, 'Νέο ραντεβού');
INSERT INTO `lang_definitions` VALUES (20079, 1862, 15, 'Νέες κατηγορίες');
INSERT INTO `lang_definitions` VALUES (20080, 1863, 15, 'Νέα Κατηγορία ');
INSERT INTO `lang_definitions` VALUES (20081, 1864, 15, 'Νέοι πελάτες');
INSERT INTO `lang_definitions` VALUES (20082, 1865, 15, 'Νέα παραπομπή');
INSERT INTO `lang_definitions` VALUES (20083, 1866, 15, 'Νέο σύνολο ορισμών εισήχθη');
INSERT INTO `lang_definitions` VALUES (20084, 1867, 15, 'Νέο έγγραφο ');
INSERT INTO `lang_definitions` VALUES (20085, 1868, 15, 'Νέα επίσκεψη');
INSERT INTO `lang_definitions` VALUES (20086, 1869, 15, 'Νέες επισκέψεις δεν επιτρέπονται');
INSERT INTO `lang_definitions` VALUES (20087, 1870, 15, 'Νέα επισκ');
INSERT INTO `lang_definitions` VALUES (20088, 1871, 15, 'Πληροφορίες νέας Έδρας');
INSERT INTO `lang_definitions` VALUES (20089, 1872, 15, 'Νέα Ομάδα ');
INSERT INTO `lang_definitions` VALUES (20090, 1873, 15, 'Νέα πληροφορία για την ομάδα ');
INSERT INTO `lang_definitions` VALUES (20091, 1874, 15, 'Νέο όριο συμβαμάτων');
INSERT INTO `lang_definitions` VALUES (20092, 1875, 15, 'Νέος Κατάλογος ');
INSERT INTO `lang_definitions` VALUES (20093, 1876, 15, 'Νέος Ασθενής ');
INSERT INTO `lang_definitions` VALUES (20094, 1877, 15, 'Επίσκεψη ασθενή');
INSERT INTO `lang_definitions` VALUES (20095, 1878, 15, 'Νέο αναγνωριστικό ασθενή');
INSERT INTO `lang_definitions` VALUES (20096, 1879, 15, 'Νέος Ασθ');
INSERT INTO `lang_definitions` VALUES (20097, 1880, 15, 'Νέες Αποστολές');
INSERT INTO `lang_definitions` VALUES (20098, 1881, 15, 'Νέος Χρήστης');
INSERT INTO `lang_definitions` VALUES (20099, 1882, 15, 'Νέα');
INSERT INTO `lang_definitions` VALUES (20100, 1883, 15, 'Νέος ή Εύρεση');
INSERT INTO `lang_definitions` VALUES (20101, 1884, 15, 'Εφημερίδα');
INSERT INTO `lang_definitions` VALUES (20102, 1885, 15, 'Επόμενο');
INSERT INTO `lang_definitions` VALUES (20103, 1886, 15, 'Επόμενη Μέρα');
INSERT INTO `lang_definitions` VALUES (20104, 1887, 15, 'Επόμενος Μήνας');
INSERT INTO `lang_definitions` VALUES (20105, 1888, 15, 'Επόμενη Εβδομάδα');
INSERT INTO `lang_definitions` VALUES (20106, 1889, 15, 'Παρωνύμιο ');
INSERT INTO `lang_definitions` VALUES (20107, 1890, 15, 'Νυχτερινές εφιδρώσεις ');
INSERT INTO `lang_definitions` VALUES (20108, 1891, 15, 'ΜΗ-ΑΝΑΓΝ έξω γενν όργ, κολπικός βλενν, τράχηλος');
INSERT INTO `lang_definitions` VALUES (20109, 1893, 15, 'Όχι');
INSERT INTO `lang_definitions` VALUES (20110, 1894, 15, 'Καμία πρόσβαση ');
INSERT INTO `lang_definitions` VALUES (20111, 1895, 15, 'Καμία αδενοπάθεια (απαιτούνται 2 περιοχές) ');
INSERT INTO `lang_definitions` VALUES (20112, 1896, 15, 'Καμία ευαισθησία/μάζες εξαρτημάτων');
INSERT INTO `lang_definitions` VALUES (20113, 1897, 15, 'Κανένα σύστημα χρέωσης δεν είναι ενεργό');
INSERT INTO `lang_definitions` VALUES (20114, 1898, 15, 'Δεν βρέθηκαν χρεώσεις για να συμπεριληφθούν στην Εξαγωγή Ανοικτής Οικονομικής Ανταλλαγής');
INSERT INTO `lang_definitions` VALUES (20115, 1899, 15, 'Δεν έχει καθοριστεί κωδικός! ');
INSERT INTO `lang_definitions` VALUES (20116, 1900, 15, 'Καμία Διάγνωση ');
INSERT INTO `lang_definitions` VALUES (20117, 1901, 15, 'Καμία ημερομηνία λήξης ');
INSERT INTO `lang_definitions` VALUES (20118, 1902, 15, 'Δεν βρέθηκαν εγγραφές, χρησιμοποιήστε την παρακάτω φόρμα για να προσθέσετε μια καταχώρηση. ');
INSERT INTO `lang_definitions` VALUES (20119, 1903, 15, 'Κανένα σύμβαμα');
INSERT INTO `lang_definitions` VALUES (20120, 1904, 15, 'Καμία ομάδα δεν έχει επιλεγεί ');
INSERT INTO `lang_definitions` VALUES (20121, 1905, 15, 'Καμία κήλη');
INSERT INTO `lang_definitions` VALUES (20122, 1906, 15, 'Δεν βρέθηκαν Ασφαλιστικές Εταιρείες');
INSERT INTO `lang_definitions` VALUES (20123, 1907, 15, 'Δεν έχουν επιλεγεί αντικείμενα!');
INSERT INTO `lang_definitions` VALUES (20124, 1908, 15, 'Χωρία μάζες, ευαισθησία');
INSERT INTO `lang_definitions` VALUES (20125, 1909, 15, 'Καμία σημειώσει');
INSERT INTO `lang_definitions` VALUES (20126, 1910, 15, 'Χωρία οργανομεγαλία');
INSERT INTO `lang_definitions` VALUES (20127, 1911, 15, 'Δεν βρέθηκαν ανοίγματα για αυτήν την περίοδο. ');
INSERT INTO `lang_definitions` VALUES (20128, 1912, 15, 'Δεν βρέθηκαν συνεργάτες ');
INSERT INTO `lang_definitions` VALUES (20129, 1913, 15, 'Χωρίς περιφερικό οίδημα ');
INSERT INTO `lang_definitions` VALUES (20130, 1914, 15, 'Δεν βρέθηκαν φαρμακεία');
INSERT INTO `lang_definitions` VALUES (20131, 1915, 15, 'Δεν βρέθηκαν συνταγές ');
INSERT INTO `lang_definitions` VALUES (20132, 1916, 15, 'Καμία παρούσα ασθένεια/κάκωση ');
INSERT INTO `lang_definitions` VALUES (20133, 1917, 15, 'Δεν βρέθηκαν πάροχοι ');
INSERT INTO `lang_definitions` VALUES (20134, 1918, 15, 'Χωρίς εξάνθημα ή ανώμαλες βλάβες ');
INSERT INTO `lang_definitions` VALUES (20135, 1919, 15, 'Δεν βρέθηκαν καταχωρήσεις Παρακαλώ επεκτείνετε τα κριτήρια αναζήτησης σας.');
INSERT INTO `lang_definitions` VALUES (20136, 1920, 15, 'Δεν βρέθηκαν αποτελέσματα');
INSERT INTO `lang_definitions` VALUES (20137, 1921, 15, 'Δεν βρέθηκαν αποτελέσματα για την Αναζήτηση ');
INSERT INTO `lang_definitions` VALUES (20138, 1922, 15, 'Κανένα αποτέλεσμα, παρακαλώ δοκιμάστε ξανά. ');
INSERT INTO `lang_definitions` VALUES (20139, 1923, 15, 'Κανένα αποτέλεσμα, παρακαλώ δοκιμάστε ξανά. ');
INSERT INTO `lang_definitions` VALUES (20140, 1924, 15, 'Μη εμφάνιση ');
INSERT INTO `lang_definitions` VALUES (20141, 1925, 15, 'Χωρίς κολπική ευαισθησία ');
INSERT INTO `lang_definitions` VALUES (20142, 1926, 15, 'Χωρίς εισολκη δέρματος η οζίδια μαστού');
INSERT INTO `lang_definitions` VALUES (20143, 1927, 15, 'Χωρίς ορχική ευαισθησία, μάζες');
INSERT INTO `lang_definitions` VALUES (20144, 1929, 15, 'Καμία επίσκεψη');
INSERT INTO `lang_definitions` VALUES (20145, 1930, 15, 'Όχι, ακύρωση');
INSERT INTO `lang_definitions` VALUES (20146, 1931, 15, 'Όχι:');
INSERT INTO `lang_definitions` VALUES (20147, 1932, 15, 'Νυκτουρία');
INSERT INTO `lang_definitions` VALUES (20148, 1933, 15, 'Μη ειδική κάκωση ');
INSERT INTO `lang_definitions` VALUES (20149, 1934, 15, 'Μη ινσουλινοεξαρτώμενος διαβήτης ');
INSERT INTO `lang_definitions` VALUES (20150, 1935, 15, 'Μη-αναπαραγωγική υγεία (Ιατρικό)');
INSERT INTO `lang_definitions` VALUES (20151, 1936, 15, 'Μη-αναπαραγωγική υγεία (Μη-ιατρικό)');
INSERT INTO `lang_definitions` VALUES (20152, 1937, 15, 'Κανένα');
INSERT INTO `lang_definitions` VALUES (20153, 1938, 15, 'Κανένα');
INSERT INTO `lang_definitions` VALUES (20154, 1939, 15, 'Κανένα από τα παραπάνω');
INSERT INTO `lang_definitions` VALUES (20155, 1940, 15, 'Μη ινσουλινοεξαρτώμενος διαβήτης ');
INSERT INTO `lang_definitions` VALUES (20156, 1941, 15, 'ΚΦ');
INSERT INTO `lang_definitions` VALUES (20157, 1942, 15, 'Φυσιολογικός');
INSERT INTO `lang_definitions` VALUES (20158, 1944, 15, 'Φυσιολογική εξέταση καρδιάς:');
INSERT INTO `lang_definitions` VALUES (20159, 1945, 15, 'Φυσιολογική εξέταση καρδιάς:');
INSERT INTO `lang_definitions` VALUES (20160, 1946, 15, 'Φυσιολογική εξέταση πνεύμονα:');
INSERT INTO `lang_definitions` VALUES (20161, 1947, 15, 'Φυσιολογική εξέταση πνεύμονα:');
INSERT INTO `lang_definitions` VALUES (20162, 1948, 15, 'Κανονική επίσκεψη γραφείου');
INSERT INTO `lang_definitions` VALUES (20163, 1949, 15, 'Φυσιολογικός οροφάρυγγας:');
INSERT INTO `lang_definitions` VALUES (20164, 1950, 15, 'Φυσιολογικό δεξιά');
INSERT INTO `lang_definitions` VALUES (20165, 1951, 15, 'Φυσιολογικό δεξιά:');
INSERT INTO `lang_definitions` VALUES (20166, 1952, 15, 'Φυσιολογική όψη');
INSERT INTO `lang_definitions` VALUES (20167, 1953, 15, 'Φυσιολογικό');
INSERT INTO `lang_definitions` VALUES (20168, 1954, 15, 'Νορβηγικά ');
INSERT INTO `lang_definitions` VALUES (20169, 1955, 15, 'Μύτη');
INSERT INTO `lang_definitions` VALUES (20170, 1956, 15, 'Ρινορραγία');
INSERT INTO `lang_definitions` VALUES (20171, 1957, 15, 'Δεν είναι απαραίτητα όλα τα πεδία για όλους τους τύπους κωδικών. ');
INSERT INTO `lang_definitions` VALUES (20172, 1958, 15, 'Δεν επιτρέπεται ');
INSERT INTO `lang_definitions` VALUES (20173, 1959, 15, 'Δεν επιτρέπεται να διαγράψετε την ομάδα Διαχειριστές');
INSERT INTO `lang_definitions` VALUES (20174, 1960, 15, 'Δεν επιτρέπεται να αδρανοποιήσετε όλα τα αντικείμενα ασφαλείας');
INSERT INTO `lang_definitions` VALUES (20175, 1961, 15, 'Κατάλογος ελέγχου πρόσβασης (ACL)');
INSERT INTO `lang_definitions` VALUES (20176, 1962, 15, 'Δεν επιτρέπεται να καταργήσετε το χρήστη από το admin ομάδας Administrators ');
INSERT INTO `lang_definitions` VALUES (20177, 1963, 15, 'Δεν έχετε δικαίωμα πρόσβασης στο στοιχείο του Ημερολογίου');
INSERT INTO `lang_definitions` VALUES (20178, 1964, 15, 'Δεν επιτρέπεται ');
INSERT INTO `lang_definitions` VALUES (20179, 1965, 15, 'Δεν επιτρέπεται για αυτή την ομάδα. ');
INSERT INTO `lang_definitions` VALUES (20180, 1966, 15, 'Μη διαθέσιμο');
INSERT INTO `lang_definitions` VALUES (20181, 1967, 15, 'Μη χρεωμένο');
INSERT INTO `lang_definitions` VALUES (20182, 1968, 15, 'Μη ');
INSERT INTO `lang_definitions` VALUES (20183, 1969, 15, 'Δεν εξετάστηκε');
INSERT INTO `lang_definitions` VALUES (20184, 1970, 15, 'Δεν εξετάστηκε:');
INSERT INTO `lang_definitions` VALUES (20185, 1971, 15, 'Δεν εξετάστηκε:');
INSERT INTO `lang_definitions` VALUES (20186, 1972, 15, 'δεν βρέθηκε ');
INSERT INTO `lang_definitions` VALUES (20187, 1973, 15, 'δεν βρέθηκε!');
INSERT INTO `lang_definitions` VALUES (20188, 1974, 15, 'Δεν έχει εμφανιστεί εδώ και');
INSERT INTO `lang_definitions` VALUES (20189, 1975, 15, 'Σημείωση ');
INSERT INTO `lang_definitions` VALUES (20190, 1976, 15, 'Τύπος σημείωσης');
INSERT INTO `lang_definitions` VALUES (20191, 1977, 15, 'Προσοχή: Αυτές οι γραμμές κώδικα δεν έχουν γραφεί από κάποιον εξειδικευμένο χρήστη. Μόνο κώδικας γραμμένος από εξειδικευμένο προσωπικό μπορεί να προστεθεί στο Open Medical Billing Network. Αν θέλετε να προσθέσετε αυτές τις αλλαγές, παρακαλώ επιλέξτε κάποιον εξειδικευμένο χρήστη εδώ.');
INSERT INTO `lang_definitions` VALUES (20192, 1978, 15, 'Προσοχή: Όταν γίνεται προσθήκη αρχείων με όνομα που ήδη υπάρχει το πρόγραμμα θα μετονομάζει αυτόματα το αρχείο. Παράδειγμα το αρχείο file.jpg θα μετονομαστεί σε file.jpg.1. Μοναδικά θεωρούνται τα αρχεία για κάθε ασθενή όχι για κάθε κατηγορία. ');
INSERT INTO `lang_definitions` VALUES (20193, 1979, 15, 'Σημειώσεις ');
INSERT INTO `lang_definitions` VALUES (20194, 1980, 15, 'Σημειώσεις – όλες οι επισκέψεις (εγγραφή, προαιρετικά προσθήκη)');
INSERT INTO `lang_definitions` VALUES (20195, 1981, 15, 'Σημειώσεις – οι επισκέψεις μου (εγγραφή, προαιρετικά προσθήκη)');
INSERT INTO `lang_definitions` VALUES (20196, 1982, 15, 'Σημειώσεις δεν επιτρέπονται');
INSERT INTO `lang_definitions` VALUES (20197, 1983, 15, 'Τίποτα δεν επελέγη ');
INSERT INTO `lang_definitions` VALUES (20198, 1984, 15, 'ΠΑΡΑΤΗΡΗΣΗ:: Προσθήκη/Αλλαγή στο υποσύστημα του Ημερολογίου');
INSERT INTO `lang_definitions` VALUES (20199, 1985, 15, 'Γνωστοποίηση ');
INSERT INTO `lang_definitions` VALUES (20200, 1986, 15, 'Να ειδοποιηθεί ο Διαχειριστής για την υποβολή/τροποποίηση του Συμβάματος? ');
INSERT INTO `lang_definitions` VALUES (20201, 1987, 15, 'Νοέμβριος ');
INSERT INTO `lang_definitions` VALUES (20202, 1988, 15, 'Αποοστολη τώρα για:');
INSERT INTO `lang_definitions` VALUES (20203, 1989, 15, 'Τύπωση τώρα των $stmt_count καταστάσεων και ενημέρωση επισκέψεων');
INSERT INTO `lang_definitions` VALUES (20204, 1990, 15, 'Τύπωση τώρα των $stmt_count καταστάσεων και ενημέρωση τιμολογίων');
INSERT INTO `lang_definitions` VALUES (20205, 1991, 15, 'Τύπωση τώρα των $stmt_count καταστάσεων Οι επισκέψεις δε θα ενημερωθούν');
INSERT INTO `lang_definitions` VALUES (20206, 1992, 15, 'Τύπωση τώρα των $stmt_count καταστάσεων Τα τιμολόγια δε θα ενημερωθούν');
INSERT INTO `lang_definitions` VALUES (20207, 1993, 15, 'Προσωπικός Ιατρικός Αριθμός');
INSERT INTO `lang_definitions` VALUES (20208, 1994, 15, 'Αριθμός ');
INSERT INTO `lang_definitions` VALUES (20209, 1995, 15, 'Αριθμός στηλών στην προβολή έτους');
INSERT INTO `lang_definitions` VALUES (20210, 1996, 15, 'Αριθμός παιχνιδιών η συμβαματων, αν υπάρχουν');
INSERT INTO `lang_definitions` VALUES (20211, 1997, 15, 'Βαρυκοϊα');
INSERT INTO `lang_definitions` VALUES (20212, 2000, 15, 'Παχυσαρκία Ι');
INSERT INTO `lang_definitions` VALUES (20213, 2001, 15, 'Παχυσαρκία ΙΙ');
INSERT INTO `lang_definitions` VALUES (20214, 2002, 15, 'Παχυσαρκία ΙΙΙ');
INSERT INTO `lang_definitions` VALUES (20215, 2003, 15, 'Κλινική εξέταση');
INSERT INTO `lang_definitions` VALUES (20216, 2004, 15, 'Επάγγελμα ');
INSERT INTO `lang_definitions` VALUES (20217, 2005, 15, 'Εμφάνιση');
INSERT INTO `lang_definitions` VALUES (20218, 2006, 15, 'Οκτώβριος ');
INSERT INTO `lang_definitions` VALUES (20219, 2007, 15, 'Δεξιός οφθαλμός');
INSERT INTO `lang_definitions` VALUES (20220, 2008, 15, 'της ποσότητας');
INSERT INTO `lang_definitions` VALUES (20221, 2009, 15, 'των δισκίων ');
INSERT INTO `lang_definitions` VALUES (20222, 2010, 15, 'του μηνός κάθε');
INSERT INTO `lang_definitions` VALUES (20223, 2011, 15, 'Σημειώσεις γραφείου');
INSERT INTO `lang_definitions` VALUES (20224, 2012, 15, 'Σημειώσεις γραφείου');
INSERT INTO `lang_definitions` VALUES (20225, 2013, 15, 'Επίσκεψη γραφείου');
INSERT INTO `lang_definitions` VALUES (20226, 2014, 15, 'Απόγονοι');
INSERT INTO `lang_definitions` VALUES (20227, 2015, 15, 'αλοιφή (oint)');
INSERT INTO `lang_definitions` VALUES (20228, 2016, 15, 'Εντάξει');
INSERT INTO `lang_definitions` VALUES (20229, 2018, 15, 'Παλιοί πελάτες ');
INSERT INTO `lang_definitions` VALUES (20230, 2019, 15, 'Παλαιό κάταγμα μη / κακή επούλωση');
INSERT INTO `lang_definitions` VALUES (20231, 2020, 15, 'Να παραλειφθούν οι εσωτερικοί χρήστες;');
INSERT INTO `lang_definitions` VALUES (20232, 2021, 15, 'Κενό για αυτόματη συμπλήρωση από το σύστημα');
INSERT INTO `lang_definitions` VALUES (20233, 2022, 15, 'επί');
INSERT INTO `lang_definitions` VALUES (20234, 2023, 15, 'Επί χειρός');
INSERT INTO `lang_definitions` VALUES (20235, 2024, 15, 'Επί παραγγελίας');
INSERT INTO `lang_definitions` VALUES (20236, 2025, 15, 'Αν αλλάξετε τον κωδικό σας, θα πρέπει να επανασυνδεθείτε ');
INSERT INTO `lang_definitions` VALUES (20237, 2026, 15, 'Online Βοήθεια');
INSERT INTO `lang_definitions` VALUES (20238, 2027, 15, 'Μόνο ενεργό');
INSERT INTO `lang_definitions` VALUES (20239, 2028, 15, 'μόνο αν η τοποθεσία χρέωσης ');
INSERT INTO `lang_definitions` VALUES (20240, 2029, 15, 'Μόνο ανενεργό');
INSERT INTO `lang_definitions` VALUES (20241, 2030, 15, 'Μόνο δικό μου');
INSERT INTO `lang_definitions` VALUES (20242, 2031, 15, 'Έναρξη της ασθένειας: ');
INSERT INTO `lang_definitions` VALUES (20243, 2032, 15, 'Έναρξη της ασθένειας: ');
INSERT INTO `lang_definitions` VALUES (20244, 2033, 15, 'Έναρξη της διόγκωσης:');
INSERT INTO `lang_definitions` VALUES (20245, 2034, 15, 'Έναρξη/ημ.νοσηλείας:');
INSERT INTO `lang_definitions` VALUES (20246, 2035, 15, 'Ανοικτό');
INSERT INTO `lang_definitions` VALUES (20247, 2036, 15, 'Το OpenEMR απαιτεί Javascript για να εκτελέσει την ταυτοποίηση του χρήστη. ');
INSERT INTO `lang_definitions` VALUES (20248, 2037, 15, 'Χρήστες OpenEMR');
INSERT INTO `lang_definitions` VALUES (20249, 2038, 15, 'Επιλογή ');
INSERT INTO `lang_definitions` VALUES (20250, 2039, 15, 'Προαιρετικό ');
INSERT INTO `lang_definitions` VALUES (20251, 2040, 15, 'Προαιρετική ονομασία φαρμάκου, χρησιμοποιήστε % ως μπαλαντέρ');
INSERT INTO `lang_definitions` VALUES (20252, 2041, 15, 'Προαιρετικές πληροφορίες για αυτό το σύμβαμα ');
INSERT INTO `lang_definitions` VALUES (20253, 2042, 15, 'Προαιρετικός αριθμός παρτίδας, χρησιμοποιήστε % ως μπαλαντέρ');
INSERT INTO `lang_definitions` VALUES (20254, 2043, 15, 'Προαιρετική αριθμητικό αναγνωριστικό του ασθενή ');
INSERT INTO `lang_definitions` VALUES (20255, 2044, 15, 'Προαιρετικός κωδικός διαδικασίας');
INSERT INTO `lang_definitions` VALUES (20256, 2045, 15, 'Ή ');
INSERT INTO `lang_definitions` VALUES (20257, 2046, 15, 'Ή');
INSERT INTO `lang_definitions` VALUES (20258, 2047, 15, 'ή επιλέξτε');
INSERT INTO `lang_definitions` VALUES (20259, 2048, 15, 'Ή να ');
INSERT INTO `lang_definitions` VALUES (20260, 2049, 15, 'Ή ανεβάστε αρχείο ERA:');
INSERT INTO `lang_definitions` VALUES (20261, 2050, 15, 'Στόμα');
INSERT INTO `lang_definitions` VALUES (20262, 2051, 15, 'Στοματικός βλεννογόνος ροζ, λάρυγγας καθαρός ');
INSERT INTO `lang_definitions` VALUES (20263, 2052, 15, 'Σειρά');
INSERT INTO `lang_definitions` VALUES (20264, 2053, 15, 'Η σειρά πρέπει να είναι ένας αριθμός μεταξύ 1 και 999 ');
INSERT INTO `lang_definitions` VALUES (20265, 2054, 15, 'Βλάβη οργάνου ');
INSERT INTO `lang_definitions` VALUES (20266, 2055, 15, 'Οργανισμός');
INSERT INTO `lang_definitions` VALUES (20267, 2056, 15, 'Οργανισμοί ');
INSERT INTO `lang_definitions` VALUES (20268, 2057, 15, 'Προσανατολισμένο x 3 ');
INSERT INTO `lang_definitions` VALUES (20269, 2058, 15, 'Πρωτότυπο');
INSERT INTO `lang_definitions` VALUES (20270, 2059, 15, 'ΟΡΟΦΑΡΥΓΓΑΣ:');
INSERT INTO `lang_definitions` VALUES (20271, 2060, 15, 'Ορθόπνοια');
INSERT INTO `lang_definitions` VALUES (20272, 2061, 15, 'Αριστερός οφθαλμός');
INSERT INTO `lang_definitions` VALUES (20273, 2062, 15, 'Οστεοαρθρίτιδα');
INSERT INTO `lang_definitions` VALUES (20274, 2063, 15, 'Άλλα');
INSERT INTO `lang_definitions` VALUES (20275, 2064, 15, 'Άλλο');
INSERT INTO `lang_definitions` VALUES (20276, 2065, 15, 'Άλλο (προσδιορίστε) ');
INSERT INTO `lang_definitions` VALUES (20277, 2066, 15, 'Άλλο Ομοσπονδιακό Πρόγραμμα ');
INSERT INTO `lang_definitions` VALUES (20278, 2067, 15, 'Άλλη Διεύθυνση Χρηματοδότησης Υγείας');
INSERT INTO `lang_definitions` VALUES (20279, 2068, 15, 'Άλλη βλάβη που δεν προσδιορίζεται αλλού');
INSERT INTO `lang_definitions` VALUES (20280, 2069, 15, 'άλλος μήνας');
INSERT INTO `lang_definitions` VALUES (20281, 2070, 15, 'Άλλα μη Ομοσπονδιακά Προγράμματα ');
INSERT INTO `lang_definitions` VALUES (20282, 2071, 15, 'Άλλες σημειώσεις');
INSERT INTO `lang_definitions` VALUES (20283, 2072, 15, 'Άλλα σχετικά συμπτώματα ');
INSERT INTO `lang_definitions` VALUES (20284, 2073, 15, 'Άλλα σχετικά συμπτώματα:');
INSERT INTO `lang_definitions` VALUES (20285, 2074, 15, 'Άλλες βλάβες από stress/υπερβολική χρήση');
INSERT INTO `lang_definitions` VALUES (20286, 2075, 15, 'Άλλα Χειρουργικά');
INSERT INTO `lang_definitions` VALUES (20287, 2076, 15, 'Άλλα/πρωτοπαθή σχετικά με άμβλωση ');
INSERT INTO `lang_definitions` VALUES (20288, 2077, 15, 'αλλιώς θα καταστρέψετε αναφορές στα/από τα υπάρχοντα δεδομένα.');
INSERT INTO `lang_definitions` VALUES (20289, 2078, 15, 'Κανόνες αστραγάλου της Οτάβα');
INSERT INTO `lang_definitions` VALUES (20290, 2080, 15, 'ΕΞΩ');
INSERT INTO `lang_definitions` VALUES (20291, 2081, 15, 'Εκτός γραφείου');
INSERT INTO `lang_definitions` VALUES (20292, 2082, 15, 'Έκβαση ');
INSERT INTO `lang_definitions` VALUES (20293, 2083, 15, 'Outlook ');
INSERT INTO `lang_definitions` VALUES (20294, 2084, 15, 'Υπερβολική χρήση');
INSERT INTO `lang_definitions` VALUES (20295, 2085, 15, 'Υπερβαρος');
INSERT INTO `lang_definitions` VALUES (20296, 2086, 15, 'Επικαλύψτε την επιλογή HIPAA');
INSERT INTO `lang_definitions` VALUES (20297, 2087, 15, 'Κορεσμός οξυγόνου');
INSERT INTO `lang_definitions` VALUES (20298, 2089, 15, 'μετά φαγητό');
INSERT INTO `lang_definitions` VALUES (20299, 2090, 15, 'μμ');
INSERT INTO `lang_definitions` VALUES (20300, 2091, 15, 'όταν είναι απαραίτητο');
INSERT INTO `lang_definitions` VALUES (20301, 2092, 15, 'Παιδιατρικό');
INSERT INTO `lang_definitions` VALUES (20302, 2093, 15, 'Σελίδες ');
INSERT INTO `lang_definitions` VALUES (20303, 2094, 15, 'Σελίδα');
INSERT INTO `lang_definitions` VALUES (20304, 2095, 15, 'Αμειβόμενος/η');
INSERT INTO `lang_definitions` VALUES (20305, 2096, 15, 'Πληρωμένο ποσό που θα κατανείμετε');
INSERT INTO `lang_definitions` VALUES (20306, 2097, 15, 'Πληρωμένα μέσω ');
INSERT INTO `lang_definitions` VALUES (20307, 2098, 15, 'Πόνος');
INSERT INTO `lang_definitions` VALUES (20308, 2099, 15, 'Επίκρουση');
INSERT INTO `lang_definitions` VALUES (20309, 2100, 15, 'Τεστ Παπανικολάου ');
INSERT INTO `lang_definitions` VALUES (20310, 2101, 15, 'Παράλυση');
INSERT INTO `lang_definitions` VALUES (20311, 2102, 15, 'Ανάλυση HL7');
INSERT INTO `lang_definitions` VALUES (20312, 2103, 15, 'Εταίρος ');
INSERT INTO `lang_definitions` VALUES (20313, 2104, 15, 'Κωδικός πρόσβ.');
INSERT INTO `lang_definitions` VALUES (20314, 2105, 15, 'Αλλαγή Κωδικού πρόσβασης');
INSERT INTO `lang_definitions` VALUES (20315, 2106, 15, 'Αλλαγή Κωδικού πρόσβασης επιτυχής');
INSERT INTO `lang_definitions` VALUES (20316, 2107, 15, 'Κωδικός για το SMS Gateway ');
INSERT INTO `lang_definitions` VALUES (20317, 2108, 15, 'Κωδικός Πρόσβασης:');
INSERT INTO `lang_definitions` VALUES (20318, 2109, 15, 'Προηγούμενες επισκέψεις');
INSERT INTO `lang_definitions` VALUES (20319, 2110, 15, 'Προηγούμενες επισκέψεις και έγγραφα');
INSERT INTO `lang_definitions` VALUES (20320, 2111, 15, 'Επικόλληση HL7 δεδομένων ');
INSERT INTO `lang_definitions` VALUES (20321, 2112, 15, 'Επικολλήσετε τα δεδομένα για να εισάγεται στο παρακάτω πεδίο κειμένου:');
INSERT INTO `lang_definitions` VALUES (20322, 2113, 15, 'Μπάλωμα');
INSERT INTO `lang_definitions` VALUES (20323, 2114, 15, 'Ασθενής');
INSERT INTO `lang_definitions` VALUES (20324, 2115, 15, 'Ασθενής');
INSERT INTO `lang_definitions` VALUES (20325, 2116, 15, 'ΑΣΘΕΝΕΙΣ');
INSERT INTO `lang_definitions` VALUES (20326, 2117, 15, 'Αλλεργίες ασθενή');
INSERT INTO `lang_definitions` VALUES (20327, 2118, 15, 'Αλλεργίες ασθενή');
INSERT INTO `lang_definitions` VALUES (20328, 2119, 15, 'Ραντεβού ασθενή');
INSERT INTO `lang_definitions` VALUES (20329, 2120, 15, 'Αναγνωριστικό γραφήματος ασθενούς');
INSERT INTO `lang_definitions` VALUES (20330, 2121, 15, 'Αποχώρηση ασθενή');
INSERT INTO `lang_definitions` VALUES (20331, 2122, 15, 'Αποχώρηση ασθενή για');
INSERT INTO `lang_definitions` VALUES (20332, 2123, 15, 'Επικοινωνία ασθενή απεστάλη');
INSERT INTO `lang_definitions` VALUES (20333, 2124, 15, 'Επικοινωνία ασθενή απεστάλη');
INSERT INTO `lang_definitions` VALUES (20334, 2125, 15, 'Στοιχεία ασθενούς');
INSERT INTO `lang_definitions` VALUES (20335, 2126, 15, 'Έγγραφο ασθενούς');
INSERT INTO `lang_definitions` VALUES (20336, 2127, 15, 'Επίσκεψη ασθενή');
INSERT INTO `lang_definitions` VALUES (20337, 2128, 15, 'Έντυπο επίσκεψης ασθενή');
INSERT INTO `lang_definitions` VALUES (20338, 2129, 15, 'Επισκέψεις ασθενή');
INSERT INTO `lang_definitions` VALUES (20339, 2130, 15, 'Εύρεση ασθενή');
INSERT INTO `lang_definitions` VALUES (20340, 2131, 15, 'Ιστορικό ασθενούς');
INSERT INTO `lang_definitions` VALUES (20341, 2132, 15, 'Ιστορικό ασθενούς / Τρόπος ζωής');
INSERT INTO `lang_definitions` VALUES (20342, 2133, 15, 'Αναγνωριστικό ασθενούς');
INSERT INTO `lang_definitions` VALUES (20343, 2134, 15, 'Κάρτα ασθενούς');
INSERT INTO `lang_definitions` VALUES (20344, 2135, 15, 'Ανοσοποίηση ασθενούς');
INSERT INTO `lang_definitions` VALUES (20345, 2136, 15, 'Πληροφορίες ασθενούς');
INSERT INTO `lang_definitions` VALUES (20346, 2137, 15, 'Κατανομή ασφάλισης ασθενών');
INSERT INTO `lang_definitions` VALUES (20347, 2138, 15, 'Αναφορά κατανομής ασφάλισης ασθενών ');
INSERT INTO `lang_definitions` VALUES (20348, 2139, 15, 'Διαγνώσεις ασθενούς ');
INSERT INTO `lang_definitions` VALUES (20349, 2140, 15, 'Κατάλογος ασθενών');
INSERT INTO `lang_definitions` VALUES (20350, 2141, 15, 'Διαγνώσεις ασθενούς');
INSERT INTO `lang_definitions` VALUES (20351, 2142, 15, 'Αγωγή ασθενούς');
INSERT INTO `lang_definitions` VALUES (20352, 2143, 15, 'Όνομα & Διεύθυνση ασθενούς');
INSERT INTO `lang_definitions` VALUES (20353, 2144, 15, 'Τύποι σημειώσεων');
INSERT INTO `lang_definitions` VALUES (20354, 2145, 15, 'Σημειώσεις ασθενούς');
INSERT INTO `lang_definitions` VALUES (20355, 2146, 15, 'Σημειώσεις ασθενούς (εγγραφή, προαιρετικά προσθήκη)');
INSERT INTO `lang_definitions` VALUES (20356, 2147, 15, 'Αριθμός ασθενών ');
INSERT INTO `lang_definitions` VALUES (20357, 2148, 15, 'Εκτυπωμένη αναφορά ασθενούς');
INSERT INTO `lang_definitions` VALUES (20358, 2149, 15, 'Αναφορά φακέλου ασθενούς');
INSERT INTO `lang_definitions` VALUES (20359, 2150, 15, 'Αναφορά ασθενούς');
INSERT INTO `lang_definitions` VALUES (20360, 2151, 15, 'Αίτημα ασθενούς');
INSERT INTO `lang_definitions` VALUES (20361, 2152, 15, 'Περίληψη ασθενών');
INSERT INTO `lang_definitions` VALUES (20362, 2153, 15, 'Συναλλαγές ασθενούς');
INSERT INTO `lang_definitions` VALUES (20363, 2154, 15, 'ασθενής(-εις) στη βάση δεδομένων που ταιριάζουν με τις δημογραφικές πληροφορίες που έχετε εισάγει.');
INSERT INTO `lang_definitions` VALUES (20364, 2155, 15, 'ΑΣΘΕΝΗΣ');
INSERT INTO `lang_definitions` VALUES (20365, 2156, 15, 'Ασθενής: ');
INSERT INTO `lang_definitions` VALUES (20366, 2157, 15, 'Ασθενείς ');
INSERT INTO `lang_definitions` VALUES (20367, 2158, 15, 'Πληρωμή');
INSERT INTO `lang_definitions` VALUES (20368, 2159, 15, 'Δώστε προσοχή στα κουτάκια \"Έγινε με\". Αφού οι ασφάλειες σημειωθούν ως πλήρεις τότε θα ξεκινήσουμε ζητώντας από τον ασθενή να καταβάλει το υπόλοιπο ποσό. Αν αποτύχετε να επισημάνετε όλες τις πλήρεις ασφάλειες τότε το υπόλοιπο ποσό δεν θα εισπραχθεί! Επίσης, εάν υπάρχει ένα ποσό που ο ασθενής θα πρέπει να πληρώσει, τότε θέστε την ημερομηνία λήξης κατάλληλα, καθώς αυτό θα επηρεάσει τη γλώσσα που εμφανίζεται στις καταστάσεις του ασθενή.');
INSERT INTO `lang_definitions` VALUES (20369, 2160, 15, 'Ημερομηνία Πληρωμής ');
INSERT INTO `lang_definitions` VALUES (20370, 2161, 15, 'Πληρωτής ');
INSERT INTO `lang_definitions` VALUES (20371, 2162, 15, 'Τύπος πληρωτή');
INSERT INTO `lang_definitions` VALUES (20372, 2163, 15, 'Πλήρωση');
INSERT INTO `lang_definitions` VALUES (20373, 2164, 15, 'Πληρωμή ');
INSERT INTO `lang_definitions` VALUES (20374, 2165, 15, 'Πληρωμή');
INSERT INTO `lang_definitions` VALUES (20375, 2166, 15, 'Ημερομηνία Πληρωμής ');
INSERT INTO `lang_definitions` VALUES (20376, 2167, 15, 'η πληρωμή εισήχθει στις');
INSERT INTO `lang_definitions` VALUES (20377, 2168, 15, 'Τρόπος πληρωμής ');
INSERT INTO `lang_definitions` VALUES (20378, 2169, 15, 'Αξίας πληρωμής για κωδικό ');
INSERT INTO `lang_definitions` VALUES (20379, 2170, 15, 'Πληρωμές ');
INSERT INTO `lang_definitions` VALUES (20380, 2171, 15, 'PDF');
INSERT INTO `lang_definitions` VALUES (20381, 2172, 15, 'Πύελος και γλουτός ');
INSERT INTO `lang_definitions` VALUES (20382, 2173, 15, 'Πέμφυγα');
INSERT INTO `lang_definitions` VALUES (20383, 2174, 15, 'Εκκρεμεί ');
INSERT INTO `lang_definitions` VALUES (20384, 2175, 15, 'Εκκρεμής επανεκτίμηση ');
INSERT INTO `lang_definitions` VALUES (20385, 2176, 15, 'Εταιρεία Pennington OpenEMR v');
INSERT INTO `lang_definitions` VALUES (20386, 2177, 15, 'Νόσος πεπτικού έλκους ');
INSERT INTO `lang_definitions` VALUES (20387, 2178, 15, 'ανά λεπτό');
INSERT INTO `lang_definitions` VALUES (20388, 2179, 15, 'Σε κάθε ρουθούνι ');
INSERT INTO `lang_definitions` VALUES (20389, 2180, 15, 'σε κάθε ρουθούνι ');
INSERT INTO `lang_definitions` VALUES (20390, 2181, 15, 'Aπό το στόμα');
INSERT INTO `lang_definitions` VALUES (20391, 2182, 15, 'Aπό το στόμα');
INSERT INTO `lang_definitions` VALUES (20392, 2183, 15, 'Ορθικά');
INSERT INTO `lang_definitions` VALUES (20393, 2184, 15, 'ορθικά');
INSERT INTO `lang_definitions` VALUES (20394, 2185, 15, 'Διατρημένο Δεξιά: ');
INSERT INTO `lang_definitions` VALUES (20395, 2186, 15, 'Εκτέλεση αναζήτησης');
INSERT INTO `lang_definitions` VALUES (20396, 2187, 15, 'Εκτέλεση αυτής της ενέργειας');
INSERT INTO `lang_definitions` VALUES (20397, 2188, 15, 'Περιφερειακό');
INSERT INTO `lang_definitions` VALUES (20398, 2189, 15, 'Άτομο');
INSERT INTO `lang_definitions` VALUES (20399, 2190, 15, 'Φάρμακα');
INSERT INTO `lang_definitions` VALUES (20400, 2191, 15, 'Φαρμακείο');
INSERT INTO `lang_definitions` VALUES (20401, 2192, 15, 'Αποθήκη φαρμακείου');
INSERT INTO `lang_definitions` VALUES (20402, 2193, 15, 'Πνευμοθώρακας');
INSERT INTO `lang_definitions` VALUES (20403, 2194, 15, 'Τηλέφωνο');
INSERT INTO `lang_definitions` VALUES (20404, 2195, 15, 'Λίστα τηλεφωνικών κλήσεων');
INSERT INTO `lang_definitions` VALUES (20405, 2196, 15, 'Αριθμός τηλεφώνου');
INSERT INTO `lang_definitions` VALUES (20406, 2197, 15, 'Φωτοφοβία');
INSERT INTO `lang_definitions` VALUES (20407, 2198, 15, 'PHP compressed');
INSERT INTO `lang_definitions` VALUES (20408, 2199, 15, 'PHP extracted');
INSERT INTO `lang_definitions` VALUES (20409, 2200, 15, 'php=GACL access controls are turned off');
INSERT INTO `lang_definitions` VALUES (20410, 2201, 15, 'PHP-gacl is not installed');
INSERT INTO `lang_definitions` VALUES (20411, 2202, 15, 'Φυσική εξέταση');
INSERT INTO `lang_definitions` VALUES (20412, 2203, 15, 'Αίτηση ιατρού');
INSERT INTO `lang_definitions` VALUES (20413, 2204, 15, 'Υπογραφή ιατρού ');
INSERT INTO `lang_definitions` VALUES (20414, 2205, 15, 'Ιατροί ');
INSERT INTO `lang_definitions` VALUES (20415, 2206, 15, 'συλλέξτε');
INSERT INTO `lang_definitions` VALUES (20416, 2207, 15, 'Προσωπικό αναγνωριστικό');
INSERT INTO `lang_definitions` VALUES (20417, 2208, 15, 'Φλεγμ. νόσος πυέλου');
INSERT INTO `lang_definitions` VALUES (20418, 2209, 15, 'Μέγεθος χαπιού');
INSERT INTO `lang_definitions` VALUES (20419, 2210, 15, 'Χάπια ');
INSERT INTO `lang_definitions` VALUES (20420, 2213, 15, 'Απλό κείμενο ');
INSERT INTO `lang_definitions` VALUES (20421, 2214, 15, 'Οδηγίες');
INSERT INTO `lang_definitions` VALUES (20422, 2215, 15, 'Όνομα πλάνου');
INSERT INTO `lang_definitions` VALUES (20423, 2216, 15, 'Πλάνο:');
INSERT INTO `lang_definitions` VALUES (20424, 2217, 15, 'Παίκτης ');
INSERT INTO `lang_definitions` VALUES (20425, 2218, 15, 'Θέση παιχνιδιού ');
INSERT INTO `lang_definitions` VALUES (20426, 2219, 15, 'Παρακαλώ επιλέξτε μια έγκυρη επιλογή από τη λίστα. ');
INSERT INTO `lang_definitions` VALUES (20427, 2220, 15, 'Παρακαλώ επιλέξτε μια έγκυρη επιλογή.');
INSERT INTO `lang_definitions` VALUES (20428, 2221, 15, 'Παρακαλώ επιλέξτε μια τιμή για ');
INSERT INTO `lang_definitions` VALUES (20429, 2222, 15, 'Παρακαλώ κλείστε αυτό το παράθυρο');
INSERT INTO `lang_definitions` VALUES (20430, 2223, 15, 'Παρακαλώ συγκρίνετε το νέο όνομα');
INSERT INTO `lang_definitions` VALUES (20431, 2224, 15, 'Παρακαλώ μη δέχεστε αυτή τη συνταγή εκτός αν λήφθηκε μέσω facimile.');
INSERT INTO `lang_definitions` VALUES (20432, 2225, 15, 'Παρακαλώ μην χρησιμοποιείτε τα κουμπιά Stop ή Reload του φυλλομετρητή σας ενώ αυτή η σελίδα τρέχει, εκτός αν έχουν παρέλθει περισσότερα από 10 λεπτά. Αυτό δεν θα προκαλέσει το σταμάτημα της διαδικασίας στο διακομιστή και θα καταναλώσει περιτούς πόρους.');
INSERT INTO `lang_definitions` VALUES (20433, 2226, 15, 'Παρακαλώ εισάγετε ένα χρηματικό ποσό χρησιμοποιώντας μόνο αριθμούς και ένα δεκαδικό ψηφίο');
INSERT INTO `lang_definitions` VALUES (20434, 2227, 15, 'Παρακαλώ εισάγετε τίτλο! ');
INSERT INTO `lang_definitions` VALUES (20435, 2228, 15, 'Παρακαλώ σημειώστε ότι αυτό μπορεί να πάρει πολύ χρόνο, μέχρι και αρκετά λεπτά. Ο φυλλομετρητής σας μπορεί να μην εμφανίζεται πολύ δραστήριος κατά τη διάρκεια αυτής της περιόδου, αλλά η δημιουργία μιας χρέωσης είναι μια περίπλοκη διαδικασία και ο φυλλομετρητής σας απλώς περιμένει περισσότερες πληροφορίες.');
INSERT INTO `lang_definitions` VALUES (20436, 2229, 15, 'Σημείωση: στις σταθερές παίζουν ρόλο τα μικρά-κεφαλαία και επιτρέπεται κάθε string.');
INSERT INTO `lang_definitions` VALUES (20437, 2230, 15, 'Παρακαλώ χρησιμοποιήστε μόνο αλφαβητικούς χαρακτήρες');
INSERT INTO `lang_definitions` VALUES (20438, 2231, 15, 'Παρακαλώ χρησιμοποιήστε μόνο αλφαβητικούς χαρακτήρες χωρίς κενά');
INSERT INTO `lang_definitions` VALUES (20439, 2232, 15, 'Παρακαλώ πληρώστε αυτό το ποσό');
INSERT INTO `lang_definitions` VALUES (20440, 2233, 15, 'Παρακαλώ επιλέξτε μια δικαιολογία για τον κωδικό');
INSERT INTO `lang_definitions` VALUES (20441, 2234, 15, 'Παρακαλώ επιλέξτε ένα σύμβαμα');
INSERT INTO `lang_definitions` VALUES (20442, 2235, 15, 'Παρακαλώ επιλέξτε τις επιθυμητές σελίδες για αντιγραφή ή προώθηση: ');
INSERT INTO `lang_definitions` VALUES (20443, 2236, 15, 'ΜΜ');
INSERT INTO `lang_definitions` VALUES (20444, 2237, 15, 'Μέθοδος πληρωμής');
INSERT INTO `lang_definitions` VALUES (20445, 2238, 15, 'Κατάθλιψη μετά τον τοκετό');
INSERT INTO `lang_definitions` VALUES (20446, 2239, 15, 'Σύμπλεγμα πνευμονιόκοκκου 1');
INSERT INTO `lang_definitions` VALUES (20447, 2240, 15, 'Σύμπλεγμα πνευμονιόκοκκου 2');
INSERT INTO `lang_definitions` VALUES (20448, 2241, 15, 'Σύμπλεγμα πνευμονιόκοκκου 3');
INSERT INTO `lang_definitions` VALUES (20449, 2242, 15, 'Σύμπλεγμα πνευμονιόκοκκου 4');
INSERT INTO `lang_definitions` VALUES (20450, 2243, 15, 'Εμβολιασμός για πνευμονία');
INSERT INTO `lang_definitions` VALUES (20451, 2244, 15, 'Σημείο εξυπηρέτησης');
INSERT INTO `lang_definitions` VALUES (20452, 2245, 15, 'Πολιτική ');
INSERT INTO `lang_definitions` VALUES (20453, 2246, 15, 'Αριθμός πολιτικής ');
INSERT INTO `lang_definitions` VALUES (20454, 2247, 15, 'Πολυδιψία');
INSERT INTO `lang_definitions` VALUES (20455, 2248, 15, 'Πολύποδες ');
INSERT INTO `lang_definitions` VALUES (20456, 2249, 15, 'Πολυουρία');
INSERT INTO `lang_definitions` VALUES (20457, 2250, 15, 'Κακή όρεξη ');
INSERT INTO `lang_definitions` VALUES (20458, 2251, 15, 'Κακή κυκλοφορία ');
INSERT INTO `lang_definitions` VALUES (20459, 2252, 15, 'Βαρηκοΐα ');
INSERT INTO `lang_definitions` VALUES (20460, 2253, 15, 'Να συμπληρωθεί η εμφάνιση του έτους με συμβάματα;');
INSERT INTO `lang_definitions` VALUES (20461, 2254, 15, 'Popups');
INSERT INTO `lang_definitions` VALUES (20462, 2255, 15, 'Πορτογαλικά (Βραζιλία)');
INSERT INTO `lang_definitions` VALUES (20463, 2256, 15, 'Πορτογαλικά (Ευρωπαϊκά)');
INSERT INTO `lang_definitions` VALUES (20464, 2257, 15, 'Κωδικός σημείου εξυπηρέτησης');
INSERT INTO `lang_definitions` VALUES (20465, 2258, 15, 'Ρινική καταρροή');
INSERT INTO `lang_definitions` VALUES (20466, 2259, 15, 'Μετεγχειρητικό ');
INSERT INTO `lang_definitions` VALUES (20467, 2260, 15, 'Αποστολή στο λογιστήριο και σημείωση ως πληρωμένο');
INSERT INTO `lang_definitions` VALUES (20468, 2261, 15, 'Φροντίδα μετά την άμβλωση');
INSERT INTO `lang_definitions` VALUES (20469, 2262, 15, 'Αντισύλληψη μετά την άμβλωση');
INSERT INTO `lang_definitions` VALUES (20470, 2263, 15, 'Συμβουλευτική μετά την άμβλωση');
INSERT INTO `lang_definitions` VALUES (20471, 2264, 15, 'Παρακολούθηση μετά την άμβλωση');
INSERT INTO `lang_definitions` VALUES (20472, 2265, 15, 'Ταχυδρομικός/ό/ή');
INSERT INTO `lang_definitions` VALUES (20473, 2266, 15, 'Τ.Κ. ');
INSERT INTO `lang_definitions` VALUES (20474, 2267, 15, 'Ταχυδρομικός κώδικας ');
INSERT INTO `lang_definitions` VALUES (20475, 2268, 15, 'Ημερολόγιο');
INSERT INTO `lang_definitions` VALUES (20476, 2269, 15, 'Διαχείριση Ημερολογίου');
INSERT INTO `lang_definitions` VALUES (20477, 2270, 15, 'Ρύθμιση κατηγοριών Ημερολογίου');
INSERT INTO `lang_definitions` VALUES (20478, 2271, 15, 'Γενικές ρυθμίσεις Ημερολογίου');
INSERT INTO `lang_definitions` VALUES (20479, 2272, 15, 'Απεστάλη στις ');
INSERT INTO `lang_definitions` VALUES (20480, 2273, 15, 'Ημερομηνία αποστολής');
INSERT INTO `lang_definitions` VALUES (20481, 2275, 15, 'Συνεργάτες');
INSERT INTO `lang_definitions` VALUES (20482, 2276, 15, 'Ρυθμίσεις Συνεργατών');
INSERT INTO `lang_definitions` VALUES (20483, 2277, 15, 'Πρακτικός');
INSERT INTO `lang_definitions` VALUES (20484, 2278, 15, 'Συμβουλή προ της άμβλωσης');
INSERT INTO `lang_definitions` VALUES (20485, 2279, 15, 'Συμβουλευτική προ της άμβλωσης');
INSERT INTO `lang_definitions` VALUES (20486, 2280, 15, 'Προτιμ κατηγ');
INSERT INTO `lang_definitions` VALUES (20487, 2281, 15, 'Προτιμώμενη κατηγορία συμβαμάτων');
INSERT INTO `lang_definitions` VALUES (20488, 2282, 15, 'Προτιμώμενη γλώσσα ');
INSERT INTO `lang_definitions` VALUES (20489, 2283, 15, 'Προτιμώμενο φαρμακείο');
INSERT INTO `lang_definitions` VALUES (20490, 2284, 15, 'Προτιμώμενο οργανισμός Παρόχου');
INSERT INTO `lang_definitions` VALUES (20491, 2285, 15, 'Τέστ εγκυμοσύνης');
INSERT INTO `lang_definitions` VALUES (20492, 2286, 15, 'Προπληρωμή ');
INSERT INTO `lang_definitions` VALUES (20493, 2287, 15, 'Συνταγή');
INSERT INTO `lang_definitions` VALUES (20494, 2288, 15, 'Συνταγογραφούμενη ετικέτα ');
INSERT INTO `lang_definitions` VALUES (20495, 2289, 15, 'Συνταγές ');
INSERT INTO `lang_definitions` VALUES (20496, 2290, 15, 'Συνταγές και σκευάσματα');
INSERT INTO `lang_definitions` VALUES (20497, 2291, 15, 'Συνταγές και άλλες παραπομπές');
INSERT INTO `lang_definitions` VALUES (20498, 2292, 15, 'Συνταγές ή/και παραπομπές από ειδικό');
INSERT INTO `lang_definitions` VALUES (20499, 2293, 15, 'Αναφορά συνταγών');
INSERT INTO `lang_definitions` VALUES (20500, 2294, 15, 'Συνταγές/Παραπομπές');
INSERT INTO `lang_definitions` VALUES (20501, 2295, 15, 'Κύριο ενόχλημα');
INSERT INTO `lang_definitions` VALUES (20502, 2296, 15, 'Πατήστε Συνέχεια για να προχωρήσετε ');
INSERT INTO `lang_definitions` VALUES (20503, 2297, 15, 'Υποτιθέμενη διάγνωση ');
INSERT INTO `lang_definitions` VALUES (20504, 2298, 15, 'Υποτιθέμενη διάγνωση από ειδικό');
INSERT INTO `lang_definitions` VALUES (20505, 2299, 15, 'Προηγ ');
INSERT INTO `lang_definitions` VALUES (20506, 2300, 15, 'Προβολή συμβάματος');
INSERT INTO `lang_definitions` VALUES (20507, 2301, 15, 'Προηγούμενο');
INSERT INTO `lang_definitions` VALUES (20508, 2302, 15, 'Προηγούμενη συμβουλή');
INSERT INTO `lang_definitions` VALUES (20509, 2303, 15, 'Προηγούμενη ημέρα');
INSERT INTO `lang_definitions` VALUES (20510, 2304, 15, 'Προηγούμενη Ιστορικό/Έλεγχος ');
INSERT INTO `lang_definitions` VALUES (20511, 2305, 15, 'Προηγούμενος μήνας');
INSERT INTO `lang_definitions` VALUES (20512, 2306, 15, 'Προηγούμενη εβδομάδα');
INSERT INTO `lang_definitions` VALUES (20513, 2307, 15, 'Τιμή ');
INSERT INTO `lang_definitions` VALUES (20514, 2308, 15, 'Έκπτωση τιμής');
INSERT INTO `lang_definitions` VALUES (20515, 2309, 15, 'Επίπεδο τιμής');
INSERT INTO `lang_definitions` VALUES (20516, 2310, 15, 'Επίπεδο τιμής:');
INSERT INTO `lang_definitions` VALUES (20517, 2311, 15, 'Τιμές');
INSERT INTO `lang_definitions` VALUES (20518, 2312, 15, 'Πρωτεύουσα');
INSERT INTO `lang_definitions` VALUES (20519, 2313, 15, 'Πρωτεύουσα ασφ');
INSERT INTO `lang_definitions` VALUES (20520, 2314, 15, 'Πρωτεύουσα Ασφάλιση');
INSERT INTO `lang_definitions` VALUES (20521, 2315, 15, 'Δεδομένα Πρωτεύουσας Ασφάλισης');
INSERT INTO `lang_definitions` VALUES (20522, 2316, 15, 'Πάροχος Πρωτεύουσας Ασφάλισης');
INSERT INTO `lang_definitions` VALUES (20523, 2317, 15, 'Πρωτεύων πάροχος');
INSERT INTO `lang_definitions` VALUES (20524, 2318, 15, 'Εκτύπωση');
INSERT INTO `lang_definitions` VALUES (20525, 2322, 15, 'Εκτύπωση κενού εντύπου παραπομπής');
INSERT INTO `lang_definitions` VALUES (20526, 2323, 15, 'Εκτύπωση εντύπου');
INSERT INTO `lang_definitions` VALUES (20527, 2324, 15, 'Εκτύπωση τετραπλού Panel');
INSERT INTO `lang_definitions` VALUES (20528, 2325, 15, 'Πολλαπλή εκτύπωση');
INSERT INTO `lang_definitions` VALUES (20529, 2326, 15, 'Πολλαπλή εκτύπωση σε FAX');
INSERT INTO `lang_definitions` VALUES (20530, 2329, 15, 'Εκτύπωση σελίδας 1');
INSERT INTO `lang_definitions` VALUES (20531, 2330, 15, 'Εκτύπωση σελίδας 2');
INSERT INTO `lang_definitions` VALUES (20532, 2331, 15, 'Εκτύπωση Εγγραφής');
INSERT INTO `lang_definitions` VALUES (20533, 2334, 15, 'Εκτύπωση αυτής της σημείωσης');
INSERT INTO `lang_definitions` VALUES (20534, 2335, 15, 'Εκτύπωση αυτής της σημείωσης');
INSERT INTO `lang_definitions` VALUES (20535, 2336, 15, 'Εκτύπωση σε FAX');
INSERT INTO `lang_definitions` VALUES (20536, 2337, 15, 'Προβολή Εκτύπωσης');
INSERT INTO `lang_definitions` VALUES (20537, 2338, 15, 'εκτυπώσιμη');
INSERT INTO `lang_definitions` VALUES (20538, 2339, 15, 'Εκτυπώσιμη Έκδοση');
INSERT INTO `lang_definitions` VALUES (20539, 2340, 15, 'Εκτυπωμένο');
INSERT INTO `lang_definitions` VALUES (20540, 2341, 15, 'Εκτύπωση αποτελεσμάτων:');
INSERT INTO `lang_definitions` VALUES (20541, 2342, 15, 'Η εκτύπωση παραλήφθηκε, δείτε την έξοδος του τεστ στο');
INSERT INTO `lang_definitions` VALUES (20542, 2343, 15, 'Προηγουμενη εξουσιοδοτηση');
INSERT INTO `lang_definitions` VALUES (20543, 2344, 15, 'Προηγούμενο έντυπο άδειας ');
INSERT INTO `lang_definitions` VALUES (20544, 2345, 15, 'Προτεραιότητα ');
INSERT INTO `lang_definitions` VALUES (20545, 2346, 15, 'Ιδιωτικό');
INSERT INTO `lang_definitions` VALUES (20546, 2347, 15, 'Πρόβλημα ');
INSERT INTO `lang_definitions` VALUES (20547, 2348, 15, 'Λίστα προβλημάτων');
INSERT INTO `lang_definitions` VALUES (20548, 2349, 15, 'Προβλήματα/Θέματα ');
INSERT INTO `lang_definitions` VALUES (20549, 2350, 15, 'Διαδικασία ');
INSERT INTO `lang_definitions` VALUES (20550, 2351, 15, 'Διαδικασίες ');
INSERT INTO `lang_definitions` VALUES (20551, 2352, 15, 'Επεξεργασία');
INSERT INTO `lang_definitions` VALUES (20552, 2353, 15, 'Επεξεργάζεται');
INSERT INTO `lang_definitions` VALUES (20553, 2354, 15, 'Προϊόντα ');
INSERT INTO `lang_definitions` VALUES (20554, 2355, 15, 'Ποσό');
INSERT INTO `lang_definitions` VALUES (20555, 2357, 15, 'Καρκίνος προστάτη');
INSERT INTO `lang_definitions` VALUES (20556, 2358, 15, 'Εξέταση προστάτη');
INSERT INTO `lang_definitions` VALUES (20557, 2359, 15, 'Προβλήματα προστάτη');
INSERT INTO `lang_definitions` VALUES (20558, 2360, 15, 'Προστάτης χωρίς διογκ, όζους, ευαισθησία');
INSERT INTO `lang_definitions` VALUES (20559, 2361, 15, 'Πάροχος');
INSERT INTO `lang_definitions` VALUES (20560, 2362, 15, 'Αριθμός παρόχου');
INSERT INTO `lang_definitions` VALUES (20561, 2363, 15, 'Πάροχος:');
INSERT INTO `lang_definitions` VALUES (20562, 2364, 15, 'Πάροχοι');
INSERT INTO `lang_definitions` VALUES (20563, 2365, 15, 'Εθνικά αναγνωριστικά παρόχων');
INSERT INTO `lang_definitions` VALUES (20564, 2366, 15, 'Προηγ ');
INSERT INTO `lang_definitions` VALUES (20565, 2367, 15, 'PSA');
INSERT INTO `lang_definitions` VALUES (20566, 2368, 15, 'Ψωρίαση');
INSERT INTO `lang_definitions` VALUES (20567, 2369, 15, 'Ψυχ Διάγνωση');
INSERT INTO `lang_definitions` VALUES (20568, 2370, 15, 'Ψυχ Φάρμακα');
INSERT INTO `lang_definitions` VALUES (20569, 2371, 15, 'Ψυχιατρικό');
INSERT INTO `lang_definitions` VALUES (20570, 2372, 15, 'Ψυχιατρική επιστολή');
INSERT INTO `lang_definitions` VALUES (20571, 2373, 15, 'Ψυχιατρική διάγνωση');
INSERT INTO `lang_definitions` VALUES (20572, 2374, 15, 'Ψυχιατρική εξέταση');
INSERT INTO `lang_definitions` VALUES (20573, 2375, 15, 'Ψυχιατρική ιστορικό');
INSERT INTO `lang_definitions` VALUES (20574, 2376, 15, 'Ψυχιατρική Λήψη');
INSERT INTO `lang_definitions` VALUES (20575, 2377, 15, 'Ψυχιατρικά φάρμακα');
INSERT INTO `lang_definitions` VALUES (20576, 2378, 15, 'Ασθ %');
INSERT INTO `lang_definitions` VALUES (20577, 2379, 15, 'Σημειώσεις ασθενούς');
INSERT INTO `lang_definitions` VALUES (20578, 2380, 15, 'Σημειώσ/Εξουσιοδ');
INSERT INTO `lang_definitions` VALUES (20579, 2382, 15, 'Πληρωμένος ασθ ');
INSERT INTO `lang_definitions` VALUES (20580, 2383, 15, 'Επιστροφή ασθ');
INSERT INTO `lang_definitions` VALUES (20581, 2384, 15, 'Απολυμένος ασθ');
INSERT INTO `lang_definitions` VALUES (20582, 2385, 15, 'Αναφορά ασθ');
INSERT INTO `lang_definitions` VALUES (20583, 2386, 15, 'Φυσική θεραπεία φοιτητή, ή αφήστε κενό');
INSERT INTO `lang_definitions` VALUES (20584, 2388, 15, 'Ασθ_ΗμερΓενν');
INSERT INTO `lang_definitions` VALUES (20585, 2389, 15, 'Ασθ_Όνομα');
INSERT INTO `lang_definitions` VALUES (20586, 2390, 15, 'Ασθ_Επώνυμο');
INSERT INTO `lang_definitions` VALUES (20587, 2391, 15, 'Ασθ_ΜεσαιοΟνομα');
INSERT INTO `lang_definitions` VALUES (20588, 2395, 15, 'Δημόσιο');
INSERT INTO `lang_definitions` VALUES (20589, 2396, 15, 'Πνευμονικό');
INSERT INTO `lang_definitions` VALUES (20590, 2397, 15, 'Σφυγμός');
INSERT INTO `lang_definitions` VALUES (20591, 2398, 15, 'κάθε 3 ώρες');
INSERT INTO `lang_definitions` VALUES (20592, 2399, 15, 'κάθε 4 ώρες');
INSERT INTO `lang_definitions` VALUES (20593, 2400, 15, 'κάθε 5 ώρες');
INSERT INTO `lang_definitions` VALUES (20594, 2401, 15, 'κάθε 6 ώρες');
INSERT INTO `lang_definitions` VALUES (20595, 2402, 15, 'κάθε 8 ώρες');
INSERT INTO `lang_definitions` VALUES (20596, 2403, 15, 'κάθε μέρα');
INSERT INTO `lang_definitions` VALUES (20597, 2404, 15, '4 φορές την ημέρα');
INSERT INTO `lang_definitions` VALUES (20598, 2405, 15, 'Ποιότητα υγείας εργασίας');
INSERT INTO `lang_definitions` VALUES (20599, 2406, 15, 'Ποσοτ');
INSERT INTO `lang_definitions` VALUES (20600, 2407, 15, 'ΠΟΣΟΤ');
INSERT INTO `lang_definitions` VALUES (20601, 2408, 15, 'Ποιότητα ');
INSERT INTO `lang_definitions` VALUES (20602, 2409, 15, 'Ποσότητα ');
INSERT INTO `lang_definitions` VALUES (20603, 2410, 15, 'Ποσότητα Εθνικού Κωδικού Φαρμάκων');
INSERT INTO `lang_definitions` VALUES (20604, 2411, 15, 'Ποσότητα στο χέρι');
INSERT INTO `lang_definitions` VALUES (20605, 2416, 15, 'Σε ουρά ');
INSERT INTO `lang_definitions` VALUES (20606, 2417, 15, 'Διαχείριση συμβαμάτων ουράς ');
INSERT INTO `lang_definitions` VALUES (20607, 2418, 15, 'Ουρά για ');
INSERT INTO `lang_definitions` VALUES (20608, 2419, 15, 'Διαχείριση αποστολών ουράς ');
INSERT INTO `lang_definitions` VALUES (20609, 2421, 15, 'Φυλή');
INSERT INTO `lang_definitions` VALUES (20610, 2422, 15, 'Φυλή/Εθνικότητα');
INSERT INTO `lang_definitions` VALUES (20611, 2423, 15, 'Ραδιόφωνο ');
INSERT INTO `lang_definitions` VALUES (20612, 2424, 15, 'Κουμπιά επιλογής');
INSERT INTO `lang_definitions` VALUES (20613, 2425, 15, 'Εξανθήματα ');
INSERT INTO `lang_definitions` VALUES (20614, 2426, 15, 'Ρυθμός ');
INSERT INTO `lang_definitions` VALUES (20615, 2427, 15, 'Επανα-άνοιγμα');
INSERT INTO `lang_definitions` VALUES (20616, 2428, 15, 'Εκ νέου ανοιγμένο ');
INSERT INTO `lang_definitions` VALUES (20617, 2429, 15, 'Αντιδράσεις ');
INSERT INTO `lang_definitions` VALUES (20618, 2430, 15, 'Πραγματικό Όνομα ');
INSERT INTO `lang_definitions` VALUES (20619, 2431, 15, 'Αιτιολογία ');
INSERT INTO `lang_definitions` VALUES (20620, 2432, 15, 'Αιτία παραπομπής');
INSERT INTO `lang_definitions` VALUES (20621, 2433, 15, 'Αιτία επίσκεψης');
INSERT INTO `lang_definitions` VALUES (20622, 2434, 15, 'Αιτιολογία/Μορφή ');
INSERT INTO `lang_definitions` VALUES (20623, 2435, 15, 'Απόδειξη');
INSERT INTO `lang_definitions` VALUES (20624, 2436, 15, 'Απόδειξη πληρωμής');
INSERT INTO `lang_definitions` VALUES (20625, 2437, 15, 'Η απόδειξη δημιουργήθηκε');
INSERT INTO `lang_definitions` VALUES (20626, 2438, 15, 'Αναφορά αποδείξεων με βάση τη μέθοδο πληρωμής');
INSERT INTO `lang_definitions` VALUES (20627, 2439, 15, 'Σύνοψη Αποδείξεων');
INSERT INTO `lang_definitions` VALUES (20628, 2440, 15, 'Ελήφθη');
INSERT INTO `lang_definitions` VALUES (20629, 2441, 15, 'Ελήφθη από');
INSERT INTO `lang_definitions` VALUES (20630, 2442, 15, 'Ληφθέντα Fax');
INSERT INTO `lang_definitions` VALUES (20631, 2443, 15, 'Δέκτης');
INSERT INTO `lang_definitions` VALUES (20632, 2444, 15, 'Αναγνωριστικό δέκτη');
INSERT INTO `lang_definitions` VALUES (20633, 2447, 15, 'Συστάσεις');
INSERT INTO `lang_definitions` VALUES (20634, 2448, 15, 'Συστάσεις και θεραπεία');
INSERT INTO `lang_definitions` VALUES (20635, 2449, 15, 'Συστάσεις από ειδικό');
INSERT INTO `lang_definitions` VALUES (20636, 2450, 15, 'Φάκελος Πληρωμών');
INSERT INTO `lang_definitions` VALUES (20637, 2451, 15, 'βρέθηκαν εγγραφές');
INSERT INTO `lang_definitions` VALUES (20638, 2452, 15, 'Ορθό');
INSERT INTO `lang_definitions` VALUES (20639, 2453, 15, 'Εξετάση ορθού');
INSERT INTO `lang_definitions` VALUES (20640, 2454, 15, 'ορθικό');
INSERT INTO `lang_definitions` VALUES (20641, 2455, 15, 'Ερυθρότητα');
INSERT INTO `lang_definitions` VALUES (20642, 2456, 15, 'ελαττωμένο:');
INSERT INTO `lang_definitions` VALUES (20643, 2457, 15, 'Παραπομπή');
INSERT INTO `lang_definitions` VALUES (20644, 2458, 15, 'Παραπεμφθέν από');
INSERT INTO `lang_definitions` VALUES (20645, 2459, 15, 'Ημερομηνία παραπομπής');
INSERT INTO `lang_definitions` VALUES (20646, 2460, 15, 'Παραπομπή σε ');
INSERT INTO `lang_definitions` VALUES (20647, 2461, 15, 'Ταξινόμηση παραπομπής (επίπεδο κινδύνου)');
INSERT INTO `lang_definitions` VALUES (20648, 2462, 15, 'Αιτιολογία παραπομπής');
INSERT INTO `lang_definitions` VALUES (20649, 2463, 15, 'Όνομα και υπογραφή παραπεμποντος');
INSERT INTO `lang_definitions` VALUES (20650, 2464, 15, 'Παραπομπή ');
INSERT INTO `lang_definitions` VALUES (20651, 2465, 15, 'Παραπομπή από');
INSERT INTO `lang_definitions` VALUES (20652, 2466, 15, 'Κάρτα παραπομπής');
INSERT INTO `lang_definitions` VALUES (20653, 2467, 15, 'Ημερομηνία παραπομπής');
INSERT INTO `lang_definitions` VALUES (20654, 2468, 15, 'Έντυπο παραπομπής');
INSERT INTO `lang_definitions` VALUES (20655, 2469, 15, 'ΕΝΤΥΠΟ ΠΑΡΑΠΟΜΠΗΣ');
INSERT INTO `lang_definitions` VALUES (20656, 2470, 15, 'Πηγές παραπομπής ');
INSERT INTO `lang_definitions` VALUES (20657, 2471, 15, 'Παραπομπή σε ');
INSERT INTO `lang_definitions` VALUES (20658, 2472, 15, 'Παραπομπές');
INSERT INTO `lang_definitions` VALUES (20659, 2473, 15, 'Αναφορά παραπομπών');
INSERT INTO `lang_definitions` VALUES (20660, 2474, 15, 'Παραπομπή από');
INSERT INTO `lang_definitions` VALUES (20661, 2475, 15, 'Παραπομπή από');
INSERT INTO `lang_definitions` VALUES (20662, 2476, 15, 'Παραπομπή σε');
INSERT INTO `lang_definitions` VALUES (20663, 2477, 15, 'Παραπέμπων');
INSERT INTO `lang_definitions` VALUES (20664, 2478, 15, 'Διάγνωση παραπομπής');
INSERT INTO `lang_definitions` VALUES (20665, 2479, 15, 'Διάγνωση παραπομπής');
INSERT INTO `lang_definitions` VALUES (20666, 2480, 15, 'Παραπέμπων ιατρός και ιατρείο');
INSERT INTO `lang_definitions` VALUES (20667, 2481, 15, 'Πάροχος παραπομπής');
INSERT INTO `lang_definitions` VALUES (20668, 2482, 15, 'Ανταλλακτικά ');
INSERT INTO `lang_definitions` VALUES (20669, 2483, 15, 'ανταλλακτικά ');
INSERT INTO `lang_definitions` VALUES (20670, 2484, 15, 'Αντανακλαστικά φυσιολογικά');
INSERT INTO `lang_definitions` VALUES (20671, 2485, 15, 'Ανανέωση ');
INSERT INTO `lang_definitions` VALUES (20672, 2487, 15, 'μητρώο ');
INSERT INTO `lang_definitions` VALUES (20673, 2488, 15, 'Εγγράφηκε');
INSERT INTO `lang_definitions` VALUES (20674, 2489, 15, 'εγγράφηκε');
INSERT INTO `lang_definitions` VALUES (20675, 2490, 15, 'Ημ/νια Εγγραφής');
INSERT INTO `lang_definitions` VALUES (20676, 2491, 15, 'Έντυπο Εγγραφής');
INSERT INTO `lang_definitions` VALUES (20677, 2492, 15, 'Αποκατάσταση ');
INSERT INTO `lang_definitions` VALUES (20678, 2493, 15, 'Αφορά σε');
INSERT INTO `lang_definitions` VALUES (20679, 2494, 15, 'Σχετικό');
INSERT INTO `lang_definitions` VALUES (20680, 2495, 15, 'Σχέση/εις / Παιδιά');
INSERT INTO `lang_definitions` VALUES (20681, 2496, 15, 'Σχέση');
INSERT INTO `lang_definitions` VALUES (20682, 2497, 15, 'Συγγενείς ');
INSERT INTO `lang_definitions` VALUES (20683, 2498, 15, 'Οι πιστοποιήσεις υγείας λείπουν από το λογαριασμό αυτό του χρήστη. ');
INSERT INTO `lang_definitions` VALUES (20684, 2499, 15, 'Αναγνωριστικό πιστοποιήσεων υγείας ');
INSERT INTO `lang_definitions` VALUES (20685, 2500, 15, 'Θρησκεία ');
INSERT INTO `lang_definitions` VALUES (20686, 2501, 15, 'Επανασύνδεση');
INSERT INTO `lang_definitions` VALUES (20687, 2502, 15, 'Αφαίρεση');
INSERT INTO `lang_definitions` VALUES (20688, 2503, 15, 'Κατάργηση ομάδας ');
INSERT INTO `lang_definitions` VALUES (20689, 2504, 15, 'Κατάργηση εντύπου ομάδας ');
INSERT INTO `lang_definitions` VALUES (20690, 2505, 15, 'Νεφρικοί λίθοι');
INSERT INTO `lang_definitions` VALUES (20691, 2506, 15, 'Μετονομασία ομάδας ');
INSERT INTO `lang_definitions` VALUES (20692, 2510, 15, 'Επαναταξινόμηση σε');
INSERT INTO `lang_definitions` VALUES (20693, 2511, 15, 'Πληροφορίες επανάληψης:');
INSERT INTO `lang_definitions` VALUES (20694, 2512, 15, 'Επαναλήψεις');
INSERT INTO `lang_definitions` VALUES (20695, 2513, 15, 'Ημερομηνία απάντησης');
INSERT INTO `lang_definitions` VALUES (20696, 2514, 15, 'Απάντηση από');
INSERT INTO `lang_definitions` VALUES (20697, 2515, 15, 'Αναφορά');
INSERT INTO `lang_definitions` VALUES (20698, 2516, 15, 'Αναφορά από');
INSERT INTO `lang_definitions` VALUES (20699, 2517, 15, 'Αναφορά συνόλων');
INSERT INTO `lang_definitions` VALUES (20700, 2518, 15, 'ΑΝΑΦΟΡΕΣ');
INSERT INTO `lang_definitions` VALUES (20701, 2519, 15, 'Η αίτηση αγνοήθηκε – η επεξεργασία απαιτήσεων εκτελείται ήδη! ');
INSERT INTO `lang_definitions` VALUES (20702, 2520, 15, 'Αιτηθείσα υπηρεσία ');
INSERT INTO `lang_definitions` VALUES (20703, 2521, 15, 'Απαιτείται ');
INSERT INTO `lang_definitions` VALUES (20704, 2522, 15, 'ΚΡΑΤΗΜΕΝΟ');
INSERT INTO `lang_definitions` VALUES (20705, 2523, 15, 'Κρατημένο');
INSERT INTO `lang_definitions` VALUES (20706, 2524, 15, 'Κρατημένο για χρήση ορισμού η ώρα των προγραμματισμένων διακοπών ');
INSERT INTO `lang_definitions` VALUES (20707, 2525, 15, 'Κρατημένο για να οριστεί αν ο πάροχος έχει διαθέσιμα ραντεβού μετά. ');
INSERT INTO `lang_definitions` VALUES (20708, 2526, 15, 'Κρατημένο για να οριστεί αν ένα σύμβαμα δεν συνέβηκε όπως προσδιορίστηκε.');
INSERT INTO `lang_definitions` VALUES (20709, 2527, 15, 'Κρατημένο για να οριστεί αν ο πάροχος έχει διαθέσιμα ραντεβού μετά. ');
INSERT INTO `lang_definitions` VALUES (20710, 2528, 15, 'Επιλυμένο');
INSERT INTO `lang_definitions` VALUES (20711, 2529, 15, 'Αναπνοή');
INSERT INTO `lang_definitions` VALUES (20712, 2530, 15, 'Αναπνευστικές κινήσεις χωρίς προσπάθεια');
INSERT INTO `lang_definitions` VALUES (20713, 2531, 15, 'Αναπνευστικό');
INSERT INTO `lang_definitions` VALUES (20714, 2532, 15, 'Περιορισμένη κατάρτιση ');
INSERT INTO `lang_definitions` VALUES (20715, 2533, 15, 'Αποτέλεσμα ');
INSERT INTO `lang_definitions` VALUES (20716, 2534, 15, 'Βρέθηκαν αποτελέσματα για την αναζήτηση ');
INSERT INTO `lang_definitions` VALUES (20717, 2535, 15, 'Εξέταση αμφιβληστροειδούς');
INSERT INTO `lang_definitions` VALUES (20718, 2536, 15, 'Παρεκκλιμενο δεξιά:');
INSERT INTO `lang_definitions` VALUES (20719, 2537, 15, 'Επιστροφή ');
INSERT INTO `lang_definitions` VALUES (20720, 2538, 15, 'Επιστροφή στο ημερολόγιο');
INSERT INTO `lang_definitions` VALUES (20721, 2539, 15, 'Τιμή επιστροφής');
INSERT INTO `lang_definitions` VALUES (20722, 2540, 15, 'Επίσκεψη επιστροφής');
INSERT INTO `lang_definitions` VALUES (20723, 2542, 15, 'Ανασκόπηση παλαιού ιστορικού:');
INSERT INTO `lang_definitions` VALUES (20724, 2543, 15, 'Ανασκόπηση συστημάτων ');
INSERT INTO `lang_definitions` VALUES (20725, 2544, 15, 'Ανασκόπηση ελέγχων συστημάτων');
INSERT INTO `lang_definitions` VALUES (20726, 2545, 15, 'Αναθεώρηση ');
INSERT INTO `lang_definitions` VALUES (20727, 2546, 15, 'Ρευματοειδής αρθρίτιδα');
INSERT INTO `lang_definitions` VALUES (20728, 2547, 15, 'Δεξιά ');
INSERT INTO `lang_definitions` VALUES (20729, 2548, 15, 'Δεξί αυτί');
INSERT INTO `lang_definitions` VALUES (20730, 2549, 15, 'δεξί αυτί');
INSERT INTO `lang_definitions` VALUES (20731, 2550, 15, 'Δεξιά:');
INSERT INTO `lang_definitions` VALUES (20732, 2551, 15, 'Εμβοες στα αυτιά');
INSERT INTO `lang_definitions` VALUES (20733, 2552, 15, 'Εμβοες στα αυτιά');
INSERT INTO `lang_definitions` VALUES (20734, 2553, 15, 'Παράγοντες κινδύνου ');
INSERT INTO `lang_definitions` VALUES (20735, 2554, 15, 'Επίπεδο κινδύνου ');
INSERT INTO `lang_definitions` VALUES (20736, 2555, 15, 'Δεξιός κάτω λοβός:');
INSERT INTO `lang_definitions` VALUES (20737, 2556, 15, 'Κίνδυνος θνητότητας');
INSERT INTO `lang_definitions` VALUES (20738, 2557, 15, 'Μητρώο ');
INSERT INTO `lang_definitions` VALUES (20739, 2558, 15, 'Διαδρομή ');
INSERT INTO `lang_definitions` VALUES (20740, 2559, 15, 'Σειρές ');
INSERT INTO `lang_definitions` VALUES (20741, 2560, 15, 'Σχετικός κίνδυνος χωρίς Ιατρική αναφορά ');
INSERT INTO `lang_definitions` VALUES (20742, 2561, 15, 'Τρίψτε: ');
INSERT INTO `lang_definitions` VALUES (20743, 2563, 15, 'Τρέχουσα εντολή:');
INSERT INTO `lang_definitions` VALUES (20744, 2564, 15, 'Ρήξη ');
INSERT INTO `lang_definitions` VALUES (20745, 2565, 15, 'Ρωσικά ');
INSERT INTO `lang_definitions` VALUES (20746, 2566, 15, 'Φάρμακα');
INSERT INTO `lang_definitions` VALUES (20747, 2567, 15, 'Φάρμακα');
INSERT INTO `lang_definitions` VALUES (20748, 2569, 15, 'ΑΜΚΑ');
INSERT INTO `lang_definitions` VALUES (20749, 2570, 15, 'Τόνος S3');
INSERT INTO `lang_definitions` VALUES (20750, 2571, 15, 'Τόνος S3');
INSERT INTO `lang_definitions` VALUES (20751, 2572, 15, 'ΠΑΡΑΠΟΜΠΗ * * Για να διαβάσεται την άδεια χρήσης φορτώστε το αρχείο docs/license.txt ή επισκεφθείτε την ιστοσελίδα * http://www.gnu.org/copyleft/gpl.html * */ //========================================================================= // ');
INSERT INTO `lang_definitions` VALUES (20752, 2573, 15, 'Πωλήσεις ');
INSERT INTO `lang_definitions` VALUES (20753, 2574, 15, 'Πωλήσεις ανά Τεμάχιο ');
INSERT INTO `lang_definitions` VALUES (20754, 2575, 15, 'Πωλήσεις ανά Αναφορά Προϊόντος');
INSERT INTO `lang_definitions` VALUES (20755, 2576, 15, 'Ίδια Ημέρα ');
INSERT INTO `lang_definitions` VALUES (20756, 2577, 15, 'Δείγμα ');
INSERT INTO `lang_definitions` VALUES (20757, 2578, 15, 'Τύπος έγκρισης');
INSERT INTO `lang_definitions` VALUES (20758, 2579, 15, 'Σάβ');
INSERT INTO `lang_definitions` VALUES (20759, 2580, 15, 'Σάβ & Κυρ ');
INSERT INTO `lang_definitions` VALUES (20760, 2581, 15, 'Σάββατο');
INSERT INTO `lang_definitions` VALUES (20761, 2582, 15, 'Αποθήκευση');
INSERT INTO `lang_definitions` VALUES (20762, 2583, 15, 'Αποθήκευση και Διανομή');
INSERT INTO `lang_definitions` VALUES (20763, 2584, 15, 'Αποθήκευση ως νέο');
INSERT INTO `lang_definitions` VALUES (20764, 2585, 15, 'Αποθήκευση Αλλαγών');
INSERT INTO `lang_definitions` VALUES (20765, 2586, 15, 'Αποθήκευση Εντύπου');
INSERT INTO `lang_definitions` VALUES (20766, 2587, 15, 'Αποθήκευση Ανοσοποίησης');
INSERT INTO `lang_definitions` VALUES (20767, 2588, 15, 'Αποθήκευση Νέου Πεδίου');
INSERT INTO `lang_definitions` VALUES (20768, 2589, 15, 'Αποθήκευση Νέας Ομάδας ');
INSERT INTO `lang_definitions` VALUES (20769, 2590, 15, 'Αποθήκευση Νέου Καταλόγου');
INSERT INTO `lang_definitions` VALUES (20770, 2591, 15, 'Αποθήκευση Νέας χωροθέτησης');
INSERT INTO `lang_definitions` VALUES (20771, 2592, 15, 'Αποθήκευση Δημογραφικών στοιχείων ασθενούς');
INSERT INTO `lang_definitions` VALUES (20772, 2593, 15, 'Επιτυχής αποθήκευση για το αναγνωριστικό γραφήματος');
INSERT INTO `lang_definitions` VALUES (20773, 2594, 15, 'Αποθήκευση Συναλλαγής');
INSERT INTO `lang_definitions` VALUES (20774, 2595, 15, 'Σαρωμένο');
INSERT INTO `lang_definitions` VALUES (20775, 2596, 15, 'Σαρωμένη σημείωση επίσκεψης');
INSERT INTO `lang_definitions` VALUES (20776, 2597, 15, 'Σαρωτής σε');
INSERT INTO `lang_definitions` VALUES (20777, 2598, 15, 'Πρόγραμμα');
INSERT INTO `lang_definitions` VALUES (20778, 2599, 15, 'Πρόγραμμα Έδρας:');
INSERT INTO `lang_definitions` VALUES (20779, 2600, 15, 'ΣΗΜΕΙΩΣΗ ΣΧΟΛΕΙΟΥ');
INSERT INTO `lang_definitions` VALUES (20780, 2601, 15, 'Σκολίωση ');
INSERT INTO `lang_definitions` VALUES (20781, 2602, 15, 'Εργοδότης');
INSERT INTO `lang_definitions` VALUES (20782, 2603, 15, 'Διεύθυνση Εργοδότη');
INSERT INTO `lang_definitions` VALUES (20783, 2604, 15, 'Πόλη Εργοδότη');
INSERT INTO `lang_definitions` VALUES (20784, 2605, 15, 'Χώρα Εργοδότη');
INSERT INTO `lang_definitions` VALUES (20785, 2606, 15, 'Περιοχή Εργοδότη');
INSERT INTO `lang_definitions` VALUES (20786, 2607, 15, 'Τ.Κ. Εργοδότη');
INSERT INTO `lang_definitions` VALUES (20787, 2608, 15, 'Νομός Εργοδότη');
INSERT INTO `lang_definitions` VALUES (20788, 2609, 15, 'Τ.Κ. Εργοδότη');
INSERT INTO `lang_definitions` VALUES (20789, 2610, 15, 'Αναζήτηση');
INSERT INTO `lang_definitions` VALUES (20790, 2611, 15, 'αναζήτηση');
INSERT INTO `lang_definitions` VALUES (20791, 2612, 15, 'αναζήτησε πάλι');
INSERT INTO `lang_definitions` VALUES (20792, 2613, 15, 'Αναζήτηση με βάση:');
INSERT INTO `lang_definitions` VALUES (20793, 2614, 15, 'Αναζήτηση για:');
INSERT INTO `lang_definitions` VALUES (20794, 2615, 15, 'Εύρεση ή προσθήκη Ασθενή');
INSERT INTO `lang_definitions` VALUES (20795, 2616, 15, 'Αποτελέσματα Αναζήτησης');
INSERT INTO `lang_definitions` VALUES (20796, 2618, 15, 'Αναζήτηση στα Γεγονότα');
INSERT INTO `lang_definitions` VALUES (20797, 2619, 15, 'Αναζήτηση/Προσθήκη Ασφαλιστή');
INSERT INTO `lang_definitions` VALUES (20798, 2620, 15, 'Αναζήτηση για ραντεβού');
INSERT INTO `lang_definitions` VALUES (20799, 2621, 15, 'Αναζήτηση...');
INSERT INTO `lang_definitions` VALUES (20800, 2622, 15, 'Χρήση ζώνης ασφαλείας ');
INSERT INTO `lang_definitions` VALUES (20801, 2623, 15, 'Χρήση Ζώνης Ασφαλείας');
INSERT INTO `lang_definitions` VALUES (20802, 2624, 15, 'Δεύτερο');
INSERT INTO `lang_definitions` VALUES (20803, 2625, 15, 'Δευτερεύουσα');
INSERT INTO `lang_definitions` VALUES (20804, 2626, 15, 'Δευτερέυουσα Ασφάλιση');
INSERT INTO `lang_definitions` VALUES (20805, 2627, 15, 'Δεδομένα Δευτερεύουσας Ασφάλισης');
INSERT INTO `lang_definitions` VALUES (20806, 2628, 15, 'Πάροχος Δευτερεύουσας Ασφάλισης');
INSERT INTO `lang_definitions` VALUES (20807, 2629, 15, 'Προβολή Όλων');
INSERT INTO `lang_definitions` VALUES (20808, 2630, 15, 'Δείτε τις εξουσιοδοτήσεις');
INSERT INTO `lang_definitions` VALUES (20809, 2631, 15, 'Δείτε τα διαγράμματα ανάπτυξης');
INSERT INTO `lang_definitions` VALUES (20810, 2632, 15, 'Δείτε τα μυνήματα από το τελευταίο σύνολο των δημιουργημένων απαιτήσεων');
INSERT INTO `lang_definitions` VALUES (20811, 2633, 15, 'Προβολή από');
INSERT INTO `lang_definitions` VALUES (20812, 2634, 15, 'Επιληπτικές κρίσεις');
INSERT INTO `lang_definitions` VALUES (20813, 2635, 15, 'Επιλ');
INSERT INTO `lang_definitions` VALUES (20814, 2636, 15, 'Επιλογή');
INSERT INTO `lang_definitions` VALUES (20815, 2637, 15, 'Επιλογή Όλων');
INSERT INTO `lang_definitions` VALUES (20816, 2639, 15, 'Επιλογή Πεδίου');
INSERT INTO `lang_definitions` VALUES (20817, 2640, 15, 'Επιλογή Πεδίων');
INSERT INTO `lang_definitions` VALUES (20818, 2641, 15, 'Επιλογή για εκτύπωση');
INSERT INTO `lang_definitions` VALUES (20819, 2642, 15, 'Επιλογή διάγνωσης');
INSERT INTO `lang_definitions` VALUES (20820, 2643, 15, 'Επιλέξτε τα στοιχεία ρύθμισης για εξαγωγή');
INSERT INTO `lang_definitions` VALUES (20821, 2644, 15, 'Επιλέξτε Ναι για να επιβεβαιώσετε τη διαγραφή της ομάδας ');
INSERT INTO `lang_definitions` VALUES (20822, 2645, 15, 'Εαυτός');
INSERT INTO `lang_definitions` VALUES (20823, 2646, 15, 'Αυτο-πληρωμή');
INSERT INTO `lang_definitions` VALUES (20824, 2647, 15, 'Αποστολή σε εξέλιξη');
INSERT INTO `lang_definitions` VALUES (20825, 2649, 15, 'Αποστολέας ');
INSERT INTO `lang_definitions` VALUES (20826, 2650, 15, 'Αναγνωριστικό Αποστολέα');
INSERT INTO `lang_definitions` VALUES (20827, 2653, 15, 'Ευαισθησίες ');
INSERT INTO `lang_definitions` VALUES (20828, 2654, 15, 'Ευαισθησία: ');
INSERT INTO `lang_definitions` VALUES (20829, 2655, 15, 'Αισθητική εξέταση φυσιολογική');
INSERT INTO `lang_definitions` VALUES (20830, 2656, 15, 'Απεστάλη επιτυχώς');
INSERT INTO `lang_definitions` VALUES (20831, 2657, 15, 'απεστάλη στον εκτυπωτή');
INSERT INTO `lang_definitions` VALUES (20832, 2658, 15, 'Χωρισμένος/η');
INSERT INTO `lang_definitions` VALUES (20833, 2659, 15, 'Σεπτέμβριος');
INSERT INTO `lang_definitions` VALUES (20834, 2660, 15, 'Κατηγορία υπηρεσιών ');
INSERT INTO `lang_definitions` VALUES (20835, 2661, 15, 'Ημερομηνία Υπηρεσίας');
INSERT INTO `lang_definitions` VALUES (20836, 2662, 15, 'Ημερομηνία υπηρεσίας:');
INSERT INTO `lang_definitions` VALUES (20837, 2663, 15, 'Τοποθεσία υπηρεσίας');
INSERT INTO `lang_definitions` VALUES (20838, 2664, 15, 'Παρεχόμενη υπηρεσία από ειδικό');
INSERT INTO `lang_definitions` VALUES (20839, 2665, 15, 'Υπηρεσίες');
INSERT INTO `lang_definitions` VALUES (20840, 2666, 15, 'Υπηρεσίες ανά Κατηγορία');
INSERT INTO `lang_definitions` VALUES (20841, 2667, 15, 'Παρεχόμενες υπηρεσίες');
INSERT INTO `lang_definitions` VALUES (20842, 2668, 15, 'Παρεχόμενες υπηρεσίες');
INSERT INTO `lang_definitions` VALUES (20843, 2669, 15, 'Ρυθμίσεις');
INSERT INTO `lang_definitions` VALUES (20844, 2670, 15, 'Ημικρανία');
INSERT INTO `lang_definitions` VALUES (20845, 2671, 15, 'Βαρύτητα πόνου');
INSERT INTO `lang_definitions` VALUES (20846, 2672, 15, 'Βαρύτητα πόνου:');
INSERT INTO `lang_definitions` VALUES (20847, 2673, 15, 'Φύλο ');
INSERT INTO `lang_definitions` VALUES (20848, 2674, 15, 'Σεξουαλικά μεταδιδόμενο νόσημα');
INSERT INTO `lang_definitions` VALUES (20849, 2675, 15, 'Διαμοιρασμός');
INSERT INTO `lang_definitions` VALUES (20850, 2676, 15, 'Δύσπνοια ');
INSERT INTO `lang_definitions` VALUES (20851, 2677, 15, 'Δύσπνοια ');
INSERT INTO `lang_definitions` VALUES (20852, 2678, 15, 'Δύσπνοια 2');
INSERT INTO `lang_definitions` VALUES (20853, 2681, 15, 'θα πρέπει να είναι ως nnnnn-nnnn-nn ');
INSERT INTO `lang_definitions` VALUES (20854, 2682, 15, 'Ώμος ');
INSERT INTO `lang_definitions` VALUES (20855, 2683, 15, 'Ώμος + κλείδα');
INSERT INTO `lang_definitions` VALUES (20856, 2684, 15, 'Προβλήματα ώμου ');
INSERT INTO `lang_definitions` VALUES (20857, 2685, 15, 'Προβολή');
INSERT INTO `lang_definitions` VALUES (20858, 2686, 15, 'Προβολή ως απασχολημένο');
INSERT INTO `lang_definitions` VALUES (20859, 2687, 15, 'Προβολή μόνο των εξουσιοδοτημένων');
INSERT INTO `lang_definitions` VALUES (20860, 2688, 15, 'Προβολή Λεπτομερειών');
INSERT INTO `lang_definitions` VALUES (20861, 2689, 15, 'Να προβάλλεται βοηθητικό κείμενο κατά την κατάδειξη με το ποντίκι;');
INSERT INTO `lang_definitions` VALUES (20862, 2690, 15, 'Πόσα γεγονότα θέλετε να προβάλλονται στις σελίδες διαχείρισης;');
INSERT INTO `lang_definitions` VALUES (20863, 2692, 15, 'Προβολή Αναφοράς');
INSERT INTO `lang_definitions` VALUES (20864, 2693, 15, 'Προβολή δεσμών αναζήτησης/αποστολή σε μπλοκ;');
INSERT INTO `lang_definitions` VALUES (20865, 2694, 15, 'Προβολή μόνο μη χρεωμένων');
INSERT INTO `lang_definitions` VALUES (20866, 2695, 15, 'Αδέλφια ');
INSERT INTO `lang_definitions` VALUES (20867, 2696, 15, 'Δρεπανοκύτταρο');
INSERT INTO `lang_definitions` VALUES (20868, 2697, 15, 'Δόση');
INSERT INTO `lang_definitions` VALUES (20869, 2698, 15, 'Σιγμοειδο-/Κολονοσκόπηση');
INSERT INTO `lang_definitions` VALUES (20870, 2699, 15, 'Υπογραφή ');
INSERT INTO `lang_definitions` VALUES (20871, 2700, 15, 'Υπογραφή: ');
INSERT INTO `lang_definitions` VALUES (20872, 2702, 15, 'Έντονη διόγκωση:');
INSERT INTO `lang_definitions` VALUES (20873, 2703, 15, 'Εδώ και');
INSERT INTO `lang_definitions` VALUES (20874, 2705, 15, 'Εργένης');
INSERT INTO `lang_definitions` VALUES (20875, 2706, 15, 'Προβλήματα κόλπου');
INSERT INTO `lang_definitions` VALUES (20876, 2707, 15, 'Εγχείρηση κόλπου ');
INSERT INTO `lang_definitions` VALUES (20877, 2708, 15, 'Ευαισθησία κόλπου:');
INSERT INTO `lang_definitions` VALUES (20878, 2709, 15, 'Παραρρινοκολπίτιδα');
INSERT INTO `lang_definitions` VALUES (20879, 2710, 15, 'Μέγεθος ');
INSERT INTO `lang_definitions` VALUES (20880, 2711, 15, 'Το μέγεθος πρέπει να είναι αριθμός μεταξύ 1 και 999 ');
INSERT INTO `lang_definitions` VALUES (20881, 2712, 15, 'Μέγεθος/Κατάλογος ');
INSERT INTO `lang_definitions` VALUES (20882, 2713, 15, 'Δέρμα ');
INSERT INTO `lang_definitions` VALUES (20883, 2714, 15, 'Καρκίνος δέρματος');
INSERT INTO `lang_definitions` VALUES (20884, 2715, 15, 'Νόσος δέρματος');
INSERT INTO `lang_definitions` VALUES (20885, 2716, 15, 'Δέρμα – άλλο');
INSERT INTO `lang_definitions` VALUES (20886, 2718, 15, 'Τύπος ύπνου');
INSERT INTO `lang_definitions` VALUES (20887, 2719, 15, 'Τύπος ύπνου');
INSERT INTO `lang_definitions` VALUES (20888, 2720, 15, 'Κοιμώμενο');
INSERT INTO `lang_definitions` VALUES (20889, 2721, 15, 'Σλοβακικά ');
INSERT INTO `lang_definitions` VALUES (20890, 2723, 15, 'Η Smarty κρυφή μνήμη έχει καθαριστεί');
INSERT INTO `lang_definitions` VALUES (20891, 2724, 15, 'SMS Gateway');
INSERT INTO `lang_definitions` VALUES (20892, 2725, 15, 'SMS Gateway API key');
INSERT INTO `lang_definitions` VALUES (20893, 2726, 15, 'Ειδοποίηση μέσω SMS ');
INSERT INTO `lang_definitions` VALUES (20894, 2727, 15, 'Το SMS εστάλει προηγουμένως');
INSERT INTO `lang_definitions` VALUES (20895, 2729, 15, 'SMS Gateway API key');
INSERT INTO `lang_definitions` VALUES (20896, 2730, 15, 'Ροχαλητο');
INSERT INTO `lang_definitions` VALUES (20897, 2731, 15, 'ΕΚΤΙΜΗΣΗ Ασθενούς');
INSERT INTO `lang_definitions` VALUES (20898, 2732, 15, 'Κοινωνικές δυσκολίες');
INSERT INTO `lang_definitions` VALUES (20899, 2733, 15, 'Κοινωνικό Ιστορικό:');
INSERT INTO `lang_definitions` VALUES (20900, 2734, 15, 'Αριθμός Μητρώου Κοινωνικής Ασφάλισης');
INSERT INTO `lang_definitions` VALUES (20901, 2735, 15, 'διάλυμα (sol)');
INSERT INTO `lang_definitions` VALUES (20902, 2736, 15, 'Σωματικο περιγραμμα');
INSERT INTO `lang_definitions` VALUES (20903, 2737, 15, 'Ορισμένες άδειες δεν εμφανίζονται. Κάντε κλικ εδώ για να τις δείτε όλες');
INSERT INTO `lang_definitions` VALUES (20904, 2738, 15, 'Ορισμένοι κωδικοί δεν εμφανίστηκαν');
INSERT INTO `lang_definitions` VALUES (20905, 2739, 15, 'Ορισμένες επισκέψεις δεν εμφανίστηκαν. Κάντε κλικ εδώ για να τις δείτε όλες.');
INSERT INTO `lang_definitions` VALUES (20906, 2740, 15, 'Ορισμένες σημειώσεις δεν εμφανίστηκαν');
INSERT INTO `lang_definitions` VALUES (20907, 2741, 15, 'ορισμένες λέξεις');
INSERT INTO `lang_definitions` VALUES (20908, 2742, 15, 'Φαρυγγαλγια');
INSERT INTO `lang_definitions` VALUES (20909, 2743, 15, 'Ταξινόμηση ανα');
INSERT INTO `lang_definitions` VALUES (20910, 2744, 15, 'Ταξινόμηση ανα Σχολια');
INSERT INTO `lang_definitions` VALUES (20911, 2745, 15, 'Ταξινόμηση ανα ημερομηνια');
INSERT INTO `lang_definitions` VALUES (20912, 2746, 15, 'Ταξινόμηση ανα ημερομηνια/ωρα');
INSERT INTO `lang_definitions` VALUES (20913, 2747, 15, 'Ταξινόμηση ανα Συμβαμα');
INSERT INTO `lang_definitions` VALUES (20914, 2748, 15, 'Ταξινόμηση ανα Ομαδα');
INSERT INTO `lang_definitions` VALUES (20915, 2749, 15, 'Ταξινόμηση ανα Χρηστη');
INSERT INTO `lang_definitions` VALUES (20916, 2750, 15, 'Ταξινόμηση ανα εμβολιο');
INSERT INTO `lang_definitions` VALUES (20917, 2751, 15, 'Πηγή ');
INSERT INTO `lang_definitions` VALUES (20918, 2752, 15, 'Η πηγή λείπει για τον κωδικό');
INSERT INTO `lang_definitions` VALUES (20919, 2753, 15, 'Πηγή: ');
INSERT INTO `lang_definitions` VALUES (20920, 2754, 15, 'Ισπανικά');
INSERT INTO `lang_definitions` VALUES (20921, 2755, 15, 'Ονομα και υπογραφη ειδικου');
INSERT INTO `lang_definitions` VALUES (20922, 2756, 15, 'Ειδικότητα ');
INSERT INTO `lang_definitions` VALUES (20923, 2757, 15, 'Συστήματα ειδικού');
INSERT INTO `lang_definitions` VALUES (20924, 2758, 15, 'Ειδικότητα: ');
INSERT INTO `lang_definitions` VALUES (20925, 2759, 15, 'Ειδικό');
INSERT INTO `lang_definitions` VALUES (20926, 2760, 15, 'Ειδική Υπηρεσία ');
INSERT INTO `lang_definitions` VALUES (20927, 2761, 15, 'Υπαγόρευση ομιλίας');
INSERT INTO `lang_definitions` VALUES (20928, 2762, 15, 'Σπερματοκτόνο');
INSERT INTO `lang_definitions` VALUES (20929, 2763, 15, 'Σπληνεκτομή');
INSERT INTO `lang_definitions` VALUES (20930, 2764, 15, 'Σύζυγος ');
INSERT INTO `lang_definitions` VALUES (20931, 2765, 15, 'Πτύελα');
INSERT INTO `lang_definitions` VALUES (20932, 2766, 15, 'Πτύελα: ');
INSERT INTO `lang_definitions` VALUES (20933, 2767, 15, 'Υποδόρια');
INSERT INTO `lang_definitions` VALUES (20934, 2768, 15, 'Ομάδα ');
INSERT INTO `lang_definitions` VALUES (20935, 2769, 15, 'Μέλος ομάδας');
INSERT INTO `lang_definitions` VALUES (20936, 2770, 15, 'Ομάδες ');
INSERT INTO `lang_definitions` VALUES (20937, 2771, 15, 'Σεξουαλική και αναπαραγωγική υγεία');
INSERT INTO `lang_definitions` VALUES (20938, 2772, 15, 'Σεξουαλική και αναπαραγωγική υγεία – Οικογενειακός προγραμματισμός');
INSERT INTO `lang_definitions` VALUES (20939, 2773, 15, 'Σεξουαλική και αναπαραγωγική υγεία – Μη οικογενειακός προγραμματισμός');
INSERT INTO `lang_definitions` VALUES (20940, 2774, 15, 'Παραπομπές σεξουαλικής και αναπαραγωγικής υγείας');
INSERT INTO `lang_definitions` VALUES (20941, 2775, 15, 'Έντυπο επίσκεψης σεξουαλικής και αναπαραγωγικής υγείας');
INSERT INTO `lang_definitions` VALUES (20942, 2776, 15, 'ΑΜΚΑ');
INSERT INTO `lang_definitions` VALUES (20943, 2777, 15, 'ΑΜΚΑ');
INSERT INTO `lang_definitions` VALUES (20944, 2778, 15, 'Σταθερότητα ');
INSERT INTO `lang_definitions` VALUES (20945, 2779, 15, 'Πρότυπο ');
INSERT INTO `lang_definitions` VALUES (20946, 2780, 15, 'Έναρξη');
INSERT INTO `lang_definitions` VALUES (20947, 2781, 15, 'Έναρξη (εεεε-μμ-ηη)');
INSERT INTO `lang_definitions` VALUES (20948, 2782, 15, 'Ημερομηνία έναρξης ');
INSERT INTO `lang_definitions` VALUES (20949, 2783, 15, 'Ημερομηνία έναρξης στην παρούσα Κλινική ');
INSERT INTO `lang_definitions` VALUES (20950, 2784, 15, 'Ημερομηνία έναρξης:');
INSERT INTO `lang_definitions` VALUES (20951, 2785, 15, 'Ημερομηνία έναρξης:');
INSERT INTO `lang_definitions` VALUES (20952, 2786, 15, 'Ώρα έναρξης ');
INSERT INTO `lang_definitions` VALUES (20953, 2787, 15, 'Ημερομηνία Έναρξης ');
INSERT INTO `lang_definitions` VALUES (20954, 2788, 15, 'εφάπαξ');
INSERT INTO `lang_definitions` VALUES (20955, 2789, 15, 'Νομός');
INSERT INTO `lang_definitions` VALUES (20956, 2790, 15, 'Λίστα Κατάστασης (εγγραφή, προαιρετικά προσθήκη)');
INSERT INTO `lang_definitions` VALUES (20957, 2791, 15, 'Νομός/Περιοχή ');
INSERT INTO `lang_definitions` VALUES (20958, 2792, 15, 'Νομός/Κοινότητα');
INSERT INTO `lang_definitions` VALUES (20959, 2793, 15, 'Στατιστικά ');
INSERT INTO `lang_definitions` VALUES (20960, 2794, 15, 'Στατιστικά ');
INSERT INTO `lang_definitions` VALUES (20961, 2795, 15, 'Κατάσταση ');
INSERT INTO `lang_definitions` VALUES (20962, 2796, 15, 'Ιδία κατάσταση ');
INSERT INTO `lang_definitions` VALUES (20963, 2797, 15, 'Συμβουλευτική ΣΜΝ/AIDS');
INSERT INTO `lang_definitions` VALUES (20964, 2799, 15, 'Δυσκαμψία αρθρώσεων');
INSERT INTO `lang_definitions` VALUES (20965, 2800, 15, 'Δυσκαμψία');
INSERT INTO `lang_definitions` VALUES (20966, 2801, 15, 'Άλγη στομάχου');
INSERT INTO `lang_definitions` VALUES (20967, 2802, 15, 'Διάταση μυός');
INSERT INTO `lang_definitions` VALUES (20968, 2804, 15, 'Οδός ');
INSERT INTO `lang_definitions` VALUES (20969, 2806, 15, 'Οδός και Αριθμός ');
INSERT INTO `lang_definitions` VALUES (20970, 2807, 15, 'Δύναμη ');
INSERT INTO `lang_definitions` VALUES (20971, 2808, 15, 'Φάρυγγας Στρεπ ');
INSERT INTO `lang_definitions` VALUES (20972, 2809, 15, 'Κάταγμα κόπωσης');
INSERT INTO `lang_definitions` VALUES (20973, 2810, 15, 'Δοκιμασία κόπωσης');
INSERT INTO `lang_definitions` VALUES (20974, 2811, 15, 'Αγγειακό εγκεφαλικό');
INSERT INTO `lang_definitions` VALUES (20975, 2812, 15, 'Υποκατηγορία');
INSERT INTO `lang_definitions` VALUES (20976, 2813, 15, 'Μερικό Σύνολο ');
INSERT INTO `lang_definitions` VALUES (20977, 2814, 15, 'Υποκατηγορία ');
INSERT INTO `lang_definitions` VALUES (20978, 2815, 15, 'υποκατηγορία ');
INSERT INTO `lang_definitions` VALUES (20979, 2816, 15, 'υποδορίως');
INSERT INTO `lang_definitions` VALUES (20980, 2817, 15, 'Ιστορικό');
INSERT INTO `lang_definitions` VALUES (20981, 2818, 15, 'Υπογλώσσιο');
INSERT INTO `lang_definitions` VALUES (20982, 2819, 15, 'υπογλώσσιο');
INSERT INTO `lang_definitions` VALUES (20983, 2820, 15, 'Υποβολή');
INSERT INTO `lang_definitions` VALUES (20984, 2822, 15, 'Υποβολή Συμβάματος');
INSERT INTO `lang_definitions` VALUES (20985, 2823, 15, 'υποβολή εντύπου ');
INSERT INTO `lang_definitions` VALUES (20986, 2826, 15, 'Υποβεβλημένο από');
INSERT INTO `lang_definitions` VALUES (20987, 2828, 15, 'Συνδρομητής ');
INSERT INTO `lang_definitions` VALUES (20988, 2829, 15, 'Διεύθυνση Συνδρομητή');
INSERT INTO `lang_definitions` VALUES (20989, 2830, 15, 'Εργοδότης Συνδρομητή');
INSERT INTO `lang_definitions` VALUES (20990, 2831, 15, 'Εργοδότης Συνδρομητή');
INSERT INTO `lang_definitions` VALUES (20991, 2832, 15, 'Διεύθυνση Εργοδότη Συνδρομητή');
INSERT INTO `lang_definitions` VALUES (20992, 2833, 15, 'Πόλη Εργοδότη Συνδρομητή');
INSERT INTO `lang_definitions` VALUES (20993, 2834, 15, 'Χώρα Εργοδότη Συνδρομητή');
INSERT INTO `lang_definitions` VALUES (20994, 2835, 15, 'Νομός Εργοδότη Συνδρομητή');
INSERT INTO `lang_definitions` VALUES (20995, 2836, 15, 'Τ.Κ. Εργοδότη Συνδρομητή');
INSERT INTO `lang_definitions` VALUES (20996, 2837, 15, 'Τηλέφωνο Εργοδότη Συνδρομητή');
INSERT INTO `lang_definitions` VALUES (20997, 2838, 15, 'Σχέση Εργοδότη Συνδρομητή');
INSERT INTO `lang_definitions` VALUES (20998, 2839, 15, 'Η σχέση του συνδρομητή δεν είναι αφ\' εαυτή αλλά το όνομα είναι το ίδιο! Είναι πραγματικά εντάξει;');
INSERT INTO `lang_definitions` VALUES (20999, 2840, 15, 'Η σχέση του συνδρομητή δεν είναι αφ\' εαυτή αλλά το όνομα είναι το ίδιο!');
INSERT INTO `lang_definitions` VALUES (21000, 2841, 15, 'Η σχέση του συνδρομητή είναι αφ\' εαυτή αλλά το όνομα είναι διαφορετικό! Είναι πραγματικά εντάξει;');
INSERT INTO `lang_definitions` VALUES (21001, 2842, 15, 'Η σχέση του συνδρομητή είναι αφ\' εαυτή αλλά ο αριθμός SS είναι διαφορετικός!');
INSERT INTO `lang_definitions` VALUES (21002, 2843, 15, 'Φύλο Συνδρομητή');
INSERT INTO `lang_definitions` VALUES (21003, 2844, 15, 'Υποκατάσταση ');
INSERT INTO `lang_definitions` VALUES (21004, 2845, 15, 'Επιτρέπεται η υποκατάσταση');
INSERT INTO `lang_definitions` VALUES (21005, 2846, 15, 'επιτυχία');
INSERT INTO `lang_definitions` VALUES (21006, 2847, 15, 'προστέθηκε στην κατηγορία επιτυχώς,');
INSERT INTO `lang_definitions` VALUES (21007, 2848, 15, 'αποθηκεύτηκε επιτυχώς');
INSERT INTO `lang_definitions` VALUES (21008, 2849, 15, 'επιτυχώς');
INSERT INTO `lang_definitions` VALUES (21009, 2850, 15, 'Αυτοκτονία ');
INSERT INTO `lang_definitions` VALUES (21010, 2851, 15, 'Περίληψη ');
INSERT INTO `lang_definitions` VALUES (21011, 2852, 15, 'Ήλιος ');
INSERT INTO `lang_definitions` VALUES (21012, 2853, 15, 'Κυριακή ');
INSERT INTO `lang_definitions` VALUES (21013, 2854, 15, 'Υπερχρέωση');
INSERT INTO `lang_definitions` VALUES (21014, 2855, 15, 'Κώδικες υπερχρέωσης');
INSERT INTO `lang_definitions` VALUES (21015, 2856, 15, 'Διαχείριση κωδίκων υπερχρέωσης');
INSERT INTO `lang_definitions` VALUES (21016, 2857, 15, 'Αναφορά υπερχρέωσης');
INSERT INTO `lang_definitions` VALUES (21017, 2858, 15, 'Οι υπερχρεώσεις, μερικές φορές αναφέρονται ως Εντυπα Επίσκεψης, αποτελούν ουσιαστικό μέρος των περισσότερων ιατρείων.');
INSERT INTO `lang_definitions` VALUES (21018, 2859, 15, 'Υπερχρήστης');
INSERT INTO `lang_definitions` VALUES (21019, 2861, 15, 'Τύπος επιφανείας ');
INSERT INTO `lang_definitions` VALUES (21020, 2862, 15, 'Χειρουργεία');
INSERT INTO `lang_definitions` VALUES (21021, 2863, 15, 'Χειρουργική ');
INSERT INTO `lang_definitions` VALUES (21022, 2864, 15, 'Ανεστάλη ');
INSERT INTO `lang_definitions` VALUES (21023, 2865, 15, 'εναιώρημα (susp)');
INSERT INTO `lang_definitions` VALUES (21024, 2866, 15, 'Ημερομηνία Υπ.');
INSERT INTO `lang_definitions` VALUES (21025, 2867, 15, 'Ημερομηνία Υπ:');
INSERT INTO `lang_definitions` VALUES (21026, 2868, 15, 'Εφίδρωση: ');
INSERT INTO `lang_definitions` VALUES (21027, 2869, 15, 'Σουηδικά ');
INSERT INTO `lang_definitions` VALUES (21028, 2870, 15, 'Διόγκωση');
INSERT INTO `lang_definitions` VALUES (21029, 2871, 15, 'Διόγκωση δεξιά ');
INSERT INTO `lang_definitions` VALUES (21030, 2872, 15, 'Διογκωμένες αρθρώσεις');
INSERT INTO `lang_definitions` VALUES (21031, 2873, 15, 'Διογκωμένοι λεμφαδένες');
INSERT INTO `lang_definitions` VALUES (21032, 2874, 15, 'Συμπτώματα');
INSERT INTO `lang_definitions` VALUES (21033, 2875, 15, 'Συγκοπή');
INSERT INTO `lang_definitions` VALUES (21034, 2877, 15, 'Σύστημα ');
INSERT INTO `lang_definitions` VALUES (21035, 2878, 15, 'Τ');
INSERT INTO `lang_definitions` VALUES (21036, 2879, 15, '3 φορές την ημέρα');
INSERT INTO `lang_definitions` VALUES (21037, 2881, 15, 'Απέτυχε η δημιουργία του πίνακα');
INSERT INTO `lang_definitions` VALUES (21038, 2882, 15, 'Απέτυχε η ενημέρωση του πίνακα');
INSERT INTO `lang_definitions` VALUES (21039, 2883, 15, 'δισκίο (tab) ');
INSERT INTO `lang_definitions` VALUES (21040, 2884, 15, 'Δόση');
INSERT INTO `lang_definitions` VALUES (21041, 2885, 15, 'Απαιτεί χρόνο');
INSERT INTO `lang_definitions` VALUES (21042, 2886, 15, 'Φορολογικός συντελεστής ');
INSERT INTO `lang_definitions` VALUES (21043, 2887, 15, 'Φόροι ');
INSERT INTO `lang_definitions` VALUES (21044, 2888, 15, 'Τοξίνη τετάνου');
INSERT INTO `lang_definitions` VALUES (21045, 2890, 15, 'Περίληψη ομάδας κακώσεων ');
INSERT INTO `lang_definitions` VALUES (21046, 2891, 15, 'Μητρώο Ομάδας');
INSERT INTO `lang_definitions` VALUES (21047, 2892, 15, 'Προβολή Μητρώου Ομάδας');
INSERT INTO `lang_definitions` VALUES (21048, 2893, 15, 'Τηλ');
INSERT INTO `lang_definitions` VALUES (21049, 2895, 15, 'Θέση θερμομέτρησης');
INSERT INTO `lang_definitions` VALUES (21050, 2896, 15, 'Προσωρ Μέθοδος');
INSERT INTO `lang_definitions` VALUES (21051, 2897, 15, 'Θερμοκρασία');
INSERT INTO `lang_definitions` VALUES (21052, 2898, 15, 'Template ');
INSERT INTO `lang_definitions` VALUES (21053, 2899, 15, 'Όνομα Template');
INSERT INTO `lang_definitions` VALUES (21054, 2900, 15, 'Τα ονόματα των Template δεν μπορούν να αρχίσουν με αριθμούς');
INSERT INTO `lang_definitions` VALUES (21055, 2901, 15, 'Template: ');
INSERT INTO `lang_definitions` VALUES (21056, 2902, 15, 'Templates ');
INSERT INTO `lang_definitions` VALUES (21057, 2903, 15, 'Κροταφική αρτ');
INSERT INTO `lang_definitions` VALUES (21058, 2904, 15, 'Κάκωση τένοντα');
INSERT INTO `lang_definitions` VALUES (21059, 2905, 15, 'Τενοντίτιδα/θυλακίτιδα');
INSERT INTO `lang_definitions` VALUES (21060, 2906, 15, 'Τριτεύουσα');
INSERT INTO `lang_definitions` VALUES (21061, 2907, 15, 'Τριτεύουσα Ασφάλιση');
INSERT INTO `lang_definitions` VALUES (21062, 2908, 15, 'Δεδομένα Τριτεύουσας Ασφάλισης');
INSERT INTO `lang_definitions` VALUES (21063, 2909, 15, 'Πάροχος Τριτεύουσας Ασφάλισης');
INSERT INTO `lang_definitions` VALUES (21064, 2910, 15, 'Έλεγχος χρονοδιαγράμματος');
INSERT INTO `lang_definitions` VALUES (21065, 2911, 15, 'Πειραματικό σύστημα ');
INSERT INTO `lang_definitions` VALUES (21066, 2912, 15, 'κείμενο-ημερομηνία ');
INSERT INTO `lang_definitions` VALUES (21067, 2913, 15, 'κείμενο-ημερομηνία ');
INSERT INTO `lang_definitions` VALUES (21068, 2914, 15, 'χώρος κειμένου');
INSERT INTO `lang_definitions` VALUES (21069, 2915, 15, 'χώρος κειμένου');
INSERT INTO `lang_definitions` VALUES (21070, 2916, 15, 'πλαίσιο κειμένου');
INSERT INTO `lang_definitions` VALUES (21071, 2917, 15, 'πλαίσιο κειμένου');
INSERT INTO `lang_definitions` VALUES (21072, 2918, 15, 'λίστα πλαισίων κειμένου');
INSERT INTO `lang_definitions` VALUES (21073, 2919, 15, 'λίστα πλαισίων κειμένου');
INSERT INTO `lang_definitions` VALUES (21074, 2920, 15, 'Σας Ευχαριστώ ');
INSERT INTO `lang_definitions` VALUES (21075, 2921, 15, 'Αρχείο απαιτήσεων:');
INSERT INTO `lang_definitions` VALUES (21076, 2922, 15, 'Το έντυπο προορισμού έκλεισε, δεν μπορώ να ενεργήσω στην επιλογή σας.');
INSERT INTO `lang_definitions` VALUES (21077, 2923, 15, 'Τα συμβάματα έχουν εγκριθεί.');
INSERT INTO `lang_definitions` VALUES (21078, 2924, 15, 'Τα συμβάματα έχουν κρυφτεί.');
INSERT INTO `lang_definitions` VALUES (21079, 2925, 15, 'Τα δεδομένα που εξάγονται εμφανίζονται στην περιοχή κείμενου που ακολουθεί. Μπορείτε να αντιγράψετε και να επικολλήσετε αυτά σε ένα email ή σε οποιοδήποτε άλλο επιθυμητό προορισμό.');
INSERT INTO `lang_definitions` VALUES (21080, 2926, 15, 'Το ακόλουθο σύμβαμα ημερολογίου έχει προστεθεί:');
INSERT INTO `lang_definitions` VALUES (21081, 2927, 15, 'Το ακόλουθο σύμβαμα ημερολογίου έχει τροποποιηθεί:');
INSERT INTO `lang_definitions` VALUES (21082, 2928, 15, 'Συνέβησαν τα ακόλουθα σφάλματα');
INSERT INTO `lang_definitions` VALUES (21083, 2929, 15, 'Το αρχικό παράθυρο είναι η σελίδα αναζήτησης του τιμολογίου. Στην κορυφή μπορείτε να δώσετε μια πηγή (π.χ. αριθμός ελέγχου), ημερομηνία πληρωμής και ποσό ελέγχου. Ο λόγος για την ημερομηνία πηγής και πληρωμής είναι αυτός, ώστε δεν χρειάζεται να τα εισάγετε ξανά και ξανά για κάθε αξίωση. Το ποσό που εισάγετε θα μειωθεί για κάθε τιμολόγιο που δίνεται μέρος της πληρωμής και ελπίζουμε ότι θα τελειώσει στο μηδέν όταν τελειώσετε.');
INSERT INTO `lang_definitions` VALUES (21084, 2930, 15, 'Η ετικέτα που φαίνεται στο χρήστη πάνω στο έντυπο');
INSERT INTO `lang_definitions` VALUES (21085, 2931, 15, 'Ο νέος κατάλογος θα είναι μια υπο-κατηγορία του/της');
INSERT INTO `lang_definitions` VALUES (21086, 2932, 15, 'Οι υπόλοιπες πληροφορίες παρακάτω ισχύουν μόνο αν αποστέλλετε χειρωνακτικά, ή αν κάνετε διορθώσεις με το χέρι. ');
INSERT INTO `lang_definitions` VALUES (21087, 2933, 15, 'Το ζητούμενο έγγραφο δεν είναι παρών στην αναμενόμενη θέση στο σύστημα αρχείων ή δεν υπάρχουν επαρκή δικαιώματα για πρόσβαση σε αυτό.');
INSERT INTO `lang_definitions` VALUES (21088, 2934, 15, 'Οι στήλες Πηγής και Ημερομηνίας αντιγράφονται από την πρώτη σελίδα, έτσι κανονικά δεν θα χρειαστεί να τις αγγίξετε. Μπορείτε να τοποθετήσετε ένα ποσό πληρωμής στη στήλη Πληρωμή, ένα ποσό προσαρμογής στην στήλη Ρύθμιση, ή και τα δύο. Μπορείτε επίσης να κάνετε κλικ στο \"W\" στα δεξιά για να υπολογιστεί αυτόματα μια τιμή προσαρμογής που γράφει το υπόλοιπο του τέλους για το στοιχείο γραμμής.');
INSERT INTO `lang_definitions` VALUES (21089, 2935, 15, 'Η μεταφρασμένη ετικέτα που θα εμφανιστεί στο έντυπο στην τρέχουσα γλώσσα');
INSERT INTO `lang_definitions` VALUES (21090, 2936, 15, 'Ο μεταφρασμένος Τίτλος που θα εμφανιστεί στην τρέχουσα γλώσσα');
INSERT INTO `lang_definitions` VALUES (21091, 2937, 15, 'Η μετάφραση της περιγραφής στην τρέχουσα γλώσσα');
INSERT INTO `lang_definitions` VALUES (21092, 2938, 15, 'Τα X12 αρχεία, καθώς και οι σχετικές αναφορές εξόδου HTML αρχειοθετούνται στον υποκατάλογο \"era\" του κυρίου καταλόγου εγκατάστασης του OpenEMR. Θα θέλατε να αναφερθείτε σε αυτά τα αρχεία κάπου κάπου. Η διεύθυνση URL είναι');
INSERT INTO `lang_definitions` VALUES (21093, 2939, 15, 'Θεραπευτικές ενέσεις');
INSERT INTO `lang_definitions` VALUES (21094, 2940, 15, 'Υπάρχουν');
INSERT INTO `lang_definitions` VALUES (21095, 2941, 15, 'Υπάρχουν σφάλματα με την υποβολή σας. Αυτά σκιαγραφούνται παρακάτω. ');
INSERT INTO `lang_definitions` VALUES (21096, 2942, 15, 'Δεν υπάρχουν νέες Υποβολές.');
INSERT INTO `lang_definitions` VALUES (21097, 2943, 15, 'Υπήρξε σφάλμα ταχυδρομείου που έστελνε σε');
INSERT INTO `lang_definitions` VALUES (21098, 2950, 15, 'Δεν υπάρχει ταίριασμα για το αναγνωριστικό τιμολογίου');
INSERT INTO `lang_definitions` VALUES (21099, 2951, 15, 'Δεν υπάρχει ταίριασμα για το αναγνωριστικό τιμολογίου =');
INSERT INTO `lang_definitions` VALUES (21100, 2952, 15, 'Δεν υπάρχει εγγραφή τμήματος για το αναγνωριστικό υπηρεσιών');
INSERT INTO `lang_definitions` VALUES (21101, 2953, 15, 'Υπήρξε ένα σφάλμα κατά την επεξεργασία του αιτήματός σας');
INSERT INTO `lang_definitions` VALUES (21102, 2954, 15, 'Πυκνό δεξιά:');
INSERT INTO `lang_definitions` VALUES (21103, 2955, 15, 'Μηρός');
INSERT INTO `lang_definitions` VALUES (21104, 2956, 15, 'Μηρός + ιγνυακός τένοντας');
INSERT INTO `lang_definitions` VALUES (21105, 2957, 15, 'Πράγματα που το οπίσθιο γραφείο μπορεί να διαβάσει και να εισάγει αλλά όχι να τροποποιήσει ');
INSERT INTO `lang_definitions` VALUES (21106, 2958, 15, 'Πράγματα που το οπίσθιο γραφείο μπορεί να διαβάσει και να τροποποιήσει ');
INSERT INTO `lang_definitions` VALUES (21107, 2959, 15, 'Πράγματα που οι κλινικοί μπορούν να διαβάσουν και να εισάγουν αλλά όχι να τροποποιήσουν');
INSERT INTO `lang_definitions` VALUES (21108, 2960, 15, 'Πράγματα που οι κλινικοί μπορούν να διαβάσουν και να τροποποιήσουν');
INSERT INTO `lang_definitions` VALUES (21109, 2961, 15, 'Πράγματα που το πρόσθιο γραφείο μπορεί να διαβάσει και να εισάγει αλλά όχι να τροποποιήσει ');
INSERT INTO `lang_definitions` VALUES (21110, 2962, 15, 'Πράγματα που το πρόσθιο μπορεί να διαβάσει και να τροποποιήσει ');
INSERT INTO `lang_definitions` VALUES (21111, 2963, 15, 'Πράγματα που οι ιατροί μπορούν να διαβάσουν και να εισάγουν αλλά όχι να τροποποιήσουν');
INSERT INTO `lang_definitions` VALUES (21112, 2964, 15, 'Πράγματα που οι ιατροί μπορούν να διαβάσουν και να τροποποιήσουν');
INSERT INTO `lang_definitions` VALUES (21113, 2965, 15, 'Τρίτο');
INSERT INTO `lang_definitions` VALUES (21114, 2966, 15, 'Αυτή η ενέργεια δεν μπορεί να αναιρεθεί. ');
INSERT INTO `lang_definitions` VALUES (21115, 2967, 15, 'Αυτή η ενέργεια ΔΕΝ ΜΠΟΡΕΙ να αναιρεθεί. ');
INSERT INTO `lang_definitions` VALUES (21116, 2968, 15, 'Αυτό ο τύπος κωδικού δεν αποδέχεται σχέσεις.');
INSERT INTO `lang_definitions` VALUES (21117, 2969, 15, 'Αυτή η Επίσκεψη');
INSERT INTO `lang_definitions` VALUES (21118, 2971, 15, 'Αυτός ο αριθμός τιμολογίου έχει αλλάξει σε');
INSERT INTO `lang_definitions` VALUES (21119, 2972, 15, 'Η ενότητα αυτή είναι σε φάση δοκιμής. Η βάση δεδομένων δεν θα αλλάξει. ');
INSERT INTO `lang_definitions` VALUES (21120, 2973, 15, 'Η ενότητα αυτή προωθεί την αποτελεσματική είσοδο των δεδομένων Εξήγησης του Κέρδους');
INSERT INTO `lang_definitions` VALUES (21121, 2974, 15, 'Αυτή η σελίδα θα περιλαμβάνει ενσωματωμένη τη σελίδα σύνδεσης, έτσι ώστε να μην χρειάζεται να κάνετε κλικ στην επανασύνδεση κάθε φορά.');
INSERT INTO `lang_definitions` VALUES (21122, 2975, 15, 'Αυτός ο ασθενής δεν έχει δραστηριότητα.');
INSERT INTO `lang_definitions` VALUES (21123, 2976, 15, 'Αυτό το αναγνωριστικό ασθενή χρησιμοποιείται ήδη!');
INSERT INTO `lang_definitions` VALUES (21124, 2977, 15, 'Αυτός ο χρήστης δεν είναι μέλος κάποιας ομάδας');
INSERT INTO `lang_definitions` VALUES (21125, 2978, 15, 'Αυτή η Επίσκεψη ξεκινά νέα χρήση αντισυλληπτικών');
INSERT INTO `lang_definitions` VALUES (21126, 2979, 15, 'Αυτό θα δημιουργήσει ένα backup αρχείο σε tar format και θα το στείλι στον Web browser σας ώστε να μπορείτε να το αποθηκεύσετε.');
INSERT INTO `lang_definitions` VALUES (21127, 2980, 15, 'Θωρακικής μοίρα της ΣΣ');
INSERT INTO `lang_definitions` VALUES (21128, 2981, 15, 'Λάρυγγας');
INSERT INTO `lang_definitions` VALUES (21129, 2982, 15, 'Καρκίνος του λάρυγγα');
INSERT INTO `lang_definitions` VALUES (21130, 2983, 15, 'Εγχείρηση καρκίνου του λάρυγγα');
INSERT INTO `lang_definitions` VALUES (21131, 2984, 15, 'Θρόμβωση/ΑΕΕ');
INSERT INTO `lang_definitions` VALUES (21132, 2985, 15, 'Πεμ ');
INSERT INTO `lang_definitions` VALUES (21133, 2986, 15, 'Πέμπτη');
INSERT INTO `lang_definitions` VALUES (21134, 2987, 15, 'Πέμπτη');
INSERT INTO `lang_definitions` VALUES (21135, 2988, 15, 'Θυρεοειδής φυσιολογικός');
INSERT INTO `lang_definitions` VALUES (21136, 2989, 15, 'Προβλήματα θυροειδη');
INSERT INTO `lang_definitions` VALUES (21137, 2990, 15, 'Παροδικό ισχαιμικό εγκεφαλικό επεισόδιο');
INSERT INTO `lang_definitions` VALUES (21138, 2991, 15, 'Χρόνος ');
INSERT INTO `lang_definitions` VALUES (21139, 2992, 15, 'Προσαύξηση ώρας για Προσθήκη (λεπτά 1-60) ');
INSERT INTO `lang_definitions` VALUES (21140, 2993, 15, 'Χρονικό σύμβαμα');
INSERT INTO `lang_definitions` VALUES (21141, 2994, 15, 'Συστοιχία χρόνων');
INSERT INTO `lang_definitions` VALUES (21142, 2995, 15, 'Χρονοθέτηση και Κείμενο ');
INSERT INTO `lang_definitions` VALUES (21143, 2996, 15, 'Αναγνωριστικός αριθμός φορολογούμενου');
INSERT INTO `lang_definitions` VALUES (21144, 2997, 15, 'Εμβοες');
INSERT INTO `lang_definitions` VALUES (21145, 2998, 15, 'Τίτλος ');
INSERT INTO `lang_definitions` VALUES (21146, 2999, 15, 'Τίτλος V ');
INSERT INTO `lang_definitions` VALUES (21147, 3000, 15, 'Οι στήλες του τίτλου πρέπει να είναι αριθμός μεταξύ 1 και 999 ');
INSERT INTO `lang_definitions` VALUES (21148, 3001, 15, 'Τίτλοι ');
INSERT INTO `lang_definitions` VALUES (21149, 3003, 15, '/Έξω ακουστικοί πόροι/, έξω ρις');
INSERT INTO `lang_definitions` VALUES (21150, 3004, 15, 'Στο');
INSERT INTO `lang_definitions` VALUES (21151, 3006, 15, 'Στο');
INSERT INTO `lang_definitions` VALUES (21152, 3007, 15, 'Στην προσβεβλημένη περιοχή ');
INSERT INTO `lang_definitions` VALUES (21153, 3008, 15, 'στην προσβεβλημένη περιοχή ');
INSERT INTO `lang_definitions` VALUES (21154, 3009, 15, 'Στην προβολή Χρέωσης');
INSERT INTO `lang_definitions` VALUES (21155, 3010, 15, 'Στην κατηγορία ');
INSERT INTO `lang_definitions` VALUES (21156, 3011, 15, 'Στην Κλινική προβολή');
INSERT INTO `lang_definitions` VALUES (21157, 3012, 15, 'Στη Συμμετοχή');
INSERT INTO `lang_definitions` VALUES (21158, 3014, 15, 'Στα Δημογρ');
INSERT INTO `lang_definitions` VALUES (21159, 3015, 15, 'Στην Επισκ');
INSERT INTO `lang_definitions` VALUES (21160, 3016, 15, 'Για φιλτράρισμα κατά φύλο ');
INSERT INTO `lang_definitions` VALUES (21161, 3017, 15, 'Στο Ιστορικό ');
INSERT INTO `lang_definitions` VALUES (21162, 3018, 15, 'Στις διαγνώσεις');
INSERT INTO `lang_definitions` VALUES (21163, 3019, 15, 'Για να συνδέσετε αυτήν την επίσκεψη/εκτίμηση με ένα υπάρχον πρόβλημα, κάντε κλικ στο θέμα που θέλετε παραπάνω για να το επιλέξετε και στη συνέχεια κάντε κλικ στο [Αποθήκευση]. Κρατήστε πατημένο το [Ctrl] για να επιλέξετε πολλά προβλήματα.');
INSERT INTO `lang_definitions` VALUES (21164, 3020, 15, 'για να συνδεθείτε ξανά ');
INSERT INTO `lang_definitions` VALUES (21165, 3021, 15, 'Στο δέρμα');
INSERT INTO `lang_definitions` VALUES (21166, 3022, 15, 'στο δέρμα ');
INSERT INTO `lang_definitions` VALUES (21167, 3023, 15, 'Για αυτήν την επίσκεψη;');
INSERT INTO `lang_definitions` VALUES (21168, 3024, 15, 'Προς: ');
INSERT INTO `lang_definitions` VALUES (21169, 3025, 15, 'Προς: ');
INSERT INTO `lang_definitions` VALUES (21170, 3026, 15, 'TO_CITY');
INSERT INTO `lang_definitions` VALUES (21171, 3027, 15, 'TO_FAX');
INSERT INTO `lang_definitions` VALUES (21172, 3028, 15, 'TO_FNAME');
INSERT INTO `lang_definitions` VALUES (21173, 3029, 15, 'TO_LNAME');
INSERT INTO `lang_definitions` VALUES (21174, 3030, 15, 'TO_MNAME');
INSERT INTO `lang_definitions` VALUES (21175, 3031, 15, 'TO_ORGANIZATION');
INSERT INTO `lang_definitions` VALUES (21176, 3032, 15, 'TO_POSTAL');
INSERT INTO `lang_definitions` VALUES (21177, 3033, 15, 'TO_STATE');
INSERT INTO `lang_definitions` VALUES (21178, 3034, 15, 'TO_STREET');
INSERT INTO `lang_definitions` VALUES (21179, 3035, 15, 'TO_TITLE');
INSERT INTO `lang_definitions` VALUES (21180, 3036, 15, 'TO_VALEDICTORY');
INSERT INTO `lang_definitions` VALUES (21181, 3037, 15, 'Καπνός ');
INSERT INTO `lang_definitions` VALUES (21182, 3038, 15, 'Χρήση καπνού ');
INSERT INTO `lang_definitions` VALUES (21183, 3039, 15, 'Σήμερα ');
INSERT INTO `lang_definitions` VALUES (21184, 3040, 15, 'Σημερινή ήμερα');
INSERT INTO `lang_definitions` VALUES (21185, 3041, 15, 'Τα σημερινά Συμβάματα ');
INSERT INTO `lang_definitions` VALUES (21186, 3042, 15, 'Αμυγδαλεκτομή');
INSERT INTO `lang_definitions` VALUES (21187, 3043, 15, 'Πάνω');
INSERT INTO `lang_definitions` VALUES (21188, 3044, 15, 'Θέμα ');
INSERT INTO `lang_definitions` VALUES (21189, 3045, 15, 'σύνολο');
INSERT INTO `lang_definitions` VALUES (21190, 3046, 15, 'Σύνολο ');
INSERT INTO `lang_definitions` VALUES (21191, 3047, 15, 'Συνολικό πληρωτέο ποσό');
INSERT INTO `lang_definitions` VALUES (21192, 3048, 15, 'Σύνολο Χρεώσεων');
INSERT INTO `lang_definitions` VALUES (21193, 3049, 15, 'Σύνολο Πελατών');
INSERT INTO `lang_definitions` VALUES (21194, 3050, 15, 'Σύνολο για ');
INSERT INTO `lang_definitions` VALUES (21195, 3051, 15, 'Σύνολο για ');
INSERT INTO `lang_definitions` VALUES (21196, 3052, 15, 'Σύνολο για την κατηγορία ');
INSERT INTO `lang_definitions` VALUES (21197, 3053, 15, 'Συνολικός αριθμός ασθενών');
INSERT INTO `lang_definitions` VALUES (21198, 3054, 15, 'Συνολική σεξουαλική και αναπαραγωγική υγεία και Οικογενειακός προγραμματισμός');
INSERT INTO `lang_definitions` VALUES (21199, 3055, 15, 'Σύνολα ');
INSERT INTO `lang_definitions` VALUES (21200, 3056, 15, 'Σύνολα για');
INSERT INTO `lang_definitions` VALUES (21201, 3057, 15, 'Σύνολα για');
INSERT INTO `lang_definitions` VALUES (21202, 3058, 15, 'Τύπος κατάρτισης');
INSERT INTO `lang_definitions` VALUES (21203, 3059, 15, 'Συναλλαγές');
INSERT INTO `lang_definitions` VALUES (21204, 3060, 15, 'συναλλαγή');
INSERT INTO `lang_definitions` VALUES (21205, 3061, 15, 'Συναλλαγή ');
INSERT INTO `lang_definitions` VALUES (21206, 3062, 15, 'Είδος συναλλαγής');
INSERT INTO `lang_definitions` VALUES (21207, 3063, 15, 'Συναλλαγές ');
INSERT INTO `lang_definitions` VALUES (21208, 3064, 15, 'Συναλλαγές (εγγραφή προαιρετικά) ');
INSERT INTO `lang_definitions` VALUES (21209, 3065, 15, 'Συναλλαγές/Παραπομπές');
INSERT INTO `lang_definitions` VALUES (21210, 3066, 15, 'Μεταφράστε αυτό');
INSERT INTO `lang_definitions` VALUES (21211, 3067, 15, 'Μετάφραση ');
INSERT INTO `lang_definitions` VALUES (21212, 3068, 15, 'Μεταφράσεις');
INSERT INTO `lang_definitions` VALUES (21213, 3069, 15, 'Τραύμα');
INSERT INTO `lang_definitions` VALUES (21214, 3070, 15, 'Στόχοι θεραπείας');
INSERT INTO `lang_definitions` VALUES (21215, 3071, 15, 'Σχέδιο θεραπείας');
INSERT INTO `lang_definitions` VALUES (21216, 3072, 15, 'Θεραπεία: ');
INSERT INTO `lang_definitions` VALUES (21217, 3073, 15, 'Θεραπεία: ');
INSERT INTO `lang_definitions` VALUES (21218, 3075, 15, 'Σημείο ερεθισμού / σύνδρομο διαμερίσματος / καθυστερημένος μυϊκός πόνος / κράμπα');
INSERT INTO `lang_definitions` VALUES (21219, 3076, 15, 'Τρισφύριος');
INSERT INTO `lang_definitions` VALUES (21220, 3078, 15, 'Κορμός και κοιλιά ');
INSERT INTO `lang_definitions` VALUES (21221, 3079, 15, 'κουταλάκι (5ml)');
INSERT INTO `lang_definitions` VALUES (21222, 3080, 15, 'Διαδερμικό θεραπευτικό σύστημα');
INSERT INTO `lang_definitions` VALUES (21223, 3081, 15, 'Φυματίωση ');
INSERT INTO `lang_definitions` VALUES (21224, 3082, 15, 'Τρί');
INSERT INTO `lang_definitions` VALUES (21225, 3083, 15, 'Τρίτη & Πέμπτη ');
INSERT INTO `lang_definitions` VALUES (21226, 3084, 15, 'Τρίτη ');
INSERT INTO `lang_definitions` VALUES (21227, 3085, 15, 'Όγκος');
INSERT INTO `lang_definitions` VALUES (21228, 3086, 15, 'δύο φορές ημερησίως');
INSERT INTO `lang_definitions` VALUES (21229, 3087, 15, 'Τυμπ μεμβράνη');
INSERT INTO `lang_definitions` VALUES (21230, 3088, 15, 'Τύπος ');
INSERT INTO `lang_definitions` VALUES (21231, 3089, 15, 'Πληκτρολογήστε ή σαρώστε το αναγνωριστικό του ασθενή εδώ');
INSERT INTO `lang_definitions` VALUES (21232, 3091, 15, 'Εξελκώσεις ');
INSERT INTO `lang_definitions` VALUES (21233, 3092, 15, 'Ελκώδης κολίτιδα ');
INSERT INTO `lang_definitions` VALUES (21234, 3093, 15, 'Έλκη');
INSERT INTO `lang_definitions` VALUES (21235, 3094, 15, 'Ανεκχώρητο ');
INSERT INTO `lang_definitions` VALUES (21236, 3095, 15, 'Αναρμόδια πρόσβαση. ');
INSERT INTO `lang_definitions` VALUES (21237, 3096, 15, 'Κάτωθεν της γλώσσας ');
INSERT INTO `lang_definitions` VALUES (21238, 3097, 15, 'Ελλιποβαρής');
INSERT INTO `lang_definitions` VALUES (21239, 3098, 15, 'Αδιάγνωστο');
INSERT INTO `lang_definitions` VALUES (21240, 3099, 15, 'Αναίρεση αποχώρησης');
INSERT INTO `lang_definitions` VALUES (21241, 3100, 15, 'Μοναδικοί Πελάτες ');
INSERT INTO `lang_definitions` VALUES (21242, 3101, 15, 'Μοναδικοί Νέοι Πελάτες ');
INSERT INTO `lang_definitions` VALUES (21243, 3102, 15, 'Μοναδικοί εξετασθέντες Ασθενείς ');
INSERT INTO `lang_definitions` VALUES (21244, 3103, 15, 'Αναφορά μοναδικών εξετασθέντων Ασθενών');
INSERT INTO `lang_definitions` VALUES (21245, 3104, 15, 'Μοναδικά εξετασθέντες');
INSERT INTO `lang_definitions` VALUES (21246, 3105, 15, 'Μονάδα ');
INSERT INTO `lang_definitions` VALUES (21247, 3106, 15, 'Μονάδες ');
INSERT INTO `lang_definitions` VALUES (21248, 3107, 15, 'μονάδες (units) ');
INSERT INTO `lang_definitions` VALUES (21249, 3108, 15, 'Οι μονάδες πρέπει να είναι ένας αριθμός');
INSERT INTO `lang_definitions` VALUES (21250, 3109, 15, 'Άγνωστο');
INSERT INTO `lang_definitions` VALUES (21251, 3110, 15, 'Άγνωστο ή μη διαθέσιμο');
INSERT INTO `lang_definitions` VALUES (21252, 3111, 15, 'Ασφαλιστική εταιρεία χωρίς όνομα');
INSERT INTO `lang_definitions` VALUES (21253, 3112, 15, 'Μη καταχωρηθέν');
INSERT INTO `lang_definitions` VALUES (21254, 3113, 15, 'Αποεπιλογη Όλων');
INSERT INTO `lang_definitions` VALUES (21255, 3114, 15, 'Μη επιλεγμένο');
INSERT INTO `lang_definitions` VALUES (21256, 3115, 15, 'Απροσδιόριστο ');
INSERT INTO `lang_definitions` VALUES (21257, 3116, 15, 'μέχρι ');
INSERT INTO `lang_definitions` VALUES (21258, 3117, 15, 'Άκαιρη πλήρωση');
INSERT INTO `lang_definitions` VALUES (21259, 3118, 15, 'Αχρησιμοποίητο');
INSERT INTO `lang_definitions` VALUES (21260, 3119, 15, 'Μονάδες ανάλυσης');
INSERT INTO `lang_definitions` VALUES (21261, 3120, 15, 'Μέχρι ');
INSERT INTO `lang_definitions` VALUES (21262, 3121, 15, 'Προσεχή ραντεβού');
INSERT INTO `lang_definitions` VALUES (21263, 3122, 15, 'Προσεχή συμβάματα');
INSERT INTO `lang_definitions` VALUES (21264, 3123, 15, 'Ενημέρωση ');
INSERT INTO `lang_definitions` VALUES (21265, 3124, 15, 'ενημέρωση ');
INSERT INTO `lang_definitions` VALUES (21266, 3125, 15, 'Ενημέρωση αρχείων ');
INSERT INTO `lang_definitions` VALUES (21267, 3126, 15, 'Ενημέρωση Πληροφοριών');
INSERT INTO `lang_definitions` VALUES (21268, 3130, 15, 'Η ενημέρωση των δημογραφικών δεν επιτρέπεται. ');
INSERT INTO `lang_definitions` VALUES (21269, 3131, 15, 'Μοναδικός προσωπικός αριθμός');
INSERT INTO `lang_definitions` VALUES (21270, 3132, 15, 'Ανέβασμα ');
INSERT INTO `lang_definitions` VALUES (21271, 3133, 15, 'Ανέβασμα δεδομένων ρύθμισης');
INSERT INTO `lang_definitions` VALUES (21272, 3134, 15, 'Ανέβασμα εγγράφου ');
INSERT INTO `lang_definitions` VALUES (21273, 3135, 15, 'Το ανέβασμα απέτυχε!');
INSERT INTO `lang_definitions` VALUES (21274, 3136, 15, 'Ανέβασμα αρχείου εισαγωγής: ');
INSERT INTO `lang_definitions` VALUES (21275, 3137, 15, 'Ανέβασμα αναφοράς');
INSERT INTO `lang_definitions` VALUES (21276, 3138, 15, 'Ανέβασμα αυτού του αρχείου: ');
INSERT INTO `lang_definitions` VALUES (21277, 3139, 15, 'Μόλις κάνετε κλικ στο αριθμό τιμολoγίου εμφανίζεται το \"παράθυρο χειροκίνητης αποστολής\". Εδώ μπορείτε να αλλάξετε την ημερομηνία λήξης της προθεσμίας και τις σημειώσεις για αυτό τιμολόγιο, να επιλέξτε το συνεργάτη για τον οποίο αποστέλετε και να επιλέξετε την ασφαλιστική κάλυψη των οποίων όλες οι αναμενόμενες πληρωμές έχουν ληφθεί. Το σημαντικότερο είναι, για κάθε κωδικό χρέωσης ο οποίος έχει επιβαρυνθεί με ένα ποσό, μπορείτε να εισαγάγετε την πληρωμή και προσαρμογή πληροφοριών.');
INSERT INTO `lang_definitions` VALUES (21278, 3140, 15, 'Κατά την αναζήτηση σας παρουσιάστηκε μια λίστα με τιμολόγια. Μπορείτε να κάνετε κλικ σε έναν από τους αριθμούς τιμολογίου για να ανοίξει ένα δεύτερο παράθυρο, το οποίο είναι η σελίδα εισόδου δεδομένων για χειροκίνητη αποστολή. Μπορείτε επίσης να κάνετε κλικ στο όνομα του ασθενούς, εάν θέλετε να εισάγετε μια σημείωση που θα δει το προσωπικό του γραφείου υποδοχής όταν ο ασθενής θα εισαχθεί και μπορείτε να επιλέξετε τιμολόγια για να εμφανιστούν στις καταστάσεις των ασθενών και να εκτυπώσετε αυτές.');
INSERT INTO `lang_definitions` VALUES (21279, 3141, 15, 'Άνω άκρο');
INSERT INTO `lang_definitions` VALUES (21280, 3142, 15, 'Κατεπείγον');
INSERT INTO `lang_definitions` VALUES (21281, 3143, 15, 'Σταγόνες κατά την ούρηση');
INSERT INTO `lang_definitions` VALUES (21282, 3144, 15, 'Συχνότητα ούρησης');
INSERT INTO `lang_definitions` VALUES (21283, 3145, 15, 'Δισταγμός ούρησης');
INSERT INTO `lang_definitions` VALUES (21284, 3146, 15, 'Ακτίνα ούρησης');
INSERT INTO `lang_definitions` VALUES (21285, 3147, 15, 'Επιτακτική ούρηση');
INSERT INTO `lang_definitions` VALUES (21286, 3148, 15, 'URL ');
INSERT INTO `lang_definitions` VALUES (21287, 3150, 15, 'Χρήση μορφή ώρας 24 ωρών; ');
INSERT INTO `lang_definitions` VALUES (21288, 3151, 15, 'Χρήση προεπιλογών ');
INSERT INTO `lang_definitions` VALUES (21289, 3152, 15, 'Χρήση ημερομηνίας διεθνούς στυλ; ');
INSERT INTO `lang_definitions` VALUES (21290, 3153, 15, 'Χρηση αυτής της δυνατότητας μόνο με νέα εγκατεστημένες σελίδες,');
INSERT INTO `lang_definitions` VALUES (21291, 3154, 15, 'Χρήση θεμάτων; ');
INSERT INTO `lang_definitions` VALUES (21292, 3155, 15, 'Χρήστης ');
INSERT INTO `lang_definitions` VALUES (21293, 3156, 15, 'Διαχείριση χρήστη');
INSERT INTO `lang_definitions` VALUES (21294, 3157, 15, 'Διαχειρηση χρήστη και έδρας');
INSERT INTO `lang_definitions` VALUES (21295, 3158, 15, 'Διαχειρηση χρήστη και ομάδας');
INSERT INTO `lang_definitions` VALUES (21296, 3159, 15, 'Ορισμένο από το Χρήστη');
INSERT INTO `lang_definitions` VALUES (21297, 3160, 15, 'Περιοχή ορισμένη από το Χρήστη 11');
INSERT INTO `lang_definitions` VALUES (21298, 3161, 15, 'Περιοχή ορισμένη από το Χρήστη 12');
INSERT INTO `lang_definitions` VALUES (21299, 3162, 15, 'Πεδίο ορισμένο από το Χρήστη');
INSERT INTO `lang_definitions` VALUES (21300, 3163, 15, 'Λίστα ορισμένη από το Χρήστη 1');
INSERT INTO `lang_definitions` VALUES (21301, 3164, 15, 'Λίστα ορισμένη από το Χρήστη 2');
INSERT INTO `lang_definitions` VALUES (21302, 3165, 15, 'Λίστα ορισμένη από το Χρήστη 3');
INSERT INTO `lang_definitions` VALUES (21303, 3166, 15, 'Λίστα ορισμένη από το Χρήστη 4');
INSERT INTO `lang_definitions` VALUES (21304, 3167, 15, 'Λίστα ορισμένη από το Χρήστη 5');
INSERT INTO `lang_definitions` VALUES (21305, 3168, 15, 'Λίστα ορισμένη από το Χρήστη 6');
INSERT INTO `lang_definitions` VALUES (21306, 3169, 15, 'Λίστα ορισμένη από το Χρήστη 7');
INSERT INTO `lang_definitions` VALUES (21307, 3170, 15, 'Κείμενο ορισμένο από το Χρήστη 1');
INSERT INTO `lang_definitions` VALUES (21308, 3171, 15, 'Κείμενο ορισμένο από το Χρήστη 2');
INSERT INTO `lang_definitions` VALUES (21309, 3172, 15, 'Κείμενο ορισμένο από το Χρήστη 3');
INSERT INTO `lang_definitions` VALUES (21310, 3173, 15, 'Κείμενο ορισμένο από το Χρήστη 4');
INSERT INTO `lang_definitions` VALUES (21311, 3174, 15, 'Κείμενο ορισμένο από το Χρήστη 5');
INSERT INTO `lang_definitions` VALUES (21312, 3175, 15, 'Κείμενο ορισμένο από το Χρήστη 6');
INSERT INTO `lang_definitions` VALUES (21313, 3176, 15, 'Κείμενο ορισμένο από το Χρήστη 7');
INSERT INTO `lang_definitions` VALUES (21314, 3177, 15, 'Κείμενο ορισμένο από το Χρήστη 8');
INSERT INTO `lang_definitions` VALUES (21315, 3178, 15, 'Εχγειρίδιο χρήσης');
INSERT INTO `lang_definitions` VALUES (21316, 3179, 15, 'Συμμετοχές μελών');
INSERT INTO `lang_definitions` VALUES (21317, 3180, 15, 'Όνομα Χρήστη');
INSERT INTO `lang_definitions` VALUES (21318, 3182, 15, 'Όνομα Χρήστη:');
INSERT INTO `lang_definitions` VALUES (21319, 3183, 15, 'Χρήστες ');
INSERT INTO `lang_definitions` VALUES (21320, 3184, 15, 'Διαχείριση Χρηστών/Ομάδων/Logs');
INSERT INTO `lang_definitions` VALUES (21321, 3186, 15, 'Λοίμωξη ανώτερου ουροποιητικού');
INSERT INTO `lang_definitions` VALUES (21322, 3187, 15, 'ΑΡΓΙΑ');
INSERT INTO `lang_definitions` VALUES (21323, 3188, 15, 'Αργία');
INSERT INTO `lang_definitions` VALUES (21324, 3189, 15, 'Εμβόλιο ');
INSERT INTO `lang_definitions` VALUES (21325, 3190, 15, 'Κολπικός δακτυλίος');
INSERT INTO `lang_definitions` VALUES (21326, 3191, 15, 'Αποχαιρετιστήριος ');
INSERT INTO `lang_definitions` VALUES (21327, 3192, 15, 'Τιμή 1 ');
INSERT INTO `lang_definitions` VALUES (21328, 3193, 15, 'Τιμή 2 ');
INSERT INTO `lang_definitions` VALUES (21329, 3194, 15, 'Μεταβλ 1');
INSERT INTO `lang_definitions` VALUES (21330, 3195, 15, 'Μεταβλ 2');
INSERT INTO `lang_definitions` VALUES (21331, 3196, 15, 'Έρπης 1');
INSERT INTO `lang_definitions` VALUES (21332, 3197, 15, 'Έρπης 2');
INSERT INTO `lang_definitions` VALUES (21333, 3198, 15, 'Κιρσοί φλεβών');
INSERT INTO `lang_definitions` VALUES (21334, 3199, 15, 'Αγγειακή κατάσταση');
INSERT INTO `lang_definitions` VALUES (21335, 3200, 15, 'Αγγειακή βλάβη');
INSERT INTO `lang_definitions` VALUES (21336, 3201, 15, 'Χειρουργική αγγείων ');
INSERT INTO `lang_definitions` VALUES (21337, 3202, 15, 'Έκδοση');
INSERT INTO `lang_definitions` VALUES (21338, 3203, 15, 'Ίλιγγος');
INSERT INTO `lang_definitions` VALUES (21339, 3204, 15, 'Σχέδιο Διαχείρισης Βετεράνων');
INSERT INTO `lang_definitions` VALUES (21340, 3205, 15, 'Προβολή');
INSERT INTO `lang_definitions` VALUES (21341, 3206, 15, 'προβολή');
INSERT INTO `lang_definitions` VALUES (21342, 3207, 15, 'Προβολή αλλεργιών');
INSERT INTO `lang_definitions` VALUES (21343, 3208, 15, 'Προβολή αναλυτικής αναφοράς ');
INSERT INTO `lang_definitions` VALUES (21344, 3209, 15, 'Προβολή εγγράφου ');
INSERT INTO `lang_definitions` VALUES (21345, 3210, 15, 'Προβολή επίσκεψης');
INSERT INTO `lang_definitions` VALUES (21346, 3211, 15, 'Προβολή γεγονότων σε ένα αναδυόμενο παράθυρο');
INSERT INTO `lang_definitions` VALUES (21347, 3212, 15, 'Προβολή σελίδας 1');
INSERT INTO `lang_definitions` VALUES (21348, 3213, 15, 'Προβολή σελίδας 2');
INSERT INTO `lang_definitions` VALUES (21349, 3214, 15, 'Δείτε σχετικές επισκέψεις');
INSERT INTO `lang_definitions` VALUES (21350, 3216, 15, 'Προβολή:');
INSERT INTO `lang_definitions` VALUES (21351, 3217, 15, 'VISA');
INSERT INTO `lang_definitions` VALUES (21352, 3218, 15, 'Σπλαγχνική καταστροφή/τραύμα/χειρουργική ');
INSERT INTO `lang_definitions` VALUES (21353, 3219, 15, 'Κατηγορία Επίσκεψη: ');
INSERT INTO `lang_definitions` VALUES (21354, 3220, 15, 'Ημ/νια Επίσκεψης');
INSERT INTO `lang_definitions` VALUES (21355, 3221, 15, 'Έντυπα επίσκεψης');
INSERT INTO `lang_definitions` VALUES (21356, 3222, 15, 'Επισκέψεις');
INSERT INTO `lang_definitions` VALUES (21357, 3223, 15, 'Επισκέψεις από');
INSERT INTO `lang_definitions` VALUES (21358, 3225, 15, 'Ζωτικά σημεία');
INSERT INTO `lang_definitions` VALUES (21359, 3226, 15, 'Ζωτικά σημεία (μετρικό)');
INSERT INTO `lang_definitions` VALUES (21360, 3228, 15, 'Εμετός');
INSERT INTO `lang_definitions` VALUES (21361, 3230, 15, 'Περιφ μέσης');
INSERT INTO `lang_definitions` VALUES (21362, 3231, 15, 'Περιφέρεια μέσης');
INSERT INTO `lang_definitions` VALUES (21363, 3232, 15, 'Αναμένοντας');
INSERT INTO `lang_definitions` VALUES (21364, 3233, 15, 'Υποδοχή');
INSERT INTO `lang_definitions` VALUES (21365, 3234, 15, 'Walt Pennington');
INSERT INTO `lang_definitions` VALUES (21366, 3235, 15, 'Θερμό');
INSERT INTO `lang_definitions` VALUES (21367, 3236, 15, 'ΠΡΟΕΙΔΟΠΟΙΗΣΗ ');
INSERT INTO `lang_definitions` VALUES (21368, 3237, 15, 'Προειδοποίηση: Μια επίσκεψη έχει ήδη δημιουργηθεί για αυτόν τον ασθενή σήμερα! ');
INSERT INTO `lang_definitions` VALUES (21369, 3238, 15, 'Προειδοποίηση: το αναγνωριστικό του ασθενούς δεν είναι μοναδικό! ');
INSERT INTO `lang_definitions` VALUES (21370, 3239, 15, 'ΠΡΟΕΙΔΟΠΟΙΗΣΗ: Αυτό θα αντικαταστήσει πληροφορίες ρύθμισης με δεδομένα από το αρχείο!');
INSERT INTO `lang_definitions` VALUES (21371, 3240, 15, 'είδαμε τον παραπάνω ασθενή σας για εκτίμηση και θεραπεία στο τμήμα εξωτερικών ιατρείων της ψυχιατρικής κλινικής μας. Ευχαριστούμε για αυτήν την παραπομπή');
INSERT INTO `lang_definitions` VALUES (21372, 3241, 15, 'Αδυναμία');
INSERT INTO `lang_definitions` VALUES (21373, 3242, 15, 'Ιστοσελίδα');
INSERT INTO `lang_definitions` VALUES (21374, 3243, 15, 'Τετ');
INSERT INTO `lang_definitions` VALUES (21375, 3244, 15, 'Τετάρτη');
INSERT INTO `lang_definitions` VALUES (21376, 3245, 15, 'εβδομάδα ');
INSERT INTO `lang_definitions` VALUES (21377, 3246, 15, 'Εβδομάδα ');
INSERT INTO `lang_definitions` VALUES (21378, 3247, 15, 'Προβολή Εβδομάδας');
INSERT INTO `lang_definitions` VALUES (21379, 3248, 15, 'Εβδομάδα(ες) ');
INSERT INTO `lang_definitions` VALUES (21380, 3249, 15, 'Βάρος');
INSERT INTO `lang_definitions` VALUES (21381, 3250, 15, 'Αλλαγή βάρους');
INSERT INTO `lang_definitions` VALUES (21382, 3251, 15, 'Απώλεια βάρους ');
INSERT INTO `lang_definitions` VALUES (21383, 3252, 15, 'Τι πρέπει να συνυπολογιστεί; ');
INSERT INTO `lang_definitions` VALUES (21384, 3253, 15, 'Συριγμοί: ');
INSERT INTO `lang_definitions` VALUES (21385, 3254, 15, 'Συριγμός');
INSERT INTO `lang_definitions` VALUES (21386, 3255, 15, 'Συριγμός');
INSERT INTO `lang_definitions` VALUES (21387, 3256, 15, 'Που θα μπορούσαν να βρεθούν σχετικά σαρωμένα ή τυπωμένα έγγραφα; ');
INSERT INTO `lang_definitions` VALUES (21388, 3258, 15, 'Ταυτότητα');
INSERT INTO `lang_definitions` VALUES (21389, 3259, 15, 'Ποιος απάντησε; ');
INSERT INTO `lang_definitions` VALUES (21390, 3260, 15, 'Χήρος/α');
INSERT INTO `lang_definitions` VALUES (21391, 3261, 15, 'Με επιλεγμένα:');
INSERT INTO `lang_definitions` VALUES (21392, 3262, 15, 'με το παλιό όνομα ');
INSERT INTO `lang_definitions` VALUES (21393, 3263, 15, 'Με ποιον θα μπορούσαμε να αφήσουμε ένα μήνυμα; ');
INSERT INTO `lang_definitions` VALUES (21394, 3264, 15, 'μέσα σε ώρες ');
INSERT INTO `lang_definitions` VALUES (21395, 3265, 15, 'μέσα σε ώρες: ');
INSERT INTO `lang_definitions` VALUES (21396, 3266, 15, 'μέσα σε λεπτά ');
INSERT INTO `lang_definitions` VALUES (21397, 3267, 15, 'μέσα σε λεπτά: ');
INSERT INTO `lang_definitions` VALUES (21398, 3268, 15, 'Χωρίς Ενημέρωση ');
INSERT INTO `lang_definitions` VALUES (21399, 3269, 15, 'Μάρτυρας ');
INSERT INTO `lang_definitions` VALUES (21400, 3270, 15, 'ΕΦΟ');
INSERT INTO `lang_definitions` VALUES (21401, 3271, 15, 'Γυναίκες ');
INSERT INTO `lang_definitions` VALUES (21402, 3272, 15, 'Μόνο γυναίκες ');
INSERT INTO `lang_definitions` VALUES (21403, 3273, 15, 'Εργασία ');
INSERT INTO `lang_definitions` VALUES (21404, 3274, 15, 'ΣΗΜΕΙΩΣΗ ΕΡΓΑΣΙΑΣ ');
INSERT INTO `lang_definitions` VALUES (21405, 3275, 15, 'Τηλέφωνο εργασίας');
INSERT INTO `lang_definitions` VALUES (21406, 3276, 15, 'Αριθμός τηλεφώνου εργασίας ');
INSERT INTO `lang_definitions` VALUES (21407, 3277, 15, 'Σχετικό με εργασία; ');
INSERT INTO `lang_definitions` VALUES (21408, 3278, 15, 'Εργασία/Εκπαίδευση/Χομπυ');
INSERT INTO `lang_definitions` VALUES (21409, 3279, 15, 'Σημείωση εργασίας/σχολείου ');
INSERT INTO `lang_definitions` VALUES (21410, 3280, 15, 'εργάσιμη μέρα');
INSERT INTO `lang_definitions` VALUES (21411, 3281, 15, 'Σχέδιο Αποζημίωσης Υγείας εργαζομένων');
INSERT INTO `lang_definitions` VALUES (21412, 3282, 15, 'Χειρότερο');
INSERT INTO `lang_definitions` VALUES (21413, 3283, 15, 'Καρπός');
INSERT INTO `lang_definitions` VALUES (21414, 3284, 15, 'Καρπός και χέρι');
INSERT INTO `lang_definitions` VALUES (21415, 3285, 15, 'Προβλήματα καρπού ');
INSERT INTO `lang_definitions` VALUES (21416, 3286, 15, 'εγγραφή');
INSERT INTO `lang_definitions` VALUES (21417, 3288, 15, 'μερικά');
INSERT INTO `lang_definitions` VALUES (21418, 3290, 15, 'x Ακυρωθέν');
INSERT INTO `lang_definitions` VALUES (21419, 3291, 15, 'Ακτινογραφίες');
INSERT INTO `lang_definitions` VALUES (21420, 3292, 15, 'Εκτίμηση ακτινογραφιών:');
INSERT INTO `lang_definitions` VALUES (21421, 3293, 15, 'Εκτίμηση ακτινογραφιών:');
INSERT INTO `lang_definitions` VALUES (21422, 3295, 15, 'Συνεργάτης Χ12');
INSERT INTO `lang_definitions` VALUES (21423, 3296, 15, 'Συνεργάτες Χ12');
INSERT INTO `lang_definitions` VALUES (21424, 3297, 15, 'Υ');
INSERT INTO `lang_definitions` VALUES (21425, 3298, 15, 'έτος ');
INSERT INTO `lang_definitions` VALUES (21426, 3299, 15, 'Έτος ');
INSERT INTO `lang_definitions` VALUES (21427, 3300, 15, 'Προβολή Χρονιάς');
INSERT INTO `lang_definitions` VALUES (21428, 3301, 15, 'Έτος(η) ');
INSERT INTO `lang_definitions` VALUES (21429, 3302, 15, 'ΝΑΙ');
INSERT INTO `lang_definitions` VALUES (21430, 3303, 15, 'Ναι');
INSERT INTO `lang_definitions` VALUES (21431, 3304, 15, 'ναι');
INSERT INTO `lang_definitions` VALUES (21432, 3305, 15, 'ΝΑΙ!');
INSERT INTO `lang_definitions` VALUES (21433, 3306, 15, 'Ναι, διαγραφή και Log');
INSERT INTO `lang_definitions` VALUES (21434, 3307, 15, 'Ναι/Όχι ');
INSERT INTO `lang_definitions` VALUES (21435, 3308, 15, 'Ναι:');
INSERT INTO `lang_definitions` VALUES (21436, 3309, 15, 'Πρόκειται να αντικαταστήσετε μόνιμα το υπάρχον template. Είστε σίγουρος ότι θέλετε να συνεχίσετε;');
INSERT INTO `lang_definitions` VALUES (21437, 3310, 15, 'Δεν έχετε δικαίωμα να διαγράψετε αυτό το σύμβαμα');
INSERT INTO `lang_definitions` VALUES (21438, 3311, 15, 'Δεν έχετε δικαίωμα να τροποποιήσετε αυτό το σύμβαμα');
INSERT INTO `lang_definitions` VALUES (21439, 3312, 15, 'Δεν έχετε δικαίωμα για αυτό.');
INSERT INTO `lang_definitions` VALUES (21440, 3313, 15, 'Δεν έχετε δικαίωμα πρόσβασης αυτής την ομάδα. ');
INSERT INTO `lang_definitions` VALUES (21441, 3314, 15, 'Δεν έχετε δικαίωμα να προσθέσετε/επεξεργαστείτε διαγνώσεις');
INSERT INTO `lang_definitions` VALUES (21442, 3315, 15, 'Δεν έχετε δικαίωμα να δείτε αυτή την επίσκεψη.');
INSERT INTO `lang_definitions` VALUES (21443, 3316, 15, 'Δεν μπορείτε να προσπελάζεται αυτή τη λειτουργία άμεσα.');
INSERT INTO `lang_definitions` VALUES (21444, 3317, 15, 'Δεν μπορείτε να προσπελάζεται αυτή τη σελίδα άμεσα.');
INSERT INTO `lang_definitions` VALUES (21445, 3321, 15, 'Δεν έχετε επιλέξει καμία ενέργεια. ');
INSERT INTO `lang_definitions` VALUES (21446, 3322, 15, 'Δεν έχετε πρόσβαση να δείτε/επεξεργαστείτε αυτό το σημείωμα');
INSERT INTO `lang_definitions` VALUES (21447, 3324, 15, 'Πρέπει πρώτα να επιλέξετε ασθενή ή να προσθέσετε νέο');
INSERT INTO `lang_definitions` VALUES (21448, 3325, 15, 'Πρέπει πρώτα να επιλέξετε επίσκεψη ή να δημιουργήσετε νέα');
INSERT INTO `lang_definitions` VALUES (21449, 3326, 15, 'Πρέπει να επιλέξετε μερικά πεδία για να συνεχίσετε');
INSERT INTO `lang_definitions` VALUES (21450, 3327, 15, 'Θα πρέπει να εκτελείτε αυτή τη δοκιμή, εάν ο ισχυρισμός αυτός φαίνεται να παράγεται με επιτυχία αλλά το πραγματικό αρχείο αξίωσης δεν περιέχει δεδομένα ή μόνο ένα ημιτελές τμήμα του όγκου των δεδομένων που θα έπρεπε να περιέχει. Αυτό είναι προφανές με τις αξιώσεις HCFA επειδή είναι αναγνώσιμες από τον άνθρωπο, όμως με τις αξιώσεις X12 είναι πιο δύσκολη διαδικασία να προσδιοριστεί αν η αξίωση έχει ολοκληρωθεί δεόντως.');
INSERT INTO `lang_definitions` VALUES (21451, 3328, 15, 'Η ημερομηνία λήξης σας είναι άκυρη');
INSERT INTO `lang_definitions` VALUES (21452, 3329, 15, 'Η συνεδρία διαγράφηκε');
INSERT INTO `lang_definitions` VALUES (21453, 3330, 15, 'Η συνεδρία τροποποιήθηκε');
INSERT INTO `lang_definitions` VALUES (21454, 3331, 15, 'Έγινε καταχώρηση της συνεδρίας');
INSERT INTO `lang_definitions` VALUES (21455, 3332, 15, 'Το όνομα της λίστας έχει αλλάξει για να ανταποκρίνεται στις απαιτήσεις της ονοματοδοσίας. ');
INSERT INTO `lang_definitions` VALUES (21456, 3335, 15, 'Η συχνότητα επανάληψής σας πρέπει να είναι ακέραιος.');
INSERT INTO `lang_definitions` VALUES (21457, 3336, 15, 'Η συχνότητα επανάληψής σας πρέπει να είναι τουλάχιστον 1.');
INSERT INTO `lang_definitions` VALUES (21458, 3337, 15, 'Η ημερομηνία έναρξής σας είναι μεγαλύτερη από την ημερομηνία λήξης σας');
INSERT INTO `lang_definitions` VALUES (21459, 3338, 15, 'Η ημερομηνία έναρξής σας είναι άκυρη');
INSERT INTO `lang_definitions` VALUES (21460, 3339, 15, 'Η υποβολή σας απέτυχε');
INSERT INTO `lang_definitions` VALUES (21461, 3340, 15, 'εεεε-μμ-ηη ');
INSERT INTO `lang_definitions` VALUES (21462, 3341, 15, 'εεεε-μμ-ηη Ημερομηνία συνδεδεμένη με αυτό το έγγραφο');
INSERT INTO `lang_definitions` VALUES (21463, 3342, 15, 'εεεε-μμ-ηη Ημερομηνία καταστράφηκε');
INSERT INTO `lang_definitions` VALUES (21464, 3343, 15, 'εεεε-μμ-ηη Ημερομηνία γέννησης');
INSERT INTO `lang_definitions` VALUES (21465, 3344, 15, 'εεεε-μμ-ηη ημερομηνία γέννησης ');
INSERT INTO `lang_definitions` VALUES (21466, 3345, 15, 'εεεε-μμ-ηη Ημερομηνία λήξης');
INSERT INTO `lang_definitions` VALUES (21467, 3346, 15, 'εεεε-μμ-ηη Ημερομηνία έναρξης ή νοσηλείας');
INSERT INTO `lang_definitions` VALUES (21468, 3347, 15, 'εεεε-μμ-ηη ημερομηνία έναρξης, εγχείρησης ή έναρξης της αγωγής');
INSERT INTO `lang_definitions` VALUES (21469, 3348, 15, 'εεεε-μμ-ηη ημερομηνία ανάρρωσης ή διακοπής της αγωγής');
INSERT INTO `lang_definitions` VALUES (21470, 3350, 15, 'εεεε-μμ-ηη Ημερομηνία υπηρεσίας');
INSERT INTO `lang_definitions` VALUES (21471, 3351, 15, 'εεεε-μμ-ηη ημερομηνία αυτής της επιστολής');
INSERT INTO `lang_definitions` VALUES (21472, 3353, 15, 'εεεε-μμ-ηη ημερομηνία εγγράφου');
INSERT INTO `lang_definitions` VALUES (21473, 3354, 15, 'εεεε-μμ-ηη ημερομηνία συμβάματος ή ημερομηνία έναρξης');
INSERT INTO `lang_definitions` VALUES (21474, 3355, 15, 'εεεε-μμ-ηη τελευταία ημερομηνία αυτού του συμβάματος');
INSERT INTO `lang_definitions` VALUES (21475, 3356, 15, 'Μηδέν');
INSERT INTO `lang_definitions` VALUES (21476, 3357, 15, 'ΤΚ');
INSERT INTO `lang_definitions` VALUES (21477, 3358, 15, 'Τ.Κ ');
INSERT INTO `lang_definitions` VALUES (21478, 3359, 15, 'Τ.Κ/Χώρα:');
INSERT INTO `lang_definitions` VALUES (21479, 3360, 15, 'αλλά ήταν ');
INSERT INTO `lang_definitions` VALUES (21480, 3361, 15, 'δεν μπορούσε να προσπελαστεί. ');
INSERT INTO `lang_definitions` VALUES (21481, 3362, 15, 'Είστε σίγουροι ότι θέλετε να διαγράψετε ');
INSERT INTO `lang_definitions` VALUES (21482, 3363, 15, 'Φάρμακο');
INSERT INTO `lang_definitions` VALUES (21483, 3364, 15, 'μηνύματα email που δεν στάλθηκαν ');
INSERT INTO `lang_definitions` VALUES (21484, 3365, 15, 'από ');
INSERT INTO `lang_definitions` VALUES (21485, 3366, 15, 'έχει δημιουργηθεί. ');
INSERT INTO `lang_definitions` VALUES (21486, 3367, 15, 'έχει ανοιχθεί εκ νέου. ');
INSERT INTO `lang_definitions` VALUES (21487, 3368, 15, 'Ιστορικό');
INSERT INTO `lang_definitions` VALUES (21488, 3369, 15, 'δεν είναι αριθμός ');
INSERT INTO `lang_definitions` VALUES (21489, 3370, 15, 'είναι έτοιμο για επανα-χρέωση.');
INSERT INTO `lang_definitions` VALUES (21490, 3372, 15, 'Παρτίδα ');
INSERT INTO `lang_definitions` VALUES (21491, 3374, 15, 'λεπτ');
INSERT INTO `lang_definitions` VALUES (21492, 3375, 15, 'δεν βρέθηκε! ');
INSERT INTO `lang_definitions` VALUES (21493, 3376, 15, 'Ιδιομορφίες σε πολλούς φυλλομετρητές μπορεί να οδηγήσουν στο ότι η κάτωθι έξοδος εισάγετεται στην οθόνη σας με απότομα τινάγματα και ότι υπάρχουν μεγάλες παύσεις μερικών δευτερολέπτων, όπου φαίνεται όπως ότι πράγματα μπορεί να έχουν κάνει crash. Αυτό δεν συμβαίνει, θα δείτε τελικά την έξοδο να εμφανίζεται γραμμή προς γραμμή. Μπορεί να υπάρχουν διαδοχικοί αριθμοί που εμφανίζονται κατωτέρω, αυτό είναι ένδειξη ότι, ακόμη και αν τίποτα άλλο δεν εμφανίζεται, υπάρχει συνεχιζόμενη δραστηριότητα. Οι αριθμοί αυτοί θα είναι διάσπαρτοι με το περιεχόμενο της χρέωσης και αυτό είναι φυσιολογικό.');
INSERT INTO `lang_definitions` VALUES (21494, 3377, 15, 'η συνταγή έχει φτάσει το όριό της των');
INSERT INTO `lang_definitions` VALUES (21495, 3378, 15, 'μέχρι ');
INSERT INTO `lang_definitions` VALUES (21496, 3379, 15, 'η ενημέρωση απέτυχε, δεν είναι στη βάση δεδομένων; ');
INSERT INTO `lang_definitions` VALUES (21497, 3380, 15, 'χαρακτηρίστηκε ως χρεωμένο μόνο. ');
INSERT INTO `lang_definitions` VALUES (21498, 3381, 15, 'τοποθετήθηκε στην ουρά με επιτυχία. ');
INSERT INTO `lang_definitions` VALUES (21499, 3383, 15, '\" για τον κωδικό ');
INSERT INTO `lang_definitions` VALUES (21500, 3384, 15, '\" ΕΛΕΓΧΘΗΚΕ στις παραμέτρους του PostCalendar');
INSERT INTO `lang_definitions` VALUES (21501, 3386, 15, 'Αριθμ. δισκίων: ');
INSERT INTO `lang_definitions` VALUES (21502, 3387, 15, 'Ευρώ');
INSERT INTO `lang_definitions` VALUES (21503, 3388, 15, 'Ευρώ Η κωδικοποίηση έγινε');
INSERT INTO `lang_definitions` VALUES (21504, 3389, 15, '1 Ευρώ');
INSERT INTO `lang_definitions` VALUES (21505, 3390, 15, '$ετικέτα (εεεε-μμ-ηη): ');
INSERT INTO `lang_definitions` VALUES (21506, 3391, 15, '%');
INSERT INTO `lang_definitions` VALUES (21507, 3392, 15, '% Ακυρωθέντα < 24 ώρες ');
INSERT INTO `lang_definitions` VALUES (21508, 3393, 15, 'θα έπρεπε να υπήρχε, αλλά δεν υπάρχει. ');
INSERT INTO `lang_definitions` VALUES (21509, 3394, 15, '(το % ταιριάζει με οποιαδήποτε συμβολοσειρά, το _ ταιριάζει με οποιοδήποτε χαρακτήρα) ');
INSERT INTO `lang_definitions` VALUES (21510, 3395, 15, '(Πίσω) ');
INSERT INTO `lang_definitions` VALUES (21511, 3396, 15, '(κλικ για επεξεργασία)');
INSERT INTO `lang_definitions` VALUES (21512, 3397, 15, '(Περισσότερα) ');
INSERT INTO `lang_definitions` VALUES (21513, 3398, 15, '(Νέος Ασθενής) ');
INSERT INTO `lang_definitions` VALUES (21514, 3399, 15, '(Σημειώσεις και Άδειες)');
INSERT INTO `lang_definitions` VALUES (21515, 3400, 15, '(Σημειώσεις Ασθενή)');
INSERT INTO `lang_definitions` VALUES (21516, 3401, 15, '(Επιλέξτε έναν από αυτούς ή πληκτρολογήστε το δικό σας τίτλο) ');
INSERT INTO `lang_definitions` VALUES (21517, 3402, 15, '* Να γίνει Υπενθύμιση');
INSERT INTO `lang_definitions` VALUES (21518, 3403, 15, '** Παρακαλώ μεταφέρετε τα χειρουργεία στα Θέματα! ');
INSERT INTO `lang_definitions` VALUES (21519, 3404, 15, '*Απαραίτητο');
INSERT INTO `lang_definitions` VALUES (21520, 3406, 15, '.');
INSERT INTO `lang_definitions` VALUES (21521, 3407, 15, '0-10');
INSERT INTO `lang_definitions` VALUES (21522, 3408, 15, '1.Ανάπαυση 2. Πάγος για δύο ημέρες 3. Συμπίεση, αφήστε την πίεση στη θέση της, εκτός αν το πόδι αναπτύξει μούδιασμα ή ωχρό χρώμα 4. Ανυψώστε το πόδι και το κάτω άκρο');
INSERT INTO `lang_definitions` VALUES (21523, 3409, 15, '11/14/09');
INSERT INTO `lang_definitions` VALUES (21524, 3410, 15, '15-19');
INSERT INTO `lang_definitions` VALUES (21525, 3411, 15, '20-24');
INSERT INTO `lang_definitions` VALUES (21526, 3412, 15, '2111-13');
INSERT INTO `lang_definitions` VALUES (21527, 3413, 15, '25-29');
INSERT INTO `lang_definitions` VALUES (21528, 3414, 15, '2ο');
INSERT INTO `lang_definitions` VALUES (21529, 3415, 15, '3 μήνες');
INSERT INTO `lang_definitions` VALUES (21530, 3416, 15, '3 φορές ημερησίως');
INSERT INTO `lang_definitions` VALUES (21531, 3417, 15, '30-34');
INSERT INTO `lang_definitions` VALUES (21532, 3418, 15, '35-39');
INSERT INTO `lang_definitions` VALUES (21533, 3419, 15, '3ο');
INSERT INTO `lang_definitions` VALUES (21534, 3420, 15, '4 μήνες');
INSERT INTO `lang_definitions` VALUES (21535, 3421, 15, '4 φορές ημερησίως');
INSERT INTO `lang_definitions` VALUES (21536, 3422, 15, '40-44');
INSERT INTO `lang_definitions` VALUES (21537, 3423, 15, '45');
INSERT INTO `lang_definitions` VALUES (21538, 3424, 15, '465.9, λοίμωξη ανώτερου ουροποιητικού');
INSERT INTO `lang_definitions` VALUES (21539, 3425, 15, '466.0, Βρογχίτιδα, Οξεία Συνθετάση του ΝΟ');
INSERT INTO `lang_definitions` VALUES (21540, 3426, 15, '486.0, Πνευμονία, οξεία ');
INSERT INTO `lang_definitions` VALUES (21541, 3427, 15, '491.21, ΧΑΠ έξαρση ');
INSERT INTO `lang_definitions` VALUES (21542, 3428, 15, '491.8, Βρογχίτιδα, Χρόνια ');
INSERT INTO `lang_definitions` VALUES (21543, 3429, 15, '493.92, Άσθμα, οξεία έξαρση');
INSERT INTO `lang_definitions` VALUES (21544, 3430, 15, '496.0, ΧΑΠ ');
INSERT INTO `lang_definitions` VALUES (21545, 3431, 15, '4ο');
INSERT INTO `lang_definitions` VALUES (21546, 3432, 15, '519.7, Βρογχόσπασμος ');
INSERT INTO `lang_definitions` VALUES (21547, 3433, 15, '5ο');
INSERT INTO `lang_definitions` VALUES (21548, 3434, 15, '6 μήνες');
INSERT INTO `lang_definitions` VALUES (21549, 3435, 15, '6ο');
INSERT INTO `lang_definitions` VALUES (21550, 3436, 15, '824.0 Κάταγμα, έσω σφυρό, κλειστό ');
INSERT INTO `lang_definitions` VALUES (21551, 3437, 15, '824.2 Κάταγμα, έξω σφυρό, κλειστό ');
INSERT INTO `lang_definitions` VALUES (21552, 3438, 15, '824.6 Κάταγμα, τρισφύριο, κλειστό ');
INSERT INTO `lang_definitions` VALUES (21553, 3439, 15, '825.32 Κάταγμα, σκαφοειδούς (αστράγαλο) ');
INSERT INTO `lang_definitions` VALUES (21554, 3440, 15, '825.35 Κάταγμα, Βάση του πέμπτου (5ου) μεταταρσίου ');
INSERT INTO `lang_definitions` VALUES (21555, 3442, 15, '845.01 Διάστρεμμα έσω (δελτοειδικού) συνδ.');
INSERT INTO `lang_definitions` VALUES (21556, 3443, 15, '845.02 Διάστρεμμα, περονιαίας πτέρνας');
INSERT INTO `lang_definitions` VALUES (21557, 3444, 15, '99212 Βεβαιωμένο – ανεπίπλεκτο');
INSERT INTO `lang_definitions` VALUES (21558, 3445, 15, '99213 Βεβαιωμένο – ήπια πολυπλοκότητα');
INSERT INTO `lang_definitions` VALUES (21559, 3446, 15, '< Στο εξεταστήριο');
INSERT INTO `lang_definitions` VALUES (21560, 3447, 15, '> Αποχώρησε');
INSERT INTO `lang_definitions` VALUES (21561, 3448, 15, '? Μη εμφάνιση');
INSERT INTO `lang_definitions` VALUES (21562, 3449, 15, '@ Έφτασε');
INSERT INTO `lang_definitions` VALUES (21563, 3450, 15, '[Αλλαγή Προβολής]');
INSERT INTO `lang_definitions` VALUES (21564, 3451, 15, '[Ημερομηνία Τελευταίας επίσκεψης] ');
INSERT INTO `lang_definitions` VALUES (21565, 3452, 15, '[Ημέρες από την Τελευταία επίσκεψη] ');
INSERT INTO `lang_definitions` VALUES (21566, 3454, 15, '[Εξαγωγή ');
INSERT INTO `lang_definitions` VALUES (21567, 3455, 15, '[δεν συνιστάται]');
INSERT INTO `lang_definitions` VALUES (21568, 3456, 15, '[Αριθμός Επισκέψεων] ');
INSERT INTO `lang_definitions` VALUES (21569, 3457, 15, '[Αναφορές]');
INSERT INTO `lang_definitions` VALUES (21570, 3458, 15, '[Επιλογή Όλων]');
INSERT INTO `lang_definitions` VALUES (21571, 3459, 15, '[SQL-Ledger]');
INSERT INTO `lang_definitions` VALUES (21572, 3460, 15, '[Έναρξη Επεξεργασίας κατά Δέσμες] ');
INSERT INTO `lang_definitions` VALUES (21573, 3461, 15, '[Προβολή Log] ');
INSERT INTO `lang_definitions` VALUES (21574, 3462, 15, '[Προβολή Εκτυπώσιμης Αναφοράς] ');
INSERT INTO `lang_definitions` VALUES (21575, 3463, 15, '_PC_DUR_HOURS');
INSERT INTO `lang_definitions` VALUES (21576, 3464, 15, '_PC_DUR_MINUTES');
INSERT INTO `lang_definitions` VALUES (21577, 3465, 15, '_PC_LOCALE');
INSERT INTO `lang_definitions` VALUES (21578, 3466, 15, '~ Εφτασε καθυστερημένο');
INSERT INTO `lang_definitions` VALUES (21579, 37, 16, 'ACL Administration Not Authorised');
INSERT INTO `lang_definitions` VALUES (21580, 80, 16, 'Adding demographics is not authorised.');
INSERT INTO `lang_definitions` VALUES (21581, 260, 16, 'Authorisations');
INSERT INTO `lang_definitions` VALUES (21582, 261, 16, 'Authorise');
INSERT INTO `lang_definitions` VALUES (21583, 262, 16, 'Authorise - any encounters');
INSERT INTO `lang_definitions` VALUES (21584, 263, 16, 'Authorise - my encounters');
INSERT INTO `lang_definitions` VALUES (21585, 264, 16, 'Authorised');
INSERT INTO `lang_definitions` VALUES (21586, 360, 16, 'BOX 18. Hospitalisation date from (yyyy-mm-dd): ');
INSERT INTO `lang_definitions` VALUES (21587, 361, 16, 'BOX 18. Hospitalisation date to (yyyy-mm-dd): ');
INSERT INTO `lang_definitions` VALUES (21588, 364, 16, 'BOX 23. Prior Authorisation No. ');
INSERT INTO `lang_definitions` VALUES (21589, 420, 16, 'Cardiac Catheterisation');
INSERT INTO `lang_definitions` VALUES (21590, 509, 16, 'City, State Pin');
INSERT INTO `lang_definitions` VALUES (21591, 569, 16, 'Coding not authorised');
INSERT INTO `lang_definitions` VALUES (21592, 579, 16, 'Colour');
INSERT INTO `lang_definitions` VALUES (21593, 634, 16, 'Counselling');
INSERT INTO `lang_definitions` VALUES (21594, 635, 16, 'Counselling activities');
INSERT INTO `lang_definitions` VALUES (21595, 640, 16, 'district');
INSERT INTO `lang_definitions` VALUES (21596, 660, 16, 'Current day highlight colour');
INSERT INTO `lang_definitions` VALUES (21597, 695, 16, 'Date Immunisation Information Statements Given');
INSERT INTO `lang_definitions` VALUES (21598, 754, 16, 'Demographics not authorised');
INSERT INTO `lang_definitions` VALUES (21599, 755, 16, 'Demographics not authorised.');
INSERT INTO `lang_definitions` VALUES (21600, 826, 16, 'Do you wish to PERMANENTLY delete this immunisation record?');
INSERT INTO `lang_definitions` VALUES (21601, 965, 16, 'Encounters not authorised');
INSERT INTO `lang_definitions` VALUES (21602, 1060, 16, 'Exclusive Provider Organisation (EPO)');
INSERT INTO `lang_definitions` VALUES (21603, 1121, 16, 'Registration No');
INSERT INTO `lang_definitions` VALUES (21604, 1122, 16, 'TAN');
INSERT INTO `lang_definitions` VALUES (21605, 1123, 16, 'PAN ');
INSERT INTO `lang_definitions` VALUES (21606, 1311, 16, 'Health Maintenance Organisation');
INSERT INTO `lang_definitions` VALUES (21607, 1312, 16, 'Health Maintenance Organisation (HMO) Medicare Risk');
INSERT INTO `lang_definitions` VALUES (21608, 1411, 16, 'Immunisation');
INSERT INTO `lang_definitions` VALUES (21609, 1412, 16, 'Immunisation Lot Number');
INSERT INTO `lang_definitions` VALUES (21610, 1413, 16, 'Immunisation Manufacturer');
INSERT INTO `lang_definitions` VALUES (21611, 1414, 16, 'Immunisations');
INSERT INTO `lang_definitions` VALUES (21612, 1415, 16, 'Immunise');
INSERT INTO `lang_definitions` VALUES (21613, 1435, 16, 'Include Uncategorised');
INSERT INTO `lang_definitions` VALUES (21614, 1551, 16, 'Issues not authorised');
INSERT INTO `lang_definitions` VALUES (21615, 1828, 16, 'Name and Title of Immunisation Administrator');
INSERT INTO `lang_definitions` VALUES (21616, 1869, 16, 'New encounters not authorised');
INSERT INTO `lang_definitions` VALUES (21617, 1963, 16, 'Not authorised to access PostCalendar module');
INSERT INTO `lang_definitions` VALUES (21618, 1964, 16, 'Not authorised');
INSERT INTO `lang_definitions` VALUES (21619, 1965, 16, 'Not authorised for this squad.');
INSERT INTO `lang_definitions` VALUES (21620, 1977, 16, 'Note: This code was not entered by an authorised user. Only authorised codes may be uploaded to the Open Medical Billing Network for processing. If you wish to upload these codes, please select an authorised user here.');
INSERT INTO `lang_definitions` VALUES (21621, 1982, 16, 'Notes not authorised');
INSERT INTO `lang_definitions` VALUES (21622, 2055, 16, 'Organisation');
INSERT INTO `lang_definitions` VALUES (21623, 2056, 16, 'Organisations');
INSERT INTO `lang_definitions` VALUES (21624, 2135, 16, 'Patient Immunisation');
INSERT INTO `lang_definitions` VALUES (21625, 2263, 16, 'Post-Abortion Counselling');
INSERT INTO `lang_definitions` VALUES (21626, 2284, 16, 'Preferred Provider Organisation (PPO)');
INSERT INTO `lang_definitions` VALUES (21627, 2344, 16, 'Prior Authorisation Form');
INSERT INTO `lang_definitions` VALUES (21628, 2587, 16, 'Save Immunisation');
INSERT INTO `lang_definitions` VALUES (21629, 2609, 16, 'SE Pin Code');
INSERT INTO `lang_definitions` VALUES (21630, 2630, 16, 'See Authorisations');
INSERT INTO `lang_definitions` VALUES (21631, 2687, 16, 'Show Authorised Only');
INSERT INTO `lang_definitions` VALUES (21632, 2737, 16, 'Some authorisations were not displayed. Click here to view all');
INSERT INTO `lang_definitions` VALUES (21633, 2776, 16, 'UID');
INSERT INTO `lang_definitions` VALUES (21634, 2836, 16, 'Subscriber Employer Pin Code');
INSERT INTO `lang_definitions` VALUES (21635, 3095, 16, 'Unauthorised access.');
INSERT INTO `lang_definitions` VALUES (21636, 3130, 16, 'Updating demographics is not authorised.');
INSERT INTO `lang_definitions` VALUES (21637, 3312, 16, 'You are not authorised for this.');
INSERT INTO `lang_definitions` VALUES (21638, 3313, 16, 'You are not authorised to access this squad.');
INSERT INTO `lang_definitions` VALUES (21639, 3314, 16, 'You are not authorised to add/edit issues');
INSERT INTO `lang_definitions` VALUES (21640, 3315, 16, 'You are not authorised to see this encounter.');
INSERT INTO `lang_definitions` VALUES (21641, 3346, 16, 'yyyy-mm-dd Date of onset or hospitalisation');
INSERT INTO `lang_definitions` VALUES (21642, 3357, 16, 'Pin');
INSERT INTO `lang_definitions` VALUES (21643, 3358, 16, 'Pin Code');
INSERT INTO `lang_definitions` VALUES (21644, 3359, 16, 'Pin/Country');
INSERT INTO `lang_definitions` VALUES (21645, 3387, 16, 'INR');
INSERT INTO `lang_definitions` VALUES (21646, 3389, 16, 'INR1.00');
INSERT INTO `lang_definitions` VALUES (21647, 3399, 16, '(Notes and Authorisations)');
INSERT INTO `lang_definitions` VALUES (21648, 3408, 16, '1.Rest 2. Ice for two days 3. Compression, leave the dressing in place unless the foot develops numbness or pale colour 4. Elevate the foot and leg');
INSERT INTO `lang_definitions` VALUES (21649, 1, 17, 'Um');
INSERT INTO `lang_definitions` VALUES (21650, 2, 17, 'pagamento');
INSERT INTO `lang_definitions` VALUES (21651, 3, 17, 'Um formulario da vista do GCAC deve ser adicionado.');
INSERT INTO `lang_definitions` VALUES (21652, 4, 17, 'O numero do lote e necessario');
INSERT INTO `lang_definitions` VALUES (21653, 5, 17, 'Necessario o codigo IPPF');
INSERT INTO `lang_definitions` VALUES (21654, 6, 17, 'usuario');
INSERT INTO `lang_definitions` VALUES (21655, 7, 17, 'a.c.');
INSERT INTO `lang_definitions` VALUES (21656, 8, 17, 'a.m');
INSERT INTO `lang_definitions` VALUES (21657, 9, 17, 'A/F Nivel Direito');
INSERT INTO `lang_definitions` VALUES (21658, 10, 17, 'Abcesso');
INSERT INTO `lang_definitions` VALUES (21659, 11, 17, 'Abreviacao');
INSERT INTO `lang_definitions` VALUES (21660, 12, 17, 'Abcesso');
INSERT INTO `lang_definitions` VALUES (21661, 13, 17, 'Abdominal');
INSERT INTO `lang_definitions` VALUES (21662, 15, 17, 'Abn');
INSERT INTO `lang_definitions` VALUES (21663, 16, 17, 'ABN1');
INSERT INTO `lang_definitions` VALUES (21664, 17, 17, 'Anormal');
INSERT INTO `lang_definitions` VALUES (21665, 18, 17, 'Teste Sanguineo Anormal');
INSERT INTO `lang_definitions` VALUES (21666, 19, 17, 'Crescimento Anormal do Cabelo');
INSERT INTO `lang_definitions` VALUES (21667, 20, 17, 'Mamografia Anormal');
INSERT INTO `lang_definitions` VALUES (21668, 21, 17, 'Aborto');
INSERT INTO `lang_definitions` VALUES (21669, 22, 17, 'Casos de Abortos');
INSERT INTO `lang_definitions` VALUES (21670, 23, 17, 'Metodos de Abortar');
INSERT INTO `lang_definitions` VALUES (21671, 24, 17, 'Categorias Relacionadas com Abortos');
INSERT INTO `lang_definitions` VALUES (21672, 25, 17, 'Absorcoes');
INSERT INTO `lang_definitions` VALUES (21673, 26, 17, 'Ausências através de Diagnose');
INSERT INTO `lang_definitions` VALUES (21674, 27, 17, 'Aceite Tarefa');
INSERT INTO `lang_definitions` VALUES (21675, 28, 17, 'Aceite Pagamento para');
INSERT INTO `lang_definitions` VALUES (21676, 29, 17, 'Aceita Tarefa');
INSERT INTO `lang_definitions` VALUES (21677, 30, 17, 'Control de Access');
INSERT INTO `lang_definitions` VALUES (21678, 31, 17, 'Access Controle Lista Administração');
INSERT INTO `lang_definitions` VALUES (21679, 32, 17, 'Contabilidade');
INSERT INTO `lang_definitions` VALUES (21680, 33, 17, 'Dores');
INSERT INTO `lang_definitions` VALUES (21681, 35, 17, 'ACL');
INSERT INTO `lang_definitions` VALUES (21682, 36, 17, 'Administração de ACL');
INSERT INTO `lang_definitions` VALUES (21683, 37, 17, 'Administração de ACL não Autorizou');
INSERT INTO `lang_definitions` VALUES (21684, 38, 17, 'Acne');
INSERT INTO `lang_definitions` VALUES (21685, 39, 17, 'Ato');
INSERT INTO `lang_definitions` VALUES (21686, 40, 17, 'Data de ato');
INSERT INTO `lang_definitions` VALUES (21687, 41, 17, 'Ativo');
INSERT INTO `lang_definitions` VALUES (21688, 42, 17, 'Encontro ativo');
INSERT INTO `lang_definitions` VALUES (21689, 43, 17, 'Listas ativas');
INSERT INTO `lang_definitions` VALUES (21690, 44, 17, 'Paciente ativo');
INSERT INTO `lang_definitions` VALUES (21691, 45, 17, 'Tipo de atividade');
INSERT INTO `lang_definitions` VALUES (21692, 46, 17, 'Agudo em Crônico');
INSERT INTO `lang_definitions` VALUES (21693, 47, 17, 'Some');
INSERT INTO `lang_definitions` VALUES (21694, 49, 17, 'Some uma Companhia');
INSERT INTO `lang_definitions` VALUES (21695, 50, 17, 'Some uma Farmácia');
INSERT INTO `lang_definitions` VALUES (21696, 51, 17, 'some um evento para');
INSERT INTO `lang_definitions` VALUES (21697, 52, 17, 'Some como uma nota nova');
INSERT INTO `lang_definitions` VALUES (21698, 53, 17, 'Some como Novo');
INSERT INTO `lang_definitions` VALUES (21699, 54, 17, 'Some Categoria');
INSERT INTO `lang_definitions` VALUES (21700, 55, 17, 'Some Constante');
INSERT INTO `lang_definitions` VALUES (21701, 56, 17, 'Some Copay');
INSERT INTO `lang_definitions` VALUES (21702, 57, 17, 'Some Droga');
INSERT INTO `lang_definitions` VALUES (21703, 58, 17, 'Some Encontro');
INSERT INTO `lang_definitions` VALUES (21704, 59, 17, 'Some Facilidade');
INSERT INTO `lang_definitions` VALUES (21705, 60, 17, 'Some Campo');
INSERT INTO `lang_definitions` VALUES (21706, 61, 17, 'Some Grupo');
INSERT INTO `lang_definitions` VALUES (21707, 62, 17, 'Some Código de ICD');
INSERT INTO `lang_definitions` VALUES (21708, 63, 17, 'Some Assunto');
INSERT INTO `lang_definitions` VALUES (21709, 64, 17, 'Some Idioma');
INSERT INTO `lang_definitions` VALUES (21710, 65, 17, 'Some Novo');
INSERT INTO `lang_definitions` VALUES (21711, 66, 17, 'Some categoria nova:');
INSERT INTO `lang_definitions` VALUES (21712, 67, 17, 'Some Grupo Novo');
INSERT INTO `lang_definitions` VALUES (21713, 68, 17, 'Some Nota Nova');
INSERT INTO `lang_definitions` VALUES (21714, 69, 17, 'Some nota nova');
INSERT INTO `lang_definitions` VALUES (21715, 70, 17, 'Some o Sócio Novo');
INSERT INTO `lang_definitions` VALUES (21716, 71, 17, 'Some Nota');
INSERT INTO `lang_definitions` VALUES (21717, 72, 17, 'Some Registro Paciente');
INSERT INTO `lang_definitions` VALUES (21718, 73, 17, 'Some Prescrição');
INSERT INTO `lang_definitions` VALUES (21719, 75, 17, 'Acrescente a Lista de Medicamento');
INSERT INTO `lang_definitions` VALUES (21720, 76, 17, 'Some Transação');
INSERT INTO `lang_definitions` VALUES (21721, 77, 17, 'Some o Usuário');
INSERT INTO `lang_definitions` VALUES (21722, 78, 17, 'Some o Usuário para Se agrupar');
INSERT INTO `lang_definitions` VALUES (21723, 79, 17, 'somado');
INSERT INTO `lang_definitions` VALUES (21724, 80, 17, 'Somando demographics não é autorizado.');
INSERT INTO `lang_definitions` VALUES (21725, 81, 17, 'Addison Syndrom');
INSERT INTO `lang_definitions` VALUES (21726, 82, 17, 'Síndrome de Addison');
INSERT INTO `lang_definitions` VALUES (21727, 83, 17, 'Diagnose adicional:');
INSERT INTO `lang_definitions` VALUES (21728, 84, 17, 'História adicional');
INSERT INTO `lang_definitions` VALUES (21729, 85, 17, 'Notas de história adicionais');
INSERT INTO `lang_definitions` VALUES (21730, 86, 17, 'Info adicional');
INSERT INTO `lang_definitions` VALUES (21731, 87, 17, 'Laboratórios adicionais');
INSERT INTO `lang_definitions` VALUES (21732, 88, 17, 'Notas adicionais');
INSERT INTO `lang_definitions` VALUES (21733, 89, 17, 'Notas adicionais:');
INSERT INTO `lang_definitions` VALUES (21734, 90, 17, 'Notas adicionais:');
INSERT INTO `lang_definitions` VALUES (21735, 91, 17, 'Notas de RADIOGRAFIA adicionais:');
INSERT INTO `lang_definitions` VALUES (21736, 92, 17, 'addonly');
INSERT INTO `lang_definitions` VALUES (21737, 93, 17, 'Addr Bk');
INSERT INTO `lang_definitions` VALUES (21738, 94, 17, 'Addr Book');
INSERT INTO `lang_definitions` VALUES (21739, 95, 17, 'Endereço');
INSERT INTO `lang_definitions` VALUES (21740, 96, 17, 'Agenda de endereços');
INSERT INTO `lang_definitions` VALUES (21741, 97, 17, 'Address1');
INSERT INTO `lang_definitions` VALUES (21742, 98, 17, 'Address2');
INSERT INTO `lang_definitions` VALUES (21743, 99, 17, 'Adj');
INSERT INTO `lang_definitions` VALUES (21744, 100, 17, 'Ajuste');
INSERT INTO `lang_definitions` VALUES (21745, 101, 17, 'Razões de ajuste');
INSERT INTO `lang_definitions` VALUES (21746, 102, 17, 'Valor de ajuste para código');
INSERT INTO `lang_definitions` VALUES (21747, 103, 17, 'Ajustes');
INSERT INTO `lang_definitions` VALUES (21748, 104, 17, 'Adm ajustam');
INSERT INTO `lang_definitions` VALUES (21749, 105, 17, 'Admin');
INSERT INTO `lang_definitions` VALUES (21750, 106, 17, 'Admin E-mail Endereço');
INSERT INTO `lang_definitions` VALUES (21751, 107, 17, 'Administrado');
INSERT INTO `lang_definitions` VALUES (21752, 108, 17, 'Administrado Por');
INSERT INTO `lang_definitions` VALUES (21753, 109, 17, 'Administração');
INSERT INTO `lang_definitions` VALUES (21754, 110, 17, 'Administradores');
INSERT INTO `lang_definitions` VALUES (21755, 111, 17, 'Administradores podem fazer qualquer coisa');
INSERT INTO `lang_definitions` VALUES (21756, 112, 17, 'Avançado');
INSERT INTO `lang_definitions` VALUES (21757, 113, 17, 'Conselho');
INSERT INTO `lang_definitions` VALUES (21758, 114, 17, 'Afete normal');
INSERT INTO `lang_definitions` VALUES (21759, 115, 17, 'Depois que chamadas de hrs');
INSERT INTO `lang_definitions` VALUES (21760, 116, 17, 'Depois de salvar o PDF, clique [Tronco de Visão] conferir para erros.');
INSERT INTO `lang_definitions` VALUES (21761, 117, 17, 'Depois de economizar seu grupo, clique [Tronco de Visão] conferir para erros.');
INSERT INTO `lang_definitions` VALUES (21762, 118, 17, 'Depois que na informação é entrada corretamente, clique o Economize botão.');
INSERT INTO `lang_definitions` VALUES (21763, 119, 17, 'Novamente');
INSERT INTO `lang_definitions` VALUES (21764, 120, 17, 'Idade');
INSERT INTO `lang_definitions` VALUES (21765, 121, 17, 'Envelheça Por');
INSERT INTO `lang_definitions` VALUES (21766, 122, 17, 'Categoria de idade');
INSERT INTO `lang_definitions` VALUES (21767, 123, 17, 'Dados de idade é fora do alcance.');
INSERT INTO `lang_definitions` VALUES (21768, 124, 17, 'Formato de idade para \"idade de\" não é válido');
INSERT INTO `lang_definitions` VALUES (21769, 125, 17, 'Formato de idade para \"idade até\" não é válido');
INSERT INTO `lang_definitions` VALUES (21770, 126, 17, 'Envelheça De');
INSERT INTO `lang_definitions` VALUES (21771, 127, 17, 'Envelhecendo Colunas:');
INSERT INTO `lang_definitions` VALUES (21772, 128, 17, 'Álcool');
INSERT INTO `lang_definitions` VALUES (21773, 129, 17, 'Consumo de álcool');
INSERT INTO `lang_definitions` VALUES (21774, 130, 17, 'Tudo');
INSERT INTO `lang_definitions` VALUES (21775, 131, 17, 'Todas as Categorias');
INSERT INTO `lang_definitions` VALUES (21776, 132, 17, 'Todo o Dia');
INSERT INTO `lang_definitions` VALUES (21777, 133, 17, 'Todo o evento de dia');
INSERT INTO `lang_definitions` VALUES (21778, 134, 17, 'Todas as Instalações');
INSERT INTO `lang_definitions` VALUES (21779, 135, 17, 'Tudo ou parte do nome próprio');
INSERT INTO `lang_definitions` VALUES (21780, 136, 17, 'Tudo ou parte do último nome');
INSERT INTO `lang_definitions` VALUES (21781, 137, 17, 'Todos os Provedores');
INSERT INTO `lang_definitions` VALUES (21782, 138, 17, 'Tudo Revisaram e Negam:');
INSERT INTO `lang_definitions` VALUES (21783, 139, 17, 'Todos os Tópicos');
INSERT INTO `lang_definitions` VALUES (21784, 140, 17, 'Todos os Usuários');
INSERT INTO `lang_definitions` VALUES (21785, 141, 17, 'Alérgico');
INSERT INTO `lang_definitions` VALUES (21786, 142, 17, 'Alergias');
INSERT INTO `lang_definitions` VALUES (21787, 143, 17, 'Alergias:');
INSERT INTO `lang_definitions` VALUES (21788, 144, 17, 'Alergia');
INSERT INTO `lang_definitions` VALUES (21789, 145, 17, 'Permita E-mail');
INSERT INTO `lang_definitions` VALUES (21790, 146, 17, 'Permita mensagens de e-mail?');
INSERT INTO `lang_definitions` VALUES (21791, 147, 17, 'Permita E-mail?');
INSERT INTO `lang_definitions` VALUES (21792, 148, 17, 'Permita Mensagem de Correio');
INSERT INTO `lang_definitions` VALUES (21793, 149, 17, 'Permita SMS');
INSERT INTO `lang_definitions` VALUES (21794, 150, 17, 'Permita SMS (mensagens de texto)?');
INSERT INTO `lang_definitions` VALUES (21795, 151, 17, 'Permita fazer eventos submetidos imediatamente ativo?');
INSERT INTO `lang_definitions` VALUES (21796, 152, 17, 'Permita mensagens de telefone?');
INSERT INTO `lang_definitions` VALUES (21797, 153, 17, 'Permita os usuários para publicar Eventos Globais');
INSERT INTO `lang_definitions` VALUES (21798, 154, 17, 'Permita os usuários para publicar Calendários Pessoais');
INSERT INTO `lang_definitions` VALUES (21799, 155, 17, 'Permita Mensagem de Voz');
INSERT INTO `lang_definitions` VALUES (21800, 156, 17, 'Permitido');
INSERT INTO `lang_definitions` VALUES (21801, 157, 17, 'já existe.');
INSERT INTO `lang_definitions` VALUES (21802, 158, 17, 'Já usado, escolha outro identificador');
INSERT INTO `lang_definitions` VALUES (21803, 159, 17, 'Já usado, escolha outro título');
INSERT INTO `lang_definitions` VALUES (21804, 160, 17, 'Alt Address');
INSERT INTO `lang_definitions` VALUES (21805, 162, 17, 'Alternativamente, você pode usar a página de procura para transferir uma remessa eletrônica (X12 835) arquivo que você obteve de seu pagador ou clearinghouse. Você pode fazer isto clicando o Folheie botão e selecionando o arquivo para transferir, e clicando Procura então para executar a carga e exibir as faturas correspondentes. Neste caso não aplicam os outros parâmetros mencionados acima e serão ignorados. Transferindo economiza o arquivo mas ainda não processa seus conteúdos--isso é separadamente terminado como descrito abaixo.');
INSERT INTO `lang_definitions` VALUES (21806, 163, 17, 'É');
INSERT INTO `lang_definitions` VALUES (21807, 164, 17, 'Emende Nota Existente');
INSERT INTO `lang_definitions` VALUES (21808, 165, 17, 'AMEX');
INSERT INTO `lang_definitions` VALUES (21809, 166, 17, 'Quantia');
INSERT INTO `lang_definitions` VALUES (21810, 167, 17, 'Custos de quantia');
INSERT INTO `lang_definitions` VALUES (21811, 168, 17, 'Chegue para Equilíbrio Passado');
INSERT INTO `lang_definitions` VALUES (21812, 169, 17, 'Chegue para Esta Visita');
INSERT INTO `lang_definitions` VALUES (21813, 170, 17, 'Quantia Pagou');
INSERT INTO `lang_definitions` VALUES (21814, 171, 17, 'Quantia:');
INSERT INTO `lang_definitions` VALUES (21815, 175, 17, 'Um assunto de GCAC incompleto foi criado e foi unido. Alguém precisará completar isto depois.');
INSERT INTO `lang_definitions` VALUES (21816, 176, 17, 'E');
INSERT INTO `lang_definitions` VALUES (21817, 177, 17, 'E');
INSERT INTO `lang_definitions` VALUES (21818, 178, 17, 'e');
INSERT INTO `lang_definitions` VALUES (21819, 179, 17, 'e');
INSERT INTO `lang_definitions` VALUES (21820, 180, 17, 'e todos os dados de subordinado? Esta ação será anotada');
INSERT INTO `lang_definitions` VALUES (21821, 181, 17, 'Anemia');
INSERT INTO `lang_definitions` VALUES (21822, 182, 17, 'Tornozelo');
INSERT INTO `lang_definitions` VALUES (21823, 183, 17, 'Tornozelo + salto de sapato');
INSERT INTO `lang_definitions` VALUES (21824, 184, 17, 'Forma de Avaliação de tornozelo');
INSERT INTO `lang_definitions` VALUES (21825, 185, 17, 'Problemas de tornozelo');
INSERT INTO `lang_definitions` VALUES (21826, 186, 17, 'Ankylosing Sondlilitis');
INSERT INTO `lang_definitions` VALUES (21827, 187, 17, 'Ankylosing Spondlilitis');
INSERT INTO `lang_definitions` VALUES (21828, 188, 17, 'Anorexia');
INSERT INTO `lang_definitions` VALUES (21829, 189, 17, 'Outra coisa que você pode fazer na janela postando é pedido faturamento secundário. Se você selecionar este checkbox antes de economizar, então a reivindicação original será re-aberta e será feita fila na página de Faturamento, e será processado durante a próxima corrida de faturamento.');
INSERT INTO `lang_definitions` VALUES (21830, 190, 17, 'parada');
INSERT INTO `lang_definitions` VALUES (21831, 191, 17, 'Nl de ânus, nenhum tenderness/mass retal,');
INSERT INTO `lang_definitions` VALUES (21832, 192, 17, 'Ansiedade');
INSERT INTO `lang_definitions` VALUES (21833, 193, 17, 'Qualquer');
INSERT INTO `lang_definitions` VALUES (21834, 194, 17, 'Qualquer Categoria');
INSERT INTO `lang_definitions` VALUES (21835, 195, 17, 'Qualquer parte do código desejado ou sua descrição');
INSERT INTO `lang_definitions` VALUES (21836, 196, 17, 'Qualquer parte da especialidade desejada');
INSERT INTO `lang_definitions` VALUES (21837, 197, 17, 'Qualquer parte do nome paciente, ou \"last,first \", ou \"X-Y \"');
INSERT INTO `lang_definitions` VALUES (21838, 198, 17, 'Apnéia');
INSERT INTO `lang_definitions` VALUES (21839, 199, 17, 'Aparecimento');
INSERT INTO `lang_definitions` VALUES (21840, 200, 17, 'Aparecimento:');
INSERT INTO `lang_definitions` VALUES (21841, 201, 17, 'Junte à nota existente');
INSERT INTO `lang_definitions` VALUES (21842, 202, 17, 'Junte a esta nota');
INSERT INTO `lang_definitions` VALUES (21843, 203, 17, 'Junte a Esta Nota');
INSERT INTO `lang_definitions` VALUES (21844, 204, 17, 'Apendicectomia');
INSERT INTO `lang_definitions` VALUES (21845, 206, 17, 'aplique a área afetada');
INSERT INTO `lang_definitions` VALUES (21846, 207, 17, 'aplique para esfolar');
INSERT INTO `lang_definitions` VALUES (21847, 208, 17, 'Aplicando');
INSERT INTO `lang_definitions` VALUES (21848, 209, 17, 'Data de compromisso');
INSERT INTO `lang_definitions` VALUES (21849, 210, 17, 'Estado de compromisso');
INSERT INTO `lang_definitions` VALUES (21850, 211, 17, 'Compromisso dentro');
INSERT INTO `lang_definitions` VALUES (21851, 212, 17, 'Compromissos');
INSERT INTO `lang_definitions` VALUES (21852, 213, 17, 'Compromissos (escreva opcional)');
INSERT INTO `lang_definitions` VALUES (21853, 214, 17, 'Compromissos e Encontros');
INSERT INTO `lang_definitions` VALUES (21854, 215, 17, 'Compromissos Informam');
INSERT INTO `lang_definitions` VALUES (21855, 216, 17, 'Compromisso-encontros Informam');
INSERT INTO `lang_definitions` VALUES (21856, 217, 17, 'Aprove');
INSERT INTO `lang_definitions` VALUES (21857, 218, 17, 'Aprovado');
INSERT INTO `lang_definitions` VALUES (21858, 219, 17, 'Administração de Eventos aprovada');
INSERT INTO `lang_definitions` VALUES (21859, 220, 17, 'Appt-Enc');
INSERT INTO `lang_definitions` VALUES (21860, 221, 17, 'Appts');
INSERT INTO `lang_definitions` VALUES (21861, 222, 17, 'Abril');
INSERT INTO `lang_definitions` VALUES (21862, 224, 17, 'Você é preparado completar um GCAC novo emita para esta visita?');
INSERT INTO `lang_definitions` VALUES (21863, 225, 17, 'Você está seguro você quer aprovar estes eventos?');
INSERT INTO `lang_definitions` VALUES (21864, 226, 17, 'Você está seguro você quer remover esta forma completamente?');
INSERT INTO `lang_definitions` VALUES (21865, 227, 17, 'Você está seguro você quer apagar este evento?');
INSERT INTO `lang_definitions` VALUES (21866, 229, 17, 'Você está seguro você quer apagar esta nota?');
INSERT INTO `lang_definitions` VALUES (21867, 230, 17, 'Você está seguro você quer editar estes eventos?');
INSERT INTO `lang_definitions` VALUES (21868, 231, 17, 'Você está seguro você quer esconder estes eventos?');
INSERT INTO `lang_definitions` VALUES (21869, 232, 17, 'Você está seguro você quer ver estes eventos?');
INSERT INTO `lang_definitions` VALUES (21870, 233, 17, 'É você seguro você deseja apagar o grupo inteiro nomeado');
INSERT INTO `lang_definitions` VALUES (21871, 234, 17, 'É você seguro você deseja apagar a lista inteira');
INSERT INTO `lang_definitions` VALUES (21872, 235, 17, 'É você seguro você deseja apagar o campo dentro');
INSERT INTO `lang_definitions` VALUES (21873, 236, 17, 'Você está seguro você deseja apagar os campos selecionados?');
INSERT INTO `lang_definitions` VALUES (21874, 237, 17, 'Você é seguramente você \'d gostam de continuar com estas ações?');
INSERT INTO `lang_definitions` VALUES (21875, 238, 17, 'Área não especificou');
INSERT INTO `lang_definitions` VALUES (21876, 239, 17, 'Armênio');
INSERT INTO `lang_definitions` VALUES (21877, 240, 17, 'Arrythmia');
INSERT INTO `lang_definitions` VALUES (21878, 241, 17, 'Artrite');
INSERT INTO `lang_definitions` VALUES (21879, 242, 17, 'Artrite / degen diseas em comum');
INSERT INTO `lang_definitions` VALUES (21880, 243, 17, 'Artrite / degen doença em comum');
INSERT INTO `lang_definitions` VALUES (21881, 244, 17, 'como');
INSERT INTO `lang_definitions` VALUES (21882, 245, 17, 'A partir de');
INSERT INTO `lang_definitions` VALUES (21883, 246, 17, 'Asiático');
INSERT INTO `lang_definitions` VALUES (21884, 247, 17, 'Avaliação');
INSERT INTO `lang_definitions` VALUES (21885, 248, 17, 'Nomeado');
INSERT INTO `lang_definitions` VALUES (21886, 249, 17, 'Assistente');
INSERT INTO `lang_definitions` VALUES (21887, 250, 17, 'Asma');
INSERT INTO `lang_definitions` VALUES (21888, 251, 17, 'a');
INSERT INTO `lang_definitions` VALUES (21889, 252, 17, 'Ao Navicular');
INSERT INTO `lang_definitions` VALUES (21890, 253, 17, 'Ao Navicular:');
INSERT INTO `lang_definitions` VALUES (21891, 254, 17, 'Athletic/Injury');
INSERT INTO `lang_definitions` VALUES (21892, 255, 17, 'Atenção');
INSERT INTO `lang_definitions` VALUES (21893, 256, 17, 'Attn');
INSERT INTO `lang_definitions` VALUES (21894, 257, 17, 'Agosto');
INSERT INTO `lang_definitions` VALUES (21895, 258, 17, 'Auth');
INSERT INTO `lang_definitions` VALUES (21896, 259, 17, 'Auth/notes');
INSERT INTO `lang_definitions` VALUES (21897, 260, 17, 'Autorizações');
INSERT INTO `lang_definitions` VALUES (21898, 261, 17, 'Autorize');
INSERT INTO `lang_definitions` VALUES (21899, 262, 17, 'Autorize - qualquer encontro');
INSERT INTO `lang_definitions` VALUES (21900, 263, 17, 'Autorize - meus encontros');
INSERT INTO `lang_definitions` VALUES (21901, 264, 17, 'Autorizado');
INSERT INTO `lang_definitions` VALUES (21902, 265, 17, 'Auto Envia');
INSERT INTO `lang_definitions` VALUES (21903, 266, 17, 'Auto-gerado');
INSERT INTO `lang_definitions` VALUES (21904, 267, 17, 'Exame médico automóvel');
INSERT INTO `lang_definitions` VALUES (21905, 268, 17, 'autosaved');
INSERT INTO `lang_definitions` VALUES (21906, 269, 17, 'Times disponível');
INSERT INTO `lang_definitions` VALUES (21907, 270, 17, 'Avulsão / fratura de avulsão');
INSERT INTO `lang_definitions` VALUES (21908, 271, 17, 'Avulsão malleolus lateral');
INSERT INTO `lang_definitions` VALUES (21909, 272, 17, 'Avulsão malleolus mediano');
INSERT INTO `lang_definitions` VALUES (21910, 273, 17, 'Consciência-baseado');
INSERT INTO `lang_definitions` VALUES (21911, 274, 17, 'Axilar');
INSERT INTO `lang_definitions` VALUES (21912, 275, 17, 'b.i.d.');
INSERT INTO `lang_definitions` VALUES (21913, 276, 17, 'atrás');
INSERT INTO `lang_definitions` VALUES (21914, 277, 17, 'Atrás');
INSERT INTO `lang_definitions` VALUES (21915, 284, 17, 'Atrás Problemas');
INSERT INTO `lang_definitions` VALUES (21916, 287, 17, 'Atrás Cirurgia');
INSERT INTO `lang_definitions` VALUES (21917, 292, 17, 'Auxílio');
INSERT INTO `lang_definitions` VALUES (21918, 293, 17, 'Arquivo reserva foi criado. Enviará carregamento agora.');
INSERT INTO `lang_definitions` VALUES (21919, 294, 17, 'Cheque sem fundo');
INSERT INTO `lang_definitions` VALUES (21920, 295, 17, 'Dívida incobrável');
INSERT INTO `lang_definitions` VALUES (21921, 296, 17, 'Bahasa Indonésia');
INSERT INTO `lang_definitions` VALUES (21922, 297, 17, 'Bal');
INSERT INTO `lang_definitions` VALUES (21923, 298, 17, 'Equilíbrio');
INSERT INTO `lang_definitions` VALUES (21924, 299, 17, 'equilíbrio');
INSERT INTO `lang_definitions` VALUES (21925, 300, 17, 'Equilibre Devido');
INSERT INTO `lang_definitions` VALUES (21926, 301, 17, 'Base de quinto (5º) Metarsal');
INSERT INTO `lang_definitions` VALUES (21927, 302, 17, 'Base de quinto (5º) Metarsal:');
INSERT INTO `lang_definitions` VALUES (21928, 303, 17, 'Ferramenta de Comunicação de grupo');
INSERT INTO `lang_definitions` VALUES (21929, 304, 17, 'Processamento em lote iniciou; isto pode demorar um tempo.');
INSERT INTO `lang_definitions` VALUES (21930, 305, 17, 'BatchCom');
INSERT INTO `lang_definitions` VALUES (21931, 306, 17, 'porque aquele id não existe.');
INSERT INTO `lang_definitions` VALUES (21932, 307, 17, 'Comece');
INSERT INTO `lang_definitions` VALUES (21933, 308, 17, 'Comece Data');
INSERT INTO `lang_definitions` VALUES (21934, 309, 17, 'Data começando de yyyy-mm-dd de serviço');
INSERT INTO `lang_definitions` VALUES (21935, 310, 17, 'Arrotando');
INSERT INTO `lang_definitions` VALUES (21936, 311, 17, 'entre');
INSERT INTO `lang_definitions` VALUES (21937, 312, 17, 'Bilateral:');
INSERT INTO `lang_definitions` VALUES (21938, 313, 17, 'Bill Date:');
INSERT INTO `lang_definitions` VALUES (21939, 314, 17, 'Bill/Collect');
INSERT INTO `lang_definitions` VALUES (21940, 315, 17, 'Faturado');
INSERT INTO `lang_definitions` VALUES (21941, 316, 17, 'Faturando');
INSERT INTO `lang_definitions` VALUES (21942, 317, 17, 'Faturando (escreva opcional)');
INSERT INTO `lang_definitions` VALUES (21943, 318, 17, 'Attn faturando');
INSERT INTO `lang_definitions` VALUES (21944, 319, 17, 'Código faturando para Serviço Pedido');
INSERT INTO `lang_definitions` VALUES (21945, 320, 17, 'Códigos faturando');
INSERT INTO `lang_definitions` VALUES (21946, 321, 17, 'Informação faturando');
INSERT INTO `lang_definitions` VALUES (21947, 322, 17, 'Local faturando');
INSERT INTO `lang_definitions` VALUES (21948, 323, 17, 'Nota faturando');
INSERT INTO `lang_definitions` VALUES (21949, 324, 17, 'Nota faturando para');
INSERT INTO `lang_definitions` VALUES (21950, 325, 17, 'Nota faturando:');
INSERT INTO `lang_definitions` VALUES (21951, 326, 17, 'Resultados de fila faturando:');
INSERT INTO `lang_definitions` VALUES (21952, 327, 17, 'Relatório faturando');
INSERT INTO `lang_definitions` VALUES (21953, 328, 17, 'faturando');
INSERT INTO `lang_definitions` VALUES (21954, 329, 17, 'Biópsia');
INSERT INTO `lang_definitions` VALUES (21955, 330, 17, 'Data de aniversário');
INSERT INTO `lang_definitions` VALUES (21956, 331, 17, 'Preto');
INSERT INTO `lang_definitions` VALUES (21957, 332, 17, 'Câncer de bexiga');
INSERT INTO `lang_definitions` VALUES (21958, 333, 17, 'Infecções de bexiga');
INSERT INTO `lang_definitions` VALUES (21959, 334, 17, 'Formas de espaço em branco');
INSERT INTO `lang_definitions` VALUES (21960, 335, 17, 'Sangrando Problemas');
INSERT INTO `lang_definitions` VALUES (21961, 336, 17, 'Manchas de cortina');
INSERT INTO `lang_definitions` VALUES (21962, 337, 17, 'Inchando');
INSERT INTO `lang_definitions` VALUES (21963, 338, 17, 'Bloqueado');
INSERT INTO `lang_definitions` VALUES (21964, 339, 17, 'Pressão sanguínea');
INSERT INTO `lang_definitions` VALUES (21965, 340, 17, 'Pressão sanguínea');
INSERT INTO `lang_definitions` VALUES (21966, 341, 17, 'Nariz sangrento');
INSERT INTO `lang_definitions` VALUES (21967, 342, 17, 'Cruz azul Proteção Azul');
INSERT INTO `lang_definitions` VALUES (21968, 343, 17, 'Linhas azuis neste relatório são informador. Linhas de preto mostram informação existente previamente. Mudanças de espetáculo de linhas verdes que eram prosperamente aplicadas. Linhas vermelhas indicam erros, ou mudanças que não eram aplicadas; estes devem ser processados manualmente. Não são controladas reivindicações atualmente negadas e reversões de pagamento automaticamente e assim se aparecerá dentro vermelho.');
INSERT INTO `lang_definitions` VALUES (21969, 344, 17, 'Visão borrada');
INSERT INTO `lang_definitions` VALUES (21970, 345, 17, 'BMI');
INSERT INTO `lang_definitions` VALUES (21971, 346, 17, 'Estado de BMI');
INSERT INTO `lang_definitions` VALUES (21972, 347, 17, 'Região de corpo');
INSERT INTO `lang_definitions` VALUES (21973, 348, 17, 'Desosse Ternura:');
INSERT INTO `lang_definitions` VALUES (21974, 349, 17, 'Desosse Ternura: Malleolus mediano');
INSERT INTO `lang_definitions` VALUES (21975, 350, 17, 'Booleano');
INSERT INTO `lang_definitions` VALUES (21976, 351, 17, 'Bot');
INSERT INTO `lang_definitions` VALUES (21977, 352, 17, 'Ambas as Orelhas');
INSERT INTO `lang_definitions` VALUES (21978, 353, 17, 'ambas as orelhas');
INSERT INTO `lang_definitions` VALUES (21979, 354, 17, 'Fundo');
INSERT INTO `lang_definitions` VALUES (21980, 355, 17, 'ENCAIXOTE 10 Emprego de A. relacionado');
INSERT INTO `lang_definitions` VALUES (21981, 356, 17, 'ENCAIXOTE 10 B. Acidente Automático');
INSERT INTO `lang_definitions` VALUES (21982, 357, 17, 'ENCAIXOTE 10 C. Outro Acidente');
INSERT INTO `lang_definitions` VALUES (21983, 358, 17, 'ENCAIXOTE 16. Data incapaz trabalhar de (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (21984, 359, 17, 'ENCAIXOTE 16. Data incapaz trabalhar (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (21985, 360, 17, 'ENCAIXOTE 18. Data de hospitalização de (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (21986, 361, 17, 'ENCAIXOTE 18. Data de hospitalização para (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (21987, 362, 17, 'ENCAIXOTE 20. Está Fora de Laboratório usado?');
INSERT INTO `lang_definitions` VALUES (21988, 363, 17, 'ENCAIXOTE 22. Medicaid Resubmission Código (ICD-9)');
INSERT INTO `lang_definitions` VALUES (21989, 364, 17, 'ENCAIXOTE 23. Autorização anterior Não.');
INSERT INTO `lang_definitions` VALUES (21990, 366, 17, 'BP Diastolic');
INSERT INTO `lang_definitions` VALUES (21991, 367, 17, 'BP Systolic');
INSERT INTO `lang_definitions` VALUES (21992, 368, 17, 'Bpd');
INSERT INTO `lang_definitions` VALUES (21993, 369, 17, 'Bps');
INSERT INTO `lang_definitions` VALUES (21994, 370, 17, 'Brasileiro o português');
INSERT INTO `lang_definitions` VALUES (21995, 371, 17, 'Peito');
INSERT INTO `lang_definitions` VALUES (21996, 372, 17, 'Enfrente Biópsia');
INSERT INTO `lang_definitions` VALUES (21997, 373, 17, 'Descarga de peito');
INSERT INTO `lang_definitions` VALUES (21998, 374, 17, 'Doença de peito');
INSERT INTO `lang_definitions` VALUES (21999, 375, 17, 'Enfrente Exame');
INSERT INTO `lang_definitions` VALUES (22000, 376, 17, 'Massa de peito');
INSERT INTO `lang_definitions` VALUES (22001, 377, 17, 'Sons de respiração:');
INSERT INTO `lang_definitions` VALUES (22002, 378, 17, 'Ossos quebrados');
INSERT INTO `lang_definitions` VALUES (22003, 379, 17, 'Bronquites Formam');
INSERT INTO `lang_definitions` VALUES (22004, 380, 17, 'Folheie');
INSERT INTO `lang_definitions` VALUES (22005, 381, 17, 'Paste para Registro');
INSERT INTO `lang_definitions` VALUES (22006, 382, 17, 'Bruising/haematoma');
INSERT INTO `lang_definitions` VALUES (22007, 383, 17, 'Inchando Direito:');
INSERT INTO `lang_definitions` VALUES (22008, 384, 17, 'Queimando com Urinação');
INSERT INTO `lang_definitions` VALUES (22009, 385, 17, 'Queimando Com Urinação');
INSERT INTO `lang_definitions` VALUES (22010, 386, 17, 'Ocupado');
INSERT INTO `lang_definitions` VALUES (22011, 387, 17, 'Nádega + S.I.');
INSERT INTO `lang_definitions` VALUES (22012, 388, 17, 'por');
INSERT INTO `lang_definitions` VALUES (22013, 389, 17, 'através de boca');
INSERT INTO `lang_definitions` VALUES (22014, 390, 17, 'By/Source');
INSERT INTO `lang_definitions` VALUES (22015, 391, 17, 'Por:');
INSERT INTO `lang_definitions` VALUES (22016, 392, 17, 'C');
INSERT INTO `lang_definitions` VALUES (22017, 393, 17, 'Vida de esconderijo (em segundos)');
INSERT INTO `lang_definitions` VALUES (22018, 394, 17, 'Produção de modelo de esconderijo?');
INSERT INTO `lang_definitions` VALUES (22019, 395, 17, 'Consumo de Cafeína');
INSERT INTO `lang_definitions` VALUES (22020, 396, 17, 'Calendário');
INSERT INTO `lang_definitions` VALUES (22021, 397, 17, 'Aplicações do Calendário');
INSERT INTO `lang_definitions` VALUES (22022, 398, 17, 'Calendário UI');
INSERT INTO `lang_definitions` VALUES (22023, 399, 17, 'Visão do Calendário');
INSERT INTO `lang_definitions` VALUES (22024, 400, 17, 'Chame para addform() vai aqui. <br>');
INSERT INTO `lang_definitions` VALUES (22025, 402, 17, 'CAMOS');
INSERT INTO `lang_definitions` VALUES (22026, 403, 17, 'Cancelar');
INSERT INTO `lang_definitions` VALUES (22027, 404, 17, 'Cancer');
INSERT INTO `lang_definitions` VALUES (22028, 405, 17, 'Não pode acrescentar isto porque já existe!');
INSERT INTO `lang_definitions` VALUES (22029, 406, 17, 'Não pode acrescentar/atualizar esta entrada porque Há duplicada');
INSERT INTO `lang_definitions` VALUES (22030, 407, 17, 'ImageMagick não está instalaso');
INSERT INTO `lang_definitions` VALUES (22031, 408, 17, 'não pode ser exibido inline porque seu tipo não é');
INSERT INTO `lang_definitions` VALUES (22032, 409, 17, 'não pode ser exibido inline porque seu tipo não é');
INSERT INTO `lang_definitions` VALUES (22033, 410, 17, 'não pode ser exibido inline porque seu tipo não é');
INSERT INTO `lang_definitions` VALUES (22034, 411, 17, 'Não pode criar');
INSERT INTO `lang_definitions` VALUES (22035, 412, 17, 'Não pode achar');
INSERT INTO `lang_definitions` VALUES (22036, 413, 17, 'Não pode achar o pacinte do SQL-Razão no id do cliente');
INSERT INTO `lang_definitions` VALUES (22037, 414, 17, 'Não pode achar referênciado documento de pós -escrito dentro');
INSERT INTO `lang_definitions` VALUES (22038, 415, 17, 'Não pode achar o provedor de empregado no SQL-Razão =');
INSERT INTO `lang_definitions` VALUES (22039, 416, 17, 'Não pode abrir');
INSERT INTO `lang_definitions` VALUES (22040, 417, 17, 'Não pode ler');
INSERT INTO `lang_definitions` VALUES (22041, 418, 17, 'Não pode atualizar porque voçê está editando um');
INSERT INTO `lang_definitions` VALUES (22042, 419, 17, 'cápsula');
INSERT INTO `lang_definitions` VALUES (22043, 420, 17, 'Cateterização Cardíaca');
INSERT INTO `lang_definitions` VALUES (22044, 421, 17, 'Eco cardíaco');
INSERT INTO `lang_definitions` VALUES (22045, 422, 17, 'Cardiovascular');
INSERT INTO `lang_definitions` VALUES (22046, 423, 17, 'Cartilagem / chondral / dano de disco');
INSERT INTO `lang_definitions` VALUES (22047, 424, 17, 'Dano de cartilagem');
INSERT INTO `lang_definitions` VALUES (22048, 425, 17, 'Cartoid pulsação nl,pedal pulsos nl');
INSERT INTO `lang_definitions` VALUES (22049, 426, 17, 'dinheiro');
INSERT INTO `lang_definitions` VALUES (22050, 427, 17, 'Dinheiro');
INSERT INTO `lang_definitions` VALUES (22051, 428, 17, 'Troque Rec');
INSERT INTO `lang_definitions` VALUES (22052, 429, 17, 'Recibos de Dinheiro por Provedor');
INSERT INTO `lang_definitions` VALUES (22053, 430, 17, 'Cirurgia de Catarata');
INSERT INTO `lang_definitions` VALUES (22054, 431, 17, 'Cataratas');
INSERT INTO `lang_definitions` VALUES (22055, 432, 17, 'Categorias');
INSERT INTO `lang_definitions` VALUES (22056, 433, 17, 'Categoria');
INSERT INTO `lang_definitions` VALUES (22057, 434, 17, 'categoria');
INSERT INTO `lang_definitions` VALUES (22058, 435, 17, 'Categoria');
INSERT INTO `lang_definitions` VALUES (22059, 436, 17, 'Detalhes de categoria');
INSERT INTO `lang_definitions` VALUES (22060, 437, 17, 'Limites de Categoria');
INSERT INTO `lang_definitions` VALUES (22061, 438, 17, 'Nome de Categoria');
INSERT INTO `lang_definitions` VALUES (22062, 439, 17, 'Caucasiano');
INSERT INTO `lang_definitions` VALUES (22063, 440, 17, 'Telefone Celular');
INSERT INTO `lang_definitions` VALUES (22064, 441, 17, 'Numero de Tefone Celular');
INSERT INTO `lang_definitions` VALUES (22065, 442, 17, 'Certificação Central');
INSERT INTO `lang_definitions` VALUES (22066, 443, 17, 'cfirst($instype) . \' Ins');
INSERT INTO `lang_definitions` VALUES (22067, 444, 17, 'ChampUS');
INSERT INTO `lang_definitions` VALUES (22068, 445, 17, 'ChampUSVA');
INSERT INTO `lang_definitions` VALUES (22069, 446, 17, 'mudança');
INSERT INTO `lang_definitions` VALUES (22070, 448, 17, 'Mude Atividade');
INSERT INTO `lang_definitions` VALUES (22071, 449, 17, 'Mude em Visão');
INSERT INTO `lang_definitions` VALUES (22072, 450, 17, 'Mude em Visão');
INSERT INTO `lang_definitions` VALUES (22073, 451, 17, 'Mudado');
INSERT INTO `lang_definitions` VALUES (22074, 452, 17, 'Mudado Intestino');
INSERT INTO `lang_definitions` VALUES (22075, 453, 17, 'Custo');
INSERT INTO `lang_definitions` VALUES (22076, 454, 17, 'Custos');
INSERT INTO `lang_definitions` VALUES (22077, 455, 17, 'Quadro');
INSERT INTO `lang_definitions` VALUES (22078, 456, 17, 'Quadro de Atividade');
INSERT INTO `lang_definitions` VALUES (22079, 457, 17, 'Quadro Conferir-entrar/sair Relatório de Atividade');
INSERT INTO `lang_definitions` VALUES (22080, 458, 17, 'Traçar ID');
INSERT INTO `lang_definitions` VALUES (22081, 459, 17, 'Traçar ID');
INSERT INTO `lang_definitions` VALUES (22082, 460, 17, 'Traçar Atividade de Localização');
INSERT INTO `lang_definitions` VALUES (22083, 461, 17, 'Nota de Quadro');
INSERT INTO `lang_definitions` VALUES (22084, 462, 17, 'Traçar Posições de Memória');
INSERT INTO `lang_definitions` VALUES (22085, 463, 17, 'Traçar Perseguidor');
INSERT INTO `lang_definitions` VALUES (22086, 464, 17, 'Traçe Trk');
INSERT INTO `lang_definitions` VALUES (22087, 465, 17, 'Quadro Confirmou');
INSERT INTO `lang_definitions` VALUES (22088, 466, 17, 'Traçar Fora');
INSERT INTO `lang_definitions` VALUES (22089, 467, 17, 'cheque');
INSERT INTO `lang_definitions` VALUES (22090, 468, 17, 'Cheque');
INSERT INTO `lang_definitions` VALUES (22091, 469, 17, 'Confira Tudo');
INSERT INTO `lang_definitions` VALUES (22092, 470, 17, 'Confira dentro para');
INSERT INTO `lang_definitions` VALUES (22093, 471, 17, 'Confira Dados de Contribuição');
INSERT INTO `lang_definitions` VALUES (22094, 472, 17, 'Confira Número');
INSERT INTO `lang_definitions` VALUES (22095, 473, 17, 'Dados de Check/EOB');
INSERT INTO `lang_definitions` VALUES (22096, 474, 17, 'No.: Check/EOB');
INSERT INTO `lang_definitions` VALUES (22097, 475, 17, 'Confira/Ref Número');
INSERT INTO `lang_definitions` VALUES (22098, 476, 17, 'Confira/Número de Referênçia');
INSERT INTO `lang_definitions` VALUES (22099, 477, 17, 'Caixa de Verificar lista');
INSERT INTO `lang_definitions` VALUES (22100, 478, 17, 'Caixa de Verificar lista');
INSERT INTO `lang_definitions` VALUES (22101, 479, 17, 'Caixa de Verificar w/ texto');
INSERT INTO `lang_definitions` VALUES (22102, 480, 17, 'Caixa de Verificar w/texto');
INSERT INTO `lang_definitions` VALUES (22103, 481, 17, 'Caixa conferida = sim , vazio = não');
INSERT INTO `lang_definitions` VALUES (22104, 482, 17, 'Saída');
INSERT INTO `lang_definitions` VALUES (22105, 483, 17, 'Torax');
INSERT INTO `lang_definitions` VALUES (22106, 484, 17, 'Torax CTAB');
INSERT INTO `lang_definitions` VALUES (22107, 485, 17, 'Dores no Torax');
INSERT INTO `lang_definitions` VALUES (22108, 486, 17, 'Dores no Torax:');
INSERT INTO `lang_definitions` VALUES (22109, 487, 17, 'Dores no Torax');
INSERT INTO `lang_definitions` VALUES (22110, 488, 17, 'Chg');
INSERT INTO `lang_definitions` VALUES (22111, 490, 17, 'Criança');
INSERT INTO `lang_definitions` VALUES (22112, 491, 17, 'Frios');
INSERT INTO `lang_definitions` VALUES (22113, 492, 17, 'Chinês');
INSERT INTO `lang_definitions` VALUES (22114, 493, 17, 'Escolhas');
INSERT INTO `lang_definitions` VALUES (22115, 494, 17, 'Cholecystectomy');
INSERT INTO `lang_definitions` VALUES (22116, 495, 17, 'Cholecystectomy');
INSERT INTO `lang_definitions` VALUES (22117, 496, 17, 'Escolhas');
INSERT INTO `lang_definitions` VALUES (22118, 497, 17, 'Escolhe uma seção e clique um artigo dentro disto; entao');
INSERT INTO `lang_definitions` VALUES (22119, 498, 17, 'Escolhe lista');
INSERT INTO `lang_definitions` VALUES (22120, 500, 17, 'Bronquites crônicas');
INSERT INTO `lang_definitions` VALUES (22121, 501, 17, 'Dor da Junta crônica');
INSERT INTO `lang_definitions` VALUES (22122, 502, 17, 'Synovitis crônico / efusão /do nas juntas / gout');
INSERT INTO `lang_definitions` VALUES (22123, 503, 17, 'Crônica/Recorrente');
INSERT INTO `lang_definitions` VALUES (22124, 504, 17, 'Cirrose do Fígado');
INSERT INTO `lang_definitions` VALUES (22125, 505, 17, 'Cirrose Do Fígado');
INSERT INTO `lang_definitions` VALUES (22126, 506, 17, 'Cidade');
INSERT INTO `lang_definitions` VALUES (22127, 507, 17, 'Nome da Cidade');
INSERT INTO `lang_definitions` VALUES (22128, 508, 17, 'Cidade, Estado');
INSERT INTO `lang_definitions` VALUES (22129, 509, 17, 'Cidade, Vigor Estatal,');
INSERT INTO `lang_definitions` VALUES (22130, 510, 17, 'Cidade/Estado');
INSERT INTO `lang_definitions` VALUES (22131, 512, 17, 'Reivindicação');
INSERT INTO `lang_definitions` VALUES (22132, 513, 17, 'Teste de reivindicação foi completada');
INSERT INTO `lang_definitions` VALUES (22133, 514, 17, 'Reivindicação foi gerada para arquivar');
INSERT INTO `lang_definitions` VALUES (22134, 515, 17, 'Classificação');
INSERT INTO `lang_definitions` VALUES (22135, 516, 17, 'Claro');
INSERT INTO `lang_definitions` VALUES (22136, 517, 17, 'Clarear tudo');
INSERT INTO `lang_definitions` VALUES (22137, 518, 17, 'Justificação Clara');
INSERT INTO `lang_definitions` VALUES (22138, 519, 17, 'Esconderijo de Smarty claro');
INSERT INTO `lang_definitions` VALUES (22139, 520, 17, 'CLIA Number');
INSERT INTO `lang_definitions` VALUES (22140, 521, 17, 'Clique');
INSERT INTO `lang_definitions` VALUES (22141, 523, 17, 'clique mais para');
INSERT INTO `lang_definitions` VALUES (22142, 524, 17, 'Faça clique aqui para escolher uma data');
INSERT INTO `lang_definitions` VALUES (22143, 525, 17, 'Faça clique aqui para atualizar prioridade, categoria e');
INSERT INTO `lang_definitions` VALUES (22144, 526, 17, 'Faça clique aqui para ver tudo.');
INSERT INTO `lang_definitions` VALUES (22145, 527, 17, 'Faça clique para carregar');
INSERT INTO `lang_definitions` VALUES (22146, 528, 17, 'Faça clique para editar');
INSERT INTO `lang_definitions` VALUES (22147, 529, 17, 'Faça clique para editar esta evento');
INSERT INTO `lang_definitions` VALUES (22148, 530, 17, 'Faça clique para gerar o relatório');
INSERT INTO `lang_definitions` VALUES (22149, 531, 17, 'Faça clique para imprimir');
INSERT INTO `lang_definitions` VALUES (22150, 532, 17, 'Faça clique para receber (adicionar) novo lote');
INSERT INTO `lang_definitions` VALUES (22151, 533, 17, 'Faça cilque para selecionar');
INSERT INTO `lang_definitions` VALUES (22152, 534, 17, 'Faça clique para selecionar ou mudança de diagnóstico');
INSERT INTO `lang_definitions` VALUES (22153, 535, 17, 'Faça clique para selecionar o paciente');
INSERT INTO `lang_definitions` VALUES (22154, 536, 17, 'Faça clique para selecionar o código relacionado');
INSERT INTO `lang_definitions` VALUES (22155, 537, 17, 'Clique para ver');
INSERT INTO `lang_definitions` VALUES (22156, 538, 17, 'Faça clique ver ou editar');
INSERT INTO `lang_definitions` VALUES (22157, 539, 17, 'Faça clique para ver/editar');
INSERT INTO `lang_definitions` VALUES (22158, 540, 17, 'Clique');
INSERT INTO `lang_definitions` VALUES (22159, 542, 17, 'Assunto da história médica do cliente');
INSERT INTO `lang_definitions` VALUES (22160, 543, 17, 'Perfil do cliente - Clientes Novo');
INSERT INTO `lang_definitions` VALUES (22161, 544, 17, 'Perfil do cliente - Clientes sem igual');
INSERT INTO `lang_definitions` VALUES (22162, 545, 17, 'Clientes');
INSERT INTO `lang_definitions` VALUES (22163, 546, 17, 'Clínica');
INSERT INTO `lang_definitions` VALUES (22164, 548, 17, 'Registro Diário da Clinica');
INSERT INTO `lang_definitions` VALUES (22165, 549, 17, 'Clínica ID');
INSERT INTO `lang_definitions` VALUES (22166, 550, 17, 'Clínicos');
INSERT INTO `lang_definitions` VALUES (22167, 553, 17, 'Fechar');
INSERT INTO `lang_definitions` VALUES (22168, 554, 17, 'Fechar a janela');
INSERT INTO `lang_definitions` VALUES (22169, 555, 17, 'Fechado');
INSERT INTO `lang_definitions` VALUES (22170, 556, 17, 'cm');
INSERT INTO `lang_definitions` VALUES (22171, 558, 17, 'CMS ID');
INSERT INTO `lang_definitions` VALUES (22172, 559, 17, 'CN2-12 íntima');
INSERT INTO `lang_definitions` VALUES (22173, 560, 17, 'Código');
INSERT INTO `lang_definitions` VALUES (22174, 561, 17, 'Código');
INSERT INTO `lang_definitions` VALUES (22175, 562, 17, 'Codifique o descobridor');
INSERT INTO `lang_definitions` VALUES (22176, 563, 17, 'Código deve ser duas letras minúsculs');
INSERT INTO `lang_definitions` VALUES (22177, 564, 17, 'tipo de códig');
INSERT INTO `lang_definitions` VALUES (22178, 565, 17, 'Códigos');
INSERT INTO `lang_definitions` VALUES (22179, 566, 17, 'Codificando');
INSERT INTO `lang_definitions` VALUES (22180, 567, 17, 'Codificando - qualquer encontro (escrever, aumentar opcional)');
INSERT INTO `lang_definitions` VALUES (22181, 568, 17, 'Codificando - meu encontro (escrever, aumentar opcional)');
INSERT INTO `lang_definitions` VALUES (22182, 569, 17, 'Código não autorizado');
INSERT INTO `lang_definitions` VALUES (22183, 570, 17, 'Café');
INSERT INTO `lang_definitions` VALUES (22184, 571, 17, 'Coll w/o');
INSERT INTO `lang_definitions` VALUES (22185, 572, 17, 'cair tudo');
INSERT INTO `lang_definitions` VALUES (22186, 573, 17, 'Coleções');
INSERT INTO `lang_definitions` VALUES (22187, 574, 17, 'Relatório de Coleções');
INSERT INTO `lang_definitions` VALUES (22188, 575, 17, 'Câncer do Cólon');
INSERT INTO `lang_definitions` VALUES (22189, 576, 17, 'Cirurgia do Câncer de Cólon');
INSERT INTO `lang_definitions` VALUES (22190, 577, 17, 'Colonoscopia');
INSERT INTO `lang_definitions` VALUES (22191, 578, 17, 'Colonoscopia');
INSERT INTO `lang_definitions` VALUES (22192, 579, 17, 'Cor');
INSERT INTO `lang_definitions` VALUES (22193, 580, 17, 'Colunas');
INSERT INTO `lang_definitions` VALUES (22194, 581, 17, 'Coméntarios');
INSERT INTO `lang_definitions` VALUES (22195, 582, 17, 'Cia. De Seguro comercial');
INSERT INTO `lang_definitions` VALUES (22196, 583, 17, 'Faça mudanças');
INSERT INTO `lang_definitions` VALUES (22197, 584, 17, 'Comunicações');
INSERT INTO `lang_definitions` VALUES (22198, 585, 17, 'Completado');
INSERT INTO `lang_definitions` VALUES (22199, 586, 17, 'Complicações através do provedor de serviços');
INSERT INTO `lang_definitions` VALUES (22200, 587, 17, 'Complicações do Aborto');
INSERT INTO `lang_definitions` VALUES (22201, 588, 17, 'Computador Ajudou Sistema de Ordenamento de Exame médico');
INSERT INTO `lang_definitions` VALUES (22202, 589, 17, 'Conclusões');
INSERT INTO `lang_definitions` VALUES (22203, 590, 17, 'Congênito');
INSERT INTO `lang_definitions` VALUES (22204, 591, 17, 'Conjuntiva, pupils');
INSERT INTO `lang_definitions` VALUES (22205, 592, 17, 'Constante');
INSERT INTO `lang_definitions` VALUES (22206, 593, 17, 'Nome Constante');
INSERT INTO `lang_definitions` VALUES (22207, 594, 17, 'Constantes');
INSERT INTO `lang_definitions` VALUES (22208, 595, 17, 'Constipação');
INSERT INTO `lang_definitions` VALUES (22209, 596, 17, 'Constitucional');
INSERT INTO `lang_definitions` VALUES (22210, 597, 17, 'Descrição Breve da Consulta');
INSERT INTO `lang_definitions` VALUES (22211, 598, 17, 'Contacto');
INSERT INTO `lang_definitions` VALUES (22212, 599, 17, 'Contacto eletônico (email)');
INSERT INTO `lang_definitions` VALUES (22213, 600, 17, 'Contacto do Endereço Eletrônico');
INSERT INTO `lang_definitions` VALUES (22214, 601, 17, 'Contacto info');
INSERT INTO `lang_definitions` VALUES (22215, 602, 17, 'Lentes de Contacto');
INSERT INTO `lang_definitions` VALUES (22216, 603, 17, 'Contate o Nome');
INSERT INTO `lang_definitions` VALUES (22217, 604, 17, 'Contate a pessoa');
INSERT INTO `lang_definitions` VALUES (22218, 605, 17, 'Contate o Número de Telefone');
INSERT INTO `lang_definitions` VALUES (22219, 606, 17, 'Conteúdo');
INSERT INTO `lang_definitions` VALUES (22220, 607, 17, 'conteúdo');
INSERT INTO `lang_definitions` VALUES (22221, 608, 17, 'Continuar');
INSERT INTO `lang_definitions` VALUES (22222, 609, 17, 'Clientes de Contra');
INSERT INTO `lang_definitions` VALUES (22223, 610, 17, 'Contracepção');
INSERT INTO `lang_definitions` VALUES (22224, 611, 17, 'Assuntos de Contracepção');
INSERT INTO `lang_definitions` VALUES (22225, 612, 17, 'Complicação anticoncepcional (especifique)');
INSERT INTO `lang_definitions` VALUES (22226, 613, 17, 'Métodos Anticontracepcional');
INSERT INTO `lang_definitions` VALUES (22227, 614, 17, 'Sérviços anticontracepcionais começaram previamente');
INSERT INTO `lang_definitions` VALUES (22228, 615, 17, 'Anticontracepciona Começou');
INSERT INTO `lang_definitions` VALUES (22229, 616, 17, 'Control No');
INSERT INTO `lang_definitions` VALUES (22230, 617, 17, 'Copay');
INSERT INTO `lang_definitions` VALUES (22231, 618, 17, 'CoPay');
INSERT INTO `lang_definitions` VALUES (22232, 619, 17, 'Copay não positivo');
INSERT INTO `lang_definitions` VALUES (22233, 620, 17, 'Copays');
INSERT INTO `lang_definitions` VALUES (22234, 621, 17, 'COPD');
INSERT INTO `lang_definitions` VALUES (22235, 622, 17, 'Copia página do paciente traçada');
INSERT INTO `lang_definitions` VALUES (22236, 623, 17, 'Copia Valores');
INSERT INTO `lang_definitions` VALUES (22237, 624, 17, 'Notificação protegido por direitos autorais');
INSERT INTO `lang_definitions` VALUES (22238, 625, 17, 'Estado de contorno de Artéria coronária');
INSERT INTO `lang_definitions` VALUES (22239, 626, 17, 'Tosse');
INSERT INTO `lang_definitions` VALUES (22240, 627, 17, 'Tosse:');
INSERT INTO `lang_definitions` VALUES (22241, 628, 17, 'Não pode enviar e-mail devido a problema do servidor,');
INSERT INTO `lang_definitions` VALUES (22242, 633, 17, 'Couns através de Método');
INSERT INTO `lang_definitions` VALUES (22243, 634, 17, 'Aconselhando');
INSERT INTO `lang_definitions` VALUES (22244, 635, 17, 'Atividade de Aconselhamento');
INSERT INTO `lang_definitions` VALUES (22245, 636, 17, 'CONTRA FORMA DE INDICAÇÃO');
INSERT INTO `lang_definitions` VALUES (22246, 637, 17, 'Contra informação');
INSERT INTO `lang_definitions` VALUES (22247, 638, 17, 'País');
INSERT INTO `lang_definitions` VALUES (22248, 639, 17, 'Lista de Países (escrever,adicionar somente opcional)');
INSERT INTO `lang_definitions` VALUES (22249, 640, 17, 'país');
INSERT INTO `lang_definitions` VALUES (22250, 641, 17, 'Cupom');
INSERT INTO `lang_definitions` VALUES (22251, 642, 17, 'CPT');
INSERT INTO `lang_definitions` VALUES (22252, 643, 17, 'CPT Códigos');
INSERT INTO `lang_definitions` VALUES (22253, 644, 17, 'Crackles:');
INSERT INTO `lang_definitions` VALUES (22254, 645, 17, 'nata');
INSERT INTO `lang_definitions` VALUES (22255, 646, 17, 'Criar um Evento');
INSERT INTO `lang_definitions` VALUES (22256, 647, 17, 'Crie e carregue um auxílio cheio');
INSERT INTO `lang_definitions` VALUES (22257, 648, 17, 'Criar um Auxílio');
INSERT INTO `lang_definitions` VALUES (22258, 649, 17, 'Criar novo paciente');
INSERT INTO `lang_definitions` VALUES (22259, 650, 17, 'Criar notas do paciente');
INSERT INTO `lang_definitions` VALUES (22260, 651, 17, 'Criado');
INSERT INTO `lang_definitions` VALUES (22261, 652, 17, 'Arquivo de exportação criado');
INSERT INTO `lang_definitions` VALUES (22262, 653, 17, 'crédito');
INSERT INTO `lang_definitions` VALUES (22263, 654, 17, 'Créditos');
INSERT INTO `lang_definitions` VALUES (22264, 655, 17, 'Crohn\'Doença de');
INSERT INTO `lang_definitions` VALUES (22265, 656, 17, 'Crohn Doença de');
INSERT INTO `lang_definitions` VALUES (22266, 657, 17, 'Arquivo CSV');
INSERT INTO `lang_definitions` VALUES (22267, 658, 17, 'Corrente');
INSERT INTO `lang_definitions` VALUES (22268, 659, 17, 'Consulta atual');
INSERT INTO `lang_definitions` VALUES (22269, 660, 17, 'Cor de destaque de dia atual');
INSERT INTO `lang_definitions` VALUES (22270, 661, 17, 'O nome da pasta foi trocado para');
INSERT INTO `lang_definitions` VALUES (22271, 662, 17, 'Localização atual');
INSERT INTO `lang_definitions` VALUES (22272, 663, 17, 'Paciente Corrente');
INSERT INTO `lang_definitions` VALUES (22273, 664, 17, 'Atualmente ativo');
INSERT INTO `lang_definitions` VALUES (22274, 665, 17, 'Syndrom esmagado');
INSERT INTO `lang_definitions` VALUES (22275, 666, 17, 'Syndrom esmagado');
INSERT INTO `lang_definitions` VALUES (22276, 667, 17, 'Costume');
INSERT INTO `lang_definitions` VALUES (22277, 669, 17, 'CYP');
INSERT INTO `lang_definitions` VALUES (22278, 670, 17, 'Fator CYP');
INSERT INTO `lang_definitions` VALUES (22279, 671, 17, 'Relatório CYP');
INSERT INTO `lang_definitions` VALUES (22280, 672, 17, 'D');
INSERT INTO `lang_definitions` VALUES (22281, 673, 17, 'D&C');
INSERT INTO `lang_definitions` VALUES (22282, 674, 17, 'D&E');
INSERT INTO `lang_definitions` VALUES (22283, 675, 17, 'D.O.B.');
INSERT INTO `lang_definitions` VALUES (22284, 676, 17, 'diariamente');
INSERT INTO `lang_definitions` VALUES (22285, 677, 17, 'código e/ou descrição');
INSERT INTO `lang_definitions` VALUES (22286, 678, 17, 'Dados Semelhantes já está em banco de dados, por favor mude');
INSERT INTO `lang_definitions` VALUES (22287, 679, 17, 'Dados Cols');
INSERT INTO `lang_definitions` VALUES (22288, 680, 17, 'Tipos de Dados');
INSERT INTO `lang_definitions` VALUES (22289, 681, 17, 'Base de Dados');
INSERT INTO `lang_definitions` VALUES (22290, 682, 17, 'Relatório da Base de Dados');
INSERT INTO `lang_definitions` VALUES (22291, 683, 17, 'DataCols deve ser um número entre 1 e 999');
INSERT INTO `lang_definitions` VALUES (22292, 684, 17, 'Data');
INSERT INTO `lang_definitions` VALUES (22293, 685, 17, 'DATA');
INSERT INTO `lang_definitions` VALUES (22294, 686, 17, 'Data Administrou');
INSERT INTO `lang_definitions` VALUES (22295, 687, 17, 'Dada de Serviços anticoncepcionais inicialmente contanto');
INSERT INTO `lang_definitions` VALUES (22296, 688, 17, 'Data Destruiu');
INSERT INTO `lang_definitions` VALUES (22297, 689, 17, 'Date formato de representação visual');
INSERT INTO `lang_definitions` VALUES (22298, 690, 17, 'Formato de data para \"fim de compomisso\" não é válido');
INSERT INTO `lang_definitions` VALUES (22299, 691, 17, 'Formato de data para \"início de compomisso\" não é válido');
INSERT INTO `lang_definitions` VALUES (22300, 692, 17, 'Formato de data para \"Próximo compomisso\" não é válido');
INSERT INTO `lang_definitions` VALUES (22301, 693, 17, 'Formato de data para \"não visto desde então\" não é válido');
INSERT INTO `lang_definitions` VALUES (22302, 694, 17, 'Formato de data para \"visto desde então\" não é válido');
INSERT INTO `lang_definitions` VALUES (22303, 695, 17, 'Date Declarações de Informação de Imunização Dadas');
INSERT INTO `lang_definitions` VALUES (22304, 696, 17, 'Data está perdendo para código');
INSERT INTO `lang_definitions` VALUES (22305, 697, 17, 'Data do depósito bancário yyyy-mm-dd');
INSERT INTO `lang_definitions` VALUES (22306, 698, 17, 'Data de Nascimento');
INSERT INTO `lang_definitions` VALUES (22307, 699, 17, 'Data de nascimento');
INSERT INTO `lang_definitions` VALUES (22308, 700, 17, 'Data do Dano');
INSERT INTO `lang_definitions` VALUES (22309, 701, 17, 'Data do Pagamento yyyy-mm-dd');
INSERT INTO `lang_definitions` VALUES (22310, 702, 17, 'Data de Indicação');
INSERT INTO `lang_definitions` VALUES (22311, 703, 17, 'Data de resposta');
INSERT INTO `lang_definitions` VALUES (22312, 704, 17, 'Data De Serviço');
INSERT INTO `lang_definitions` VALUES (22313, 705, 17, 'Data de serviço mm-dd-yyyy');
INSERT INTO `lang_definitions` VALUES (22314, 706, 17, 'Data de Serviço');
INSERT INTO `lang_definitions` VALUES (22315, 707, 17, 'Data De Assinatura');
INSERT INTO `lang_definitions` VALUES (22316, 708, 17, 'Data de Declaração de VIS');
INSERT INTO `lang_definitions` VALUES (22317, 709, 17, 'Data/Appt');
INSERT INTO `lang_definitions` VALUES (22318, 710, 17, 'Data/Notas');
INSERT INTO `lang_definitions` VALUES (22319, 711, 17, 'Data/Ùltimas Notas');
INSERT INTO `lang_definitions` VALUES (22320, 712, 17, 'Data:');
INSERT INTO `lang_definitions` VALUES (22321, 713, 17, 'dia');
INSERT INTO `lang_definitions` VALUES (22322, 714, 17, 'Dia');
INSERT INTO `lang_definitions` VALUES (22323, 715, 17, 'Visão do Dia');
INSERT INTO `lang_definitions` VALUES (22324, 716, 17, 'Dia(s)');
INSERT INTO `lang_definitions` VALUES (22325, 717, 17, 'Dia(s) M-F');
INSERT INTO `lang_definitions` VALUES (22326, 718, 17, 'dias');
INSERT INTO `lang_definitions` VALUES (22327, 719, 17, 'Days');
INSERT INTO `lang_definitions` VALUES (22328, 720, 17, 'Dias e Jogos Perderam');
INSERT INTO `lang_definitions` VALUES (22329, 721, 17, 'Dias De Ùltimo Encontro');
INSERT INTO `lang_definitions` VALUES (22330, 722, 17, 'Dias por Colunas');
INSERT INTO `lang_definitions` VALUES (22331, 723, 17, 'DB Instalou');
INSERT INTO `lang_definitions` VALUES (22332, 724, 17, 'DEA');
INSERT INTO `lang_definitions` VALUES (22333, 725, 17, 'Depure Informação');
INSERT INTO `lang_definitions` VALUES (22334, 726, 17, 'Dezembro');
INSERT INTO `lang_definitions` VALUES (22335, 727, 17, 'Omita');
INSERT INTO `lang_definitions` VALUES (22336, 728, 17, 'Omitir Visão de Caléndario');
INSERT INTO `lang_definitions` VALUES (22337, 729, 17, 'Omita Facilidades');
INSERT INTO `lang_definitions` VALUES (22338, 730, 17, 'Lista de Falta (escrever,addonly opcional)');
INSERT INTO `lang_definitions` VALUES (22339, 731, 17, 'Omita Método');
INSERT INTO `lang_definitions` VALUES (22340, 732, 17, 'Omita Provedor');
INSERT INTO `lang_definitions` VALUES (22341, 733, 17, 'Omita Modelo');
INSERT INTO `lang_definitions` VALUES (22342, 734, 17, 'Omita Valor');
INSERT INTO `lang_definitions` VALUES (22343, 735, 17, 'Omita X12 Sócio');
INSERT INTO `lang_definitions` VALUES (22344, 736, 17, 'Omita/Global');
INSERT INTO `lang_definitions` VALUES (22345, 738, 17, 'Retorno Atrasado (> 12 Mo)');
INSERT INTO `lang_definitions` VALUES (22346, 739, 17, 'Apagar');
INSERT INTO `lang_definitions` VALUES (22347, 740, 17, 'apagar');
INSERT INTO `lang_definitions` VALUES (22348, 741, 17, 'Apague Categorias com ID(s):');
INSERT INTO `lang_definitions` VALUES (22349, 742, 17, 'Apague Grupo');
INSERT INTO `lang_definitions` VALUES (22350, 743, 17, 'Apague Lista');
INSERT INTO `lang_definitions` VALUES (22351, 744, 17, 'Apague Páginas');
INSERT INTO `lang_definitions` VALUES (22352, 745, 17, 'Apague Paciente, Encontro, Forma, Emissão,');
INSERT INTO `lang_definitions` VALUES (22353, 747, 17, 'Apagado com sucesso');
INSERT INTO `lang_definitions` VALUES (22354, 748, 17, 'Apague este documento');
INSERT INTO `lang_definitions` VALUES (22355, 749, 17, 'Apague esta forma');
INSERT INTO `lang_definitions` VALUES (22356, 750, 17, 'Apague esta nota');
INSERT INTO `lang_definitions` VALUES (22357, 751, 17, 'Demência');
INSERT INTO `lang_definitions` VALUES (22358, 752, 17, 'Demographics');
INSERT INTO `lang_definitions` VALUES (22359, 753, 17, 'Demographics (escrever,addonly opcional)');
INSERT INTO `lang_definitions` VALUES (22360, 754, 17, 'Demographics não autorizou');
INSERT INTO `lang_definitions` VALUES (22361, 755, 17, 'Demographics não autorizou.');
INSERT INTO `lang_definitions` VALUES (22362, 756, 17, 'Dental');
INSERT INTO `lang_definitions` VALUES (22363, 757, 17, 'Assuntos Dentais');
INSERT INTO `lang_definitions` VALUES (22364, 758, 17, 'verá HCFA como produção em uma página em branco para');
INSERT INTO `lang_definitions` VALUES (22365, 759, 17, 'Data do Depósito');
INSERT INTO `lang_definitions` VALUES (22366, 760, 17, 'Deprimido');
INSERT INTO `lang_definitions` VALUES (22367, 761, 17, 'Depressão');
INSERT INTO `lang_definitions` VALUES (22368, 762, 17, 'Descrição');
INSERT INTO `lang_definitions` VALUES (22369, 763, 17, 'descrição');
INSERT INTO `lang_definitions` VALUES (22370, 764, 17, 'Tradução de descrição');
INSERT INTO `lang_definitions` VALUES (22371, 765, 17, 'Destino');
INSERT INTO `lang_definitions` VALUES (22372, 766, 17, 'Destrua Lote');
INSERT INTO `lang_definitions` VALUES (22373, 767, 17, 'Destruir');
INSERT INTO `lang_definitions` VALUES (22374, 768, 17, 'Destruido');
INSERT INTO `lang_definitions` VALUES (22375, 769, 17, 'Drogas Destruidas');
INSERT INTO `lang_definitions` VALUES (22376, 770, 17, 'Relatório de Drogas Destruidas');
INSERT INTO `lang_definitions` VALUES (22377, 771, 17, 'Detalhes');
INSERT INTO `lang_definitions` VALUES (22378, 772, 17, 'anormalidade Desenvolvente');
INSERT INTO `lang_definitions` VALUES (22379, 773, 17, 'Diabete');
INSERT INTO `lang_definitions` VALUES (22380, 774, 17, 'Diag');
INSERT INTO `lang_definitions` VALUES (22381, 775, 17, 'Diagnóstico:');
INSERT INTO `lang_definitions` VALUES (22382, 776, 17, 'Diagnóstico deve ser codificado em um encontro único');
INSERT INTO `lang_definitions` VALUES (22383, 777, 17, 'Diagnósticos:');
INSERT INTO `lang_definitions` VALUES (22384, 778, 17, 'Diagnósticos:');
INSERT INTO `lang_definitions` VALUES (22385, 779, 17, 'Testes do Diagnósticos');
INSERT INTO `lang_definitions` VALUES (22386, 780, 17, 'Dials');
INSERT INTO `lang_definitions` VALUES (22387, 781, 17, 'Diaphragms/Caps');
INSERT INTO `lang_definitions` VALUES (22388, 782, 17, 'Diarréia');
INSERT INTO `lang_definitions` VALUES (22389, 783, 17, 'Ditado');
INSERT INTO `lang_definitions` VALUES (22390, 784, 17, 'Ditado:');
INSERT INTO `lang_definitions` VALUES (22391, 785, 17, 'Voçê recebeu uma cópia da Notificação de HIPAA?');
INSERT INTO `lang_definitions` VALUES (22392, 786, 17, 'Difunda:');
INSERT INTO `lang_definitions` VALUES (22393, 788, 17, 'Mala Direta');
INSERT INTO `lang_definitions` VALUES (22394, 789, 17, 'Incapacidade');
INSERT INTO `lang_definitions` VALUES (22395, 790, 17, 'deficiente');
INSERT INTO `lang_definitions` VALUES (22396, 791, 17, 'Deficiente');
INSERT INTO `lang_definitions` VALUES (22397, 792, 17, 'DISC');
INSERT INTO `lang_definitions` VALUES (22398, 793, 17, 'Descarregue');
INSERT INTO `lang_definitions` VALUES (22399, 794, 17, 'Descarregue De Ureta');
INSERT INTO `lang_definitions` VALUES (22400, 795, 17, 'Descarregue Direto');
INSERT INTO `lang_definitions` VALUES (22401, 796, 17, 'Descarregue Direto');
INSERT INTO `lang_definitions` VALUES (22402, 797, 17, 'Desconto');
INSERT INTO `lang_definitions` VALUES (22403, 798, 17, 'Quantia de desconto');
INSERT INTO `lang_definitions` VALUES (22404, 799, 17, 'Alavanc do Desconto');
INSERT INTO `lang_definitions` VALUES (22405, 800, 17, 'Doença');
INSERT INTO `lang_definitions` VALUES (22406, 801, 17, 'Deslocação');
INSERT INTO `lang_definitions` VALUES (22407, 802, 17, 'Disp #');
INSERT INTO `lang_definitions` VALUES (22408, 803, 17, 'Despacho');
INSERT INTO `lang_definitions` VALUES (22409, 804, 17, 'Despacho Recebeu Documento');
INSERT INTO `lang_definitions` VALUES (22410, 805, 17, 'Dispensado');
INSERT INTO `lang_definitions` VALUES (22411, 806, 17, 'Datas de eventos de exibição em bloco?');
INSERT INTO `lang_definitions` VALUES (22412, 807, 17, 'Exiba quantos eventos?');
INSERT INTO `lang_definitions` VALUES (22413, 808, 17, 'Exiba Localização em bloco?');
INSERT INTO `lang_definitions` VALUES (22414, 809, 17, 'Exiba o calendário?');
INSERT INTO `lang_definitions` VALUES (22415, 810, 17, 'Exiba eventos de hoje em bloco?');
INSERT INTO `lang_definitions` VALUES (22416, 811, 17, 'Exiba tópico em bloco?');
INSERT INTO `lang_definitions` VALUES (22417, 812, 17, 'Exiba eventos a chegar em bloco?');
INSERT INTO `lang_definitions` VALUES (22418, 813, 17, 'Distribuição');
INSERT INTO `lang_definitions` VALUES (22419, 814, 17, 'Diverticulitis');
INSERT INTO `lang_definitions` VALUES (22420, 815, 17, 'Cirúrgia de Diverticulitis');
INSERT INTO `lang_definitions` VALUES (22421, 816, 17, 'Diverticulitis');
INSERT INTO `lang_definitions` VALUES (22422, 817, 17, 'Cirúrgia de Diverticulitis');
INSERT INTO `lang_definitions` VALUES (22423, 818, 17, 'Divorciado');
INSERT INTO `lang_definitions` VALUES (22424, 819, 17, 'Vertigem:');
INSERT INTO `lang_definitions` VALUES (22425, 820, 17, 'Não guardar');
INSERT INTO `lang_definitions` VALUES (22426, 821, 17, 'Não substitua');
INSERT INTO `lang_definitions` VALUES (22427, 823, 17, 'Voçê tem certeza que quer apagar este grupo');
INSERT INTO `lang_definitions` VALUES (22428, 824, 17, 'Voçê deseja continuar a editar este paciente novo?');
INSERT INTO `lang_definitions` VALUES (22429, 825, 17, 'Voçê deseja continuar com o nome novo?');
INSERT INTO `lang_definitions` VALUES (22430, 826, 17, 'Voçê deseja apagar isto PERMANENTEMENTE');
INSERT INTO `lang_definitions` VALUES (22431, 827, 17, 'DOB');
INSERT INTO `lang_definitions` VALUES (22432, 828, 17, 'DOB está perdendo, por favor entre se possível');
INSERT INTO `lang_definitions` VALUES (22433, 829, 17, 'Docs');
INSERT INTO `lang_definitions` VALUES (22434, 830, 17, 'Doutor');
INSERT INTO `lang_definitions` VALUES (22435, 831, 17, 'Doutor:');
INSERT INTO `lang_definitions` VALUES (22436, 832, 17, 'Nome do Doutor\'s e assinatura');
INSERT INTO `lang_definitions` VALUES (22437, 833, 17, 'Documento');
INSERT INTO `lang_definitions` VALUES (22438, 834, 17, 'documento');
INSERT INTO `lang_definitions` VALUES (22439, 835, 17, 'Categórias dos Documentos');
INSERT INTO `lang_definitions` VALUES (22440, 836, 17, 'Documento não pode ser movido para o id do paciente');
INSERT INTO `lang_definitions` VALUES (22441, 837, 17, 'Data do Documento');
INSERT INTO `lang_definitions` VALUES (22442, 838, 17, 'Data do documento e assunto foi atualizado com sucesso');
INSERT INTO `lang_definitions` VALUES (22443, 839, 17, 'Documento movido para nova categória');
INSERT INTO `lang_definitions` VALUES (22444, 840, 17, 'Documento movido para o id do paciente');
INSERT INTO `lang_definitions` VALUES (22445, 841, 17, 'Documento/Imaging Store');
INSERT INTO `lang_definitions` VALUES (22446, 842, 17, 'Documentos');
INSERT INTO `lang_definitions` VALUES (22447, 843, 17, 'Documentos (escrever,addonly opcional)');
INSERT INTO `lang_definitions` VALUES (22448, 844, 17, 'DOE');
INSERT INTO `lang_definitions` VALUES (22449, 845, 17, 'Sócio Doméstico');
INSERT INTO `lang_definitions` VALUES (22450, 846, 17, 'Não guardar');
INSERT INTO `lang_definitions` VALUES (22451, 847, 17, 'Não guardar');
INSERT INTO `lang_definitions` VALUES (22452, 848, 17, 'Não guardar as mudanças');
INSERT INTO `lang_definitions` VALUES (22453, 849, 17, 'Feito');
INSERT INTO `lang_definitions` VALUES (22454, 850, 17, 'Feito com');
INSERT INTO `lang_definitions` VALUES (22455, 851, 17, 'Feito. Enviará o carregamento agpra.');
INSERT INTO `lang_definitions` VALUES (22456, 852, 17, 'DOS');
INSERT INTO `lang_definitions` VALUES (22457, 853, 17, 'Dosagem');
INSERT INTO `lang_definitions` VALUES (22458, 854, 17, 'Duplo-clique para editar');
INSERT INTO `lang_definitions` VALUES (22459, 855, 17, 'Visão duplo');
INSERT INTO `lang_definitions` VALUES (22460, 856, 17, 'Carregamento da faturamento do arquivo, poste para a contabilidade e marca');
INSERT INTO `lang_definitions` VALUES (22461, 857, 17, 'Carregamento da configuração de dados');
INSERT INTO `lang_definitions` VALUES (22462, 858, 17, 'Dr Check');
INSERT INTO `lang_definitions` VALUES (22463, 859, 17, 'Visita Dr');
INSERT INTO `lang_definitions` VALUES (22464, 860, 17, 'Dr.');
INSERT INTO `lang_definitions` VALUES (22465, 861, 17, 'Pingando');
INSERT INTO `lang_definitions` VALUES (22466, 862, 17, 'Carta de Condução ou ID Estatal');
INSERT INTO `lang_definitions` VALUES (22467, 863, 17, 'Droga');
INSERT INTO `lang_definitions` VALUES (22468, 864, 17, 'Formas de Droga');
INSERT INTO `lang_definitions` VALUES (22469, 865, 17, 'Perdendo ID das Drodas');
INSERT INTO `lang_definitions` VALUES (22470, 866, 17, 'Intervalo das Drogas');
INSERT INTO `lang_definitions` VALUES (22471, 867, 17, 'Inventário de Droga');
INSERT INTO `lang_definitions` VALUES (22472, 868, 17, 'Nome da Droga');
INSERT INTO `lang_definitions` VALUES (22473, 869, 17, 'Rotas de Droga');
INSERT INTO `lang_definitions` VALUES (22474, 870, 17, 'Unidades de Droga');
INSERT INTO `lang_definitions` VALUES (22475, 871, 17, 'Drogas');
INSERT INTO `lang_definitions` VALUES (22476, 872, 17, 'Boca seca');
INSERT INTO `lang_definitions` VALUES (22477, 873, 17, 'DT 1');
INSERT INTO `lang_definitions` VALUES (22478, 874, 17, 'DT 2');
INSERT INTO `lang_definitions` VALUES (22479, 875, 17, 'DT 3');
INSERT INTO `lang_definitions` VALUES (22480, 876, 17, 'DT 4');
INSERT INTO `lang_definitions` VALUES (22481, 877, 17, 'DT 5');
INSERT INTO `lang_definitions` VALUES (22482, 878, 17, 'DTaP 1');
INSERT INTO `lang_definitions` VALUES (22483, 879, 17, 'DTaP 2');
INSERT INTO `lang_definitions` VALUES (22484, 880, 17, 'DTaP 3');
INSERT INTO `lang_definitions` VALUES (22485, 881, 17, 'DTaP 4');
INSERT INTO `lang_definitions` VALUES (22486, 882, 17, 'DTaP 5');
INSERT INTO `lang_definitions` VALUES (22487, 883, 17, 'Data de vencimento');
INSERT INTO `lang_definitions` VALUES (22488, 884, 17, 'Data de vencimento m/dd/yyyy ou yyyy/mm/dd');
INSERT INTO `lang_definitions` VALUES (22489, 885, 17, 'Data de vencimento');
INSERT INTO `lang_definitions` VALUES (22490, 886, 17, 'Vencimento Ins');
INSERT INTO `lang_definitions` VALUES (22491, 887, 17, 'Vencimento Pt');
INSERT INTO `lang_definitions` VALUES (22492, 888, 17, 'Base de dados OpenEMR esvaziado');
INSERT INTO `lang_definitions` VALUES (22493, 889, 17, 'Rede da árvore OpenEMR do diretório esvaziando');
INSERT INTO `lang_definitions` VALUES (22494, 890, 17, 'Base de dados de phpGACL esvaziando');
INSERT INTO `lang_definitions` VALUES (22495, 891, 17, 'Rede da árvore phpGACL do diretório esvaziando');
INSERT INTO `lang_definitions` VALUES (22496, 892, 17, 'Base de dados SQL-Ledger esvaziado');
INSERT INTO `lang_definitions` VALUES (22497, 893, 17, 'Rede da árvore SQL-Ledger do diretório esvaziando');
INSERT INTO `lang_definitions` VALUES (22498, 894, 17, 'ADVERTÊNCIA DE DUPLICAÇÃO');
INSERT INTO `lang_definitions` VALUES (22499, 895, 17, 'duração');
INSERT INTO `lang_definitions` VALUES (22500, 896, 17, 'Duração');
INSERT INTO `lang_definitions` VALUES (22501, 897, 17, 'Holandês');
INSERT INTO `lang_definitions` VALUES (22502, 898, 17, 'Disfagia');
INSERT INTO `lang_definitions` VALUES (22503, 899, 17, 'Dysphagia');
INSERT INTO `lang_definitions` VALUES (22504, 900, 17, 'Dysuria');
INSERT INTO `lang_definitions` VALUES (22505, 901, 17, 'Retorno Cedo (<2 Mo)');
INSERT INTO `lang_definitions` VALUES (22506, 902, 17, 'Orelhas');
INSERT INTO `lang_definitions` VALUES (22507, 903, 17, 'ECG');
INSERT INTO `lang_definitions` VALUES (22508, 904, 17, 'Edema');
INSERT INTO `lang_definitions` VALUES (22509, 905, 17, 'Editar');
INSERT INTO `lang_definitions` VALUES (22510, 906, 17, 'Edite Alergias');
INSERT INTO `lang_definitions` VALUES (22511, 907, 17, 'Edite Categórias');
INSERT INTO `lang_definitions` VALUES (22512, 908, 17, 'Edite definições');
INSERT INTO `lang_definitions` VALUES (22513, 909, 17, 'Edite Diagnósticos para');
INSERT INTO `lang_definitions` VALUES (22514, 910, 17, 'Edite Facilidades');
INSERT INTO `lang_definitions` VALUES (22515, 911, 17, 'Edite Infirmações com Facilidade');
INSERT INTO `lang_definitions` VALUES (22516, 912, 17, 'Edite forma');
INSERT INTO `lang_definitions` VALUES (22517, 913, 17, 'Edite Plano');
INSERT INTO `lang_definitions` VALUES (22518, 914, 17, 'Edite Lista');
INSERT INTO `lang_definitions` VALUES (22519, 915, 17, 'Edite Estrutura');
INSERT INTO `lang_definitions` VALUES (22520, 916, 17, 'Educação');
INSERT INTO `lang_definitions` VALUES (22521, 917, 17, 'Data de Educação');
INSERT INTO `lang_definitions` VALUES (22522, 918, 17, 'detalhes.* * Voçê deveria ter recebido uma cópia do');
INSERT INTO `lang_definitions` VALUES (22523, 919, 17, 'Data Efetiva');
INSERT INTO `lang_definitions` VALUES (22524, 920, 17, 'Efetividade');
INSERT INTO `lang_definitions` VALUES (22525, 921, 17, 'Ejaculação');
INSERT INTO `lang_definitions` VALUES (22526, 922, 17, 'Cotovelo');
INSERT INTO `lang_definitions` VALUES (22527, 923, 17, 'Ploblemas do Cotovelo');
INSERT INTO `lang_definitions` VALUES (22528, 924, 17, 'Eletrônico Remete');
INSERT INTO `lang_definitions` VALUES (22529, 925, 17, 'E-mail');
INSERT INTO `lang_definitions` VALUES (22530, 926, 17, 'E-mail de Batchcom');
INSERT INTO `lang_definitions` VALUES (22531, 927, 17, 'Notificação de E-mail');
INSERT INTO `lang_definitions` VALUES (22532, 928, 17, 'E-mail enviado antes');
INSERT INTO `lang_definitions` VALUES (22533, 929, 17, 'E-mail Remitente');
INSERT INTO `lang_definitions` VALUES (22534, 930, 17, 'Assunto de e-mail');
INSERT INTO `lang_definitions` VALUES (22535, 931, 17, '***NOME***');
INSERT INTO `lang_definitions` VALUES (22536, 932, 17, 'Contato de Emergência');
INSERT INTO `lang_definitions` VALUES (22537, 933, 17, 'Contato da Pessoa de Emergêrcia');
INSERT INTO `lang_definitions` VALUES (22538, 934, 17, 'Numero do Telefone de Emergência da Pessoa');
INSERT INTO `lang_definitions` VALUES (22539, 935, 17, 'Anticontraceptivos de Emergência');
INSERT INTO `lang_definitions` VALUES (22540, 936, 17, 'Telefone de Emergência');
INSERT INTO `lang_definitions` VALUES (22541, 937, 17, 'Enfisema');
INSERT INTO `lang_definitions` VALUES (22542, 938, 17, 'Empregado');
INSERT INTO `lang_definitions` VALUES (22543, 939, 17, 'Empregador');
INSERT INTO `lang_definitions` VALUES (22544, 940, 17, 'Endereço Empregador');
INSERT INTO `lang_definitions` VALUES (22545, 941, 17, 'Data do Empregador');
INSERT INTO `lang_definitions` VALUES (22546, 942, 17, 'Nome do Empregador');
INSERT INTO `lang_definitions` VALUES (22547, 943, 17, 'Vazio');
INSERT INTO `lang_definitions` VALUES (22548, 944, 17, 'Valor vazio em \"Hora do E-mail\"');
INSERT INTO `lang_definitions` VALUES (22549, 945, 17, 'Valor vazio em \"Rementente do E-mail\"');
INSERT INTO `lang_definitions` VALUES (22550, 946, 17, 'Valor vazio em \"Assunto de E-mail');
INSERT INTO `lang_definitions` VALUES (22551, 947, 17, 'Valor vazio em \"Testo de E-mail\"');
INSERT INTO `lang_definitions` VALUES (22552, 948, 17, 'Valor vazio em \"Nome do Provedor\"');
INSERT INTO `lang_definitions` VALUES (22553, 949, 17, 'Valor vazio em \"Palavra-chave\"');
INSERT INTO `lang_definitions` VALUES (22554, 950, 17, 'Valor vazio em \"Horas do SMS\"');
INSERT INTO `lang_definitions` VALUES (22555, 951, 17, 'Valor vazio em \"Testo do SMS\"');
INSERT INTO `lang_definitions` VALUES (22556, 952, 17, 'Valor vazio em \"Nome do Ùsuario\"');
INSERT INTO `lang_definitions` VALUES (22557, 953, 17, 'Habilitado');
INSERT INTO `lang_definitions` VALUES (22558, 954, 17, 'Enc');
INSERT INTO `lang_definitions` VALUES (22559, 955, 17, 'encontro');
INSERT INTO `lang_definitions` VALUES (22560, 956, 17, 'Encontro');
INSERT INTO `lang_definitions` VALUES (22561, 957, 17, 'Encontro');
INSERT INTO `lang_definitions` VALUES (22562, 958, 17, 'Formas de Encontro');
INSERT INTO `lang_definitions` VALUES (22563, 959, 17, 'Número de Encontro');
INSERT INTO `lang_definitions` VALUES (22564, 960, 17, 'Encontro foi codificado');
INSERT INTO `lang_definitions` VALUES (22565, 961, 17, 'Encontro:');
INSERT INTO `lang_definitions` VALUES (22566, 962, 17, 'Encontros:');
INSERT INTO `lang_definitions` VALUES (22567, 963, 17, 'Encontros & Formas');
INSERT INTO `lang_definitions` VALUES (22568, 964, 17, 'Encontros &amp; Formas');
INSERT INTO `lang_definitions` VALUES (22569, 965, 17, 'Encontro não autorizado');
INSERT INTO `lang_definitions` VALUES (22570, 966, 17, 'Relatório de Encontro');
INSERT INTO `lang_definitions` VALUES (22571, 967, 17, 'Secção de Encontros');
INSERT INTO `lang_definitions` VALUES (22572, 968, 17, 'Fim');
INSERT INTO `lang_definitions` VALUES (22573, 969, 17, 'Fim (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (22574, 970, 17, 'Data do Fim');
INSERT INTO `lang_definitions` VALUES (22575, 971, 17, 'Data do Fim');
INSERT INTO `lang_definitions` VALUES (22576, 972, 17, 'Data do Fim');
INSERT INTO `lang_definitions` VALUES (22577, 973, 17, 'Tempo do Fim');
INSERT INTO `lang_definitions` VALUES (22578, 974, 17, 'Terminada a data de serviço yyyy-mm-dd');
INSERT INTO `lang_definitions` VALUES (22579, 975, 17, 'gama');
INSERT INTO `lang_definitions` VALUES (22580, 976, 17, 'Endo Sangue anormal');
INSERT INTO `lang_definitions` VALUES (22581, 977, 17, 'Endócrine');
INSERT INTO `lang_definitions` VALUES (22582, 978, 17, 'Endoscopia');
INSERT INTO `lang_definitions` VALUES (22583, 979, 17, 'Inglês');
INSERT INTO `lang_definitions` VALUES (22584, 980, 17, 'Inglês');
INSERT INTO `lang_definitions` VALUES (22585, 981, 17, 'Inglês (Indiano)');
INSERT INTO `lang_definitions` VALUES (22586, 982, 17, 'Inglês (Padrão)');
INSERT INTO `lang_definitions` VALUES (22587, 983, 17, 'Assegure OpenEMR foi escrito privilégios a diretório');
INSERT INTO `lang_definitions` VALUES (22588, 984, 17, 'ENT Descarga');
INSERT INTO `lang_definitions` VALUES (22589, 985, 17, 'ENT Dor');
INSERT INTO `lang_definitions` VALUES (22590, 986, 17, 'Execute em código de diagnóstico para excluir todas as faturas');
INSERT INTO `lang_definitions` VALUES (22591, 987, 17, 'Execute aqui em corpo de carta');
INSERT INTO `lang_definitions` VALUES (22592, 988, 17, 'Execute novo Estado');
INSERT INTO `lang_definitions` VALUES (22593, 989, 17, 'Entre em seus critérios de pesquisa acima');
INSERT INTO `lang_definitions` VALUES (22594, 990, 17, 'Ambiental');
INSERT INTO `lang_definitions` VALUES (22595, 991, 17, 'Entrada de dados de EOB');
INSERT INTO `lang_definitions` VALUES (22596, 992, 17, 'EOB Postando - Remessas Eletrônicas');
INSERT INTO `lang_definitions` VALUES (22597, 993, 17, 'EOB Postando - Instruções');
INSERT INTO `lang_definitions` VALUES (22598, 994, 17, 'EOB Postando - Fatura');
INSERT INTO `lang_definitions` VALUES (22599, 995, 17, 'EOB Postando - Notas do Paciente');
INSERT INTO `lang_definitions` VALUES (22600, 996, 17, 'EOB Postando - Procura');
INSERT INTO `lang_definitions` VALUES (22601, 997, 17, 'Epilepsia');
INSERT INTO `lang_definitions` VALUES (22602, 998, 17, 'Apague');
INSERT INTO `lang_definitions` VALUES (22603, 999, 17, 'Ereção');
INSERT INTO `lang_definitions` VALUES (22604, 1000, 17, 'Erro');
INSERT INTO `lang_definitions` VALUES (22605, 1001, 17, 'Erro de seleção em \"Gênero\"');
INSERT INTO `lang_definitions` VALUES (22606, 1002, 17, 'Erro de seleção em \"HIPAA\"');
INSERT INTO `lang_definitions` VALUES (22607, 1003, 17, 'Erro de seleção em \"Processo\"');
INSERT INTO `lang_definitions` VALUES (22608, 1004, 17, 'Erro de seleção em \"Portal de SMS\"');
INSERT INTO `lang_definitions` VALUES (22609, 1005, 17, 'Erro de seleção em \"Ordene Por\"');
INSERT INTO `lang_definitions` VALUES (22610, 1007, 17, 'Erro de seleção em opções SIM ou NÂO');
INSERT INTO `lang_definitions` VALUES (22611, 1009, 17, 'erro enquanto registrando forma!');
INSERT INTO `lang_definitions` VALUES (22612, 1010, 17, 'Erro enquanto está guardando ão arquivo');
INSERT INTO `lang_definitions` VALUES (22613, 1011, 17, 'Erro enquanto está escrevendo ão arquivo');
INSERT INTO `lang_definitions` VALUES (22614, 1012, 17, 'ERRO, Incapaz de colecionar dados do servidor');
INSERT INTO `lang_definitions` VALUES (22615, 1014, 17, 'ERRO, não pode abrir table.sql, forma quebrada');
INSERT INTO `lang_definitions` VALUES (22616, 1016, 17, 'Erro: palavra-chave não combina. Por favor confira seu');
INSERT INTO `lang_definitions` VALUES (22617, 1018, 17, 'Erros');
INSERT INTO `lang_definitions` VALUES (22618, 1019, 17, 'Erythema:');
INSERT INTO `lang_definitions` VALUES (22619, 1020, 17, 'Paciente Estabelecido');
INSERT INTO `lang_definitions` VALUES (22620, 1021, 17, 'Etnicidade ou Raça');
INSERT INTO `lang_definitions` VALUES (22621, 1022, 17, 'Lista de Etnicidade-Raça (escrever,addonly opcional)');
INSERT INTO `lang_definitions` VALUES (22622, 1023, 17, 'ETIN');
INSERT INTO `lang_definitions` VALUES (22623, 1024, 17, 'Evento');
INSERT INTO `lang_definitions` VALUES (22624, 1025, 17, 'Início de Eventos');
INSERT INTO `lang_definitions` VALUES (22625, 1026, 17, 'Categoria de Eventos');
INSERT INTO `lang_definitions` VALUES (22626, 1027, 17, 'Data de Evento');
INSERT INTO `lang_definitions` VALUES (22627, 1028, 17, 'Descrição de Eventos');
INSERT INTO `lang_definitions` VALUES (22628, 1029, 17, 'Detalhes de Evento');
INSERT INTO `lang_definitions` VALUES (22629, 1030, 17, 'Evento não repete');
INSERT INTO `lang_definitions` VALUES (22630, 1031, 17, 'Duração de Evento');
INSERT INTO `lang_definitions` VALUES (22631, 1032, 17, 'Duração de Evento em minutos');
INSERT INTO `lang_definitions` VALUES (22632, 1033, 17, 'Evento Livre');
INSERT INTO `lang_definitions` VALUES (22633, 1034, 17, 'Localização de Evento');
INSERT INTO `lang_definitions` VALUES (22634, 1035, 17, 'Evento repete todo');
INSERT INTO `lang_definitions` VALUES (22635, 1036, 17, 'Evento repete em');
INSERT INTO `lang_definitions` VALUES (22636, 1037, 17, 'Tempo do começo de Evento');
INSERT INTO `lang_definitions` VALUES (22637, 1038, 17, 'título de Evento');
INSERT INTO `lang_definitions` VALUES (22638, 1039, 17, 'Título de Evento');
INSERT INTO `lang_definitions` VALUES (22639, 1040, 17, 'Site da Web de Evento');
INSERT INTO `lang_definitions` VALUES (22640, 1041, 17, 'Eventos');
INSERT INTO `lang_definitions` VALUES (22641, 1042, 17, 'Eventos para');
INSERT INTO `lang_definitions` VALUES (22642, 1043, 17, 'Evento aberto em nova janela');
INSERT INTO `lang_definitions` VALUES (22643, 1044, 17, 'todo');
INSERT INTO `lang_definitions` VALUES (22644, 1045, 17, 'Todo');
INSERT INTO `lang_definitions` VALUES (22645, 1046, 17, 'Cada 3 horas');
INSERT INTO `lang_definitions` VALUES (22646, 1047, 17, 'Cada 4 horas');
INSERT INTO `lang_definitions` VALUES (22647, 1048, 17, 'Cada 5 horas');
INSERT INTO `lang_definitions` VALUES (22648, 1049, 17, 'Cada 6 horas');
INSERT INTO `lang_definitions` VALUES (22649, 1050, 17, 'Cada 8 horas');
INSERT INTO `lang_definitions` VALUES (22650, 1051, 17, 'Cada Quarto');
INSERT INTO `lang_definitions` VALUES (22651, 1052, 17, 'Cada Outro');
INSERT INTO `lang_definitions` VALUES (22652, 1053, 17, 'Cada Terço');
INSERT INTO `lang_definitions` VALUES (22653, 1054, 17, 'Cada, cada outro, Cada 3rd, etc.');
INSERT INTO `lang_definitions` VALUES (22654, 1055, 17, 'Exam e resultados dos testes');
INSERT INTO `lang_definitions` VALUES (22655, 1056, 17, 'Resultados dos Exam');
INSERT INTO `lang_definitions` VALUES (22656, 1057, 17, 'Data da Examinação');
INSERT INTO `lang_definitions` VALUES (22657, 1058, 17, 'Exams/testes');
INSERT INTO `lang_definitions` VALUES (22658, 1059, 17, 'Excessivas Lágrimas');
INSERT INTO `lang_definitions` VALUES (22659, 1060, 17, 'Organização de provedor excessiva (EPO)');
INSERT INTO `lang_definitions` VALUES (22660, 1061, 17, 'Exercite padrões');
INSERT INTO `lang_definitions` VALUES (22661, 1062, 17, 'Exercite Padrões');
INSERT INTO `lang_definitions` VALUES (22662, 1063, 17, 'Sair da Administração');
INSERT INTO `lang_definitions` VALUES (22663, 1064, 17, 'Exp');
INSERT INTO `lang_definitions` VALUES (22664, 1065, 17, 'Visão Expandida');
INSERT INTO `lang_definitions` VALUES (22665, 1066, 17, 'Forma_encontro.pid esperado para ser');
INSERT INTO `lang_definitions` VALUES (22666, 1067, 17, 'Expiração');
INSERT INTO `lang_definitions` VALUES (22667, 1068, 17, 'Data de Expiração');
INSERT INTO `lang_definitions` VALUES (22668, 1069, 17, 'Expira');
INSERT INTO `lang_definitions` VALUES (22669, 1070, 17, 'Exportação');
INSERT INTO `lang_definitions` VALUES (22670, 1071, 17, 'Exportação como CSV');
INSERT INTO `lang_definitions` VALUES (22671, 1072, 17, 'Configuração de Exportação');
INSERT INTO `lang_definitions` VALUES (22672, 1073, 17, 'Exportção Demographics do Paciente');
INSERT INTO `lang_definitions` VALUES (22673, 1074, 17, 'Seleção de Exportação como CSV');
INSERT INTO `lang_definitions` VALUES (22674, 1075, 17, 'Seleção de Exportação para coleções');
INSERT INTO `lang_definitions` VALUES (22675, 1076, 17, 'Exporte para CSV');
INSERT INTO `lang_definitions` VALUES (22676, 1077, 17, 'Exporte para o sistema de faturamento externo');
INSERT INTO `lang_definitions` VALUES (22677, 1078, 17, 'Exposições para países estrângeiros');
INSERT INTO `lang_definitions` VALUES (22678, 1079, 17, 'Exposições Para países estrângeiros');
INSERT INTO `lang_definitions` VALUES (22679, 1080, 17, 'Externo');
INSERT INTO `lang_definitions` VALUES (22680, 1081, 17, 'ID Externo');
INSERT INTO `lang_definitions` VALUES (22681, 1082, 17, 'Identificação Externo');
INSERT INTO `lang_definitions` VALUES (22682, 1083, 17, 'Somente Externo');
INSERT INTO `lang_definitions` VALUES (22683, 1084, 17, 'Indicação Externa');
INSERT INTO `lang_definitions` VALUES (22684, 1085, 17, 'Indicação Externa Followups');
INSERT INTO `lang_definitions` VALUES (22685, 1086, 17, 'Indicação Externa?');
INSERT INTO `lang_definitions` VALUES (22686, 1087, 17, 'Indicações Externa');
INSERT INTO `lang_definitions` VALUES (22687, 1088, 17, 'Exsudato:');
INSERT INTO `lang_definitions` VALUES (22688, 1089, 17, 'Irritação nos olhos');
INSERT INTO `lang_definitions` VALUES (22689, 1090, 17, 'Dor nos olhos');
INSERT INTO `lang_definitions` VALUES (22690, 1091, 17, 'Olhos Vermelhos');
INSERT INTO `lang_definitions` VALUES (22691, 1092, 17, 'Olhos');
INSERT INTO `lang_definitions` VALUES (22692, 1093, 17, 'F');
INSERT INTO `lang_definitions` VALUES (22693, 1094, 17, 'F/H Blood Problems');
INSERT INTO `lang_definitions` VALUES (22694, 1096, 17, 'Instalações');
INSERT INTO `lang_definitions` VALUES (22695, 1097, 17, 'Facilidade');
INSERT INTO `lang_definitions` VALUES (22696, 1098, 17, 'facilidade');
INSERT INTO `lang_definitions` VALUES (22697, 1099, 17, 'Administração de Facilidades');
INSERT INTO `lang_definitions` VALUES (22698, 1100, 17, 'Código de Facilidade');
INSERT INTO `lang_definitions` VALUES (22699, 1101, 17, 'Facilidade NPI');
INSERT INTO `lang_definitions` VALUES (22700, 1102, 17, 'Facilidade:');
INSERT INTO `lang_definitions` VALUES (22701, 1103, 17, 'Falhado');
INSERT INTO `lang_definitions` VALUES (22702, 1105, 17, 'Fracasso');
INSERT INTO `lang_definitions` VALUES (22703, 1106, 17, 'História da Familia');
INSERT INTO `lang_definitions` VALUES (22704, 1107, 17, 'História da Familia de Glaucoma');
INSERT INTO `lang_definitions` VALUES (22705, 1108, 17, 'História da Familia:');
INSERT INTO `lang_definitions` VALUES (22706, 1109, 17, 'Tamanho da Familia');
INSERT INTO `lang_definitions` VALUES (22707, 1110, 17, 'Fantasia');
INSERT INTO `lang_definitions` VALUES (22708, 1111, 17, 'Pai');
INSERT INTO `lang_definitions` VALUES (22709, 1112, 17, 'Fadiga');
INSERT INTO `lang_definitions` VALUES (22710, 1113, 17, 'Cansado');
INSERT INTO `lang_definitions` VALUES (22711, 1114, 17, 'Fax');
INSERT INTO `lang_definitions` VALUES (22712, 1115, 17, 'Número do Fax');
INSERT INTO `lang_definitions` VALUES (22713, 1116, 17, 'Fax/Scan');
INSERT INTO `lang_definitions` VALUES (22714, 1117, 17, 'Envie Fax dentro');
INSERT INTO `lang_definitions` VALUES (22715, 1118, 17, 'Envie Fax Fora');
INSERT INTO `lang_definitions` VALUES (22716, 1119, 17, 'Fevereiro');
INSERT INTO `lang_definitions` VALUES (22717, 1120, 17, 'FECA');
INSERT INTO `lang_definitions` VALUES (22718, 1121, 17, 'Droga Federal ID');
INSERT INTO `lang_definitions` VALUES (22719, 1122, 17, 'EID Federal');
INSERT INTO `lang_definitions` VALUES (22720, 1123, 17, 'Imposto Federal ID');
INSERT INTO `lang_definitions` VALUES (22721, 1124, 17, 'Taxa');
INSERT INTO `lang_definitions` VALUES (22722, 1125, 17, 'taxa');
INSERT INTO `lang_definitions` VALUES (22723, 1126, 17, 'Taxa não é permitida');
INSERT INTO `lang_definitions` VALUES (22724, 1127, 17, 'Folha da Taxa');
INSERT INTO `lang_definitions` VALUES (22725, 1128, 17, 'Opções da Folha da Taxa');
INSERT INTO `lang_definitions` VALUES (22726, 1129, 17, 'Taxas');
INSERT INTO `lang_definitions` VALUES (22727, 1130, 17, 'Femenina');
INSERT INTO `lang_definitions` VALUES (22728, 1131, 17, 'AP Femenino');
INSERT INTO `lang_definitions` VALUES (22729, 1132, 17, 'Camisinhas Femenina');
INSERT INTO `lang_definitions` VALUES (22730, 1133, 17, 'G Feminina');
INSERT INTO `lang_definitions` VALUES (22731, 1134, 17, 'LC Femenina');
INSERT INTO `lang_definitions` VALUES (22732, 1135, 17, 'P Femenina');
INSERT INTO `lang_definitions` VALUES (22733, 1136, 17, 'Sintomas Femeninos');
INSERT INTO `lang_definitions` VALUES (22734, 1137, 17, 'VSC Femenino');
INSERT INTO `lang_definitions` VALUES (22735, 1138, 17, 'Febre');
INSERT INTO `lang_definitions` VALUES (22736, 1139, 17, 'Febre:');
INSERT INTO `lang_definitions` VALUES (22737, 1140, 17, 'Problema no Sangue FH');
INSERT INTO `lang_definitions` VALUES (22738, 1141, 17, 'Fibroids');
INSERT INTO `lang_definitions` VALUES (22739, 1142, 17, 'Arquivo');
INSERT INTO `lang_definitions` VALUES (22740, 1143, 17, 'Quarto de Arquivo');
INSERT INTO `lang_definitions` VALUES (22741, 1144, 17, 'Arquive para transferir');
INSERT INTO `lang_definitions` VALUES (22742, 1145, 17, 'Arquivi com mesmo nome já existe neste local');
INSERT INTO `lang_definitions` VALUES (22743, 1146, 17, 'Nome do Arquivo');
INSERT INTO `lang_definitions` VALUES (22744, 1147, 17, 'Preencha aqui somente se enviarem notificação do e-mail para');
INSERT INTO `lang_definitions` VALUES (22745, 1148, 17, 'Filtro');
INSERT INTO `lang_definitions` VALUES (22746, 1149, 17, 'Filtro para Constantes');
INSERT INTO `lang_definitions` VALUES (22747, 1150, 17, 'Filtros');
INSERT INTO `lang_definitions` VALUES (22748, 1151, 17, 'Diagnóstico Final');
INSERT INTO `lang_definitions` VALUES (22749, 1152, 17, 'Diagnóstico Final pelo especialista');
INSERT INTO `lang_definitions` VALUES (22750, 1153, 17, 'Financeiro');
INSERT INTO `lang_definitions` VALUES (22751, 1154, 17, 'Relatório Financeiro - qualquer coisa');
INSERT INTO `lang_definitions` VALUES (22752, 1155, 17, 'Relatório Financeiro - meus encontros');
INSERT INTO `lang_definitions` VALUES (22753, 1156, 17, 'Data da Revisão Financeira');
INSERT INTO `lang_definitions` VALUES (22754, 1157, 17, 'Achar');
INSERT INTO `lang_definitions` VALUES (22755, 1158, 17, 'Achar Disponíveis');
INSERT INTO `lang_definitions` VALUES (22756, 1159, 17, 'Achar Compromissos Disponíveis');
INSERT INTO `lang_definitions` VALUES (22757, 1160, 17, 'Encontre Paciente');
INSERT INTO `lang_definitions` VALUES (22758, 1161, 17, 'Achados');
INSERT INTO `lang_definitions` VALUES (22759, 1162, 17, 'Achados por especialista');
INSERT INTO `lang_definitions` VALUES (22760, 1163, 17, 'Multa');
INSERT INTO `lang_definitions` VALUES (22761, 1164, 17, 'Primeiro');
INSERT INTO `lang_definitions` VALUES (22762, 1165, 17, 'Primeiro dia da Semana');
INSERT INTO `lang_definitions` VALUES (22763, 1166, 17, 'Primeiro Nome');
INSERT INTO `lang_definitions` VALUES (22764, 1167, 17, 'Primeiro nome');
INSERT INTO `lang_definitions` VALUES (22765, 1168, 17, 'Primeiro Nome');
INSERT INTO `lang_definitions` VALUES (22766, 1169, 17, 'Boa forma');
INSERT INTO `lang_definitions` VALUES (22767, 1170, 17, 'Boa forma para Jogar');
INSERT INTO `lang_definitions` VALUES (22768, 1171, 17, 'Fixar datas para encontro - qualquer encontro');
INSERT INTO `lang_definitions` VALUES (22769, 1172, 17, 'Fixar isto');
INSERT INTO `lang_definitions` VALUES (22770, 1173, 17, 'Flatulência');
INSERT INTO `lang_definitions` VALUES (22771, 1174, 17, 'Fluxo');
INSERT INTO `lang_definitions` VALUES (22772, 1175, 17, 'Vacinação de Infuenza');
INSERT INTO `lang_definitions` VALUES (22773, 1176, 17, 'Fluido e problema de eletrólito');
INSERT INTO `lang_definitions` VALUES (22774, 1177, 17, 'FMS');
INSERT INTO `lang_definitions` VALUES (22775, 1178, 17, 'Siga Manualmente');
INSERT INTO `lang_definitions` VALUES (22776, 1179, 17, 'Intolerância da Comida');
INSERT INTO `lang_definitions` VALUES (22777, 1180, 17, 'Pé');
INSERT INTO `lang_definitions` VALUES (22778, 1181, 17, 'Problema nos Pés');
INSERT INTO `lang_definitions` VALUES (22779, 1182, 17, 'Pé:');
INSERT INTO `lang_definitions` VALUES (22780, 1183, 17, 'Danos do Futebol');
INSERT INTO `lang_definitions` VALUES (22781, 1184, 17, 'Relatório de Danos do Futebol');
INSERT INTO `lang_definitions` VALUES (22782, 1185, 17, 'Tipo de Calçado');
INSERT INTO `lang_definitions` VALUES (22783, 1186, 17, 'Para');
INSERT INTO `lang_definitions` VALUES (22784, 1189, 17, 'Para:');
INSERT INTO `lang_definitions` VALUES (22785, 1190, 17, 'Antebraço');
INSERT INTO `lang_definitions` VALUES (22786, 1191, 17, 'Forma');
INSERT INTO `lang_definitions` VALUES (22787, 1192, 17, 'forma');
INSERT INTO `lang_definitions` VALUES (22788, 1193, 17, 'formato');
INSERT INTO `lang_definitions` VALUES (22789, 1194, 17, 'Formato');
INSERT INTO `lang_definitions` VALUES (22790, 1195, 17, 'Formato incorreto para NDC');
INSERT INTO `lang_definitions` VALUES (22791, 1196, 17, 'Formas');
INSERT INTO `lang_definitions` VALUES (22792, 1197, 17, 'Formas Administrativas');
INSERT INTO `lang_definitions` VALUES (22793, 1198, 17, 'Remetir Páginas por Fax');
INSERT INTO `lang_definitions` VALUES (22794, 1199, 17, 'Quarto');
INSERT INTO `lang_definitions` VALUES (22795, 1200, 17, 'Frature');
INSERT INTO `lang_definitions` VALUES (22796, 1201, 17, 'Fratura ao Navicula');
INSERT INTO `lang_definitions` VALUES (22797, 1202, 17, 'Fratura lateral malleolus');
INSERT INTO `lang_definitions` VALUES (22798, 1203, 17, 'Fratura medial malleolus');
INSERT INTO `lang_definitions` VALUES (22799, 1204, 17, 'Fratura, Base do quinto metatarsal');
INSERT INTO `lang_definitions` VALUES (22800, 1205, 17, 'Francês');
INSERT INTO `lang_definitions` VALUES (22801, 1206, 17, 'Frequência');
INSERT INTO `lang_definitions` VALUES (22802, 1207, 17, 'Resfriados Frequêntes');
INSERT INTO `lang_definitions` VALUES (22803, 1208, 17, 'Doeça Frequência');
INSERT INTO `lang_definitions` VALUES (22804, 1209, 17, 'Fri');
INSERT INTO `lang_definitions` VALUES (22805, 1210, 17, 'Sexta');
INSERT INTO `lang_definitions` VALUES (22806, 1211, 17, 'De');
INSERT INTO `lang_definitions` VALUES (22807, 1212, 17, 'DE');
INSERT INTO `lang_definitions` VALUES (22808, 1213, 17, 'De:');
INSERT INTO `lang_definitions` VALUES (22809, 1214, 17, 'De:');
INSERT INTO `lang_definitions` VALUES (22810, 1215, 17, 'DE_CIDADE');
INSERT INTO `lang_definitions` VALUES (22811, 1216, 17, 'DE_FNOME');
INSERT INTO `lang_definitions` VALUES (22812, 1217, 17, 'DE_LNOME');
INSERT INTO `lang_definitions` VALUES (22813, 1218, 17, 'DE_MNOME');
INSERT INTO `lang_definitions` VALUES (22814, 1219, 17, 'DE_TELEFONECELULAR');
INSERT INTO `lang_definitions` VALUES (22815, 1220, 17, 'DE_POSTAL');
INSERT INTO `lang_definitions` VALUES (22816, 1221, 17, 'DE_ESTADO');
INSERT INTO `lang_definitions` VALUES (22817, 1222, 17, 'DE_RUA');
INSERT INTO `lang_definitions` VALUES (22818, 1223, 17, 'DE_TÍTULO');
INSERT INTO `lang_definitions` VALUES (22819, 1224, 17, 'DE_VALEDICTORY');
INSERT INTO `lang_definitions` VALUES (22820, 1225, 17, 'Escritório Dianteiro');
INSERT INTO `lang_definitions` VALUES (22821, 1226, 17, 'Receitas do Escritório Dianteiro');
INSERT INTO `lang_definitions` VALUES (22822, 1227, 17, 'Relatório das Receitas do Escritório Dianteiro');
INSERT INTO `lang_definitions` VALUES (22823, 1228, 17, 'Dianteiro Rec');
INSERT INTO `lang_definitions` VALUES (22824, 1229, 17, 'Doireito Fronteiriço');
INSERT INTO `lang_definitions` VALUES (22825, 1230, 17, 'Nome Completo');
INSERT INTO `lang_definitions` VALUES (22826, 1231, 17, 'Jogo Completo');
INSERT INTO `lang_definitions` VALUES (22827, 1232, 17, 'Treinamento Completo');
INSERT INTO `lang_definitions` VALUES (22828, 1233, 17, 'G');
INSERT INTO `lang_definitions` VALUES (22829, 1234, 17, 'Esfole Condições da Bexiga');
INSERT INTO `lang_definitions` VALUES (22830, 1235, 17, 'Pedras de Fel');
INSERT INTO `lang_definitions` VALUES (22831, 1236, 17, 'Período do Jogo');
INSERT INTO `lang_definitions` VALUES (22832, 1237, 17, 'Jogos');
INSERT INTO `lang_definitions` VALUES (22833, 1238, 17, 'jogos/Eventos');
INSERT INTO `lang_definitions` VALUES (22834, 1239, 17, 'jogos/Eventos Perdidos');
INSERT INTO `lang_definitions` VALUES (22835, 1240, 17, 'Gastrites');
INSERT INTO `lang_definitions` VALUES (22836, 1241, 17, 'Dor de Gastro');
INSERT INTO `lang_definitions` VALUES (22837, 1242, 17, 'Gastrointestinal');
INSERT INTO `lang_definitions` VALUES (22838, 1243, 17, 'Relatório de Estatisticas GCAC');
INSERT INTO `lang_definitions` VALUES (22839, 1244, 17, 'Está perdendo a forma de visita GCAC');
INSERT INTO `lang_definitions` VALUES (22840, 1245, 17, 'Gênero');
INSERT INTO `lang_definitions` VALUES (22841, 1246, 17, 'Gênero');
INSERT INTO `lang_definitions` VALUES (22842, 1247, 17, 'Geral');
INSERT INTO `lang_definitions` VALUES (22843, 1248, 17, 'Serviço Geral de Categoria');
INSERT INTO `lang_definitions` VALUES (22844, 1249, 17, 'Gere e Carregue reivindicaçôes de papel HCFA 1500');
INSERT INTO `lang_definitions` VALUES (22845, 1250, 17, 'Gere e Carregue Grupo X12');
INSERT INTO `lang_definitions` VALUES (22846, 1253, 17, 'HCFA Geral');
INSERT INTO `lang_definitions` VALUES (22847, 1254, 17, 'Carta Geral');
INSERT INTO `lang_definitions` VALUES (22848, 1255, 17, 'Carta Geral relativo a');
INSERT INTO `lang_definitions` VALUES (22849, 1256, 17, 'Relatório Geral');
INSERT INTO `lang_definitions` VALUES (22850, 1257, 17, 'Geral X12');
INSERT INTO `lang_definitions` VALUES (22851, 1259, 17, 'Gerado em');
INSERT INTO `lang_definitions` VALUES (22852, 1260, 17, 'Gerados');
INSERT INTO `lang_definitions` VALUES (22853, 1261, 17, 'Genitourinary');
INSERT INTO `lang_definitions` VALUES (22854, 1262, 17, 'Alemão');
INSERT INTO `lang_definitions` VALUES (22855, 1263, 17, 'Glaucoma');
INSERT INTO `lang_definitions` VALUES (22856, 1264, 17, 'História Glaucoma da Familia');
INSERT INTO `lang_definitions` VALUES (22857, 1265, 17, 'Global');
INSERT INTO `lang_definitions` VALUES (22858, 1266, 17, 'ID Global');
INSERT INTO `lang_definitions` VALUES (22859, 1267, 17, 'vai');
INSERT INTO `lang_definitions` VALUES (22860, 1268, 17, 'Vai');
INSERT INTO `lang_definitions` VALUES (22861, 1269, 17, 'Vai Para');
INSERT INTO `lang_definitions` VALUES (22862, 1270, 17, 'Vai para o próxima semana');
INSERT INTO `lang_definitions` VALUES (22863, 1271, 17, 'Grau:');
INSERT INTO `lang_definitions` VALUES (22864, 1272, 17, 'Gramas');
INSERT INTO `lang_definitions` VALUES (22865, 1273, 17, 'Total Principal');
INSERT INTO `lang_definitions` VALUES (22866, 1274, 17, 'Total Principal');
INSERT INTO `lang_definitions` VALUES (22867, 1275, 17, 'Grego');
INSERT INTO `lang_definitions` VALUES (22868, 1276, 17, 'Grupo');
INSERT INTO `lang_definitions` VALUES (22869, 1277, 17, 'Nome do Grupo');
INSERT INTO `lang_definitions` VALUES (22870, 1278, 17, 'Nomes do grupo não pode estár em branco');
INSERT INTO `lang_definitions` VALUES (22871, 1279, 17, 'Nomes do grupo não pode iniciar com números ou');
INSERT INTO `lang_definitions` VALUES (22872, 1280, 17, 'Nomes do grupo não pode iniciar com números');
INSERT INTO `lang_definitions` VALUES (22873, 1281, 17, 'Número do Grupo');
INSERT INTO `lang_definitions` VALUES (22874, 1282, 17, 'Grupo:');
INSERT INTO `lang_definitions` VALUES (22875, 1283, 17, 'Nome do Grupo');
INSERT INTO `lang_definitions` VALUES (22876, 1284, 17, 'Grupos e control de Access');
INSERT INTO `lang_definitions` VALUES (22877, 1285, 17, 'Desenhar o Tumor');
INSERT INTO `lang_definitions` VALUES (22878, 1286, 17, 'Desenhar -Tumor');
INSERT INTO `lang_definitions` VALUES (22879, 1287, 17, 'gtts(gotas)');
INSERT INTO `lang_definitions` VALUES (22880, 1288, 17, 'Exame ginecológico');
INSERT INTO `lang_definitions` VALUES (22881, 1289, 17, 'h');
INSERT INTO `lang_definitions` VALUES (22882, 1290, 17, 'h.s.');
INSERT INTO `lang_definitions` VALUES (22883, 1291, 17, 'Hepatite H/O');
INSERT INTO `lang_definitions` VALUES (22884, 1292, 17, 'Foi apagado com sucesso. Algumas sub-categórias');
INSERT INTO `lang_definitions` VALUES (22885, 1293, 17, 'Hematoma / contindindo');
INSERT INTO `lang_definitions` VALUES (22886, 1294, 17, 'Estado de HAI');
INSERT INTO `lang_definitions` VALUES (22887, 1295, 17, 'Maõ + Dedos');
INSERT INTO `lang_definitions` VALUES (22888, 1296, 17, 'Problema das Maõs');
INSERT INTO `lang_definitions` VALUES (22889, 1297, 17, 'w/ de Sofrimento');
INSERT INTO `lang_definitions` VALUES (22890, 1298, 17, 'Foi unido para visitar');
INSERT INTO `lang_definitions` VALUES (22891, 1299, 17, 'atividades Perigosas');
INSERT INTO `lang_definitions` VALUES (22892, 1300, 17, 'Atividades Perigosas');
INSERT INTO `lang_definitions` VALUES (22893, 1301, 17, 'HCFA deixou margens em pontos');
INSERT INTO `lang_definitions` VALUES (22894, 1302, 17, 'HCFA Margens');
INSERT INTO `lang_definitions` VALUES (22895, 1303, 17, 'HCFA tampam margens em pontos');
INSERT INTO `lang_definitions` VALUES (22896, 1304, 17, 'ele CaléndarioPostal');
INSERT INTO `lang_definitions` VALUES (22897, 1305, 17, 'Cabeça');
INSERT INTO `lang_definitions` VALUES (22898, 1306, 17, 'Circ Da Cabeça');
INSERT INTO `lang_definitions` VALUES (22899, 1307, 17, 'Circunferência da Cabeça');
INSERT INTO `lang_definitions` VALUES (22900, 1308, 17, 'Dor da Cabeça');
INSERT INTO `lang_definitions` VALUES (22901, 1309, 17, 'Dores de Cabeça');
INSERT INTO `lang_definitions` VALUES (22902, 1310, 17, 'Centro de saúde/clinica');
INSERT INTO `lang_definitions` VALUES (22903, 1311, 17, 'Organização de Manutenção da Saúde');
INSERT INTO `lang_definitions` VALUES (22904, 1312, 17, 'Organização de Manutenção da Saúde (HMO) Sistema de Saúde');
INSERT INTO `lang_definitions` VALUES (22905, 1313, 17, 'Perda da Audição');
INSERT INTO `lang_definitions` VALUES (22906, 1314, 17, 'Ataque Cardiaco');
INSERT INTO `lang_definitions` VALUES (22907, 1315, 17, 'Doença do Coração');
INSERT INTO `lang_definitions` VALUES (22908, 1316, 17, 'Falha no Coração');
INSERT INTO `lang_definitions` VALUES (22909, 1317, 17, 'Problema do Coração');
INSERT INTO `lang_definitions` VALUES (22910, 1318, 17, 'Problemas do Coração');
INSERT INTO `lang_definitions` VALUES (22911, 1319, 17, 'Cirúrgia no Coração');
INSERT INTO `lang_definitions` VALUES (22912, 1320, 17, 'Transplante do Coração');
INSERT INTO `lang_definitions` VALUES (22913, 1321, 17, 'CORAÇÃO:');
INSERT INTO `lang_definitions` VALUES (22914, 1322, 17, 'Azia');
INSERT INTO `lang_definitions` VALUES (22915, 1323, 17, 'Calor ou Frio');
INSERT INTO `lang_definitions` VALUES (22916, 1324, 17, 'Calor Ou Frio');
INSERT INTO `lang_definitions` VALUES (22917, 1325, 17, 'Hebreu');
INSERT INTO `lang_definitions` VALUES (22918, 1326, 17, 'HEENT');
INSERT INTO `lang_definitions` VALUES (22919, 1327, 17, 'Altura');
INSERT INTO `lang_definitions` VALUES (22920, 1328, 17, 'Ajuda');
INSERT INTO `lang_definitions` VALUES (22921, 1329, 17, 'ajuda');
INSERT INTO `lang_definitions` VALUES (22922, 1330, 17, 'Hemattmesis');
INSERT INTO `lang_definitions` VALUES (22923, 1331, 17, 'Hematochezia');
INSERT INTO `lang_definitions` VALUES (22924, 1332, 17, 'Hematologic');
INSERT INTO `lang_definitions` VALUES (22925, 1333, 17, 'Hematúria');
INSERT INTO `lang_definitions` VALUES (22926, 1334, 17, 'Hemoglobina');
INSERT INTO `lang_definitions` VALUES (22927, 1335, 17, 'Hemoptysis');
INSERT INTO `lang_definitions` VALUES (22928, 1336, 17, 'Hepatites');
INSERT INTO `lang_definitions` VALUES (22929, 1337, 17, 'Hepatite A 1');
INSERT INTO `lang_definitions` VALUES (22930, 1338, 17, 'Hepatite A 2');
INSERT INTO `lang_definitions` VALUES (22931, 1339, 17, 'Hepatite B 1');
INSERT INTO `lang_definitions` VALUES (22932, 1340, 17, 'Hepatite B 2');
INSERT INTO `lang_definitions` VALUES (22933, 1341, 17, 'Hepatite B 3');
INSERT INTO `lang_definitions` VALUES (22934, 1342, 17, 'Aqui');
INSERT INTO `lang_definitions` VALUES (22935, 1343, 17, 'Conserto da Hérnia');
INSERT INTO `lang_definitions` VALUES (22936, 1344, 17, 'Disco Herniado');
INSERT INTO `lang_definitions` VALUES (22937, 1345, 17, 'Herpes');
INSERT INTO `lang_definitions` VALUES (22938, 1346, 17, 'Hesitação');
INSERT INTO `lang_definitions` VALUES (22939, 1347, 17, 'heyyo.voçê esteve aqui para');
INSERT INTO `lang_definitions` VALUES (22940, 1348, 17, 'Hib 1');
INSERT INTO `lang_definitions` VALUES (22941, 1349, 17, 'Hib 2');
INSERT INTO `lang_definitions` VALUES (22942, 1350, 17, 'Hib 3');
INSERT INTO `lang_definitions` VALUES (22943, 1351, 17, 'Hib 4');
INSERT INTO `lang_definitions` VALUES (22944, 1352, 17, 'Esconder');
INSERT INTO `lang_definitions` VALUES (22945, 1353, 17, 'Administração de Eventos Escondida');
INSERT INTO `lang_definitions` VALUES (22946, 1354, 17, 'Pele');
INSERT INTO `lang_definitions` VALUES (22947, 1355, 17, 'Detalhes de Pele');
INSERT INTO `lang_definitions` VALUES (22948, 1357, 17, 'Alto');
INSERT INTO `lang_definitions` VALUES (22949, 1358, 17, 'Atenção Alta');
INSERT INTO `lang_definitions` VALUES (22950, 1359, 17, 'Quadril + virilha');
INSERT INTO `lang_definitions` VALUES (22951, 1360, 17, 'Quadril e virilha');
INSERT INTO `lang_definitions` VALUES (22952, 1361, 17, 'Problemas de Quadril');
INSERT INTO `lang_definitions` VALUES (22953, 1362, 17, 'Substituição de Quadril');
INSERT INTO `lang_definitions` VALUES (22954, 1363, 17, 'Recebeu a Notícia HIPAA');
INSERT INTO `lang_definitions` VALUES (22955, 1364, 17, 'Hirsutism/Striae');
INSERT INTO `lang_definitions` VALUES (22956, 1365, 17, 'Hispânico');
INSERT INTO `lang_definitions` VALUES (22957, 1366, 17, 'História');
INSERT INTO `lang_definitions` VALUES (22958, 1367, 17, 'Data da História');
INSERT INTO `lang_definitions` VALUES (22959, 1368, 17, 'História de Murmúrio');
INSERT INTO `lang_definitions` VALUES (22960, 1369, 17, 'História de Murmúrio do Coração');
INSERT INTO `lang_definitions` VALUES (22961, 1370, 17, 'HIV');
INSERT INTO `lang_definitions` VALUES (22962, 1371, 17, 'Espectador de HL7');
INSERT INTO `lang_definitions` VALUES (22963, 1372, 17, 'unselect');
INSERT INTO `lang_definitions` VALUES (22964, 1373, 17, 'Pressione Ctrl para celecional múltiplos itens');
INSERT INTO `lang_definitions` VALUES (22965, 1374, 17, 'Pressione Ctrl para celecional múltiplas esquadras');
INSERT INTO `lang_definitions` VALUES (22966, 1375, 17, 'Casa');
INSERT INTO `lang_definitions` VALUES (22967, 1376, 17, 'Telefone de Casa');
INSERT INTO `lang_definitions` VALUES (22968, 1377, 17, 'Número de Telefone de Casa');
INSERT INTO `lang_definitions` VALUES (22969, 1378, 17, 'Sem-lar oy semelhante?');
INSERT INTO `lang_definitions` VALUES (22970, 1379, 17, 'Sem-lar, etc');
INSERT INTO `lang_definitions` VALUES (22971, 1380, 17, 'Sem-lar, etc.');
INSERT INTO `lang_definitions` VALUES (22972, 1381, 17, 'Horas');
INSERT INTO `lang_definitions` VALUES (22973, 1382, 17, 'Como o Dano Aconteceu?');
INSERT INTO `lang_definitions` VALUES (22974, 1383, 17, 'Como o Dano Aconteceu?:');
INSERT INTO `lang_definitions` VALUES (22975, 1384, 17, 'Quantos meses á frente para chegar a examinar');
INSERT INTO `lang_definitions` VALUES (22976, 1385, 17, 'HPI:');
INSERT INTO `lang_definitions` VALUES (22977, 1387, 17, 'HTML');
INSERT INTO `lang_definitions` VALUES (22978, 1388, 17, 'Hiperactive');
INSERT INTO `lang_definitions` VALUES (22979, 1389, 17, 'Hipertenção');
INSERT INTO `lang_definitions` VALUES (22980, 1390, 17, 'Hyperthyroidism');
INSERT INTO `lang_definitions` VALUES (22981, 1391, 17, 'Hipotireoidismo');
INSERT INTO `lang_definitions` VALUES (22982, 1392, 17, 'Histerectomia');
INSERT INTO `lang_definitions` VALUES (22983, 1393, 17, 'I');
INSERT INTO `lang_definitions` VALUES (22984, 1394, 17, 'Estou ocupado durante este momento');
INSERT INTO `lang_definitions` VALUES (22985, 1395, 17, 'Não tem Permissão para ler');
INSERT INTO `lang_definitions` VALUES (22986, 1396, 17, 'ICD');
INSERT INTO `lang_definitions` VALUES (22987, 1398, 17, 'ID');
INSERT INTO `lang_definitions` VALUES (22988, 1399, 17, 'ID não pode ficar em branco');
INSERT INTO `lang_definitions` VALUES (22989, 1400, 17, 'Idias');
INSERT INTO `lang_definitions` VALUES (22990, 1401, 17, 'identificado como');
INSERT INTO `lang_definitions` VALUES (22991, 1402, 17, 'Identificar(uma palavra)');
INSERT INTO `lang_definitions` VALUES (22992, 1403, 17, 'Se todos os dados para todas as colunas estão completas para esta forma');
INSERT INTO `lang_definitions` VALUES (22993, 1404, 17, 'Se nome, qualquer parte do último nome ou');
INSERT INTO `lang_definitions` VALUES (22994, 1405, 17, 'Se desempregado clique estudane');
INSERT INTO `lang_definitions` VALUES (22995, 1406, 17, 'Remessas, então a janela de procura o redisplays');
INSERT INTO `lang_definitions` VALUES (22996, 1407, 17, 'Isto anulará a data postado de pagamento e');
INSERT INTO `lang_definitions` VALUES (22997, 1408, 17, 'Se voçê quer mudar tipos de dados, ou acrescentar filas ou');
INSERT INTO `lang_definitions` VALUES (22998, 1410, 17, 'IM');
INSERT INTO `lang_definitions` VALUES (22999, 1411, 17, 'Imunização');
INSERT INTO `lang_definitions` VALUES (23000, 1412, 17, 'Imunização perdeu o número');
INSERT INTO `lang_definitions` VALUES (23001, 1413, 17, 'Fabricante de Imunização');
INSERT INTO `lang_definitions` VALUES (23002, 1414, 17, 'Imunizações');
INSERT INTO `lang_definitions` VALUES (23003, 1415, 17, 'Imunize');
INSERT INTO `lang_definitions` VALUES (23004, 1416, 17, 'Imunológico');
INSERT INTO `lang_definitions` VALUES (23005, 1417, 17, 'Implantes');
INSERT INTO `lang_definitions` VALUES (23006, 1418, 17, 'Importe');
INSERT INTO `lang_definitions` VALUES (23007, 1419, 17, 'Importe Configuração');
INSERT INTO `lang_definitions` VALUES (23008, 1420, 17, 'Importe Paciente');
INSERT INTO `lang_definitions` VALUES (23009, 1421, 17, 'Importe Pacientes Demograficos');
INSERT INTO `lang_definitions` VALUES (23010, 1422, 17, 'Importado apartir da Contabilidade');
INSERT INTO `lang_definitions` VALUES (23011, 1423, 17, 'Melhorado');
INSERT INTO `lang_definitions` VALUES (23012, 1424, 17, 'dentro');
INSERT INTO `lang_definitions` VALUES (23013, 1425, 17, 'Dentro');
INSERT INTO `lang_definitions` VALUES (23014, 1426, 17, 'Em cada olho');
INSERT INTO `lang_definitions` VALUES (23015, 1427, 17, 'no olho esquerdo');
INSERT INTO `lang_definitions` VALUES (23016, 1428, 17, 'Em narina');
INSERT INTO `lang_definitions` VALUES (23017, 1429, 17, 'No Escritório');
INSERT INTO `lang_definitions` VALUES (23018, 1430, 17, 'no olho direto');
INSERT INTO `lang_definitions` VALUES (23019, 1431, 17, 'em-casa');
INSERT INTO `lang_definitions` VALUES (23020, 1432, 17, 'Inativo');
INSERT INTO `lang_definitions` VALUES (23021, 1433, 17, 'Dias Inativos');
INSERT INTO `lang_definitions` VALUES (23022, 1434, 17, 'Inclua usuários inativos');
INSERT INTO `lang_definitions` VALUES (23023, 1435, 17, 'Inclua Uncategorized');
INSERT INTO `lang_definitions` VALUES (23024, 1436, 17, 'Inclua Vitais');
INSERT INTO `lang_definitions` VALUES (23025, 1437, 17, 'Inclua dados vitais?');
INSERT INTO `lang_definitions` VALUES (23026, 1438, 17, 'Renda');
INSERT INTO `lang_definitions` VALUES (23027, 1439, 17, 'Tratamento de Aborto Incompleto');
INSERT INTO `lang_definitions` VALUES (23028, 1440, 17, 'Incontinênçia');
INSERT INTO `lang_definitions` VALUES (23029, 1441, 17, 'Aumentado:');
INSERT INTO `lang_definitions` VALUES (23030, 1442, 17, 'Seguro contra dados');
INSERT INTO `lang_definitions` VALUES (23031, 1443, 17, 'Indeterminado');
INSERT INTO `lang_definitions` VALUES (23032, 1444, 17, 'Indicando se este assunto ativo corretamente');
INSERT INTO `lang_definitions` VALUES (23033, 1445, 17, 'Relatório de Paciente Indigente');
INSERT INTO `lang_definitions` VALUES (23034, 1446, 17, 'Indigentes');
INSERT INTO `lang_definitions` VALUES (23035, 1447, 17, 'Aborto Provocado');
INSERT INTO `lang_definitions` VALUES (23036, 1448, 17, 'Infecções / Abcesso');
INSERT INTO `lang_definitions` VALUES (23037, 1449, 17, 'Infecções');
INSERT INTO `lang_definitions` VALUES (23038, 1450, 17, 'Infert Couns');
INSERT INTO `lang_definitions` VALUES (23039, 1451, 17, 'Infertilidade');
INSERT INTO `lang_definitions` VALUES (23040, 1452, 17, 'Gripe 1');
INSERT INTO `lang_definitions` VALUES (23041, 1453, 17, 'Gripe 2');
INSERT INTO `lang_definitions` VALUES (23042, 1454, 17, 'Info');
INSERT INTO `lang_definitions` VALUES (23043, 1455, 17, 'Info teste 1');
INSERT INTO `lang_definitions` VALUES (23044, 1456, 17, 'Info teste 2');
INSERT INTO `lang_definitions` VALUES (23045, 1457, 17, 'Info teste 3');
INSERT INTO `lang_definitions` VALUES (23046, 1458, 17, 'Info teste 4');
INSERT INTO `lang_definitions` VALUES (23047, 1459, 17, 'Info teste 5');
INSERT INTO `lang_definitions` VALUES (23048, 1460, 17, 'Info teste 6');
INSERT INTO `lang_definitions` VALUES (23049, 1461, 17, 'Inalações');
INSERT INTO `lang_definitions` VALUES (23050, 1462, 17, 'Inhilations');
INSERT INTO `lang_definitions` VALUES (23051, 1463, 17, 'Usuário Inicial');
INSERT INTO `lang_definitions` VALUES (23052, 1464, 17, 'Injetáveis');
INSERT INTO `lang_definitions` VALUES (23053, 1465, 17, 'Dano fora');
INSERT INTO `lang_definitions` VALUES (23054, 1466, 17, 'Dano');
INSERT INTO `lang_definitions` VALUES (23055, 1467, 17, 'Mecanismo de Dano');
INSERT INTO `lang_definitions` VALUES (23056, 1468, 17, 'Relatório de Avaliação de Dano');
INSERT INTO `lang_definitions` VALUES (23057, 1469, 17, 'Vigiláncia de Dano');
INSERT INTO `lang_definitions` VALUES (23058, 1470, 17, 'Tipo de Dano');
INSERT INTO `lang_definitions` VALUES (23059, 1471, 17, 'Introduza os Fields');
INSERT INTO `lang_definitions` VALUES (23060, 1472, 17, 'Ins ajustam');
INSERT INTO `lang_definitions` VALUES (23061, 1473, 17, 'Ins Ajuste');
INSERT INTO `lang_definitions` VALUES (23062, 1474, 17, 'Ins Overpaid');
INSERT INTO `lang_definitions` VALUES (23063, 1475, 17, 'Ins Reembolso');
INSERT INTO `lang_definitions` VALUES (23064, 1476, 17, 'Ins Resumo');
INSERT INTO `lang_definitions` VALUES (23065, 1477, 17, 'Ins 1');
INSERT INTO `lang_definitions` VALUES (23066, 1478, 17, 'Ins 2');
INSERT INTO `lang_definitions` VALUES (23067, 1479, 17, 'Ins 3');
INSERT INTO `lang_definitions` VALUES (23068, 1480, 17, 'Inserido Falhado:');
INSERT INTO `lang_definitions` VALUES (23069, 1481, 17, 'Inserir eventos antigos dentro das tabelas');
INSERT INTO `lang_definitions` VALUES (23070, 1482, 17, 'Insónia');
INSERT INTO `lang_definitions` VALUES (23071, 1483, 17, 'Inspeção');
INSERT INTO `lang_definitions` VALUES (23072, 1484, 17, 'Instabilidade /');
INSERT INTO `lang_definitions` VALUES (23073, 1485, 17, 'Instalar DB');
INSERT INTO `lang_definitions` VALUES (23074, 1486, 17, 'Instruido');
INSERT INTO `lang_definitions` VALUES (23075, 1487, 17, 'Instruções');
INSERT INTO `lang_definitions` VALUES (23076, 1488, 17, 'Dependente de Diabete Insulina');
INSERT INTO `lang_definitions` VALUES (23077, 1489, 17, 'Seguro');
INSERT INTO `lang_definitions` VALUES (23078, 1490, 17, 'seguro');
INSERT INTO `lang_definitions` VALUES (23079, 1491, 17, 'Companias de Seguro');
INSERT INTO `lang_definitions` VALUES (23080, 1492, 17, 'Compania de Seguro');
INSERT INTO `lang_definitions` VALUES (23081, 1493, 17, 'Procurar/Acrescentar Compania de Seguro');
INSERT INTO `lang_definitions` VALUES (23082, 1494, 17, 'Data de Seguro');
INSERT INTO `lang_definitions` VALUES (23083, 1495, 17, 'Número do Seguro');
INSERT INTO `lang_definitions` VALUES (23084, 1496, 17, 'Provedor de Seguro');
INSERT INTO `lang_definitions` VALUES (23085, 1497, 17, 'Conclusão de Entrada');
INSERT INTO `lang_definitions` VALUES (23086, 1498, 17, 'Data de Entrada');
INSERT INTO `lang_definitions` VALUES (23087, 1499, 17, 'Declínio Intelectual');
INSERT INTO `lang_definitions` VALUES (23088, 1500, 17, 'Erro Interno - Nenhuma página foi selecionada!');
INSERT INTO `lang_definitions` VALUES (23089, 1501, 17, 'Erro Interno - ID do Paciente não foi provido!');
INSERT INTO `lang_definitions` VALUES (23090, 1502, 17, 'Erro interno que acessa arquivos transferidos!');
INSERT INTO `lang_definitions` VALUES (23091, 1503, 17, 'Erro Interno!');
INSERT INTO `lang_definitions` VALUES (23092, 1504, 17, 'Erro Interno,não há ID de droga especificada!');
INSERT INTO `lang_definitions` VALUES (23093, 1505, 17, 'Erro Interno: Reivindicação');
INSERT INTO `lang_definitions` VALUES (23094, 1506, 17, 'Erro Interno: Encontro\'');
INSERT INTO `lang_definitions` VALUES (23095, 1507, 17, 'Erro Interno: pid ou está perdendo o encontro.');
INSERT INTO `lang_definitions` VALUES (23096, 1508, 17, 'Interno Identificou (pid)');
INSERT INTO `lang_definitions` VALUES (23097, 1509, 17, 'Indicações Internas');
INSERT INTO `lang_definitions` VALUES (23098, 1510, 17, 'Dever Internacional');
INSERT INTO `lang_definitions` VALUES (23099, 1511, 17, 'Intérprete');
INSERT INTO `lang_definitions` VALUES (23100, 1512, 17, 'Precisou de Intérprete?');
INSERT INTO `lang_definitions` VALUES (23101, 1513, 17, 'Doenças Pulmonar Interstical');
INSERT INTO `lang_definitions` VALUES (23102, 1514, 17, 'Intervalo');
INSERT INTO `lang_definitions` VALUES (23103, 1515, 17, 'Intolerância');
INSERT INTO `lang_definitions` VALUES (23104, 1516, 17, 'Intramuscular');
INSERT INTO `lang_definitions` VALUES (23105, 1517, 17, 'Intravenously');
INSERT INTO `lang_definitions` VALUES (23106, 1518, 17, 'Introdução');
INSERT INTO `lang_definitions` VALUES (23107, 1519, 17, 'Inválido ou pagador em falta par código em falta');
INSERT INTO `lang_definitions` VALUES (23108, 1520, 17, 'Inválido Código de Servico');
INSERT INTO `lang_definitions` VALUES (23109, 1521, 17, 'Desegnação de fonte inválida');
INSERT INTO `lang_definitions` VALUES (23110, 1522, 17, 'InvAmt');
INSERT INTO `lang_definitions` VALUES (23111, 1523, 17, 'Inventário');
INSERT INTO `lang_definitions` VALUES (23112, 1524, 17, 'Inventário ntá disponivel nesta ordem.');
INSERT INTO `lang_definitions` VALUES (23113, 1525, 17, 'Inventário não está disponivel para esta ordem.');
INSERT INTO `lang_definitions` VALUES (23114, 1526, 17, 'Lista de Inventário');
INSERT INTO `lang_definitions` VALUES (23115, 1527, 17, 'Fatura');
INSERT INTO `lang_definitions` VALUES (23116, 1528, 17, 'Data da Fatura');
INSERT INTO `lang_definitions` VALUES (23117, 1529, 17, 'Fatura não tem nenhuma data!');
INSERT INTO `lang_definitions` VALUES (23118, 1530, 17, 'Fatura:');
INSERT INTO `lang_definitions` VALUES (23119, 1531, 17, 'IPPF SRH Data para');
INSERT INTO `lang_definitions` VALUES (23120, 1532, 17, 'IPPF Relatório de Estatística');
INSERT INTO `lang_definitions` VALUES (23121, 1533, 17, 'IPV 1');
INSERT INTO `lang_definitions` VALUES (23122, 1534, 17, 'IPV 2');
INSERT INTO `lang_definitions` VALUES (23123, 1535, 17, 'IPV 3');
INSERT INTO `lang_definitions` VALUES (23124, 1536, 17, 'IPV 4');
INSERT INTO `lang_definitions` VALUES (23125, 1537, 17, 'Batimento Cárdiaco Irregular');
INSERT INTO `lang_definitions` VALUES (23126, 1538, 17, 'Irritabilidade');
INSERT INTO `lang_definitions` VALUES (23127, 1539, 17, 'Irritação');
INSERT INTO `lang_definitions` VALUES (23128, 1540, 17, 'È um field exigido.');
INSERT INTO `lang_definitions` VALUES (23129, 1541, 17, 'È um nodo de raiz e não pode ser apagado.');
INSERT INTO `lang_definitions` VALUES (23130, 1542, 17, 'Não é valido (frações decimais são OK).');
INSERT INTO `lang_definitions` VALUES (23131, 1543, 17, 'PHP está usando o modo seguro?');
INSERT INTO `lang_definitions` VALUES (23132, 1545, 17, 'assunto');
INSERT INTO `lang_definitions` VALUES (23133, 1546, 17, 'Assunto');
INSERT INTO `lang_definitions` VALUES (23134, 1547, 17, 'Assuntos');
INSERT INTO `lang_definitions` VALUES (23135, 1548, 17, 'Asuntos (Danos/Médico/Alergi');
INSERT INTO `lang_definitions` VALUES (23136, 1549, 17, 'Assuntos e Encontros');
INSERT INTO `lang_definitions` VALUES (23137, 1550, 17, 'Assuntos e Encontros para');
INSERT INTO `lang_definitions` VALUES (23138, 1551, 17, 'Assuntos não autorizados');
INSERT INTO `lang_definitions` VALUES (23139, 1552, 17, 'Secção de Assuntos');
INSERT INTO `lang_definitions` VALUES (23140, 1553, 17, 'Carga');
INSERT INTO `lang_definitions` VALUES (23141, 1554, 17, 'carga');
INSERT INTO `lang_definitions` VALUES (23142, 1555, 17, 'Carga de artigo falhou');
INSERT INTO `lang_definitions` VALUES (23143, 1556, 17, 'IUD');
INSERT INTO `lang_definitions` VALUES (23144, 1557, 17, 'IV');
INSERT INTO `lang_definitions` VALUES (23145, 1558, 17, 'Janeiro');
INSERT INTO `lang_definitions` VALUES (23146, 1559, 17, 'Icterícia');
INSERT INTO `lang_definitions` VALUES (23147, 1560, 17, 'Descrição de Trabalho');
INSERT INTO `lang_definitions` VALUES (23148, 1561, 17, 'ID do Trabalho');
INSERT INTO `lang_definitions` VALUES (23149, 1562, 17, 'Deslocação em comum');
INSERT INTO `lang_definitions` VALUES (23150, 1563, 17, 'Dor em Comum');
INSERT INTO `lang_definitions` VALUES (23151, 1564, 17, 'Deslocamentos em comum');
INSERT INTO `lang_definitions` VALUES (23152, 1565, 17, 'Julho');
INSERT INTO `lang_definitions` VALUES (23153, 1566, 17, 'Junho');
INSERT INTO `lang_definitions` VALUES (23154, 1567, 17, 'Só debaixo da informação verificada uma área azul');
INSERT INTO `lang_definitions` VALUES (23155, 1568, 17, 'Somente Meu');
INSERT INTO `lang_definitions` VALUES (23156, 1569, 17, 'Justifique');
INSERT INTO `lang_definitions` VALUES (23157, 1570, 17, 'Justifique/Salvar');
INSERT INTO `lang_definitions` VALUES (23158, 1571, 17, 'k, aqui é o resto');
INSERT INTO `lang_definitions` VALUES (23159, 1572, 17, 'Palavras chaves');
INSERT INTO `lang_definitions` VALUES (23160, 1573, 17, 'kg');
INSERT INTO `lang_definitions` VALUES (23161, 1574, 17, 'kg/m^2');
INSERT INTO `lang_definitions` VALUES (23162, 1575, 17, 'Cancer do Rim');
INSERT INTO `lang_definitions` VALUES (23163, 1576, 17, 'Fracasso nos rims');
INSERT INTO `lang_definitions` VALUES (23164, 1577, 17, 'Infecções nos rins');
INSERT INTO `lang_definitions` VALUES (23165, 1578, 17, 'Pedras no Rim');
INSERT INTO `lang_definitions` VALUES (23166, 1579, 17, 'Transplante nos Rims');
INSERT INTO `lang_definitions` VALUES (23167, 1580, 17, 'Joelho');
INSERT INTO `lang_definitions` VALUES (23168, 1581, 17, 'Problemas no Joelho');
INSERT INTO `lang_definitions` VALUES (23169, 1582, 17, 'Substituição no Joelho');
INSERT INTO `lang_definitions` VALUES (23170, 1583, 17, 'Lab');
INSERT INTO `lang_definitions` VALUES (23171, 1584, 17, 'Relatório de Lab');
INSERT INTO `lang_definitions` VALUES (23172, 1585, 17, 'Rótulo');
INSERT INTO `lang_definitions` VALUES (23173, 1586, 17, 'Rótulo não pode ser em branco');
INSERT INTO `lang_definitions` VALUES (23174, 1588, 17, 'LabelCols deve ser um número entre 1 e 999');
INSERT INTO `lang_definitions` VALUES (23175, 1589, 17, 'Rótulos');
INSERT INTO `lang_definitions` VALUES (23176, 1590, 17, 'Labs');
INSERT INTO `lang_definitions` VALUES (23177, 1591, 17, 'Dilaceração / condição da Pele');
INSERT INTO `lang_definitions` VALUES (23178, 1592, 17, 'Dilaceração/abrasão');
INSERT INTO `lang_definitions` VALUES (23179, 1593, 17, 'Idioma');
INSERT INTO `lang_definitions` VALUES (23180, 1594, 17, 'Código do Idioma');
INSERT INTO `lang_definitions` VALUES (23181, 1595, 17, 'Definição do Idioma acrescentado');
INSERT INTO `lang_definitions` VALUES (23182, 1597, 17, 'Lista de Idioma (escrever, addonly opcional)');
INSERT INTO `lang_definitions` VALUES (23183, 1598, 17, 'Nome do Idioma');
INSERT INTO `lang_definitions` VALUES (23184, 1599, 17, 'Idioma:');
INSERT INTO `lang_definitions` VALUES (23185, 1600, 17, 'Ùltimo');
INSERT INTO `lang_definitions` VALUES (23186, 1601, 17, 'Data da Ùltima Atividade');
INSERT INTO `lang_definitions` VALUES (23187, 1602, 17, 'Data da Ùltima Conta');
INSERT INTO `lang_definitions` VALUES (23188, 1603, 17, 'Ùltimo Encontro');
INSERT INTO `lang_definitions` VALUES (23189, 1604, 17, 'Ùltimo Nome');
INSERT INTO `lang_definitions` VALUES (23190, 1605, 17, 'Ùltimo Nome');
INSERT INTO `lang_definitions` VALUES (23191, 1606, 17, 'Ùltimo Nome:');
INSERT INTO `lang_definitions` VALUES (23192, 1607, 17, 'Ùltimos Salvados');
INSERT INTO `lang_definitions` VALUES (23193, 1608, 17, 'Por Ùltimo atualize por');
INSERT INTO `lang_definitions` VALUES (23194, 1609, 17, 'Ùltima Visita');
INSERT INTO `lang_definitions` VALUES (23195, 1610, 17, 'Retorno Tarde (2-12 Mo)');
INSERT INTO `lang_definitions` VALUES (23196, 1611, 17, 'Malleolus Lateral');
INSERT INTO `lang_definitions` VALUES (23197, 1612, 17, 'Malleolus Lateral:');
INSERT INTO `lang_definitions` VALUES (23198, 1613, 17, 'Deslocou Lateral');
INSERT INTO `lang_definitions` VALUES (23199, 1614, 17, 'Baseado no Plano');
INSERT INTO `lang_definitions` VALUES (23200, 1615, 17, 'Editar o Plano');
INSERT INTO `lang_definitions` VALUES (23201, 1616, 17, 'Plano de Grupos');
INSERT INTO `lang_definitions` VALUES (23202, 1617, 17, 'Plano-Baseado nas Formas de Visita');
INSERT INTO `lang_definitions` VALUES (23203, 1618, 17, 'Planos');
INSERT INTO `lang_definitions` VALUES (23204, 1619, 17, 'lb');
INSERT INTO `lang_definitions` VALUES (23205, 1620, 17, 'Lbs');
INSERT INTO `lang_definitions` VALUES (23206, 1621, 17, 'LDL');
INSERT INTO `lang_definitions` VALUES (23207, 1622, 17, 'Deixa em branco se continuar ativo');
INSERT INTO `lang_definitions` VALUES (23208, 1623, 17, 'Deixe espaço em branco para manter palavra-chave inalterado.');
INSERT INTO `lang_definitions` VALUES (23209, 1624, 17, 'Deixa Mensagem com');
INSERT INTO `lang_definitions` VALUES (23210, 1625, 17, 'Deixa a Forma');
INSERT INTO `lang_definitions` VALUES (23211, 1626, 17, 'Esquerdo');
INSERT INTO `lang_definitions` VALUES (23212, 1627, 17, 'Ouvido Esquerdo');
INSERT INTO `lang_definitions` VALUES (23213, 1628, 17, 'ouvido esquerdo');
INSERT INTO `lang_definitions` VALUES (23214, 1629, 17, 'Esquerdo:');
INSERT INTO `lang_definitions` VALUES (23215, 1630, 17, 'Esquerdo:');
INSERT INTO `lang_definitions` VALUES (23216, 1631, 17, 'Dor da perna/Grampeado');
INSERT INTO `lang_definitions` VALUES (23217, 1632, 17, 'Legal');
INSERT INTO `lang_definitions` VALUES (23218, 1633, 17, 'Legenda:');
INSERT INTO `lang_definitions` VALUES (23219, 1634, 17, 'Comprimento');
INSERT INTO `lang_definitions` VALUES (23220, 1635, 17, 'Menos-informação privada (escrever,addonly opcional)');
INSERT INTO `lang_definitions` VALUES (23221, 1636, 17, 'Carta');
INSERT INTO `lang_definitions` VALUES (23222, 1637, 17, 'Gerador de Cartas');
INSERT INTO `lang_definitions` VALUES (23223, 1640, 17, 'Nível de urgência');
INSERT INTO `lang_definitions` VALUES (23224, 1641, 17, 'Responsabilidade');
INSERT INTO `lang_definitions` VALUES (23225, 1642, 17, 'Exame médico de Responsabilidade');
INSERT INTO `lang_definitions` VALUES (23226, 1643, 17, 'Licença/ID');
INSERT INTO `lang_definitions` VALUES (23227, 1644, 17, 'Estilo de vida');
INSERT INTO `lang_definitions` VALUES (23228, 1645, 17, 'Lágrima de Ligamento ou entorse');
INSERT INTO `lang_definitions` VALUES (23229, 1646, 17, 'Limites De Eventos');
INSERT INTO `lang_definitions` VALUES (23230, 1649, 17, 'Lista');
INSERT INTO `lang_definitions` VALUES (23231, 1650, 17, 'Caixa de Lista');
INSERT INTO `lang_definitions` VALUES (23232, 1651, 17, 'caixa de lista');
INSERT INTO `lang_definitions` VALUES (23233, 1652, 17, 'caixa de lista w/ add');
INSERT INTO `lang_definitions` VALUES (23234, 1653, 17, 'caixa de lista w/add');
INSERT INTO `lang_definitions` VALUES (23235, 1654, 17, 'Liste o Editor');
INSERT INTO `lang_definitions` VALUES (23236, 1655, 17, 'Lista de grupos');
INSERT INTO `lang_definitions` VALUES (23237, 1656, 17, 'Aliste Companias de Seguro');
INSERT INTO `lang_definitions` VALUES (23238, 1657, 17, 'Aliste artigos que não podem começar com um número.');
INSERT INTO `lang_definitions` VALUES (23239, 1658, 17, 'Aliste artigos que contém caracter(s) ilegal.');
INSERT INTO `lang_definitions` VALUES (23240, 1659, 17, 'Listas de lista');
INSERT INTO `lang_definitions` VALUES (23241, 1660, 17, 'Nomeda Lista');
INSERT INTO `lang_definitions` VALUES (23242, 1661, 17, 'Nome da Lista não pode começar com números.');
INSERT INTO `lang_definitions` VALUES (23243, 1662, 17, 'Lista de Receitas');
INSERT INTO `lang_definitions` VALUES (23244, 1663, 17, 'Listas');
INSERT INTO `lang_definitions` VALUES (23245, 1664, 17, 'LLL:');
INSERT INTO `lang_definitions` VALUES (23246, 1665, 17, 'LMP');
INSERT INTO `lang_definitions` VALUES (23247, 1666, 17, 'Carregue Definições');
INSERT INTO `lang_definitions` VALUES (23248, 1667, 17, 'CARREGANDO');
INSERT INTO `lang_definitions` VALUES (23249, 1668, 17, 'LOC');
INSERT INTO `lang_definitions` VALUES (23250, 1669, 17, 'Local');
INSERT INTO `lang_definitions` VALUES (23251, 1670, 17, 'Localidade');
INSERT INTO `lang_definitions` VALUES (23252, 1671, 17, 'Localização');
INSERT INTO `lang_definitions` VALUES (23253, 1672, 17, 'Localização não especificada');
INSERT INTO `lang_definitions` VALUES (23254, 1673, 17, 'Localização:');
INSERT INTO `lang_definitions` VALUES (23255, 1675, 17, 'Começar dentro');
INSERT INTO `lang_definitions` VALUES (23256, 1676, 17, 'Começar dentro como');
INSERT INTO `lang_definitions` VALUES (23257, 1677, 17, 'Começar dentro como:');
INSERT INTO `lang_definitions` VALUES (23258, 1678, 17, 'Começar fora');
INSERT INTO `lang_definitions` VALUES (23259, 1679, 17, 'Entrar');
INSERT INTO `lang_definitions` VALUES (23260, 1680, 17, 'entrar');
INSERT INTO `lang_definitions` VALUES (23261, 1681, 17, 'Sair');
INSERT INTO `lang_definitions` VALUES (23262, 1682, 17, 'sair');
INSERT INTO `lang_definitions` VALUES (23263, 1683, 17, 'Troncos');
INSERT INTO `lang_definitions` VALUES (23264, 1684, 17, 'Vêem Troncos');
INSERT INTO `lang_definitions` VALUES (23265, 1685, 17, 'Observe');
INSERT INTO `lang_definitions` VALUES (23266, 1686, 17, 'Lote');
INSERT INTO `lang_definitions` VALUES (23267, 1687, 17, 'Lote ID desapareceu');
INSERT INTO `lang_definitions` VALUES (23268, 1688, 17, 'Número de Lote');
INSERT INTO `lang_definitions` VALUES (23269, 1689, 17, 'Baixo');
INSERT INTO `lang_definitions` VALUES (23270, 1690, 17, 'Mais baixa perna');
INSERT INTO `lang_definitions` VALUES (23271, 1691, 17, 'Serre espinha');
INSERT INTO `lang_definitions` VALUES (23272, 1692, 17, 'Almoço');
INSERT INTO `lang_definitions` VALUES (23273, 1693, 17, 'almoço');
INSERT INTO `lang_definitions` VALUES (23274, 1694, 17, 'Cancer do Pulmão');
INSERT INTO `lang_definitions` VALUES (23275, 1695, 17, 'Cirurgia de Cancer do Pulmão');
INSERT INTO `lang_definitions` VALUES (23276, 1696, 17, 'PULMÕES:');
INSERT INTO `lang_definitions` VALUES (23277, 1697, 17, 'pulmões:');
INSERT INTO `lang_definitions` VALUES (23278, 1698, 17, 'Lúpus');
INSERT INTO `lang_definitions` VALUES (23279, 1699, 17, 'M');
INSERT INTO `lang_definitions` VALUES (23280, 1700, 17, 'Categoria MA');
INSERT INTO `lang_definitions` VALUES (23281, 1701, 17, 'Endereço Principal');
INSERT INTO `lang_definitions` VALUES (23282, 1702, 17, 'Faça modificações para categorias recentes');
INSERT INTO `lang_definitions` VALUES (23283, 1703, 17, 'Tenha Certeza');
INSERT INTO `lang_definitions` VALUES (23284, 1704, 17, 'Mal-estar');
INSERT INTO `lang_definitions` VALUES (23285, 1705, 17, 'Masculino');
INSERT INTO `lang_definitions` VALUES (23286, 1706, 17, 'Camisinhas Masculinas');
INSERT INTO `lang_definitions` VALUES (23287, 1707, 17, 'VSC Masculinas');
INSERT INTO `lang_definitions` VALUES (23288, 1708, 17, 'Mamograma');
INSERT INTO `lang_definitions` VALUES (23289, 1709, 17, 'Administração');
INSERT INTO `lang_definitions` VALUES (23290, 1710, 17, 'Manual Postado');
INSERT INTO `lang_definitions` VALUES (23291, 1711, 17, 'Fabricante');
INSERT INTO `lang_definitions` VALUES (23292, 1712, 17, 'Março');
INSERT INTO `lang_definitions` VALUES (23293, 1713, 17, 'Estado Civil');
INSERT INTO `lang_definitions` VALUES (23294, 1714, 17, 'Marque como faturado mas salta faturamento');
INSERT INTO `lang_definitions` VALUES (23295, 1715, 17, 'Marque como Clareado');
INSERT INTO `lang_definitions` VALUES (23296, 1716, 17, 'Marque como não faturou');
INSERT INTO `lang_definitions` VALUES (23297, 1717, 17, 'Marque como clareado');
INSERT INTO `lang_definitions` VALUES (23298, 1718, 17, 'Casado');
INSERT INTO `lang_definitions` VALUES (23299, 1719, 17, 'Maxilar Direto:');
INSERT INTO `lang_definitions` VALUES (23300, 1720, 17, 'Maio');
INSERT INTO `lang_definitions` VALUES (23301, 1721, 17, 'MC');
INSERT INTO `lang_definitions` VALUES (23302, 1722, 17, 'mcg');
INSERT INTO `lang_definitions` VALUES (23303, 1723, 17, 'Malleolus mediano');
INSERT INTO `lang_definitions` VALUES (23304, 1724, 17, 'Exame médico');
INSERT INTO `lang_definitions` VALUES (23305, 1725, 17, 'Médico');
INSERT INTO `lang_definitions` VALUES (23306, 1726, 17, 'Aborto Médico');
INSERT INTO `lang_definitions` VALUES (23307, 1727, 17, 'problemas Médicos');
INSERT INTO `lang_definitions` VALUES (23308, 1728, 17, 'Problemas Médicos');
INSERT INTO `lang_definitions` VALUES (23309, 1729, 17, 'Registro médico');
INSERT INTO `lang_definitions` VALUES (23310, 1730, 17, 'Registro médico #');
INSERT INTO `lang_definitions` VALUES (23311, 1731, 17, 'Registros médico');
INSERT INTO `lang_definitions` VALUES (23312, 1732, 17, 'Médico/História (escrever,addonly opcional)');
INSERT INTO `lang_definitions` VALUES (23313, 1733, 17, 'Medicare Part B');
INSERT INTO `lang_definitions` VALUES (23314, 1734, 17, 'Medicamento');
INSERT INTO `lang_definitions` VALUES (23315, 1735, 17, 'Medicamentos');
INSERT INTO `lang_definitions` VALUES (23316, 1736, 17, 'Medicamentos:');
INSERT INTO `lang_definitions` VALUES (23317, 1737, 17, 'Unidades de medicinas');
INSERT INTO `lang_definitions` VALUES (23318, 1738, 17, 'Médio');
INSERT INTO `lang_definitions` VALUES (23319, 1739, 17, 'Relatório de Estatísticas da Associação de Membro');
INSERT INTO `lang_definitions` VALUES (23320, 1740, 17, 'Problemas de Memória');
INSERT INTO `lang_definitions` VALUES (23321, 1741, 17, 'Homem');
INSERT INTO `lang_definitions` VALUES (23322, 1742, 17, 'Homem e Mulher');
INSERT INTO `lang_definitions` VALUES (23323, 1743, 17, 'Somente Homem');
INSERT INTO `lang_definitions` VALUES (23324, 1744, 17, 'Menarche');
INSERT INTO `lang_definitions` VALUES (23325, 1745, 17, 'Menopausa');
INSERT INTO `lang_definitions` VALUES (23326, 1746, 17, 'Fluxo Mestrual');
INSERT INTO `lang_definitions` VALUES (23327, 1747, 17, 'Frequência mestrual');
INSERT INTO `lang_definitions` VALUES (23328, 1748, 17, 'Doença mental');
INSERT INTO `lang_definitions` VALUES (23329, 1749, 17, 'Mensagen');
INSERT INTO `lang_definitions` VALUES (23330, 1750, 17, 'MENSAGEN');
INSERT INTO `lang_definitions` VALUES (23331, 1751, 17, 'Método');
INSERT INTO `lang_definitions` VALUES (23332, 1752, 17, 'Método de Destruição');
INSERT INTO `lang_definitions` VALUES (23333, 1753, 17, 'mg');
INSERT INTO `lang_definitions` VALUES (23334, 1754, 17, 'mg/1cc');
INSERT INTO `lang_definitions` VALUES (23335, 1755, 17, 'mg/2cc');
INSERT INTO `lang_definitions` VALUES (23336, 1756, 17, 'mg/3cc');
INSERT INTO `lang_definitions` VALUES (23337, 1757, 17, 'mg/4cc');
INSERT INTO `lang_definitions` VALUES (23338, 1758, 17, 'mg/5cc');
INSERT INTO `lang_definitions` VALUES (23339, 1759, 17, 'Meio');
INSERT INTO `lang_definitions` VALUES (23340, 1760, 17, 'Nome do Meio');
INSERT INTO `lang_definitions` VALUES (23341, 1761, 17, 'nome do Meio');
INSERT INTO `lang_definitions` VALUES (23342, 1762, 17, 'Migrante ou trabalhador sazonal?');
INSERT INTO `lang_definitions` VALUES (23343, 1763, 17, 'Migrante/Sazonal');
INSERT INTO `lang_definitions` VALUES (23344, 1764, 17, 'Mimique Tipo');
INSERT INTO `lang_definitions` VALUES (23345, 1765, 17, 'min');
INSERT INTO `lang_definitions` VALUES (23346, 1766, 17, 'Tensão de juntas secundária +/- Synovitis');
INSERT INTO `lang_definitions` VALUES (23347, 1767, 17, 'minutos');
INSERT INTO `lang_definitions` VALUES (23348, 1768, 17, 'Minutos');
INSERT INTO `lang_definitions` VALUES (23349, 1769, 17, 'Misc');
INSERT INTO `lang_definitions` VALUES (23350, 1770, 17, 'Opções para fatura misc');
INSERT INTO `lang_definitions` VALUES (23351, 1771, 17, 'Opções para fatura misc para HCFA-1500');
INSERT INTO `lang_definitions` VALUES (23352, 1772, 17, 'Opções para fatura misc HCFA');
INSERT INTO `lang_definitions` VALUES (23353, 1773, 17, 'Diverso');
INSERT INTO `lang_definitions` VALUES (23354, 1774, 17, 'Perdido');
INSERT INTO `lang_definitions` VALUES (23355, 1775, 17, 'Taxa Perdida');
INSERT INTO `lang_definitions` VALUES (23356, 1776, 17, 'PID Perdida');
INSERT INTO `lang_definitions` VALUES (23357, 1777, 17, 'Golpe perdido depois de pagador em fonte para código');
INSERT INTO `lang_definitions` VALUES (23358, 1778, 17, 'Misturado');
INSERT INTO `lang_definitions` VALUES (23359, 1779, 17, 'ml');
INSERT INTO `lang_definitions` VALUES (23360, 1780, 17, 'mm/hg');
INSERT INTO `lang_definitions` VALUES (23361, 1781, 17, 'MMR 1');
INSERT INTO `lang_definitions` VALUES (23362, 1782, 17, 'MMR 2');
INSERT INTO `lang_definitions` VALUES (23363, 1783, 17, 'Móvel');
INSERT INTO `lang_definitions` VALUES (23364, 1784, 17, 'Telefone Móvel');
INSERT INTO `lang_definitions` VALUES (23365, 1785, 17, 'Mod');
INSERT INTO `lang_definitions` VALUES (23366, 1786, 17, 'Modificador');
INSERT INTO `lang_definitions` VALUES (23367, 1787, 17, 'Mon');
INSERT INTO `lang_definitions` VALUES (23368, 1790, 17, 'Segunda');
INSERT INTO `lang_definitions` VALUES (23369, 1791, 17, 'mês');
INSERT INTO `lang_definitions` VALUES (23370, 1792, 17, 'Mês');
INSERT INTO `lang_definitions` VALUES (23371, 1793, 17, 'Visão do Mês');
INSERT INTO `lang_definitions` VALUES (23372, 1794, 17, 'Mêses');
INSERT INTO `lang_definitions` VALUES (23373, 1795, 17, 'Renda do Mês');
INSERT INTO `lang_definitions` VALUES (23374, 1796, 17, 'Mais de 100 registros fundo. Por Favor estreite seu');
INSERT INTO `lang_definitions` VALUES (23375, 1797, 17, 'Mais de 50 resultados, por favor faça sua procura');
INSERT INTO `lang_definitions` VALUES (23376, 1798, 17, 'Mãe');
INSERT INTO `lang_definitions` VALUES (23377, 1799, 17, 'Boca');
INSERT INTO `lang_definitions` VALUES (23378, 1800, 17, 'Mova');
INSERT INTO `lang_definitions` VALUES (23379, 1801, 17, 'Mova Documento a Categoria:');
INSERT INTO `lang_definitions` VALUES (23380, 1802, 17, 'Rebaixe');
INSERT INTO `lang_definitions` VALUES (23381, 1803, 17, 'Move para Paciente');
INSERT INTO `lang_definitions` VALUES (23382, 1804, 17, 'Move para...');
INSERT INTO `lang_definitions` VALUES (23383, 1805, 17, 'Mova para Cima');
INSERT INTO `lang_definitions` VALUES (23384, 1806, 17, 'Mr.');
INSERT INTO `lang_definitions` VALUES (23385, 1807, 17, 'Mrs.');
INSERT INTO `lang_definitions` VALUES (23386, 1808, 17, 'Ms.');
INSERT INTO `lang_definitions` VALUES (23387, 1809, 17, 'Ferramenta Mult Idioma');
INSERT INTO `lang_definitions` VALUES (23388, 1810, 17, 'Àreas múltiplas');
INSERT INTO `lang_definitions` VALUES (23389, 1811, 17, 'Murmúrio:');
INSERT INTO `lang_definitions` VALUES (23390, 1812, 17, 'Musc Dor');
INSERT INTO `lang_definitions` VALUES (23391, 1813, 17, 'Musc Dores');
INSERT INTO `lang_definitions` VALUES (23392, 1814, 17, 'Vermelhidão de Musc');
INSERT INTO `lang_definitions` VALUES (23393, 1815, 17, 'Duraza de Musc');
INSERT INTO `lang_definitions` VALUES (23394, 1816, 17, 'Inchando Musc');
INSERT INTO `lang_definitions` VALUES (23395, 1817, 17, 'Morno Musc');
INSERT INTO `lang_definitions` VALUES (23396, 1818, 17, 'Músculo');
INSERT INTO `lang_definitions` VALUES (23397, 1819, 17, 'Dano de Músculo');
INSERT INTO `lang_definitions` VALUES (23398, 1820, 17, 'Muscoloskeletal');
INSERT INTO `lang_definitions` VALUES (23399, 1821, 17, 'Mutualmente Definido');
INSERT INTO `lang_definitions` VALUES (23400, 1822, 17, 'MVA');
INSERT INTO `lang_definitions` VALUES (23401, 1823, 17, 'N/A');
INSERT INTO `lang_definitions` VALUES (23402, 1824, 17, 'n/a');
INSERT INTO `lang_definitions` VALUES (23403, 1825, 17, 'Nome');
INSERT INTO `lang_definitions` VALUES (23404, 1826, 17, 'Nome 1');
INSERT INTO `lang_definitions` VALUES (23405, 1827, 17, 'Nome 2');
INSERT INTO `lang_definitions` VALUES (23406, 1828, 17, 'Nome e Título de Administrador de Imunização');
INSERT INTO `lang_definitions` VALUES (23407, 1829, 17, 'Nome de companhia de seguros');
INSERT INTO `lang_definitions` VALUES (23408, 1830, 17, 'Nome de Provedor');
INSERT INTO `lang_definitions` VALUES (23409, 1831, 17, 'Nomeie Tradução');
INSERT INTO `lang_definitions` VALUES (23410, 1832, 17, 'Name/Value');
INSERT INTO `lang_definitions` VALUES (23411, 1833, 17, 'Nome:');
INSERT INTO `lang_definitions` VALUES (23412, 1834, 17, 'NARES:');
INSERT INTO `lang_definitions` VALUES (23413, 1835, 17, 'NARES: Direito normal');
INSERT INTO `lang_definitions` VALUES (23414, 1836, 17, 'Cor-de-rosa de mucosa nasal, midline de septum,');
INSERT INTO `lang_definitions` VALUES (23415, 1837, 17, 'Nacionalidade');
INSERT INTO `lang_definitions` VALUES (23416, 1838, 17, 'Náusea');
INSERT INTO `lang_definitions` VALUES (23417, 1839, 17, 'Navegação');
INSERT INTO `lang_definitions` VALUES (23418, 1840, 17, 'NDC');
INSERT INTO `lang_definitions` VALUES (23419, 1841, 17, 'NDC Number');
INSERT INTO `lang_definitions` VALUES (23420, 1842, 17, 'Pescoço');
INSERT INTO `lang_definitions` VALUES (23421, 1843, 17, 'Beije Problemas');
INSERT INTO `lang_definitions` VALUES (23422, 1844, 17, 'Pescoço flexível');
INSERT INTO `lang_definitions` VALUES (23423, 1845, 17, 'Precise entrar em uma descrição');
INSERT INTO `lang_definitions` VALUES (23424, 1846, 17, 'Precise entrar em um Valor de Retorno');
INSERT INTO `lang_definitions` VALUES (23425, 1847, 17, 'Precise entrar em identificador');
INSERT INTO `lang_definitions` VALUES (23426, 1848, 17, 'Precise entrar em título');
INSERT INTO `lang_definitions` VALUES (23427, 1849, 17, 'Necessidades Auth');
INSERT INTO `lang_definitions` VALUES (23428, 1850, 17, 'Necessidades Justificam');
INSERT INTO `lang_definitions` VALUES (23429, 1851, 17, 'Necessidades faturamento secundário');
INSERT INTO `lang_definitions` VALUES (23430, 1852, 17, 'Dano de nervo');
INSERT INTO `lang_definitions` VALUES (23431, 1853, 17, 'Condição neural / dano de nervo');
INSERT INTO `lang_definitions` VALUES (23432, 1854, 17, 'Entorpecimento de Neuro');
INSERT INTO `lang_definitions` VALUES (23433, 1855, 17, 'Fraqueza de Neuro');
INSERT INTO `lang_definitions` VALUES (23434, 1856, 17, 'Neurologic');
INSERT INTO `lang_definitions` VALUES (23435, 1857, 17, 'Novo');
INSERT INTO `lang_definitions` VALUES (23436, 1858, 17, 'Novo =>');
INSERT INTO `lang_definitions` VALUES (23437, 1859, 17, 'Aceitantes novos');
INSERT INTO `lang_definitions` VALUES (23438, 1860, 17, 'Alergia nova');
INSERT INTO `lang_definitions` VALUES (23439, 1861, 17, 'Compromisso novo');
INSERT INTO `lang_definitions` VALUES (23440, 1862, 17, 'Categorias novas');
INSERT INTO `lang_definitions` VALUES (23441, 1863, 17, 'Categoria nova');
INSERT INTO `lang_definitions` VALUES (23442, 1864, 17, 'Clientes novos');
INSERT INTO `lang_definitions` VALUES (23443, 1865, 17, 'Consulta nova');
INSERT INTO `lang_definitions` VALUES (23444, 1866, 17, 'Jogo de Definição novo somou');
INSERT INTO `lang_definitions` VALUES (23445, 1867, 17, 'Documento novo');
INSERT INTO `lang_definitions` VALUES (23446, 1868, 17, 'Forma de Encontro nova');
INSERT INTO `lang_definitions` VALUES (23447, 1869, 17, 'Encontros novos não autorizaram');
INSERT INTO `lang_definitions` VALUES (23448, 1870, 17, 'Enctr novo');
INSERT INTO `lang_definitions` VALUES (23449, 1871, 17, 'Informação de Facilidade nova');
INSERT INTO `lang_definitions` VALUES (23450, 1872, 17, 'Grupo novo');
INSERT INTO `lang_definitions` VALUES (23451, 1873, 17, 'Informação de Grupo nova');
INSERT INTO `lang_definitions` VALUES (23452, 1874, 17, 'Limite novo de Eventos');
INSERT INTO `lang_definitions` VALUES (23453, 1875, 17, 'Lista nova');
INSERT INTO `lang_definitions` VALUES (23454, 1876, 17, 'Paciente novo');
INSERT INTO `lang_definitions` VALUES (23455, 1877, 17, 'Encontro Paciente novo');
INSERT INTO `lang_definitions` VALUES (23456, 1878, 17, 'ID Paciente novo');
INSERT INTO `lang_definitions` VALUES (23457, 1879, 17, 'Pt novo');
INSERT INTO `lang_definitions` VALUES (23458, 1880, 17, 'Submissões novas');
INSERT INTO `lang_definitions` VALUES (23459, 1881, 17, 'Usuário novo');
INSERT INTO `lang_definitions` VALUES (23460, 1882, 17, 'Visita nova');
INSERT INTO `lang_definitions` VALUES (23461, 1883, 17, 'New/Search');
INSERT INTO `lang_definitions` VALUES (23462, 1884, 17, 'Jornal');
INSERT INTO `lang_definitions` VALUES (23463, 1885, 17, 'Logo');
INSERT INTO `lang_definitions` VALUES (23464, 1886, 17, 'Dia que vem');
INSERT INTO `lang_definitions` VALUES (23465, 1887, 17, 'Mês que vem');
INSERT INTO `lang_definitions` VALUES (23466, 1888, 17, 'Semana que vem');
INSERT INTO `lang_definitions` VALUES (23467, 1889, 17, 'Apelido');
INSERT INTO `lang_definitions` VALUES (23468, 1890, 17, 'Suores noturnos');
INSERT INTO `lang_definitions` VALUES (23469, 1891, 17, 'Nl ext genitália, mucosa de vag, cerviz,');
INSERT INTO `lang_definitions` VALUES (23470, 1892, 17, 'NÃO');
INSERT INTO `lang_definitions` VALUES (23471, 1893, 17, 'Não');
INSERT INTO `lang_definitions` VALUES (23472, 1894, 17, 'Nenhum acesso');
INSERT INTO `lang_definitions` VALUES (23473, 1895, 17, 'Nenhum adenopathy (2 áreas requereram)');
INSERT INTO `lang_definitions` VALUES (23474, 1896, 17, 'Nenhum tenderness/masses anexo');
INSERT INTO `lang_definitions` VALUES (23475, 1897, 17, 'Nenhum sistema de faturamento é atualmente ativo');
INSERT INTO `lang_definitions` VALUES (23476, 1898, 17, 'Nenhuma Conta Achou para Incluir em OFX Export <br>');
INSERT INTO `lang_definitions` VALUES (23477, 1899, 17, 'Nenhum código foi especificado!');
INSERT INTO `lang_definitions` VALUES (23478, 1900, 17, 'Nenhuma Diagnose');
INSERT INTO `lang_definitions` VALUES (23479, 1901, 17, 'Nenhuma data de fim');
INSERT INTO `lang_definitions` VALUES (23480, 1902, 17, 'Nenhuma entrada achou, use a forma abaixo somar uma entrada.');
INSERT INTO `lang_definitions` VALUES (23481, 1903, 17, 'Nenhum Evento');
INSERT INTO `lang_definitions` VALUES (23482, 1904, 17, 'Nenhum grupo foi selecionado');
INSERT INTO `lang_definitions` VALUES (23483, 1905, 17, 'Nenhuma hérnia');
INSERT INTO `lang_definitions` VALUES (23484, 1906, 17, 'Nenhuma Companhia de seguros Achou');
INSERT INTO `lang_definitions` VALUES (23485, 1907, 17, 'Nenhum artigo foi selecionado!');
INSERT INTO `lang_definitions` VALUES (23486, 1908, 17, 'Nenhuma massa, ternura,');
INSERT INTO `lang_definitions` VALUES (23487, 1909, 17, 'Nenhuma nota');
INSERT INTO `lang_definitions` VALUES (23488, 1910, 17, 'Nenhum ogrganomegoly');
INSERT INTO `lang_definitions` VALUES (23489, 1911, 17, 'Nenhuma abertura foi achada durante este período.');
INSERT INTO `lang_definitions` VALUES (23490, 1912, 17, 'Nenhum Sócio Achou');
INSERT INTO `lang_definitions` VALUES (23491, 1913, 17, 'Nenhum edema periférico');
INSERT INTO `lang_definitions` VALUES (23492, 1914, 17, 'Nenhuma Farmácia Achou');
INSERT INTO `lang_definitions` VALUES (23493, 1915, 17, 'Nenhuma Prescrição Achou');
INSERT INTO `lang_definitions` VALUES (23494, 1916, 17, 'Nenhum illness/injury apresentando');
INSERT INTO `lang_definitions` VALUES (23495, 1917, 17, 'Nenhum Provedor Achou');
INSERT INTO `lang_definitions` VALUES (23496, 1918, 17, 'Nenhuma lesão apressada ou anormal');
INSERT INTO `lang_definitions` VALUES (23497, 1919, 17, 'Nenhum registro achou. Por favor amplie seus critério de pesquisa.');
INSERT INTO `lang_definitions` VALUES (23498, 1920, 17, 'Nenhum Resultado');
INSERT INTO `lang_definitions` VALUES (23499, 1921, 17, 'Nenhum Resultado Achou Para Procura');
INSERT INTO `lang_definitions` VALUES (23500, 1922, 17, 'Nenhum resultado, por favor bandeja novamente.');
INSERT INTO `lang_definitions` VALUES (23501, 1923, 17, 'Nenhum resultado, por favor tente novamente.');
INSERT INTO `lang_definitions` VALUES (23502, 1924, 17, 'Nenhum Espetáculo');
INSERT INTO `lang_definitions` VALUES (23503, 1925, 17, 'Nenhuma Ternura de Seio:');
INSERT INTO `lang_definitions` VALUES (23504, 1926, 17, 'Nenhum dimpling de pele ou nódulos de peito');
INSERT INTO `lang_definitions` VALUES (23505, 1927, 17, 'Nenhuma ternura de testicular, massas,');
INSERT INTO `lang_definitions` VALUES (23506, 1928, 17, 'Nenhuma emoção ou suspiros');
INSERT INTO `lang_definitions` VALUES (23507, 1929, 17, 'Nenhuma visita');
INSERT INTO `lang_definitions` VALUES (23508, 1930, 17, 'Não, Cancelamento');
INSERT INTO `lang_definitions` VALUES (23509, 1931, 17, 'Não:');
INSERT INTO `lang_definitions` VALUES (23510, 1932, 17, 'Nocturia');
INSERT INTO `lang_definitions` VALUES (23511, 1933, 17, 'Non dano específico');
INSERT INTO `lang_definitions` VALUES (23512, 1934, 17, 'Non-insulina Diabete Dependente');
INSERT INTO `lang_definitions` VALUES (23513, 1935, 17, 'Exame médico de Non-SRH');
INSERT INTO `lang_definitions` VALUES (23514, 1936, 17, 'Non-SRH Non-Medical');
INSERT INTO `lang_definitions` VALUES (23515, 1937, 17, 'Nenhum');
INSERT INTO `lang_definitions` VALUES (23516, 1938, 17, 'nenhum');
INSERT INTO `lang_definitions` VALUES (23517, 1939, 17, 'Nenhum do anterior');
INSERT INTO `lang_definitions` VALUES (23518, 1940, 17, 'Noninsulin Diabete Dependente');
INSERT INTO `lang_definitions` VALUES (23519, 1941, 17, 'Nem');
INSERT INTO `lang_definitions` VALUES (23520, 1942, 17, 'Normal');
INSERT INTO `lang_definitions` VALUES (23521, 1943, 17, 'BL normal');
INSERT INTO `lang_definitions` VALUES (23522, 1944, 17, 'Exame Cardíaco normal:');
INSERT INTO `lang_definitions` VALUES (23523, 1945, 17, 'Exame Cardíaco normal:');
INSERT INTO `lang_definitions` VALUES (23524, 1946, 17, 'Exame Pulmonar normal:');
INSERT INTO `lang_definitions` VALUES (23525, 1947, 17, 'Exame Pulmonar normal:');
INSERT INTO `lang_definitions` VALUES (23526, 1948, 17, 'Visita de Escritório normal');
INSERT INTO `lang_definitions` VALUES (23527, 1949, 17, 'Oropharynx normal:');
INSERT INTO `lang_definitions` VALUES (23528, 1950, 17, 'Direito normal');
INSERT INTO `lang_definitions` VALUES (23529, 1951, 17, 'Direito normal:');
INSERT INTO `lang_definitions` VALUES (23530, 1952, 17, 'Visão normal');
INSERT INTO `lang_definitions` VALUES (23531, 1953, 17, 'normal:');
INSERT INTO `lang_definitions` VALUES (23532, 1954, 17, 'Norueguês');
INSERT INTO `lang_definitions` VALUES (23533, 1955, 17, 'Nariz');
INSERT INTO `lang_definitions` VALUES (23534, 1956, 17, 'Hemorragia nasal');
INSERT INTO `lang_definitions` VALUES (23535, 1957, 17, 'Não todos os campos são requeridos para todos os códigos ou tipos de código.');
INSERT INTO `lang_definitions` VALUES (23536, 1958, 17, 'Não Permitido');
INSERT INTO `lang_definitions` VALUES (23537, 1959, 17, 'Não permitido apagar o grupo de Administradores');
INSERT INTO `lang_definitions` VALUES (23538, 1960, 17, 'Não permitido a inactivate todos os objetos de segurança');
INSERT INTO `lang_definitions` VALUES (23539, 1961, 17, 'Não permitido a inactivate qualquer coisa dos Administradores ACL');
INSERT INTO `lang_definitions` VALUES (23540, 1962, 17, 'Não permitido remover o usuário de admin do grupo de Administradores');
INSERT INTO `lang_definitions` VALUES (23541, 1963, 17, 'Não autorizado para acessar módulo de PostCalendar');
INSERT INTO `lang_definitions` VALUES (23542, 1964, 17, 'Não autorizado');
INSERT INTO `lang_definitions` VALUES (23543, 1965, 17, 'Não autorizado para esta esquadra.');
INSERT INTO `lang_definitions` VALUES (23544, 1966, 17, 'Não Disponível');
INSERT INTO `lang_definitions` VALUES (23545, 1967, 17, 'Não faturado');
INSERT INTO `lang_definitions` VALUES (23546, 1968, 17, 'Não confirmado');
INSERT INTO `lang_definitions` VALUES (23547, 1969, 17, 'Não Examinado');
INSERT INTO `lang_definitions` VALUES (23548, 1970, 17, 'Não Examinado:');
INSERT INTO `lang_definitions` VALUES (23549, 1971, 17, 'Não Examinado:');
INSERT INTO `lang_definitions` VALUES (23550, 1972, 17, 'não ache');
INSERT INTO `lang_definitions` VALUES (23551, 1973, 17, 'não ache!');
INSERT INTO `lang_definitions` VALUES (23552, 1974, 17, 'Não visto desde então');
INSERT INTO `lang_definitions` VALUES (23553, 1975, 17, 'Nota');
INSERT INTO `lang_definitions` VALUES (23554, 1976, 17, 'Tipo de nota');
INSERT INTO `lang_definitions` VALUES (23555, 1977, 17, 'Nota: Neste código não foi entrado por um usuário autorizado. Podem ser transferidos códigos só autorizados à Rede de Faturamento Médica Aberta por processar. Se você desejar transferir estes códigos, por favor selecione um usuário autorizado aqui.');
INSERT INTO `lang_definitions` VALUES (23556, 1978, 17, 'NOTA: Arquivos transferindo com nomes duplicados causarão os arquivos a ser renomeados automaticamente. Por exemplo \'<i>file.jpg </ i> \' se tornará \'<i>file.jpg.1 </ i> \'. Filenames são considerados sem igual por paciente, não por categoria.');
INSERT INTO `lang_definitions` VALUES (23557, 1979, 17, 'Notas');
INSERT INTO `lang_definitions` VALUES (23558, 1980, 17, 'Notas - qualquer encontro (write,addonly opcional)');
INSERT INTO `lang_definitions` VALUES (23559, 1981, 17, 'Notas - meus encontros (write,addonly opcional)');
INSERT INTO `lang_definitions` VALUES (23560, 1982, 17, 'Notas não autorizaram');
INSERT INTO `lang_definitions` VALUES (23561, 1983, 17, 'Nada foi selecionado');
INSERT INTO `lang_definitions` VALUES (23562, 1984, 17, 'NOTE:: PostCalendar Submission/Modification');
INSERT INTO `lang_definitions` VALUES (23563, 1985, 17, 'Notificação');
INSERT INTO `lang_definitions` VALUES (23564, 1986, 17, 'Notifique Admin Sobre Evento Submission/Modification?');
INSERT INTO `lang_definitions` VALUES (23565, 1987, 17, 'Novembro');
INSERT INTO `lang_definitions` VALUES (23566, 1988, 17, 'Postando agora para:');
INSERT INTO `lang_definitions` VALUES (23567, 1989, 17, 'Imprimindo agora $declarações de stmt_count e encontros atualizando.');
INSERT INTO `lang_definitions` VALUES (23568, 1990, 17, 'Imprimindo agora $declarações de stmt_count e faturas atualizando.');
INSERT INTO `lang_definitions` VALUES (23569, 1991, 17, 'Imprimindo agora $declarações de stmt_count; não serão atualizados encontros.');
INSERT INTO `lang_definitions` VALUES (23570, 1992, 17, 'Imprimindo agora $declarações de stmt_count; não serão atualizadas faturas.');
INSERT INTO `lang_definitions` VALUES (23571, 1993, 17, 'NPI');
INSERT INTO `lang_definitions` VALUES (23572, 1994, 17, 'Número');
INSERT INTO `lang_definitions` VALUES (23573, 1995, 17, 'Número de colunas em visão de ano.');
INSERT INTO `lang_definitions` VALUES (23574, 1996, 17, 'Número de jogos ou eventos perdeu, se qualquer');
INSERT INTO `lang_definitions` VALUES (23575, 1997, 17, 'Entorpecimento');
INSERT INTO `lang_definitions` VALUES (23576, 1998, 17, 'O.A.F.V.');
INSERT INTO `lang_definitions` VALUES (23577, 2000, 17, 'Obesidade eu');
INSERT INTO `lang_definitions` VALUES (23578, 2001, 17, 'Obesidade II');
INSERT INTO `lang_definitions` VALUES (23579, 2002, 17, 'Obesidade III');
INSERT INTO `lang_definitions` VALUES (23580, 2003, 17, 'Objetivo');
INSERT INTO `lang_definitions` VALUES (23581, 2004, 17, 'Ocupação');
INSERT INTO `lang_definitions` VALUES (23582, 2005, 17, 'Ocorrência');
INSERT INTO `lang_definitions` VALUES (23583, 2006, 17, 'Outubro');
INSERT INTO `lang_definitions` VALUES (23584, 2007, 17, 'OD');
INSERT INTO `lang_definitions` VALUES (23585, 2008, 17, 'de quantidade');
INSERT INTO `lang_definitions` VALUES (23586, 2009, 17, 'de tabletes');
INSERT INTO `lang_definitions` VALUES (23587, 2010, 17, 'do mês todo');
INSERT INTO `lang_definitions` VALUES (23588, 2011, 17, 'Ofc Notes');
INSERT INTO `lang_definitions` VALUES (23589, 2012, 17, 'Notas de escritório');
INSERT INTO `lang_definitions` VALUES (23590, 2013, 17, 'Visita de escritório');
INSERT INTO `lang_definitions` VALUES (23591, 2014, 17, 'Descendência');
INSERT INTO `lang_definitions` VALUES (23592, 2015, 17, 'ungüento');
INSERT INTO `lang_definitions` VALUES (23593, 2016, 17, 'OK');
INSERT INTO `lang_definitions` VALUES (23594, 2017, 17, 'OK para unir o assunto de GCAC datado');
INSERT INTO `lang_definitions` VALUES (23595, 2018, 17, 'Clientes velhos');
INSERT INTO `lang_definitions` VALUES (23596, 2019, 17, 'Non de fratura velho / malunion');
INSERT INTO `lang_definitions` VALUES (23597, 2020, 17, 'Omita os usuários internos?');
INSERT INTO `lang_definitions` VALUES (23598, 2021, 17, 'omita a autoassign');
INSERT INTO `lang_definitions` VALUES (23599, 2022, 17, 'em');
INSERT INTO `lang_definitions` VALUES (23600, 2023, 17, 'Disponível');
INSERT INTO `lang_definitions` VALUES (23601, 2024, 17, 'Em Ordem');
INSERT INTO `lang_definitions` VALUES (23602, 2025, 17, 'Uma vez você muda sua contra-senha, você terá a re-login.');
INSERT INTO `lang_definitions` VALUES (23603, 2026, 17, 'Apoio on-line');
INSERT INTO `lang_definitions` VALUES (23604, 2027, 17, 'Só Ativo');
INSERT INTO `lang_definitions` VALUES (23605, 2028, 17, 'só se faturando local');
INSERT INTO `lang_definitions` VALUES (23606, 2029, 17, 'Só Inativo');
INSERT INTO `lang_definitions` VALUES (23607, 2030, 17, 'Só Mina');
INSERT INTO `lang_definitions` VALUES (23608, 2031, 17, 'Começo de Doença:');
INSERT INTO `lang_definitions` VALUES (23609, 2032, 17, 'Começo de Ilness:');
INSERT INTO `lang_definitions` VALUES (23610, 2033, 17, 'Começo de Inchar:');
INSERT INTO `lang_definitions` VALUES (23611, 2034, 17, 'Onset/hosp. data:');
INSERT INTO `lang_definitions` VALUES (23612, 2035, 17, 'Aberto');
INSERT INTO `lang_definitions` VALUES (23613, 2036, 17, 'OpenEMR exige para Javascript que execute autenticação de usuário.');
INSERT INTO `lang_definitions` VALUES (23614, 2037, 17, 'Usuários de OpenEMR');
INSERT INTO `lang_definitions` VALUES (23615, 2038, 17, 'Opção');
INSERT INTO `lang_definitions` VALUES (23616, 2039, 17, 'Opcional');
INSERT INTO `lang_definitions` VALUES (23617, 2040, 17, 'Nome de droga opcional, use% como um curinga');
INSERT INTO `lang_definitions` VALUES (23618, 2041, 17, 'Informação opcional sobre este evento');
INSERT INTO `lang_definitions` VALUES (23619, 2042, 17, 'Número de lote opcional, use% como um curinga');
INSERT INTO `lang_definitions` VALUES (23620, 2043, 17, 'Paciente numérico opcional ID');
INSERT INTO `lang_definitions` VALUES (23621, 2044, 17, 'Código de procedimento opcional');
INSERT INTO `lang_definitions` VALUES (23622, 2045, 17, 'Ou');
INSERT INTO `lang_definitions` VALUES (23623, 2046, 17, 'OU');
INSERT INTO `lang_definitions` VALUES (23624, 2047, 17, 'ou escolhe');
INSERT INTO `lang_definitions` VALUES (23625, 2048, 17, 'Ou Fora Para');
INSERT INTO `lang_definitions` VALUES (23626, 2049, 17, 'Ou transfere arquivo de ERA:');
INSERT INTO `lang_definitions` VALUES (23627, 2050, 17, 'Oral');
INSERT INTO `lang_definitions` VALUES (23628, 2051, 17, 'Cor-de-rosa de mucosa oral, garganta claro');
INSERT INTO `lang_definitions` VALUES (23629, 2052, 17, 'Ordem');
INSERT INTO `lang_definitions` VALUES (23630, 2053, 17, 'Ordem deve ser um número entre 1 e 999');
INSERT INTO `lang_definitions` VALUES (23631, 2054, 17, 'Dano de órgão');
INSERT INTO `lang_definitions` VALUES (23632, 2055, 17, 'Organização');
INSERT INTO `lang_definitions` VALUES (23633, 2056, 17, 'Organizações');
INSERT INTO `lang_definitions` VALUES (23634, 2057, 17, 'X 3 orientado');
INSERT INTO `lang_definitions` VALUES (23635, 2058, 17, 'Original');
INSERT INTO `lang_definitions` VALUES (23636, 2059, 17, 'OROPHARYNX:');
INSERT INTO `lang_definitions` VALUES (23637, 2060, 17, 'Orthopnea');
INSERT INTO `lang_definitions` VALUES (23638, 2061, 17, 'OS');
INSERT INTO `lang_definitions` VALUES (23639, 2062, 17, 'Osetoarthritis');
INSERT INTO `lang_definitions` VALUES (23640, 2063, 17, 'Outro');
INSERT INTO `lang_definitions` VALUES (23641, 2064, 17, 'outro');
INSERT INTO `lang_definitions` VALUES (23642, 2065, 17, 'Outro (especifique)');
INSERT INTO `lang_definitions` VALUES (23643, 2066, 17, 'Outro Programa Federal');
INSERT INTO `lang_definitions` VALUES (23644, 2067, 17, 'Outro HCFA');
INSERT INTO `lang_definitions` VALUES (23645, 2068, 17, 'Outro dano especificou não em outro lugar');
INSERT INTO `lang_definitions` VALUES (23646, 2069, 17, 'outro mês');
INSERT INTO `lang_definitions` VALUES (23647, 2070, 17, 'Outros Programas Non-federais');
INSERT INTO `lang_definitions` VALUES (23648, 2071, 17, 'Outras Notas');
INSERT INTO `lang_definitions` VALUES (23649, 2072, 17, 'Outros Sintomas Pertinentes');
INSERT INTO `lang_definitions` VALUES (23650, 2073, 17, 'Outros Sintomas Pertinentes:');
INSERT INTO `lang_definitions` VALUES (23651, 2074, 17, 'Outro stress/Over usam dano');
INSERT INTO `lang_definitions` VALUES (23652, 2075, 17, 'Outro Cirúrgico');
INSERT INTO `lang_definitions` VALUES (23653, 2076, 17, 'Other/Generic Abortion-Related');
INSERT INTO `lang_definitions` VALUES (23654, 2077, 17, 'caso contrário você destruirá to/from de referências dados existentes.');
INSERT INTO `lang_definitions` VALUES (23655, 2078, 17, 'Ottawa Tornozelo Regras');
INSERT INTO `lang_definitions` VALUES (23656, 2079, 17, 'OU');
INSERT INTO `lang_definitions` VALUES (23657, 2080, 17, 'FORA');
INSERT INTO `lang_definitions` VALUES (23658, 2081, 17, 'Fora De Escritório');
INSERT INTO `lang_definitions` VALUES (23659, 2082, 17, 'Resultado');
INSERT INTO `lang_definitions` VALUES (23660, 2083, 17, 'Perspectiva');
INSERT INTO `lang_definitions` VALUES (23661, 2084, 17, 'Overuse');
INSERT INTO `lang_definitions` VALUES (23662, 2085, 17, 'Sobrepeso');
INSERT INTO `lang_definitions` VALUES (23663, 2086, 17, 'Escreva elaboradamente escolha de HIPAA');
INSERT INTO `lang_definitions` VALUES (23664, 2087, 17, 'Saturação de oxigênio');
INSERT INTO `lang_definitions` VALUES (23665, 2088, 17, 'P');
INSERT INTO `lang_definitions` VALUES (23666, 2089, 17, 'p.c.');
INSERT INTO `lang_definitions` VALUES (23667, 2090, 17, 'da tarde');
INSERT INTO `lang_definitions` VALUES (23668, 2091, 17, 'p.r.n.');
INSERT INTO `lang_definitions` VALUES (23669, 2092, 17, 'Paedeatric');
INSERT INTO `lang_definitions` VALUES (23670, 2093, 17, 'Página');
INSERT INTO `lang_definitions` VALUES (23671, 2094, 17, 'Páginas');
INSERT INTO `lang_definitions` VALUES (23672, 2095, 17, 'Pagado');
INSERT INTO `lang_definitions` VALUES (23673, 2096, 17, 'Quantia pagada que você alocará');
INSERT INTO `lang_definitions` VALUES (23674, 2097, 17, 'Pagado Por');
INSERT INTO `lang_definitions` VALUES (23675, 2098, 17, 'Dor');
INSERT INTO `lang_definitions` VALUES (23676, 2099, 17, 'Palpitação');
INSERT INTO `lang_definitions` VALUES (23677, 2100, 17, 'Sujeira de papinha');
INSERT INTO `lang_definitions` VALUES (23678, 2101, 17, 'Paralisia');
INSERT INTO `lang_definitions` VALUES (23679, 2102, 17, 'Analise gramaticalmente HL7');
INSERT INTO `lang_definitions` VALUES (23680, 2103, 17, 'Sócio');
INSERT INTO `lang_definitions` VALUES (23681, 2104, 17, 'Contra-senha');
INSERT INTO `lang_definitions` VALUES (23682, 2105, 17, 'Mudança de contra-senha');
INSERT INTO `lang_definitions` VALUES (23683, 2106, 17, 'Mudança de contra-senha próspero.');
INSERT INTO `lang_definitions` VALUES (23684, 2107, 17, 'Contra-senha para Portal de SMS');
INSERT INTO `lang_definitions` VALUES (23685, 2108, 17, 'Contra-senha:');
INSERT INTO `lang_definitions` VALUES (23686, 2109, 17, 'Encontros passados');
INSERT INTO `lang_definitions` VALUES (23687, 2110, 17, 'Encontros passados e Documentos');
INSERT INTO `lang_definitions` VALUES (23688, 2111, 17, 'Cole Dados de HL7');
INSERT INTO `lang_definitions` VALUES (23689, 2112, 17, 'Cole os dados para importar na área de texto abaixo:');
INSERT INTO `lang_definitions` VALUES (23690, 2113, 17, 'Remendo');
INSERT INTO `lang_definitions` VALUES (23691, 2114, 17, 'Paciente');
INSERT INTO `lang_definitions` VALUES (23692, 2115, 17, 'paciente');
INSERT INTO `lang_definitions` VALUES (23693, 2116, 17, 'PACIENTE');
INSERT INTO `lang_definitions` VALUES (23694, 2117, 17, 'Alergias pacientes');
INSERT INTO `lang_definitions` VALUES (23695, 2118, 17, 'Alergias pacientes');
INSERT INTO `lang_definitions` VALUES (23696, 2119, 17, 'Compromisso paciente');
INSERT INTO `lang_definitions` VALUES (23697, 2120, 17, 'Quadro paciente ID');
INSERT INTO `lang_definitions` VALUES (23698, 2121, 17, 'Saída paciente');
INSERT INTO `lang_definitions` VALUES (23699, 2122, 17, 'Saída paciente para');
INSERT INTO `lang_definitions` VALUES (23700, 2123, 17, 'Comunicação paciente enviou');
INSERT INTO `lang_definitions` VALUES (23701, 2124, 17, 'Comunication Sent paciente');
INSERT INTO `lang_definitions` VALUES (23702, 2125, 17, 'Dados pacientes');
INSERT INTO `lang_definitions` VALUES (23703, 2126, 17, 'Documento paciente');
INSERT INTO `lang_definitions` VALUES (23704, 2127, 17, 'Encontro paciente');
INSERT INTO `lang_definitions` VALUES (23705, 2128, 17, 'Forma de Encontro paciente');
INSERT INTO `lang_definitions` VALUES (23706, 2129, 17, 'Encontros pacientes');
INSERT INTO `lang_definitions` VALUES (23707, 2130, 17, 'Descobridor paciente');
INSERT INTO `lang_definitions` VALUES (23708, 2131, 17, 'História paciente');
INSERT INTO `lang_definitions` VALUES (23709, 2132, 17, 'História paciente / Estilo de vida');
INSERT INTO `lang_definitions` VALUES (23710, 2133, 17, 'ID paciente');
INSERT INTO `lang_definitions` VALUES (23711, 2134, 17, 'Carteira de identidade paciente');
INSERT INTO `lang_definitions` VALUES (23712, 2135, 17, 'Imunização paciente');
INSERT INTO `lang_definitions` VALUES (23713, 2136, 17, 'Informação paciente');
INSERT INTO `lang_definitions` VALUES (23714, 2137, 17, 'Distribuição de Seguro paciente');
INSERT INTO `lang_definitions` VALUES (23715, 2138, 17, 'Relatório de Distribuição de Seguro paciente');
INSERT INTO `lang_definitions` VALUES (23716, 2139, 17, 'Assuntos pacientes');
INSERT INTO `lang_definitions` VALUES (23717, 2140, 17, 'Lista paciente');
INSERT INTO `lang_definitions` VALUES (23718, 2141, 17, 'Problemas Médicos pacientes');
INSERT INTO `lang_definitions` VALUES (23719, 2142, 17, 'Medicamentos pacientes');
INSERT INTO `lang_definitions` VALUES (23720, 2143, 17, 'Name & Address paciente');
INSERT INTO `lang_definitions` VALUES (23721, 2144, 17, 'Tipos de Nota pacientes');
INSERT INTO `lang_definitions` VALUES (23722, 2145, 17, 'Notas pacientes');
INSERT INTO `lang_definitions` VALUES (23723, 2146, 17, 'Notas pacientes (write,addonly opcional)');
INSERT INTO `lang_definitions` VALUES (23724, 2147, 17, 'Número paciente');
INSERT INTO `lang_definitions` VALUES (23725, 2148, 17, 'Paciente Imprimiu Relatório');
INSERT INTO `lang_definitions` VALUES (23726, 2149, 17, 'Relatório de Registro paciente');
INSERT INTO `lang_definitions` VALUES (23727, 2150, 17, 'Relatório paciente');
INSERT INTO `lang_definitions` VALUES (23728, 2151, 17, 'Pedido paciente');
INSERT INTO `lang_definitions` VALUES (23729, 2152, 17, 'Resumo paciente');
INSERT INTO `lang_definitions` VALUES (23730, 2153, 17, 'Transações pacientes');
INSERT INTO `lang_definitions` VALUES (23731, 2154, 17, 'patient(s) no banco de dados que partida a informação demográfica na que você entrou.');
INSERT INTO `lang_definitions` VALUES (23732, 2155, 17, 'Patient/Client');
INSERT INTO `lang_definitions` VALUES (23733, 2156, 17, 'Paciente:');
INSERT INTO `lang_definitions` VALUES (23734, 2157, 17, 'Pacientes');
INSERT INTO `lang_definitions` VALUES (23735, 2158, 17, 'Pagamento');
INSERT INTO `lang_definitions` VALUES (23736, 2159, 17, 'Preste atenção para o \"Terminado com\" checkboxes. Depois que os seguros sejam marcados complete então nós começaremos pedindo para o paciente que pagasse o equilíbrio restante; se você não marca tudo dos seguros complete então a quantia restante não será colecionada! Também se há um equilíbrio que o paciente deveria pagar, então fixe a data de vencimento adequadamente, como isto afetará o idioma que se aparece em declarações pacientes.');
INSERT INTO `lang_definitions` VALUES (23737, 2160, 17, 'Pague Data:');
INSERT INTO `lang_definitions` VALUES (23738, 2161, 17, 'Pagador');
INSERT INTO `lang_definitions` VALUES (23739, 2162, 17, 'Tipo de pagador');
INSERT INTO `lang_definitions` VALUES (23740, 2163, 17, 'Pagando');
INSERT INTO `lang_definitions` VALUES (23741, 2164, 17, 'Pagamento');
INSERT INTO `lang_definitions` VALUES (23742, 2165, 17, 'pagamento');
INSERT INTO `lang_definitions` VALUES (23743, 2166, 17, 'Data de pagamento');
INSERT INTO `lang_definitions` VALUES (23744, 2167, 17, 'pagamento entrou em');
INSERT INTO `lang_definitions` VALUES (23745, 2168, 17, 'Método de pagamento');
INSERT INTO `lang_definitions` VALUES (23746, 2169, 17, 'Valor de pagamento para código');
INSERT INTO `lang_definitions` VALUES (23747, 2170, 17, 'Pagamentos');
INSERT INTO `lang_definitions` VALUES (23748, 2171, 17, 'PDF');
INSERT INTO `lang_definitions` VALUES (23749, 2172, 17, 'Pélvis e nádega');
INSERT INTO `lang_definitions` VALUES (23750, 2173, 17, 'Pemphigus');
INSERT INTO `lang_definitions` VALUES (23751, 2174, 17, 'Pendente');
INSERT INTO `lang_definitions` VALUES (23752, 2175, 17, 'Followup pendente');
INSERT INTO `lang_definitions` VALUES (23753, 2176, 17, 'Pennington OpenEMR v Firme');
INSERT INTO `lang_definitions` VALUES (23754, 2177, 17, 'Doença de Úlcera péptica');
INSERT INTO `lang_definitions` VALUES (23755, 2178, 17, 'por min');
INSERT INTO `lang_definitions` VALUES (23756, 2179, 17, 'Por Narina');
INSERT INTO `lang_definitions` VALUES (23757, 2180, 17, 'por narina');
INSERT INTO `lang_definitions` VALUES (23758, 2181, 17, 'Por Oris');
INSERT INTO `lang_definitions` VALUES (23759, 2182, 17, 'por oris');
INSERT INTO `lang_definitions` VALUES (23760, 2183, 17, 'Por Reto');
INSERT INTO `lang_definitions` VALUES (23761, 2184, 17, 'por reto');
INSERT INTO `lang_definitions` VALUES (23762, 2185, 17, 'Direito perfurado:');
INSERT INTO `lang_definitions` VALUES (23763, 2186, 17, 'Execute Procura');
INSERT INTO `lang_definitions` VALUES (23764, 2187, 17, 'Execute esta ação');
INSERT INTO `lang_definitions` VALUES (23765, 2188, 17, 'Periférico');
INSERT INTO `lang_definitions` VALUES (23766, 2189, 17, 'Pessoa');
INSERT INTO `lang_definitions` VALUES (23767, 2190, 17, 'Farmácias');
INSERT INTO `lang_definitions` VALUES (23768, 2191, 17, 'Farmácia');
INSERT INTO `lang_definitions` VALUES (23769, 2192, 17, 'Dispensário de farmácia');
INSERT INTO `lang_definitions` VALUES (23770, 2193, 17, 'Pheumothorax');
INSERT INTO `lang_definitions` VALUES (23771, 2194, 17, 'Telefone');
INSERT INTO `lang_definitions` VALUES (23772, 2195, 17, 'Lista de telefonema');
INSERT INTO `lang_definitions` VALUES (23773, 2196, 17, 'Número de telefone');
INSERT INTO `lang_definitions` VALUES (23774, 2197, 17, 'Photophobia');
INSERT INTO `lang_definitions` VALUES (23775, 2198, 17, 'PHP comprimiu');
INSERT INTO `lang_definitions` VALUES (23776, 2199, 17, 'PHP extraiu');
INSERT INTO `lang_definitions` VALUES (23777, 2200, 17, 'controles de acesso de php-GACL são virados fora');
INSERT INTO `lang_definitions` VALUES (23778, 2201, 17, 'PHP-gacl não é instalado');
INSERT INTO `lang_definitions` VALUES (23779, 2202, 17, 'Exame físico');
INSERT INTO `lang_definitions` VALUES (23780, 2203, 17, 'Médico Request');
INSERT INTO `lang_definitions` VALUES (23781, 2204, 17, 'Médico Signature');
INSERT INTO `lang_definitions` VALUES (23782, 2205, 17, 'Médicos');
INSERT INTO `lang_definitions` VALUES (23783, 2206, 17, 'pico');
INSERT INTO `lang_definitions` VALUES (23784, 2207, 17, 'PID');
INSERT INTO `lang_definitions` VALUES (23785, 2208, 17, 'PID (Doença Inflamatória Pélvica)');
INSERT INTO `lang_definitions` VALUES (23786, 2209, 17, 'Tamanho de pílula');
INSERT INTO `lang_definitions` VALUES (23787, 2210, 17, 'Pílulas');
INSERT INTO `lang_definitions` VALUES (23788, 2211, 17, 'Placeholder');
INSERT INTO `lang_definitions` VALUES (23789, 2212, 17, 'Placeholder (Mantém ACLs vazio)');
INSERT INTO `lang_definitions` VALUES (23790, 2213, 17, 'Texto claro');
INSERT INTO `lang_definitions` VALUES (23791, 2214, 17, 'Plano');
INSERT INTO `lang_definitions` VALUES (23792, 2215, 17, 'Nome de plano');
INSERT INTO `lang_definitions` VALUES (23793, 2216, 17, 'Plano:');
INSERT INTO `lang_definitions` VALUES (23794, 2217, 17, 'Jogador');
INSERT INTO `lang_definitions` VALUES (23795, 2218, 17, 'Posição jogando');
INSERT INTO `lang_definitions` VALUES (23796, 2219, 17, 'Por favor escolha uma seleção válida da lista.');
INSERT INTO `lang_definitions` VALUES (23797, 2220, 17, 'Por favor escolha uma seleção válida.');
INSERT INTO `lang_definitions` VALUES (23798, 2221, 17, 'Por favor escolha um valor para');
INSERT INTO `lang_definitions` VALUES (23799, 2222, 17, 'Por favor feche esta janela.');
INSERT INTO `lang_definitions` VALUES (23800, 2223, 17, 'Por favor compare o nome novo');
INSERT INTO `lang_definitions` VALUES (23801, 2224, 17, 'Por favor não aceite esta prescrição a menos que fosse recebido por facimile.');
INSERT INTO `lang_definitions` VALUES (23802, 2225, 17, 'Por favor não use seus browsers param ou botão de recarga enquanto esta página está correndo que a menos que mais de 10 atas decorressem, isto não fará o processo parar no servidor e consumirá recursos de uneccesary.');
INSERT INTO `lang_definitions` VALUES (23803, 2226, 17, 'Por favor entre em uma quantia monetária que usa só números e um ponto decimal.');
INSERT INTO `lang_definitions` VALUES (23804, 2227, 17, 'Por favor entre em um título!');
INSERT INTO `lang_definitions` VALUES (23805, 2228, 17, 'Por favor note que isto pode levar um tempo muito longo, até várias atas, que seu browser de teia pode não se aparecer muito ativo durante este tempo mas gerando uma conta é um processo complicado e seu browser de teia somente está esperando por mais informação.');
INSERT INTO `lang_definitions` VALUES (23806, 2229, 17, 'Por favor Note: constantes são caso sensível e qualquer fio é permitido.');
INSERT INTO `lang_definitions` VALUES (23807, 2230, 17, 'Só agrade use caráter alfabéticos');
INSERT INTO `lang_definitions` VALUES (23808, 2231, 17, 'Só agrade use caráter alfabéticos sem espaços');
INSERT INTO `lang_definitions` VALUES (23809, 2232, 17, 'Por favor pague esta quantia');
INSERT INTO `lang_definitions` VALUES (23810, 2233, 17, 'Por favor selecione uma razão de ajuste para código');
INSERT INTO `lang_definitions` VALUES (23811, 2234, 17, 'Por favor selecione um evento');
INSERT INTO `lang_definitions` VALUES (23812, 2235, 17, 'Por favor selecione as páginas desejadas para copiar ou remeter:');
INSERT INTO `lang_definitions` VALUES (23813, 2236, 17, 'PM');
INSERT INTO `lang_definitions` VALUES (23814, 2237, 17, 'Método de Pmt');
INSERT INTO `lang_definitions` VALUES (23815, 2238, 17, 'PND');
INSERT INTO `lang_definitions` VALUES (23816, 2239, 17, 'Pneumococcal Conjugate 1');
INSERT INTO `lang_definitions` VALUES (23817, 2240, 17, 'Pneumococcal Conjugate 2');
INSERT INTO `lang_definitions` VALUES (23818, 2241, 17, 'Pneumococcal Conjugate 3');
INSERT INTO `lang_definitions` VALUES (23819, 2242, 17, 'Pneumococcal Conjugate 4');
INSERT INTO `lang_definitions` VALUES (23820, 2243, 17, 'Vacinação de pneumonia');
INSERT INTO `lang_definitions` VALUES (23821, 2244, 17, 'Ponto de Serviço (POS)');
INSERT INTO `lang_definitions` VALUES (23822, 2245, 17, 'Política');
INSERT INTO `lang_definitions` VALUES (23823, 2246, 17, 'Número de política');
INSERT INTO `lang_definitions` VALUES (23824, 2247, 17, 'Polydypsia');
INSERT INTO `lang_definitions` VALUES (23825, 2248, 17, 'Pólipos');
INSERT INTO `lang_definitions` VALUES (23826, 2249, 17, 'Polyuria');
INSERT INTO `lang_definitions` VALUES (23827, 2250, 17, 'Apetite pobre');
INSERT INTO `lang_definitions` VALUES (23828, 2251, 17, 'Circulação pobre');
INSERT INTO `lang_definitions` VALUES (23829, 2252, 17, 'Audição pobre');
INSERT INTO `lang_definitions` VALUES (23830, 2253, 17, 'Povoe a visão de ano com eventos?');
INSERT INTO `lang_definitions` VALUES (23831, 2254, 17, 'Popups');
INSERT INTO `lang_definitions` VALUES (23832, 2255, 17, 'Português (brasileiro)');
INSERT INTO `lang_definitions` VALUES (23833, 2256, 17, 'Português (europeu)');
INSERT INTO `lang_definitions` VALUES (23834, 2257, 17, 'POS Code');
INSERT INTO `lang_definitions` VALUES (23835, 2258, 17, 'Poste Goteira Nasal');
INSERT INTO `lang_definitions` VALUES (23836, 2259, 17, 'Poste cirúrgico');
INSERT INTO `lang_definitions` VALUES (23837, 2260, 17, 'Poste a contabilidade e marque como faturado');
INSERT INTO `lang_definitions` VALUES (23838, 2261, 17, 'Cuidado de poste-aborto');
INSERT INTO `lang_definitions` VALUES (23839, 2262, 17, 'Contracepção de poste-aborto');
INSERT INTO `lang_definitions` VALUES (23840, 2263, 17, 'Poste-aborto Aconselhando');
INSERT INTO `lang_definitions` VALUES (23841, 2264, 17, 'Poste-aborto Followup');
INSERT INTO `lang_definitions` VALUES (23842, 2265, 17, 'Postal');
INSERT INTO `lang_definitions` VALUES (23843, 2266, 17, 'Código postal');
INSERT INTO `lang_definitions` VALUES (23844, 2267, 17, 'Código postal');
INSERT INTO `lang_definitions` VALUES (23845, 2268, 17, 'PostCalendar');
INSERT INTO `lang_definitions` VALUES (23846, 2269, 17, 'Administração de PostCalendar');
INSERT INTO `lang_definitions` VALUES (23847, 2270, 17, 'PostCalendar Categoria Colocações');
INSERT INTO `lang_definitions` VALUES (23848, 2271, 17, 'PostCalendar Colocações Globais');
INSERT INTO `lang_definitions` VALUES (23849, 2272, 17, 'Postado em');
INSERT INTO `lang_definitions` VALUES (23850, 2273, 17, 'Data postando');
INSERT INTO `lang_definitions` VALUES (23851, 2275, 17, 'Prática');
INSERT INTO `lang_definitions` VALUES (23852, 2276, 17, 'Pratique Colocações');
INSERT INTO `lang_definitions` VALUES (23853, 2277, 17, 'Médico');
INSERT INTO `lang_definitions` VALUES (23854, 2278, 17, 'Consulta de Pre-aborto');
INSERT INTO `lang_definitions` VALUES (23855, 2279, 17, 'Pre-aborto Aconselhando');
INSERT INTO `lang_definitions` VALUES (23856, 2280, 17, 'Gato de Pref');
INSERT INTO `lang_definitions` VALUES (23857, 2281, 17, 'Categoria de Evento preferida');
INSERT INTO `lang_definitions` VALUES (23858, 2282, 17, 'Idioma preferido');
INSERT INTO `lang_definitions` VALUES (23859, 2283, 17, 'Farmácia preferida');
INSERT INTO `lang_definitions` VALUES (23860, 2284, 17, 'Provedor Organization preferida (PPO)');
INSERT INTO `lang_definitions` VALUES (23861, 2285, 17, 'Preg Test');
INSERT INTO `lang_definitions` VALUES (23862, 2286, 17, 'Pague');
INSERT INTO `lang_definitions` VALUES (23863, 2287, 17, 'Prescrição');
INSERT INTO `lang_definitions` VALUES (23864, 2288, 17, 'Rótulo de prescrição');
INSERT INTO `lang_definitions` VALUES (23865, 2289, 17, 'Prescrições');
INSERT INTO `lang_definitions` VALUES (23866, 2290, 17, 'Prescrições e Dispensações');
INSERT INTO `lang_definitions` VALUES (23867, 2291, 17, 'Prescrições e outras indicações');
INSERT INTO `lang_definitions` VALUES (23868, 2292, 17, 'Indicações de and/or de prescrições por especialista');
INSERT INTO `lang_definitions` VALUES (23869, 2293, 17, 'Prescrições Informam');
INSERT INTO `lang_definitions` VALUES (23870, 2294, 17, 'Prescriptions/Referrals');
INSERT INTO `lang_definitions` VALUES (23871, 2295, 17, 'Reclamação apresentando');
INSERT INTO `lang_definitions` VALUES (23872, 2296, 17, 'Imprensa Continua procedendo');
INSERT INTO `lang_definitions` VALUES (23873, 2297, 17, 'Diagnose presumida');
INSERT INTO `lang_definitions` VALUES (23874, 2298, 17, 'Diagnose presumida por especialista');
INSERT INTO `lang_definitions` VALUES (23875, 2299, 17, 'Prev');
INSERT INTO `lang_definitions` VALUES (23876, 2300, 17, 'Preveja Evento');
INSERT INTO `lang_definitions` VALUES (23877, 2301, 17, 'Previamente');
INSERT INTO `lang_definitions` VALUES (23878, 2302, 17, 'Consultas prévias');
INSERT INTO `lang_definitions` VALUES (23879, 2303, 17, 'Dia prévio');
INSERT INTO `lang_definitions` VALUES (23880, 2304, 17, 'History/Screening prévio');
INSERT INTO `lang_definitions` VALUES (23881, 2305, 17, 'Mês prévio');
INSERT INTO `lang_definitions` VALUES (23882, 2306, 17, 'Semana prévia');
INSERT INTO `lang_definitions` VALUES (23883, 2307, 17, 'Preço');
INSERT INTO `lang_definitions` VALUES (23884, 2308, 17, 'Preço Descontando');
INSERT INTO `lang_definitions` VALUES (23885, 2309, 17, 'Nível de preços');
INSERT INTO `lang_definitions` VALUES (23886, 2310, 17, 'Nível de preços:');
INSERT INTO `lang_definitions` VALUES (23887, 2311, 17, 'Preços');
INSERT INTO `lang_definitions` VALUES (23888, 2312, 17, 'Primário');
INSERT INTO `lang_definitions` VALUES (23889, 2313, 17, 'Ins primário');
INSERT INTO `lang_definitions` VALUES (23890, 2314, 17, 'Seguro primário');
INSERT INTO `lang_definitions` VALUES (23891, 2315, 17, 'Dados de Seguro primários');
INSERT INTO `lang_definitions` VALUES (23892, 2316, 17, 'Provedor de Seguro primário');
INSERT INTO `lang_definitions` VALUES (23893, 2317, 17, 'Provedor primário');
INSERT INTO `lang_definitions` VALUES (23894, 2318, 17, 'Impressão');
INSERT INTO `lang_definitions` VALUES (23895, 2322, 17, 'Imprima Forma de Indicação Em branco');
INSERT INTO `lang_definitions` VALUES (23896, 2323, 17, 'Imprima Formato');
INSERT INTO `lang_definitions` VALUES (23897, 2324, 17, 'Imprima Quatro Painel');
INSERT INTO `lang_definitions` VALUES (23898, 2325, 17, 'Imprima Múltiplo');
INSERT INTO `lang_definitions` VALUES (23899, 2326, 17, 'Imprima Múltiplo para Enviar fax');
INSERT INTO `lang_definitions` VALUES (23900, 2329, 17, 'Imprima Página 1');
INSERT INTO `lang_definitions` VALUES (23901, 2330, 17, 'Imprima Página 2');
INSERT INTO `lang_definitions` VALUES (23902, 2331, 17, 'Imprima Registro');
INSERT INTO `lang_definitions` VALUES (23903, 2332, 17, 'Imprima Registro Atirado');
INSERT INTO `lang_definitions` VALUES (23904, 2334, 17, 'Imprima esta nota');
INSERT INTO `lang_definitions` VALUES (23905, 2335, 17, 'Imprima Esta Nota');
INSERT INTO `lang_definitions` VALUES (23906, 2336, 17, 'Imprima para Enviar fax');
INSERT INTO `lang_definitions` VALUES (23907, 2337, 17, 'Imprima Visão');
INSERT INTO `lang_definitions` VALUES (23908, 2338, 17, 'imprimível');
INSERT INTO `lang_definitions` VALUES (23909, 2339, 17, 'Versão imprimível');
INSERT INTO `lang_definitions` VALUES (23910, 2340, 17, 'Impresso');
INSERT INTO `lang_definitions` VALUES (23911, 2341, 17, 'Resultados imprimindo:');
INSERT INTO `lang_definitions` VALUES (23912, 2342, 17, 'Imprimindo saltaram; veja teste produzido dentro');
INSERT INTO `lang_definitions` VALUES (23913, 2343, 17, 'Auth anterior');
INSERT INTO `lang_definitions` VALUES (23914, 2344, 17, 'Forma de Autorização anterior');
INSERT INTO `lang_definitions` VALUES (23915, 2345, 17, 'Prioridade');
INSERT INTO `lang_definitions` VALUES (23916, 2346, 17, 'Privado');
INSERT INTO `lang_definitions` VALUES (23917, 2347, 17, 'Problema');
INSERT INTO `lang_definitions` VALUES (23918, 2348, 17, 'Lista de problema');
INSERT INTO `lang_definitions` VALUES (23919, 2349, 17, 'Problems/Issues');
INSERT INTO `lang_definitions` VALUES (23920, 2350, 17, 'Procedimento');
INSERT INTO `lang_definitions` VALUES (23921, 2351, 17, 'Procedimentos');
INSERT INTO `lang_definitions` VALUES (23922, 2352, 17, 'Processo');
INSERT INTO `lang_definitions` VALUES (23923, 2353, 17, 'Processando');
INSERT INTO `lang_definitions` VALUES (23924, 2354, 17, 'Produtos');
INSERT INTO `lang_definitions` VALUES (23925, 2355, 17, 'Prof.');
INSERT INTO `lang_definitions` VALUES (23926, 2357, 17, 'Câncer prostático');
INSERT INTO `lang_definitions` VALUES (23927, 2358, 17, 'Exame prostático');
INSERT INTO `lang_definitions` VALUES (23928, 2359, 17, 'Problemas prostáticos');
INSERT INTO `lang_definitions` VALUES (23929, 2360, 17, 'Enlrgmt de w/o prostático, nódulos, oferta,');
INSERT INTO `lang_definitions` VALUES (23930, 2361, 17, 'Provedor');
INSERT INTO `lang_definitions` VALUES (23931, 2362, 17, 'Provedor Number');
INSERT INTO `lang_definitions` VALUES (23932, 2363, 17, 'Provedor:');
INSERT INTO `lang_definitions` VALUES (23933, 2364, 17, 'Provedores');
INSERT INTO `lang_definitions` VALUES (23934, 2365, 17, 'Provedores NPI');
INSERT INTO `lang_definitions` VALUES (23935, 2366, 17, 'Prv');
INSERT INTO `lang_definitions` VALUES (23936, 2367, 17, 'PSA');
INSERT INTO `lang_definitions` VALUES (23937, 2368, 17, 'Psoríase');
INSERT INTO `lang_definitions` VALUES (23938, 2369, 17, 'Intimide psicologicamente Diagnose');
INSERT INTO `lang_definitions` VALUES (23939, 2370, 17, 'Intimide psicologicamente Medicamento');
INSERT INTO `lang_definitions` VALUES (23940, 2371, 17, 'Psiquiátrico');
INSERT INTO `lang_definitions` VALUES (23941, 2372, 17, 'Carta Breve psiquiátrica');
INSERT INTO `lang_definitions` VALUES (23942, 2373, 17, 'Diagnose psiquiátrica');
INSERT INTO `lang_definitions` VALUES (23943, 2374, 17, 'Exame psiquiátrico');
INSERT INTO `lang_definitions` VALUES (23944, 2375, 17, 'História psiquiátrica');
INSERT INTO `lang_definitions` VALUES (23945, 2376, 17, 'Entrada psiquiátrica');
INSERT INTO `lang_definitions` VALUES (23946, 2377, 17, 'Medicamento psiquiátrico');
INSERT INTO `lang_definitions` VALUES (23947, 2378, 17, 'Pt%');
INSERT INTO `lang_definitions` VALUES (23948, 2379, 17, 'Pt Notes');
INSERT INTO `lang_definitions` VALUES (23949, 2380, 17, 'Pt Notes/Auth');
INSERT INTO `lang_definitions` VALUES (23950, 2381, 17, 'Overpaid de Pt');
INSERT INTO `lang_definitions` VALUES (23951, 2382, 17, 'Pt Paid');
INSERT INTO `lang_definitions` VALUES (23952, 2383, 17, 'Pt reembolsam');
INSERT INTO `lang_definitions` VALUES (23953, 2384, 17, 'Pt libertou');
INSERT INTO `lang_definitions` VALUES (23954, 2385, 17, 'Pt Report');
INSERT INTO `lang_definitions` VALUES (23955, 2386, 17, 'Estudante de PT, ou deixa espaço em branco');
INSERT INTO `lang_definitions` VALUES (23956, 2388, 17, 'PT_DOB');
INSERT INTO `lang_definitions` VALUES (23957, 2389, 17, 'PT_FNAME');
INSERT INTO `lang_definitions` VALUES (23958, 2390, 17, 'PT_LNAME');
INSERT INTO `lang_definitions` VALUES (23959, 2391, 17, 'PT_MNAME');
INSERT INTO `lang_definitions` VALUES (23960, 2395, 17, 'Público');
INSERT INTO `lang_definitions` VALUES (23961, 2396, 17, 'Pulmonar');
INSERT INTO `lang_definitions` VALUES (23962, 2397, 17, 'Pulso');
INSERT INTO `lang_definitions` VALUES (23963, 2398, 17, 'q.3h');
INSERT INTO `lang_definitions` VALUES (23964, 2399, 17, 'q.4h');
INSERT INTO `lang_definitions` VALUES (23965, 2400, 17, 'q.5h');
INSERT INTO `lang_definitions` VALUES (23966, 2401, 17, 'q.6h');
INSERT INTO `lang_definitions` VALUES (23967, 2402, 17, 'q.8h');
INSERT INTO `lang_definitions` VALUES (23968, 2403, 17, 'q.d.');
INSERT INTO `lang_definitions` VALUES (23969, 2404, 17, 'q.i.d.');
INSERT INTO `lang_definitions` VALUES (23970, 2405, 17, 'QOH');
INSERT INTO `lang_definitions` VALUES (23971, 2406, 17, 'Qty');
INSERT INTO `lang_definitions` VALUES (23972, 2407, 17, 'QTY');
INSERT INTO `lang_definitions` VALUES (23973, 2408, 17, 'Qualidade');
INSERT INTO `lang_definitions` VALUES (23974, 2409, 17, 'Quantidade');
INSERT INTO `lang_definitions` VALUES (23975, 2410, 17, 'Quantidade para NDC');
INSERT INTO `lang_definitions` VALUES (23976, 2411, 17, 'Quantidade Disponível');
INSERT INTO `lang_definitions` VALUES (23977, 2412, 17, 'Fila para processamento em lote de HCFA');
INSERT INTO `lang_definitions` VALUES (23978, 2413, 17, 'Fila para processamento em lote de HCFA e imprimindo');
INSERT INTO `lang_definitions` VALUES (23979, 2414, 17, 'Fila para processamento em lote de UB-92');
INSERT INTO `lang_definitions` VALUES (23980, 2415, 17, 'Fila para processamento em lote de UB-92 e imprimindo');
INSERT INTO `lang_definitions` VALUES (23981, 2416, 17, 'Feito fila');
INSERT INTO `lang_definitions` VALUES (23982, 2417, 17, 'Administração de Eventos feita fila');
INSERT INTO `lang_definitions` VALUES (23983, 2418, 17, 'Feito fila para');
INSERT INTO `lang_definitions` VALUES (23984, 2419, 17, 'Administração de Submissões feita fila');
INSERT INTO `lang_definitions` VALUES (23985, 2420, 17, 'R');
INSERT INTO `lang_definitions` VALUES (23986, 2421, 17, 'Raça');
INSERT INTO `lang_definitions` VALUES (23987, 2422, 17, 'Race/Ethnicity');
INSERT INTO `lang_definitions` VALUES (23988, 2423, 17, 'Rádio');
INSERT INTO `lang_definitions` VALUES (23989, 2424, 17, 'Botões de rádio');
INSERT INTO `lang_definitions` VALUES (23990, 2425, 17, 'Erupções cutâneas');
INSERT INTO `lang_definitions` VALUES (23991, 2426, 17, 'Taxa');
INSERT INTO `lang_definitions` VALUES (23992, 2427, 17, 'Re-aberto');
INSERT INTO `lang_definitions` VALUES (23993, 2428, 17, 'Re-aberto');
INSERT INTO `lang_definitions` VALUES (23994, 2429, 17, 'Reações');
INSERT INTO `lang_definitions` VALUES (23995, 2430, 17, 'Real Nome');
INSERT INTO `lang_definitions` VALUES (23996, 2431, 17, 'Razão');
INSERT INTO `lang_definitions` VALUES (23997, 2432, 17, 'Razão para indicação');
INSERT INTO `lang_definitions` VALUES (23998, 2433, 17, 'Argumente para Visita');
INSERT INTO `lang_definitions` VALUES (23999, 2434, 17, 'Reason/Form');
INSERT INTO `lang_definitions` VALUES (24000, 2435, 17, 'Recibo');
INSERT INTO `lang_definitions` VALUES (24001, 2436, 17, 'Recibo para Pagamento');
INSERT INTO `lang_definitions` VALUES (24002, 2437, 17, 'Recibo Gerou');
INSERT INTO `lang_definitions` VALUES (24003, 2438, 17, 'Recibos através de Relatório de Método de Pagamento');
INSERT INTO `lang_definitions` VALUES (24004, 2439, 17, 'Resumo de recibos');
INSERT INTO `lang_definitions` VALUES (24005, 2440, 17, 'Recebido');
INSERT INTO `lang_definitions` VALUES (24006, 2441, 17, 'Recebido Por');
INSERT INTO `lang_definitions` VALUES (24007, 2442, 17, 'Fac-símiles recebidos');
INSERT INTO `lang_definitions` VALUES (24008, 2443, 17, 'Receptor');
INSERT INTO `lang_definitions` VALUES (24009, 2444, 17, 'Administrador ID');
INSERT INTO `lang_definitions` VALUES (24010, 2447, 17, 'Recomendações');
INSERT INTO `lang_definitions` VALUES (24011, 2448, 17, 'Recomendações e tratamento');
INSERT INTO `lang_definitions` VALUES (24012, 2449, 17, 'Recomendações por especialista');
INSERT INTO `lang_definitions` VALUES (24013, 2450, 17, 'Registre Pagamento');
INSERT INTO `lang_definitions` VALUES (24014, 2451, 17, 'registros acharam.');
INSERT INTO `lang_definitions` VALUES (24015, 2452, 17, 'Retal');
INSERT INTO `lang_definitions` VALUES (24016, 2453, 17, 'Exame retal');
INSERT INTO `lang_definitions` VALUES (24017, 2454, 17, 'rectally');
INSERT INTO `lang_definitions` VALUES (24018, 2455, 17, 'Vermelhidão');
INSERT INTO `lang_definitions` VALUES (24019, 2456, 17, 'reduzido:');
INSERT INTO `lang_definitions` VALUES (24020, 2457, 17, 'Se refira');
INSERT INTO `lang_definitions` VALUES (24021, 2458, 17, 'Se refira Por');
INSERT INTO `lang_definitions` VALUES (24022, 2459, 17, 'Se refira Data');
INSERT INTO `lang_definitions` VALUES (24023, 2460, 17, 'Se refira');
INSERT INTO `lang_definitions` VALUES (24024, 2461, 17, 'Classificação de referência (nível de risco)');
INSERT INTO `lang_definitions` VALUES (24025, 2462, 17, 'Razão de referência');
INSERT INTO `lang_definitions` VALUES (24026, 2463, 17, 'Nome de Referer e assinatura');
INSERT INTO `lang_definitions` VALUES (24027, 2464, 17, 'Indicação');
INSERT INTO `lang_definitions` VALUES (24028, 2465, 17, 'Indicação Por');
INSERT INTO `lang_definitions` VALUES (24029, 2466, 17, 'Cartão de indicação');
INSERT INTO `lang_definitions` VALUES (24030, 2467, 17, 'Data de indicação');
INSERT INTO `lang_definitions` VALUES (24031, 2468, 17, 'Forma de indicação');
INSERT INTO `lang_definitions` VALUES (24032, 2469, 17, 'FORMA DE INDICAÇÃO');
INSERT INTO `lang_definitions` VALUES (24033, 2470, 17, 'Fonte de indicação');
INSERT INTO `lang_definitions` VALUES (24034, 2471, 17, 'Indicação Para');
INSERT INTO `lang_definitions` VALUES (24035, 2472, 17, 'Indicações');
INSERT INTO `lang_definitions` VALUES (24036, 2473, 17, 'Indicações Informam');
INSERT INTO `lang_definitions` VALUES (24037, 2474, 17, 'Se referido por');
INSERT INTO `lang_definitions` VALUES (24038, 2475, 17, 'Se referido Por');
INSERT INTO `lang_definitions` VALUES (24039, 2476, 17, 'Se referido');
INSERT INTO `lang_definitions` VALUES (24040, 2477, 17, 'Referrer');
INSERT INTO `lang_definitions` VALUES (24041, 2478, 17, 'Diagnose de Referrer');
INSERT INTO `lang_definitions` VALUES (24042, 2479, 17, 'Diagnose de Referrer');
INSERT INTO `lang_definitions` VALUES (24043, 2480, 17, 'O médico se referindo e prática');
INSERT INTO `lang_definitions` VALUES (24044, 2481, 17, 'Provedor se referindo');
INSERT INTO `lang_definitions` VALUES (24045, 2482, 17, 'Refis');
INSERT INTO `lang_definitions` VALUES (24046, 2483, 17, 'refis');
INSERT INTO `lang_definitions` VALUES (24047, 2484, 17, 'Normal de reflexos');
INSERT INTO `lang_definitions` VALUES (24048, 2485, 17, 'Refresque');
INSERT INTO `lang_definitions` VALUES (24049, 2486, 17, 'reg_re');
INSERT INTO `lang_definitions` VALUES (24050, 2487, 17, 'registro');
INSERT INTO `lang_definitions` VALUES (24051, 2488, 17, 'Registrado');
INSERT INTO `lang_definitions` VALUES (24052, 2489, 17, 'registrado');
INSERT INTO `lang_definitions` VALUES (24053, 2490, 17, 'Data de inscrição');
INSERT INTO `lang_definitions` VALUES (24054, 2491, 17, 'Forma de inscrição');
INSERT INTO `lang_definitions` VALUES (24055, 2492, 17, 'Reabilitação');
INSERT INTO `lang_definitions` VALUES (24056, 2493, 17, 'Relacione');
INSERT INTO `lang_definitions` VALUES (24057, 2494, 17, 'Relacionado');
INSERT INTO `lang_definitions` VALUES (24058, 2495, 17, 'Relation(s) / as Crianças');
INSERT INTO `lang_definitions` VALUES (24059, 2496, 17, 'Relação');
INSERT INTO `lang_definitions` VALUES (24060, 2497, 17, 'Parentes');
INSERT INTO `lang_definitions` VALUES (24061, 2498, 17, 'Retransmita credenciais de Saúde estão perdendo desta conta do usuário.');
INSERT INTO `lang_definitions` VALUES (24062, 2499, 17, 'Retransmita ID para Saúde');
INSERT INTO `lang_definitions` VALUES (24063, 2500, 17, 'Religião');
INSERT INTO `lang_definitions` VALUES (24064, 2501, 17, 'Relogin');
INSERT INTO `lang_definitions` VALUES (24065, 2502, 17, 'Remova');
INSERT INTO `lang_definitions` VALUES (24066, 2503, 17, 'Remova Grupo');
INSERT INTO `lang_definitions` VALUES (24067, 2504, 17, 'Remova Forma de Grupo');
INSERT INTO `lang_definitions` VALUES (24068, 2505, 17, 'Pedras renais');
INSERT INTO `lang_definitions` VALUES (24069, 2506, 17, 'Renomeie Grupo');
INSERT INTO `lang_definitions` VALUES (24070, 2507, 17, 'Fazendo');
INSERT INTO `lang_definitions` VALUES (24071, 2508, 17, 'Provedor fazendo');
INSERT INTO `lang_definitions` VALUES (24072, 2509, 17, 'Provedor Number fazendo');
INSERT INTO `lang_definitions` VALUES (24073, 2510, 17, 'Reordene A');
INSERT INTO `lang_definitions` VALUES (24074, 2511, 17, 'Info repetindo:');
INSERT INTO `lang_definitions` VALUES (24075, 2512, 17, 'Repetições');
INSERT INTO `lang_definitions` VALUES (24076, 2513, 17, 'Data de resposta');
INSERT INTO `lang_definitions` VALUES (24077, 2514, 17, 'Responda De');
INSERT INTO `lang_definitions` VALUES (24078, 2515, 17, 'Relatório');
INSERT INTO `lang_definitions` VALUES (24079, 2516, 17, 'Informe por');
INSERT INTO `lang_definitions` VALUES (24080, 2517, 17, 'Totais de relatório');
INSERT INTO `lang_definitions` VALUES (24081, 2518, 17, 'Relatórios');
INSERT INTO `lang_definitions` VALUES (24082, 2519, 17, 'Pedido ignorou - processo de reivindicações já é corrente!');
INSERT INTO `lang_definitions` VALUES (24083, 2520, 17, 'Serviço pedido');
INSERT INTO `lang_definitions` VALUES (24084, 2521, 17, 'Requerido');
INSERT INTO `lang_definitions` VALUES (24085, 2522, 17, 'RESERVADO');
INSERT INTO `lang_definitions` VALUES (24086, 2523, 17, 'Reservado');
INSERT INTO `lang_definitions` VALUES (24087, 2524, 17, 'Reservado para uso para definir Tempo de Férias Marcado');
INSERT INTO `lang_definitions` VALUES (24088, 2525, 17, 'Reservou para definir quando um provedor pode não ter compromissos disponíveis depois.');
INSERT INTO `lang_definitions` VALUES (24089, 2526, 17, 'Reservou para definir quando um evento não aconteceu como especificado.');
INSERT INTO `lang_definitions` VALUES (24090, 2527, 17, 'Todefine reservado quando um provedor pode compromissos de haveavailable depois.');
INSERT INTO `lang_definitions` VALUES (24091, 2528, 17, 'Solucionado');
INSERT INTO `lang_definitions` VALUES (24092, 2529, 17, 'Respiração');
INSERT INTO `lang_definitions` VALUES (24093, 2530, 17, 'Unlabored de esforço de respirador');
INSERT INTO `lang_definitions` VALUES (24094, 2531, 17, 'Respiratório');
INSERT INTO `lang_definitions` VALUES (24095, 2532, 17, 'Treinamento restringido');
INSERT INTO `lang_definitions` VALUES (24096, 2533, 17, 'Resultado');
INSERT INTO `lang_definitions` VALUES (24097, 2534, 17, 'Resultados Acharam Para Procura');
INSERT INTO `lang_definitions` VALUES (24098, 2535, 17, 'Exame de Retinal');
INSERT INTO `lang_definitions` VALUES (24099, 2536, 17, 'Direito retratado:');
INSERT INTO `lang_definitions` VALUES (24100, 2537, 17, 'Retorno');
INSERT INTO `lang_definitions` VALUES (24101, 2538, 17, 'Volte a calendário');
INSERT INTO `lang_definitions` VALUES (24102, 2539, 17, 'Valor de retorno');
INSERT INTO `lang_definitions` VALUES (24103, 2540, 17, 'Visita de retorno');
INSERT INTO `lang_definitions` VALUES (24104, 2541, 17, 'Devolvido para Jogar');
INSERT INTO `lang_definitions` VALUES (24105, 2542, 17, 'Revisão de PMH:');
INSERT INTO `lang_definitions` VALUES (24106, 2543, 17, 'Revisão De Sistemas');
INSERT INTO `lang_definitions` VALUES (24107, 2544, 17, 'Revisão de Cheques de Sistemas');
INSERT INTO `lang_definitions` VALUES (24108, 2545, 17, 'Revisão');
INSERT INTO `lang_definitions` VALUES (24109, 2546, 17, 'Artrite de Rheumotoid');
INSERT INTO `lang_definitions` VALUES (24110, 2547, 17, 'Direito');
INSERT INTO `lang_definitions` VALUES (24111, 2548, 17, 'Orelha certa');
INSERT INTO `lang_definitions` VALUES (24112, 2549, 17, 'orelha certa');
INSERT INTO `lang_definitions` VALUES (24113, 2550, 17, 'Direito:');
INSERT INTO `lang_definitions` VALUES (24114, 2551, 17, 'Tocando em Orelhas');
INSERT INTO `lang_definitions` VALUES (24115, 2552, 17, 'Tocando Em Orelhas');
INSERT INTO `lang_definitions` VALUES (24116, 2553, 17, 'Fatores de risco');
INSERT INTO `lang_definitions` VALUES (24117, 2554, 17, 'Nível de risco');
INSERT INTO `lang_definitions` VALUES (24118, 2555, 17, 'RLL:');
INSERT INTO `lang_definitions` VALUES (24119, 2556, 17, 'ROM');
INSERT INTO `lang_definitions` VALUES (24120, 2557, 17, 'Lista');
INSERT INTO `lang_definitions` VALUES (24121, 2558, 17, 'Rota');
INSERT INTO `lang_definitions` VALUES (24122, 2559, 17, 'Filas');
INSERT INTO `lang_definitions` VALUES (24123, 2560, 17, 'RRR sem MOR');
INSERT INTO `lang_definitions` VALUES (24124, 2561, 17, 'Esfrega:');
INSERT INTO `lang_definitions` VALUES (24125, 2562, 17, 'Esfregas:');
INSERT INTO `lang_definitions` VALUES (24126, 2563, 17, 'Comando corrente:');
INSERT INTO `lang_definitions` VALUES (24127, 2564, 17, 'Ruptura');
INSERT INTO `lang_definitions` VALUES (24128, 2565, 17, 'Russo');
INSERT INTO `lang_definitions` VALUES (24129, 2566, 17, 'Rx');
INSERT INTO `lang_definitions` VALUES (24130, 2567, 17, 'RX');
INSERT INTO `lang_definitions` VALUES (24131, 2568, 17, 'S');
INSERT INTO `lang_definitions` VALUES (24132, 2569, 17, 'S.S.');
INSERT INTO `lang_definitions` VALUES (24133, 2570, 17, 'S3:');
INSERT INTO `lang_definitions` VALUES (24134, 2571, 17, 'S4:');
INSERT INTO `lang_definitions` VALUES (24135, 2572, 17, 'SÁ * * por favor ler a licença lida o docs/license.txt ou visita * http://www.gnu.org/copyleft/gpl.html * * / / / == == == == == == == == == == == == == == == == == == == == == == == == == == == == == == == == == == == == = / /');
INSERT INTO `lang_definitions` VALUES (24136, 2573, 17, 'Sales');
INSERT INTO `lang_definitions` VALUES (24137, 2574, 17, 'Sales através de Artigo');
INSERT INTO `lang_definitions` VALUES (24138, 2575, 17, 'Sales através de Relatório de Produto');
INSERT INTO `lang_definitions` VALUES (24139, 2576, 17, 'Mesmo Dia');
INSERT INTO `lang_definitions` VALUES (24140, 2577, 17, 'Amostra');
INSERT INTO `lang_definitions` VALUES (24141, 2578, 17, 'Sancione Tipo');
INSERT INTO `lang_definitions` VALUES (24142, 2579, 17, 'Sábado');
INSERT INTO `lang_definitions` VALUES (24143, 2580, 17, 'Sábado & ampère; Sol');
INSERT INTO `lang_definitions` VALUES (24144, 2581, 17, 'Sábado');
INSERT INTO `lang_definitions` VALUES (24145, 2582, 17, 'Economize');
INSERT INTO `lang_definitions` VALUES (24146, 2583, 17, 'Economize e Dispense');
INSERT INTO `lang_definitions` VALUES (24147, 2584, 17, 'Economize como Novo');
INSERT INTO `lang_definitions` VALUES (24148, 2585, 17, 'Exceto Mudanças');
INSERT INTO `lang_definitions` VALUES (24149, 2586, 17, 'Exceto Forma');
INSERT INTO `lang_definitions` VALUES (24150, 2587, 17, 'Economize Imunização');
INSERT INTO `lang_definitions` VALUES (24151, 2588, 17, 'Economize Campo Novo');
INSERT INTO `lang_definitions` VALUES (24152, 2589, 17, 'Economize Grupo Novo');
INSERT INTO `lang_definitions` VALUES (24153, 2590, 17, 'Economize Lista Nova');
INSERT INTO `lang_definitions` VALUES (24154, 2591, 17, 'Economize modelo novo');
INSERT INTO `lang_definitions` VALUES (24155, 2592, 17, 'Exceto Demographics Paciente');
INSERT INTO `lang_definitions` VALUES (24156, 2593, 17, 'Economize Próspero para quadro ID');
INSERT INTO `lang_definitions` VALUES (24157, 2594, 17, 'Economize Transação');
INSERT INTO `lang_definitions` VALUES (24158, 2595, 17, 'Esquadrinhado');
INSERT INTO `lang_definitions` VALUES (24159, 2596, 17, 'Nota de Encontro esquadrinhada');
INSERT INTO `lang_definitions` VALUES (24160, 2597, 17, 'Escâner Em');
INSERT INTO `lang_definitions` VALUES (24161, 2598, 17, 'Horário');
INSERT INTO `lang_definitions` VALUES (24162, 2599, 17, 'Programe Instalações:');
INSERT INTO `lang_definitions` VALUES (24163, 2600, 17, 'NOTA ESCOLAR');
INSERT INTO `lang_definitions` VALUES (24164, 2601, 17, 'Escoliose');
INSERT INTO `lang_definitions` VALUES (24165, 2602, 17, 'SE');
INSERT INTO `lang_definitions` VALUES (24166, 2603, 17, 'SE Address');
INSERT INTO `lang_definitions` VALUES (24167, 2604, 17, 'Cidade de SE');
INSERT INTO `lang_definitions` VALUES (24168, 2605, 17, 'País de SE');
INSERT INTO `lang_definitions` VALUES (24169, 2606, 17, 'Localidade de SE');
INSERT INTO `lang_definitions` VALUES (24170, 2607, 17, 'SE Código Postal');
INSERT INTO `lang_definitions` VALUES (24171, 2608, 17, 'SE State');
INSERT INTO `lang_definitions` VALUES (24172, 2609, 17, 'Cep de SE');
INSERT INTO `lang_definitions` VALUES (24173, 2610, 17, 'Procura');
INSERT INTO `lang_definitions` VALUES (24174, 2611, 17, 'procura');
INSERT INTO `lang_definitions` VALUES (24175, 2612, 17, 'procure novamente');
INSERT INTO `lang_definitions` VALUES (24176, 2613, 17, 'Procure por:');
INSERT INTO `lang_definitions` VALUES (24177, 2614, 17, 'Procure:');
INSERT INTO `lang_definitions` VALUES (24178, 2615, 17, 'Procura ou Soma o Paciente');
INSERT INTO `lang_definitions` VALUES (24179, 2616, 17, 'Resultados de procura:');
INSERT INTO `lang_definitions` VALUES (24180, 2618, 17, 'Procure os Eventos');
INSERT INTO `lang_definitions` VALUES (24181, 2619, 17, 'Segurador de Search/Add');
INSERT INTO `lang_definitions` VALUES (24182, 2620, 17, 'Procurando compromissos');
INSERT INTO `lang_definitions` VALUES (24183, 2621, 17, 'Procurando...');
INSERT INTO `lang_definitions` VALUES (24184, 2622, 17, 'Uso de cinto de segurança');
INSERT INTO `lang_definitions` VALUES (24185, 2623, 17, 'Uso de cinto de segurança');
INSERT INTO `lang_definitions` VALUES (24186, 2624, 17, 'Segundo');
INSERT INTO `lang_definitions` VALUES (24187, 2625, 17, 'Secundário');
INSERT INTO `lang_definitions` VALUES (24188, 2626, 17, 'Seguro secundário');
INSERT INTO `lang_definitions` VALUES (24189, 2627, 17, 'Dados de Seguro secundários');
INSERT INTO `lang_definitions` VALUES (24190, 2628, 17, 'Provedor de Seguro secundário');
INSERT INTO `lang_definitions` VALUES (24191, 2629, 17, 'Veja Tudo');
INSERT INTO `lang_definitions` VALUES (24192, 2630, 17, 'Veja Autorizações');
INSERT INTO `lang_definitions` VALUES (24193, 2631, 17, 'Veja Crescimento-quadro');
INSERT INTO `lang_definitions` VALUES (24194, 2632, 17, 'Veja mensagens do último fixado de reivindicações geradas');
INSERT INTO `lang_definitions` VALUES (24195, 2633, 17, 'Visto desde então');
INSERT INTO `lang_definitions` VALUES (24196, 2634, 17, 'Ataques apopléticos');
INSERT INTO `lang_definitions` VALUES (24197, 2635, 17, 'Sel');
INSERT INTO `lang_definitions` VALUES (24198, 2636, 17, 'Selecione');
INSERT INTO `lang_definitions` VALUES (24199, 2637, 17, 'Selecione Tudo');
INSERT INTO `lang_definitions` VALUES (24200, 2639, 17, 'Campo seleto');
INSERT INTO `lang_definitions` VALUES (24201, 2640, 17, 'Fields seleto');
INSERT INTO `lang_definitions` VALUES (24202, 2641, 17, 'Selecione por imprimir');
INSERT INTO `lang_definitions` VALUES (24203, 2642, 17, 'Assunto seleto');
INSERT INTO `lang_definitions` VALUES (24204, 2643, 17, 'Selecione os artigos de configuração para exportar');
INSERT INTO `lang_definitions` VALUES (24205, 2644, 17, 'Selecione Sim para confirmar apagamento de grupo');
INSERT INTO `lang_definitions` VALUES (24206, 2645, 17, 'Ego');
INSERT INTO `lang_definitions` VALUES (24207, 2646, 17, 'Pagamento de ego');
INSERT INTO `lang_definitions` VALUES (24208, 2647, 17, 'Envie em desenvolvimento');
INSERT INTO `lang_definitions` VALUES (24209, 2649, 17, 'Remetente');
INSERT INTO `lang_definitions` VALUES (24210, 2650, 17, 'Remetente ID');
INSERT INTO `lang_definitions` VALUES (24211, 2653, 17, 'Sensibilidades');
INSERT INTO `lang_definitions` VALUES (24212, 2654, 17, 'Sensibilidade:');
INSERT INTO `lang_definitions` VALUES (24213, 2655, 17, 'Normal de exame sensório');
INSERT INTO `lang_definitions` VALUES (24214, 2656, 17, 'Enviado prosperamente');
INSERT INTO `lang_definitions` VALUES (24215, 2657, 17, 'enviado a impressora.');
INSERT INTO `lang_definitions` VALUES (24216, 2658, 17, 'Separado');
INSERT INTO `lang_definitions` VALUES (24217, 2659, 17, 'Setembro');
INSERT INTO `lang_definitions` VALUES (24218, 2660, 17, 'Conserte Categoria');
INSERT INTO `lang_definitions` VALUES (24219, 2661, 17, 'Data de serviço');
INSERT INTO `lang_definitions` VALUES (24220, 2662, 17, 'Data de serviço:');
INSERT INTO `lang_definitions` VALUES (24221, 2663, 17, 'Conserte Local');
INSERT INTO `lang_definitions` VALUES (24222, 2664, 17, 'Serviço provido por especialista');
INSERT INTO `lang_definitions` VALUES (24223, 2665, 17, 'Serviços');
INSERT INTO `lang_definitions` VALUES (24224, 2666, 17, 'Serviços através de Categoria');
INSERT INTO `lang_definitions` VALUES (24225, 2667, 17, 'Serviços proveram');
INSERT INTO `lang_definitions` VALUES (24226, 2668, 17, 'Serviços Proveram');
INSERT INTO `lang_definitions` VALUES (24227, 2669, 17, 'Colocações');
INSERT INTO `lang_definitions` VALUES (24228, 2670, 17, 'Enxaqueca severa');
INSERT INTO `lang_definitions` VALUES (24229, 2671, 17, 'Severidade de Dor');
INSERT INTO `lang_definitions` VALUES (24230, 2672, 17, 'Severidade de Dor:');
INSERT INTO `lang_definitions` VALUES (24231, 2673, 17, 'Sexo');
INSERT INTO `lang_definitions` VALUES (24232, 2674, 17, 'Doença sexualmente Transmitida');
INSERT INTO `lang_definitions` VALUES (24233, 2675, 17, 'Compartilhando');
INSERT INTO `lang_definitions` VALUES (24234, 2676, 17, 'Brevidade de Respiração');
INSERT INTO `lang_definitions` VALUES (24235, 2677, 17, 'Brevidade De Respiração');
INSERT INTO `lang_definitions` VALUES (24236, 2678, 17, 'Brevidade De Respiração 2');
INSERT INTO `lang_definitions` VALUES (24237, 2679, 17, 'Registro de tiro');
INSERT INTO `lang_definitions` VALUES (24238, 2680, 17, 'Registro de tiro a partir de:');
INSERT INTO `lang_definitions` VALUES (24239, 2681, 17, 'deveria estar como nnnnn-nnnn-nn');
INSERT INTO `lang_definitions` VALUES (24240, 2682, 17, 'Ombro');
INSERT INTO `lang_definitions` VALUES (24241, 2683, 17, 'Ombro + clavícula');
INSERT INTO `lang_definitions` VALUES (24242, 2684, 17, 'Assuma Problemas');
INSERT INTO `lang_definitions` VALUES (24243, 2685, 17, 'Espetáculo');
INSERT INTO `lang_definitions` VALUES (24244, 2686, 17, 'Mostre como Ocupado');
INSERT INTO `lang_definitions` VALUES (24245, 2687, 17, 'Espetáculo Só Autorizou');
INSERT INTO `lang_definitions` VALUES (24246, 2688, 17, 'Detalhes de espetáculo');
INSERT INTO `lang_definitions` VALUES (24247, 2689, 17, 'Espetáculo que paira texto de evento mouseover aceso?');
INSERT INTO `lang_definitions` VALUES (24248, 2690, 17, 'Espetáculo quantos eventos páginas de admin acesas?');
INSERT INTO `lang_definitions` VALUES (24249, 2692, 17, 'Relatório de espetáculo');
INSERT INTO `lang_definitions` VALUES (24250, 2693, 17, 'Ligações de search/submit de espetáculo em bloco?');
INSERT INTO `lang_definitions` VALUES (24251, 2694, 17, 'Mostre Unbilled Only');
INSERT INTO `lang_definitions` VALUES (24252, 2695, 17, 'Irmãos');
INSERT INTO `lang_definitions` VALUES (24253, 2696, 17, 'Cela de foicinho');
INSERT INTO `lang_definitions` VALUES (24254, 2697, 17, 'Sig');
INSERT INTO `lang_definitions` VALUES (24255, 2698, 17, 'Sigmoid/Colonoscopy');
INSERT INTO `lang_definitions` VALUES (24256, 2699, 17, 'Assinatura');
INSERT INTO `lang_definitions` VALUES (24257, 2700, 17, 'Assinatura:');
INSERT INTO `lang_definitions` VALUES (24258, 2702, 17, 'Inchação significante:');
INSERT INTO `lang_definitions` VALUES (24259, 2703, 17, 'Desde então');
INSERT INTO `lang_definitions` VALUES (24260, 2705, 17, 'Único');
INSERT INTO `lang_definitions` VALUES (24261, 2706, 17, 'Problemas de seio');
INSERT INTO `lang_definitions` VALUES (24262, 2707, 17, 'Cirurgia de seio');
INSERT INTO `lang_definitions` VALUES (24263, 2708, 17, 'TERNURA DE SEIO:');
INSERT INTO `lang_definitions` VALUES (24264, 2709, 17, 'Sinusite');
INSERT INTO `lang_definitions` VALUES (24265, 2710, 17, 'Tamanho');
INSERT INTO `lang_definitions` VALUES (24266, 2711, 17, 'Tamanho deve ser um número entre 1 e 999');
INSERT INTO `lang_definitions` VALUES (24267, 2712, 17, 'Size/List');
INSERT INTO `lang_definitions` VALUES (24268, 2713, 17, 'Pele');
INSERT INTO `lang_definitions` VALUES (24269, 2714, 17, 'Esfole Câncer');
INSERT INTO `lang_definitions` VALUES (24270, 2715, 17, 'Doença de pele');
INSERT INTO `lang_definitions` VALUES (24271, 2716, 17, 'Pele Outro');
INSERT INTO `lang_definitions` VALUES (24272, 2718, 17, 'Durma padrões');
INSERT INTO `lang_definitions` VALUES (24273, 2719, 17, 'Durma Padrões');
INSERT INTO `lang_definitions` VALUES (24274, 2720, 17, 'Dormindo');
INSERT INTO `lang_definitions` VALUES (24275, 2721, 17, 'Eslovaco');
INSERT INTO `lang_definitions` VALUES (24276, 2722, 17, 'Sm dívida w/o');
INSERT INTO `lang_definitions` VALUES (24277, 2723, 17, 'Esconderijo de Smarty foi clareado');
INSERT INTO `lang_definitions` VALUES (24278, 2724, 17, 'Portal de SMS');
INSERT INTO `lang_definitions` VALUES (24279, 2725, 17, 'Portal de SMS chave de API');
INSERT INTO `lang_definitions` VALUES (24280, 2726, 17, 'Notificação de SMS');
INSERT INTO `lang_definitions` VALUES (24281, 2727, 17, 'SMS enviam antes');
INSERT INTO `lang_definitions` VALUES (24282, 2728, 17, 'Texto de SMS, Etiqueta Utilizável,: * * * NOME * * *, * * * o PROVEDOR * * *, * * * DATA * * *, * * * STARTTIME * * *, * * * ENDTIME***<br> i.e. Querido * * * NOME * * *');
INSERT INTO `lang_definitions` VALUES (24283, 2729, 17, 'SMS/Email Alert Colocações');
INSERT INTO `lang_definitions` VALUES (24284, 2730, 17, 'Roncando');
INSERT INTO `lang_definitions` VALUES (24285, 2731, 17, 'SABÃO');
INSERT INTO `lang_definitions` VALUES (24286, 2732, 17, 'Dificuldades sociais');
INSERT INTO `lang_definitions` VALUES (24287, 2733, 17, 'História social:');
INSERT INTO `lang_definitions` VALUES (24288, 2734, 17, 'Número de previdência social');
INSERT INTO `lang_definitions` VALUES (24289, 2735, 17, 'solução');
INSERT INTO `lang_definitions` VALUES (24290, 2736, 17, 'Contexto somático');
INSERT INTO `lang_definitions` VALUES (24291, 2737, 17, 'Algumas autorizações não foram exibidas. Faça tique-taque aqui para ver tudo');
INSERT INTO `lang_definitions` VALUES (24292, 2738, 17, 'Alguns códigos não foram exibidos.');
INSERT INTO `lang_definitions` VALUES (24293, 2739, 17, 'Alguns encontros não foram exibidos. Faça tique-taque aqui para ver tudo.');
INSERT INTO `lang_definitions` VALUES (24294, 2740, 17, 'Algumas notas não foram exibidas.');
INSERT INTO `lang_definitions` VALUES (24295, 2741, 17, 'algumas palavras');
INSERT INTO `lang_definitions` VALUES (24296, 2742, 17, 'Dor de garganta');
INSERT INTO `lang_definitions` VALUES (24297, 2743, 17, 'Ordene por');
INSERT INTO `lang_definitions` VALUES (24298, 2744, 17, 'Ordene através de Comentários');
INSERT INTO `lang_definitions` VALUES (24299, 2745, 17, 'Ordene através de data');
INSERT INTO `lang_definitions` VALUES (24300, 2746, 17, 'Ordene através de date/time');
INSERT INTO `lang_definitions` VALUES (24301, 2747, 17, 'Ordene através de Evento');
INSERT INTO `lang_definitions` VALUES (24302, 2748, 17, 'Ordene através de Grupo');
INSERT INTO `lang_definitions` VALUES (24303, 2749, 17, 'Ordene por Usuário');
INSERT INTO `lang_definitions` VALUES (24304, 2750, 17, 'Ordene através de vacina');
INSERT INTO `lang_definitions` VALUES (24305, 2751, 17, 'Fonte');
INSERT INTO `lang_definitions` VALUES (24306, 2752, 17, 'Fonte está perdendo para código');
INSERT INTO `lang_definitions` VALUES (24307, 2753, 17, 'Fonte:');
INSERT INTO `lang_definitions` VALUES (24308, 2754, 17, 'Espanhol');
INSERT INTO `lang_definitions` VALUES (24309, 2755, 17, 'Nome especialista e assinatura');
INSERT INTO `lang_definitions` VALUES (24310, 2756, 17, 'Especialidade');
INSERT INTO `lang_definitions` VALUES (24311, 2757, 17, 'Sistemas de especialidade');
INSERT INTO `lang_definitions` VALUES (24312, 2758, 17, 'Especialidade:');
INSERT INTO `lang_definitions` VALUES (24313, 2759, 17, 'Específico');
INSERT INTO `lang_definitions` VALUES (24314, 2760, 17, 'Serviço específico');
INSERT INTO `lang_definitions` VALUES (24315, 2761, 17, 'Ditado de fala');
INSERT INTO `lang_definitions` VALUES (24316, 2762, 17, 'Espermicidas');
INSERT INTO `lang_definitions` VALUES (24317, 2763, 17, 'Splenectomy');
INSERT INTO `lang_definitions` VALUES (24318, 2764, 17, 'Cônjuge');
INSERT INTO `lang_definitions` VALUES (24319, 2765, 17, 'Cuspe');
INSERT INTO `lang_definitions` VALUES (24320, 2766, 17, 'Cuspe:');
INSERT INTO `lang_definitions` VALUES (24321, 2767, 17, 'SQ');
INSERT INTO `lang_definitions` VALUES (24322, 2768, 17, 'Esquadra');
INSERT INTO `lang_definitions` VALUES (24323, 2769, 17, 'Sociedade de esquadra');
INSERT INTO `lang_definitions` VALUES (24324, 2770, 17, 'Esquadras');
INSERT INTO `lang_definitions` VALUES (24325, 2771, 17, 'SRH');
INSERT INTO `lang_definitions` VALUES (24326, 2772, 17, 'SRH - Controle de natalidade');
INSERT INTO `lang_definitions` VALUES (24327, 2773, 17, 'SRH Non Controle de natalidade');
INSERT INTO `lang_definitions` VALUES (24328, 2774, 17, 'Indicações de SRH');
INSERT INTO `lang_definitions` VALUES (24329, 2775, 17, 'SRH Visit Forma');
INSERT INTO `lang_definitions` VALUES (24330, 2776, 17, 'SS');
INSERT INTO `lang_definitions` VALUES (24331, 2777, 17, 'SSN');
INSERT INTO `lang_definitions` VALUES (24332, 2778, 17, 'Estabilidade');
INSERT INTO `lang_definitions` VALUES (24333, 2779, 17, 'Padrão');
INSERT INTO `lang_definitions` VALUES (24334, 2780, 17, 'Começo');
INSERT INTO `lang_definitions` VALUES (24335, 2781, 17, 'Começo (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (24336, 2782, 17, 'Data de começo');
INSERT INTO `lang_definitions` VALUES (24337, 2783, 17, 'Data de começo em Esta Clínica');
INSERT INTO `lang_definitions` VALUES (24338, 2784, 17, 'Data de começo:');
INSERT INTO `lang_definitions` VALUES (24339, 2785, 17, 'Data de começo:');
INSERT INTO `lang_definitions` VALUES (24340, 2786, 17, 'Tempo de começo');
INSERT INTO `lang_definitions` VALUES (24341, 2787, 17, 'Data começando');
INSERT INTO `lang_definitions` VALUES (24342, 2788, 17, 'stat');
INSERT INTO `lang_definitions` VALUES (24343, 2789, 17, 'Estado');
INSERT INTO `lang_definitions` VALUES (24344, 2790, 17, 'Lista estatal (write,addonly opcional)');
INSERT INTO `lang_definitions` VALUES (24345, 2791, 17, 'State/Locality');
INSERT INTO `lang_definitions` VALUES (24346, 2792, 17, 'State/Parish');
INSERT INTO `lang_definitions` VALUES (24347, 2793, 17, 'Estatísticas');
INSERT INTO `lang_definitions` VALUES (24348, 2794, 17, 'Stats');
INSERT INTO `lang_definitions` VALUES (24349, 2795, 17, 'Estado');
INSERT INTO `lang_definitions` VALUES (24350, 2796, 17, 'Status quo');
INSERT INTO `lang_definitions` VALUES (24351, 2797, 17, 'STD/AIDS Couns');
INSERT INTO `lang_definitions` VALUES (24352, 2798, 17, 'Stength e Condicionando');
INSERT INTO `lang_definitions` VALUES (24353, 2799, 17, 'Juntas duras');
INSERT INTO `lang_definitions` VALUES (24354, 2800, 17, 'Dureza');
INSERT INTO `lang_definitions` VALUES (24355, 2801, 17, 'Dores de estômago');
INSERT INTO `lang_definitions` VALUES (24356, 2802, 17, 'Puxe de músculo');
INSERT INTO `lang_definitions` VALUES (24357, 2803, 17, 'Fluxo');
INSERT INTO `lang_definitions` VALUES (24358, 2804, 17, 'Rua');
INSERT INTO `lang_definitions` VALUES (24359, 2806, 17, 'Rua e Número');
INSERT INTO `lang_definitions` VALUES (24360, 2807, 17, 'Força');
INSERT INTO `lang_definitions` VALUES (24361, 2808, 17, 'Garganta de Strep');
INSERT INTO `lang_definitions` VALUES (24362, 2809, 17, 'Fratura de tensão');
INSERT INTO `lang_definitions` VALUES (24363, 2810, 17, 'Teste de tensão');
INSERT INTO `lang_definitions` VALUES (24364, 2811, 17, 'Golpe');
INSERT INTO `lang_definitions` VALUES (24365, 2812, 17, 'Substituto-categoria');
INSERT INTO `lang_definitions` VALUES (24366, 2813, 17, 'Substituto-total');
INSERT INTO `lang_definitions` VALUES (24367, 2814, 17, 'Subcategory');
INSERT INTO `lang_definitions` VALUES (24368, 2815, 17, 'subcategory');
INSERT INTO `lang_definitions` VALUES (24369, 2816, 17, 'subcutaneously');
INSERT INTO `lang_definitions` VALUES (24370, 2817, 17, 'Subjetivo');
INSERT INTO `lang_definitions` VALUES (24371, 2818, 17, 'Sublingual');
INSERT INTO `lang_definitions` VALUES (24372, 2819, 17, 'sublingual');
INSERT INTO `lang_definitions` VALUES (24373, 2820, 17, 'Submeta');
INSERT INTO `lang_definitions` VALUES (24374, 2822, 17, 'Submeta Evento');
INSERT INTO `lang_definitions` VALUES (24375, 2823, 17, 'submeta forma');
INSERT INTO `lang_definitions` VALUES (24376, 2826, 17, 'Submetido por');
INSERT INTO `lang_definitions` VALUES (24377, 2828, 17, 'Subscritor');
INSERT INTO `lang_definitions` VALUES (24378, 2829, 17, 'Endereço de subscritor');
INSERT INTO `lang_definitions` VALUES (24379, 2830, 17, 'Empregador de subscritor');
INSERT INTO `lang_definitions` VALUES (24380, 2831, 17, 'Empregador de subscritor (SE)');
INSERT INTO `lang_definitions` VALUES (24381, 2832, 17, 'Subscritor Empregador Address');
INSERT INTO `lang_definitions` VALUES (24382, 2833, 17, 'Subscritor Empregador City');
INSERT INTO `lang_definitions` VALUES (24383, 2834, 17, 'Subscritor Empregador Country');
INSERT INTO `lang_definitions` VALUES (24384, 2835, 17, 'Subscritor Empregador State');
INSERT INTO `lang_definitions` VALUES (24385, 2836, 17, 'Subscritor Empregador Cep');
INSERT INTO `lang_definitions` VALUES (24386, 2837, 17, 'Telefone de subscritor');
INSERT INTO `lang_definitions` VALUES (24387, 2838, 17, 'Relação de subscritor');
INSERT INTO `lang_definitions` VALUES (24388, 2839, 17, 'Relação de subscritor não é ego mas nome é o mesmo! Este realmente é o OK?');
INSERT INTO `lang_definitions` VALUES (24389, 2840, 17, 'Relação de subscritor não é ego mas número de SS é o mesmo!');
INSERT INTO `lang_definitions` VALUES (24390, 2841, 17, 'Relação de subscritor é ego mas nome é diferente! Este realmente é o OK?');
INSERT INTO `lang_definitions` VALUES (24391, 2842, 17, 'Relação de subscritor é ego mas número de SS é diferente!');
INSERT INTO `lang_definitions` VALUES (24392, 2843, 17, 'Sexo de subscritor');
INSERT INTO `lang_definitions` VALUES (24393, 2844, 17, 'Substituição');
INSERT INTO `lang_definitions` VALUES (24394, 2845, 17, 'substituição permitiu');
INSERT INTO `lang_definitions` VALUES (24395, 2846, 17, 'sucesso');
INSERT INTO `lang_definitions` VALUES (24396, 2847, 17, 'prosperamente acrescentado a categoria,');
INSERT INTO `lang_definitions` VALUES (24397, 2848, 17, 'prosperamente armazenado.');
INSERT INTO `lang_definitions` VALUES (24398, 2849, 17, 'prosperamente.');
INSERT INTO `lang_definitions` VALUES (24399, 2850, 17, 'Suicídio');
INSERT INTO `lang_definitions` VALUES (24400, 2851, 17, 'Resumo');
INSERT INTO `lang_definitions` VALUES (24401, 2852, 17, 'Sol');
INSERT INTO `lang_definitions` VALUES (24402, 2853, 17, 'Domingo');
INSERT INTO `lang_definitions` VALUES (24403, 2854, 17, 'Superbill');
INSERT INTO `lang_definitions` VALUES (24404, 2855, 17, 'Superbill Codes');
INSERT INTO `lang_definitions` VALUES (24405, 2856, 17, 'Superbill Codes Administração');
INSERT INTO `lang_definitions` VALUES (24406, 2857, 17, 'Superbill Report');
INSERT INTO `lang_definitions` VALUES (24407, 2858, 17, 'Superbills, às vezes chamado Formas de Encontro ou Deslizes Derrotando, são uma parte essencial da maioria das práticas médicas.');
INSERT INTO `lang_definitions` VALUES (24408, 2859, 17, 'Superusuário');
INSERT INTO `lang_definitions` VALUES (24409, 2860, 17, 'Supervisionando');
INSERT INTO `lang_definitions` VALUES (24410, 2861, 17, 'Tipo de superfície');
INSERT INTO `lang_definitions` VALUES (24411, 2862, 17, 'Cirurgias');
INSERT INTO `lang_definitions` VALUES (24412, 2863, 17, 'Cirurgia');
INSERT INTO `lang_definitions` VALUES (24413, 2864, 17, 'Suspenso');
INSERT INTO `lang_definitions` VALUES (24414, 2865, 17, 'suspensão');
INSERT INTO `lang_definitions` VALUES (24415, 2866, 17, 'Svc Date');
INSERT INTO `lang_definitions` VALUES (24416, 2867, 17, 'Svc Date:');
INSERT INTO `lang_definitions` VALUES (24417, 2868, 17, 'Suando:');
INSERT INTO `lang_definitions` VALUES (24418, 2869, 17, 'Sueco');
INSERT INTO `lang_definitions` VALUES (24419, 2870, 17, 'Inchando');
INSERT INTO `lang_definitions` VALUES (24420, 2871, 17, 'Direito inchando');
INSERT INTO `lang_definitions` VALUES (24421, 2872, 17, 'Juntas inchadas');
INSERT INTO `lang_definitions` VALUES (24422, 2873, 17, 'Linfonodos inchados');
INSERT INTO `lang_definitions` VALUES (24423, 2874, 17, 'Sintomas');
INSERT INTO `lang_definitions` VALUES (24424, 2875, 17, 'Síncope');
INSERT INTO `lang_definitions` VALUES (24425, 2876, 17, 'Synovitis, intrusão, bursite,');
INSERT INTO `lang_definitions` VALUES (24426, 2877, 17, 'Sistema');
INSERT INTO `lang_definitions` VALUES (24427, 2878, 17, 'T');
INSERT INTO `lang_definitions` VALUES (24428, 2879, 17, 't.i.d.');
INSERT INTO `lang_definitions` VALUES (24429, 2880, 17, 'T.V.');
INSERT INTO `lang_definitions` VALUES (24430, 2881, 17, 'Criação de mesa falhou');
INSERT INTO `lang_definitions` VALUES (24431, 2882, 17, 'Atualização de mesa falhou');
INSERT INTO `lang_definitions` VALUES (24432, 2883, 17, 'tablete');
INSERT INTO `lang_definitions` VALUES (24433, 2884, 17, 'Objeto pegado');
INSERT INTO `lang_definitions` VALUES (24434, 2885, 17, 'Objetos pegados muito tempo');
INSERT INTO `lang_definitions` VALUES (24435, 2886, 17, 'Taxa de imposição');
INSERT INTO `lang_definitions` VALUES (24436, 2887, 17, 'Impostos');
INSERT INTO `lang_definitions` VALUES (24437, 2888, 17, 'Taxonomia');
INSERT INTO `lang_definitions` VALUES (24438, 2889, 17, 'Td');
INSERT INTO `lang_definitions` VALUES (24439, 2890, 17, 'Emparelhe Avaliação de Dano');
INSERT INTO `lang_definitions` VALUES (24440, 2891, 17, 'Emparelhe Lista');
INSERT INTO `lang_definitions` VALUES (24441, 2892, 17, 'Emparelhe Visão de Lista');
INSERT INTO `lang_definitions` VALUES (24442, 2893, 17, 'Tel');
INSERT INTO `lang_definitions` VALUES (24443, 2895, 17, 'Local temporário');
INSERT INTO `lang_definitions` VALUES (24444, 2896, 17, 'Método temporário');
INSERT INTO `lang_definitions` VALUES (24445, 2897, 17, 'Temperatura');
INSERT INTO `lang_definitions` VALUES (24446, 2898, 17, 'Modelo');
INSERT INTO `lang_definitions` VALUES (24447, 2899, 17, 'Nome de modelo');
INSERT INTO `lang_definitions` VALUES (24448, 2900, 17, 'Nomes de modelo não podem começar com números.');
INSERT INTO `lang_definitions` VALUES (24449, 2901, 17, 'Modelo:');
INSERT INTO `lang_definitions` VALUES (24450, 2902, 17, 'Modelos');
INSERT INTO `lang_definitions` VALUES (24451, 2903, 17, 'Artéria temporal');
INSERT INTO `lang_definitions` VALUES (24452, 2904, 17, 'Dano de tendão');
INSERT INTO `lang_definitions` VALUES (24453, 2905, 17, 'Tendinite / osis / bursite');
INSERT INTO `lang_definitions` VALUES (24454, 2906, 17, 'Terciário');
INSERT INTO `lang_definitions` VALUES (24455, 2907, 17, 'Seguro terciário');
INSERT INTO `lang_definitions` VALUES (24456, 2908, 17, 'Dados de Seguro terciários');
INSERT INTO `lang_definitions` VALUES (24457, 2909, 17, 'Provedor de Seguro terciário');
INSERT INTO `lang_definitions` VALUES (24458, 2910, 17, 'Programação de teste');
INSERT INTO `lang_definitions` VALUES (24459, 2911, 17, 'Sistema de teste');
INSERT INTO `lang_definitions` VALUES (24460, 2912, 17, 'Texto-data');
INSERT INTO `lang_definitions` VALUES (24461, 2913, 17, 'texto-data');
INSERT INTO `lang_definitions` VALUES (24462, 2914, 17, 'Textarea');
INSERT INTO `lang_definitions` VALUES (24463, 2915, 17, 'textarea');
INSERT INTO `lang_definitions` VALUES (24464, 2916, 17, 'Textbox');
INSERT INTO `lang_definitions` VALUES (24465, 2917, 17, 'textbox');
INSERT INTO `lang_definitions` VALUES (24466, 2918, 17, 'Textbox listam');
INSERT INTO `lang_definitions` VALUES (24467, 2919, 17, 'textbox listam');
INSERT INTO `lang_definitions` VALUES (24468, 2920, 17, 'Obrigado');
INSERT INTO `lang_definitions` VALUES (24469, 2921, 17, 'O arquivo de reivindicação:');
INSERT INTO `lang_definitions` VALUES (24470, 2922, 17, 'A forma de destino estava fechada; Eu não posso agir em sua seleção.');
INSERT INTO `lang_definitions` VALUES (24471, 2923, 17, 'O event(s) foi aprovado.');
INSERT INTO `lang_definitions` VALUES (24472, 2924, 17, 'O event(s) foi escondido.');
INSERT INTO `lang_definitions` VALUES (24473, 2925, 17, 'O dados exportado se aparece na área de texto abaixo. Você pode copiar e pode colar isto em um e-mail ou para qualquer outro destino desejado.');
INSERT INTO `lang_definitions` VALUES (24474, 2926, 17, 'O evento de calendário seguinte foi somado:');
INSERT INTO `lang_definitions` VALUES (24475, 2927, 17, 'O evento de calendário seguinte foi modifed:');
INSERT INTO `lang_definitions` VALUES (24476, 2928, 17, 'Os erros seguintes aconteceram');
INSERT INTO `lang_definitions` VALUES (24477, 2929, 17, 'A janela inicial é a página de procura de fatura. Ao topo você pode entrar em uma fonte (por exemplo confira número), pague data e confira quantia. A razão para a fonte e data de pagamento está de forma que você dom \'t têm que entrar neles inúmeras vezes para cada reivindicação. A quantia na que você entra será diminuída para cada fatura que é determinada parte do pagamento, e esperançosamente terminará a zero quando você for terminado.');
INSERT INTO `lang_definitions` VALUES (24478, 2930, 17, 'O rótulo que se aparece ao usuário na forma');
INSERT INTO `lang_definitions` VALUES (24479, 2931, 17, 'A categoria nova será uma substituto-categoria de');
INSERT INTO `lang_definitions` VALUES (24480, 2932, 17, 'A informação restante debaixo de só aplica se você está postando manualmente, ou se você está fazendo correções manuais.');
INSERT INTO `lang_definitions` VALUES (24481, 2933, 17, 'O documento pedido não está presente no local esperado no filesystem ou não há permissões suficientes para acessar isto.');
INSERT INTO `lang_definitions` VALUES (24482, 2934, 17, 'São copiadas a Fonte e colunas de Data da primeira página, tão normalmente você não precisará tocar esses. Você pode pôr uma quantia de pagamento na coluna de Pagamento, uma quantia de ajuste no Ajuste coluna, ou ambos. Você também pode clicar à direita o \"W\" para computar um valor de ajuste que escreve fora o resto do custo para aquele artigo de linha automaticamente.');
INSERT INTO `lang_definitions` VALUES (24483, 2935, 17, 'O rótulo traduzido que se aparecerá na forma em idioma atual');
INSERT INTO `lang_definitions` VALUES (24484, 2936, 17, 'O Título traduzido que se aparecerá em idioma atual');
INSERT INTO `lang_definitions` VALUES (24485, 2937, 17, 'A tradução de descrição em idioma atual');
INSERT INTO `lang_definitions` VALUES (24486, 2938, 17, 'O X12 arquiva como também a HTML resultante produziu são arquivados relatórios no subdiretório de \"era\" do OpenEMR instalação diretório principal. Você quererá recorrer de vez em quando a estes arquivos. A URL é');
INSERT INTO `lang_definitions` VALUES (24487, 2939, 17, 'Injeções terapêuticas');
INSERT INTO `lang_definitions` VALUES (24488, 2940, 17, 'Há');
INSERT INTO `lang_definitions` VALUES (24489, 2941, 17, 'Há erros com sua submissão. Estes são esboçados abaixo.');
INSERT INTO `lang_definitions` VALUES (24490, 2942, 17, 'Não há nenhuma Submissão Nova');
INSERT INTO `lang_definitions` VALUES (24491, 2943, 17, 'Houve um erro de correio que envia');
INSERT INTO `lang_definitions` VALUES (24492, 2947, 17, 'Não há nenhuma entrada de COA para conta de AR');
INSERT INTO `lang_definitions` VALUES (24493, 2948, 17, 'Não há nenhuma entrada de COA para conta de caixa');
INSERT INTO `lang_definitions` VALUES (24494, 2949, 17, 'Não há nenhuma entrada de COA para conta de renda');
INSERT INTO `lang_definitions` VALUES (24495, 2950, 17, 'Não há nenhuma partida para id de fatura');
INSERT INTO `lang_definitions` VALUES (24496, 2951, 17, 'Não há nenhuma partida para id de fatura =');
INSERT INTO `lang_definitions` VALUES (24497, 2952, 17, 'Não há nenhuma entrada de partes para serviços ID');
INSERT INTO `lang_definitions` VALUES (24498, 2953, 17, 'Havia um erro enquanto processando seu pedido.');
INSERT INTO `lang_definitions` VALUES (24499, 2954, 17, 'Direito engrossado:');
INSERT INTO `lang_definitions` VALUES (24500, 2955, 17, 'Coxa');
INSERT INTO `lang_definitions` VALUES (24501, 2956, 17, 'Coxa + paralise');
INSERT INTO `lang_definitions` VALUES (24502, 2957, 17, 'Coisas que atrás escritório pode ler e pode entrar mas não pode modificar');
INSERT INTO `lang_definitions` VALUES (24503, 2958, 17, 'Coisas que atrás escritório pode ler e pode modificar');
INSERT INTO `lang_definitions` VALUES (24504, 2959, 17, 'Coisas que os clínicos podem ler e podem entrar mas não podem modificar');
INSERT INTO `lang_definitions` VALUES (24505, 2960, 17, 'Coisas que os clínicos podem ler e podem modificar');
INSERT INTO `lang_definitions` VALUES (24506, 2961, 17, 'Coisas que escritório dianteiro pode ler e pode entrar mas não pode modificar');
INSERT INTO `lang_definitions` VALUES (24507, 2962, 17, 'Coisas que escritório dianteiro pode ler e pode modificar');
INSERT INTO `lang_definitions` VALUES (24508, 2963, 17, 'Coisas que os médicos podem ler e podem entrar mas não podem modificar');
INSERT INTO `lang_definitions` VALUES (24509, 2964, 17, 'Coisas que os médicos podem ler e podem modificar');
INSERT INTO `lang_definitions` VALUES (24510, 2965, 17, 'Terço');
INSERT INTO `lang_definitions` VALUES (24511, 2966, 17, 'Esta ação não pode ser desfeita.');
INSERT INTO `lang_definitions` VALUES (24512, 2967, 17, 'Esta ação não pode ser desfeita.');
INSERT INTO `lang_definitions` VALUES (24513, 2968, 17, 'Este tipo de código não aceita relações.');
INSERT INTO `lang_definitions` VALUES (24514, 2969, 17, 'Este Encontro');
INSERT INTO `lang_definitions` VALUES (24515, 2971, 17, 'Este número de fatura foi mudado');
INSERT INTO `lang_definitions` VALUES (24516, 2972, 17, 'Este módulo está em modo de teste. O banco de dados não será mudado.');
INSERT INTO `lang_definitions` VALUES (24517, 2973, 17, 'Este módulo promove entrada eficiente de dados de EOB.');
INSERT INTO `lang_definitions` VALUES (24518, 2974, 17, 'Esta página vai inline incluem a página de login, de forma que nós não têm clicar relogin toda vez.');
INSERT INTO `lang_definitions` VALUES (24519, 2975, 17, 'Este paciente não tem nenhuma atividade.');
INSERT INTO `lang_definitions` VALUES (24520, 2976, 17, 'Este ID paciente já é em uso!');
INSERT INTO `lang_definitions` VALUES (24521, 2977, 17, 'Este usuário não é um sócio de qualquer grupo');
INSERT INTO `lang_definitions` VALUES (24522, 2978, 17, 'Esta visita começa uso anticoncepcional novo');
INSERT INTO `lang_definitions` VALUES (24523, 2979, 17, 'Isto criará um auxílio em formato de piche e então envia isto a seu browser de teia assim você pode salvar isto');
INSERT INTO `lang_definitions` VALUES (24524, 2980, 17, 'Espinha torácica');
INSERT INTO `lang_definitions` VALUES (24525, 2981, 17, 'Garganta');
INSERT INTO `lang_definitions` VALUES (24526, 2982, 17, 'Câncer de garganta');
INSERT INTO `lang_definitions` VALUES (24527, 2983, 17, 'Cirurgia de Câncer de garganta');
INSERT INTO `lang_definitions` VALUES (24528, 2984, 17, 'Thrombosis/Stroke');
INSERT INTO `lang_definitions` VALUES (24529, 2985, 17, 'Thu');
INSERT INTO `lang_definitions` VALUES (24530, 2986, 17, 'Thurdsay');
INSERT INTO `lang_definitions` VALUES (24531, 2987, 17, 'Quinta-feira');
INSERT INTO `lang_definitions` VALUES (24532, 2988, 17, 'Normal tiróide');
INSERT INTO `lang_definitions` VALUES (24533, 2989, 17, 'Problemas tiróides');
INSERT INTO `lang_definitions` VALUES (24534, 2990, 17, 'TIA');
INSERT INTO `lang_definitions` VALUES (24535, 2991, 17, 'Tempo');
INSERT INTO `lang_definitions` VALUES (24536, 2992, 17, 'Incremento de tempo para Some (atas 1-60)');
INSERT INTO `lang_definitions` VALUES (24537, 2993, 17, 'Evento cronometrado');
INSERT INTO `lang_definitions` VALUES (24538, 2994, 17, 'Tempos formam (N/A)');
INSERT INTO `lang_definitions` VALUES (24539, 2995, 17, 'Timestamp e Texto');
INSERT INTO `lang_definitions` VALUES (24540, 2996, 17, 'LATA');
INSERT INTO `lang_definitions` VALUES (24541, 2997, 17, 'Tinido');
INSERT INTO `lang_definitions` VALUES (24542, 2998, 17, 'Título');
INSERT INTO `lang_definitions` VALUES (24543, 2999, 17, 'Título V');
INSERT INTO `lang_definitions` VALUES (24544, 3000, 17, 'TitleCols deve ser um número entre 1 e 999');
INSERT INTO `lang_definitions` VALUES (24545, 3001, 17, 'Títulos');
INSERT INTO `lang_definitions` VALUES (24546, 3002, 17, 'TM \'S:');
INSERT INTO `lang_definitions` VALUES (24547, 3003, 17, 'TMs/EAMs/EE, nariz de ext,');
INSERT INTO `lang_definitions` VALUES (24548, 3004, 17, 'Para');
INSERT INTO `lang_definitions` VALUES (24549, 3005, 17, 'PARA');
INSERT INTO `lang_definitions` VALUES (24550, 3006, 17, 'para');
INSERT INTO `lang_definitions` VALUES (24551, 3007, 17, 'Para Área Afetada');
INSERT INTO `lang_definitions` VALUES (24552, 3008, 17, 'para área afetada');
INSERT INTO `lang_definitions` VALUES (24553, 3009, 17, 'Para Faturar Visão');
INSERT INTO `lang_definitions` VALUES (24554, 3010, 17, 'para categoria');
INSERT INTO `lang_definitions` VALUES (24555, 3011, 17, 'Para Visão Clínica');
INSERT INTO `lang_definitions` VALUES (24556, 3012, 17, 'Para copay');
INSERT INTO `lang_definitions` VALUES (24557, 3013, 17, 'Para ded\'ble');
INSERT INTO `lang_definitions` VALUES (24558, 3014, 17, 'Para Dems');
INSERT INTO `lang_definitions` VALUES (24559, 3015, 17, 'Para Enctr');
INSERT INTO `lang_definitions` VALUES (24560, 3016, 17, 'Filtrar através de sexo');
INSERT INTO `lang_definitions` VALUES (24561, 3017, 17, 'Para História');
INSERT INTO `lang_definitions` VALUES (24562, 3018, 17, 'Para Assuntos');
INSERT INTO `lang_definitions` VALUES (24563, 3019, 17, 'Unir este encounter/consult a um assunto existente, clique o assunto desejado acima realçar isto e então clicar [Economize]. Sujeite [Ctrl] botão para selecionar assuntos múltiplos.');
INSERT INTO `lang_definitions` VALUES (24564, 3020, 17, 'para login novamente');
INSERT INTO `lang_definitions` VALUES (24565, 3021, 17, 'Esfolar');
INSERT INTO `lang_definitions` VALUES (24566, 3022, 17, 'esfolar');
INSERT INTO `lang_definitions` VALUES (24567, 3023, 17, 'para esta visita?');
INSERT INTO `lang_definitions` VALUES (24568, 3024, 17, 'Para:');
INSERT INTO `lang_definitions` VALUES (24569, 3025, 17, 'Para:');
INSERT INTO `lang_definitions` VALUES (24570, 3026, 17, 'TO_CITY');
INSERT INTO `lang_definitions` VALUES (24571, 3027, 17, 'TO_FAX');
INSERT INTO `lang_definitions` VALUES (24572, 3028, 17, 'TO_FNAME');
INSERT INTO `lang_definitions` VALUES (24573, 3029, 17, 'TO_LNAME');
INSERT INTO `lang_definitions` VALUES (24574, 3030, 17, 'TO_MNAME');
INSERT INTO `lang_definitions` VALUES (24575, 3031, 17, 'TO_ORGANIZATION');
INSERT INTO `lang_definitions` VALUES (24576, 3032, 17, 'TO_POSTAL');
INSERT INTO `lang_definitions` VALUES (24577, 3033, 17, 'TO_STATE');
INSERT INTO `lang_definitions` VALUES (24578, 3034, 17, 'TO_STREET');
INSERT INTO `lang_definitions` VALUES (24579, 3035, 17, 'TO_TITLE');
INSERT INTO `lang_definitions` VALUES (24580, 3036, 17, 'TO_VALEDICTORY');
INSERT INTO `lang_definitions` VALUES (24581, 3037, 17, 'Tabaco');
INSERT INTO `lang_definitions` VALUES (24582, 3038, 17, 'Uso de tabaco');
INSERT INTO `lang_definitions` VALUES (24583, 3039, 17, 'Hoje');
INSERT INTO `lang_definitions` VALUES (24584, 3040, 17, 'Hoje \'Data de s');
INSERT INTO `lang_definitions` VALUES (24585, 3041, 17, 'Hoje \'Eventos de s');
INSERT INTO `lang_definitions` VALUES (24586, 3042, 17, 'Tonsillectomy');
INSERT INTO `lang_definitions` VALUES (24587, 3043, 17, 'Topo');
INSERT INTO `lang_definitions` VALUES (24588, 3044, 17, 'Tópico');
INSERT INTO `lang_definitions` VALUES (24589, 3045, 17, 'total');
INSERT INTO `lang_definitions` VALUES (24590, 3046, 17, 'Total');
INSERT INTO `lang_definitions` VALUES (24591, 3047, 17, 'Total Pagou');
INSERT INTO `lang_definitions` VALUES (24592, 3048, 17, 'Custos de total');
INSERT INTO `lang_definitions` VALUES (24593, 3049, 17, 'Clientes totais');
INSERT INTO `lang_definitions` VALUES (24594, 3050, 17, 'Some para');
INSERT INTO `lang_definitions` VALUES (24595, 3051, 17, 'Some para');
INSERT INTO `lang_definitions` VALUES (24596, 3052, 17, 'Total para categoria');
INSERT INTO `lang_definitions` VALUES (24597, 3053, 17, 'Número total de Pacientes');
INSERT INTO `lang_definitions` VALUES (24598, 3054, 17, 'SRH & Family Planning total');
INSERT INTO `lang_definitions` VALUES (24599, 3055, 17, 'Totais');
INSERT INTO `lang_definitions` VALUES (24600, 3056, 17, 'Totais para');
INSERT INTO `lang_definitions` VALUES (24601, 3057, 17, 'Totais para');
INSERT INTO `lang_definitions` VALUES (24602, 3058, 17, 'Tipo treinando');
INSERT INTO `lang_definitions` VALUES (24603, 3059, 17, 'Negocie');
INSERT INTO `lang_definitions` VALUES (24604, 3060, 17, 'transação');
INSERT INTO `lang_definitions` VALUES (24605, 3061, 17, 'Transação');
INSERT INTO `lang_definitions` VALUES (24606, 3062, 17, 'Tipo de transação');
INSERT INTO `lang_definitions` VALUES (24607, 3063, 17, 'Transações');
INSERT INTO `lang_definitions` VALUES (24608, 3064, 17, 'Transações (escreva opcional)');
INSERT INTO `lang_definitions` VALUES (24609, 3065, 17, 'Transactions/Referrals');
INSERT INTO `lang_definitions` VALUES (24610, 3066, 17, 'traduza isto');
INSERT INTO `lang_definitions` VALUES (24611, 3067, 17, 'Tradução');
INSERT INTO `lang_definitions` VALUES (24612, 3068, 17, 'Traduções');
INSERT INTO `lang_definitions` VALUES (24613, 3069, 17, 'Trauma');
INSERT INTO `lang_definitions` VALUES (24614, 3070, 17, 'Metas de tratamento');
INSERT INTO `lang_definitions` VALUES (24615, 3071, 17, 'Plano de tratamento');
INSERT INTO `lang_definitions` VALUES (24616, 3072, 17, 'Tratamento:');
INSERT INTO `lang_definitions` VALUES (24617, 3073, 17, 'Tratamento:');
INSERT INTO `lang_definitions` VALUES (24618, 3074, 17, 'trftime($month_format, mktime(0, 0, 0, $i, 1, 2000))); $month_value');
INSERT INTO `lang_definitions` VALUES (24619, 3075, 17, 'Ponto de gatilho / síndrome de compartimento / DOMS / câimbra');
INSERT INTO `lang_definitions` VALUES (24620, 3076, 17, 'Trimalleolar');
INSERT INTO `lang_definitions` VALUES (24621, 3077, 17, 'tring [, \'r\' [,');
INSERT INTO `lang_definitions` VALUES (24622, 3078, 17, 'Tronco e abdômen');
INSERT INTO `lang_definitions` VALUES (24623, 3079, 17, 'tsp');
INSERT INTO `lang_definitions` VALUES (24624, 3080, 17, 'TTS');
INSERT INTO `lang_definitions` VALUES (24625, 3081, 17, 'Tuberculose');
INSERT INTO `lang_definitions` VALUES (24626, 3082, 17, 'Tue');
INSERT INTO `lang_definitions` VALUES (24627, 3083, 17, 'Tues & ampère; Thur');
INSERT INTO `lang_definitions` VALUES (24628, 3084, 17, 'Terça-feira');
INSERT INTO `lang_definitions` VALUES (24629, 3085, 17, 'Tumor');
INSERT INTO `lang_definitions` VALUES (24630, 3086, 17, 'duas vezes diariamente');
INSERT INTO `lang_definitions` VALUES (24631, 3087, 17, 'Membrana timpânica');
INSERT INTO `lang_definitions` VALUES (24632, 3088, 17, 'Tipo');
INSERT INTO `lang_definitions` VALUES (24633, 3089, 17, 'Tipo ou esquadrinha o identificador paciente aqui');
INSERT INTO `lang_definitions` VALUES (24634, 3090, 17, 'Códigos de UCSMC providos pela Universidade de Calgary Centro de Medicina De esporte');
INSERT INTO `lang_definitions` VALUES (24635, 3091, 17, 'Ulcerações');
INSERT INTO `lang_definitions` VALUES (24636, 3092, 17, 'Colites ulcerativas');
INSERT INTO `lang_definitions` VALUES (24637, 3093, 17, 'Úlceras:');
INSERT INTO `lang_definitions` VALUES (24638, 3094, 17, 'Unassigned');
INSERT INTO `lang_definitions` VALUES (24639, 3095, 17, 'Acesso sem autorização.');
INSERT INTO `lang_definitions` VALUES (24640, 3096, 17, 'debaixo de língua');
INSERT INTO `lang_definitions` VALUES (24641, 3097, 17, 'De peso inferior ao normal');
INSERT INTO `lang_definitions` VALUES (24642, 3098, 17, 'Undiagnosed');
INSERT INTO `lang_definitions` VALUES (24643, 3099, 17, 'Desfaça Saída');
INSERT INTO `lang_definitions` VALUES (24644, 3100, 17, 'Clientes sem igual');
INSERT INTO `lang_definitions` VALUES (24645, 3101, 17, 'Clientes Novos sem igual');
INSERT INTO `lang_definitions` VALUES (24646, 3102, 17, 'Pacientes Vistos sem igual');
INSERT INTO `lang_definitions` VALUES (24647, 3103, 17, 'Relatório de Pacientes Visto sem igual');
INSERT INTO `lang_definitions` VALUES (24648, 3104, 17, 'SP sem igual');
INSERT INTO `lang_definitions` VALUES (24649, 3105, 17, 'Unidade');
INSERT INTO `lang_definitions` VALUES (24650, 3106, 17, 'Unidades');
INSERT INTO `lang_definitions` VALUES (24651, 3107, 17, 'unidades');
INSERT INTO `lang_definitions` VALUES (24652, 3108, 17, 'Unidades devem ser um número');
INSERT INTO `lang_definitions` VALUES (24653, 3109, 17, 'Desconhecido');
INSERT INTO `lang_definitions` VALUES (24654, 3110, 17, 'Desconhecido ou N/A');
INSERT INTO `lang_definitions` VALUES (24655, 3111, 17, 'Companhia de seguros não mencionada');
INSERT INTO `lang_definitions` VALUES (24656, 3112, 17, 'Não registrado');
INSERT INTO `lang_definitions` VALUES (24657, 3113, 17, 'Unselect Tudo');
INSERT INTO `lang_definitions` VALUES (24658, 3114, 17, 'Unselected');
INSERT INTO `lang_definitions` VALUES (24659, 3115, 17, 'Não especificado');
INSERT INTO `lang_definitions` VALUES (24660, 3116, 17, 'até');
INSERT INTO `lang_definitions` VALUES (24661, 3117, 17, 'Intempestivamente arquivamento');
INSERT INTO `lang_definitions` VALUES (24662, 3118, 17, 'Novo');
INSERT INTO `lang_definitions` VALUES (24663, 3119, 17, 'UOR');
INSERT INTO `lang_definitions` VALUES (24664, 3120, 17, 'Até');
INSERT INTO `lang_definitions` VALUES (24665, 3121, 17, 'Compromissos a chegar');
INSERT INTO `lang_definitions` VALUES (24666, 3122, 17, 'Eventos a chegar');
INSERT INTO `lang_definitions` VALUES (24667, 3123, 17, 'Atualização');
INSERT INTO `lang_definitions` VALUES (24668, 3124, 17, 'atualização');
INSERT INTO `lang_definitions` VALUES (24669, 3125, 17, 'Arquivos de atualização');
INSERT INTO `lang_definitions` VALUES (24670, 3126, 17, 'Atualize Info');
INSERT INTO `lang_definitions` VALUES (24671, 3130, 17, 'Atualizando demographics não é autorizado.');
INSERT INTO `lang_definitions` VALUES (24672, 3131, 17, 'UPIN');
INSERT INTO `lang_definitions` VALUES (24673, 3132, 17, 'Carga');
INSERT INTO `lang_definitions` VALUES (24674, 3133, 17, 'Transfera dados de configuração');
INSERT INTO `lang_definitions` VALUES (24675, 3134, 17, 'Transfera Documento');
INSERT INTO `lang_definitions` VALUES (24676, 3135, 17, 'Carga falhou!');
INSERT INTO `lang_definitions` VALUES (24677, 3136, 17, 'Transfera arquivo de importação:');
INSERT INTO `lang_definitions` VALUES (24678, 3137, 17, 'Transfera Relatório');
INSERT INTO `lang_definitions` VALUES (24679, 3138, 17, 'Transfera este arquivo:');
INSERT INTO `lang_definitions` VALUES (24680, 3139, 17, 'Ao clicar um número de fatura a janela postando\" manual\" se aparece. Aqui você pode mudar a data de vencimento e notas para a fatura, selecione a festa para quem você está postando, e seleciona foram recebidos os seguros para os quais tudo esperaram paymants. Importantemente, para cada código de faturamento pelo qual uma quantia foi cobrada, você pode entrar em pagamento e informação de ajuste.');
INSERT INTO `lang_definitions` VALUES (24681, 3140, 17, 'Ao o procurar é apresentado com uma lista de faturas. Você pode clicar aceso dos números de fatura abrir uma segunda janela que é a página de entrada de dados por manual postar. Você também pode fazer tique-taque em um nome paciente se você quiser entrar em uma nota que o pessoal de escritório dianteiro verá quando os cheques pacientes em, e você pode selecionar faturas para se aparecer em declarações pacientes e imprimir essas declarações.');
INSERT INTO `lang_definitions` VALUES (24682, 3141, 17, 'Braço superior');
INSERT INTO `lang_definitions` VALUES (24683, 3142, 17, 'Urgência');
INSERT INTO `lang_definitions` VALUES (24684, 3143, 17, 'Urina Pingando');
INSERT INTO `lang_definitions` VALUES (24685, 3144, 17, 'Freqüência de urina');
INSERT INTO `lang_definitions` VALUES (24686, 3145, 17, 'Hesitação de urina');
INSERT INTO `lang_definitions` VALUES (24687, 3146, 17, 'Fluxo de urina');
INSERT INTO `lang_definitions` VALUES (24688, 3147, 17, 'Urgência de urina');
INSERT INTO `lang_definitions` VALUES (24689, 3148, 17, 'URL');
INSERT INTO `lang_definitions` VALUES (24690, 3150, 17, 'Use 24 formato de tempo de hora?');
INSERT INTO `lang_definitions` VALUES (24691, 3151, 17, 'Faltas de uso');
INSERT INTO `lang_definitions` VALUES (24692, 3152, 17, 'Use estilo de data internacional?');
INSERT INTO `lang_definitions` VALUES (24693, 3153, 17, 'Só use esta característica com locais recentemente instalados,');
INSERT INTO `lang_definitions` VALUES (24694, 3154, 17, 'Use tópicos?');
INSERT INTO `lang_definitions` VALUES (24695, 3155, 17, 'Usuário');
INSERT INTO `lang_definitions` VALUES (24696, 3156, 17, 'Administração de usuário');
INSERT INTO `lang_definitions` VALUES (24697, 3157, 17, 'O usuário e Administração de Facilidade');
INSERT INTO `lang_definitions` VALUES (24698, 3158, 17, 'O usuário e Administração de Grupo');
INSERT INTO `lang_definitions` VALUES (24699, 3159, 17, 'Usuário Definiu');
INSERT INTO `lang_definitions` VALUES (24700, 3160, 17, 'Usuário Definiu Área 11');
INSERT INTO `lang_definitions` VALUES (24701, 3161, 17, 'Usuário Definiu Área 12');
INSERT INTO `lang_definitions` VALUES (24702, 3162, 17, 'Usuário Definiu Campo');
INSERT INTO `lang_definitions` VALUES (24703, 3163, 17, 'Usuário Definiu Lista 1');
INSERT INTO `lang_definitions` VALUES (24704, 3164, 17, 'Usuário Definiu Lista 2');
INSERT INTO `lang_definitions` VALUES (24705, 3165, 17, 'Usuário Definiu Lista 3');
INSERT INTO `lang_definitions` VALUES (24706, 3166, 17, 'Usuário Definiu Lista 4');
INSERT INTO `lang_definitions` VALUES (24707, 3167, 17, 'Usuário Definiu Lista 5');
INSERT INTO `lang_definitions` VALUES (24708, 3168, 17, 'Usuário Definiu Lista 6');
INSERT INTO `lang_definitions` VALUES (24709, 3169, 17, 'Usuário Definiu Lista 7');
INSERT INTO `lang_definitions` VALUES (24710, 3170, 17, 'Usuário Definiu Texto 1');
INSERT INTO `lang_definitions` VALUES (24711, 3171, 17, 'Usuário Definiu Texto 2');
INSERT INTO `lang_definitions` VALUES (24712, 3172, 17, 'Usuário Definiu Texto 3');
INSERT INTO `lang_definitions` VALUES (24713, 3173, 17, 'Usuário Definiu Texto 4');
INSERT INTO `lang_definitions` VALUES (24714, 3174, 17, 'Usuário Definiu Texto 5');
INSERT INTO `lang_definitions` VALUES (24715, 3175, 17, 'Usuário Definiu Texto 6');
INSERT INTO `lang_definitions` VALUES (24716, 3176, 17, 'Usuário Definiu Texto 7');
INSERT INTO `lang_definitions` VALUES (24717, 3177, 17, 'Usuário Definiu Texto 8');
INSERT INTO `lang_definitions` VALUES (24718, 3178, 17, 'Manual de usuário');
INSERT INTO `lang_definitions` VALUES (24719, 3179, 17, 'Sociedades de usuário');
INSERT INTO `lang_definitions` VALUES (24720, 3180, 17, 'Nome de usuário');
INSERT INTO `lang_definitions` VALUES (24721, 3181, 17, 'Nome de usuário para Portal de SMS');
INSERT INTO `lang_definitions` VALUES (24722, 3182, 17, 'Nome de usuário:');
INSERT INTO `lang_definitions` VALUES (24723, 3183, 17, 'Usuários');
INSERT INTO `lang_definitions` VALUES (24724, 3184, 17, 'Administração de Users/Groups/Logs');
INSERT INTO `lang_definitions` VALUES (24725, 3185, 17, 'php de usos <um href = \"http://php.net/strftime\">strftime </ um> formato');
INSERT INTO `lang_definitions` VALUES (24726, 3186, 17, 'UTIs');
INSERT INTO `lang_definitions` VALUES (24727, 3187, 17, 'FÉRIAS');
INSERT INTO `lang_definitions` VALUES (24728, 3188, 17, 'Férias');
INSERT INTO `lang_definitions` VALUES (24729, 3189, 17, 'Vacina');
INSERT INTO `lang_definitions` VALUES (24730, 3190, 17, 'Anel vaginal');
INSERT INTO `lang_definitions` VALUES (24731, 3191, 17, 'Valedictory');
INSERT INTO `lang_definitions` VALUES (24732, 3192, 17, 'Avalie 1');
INSERT INTO `lang_definitions` VALUES (24733, 3193, 17, 'Avalie 2');
INSERT INTO `lang_definitions` VALUES (24734, 3194, 17, 'Var1');
INSERT INTO `lang_definitions` VALUES (24735, 3195, 17, 'Var2');
INSERT INTO `lang_definitions` VALUES (24736, 3196, 17, 'Varicela 1');
INSERT INTO `lang_definitions` VALUES (24737, 3197, 17, 'Varicela 2');
INSERT INTO `lang_definitions` VALUES (24738, 3198, 17, 'Veias varicosas');
INSERT INTO `lang_definitions` VALUES (24739, 3199, 17, 'Condição vascular');
INSERT INTO `lang_definitions` VALUES (24740, 3200, 17, 'Dano vascular');
INSERT INTO `lang_definitions` VALUES (24741, 3201, 17, 'Cirurgia vascular');
INSERT INTO `lang_definitions` VALUES (24742, 3202, 17, 'Versão');
INSERT INTO `lang_definitions` VALUES (24743, 3203, 17, 'Vertigem');
INSERT INTO `lang_definitions` VALUES (24744, 3204, 17, 'Veterans Administração Plano');
INSERT INTO `lang_definitions` VALUES (24745, 3205, 17, 'Visão');
INSERT INTO `lang_definitions` VALUES (24746, 3206, 17, 'visão');
INSERT INTO `lang_definitions` VALUES (24747, 3207, 17, 'Veja Alergias');
INSERT INTO `lang_definitions` VALUES (24748, 3208, 17, 'Visão Relatório Paciente Inclusivo');
INSERT INTO `lang_definitions` VALUES (24749, 3209, 17, 'Documento de visão');
INSERT INTO `lang_definitions` VALUES (24750, 3210, 17, 'Encontro de visão');
INSERT INTO `lang_definitions` VALUES (24751, 3211, 17, 'Veja eventos em uma janela de popup?');
INSERT INTO `lang_definitions` VALUES (24752, 3212, 17, 'Veja Página 1');
INSERT INTO `lang_definitions` VALUES (24753, 3213, 17, 'Veja Página 2');
INSERT INTO `lang_definitions` VALUES (24754, 3214, 17, 'Visão relacionou encontros');
INSERT INTO `lang_definitions` VALUES (24755, 3216, 17, 'Visão:');
INSERT INTO `lang_definitions` VALUES (24756, 3217, 17, 'VISTO');
INSERT INTO `lang_definitions` VALUES (24757, 3218, 17, 'Damage/trauma/surgery visceral');
INSERT INTO `lang_definitions` VALUES (24758, 3219, 17, 'Visite Categoria:');
INSERT INTO `lang_definitions` VALUES (24759, 3220, 17, 'Data de visita');
INSERT INTO `lang_definitions` VALUES (24760, 3221, 17, 'Formas de visita');
INSERT INTO `lang_definitions` VALUES (24761, 3222, 17, 'Visitas');
INSERT INTO `lang_definitions` VALUES (24762, 3223, 17, 'Visitas De');
INSERT INTO `lang_definitions` VALUES (24763, 3225, 17, 'Vitals');
INSERT INTO `lang_definitions` VALUES (24764, 3226, 17, 'Vitals (Métrico)');
INSERT INTO `lang_definitions` VALUES (24765, 3228, 17, 'Vomitando');
INSERT INTO `lang_definitions` VALUES (24766, 3229, 17, 'W');
INSERT INTO `lang_definitions` VALUES (24767, 3230, 17, 'Cintura Circ');
INSERT INTO `lang_definitions` VALUES (24768, 3231, 17, 'Circunferência de cintura');
INSERT INTO `lang_definitions` VALUES (24769, 3232, 17, 'Esperando');
INSERT INTO `lang_definitions` VALUES (24770, 3233, 17, 'Caminhar-em');
INSERT INTO `lang_definitions` VALUES (24771, 3234, 17, 'Walt Pennington');
INSERT INTO `lang_definitions` VALUES (24772, 3235, 17, 'Morno');
INSERT INTO `lang_definitions` VALUES (24773, 3236, 17, 'ADVERTINDO');
INSERT INTO `lang_definitions` VALUES (24774, 3237, 17, 'Advertindo: Uma visita já foi criada para este paciente hoje!');
INSERT INTO `lang_definitions` VALUES (24775, 3238, 17, 'Advertindo: ID paciente não é sem igual!');
INSERT INTO `lang_definitions` VALUES (24776, 3239, 17, 'ADVERTINDO: Isto escreverá elaboradamente informação de configuração com dados do arquivo transferido!');
INSERT INTO `lang_definitions` VALUES (24777, 3240, 17, 'nós vimos seu anterior paciente para avaliação e tratamento em nossa clínica de psiquiatria de paciente externo. Obrigado por esta indicação.');
INSERT INTO `lang_definitions` VALUES (24778, 3241, 17, 'Fraqueza');
INSERT INTO `lang_definitions` VALUES (24779, 3242, 17, 'Site da Web');
INSERT INTO `lang_definitions` VALUES (24780, 3243, 17, 'Se case');
INSERT INTO `lang_definitions` VALUES (24781, 3244, 17, 'Quarta-feira');
INSERT INTO `lang_definitions` VALUES (24782, 3245, 17, 'semana');
INSERT INTO `lang_definitions` VALUES (24783, 3246, 17, 'Semana');
INSERT INTO `lang_definitions` VALUES (24784, 3247, 17, 'Visão de semana');
INSERT INTO `lang_definitions` VALUES (24785, 3248, 17, 'Week(s)');
INSERT INTO `lang_definitions` VALUES (24786, 3249, 17, 'Peso');
INSERT INTO `lang_definitions` VALUES (24787, 3250, 17, 'Mudança de peso');
INSERT INTO `lang_definitions` VALUES (24788, 3251, 17, 'Perda de peso');
INSERT INTO `lang_definitions` VALUES (24789, 3252, 17, 'O que será contado?');
INSERT INTO `lang_definitions` VALUES (24790, 3253, 17, 'Ofega:');
INSERT INTO `lang_definitions` VALUES (24791, 3254, 17, 'Ofegando');
INSERT INTO `lang_definitions` VALUES (24792, 3255, 17, 'Ofegando:');
INSERT INTO `lang_definitions` VALUES (24793, 3256, 17, 'Onde possa relacionado esquadrinhou ou empapela documentos seja achado?');
INSERT INTO `lang_definitions` VALUES (24794, 3257, 17, 'Cordel de chicote');
INSERT INTO `lang_definitions` VALUES (24795, 3258, 17, 'Quem');
INSERT INTO `lang_definitions` VALUES (24796, 3259, 17, 'Quem respondeu?');
INSERT INTO `lang_definitions` VALUES (24797, 3260, 17, 'Enviuvado');
INSERT INTO `lang_definitions` VALUES (24798, 3261, 17, 'Com selecionou:');
INSERT INTO `lang_definitions` VALUES (24799, 3262, 17, 'com o nome velho');
INSERT INTO `lang_definitions` VALUES (24800, 3263, 17, 'Com quem podemos partir nós uma mensagem?');
INSERT INTO `lang_definitions` VALUES (24801, 3264, 17, 'dentro de horas');
INSERT INTO `lang_definitions` VALUES (24802, 3265, 17, 'dentro de horas:');
INSERT INTO `lang_definitions` VALUES (24803, 3266, 17, 'dentro de atas');
INSERT INTO `lang_definitions` VALUES (24804, 3267, 17, 'dentro de atas:');
INSERT INTO `lang_definitions` VALUES (24805, 3268, 17, 'Sem Atualização');
INSERT INTO `lang_definitions` VALUES (24806, 3269, 17, 'Testemunha');
INSERT INTO `lang_definitions` VALUES (24807, 3270, 17, 'WNL');
INSERT INTO `lang_definitions` VALUES (24808, 3271, 17, 'Mulheres');
INSERT INTO `lang_definitions` VALUES (24809, 3272, 17, 'Mulheres Só');
INSERT INTO `lang_definitions` VALUES (24810, 3273, 17, 'Trabalho');
INSERT INTO `lang_definitions` VALUES (24811, 3274, 17, 'TRABALHE NOTA');
INSERT INTO `lang_definitions` VALUES (24812, 3275, 17, 'Trabalhe Telefone');
INSERT INTO `lang_definitions` VALUES (24813, 3276, 17, 'Trabalhe Número de telefone');
INSERT INTO `lang_definitions` VALUES (24814, 3277, 17, 'Trabalhe relacionado?');
INSERT INTO `lang_definitions` VALUES (24815, 3278, 17, 'Trabalhe / Educação / Passatempos');
INSERT INTO `lang_definitions` VALUES (24816, 3279, 17, 'Work/School Note');
INSERT INTO `lang_definitions` VALUES (24817, 3280, 17, 'dia de trabalho');
INSERT INTO `lang_definitions` VALUES (24818, 3281, 17, 'Trabalhadores Compensação Saúde Plano');
INSERT INTO `lang_definitions` VALUES (24819, 3282, 17, 'Pior');
INSERT INTO `lang_definitions` VALUES (24820, 3283, 17, 'Pulso');
INSERT INTO `lang_definitions` VALUES (24821, 3284, 17, 'Pulso e mão');
INSERT INTO `lang_definitions` VALUES (24822, 3285, 17, 'Problemas de pulso');
INSERT INTO `lang_definitions` VALUES (24823, 3286, 17, 'escreva');
INSERT INTO `lang_definitions` VALUES (24824, 3287, 17, 'escreva fora');
INSERT INTO `lang_definitions` VALUES (24825, 3288, 17, 'wsome');
INSERT INTO `lang_definitions` VALUES (24826, 3290, 17, 'x Cancelled');
INSERT INTO `lang_definitions` VALUES (24827, 3291, 17, 'Radiografia');
INSERT INTO `lang_definitions` VALUES (24828, 3292, 17, 'RADIOGRAFE Interpretação:');
INSERT INTO `lang_definitions` VALUES (24829, 3293, 17, 'Radiografe Interpretação:');
INSERT INTO `lang_definitions` VALUES (24830, 3294, 17, 'X12 só: Sobressalente Claim');
INSERT INTO `lang_definitions` VALUES (24831, 3295, 17, 'Sócio de X12');
INSERT INTO `lang_definitions` VALUES (24832, 3296, 17, 'Sócios de X12');
INSERT INTO `lang_definitions` VALUES (24833, 3297, 17, 'Y');
INSERT INTO `lang_definitions` VALUES (24834, 3298, 17, 'ano');
INSERT INTO `lang_definitions` VALUES (24835, 3299, 17, 'Ano');
INSERT INTO `lang_definitions` VALUES (24836, 3300, 17, 'Visão de ano');
INSERT INTO `lang_definitions` VALUES (24837, 3301, 17, 'Year(s)');
INSERT INTO `lang_definitions` VALUES (24838, 3302, 17, 'SIM');
INSERT INTO `lang_definitions` VALUES (24839, 3303, 17, 'Sim');
INSERT INTO `lang_definitions` VALUES (24840, 3304, 17, 'sim');
INSERT INTO `lang_definitions` VALUES (24841, 3305, 17, 'SIM!');
INSERT INTO `lang_definitions` VALUES (24842, 3306, 17, 'Sim, Apague e Anote');
INSERT INTO `lang_definitions` VALUES (24843, 3307, 17, 'Yes/No');
INSERT INTO `lang_definitions` VALUES (24844, 3308, 17, 'Sim:');
INSERT INTO `lang_definitions` VALUES (24845, 3309, 17, 'Você está a ponto de substituir o modelo existente permanentemente. Você está seguro você deseja continuar?');
INSERT INTO `lang_definitions` VALUES (24846, 3310, 17, 'Não lhe permitem apagar este evento');
INSERT INTO `lang_definitions` VALUES (24847, 3311, 17, 'Não lhe permitem editar este evento');
INSERT INTO `lang_definitions` VALUES (24848, 3312, 17, 'Não lhe autorizam para isto.');
INSERT INTO `lang_definitions` VALUES (24849, 3313, 17, 'Não autorizam que você acesse esta esquadra.');
INSERT INTO `lang_definitions` VALUES (24850, 3314, 17, 'Não lhe autorizam a assuntos de add/edit');
INSERT INTO `lang_definitions` VALUES (24851, 3315, 17, 'Não autorizam que você veja este encontro.');
INSERT INTO `lang_definitions` VALUES (24852, 3316, 17, 'Você não pode acessar esta função diretamente.');
INSERT INTO `lang_definitions` VALUES (24853, 3317, 17, 'Você não pode acessar esta página diretamente.');
INSERT INTO `lang_definitions` VALUES (24854, 3321, 17, 'Você não escolheu nenhuma ação.');
INSERT INTO `lang_definitions` VALUES (24855, 3322, 17, 'Você não tem acesso a view/edit esta nota');
INSERT INTO `lang_definitions` VALUES (24856, 3324, 17, 'Você tem que selecionar primeiro ou tem que somar um paciente.');
INSERT INTO `lang_definitions` VALUES (24857, 3325, 17, 'Você tem que selecionar primeiro ou tem que criar um encontro.');
INSERT INTO `lang_definitions` VALUES (24858, 3326, 17, 'Você tem que selecionar alguns campos para continuar.');
INSERT INTO `lang_definitions` VALUES (24859, 3327, 17, 'Você deveria estar fazendo este teste se esta reivindicação parecesse gerar prosperamente mas o arquivo de reivindicação atual não contém qualquer dados ou só uma porção inacabada da quantia de dados é suposto que contém. É óbvio com reivindicações de HCFA porque eles são humanos legível, com reivindicações de X12 é um processo mais difícil para determinar se a reivindicação for corretamente complete.');
INSERT INTO `lang_definitions` VALUES (24860, 3328, 17, 'Sua data de fim é inválida');
INSERT INTO `lang_definitions` VALUES (24861, 3329, 17, 'Seu evento foi apagado.');
INSERT INTO `lang_definitions` VALUES (24862, 3330, 17, 'Seu evento foi modificado.');
INSERT INTO `lang_definitions` VALUES (24863, 3331, 17, 'Seu evento foi submetido.');
INSERT INTO `lang_definitions` VALUES (24864, 3332, 17, 'Seu nome de lista foi mudado para conhecer nomeando exigências.');
INSERT INTO `lang_definitions` VALUES (24865, 3333, 17, 'Sua configuração de PostCalendar foi reajustada para usar faltas.');
INSERT INTO `lang_definitions` VALUES (24866, 3334, 17, 'Sua configuração de PostCalendar foi atualizada.');
INSERT INTO `lang_definitions` VALUES (24867, 3335, 17, 'Sua freqüência repetindo deve ser uma inteireza.');
INSERT INTO `lang_definitions` VALUES (24868, 3336, 17, 'Sua freqüência repetindo deve ser pelo menos 1.');
INSERT INTO `lang_definitions` VALUES (24869, 3337, 17, 'Sua data de começo é maior que sua data de fim');
INSERT INTO `lang_definitions` VALUES (24870, 3338, 17, 'Sua data de começo é inválida');
INSERT INTO `lang_definitions` VALUES (24871, 3339, 17, 'Sua submissão falhou.');
INSERT INTO `lang_definitions` VALUES (24872, 3340, 17, 'yyyy-mm-dd');
INSERT INTO `lang_definitions` VALUES (24873, 3341, 17, 'yyyy-mm-dd datam associado com este documento');
INSERT INTO `lang_definitions` VALUES (24874, 3342, 17, 'data de yyyy-mm-dd destruiu');
INSERT INTO `lang_definitions` VALUES (24875, 3343, 17, 'yyyy-mm-dd Datam de Nascimento');
INSERT INTO `lang_definitions` VALUES (24876, 3344, 17, 'yyyy-mm-dd datam de nascimento');
INSERT INTO `lang_definitions` VALUES (24877, 3345, 17, 'yyyy-mm-dd datam de vencimento');
INSERT INTO `lang_definitions` VALUES (24878, 3346, 17, 'yyyy-mm-dd Datam de começo ou hospitalização');
INSERT INTO `lang_definitions` VALUES (24879, 3347, 17, 'yyyy-mm-dd datam de começo, cirurgia ou começo de medicamento');
INSERT INTO `lang_definitions` VALUES (24880, 3348, 17, 'yyyy-mm-dd datam de recuperação ou fim de medicamento');
INSERT INTO `lang_definitions` VALUES (24881, 3349, 17, 'yyyy-mm-dd Datam de retorno para jogar');
INSERT INTO `lang_definitions` VALUES (24882, 3350, 17, 'yyyy-mm-dd Datam de serviço');
INSERT INTO `lang_definitions` VALUES (24883, 3351, 17, 'yyyy-mm-dd datam desta carta');
INSERT INTO `lang_definitions` VALUES (24884, 3352, 17, 'data de yyyy-mm-dd devolveu para jogar');
INSERT INTO `lang_definitions` VALUES (24885, 3353, 17, 'yyyy-mm-dd documentam data');
INSERT INTO `lang_definitions` VALUES (24886, 3354, 17, 'data de evento de yyyy-mm-dd ou data começando');
INSERT INTO `lang_definitions` VALUES (24887, 3355, 17, 'yyyy-mm-dd por último data deste evento');
INSERT INTO `lang_definitions` VALUES (24888, 3356, 17, 'Zero');
INSERT INTO `lang_definitions` VALUES (24889, 3357, 17, 'Vigor');
INSERT INTO `lang_definitions` VALUES (24890, 3358, 17, 'Cep');
INSERT INTO `lang_definitions` VALUES (24891, 3359, 17, 'Zip/Country:');
INSERT INTO `lang_definitions` VALUES (24892, 3360, 17, 'mas era');
INSERT INTO `lang_definitions` VALUES (24893, 3361, 17, 'não pôde ser acessado.');
INSERT INTO `lang_definitions` VALUES (24894, 3362, 17, 'Realmente faça você quer apagar');
INSERT INTO `lang_definitions` VALUES (24895, 3363, 17, 'Droga');
INSERT INTO `lang_definitions` VALUES (24896, 3364, 17, 'e-mails não enviaram');
INSERT INTO `lang_definitions` VALUES (24897, 3365, 17, 'de');
INSERT INTO `lang_definitions` VALUES (24898, 3366, 17, 'foi criado.');
INSERT INTO `lang_definitions` VALUES (24899, 3367, 17, 'foi re-aberto.');
INSERT INTO `lang_definitions` VALUES (24900, 3368, 17, 'História');
INSERT INTO `lang_definitions` VALUES (24901, 3369, 17, 'não é um número');
INSERT INTO `lang_definitions` VALUES (24902, 3370, 17, 'está pronto para re-faturar.');
INSERT INTO `lang_definitions` VALUES (24903, 3371, 17, 'LLL:');
INSERT INTO `lang_definitions` VALUES (24904, 3372, 17, 'Lote');
INSERT INTO `lang_definitions` VALUES (24905, 3373, 17, 'Medicaid Referência Original Não.');
INSERT INTO `lang_definitions` VALUES (24906, 3374, 17, 'min');
INSERT INTO `lang_definitions` VALUES (24907, 3375, 17, 'não ache!');
INSERT INTO `lang_definitions` VALUES (24908, 3376, 17, 'Pecularities em muitos browsers pode querer dizer que a produção debaixo de entra em sua tela em puxões súbitos e que há longo pausa de vários segundos onde se aparece como se coisas podem ter batido. Isso não é o caso, você verá produção que sai de linha através de linha eventualmente. Pode haver números seqüentes que se aparecem abaixo, este é indicar que embora nada mais possa estar exibindo há atividade que vai em. Estes números serão entremeados com o conteúdo do faturamento e isso é normal.');
INSERT INTO `lang_definitions` VALUES (24909, 3377, 17, 'prescrição alcançou seu limite de');
INSERT INTO `lang_definitions` VALUES (24910, 3378, 17, 'até');
INSERT INTO `lang_definitions` VALUES (24911, 3379, 17, 'atualização falhou, não em banco de dados?');
INSERT INTO `lang_definitions` VALUES (24912, 3380, 17, 'era marcado como só faturado.');
INSERT INTO `lang_definitions` VALUES (24913, 3381, 17, 'foi feito fila prosperamente.');
INSERT INTO `lang_definitions` VALUES (24914, 3382, 17, '! Visita de w/o esquerda');
INSERT INTO `lang_definitions` VALUES (24915, 3383, 17, 'para código _x000D_ é CONFERIDO em Colocações de PostCalendar!');
INSERT INTO `lang_definitions` VALUES (24916, 3384, 17, 'é CONFERIDO em Colocações de PostCalendar! _x000D_');
INSERT INTO `lang_definitions` VALUES (24917, 3385, 17, '#Assunto de Ins/fin');
INSERT INTO `lang_definitions` VALUES (24918, 3386, 17, '#de tabletes:');
INSERT INTO `lang_definitions` VALUES (24919, 3387, 17, '$');
INSERT INTO `lang_definitions` VALUES (24920, 3388, 17, '$Codificando terminado');
INSERT INTO `lang_definitions` VALUES (24921, 3389, 17, '$1,00');
INSERT INTO `lang_definitions` VALUES (24922, 3390, 17, '$rótulo (yyyy-mm-dd):');
INSERT INTO `lang_definitions` VALUES (24923, 3391, 17, '%');
INSERT INTO `lang_definitions` VALUES (24924, 3392, 17, '% Cancelou <24h');
INSERT INTO `lang_definitions` VALUES (24925, 3393, 17, 'deveria existir mas não deveria fazer.');
INSERT INTO `lang_definitions` VALUES (24926, 3394, 17, '(% partidas qualquer fio, _ emparelha qualquer caráter)');
INSERT INTO `lang_definitions` VALUES (24927, 3395, 17, '(Atrás)');
INSERT INTO `lang_definitions` VALUES (24928, 3396, 17, '(Faça tique-taque para editar)');
INSERT INTO `lang_definitions` VALUES (24929, 3397, 17, '(Mais)');
INSERT INTO `lang_definitions` VALUES (24930, 3398, 17, '(O Paciente novo)');
INSERT INTO `lang_definitions` VALUES (24931, 3399, 17, '(Notas e Autorizações)');
INSERT INTO `lang_definitions` VALUES (24932, 3400, 17, '(Notas pacientes)');
INSERT INTO `lang_definitions` VALUES (24933, 3401, 17, '(Selecione um destes, ou digite seu próprio título)');
INSERT INTO `lang_definitions` VALUES (24934, 3402, 17, '* Lembrança feita');
INSERT INTO `lang_definitions` VALUES (24935, 3403, 17, '* * Por favor mova cirurgias a Assuntos!');
INSERT INTO `lang_definitions` VALUES (24936, 3404, 17, '* Exigido');
INSERT INTO `lang_definitions` VALUES (24937, 3405, 17, '#N/A');
INSERT INTO `lang_definitions` VALUES (24938, 3406, 17, '.');
INSERT INTO `lang_definitions` VALUES (24939, 3407, 17, '0-10');
INSERT INTO `lang_definitions` VALUES (24940, 3408, 17, '1.Rest 2. Gelo durante dois dias 3. Compressão, deixa o penso em lugar a menos que o pé desenvolva entorpecimento ou cor 4 pálida. Eleve o pé e perna');
INSERT INTO `lang_definitions` VALUES (24941, 3409, 17, '11/14/09');
INSERT INTO `lang_definitions` VALUES (24942, 3410, 17, '15-19');
INSERT INTO `lang_definitions` VALUES (24943, 3411, 17, '20-24');
INSERT INTO `lang_definitions` VALUES (24944, 3412, 17, '2111-13');
INSERT INTO `lang_definitions` VALUES (24945, 3413, 17, '25-29');
INSERT INTO `lang_definitions` VALUES (24946, 3414, 17, '2º');
INSERT INTO `lang_definitions` VALUES (24947, 3415, 17, '3 meses');
INSERT INTO `lang_definitions` VALUES (24948, 3416, 17, '3 vezes diariamente');
INSERT INTO `lang_definitions` VALUES (24949, 3417, 17, '30-34');
INSERT INTO `lang_definitions` VALUES (24950, 3418, 17, '35-39');
INSERT INTO `lang_definitions` VALUES (24951, 3419, 17, '3º');
INSERT INTO `lang_definitions` VALUES (24952, 3420, 17, '4 meses');
INSERT INTO `lang_definitions` VALUES (24953, 3421, 17, '4 vezes diariamente');
INSERT INTO `lang_definitions` VALUES (24954, 3422, 17, '40-44');
INSERT INTO `lang_definitions` VALUES (24955, 3423, 17, '45');
INSERT INTO `lang_definitions` VALUES (24956, 3424, 17, '465.9, URI,');
INSERT INTO `lang_definitions` VALUES (24957, 3425, 17, '466.0, bronquites, NOS Agudo,');
INSERT INTO `lang_definitions` VALUES (24958, 3426, 17, '486.0, pneumonia, Agudo,');
INSERT INTO `lang_definitions` VALUES (24959, 3427, 17, '491.21, Exacerbação de COPD,');
INSERT INTO `lang_definitions` VALUES (24960, 3428, 17, '491.8, bronquites, Crônico,');
INSERT INTO `lang_definitions` VALUES (24961, 3429, 17, '493.92, asma, Exac Agudo.');
INSERT INTO `lang_definitions` VALUES (24962, 3430, 17, '496.0, COPD,');
INSERT INTO `lang_definitions` VALUES (24963, 3431, 17, '4º');
INSERT INTO `lang_definitions` VALUES (24964, 3432, 17, '519.7, Bronchospasm,');
INSERT INTO `lang_definitions` VALUES (24965, 3433, 17, '5º');
INSERT INTO `lang_definitions` VALUES (24966, 3434, 17, '6 meses');
INSERT INTO `lang_definitions` VALUES (24967, 3435, 17, '6º');
INSERT INTO `lang_definitions` VALUES (24968, 3436, 17, '824.0 fratura, malleolus mediano, fechado,');
INSERT INTO `lang_definitions` VALUES (24969, 3437, 17, '824.2 fratura, malleolus lateral, fechado,');
INSERT INTO `lang_definitions` VALUES (24970, 3438, 17, '824.6 fratura, Trimalleolar, fechado,');
INSERT INTO `lang_definitions` VALUES (24971, 3439, 17, '825.32 fratura, de Navicular (tornozelo)');
INSERT INTO `lang_definitions` VALUES (24972, 3440, 17, '825.35 fratura, Base de quinto (5º) Metatarsal');
INSERT INTO `lang_definitions` VALUES (24973, 3441, 17, '845.00 deslocamento de tornozelo NOS');
INSERT INTO `lang_definitions` VALUES (24974, 3442, 17, '845.01 deslocamento Mediano (Deltoid) Lig.');
INSERT INTO `lang_definitions` VALUES (24975, 3443, 17, '845.02 deslocamento, fibular de Calcaneal,');
INSERT INTO `lang_definitions` VALUES (24976, 3444, 17, '99212 estabelecido - Descomplicado');
INSERT INTO `lang_definitions` VALUES (24977, 3445, 17, '99213 estabelecido - Baixa Complexidade');
INSERT INTO `lang_definitions` VALUES (24978, 3446, 17, '<Em quarto de exame');
INSERT INTO `lang_definitions` VALUES (24979, 3447, 17, '> Confirmou');
INSERT INTO `lang_definitions` VALUES (24980, 3448, 17, '? Nenhum espetáculo');
INSERT INTO `lang_definitions` VALUES (24981, 3449, 17, '@ Chegou');
INSERT INTO `lang_definitions` VALUES (24982, 3450, 17, '[Visão de mudança]');
INSERT INTO `lang_definitions` VALUES (24983, 3451, 17, '[Data de Último Encontro]');
INSERT INTO `lang_definitions` VALUES (24984, 3452, 17, '[Dias Como Último Encontro]');
INSERT INTO `lang_definitions` VALUES (24985, 3453, 17, '[EOBs]');
INSERT INTO `lang_definitions` VALUES (24986, 3454, 17, '[Exportação OFX]');
INSERT INTO `lang_definitions` VALUES (24987, 3455, 17, '[não recomendou]');
INSERT INTO `lang_definitions` VALUES (24988, 3456, 17, '[Número De Encontros]');
INSERT INTO `lang_definitions` VALUES (24989, 3457, 17, '[Relatórios]');
INSERT INTO `lang_definitions` VALUES (24990, 3458, 17, '[Selecione Tudo]');
INSERT INTO `lang_definitions` VALUES (24991, 3459, 17, '[SQL-razão]');
INSERT INTO `lang_definitions` VALUES (24992, 3460, 17, '[Processamento em lote de começo]');
INSERT INTO `lang_definitions` VALUES (24993, 3461, 17, '[Tronco de visão]');
INSERT INTO `lang_definitions` VALUES (24994, 3462, 17, '[Visão Relatório Imprimível]');
INSERT INTO `lang_definitions` VALUES (24995, 3463, 17, '_PC_DUR_HOURS');
INSERT INTO `lang_definitions` VALUES (24996, 3464, 17, '_PC_DUR_MINUTES');
INSERT INTO `lang_definitions` VALUES (24997, 3465, 17, '_PC_LOCALE');
INSERT INTO `lang_definitions` VALUES (24998, 3466, 17, '~ Chegou tarde');
INSERT INTO `lang_definitions` VALUES (24999, 2, 18, 'رقم الإيصال أو المطالبة للتعريف بالدفع');
INSERT INTO `lang_definitions` VALUES (25000, 4, 18, 'مطلوب رقم أكبر');
INSERT INTO `lang_definitions` VALUES (25001, 6, 18, 'رقم فريد للتعريف بهذا الحقل,غير مرئي للمستخدم');
INSERT INTO `lang_definitions` VALUES (25002, 7, 18, 'قبل الطعام');
INSERT INTO `lang_definitions` VALUES (25003, 8, 18, 'بعد الطعام');
INSERT INTO `lang_definitions` VALUES (25004, 11, 18, 'اختصارات');
INSERT INTO `lang_definitions` VALUES (25005, 12, 18, 'خراج');
INSERT INTO `lang_definitions` VALUES (25006, 13, 18, 'بطني');
INSERT INTO `lang_definitions` VALUES (25007, 14, 18, 'قادر على حمل الوزن أربع خطوات');
INSERT INTO `lang_definitions` VALUES (25008, 15, 18, 'غير سوي');
INSERT INTO `lang_definitions` VALUES (25009, 17, 18, 'غير سوي');
INSERT INTO `lang_definitions` VALUES (25010, 18, 18, 'فحص دم غير سوي');
INSERT INTO `lang_definitions` VALUES (25011, 19, 18, 'نمو شعر غير طبيعي');
INSERT INTO `lang_definitions` VALUES (25012, 20, 18, 'تصوير ثدي غير طبيعي');
INSERT INTO `lang_definitions` VALUES (25013, 21, 18, 'اجهاض');
INSERT INTO `lang_definitions` VALUES (25014, 22, 18, 'مسائل الإجهاض');
INSERT INTO `lang_definitions` VALUES (25015, 23, 18, 'طريقة الإجهاض');
INSERT INTO `lang_definitions` VALUES (25016, 24, 18, 'الفئات المتعلقة بالإجهاض');
INSERT INTO `lang_definitions` VALUES (25017, 25, 18, 'اجهاضات');
INSERT INTO `lang_definitions` VALUES (25018, 26, 18, 'غياب بالتشخيص');
INSERT INTO `lang_definitions` VALUES (25019, 27, 18, 'قبول المهمة');
INSERT INTO `lang_definitions` VALUES (25020, 28, 18, 'قبول الدفع ل');
INSERT INTO `lang_definitions` VALUES (25021, 29, 18, 'قبول المهمة');
INSERT INTO `lang_definitions` VALUES (25022, 30, 18, 'تحكم الوصول');
INSERT INTO `lang_definitions` VALUES (25023, 31, 18, 'ادارة قائمة التحكم بالوصول');
INSERT INTO `lang_definitions` VALUES (25024, 32, 18, 'المحاسبة');
INSERT INTO `lang_definitions` VALUES (25025, 33, 18, 'آلام');
INSERT INTO `lang_definitions` VALUES (25026, 35, 18, 'قائمة التحكم بالوصول');
INSERT INTO `lang_definitions` VALUES (25027, 36, 18, 'ادارة قائمة التحكم بالوصول');
INSERT INTO `lang_definitions` VALUES (25028, 37, 18, 'ادارة قائمة التحكم بالوصول غير مسموحة');
INSERT INTO `lang_definitions` VALUES (25029, 38, 18, 'العد');
INSERT INTO `lang_definitions` VALUES (25030, 39, 18, 'الفعل');
INSERT INTO `lang_definitions` VALUES (25031, 40, 18, 'تاريخ الفعل');
INSERT INTO `lang_definitions` VALUES (25032, 41, 18, 'فعال');
INSERT INTO `lang_definitions` VALUES (25033, 42, 18, 'الموعد الفعال');
INSERT INTO `lang_definitions` VALUES (25034, 43, 18, 'القوائم الفعالة');
INSERT INTO `lang_definitions` VALUES (25035, 44, 18, 'المريض الفعال');
INSERT INTO `lang_definitions` VALUES (25036, 45, 18, 'النوع الفعال');
INSERT INTO `lang_definitions` VALUES (25037, 46, 18, 'حاد أو مزمن');
INSERT INTO `lang_definitions` VALUES (25038, 47, 18, 'اضافة');
INSERT INTO `lang_definitions` VALUES (25039, 49, 18, 'اضافة شركة');
INSERT INTO `lang_definitions` VALUES (25040, 50, 18, 'اضافة صيدلية');
INSERT INTO `lang_definitions` VALUES (25041, 51, 18, 'اضافة حدث ل');
INSERT INTO `lang_definitions` VALUES (25042, 52, 18, 'اضافة كملاحظة جديدة');
INSERT INTO `lang_definitions` VALUES (25043, 53, 18, 'اضافة جديد');
INSERT INTO `lang_definitions` VALUES (25044, 54, 18, 'اضافة فئة');
INSERT INTO `lang_definitions` VALUES (25045, 55, 18, 'اضافة ثابت');
INSERT INTO `lang_definitions` VALUES (25046, 56, 18, 'اضافة تحمل');
INSERT INTO `lang_definitions` VALUES (25047, 57, 18, 'اضافة دواء');
INSERT INTO `lang_definitions` VALUES (25048, 58, 18, 'اضافة موعد');
INSERT INTO `lang_definitions` VALUES (25049, 59, 18, 'اضافة منشأة');
INSERT INTO `lang_definitions` VALUES (25050, 60, 18, 'اضافة حقل');
INSERT INTO `lang_definitions` VALUES (25051, 61, 18, 'اضافة مجموعة');
INSERT INTO `lang_definitions` VALUES (25052, 62, 18, 'اضافة رمز المرض');
INSERT INTO `lang_definitions` VALUES (25053, 63, 18, 'اضافة مسألة');
INSERT INTO `lang_definitions` VALUES (25054, 64, 18, 'اضافة لغة');
INSERT INTO `lang_definitions` VALUES (25055, 65, 18, 'اضافة جديد');
INSERT INTO `lang_definitions` VALUES (25056, 66, 18, 'اضافة فئة جديدة');
INSERT INTO `lang_definitions` VALUES (25057, 67, 18, 'اضافة مجموعة جديدة');
INSERT INTO `lang_definitions` VALUES (25058, 68, 18, 'اضافة ملاحظة جديدة');
INSERT INTO `lang_definitions` VALUES (25059, 69, 18, 'اضافة ملاحظة جديدة');
INSERT INTO `lang_definitions` VALUES (25060, 70, 18, 'اضافة شريك جديد');
INSERT INTO `lang_definitions` VALUES (25061, 71, 18, 'اضافة ملاحظة');
INSERT INTO `lang_definitions` VALUES (25062, 72, 18, 'اضافة سجل مريض');
INSERT INTO `lang_definitions` VALUES (25063, 73, 18, 'اضافة وصفة');
INSERT INTO `lang_definitions` VALUES (25064, 75, 18, 'اضافة الى قائمة الأدوية');
INSERT INTO `lang_definitions` VALUES (25065, 76, 18, 'اضافة تحويل');
INSERT INTO `lang_definitions` VALUES (25066, 77, 18, 'اضافة مستخدم');
INSERT INTO `lang_definitions` VALUES (25067, 78, 18, 'اضافة مستخدم الى مجموعة');
INSERT INTO `lang_definitions` VALUES (25068, 79, 18, 'مضاف');
INSERT INTO `lang_definitions` VALUES (25069, 80, 18, 'اضافة معلومات ديموغرافية غير مسموح');
INSERT INTO `lang_definitions` VALUES (25070, 81, 18, 'متلازمة أديسون');
INSERT INTO `lang_definitions` VALUES (25071, 82, 18, 'متلازمة أديسون');
INSERT INTO `lang_definitions` VALUES (25072, 83, 18, 'تشخيص اضافي');
INSERT INTO `lang_definitions` VALUES (25073, 84, 18, 'تاريخ مرضي اضافي');
INSERT INTO `lang_definitions` VALUES (25074, 85, 18, 'ملاحظات في التاريخ المرضي اضافية');
INSERT INTO `lang_definitions` VALUES (25075, 86, 18, 'معلومات اضافية');
INSERT INTO `lang_definitions` VALUES (25076, 87, 18, 'تحاليل مخبرية اضافية');
INSERT INTO `lang_definitions` VALUES (25077, 88, 18, 'ملاحظات اضافية');
INSERT INTO `lang_definitions` VALUES (25078, 89, 18, 'ملاحظات اضافية');
INSERT INTO `lang_definitions` VALUES (25079, 90, 18, 'ملاحظات اضافية');
INSERT INTO `lang_definitions` VALUES (25080, 91, 18, 'ملاحظات شعاعية اضافية');
INSERT INTO `lang_definitions` VALUES (25081, 92, 18, 'اضافة محددة');
INSERT INTO `lang_definitions` VALUES (25082, 93, 18, 'دفتر العناوين');
INSERT INTO `lang_definitions` VALUES (25083, 94, 18, 'دفتر العناوين');
INSERT INTO `lang_definitions` VALUES (25084, 95, 18, 'العنوان');
INSERT INTO `lang_definitions` VALUES (25085, 96, 18, 'دفتر العناوين');
INSERT INTO `lang_definitions` VALUES (25086, 97, 18, 'العنوان 1');
INSERT INTO `lang_definitions` VALUES (25087, 98, 18, 'العنوان 2');
INSERT INTO `lang_definitions` VALUES (25088, 99, 18, 'تعديل');
INSERT INTO `lang_definitions` VALUES (25089, 100, 18, 'تعديل');
INSERT INTO `lang_definitions` VALUES (25090, 101, 18, 'أسباب التعديل');
INSERT INTO `lang_definitions` VALUES (25091, 102, 18, 'القيمة المعدلة للرمز');
INSERT INTO `lang_definitions` VALUES (25092, 103, 18, 'تعديلات');
INSERT INTO `lang_definitions` VALUES (25093, 104, 18, 'تعديلات المدير');
INSERT INTO `lang_definitions` VALUES (25094, 105, 18, 'المدير');
INSERT INTO `lang_definitions` VALUES (25095, 106, 18, 'العنوان الألكتروني للمدير');
INSERT INTO `lang_definitions` VALUES (25096, 107, 18, 'ادارة');
INSERT INTO `lang_definitions` VALUES (25097, 108, 18, 'ادارة عن طريق');
INSERT INTO `lang_definitions` VALUES (25098, 109, 18, 'الإدارة');
INSERT INTO `lang_definitions` VALUES (25099, 110, 18, 'المدراء');
INSERT INTO `lang_definitions` VALUES (25100, 111, 18, 'المدراء لهم كافة الصلاحيات');
INSERT INTO `lang_definitions` VALUES (25101, 112, 18, 'متقدم');
INSERT INTO `lang_definitions` VALUES (25102, 113, 18, 'نصيحة');
INSERT INTO `lang_definitions` VALUES (25103, 114, 18, 'يؤثر طبيعياً');
INSERT INTO `lang_definitions` VALUES (25104, 115, 18, 'مكالمة بعد ساعات');
INSERT INTO `lang_definitions` VALUES (25105, 116, 18, 'بعد حفظ الملف بصيغة بدف اضغط مشاهدة السجل للتأكد من عدم وجود أخطاء');
INSERT INTO `lang_definitions` VALUES (25106, 117, 18, 'بعد حفظ تعديلك اضغط مشاهدة السجل للتأكد من عدم وجود أخطاء');
INSERT INTO `lang_definitions` VALUES (25107, 118, 18, 'بعد ادخال المعلومات بشكل صحيح اضغط زر الحفظ');
INSERT INTO `lang_definitions` VALUES (25108, 119, 18, 'مرة اخرى');
INSERT INTO `lang_definitions` VALUES (25109, 120, 18, 'العمر');
INSERT INTO `lang_definitions` VALUES (25110, 121, 18, 'العمر ب');
INSERT INTO `lang_definitions` VALUES (25111, 122, 18, 'الفئة العمرية');
INSERT INTO `lang_definitions` VALUES (25112, 123, 18, 'بيانات العمر خارج المجال');
INSERT INTO `lang_definitions` VALUES (25113, 124, 18, 'نمط ادخال العمر ل (العمر من ) غير صحيح');
INSERT INTO `lang_definitions` VALUES (25114, 125, 18, 'نمط ادخال العمر ل (العمر الى) غير صحيح');
INSERT INTO `lang_definitions` VALUES (25115, 126, 18, 'العمر من');
INSERT INTO `lang_definitions` VALUES (25116, 127, 18, 'أعمدة العمر');
INSERT INTO `lang_definitions` VALUES (25117, 128, 18, 'الكحول');
INSERT INTO `lang_definitions` VALUES (25118, 129, 18, 'استهلاك الكحول');
INSERT INTO `lang_definitions` VALUES (25119, 130, 18, 'الكل');
INSERT INTO `lang_definitions` VALUES (25120, 131, 18, 'كل الفئات');
INSERT INTO `lang_definitions` VALUES (25121, 132, 18, 'كل الأيام');
INSERT INTO `lang_definitions` VALUES (25122, 133, 18, 'كل أحداث اليوم');
INSERT INTO `lang_definitions` VALUES (25123, 134, 18, 'كل الهيئات');
INSERT INTO `lang_definitions` VALUES (25124, 135, 18, 'كل أو جزء من الإسم الأول');
INSERT INTO `lang_definitions` VALUES (25125, 136, 18, 'كل أو جزء من الإسم الأخير');
INSERT INTO `lang_definitions` VALUES (25126, 137, 18, 'كل المزودين');
INSERT INTO `lang_definitions` VALUES (25127, 138, 18, 'الكل تمت مراجعته وسلبي');
INSERT INTO `lang_definitions` VALUES (25128, 139, 18, 'كافة المواضيع');
INSERT INTO `lang_definitions` VALUES (25129, 140, 18, 'كافة المستخدمين');
INSERT INTO `lang_definitions` VALUES (25130, 141, 18, 'تحسسي');
INSERT INTO `lang_definitions` VALUES (25131, 142, 18, 'المحسسات');
INSERT INTO `lang_definitions` VALUES (25132, 143, 18, 'المحسسات:');
INSERT INTO `lang_definitions` VALUES (25133, 144, 18, 'الحساسية');
INSERT INTO `lang_definitions` VALUES (25134, 145, 18, 'السماح بالبريد الألكتروني');
INSERT INTO `lang_definitions` VALUES (25135, 146, 18, 'السماح برسائل البريد الألكتروني');
INSERT INTO `lang_definitions` VALUES (25136, 147, 18, 'السماح بالبريد الألكتروني ؟');
INSERT INTO `lang_definitions` VALUES (25137, 148, 18, 'السماح برسالة بريدية');
INSERT INTO `lang_definitions` VALUES (25138, 149, 18, 'السماح برسالة نصية');
INSERT INTO `lang_definitions` VALUES (25139, 150, 18, 'السماح برسالة نصية ؟');
INSERT INTO `lang_definitions` VALUES (25140, 151, 18, 'السماح بالأحداث المدخلة لتصبح فعالة بسرعة؟');
INSERT INTO `lang_definitions` VALUES (25141, 152, 18, 'السماح بالرسائل الهاتفية');
INSERT INTO `lang_definitions` VALUES (25142, 153, 18, 'السماح للمستخدمين بنشر الأحداث العامة');
INSERT INTO `lang_definitions` VALUES (25143, 154, 18, 'السماح للمستخدمين بنشر المواعيد الشخصية');
INSERT INTO `lang_definitions` VALUES (25144, 155, 18, 'السماح بالرسائل الصوتية');
INSERT INTO `lang_definitions` VALUES (25145, 156, 18, 'مسموح');
INSERT INTO `lang_definitions` VALUES (25146, 157, 18, 'متواجد حالياً');
INSERT INTO `lang_definitions` VALUES (25147, 158, 18, 'مستخدم حالياً ,الرجاء اختيار تعريف آخر');
INSERT INTO `lang_definitions` VALUES (25148, 159, 18, 'مستخدم حالياً,الرجاء اختيار تعريف آخر');
INSERT INTO `lang_definitions` VALUES (25149, 160, 18, 'عنوان بديل');
INSERT INTO `lang_definitions` VALUES (25150, 162, 18, 'بشكل بديل, يمكنك استخدام صفحة البحث');
INSERT INTO `lang_definitions` VALUES (25151, 163, 18, 'صباحاً');
INSERT INTO `lang_definitions` VALUES (25152, 164, 18, 'تغيير ملاحظة موجودة');
INSERT INTO `lang_definitions` VALUES (25153, 165, 18, 'AMEX');
INSERT INTO `lang_definitions` VALUES (25154, 166, 18, 'كمية');
INSERT INTO `lang_definitions` VALUES (25155, 167, 18, 'تكاليف الكمية');
INSERT INTO `lang_definitions` VALUES (25156, 168, 18, 'كمية التوازن الماضي');
INSERT INTO `lang_definitions` VALUES (25157, 169, 18, 'مقدار هذه الزيارة');
INSERT INTO `lang_definitions` VALUES (25158, 170, 18, 'المقدار المدفوع');
INSERT INTO `lang_definitions` VALUES (25159, 171, 18, 'الكمية');
INSERT INTO `lang_definitions` VALUES (25160, 176, 18, 'و');
INSERT INTO `lang_definitions` VALUES (25161, 177, 18, 'و');
INSERT INTO `lang_definitions` VALUES (25162, 178, 18, 'و');
INSERT INTO `lang_definitions` VALUES (25163, 179, 18, 'و');
INSERT INTO `lang_definitions` VALUES (25164, 181, 18, 'فقر دم');
INSERT INTO `lang_definitions` VALUES (25165, 182, 18, 'كاحل');
INSERT INTO `lang_definitions` VALUES (25166, 183, 18, 'الكاحل + العقب');
INSERT INTO `lang_definitions` VALUES (25167, 184, 18, 'نموذج تقييم الكاحل');
INSERT INTO `lang_definitions` VALUES (25168, 185, 18, 'مشاكل الكاحل');
INSERT INTO `lang_definitions` VALUES (25169, 186, 18, 'التهاب الفقار اللاصق');
INSERT INTO `lang_definitions` VALUES (25170, 187, 18, 'التهاب الفقار اللاصق');
INSERT INTO `lang_definitions` VALUES (25171, 188, 18, 'القهم');
INSERT INTO `lang_definitions` VALUES (25172, 190, 18, 'قبل');
INSERT INTO `lang_definitions` VALUES (25173, 191, 18, 'فحص اشرج سوي,لا كتل أو مضض في المستقيم');
INSERT INTO `lang_definitions` VALUES (25174, 192, 18, 'قلق');
INSERT INTO `lang_definitions` VALUES (25175, 193, 18, 'أية');
INSERT INTO `lang_definitions` VALUES (25176, 194, 18, 'أي فئة');
INSERT INTO `lang_definitions` VALUES (25177, 195, 18, 'اي جزء من الرمز المطلوب او وصفه');
INSERT INTO `lang_definitions` VALUES (25178, 196, 18, 'أي جزء من الإختصاص المطلوب');
INSERT INTO `lang_definitions` VALUES (25179, 197, 18, 'أي جزء من اسم المريض');
INSERT INTO `lang_definitions` VALUES (25180, 198, 18, 'توقف تنفس');
INSERT INTO `lang_definitions` VALUES (25181, 199, 18, 'مظهر');
INSERT INTO `lang_definitions` VALUES (25182, 200, 18, 'مظهر:');
INSERT INTO `lang_definitions` VALUES (25183, 201, 18, 'اضافة الى الملاحظة الموجودة');
INSERT INTO `lang_definitions` VALUES (25184, 202, 18, 'اضافة الى هذه الملاحظة');
INSERT INTO `lang_definitions` VALUES (25185, 203, 18, 'اضافة الى هذه الملاحظة');
INSERT INTO `lang_definitions` VALUES (25186, 204, 18, 'استئصال الزائدة');
INSERT INTO `lang_definitions` VALUES (25187, 206, 18, 'تطبيق على المنطقة المصابة');
INSERT INTO `lang_definitions` VALUES (25188, 207, 18, 'تطبيق على الجلد');
INSERT INTO `lang_definitions` VALUES (25189, 208, 18, 'تطبيق');
INSERT INTO `lang_definitions` VALUES (25190, 209, 18, 'تاريخ الموعد');
INSERT INTO `lang_definitions` VALUES (25191, 210, 18, 'حالة الموعد');
INSERT INTO `lang_definitions` VALUES (25192, 211, 18, 'الموعد خلال');
INSERT INTO `lang_definitions` VALUES (25193, 212, 18, 'المواعيد');
INSERT INTO `lang_definitions` VALUES (25194, 213, 18, 'المواعيد (الكتابة اختيارية)');
INSERT INTO `lang_definitions` VALUES (25195, 214, 18, 'المواعيد والمقابلات');
INSERT INTO `lang_definitions` VALUES (25196, 215, 18, 'تقرير بالمواعيد');
INSERT INTO `lang_definitions` VALUES (25197, 216, 18, 'تقرير بالمواعيد والمقابلات');
INSERT INTO `lang_definitions` VALUES (25198, 217, 18, 'موافق');
INSERT INTO `lang_definitions` VALUES (25199, 218, 18, 'الموافقة');
INSERT INTO `lang_definitions` VALUES (25200, 219, 18, 'ادارة الأحداث الموافقة');
INSERT INTO `lang_definitions` VALUES (25201, 220, 18, 'المواعيد والمقابلات');
INSERT INTO `lang_definitions` VALUES (25202, 221, 18, 'المواعيد');
INSERT INTO `lang_definitions` VALUES (25203, 222, 18, 'نيسان');
INSERT INTO `lang_definitions` VALUES (25204, 1, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25205, 2, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25206, 3, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25207, 4, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25208, 5, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25209, 6, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25210, 7, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25211, 8, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25212, 9, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25213, 10, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25214, 11, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25215, 12, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25216, 13, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25217, 14, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25218, 15, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25219, 16, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25220, 17, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25221, 18, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25222, 19, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25223, 20, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25224, 21, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25225, 22, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25226, 23, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25227, 24, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25228, 25, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25229, 26, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25230, 27, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25231, 28, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25232, 29, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25233, 30, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25234, 31, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25235, 32, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25236, 33, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25237, 34, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25238, 35, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25239, 36, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25240, 37, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25241, 38, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25242, 39, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25243, 40, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25244, 41, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25245, 42, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25246, 43, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25247, 44, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25248, 45, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25249, 46, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25250, 47, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25251, 48, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25252, 49, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25253, 50, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25254, 51, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25255, 52, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25256, 53, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25257, 54, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25258, 55, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25259, 56, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25260, 57, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25261, 58, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25262, 59, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25263, 60, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25264, 61, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25265, 62, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25266, 63, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25267, 64, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25268, 65, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25269, 66, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25270, 67, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25271, 68, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25272, 69, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25273, 70, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25274, 71, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25275, 72, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25276, 73, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25277, 74, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25278, 75, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25279, 76, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25280, 77, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25281, 78, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25282, 79, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25283, 80, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25284, 81, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25285, 82, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25286, 83, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25287, 84, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25288, 85, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25289, 86, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25290, 87, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25291, 88, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25292, 89, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25293, 90, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25294, 91, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25295, 92, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25296, 93, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25297, 94, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25298, 95, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25299, 96, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25300, 97, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25301, 98, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25302, 99, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25303, 100, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25304, 101, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25305, 102, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25306, 103, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25307, 104, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25308, 105, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25309, 106, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25310, 107, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25311, 108, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25312, 109, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25313, 110, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25314, 111, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25315, 112, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25316, 113, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25317, 114, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25318, 115, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25319, 116, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25320, 117, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25321, 118, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25322, 119, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25323, 120, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25324, 121, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25325, 122, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25326, 123, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25327, 124, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25328, 125, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25329, 126, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25330, 127, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25331, 128, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25332, 129, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25333, 130, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25334, 131, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25335, 132, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25336, 133, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25337, 134, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25338, 135, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25339, 136, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25340, 137, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25341, 138, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25342, 139, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25343, 140, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25344, 141, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25345, 142, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25346, 143, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25347, 144, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25348, 145, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25349, 146, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25350, 147, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25351, 148, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25352, 149, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25353, 150, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25354, 151, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25355, 152, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25356, 153, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25357, 154, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25358, 155, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25359, 156, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25360, 157, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25361, 158, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25362, 159, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25363, 160, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25364, 161, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25365, 162, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25366, 163, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25367, 164, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25368, 165, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25369, 166, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25370, 167, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25371, 168, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25372, 169, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25373, 170, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25374, 171, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25375, 172, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25376, 173, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25377, 174, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25378, 175, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25379, 176, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25380, 177, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25381, 178, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25382, 179, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25383, 180, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25384, 181, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25385, 182, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25386, 183, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25387, 184, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25388, 185, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25389, 186, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25390, 187, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25391, 188, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25392, 189, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25393, 190, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25394, 191, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25395, 192, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25396, 193, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25397, 194, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25398, 195, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25399, 196, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25400, 197, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25401, 198, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25402, 199, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25403, 200, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25404, 201, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25405, 202, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25406, 203, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25407, 204, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25408, 205, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25409, 206, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25410, 207, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25411, 208, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25412, 209, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25413, 210, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25414, 211, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25415, 212, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25416, 213, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25417, 214, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25418, 215, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25419, 216, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25420, 217, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25421, 218, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25422, 219, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25423, 220, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25424, 221, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25425, 222, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25426, 223, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25427, 224, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25428, 225, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25429, 226, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25430, 227, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25431, 228, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25432, 229, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25433, 230, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25434, 231, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25435, 232, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25436, 233, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25437, 234, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25438, 235, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25439, 236, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25440, 237, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25441, 238, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25442, 239, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25443, 240, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25444, 241, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25445, 242, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25446, 243, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25447, 244, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25448, 245, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25449, 246, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25450, 247, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25451, 248, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25452, 249, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25453, 250, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25454, 251, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25455, 252, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25456, 253, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25457, 254, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25458, 255, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25459, 256, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25460, 257, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25461, 258, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25462, 259, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25463, 260, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25464, 261, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25465, 262, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25466, 263, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25467, 264, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25468, 265, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25469, 266, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25470, 267, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25471, 268, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25472, 269, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25473, 270, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25474, 271, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25475, 272, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25476, 273, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25477, 274, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25478, 275, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25479, 276, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25480, 277, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25481, 278, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25482, 279, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25483, 280, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25484, 281, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25485, 282, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25486, 283, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25487, 284, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25488, 285, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25489, 286, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25490, 287, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25491, 288, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25492, 289, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25493, 290, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25494, 291, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25495, 292, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25496, 293, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25497, 294, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25498, 295, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25499, 296, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25500, 297, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25501, 298, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25502, 299, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25503, 300, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25504, 301, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25505, 302, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25506, 303, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25507, 304, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25508, 305, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25509, 306, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25510, 307, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25511, 308, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25512, 309, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25513, 310, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25514, 311, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25515, 312, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25516, 313, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25517, 314, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25518, 315, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25519, 316, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25520, 317, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25521, 318, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25522, 319, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25523, 320, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25524, 321, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25525, 322, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25526, 323, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25527, 324, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25528, 325, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25529, 326, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25530, 327, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25531, 328, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25532, 329, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25533, 330, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25534, 331, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25535, 332, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25536, 333, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25537, 334, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25538, 335, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25539, 336, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25540, 337, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25541, 338, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25542, 339, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25543, 340, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25544, 341, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25545, 342, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25546, 343, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25547, 344, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25548, 345, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25549, 346, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25550, 347, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25551, 348, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25552, 349, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25553, 350, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25554, 351, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25555, 352, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25556, 353, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25557, 354, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25558, 355, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25559, 356, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25560, 357, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25561, 358, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25562, 359, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25563, 360, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25564, 361, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25565, 362, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25566, 363, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25567, 364, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25568, 365, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25569, 366, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25570, 367, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25571, 368, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25572, 369, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25573, 370, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25574, 371, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25575, 372, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25576, 373, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25577, 374, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25578, 375, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25579, 376, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25580, 377, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25581, 378, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25582, 379, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25583, 380, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25584, 381, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25585, 382, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25586, 383, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25587, 384, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25588, 385, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25589, 386, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25590, 387, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25591, 388, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25592, 389, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25593, 390, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25594, 391, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25595, 392, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25596, 393, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25597, 394, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25598, 395, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25599, 396, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25600, 397, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25601, 398, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25602, 399, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25603, 400, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25604, 401, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25605, 402, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25606, 403, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25607, 404, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25608, 405, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25609, 406, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25610, 407, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25611, 408, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25612, 409, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25613, 410, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25614, 411, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25615, 412, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25616, 413, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25617, 414, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25618, 415, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25619, 416, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25620, 417, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25621, 418, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25622, 419, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25623, 420, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25624, 421, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25625, 422, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25626, 423, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25627, 424, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25628, 425, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25629, 426, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25630, 427, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25631, 428, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25632, 429, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25633, 430, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25634, 431, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25635, 432, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25636, 433, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25637, 434, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25638, 435, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25639, 436, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25640, 437, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25641, 438, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25642, 439, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25643, 440, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25644, 441, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25645, 442, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25646, 443, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25647, 444, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25648, 445, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25649, 446, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25650, 447, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25651, 448, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25652, 449, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25653, 450, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25654, 451, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25655, 452, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25656, 453, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25657, 454, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25658, 455, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25659, 456, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25660, 457, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25661, 458, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25662, 459, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25663, 460, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25664, 461, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25665, 462, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25666, 463, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25667, 464, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25668, 465, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25669, 466, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25670, 467, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25671, 468, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25672, 469, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25673, 470, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25674, 471, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25675, 472, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25676, 473, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25677, 474, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25678, 475, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25679, 476, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25680, 477, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25681, 478, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25682, 479, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25683, 480, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25684, 481, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25685, 482, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25686, 483, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25687, 484, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25688, 485, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25689, 486, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25690, 487, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25691, 488, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25692, 489, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25693, 490, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25694, 491, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25695, 492, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25696, 493, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25697, 494, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25698, 495, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25699, 496, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25700, 497, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25701, 498, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25702, 499, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25703, 500, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25704, 501, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25705, 502, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25706, 503, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25707, 504, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25708, 505, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25709, 506, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25710, 507, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25711, 508, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25712, 509, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25713, 510, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25714, 511, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25715, 512, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25716, 513, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25717, 514, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25718, 515, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25719, 516, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25720, 517, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25721, 518, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25722, 519, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25723, 520, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25724, 521, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25725, 522, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25726, 523, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25727, 524, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25728, 525, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25729, 526, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25730, 527, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25731, 528, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25732, 529, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25733, 530, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25734, 531, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25735, 532, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25736, 533, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25737, 534, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25738, 535, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25739, 536, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25740, 537, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25741, 538, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25742, 539, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25743, 540, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25744, 541, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25745, 542, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25746, 543, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25747, 544, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25748, 545, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25749, 546, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25750, 547, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25751, 548, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25752, 549, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25753, 550, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25754, 551, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25755, 552, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25756, 553, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25757, 554, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25758, 555, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25759, 556, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25760, 557, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25761, 558, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25762, 559, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25763, 560, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25764, 561, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25765, 562, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25766, 563, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25767, 564, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25768, 565, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25769, 566, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25770, 567, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25771, 568, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25772, 569, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25773, 570, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25774, 571, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25775, 572, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25776, 573, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25777, 574, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25778, 575, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25779, 576, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25780, 577, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25781, 578, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25782, 579, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25783, 580, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25784, 581, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25785, 582, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25786, 583, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25787, 584, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25788, 585, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25789, 586, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25790, 587, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25791, 588, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25792, 589, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25793, 590, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25794, 591, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25795, 592, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25796, 593, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25797, 594, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25798, 595, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25799, 596, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25800, 597, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25801, 598, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25802, 599, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25803, 600, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25804, 601, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25805, 602, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25806, 603, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25807, 604, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25808, 605, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25809, 606, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25810, 607, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25811, 608, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25812, 609, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25813, 610, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25814, 611, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25815, 612, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25816, 613, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25817, 614, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25818, 615, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25819, 616, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25820, 617, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25821, 618, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25822, 619, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25823, 620, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25824, 621, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25825, 622, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25826, 623, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25827, 624, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25828, 625, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25829, 626, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25830, 627, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25831, 628, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25832, 629, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25833, 630, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25834, 631, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25835, 632, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25836, 633, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25837, 634, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25838, 635, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25839, 636, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25840, 637, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25841, 638, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25842, 639, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25843, 640, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25844, 641, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25845, 642, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25846, 643, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25847, 644, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25848, 645, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25849, 646, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25850, 647, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25851, 648, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25852, 649, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25853, 650, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25854, 651, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25855, 652, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25856, 653, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25857, 654, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25858, 655, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25859, 656, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25860, 657, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25861, 658, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25862, 659, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25863, 660, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25864, 661, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25865, 662, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25866, 663, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25867, 664, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25868, 665, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25869, 666, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25870, 667, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25871, 668, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25872, 669, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25873, 670, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25874, 671, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25875, 672, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25876, 673, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25877, 674, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25878, 675, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25879, 676, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25880, 677, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25881, 678, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25882, 679, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25883, 680, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25884, 681, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25885, 682, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25886, 683, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25887, 684, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25888, 685, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25889, 686, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25890, 687, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25891, 688, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25892, 689, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25893, 690, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25894, 691, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25895, 692, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25896, 693, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25897, 694, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25898, 695, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25899, 696, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25900, 697, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25901, 698, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25902, 699, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25903, 700, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25904, 701, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25905, 702, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25906, 703, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25907, 704, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25908, 705, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25909, 706, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25910, 707, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25911, 708, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25912, 709, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25913, 710, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25914, 711, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25915, 712, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25916, 713, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25917, 714, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25918, 715, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25919, 716, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25920, 717, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25921, 718, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25922, 719, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25923, 720, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25924, 721, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25925, 722, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25926, 723, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25927, 724, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25928, 725, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25929, 726, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25930, 727, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25931, 728, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25932, 729, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25933, 730, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25934, 731, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25935, 732, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25936, 733, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25937, 734, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25938, 735, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25939, 736, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25940, 737, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25941, 738, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25942, 739, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25943, 740, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25944, 741, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25945, 742, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25946, 743, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25947, 744, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25948, 745, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25949, 746, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25950, 747, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25951, 748, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25952, 749, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25953, 750, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25954, 751, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25955, 752, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25956, 753, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25957, 754, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25958, 755, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25959, 756, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25960, 757, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25961, 758, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25962, 759, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25963, 760, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25964, 761, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25965, 762, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25966, 763, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25967, 764, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25968, 765, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25969, 766, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25970, 767, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25971, 768, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25972, 769, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25973, 770, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25974, 771, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25975, 772, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25976, 773, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25977, 774, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25978, 775, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25979, 776, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25980, 777, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25981, 778, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25982, 779, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25983, 780, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25984, 781, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25985, 782, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25986, 783, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25987, 784, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25988, 785, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25989, 786, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25990, 787, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25991, 788, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25992, 789, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25993, 790, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25994, 791, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25995, 792, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25996, 793, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25997, 794, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25998, 795, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (25999, 796, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26000, 797, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26001, 798, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26002, 799, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26003, 800, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26004, 801, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26005, 802, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26006, 803, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26007, 804, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26008, 805, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26009, 806, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26010, 807, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26011, 808, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26012, 809, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26013, 810, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26014, 811, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26015, 812, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26016, 813, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26017, 814, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26018, 815, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26019, 816, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26020, 817, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26021, 818, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26022, 819, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26023, 820, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26024, 821, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26025, 822, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26026, 823, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26027, 824, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26028, 825, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26029, 826, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26030, 827, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26031, 828, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26032, 829, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26033, 830, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26034, 831, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26035, 832, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26036, 833, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26037, 834, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26038, 835, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26039, 836, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26040, 837, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26041, 838, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26042, 839, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26043, 840, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26044, 841, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26045, 842, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26046, 843, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26047, 844, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26048, 845, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26049, 846, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26050, 847, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26051, 848, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26052, 849, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26053, 850, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26054, 851, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26055, 852, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26056, 853, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26057, 854, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26058, 855, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26059, 856, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26060, 857, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26061, 858, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26062, 859, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26063, 860, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26064, 861, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26065, 862, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26066, 863, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26067, 864, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26068, 865, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26069, 866, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26070, 867, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26071, 868, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26072, 869, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26073, 870, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26074, 871, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26075, 872, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26076, 873, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26077, 874, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26078, 875, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26079, 876, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26080, 877, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26081, 878, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26082, 879, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26083, 880, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26084, 881, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26085, 882, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26086, 883, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26087, 884, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26088, 885, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26089, 886, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26090, 887, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26091, 888, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26092, 889, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26093, 890, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26094, 891, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26095, 892, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26096, 893, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26097, 894, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26098, 895, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26099, 896, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26100, 897, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26101, 898, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26102, 899, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26103, 900, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26104, 901, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26105, 902, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26106, 903, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26107, 904, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26108, 905, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26109, 906, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26110, 907, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26111, 908, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26112, 909, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26113, 910, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26114, 911, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26115, 912, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26116, 913, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26117, 914, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26118, 915, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26119, 916, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26120, 917, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26121, 918, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26122, 919, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26123, 920, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26124, 921, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26125, 922, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26126, 923, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26127, 924, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26128, 925, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26129, 926, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26130, 927, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26131, 928, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26132, 929, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26133, 930, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26134, 931, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26135, 932, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26136, 933, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26137, 934, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26138, 935, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26139, 936, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26140, 937, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26141, 938, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26142, 939, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26143, 940, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26144, 941, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26145, 942, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26146, 943, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26147, 944, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26148, 945, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26149, 946, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26150, 947, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26151, 948, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26152, 949, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26153, 950, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26154, 951, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26155, 952, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26156, 953, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26157, 954, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26158, 955, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26159, 956, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26160, 957, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26161, 958, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26162, 959, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26163, 960, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26164, 961, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26165, 962, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26166, 963, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26167, 964, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26168, 965, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26169, 966, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26170, 967, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26171, 968, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26172, 969, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26173, 970, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26174, 971, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26175, 972, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26176, 973, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26177, 974, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26178, 975, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26179, 976, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26180, 977, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26181, 978, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26182, 979, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26183, 980, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26184, 981, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26185, 982, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26186, 983, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26187, 984, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26188, 985, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26189, 986, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26190, 987, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26191, 988, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26192, 989, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26193, 990, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26194, 991, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26195, 992, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26196, 993, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26197, 994, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26198, 995, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26199, 996, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26200, 997, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26201, 998, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26202, 999, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26203, 1000, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26204, 1001, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26205, 1002, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26206, 1003, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26207, 1004, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26208, 1005, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26209, 1006, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26210, 1007, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26211, 1008, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26212, 1009, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26213, 1010, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26214, 1011, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26215, 1012, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26216, 1013, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26217, 1014, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26218, 1015, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26219, 1016, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26220, 1017, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26221, 1018, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26222, 1019, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26223, 1020, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26224, 1021, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26225, 1022, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26226, 1023, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26227, 1024, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26228, 1025, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26229, 1026, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26230, 1027, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26231, 1028, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26232, 1029, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26233, 1030, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26234, 1031, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26235, 1032, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26236, 1033, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26237, 1034, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26238, 1035, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26239, 1036, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26240, 1037, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26241, 1038, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26242, 1039, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26243, 1040, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26244, 1041, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26245, 1042, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26246, 1043, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26247, 1044, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26248, 1045, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26249, 1046, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26250, 1047, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26251, 1048, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26252, 1049, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26253, 1050, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26254, 1051, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26255, 1052, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26256, 1053, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26257, 1054, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26258, 1055, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26259, 1056, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26260, 1057, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26261, 1058, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26262, 1059, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26263, 1060, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26264, 1061, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26265, 1062, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26266, 1063, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26267, 1064, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26268, 1065, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26269, 1066, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26270, 1067, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26271, 1068, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26272, 1069, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26273, 1070, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26274, 1071, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26275, 1072, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26276, 1073, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26277, 1074, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26278, 1075, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26279, 1076, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26280, 1077, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26281, 1078, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26282, 1079, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26283, 1080, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26284, 1081, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26285, 1082, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26286, 1083, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26287, 1084, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26288, 1085, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26289, 1086, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26290, 1087, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26291, 1088, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26292, 1089, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26293, 1090, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26294, 1091, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26295, 1092, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26296, 1093, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26297, 1094, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26298, 1095, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26299, 1096, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26300, 1097, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26301, 1098, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26302, 1099, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26303, 1100, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26304, 1101, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26305, 1102, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26306, 1103, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26307, 1104, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26308, 1105, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26309, 1106, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26310, 1107, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26311, 1108, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26312, 1109, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26313, 1110, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26314, 1111, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26315, 1112, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26316, 1113, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26317, 1114, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26318, 1115, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26319, 1116, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26320, 1117, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26321, 1118, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26322, 1119, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26323, 1120, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26324, 1121, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26325, 1122, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26326, 1123, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26327, 1124, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26328, 1125, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26329, 1126, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26330, 1127, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26331, 1128, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26332, 1129, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26333, 1130, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26334, 1131, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26335, 1132, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26336, 1133, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26337, 1134, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26338, 1135, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26339, 1136, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26340, 1137, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26341, 1138, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26342, 1139, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26343, 1140, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26344, 1141, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26345, 1142, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26346, 1143, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26347, 1144, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26348, 1145, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26349, 1146, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26350, 1147, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26351, 1148, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26352, 1149, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26353, 1150, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26354, 1151, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26355, 1152, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26356, 1153, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26357, 1154, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26358, 1155, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26359, 1156, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26360, 1157, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26361, 1158, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26362, 1159, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26363, 1160, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26364, 1161, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26365, 1162, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26366, 1163, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26367, 1164, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26368, 1165, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26369, 1166, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26370, 1167, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26371, 1168, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26372, 1169, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26373, 1170, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26374, 1171, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26375, 1172, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26376, 1173, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26377, 1174, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26378, 1175, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26379, 1176, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26380, 1177, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26381, 1178, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26382, 1179, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26383, 1180, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26384, 1181, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26385, 1182, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26386, 1183, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26387, 1184, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26388, 1185, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26389, 1186, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26390, 1187, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26391, 1188, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26392, 1189, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26393, 1190, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26394, 1191, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26395, 1192, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26396, 1193, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26397, 1194, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26398, 1195, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26399, 1196, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26400, 1197, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26401, 1198, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26402, 1199, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26403, 1200, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26404, 1201, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26405, 1202, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26406, 1203, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26407, 1204, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26408, 1205, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26409, 1206, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26410, 1207, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26411, 1208, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26412, 1209, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26413, 1210, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26414, 1211, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26415, 1212, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26416, 1213, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26417, 1214, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26418, 1215, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26419, 1216, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26420, 1217, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26421, 1218, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26422, 1219, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26423, 1220, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26424, 1221, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26425, 1222, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26426, 1223, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26427, 1224, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26428, 1225, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26429, 1226, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26430, 1227, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26431, 1228, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26432, 1229, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26433, 1230, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26434, 1231, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26435, 1232, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26436, 1233, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26437, 1234, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26438, 1235, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26439, 1236, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26440, 1237, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26441, 1238, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26442, 1239, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26443, 1240, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26444, 1241, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26445, 1242, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26446, 1243, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26447, 1244, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26448, 1245, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26449, 1246, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26450, 1247, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26451, 1248, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26452, 1249, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26453, 1250, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26454, 1251, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26455, 1252, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26456, 1253, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26457, 1254, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26458, 1255, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26459, 1256, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26460, 1257, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26461, 1258, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26462, 1259, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26463, 1260, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26464, 1261, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26465, 1262, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26466, 1263, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26467, 1264, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26468, 1265, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26469, 1266, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26470, 1267, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26471, 1268, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26472, 1269, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26473, 1270, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26474, 1271, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26475, 1272, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26476, 1273, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26477, 1274, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26478, 1275, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26479, 1276, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26480, 1277, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26481, 1278, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26482, 1279, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26483, 1280, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26484, 1281, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26485, 1282, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26486, 1283, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26487, 1284, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26488, 1285, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26489, 1286, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26490, 1287, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26491, 1288, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26492, 1289, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26493, 1290, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26494, 1291, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26495, 1292, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26496, 1293, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26497, 1294, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26498, 1295, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26499, 1296, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26500, 1297, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26501, 1298, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26502, 1299, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26503, 1300, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26504, 1301, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26505, 1302, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26506, 1303, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26507, 1304, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26508, 1305, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26509, 1306, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26510, 1307, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26511, 1308, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26512, 1309, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26513, 1310, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26514, 1311, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26515, 1312, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26516, 1313, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26517, 1314, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26518, 1315, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26519, 1316, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26520, 1317, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26521, 1318, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26522, 1319, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26523, 1320, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26524, 1321, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26525, 1322, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26526, 1323, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26527, 1324, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26528, 1325, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26529, 1326, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26530, 1327, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26531, 1328, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26532, 1329, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26533, 1330, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26534, 1331, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26535, 1332, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26536, 1333, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26537, 1334, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26538, 1335, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26539, 1336, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26540, 1337, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26541, 1338, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26542, 1339, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26543, 1340, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26544, 1341, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26545, 1342, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26546, 1343, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26547, 1344, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26548, 1345, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26549, 1346, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26550, 1347, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26551, 1348, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26552, 1349, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26553, 1350, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26554, 1351, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26555, 1352, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26556, 1353, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26557, 1354, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26558, 1355, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26559, 1356, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26560, 1357, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26561, 1358, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26562, 1359, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26563, 1360, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26564, 1361, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26565, 1362, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26566, 1363, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26567, 1364, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26568, 1365, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26569, 1366, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26570, 1367, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26571, 1368, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26572, 1369, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26573, 1370, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26574, 1371, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26575, 1372, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26576, 1373, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26577, 1374, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26578, 1375, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26579, 1376, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26580, 1377, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26581, 1378, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26582, 1379, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26583, 1380, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26584, 1381, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26585, 1382, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26586, 1383, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26587, 1384, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26588, 1385, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26589, 1386, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26590, 1387, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26591, 1388, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26592, 1389, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26593, 1390, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26594, 1391, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26595, 1392, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26596, 1393, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26597, 1394, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26598, 1395, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26599, 1396, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26600, 1397, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26601, 1398, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26602, 1399, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26603, 1400, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26604, 1401, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26605, 1402, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26606, 1403, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26607, 1404, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26608, 1405, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26609, 1406, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26610, 1407, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26611, 1408, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26612, 1409, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26613, 1410, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26614, 1411, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26615, 1412, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26616, 1413, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26617, 1414, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26618, 1415, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26619, 1416, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26620, 1417, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26621, 1418, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26622, 1419, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26623, 1420, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26624, 1421, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26625, 1422, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26626, 1423, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26627, 1424, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26628, 1425, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26629, 1426, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26630, 1427, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26631, 1428, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26632, 1429, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26633, 1430, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26634, 1431, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26635, 1432, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26636, 1433, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26637, 1434, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26638, 1435, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26639, 1436, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26640, 1437, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26641, 1438, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26642, 1439, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26643, 1440, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26644, 1441, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26645, 1442, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26646, 1443, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26647, 1444, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26648, 1445, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26649, 1446, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26650, 1447, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26651, 1448, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26652, 1449, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26653, 1450, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26654, 1451, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26655, 1452, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26656, 1453, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26657, 1454, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26658, 1455, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26659, 1456, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26660, 1457, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26661, 1458, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26662, 1459, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26663, 1460, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26664, 1461, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26665, 1462, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26666, 1463, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26667, 1464, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26668, 1465, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26669, 1466, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26670, 1467, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26671, 1468, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26672, 1469, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26673, 1470, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26674, 1471, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26675, 1472, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26676, 1473, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26677, 1474, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26678, 1475, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26679, 1476, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26680, 1477, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26681, 1478, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26682, 1479, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26683, 1480, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26684, 1481, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26685, 1482, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26686, 1483, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26687, 1484, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26688, 1485, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26689, 1486, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26690, 1487, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26691, 1488, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26692, 1489, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26693, 1490, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26694, 1491, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26695, 1492, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26696, 1493, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26697, 1494, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26698, 1495, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26699, 1496, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26700, 1497, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26701, 1498, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26702, 1499, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26703, 1500, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26704, 1501, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26705, 1502, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26706, 1503, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26707, 1504, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26708, 1505, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26709, 1506, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26710, 1507, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26711, 1508, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26712, 1509, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26713, 1510, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26714, 1511, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26715, 1512, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26716, 1513, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26717, 1514, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26718, 1515, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26719, 1516, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26720, 1517, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26721, 1518, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26722, 1519, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26723, 1520, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26724, 1521, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26725, 1522, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26726, 1523, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26727, 1524, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26728, 1525, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26729, 1526, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26730, 1527, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26731, 1528, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26732, 1529, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26733, 1530, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26734, 1531, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26735, 1532, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26736, 1533, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26737, 1534, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26738, 1535, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26739, 1536, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26740, 1537, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26741, 1538, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26742, 1539, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26743, 1540, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26744, 1541, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26745, 1542, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26746, 1543, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26747, 1544, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26748, 1545, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26749, 1546, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26750, 1547, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26751, 1548, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26752, 1549, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26753, 1550, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26754, 1551, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26755, 1552, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26756, 1553, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26757, 1554, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26758, 1555, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26759, 1556, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26760, 1557, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26761, 1558, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26762, 1559, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26763, 1560, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26764, 1561, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26765, 1562, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26766, 1563, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26767, 1564, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26768, 1565, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26769, 1566, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26770, 1567, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26771, 1568, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26772, 1569, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26773, 1570, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26774, 1571, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26775, 1572, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26776, 1573, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26777, 1574, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26778, 1575, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26779, 1576, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26780, 1577, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26781, 1578, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26782, 1579, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26783, 1580, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26784, 1581, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26785, 1582, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26786, 1583, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26787, 1584, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26788, 1585, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26789, 1586, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26790, 1587, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26791, 1588, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26792, 1589, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26793, 1590, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26794, 1591, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26795, 1592, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26796, 1593, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26797, 1594, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26798, 1595, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26799, 1596, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26800, 1597, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26801, 1598, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26802, 1599, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26803, 1600, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26804, 1601, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26805, 1602, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26806, 1603, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26807, 1604, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26808, 1605, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26809, 1606, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26810, 1607, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26811, 1608, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26812, 1609, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26813, 1610, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26814, 1611, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26815, 1612, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26816, 1613, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26817, 1614, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26818, 1615, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26819, 1616, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26820, 1617, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26821, 1618, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26822, 1619, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26823, 1620, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26824, 1621, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26825, 1622, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26826, 1623, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26827, 1624, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26828, 1625, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26829, 1626, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26830, 1627, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26831, 1628, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26832, 1629, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26833, 1630, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26834, 1631, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26835, 1632, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26836, 1633, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26837, 1634, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26838, 1635, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26839, 1636, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26840, 1637, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26841, 1638, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26842, 1639, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26843, 1640, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26844, 1641, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26845, 1642, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26846, 1643, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26847, 1644, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26848, 1645, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26849, 1646, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26850, 1647, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26851, 1648, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26852, 1649, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26853, 1650, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26854, 1651, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26855, 1652, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26856, 1653, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26857, 1654, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26858, 1655, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26859, 1656, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26860, 1657, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26861, 1658, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26862, 1659, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26863, 1660, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26864, 1661, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26865, 1662, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26866, 1663, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26867, 1664, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26868, 1665, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26869, 1666, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26870, 1667, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26871, 1668, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26872, 1669, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26873, 1670, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26874, 1671, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26875, 1672, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26876, 1673, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26877, 1674, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26878, 1675, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26879, 1676, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26880, 1677, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26881, 1678, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26882, 1679, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26883, 1680, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26884, 1681, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26885, 1682, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26886, 1683, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26887, 1684, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26888, 1685, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26889, 1686, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26890, 1687, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26891, 1688, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26892, 1689, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26893, 1690, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26894, 1691, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26895, 1692, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26896, 1693, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26897, 1694, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26898, 1695, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26899, 1696, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26900, 1697, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26901, 1698, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26902, 1699, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26903, 1700, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26904, 1701, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26905, 1702, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26906, 1703, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26907, 1704, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26908, 1705, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26909, 1706, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26910, 1707, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26911, 1708, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26912, 1709, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26913, 1710, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26914, 1711, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26915, 1712, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26916, 1713, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26917, 1714, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26918, 1715, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26919, 1716, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26920, 1717, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26921, 1718, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26922, 1719, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26923, 1720, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26924, 1721, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26925, 1722, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26926, 1723, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26927, 1724, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26928, 1725, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26929, 1726, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26930, 1727, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26931, 1728, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26932, 1729, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26933, 1730, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26934, 1731, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26935, 1732, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26936, 1733, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26937, 1734, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26938, 1735, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26939, 1736, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26940, 1737, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26941, 1738, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26942, 1739, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26943, 1740, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26944, 1741, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26945, 1742, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26946, 1743, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26947, 1744, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26948, 1745, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26949, 1746, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26950, 1747, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26951, 1748, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26952, 1749, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26953, 1750, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26954, 1751, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26955, 1752, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26956, 1753, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26957, 1754, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26958, 1755, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26959, 1756, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26960, 1757, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26961, 1758, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26962, 1759, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26963, 1760, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26964, 1761, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26965, 1762, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26966, 1763, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26967, 1764, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26968, 1765, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26969, 1766, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26970, 1767, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26971, 1768, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26972, 1769, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26973, 1770, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26974, 1771, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26975, 1772, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26976, 1773, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26977, 1774, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26978, 1775, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26979, 1776, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26980, 1777, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26981, 1778, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26982, 1779, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26983, 1780, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26984, 1781, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26985, 1782, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26986, 1783, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26987, 1784, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26988, 1785, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26989, 1786, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26990, 1787, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26991, 1788, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26992, 1789, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26993, 1790, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26994, 1791, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26995, 1792, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26996, 1793, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26997, 1794, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26998, 1795, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (26999, 1796, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27000, 1797, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27001, 1798, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27002, 1799, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27003, 1800, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27004, 1801, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27005, 1802, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27006, 1803, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27007, 1804, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27008, 1805, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27009, 1806, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27010, 1807, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27011, 1808, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27012, 1809, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27013, 1810, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27014, 1811, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27015, 1812, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27016, 1813, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27017, 1814, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27018, 1815, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27019, 1816, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27020, 1817, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27021, 1818, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27022, 1819, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27023, 1820, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27024, 1821, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27025, 1822, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27026, 1823, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27027, 1824, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27028, 1825, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27029, 1826, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27030, 1827, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27031, 1828, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27032, 1829, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27033, 1830, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27034, 1831, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27035, 1832, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27036, 1833, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27037, 1834, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27038, 1835, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27039, 1836, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27040, 1837, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27041, 1838, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27042, 1839, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27043, 1840, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27044, 1841, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27045, 1842, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27046, 1843, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27047, 1844, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27048, 1845, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27049, 1846, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27050, 1847, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27051, 1848, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27052, 1849, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27053, 1850, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27054, 1851, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27055, 1852, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27056, 1853, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27057, 1854, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27058, 1855, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27059, 1856, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27060, 1857, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27061, 1858, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27062, 1859, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27063, 1860, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27064, 1861, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27065, 1862, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27066, 1863, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27067, 1864, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27068, 1865, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27069, 1866, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27070, 1867, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27071, 1868, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27072, 1869, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27073, 1870, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27074, 1871, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27075, 1872, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27076, 1873, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27077, 1874, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27078, 1875, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27079, 1876, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27080, 1877, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27081, 1878, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27082, 1879, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27083, 1880, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27084, 1881, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27085, 1882, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27086, 1883, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27087, 1884, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27088, 1885, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27089, 1886, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27090, 1887, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27091, 1888, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27092, 1889, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27093, 1890, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27094, 1891, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27095, 1892, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27096, 1893, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27097, 1894, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27098, 1895, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27099, 1896, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27100, 1897, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27101, 1898, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27102, 1899, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27103, 1900, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27104, 1901, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27105, 1902, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27106, 1903, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27107, 1904, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27108, 1905, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27109, 1906, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27110, 1907, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27111, 1908, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27112, 1909, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27113, 1910, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27114, 1911, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27115, 1912, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27116, 1913, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27117, 1914, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27118, 1915, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27119, 1916, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27120, 1917, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27121, 1918, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27122, 1919, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27123, 1920, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27124, 1921, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27125, 1922, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27126, 1923, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27127, 1924, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27128, 1925, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27129, 1926, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27130, 1927, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27131, 1928, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27132, 1929, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27133, 1930, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27134, 1931, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27135, 1932, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27136, 1933, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27137, 1934, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27138, 1935, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27139, 1936, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27140, 1937, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27141, 1938, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27142, 1939, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27143, 1940, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27144, 1941, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27145, 1942, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27146, 1943, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27147, 1944, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27148, 1945, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27149, 1946, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27150, 1947, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27151, 1948, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27152, 1949, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27153, 1950, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27154, 1951, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27155, 1952, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27156, 1953, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27157, 1954, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27158, 1955, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27159, 1956, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27160, 1957, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27161, 1958, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27162, 1959, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27163, 1960, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27164, 1961, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27165, 1962, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27166, 1963, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27167, 1964, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27168, 1965, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27169, 1966, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27170, 1967, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27171, 1968, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27172, 1969, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27173, 1970, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27174, 1971, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27175, 1972, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27176, 1973, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27177, 1974, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27178, 1975, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27179, 1976, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27180, 1977, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27181, 1978, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27182, 1979, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27183, 1980, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27184, 1981, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27185, 1982, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27186, 1983, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27187, 1984, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27188, 1985, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27189, 1986, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27190, 1987, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27191, 1988, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27192, 1989, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27193, 1990, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27194, 1991, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27195, 1992, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27196, 1993, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27197, 1994, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27198, 1995, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27199, 1996, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27200, 1997, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27201, 1998, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27202, 1999, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27203, 2000, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27204, 2001, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27205, 2002, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27206, 2003, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27207, 2004, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27208, 2005, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27209, 2006, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27210, 2007, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27211, 2008, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27212, 2009, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27213, 2010, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27214, 2011, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27215, 2012, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27216, 2013, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27217, 2014, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27218, 2015, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27219, 2016, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27220, 2017, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27221, 2018, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27222, 2019, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27223, 2020, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27224, 2021, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27225, 2022, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27226, 2023, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27227, 2024, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27228, 2025, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27229, 2026, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27230, 2027, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27231, 2028, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27232, 2029, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27233, 2030, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27234, 2031, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27235, 2032, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27236, 2033, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27237, 2034, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27238, 2035, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27239, 2036, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27240, 2037, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27241, 2038, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27242, 2039, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27243, 2040, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27244, 2041, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27245, 2042, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27246, 2043, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27247, 2044, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27248, 2045, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27249, 2046, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27250, 2047, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27251, 2048, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27252, 2049, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27253, 2050, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27254, 2051, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27255, 2052, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27256, 2053, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27257, 2054, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27258, 2055, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27259, 2056, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27260, 2057, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27261, 2058, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27262, 2059, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27263, 2060, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27264, 2061, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27265, 2062, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27266, 2063, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27267, 2064, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27268, 2065, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27269, 2066, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27270, 2067, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27271, 2068, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27272, 2069, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27273, 2070, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27274, 2071, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27275, 2072, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27276, 2073, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27277, 2074, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27278, 2075, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27279, 2076, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27280, 2077, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27281, 2078, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27282, 2079, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27283, 2080, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27284, 2081, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27285, 2082, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27286, 2083, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27287, 2084, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27288, 2085, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27289, 2086, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27290, 2087, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27291, 2088, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27292, 2089, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27293, 2090, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27294, 2091, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27295, 2092, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27296, 2093, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27297, 2094, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27298, 2095, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27299, 2096, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27300, 2097, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27301, 2098, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27302, 2099, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27303, 2100, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27304, 2101, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27305, 2102, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27306, 2103, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27307, 2104, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27308, 2105, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27309, 2106, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27310, 2107, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27311, 2108, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27312, 2109, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27313, 2110, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27314, 2111, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27315, 2112, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27316, 2113, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27317, 2114, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27318, 2115, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27319, 2116, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27320, 2117, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27321, 2118, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27322, 2119, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27323, 2120, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27324, 2121, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27325, 2122, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27326, 2123, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27327, 2124, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27328, 2125, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27329, 2126, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27330, 2127, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27331, 2128, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27332, 2129, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27333, 2130, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27334, 2131, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27335, 2132, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27336, 2133, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27337, 2134, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27338, 2135, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27339, 2136, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27340, 2137, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27341, 2138, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27342, 2139, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27343, 2140, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27344, 2141, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27345, 2142, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27346, 2143, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27347, 2144, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27348, 2145, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27349, 2146, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27350, 2147, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27351, 2148, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27352, 2149, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27353, 2150, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27354, 2151, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27355, 2152, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27356, 2153, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27357, 2154, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27358, 2155, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27359, 2156, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27360, 2157, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27361, 2158, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27362, 2159, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27363, 2160, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27364, 2161, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27365, 2162, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27366, 2163, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27367, 2164, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27368, 2165, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27369, 2166, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27370, 2167, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27371, 2168, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27372, 2169, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27373, 2170, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27374, 2171, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27375, 2172, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27376, 2173, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27377, 2174, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27378, 2175, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27379, 2176, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27380, 2177, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27381, 2178, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27382, 2179, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27383, 2180, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27384, 2181, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27385, 2182, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27386, 2183, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27387, 2184, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27388, 2185, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27389, 2186, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27390, 2187, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27391, 2188, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27392, 2189, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27393, 2190, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27394, 2191, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27395, 2192, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27396, 2193, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27397, 2194, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27398, 2195, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27399, 2196, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27400, 2197, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27401, 2198, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27402, 2199, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27403, 2200, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27404, 2201, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27405, 2202, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27406, 2203, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27407, 2204, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27408, 2205, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27409, 2206, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27410, 2207, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27411, 2208, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27412, 2209, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27413, 2210, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27414, 2211, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27415, 2212, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27416, 2213, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27417, 2214, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27418, 2215, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27419, 2216, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27420, 2217, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27421, 2218, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27422, 2219, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27423, 2220, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27424, 2221, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27425, 2222, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27426, 2223, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27427, 2224, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27428, 2225, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27429, 2226, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27430, 2227, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27431, 2228, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27432, 2229, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27433, 2230, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27434, 2231, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27435, 2232, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27436, 2233, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27437, 2234, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27438, 2235, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27439, 2236, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27440, 2237, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27441, 2238, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27442, 2239, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27443, 2240, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27444, 2241, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27445, 2242, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27446, 2243, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27447, 2244, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27448, 2245, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27449, 2246, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27450, 2247, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27451, 2248, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27452, 2249, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27453, 2250, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27454, 2251, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27455, 2252, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27456, 2253, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27457, 2254, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27458, 2255, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27459, 2256, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27460, 2257, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27461, 2258, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27462, 2259, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27463, 2260, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27464, 2261, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27465, 2262, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27466, 2263, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27467, 2264, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27468, 2265, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27469, 2266, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27470, 2267, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27471, 2268, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27472, 2269, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27473, 2270, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27474, 2271, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27475, 2272, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27476, 2273, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27477, 2274, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27478, 2275, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27479, 2276, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27480, 2277, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27481, 2278, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27482, 2279, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27483, 2280, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27484, 2281, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27485, 2282, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27486, 2283, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27487, 2284, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27488, 2285, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27489, 2286, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27490, 2287, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27491, 2288, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27492, 2289, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27493, 2290, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27494, 2291, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27495, 2292, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27496, 2293, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27497, 2294, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27498, 2295, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27499, 2296, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27500, 2297, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27501, 2298, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27502, 2299, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27503, 2300, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27504, 2301, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27505, 2302, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27506, 2303, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27507, 2304, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27508, 2305, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27509, 2306, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27510, 2307, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27511, 2308, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27512, 2309, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27513, 2310, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27514, 2311, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27515, 2312, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27516, 2313, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27517, 2314, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27518, 2315, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27519, 2316, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27520, 2317, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27521, 2318, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27522, 2319, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27523, 2320, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27524, 2321, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27525, 2322, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27526, 2323, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27527, 2324, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27528, 2325, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27529, 2326, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27530, 2327, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27531, 2328, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27532, 2329, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27533, 2330, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27534, 2331, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27535, 2332, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27536, 2333, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27537, 2334, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27538, 2335, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27539, 2336, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27540, 2337, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27541, 2338, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27542, 2339, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27543, 2340, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27544, 2341, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27545, 2342, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27546, 2343, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27547, 2344, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27548, 2345, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27549, 2346, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27550, 2347, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27551, 2348, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27552, 2349, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27553, 2350, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27554, 2351, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27555, 2352, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27556, 2353, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27557, 2354, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27558, 2355, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27559, 2356, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27560, 2357, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27561, 2358, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27562, 2359, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27563, 2360, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27564, 2361, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27565, 2362, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27566, 2363, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27567, 2364, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27568, 2365, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27569, 2366, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27570, 2367, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27571, 2368, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27572, 2369, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27573, 2370, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27574, 2371, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27575, 2372, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27576, 2373, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27577, 2374, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27578, 2375, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27579, 2376, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27580, 2377, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27581, 2378, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27582, 2379, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27583, 2380, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27584, 2381, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27585, 2382, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27586, 2383, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27587, 2384, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27588, 2385, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27589, 2386, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27590, 2387, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27591, 2388, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27592, 2389, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27593, 2390, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27594, 2391, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27595, 2392, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27596, 2393, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27597, 2394, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27598, 2395, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27599, 2396, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27600, 2397, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27601, 2398, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27602, 2399, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27603, 2400, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27604, 2401, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27605, 2402, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27606, 2403, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27607, 2404, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27608, 2405, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27609, 2406, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27610, 2407, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27611, 2408, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27612, 2409, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27613, 2410, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27614, 2411, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27615, 2412, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27616, 2413, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27617, 2414, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27618, 2415, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27619, 2416, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27620, 2417, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27621, 2418, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27622, 2419, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27623, 2420, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27624, 2421, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27625, 2422, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27626, 2423, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27627, 2424, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27628, 2425, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27629, 2426, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27630, 2427, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27631, 2428, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27632, 2429, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27633, 2430, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27634, 2431, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27635, 2432, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27636, 2433, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27637, 2434, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27638, 2435, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27639, 2436, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27640, 2437, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27641, 2438, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27642, 2439, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27643, 2440, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27644, 2441, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27645, 2442, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27646, 2443, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27647, 2444, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27648, 2445, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27649, 2446, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27650, 2447, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27651, 2448, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27652, 2449, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27653, 2450, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27654, 2451, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27655, 2452, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27656, 2453, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27657, 2454, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27658, 2455, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27659, 2456, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27660, 2457, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27661, 2458, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27662, 2459, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27663, 2460, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27664, 2461, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27665, 2462, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27666, 2463, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27667, 2464, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27668, 2465, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27669, 2466, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27670, 2467, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27671, 2468, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27672, 2469, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27673, 2470, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27674, 2471, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27675, 2472, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27676, 2473, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27677, 2474, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27678, 2475, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27679, 2476, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27680, 2477, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27681, 2478, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27682, 2479, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27683, 2480, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27684, 2481, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27685, 2482, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27686, 2483, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27687, 2484, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27688, 2485, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27689, 2486, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27690, 2487, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27691, 2488, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27692, 2489, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27693, 2490, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27694, 2491, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27695, 2492, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27696, 2493, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27697, 2494, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27698, 2495, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27699, 2496, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27700, 2497, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27701, 2498, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27702, 2499, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27703, 2500, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27704, 2501, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27705, 2502, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27706, 2503, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27707, 2504, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27708, 2505, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27709, 2506, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27710, 2507, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27711, 2508, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27712, 2509, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27713, 2510, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27714, 2511, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27715, 2512, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27716, 2513, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27717, 2514, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27718, 2515, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27719, 2516, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27720, 2517, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27721, 2518, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27722, 2519, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27723, 2520, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27724, 2521, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27725, 2522, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27726, 2523, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27727, 2524, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27728, 2525, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27729, 2526, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27730, 2527, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27731, 2528, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27732, 2529, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27733, 2530, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27734, 2531, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27735, 2532, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27736, 2533, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27737, 2534, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27738, 2535, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27739, 2536, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27740, 2537, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27741, 2538, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27742, 2539, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27743, 2540, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27744, 2541, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27745, 2542, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27746, 2543, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27747, 2544, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27748, 2545, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27749, 2546, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27750, 2547, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27751, 2548, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27752, 2549, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27753, 2550, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27754, 2551, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27755, 2552, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27756, 2553, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27757, 2554, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27758, 2555, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27759, 2556, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27760, 2557, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27761, 2558, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27762, 2559, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27763, 2560, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27764, 2561, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27765, 2562, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27766, 2563, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27767, 2564, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27768, 2565, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27769, 2566, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27770, 2567, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27771, 2568, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27772, 2569, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27773, 2570, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27774, 2571, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27775, 2572, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27776, 2573, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27777, 2574, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27778, 2575, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27779, 2576, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27780, 2577, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27781, 2578, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27782, 2579, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27783, 2580, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27784, 2581, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27785, 2582, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27786, 2583, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27787, 2584, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27788, 2585, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27789, 2586, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27790, 2587, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27791, 2588, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27792, 2589, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27793, 2590, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27794, 2591, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27795, 2592, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27796, 2593, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27797, 2594, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27798, 2595, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27799, 2596, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27800, 2597, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27801, 2598, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27802, 2599, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27803, 2600, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27804, 2601, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27805, 2602, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27806, 2603, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27807, 2604, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27808, 2605, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27809, 2606, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27810, 2607, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27811, 2608, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27812, 2609, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27813, 2610, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27814, 2611, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27815, 2612, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27816, 2613, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27817, 2614, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27818, 2615, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27819, 2616, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27820, 2617, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27821, 2618, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27822, 2619, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27823, 2620, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27824, 2621, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27825, 2622, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27826, 2623, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27827, 2624, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27828, 2625, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27829, 2626, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27830, 2627, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27831, 2628, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27832, 2629, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27833, 2630, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27834, 2631, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27835, 2632, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27836, 2633, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27837, 2634, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27838, 2635, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27839, 2636, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27840, 2637, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27841, 2638, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27842, 2639, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27843, 2640, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27844, 2641, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27845, 2642, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27846, 2643, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27847, 2644, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27848, 2645, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27849, 2646, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27850, 2647, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27851, 2648, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27852, 2649, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27853, 2650, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27854, 2651, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27855, 2652, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27856, 2653, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27857, 2654, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27858, 2655, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27859, 2656, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27860, 2657, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27861, 2658, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27862, 2659, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27863, 2660, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27864, 2661, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27865, 2662, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27866, 2663, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27867, 2664, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27868, 2665, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27869, 2666, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27870, 2667, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27871, 2668, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27872, 2669, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27873, 2670, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27874, 2671, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27875, 2672, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27876, 2673, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27877, 2674, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27878, 2675, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27879, 2676, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27880, 2677, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27881, 2678, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27882, 2679, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27883, 2680, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27884, 2681, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27885, 2682, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27886, 2683, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27887, 2684, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27888, 2685, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27889, 2686, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27890, 2687, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27891, 2688, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27892, 2689, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27893, 2690, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27894, 2691, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27895, 2692, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27896, 2693, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27897, 2694, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27898, 2695, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27899, 2696, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27900, 2697, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27901, 2698, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27902, 2699, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27903, 2700, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27904, 2701, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27905, 2702, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27906, 2703, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27907, 2704, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27908, 2705, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27909, 2706, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27910, 2707, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27911, 2708, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27912, 2709, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27913, 2710, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27914, 2711, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27915, 2712, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27916, 2713, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27917, 2714, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27918, 2715, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27919, 2716, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27920, 2717, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27921, 2718, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27922, 2719, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27923, 2720, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27924, 2721, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27925, 2722, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27926, 2723, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27927, 2724, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27928, 2725, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27929, 2726, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27930, 2727, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27931, 2728, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27932, 2729, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27933, 2730, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27934, 2731, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27935, 2732, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27936, 2733, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27937, 2734, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27938, 2735, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27939, 2736, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27940, 2737, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27941, 2738, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27942, 2739, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27943, 2740, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27944, 2741, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27945, 2742, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27946, 2743, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27947, 2744, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27948, 2745, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27949, 2746, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27950, 2747, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27951, 2748, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27952, 2749, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27953, 2750, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27954, 2751, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27955, 2752, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27956, 2753, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27957, 2754, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27958, 2755, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27959, 2756, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27960, 2757, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27961, 2758, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27962, 2759, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27963, 2760, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27964, 2761, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27965, 2762, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27966, 2763, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27967, 2764, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27968, 2765, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27969, 2766, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27970, 2767, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27971, 2768, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27972, 2769, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27973, 2770, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27974, 2771, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27975, 2772, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27976, 2773, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27977, 2774, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27978, 2775, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27979, 2776, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27980, 2777, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27981, 2778, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27982, 2779, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27983, 2780, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27984, 2781, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27985, 2782, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27986, 2783, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27987, 2784, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27988, 2785, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27989, 2786, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27990, 2787, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27991, 2788, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27992, 2789, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27993, 2790, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27994, 2791, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27995, 2792, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27996, 2793, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27997, 2794, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27998, 2795, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (27999, 2796, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28000, 2797, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28001, 2798, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28002, 2799, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28003, 2800, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28004, 2801, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28005, 2802, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28006, 2803, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28007, 2804, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28008, 2805, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28009, 2806, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28010, 2807, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28011, 2808, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28012, 2809, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28013, 2810, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28014, 2811, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28015, 2812, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28016, 2813, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28017, 2814, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28018, 2815, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28019, 2816, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28020, 2817, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28021, 2818, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28022, 2819, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28023, 2820, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28024, 2821, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28025, 2822, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28026, 2823, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28027, 2824, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28028, 2825, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28029, 2826, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28030, 2827, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28031, 2828, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28032, 2829, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28033, 2830, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28034, 2831, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28035, 2832, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28036, 2833, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28037, 2834, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28038, 2835, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28039, 2836, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28040, 2837, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28041, 2838, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28042, 2839, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28043, 2840, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28044, 2841, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28045, 2842, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28046, 2843, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28047, 2844, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28048, 2845, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28049, 2846, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28050, 2847, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28051, 2848, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28052, 2849, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28053, 2850, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28054, 2851, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28055, 2852, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28056, 2853, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28057, 2854, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28058, 2855, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28059, 2856, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28060, 2857, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28061, 2858, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28062, 2859, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28063, 2860, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28064, 2861, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28065, 2862, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28066, 2863, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28067, 2864, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28068, 2865, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28069, 2866, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28070, 2867, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28071, 2868, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28072, 2869, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28073, 2870, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28074, 2871, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28075, 2872, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28076, 2873, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28077, 2874, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28078, 2875, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28079, 2876, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28080, 2877, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28081, 2878, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28082, 2879, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28083, 2880, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28084, 2881, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28085, 2882, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28086, 2883, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28087, 2884, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28088, 2885, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28089, 2886, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28090, 2887, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28091, 2888, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28092, 2889, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28093, 2890, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28094, 2891, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28095, 2892, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28096, 2893, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28097, 2894, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28098, 2895, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28099, 2896, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28100, 2897, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28101, 2898, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28102, 2899, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28103, 2900, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28104, 2901, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28105, 2902, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28106, 2903, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28107, 2904, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28108, 2905, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28109, 2906, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28110, 2907, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28111, 2908, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28112, 2909, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28113, 2910, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28114, 2911, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28115, 2912, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28116, 2913, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28117, 2914, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28118, 2915, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28119, 2916, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28120, 2917, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28121, 2918, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28122, 2919, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28123, 2920, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28124, 2921, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28125, 2922, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28126, 2923, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28127, 2924, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28128, 2925, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28129, 2926, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28130, 2927, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28131, 2928, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28132, 2929, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28133, 2930, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28134, 2931, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28135, 2932, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28136, 2933, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28137, 2934, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28138, 2935, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28139, 2936, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28140, 2937, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28141, 2938, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28142, 2939, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28143, 2940, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28144, 2941, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28145, 2942, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28146, 2943, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28147, 2944, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28148, 2945, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28149, 2946, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28150, 2947, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28151, 2948, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28152, 2949, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28153, 2950, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28154, 2951, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28155, 2952, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28156, 2953, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28157, 2954, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28158, 2955, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28159, 2956, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28160, 2957, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28161, 2958, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28162, 2959, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28163, 2960, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28164, 2961, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28165, 2962, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28166, 2963, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28167, 2964, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28168, 2965, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28169, 2966, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28170, 2967, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28171, 2968, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28172, 2969, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28173, 2970, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28174, 2971, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28175, 2972, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28176, 2973, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28177, 2974, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28178, 2975, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28179, 2976, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28180, 2977, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28181, 2978, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28182, 2979, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28183, 2980, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28184, 2981, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28185, 2982, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28186, 2983, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28187, 2984, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28188, 2985, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28189, 2986, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28190, 2987, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28191, 2988, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28192, 2989, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28193, 2990, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28194, 2991, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28195, 2992, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28196, 2993, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28197, 2994, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28198, 2995, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28199, 2996, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28200, 2997, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28201, 2998, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28202, 2999, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28203, 3000, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28204, 3001, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28205, 3002, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28206, 3003, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28207, 3004, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28208, 3005, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28209, 3006, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28210, 3007, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28211, 3008, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28212, 3009, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28213, 3010, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28214, 3011, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28215, 3012, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28216, 3013, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28217, 3014, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28218, 3015, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28219, 3016, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28220, 3017, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28221, 3018, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28222, 3019, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28223, 3020, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28224, 3021, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28225, 3022, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28226, 3023, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28227, 3024, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28228, 3025, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28229, 3026, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28230, 3027, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28231, 3028, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28232, 3029, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28233, 3030, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28234, 3031, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28235, 3032, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28236, 3033, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28237, 3034, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28238, 3035, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28239, 3036, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28240, 3037, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28241, 3038, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28242, 3039, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28243, 3040, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28244, 3041, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28245, 3042, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28246, 3043, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28247, 3044, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28248, 3045, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28249, 3046, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28250, 3047, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28251, 3048, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28252, 3049, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28253, 3050, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28254, 3051, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28255, 3052, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28256, 3053, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28257, 3054, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28258, 3055, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28259, 3056, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28260, 3057, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28261, 3058, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28262, 3059, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28263, 3060, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28264, 3061, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28265, 3062, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28266, 3063, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28267, 3064, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28268, 3065, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28269, 3066, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28270, 3067, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28271, 3068, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28272, 3069, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28273, 3070, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28274, 3071, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28275, 3072, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28276, 3073, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28277, 3074, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28278, 3075, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28279, 3076, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28280, 3077, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28281, 3078, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28282, 3079, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28283, 3080, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28284, 3081, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28285, 3082, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28286, 3083, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28287, 3084, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28288, 3085, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28289, 3086, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28290, 3087, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28291, 3088, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28292, 3089, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28293, 3090, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28294, 3091, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28295, 3092, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28296, 3093, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28297, 3094, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28298, 3095, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28299, 3096, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28300, 3097, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28301, 3098, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28302, 3099, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28303, 3100, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28304, 3101, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28305, 3102, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28306, 3103, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28307, 3104, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28308, 3105, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28309, 3106, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28310, 3107, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28311, 3108, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28312, 3109, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28313, 3110, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28314, 3111, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28315, 3112, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28316, 3113, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28317, 3114, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28318, 3115, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28319, 3116, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28320, 3117, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28321, 3118, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28322, 3119, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28323, 3120, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28324, 3121, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28325, 3122, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28326, 3123, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28327, 3124, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28328, 3125, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28329, 3126, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28330, 3127, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28331, 3128, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28332, 3129, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28333, 3130, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28334, 3131, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28335, 3132, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28336, 3133, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28337, 3134, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28338, 3135, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28339, 3136, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28340, 3137, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28341, 3138, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28342, 3139, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28343, 3140, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28344, 3141, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28345, 3142, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28346, 3143, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28347, 3144, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28348, 3145, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28349, 3146, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28350, 3147, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28351, 3148, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28352, 3149, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28353, 3150, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28354, 3151, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28355, 3152, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28356, 3153, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28357, 3154, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28358, 3155, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28359, 3156, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28360, 3157, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28361, 3158, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28362, 3159, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28363, 3160, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28364, 3161, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28365, 3162, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28366, 3163, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28367, 3164, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28368, 3165, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28369, 3166, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28370, 3167, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28371, 3168, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28372, 3169, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28373, 3170, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28374, 3171, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28375, 3172, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28376, 3173, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28377, 3174, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28378, 3175, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28379, 3176, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28380, 3177, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28381, 3178, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28382, 3179, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28383, 3180, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28384, 3181, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28385, 3182, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28386, 3183, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28387, 3184, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28388, 3185, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28389, 3186, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28390, 3187, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28391, 3188, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28392, 3189, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28393, 3190, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28394, 3191, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28395, 3192, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28396, 3193, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28397, 3194, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28398, 3195, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28399, 3196, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28400, 3197, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28401, 3198, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28402, 3199, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28403, 3200, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28404, 3201, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28405, 3202, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28406, 3203, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28407, 3204, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28408, 3205, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28409, 3206, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28410, 3207, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28411, 3208, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28412, 3209, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28413, 3210, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28414, 3211, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28415, 3212, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28416, 3213, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28417, 3214, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28418, 3215, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28419, 3216, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28420, 3217, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28421, 3218, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28422, 3219, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28423, 3220, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28424, 3221, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28425, 3222, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28426, 3223, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28427, 3224, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28428, 3225, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28429, 3226, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28430, 3227, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28431, 3228, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28432, 3229, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28433, 3230, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28434, 3231, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28435, 3232, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28436, 3233, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28437, 3234, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28438, 3235, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28439, 3236, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28440, 3237, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28441, 3238, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28442, 3239, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28443, 3240, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28444, 3241, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28445, 3242, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28446, 3243, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28447, 3244, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28448, 3245, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28449, 3246, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28450, 3247, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28451, 3248, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28452, 3249, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28453, 3250, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28454, 3251, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28455, 3252, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28456, 3253, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28457, 3254, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28458, 3255, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28459, 3256, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28460, 3257, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28461, 3258, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28462, 3259, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28463, 3260, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28464, 3261, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28465, 3262, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28466, 3263, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28467, 3264, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28468, 3265, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28469, 3266, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28470, 3267, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28471, 3268, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28472, 3269, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28473, 3270, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28474, 3271, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28475, 3272, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28476, 3273, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28477, 3274, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28478, 3275, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28479, 3276, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28480, 3277, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28481, 3278, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28482, 3279, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28483, 3280, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28484, 3281, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28485, 3282, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28486, 3283, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28487, 3284, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28488, 3285, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28489, 3286, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28490, 3287, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28491, 3288, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28492, 3289, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28493, 3290, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28494, 3291, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28495, 3292, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28496, 3293, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28497, 3294, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28498, 3295, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28499, 3296, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28500, 3297, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28501, 3298, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28502, 3299, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28503, 3300, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28504, 3301, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28505, 3302, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28506, 3303, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28507, 3304, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28508, 3305, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28509, 3306, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28510, 3307, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28511, 3308, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28512, 3309, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28513, 3310, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28514, 3311, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28515, 3312, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28516, 3313, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28517, 3314, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28518, 3315, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28519, 3316, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28520, 3317, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28521, 3318, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28522, 3319, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28523, 3320, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28524, 3321, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28525, 3322, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28526, 3323, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28527, 3324, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28528, 3325, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28529, 3326, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28530, 3327, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28531, 3328, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28532, 3329, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28533, 3330, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28534, 3331, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28535, 3332, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28536, 3333, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28537, 3334, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28538, 3335, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28539, 3336, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28540, 3337, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28541, 3338, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28542, 3339, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28543, 3340, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28544, 3341, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28545, 3342, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28546, 3343, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28547, 3344, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28548, 3345, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28549, 3346, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28550, 3347, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28551, 3348, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28552, 3349, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28553, 3350, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28554, 3351, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28555, 3352, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28556, 3353, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28557, 3354, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28558, 3355, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28559, 3356, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28560, 3357, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28561, 3358, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28562, 3359, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28563, 3360, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28564, 3361, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28565, 3362, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28566, 3363, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28567, 3364, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28568, 3365, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28569, 3366, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28570, 3367, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28571, 3368, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28572, 3369, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28573, 3370, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28574, 3371, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28575, 3372, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28576, 3373, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28577, 3374, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28578, 3375, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28579, 3376, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28580, 3377, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28581, 3378, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28582, 3379, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28583, 3380, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28584, 3381, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28585, 3382, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28586, 3383, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28587, 3384, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28588, 3385, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28589, 3386, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28590, 3387, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28591, 3388, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28592, 3389, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28593, 3390, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28594, 3391, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28595, 3392, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28596, 3393, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28597, 3394, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28598, 3395, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28599, 3396, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28600, 3397, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28601, 3398, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28602, 3399, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28603, 3400, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28604, 3401, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28605, 3402, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28606, 3403, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28607, 3404, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28608, 3405, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28609, 3406, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28610, 3407, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28611, 3408, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28612, 3409, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28613, 3410, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28614, 3411, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28615, 3412, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28616, 3413, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28617, 3414, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28618, 3415, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28619, 3416, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28620, 3417, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28621, 3418, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28622, 3419, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28623, 3420, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28624, 3421, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28625, 3422, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28626, 3423, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28627, 3424, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28628, 3425, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28629, 3426, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28630, 3427, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28631, 3428, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28632, 3429, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28633, 3430, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28634, 3431, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28635, 3432, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28636, 3433, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28637, 3434, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28638, 3435, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28639, 3436, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28640, 3437, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28641, 3438, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28642, 3439, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28643, 3440, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28644, 3441, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28645, 3442, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28646, 3443, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28647, 3444, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28648, 3445, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28649, 3446, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28650, 3447, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28651, 3448, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28652, 3449, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28653, 3450, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28654, 3451, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28655, 3452, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28656, 3453, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28657, 3454, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28658, 3455, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28659, 3456, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28660, 3457, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28661, 3458, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28662, 3459, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28663, 3460, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28664, 3461, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28665, 3462, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28666, 3463, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28667, 3464, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28668, 3465, 19, 'dummy');
INSERT INTO `lang_definitions` VALUES (28669, 3466, 19, 'dummy');

--

